#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 970
#define LARGE_STATE_COUNT 6
#define SYMBOL_COUNT 264
#define ALIAS_COUNT 0
#define TOKEN_COUNT 108
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 1
#define MAX_ALIAS_SEQUENCE_LENGTH 18
#define PRODUCTION_ID_COUNT 2

enum {
  anon_sym_align = 1,
  anon_sym_EQ = 2,
  sym_align_offset_value = 3,
  anon_sym_LPAREN_AT = 4,
  anon_sym_RPAREN = 5,
  anon_sym_LPAREN = 6,
  anon_sym_block = 7,
  anon_sym_end = 8,
  anon_sym_if = 9,
  anon_sym_else = 10,
  anon_sym_loop = 11,
  anon_sym_LPAREN_SEMI = 12,
  anon_sym_SEMI_RPAREN = 13,
  sym_comment_block_inner = 14,
  aux_sym_comment_line_token1 = 15,
  sym_dec_float = 16,
  sym_dec_nat = 17,
  anon_sym_item = 18,
  anon_sym_func = 19,
  sym_escape_sequence = 20,
  anon_sym_export = 21,
  anon_sym_global = 22,
  anon_sym_memory = 23,
  anon_sym_table = 24,
  anon_sym_call_indirect = 25,
  anon_sym_inf = 26,
  anon_sym_local = 27,
  anon_sym_param = 28,
  anon_sym_result = 29,
  anon_sym_mut = 30,
  sym_hex_float = 31,
  sym_hex_nat = 32,
  sym_identifier = 33,
  sym_identifier_pattern = 34,
  anon_sym_then = 35,
  anon_sym_import = 36,
  anon_sym_br_table = 37,
  anon_sym_ref_DOTextern = 38,
  anon_sym_ref_DOTnull = 39,
  sym_op_nullary = 40,
  sym_op_index = 41,
  sym_op_index_opt = 42,
  sym_op_index_opt_offset_opt_align_opt = 43,
  sym_op_simd_offset_opt_align_opt = 44,
  aux_sym_op_const_token1 = 45,
  aux_sym_op_const_token2 = 46,
  anon_sym_func_DOTbind = 47,
  anon_sym_type = 48,
  anon_sym_let = 49,
  anon_sym_select = 50,
  anon_sym_v128_DOTconst = 51,
  anon_sym_f32x4 = 52,
  anon_sym_f64x2 = 53,
  anon_sym_i8x16 = 54,
  anon_sym_i16x8 = 55,
  anon_sym_i32x4 = 56,
  anon_sym_i64x2 = 57,
  anon_sym_DOTshuffle = 58,
  anon_sym_DOT = 59,
  anon_sym_extract_lane = 60,
  anon_sym__ = 61,
  aux_sym_op_simd_lane_token1 = 62,
  anon_sym_replace_lane = 63,
  anon_sym_table_DOTcopy = 64,
  anon_sym_table_DOTinit = 65,
  anon_sym_data = 66,
  anon_sym_module = 67,
  anon_sym_elem = 68,
  anon_sym_declare = 69,
  anon_sym_start = 70,
  sym_nan = 71,
  anon_sym_f32 = 72,
  anon_sym_f64 = 73,
  anon_sym_i32 = 74,
  anon_sym_i64 = 75,
  sym_num_type_v128 = 76,
  anon_sym_offset = 77,
  sym_ref_kind = 78,
  sym_ref_type_externref = 79,
  sym_ref_type_funcref = 80,
  anon_sym_ref = 81,
  anon_sym_null = 82,
  sym_reserved = 83,
  sym_share = 84,
  sym_sign = 85,
  anon_sym_DQUOTE = 86,
  aux_sym_string_token1 = 87,
  anon_sym_get = 88,
  anon_sym_invoke = 89,
  anon_sym_assert_exhaustion = 90,
  anon_sym_assert_invalid = 91,
  anon_sym_assert_malformed = 92,
  anon_sym_assert_return = 93,
  anon_sym_assert_return_arithmetic_nan = 94,
  anon_sym_assert_return_canonical_nan = 95,
  anon_sym_assert_trap = 96,
  anon_sym_assert_unlinkable = 97,
  sym_literal_nan_arithmetic = 98,
  sym_literal_nan_canonical = 99,
  anon_sym_input = 100,
  anon_sym_output = 101,
  anon_sym_script = 102,
  anon_sym_register = 103,
  anon_sym_const = 104,
  sym_result_ref_func = 105,
  anon_sym_binary = 106,
  anon_sym_quote = 107,
  sym_ROOT = 108,
  sym_align_value = 109,
  sym_annotation = 110,
  sym_annotation_parens = 111,
  sym_annotation_part = 112,
  sym_block_block = 113,
  sym_block_if = 114,
  sym_block_loop = 115,
  sym_comment_block = 116,
  sym_comment_block_annot = 117,
  sym_comment_line = 118,
  sym_comment_line_annot = 119,
  sym_elem_expr = 120,
  sym_elem_expr_expr = 121,
  sym_elem_expr_item = 122,
  sym_elem_kind = 123,
  sym_elem_list = 124,
  sym_export = 125,
  sym_export_desc = 126,
  sym_export_desc_func = 127,
  sym_export_desc_global = 128,
  sym_export_desc_memory = 129,
  sym_export_desc_table = 130,
  sym_expr = 131,
  sym_expr1 = 132,
  sym_expr1_block = 133,
  sym_expr1_call = 134,
  sym_expr1_if = 135,
  sym_expr1_loop = 136,
  sym_expr1_plain = 137,
  sym_float = 138,
  sym_func_locals = 139,
  sym_func_locals_many = 140,
  sym_func_locals_one = 141,
  sym_func_type = 142,
  sym_func_type_params = 143,
  sym_func_type_params_many = 144,
  sym_func_type_params_one = 145,
  sym_func_type_results = 146,
  sym_global_type = 147,
  sym_global_type_imm = 148,
  sym_global_type_mut = 149,
  sym_if_block = 150,
  sym_import = 151,
  sym_import_desc = 152,
  sym_import_desc_func_type = 153,
  sym_import_desc_global_type = 154,
  sym_import_desc_memory_type = 155,
  sym_import_desc_table_type = 156,
  sym_import_desc_type_use = 157,
  sym_index = 158,
  sym_instr = 159,
  sym_instr_block = 160,
  sym_instr_call = 161,
  sym_instr_list = 162,
  sym_instr_list_call = 163,
  sym_instr_plain = 164,
  sym_op_const = 165,
  sym_op_func_bind = 166,
  sym_op_let = 167,
  sym_op_select = 168,
  sym_op_simd_const = 169,
  sym_op_simd_lane = 170,
  sym_op_table_copy = 171,
  sym_op_table_init = 172,
  sym_int = 173,
  sym_limits = 174,
  sym_memory_fields_data = 175,
  sym_memory_fields_type = 176,
  sym_memory_type = 177,
  sym_memory_use = 178,
  sym_module = 179,
  sym_module_field = 180,
  sym_module_field_data = 181,
  sym_module_field_elem = 182,
  sym_module_field_export = 183,
  sym_module_field_func = 184,
  sym_module_field_global = 185,
  sym_module_field_import = 186,
  sym_module_field_memory = 187,
  sym_module_field_start = 188,
  sym_module_field_table = 189,
  sym_module_field_type = 190,
  sym_name = 191,
  sym_nat = 192,
  sym_num_type_f32 = 193,
  sym_num_type_f64 = 194,
  sym_num_type_i32 = 195,
  sym_num_type_i64 = 196,
  sym_offset = 197,
  sym_offset_const_expr = 198,
  sym_offset_expr = 199,
  sym_offset_value = 200,
  sym_ref_type = 201,
  sym_ref_type_ref = 202,
  sym_string = 203,
  sym_table_fields_elem = 204,
  sym_table_fields_type = 205,
  sym_table_type = 206,
  sym_table_use = 207,
  sym_type_field = 208,
  sym_type_use = 209,
  sym_value_type = 210,
  sym_value_type_num_type = 211,
  sym_value_type_ref_type = 212,
  sym_action = 213,
  sym_action_get = 214,
  sym_action_invoke = 215,
  sym_assert_exhaustion = 216,
  sym_assert_invalid = 217,
  sym_assert_malformed = 218,
  sym_assert_return = 219,
  sym_assert_return_arithmetic_nan = 220,
  sym_assert_return_canonical_nan = 221,
  sym_assert_trap_action = 222,
  sym_assert_trap_module = 223,
  sym_assert_unlinkable = 224,
  sym_assertion = 225,
  sym_command = 226,
  sym_expr_plain_const = 227,
  sym_literal_nan = 228,
  sym_meta = 229,
  sym_meta_input = 230,
  sym_meta_output = 231,
  sym_meta_script = 232,
  sym_op_const_ref = 233,
  sym_register = 234,
  sym_result = 235,
  sym_result_const = 236,
  sym_result_const_nan = 237,
  sym_result_ref_extern = 238,
  sym_result_ref_null = 239,
  sym_script_module = 240,
  sym_script_module_binary = 241,
  sym_script_module_quote = 242,
  aux_sym_ROOT_repeat1 = 243,
  aux_sym_ROOT_repeat2 = 244,
  aux_sym_annotation_repeat1 = 245,
  aux_sym_block_block_repeat1 = 246,
  aux_sym_block_block_repeat2 = 247,
  aux_sym_comment_block_repeat1 = 248,
  aux_sym_comment_block_annot_repeat1 = 249,
  aux_sym_elem_expr_item_repeat1 = 250,
  aux_sym_elem_list_repeat1 = 251,
  aux_sym_elem_list_repeat2 = 252,
  aux_sym_expr1_call_repeat1 = 253,
  aux_sym_func_locals_many_repeat1 = 254,
  aux_sym_import_desc_func_type_repeat1 = 255,
  aux_sym_instr_list_repeat1 = 256,
  aux_sym_op_let_repeat1 = 257,
  aux_sym_op_let_repeat2 = 258,
  aux_sym_memory_fields_data_repeat1 = 259,
  aux_sym_module_field_func_repeat1 = 260,
  aux_sym_string_repeat1 = 261,
  aux_sym_action_invoke_repeat1 = 262,
  aux_sym_assert_return_repeat1 = 263,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_align] = "align",
  [anon_sym_EQ] = "=",
  [sym_align_offset_value] = "align_offset_value",
  [anon_sym_LPAREN_AT] = "(@",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LPAREN] = "(",
  [anon_sym_block] = "block",
  [anon_sym_end] = "end",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_loop] = "loop",
  [anon_sym_LPAREN_SEMI] = "(;",
  [anon_sym_SEMI_RPAREN] = ";)",
  [sym_comment_block_inner] = "comment_block_inner",
  [aux_sym_comment_line_token1] = "comment_line_token1",
  [sym_dec_float] = "dec_float",
  [sym_dec_nat] = "dec_nat",
  [anon_sym_item] = "item",
  [anon_sym_func] = "func",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_export] = "export",
  [anon_sym_global] = "global",
  [anon_sym_memory] = "memory",
  [anon_sym_table] = "table",
  [anon_sym_call_indirect] = "call_indirect",
  [anon_sym_inf] = "inf",
  [anon_sym_local] = "local",
  [anon_sym_param] = "param",
  [anon_sym_result] = "result",
  [anon_sym_mut] = "mut",
  [sym_hex_float] = "hex_float",
  [sym_hex_nat] = "hex_nat",
  [sym_identifier] = "identifier",
  [sym_identifier_pattern] = "identifier_pattern",
  [anon_sym_then] = "then",
  [anon_sym_import] = "import",
  [anon_sym_br_table] = "br_table",
  [anon_sym_ref_DOTextern] = "ref.extern",
  [anon_sym_ref_DOTnull] = "ref.null",
  [sym_op_nullary] = "op_nullary",
  [sym_op_index] = "op_index",
  [sym_op_index_opt] = "op_index_opt",
  [sym_op_index_opt_offset_opt_align_opt] = "op_index_opt_offset_opt_align_opt",
  [sym_op_simd_offset_opt_align_opt] = "op_simd_offset_opt_align_opt",
  [aux_sym_op_const_token1] = "pat00",
  [aux_sym_op_const_token2] = "pat01",
  [anon_sym_func_DOTbind] = "func.bind",
  [anon_sym_type] = "type",
  [anon_sym_let] = "let",
  [anon_sym_select] = "select",
  [anon_sym_v128_DOTconst] = "v128.const",
  [anon_sym_f32x4] = "f32x4",
  [anon_sym_f64x2] = "f64x2",
  [anon_sym_i8x16] = "i8x16",
  [anon_sym_i16x8] = "i16x8",
  [anon_sym_i32x4] = "i32x4",
  [anon_sym_i64x2] = "i64x2",
  [anon_sym_DOTshuffle] = ".shuffle",
  [anon_sym_DOT] = ".",
  [anon_sym_extract_lane] = "extract_lane",
  [anon_sym__] = "_",
  [aux_sym_op_simd_lane_token1] = "op_simd_lane_token1",
  [anon_sym_replace_lane] = "replace_lane",
  [anon_sym_table_DOTcopy] = "table.copy",
  [anon_sym_table_DOTinit] = "table.init",
  [anon_sym_data] = "data",
  [anon_sym_module] = "module",
  [anon_sym_elem] = "elem",
  [anon_sym_declare] = "declare",
  [anon_sym_start] = "start",
  [sym_nan] = "nan",
  [anon_sym_f32] = "f32",
  [anon_sym_f64] = "f64",
  [anon_sym_i32] = "i32",
  [anon_sym_i64] = "i64",
  [sym_num_type_v128] = "num_type_v128",
  [anon_sym_offset] = "offset",
  [sym_ref_kind] = "ref_kind",
  [sym_ref_type_externref] = "ref_type_externref",
  [sym_ref_type_funcref] = "ref_type_funcref",
  [anon_sym_ref] = "ref",
  [anon_sym_null] = "null",
  [sym_reserved] = "reserved",
  [sym_share] = "share",
  [sym_sign] = "sign",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_get] = "get",
  [anon_sym_invoke] = "invoke",
  [anon_sym_assert_exhaustion] = "assert_exhaustion",
  [anon_sym_assert_invalid] = "assert_invalid",
  [anon_sym_assert_malformed] = "assert_malformed",
  [anon_sym_assert_return] = "assert_return",
  [anon_sym_assert_return_arithmetic_nan] = "assert_return_arithmetic_nan",
  [anon_sym_assert_return_canonical_nan] = "assert_return_canonical_nan",
  [anon_sym_assert_trap] = "assert_trap",
  [anon_sym_assert_unlinkable] = "assert_unlinkable",
  [sym_literal_nan_arithmetic] = "literal_nan_arithmetic",
  [sym_literal_nan_canonical] = "literal_nan_canonical",
  [anon_sym_input] = "input",
  [anon_sym_output] = "output",
  [anon_sym_script] = "script",
  [anon_sym_register] = "register",
  [anon_sym_const] = "const",
  [sym_result_ref_func] = "result_ref_func",
  [anon_sym_binary] = "binary",
  [anon_sym_quote] = "quote",
  [sym_ROOT] = "ROOT",
  [sym_align_value] = "align_value",
  [sym_annotation] = "annotation",
  [sym_annotation_parens] = "annotation_parens",
  [sym_annotation_part] = "annotation_part",
  [sym_block_block] = "block_block",
  [sym_block_if] = "block_if",
  [sym_block_loop] = "block_loop",
  [sym_comment_block] = "comment_block",
  [sym_comment_block_annot] = "comment_block_annot",
  [sym_comment_line] = "comment_line",
  [sym_comment_line_annot] = "comment_line_annot",
  [sym_elem_expr] = "elem_expr",
  [sym_elem_expr_expr] = "elem_expr_expr",
  [sym_elem_expr_item] = "elem_expr_item",
  [sym_elem_kind] = "elem_kind",
  [sym_elem_list] = "elem_list",
  [sym_export] = "export",
  [sym_export_desc] = "export_desc",
  [sym_export_desc_func] = "export_desc_func",
  [sym_export_desc_global] = "export_desc_global",
  [sym_export_desc_memory] = "export_desc_memory",
  [sym_export_desc_table] = "export_desc_table",
  [sym_expr] = "expr",
  [sym_expr1] = "expr1",
  [sym_expr1_block] = "expr1_block",
  [sym_expr1_call] = "expr1_call",
  [sym_expr1_if] = "expr1_if",
  [sym_expr1_loop] = "expr1_loop",
  [sym_expr1_plain] = "expr1_plain",
  [sym_float] = "float",
  [sym_func_locals] = "func_locals",
  [sym_func_locals_many] = "func_locals_many",
  [sym_func_locals_one] = "func_locals_one",
  [sym_func_type] = "func_type",
  [sym_func_type_params] = "func_type_params",
  [sym_func_type_params_many] = "func_type_params_many",
  [sym_func_type_params_one] = "func_type_params_one",
  [sym_func_type_results] = "func_type_results",
  [sym_global_type] = "global_type",
  [sym_global_type_imm] = "global_type_imm",
  [sym_global_type_mut] = "global_type_mut",
  [sym_if_block] = "if_block",
  [sym_import] = "import",
  [sym_import_desc] = "import_desc",
  [sym_import_desc_func_type] = "import_desc_func_type",
  [sym_import_desc_global_type] = "import_desc_global_type",
  [sym_import_desc_memory_type] = "import_desc_memory_type",
  [sym_import_desc_table_type] = "import_desc_table_type",
  [sym_import_desc_type_use] = "import_desc_type_use",
  [sym_index] = "index",
  [sym_instr] = "instr",
  [sym_instr_block] = "instr_block",
  [sym_instr_call] = "instr_call",
  [sym_instr_list] = "instr_list",
  [sym_instr_list_call] = "instr_list_call",
  [sym_instr_plain] = "instr_plain",
  [sym_op_const] = "op_const",
  [sym_op_func_bind] = "op_func_bind",
  [sym_op_let] = "op_let",
  [sym_op_select] = "op_select",
  [sym_op_simd_const] = "op_simd_const",
  [sym_op_simd_lane] = "op_simd_lane",
  [sym_op_table_copy] = "op_table_copy",
  [sym_op_table_init] = "op_table_init",
  [sym_int] = "int",
  [sym_limits] = "limits",
  [sym_memory_fields_data] = "memory_fields_data",
  [sym_memory_fields_type] = "memory_fields_type",
  [sym_memory_type] = "memory_type",
  [sym_memory_use] = "memory_use",
  [sym_module] = "module",
  [sym_module_field] = "module_field",
  [sym_module_field_data] = "module_field_data",
  [sym_module_field_elem] = "module_field_elem",
  [sym_module_field_export] = "module_field_export",
  [sym_module_field_func] = "module_field_func",
  [sym_module_field_global] = "module_field_global",
  [sym_module_field_import] = "module_field_import",
  [sym_module_field_memory] = "module_field_memory",
  [sym_module_field_start] = "module_field_start",
  [sym_module_field_table] = "module_field_table",
  [sym_module_field_type] = "module_field_type",
  [sym_name] = "name",
  [sym_nat] = "nat",
  [sym_num_type_f32] = "num_type_f32",
  [sym_num_type_f64] = "num_type_f64",
  [sym_num_type_i32] = "num_type_i32",
  [sym_num_type_i64] = "num_type_i64",
  [sym_offset] = "offset",
  [sym_offset_const_expr] = "offset_const_expr",
  [sym_offset_expr] = "offset_expr",
  [sym_offset_value] = "offset_value",
  [sym_ref_type] = "ref_type",
  [sym_ref_type_ref] = "ref_type_ref",
  [sym_string] = "string",
  [sym_table_fields_elem] = "table_fields_elem",
  [sym_table_fields_type] = "table_fields_type",
  [sym_table_type] = "table_type",
  [sym_table_use] = "table_use",
  [sym_type_field] = "type_field",
  [sym_type_use] = "type_use",
  [sym_value_type] = "value_type",
  [sym_value_type_num_type] = "value_type_num_type",
  [sym_value_type_ref_type] = "value_type_ref_type",
  [sym_action] = "action",
  [sym_action_get] = "action_get",
  [sym_action_invoke] = "action_invoke",
  [sym_assert_exhaustion] = "assert_exhaustion",
  [sym_assert_invalid] = "assert_invalid",
  [sym_assert_malformed] = "assert_malformed",
  [sym_assert_return] = "assert_return",
  [sym_assert_return_arithmetic_nan] = "assert_return_arithmetic_nan",
  [sym_assert_return_canonical_nan] = "assert_return_canonical_nan",
  [sym_assert_trap_action] = "assert_trap_action",
  [sym_assert_trap_module] = "assert_trap_module",
  [sym_assert_unlinkable] = "assert_unlinkable",
  [sym_assertion] = "assertion",
  [sym_command] = "command",
  [sym_expr_plain_const] = "expr_plain_const",
  [sym_literal_nan] = "literal_nan",
  [sym_meta] = "meta",
  [sym_meta_input] = "meta_input",
  [sym_meta_output] = "meta_output",
  [sym_meta_script] = "meta_script",
  [sym_op_const_ref] = "op_const_ref",
  [sym_register] = "register",
  [sym_result] = "result",
  [sym_result_const] = "result_const",
  [sym_result_const_nan] = "result_const_nan",
  [sym_result_ref_extern] = "result_ref_extern",
  [sym_result_ref_null] = "result_ref_null",
  [sym_script_module] = "script_module",
  [sym_script_module_binary] = "script_module_binary",
  [sym_script_module_quote] = "script_module_quote",
  [aux_sym_ROOT_repeat1] = "ROOT_repeat1",
  [aux_sym_ROOT_repeat2] = "ROOT_repeat2",
  [aux_sym_annotation_repeat1] = "annotation_repeat1",
  [aux_sym_block_block_repeat1] = "block_block_repeat1",
  [aux_sym_block_block_repeat2] = "block_block_repeat2",
  [aux_sym_comment_block_repeat1] = "comment_block_repeat1",
  [aux_sym_comment_block_annot_repeat1] = "comment_block_annot_repeat1",
  [aux_sym_elem_expr_item_repeat1] = "elem_expr_item_repeat1",
  [aux_sym_elem_list_repeat1] = "elem_list_repeat1",
  [aux_sym_elem_list_repeat2] = "elem_list_repeat2",
  [aux_sym_expr1_call_repeat1] = "expr1_call_repeat1",
  [aux_sym_func_locals_many_repeat1] = "func_locals_many_repeat1",
  [aux_sym_import_desc_func_type_repeat1] = "import_desc_func_type_repeat1",
  [aux_sym_instr_list_repeat1] = "instr_list_repeat1",
  [aux_sym_op_let_repeat1] = "op_let_repeat1",
  [aux_sym_op_let_repeat2] = "op_let_repeat2",
  [aux_sym_memory_fields_data_repeat1] = "memory_fields_data_repeat1",
  [aux_sym_module_field_func_repeat1] = "module_field_func_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_action_invoke_repeat1] = "action_invoke_repeat1",
  [aux_sym_assert_return_repeat1] = "assert_return_repeat1",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_align] = anon_sym_align,
  [anon_sym_EQ] = anon_sym_EQ,
  [sym_align_offset_value] = sym_align_offset_value,
  [anon_sym_LPAREN_AT] = anon_sym_LPAREN_AT,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_block] = anon_sym_block,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_loop] = anon_sym_loop,
  [anon_sym_LPAREN_SEMI] = anon_sym_LPAREN_SEMI,
  [anon_sym_SEMI_RPAREN] = anon_sym_SEMI_RPAREN,
  [sym_comment_block_inner] = sym_comment_block_inner,
  [aux_sym_comment_line_token1] = aux_sym_comment_line_token1,
  [sym_dec_float] = sym_dec_float,
  [sym_dec_nat] = sym_dec_nat,
  [anon_sym_item] = anon_sym_item,
  [anon_sym_func] = anon_sym_func,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_memory] = anon_sym_memory,
  [anon_sym_table] = anon_sym_table,
  [anon_sym_call_indirect] = anon_sym_call_indirect,
  [anon_sym_inf] = anon_sym_inf,
  [anon_sym_local] = anon_sym_local,
  [anon_sym_param] = anon_sym_param,
  [anon_sym_result] = anon_sym_result,
  [anon_sym_mut] = anon_sym_mut,
  [sym_hex_float] = sym_hex_float,
  [sym_hex_nat] = sym_hex_nat,
  [sym_identifier] = sym_identifier,
  [sym_identifier_pattern] = sym_identifier_pattern,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_br_table] = anon_sym_br_table,
  [anon_sym_ref_DOTextern] = anon_sym_ref_DOTextern,
  [anon_sym_ref_DOTnull] = anon_sym_ref_DOTnull,
  [sym_op_nullary] = sym_op_nullary,
  [sym_op_index] = sym_op_index,
  [sym_op_index_opt] = sym_op_index_opt,
  [sym_op_index_opt_offset_opt_align_opt] = sym_op_index_opt_offset_opt_align_opt,
  [sym_op_simd_offset_opt_align_opt] = sym_op_simd_offset_opt_align_opt,
  [aux_sym_op_const_token1] = aux_sym_op_const_token1,
  [aux_sym_op_const_token2] = aux_sym_op_const_token2,
  [anon_sym_func_DOTbind] = anon_sym_func_DOTbind,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_select] = anon_sym_select,
  [anon_sym_v128_DOTconst] = anon_sym_v128_DOTconst,
  [anon_sym_f32x4] = anon_sym_f32x4,
  [anon_sym_f64x2] = anon_sym_f64x2,
  [anon_sym_i8x16] = anon_sym_i8x16,
  [anon_sym_i16x8] = anon_sym_i16x8,
  [anon_sym_i32x4] = anon_sym_i32x4,
  [anon_sym_i64x2] = anon_sym_i64x2,
  [anon_sym_DOTshuffle] = anon_sym_DOTshuffle,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_extract_lane] = anon_sym_extract_lane,
  [anon_sym__] = anon_sym__,
  [aux_sym_op_simd_lane_token1] = aux_sym_op_simd_lane_token1,
  [anon_sym_replace_lane] = anon_sym_replace_lane,
  [anon_sym_table_DOTcopy] = anon_sym_table_DOTcopy,
  [anon_sym_table_DOTinit] = anon_sym_table_DOTinit,
  [anon_sym_data] = anon_sym_data,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_elem] = anon_sym_elem,
  [anon_sym_declare] = anon_sym_declare,
  [anon_sym_start] = anon_sym_start,
  [sym_nan] = sym_nan,
  [anon_sym_f32] = anon_sym_f32,
  [anon_sym_f64] = anon_sym_f64,
  [anon_sym_i32] = anon_sym_i32,
  [anon_sym_i64] = anon_sym_i64,
  [sym_num_type_v128] = sym_num_type_v128,
  [anon_sym_offset] = anon_sym_offset,
  [sym_ref_kind] = sym_ref_kind,
  [sym_ref_type_externref] = sym_ref_type_externref,
  [sym_ref_type_funcref] = sym_ref_type_funcref,
  [anon_sym_ref] = anon_sym_ref,
  [anon_sym_null] = anon_sym_null,
  [sym_reserved] = sym_reserved,
  [sym_share] = sym_share,
  [sym_sign] = sym_sign,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_invoke] = anon_sym_invoke,
  [anon_sym_assert_exhaustion] = anon_sym_assert_exhaustion,
  [anon_sym_assert_invalid] = anon_sym_assert_invalid,
  [anon_sym_assert_malformed] = anon_sym_assert_malformed,
  [anon_sym_assert_return] = anon_sym_assert_return,
  [anon_sym_assert_return_arithmetic_nan] = anon_sym_assert_return_arithmetic_nan,
  [anon_sym_assert_return_canonical_nan] = anon_sym_assert_return_canonical_nan,
  [anon_sym_assert_trap] = anon_sym_assert_trap,
  [anon_sym_assert_unlinkable] = anon_sym_assert_unlinkable,
  [sym_literal_nan_arithmetic] = sym_literal_nan_arithmetic,
  [sym_literal_nan_canonical] = sym_literal_nan_canonical,
  [anon_sym_input] = anon_sym_input,
  [anon_sym_output] = anon_sym_output,
  [anon_sym_script] = anon_sym_script,
  [anon_sym_register] = anon_sym_register,
  [anon_sym_const] = anon_sym_const,
  [sym_result_ref_func] = sym_result_ref_func,
  [anon_sym_binary] = anon_sym_binary,
  [anon_sym_quote] = anon_sym_quote,
  [sym_ROOT] = sym_ROOT,
  [sym_align_value] = sym_align_value,
  [sym_annotation] = sym_annotation,
  [sym_annotation_parens] = sym_annotation_parens,
  [sym_annotation_part] = sym_annotation_part,
  [sym_block_block] = sym_block_block,
  [sym_block_if] = sym_block_if,
  [sym_block_loop] = sym_block_loop,
  [sym_comment_block] = sym_comment_block,
  [sym_comment_block_annot] = sym_comment_block_annot,
  [sym_comment_line] = sym_comment_line,
  [sym_comment_line_annot] = sym_comment_line_annot,
  [sym_elem_expr] = sym_elem_expr,
  [sym_elem_expr_expr] = sym_elem_expr_expr,
  [sym_elem_expr_item] = sym_elem_expr_item,
  [sym_elem_kind] = sym_elem_kind,
  [sym_elem_list] = sym_elem_list,
  [sym_export] = sym_export,
  [sym_export_desc] = sym_export_desc,
  [sym_export_desc_func] = sym_export_desc_func,
  [sym_export_desc_global] = sym_export_desc_global,
  [sym_export_desc_memory] = sym_export_desc_memory,
  [sym_export_desc_table] = sym_export_desc_table,
  [sym_expr] = sym_expr,
  [sym_expr1] = sym_expr1,
  [sym_expr1_block] = sym_expr1_block,
  [sym_expr1_call] = sym_expr1_call,
  [sym_expr1_if] = sym_expr1_if,
  [sym_expr1_loop] = sym_expr1_loop,
  [sym_expr1_plain] = sym_expr1_plain,
  [sym_float] = sym_float,
  [sym_func_locals] = sym_func_locals,
  [sym_func_locals_many] = sym_func_locals_many,
  [sym_func_locals_one] = sym_func_locals_one,
  [sym_func_type] = sym_func_type,
  [sym_func_type_params] = sym_func_type_params,
  [sym_func_type_params_many] = sym_func_type_params_many,
  [sym_func_type_params_one] = sym_func_type_params_one,
  [sym_func_type_results] = sym_func_type_results,
  [sym_global_type] = sym_global_type,
  [sym_global_type_imm] = sym_global_type_imm,
  [sym_global_type_mut] = sym_global_type_mut,
  [sym_if_block] = sym_if_block,
  [sym_import] = sym_import,
  [sym_import_desc] = sym_import_desc,
  [sym_import_desc_func_type] = sym_import_desc_func_type,
  [sym_import_desc_global_type] = sym_import_desc_global_type,
  [sym_import_desc_memory_type] = sym_import_desc_memory_type,
  [sym_import_desc_table_type] = sym_import_desc_table_type,
  [sym_import_desc_type_use] = sym_import_desc_type_use,
  [sym_index] = sym_index,
  [sym_instr] = sym_instr,
  [sym_instr_block] = sym_instr_block,
  [sym_instr_call] = sym_instr_call,
  [sym_instr_list] = sym_instr_list,
  [sym_instr_list_call] = sym_instr_list_call,
  [sym_instr_plain] = sym_instr_plain,
  [sym_op_const] = sym_op_const,
  [sym_op_func_bind] = sym_op_func_bind,
  [sym_op_let] = sym_op_let,
  [sym_op_select] = sym_op_select,
  [sym_op_simd_const] = sym_op_simd_const,
  [sym_op_simd_lane] = sym_op_simd_lane,
  [sym_op_table_copy] = sym_op_table_copy,
  [sym_op_table_init] = sym_op_table_init,
  [sym_int] = sym_int,
  [sym_limits] = sym_limits,
  [sym_memory_fields_data] = sym_memory_fields_data,
  [sym_memory_fields_type] = sym_memory_fields_type,
  [sym_memory_type] = sym_memory_type,
  [sym_memory_use] = sym_memory_use,
  [sym_module] = sym_module,
  [sym_module_field] = sym_module_field,
  [sym_module_field_data] = sym_module_field_data,
  [sym_module_field_elem] = sym_module_field_elem,
  [sym_module_field_export] = sym_module_field_export,
  [sym_module_field_func] = sym_module_field_func,
  [sym_module_field_global] = sym_module_field_global,
  [sym_module_field_import] = sym_module_field_import,
  [sym_module_field_memory] = sym_module_field_memory,
  [sym_module_field_start] = sym_module_field_start,
  [sym_module_field_table] = sym_module_field_table,
  [sym_module_field_type] = sym_module_field_type,
  [sym_name] = sym_name,
  [sym_nat] = sym_nat,
  [sym_num_type_f32] = sym_num_type_f32,
  [sym_num_type_f64] = sym_num_type_f64,
  [sym_num_type_i32] = sym_num_type_i32,
  [sym_num_type_i64] = sym_num_type_i64,
  [sym_offset] = sym_offset,
  [sym_offset_const_expr] = sym_offset_const_expr,
  [sym_offset_expr] = sym_offset_expr,
  [sym_offset_value] = sym_offset_value,
  [sym_ref_type] = sym_ref_type,
  [sym_ref_type_ref] = sym_ref_type_ref,
  [sym_string] = sym_string,
  [sym_table_fields_elem] = sym_table_fields_elem,
  [sym_table_fields_type] = sym_table_fields_type,
  [sym_table_type] = sym_table_type,
  [sym_table_use] = sym_table_use,
  [sym_type_field] = sym_type_field,
  [sym_type_use] = sym_type_use,
  [sym_value_type] = sym_value_type,
  [sym_value_type_num_type] = sym_value_type_num_type,
  [sym_value_type_ref_type] = sym_value_type_ref_type,
  [sym_action] = sym_action,
  [sym_action_get] = sym_action_get,
  [sym_action_invoke] = sym_action_invoke,
  [sym_assert_exhaustion] = sym_assert_exhaustion,
  [sym_assert_invalid] = sym_assert_invalid,
  [sym_assert_malformed] = sym_assert_malformed,
  [sym_assert_return] = sym_assert_return,
  [sym_assert_return_arithmetic_nan] = sym_assert_return_arithmetic_nan,
  [sym_assert_return_canonical_nan] = sym_assert_return_canonical_nan,
  [sym_assert_trap_action] = sym_assert_trap_action,
  [sym_assert_trap_module] = sym_assert_trap_module,
  [sym_assert_unlinkable] = sym_assert_unlinkable,
  [sym_assertion] = sym_assertion,
  [sym_command] = sym_command,
  [sym_expr_plain_const] = sym_expr_plain_const,
  [sym_literal_nan] = sym_literal_nan,
  [sym_meta] = sym_meta,
  [sym_meta_input] = sym_meta_input,
  [sym_meta_output] = sym_meta_output,
  [sym_meta_script] = sym_meta_script,
  [sym_op_const_ref] = sym_op_const_ref,
  [sym_register] = sym_register,
  [sym_result] = sym_result,
  [sym_result_const] = sym_result_const,
  [sym_result_const_nan] = sym_result_const_nan,
  [sym_result_ref_extern] = sym_result_ref_extern,
  [sym_result_ref_null] = sym_result_ref_null,
  [sym_script_module] = sym_script_module,
  [sym_script_module_binary] = sym_script_module_binary,
  [sym_script_module_quote] = sym_script_module_quote,
  [aux_sym_ROOT_repeat1] = aux_sym_ROOT_repeat1,
  [aux_sym_ROOT_repeat2] = aux_sym_ROOT_repeat2,
  [aux_sym_annotation_repeat1] = aux_sym_annotation_repeat1,
  [aux_sym_block_block_repeat1] = aux_sym_block_block_repeat1,
  [aux_sym_block_block_repeat2] = aux_sym_block_block_repeat2,
  [aux_sym_comment_block_repeat1] = aux_sym_comment_block_repeat1,
  [aux_sym_comment_block_annot_repeat1] = aux_sym_comment_block_annot_repeat1,
  [aux_sym_elem_expr_item_repeat1] = aux_sym_elem_expr_item_repeat1,
  [aux_sym_elem_list_repeat1] = aux_sym_elem_list_repeat1,
  [aux_sym_elem_list_repeat2] = aux_sym_elem_list_repeat2,
  [aux_sym_expr1_call_repeat1] = aux_sym_expr1_call_repeat1,
  [aux_sym_func_locals_many_repeat1] = aux_sym_func_locals_many_repeat1,
  [aux_sym_import_desc_func_type_repeat1] = aux_sym_import_desc_func_type_repeat1,
  [aux_sym_instr_list_repeat1] = aux_sym_instr_list_repeat1,
  [aux_sym_op_let_repeat1] = aux_sym_op_let_repeat1,
  [aux_sym_op_let_repeat2] = aux_sym_op_let_repeat2,
  [aux_sym_memory_fields_data_repeat1] = aux_sym_memory_fields_data_repeat1,
  [aux_sym_module_field_func_repeat1] = aux_sym_module_field_func_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_action_invoke_repeat1] = aux_sym_action_invoke_repeat1,
  [aux_sym_assert_return_repeat1] = aux_sym_assert_return_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_align] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [sym_align_offset_value] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_block] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_loop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_comment_block_inner] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_comment_line_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_dec_float] = {
    .visible = true,
    .named = true,
  },
  [sym_dec_nat] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_item] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_func] = {
    .visible = true,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_memory] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_table] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_call_indirect] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inf] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_param] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_result] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mut] = {
    .visible = true,
    .named = false,
  },
  [sym_hex_float] = {
    .visible = true,
    .named = true,
  },
  [sym_hex_nat] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier_pattern] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_br_table] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ref_DOTextern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ref_DOTnull] = {
    .visible = true,
    .named = false,
  },
  [sym_op_nullary] = {
    .visible = true,
    .named = true,
  },
  [sym_op_index] = {
    .visible = true,
    .named = true,
  },
  [sym_op_index_opt] = {
    .visible = true,
    .named = true,
  },
  [sym_op_index_opt_offset_opt_align_opt] = {
    .visible = true,
    .named = true,
  },
  [sym_op_simd_offset_opt_align_opt] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_op_const_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_op_const_token2] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_func_DOTbind] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_select] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_v128_DOTconst] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_f32x4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_f64x2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_i8x16] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_i16x8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_i32x4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_i64x2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOTshuffle] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extract_lane] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_op_simd_lane_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_replace_lane] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_table_DOTcopy] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_table_DOTinit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_data] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elem] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_start] = {
    .visible = true,
    .named = false,
  },
  [sym_nan] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_f32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_f64] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_i32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_i64] = {
    .visible = true,
    .named = false,
  },
  [sym_num_type_v128] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_offset] = {
    .visible = true,
    .named = false,
  },
  [sym_ref_kind] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_type_externref] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_type_funcref] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_ref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_null] = {
    .visible = true,
    .named = false,
  },
  [sym_reserved] = {
    .visible = true,
    .named = true,
  },
  [sym_share] = {
    .visible = true,
    .named = true,
  },
  [sym_sign] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_invoke] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert_exhaustion] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert_invalid] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert_malformed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert_return_arithmetic_nan] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert_return_canonical_nan] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert_trap] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert_unlinkable] = {
    .visible = true,
    .named = false,
  },
  [sym_literal_nan_arithmetic] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_nan_canonical] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_input] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_output] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_script] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_register] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [sym_result_ref_func] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_binary] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_quote] = {
    .visible = true,
    .named = false,
  },
  [sym_ROOT] = {
    .visible = true,
    .named = true,
  },
  [sym_align_value] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_parens] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_part] = {
    .visible = true,
    .named = true,
  },
  [sym_block_block] = {
    .visible = true,
    .named = true,
  },
  [sym_block_if] = {
    .visible = true,
    .named = true,
  },
  [sym_block_loop] = {
    .visible = true,
    .named = true,
  },
  [sym_comment_block] = {
    .visible = true,
    .named = true,
  },
  [sym_comment_block_annot] = {
    .visible = true,
    .named = true,
  },
  [sym_comment_line] = {
    .visible = true,
    .named = true,
  },
  [sym_comment_line_annot] = {
    .visible = true,
    .named = true,
  },
  [sym_elem_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_elem_expr_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_elem_expr_item] = {
    .visible = true,
    .named = true,
  },
  [sym_elem_kind] = {
    .visible = true,
    .named = true,
  },
  [sym_elem_list] = {
    .visible = true,
    .named = true,
  },
  [sym_export] = {
    .visible = true,
    .named = true,
  },
  [sym_export_desc] = {
    .visible = true,
    .named = true,
  },
  [sym_export_desc_func] = {
    .visible = true,
    .named = true,
  },
  [sym_export_desc_global] = {
    .visible = true,
    .named = true,
  },
  [sym_export_desc_memory] = {
    .visible = true,
    .named = true,
  },
  [sym_export_desc_table] = {
    .visible = true,
    .named = true,
  },
  [sym_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_expr1] = {
    .visible = true,
    .named = true,
  },
  [sym_expr1_block] = {
    .visible = true,
    .named = true,
  },
  [sym_expr1_call] = {
    .visible = true,
    .named = true,
  },
  [sym_expr1_if] = {
    .visible = true,
    .named = true,
  },
  [sym_expr1_loop] = {
    .visible = true,
    .named = true,
  },
  [sym_expr1_plain] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_func_locals] = {
    .visible = true,
    .named = true,
  },
  [sym_func_locals_many] = {
    .visible = true,
    .named = true,
  },
  [sym_func_locals_one] = {
    .visible = true,
    .named = true,
  },
  [sym_func_type] = {
    .visible = true,
    .named = true,
  },
  [sym_func_type_params] = {
    .visible = true,
    .named = true,
  },
  [sym_func_type_params_many] = {
    .visible = true,
    .named = true,
  },
  [sym_func_type_params_one] = {
    .visible = true,
    .named = true,
  },
  [sym_func_type_results] = {
    .visible = true,
    .named = true,
  },
  [sym_global_type] = {
    .visible = true,
    .named = true,
  },
  [sym_global_type_imm] = {
    .visible = true,
    .named = true,
  },
  [sym_global_type_mut] = {
    .visible = true,
    .named = true,
  },
  [sym_if_block] = {
    .visible = true,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_desc] = {
    .visible = true,
    .named = true,
  },
  [sym_import_desc_func_type] = {
    .visible = true,
    .named = true,
  },
  [sym_import_desc_global_type] = {
    .visible = true,
    .named = true,
  },
  [sym_import_desc_memory_type] = {
    .visible = true,
    .named = true,
  },
  [sym_import_desc_table_type] = {
    .visible = true,
    .named = true,
  },
  [sym_import_desc_type_use] = {
    .visible = true,
    .named = true,
  },
  [sym_index] = {
    .visible = true,
    .named = true,
  },
  [sym_instr] = {
    .visible = true,
    .named = true,
  },
  [sym_instr_block] = {
    .visible = true,
    .named = true,
  },
  [sym_instr_call] = {
    .visible = true,
    .named = true,
  },
  [sym_instr_list] = {
    .visible = true,
    .named = true,
  },
  [sym_instr_list_call] = {
    .visible = true,
    .named = true,
  },
  [sym_instr_plain] = {
    .visible = true,
    .named = true,
  },
  [sym_op_const] = {
    .visible = true,
    .named = true,
  },
  [sym_op_func_bind] = {
    .visible = true,
    .named = true,
  },
  [sym_op_let] = {
    .visible = true,
    .named = true,
  },
  [sym_op_select] = {
    .visible = true,
    .named = true,
  },
  [sym_op_simd_const] = {
    .visible = true,
    .named = true,
  },
  [sym_op_simd_lane] = {
    .visible = true,
    .named = true,
  },
  [sym_op_table_copy] = {
    .visible = true,
    .named = true,
  },
  [sym_op_table_init] = {
    .visible = true,
    .named = true,
  },
  [sym_int] = {
    .visible = true,
    .named = true,
  },
  [sym_limits] = {
    .visible = true,
    .named = true,
  },
  [sym_memory_fields_data] = {
    .visible = true,
    .named = true,
  },
  [sym_memory_fields_type] = {
    .visible = true,
    .named = true,
  },
  [sym_memory_type] = {
    .visible = true,
    .named = true,
  },
  [sym_memory_use] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_module_field] = {
    .visible = true,
    .named = true,
  },
  [sym_module_field_data] = {
    .visible = true,
    .named = true,
  },
  [sym_module_field_elem] = {
    .visible = true,
    .named = true,
  },
  [sym_module_field_export] = {
    .visible = true,
    .named = true,
  },
  [sym_module_field_func] = {
    .visible = true,
    .named = true,
  },
  [sym_module_field_global] = {
    .visible = true,
    .named = true,
  },
  [sym_module_field_import] = {
    .visible = true,
    .named = true,
  },
  [sym_module_field_memory] = {
    .visible = true,
    .named = true,
  },
  [sym_module_field_start] = {
    .visible = true,
    .named = true,
  },
  [sym_module_field_table] = {
    .visible = true,
    .named = true,
  },
  [sym_module_field_type] = {
    .visible = true,
    .named = true,
  },
  [sym_name] = {
    .visible = true,
    .named = true,
  },
  [sym_nat] = {
    .visible = true,
    .named = true,
  },
  [sym_num_type_f32] = {
    .visible = true,
    .named = true,
  },
  [sym_num_type_f64] = {
    .visible = true,
    .named = true,
  },
  [sym_num_type_i32] = {
    .visible = true,
    .named = true,
  },
  [sym_num_type_i64] = {
    .visible = true,
    .named = true,
  },
  [sym_offset] = {
    .visible = true,
    .named = true,
  },
  [sym_offset_const_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_offset_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_offset_value] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_type] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_type_ref] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_table_fields_elem] = {
    .visible = true,
    .named = true,
  },
  [sym_table_fields_type] = {
    .visible = true,
    .named = true,
  },
  [sym_table_type] = {
    .visible = true,
    .named = true,
  },
  [sym_table_use] = {
    .visible = true,
    .named = true,
  },
  [sym_type_field] = {
    .visible = true,
    .named = true,
  },
  [sym_type_use] = {
    .visible = true,
    .named = true,
  },
  [sym_value_type] = {
    .visible = true,
    .named = true,
  },
  [sym_value_type_num_type] = {
    .visible = true,
    .named = true,
  },
  [sym_value_type_ref_type] = {
    .visible = true,
    .named = true,
  },
  [sym_action] = {
    .visible = true,
    .named = true,
  },
  [sym_action_get] = {
    .visible = true,
    .named = true,
  },
  [sym_action_invoke] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_exhaustion] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_invalid] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_malformed] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_return] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_return_arithmetic_nan] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_return_canonical_nan] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_trap_action] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_trap_module] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_unlinkable] = {
    .visible = true,
    .named = true,
  },
  [sym_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
  },
  [sym_expr_plain_const] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_nan] = {
    .visible = true,
    .named = true,
  },
  [sym_meta] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_input] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_output] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_script] = {
    .visible = true,
    .named = true,
  },
  [sym_op_const_ref] = {
    .visible = true,
    .named = true,
  },
  [sym_register] = {
    .visible = true,
    .named = true,
  },
  [sym_result] = {
    .visible = true,
    .named = true,
  },
  [sym_result_const] = {
    .visible = true,
    .named = true,
  },
  [sym_result_const_nan] = {
    .visible = true,
    .named = true,
  },
  [sym_result_ref_extern] = {
    .visible = true,
    .named = true,
  },
  [sym_result_ref_null] = {
    .visible = true,
    .named = true,
  },
  [sym_script_module] = {
    .visible = true,
    .named = true,
  },
  [sym_script_module_binary] = {
    .visible = true,
    .named = true,
  },
  [sym_script_module_quote] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_ROOT_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_ROOT_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_annotation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_block_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_comment_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_comment_block_annot_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_elem_expr_item_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_elem_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_elem_list_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expr1_call_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_func_locals_many_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_desc_func_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_instr_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_op_let_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_op_let_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_memory_fields_data_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_field_func_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_action_invoke_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_assert_return_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_identifier = 1,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_identifier] = "identifier",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_identifier, 2},
};

static TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < '\\'
    ? (c < '*'
      ? (c < '#'
        ? c == '!'
        : c <= '\'')
      : (c <= ':' || (c >= '<' && c <= 'Z')))
    : (c <= '\\' || (c < '|'
      ? (c < 'a'
        ? (c >= '^' && c <= '_')
        : c <= 'z')
      : (c <= '|' || c == '~'))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(1115);
      if (lookahead == '"') ADVANCE(1276);
      if (lookahead == '$') ADVANCE(1113);
      if (lookahead == '(') ADVANCE(1125);
      if (lookahead == ')') ADVANCE(1124);
      if (lookahead == '.') ADVANCE(1229);
      if (lookahead == '0') ADVANCE(1119);
      if (lookahead == ';') ADVANCE(16);
      if (lookahead == '=') ADVANCE(1117);
      if (lookahead == '\\') ADVANCE(1011);
      if (lookahead == '_') ADVANCE(1231);
      if (lookahead == 'a') ADVANCE(602);
      if (lookahead == 'b') ADVANCE(543);
      if (lookahead == 'c') ADVANCE(197);
      if (lookahead == 'd') ADVANCE(198);
      if (lookahead == 'e') ADVANCE(606);
      if (lookahead == 'f') ADVANCE(93);
      if (lookahead == 'g') ADVANCE(416);
      if (lookahead == 'i') ADVANCE(42);
      if (lookahead == 'l') ADVANCE(426);
      if (lookahead == 'm') ADVANCE(386);
      if (lookahead == 'n') ADVANCE(215);
      if (lookahead == 'o') ADVANCE(491);
      if (lookahead == 'p') ADVANCE(199);
      if (lookahead == 'q') ADVANCE(1014);
      if (lookahead == 'r') ADVANCE(387);
      if (lookahead == 's') ADVANCE(1233);
      if (lookahead == 't') ADVANCE(200);
      if (lookahead == 'u') ADVANCE(1234);
      if (lookahead == 'v') ADVANCE(43);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(1275);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(1114)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(1121);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(8)
      if (lookahead == '"') ADVANCE(1276);
      if (lookahead == '(') ADVANCE(1279);
      if (lookahead == ';') ADVANCE(1280);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(1278);
      if (lookahead != 0) ADVANCE(1281);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(1277);
      if (lookahead == '\r') ADVANCE(1151);
      if (lookahead == 'u') ADVANCE(1089);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1105);
      if (lookahead != 0) ADVANCE(1152);
      END_STATE();
    case 3:
      if (lookahead == '"') ADVANCE(1276);
      if (lookahead == '$') ADVANCE(1113);
      if (lookahead == '(') ADVANCE(1125);
      if (lookahead == ')') ADVANCE(1124);
      if (lookahead == '0') ADVANCE(1144);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == 'a') ADVANCE(603);
      if (lookahead == 'b') ADVANCE(605);
      if (lookahead == 'c') ADVANCE(274);
      if (lookahead == 'd') ADVANCE(263);
      if (lookahead == 'e') ADVANCE(651);
      if (lookahead == 'f') ADVANCE(94);
      if (lookahead == 'g') ADVANCE(417);
      if (lookahead == 'i') ADVANCE(56);
      if (lookahead == 'l') ADVANCE(426);
      if (lookahead == 'm') ADVANCE(477);
      if (lookahead == 'n') ADVANCE(253);
      if (lookahead == 'o') ADVANCE(491);
      if (lookahead == 'p') ADVANCE(199);
      if (lookahead == 'r') ADVANCE(405);
      if (lookahead == 's') ADVANCE(319);
      if (lookahead == 't') ADVANCE(200);
      if (lookahead == 'u') ADVANCE(701);
      if (lookahead == 'v') ADVANCE(53);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(1275);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(3)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(1145);
      END_STATE();
    case 4:
      if (lookahead == '"') ADVANCE(1276);
      if (lookahead == '$') ADVANCE(1113);
      if (lookahead == '(') ADVANCE(1125);
      if (lookahead == ')') ADVANCE(1124);
      if (lookahead == '0') ADVANCE(1144);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == 'a') ADVANCE(604);
      if (lookahead == 'b') ADVANCE(605);
      if (lookahead == 'c') ADVANCE(274);
      if (lookahead == 'd') ADVANCE(262);
      if (lookahead == 'e') ADVANCE(650);
      if (lookahead == 'f') ADVANCE(95);
      if (lookahead == 'g') ADVANCE(664);
      if (lookahead == 'i') ADVANCE(55);
      if (lookahead == 'l') ADVANCE(427);
      if (lookahead == 'm') ADVANCE(481);
      if (lookahead == 'n') ADVANCE(773);
      if (lookahead == 'o') ADVANCE(490);
      if (lookahead == 'r') ADVANCE(411);
      if (lookahead == 's') ADVANCE(415);
      if (lookahead == 't') ADVANCE(280);
      if (lookahead == 'u') ADVANCE(701);
      if (lookahead == 'v') ADVANCE(53);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(1275);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(4)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(1145);
      END_STATE();
    case 5:
      if (lookahead == '"') ADVANCE(1276);
      if (lookahead == '$') ADVANCE(1113);
      if (lookahead == '(') ADVANCE(1125);
      if (lookahead == ')') ADVANCE(1124);
      if (lookahead == '0') ADVANCE(1144);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == 'd') ADVANCE(385);
      if (lookahead == 'e') ADVANCE(1074);
      if (lookahead == 'f') ADVANCE(103);
      if (lookahead == 'i') ADVANCE(104);
      if (lookahead == 'v') ADVANCE(51);
      if (lookahead == 's' ||
          lookahead == 'u') ADVANCE(1232);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(6)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(1145);
      END_STATE();
    case 6:
      if (lookahead == '"') ADVANCE(1276);
      if (lookahead == '$') ADVANCE(1113);
      if (lookahead == '(') ADVANCE(1125);
      if (lookahead == ')') ADVANCE(1124);
      if (lookahead == '0') ADVANCE(1144);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == 'd') ADVANCE(385);
      if (lookahead == 'e') ADVANCE(1074);
      if (lookahead == 'f') ADVANCE(103);
      if (lookahead == 'i') ADVANCE(104);
      if (lookahead == 'v') ADVANCE(51);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(6)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(1145);
      END_STATE();
    case 7:
      if (lookahead == '"') ADVANCE(1276);
      if (lookahead == '$') ADVANCE(1272);
      if (lookahead == '(') ADVANCE(1125);
      if (lookahead == ')') ADVANCE(1124);
      if (lookahead == ',') ADVANCE(1273);
      if (lookahead == ';') ADVANCE(1271);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(1270);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(7)
      if (('!' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= '~')) ADVANCE(1273);
      END_STATE();
    case 8:
      if (lookahead == '"') ADVANCE(1276);
      if (lookahead == '(') ADVANCE(161);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(8)
      END_STATE();
    case 9:
      if (lookahead == '$') ADVANCE(1113);
      if (lookahead == '(') ADVANCE(161);
      if (lookahead == ')') ADVANCE(1124);
      if (lookahead == '0') ADVANCE(1144);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == 'e') ADVANCE(1075);
      if (lookahead == 'f') ADVANCE(107);
      if (lookahead == 'i') ADVANCE(59);
      if (lookahead == 'n') ADVANCE(1023);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(9)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(1145);
      END_STATE();
    case 10:
      if (lookahead == '(') ADVANCE(1125);
      if (lookahead == ')') ADVANCE(1124);
      if (lookahead == '0') ADVANCE(1138);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == 'a') ADVANCE(983);
      if (lookahead == 'b') ADVANCE(605);
      if (lookahead == 'c') ADVANCE(274);
      if (lookahead == 'd') ADVANCE(263);
      if (lookahead == 'e') ADVANCE(649);
      if (lookahead == 'f') ADVANCE(96);
      if (lookahead == 'g') ADVANCE(664);
      if (lookahead == 'i') ADVANCE(57);
      if (lookahead == 'l') ADVANCE(427);
      if (lookahead == 'm') ADVANCE(481);
      if (lookahead == 'n') ADVANCE(287);
      if (lookahead == 'r') ADVANCE(411);
      if (lookahead == 's') ADVANCE(414);
      if (lookahead == 't') ADVANCE(280);
      if (lookahead == 'u') ADVANCE(749);
      if (lookahead == 'v') ADVANCE(53);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(1275);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(1139);
      END_STATE();
    case 11:
      if (lookahead == '(') ADVANCE(161);
      if (lookahead == '0') ADVANCE(1120);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == 'a') ADVANCE(919);
      if (lookahead == 'd') ADVANCE(272);
      if (lookahead == 'e') ADVANCE(653);
      if (lookahead == 'f') ADVANCE(101);
      if (lookahead == 'g') ADVANCE(418);
      if (lookahead == 'i') ADVANCE(102);
      if (lookahead == 'm') ADVANCE(484);
      if (lookahead == 'o') ADVANCE(1015);
      if (lookahead == 'r') ADVANCE(412);
      if (lookahead == 's') ADVANCE(321);
      if (lookahead == 't') ADVANCE(281);
      if (lookahead == 'v') ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(1121);
      END_STATE();
    case 12:
      if (lookahead == '(') ADVANCE(161);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == 'a') ADVANCE(919);
      if (lookahead == 'd') ADVANCE(272);
      if (lookahead == 'e') ADVANCE(653);
      if (lookahead == 'f') ADVANCE(101);
      if (lookahead == 'g') ADVANCE(418);
      if (lookahead == 'i') ADVANCE(102);
      if (lookahead == 'm') ADVANCE(484);
      if (lookahead == 'o') ADVANCE(1015);
      if (lookahead == 'r') ADVANCE(412);
      if (lookahead == 's') ADVANCE(321);
      if (lookahead == 't') ADVANCE(281);
      if (lookahead == 'v') ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      END_STATE();
    case 13:
      if (lookahead == '(') ADVANCE(161);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(13)
      END_STATE();
    case 14:
      if (lookahead == '(') ADVANCE(161);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(13)
      if (lookahead == '!' ||
          ('#' <= lookahead && lookahead <= '\'') ||
          ('*' <= lookahead && lookahead <= 'Z') ||
          lookahead == '\\' ||
          lookahead == '^' ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(1173);
      END_STATE();
    case 15:
      if (lookahead == '(') ADVANCE(1135);
      if (lookahead == ';') ADVANCE(1134);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(1133);
      if (lookahead != 0) ADVANCE(1136);
      END_STATE();
    case 16:
      if (lookahead == ')') ADVANCE(1132);
      if (lookahead == ';') ADVANCE(1137);
      END_STATE();
    case 17:
      if (lookahead == '.') ADVANCE(432);
      END_STATE();
    case 18:
      if (lookahead == '.') ADVANCE(523);
      END_STATE();
    case 19:
      if (lookahead == '.') ADVANCE(332);
      END_STATE();
    case 20:
      if (lookahead == '.') ADVANCE(522);
      END_STATE();
    case 21:
      if (lookahead == '.') ADVANCE(205);
      if (lookahead == 'x') ADVANCE(120);
      END_STATE();
    case 22:
      if (lookahead == '.') ADVANCE(206);
      if (lookahead == 'x') ADVANCE(75);
      END_STATE();
    case 23:
      if (lookahead == '.') ADVANCE(207);
      if (lookahead == 'x') ADVANCE(121);
      END_STATE();
    case 24:
      if (lookahead == '.') ADVANCE(282);
      if (lookahead == 'x') ADVANCE(76);
      END_STATE();
    case 25:
      if (lookahead == '.') ADVANCE(222);
      END_STATE();
    case 26:
      if (lookahead == '.') ADVANCE(258);
      END_STATE();
    case 27:
      if (lookahead == '.') ADVANCE(259);
      END_STATE();
    case 28:
      if (lookahead == '.') ADVANCE(660);
      END_STATE();
    case 29:
      if (lookahead == '.') ADVANCE(739);
      END_STATE();
    case 30:
      if (lookahead == '.') ADVANCE(211);
      if (lookahead == '1') ADVANCE(139);
      if (lookahead == '3') ADVANCE(83);
      if (lookahead == '8') ADVANCE(38);
      END_STATE();
    case 31:
      if (lookahead == '.') ADVANCE(211);
      if (lookahead == '1') ADVANCE(139);
      if (lookahead == '8') ADVANCE(38);
      END_STATE();
    case 32:
      if (lookahead == '.') ADVANCE(376);
      END_STATE();
    case 33:
      if (lookahead == '.') ADVANCE(298);
      END_STATE();
    case 34:
      if (lookahead == '.') ADVANCE(298);
      if (lookahead == 'r') ADVANCE(433);
      END_STATE();
    case 35:
      if (lookahead == '.') ADVANCE(511);
      END_STATE();
    case 36:
      if (lookahead == '.') ADVANCE(659);
      END_STATE();
    case 37:
      if (lookahead == '.') ADVANCE(661);
      END_STATE();
    case 38:
      if (lookahead == '.') ADVANCE(266);
      END_STATE();
    case 39:
      if (lookahead == '.') ADVANCE(352);
      END_STATE();
    case 40:
      if (lookahead == '0') ADVANCE(1053);
      if (lookahead == 'a') ADVANCE(861);
      if (lookahead == 'c') ADVANCE(235);
      END_STATE();
    case 41:
      if (lookahead == '0') ADVANCE(1053);
      if (lookahead == 'a') ADVANCE(918);
      if (lookahead == 'c') ADVANCE(285);
      END_STATE();
    case 42:
      if (lookahead == '1') ADVANCE(135);
      if (lookahead == '3') ADVANCE(61);
      if (lookahead == '6') ADVANCE(109);
      if (lookahead == '8') ADVANCE(1047);
      if (lookahead == 'f') ADVANCE(1128);
      if (lookahead == 'm') ADVANCE(848);
      if (lookahead == 'n') ADVANCE(493);
      if (lookahead == 't') ADVANCE(428);
      END_STATE();
    case 43:
      if (lookahead == '1') ADVANCE(62);
      if (lookahead == '3') ADVANCE(77);
      if (lookahead == '6') ADVANCE(123);
      if (lookahead == '8') ADVANCE(1068);
      END_STATE();
    case 44:
      if (lookahead == '1') ADVANCE(130);
      END_STATE();
    case 45:
      if (lookahead == '1') ADVANCE(131);
      END_STATE();
    case 46:
      if (lookahead == '1') ADVANCE(136);
      END_STATE();
    case 47:
      if (lookahead == '1') ADVANCE(144);
      if (lookahead == '3') ADVANCE(89);
      if (lookahead == '8') ADVANCE(173);
      if (lookahead == '_') ADVANCE(579);
      END_STATE();
    case 48:
      if (lookahead == '1') ADVANCE(144);
      if (lookahead == '8') ADVANCE(173);
      END_STATE();
    case 49:
      if (lookahead == '1') ADVANCE(134);
      END_STATE();
    case 50:
      if (lookahead == '1') ADVANCE(84);
      END_STATE();
    case 51:
      if (lookahead == '1') ADVANCE(86);
      END_STATE();
    case 52:
      if (lookahead == '1') ADVANCE(143);
      END_STATE();
    case 53:
      if (lookahead == '1') ADVANCE(80);
      if (lookahead == '3') ADVANCE(77);
      if (lookahead == '6') ADVANCE(123);
      if (lookahead == '8') ADVANCE(1068);
      END_STATE();
    case 54:
      if (lookahead == '1') ADVANCE(138);
      END_STATE();
    case 55:
      if (lookahead == '1') ADVANCE(145);
      if (lookahead == '3') ADVANCE(79);
      if (lookahead == '6') ADVANCE(124);
      if (lookahead == '8') ADVANCE(1070);
      if (lookahead == 'f') ADVANCE(1128);
      END_STATE();
    case 56:
      if (lookahead == '1') ADVANCE(145);
      if (lookahead == '3') ADVANCE(79);
      if (lookahead == '6') ADVANCE(124);
      if (lookahead == '8') ADVANCE(1070);
      if (lookahead == 'f') ADVANCE(1128);
      if (lookahead == 'm') ADVANCE(848);
      if (lookahead == 'n') ADVANCE(828);
      if (lookahead == 't') ADVANCE(428);
      END_STATE();
    case 57:
      if (lookahead == '1') ADVANCE(145);
      if (lookahead == '3') ADVANCE(79);
      if (lookahead == '6') ADVANCE(124);
      if (lookahead == '8') ADVANCE(1070);
      if (lookahead == 'f') ADVANCE(1128);
      if (lookahead == 'n') ADVANCE(492);
      END_STATE();
    case 58:
      if (lookahead == '1') ADVANCE(146);
      END_STATE();
    case 59:
      if (lookahead == '1') ADVANCE(147);
      if (lookahead == '3') ADVANCE(92);
      if (lookahead == '6') ADVANCE(129);
      if (lookahead == '8') ADVANCE(1073);
      END_STATE();
    case 60:
      if (lookahead == '2') ADVANCE(1251);
      END_STATE();
    case 61:
      if (lookahead == '2') ADVANCE(1257);
      END_STATE();
    case 62:
      if (lookahead == '2') ADVANCE(148);
      if (lookahead == '6') ADVANCE(1050);
      END_STATE();
    case 63:
      if (lookahead == '2') ADVANCE(1214);
      END_STATE();
    case 64:
      if (lookahead == '2') ADVANCE(1226);
      END_STATE();
    case 65:
      if (lookahead == '2') ADVANCE(36);
      END_STATE();
    case 66:
      if (lookahead == '2') ADVANCE(21);
      END_STATE();
    case 67:
      if (lookahead == '2') ADVANCE(1179);
      END_STATE();
    case 68:
      if (lookahead == '2') ADVANCE(1196);
      END_STATE();
    case 69:
      if (lookahead == '2') ADVANCE(1250);
      END_STATE();
    case 70:
      if (lookahead == '2') ADVANCE(1256);
      END_STATE();
    case 71:
      if (lookahead == '2') ADVANCE(1249);
      END_STATE();
    case 72:
      if (lookahead == '2') ADVANCE(1255);
      END_STATE();
    case 73:
      if (lookahead == '2') ADVANCE(1213);
      END_STATE();
    case 74:
      if (lookahead == '2') ADVANCE(1225);
      END_STATE();
    case 75:
      if (lookahead == '2') ADVANCE(1215);
      END_STATE();
    case 76:
      if (lookahead == '2') ADVANCE(1227);
      END_STATE();
    case 77:
      if (lookahead == '2') ADVANCE(1055);
      END_STATE();
    case 78:
      if (lookahead == '2') ADVANCE(171);
      END_STATE();
    case 79:
      if (lookahead == '2') ADVANCE(23);
      END_STATE();
    case 80:
      if (lookahead == '2') ADVANCE(154);
      if (lookahead == '6') ADVANCE(1050);
      END_STATE();
    case 81:
      if (lookahead == '2') ADVANCE(164);
      END_STATE();
    case 82:
      if (lookahead == '2') ADVANCE(167);
      END_STATE();
    case 83:
      if (lookahead == '2') ADVANCE(38);
      END_STATE();
    case 84:
      if (lookahead == '2') ADVANCE(157);
      END_STATE();
    case 85:
      if (lookahead == '2') ADVANCE(168);
      END_STATE();
    case 86:
      if (lookahead == '2') ADVANCE(151);
      END_STATE();
    case 87:
      if (lookahead == '2') ADVANCE(177);
      END_STATE();
    case 88:
      if (lookahead == '2') ADVANCE(1058);
      END_STATE();
    case 89:
      if (lookahead == '2') ADVANCE(173);
      END_STATE();
    case 90:
      if (lookahead == '2') ADVANCE(1061);
      END_STATE();
    case 91:
      if (lookahead == '2') ADVANCE(1062);
      END_STATE();
    case 92:
      if (lookahead == '2') ADVANCE(1063);
      END_STATE();
    case 93:
      if (lookahead == '3') ADVANCE(60);
      if (lookahead == '6') ADVANCE(108);
      if (lookahead == 'u') ADVANCE(708);
      END_STATE();
    case 94:
      if (lookahead == '3') ADVANCE(66);
      if (lookahead == '6') ADVANCE(122);
      if (lookahead == 'u') ADVANCE(718);
      END_STATE();
    case 95:
      if (lookahead == '3') ADVANCE(66);
      if (lookahead == '6') ADVANCE(122);
      if (lookahead == 'u') ADVANCE(729);
      END_STATE();
    case 96:
      if (lookahead == '3') ADVANCE(66);
      if (lookahead == '6') ADVANCE(122);
      if (lookahead == 'u') ADVANCE(730);
      END_STATE();
    case 97:
      if (lookahead == '3') ADVANCE(82);
      END_STATE();
    case 98:
      if (lookahead == '3') ADVANCE(82);
      if (lookahead == '6') ADVANCE(127);
      END_STATE();
    case 99:
      if (lookahead == '3') ADVANCE(67);
      END_STATE();
    case 100:
      if (lookahead == '3') ADVANCE(67);
      if (lookahead == '6') ADVANCE(113);
      END_STATE();
    case 101:
      if (lookahead == '3') ADVANCE(69);
      if (lookahead == '6') ADVANCE(114);
      if (lookahead == 'u') ADVANCE(731);
      END_STATE();
    case 102:
      if (lookahead == '3') ADVANCE(70);
      if (lookahead == '6') ADVANCE(115);
      if (lookahead == 'm') ADVANCE(848);
      if (lookahead == 'n') ADVANCE(828);
      END_STATE();
    case 103:
      if (lookahead == '3') ADVANCE(71);
      if (lookahead == '6') ADVANCE(116);
      if (lookahead == 'u') ADVANCE(733);
      END_STATE();
    case 104:
      if (lookahead == '3') ADVANCE(72);
      if (lookahead == '6') ADVANCE(117);
      END_STATE();
    case 105:
      if (lookahead == '3') ADVANCE(88);
      END_STATE();
    case 106:
      if (lookahead == '3') ADVANCE(90);
      END_STATE();
    case 107:
      if (lookahead == '3') ADVANCE(91);
      if (lookahead == '6') ADVANCE(128);
      if (lookahead == 'u') ADVANCE(735);
      END_STATE();
    case 108:
      if (lookahead == '4') ADVANCE(1254);
      END_STATE();
    case 109:
      if (lookahead == '4') ADVANCE(1260);
      END_STATE();
    case 110:
      if (lookahead == '4') ADVANCE(1211);
      END_STATE();
    case 111:
      if (lookahead == '4') ADVANCE(1224);
      END_STATE();
    case 112:
      if (lookahead == '4') ADVANCE(36);
      END_STATE();
    case 113:
      if (lookahead == '4') ADVANCE(1179);
      END_STATE();
    case 114:
      if (lookahead == '4') ADVANCE(1253);
      END_STATE();
    case 115:
      if (lookahead == '4') ADVANCE(1259);
      END_STATE();
    case 116:
      if (lookahead == '4') ADVANCE(1252);
      END_STATE();
    case 117:
      if (lookahead == '4') ADVANCE(1258);
      END_STATE();
    case 118:
      if (lookahead == '4') ADVANCE(1210);
      END_STATE();
    case 119:
      if (lookahead == '4') ADVANCE(1222);
      END_STATE();
    case 120:
      if (lookahead == '4') ADVANCE(1212);
      END_STATE();
    case 121:
      if (lookahead == '4') ADVANCE(1223);
      END_STATE();
    case 122:
      if (lookahead == '4') ADVANCE(22);
      END_STATE();
    case 123:
      if (lookahead == '4') ADVANCE(1054);
      END_STATE();
    case 124:
      if (lookahead == '4') ADVANCE(24);
      END_STATE();
    case 125:
      if (lookahead == '4') ADVANCE(169);
      END_STATE();
    case 126:
      if (lookahead == '4') ADVANCE(164);
      END_STATE();
    case 127:
      if (lookahead == '4') ADVANCE(167);
      END_STATE();
    case 128:
      if (lookahead == '4') ADVANCE(1066);
      END_STATE();
    case 129:
      if (lookahead == '4') ADVANCE(1067);
      END_STATE();
    case 130:
      if (lookahead == '6') ADVANCE(1217);
      END_STATE();
    case 131:
      if (lookahead == '6') ADVANCE(36);
      END_STATE();
    case 132:
      if (lookahead == '6') ADVANCE(1179);
      END_STATE();
    case 133:
      if (lookahead == '6') ADVANCE(1196);
      END_STATE();
    case 134:
      if (lookahead == '6') ADVANCE(1216);
      END_STATE();
    case 135:
      if (lookahead == '6') ADVANCE(1049);
      END_STATE();
    case 136:
      if (lookahead == '6') ADVANCE(1218);
      END_STATE();
    case 137:
      if (lookahead == '6') ADVANCE(172);
      END_STATE();
    case 138:
      if (lookahead == '6') ADVANCE(167);
      END_STATE();
    case 139:
      if (lookahead == '6') ADVANCE(38);
      END_STATE();
    case 140:
      if (lookahead == '6') ADVANCE(168);
      END_STATE();
    case 141:
      if (lookahead == '6') ADVANCE(113);
      END_STATE();
    case 142:
      if (lookahead == '6') ADVANCE(177);
      END_STATE();
    case 143:
      if (lookahead == '6') ADVANCE(1059);
      END_STATE();
    case 144:
      if (lookahead == '6') ADVANCE(173);
      END_STATE();
    case 145:
      if (lookahead == '6') ADVANCE(1056);
      END_STATE();
    case 146:
      if (lookahead == '6') ADVANCE(1069);
      END_STATE();
    case 147:
      if (lookahead == '6') ADVANCE(1060);
      END_STATE();
    case 148:
      if (lookahead == '8') ADVANCE(1262);
      END_STATE();
    case 149:
      if (lookahead == '8') ADVANCE(1220);
      END_STATE();
    case 150:
      if (lookahead == '8') ADVANCE(36);
      END_STATE();
    case 151:
      if (lookahead == '8') ADVANCE(1261);
      END_STATE();
    case 152:
      if (lookahead == '8') ADVANCE(1219);
      END_STATE();
    case 153:
      if (lookahead == '8') ADVANCE(1221);
      END_STATE();
    case 154:
      if (lookahead == '8') ADVANCE(26);
      END_STATE();
    case 155:
      if (lookahead == '8') ADVANCE(164);
      END_STATE();
    case 156:
      if (lookahead == '8') ADVANCE(167);
      END_STATE();
    case 157:
      if (lookahead == '8') ADVANCE(39);
      END_STATE();
    case 158:
      if (lookahead == '8') ADVANCE(1052);
      END_STATE();
    case 159:
      if (lookahead == '8') ADVANCE(1072);
      END_STATE();
    case 160:
      if (lookahead == ':') ADVANCE(267);
      END_STATE();
    case 161:
      if (lookahead == ';') ADVANCE(1131);
      if (lookahead == '@') ADVANCE(1123);
      END_STATE();
    case 162:
      if (lookahead == ';') ADVANCE(1137);
      END_STATE();
    case 163:
      if (lookahead == '_') ADVANCE(436);
      END_STATE();
    case 164:
      if (lookahead == '_') ADVANCE(1096);
      END_STATE();
    case 165:
      if (lookahead == '_') ADVANCE(501);
      END_STATE();
    case 166:
      if (lookahead == '_') ADVANCE(536);
      END_STATE();
    case 167:
      if (lookahead == '_') ADVANCE(1097);
      END_STATE();
    case 168:
      if (lookahead == '_') ADVANCE(1098);
      END_STATE();
    case 169:
      if (lookahead == '_') ADVANCE(925);
      END_STATE();
    case 170:
      if (lookahead == '_') ADVANCE(925);
      if (lookahead == 'x') ADVANCE(155);
      END_STATE();
    case 171:
      if (lookahead == '_') ADVANCE(925);
      if (lookahead == 'x') ADVANCE(81);
      END_STATE();
    case 172:
      if (lookahead == '_') ADVANCE(925);
      if (lookahead == 'x') ADVANCE(126);
      END_STATE();
    case 173:
      if (lookahead == '_') ADVANCE(921);
      END_STATE();
    case 174:
      if (lookahead == '_') ADVANCE(750);
      END_STATE();
    case 175:
      if (lookahead == '_') ADVANCE(505);
      END_STATE();
    case 176:
      if (lookahead == '_') ADVANCE(509);
      END_STATE();
    case 177:
      if (lookahead == '_') ADVANCE(1012);
      END_STATE();
    case 178:
      if (lookahead == '_') ADVANCE(500);
      END_STATE();
    case 179:
      if (lookahead == '_') ADVANCE(553);
      END_STATE();
    case 180:
      if (lookahead == '_') ADVANCE(546);
      END_STATE();
    case 181:
      if (lookahead == '_') ADVANCE(580);
      END_STATE();
    case 182:
      if (lookahead == '_') ADVANCE(744);
      END_STATE();
    case 183:
      if (lookahead == '_') ADVANCE(554);
      END_STATE();
    case 184:
      if (lookahead == '_') ADVANCE(981);
      END_STATE();
    case 185:
      if (lookahead == '_') ADVANCE(723);
      END_STATE();
    case 186:
      if (lookahead == '_') ADVANCE(654);
      END_STATE();
    case 187:
      if (lookahead == '_') ADVANCE(513);
      END_STATE();
    case 188:
      if (lookahead == '_') ADVANCE(588);
      END_STATE();
    case 189:
      if (lookahead == '_') ADVANCE(891);
      END_STATE();
    case 190:
      if (lookahead == '_') ADVANCE(939);
      END_STATE();
    case 191:
      if (lookahead == '_') ADVANCE(584);
      END_STATE();
    case 192:
      if (lookahead == '_') ADVANCE(747);
      END_STATE();
    case 193:
      if (lookahead == '_') ADVANCE(656);
      END_STATE();
    case 194:
      if (lookahead == '_') ADVANCE(541);
      END_STATE();
    case 195:
      if (lookahead == '_') ADVANCE(753);
      END_STATE();
    case 196:
      if (lookahead == 'a') ADVANCE(622);
      END_STATE();
    case 197:
      if (lookahead == 'a') ADVANCE(622);
      if (lookahead == 'o') ADVANCE(707);
      END_STATE();
    case 198:
      if (lookahead == 'a') ADVANCE(966);
      if (lookahead == 'e') ADVANCE(323);
      END_STATE();
    case 199:
      if (lookahead == 'a') ADVANCE(860);
      END_STATE();
    case 200:
      if (lookahead == 'a') ADVANCE(296);
      if (lookahead == 'h') ADVANCE(431);
      if (lookahead == 'y') ADVANCE(835);
      END_STATE();
    case 201:
      if (lookahead == 'a') ADVANCE(1239);
      END_STATE();
    case 202:
      if (lookahead == 'a') ADVANCE(293);
      if (lookahead == 'b') ADVANCE(569);
      if (lookahead == 'l') ADVANCE(774);
      if (lookahead == 'n') ADVANCE(420);
      if (lookahead == 's') ADVANCE(842);
      END_STATE();
    case 203:
      if (lookahead == 'a') ADVANCE(293);
      if (lookahead == 'b') ADVANCE(569);
      if (lookahead == 'l') ADVANCE(777);
      if (lookahead == 'n') ADVANCE(420);
      if (lookahead == 's') ADVANCE(842);
      END_STATE();
    case 204:
      if (lookahead == 'a') ADVANCE(293);
      if (lookahead == 'b') ADVANCE(569);
      if (lookahead == 'n') ADVANCE(420);
      if (lookahead == 's') ADVANCE(842);
      END_STATE();
    case 205:
      if (lookahead == 'a') ADVANCE(294);
      if (lookahead == 'c') ADVANCE(467);
      if (lookahead == 'd') ADVANCE(464);
      if (lookahead == 'e') ADVANCE(850);
      if (lookahead == 'f') ADVANCE(662);
      if (lookahead == 'g') ADVANCE(1093);
      if (lookahead == 'l') ADVANCE(787);
      if (lookahead == 'm') ADVANCE(227);
      if (lookahead == 'n') ADVANCE(407);
      if (lookahead == 'r') ADVANCE(470);
      if (lookahead == 's') ADVANCE(853);
      if (lookahead == 't') ADVANCE(913);
      END_STATE();
    case 206:
      if (lookahead == 'a') ADVANCE(294);
      if (lookahead == 'c') ADVANCE(467);
      if (lookahead == 'd') ADVANCE(547);
      if (lookahead == 'e') ADVANCE(850);
      if (lookahead == 'f') ADVANCE(662);
      if (lookahead == 'g') ADVANCE(1093);
      if (lookahead == 'l') ADVANCE(787);
      if (lookahead == 'm') ADVANCE(227);
      if (lookahead == 'n') ADVANCE(407);
      if (lookahead == 'p') ADVANCE(879);
      if (lookahead == 'r') ADVANCE(488);
      if (lookahead == 's') ADVANCE(853);
      if (lookahead == 't') ADVANCE(913);
      END_STATE();
    case 207:
      if (lookahead == 'a') ADVANCE(379);
      if (lookahead == 'c') ADVANCE(817);
      if (lookahead == 'd') ADVANCE(550);
      if (lookahead == 'e') ADVANCE(851);
      if (lookahead == 'g') ADVANCE(1094);
      if (lookahead == 'l') ADVANCE(789);
      if (lookahead == 'm') ADVANCE(1021);
      if (lookahead == 'n') ADVANCE(406);
      if (lookahead == 'o') ADVANCE(857);
      if (lookahead == 'p') ADVANCE(776);
      if (lookahead == 'r') ADVANCE(408);
      if (lookahead == 's') ADVANCE(529);
      if (lookahead == 't') ADVANCE(915);
      if (lookahead == 'w') ADVANCE(883);
      if (lookahead == 'x') ADVANCE(785);
      END_STATE();
    case 208:
      if (lookahead == 'a') ADVANCE(292);
      if (lookahead == 'b') ADVANCE(569);
      if (lookahead == 'e') ADVANCE(849);
      if (lookahead == 'g') ADVANCE(1094);
      if (lookahead == 'l') ADVANCE(775);
      if (lookahead == 'm') ADVANCE(231);
      if (lookahead == 'n') ADVANCE(242);
      if (lookahead == 's') ADVANCE(527);
      if (lookahead == 'w') ADVANCE(568);
      END_STATE();
    case 209:
      if (lookahead == 'a') ADVANCE(292);
      if (lookahead == 'b') ADVANCE(569);
      if (lookahead == 'e') ADVANCE(849);
      if (lookahead == 'g') ADVANCE(1094);
      if (lookahead == 'l') ADVANCE(778);
      if (lookahead == 'm') ADVANCE(231);
      if (lookahead == 'n') ADVANCE(410);
      if (lookahead == 's') ADVANCE(527);
      if (lookahead == 't') ADVANCE(916);
      if (lookahead == 'w') ADVANCE(597);
      END_STATE();
    case 210:
      if (lookahead == 'a') ADVANCE(292);
      if (lookahead == 'b') ADVANCE(569);
      if (lookahead == 'e') ADVANCE(849);
      if (lookahead == 'm') ADVANCE(231);
      if (lookahead == 'n') ADVANCE(284);
      if (lookahead == 's') ADVANCE(528);
      if (lookahead == 'g' ||
          lookahead == 'l') ADVANCE(1094);
      END_STATE();
    case 211:
      if (lookahead == 'a') ADVANCE(378);
      if (lookahead == 'c') ADVANCE(674);
      if (lookahead == 'o') ADVANCE(857);
      if (lookahead == 's') ADVANCE(1016);
      if (lookahead == 'x') ADVANCE(326);
      END_STATE();
    case 212:
      if (lookahead == 'a') ADVANCE(1238);
      END_STATE();
    case 213:
      if (lookahead == 'a') ADVANCE(32);
      END_STATE();
    case 214:
      if (lookahead == 'a') ADVANCE(871);
      END_STATE();
    case 215:
      if (lookahead == 'a') ADVANCE(690);
      if (lookahead == 'u') ADVANCE(624);
      END_STATE();
    case 216:
      if (lookahead == 'a') ADVANCE(667);
      END_STATE();
    case 217:
      if (lookahead == 'a') ADVANCE(867);
      END_STATE();
    case 218:
      if (lookahead == 'a') ADVANCE(290);
      if (lookahead == 'c') ADVANCE(437);
      if (lookahead == 'f') ADVANCE(632);
      if (lookahead == 'n') ADVANCE(399);
      if (lookahead == 's') ADVANCE(842);
      if (lookahead == 't') ADVANCE(906);
      END_STATE();
    case 219:
      if (lookahead == 'a') ADVANCE(923);
      END_STATE();
    case 220:
      if (lookahead == 'a') ADVANCE(854);
      END_STATE();
    case 221:
      if (lookahead == 'a') ADVANCE(336);
      END_STATE();
    case 222:
      if (lookahead == 'a') ADVANCE(938);
      if (lookahead == 'e') ADVANCE(1071);
      if (lookahead == 'f') ADVANCE(1030);
      if (lookahead == 'i') ADVANCE(941);
      if (lookahead == 'n') ADVANCE(1025);
      END_STATE();
    case 223:
      if (lookahead == 'a') ADVANCE(610);
      END_STATE();
    case 224:
      if (lookahead == 'a') ADVANCE(357);
      END_STATE();
    case 225:
      if (lookahead == 'a') ADVANCE(373);
      END_STATE();
    case 226:
      if (lookahead == 'a') ADVANCE(1048);
      if (lookahead == 'i') ADVANCE(703);
      END_STATE();
    case 227:
      if (lookahead == 'a') ADVANCE(1048);
      if (lookahead == 'i') ADVANCE(703);
      if (lookahead == 'u') ADVANCE(616);
      END_STATE();
    case 228:
      if (lookahead == 'a') ADVANCE(1034);
      END_STATE();
    case 229:
      if (lookahead == 'a') ADVANCE(611);
      END_STATE();
    case 230:
      if (lookahead == 'a') ADVANCE(370);
      END_STATE();
    case 231:
      if (lookahead == 'a') ADVANCE(1057);
      if (lookahead == 'i') ADVANCE(714);
      if (lookahead == 'u') ADVANCE(616);
      END_STATE();
    case 232:
      if (lookahead == 'a') ADVANCE(826);
      END_STATE();
    case 233:
      if (lookahead == 'a') ADVANCE(358);
      END_STATE();
    case 234:
      if (lookahead == 'a') ADVANCE(374);
      END_STATE();
    case 235:
      if (lookahead == 'a') ADVANCE(716);
      END_STATE();
    case 236:
      if (lookahead == 'a') ADVANCE(836);
      END_STATE();
    case 237:
      if (lookahead == 'a') ADVANCE(625);
      END_STATE();
    case 238:
      if (lookahead == 'a') ADVANCE(342);
      END_STATE();
    case 239:
      if (lookahead == 'a') ADVANCE(362);
      END_STATE();
    case 240:
      if (lookahead == 'a') ADVANCE(363);
      END_STATE();
    case 241:
      if (lookahead == 'a') ADVANCE(364);
      END_STATE();
    case 242:
      if (lookahead == 'a') ADVANCE(901);
      if (lookahead == 'e') ADVANCE(1188);
      END_STATE();
    case 243:
      if (lookahead == 'a') ADVANCE(377);
      if (lookahead == 'l') ADVANCE(780);
      if (lookahead == 'm') ADVANCE(1021);
      if (lookahead == 'n') ADVANCE(420);
      if (lookahead == 's') ADVANCE(526);
      END_STATE();
    case 244:
      if (lookahead == 'a') ADVANCE(732);
      END_STATE();
    case 245:
      if (lookahead == 'a') ADVANCE(630);
      END_STATE();
    case 246:
      if (lookahead == 'a') ADVANCE(615);
      END_STATE();
    case 247:
      if (lookahead == 'a') ADVANCE(652);
      END_STATE();
    case 248:
      if (lookahead == 'a') ADVANCE(626);
      END_STATE();
    case 249:
      if (lookahead == 'a') ADVANCE(699);
      END_STATE();
    case 250:
      if (lookahead == 'a') ADVANCE(368);
      END_STATE();
    case 251:
      if (lookahead == 'a') ADVANCE(700);
      END_STATE();
    case 252:
      if (lookahead == 'a') ADVANCE(369);
      END_STATE();
    case 253:
      if (lookahead == 'a') ADVANCE(702);
      if (lookahead == 'o') ADVANCE(827);
      END_STATE();
    case 254:
      if (lookahead == 'a') ADVANCE(629);
      END_STATE();
    case 255:
      if (lookahead == 'a') ADVANCE(618);
      END_STATE();
    case 256:
      if (lookahead == 'a') ADVANCE(619);
      END_STATE();
    case 257:
      if (lookahead == 'a') ADVANCE(957);
      END_STATE();
    case 258:
      if (lookahead == 'a') ADVANCE(725);
      if (lookahead == 'b') ADVANCE(576);
      if (lookahead == 'c') ADVANCE(821);
      if (lookahead == 'l') ADVANCE(772);
      if (lookahead == 'n') ADVANCE(795);
      if (lookahead == 'o') ADVANCE(857);
      if (lookahead == 's') ADVANCE(975);
      if (lookahead == 'x') ADVANCE(785);
      END_STATE();
    case 259:
      if (lookahead == 'a') ADVANCE(1001);
      if (lookahead == 'c') ADVANCE(781);
      if (lookahead == 'f') ADVANCE(587);
      if (lookahead == 'g') ADVANCE(874);
      if (lookahead == 'i') ADVANCE(743);
      if (lookahead == 's') ADVANCE(545);
      END_STATE();
    case 260:
      if (lookahead == 'a') ADVANCE(971);
      END_STATE();
    case 261:
      if (lookahead == 'a') ADVANCE(984);
      END_STATE();
    case 262:
      if (lookahead == 'a') ADVANCE(986);
      if (lookahead == 'e') ADVANCE(323);
      if (lookahead == 'r') ADVANCE(773);
      END_STATE();
    case 263:
      if (lookahead == 'a') ADVANCE(986);
      if (lookahead == 'r') ADVANCE(773);
      END_STATE();
    case 264:
      if (lookahead == 'a') ADVANCE(291);
      if (lookahead == 'c') ADVANCE(438);
      if (lookahead == 'd') ADVANCE(547);
      if (lookahead == 'e') ADVANCE(849);
      if (lookahead == 'f') ADVANCE(632);
      if (lookahead == 'g') ADVANCE(1093);
      if (lookahead == 'l') ADVANCE(1093);
      if (lookahead == 'm') ADVANCE(227);
      if (lookahead == 'n') ADVANCE(421);
      if (lookahead == 'p') ADVANCE(668);
      if (lookahead == 's') ADVANCE(843);
      if (lookahead == 't') ADVANCE(906);
      END_STATE();
    case 265:
      if (lookahead == 'a') ADVANCE(291);
      if (lookahead == 'c') ADVANCE(437);
      if (lookahead == 'd') ADVANCE(547);
      if (lookahead == 'e') ADVANCE(849);
      if (lookahead == 'f') ADVANCE(632);
      if (lookahead == 'g') ADVANCE(1093);
      if (lookahead == 'l') ADVANCE(1093);
      if (lookahead == 'm') ADVANCE(227);
      if (lookahead == 'n') ADVANCE(421);
      if (lookahead == 'p') ADVANCE(668);
      if (lookahead == 's') ADVANCE(843);
      if (lookahead == 't') ADVANCE(906);
      END_STATE();
    case 266:
      if (lookahead == 'a') ADVANCE(382);
      if (lookahead == 'c') ADVANCE(679);
      if (lookahead == 'o') ADVANCE(878);
      if (lookahead == 's') ADVANCE(1017);
      if (lookahead == 'x') ADVANCE(330);
      END_STATE();
    case 267:
      if (lookahead == 'a') ADVANCE(861);
      if (lookahead == 'c') ADVANCE(235);
      END_STATE();
    case 268:
      if (lookahead == 'a') ADVANCE(877);
      END_STATE();
    case 269:
      if (lookahead == 'a') ADVANCE(337);
      END_STATE();
    case 270:
      if (lookahead == 'a') ADVANCE(734);
      END_STATE();
    case 271:
      if (lookahead == 'a') ADVANCE(995);
      END_STATE();
    case 272:
      if (lookahead == 'a') ADVANCE(988);
      END_STATE();
    case 273:
      if (lookahead == 'a') ADVANCE(885);
      if (lookahead == 'g') ADVANCE(1201);
      END_STATE();
    case 274:
      if (lookahead == 'a') ADVANCE(642);
      END_STATE();
    case 275:
      if (lookahead == 'a') ADVANCE(577);
      END_STATE();
    case 276:
      if (lookahead == 'a') ADVANCE(644);
      END_STATE();
    case 277:
      if (lookahead == 'a') ADVANCE(299);
      END_STATE();
    case 278:
      if (lookahead == 'a') ADVANCE(300);
      END_STATE();
    case 279:
      if (lookahead == 'a') ADVANCE(301);
      END_STATE();
    case 280:
      if (lookahead == 'a') ADVANCE(303);
      END_STATE();
    case 281:
      if (lookahead == 'a') ADVANCE(304);
      if (lookahead == 'y') ADVANCE(835);
      END_STATE();
    case 282:
      if (lookahead == 'a') ADVANCE(380);
      if (lookahead == 'c') ADVANCE(817);
      if (lookahead == 'd') ADVANCE(550);
      if (lookahead == 'e') ADVANCE(852);
      if (lookahead == 'g') ADVANCE(1094);
      if (lookahead == 'l') ADVANCE(792);
      if (lookahead == 'm') ADVANCE(1021);
      if (lookahead == 'n') ADVANCE(406);
      if (lookahead == 'o') ADVANCE(857);
      if (lookahead == 'p') ADVANCE(776);
      if (lookahead == 'r') ADVANCE(489);
      if (lookahead == 's') ADVANCE(530);
      if (lookahead == 't') ADVANCE(915);
      if (lookahead == 'x') ADVANCE(785);
      END_STATE();
    case 283:
      if (lookahead == 'a') ADVANCE(757);
      END_STATE();
    case 284:
      if (lookahead == 'a') ADVANCE(911);
      if (lookahead == 'e') ADVANCE(1188);
      END_STATE();
    case 285:
      if (lookahead == 'a') ADVANCE(759);
      END_STATE();
    case 286:
      if (lookahead == 'a') ADVANCE(917);
      if (lookahead == 'c') ADVANCE(283);
      END_STATE();
    case 287:
      if (lookahead == 'a') ADVANCE(761);
      if (lookahead == 'o') ADVANCE(827);
      END_STATE();
    case 288:
      if (lookahead == 'b') ADVANCE(1179);
      END_STATE();
    case 289:
      if (lookahead == 'b') ADVANCE(1184);
      END_STATE();
    case 290:
      if (lookahead == 'b') ADVANCE(920);
      END_STATE();
    case 291:
      if (lookahead == 'b') ADVANCE(920);
      if (lookahead == 'd') ADVANCE(361);
      END_STATE();
    case 292:
      if (lookahead == 'b') ADVANCE(920);
      if (lookahead == 'd') ADVANCE(371);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'n') ADVANCE(1082);
      if (lookahead == 'v') ADVANCE(520);
      END_STATE();
    case 293:
      if (lookahead == 'b') ADVANCE(920);
      if (lookahead == 'l') ADVANCE(623);
      if (lookahead == 'n') ADVANCE(1082);
      END_STATE();
    case 294:
      if (lookahead == 'b') ADVANCE(921);
      if (lookahead == 'd') ADVANCE(361);
      END_STATE();
    case 295:
      if (lookahead == 'b') ADVANCE(177);
      END_STATE();
    case 296:
      if (lookahead == 'b') ADVANCE(631);
      END_STATE();
    case 297:
      if (lookahead == 'b') ADVANCE(229);
      END_STATE();
    case 298:
      if (lookahead == 'b') ADVANCE(561);
      END_STATE();
    case 299:
      if (lookahead == 'b') ADVANCE(641);
      END_STATE();
    case 300:
      if (lookahead == 'b') ADVANCE(645);
      END_STATE();
    case 301:
      if (lookahead == 'b') ADVANCE(646);
      END_STATE();
    case 302:
      if (lookahead == 'b') ADVANCE(248);
      END_STATE();
    case 303:
      if (lookahead == 'b') ADVANCE(647);
      END_STATE();
    case 304:
      if (lookahead == 'b') ADVANCE(648);
      END_STATE();
    case 305:
      if (lookahead == 'b') ADVANCE(256);
      END_STATE();
    case 306:
      if (lookahead == 'c') ADVANCE(598);
      END_STATE();
    case 307:
      if (lookahead == 'c') ADVANCE(1148);
      END_STATE();
    case 308:
      if (lookahead == 'c') ADVANCE(1191);
      END_STATE();
    case 309:
      if (lookahead == 'c') ADVANCE(1264);
      END_STATE();
    case 310:
      if (lookahead == 'c') ADVANCE(1299);
      END_STATE();
    case 311:
      if (lookahead == 'c') ADVANCE(1201);
      END_STATE();
    case 312:
      if (lookahead == 'c') ADVANCE(1292);
      END_STATE();
    case 313:
      if (lookahead == 'c') ADVANCE(1179);
      END_STATE();
    case 314:
      if (lookahead == 'c') ADVANCE(34);
      END_STATE();
    case 315:
      if (lookahead == 'c') ADVANCE(1149);
      END_STATE();
    case 316:
      if (lookahead == 'c') ADVANCE(1245);
      END_STATE();
    case 317:
      if (lookahead == 'c') ADVANCE(1147);
      END_STATE();
    case 318:
      if (lookahead == 'c') ADVANCE(1150);
      END_STATE();
    case 319:
      if (lookahead == 'c') ADVANCE(859);
      if (lookahead == 'e') ADVANCE(627);
      if (lookahead == 'h') ADVANCE(214);
      END_STATE();
    case 320:
      if (lookahead == 'c') ADVANCE(859);
      if (lookahead == 'e') ADVANCE(627);
      if (lookahead == 'h') ADVANCE(214);
      if (lookahead == 't') ADVANCE(217);
      END_STATE();
    case 321:
      if (lookahead == 'c') ADVANCE(859);
      if (lookahead == 't') ADVANCE(217);
      END_STATE();
    case 322:
      if (lookahead == 'c') ADVANCE(223);
      if (lookahead == 'o') ADVANCE(824);
      END_STATE();
    case 323:
      if (lookahead == 'c') ADVANCE(658);
      END_STATE();
    case 324:
      if (lookahead == 'c') ADVANCE(35);
      END_STATE();
    case 325:
      if (lookahead == 'c') ADVANCE(531);
      END_STATE();
    case 326:
      if (lookahead == 'c') ADVANCE(531);
      if (lookahead == 'o') ADVANCE(857);
      END_STATE();
    case 327:
      if (lookahead == 'c') ADVANCE(811);
      END_STATE();
    case 328:
      if (lookahead == 'c') ADVANCE(28);
      END_STATE();
    case 329:
      if (lookahead == 'c') ADVANCE(533);
      END_STATE();
    case 330:
      if (lookahead == 'c') ADVANCE(533);
      if (lookahead == 'o') ADVANCE(878);
      END_STATE();
    case 331:
      if (lookahead == 'c') ADVANCE(29);
      END_STATE();
    case 332:
      if (lookahead == 'c') ADVANCE(771);
      if (lookahead == 'f') ADVANCE(586);
      if (lookahead == 'g') ADVANCE(454);
      if (lookahead == 'i') ADVANCE(740);
      if (lookahead == 's') ADVANCE(453);
      END_STATE();
    case 333:
      if (lookahead == 'c') ADVANCE(165);
      END_STATE();
    case 334:
      if (lookahead == 'c') ADVANCE(33);
      END_STATE();
    case 335:
      if (lookahead == 'c') ADVANCE(955);
      END_STATE();
    case 336:
      if (lookahead == 'c') ADVANCE(486);
      END_STATE();
    case 337:
      if (lookahead == 'c') ADVANCE(968);
      END_STATE();
    case 338:
      if (lookahead == 'c') ADVANCE(962);
      END_STATE();
    case 339:
      if (lookahead == 'c') ADVANCE(736);
      END_STATE();
    case 340:
      if (lookahead == 'c') ADVANCE(963);
      END_STATE();
    case 341:
      if (lookahead == 'c') ADVANCE(406);
      END_STATE();
    case 342:
      if (lookahead == 'c') ADVANCE(542);
      END_STATE();
    case 343:
      if (lookahead == 'c') ADVANCE(37);
      END_STATE();
    case 344:
      if (lookahead == 'c') ADVANCE(190);
      END_STATE();
    case 345:
      if (lookahead == 'c') ADVANCE(246);
      END_STATE();
    case 346:
      if (lookahead == 'c') ADVANCE(247);
      END_STATE();
    case 347:
      if (lookahead == 'c') ADVANCE(254);
      if (lookahead == 'o') ADVANCE(824);
      END_STATE();
    case 348:
      if (lookahead == 'c') ADVANCE(255);
      END_STATE();
    case 349:
      if (lookahead == 'c') ADVANCE(192);
      END_STATE();
    case 350:
      if (lookahead == 'c') ADVANCE(276);
      END_STATE();
    case 351:
      if (lookahead == 'c') ADVANCE(816);
      END_STATE();
    case 352:
      if (lookahead == 'c') ADVANCE(821);
      END_STATE();
    case 353:
      if (lookahead == 'c') ADVANCE(821);
      if (lookahead == 'l') ADVANCE(772);
      if (lookahead == 's') ADVANCE(975);
      END_STATE();
    case 354:
      if (lookahead == 'd') ADVANCE(1127);
      END_STATE();
    case 355:
      if (lookahead == 'd') ADVANCE(1274);
      END_STATE();
    case 356:
      if (lookahead == 'd') ADVANCE(1205);
      END_STATE();
    case 357:
      if (lookahead == 'd') ADVANCE(1202);
      END_STATE();
    case 358:
      if (lookahead == 'd') ADVANCE(105);
      END_STATE();
    case 359:
      if (lookahead == 'd') ADVANCE(1285);
      END_STATE();
    case 360:
      if (lookahead == 'd') ADVANCE(1286);
      END_STATE();
    case 361:
      if (lookahead == 'd') ADVANCE(1179);
      END_STATE();
    case 362:
      if (lookahead == 'd') ADVANCE(1196);
      END_STATE();
    case 363:
      if (lookahead == 'd') ADVANCE(1198);
      END_STATE();
    case 364:
      if (lookahead == 'd') ADVANCE(1197);
      END_STATE();
    case 365:
      if (lookahead == 'd') ADVANCE(1189);
      END_STATE();
    case 366:
      if (lookahead == 'd') ADVANCE(48);
      END_STATE();
    case 367:
      if (lookahead == 'd') ADVANCE(47);
      END_STATE();
    case 368:
      if (lookahead == 'd') ADVANCE(1183);
      END_STATE();
    case 369:
      if (lookahead == 'd') ADVANCE(1182);
      END_STATE();
    case 370:
      if (lookahead == 'd') ADVANCE(52);
      END_STATE();
    case 371:
      if (lookahead == 'd') ADVANCE(1184);
      END_STATE();
    case 372:
      if (lookahead == 'd') ADVANCE(1026);
      END_STATE();
    case 373:
      if (lookahead == 'd') ADVANCE(158);
      END_STATE();
    case 374:
      if (lookahead == 'd') ADVANCE(169);
      END_STATE();
    case 375:
      if (lookahead == 'd') ADVANCE(585);
      END_STATE();
    case 376:
      if (lookahead == 'd') ADVANCE(864);
      END_STATE();
    case 377:
      if (lookahead == 'd') ADVANCE(361);
      END_STATE();
    case 378:
      if (lookahead == 'd') ADVANCE(361);
      if (lookahead == 'n') ADVANCE(361);
      END_STATE();
    case 379:
      if (lookahead == 'd') ADVANCE(361);
      if (lookahead == 'n') ADVANCE(361);
      if (lookahead == 't') ADVANCE(797);
      END_STATE();
    case 380:
      if (lookahead == 'd') ADVANCE(361);
      if (lookahead == 'n') ADVANCE(361);
      if (lookahead == 't') ADVANCE(815);
      END_STATE();
    case 381:
      if (lookahead == 'd') ADVANCE(177);
      END_STATE();
    case 382:
      if (lookahead == 'd') ADVANCE(381);
      if (lookahead == 'n') ADVANCE(381);
      END_STATE();
    case 383:
      if (lookahead == 'd') ADVANCE(460);
      END_STATE();
    case 384:
      if (lookahead == 'd') ADVANCE(487);
      END_STATE();
    case 385:
      if (lookahead == 'e') ADVANCE(323);
      END_STATE();
    case 386:
      if (lookahead == 'e') ADVANCE(678);
      if (lookahead == 'o') ADVANCE(372);
      if (lookahead == 'u') ADVANCE(944);
      END_STATE();
    case 387:
      if (lookahead == 'e') ADVANCE(494);
      END_STATE();
    case 388:
      if (lookahead == 'e') ADVANCE(495);
      END_STATE();
    case 389:
      if (lookahead == 'e') ADVANCE(1129);
      END_STATE();
    case 390:
      if (lookahead == 'e') ADVANCE(1206);
      END_STATE();
    case 391:
      if (lookahead == 'e') ADVANCE(1191);
      END_STATE();
    case 392:
      if (lookahead == 'e') ADVANCE(1301);
      END_STATE();
    case 393:
      if (lookahead == 'e') ADVANCE(1160);
      END_STATE();
    case 394:
      if (lookahead == 'e') ADVANCE(1283);
      END_STATE();
    case 395:
      if (lookahead == 'e') ADVANCE(1240);
      END_STATE();
    case 396:
      if (lookahead == 'e') ADVANCE(1243);
      END_STATE();
    case 397:
      if (lookahead == 'e') ADVANCE(1228);
      END_STATE();
    case 398:
      if (lookahead == 'e') ADVANCE(1176);
      END_STATE();
    case 399:
      if (lookahead == 'e') ADVANCE(273);
      END_STATE();
    case 400:
      if (lookahead == 'e') ADVANCE(1201);
      END_STATE();
    case 401:
      if (lookahead == 'e') ADVANCE(1195);
      END_STATE();
    case 402:
      if (lookahead == 'e') ADVANCE(1230);
      END_STATE();
    case 403:
      if (lookahead == 'e') ADVANCE(1235);
      END_STATE();
    case 404:
      if (lookahead == 'e') ADVANCE(1291);
      END_STATE();
    case 405:
      if (lookahead == 'e') ADVANCE(502);
      END_STATE();
    case 406:
      if (lookahead == 'e') ADVANCE(1179);
      END_STATE();
    case 407:
      if (lookahead == 'e') ADVANCE(1187);
      END_STATE();
    case 408:
      if (lookahead == 'e') ADVANCE(595);
      if (lookahead == 'o') ADVANCE(964);
      END_STATE();
    case 409:
      if (lookahead == 'e') ADVANCE(1196);
      END_STATE();
    case 410:
      if (lookahead == 'e') ADVANCE(1188);
      END_STATE();
    case 411:
      if (lookahead == 'e') ADVANCE(506);
      END_STATE();
    case 412:
      if (lookahead == 'e') ADVANCE(507);
      END_STATE();
    case 413:
      if (lookahead == 'e') ADVANCE(1159);
      END_STATE();
    case 414:
      if (lookahead == 'e') ADVANCE(627);
      END_STATE();
    case 415:
      if (lookahead == 'e') ADVANCE(627);
      if (lookahead == 'h') ADVANCE(214);
      END_STATE();
    case 416:
      if (lookahead == 'e') ADVANCE(942);
      if (lookahead == 'l') ADVANCE(764);
      END_STATE();
    case 417:
      if (lookahead == 'e') ADVANCE(942);
      if (lookahead == 'l') ADVANCE(812);
      END_STATE();
    case 418:
      if (lookahead == 'e') ADVANCE(942);
      if (lookahead == 'l') ADVANCE(818);
      END_STATE();
    case 419:
      if (lookahead == 'e') ADVANCE(665);
      if (lookahead == 's') ADVANCE(389);
      END_STATE();
    case 420:
      if (lookahead == 'e') ADVANCE(514);
      END_STATE();
    case 421:
      if (lookahead == 'e') ADVANCE(1186);
      END_STATE();
    case 422:
      if (lookahead == 'e') ADVANCE(1200);
      END_STATE();
    case 423:
      if (lookahead == 'e') ADVANCE(1199);
      END_STATE();
    case 424:
      if (lookahead == 'e') ADVANCE(1181);
      END_STATE();
    case 425:
      if (lookahead == 'e') ADVANCE(1180);
      END_STATE();
    case 426:
      if (lookahead == 'e') ADVANCE(943);
      if (lookahead == 'o') ADVANCE(322);
      END_STATE();
    case 427:
      if (lookahead == 'e') ADVANCE(943);
      if (lookahead == 'o') ADVANCE(347);
      END_STATE();
    case 428:
      if (lookahead == 'e') ADVANCE(666);
      END_STATE();
    case 429:
      if (lookahead == 'e') ADVANCE(355);
      END_STATE();
    case 430:
      if (lookahead == 'e') ADVANCE(335);
      END_STATE();
    case 431:
      if (lookahead == 'e') ADVANCE(691);
      END_STATE();
    case 432:
      if (lookahead == 'e') ADVANCE(1071);
      if (lookahead == 'f') ADVANCE(1024);
      if (lookahead == 'n') ADVANCE(1025);
      END_STATE();
    case 433:
      if (lookahead == 'e') ADVANCE(498);
      END_STATE();
    case 434:
      if (lookahead == 'e') ADVANCE(866);
      END_STATE();
    case 435:
      if (lookahead == 'e') ADVANCE(866);
      if (lookahead == 'r') ADVANCE(269);
      END_STATE();
    case 436:
      if (lookahead == 'e') ADVANCE(1051);
      if (lookahead == 'i') ADVANCE(695);
      if (lookahead == 'm') ADVANCE(237);
      if (lookahead == 'r') ADVANCE(455);
      if (lookahead == 't') ADVANCE(876);
      if (lookahead == 'u') ADVANCE(720);
      END_STATE();
    case 437:
      if (lookahead == 'e') ADVANCE(564);
      END_STATE();
    case 438:
      if (lookahead == 'e') ADVANCE(564);
      if (lookahead == 'o') ADVANCE(710);
      END_STATE();
    case 439:
      if (lookahead == 'e') ADVANCE(670);
      if (lookahead == 's') ADVANCE(389);
      END_STATE();
    case 440:
      if (lookahead == 'e') ADVANCE(497);
      END_STATE();
    case 441:
      if (lookahead == 'e') ADVANCE(499);
      END_STATE();
    case 442:
      if (lookahead == 'e') ADVANCE(855);
      END_STATE();
    case 443:
      if (lookahead == 'e') ADVANCE(175);
      END_STATE();
    case 444:
      if (lookahead == 'e') ADVANCE(19);
      END_STATE();
    case 445:
      if (lookahead == 'e') ADVANCE(176);
      END_STATE();
    case 446:
      if (lookahead == 'e') ADVANCE(951);
      END_STATE();
    case 447:
      if (lookahead == 'e') ADVANCE(360);
      END_STATE();
    case 448:
      if (lookahead == 'e') ADVANCE(669);
      END_STATE();
    case 449:
      if (lookahead == 'e') ADVANCE(875);
      END_STATE();
    case 450:
      if (lookahead == 'e') ADVANCE(238);
      END_STATE();
    case 451:
      if (lookahead == 'e') ADVANCE(945);
      END_STATE();
    case 452:
      if (lookahead == 'e') ADVANCE(391);
      END_STATE();
    case 453:
      if (lookahead == 'e') ADVANCE(959);
      if (lookahead == 'i') ADVANCE(1087);
      END_STATE();
    case 454:
      if (lookahead == 'e') ADVANCE(959);
      if (lookahead == 'r') ADVANCE(762);
      END_STATE();
    case 455:
      if (lookahead == 'e') ADVANCE(972);
      END_STATE();
    case 456:
      if (lookahead == 'e') ADVANCE(977);
      END_STATE();
    case 457:
      if (lookahead == 'e') ADVANCE(982);
      END_STATE();
    case 458:
      if (lookahead == 'e') ADVANCE(727);
      END_STATE();
    case 459:
      if (lookahead == 'e') ADVANCE(728);
      END_STATE();
    case 460:
      if (lookahead == 'e') ADVANCE(719);
      END_STATE();
    case 461:
      if (lookahead == 'e') ADVANCE(978);
      END_STATE();
    case 462:
      if (lookahead == 'e') ADVANCE(976);
      END_STATE();
    case 463:
      if (lookahead == 'e') ADVANCE(1002);
      END_STATE();
    case 464:
      if (lookahead == 'e') ADVANCE(687);
      if (lookahead == 'i') ADVANCE(1037);
      END_STATE();
    case 465:
      if (lookahead == 'e') ADVANCE(870);
      END_STATE();
    case 466:
      if (lookahead == 'e') ADVANCE(880);
      END_STATE();
    case 467:
      if (lookahead == 'e') ADVANCE(571);
      if (lookahead == 'o') ADVANCE(705);
      END_STATE();
    case 468:
      if (lookahead == 'e') ADVANCE(973);
      END_STATE();
    case 469:
      if (lookahead == 'e') ADVANCE(338);
      END_STATE();
    case 470:
      if (lookahead == 'e') ADVANCE(575);
      END_STATE();
    case 471:
      if (lookahead == 'e') ADVANCE(340);
      END_STATE();
    case 472:
      if (lookahead == 'e') ADVANCE(886);
      END_STATE();
    case 473:
      if (lookahead == 'e') ADVANCE(932);
      END_STATE();
    case 474:
      if (lookahead == 'e') ADVANCE(893);
      END_STATE();
    case 475:
      if (lookahead == 'e') ADVANCE(934);
      END_STATE();
    case 476:
      if (lookahead == 'e') ADVANCE(737);
      END_STATE();
    case 477:
      if (lookahead == 'e') ADVANCE(682);
      if (lookahead == 'o') ADVANCE(372);
      if (lookahead == 'u') ADVANCE(944);
      END_STATE();
    case 478:
      if (lookahead == 'e') ADVANCE(663);
      END_STATE();
    case 479:
      if (lookahead == 'e') ADVANCE(907);
      END_STATE();
    case 480:
      if (lookahead == 'e') ADVANCE(910);
      END_STATE();
    case 481:
      if (lookahead == 'e') ADVANCE(684);
      END_STATE();
    case 482:
      if (lookahead == 'e') ADVANCE(912);
      END_STATE();
    case 483:
      if (lookahead == 'e') ADVANCE(1003);
      END_STATE();
    case 484:
      if (lookahead == 'e') ADVANCE(685);
      if (lookahead == 'o') ADVANCE(372);
      END_STATE();
    case 485:
      if (lookahead == 'e') ADVANCE(914);
      END_STATE();
    case 486:
      if (lookahead == 'e') ADVANCE(193);
      END_STATE();
    case 487:
      if (lookahead == 'e') ADVANCE(758);
      END_STATE();
    case 488:
      if (lookahead == 'e') ADVANCE(593);
      END_STATE();
    case 489:
      if (lookahead == 'e') ADVANCE(596);
      if (lookahead == 'o') ADVANCE(964);
      END_STATE();
    case 490:
      if (lookahead == 'f') ADVANCE(508);
      END_STATE();
    case 491:
      if (lookahead == 'f') ADVANCE(508);
      if (lookahead == 'u') ADVANCE(969);
      END_STATE();
    case 492:
      if (lookahead == 'f') ADVANCE(1162);
      END_STATE();
    case 493:
      if (lookahead == 'f') ADVANCE(1162);
      if (lookahead == 'p') ADVANCE(1019);
      if (lookahead == 'v') ADVANCE(765);
      END_STATE();
    case 494:
      if (lookahead == 'f') ADVANCE(1267);
      if (lookahead == 'g') ADVANCE(581);
      if (lookahead == 'p') ADVANCE(628);
      if (lookahead == 's') ADVANCE(1018);
      END_STATE();
    case 495:
      if (lookahead == 'f') ADVANCE(1267);
      if (lookahead == 'g') ADVANCE(581);
      if (lookahead == 's') ADVANCE(1018);
      END_STATE();
    case 496:
      if (lookahead == 'f') ADVANCE(1191);
      END_STATE();
    case 497:
      if (lookahead == 'f') ADVANCE(1179);
      END_STATE();
    case 498:
      if (lookahead == 'f') ADVANCE(1266);
      END_STATE();
    case 499:
      if (lookahead == 'f') ADVANCE(1265);
      END_STATE();
    case 500:
      if (lookahead == 'f') ADVANCE(98);
      END_STATE();
    case 501:
      if (lookahead == 'f') ADVANCE(98);
      if (lookahead == 's') ADVANCE(261);
      END_STATE();
    case 502:
      if (lookahead == 'f') ADVANCE(1268);
      if (lookahead == 'g') ADVANCE(581);
      if (lookahead == 's') ADVANCE(1018);
      if (lookahead == 't') ADVANCE(1031);
      END_STATE();
    case 503:
      if (lookahead == 'f') ADVANCE(510);
      END_STATE();
    case 504:
      if (lookahead == 'f') ADVANCE(1079);
      END_STATE();
    case 505:
      if (lookahead == 'f') ADVANCE(141);
      END_STATE();
    case 506:
      if (lookahead == 'f') ADVANCE(25);
      if (lookahead == 't') ADVANCE(1031);
      END_STATE();
    case 507:
      if (lookahead == 'f') ADVANCE(17);
      if (lookahead == 'g') ADVANCE(581);
      END_STATE();
    case 508:
      if (lookahead == 'f') ADVANCE(927);
      END_STATE();
    case 509:
      if (lookahead == 'f') ADVANCE(99);
      END_STATE();
    case 510:
      if (lookahead == 'f') ADVANCE(640);
      END_STATE();
    case 511:
      if (lookahead == 'f') ADVANCE(476);
      END_STATE();
    case 512:
      if (lookahead == 'f') ADVANCE(783);
      END_STATE();
    case 513:
      if (lookahead == 'f') ADVANCE(106);
      END_STATE();
    case 514:
      if (lookahead == 'g') ADVANCE(1201);
      END_STATE();
    case 515:
      if (lookahead == 'g') ADVANCE(1179);
      END_STATE();
    case 516:
      if (lookahead == 'g') ADVANCE(538);
      END_STATE();
    case 517:
      if (lookahead == 'g') ADVANCE(692);
      END_STATE();
    case 518:
      if (lookahead == 'g') ADVANCE(874);
      if (lookahead == 'i') ADVANCE(743);
      if (lookahead == 's') ADVANCE(545);
      END_STATE();
    case 519:
      if (lookahead == 'g') ADVANCE(177);
      END_STATE();
    case 520:
      if (lookahead == 'g') ADVANCE(863);
      END_STATE();
    case 521:
      if (lookahead == 'g') ADVANCE(703);
      END_STATE();
    case 522:
      if (lookahead == 'g') ADVANCE(451);
      if (lookahead == 's') ADVANCE(451);
      END_STATE();
    case 523:
      if (lookahead == 'g') ADVANCE(451);
      if (lookahead == 's') ADVANCE(451);
      if (lookahead == 't') ADVANCE(452);
      END_STATE();
    case 524:
      if (lookahead == 'g') ADVANCE(537);
      END_STATE();
    case 525:
      if (lookahead == 'h') ADVANCE(1013);
      END_STATE();
    case 526:
      if (lookahead == 'h') ADVANCE(617);
      if (lookahead == 'p') ADVANCE(637);
      if (lookahead == 'u') ADVANCE(288);
      END_STATE();
    case 527:
      if (lookahead == 'h') ADVANCE(617);
      if (lookahead == 'p') ADVANCE(637);
      if (lookahead == 'u') ADVANCE(289);
      END_STATE();
    case 528:
      if (lookahead == 'h') ADVANCE(617);
      if (lookahead == 'p') ADVANCE(637);
      if (lookahead == 'u') ADVANCE(289);
      if (lookahead == 'w') ADVANCE(549);
      END_STATE();
    case 529:
      if (lookahead == 'h') ADVANCE(617);
      if (lookahead == 't') ADVANCE(807);
      if (lookahead == 'u') ADVANCE(288);
      END_STATE();
    case 530:
      if (lookahead == 'h') ADVANCE(617);
      if (lookahead == 't') ADVANCE(808);
      if (lookahead == 'u') ADVANCE(288);
      END_STATE();
    case 531:
      if (lookahead == 'h') ADVANCE(515);
      END_STATE();
    case 532:
      if (lookahead == 'h') ADVANCE(681);
      END_STATE();
    case 533:
      if (lookahead == 'h') ADVANCE(519);
      END_STATE();
    case 534:
      if (lookahead == 'h') ADVANCE(228);
      END_STATE();
    case 535:
      if (lookahead == 'h') ADVANCE(214);
      END_STATE();
    case 536:
      if (lookahead == 'h') ADVANCE(551);
      if (lookahead == 'l') ADVANCE(819);
      END_STATE();
    case 537:
      if (lookahead == 'h') ADVANCE(181);
      END_STATE();
    case 538:
      if (lookahead == 'h') ADVANCE(183);
      END_STATE();
    case 539:
      if (lookahead == 'h') ADVANCE(683);
      END_STATE();
    case 540:
      if (lookahead == 'h') ADVANCE(686);
      END_STATE();
    case 541:
      if (lookahead == 'h') ADVANCE(591);
      if (lookahead == 'l') ADVANCE(813);
      END_STATE();
    case 542:
      if (lookahead == 'h') ADVANCE(279);
      END_STATE();
    case 543:
      if (lookahead == 'i') ADVANCE(741);
      if (lookahead == 'l') ADVANCE(763);
      if (lookahead == 'r') ADVANCE(1192);
      END_STATE();
    case 544:
      if (lookahead == 'i') ADVANCE(517);
      END_STATE();
    case 545:
      if (lookahead == 'i') ADVANCE(1087);
      END_STATE();
    case 546:
      if (lookahead == 'i') ADVANCE(98);
      END_STATE();
    case 547:
      if (lookahead == 'i') ADVANCE(1037);
      END_STATE();
    case 548:
      if (lookahead == 'i') ADVANCE(496);
      if (lookahead == 'o') ADVANCE(693);
      if (lookahead == 't') ADVANCE(277);
      END_STATE();
    case 549:
      if (lookahead == 'i') ADVANCE(1086);
      END_STATE();
    case 550:
      if (lookahead == 'i') ADVANCE(1038);
      END_STATE();
    case 551:
      if (lookahead == 'i') ADVANCE(516);
      END_STATE();
    case 552:
      if (lookahead == 'i') ADVANCE(839);
      END_STATE();
    case 553:
      if (lookahead == 'i') ADVANCE(141);
      END_STATE();
    case 554:
      if (lookahead == 'i') ADVANCE(159);
      END_STATE();
    case 555:
      if (lookahead == 'i') ADVANCE(345);
      END_STATE();
    case 556:
      if (lookahead == 'i') ADVANCE(312);
      END_STATE();
    case 557:
      if (lookahead == 'i') ADVANCE(711);
      END_STATE();
    case 558:
      if (lookahead == 'i') ADVANCE(711);
      if (lookahead == 'r') ADVANCE(440);
      END_STATE();
    case 559:
      if (lookahead == 'i') ADVANCE(349);
      END_STATE();
    case 560:
      if (lookahead == 'i') ADVANCE(359);
      END_STATE();
    case 561:
      if (lookahead == 'i') ADVANCE(712);
      END_STATE();
    case 562:
      if (lookahead == 'i') ADVANCE(324);
      END_STATE();
    case 563:
      if (lookahead == 'i') ADVANCE(504);
      END_STATE();
    case 564:
      if (lookahead == 'i') ADVANCE(613);
      END_STATE();
    case 565:
      if (lookahead == 'i') ADVANCE(709);
      END_STATE();
    case 566:
      if (lookahead == 'i') ADVANCE(967);
      END_STATE();
    case 567:
      if (lookahead == 'i') ADVANCE(328);
      END_STATE();
    case 568:
      if (lookahead == 'i') ADVANCE(383);
      END_STATE();
    case 569:
      if (lookahead == 'i') ADVANCE(970);
      END_STATE();
    case 570:
      if (lookahead == 'i') ADVANCE(331);
      END_STATE();
    case 571:
      if (lookahead == 'i') ADVANCE(616);
      END_STATE();
    case 572:
      if (lookahead == 'i') ADVANCE(945);
      END_STATE();
    case 573:
      if (lookahead == 'i') ADVANCE(960);
      END_STATE();
    case 574:
      if (lookahead == 'i') ADVANCE(316);
      END_STATE();
    case 575:
      if (lookahead == 'i') ADVANCE(746);
      END_STATE();
    case 576:
      if (lookahead == 'i') ADVANCE(997);
      END_STATE();
    case 577:
      if (lookahead == 'i') ADVANCE(992);
      END_STATE();
    case 578:
      if (lookahead == 'i') ADVANCE(521);
      END_STATE();
    case 579:
      if (lookahead == 'i') ADVANCE(97);
      END_STATE();
    case 580:
      if (lookahead == 'i') ADVANCE(58);
      END_STATE();
    case 581:
      if (lookahead == 'i') ADVANCE(936);
      END_STATE();
    case 582:
      if (lookahead == 'i') ADVANCE(790);
      END_STATE();
    case 583:
      if (lookahead == 'i') ADVANCE(343);
      END_STATE();
    case 584:
      if (lookahead == 'i') ADVANCE(99);
      END_STATE();
    case 585:
      if (lookahead == 'i') ADVANCE(900);
      END_STATE();
    case 586:
      if (lookahead == 'i') ADVANCE(639);
      END_STATE();
    case 587:
      if (lookahead == 'i') ADVANCE(643);
      END_STATE();
    case 588:
      if (lookahead == 'i') ADVANCE(106);
      END_STATE();
    case 589:
      if (lookahead == 'i') ADVANCE(346);
      END_STATE();
    case 590:
      if (lookahead == 'i') ADVANCE(348);
      END_STATE();
    case 591:
      if (lookahead == 'i') ADVANCE(524);
      END_STATE();
    case 592:
      if (lookahead == 'i') ADVANCE(1009);
      END_STATE();
    case 593:
      if (lookahead == 'i') ADVANCE(752);
      END_STATE();
    case 594:
      if (lookahead == 'i') ADVANCE(1010);
      END_STATE();
    case 595:
      if (lookahead == 'i') ADVANCE(755);
      if (lookahead == 'm') ADVANCE(167);
      END_STATE();
    case 596:
      if (lookahead == 'i') ADVANCE(756);
      if (lookahead == 'm') ADVANCE(167);
      END_STATE();
    case 597:
      if (lookahead == 'i') ADVANCE(384);
      END_STATE();
    case 598:
      if (lookahead == 'k') ADVANCE(1126);
      END_STATE();
    case 599:
      if (lookahead == 'k') ADVANCE(1201);
      END_STATE();
    case 600:
      if (lookahead == 'k') ADVANCE(394);
      END_STATE();
    case 601:
      if (lookahead == 'k') ADVANCE(278);
      END_STATE();
    case 602:
      if (lookahead == 'l') ADVANCE(544);
      if (lookahead == 's') ADVANCE(924);
      END_STATE();
    case 603:
      if (lookahead == 'l') ADVANCE(544);
      if (lookahead == 's') ADVANCE(924);
      if (lookahead == 't') ADVANCE(769);
      END_STATE();
    case 604:
      if (lookahead == 'l') ADVANCE(544);
      if (lookahead == 't') ADVANCE(769);
      END_STATE();
    case 605:
      if (lookahead == 'l') ADVANCE(763);
      if (lookahead == 'r') ADVANCE(1192);
      END_STATE();
    case 606:
      if (lookahead == 'l') ADVANCE(419);
      if (lookahead == 'n') ADVANCE(354);
      if (lookahead == 'x') ADVANCE(830);
      END_STATE();
    case 607:
      if (lookahead == 'l') ADVANCE(419);
      if (lookahead == 'n') ADVANCE(354);
      if (lookahead == 'x') ADVANCE(831);
      END_STATE();
    case 608:
      if (lookahead == 'l') ADVANCE(1269);
      END_STATE();
    case 609:
      if (lookahead == 'l') ADVANCE(1191);
      END_STATE();
    case 610:
      if (lookahead == 'l') ADVANCE(1163);
      END_STATE();
    case 611:
      if (lookahead == 'l') ADVANCE(1155);
      END_STATE();
    case 612:
      if (lookahead == 'l') ADVANCE(1178);
      END_STATE();
    case 613:
      if (lookahead == 'l') ADVANCE(1201);
      END_STATE();
    case 614:
      if (lookahead == 'l') ADVANCE(1195);
      END_STATE();
    case 615:
      if (lookahead == 'l') ADVANCE(1293);
      END_STATE();
    case 616:
      if (lookahead == 'l') ADVANCE(1179);
      END_STATE();
    case 617:
      if (lookahead == 'l') ADVANCE(1179);
      if (lookahead == 'r') ADVANCE(167);
      END_STATE();
    case 618:
      if (lookahead == 'l') ADVANCE(1245);
      END_STATE();
    case 619:
      if (lookahead == 'l') ADVANCE(1154);
      END_STATE();
    case 620:
      if (lookahead == 'l') ADVANCE(1194);
      END_STATE();
    case 621:
      if (lookahead == 'l') ADVANCE(1193);
      END_STATE();
    case 622:
      if (lookahead == 'l') ADVANCE(620);
      END_STATE();
    case 623:
      if (lookahead == 'l') ADVANCE(184);
      END_STATE();
    case 624:
      if (lookahead == 'l') ADVANCE(608);
      END_STATE();
    case 625:
      if (lookahead == 'l') ADVANCE(512);
      END_STATE();
    case 626:
      if (lookahead == 'l') ADVANCE(20);
      END_STATE();
    case 627:
      if (lookahead == 'l') ADVANCE(430);
      END_STATE();
    case 628:
      if (lookahead == 'l') ADVANCE(221);
      END_STATE();
    case 629:
      if (lookahead == 'l') ADVANCE(18);
      END_STATE();
    case 630:
      if (lookahead == 'l') ADVANCE(560);
      END_STATE();
    case 631:
      if (lookahead == 'l') ADVANCE(393);
      END_STATE();
    case 632:
      if (lookahead == 'l') ADVANCE(799);
      END_STATE();
    case 633:
      if (lookahead == 'l') ADVANCE(612);
      END_STATE();
    case 634:
      if (lookahead == 'l') ADVANCE(189);
      END_STATE();
    case 635:
      if (lookahead == 'l') ADVANCE(395);
      END_STATE();
    case 636:
      if (lookahead == 'l') ADVANCE(953);
      END_STATE();
    case 637:
      if (lookahead == 'l') ADVANCE(257);
      END_STATE();
    case 638:
      if (lookahead == 'l') ADVANCE(609);
      END_STATE();
    case 639:
      if (lookahead == 'l') ADVANCE(614);
      END_STATE();
    case 640:
      if (lookahead == 'l') ADVANCE(397);
      END_STATE();
    case 641:
      if (lookahead == 'l') ADVANCE(398);
      END_STATE();
    case 642:
      if (lookahead == 'l') ADVANCE(621);
      END_STATE();
    case 643:
      if (lookahead == 'l') ADVANCE(616);
      END_STATE();
    case 644:
      if (lookahead == 'l') ADVANCE(634);
      END_STATE();
    case 645:
      if (lookahead == 'l') ADVANCE(404);
      END_STATE();
    case 646:
      if (lookahead == 'l') ADVANCE(406);
      END_STATE();
    case 647:
      if (lookahead == 'l') ADVANCE(444);
      END_STATE();
    case 648:
      if (lookahead == 'l') ADVANCE(413);
      END_STATE();
    case 649:
      if (lookahead == 'l') ADVANCE(439);
      if (lookahead == 'n') ADVANCE(354);
      END_STATE();
    case 650:
      if (lookahead == 'l') ADVANCE(439);
      if (lookahead == 'n') ADVANCE(354);
      if (lookahead == 'x') ADVANCE(1000);
      END_STATE();
    case 651:
      if (lookahead == 'l') ADVANCE(439);
      if (lookahead == 'n') ADVANCE(354);
      if (lookahead == 'x') ADVANCE(832);
      END_STATE();
    case 652:
      if (lookahead == 'l') ADVANCE(182);
      END_STATE();
    case 653:
      if (lookahead == 'l') ADVANCE(448);
      if (lookahead == 'x') ADVANCE(829);
      END_STATE();
    case 654:
      if (lookahead == 'l') ADVANCE(244);
      END_STATE();
    case 655:
      if (lookahead == 'l') ADVANCE(565);
      END_STATE();
    case 656:
      if (lookahead == 'l') ADVANCE(270);
      END_STATE();
    case 657:
      if (lookahead == 'l') ADVANCE(780);
      if (lookahead == 'n') ADVANCE(420);
      if (lookahead == 's') ADVANCE(842);
      END_STATE();
    case 658:
      if (lookahead == 'l') ADVANCE(268);
      END_STATE();
    case 659:
      if (lookahead == 'l') ADVANCE(782);
      END_STATE();
    case 660:
      if (lookahead == 'l') ADVANCE(793);
      if (lookahead == 'r') ADVANCE(671);
      if (lookahead == 's') ADVANCE(1007);
      END_STATE();
    case 661:
      if (lookahead == 'l') ADVANCE(794);
      if (lookahead == 'r') ADVANCE(672);
      if (lookahead == 's') ADVANCE(1008);
      END_STATE();
    case 662:
      if (lookahead == 'l') ADVANCE(804);
      END_STATE();
    case 663:
      if (lookahead == 'l') ADVANCE(471);
      END_STATE();
    case 664:
      if (lookahead == 'l') ADVANCE(812);
      END_STATE();
    case 665:
      if (lookahead == 'm') ADVANCE(1242);
      END_STATE();
    case 666:
      if (lookahead == 'm') ADVANCE(1146);
      END_STATE();
    case 667:
      if (lookahead == 'm') ADVANCE(1164);
      END_STATE();
    case 668:
      if (lookahead == 'm') ADVANCE(226);
      END_STATE();
    case 669:
      if (lookahead == 'm') ADVANCE(1241);
      END_STATE();
    case 670:
      if (lookahead == 'm') ADVANCE(32);
      END_STATE();
    case 671:
      if (lookahead == 'm') ADVANCE(1042);
      END_STATE();
    case 672:
      if (lookahead == 'm') ADVANCE(1043);
      END_STATE();
    case 673:
      if (lookahead == 'm') ADVANCE(562);
      END_STATE();
    case 674:
      if (lookahead == 'm') ADVANCE(837);
      END_STATE();
    case 675:
      if (lookahead == 'm') ADVANCE(219);
      END_STATE();
    case 676:
      if (lookahead == 'm') ADVANCE(567);
      END_STATE();
    case 677:
      if (lookahead == 'm') ADVANCE(447);
      END_STATE();
    case 678:
      if (lookahead == 'm') ADVANCE(770);
      END_STATE();
    case 679:
      if (lookahead == 'm') ADVANCE(841);
      END_STATE();
    case 680:
      if (lookahead == 'm') ADVANCE(570);
      END_STATE();
    case 681:
      if (lookahead == 'm') ADVANCE(456);
      END_STATE();
    case 682:
      if (lookahead == 'm') ADVANCE(784);
      END_STATE();
    case 683:
      if (lookahead == 'm') ADVANCE(457);
      END_STATE();
    case 684:
      if (lookahead == 'm') ADVANCE(788);
      END_STATE();
    case 685:
      if (lookahead == 'm') ADVANCE(791);
      END_STATE();
    case 686:
      if (lookahead == 'm') ADVANCE(463);
      END_STATE();
    case 687:
      if (lookahead == 'm') ADVANCE(803);
      END_STATE();
    case 688:
      if (lookahead == 'm') ADVANCE(583);
      END_STATE();
    case 689:
      if (lookahead == 'm') ADVANCE(805);
      END_STATE();
    case 690:
      if (lookahead == 'n') ADVANCE(1246);
      END_STATE();
    case 691:
      if (lookahead == 'n') ADVANCE(1174);
      END_STATE();
    case 692:
      if (lookahead == 'n') ADVANCE(1116);
      END_STATE();
    case 693:
      if (lookahead == 'n') ADVANCE(174);
      END_STATE();
    case 694:
      if (lookahead == 'n') ADVANCE(1264);
      END_STATE();
    case 695:
      if (lookahead == 'n') ADVANCE(1039);
      END_STATE();
    case 696:
      if (lookahead == 'n') ADVANCE(1177);
      END_STATE();
    case 697:
      if (lookahead == 'n') ADVANCE(1287);
      END_STATE();
    case 698:
      if (lookahead == 'n') ADVANCE(1284);
      END_STATE();
    case 699:
      if (lookahead == 'n') ADVANCE(1289);
      END_STATE();
    case 700:
      if (lookahead == 'n') ADVANCE(1288);
      END_STATE();
    case 701:
      if (lookahead == 'n') ADVANCE(889);
      END_STATE();
    case 702:
      if (lookahead == 'n') ADVANCE(160);
      END_STATE();
    case 703:
      if (lookahead == 'n') ADVANCE(1179);
      END_STATE();
    case 704:
      if (lookahead == 'n') ADVANCE(1185);
      END_STATE();
    case 705:
      if (lookahead == 'n') ADVANCE(929);
      if (lookahead == 'p') ADVANCE(1083);
      END_STATE();
    case 706:
      if (lookahead == 'n') ADVANCE(922);
      END_STATE();
    case 707:
      if (lookahead == 'n') ADVANCE(926);
      END_STATE();
    case 708:
      if (lookahead == 'n') ADVANCE(307);
      END_STATE();
    case 709:
      if (lookahead == 'n') ADVANCE(601);
      END_STATE();
    case 710:
      if (lookahead == 'n') ADVANCE(1040);
      END_STATE();
    case 711:
      if (lookahead == 'n') ADVANCE(375);
      END_STATE();
    case 712:
      if (lookahead == 'n') ADVANCE(356);
      END_STATE();
    case 713:
      if (lookahead == 'n') ADVANCE(310);
      END_STATE();
    case 714:
      if (lookahead == 'n') ADVANCE(167);
      END_STATE();
    case 715:
      if (lookahead == 'n') ADVANCE(311);
      END_STATE();
    case 716:
      if (lookahead == 'n') ADVANCE(786);
      END_STATE();
    case 717:
      if (lookahead == 'n') ADVANCE(555);
      END_STATE();
    case 718:
      if (lookahead == 'n') ADVANCE(314);
      END_STATE();
    case 719:
      if (lookahead == 'n') ADVANCE(166);
      END_STATE();
    case 720:
      if (lookahead == 'n') ADVANCE(655);
      END_STATE();
    case 721:
      if (lookahead == 'n') ADVANCE(308);
      END_STATE();
    case 722:
      if (lookahead == 'n') ADVANCE(313);
      END_STATE();
    case 723:
      if (lookahead == 'n') ADVANCE(823);
      END_STATE();
    case 724:
      if (lookahead == 'n') ADVANCE(333);
      END_STATE();
    case 725:
      if (lookahead == 'n') ADVANCE(365);
      END_STATE();
    case 726:
      if (lookahead == 'n') ADVANCE(344);
      END_STATE();
    case 727:
      if (lookahead == 'n') ADVANCE(366);
      END_STATE();
    case 728:
      if (lookahead == 'n') ADVANCE(367);
      END_STATE();
    case 729:
      if (lookahead == 'n') ADVANCE(315);
      END_STATE();
    case 730:
      if (lookahead == 'n') ADVANCE(334);
      END_STATE();
    case 731:
      if (lookahead == 'n') ADVANCE(317);
      END_STATE();
    case 732:
      if (lookahead == 'n') ADVANCE(402);
      END_STATE();
    case 733:
      if (lookahead == 'n') ADVANCE(318);
      END_STATE();
    case 734:
      if (lookahead == 'n') ADVANCE(403);
      END_STATE();
    case 735:
      if (lookahead == 'n') ADVANCE(309);
      END_STATE();
    case 736:
      if (lookahead == 'n') ADVANCE(963);
      END_STATE();
    case 737:
      if (lookahead == 'n') ADVANCE(341);
      END_STATE();
    case 738:
      if (lookahead == 'n') ADVANCE(928);
      END_STATE();
    case 739:
      if (lookahead == 'n') ADVANCE(796);
      if (lookahead == 'w') ADVANCE(275);
      END_STATE();
    case 740:
      if (lookahead == 'n') ADVANCE(573);
      END_STATE();
    case 741:
      if (lookahead == 'n') ADVANCE(220);
      END_STATE();
    case 742:
      if (lookahead == 'n') ADVANCE(930);
      END_STATE();
    case 743:
      if (lookahead == 'n') ADVANCE(572);
      END_STATE();
    case 744:
      if (lookahead == 'n') ADVANCE(249);
      END_STATE();
    case 745:
      if (lookahead == 'n') ADVANCE(931);
      END_STATE();
    case 746:
      if (lookahead == 'n') ADVANCE(990);
      END_STATE();
    case 747:
      if (lookahead == 'n') ADVANCE(251);
      END_STATE();
    case 748:
      if (lookahead == 'n') ADVANCE(892);
      END_STATE();
    case 749:
      if (lookahead == 'n') ADVANCE(888);
      END_STATE();
    case 750:
      if (lookahead == 'n') ADVANCE(1029);
      END_STATE();
    case 751:
      if (lookahead == 'n') ADVANCE(589);
      END_STATE();
    case 752:
      if (lookahead == 'n') ADVANCE(1004);
      END_STATE();
    case 753:
      if (lookahead == 'n') ADVANCE(1033);
      END_STATE();
    case 754:
      if (lookahead == 'n') ADVANCE(590);
      END_STATE();
    case 755:
      if (lookahead == 'n') ADVANCE(1005);
      END_STATE();
    case 756:
      if (lookahead == 'n') ADVANCE(1006);
      END_STATE();
    case 757:
      if (lookahead == 'n') ADVANCE(814);
      END_STATE();
    case 758:
      if (lookahead == 'n') ADVANCE(194);
      END_STATE();
    case 759:
      if (lookahead == 'n') ADVANCE(820);
      END_STATE();
    case 760:
      if (lookahead == 'n') ADVANCE(195);
      END_STATE();
    case 761:
      if (lookahead == 'n') ADVANCE(1247);
      END_STATE();
    case 762:
      if (lookahead == 'o') ADVANCE(1041);
      END_STATE();
    case 763:
      if (lookahead == 'o') ADVANCE(306);
      END_STATE();
    case 764:
      if (lookahead == 'o') ADVANCE(297);
      END_STATE();
    case 765:
      if (lookahead == 'o') ADVANCE(600);
      END_STATE();
    case 766:
      if (lookahead == 'o') ADVANCE(1044);
      END_STATE();
    case 767:
      if (lookahead == 'o') ADVANCE(974);
      END_STATE();
    case 768:
      if (lookahead == 'o') ADVANCE(825);
      END_STATE();
    case 769:
      if (lookahead == 'o') ADVANCE(673);
      END_STATE();
    case 770:
      if (lookahead == 'o') ADVANCE(858);
      END_STATE();
    case 771:
      if (lookahead == 'o') ADVANCE(833);
      END_STATE();
    case 772:
      if (lookahead == 'o') ADVANCE(224);
      END_STATE();
    case 773:
      if (lookahead == 'o') ADVANCE(827);
      END_STATE();
    case 774:
      if (lookahead == 'o') ADVANCE(225);
      END_STATE();
    case 775:
      if (lookahead == 'o') ADVANCE(225);
      if (lookahead == 'e' ||
          lookahead == 't') ADVANCE(167);
      END_STATE();
    case 776:
      if (lookahead == 'o') ADVANCE(838);
      END_STATE();
    case 777:
      if (lookahead == 'o') ADVANCE(230);
      END_STATE();
    case 778:
      if (lookahead == 'o') ADVANCE(230);
      if (lookahead == 'e' ||
          lookahead == 't') ADVANCE(167);
      END_STATE();
    case 779:
      if (lookahead == 'o') ADVANCE(856);
      END_STATE();
    case 780:
      if (lookahead == 'o') ADVANCE(233);
      END_STATE();
    case 781:
      if (lookahead == 'o') ADVANCE(834);
      END_STATE();
    case 782:
      if (lookahead == 'o') ADVANCE(234);
      END_STATE();
    case 783:
      if (lookahead == 'o') ADVANCE(899);
      END_STATE();
    case 784:
      if (lookahead == 'o') ADVANCE(862);
      END_STATE();
    case 785:
      if (lookahead == 'o') ADVANCE(857);
      END_STATE();
    case 786:
      if (lookahead == 'o') ADVANCE(717);
      END_STATE();
    case 787:
      if (lookahead == 'o') ADVANCE(239);
      if (lookahead == 'e' ||
          lookahead == 't') ADVANCE(1179);
      END_STATE();
    case 788:
      if (lookahead == 'o') ADVANCE(865);
      END_STATE();
    case 789:
      if (lookahead == 'o') ADVANCE(240);
      if (lookahead == 'e' ||
          lookahead == 't') ADVANCE(167);
      END_STATE();
    case 790:
      if (lookahead == 'o') ADVANCE(698);
      END_STATE();
    case 791:
      if (lookahead == 'o') ADVANCE(868);
      END_STATE();
    case 792:
      if (lookahead == 'o') ADVANCE(241);
      if (lookahead == 'e' ||
          lookahead == 't') ADVANCE(167);
      END_STATE();
    case 793:
      if (lookahead == 'o') ADVANCE(250);
      END_STATE();
    case 794:
      if (lookahead == 'o') ADVANCE(252);
      END_STATE();
    case 795:
      if (lookahead == 'o') ADVANCE(963);
      END_STATE();
    case 796:
      if (lookahead == 'o') ADVANCE(987);
      END_STATE();
    case 797:
      if (lookahead == 'o') ADVANCE(676);
      END_STATE();
    case 798:
      if (lookahead == 'o') ADVANCE(884);
      END_STATE();
    case 799:
      if (lookahead == 'o') ADVANCE(779);
      END_STATE();
    case 800:
      if (lookahead == 'o') ADVANCE(872);
      END_STATE();
    case 801:
      if (lookahead == 'o') ADVANCE(680);
      END_STATE();
    case 802:
      if (lookahead == 'o') ADVANCE(873);
      END_STATE();
    case 803:
      if (lookahead == 'o') ADVANCE(989);
      END_STATE();
    case 804:
      if (lookahead == 'o') ADVANCE(785);
      END_STATE();
    case 805:
      if (lookahead == 'o') ADVANCE(991);
      END_STATE();
    case 806:
      if (lookahead == 'o') ADVANCE(894);
      END_STATE();
    case 807:
      if (lookahead == 'o') ADVANCE(895);
      END_STATE();
    case 808:
      if (lookahead == 'o') ADVANCE(896);
      END_STATE();
    case 809:
      if (lookahead == 'o') ADVANCE(897);
      END_STATE();
    case 810:
      if (lookahead == 'o') ADVANCE(898);
      END_STATE();
    case 811:
      if (lookahead == 'o') ADVANCE(738);
      END_STATE();
    case 812:
      if (lookahead == 'o') ADVANCE(302);
      END_STATE();
    case 813:
      if (lookahead == 'o') ADVANCE(1045);
      END_STATE();
    case 814:
      if (lookahead == 'o') ADVANCE(751);
      END_STATE();
    case 815:
      if (lookahead == 'o') ADVANCE(688);
      END_STATE();
    case 816:
      if (lookahead == 'o') ADVANCE(742);
      END_STATE();
    case 817:
      if (lookahead == 'o') ADVANCE(742);
      if (lookahead == 'l' ||
          lookahead == 't') ADVANCE(1085);
      END_STATE();
    case 818:
      if (lookahead == 'o') ADVANCE(305);
      END_STATE();
    case 819:
      if (lookahead == 'o') ADVANCE(1046);
      END_STATE();
    case 820:
      if (lookahead == 'o') ADVANCE(754);
      END_STATE();
    case 821:
      if (lookahead == 'o') ADVANCE(745);
      END_STATE();
    case 822:
      if (lookahead == 'o') ADVANCE(689);
      END_STATE();
    case 823:
      if (lookahead == 'o') ADVANCE(760);
      END_STATE();
    case 824:
      if (lookahead == 'p') ADVANCE(1130);
      END_STATE();
    case 825:
      if (lookahead == 'p') ADVANCE(1191);
      END_STATE();
    case 826:
      if (lookahead == 'p') ADVANCE(1290);
      END_STATE();
    case 827:
      if (lookahead == 'p') ADVANCE(1179);
      END_STATE();
    case 828:
      if (lookahead == 'p') ADVANCE(1019);
      if (lookahead == 'v') ADVANCE(765);
      END_STATE();
    case 829:
      if (lookahead == 'p') ADVANCE(800);
      END_STATE();
    case 830:
      if (lookahead == 'p') ADVANCE(800);
      if (lookahead == 't') ADVANCE(435);
      END_STATE();
    case 831:
      if (lookahead == 'p') ADVANCE(800);
      if (lookahead == 't') ADVANCE(434);
      END_STATE();
    case 832:
      if (lookahead == 'p') ADVANCE(800);
      if (lookahead == 't') ADVANCE(472);
      END_STATE();
    case 833:
      if (lookahead == 'p') ADVANCE(1078);
      END_STATE();
    case 834:
      if (lookahead == 'p') ADVANCE(1079);
      END_STATE();
    case 835:
      if (lookahead == 'p') ADVANCE(390);
      END_STATE();
    case 836:
      if (lookahead == 'p') ADVANCE(179);
      END_STATE();
    case 837:
      if (lookahead == 'p') ADVANCE(1064);
      END_STATE();
    case 838:
      if (lookahead == 'p') ADVANCE(339);
      END_STATE();
    case 839:
      if (lookahead == 'p') ADVANCE(954);
      END_STATE();
    case 840:
      if (lookahead == 'p') ADVANCE(1020);
      END_STATE();
    case 841:
      if (lookahead == 'p') ADVANCE(1065);
      END_STATE();
    case 842:
      if (lookahead == 'p') ADVANCE(637);
      END_STATE();
    case 843:
      if (lookahead == 'p') ADVANCE(637);
      if (lookahead == 'q') ADVANCE(890);
      if (lookahead == 'u') ADVANCE(288);
      END_STATE();
    case 844:
      if (lookahead == 'p') ADVANCE(902);
      END_STATE();
    case 845:
      if (lookahead == 'p') ADVANCE(903);
      END_STATE();
    case 846:
      if (lookahead == 'p') ADVANCE(904);
      END_STATE();
    case 847:
      if (lookahead == 'p') ADVANCE(905);
      END_STATE();
    case 848:
      if (lookahead == 'p') ADVANCE(802);
      END_STATE();
    case 849:
      if (lookahead == 'q') ADVANCE(1179);
      END_STATE();
    case 850:
      if (lookahead == 'q') ADVANCE(1190);
      END_STATE();
    case 851:
      if (lookahead == 'q') ADVANCE(1190);
      if (lookahead == 'x') ADVANCE(993);
      END_STATE();
    case 852:
      if (lookahead == 'q') ADVANCE(1190);
      if (lookahead == 'x') ADVANCE(998);
      END_STATE();
    case 853:
      if (lookahead == 'q') ADVANCE(890);
      if (lookahead == 't') ADVANCE(806);
      if (lookahead == 'u') ADVANCE(288);
      END_STATE();
    case 854:
      if (lookahead == 'r') ADVANCE(1076);
      END_STATE();
    case 855:
      if (lookahead == 'r') ADVANCE(1297);
      END_STATE();
    case 856:
      if (lookahead == 'r') ADVANCE(1201);
      END_STATE();
    case 857:
      if (lookahead == 'r') ADVANCE(1179);
      END_STATE();
    case 858:
      if (lookahead == 'r') ADVANCE(1077);
      END_STATE();
    case 859:
      if (lookahead == 'r') ADVANCE(552);
      END_STATE();
    case 860:
      if (lookahead == 'r') ADVANCE(216);
      END_STATE();
    case 861:
      if (lookahead == 'r') ADVANCE(566);
      END_STATE();
    case 862:
      if (lookahead == 'r') ADVANCE(1081);
      END_STATE();
    case 863:
      if (lookahead == 'r') ADVANCE(167);
      END_STATE();
    case 864:
      if (lookahead == 'r') ADVANCE(768);
      END_STATE();
    case 865:
      if (lookahead == 'r') ADVANCE(1084);
      END_STATE();
    case 866:
      if (lookahead == 'r') ADVANCE(694);
      END_STATE();
    case 867:
      if (lookahead == 'r') ADVANCE(948);
      END_STATE();
    case 868:
      if (lookahead == 'r') ADVANCE(1080);
      END_STATE();
    case 869:
      if (lookahead == 'r') ADVANCE(1022);
      END_STATE();
    case 870:
      if (lookahead == 'r') ADVANCE(965);
      END_STATE();
    case 871:
      if (lookahead == 'r') ADVANCE(429);
      END_STATE();
    case 872:
      if (lookahead == 'r') ADVANCE(949);
      END_STATE();
    case 873:
      if (lookahead == 'r') ADVANCE(950);
      END_STATE();
    case 874:
      if (lookahead == 'r') ADVANCE(762);
      END_STATE();
    case 875:
      if (lookahead == 'r') ADVANCE(844);
      END_STATE();
    case 876:
      if (lookahead == 'r') ADVANCE(232);
      END_STATE();
    case 877:
      if (lookahead == 'r') ADVANCE(396);
      END_STATE();
    case 878:
      if (lookahead == 'r') ADVANCE(177);
      END_STATE();
    case 879:
      if (lookahead == 'r') ADVANCE(822);
      END_STATE();
    case 880:
      if (lookahead == 'r') ADVANCE(696);
      END_STATE();
    case 881:
      if (lookahead == 'r') ADVANCE(766);
      END_STATE();
    case 882:
      if (lookahead == 'r') ADVANCE(697);
      END_STATE();
    case 883:
      if (lookahead == 'r') ADVANCE(236);
      END_STATE();
    case 884:
      if (lookahead == 'r') ADVANCE(400);
      END_STATE();
    case 885:
      if (lookahead == 'r') ADVANCE(473);
      END_STATE();
    case 886:
      if (lookahead == 'r') ADVANCE(748);
      END_STATE();
    case 887:
      if (lookahead == 'r') ADVANCE(704);
      END_STATE();
    case 888:
      if (lookahead == 'r') ADVANCE(450);
      END_STATE();
    case 889:
      if (lookahead == 'r') ADVANCE(450);
      if (lookahead == 's') ADVANCE(535);
      END_STATE();
    case 890:
      if (lookahead == 'r') ADVANCE(963);
      END_STATE();
    case 891:
      if (lookahead == 'r') ADVANCE(440);
      END_STATE();
    case 892:
      if (lookahead == 'r') ADVANCE(441);
      END_STATE();
    case 893:
      if (lookahead == 'r') ADVANCE(994);
      END_STATE();
    case 894:
      if (lookahead == 'r') ADVANCE(409);
      END_STATE();
    case 895:
      if (lookahead == 'r') ADVANCE(422);
      END_STATE();
    case 896:
      if (lookahead == 'r') ADVANCE(423);
      END_STATE();
    case 897:
      if (lookahead == 'r') ADVANCE(424);
      END_STATE();
    case 898:
      if (lookahead == 'r') ADVANCE(425);
      END_STATE();
    case 899:
      if (lookahead == 'r') ADVANCE(677);
      END_STATE();
    case 900:
      if (lookahead == 'r') ADVANCE(469);
      END_STATE();
    case 901:
      if (lookahead == 'r') ADVANCE(881);
      END_STATE();
    case 902:
      if (lookahead == 'r') ADVANCE(483);
      END_STATE();
    case 903:
      if (lookahead == 'r') ADVANCE(468);
      END_STATE();
    case 904:
      if (lookahead == 'r') ADVANCE(461);
      END_STATE();
    case 905:
      if (lookahead == 'r') ADVANCE(462);
      END_STATE();
    case 906:
      if (lookahead == 'r') ADVANCE(1027);
      END_STATE();
    case 907:
      if (lookahead == 'r') ADVANCE(845);
      END_STATE();
    case 908:
      if (lookahead == 'r') ADVANCE(813);
      END_STATE();
    case 909:
      if (lookahead == 'r') ADVANCE(475);
      END_STATE();
    case 910:
      if (lookahead == 'r') ADVANCE(999);
      END_STATE();
    case 911:
      if (lookahead == 'r') ADVANCE(908);
      END_STATE();
    case 912:
      if (lookahead == 'r') ADVANCE(846);
      END_STATE();
    case 913:
      if (lookahead == 'r') ADVANCE(1032);
      END_STATE();
    case 914:
      if (lookahead == 'r') ADVANCE(847);
      END_STATE();
    case 915:
      if (lookahead == 'r') ADVANCE(1035);
      END_STATE();
    case 916:
      if (lookahead == 'r') ADVANCE(1036);
      END_STATE();
    case 917:
      if (lookahead == 'r') ADVANCE(592);
      END_STATE();
    case 918:
      if (lookahead == 'r') ADVANCE(594);
      END_STATE();
    case 919:
      if (lookahead == 's') ADVANCE(924);
      END_STATE();
    case 920:
      if (lookahead == 's') ADVANCE(1201);
      END_STATE();
    case 921:
      if (lookahead == 's') ADVANCE(1179);
      END_STATE();
    case 922:
      if (lookahead == 's') ADVANCE(535);
      END_STATE();
    case 923:
      if (lookahead == 's') ADVANCE(599);
      END_STATE();
    case 924:
      if (lookahead == 's') ADVANCE(465);
      END_STATE();
    case 925:
      if (lookahead == 's') ADVANCE(842);
      END_STATE();
    case 926:
      if (lookahead == 's') ADVANCE(946);
      END_STATE();
    case 927:
      if (lookahead == 's') ADVANCE(446);
      END_STATE();
    case 928:
      if (lookahead == 's') ADVANCE(956);
      END_STATE();
    case 929:
      if (lookahead == 's') ADVANCE(956);
      if (lookahead == 'v') ADVANCE(474);
      END_STATE();
    case 930:
      if (lookahead == 's') ADVANCE(958);
      END_STATE();
    case 931:
      if (lookahead == 's') ADVANCE(961);
      END_STATE();
    case 932:
      if (lookahead == 's') ADVANCE(957);
      END_STATE();
    case 933:
      if (lookahead == 's') ADVANCE(980);
      END_STATE();
    case 934:
      if (lookahead == 's') ADVANCE(963);
      END_STATE();
    case 935:
      if (lookahead == 's') ADVANCE(478);
      END_STATE();
    case 936:
      if (lookahead == 's') ADVANCE(985);
      END_STATE();
    case 937:
      if (lookahead == 's') ADVANCE(260);
      END_STATE();
    case 938:
      if (lookahead == 's') ADVANCE(185);
      END_STATE();
    case 939:
      if (lookahead == 's') ADVANCE(271);
      END_STATE();
    case 940:
      if (lookahead == 's') ADVANCE(578);
      END_STATE();
    case 941:
      if (lookahead == 's') ADVANCE(195);
      END_STATE();
    case 942:
      if (lookahead == 't') ADVANCE(1282);
      END_STATE();
    case 943:
      if (lookahead == 't') ADVANCE(1207);
      END_STATE();
    case 944:
      if (lookahead == 't') ADVANCE(1166);
      END_STATE();
    case 945:
      if (lookahead == 't') ADVANCE(1191);
      END_STATE();
    case 946:
      if (lookahead == 't') ADVANCE(1298);
      END_STATE();
    case 947:
      if (lookahead == 't') ADVANCE(1294);
      END_STATE();
    case 948:
      if (lookahead == 't') ADVANCE(1244);
      END_STATE();
    case 949:
      if (lookahead == 't') ADVANCE(1153);
      END_STATE();
    case 950:
      if (lookahead == 't') ADVANCE(1175);
      END_STATE();
    case 951:
      if (lookahead == 't') ADVANCE(1263);
      END_STATE();
    case 952:
      if (lookahead == 't') ADVANCE(1295);
      END_STATE();
    case 953:
      if (lookahead == 't') ADVANCE(1165);
      END_STATE();
    case 954:
      if (lookahead == 't') ADVANCE(1296);
      END_STATE();
    case 955:
      if (lookahead == 't') ADVANCE(1208);
      END_STATE();
    case 956:
      if (lookahead == 't') ADVANCE(1203);
      END_STATE();
    case 957:
      if (lookahead == 't') ADVANCE(1201);
      END_STATE();
    case 958:
      if (lookahead == 't') ADVANCE(1204);
      END_STATE();
    case 959:
      if (lookahead == 't') ADVANCE(1195);
      END_STATE();
    case 960:
      if (lookahead == 't') ADVANCE(1237);
      END_STATE();
    case 961:
      if (lookahead == 't') ADVANCE(1209);
      END_STATE();
    case 962:
      if (lookahead == 't') ADVANCE(1161);
      END_STATE();
    case 963:
      if (lookahead == 't') ADVANCE(1179);
      END_STATE();
    case 964:
      if (lookahead == 't') ADVANCE(1095);
      END_STATE();
    case 965:
      if (lookahead == 't') ADVANCE(163);
      END_STATE();
    case 966:
      if (lookahead == 't') ADVANCE(201);
      END_STATE();
    case 967:
      if (lookahead == 't') ADVANCE(532);
      END_STATE();
    case 968:
      if (lookahead == 't') ADVANCE(186);
      END_STATE();
    case 969:
      if (lookahead == 't') ADVANCE(840);
      END_STATE();
    case 970:
      if (lookahead == 't') ADVANCE(675);
      END_STATE();
    case 971:
      if (lookahead == 't') ADVANCE(167);
      END_STATE();
    case 972:
      if (lookahead == 't') ADVANCE(1028);
      END_STATE();
    case 973:
      if (lookahead == 't') ADVANCE(179);
      END_STATE();
    case 974:
      if (lookahead == 't') ADVANCE(392);
      END_STATE();
    case 975:
      if (lookahead == 't') ADVANCE(798);
      END_STATE();
    case 976:
      if (lookahead == 't') ADVANCE(175);
      END_STATE();
    case 977:
      if (lookahead == 't') ADVANCE(556);
      END_STATE();
    case 978:
      if (lookahead == 't') ADVANCE(176);
      END_STATE();
    case 979:
      if (lookahead == 't') ADVANCE(434);
      END_STATE();
    case 980:
      if (lookahead == 't') ADVANCE(582);
      END_STATE();
    case 981:
      if (lookahead == 't') ADVANCE(869);
      END_STATE();
    case 982:
      if (lookahead == 't') ADVANCE(559);
      END_STATE();
    case 983:
      if (lookahead == 't') ADVANCE(769);
      END_STATE();
    case 984:
      if (lookahead == 't') ADVANCE(178);
      END_STATE();
    case 985:
      if (lookahead == 't') ADVANCE(442);
      END_STATE();
    case 986:
      if (lookahead == 't') ADVANCE(213);
      END_STATE();
    case 987:
      if (lookahead == 't') ADVANCE(563);
      END_STATE();
    case 988:
      if (lookahead == 't') ADVANCE(212);
      END_STATE();
    case 989:
      if (lookahead == 't') ADVANCE(443);
      END_STATE();
    case 990:
      if (lookahead == 't') ADVANCE(449);
      END_STATE();
    case 991:
      if (lookahead == 't') ADVANCE(445);
      END_STATE();
    case 992:
      if (lookahead == 't') ADVANCE(100);
      END_STATE();
    case 993:
      if (lookahead == 't') ADVANCE(458);
      END_STATE();
    case 994:
      if (lookahead == 't') ADVANCE(180);
      END_STATE();
    case 995:
      if (lookahead == 't') ADVANCE(187);
      END_STATE();
    case 996:
      if (lookahead == 't') ADVANCE(466);
      END_STATE();
    case 997:
      if (lookahead == 't') ADVANCE(935);
      END_STATE();
    case 998:
      if (lookahead == 't') ADVANCE(459);
      END_STATE();
    case 999:
      if (lookahead == 't') ADVANCE(188);
      END_STATE();
    case 1000:
      if (lookahead == 't') ADVANCE(472);
      END_STATE();
    case 1001:
      if (lookahead == 't') ADVANCE(801);
      END_STATE();
    case 1002:
      if (lookahead == 't') ADVANCE(574);
      END_STATE();
    case 1003:
      if (lookahead == 't') ADVANCE(191);
      END_STATE();
    case 1004:
      if (lookahead == 't') ADVANCE(479);
      END_STATE();
    case 1005:
      if (lookahead == 't') ADVANCE(482);
      END_STATE();
    case 1006:
      if (lookahead == 't') ADVANCE(485);
      END_STATE();
    case 1007:
      if (lookahead == 't') ADVANCE(809);
      END_STATE();
    case 1008:
      if (lookahead == 't') ADVANCE(810);
      END_STATE();
    case 1009:
      if (lookahead == 't') ADVANCE(539);
      END_STATE();
    case 1010:
      if (lookahead == 't') ADVANCE(540);
      END_STATE();
    case 1011:
      if (lookahead == 'u') ADVANCE(1089);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1105);
      if (lookahead != 0) ADVANCE(1152);
      END_STATE();
    case 1012:
      if (lookahead == 'u') ADVANCE(1179);
      END_STATE();
    case 1013:
      if (lookahead == 'u') ADVANCE(503);
      END_STATE();
    case 1014:
      if (lookahead == 'u') ADVANCE(767);
      END_STATE();
    case 1015:
      if (lookahead == 'u') ADVANCE(969);
      END_STATE();
    case 1016:
      if (lookahead == 'u') ADVANCE(288);
      END_STATE();
    case 1017:
      if (lookahead == 'u') ADVANCE(295);
      END_STATE();
    case 1018:
      if (lookahead == 'u') ADVANCE(636);
      END_STATE();
    case 1019:
      if (lookahead == 'u') ADVANCE(947);
      END_STATE();
    case 1020:
      if (lookahead == 'u') ADVANCE(952);
      END_STATE();
    case 1021:
      if (lookahead == 'u') ADVANCE(616);
      END_STATE();
    case 1022:
      if (lookahead == 'u') ADVANCE(400);
      END_STATE();
    case 1023:
      if (lookahead == 'u') ADVANCE(624);
      END_STATE();
    case 1024:
      if (lookahead == 'u') ADVANCE(713);
      END_STATE();
    case 1025:
      if (lookahead == 'u') ADVANCE(633);
      END_STATE();
    case 1026:
      if (lookahead == 'u') ADVANCE(635);
      END_STATE();
    case 1027:
      if (lookahead == 'u') ADVANCE(715);
      END_STATE();
    case 1028:
      if (lookahead == 'u') ADVANCE(882);
      END_STATE();
    case 1029:
      if (lookahead == 'u') ADVANCE(638);
      END_STATE();
    case 1030:
      if (lookahead == 'u') ADVANCE(721);
      END_STATE();
    case 1031:
      if (lookahead == 'u') ADVANCE(887);
      END_STATE();
    case 1032:
      if (lookahead == 'u') ADVANCE(722);
      END_STATE();
    case 1033:
      if (lookahead == 'u') ADVANCE(643);
      END_STATE();
    case 1034:
      if (lookahead == 'u') ADVANCE(933);
      END_STATE();
    case 1035:
      if (lookahead == 'u') ADVANCE(724);
      END_STATE();
    case 1036:
      if (lookahead == 'u') ADVANCE(726);
      END_STATE();
    case 1037:
      if (lookahead == 'v') ADVANCE(1179);
      END_STATE();
    case 1038:
      if (lookahead == 'v') ADVANCE(167);
      END_STATE();
    case 1039:
      if (lookahead == 'v') ADVANCE(245);
      END_STATE();
    case 1040:
      if (lookahead == 'v') ADVANCE(480);
      END_STATE();
    case 1041:
      if (lookahead == 'w') ADVANCE(1195);
      END_STATE();
    case 1042:
      if (lookahead == 'w') ADVANCE(31);
      END_STATE();
    case 1043:
      if (lookahead == 'w') ADVANCE(30);
      END_STATE();
    case 1044:
      if (lookahead == 'w') ADVANCE(188);
      END_STATE();
    case 1045:
      if (lookahead == 'w') ADVANCE(181);
      END_STATE();
    case 1046:
      if (lookahead == 'w') ADVANCE(183);
      END_STATE();
    case 1047:
      if (lookahead == 'x') ADVANCE(44);
      END_STATE();
    case 1048:
      if (lookahead == 'x') ADVANCE(1179);
      END_STATE();
    case 1049:
      if (lookahead == 'x') ADVANCE(149);
      END_STATE();
    case 1050:
      if (lookahead == 'x') ADVANCE(150);
      END_STATE();
    case 1051:
      if (lookahead == 'x') ADVANCE(534);
      END_STATE();
    case 1052:
      if (lookahead == 'x') ADVANCE(155);
      END_STATE();
    case 1053:
      if (lookahead == 'x') ADVANCE(1110);
      END_STATE();
    case 1054:
      if (lookahead == 'x') ADVANCE(65);
      END_STATE();
    case 1055:
      if (lookahead == 'x') ADVANCE(112);
      END_STATE();
    case 1056:
      if (lookahead == 'x') ADVANCE(153);
      END_STATE();
    case 1057:
      if (lookahead == 'x') ADVANCE(167);
      END_STATE();
    case 1058:
      if (lookahead == 'x') ADVANCE(81);
      END_STATE();
    case 1059:
      if (lookahead == 'x') ADVANCE(126);
      END_STATE();
    case 1060:
      if (lookahead == 'x') ADVANCE(152);
      END_STATE();
    case 1061:
      if (lookahead == 'x') ADVANCE(127);
      END_STATE();
    case 1062:
      if (lookahead == 'x') ADVANCE(118);
      END_STATE();
    case 1063:
      if (lookahead == 'x') ADVANCE(119);
      END_STATE();
    case 1064:
      if (lookahead == 'x') ADVANCE(325);
      END_STATE();
    case 1065:
      if (lookahead == 'x') ADVANCE(329);
      END_STATE();
    case 1066:
      if (lookahead == 'x') ADVANCE(73);
      END_STATE();
    case 1067:
      if (lookahead == 'x') ADVANCE(74);
      END_STATE();
    case 1068:
      if (lookahead == 'x') ADVANCE(45);
      END_STATE();
    case 1069:
      if (lookahead == 'x') ADVANCE(156);
      END_STATE();
    case 1070:
      if (lookahead == 'x') ADVANCE(46);
      END_STATE();
    case 1071:
      if (lookahead == 'x') ADVANCE(996);
      END_STATE();
    case 1072:
      if (lookahead == 'x') ADVANCE(54);
      END_STATE();
    case 1073:
      if (lookahead == 'x') ADVANCE(49);
      END_STATE();
    case 1074:
      if (lookahead == 'x') ADVANCE(1000);
      END_STATE();
    case 1075:
      if (lookahead == 'x') ADVANCE(979);
      END_STATE();
    case 1076:
      if (lookahead == 'y') ADVANCE(1300);
      END_STATE();
    case 1077:
      if (lookahead == 'y') ADVANCE(1157);
      END_STATE();
    case 1078:
      if (lookahead == 'y') ADVANCE(1236);
      END_STATE();
    case 1079:
      if (lookahead == 'y') ADVANCE(1179);
      END_STATE();
    case 1080:
      if (lookahead == 'y') ADVANCE(1156);
      END_STATE();
    case 1081:
      if (lookahead == 'y') ADVANCE(1158);
      END_STATE();
    case 1082:
      if (lookahead == 'y') ADVANCE(184);
      END_STATE();
    case 1083:
      if (lookahead == 'y') ADVANCE(940);
      END_STATE();
    case 1084:
      if (lookahead == 'y') ADVANCE(27);
      END_STATE();
    case 1085:
      if (lookahead == 'z') ADVANCE(1179);
      END_STATE();
    case 1086:
      if (lookahead == 'z') ADVANCE(1088);
      END_STATE();
    case 1087:
      if (lookahead == 'z') ADVANCE(401);
      END_STATE();
    case 1088:
      if (lookahead == 'z') ADVANCE(646);
      END_STATE();
    case 1089:
      if (lookahead == '{') ADVANCE(1107);
      END_STATE();
    case 1090:
      if (lookahead == '}') ADVANCE(1152);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1090);
      END_STATE();
    case 1091:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(1101);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1168);
      END_STATE();
    case 1092:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(1104);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1140);
      END_STATE();
    case 1093:
      if (lookahead == 'e' ||
          lookahead == 't') ADVANCE(1179);
      END_STATE();
    case 1094:
      if (lookahead == 'e' ||
          lookahead == 't') ADVANCE(167);
      END_STATE();
    case 1095:
      if (lookahead == 'l' ||
          lookahead == 'r') ADVANCE(1179);
      END_STATE();
    case 1096:
      if (lookahead == 's' ||
          lookahead == 'u') ADVANCE(1201);
      END_STATE();
    case 1097:
      if (lookahead == 's' ||
          lookahead == 'u') ADVANCE(1179);
      END_STATE();
    case 1098:
      if (lookahead == 's' ||
          lookahead == 'u') ADVANCE(1196);
      END_STATE();
    case 1099:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1121);
      END_STATE();
    case 1100:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1145);
      END_STATE();
    case 1101:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1168);
      END_STATE();
    case 1102:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1139);
      END_STATE();
    case 1103:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1141);
      END_STATE();
    case 1104:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1140);
      END_STATE();
    case 1105:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1152);
      END_STATE();
    case 1106:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1118);
      END_STATE();
    case 1107:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1090);
      END_STATE();
    case 1108:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1167);
      END_STATE();
    case 1109:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1169);
      END_STATE();
    case 1110:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1248);
      END_STATE();
    case 1111:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1171);
      END_STATE();
    case 1112:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1122);
      END_STATE();
    case 1113:
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(1172);
      END_STATE();
    case 1114:
      if (eof) ADVANCE(1115);
      if (lookahead == '"') ADVANCE(1276);
      if (lookahead == '$') ADVANCE(1113);
      if (lookahead == '(') ADVANCE(1125);
      if (lookahead == ')') ADVANCE(1124);
      if (lookahead == '0') ADVANCE(1143);
      if (lookahead == ';') ADVANCE(16);
      if (lookahead == 'a') ADVANCE(602);
      if (lookahead == 'b') ADVANCE(543);
      if (lookahead == 'c') ADVANCE(196);
      if (lookahead == 'd') ADVANCE(198);
      if (lookahead == 'e') ADVANCE(607);
      if (lookahead == 'f') ADVANCE(93);
      if (lookahead == 'g') ADVANCE(416);
      if (lookahead == 'i') ADVANCE(42);
      if (lookahead == 'l') ADVANCE(426);
      if (lookahead == 'm') ADVANCE(386);
      if (lookahead == 'n') ADVANCE(215);
      if (lookahead == 'o') ADVANCE(491);
      if (lookahead == 'p') ADVANCE(199);
      if (lookahead == 'q') ADVANCE(1014);
      if (lookahead == 'r') ADVANCE(388);
      if (lookahead == 's') ADVANCE(320);
      if (lookahead == 't') ADVANCE(200);
      if (lookahead == 'u') ADVANCE(706);
      if (lookahead == 'v') ADVANCE(43);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(1275);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(1114)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(1145);
      END_STATE();
    case 1115:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 1116:
      ACCEPT_TOKEN(anon_sym_align);
      END_STATE();
    case 1117:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 1118:
      ACCEPT_TOKEN(sym_align_offset_value);
      if (lookahead == '.') ADVANCE(1170);
      if (lookahead == '_') ADVANCE(1106);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1091);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1118);
      END_STATE();
    case 1119:
      ACCEPT_TOKEN(sym_align_offset_value);
      if (lookahead == '_') ADVANCE(1099);
      if (lookahead == 'x') ADVANCE(1106);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1121);
      END_STATE();
    case 1120:
      ACCEPT_TOKEN(sym_align_offset_value);
      if (lookahead == '_') ADVANCE(1099);
      if (lookahead == 'x') ADVANCE(1112);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1121);
      END_STATE();
    case 1121:
      ACCEPT_TOKEN(sym_align_offset_value);
      if (lookahead == '_') ADVANCE(1099);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1121);
      END_STATE();
    case 1122:
      ACCEPT_TOKEN(sym_align_offset_value);
      if (lookahead == '_') ADVANCE(1112);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1122);
      END_STATE();
    case 1123:
      ACCEPT_TOKEN(anon_sym_LPAREN_AT);
      END_STATE();
    case 1124:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 1125:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == ';') ADVANCE(1131);
      if (lookahead == '@') ADVANCE(1123);
      END_STATE();
    case 1126:
      ACCEPT_TOKEN(anon_sym_block);
      END_STATE();
    case 1127:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 1128:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 1129:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 1130:
      ACCEPT_TOKEN(anon_sym_loop);
      END_STATE();
    case 1131:
      ACCEPT_TOKEN(anon_sym_LPAREN_SEMI);
      END_STATE();
    case 1132:
      ACCEPT_TOKEN(anon_sym_SEMI_RPAREN);
      END_STATE();
    case 1133:
      ACCEPT_TOKEN(sym_comment_block_inner);
      if (lookahead == '(') ADVANCE(1135);
      if (lookahead == ';') ADVANCE(1134);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(1133);
      if (lookahead != 0) ADVANCE(1136);
      END_STATE();
    case 1134:
      ACCEPT_TOKEN(sym_comment_block_inner);
      if (lookahead == ')') ADVANCE(1132);
      if (lookahead == ';') ADVANCE(1137);
      END_STATE();
    case 1135:
      ACCEPT_TOKEN(sym_comment_block_inner);
      if (lookahead == ';') ADVANCE(1131);
      if (lookahead == '@') ADVANCE(1123);
      END_STATE();
    case 1136:
      ACCEPT_TOKEN(sym_comment_block_inner);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ';') ADVANCE(1136);
      END_STATE();
    case 1137:
      ACCEPT_TOKEN(aux_sym_comment_line_token1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(1137);
      END_STATE();
    case 1138:
      ACCEPT_TOKEN(sym_dec_float);
      if (lookahead == '.') ADVANCE(1142);
      if (lookahead == '_') ADVANCE(1102);
      if (lookahead == 'x') ADVANCE(1108);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1092);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1139);
      END_STATE();
    case 1139:
      ACCEPT_TOKEN(sym_dec_float);
      if (lookahead == '.') ADVANCE(1142);
      if (lookahead == '_') ADVANCE(1102);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1092);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1139);
      END_STATE();
    case 1140:
      ACCEPT_TOKEN(sym_dec_float);
      if (lookahead == '_') ADVANCE(1104);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1140);
      END_STATE();
    case 1141:
      ACCEPT_TOKEN(sym_dec_float);
      if (lookahead == '_') ADVANCE(1103);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1092);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1141);
      END_STATE();
    case 1142:
      ACCEPT_TOKEN(sym_dec_float);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(1092);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1141);
      END_STATE();
    case 1143:
      ACCEPT_TOKEN(sym_dec_nat);
      if (lookahead == '_') ADVANCE(1100);
      if (lookahead == 'x') ADVANCE(1108);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1145);
      END_STATE();
    case 1144:
      ACCEPT_TOKEN(sym_dec_nat);
      if (lookahead == '_') ADVANCE(1100);
      if (lookahead == 'x') ADVANCE(1111);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1145);
      END_STATE();
    case 1145:
      ACCEPT_TOKEN(sym_dec_nat);
      if (lookahead == '_') ADVANCE(1100);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1145);
      END_STATE();
    case 1146:
      ACCEPT_TOKEN(anon_sym_item);
      END_STATE();
    case 1147:
      ACCEPT_TOKEN(anon_sym_func);
      END_STATE();
    case 1148:
      ACCEPT_TOKEN(anon_sym_func);
      if (lookahead == '.') ADVANCE(298);
      END_STATE();
    case 1149:
      ACCEPT_TOKEN(anon_sym_func);
      if (lookahead == '.') ADVANCE(298);
      if (lookahead == 'r') ADVANCE(433);
      END_STATE();
    case 1150:
      ACCEPT_TOKEN(anon_sym_func);
      if (lookahead == 'r') ADVANCE(433);
      END_STATE();
    case 1151:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(1277);
      if (lookahead == '\\') ADVANCE(1011);
      END_STATE();
    case 1152:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(1011);
      END_STATE();
    case 1153:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 1154:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 1155:
      ACCEPT_TOKEN(anon_sym_global);
      if (lookahead == '.') ADVANCE(522);
      END_STATE();
    case 1156:
      ACCEPT_TOKEN(anon_sym_memory);
      END_STATE();
    case 1157:
      ACCEPT_TOKEN(anon_sym_memory);
      if (lookahead == '.') ADVANCE(518);
      END_STATE();
    case 1158:
      ACCEPT_TOKEN(anon_sym_memory);
      if (lookahead == '.') ADVANCE(259);
      END_STATE();
    case 1159:
      ACCEPT_TOKEN(anon_sym_table);
      END_STATE();
    case 1160:
      ACCEPT_TOKEN(anon_sym_table);
      if (lookahead == '.') ADVANCE(332);
      END_STATE();
    case 1161:
      ACCEPT_TOKEN(anon_sym_call_indirect);
      END_STATE();
    case 1162:
      ACCEPT_TOKEN(anon_sym_inf);
      END_STATE();
    case 1163:
      ACCEPT_TOKEN(anon_sym_local);
      if (lookahead == '.') ADVANCE(523);
      END_STATE();
    case 1164:
      ACCEPT_TOKEN(anon_sym_param);
      END_STATE();
    case 1165:
      ACCEPT_TOKEN(anon_sym_result);
      END_STATE();
    case 1166:
      ACCEPT_TOKEN(anon_sym_mut);
      END_STATE();
    case 1167:
      ACCEPT_TOKEN(sym_hex_float);
      if (lookahead == '.') ADVANCE(1170);
      if (lookahead == '_') ADVANCE(1108);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1091);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1167);
      END_STATE();
    case 1168:
      ACCEPT_TOKEN(sym_hex_float);
      if (lookahead == '_') ADVANCE(1101);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(1168);
      END_STATE();
    case 1169:
      ACCEPT_TOKEN(sym_hex_float);
      if (lookahead == '_') ADVANCE(1109);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1091);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1169);
      END_STATE();
    case 1170:
      ACCEPT_TOKEN(sym_hex_float);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(1091);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1169);
      END_STATE();
    case 1171:
      ACCEPT_TOKEN(sym_hex_nat);
      if (lookahead == '_') ADVANCE(1111);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1171);
      END_STATE();
    case 1172:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(1172);
      END_STATE();
    case 1173:
      ACCEPT_TOKEN(sym_identifier_pattern);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(1173);
      END_STATE();
    case 1174:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 1175:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 1176:
      ACCEPT_TOKEN(anon_sym_br_table);
      END_STATE();
    case 1177:
      ACCEPT_TOKEN(anon_sym_ref_DOTextern);
      END_STATE();
    case 1178:
      ACCEPT_TOKEN(anon_sym_ref_DOTnull);
      END_STATE();
    case 1179:
      ACCEPT_TOKEN(sym_op_nullary);
      END_STATE();
    case 1180:
      ACCEPT_TOKEN(sym_op_nullary);
      if (lookahead == '1') ADVANCE(132);
      if (lookahead == '3') ADVANCE(67);
      if (lookahead == '8') ADVANCE(1179);
      END_STATE();
    case 1181:
      ACCEPT_TOKEN(sym_op_nullary);
      if (lookahead == '1') ADVANCE(132);
      if (lookahead == '8') ADVANCE(1179);
      END_STATE();
    case 1182:
      ACCEPT_TOKEN(sym_op_nullary);
      if (lookahead == '1') ADVANCE(142);
      if (lookahead == '3') ADVANCE(87);
      if (lookahead == '8') ADVANCE(177);
      END_STATE();
    case 1183:
      ACCEPT_TOKEN(sym_op_nullary);
      if (lookahead == '1') ADVANCE(142);
      if (lookahead == '8') ADVANCE(177);
      END_STATE();
    case 1184:
      ACCEPT_TOKEN(sym_op_nullary);
      if (lookahead == '_') ADVANCE(937);
      END_STATE();
    case 1185:
      ACCEPT_TOKEN(sym_op_nullary);
      if (lookahead == '_') ADVANCE(350);
      END_STATE();
    case 1186:
      ACCEPT_TOKEN(sym_op_nullary);
      if (lookahead == 'a') ADVANCE(885);
      if (lookahead == 'g') ADVANCE(1201);
      END_STATE();
    case 1187:
      ACCEPT_TOKEN(sym_op_nullary);
      if (lookahead == 'a') ADVANCE(909);
      if (lookahead == 'g') ADVANCE(1179);
      END_STATE();
    case 1188:
      ACCEPT_TOKEN(sym_op_nullary);
      if (lookahead == 'g') ADVANCE(1201);
      END_STATE();
    case 1189:
      ACCEPT_TOKEN(sym_op_nullary);
      if (lookahead == 'n') ADVANCE(795);
      END_STATE();
    case 1190:
      ACCEPT_TOKEN(sym_op_nullary);
      if (lookahead == 'z') ADVANCE(1179);
      END_STATE();
    case 1191:
      ACCEPT_TOKEN(sym_op_index);
      END_STATE();
    case 1192:
      ACCEPT_TOKEN(sym_op_index);
      if (lookahead == '_') ADVANCE(548);
      END_STATE();
    case 1193:
      ACCEPT_TOKEN(sym_op_index);
      if (lookahead == '_') ADVANCE(558);
      END_STATE();
    case 1194:
      ACCEPT_TOKEN(sym_op_index);
      if (lookahead == '_') ADVANCE(557);
      END_STATE();
    case 1195:
      ACCEPT_TOKEN(sym_op_index_opt);
      END_STATE();
    case 1196:
      ACCEPT_TOKEN(sym_op_index_opt_offset_opt_align_opt);
      END_STATE();
    case 1197:
      ACCEPT_TOKEN(sym_op_index_opt_offset_opt_align_opt);
      if (lookahead == '1') ADVANCE(140);
      if (lookahead == '3') ADVANCE(85);
      if (lookahead == '8') ADVANCE(168);
      END_STATE();
    case 1198:
      ACCEPT_TOKEN(sym_op_index_opt_offset_opt_align_opt);
      if (lookahead == '1') ADVANCE(140);
      if (lookahead == '8') ADVANCE(168);
      END_STATE();
    case 1199:
      ACCEPT_TOKEN(sym_op_index_opt_offset_opt_align_opt);
      if (lookahead == '1') ADVANCE(133);
      if (lookahead == '3') ADVANCE(68);
      if (lookahead == '8') ADVANCE(1196);
      END_STATE();
    case 1200:
      ACCEPT_TOKEN(sym_op_index_opt_offset_opt_align_opt);
      if (lookahead == '1') ADVANCE(133);
      if (lookahead == '8') ADVANCE(1196);
      END_STATE();
    case 1201:
      ACCEPT_TOKEN(sym_op_simd_offset_opt_align_opt);
      END_STATE();
    case 1202:
      ACCEPT_TOKEN(sym_op_simd_offset_opt_align_opt);
      if (lookahead == '1') ADVANCE(137);
      if (lookahead == '3') ADVANCE(78);
      if (lookahead == '6') ADVANCE(125);
      if (lookahead == '8') ADVANCE(170);
      END_STATE();
    case 1203:
      ACCEPT_TOKEN(aux_sym_op_const_token1);
      END_STATE();
    case 1204:
      ACCEPT_TOKEN(aux_sym_op_const_token2);
      END_STATE();
    case 1205:
      ACCEPT_TOKEN(anon_sym_func_DOTbind);
      END_STATE();
    case 1206:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 1207:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 1208:
      ACCEPT_TOKEN(anon_sym_select);
      END_STATE();
    case 1209:
      ACCEPT_TOKEN(anon_sym_v128_DOTconst);
      END_STATE();
    case 1210:
      ACCEPT_TOKEN(anon_sym_f32x4);
      END_STATE();
    case 1211:
      ACCEPT_TOKEN(anon_sym_f32x4);
      if (lookahead == '.') ADVANCE(218);
      END_STATE();
    case 1212:
      ACCEPT_TOKEN(anon_sym_f32x4);
      if (lookahead == '.') ADVANCE(264);
      END_STATE();
    case 1213:
      ACCEPT_TOKEN(anon_sym_f64x2);
      END_STATE();
    case 1214:
      ACCEPT_TOKEN(anon_sym_f64x2);
      if (lookahead == '.') ADVANCE(218);
      END_STATE();
    case 1215:
      ACCEPT_TOKEN(anon_sym_f64x2);
      if (lookahead == '.') ADVANCE(265);
      END_STATE();
    case 1216:
      ACCEPT_TOKEN(anon_sym_i8x16);
      END_STATE();
    case 1217:
      ACCEPT_TOKEN(anon_sym_i8x16);
      if (lookahead == '.') ADVANCE(204);
      END_STATE();
    case 1218:
      ACCEPT_TOKEN(anon_sym_i8x16);
      if (lookahead == '.') ADVANCE(210);
      END_STATE();
    case 1219:
      ACCEPT_TOKEN(anon_sym_i16x8);
      END_STATE();
    case 1220:
      ACCEPT_TOKEN(anon_sym_i16x8);
      if (lookahead == '.') ADVANCE(202);
      END_STATE();
    case 1221:
      ACCEPT_TOKEN(anon_sym_i16x8);
      if (lookahead == '.') ADVANCE(208);
      END_STATE();
    case 1222:
      ACCEPT_TOKEN(anon_sym_i32x4);
      END_STATE();
    case 1223:
      ACCEPT_TOKEN(anon_sym_i32x4);
      if (lookahead == '.') ADVANCE(209);
      END_STATE();
    case 1224:
      ACCEPT_TOKEN(anon_sym_i32x4);
      if (lookahead == '.') ADVANCE(203);
      END_STATE();
    case 1225:
      ACCEPT_TOKEN(anon_sym_i64x2);
      END_STATE();
    case 1226:
      ACCEPT_TOKEN(anon_sym_i64x2);
      if (lookahead == '.') ADVANCE(657);
      END_STATE();
    case 1227:
      ACCEPT_TOKEN(anon_sym_i64x2);
      if (lookahead == '.') ADVANCE(243);
      END_STATE();
    case 1228:
      ACCEPT_TOKEN(anon_sym_DOTshuffle);
      END_STATE();
    case 1229:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == 's') ADVANCE(525);
      END_STATE();
    case 1230:
      ACCEPT_TOKEN(anon_sym_extract_lane);
      END_STATE();
    case 1231:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 1232:
      ACCEPT_TOKEN(aux_sym_op_simd_lane_token1);
      END_STATE();
    case 1233:
      ACCEPT_TOKEN(aux_sym_op_simd_lane_token1);
      if (lookahead == 'c') ADVANCE(859);
      if (lookahead == 'e') ADVANCE(627);
      if (lookahead == 'h') ADVANCE(214);
      if (lookahead == 't') ADVANCE(217);
      END_STATE();
    case 1234:
      ACCEPT_TOKEN(aux_sym_op_simd_lane_token1);
      if (lookahead == 'n') ADVANCE(922);
      END_STATE();
    case 1235:
      ACCEPT_TOKEN(anon_sym_replace_lane);
      END_STATE();
    case 1236:
      ACCEPT_TOKEN(anon_sym_table_DOTcopy);
      END_STATE();
    case 1237:
      ACCEPT_TOKEN(anon_sym_table_DOTinit);
      END_STATE();
    case 1238:
      ACCEPT_TOKEN(anon_sym_data);
      END_STATE();
    case 1239:
      ACCEPT_TOKEN(anon_sym_data);
      if (lookahead == '.') ADVANCE(376);
      END_STATE();
    case 1240:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 1241:
      ACCEPT_TOKEN(anon_sym_elem);
      END_STATE();
    case 1242:
      ACCEPT_TOKEN(anon_sym_elem);
      if (lookahead == '.') ADVANCE(376);
      END_STATE();
    case 1243:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 1244:
      ACCEPT_TOKEN(anon_sym_start);
      END_STATE();
    case 1245:
      ACCEPT_TOKEN(sym_nan);
      END_STATE();
    case 1246:
      ACCEPT_TOKEN(sym_nan);
      if (lookahead == ':') ADVANCE(40);
      END_STATE();
    case 1247:
      ACCEPT_TOKEN(sym_nan);
      if (lookahead == ':') ADVANCE(41);
      END_STATE();
    case 1248:
      ACCEPT_TOKEN(sym_nan);
      if (lookahead == '_') ADVANCE(1110);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(1248);
      END_STATE();
    case 1249:
      ACCEPT_TOKEN(anon_sym_f32);
      END_STATE();
    case 1250:
      ACCEPT_TOKEN(anon_sym_f32);
      if (lookahead == '.') ADVANCE(327);
      END_STATE();
    case 1251:
      ACCEPT_TOKEN(anon_sym_f32);
      if (lookahead == '.') ADVANCE(327);
      if (lookahead == 'x') ADVANCE(110);
      END_STATE();
    case 1252:
      ACCEPT_TOKEN(anon_sym_f64);
      END_STATE();
    case 1253:
      ACCEPT_TOKEN(anon_sym_f64);
      if (lookahead == '.') ADVANCE(327);
      END_STATE();
    case 1254:
      ACCEPT_TOKEN(anon_sym_f64);
      if (lookahead == '.') ADVANCE(327);
      if (lookahead == 'x') ADVANCE(63);
      END_STATE();
    case 1255:
      ACCEPT_TOKEN(anon_sym_i32);
      END_STATE();
    case 1256:
      ACCEPT_TOKEN(anon_sym_i32);
      if (lookahead == '.') ADVANCE(351);
      END_STATE();
    case 1257:
      ACCEPT_TOKEN(anon_sym_i32);
      if (lookahead == '.') ADVANCE(351);
      if (lookahead == 'x') ADVANCE(111);
      END_STATE();
    case 1258:
      ACCEPT_TOKEN(anon_sym_i64);
      END_STATE();
    case 1259:
      ACCEPT_TOKEN(anon_sym_i64);
      if (lookahead == '.') ADVANCE(351);
      END_STATE();
    case 1260:
      ACCEPT_TOKEN(anon_sym_i64);
      if (lookahead == '.') ADVANCE(351);
      if (lookahead == 'x') ADVANCE(64);
      END_STATE();
    case 1261:
      ACCEPT_TOKEN(sym_num_type_v128);
      END_STATE();
    case 1262:
      ACCEPT_TOKEN(sym_num_type_v128);
      if (lookahead == '.') ADVANCE(353);
      END_STATE();
    case 1263:
      ACCEPT_TOKEN(anon_sym_offset);
      END_STATE();
    case 1264:
      ACCEPT_TOKEN(sym_ref_kind);
      END_STATE();
    case 1265:
      ACCEPT_TOKEN(sym_ref_type_externref);
      END_STATE();
    case 1266:
      ACCEPT_TOKEN(sym_ref_type_funcref);
      END_STATE();
    case 1267:
      ACCEPT_TOKEN(anon_sym_ref);
      if (lookahead == '.') ADVANCE(432);
      END_STATE();
    case 1268:
      ACCEPT_TOKEN(anon_sym_ref);
      if (lookahead == '.') ADVANCE(222);
      END_STATE();
    case 1269:
      ACCEPT_TOKEN(anon_sym_null);
      END_STATE();
    case 1270:
      ACCEPT_TOKEN(sym_reserved);
      END_STATE();
    case 1271:
      ACCEPT_TOKEN(sym_reserved);
      if (lookahead == ';') ADVANCE(1137);
      END_STATE();
    case 1272:
      ACCEPT_TOKEN(sym_reserved);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(1172);
      END_STATE();
    case 1273:
      ACCEPT_TOKEN(sym_reserved);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(1273);
      END_STATE();
    case 1274:
      ACCEPT_TOKEN(sym_share);
      END_STATE();
    case 1275:
      ACCEPT_TOKEN(sym_sign);
      END_STATE();
    case 1276:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 1277:
      ACCEPT_TOKEN(aux_sym_string_token1);
      END_STATE();
    case 1278:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '(') ADVANCE(1279);
      if (lookahead == ';') ADVANCE(1280);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(1278);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(1281);
      END_STATE();
    case 1279:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == ';') ADVANCE(1281);
      if (lookahead == '@') ADVANCE(1281);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(1281);
      END_STATE();
    case 1280:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == ';') ADVANCE(1281);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(1281);
      END_STATE();
    case 1281:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(1281);
      END_STATE();
    case 1282:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 1283:
      ACCEPT_TOKEN(anon_sym_invoke);
      END_STATE();
    case 1284:
      ACCEPT_TOKEN(anon_sym_assert_exhaustion);
      END_STATE();
    case 1285:
      ACCEPT_TOKEN(anon_sym_assert_invalid);
      END_STATE();
    case 1286:
      ACCEPT_TOKEN(anon_sym_assert_malformed);
      END_STATE();
    case 1287:
      ACCEPT_TOKEN(anon_sym_assert_return);
      if (lookahead == '_') ADVANCE(286);
      END_STATE();
    case 1288:
      ACCEPT_TOKEN(anon_sym_assert_return_arithmetic_nan);
      END_STATE();
    case 1289:
      ACCEPT_TOKEN(anon_sym_assert_return_canonical_nan);
      END_STATE();
    case 1290:
      ACCEPT_TOKEN(anon_sym_assert_trap);
      END_STATE();
    case 1291:
      ACCEPT_TOKEN(anon_sym_assert_unlinkable);
      END_STATE();
    case 1292:
      ACCEPT_TOKEN(sym_literal_nan_arithmetic);
      END_STATE();
    case 1293:
      ACCEPT_TOKEN(sym_literal_nan_canonical);
      END_STATE();
    case 1294:
      ACCEPT_TOKEN(anon_sym_input);
      END_STATE();
    case 1295:
      ACCEPT_TOKEN(anon_sym_output);
      END_STATE();
    case 1296:
      ACCEPT_TOKEN(anon_sym_script);
      END_STATE();
    case 1297:
      ACCEPT_TOKEN(anon_sym_register);
      END_STATE();
    case 1298:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 1299:
      ACCEPT_TOKEN(sym_result_ref_func);
      END_STATE();
    case 1300:
      ACCEPT_TOKEN(anon_sym_binary);
      END_STATE();
    case 1301:
      ACCEPT_TOKEN(anon_sym_quote);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 0},
  [2] = {.lex_state = 3},
  [3] = {.lex_state = 3},
  [4] = {.lex_state = 3},
  [5] = {.lex_state = 3},
  [6] = {.lex_state = 3},
  [7] = {.lex_state = 3},
  [8] = {.lex_state = 3},
  [9] = {.lex_state = 3},
  [10] = {.lex_state = 3},
  [11] = {.lex_state = 3},
  [12] = {.lex_state = 3},
  [13] = {.lex_state = 3},
  [14] = {.lex_state = 3},
  [15] = {.lex_state = 3},
  [16] = {.lex_state = 3},
  [17] = {.lex_state = 3},
  [18] = {.lex_state = 3},
  [19] = {.lex_state = 3},
  [20] = {.lex_state = 3},
  [21] = {.lex_state = 3},
  [22] = {.lex_state = 3},
  [23] = {.lex_state = 3},
  [24] = {.lex_state = 3},
  [25] = {.lex_state = 3},
  [26] = {.lex_state = 3},
  [27] = {.lex_state = 3},
  [28] = {.lex_state = 3},
  [29] = {.lex_state = 3},
  [30] = {.lex_state = 3},
  [31] = {.lex_state = 3},
  [32] = {.lex_state = 3},
  [33] = {.lex_state = 3},
  [34] = {.lex_state = 3},
  [35] = {.lex_state = 3},
  [36] = {.lex_state = 3},
  [37] = {.lex_state = 3},
  [38] = {.lex_state = 3},
  [39] = {.lex_state = 3},
  [40] = {.lex_state = 3},
  [41] = {.lex_state = 3},
  [42] = {.lex_state = 3},
  [43] = {.lex_state = 3},
  [44] = {.lex_state = 3},
  [45] = {.lex_state = 3},
  [46] = {.lex_state = 3},
  [47] = {.lex_state = 3},
  [48] = {.lex_state = 3},
  [49] = {.lex_state = 3},
  [50] = {.lex_state = 3},
  [51] = {.lex_state = 3},
  [52] = {.lex_state = 3},
  [53] = {.lex_state = 3},
  [54] = {.lex_state = 3},
  [55] = {.lex_state = 3},
  [56] = {.lex_state = 3},
  [57] = {.lex_state = 3},
  [58] = {.lex_state = 3},
  [59] = {.lex_state = 3},
  [60] = {.lex_state = 3},
  [61] = {.lex_state = 3},
  [62] = {.lex_state = 3},
  [63] = {.lex_state = 3},
  [64] = {.lex_state = 3},
  [65] = {.lex_state = 3},
  [66] = {.lex_state = 3},
  [67] = {.lex_state = 3},
  [68] = {.lex_state = 3},
  [69] = {.lex_state = 3},
  [70] = {.lex_state = 3},
  [71] = {.lex_state = 3},
  [72] = {.lex_state = 3},
  [73] = {.lex_state = 3},
  [74] = {.lex_state = 3},
  [75] = {.lex_state = 3},
  [76] = {.lex_state = 3},
  [77] = {.lex_state = 3},
  [78] = {.lex_state = 3},
  [79] = {.lex_state = 3},
  [80] = {.lex_state = 3},
  [81] = {.lex_state = 3},
  [82] = {.lex_state = 3},
  [83] = {.lex_state = 3},
  [84] = {.lex_state = 3},
  [85] = {.lex_state = 3},
  [86] = {.lex_state = 3},
  [87] = {.lex_state = 3},
  [88] = {.lex_state = 3},
  [89] = {.lex_state = 3},
  [90] = {.lex_state = 3},
  [91] = {.lex_state = 3},
  [92] = {.lex_state = 3},
  [93] = {.lex_state = 3},
  [94] = {.lex_state = 3},
  [95] = {.lex_state = 3},
  [96] = {.lex_state = 3},
  [97] = {.lex_state = 3},
  [98] = {.lex_state = 3},
  [99] = {.lex_state = 3},
  [100] = {.lex_state = 3},
  [101] = {.lex_state = 3},
  [102] = {.lex_state = 3},
  [103] = {.lex_state = 3},
  [104] = {.lex_state = 3},
  [105] = {.lex_state = 3},
  [106] = {.lex_state = 3},
  [107] = {.lex_state = 3},
  [108] = {.lex_state = 3},
  [109] = {.lex_state = 3},
  [110] = {.lex_state = 3},
  [111] = {.lex_state = 3},
  [112] = {.lex_state = 3},
  [113] = {.lex_state = 3},
  [114] = {.lex_state = 3},
  [115] = {.lex_state = 3},
  [116] = {.lex_state = 3},
  [117] = {.lex_state = 3},
  [118] = {.lex_state = 3},
  [119] = {.lex_state = 3},
  [120] = {.lex_state = 3},
  [121] = {.lex_state = 3},
  [122] = {.lex_state = 3},
  [123] = {.lex_state = 3},
  [124] = {.lex_state = 3},
  [125] = {.lex_state = 3},
  [126] = {.lex_state = 3},
  [127] = {.lex_state = 3},
  [128] = {.lex_state = 3},
  [129] = {.lex_state = 3},
  [130] = {.lex_state = 3},
  [131] = {.lex_state = 3},
  [132] = {.lex_state = 3},
  [133] = {.lex_state = 3},
  [134] = {.lex_state = 3},
  [135] = {.lex_state = 3},
  [136] = {.lex_state = 3},
  [137] = {.lex_state = 3},
  [138] = {.lex_state = 3},
  [139] = {.lex_state = 3},
  [140] = {.lex_state = 3},
  [141] = {.lex_state = 3},
  [142] = {.lex_state = 3},
  [143] = {.lex_state = 3},
  [144] = {.lex_state = 3},
  [145] = {.lex_state = 3},
  [146] = {.lex_state = 3},
  [147] = {.lex_state = 3},
  [148] = {.lex_state = 3},
  [149] = {.lex_state = 3},
  [150] = {.lex_state = 3},
  [151] = {.lex_state = 3},
  [152] = {.lex_state = 3},
  [153] = {.lex_state = 3},
  [154] = {.lex_state = 3},
  [155] = {.lex_state = 3},
  [156] = {.lex_state = 3},
  [157] = {.lex_state = 3},
  [158] = {.lex_state = 3},
  [159] = {.lex_state = 3},
  [160] = {.lex_state = 3},
  [161] = {.lex_state = 3},
  [162] = {.lex_state = 3},
  [163] = {.lex_state = 3},
  [164] = {.lex_state = 3},
  [165] = {.lex_state = 3},
  [166] = {.lex_state = 3},
  [167] = {.lex_state = 3},
  [168] = {.lex_state = 3},
  [169] = {.lex_state = 3},
  [170] = {.lex_state = 3},
  [171] = {.lex_state = 3},
  [172] = {.lex_state = 3},
  [173] = {.lex_state = 3},
  [174] = {.lex_state = 4},
  [175] = {.lex_state = 3},
  [176] = {.lex_state = 3},
  [177] = {.lex_state = 3},
  [178] = {.lex_state = 3},
  [179] = {.lex_state = 3},
  [180] = {.lex_state = 3},
  [181] = {.lex_state = 3},
  [182] = {.lex_state = 3},
  [183] = {.lex_state = 3},
  [184] = {.lex_state = 3},
  [185] = {.lex_state = 4},
  [186] = {.lex_state = 3},
  [187] = {.lex_state = 4},
  [188] = {.lex_state = 3},
  [189] = {.lex_state = 3},
  [190] = {.lex_state = 3},
  [191] = {.lex_state = 3},
  [192] = {.lex_state = 3},
  [193] = {.lex_state = 3},
  [194] = {.lex_state = 10},
  [195] = {.lex_state = 10},
  [196] = {.lex_state = 3},
  [197] = {.lex_state = 3},
  [198] = {.lex_state = 3},
  [199] = {.lex_state = 3},
  [200] = {.lex_state = 3},
  [201] = {.lex_state = 3},
  [202] = {.lex_state = 3},
  [203] = {.lex_state = 3},
  [204] = {.lex_state = 3},
  [205] = {.lex_state = 3},
  [206] = {.lex_state = 3},
  [207] = {.lex_state = 3},
  [208] = {.lex_state = 3},
  [209] = {.lex_state = 3},
  [210] = {.lex_state = 3},
  [211] = {.lex_state = 3},
  [212] = {.lex_state = 3},
  [213] = {.lex_state = 3},
  [214] = {.lex_state = 3},
  [215] = {.lex_state = 3},
  [216] = {.lex_state = 3},
  [217] = {.lex_state = 3},
  [218] = {.lex_state = 3},
  [219] = {.lex_state = 3},
  [220] = {.lex_state = 3},
  [221] = {.lex_state = 3},
  [222] = {.lex_state = 3},
  [223] = {.lex_state = 3},
  [224] = {.lex_state = 3},
  [225] = {.lex_state = 3},
  [226] = {.lex_state = 3},
  [227] = {.lex_state = 3},
  [228] = {.lex_state = 3},
  [229] = {.lex_state = 3},
  [230] = {.lex_state = 3},
  [231] = {.lex_state = 3},
  [232] = {.lex_state = 3},
  [233] = {.lex_state = 3},
  [234] = {.lex_state = 3},
  [235] = {.lex_state = 3},
  [236] = {.lex_state = 3},
  [237] = {.lex_state = 3},
  [238] = {.lex_state = 3},
  [239] = {.lex_state = 3},
  [240] = {.lex_state = 3},
  [241] = {.lex_state = 3},
  [242] = {.lex_state = 3},
  [243] = {.lex_state = 3},
  [244] = {.lex_state = 3},
  [245] = {.lex_state = 3},
  [246] = {.lex_state = 3},
  [247] = {.lex_state = 3},
  [248] = {.lex_state = 3},
  [249] = {.lex_state = 3},
  [250] = {.lex_state = 3},
  [251] = {.lex_state = 3},
  [252] = {.lex_state = 3},
  [253] = {.lex_state = 3},
  [254] = {.lex_state = 3},
  [255] = {.lex_state = 3},
  [256] = {.lex_state = 3},
  [257] = {.lex_state = 3},
  [258] = {.lex_state = 3},
  [259] = {.lex_state = 3},
  [260] = {.lex_state = 3},
  [261] = {.lex_state = 3},
  [262] = {.lex_state = 3},
  [263] = {.lex_state = 3},
  [264] = {.lex_state = 3},
  [265] = {.lex_state = 3},
  [266] = {.lex_state = 3},
  [267] = {.lex_state = 3},
  [268] = {.lex_state = 3},
  [269] = {.lex_state = 3},
  [270] = {.lex_state = 3},
  [271] = {.lex_state = 3},
  [272] = {.lex_state = 3},
  [273] = {.lex_state = 3},
  [274] = {.lex_state = 3},
  [275] = {.lex_state = 3},
  [276] = {.lex_state = 3},
  [277] = {.lex_state = 3},
  [278] = {.lex_state = 3},
  [279] = {.lex_state = 3},
  [280] = {.lex_state = 3},
  [281] = {.lex_state = 3},
  [282] = {.lex_state = 3},
  [283] = {.lex_state = 3},
  [284] = {.lex_state = 3},
  [285] = {.lex_state = 3},
  [286] = {.lex_state = 3},
  [287] = {.lex_state = 3},
  [288] = {.lex_state = 3},
  [289] = {.lex_state = 3},
  [290] = {.lex_state = 3},
  [291] = {.lex_state = 3},
  [292] = {.lex_state = 3},
  [293] = {.lex_state = 3},
  [294] = {.lex_state = 3},
  [295] = {.lex_state = 3},
  [296] = {.lex_state = 3},
  [297] = {.lex_state = 3},
  [298] = {.lex_state = 3},
  [299] = {.lex_state = 3},
  [300] = {.lex_state = 3},
  [301] = {.lex_state = 3},
  [302] = {.lex_state = 3},
  [303] = {.lex_state = 3},
  [304] = {.lex_state = 3},
  [305] = {.lex_state = 3},
  [306] = {.lex_state = 3},
  [307] = {.lex_state = 3},
  [308] = {.lex_state = 3},
  [309] = {.lex_state = 3},
  [310] = {.lex_state = 3},
  [311] = {.lex_state = 3},
  [312] = {.lex_state = 3},
  [313] = {.lex_state = 3},
  [314] = {.lex_state = 3},
  [315] = {.lex_state = 3},
  [316] = {.lex_state = 0},
  [317] = {.lex_state = 0},
  [318] = {.lex_state = 0},
  [319] = {.lex_state = 0},
  [320] = {.lex_state = 0},
  [321] = {.lex_state = 0},
  [322] = {.lex_state = 11},
  [323] = {.lex_state = 5},
  [324] = {.lex_state = 5},
  [325] = {.lex_state = 5},
  [326] = {.lex_state = 5},
  [327] = {.lex_state = 5},
  [328] = {.lex_state = 5},
  [329] = {.lex_state = 5},
  [330] = {.lex_state = 5},
  [331] = {.lex_state = 5},
  [332] = {.lex_state = 5},
  [333] = {.lex_state = 5},
  [334] = {.lex_state = 5},
  [335] = {.lex_state = 5},
  [336] = {.lex_state = 5},
  [337] = {.lex_state = 5},
  [338] = {.lex_state = 5},
  [339] = {.lex_state = 5},
  [340] = {.lex_state = 5},
  [341] = {.lex_state = 5},
  [342] = {.lex_state = 5},
  [343] = {.lex_state = 11},
  [344] = {.lex_state = 0},
  [345] = {.lex_state = 5},
  [346] = {.lex_state = 5},
  [347] = {.lex_state = 0},
  [348] = {.lex_state = 3},
  [349] = {.lex_state = 3},
  [350] = {.lex_state = 3},
  [351] = {.lex_state = 5},
  [352] = {.lex_state = 0},
  [353] = {.lex_state = 3},
  [354] = {.lex_state = 3},
  [355] = {.lex_state = 5},
  [356] = {.lex_state = 5},
  [357] = {.lex_state = 3},
  [358] = {.lex_state = 3},
  [359] = {.lex_state = 5},
  [360] = {.lex_state = 0},
  [361] = {.lex_state = 0},
  [362] = {.lex_state = 0},
  [363] = {.lex_state = 3},
  [364] = {.lex_state = 3},
  [365] = {.lex_state = 7},
  [366] = {.lex_state = 7},
  [367] = {.lex_state = 3},
  [368] = {.lex_state = 3},
  [369] = {.lex_state = 7},
  [370] = {.lex_state = 7},
  [371] = {.lex_state = 3},
  [372] = {.lex_state = 7},
  [373] = {.lex_state = 5},
  [374] = {.lex_state = 0},
  [375] = {.lex_state = 0},
  [376] = {.lex_state = 0},
  [377] = {.lex_state = 11},
  [378] = {.lex_state = 0},
  [379] = {.lex_state = 5},
  [380] = {.lex_state = 5},
  [381] = {.lex_state = 5},
  [382] = {.lex_state = 5},
  [383] = {.lex_state = 5},
  [384] = {.lex_state = 5},
  [385] = {.lex_state = 5},
  [386] = {.lex_state = 5},
  [387] = {.lex_state = 0},
  [388] = {.lex_state = 5},
  [389] = {.lex_state = 5},
  [390] = {.lex_state = 5},
  [391] = {.lex_state = 5},
  [392] = {.lex_state = 0},
  [393] = {.lex_state = 5},
  [394] = {.lex_state = 5},
  [395] = {.lex_state = 5},
  [396] = {.lex_state = 3},
  [397] = {.lex_state = 3},
  [398] = {.lex_state = 0},
  [399] = {.lex_state = 0},
  [400] = {.lex_state = 5},
  [401] = {.lex_state = 0},
  [402] = {.lex_state = 0},
  [403] = {.lex_state = 0},
  [404] = {.lex_state = 0},
  [405] = {.lex_state = 0},
  [406] = {.lex_state = 5},
  [407] = {.lex_state = 5},
  [408] = {.lex_state = 0},
  [409] = {.lex_state = 5},
  [410] = {.lex_state = 5},
  [411] = {.lex_state = 0},
  [412] = {.lex_state = 0},
  [413] = {.lex_state = 0},
  [414] = {.lex_state = 3},
  [415] = {.lex_state = 0},
  [416] = {.lex_state = 9},
  [417] = {.lex_state = 0},
  [418] = {.lex_state = 0},
  [419] = {.lex_state = 3},
  [420] = {.lex_state = 3},
  [421] = {.lex_state = 0},
  [422] = {.lex_state = 0},
  [423] = {.lex_state = 0},
  [424] = {.lex_state = 9},
  [425] = {.lex_state = 3},
  [426] = {.lex_state = 0},
  [427] = {.lex_state = 3},
  [428] = {.lex_state = 0},
  [429] = {.lex_state = 3},
  [430] = {.lex_state = 9},
  [431] = {.lex_state = 0},
  [432] = {.lex_state = 10},
  [433] = {.lex_state = 10},
  [434] = {.lex_state = 0},
  [435] = {.lex_state = 10},
  [436] = {.lex_state = 0},
  [437] = {.lex_state = 10},
  [438] = {.lex_state = 9},
  [439] = {.lex_state = 10},
  [440] = {.lex_state = 10},
  [441] = {.lex_state = 9},
  [442] = {.lex_state = 10},
  [443] = {.lex_state = 10},
  [444] = {.lex_state = 9},
  [445] = {.lex_state = 10},
  [446] = {.lex_state = 0},
  [447] = {.lex_state = 10},
  [448] = {.lex_state = 3},
  [449] = {.lex_state = 3},
  [450] = {.lex_state = 10},
  [451] = {.lex_state = 10},
  [452] = {.lex_state = 0},
  [453] = {.lex_state = 0},
  [454] = {.lex_state = 10},
  [455] = {.lex_state = 10},
  [456] = {.lex_state = 10},
  [457] = {.lex_state = 10},
  [458] = {.lex_state = 10},
  [459] = {.lex_state = 9},
  [460] = {.lex_state = 10},
  [461] = {.lex_state = 10},
  [462] = {.lex_state = 10},
  [463] = {.lex_state = 10},
  [464] = {.lex_state = 10},
  [465] = {.lex_state = 9},
  [466] = {.lex_state = 10},
  [467] = {.lex_state = 3},
  [468] = {.lex_state = 3},
  [469] = {.lex_state = 3},
  [470] = {.lex_state = 3},
  [471] = {.lex_state = 3},
  [472] = {.lex_state = 3},
  [473] = {.lex_state = 0},
  [474] = {.lex_state = 3},
  [475] = {.lex_state = 7},
  [476] = {.lex_state = 3},
  [477] = {.lex_state = 3},
  [478] = {.lex_state = 7},
  [479] = {.lex_state = 3},
  [480] = {.lex_state = 7},
  [481] = {.lex_state = 0},
  [482] = {.lex_state = 3},
  [483] = {.lex_state = 3},
  [484] = {.lex_state = 3},
  [485] = {.lex_state = 3},
  [486] = {.lex_state = 0},
  [487] = {.lex_state = 0},
  [488] = {.lex_state = 0},
  [489] = {.lex_state = 7},
  [490] = {.lex_state = 7},
  [491] = {.lex_state = 7},
  [492] = {.lex_state = 3},
  [493] = {.lex_state = 3},
  [494] = {.lex_state = 3},
  [495] = {.lex_state = 3},
  [496] = {.lex_state = 7},
  [497] = {.lex_state = 3},
  [498] = {.lex_state = 3},
  [499] = {.lex_state = 3},
  [500] = {.lex_state = 0},
  [501] = {.lex_state = 3},
  [502] = {.lex_state = 3},
  [503] = {.lex_state = 3},
  [504] = {.lex_state = 3},
  [505] = {.lex_state = 3},
  [506] = {.lex_state = 3},
  [507] = {.lex_state = 3},
  [508] = {.lex_state = 3},
  [509] = {.lex_state = 3},
  [510] = {.lex_state = 3},
  [511] = {.lex_state = 3},
  [512] = {.lex_state = 7},
  [513] = {.lex_state = 3},
  [514] = {.lex_state = 3},
  [515] = {.lex_state = 3},
  [516] = {.lex_state = 0},
  [517] = {.lex_state = 3},
  [518] = {.lex_state = 3},
  [519] = {.lex_state = 3},
  [520] = {.lex_state = 7},
  [521] = {.lex_state = 3},
  [522] = {.lex_state = 3},
  [523] = {.lex_state = 3},
  [524] = {.lex_state = 3},
  [525] = {.lex_state = 0},
  [526] = {.lex_state = 3},
  [527] = {.lex_state = 3},
  [528] = {.lex_state = 3},
  [529] = {.lex_state = 0},
  [530] = {.lex_state = 3},
  [531] = {.lex_state = 0},
  [532] = {.lex_state = 3},
  [533] = {.lex_state = 3},
  [534] = {.lex_state = 3},
  [535] = {.lex_state = 3},
  [536] = {.lex_state = 3},
  [537] = {.lex_state = 3},
  [538] = {.lex_state = 0},
  [539] = {.lex_state = 1},
  [540] = {.lex_state = 0},
  [541] = {.lex_state = 3},
  [542] = {.lex_state = 0},
  [543] = {.lex_state = 0},
  [544] = {.lex_state = 0},
  [545] = {.lex_state = 0},
  [546] = {.lex_state = 0},
  [547] = {.lex_state = 0},
  [548] = {.lex_state = 0},
  [549] = {.lex_state = 0},
  [550] = {.lex_state = 0},
  [551] = {.lex_state = 0},
  [552] = {.lex_state = 0},
  [553] = {.lex_state = 11},
  [554] = {.lex_state = 0},
  [555] = {.lex_state = 0},
  [556] = {.lex_state = 0},
  [557] = {.lex_state = 0},
  [558] = {.lex_state = 0},
  [559] = {.lex_state = 0},
  [560] = {.lex_state = 0},
  [561] = {.lex_state = 0},
  [562] = {.lex_state = 0},
  [563] = {.lex_state = 0},
  [564] = {.lex_state = 3},
  [565] = {.lex_state = 0},
  [566] = {.lex_state = 10},
  [567] = {.lex_state = 3},
  [568] = {.lex_state = 0},
  [569] = {.lex_state = 0},
  [570] = {.lex_state = 0},
  [571] = {.lex_state = 0},
  [572] = {.lex_state = 0},
  [573] = {.lex_state = 0},
  [574] = {.lex_state = 0},
  [575] = {.lex_state = 15},
  [576] = {.lex_state = 0},
  [577] = {.lex_state = 0},
  [578] = {.lex_state = 0},
  [579] = {.lex_state = 0},
  [580] = {.lex_state = 0},
  [581] = {.lex_state = 15},
  [582] = {.lex_state = 0},
  [583] = {.lex_state = 0},
  [584] = {.lex_state = 0},
  [585] = {.lex_state = 0},
  [586] = {.lex_state = 0},
  [587] = {.lex_state = 1},
  [588] = {.lex_state = 0},
  [589] = {.lex_state = 0},
  [590] = {.lex_state = 0},
  [591] = {.lex_state = 0},
  [592] = {.lex_state = 0},
  [593] = {.lex_state = 0},
  [594] = {.lex_state = 0},
  [595] = {.lex_state = 0},
  [596] = {.lex_state = 0},
  [597] = {.lex_state = 0},
  [598] = {.lex_state = 0},
  [599] = {.lex_state = 0},
  [600] = {.lex_state = 3},
  [601] = {.lex_state = 0},
  [602] = {.lex_state = 3},
  [603] = {.lex_state = 0},
  [604] = {.lex_state = 0},
  [605] = {.lex_state = 0},
  [606] = {.lex_state = 11},
  [607] = {.lex_state = 0},
  [608] = {.lex_state = 0},
  [609] = {.lex_state = 15},
  [610] = {.lex_state = 15},
  [611] = {.lex_state = 0},
  [612] = {.lex_state = 1},
  [613] = {.lex_state = 15},
  [614] = {.lex_state = 0},
  [615] = {.lex_state = 1},
  [616] = {.lex_state = 0},
  [617] = {.lex_state = 0},
  [618] = {.lex_state = 1},
  [619] = {.lex_state = 0},
  [620] = {.lex_state = 0},
  [621] = {.lex_state = 0},
  [622] = {.lex_state = 0},
  [623] = {.lex_state = 0},
  [624] = {.lex_state = 0},
  [625] = {.lex_state = 0},
  [626] = {.lex_state = 0},
  [627] = {.lex_state = 0},
  [628] = {.lex_state = 0},
  [629] = {.lex_state = 0},
  [630] = {.lex_state = 0},
  [631] = {.lex_state = 0},
  [632] = {.lex_state = 15},
  [633] = {.lex_state = 15},
  [634] = {.lex_state = 0},
  [635] = {.lex_state = 0},
  [636] = {.lex_state = 0},
  [637] = {.lex_state = 0},
  [638] = {.lex_state = 0},
  [639] = {.lex_state = 0},
  [640] = {.lex_state = 0},
  [641] = {.lex_state = 0},
  [642] = {.lex_state = 0},
  [643] = {.lex_state = 3},
  [644] = {.lex_state = 0},
  [645] = {.lex_state = 0},
  [646] = {.lex_state = 0},
  [647] = {.lex_state = 0},
  [648] = {.lex_state = 3},
  [649] = {.lex_state = 1},
  [650] = {.lex_state = 0},
  [651] = {.lex_state = 0},
  [652] = {.lex_state = 0},
  [653] = {.lex_state = 0},
  [654] = {.lex_state = 0},
  [655] = {.lex_state = 0},
  [656] = {.lex_state = 0},
  [657] = {.lex_state = 0},
  [658] = {.lex_state = 0},
  [659] = {.lex_state = 0},
  [660] = {.lex_state = 0},
  [661] = {.lex_state = 0},
  [662] = {.lex_state = 0},
  [663] = {.lex_state = 0},
  [664] = {.lex_state = 15},
  [665] = {.lex_state = 0},
  [666] = {.lex_state = 0},
  [667] = {.lex_state = 3},
  [668] = {.lex_state = 0},
  [669] = {.lex_state = 0},
  [670] = {.lex_state = 0},
  [671] = {.lex_state = 0},
  [672] = {.lex_state = 3},
  [673] = {.lex_state = 0},
  [674] = {.lex_state = 0},
  [675] = {.lex_state = 0},
  [676] = {.lex_state = 0},
  [677] = {.lex_state = 0},
  [678] = {.lex_state = 0},
  [679] = {.lex_state = 0},
  [680] = {.lex_state = 0},
  [681] = {.lex_state = 0},
  [682] = {.lex_state = 0},
  [683] = {.lex_state = 0},
  [684] = {.lex_state = 0},
  [685] = {.lex_state = 0},
  [686] = {.lex_state = 0},
  [687] = {.lex_state = 0},
  [688] = {.lex_state = 0},
  [689] = {.lex_state = 3},
  [690] = {.lex_state = 0},
  [691] = {.lex_state = 0},
  [692] = {.lex_state = 0},
  [693] = {.lex_state = 0},
  [694] = {.lex_state = 0},
  [695] = {.lex_state = 0},
  [696] = {.lex_state = 0},
  [697] = {.lex_state = 0},
  [698] = {.lex_state = 0},
  [699] = {.lex_state = 0},
  [700] = {.lex_state = 0},
  [701] = {.lex_state = 0},
  [702] = {.lex_state = 0},
  [703] = {.lex_state = 0},
  [704] = {.lex_state = 0},
  [705] = {.lex_state = 15},
  [706] = {.lex_state = 0},
  [707] = {.lex_state = 0},
  [708] = {.lex_state = 0},
  [709] = {.lex_state = 0},
  [710] = {.lex_state = 0},
  [711] = {.lex_state = 0},
  [712] = {.lex_state = 0},
  [713] = {.lex_state = 0},
  [714] = {.lex_state = 0},
  [715] = {.lex_state = 15},
  [716] = {.lex_state = 0},
  [717] = {.lex_state = 0},
  [718] = {.lex_state = 0},
  [719] = {.lex_state = 11},
  [720] = {.lex_state = 0},
  [721] = {.lex_state = 0},
  [722] = {.lex_state = 0},
  [723] = {.lex_state = 0},
  [724] = {.lex_state = 0},
  [725] = {.lex_state = 0},
  [726] = {.lex_state = 0},
  [727] = {.lex_state = 0},
  [728] = {.lex_state = 0},
  [729] = {.lex_state = 0},
  [730] = {.lex_state = 0},
  [731] = {.lex_state = 0},
  [732] = {.lex_state = 0},
  [733] = {.lex_state = 0},
  [734] = {.lex_state = 0},
  [735] = {.lex_state = 15},
  [736] = {.lex_state = 0},
  [737] = {.lex_state = 0},
  [738] = {.lex_state = 0},
  [739] = {.lex_state = 0},
  [740] = {.lex_state = 0},
  [741] = {.lex_state = 0},
  [742] = {.lex_state = 0},
  [743] = {.lex_state = 0},
  [744] = {.lex_state = 0},
  [745] = {.lex_state = 0},
  [746] = {.lex_state = 0},
  [747] = {.lex_state = 0},
  [748] = {.lex_state = 0},
  [749] = {.lex_state = 0},
  [750] = {.lex_state = 0},
  [751] = {.lex_state = 0},
  [752] = {.lex_state = 0},
  [753] = {.lex_state = 3},
  [754] = {.lex_state = 0},
  [755] = {.lex_state = 15},
  [756] = {.lex_state = 15},
  [757] = {.lex_state = 0},
  [758] = {.lex_state = 0},
  [759] = {.lex_state = 0},
  [760] = {.lex_state = 0},
  [761] = {.lex_state = 0},
  [762] = {.lex_state = 0},
  [763] = {.lex_state = 15},
  [764] = {.lex_state = 0},
  [765] = {.lex_state = 0},
  [766] = {.lex_state = 0},
  [767] = {.lex_state = 0},
  [768] = {.lex_state = 15},
  [769] = {.lex_state = 15},
  [770] = {.lex_state = 0},
  [771] = {.lex_state = 0},
  [772] = {.lex_state = 0},
  [773] = {.lex_state = 0},
  [774] = {.lex_state = 0},
  [775] = {.lex_state = 0},
  [776] = {.lex_state = 0},
  [777] = {.lex_state = 0},
  [778] = {.lex_state = 0},
  [779] = {.lex_state = 0},
  [780] = {.lex_state = 0},
  [781] = {.lex_state = 0},
  [782] = {.lex_state = 0},
  [783] = {.lex_state = 0},
  [784] = {.lex_state = 0},
  [785] = {.lex_state = 0},
  [786] = {.lex_state = 0},
  [787] = {.lex_state = 0},
  [788] = {.lex_state = 14},
  [789] = {.lex_state = 0},
  [790] = {.lex_state = 0},
  [791] = {.lex_state = 0},
  [792] = {.lex_state = 0},
  [793] = {.lex_state = 0},
  [794] = {.lex_state = 0},
  [795] = {.lex_state = 0},
  [796] = {.lex_state = 0},
  [797] = {.lex_state = 0},
  [798] = {.lex_state = 0},
  [799] = {.lex_state = 0},
  [800] = {.lex_state = 0},
  [801] = {.lex_state = 0},
  [802] = {.lex_state = 0},
  [803] = {.lex_state = 0},
  [804] = {.lex_state = 0},
  [805] = {.lex_state = 0},
  [806] = {.lex_state = 0},
  [807] = {.lex_state = 0},
  [808] = {.lex_state = 0},
  [809] = {.lex_state = 0},
  [810] = {.lex_state = 0},
  [811] = {.lex_state = 0},
  [812] = {.lex_state = 0},
  [813] = {.lex_state = 0},
  [814] = {.lex_state = 0},
  [815] = {.lex_state = 0},
  [816] = {.lex_state = 0},
  [817] = {.lex_state = 0},
  [818] = {.lex_state = 0},
  [819] = {.lex_state = 0},
  [820] = {.lex_state = 0},
  [821] = {.lex_state = 0},
  [822] = {.lex_state = 0},
  [823] = {.lex_state = 0},
  [824] = {.lex_state = 0},
  [825] = {.lex_state = 0},
  [826] = {.lex_state = 0},
  [827] = {.lex_state = 0},
  [828] = {.lex_state = 0},
  [829] = {.lex_state = 0},
  [830] = {.lex_state = 0},
  [831] = {.lex_state = 0},
  [832] = {.lex_state = 0},
  [833] = {.lex_state = 0},
  [834] = {.lex_state = 0},
  [835] = {.lex_state = 0},
  [836] = {.lex_state = 0},
  [837] = {.lex_state = 0},
  [838] = {.lex_state = 0},
  [839] = {.lex_state = 11},
  [840] = {.lex_state = 0},
  [841] = {.lex_state = 0},
  [842] = {.lex_state = 0},
  [843] = {.lex_state = 0},
  [844] = {.lex_state = 0},
  [845] = {.lex_state = 0},
  [846] = {.lex_state = 0},
  [847] = {.lex_state = 0},
  [848] = {.lex_state = 0},
  [849] = {.lex_state = 0},
  [850] = {.lex_state = 0},
  [851] = {.lex_state = 0},
  [852] = {.lex_state = 0},
  [853] = {.lex_state = 0},
  [854] = {.lex_state = 0},
  [855] = {.lex_state = 0},
  [856] = {.lex_state = 3},
  [857] = {.lex_state = 0},
  [858] = {.lex_state = 0},
  [859] = {.lex_state = 0},
  [860] = {.lex_state = 0},
  [861] = {.lex_state = 0},
  [862] = {.lex_state = 0},
  [863] = {.lex_state = 0},
  [864] = {.lex_state = 0},
  [865] = {.lex_state = 0},
  [866] = {.lex_state = 0},
  [867] = {.lex_state = 0},
  [868] = {.lex_state = 0},
  [869] = {.lex_state = 0},
  [870] = {.lex_state = 0},
  [871] = {.lex_state = 0},
  [872] = {.lex_state = 0},
  [873] = {.lex_state = 0},
  [874] = {.lex_state = 0},
  [875] = {.lex_state = 0},
  [876] = {.lex_state = 0},
  [877] = {.lex_state = 0},
  [878] = {.lex_state = 0},
  [879] = {.lex_state = 0},
  [880] = {.lex_state = 0},
  [881] = {.lex_state = 0},
  [882] = {.lex_state = 0},
  [883] = {.lex_state = 0},
  [884] = {.lex_state = 0},
  [885] = {.lex_state = 0},
  [886] = {.lex_state = 0},
  [887] = {.lex_state = 0},
  [888] = {.lex_state = 0},
  [889] = {.lex_state = 0},
  [890] = {.lex_state = 0},
  [891] = {.lex_state = 0},
  [892] = {.lex_state = 0},
  [893] = {.lex_state = 0},
  [894] = {.lex_state = 0},
  [895] = {.lex_state = 0},
  [896] = {.lex_state = 0},
  [897] = {.lex_state = 0},
  [898] = {.lex_state = 0},
  [899] = {.lex_state = 0},
  [900] = {.lex_state = 0},
  [901] = {.lex_state = 0},
  [902] = {.lex_state = 0},
  [903] = {.lex_state = 0},
  [904] = {.lex_state = 0},
  [905] = {.lex_state = 0},
  [906] = {.lex_state = 0},
  [907] = {.lex_state = 0},
  [908] = {.lex_state = 0},
  [909] = {.lex_state = 0},
  [910] = {.lex_state = 0},
  [911] = {.lex_state = 3},
  [912] = {.lex_state = 0},
  [913] = {.lex_state = 0},
  [914] = {.lex_state = 0},
  [915] = {.lex_state = 0},
  [916] = {.lex_state = 0},
  [917] = {.lex_state = 0},
  [918] = {.lex_state = 0},
  [919] = {.lex_state = 0},
  [920] = {.lex_state = 0},
  [921] = {.lex_state = 0},
  [922] = {.lex_state = 0},
  [923] = {.lex_state = 0},
  [924] = {.lex_state = 0},
  [925] = {.lex_state = 0},
  [926] = {.lex_state = 0},
  [927] = {.lex_state = 0},
  [928] = {.lex_state = 0},
  [929] = {.lex_state = 0},
  [930] = {.lex_state = 0},
  [931] = {.lex_state = 0},
  [932] = {.lex_state = 0},
  [933] = {.lex_state = 0},
  [934] = {.lex_state = 5},
  [935] = {.lex_state = 0},
  [936] = {.lex_state = 0},
  [937] = {.lex_state = 0},
  [938] = {.lex_state = 0},
  [939] = {.lex_state = 0},
  [940] = {.lex_state = 0},
  [941] = {.lex_state = 0},
  [942] = {.lex_state = 0},
  [943] = {.lex_state = 0},
  [944] = {.lex_state = 0},
  [945] = {.lex_state = 0},
  [946] = {.lex_state = 0},
  [947] = {.lex_state = 0},
  [948] = {.lex_state = 0},
  [949] = {.lex_state = 0},
  [950] = {.lex_state = 0},
  [951] = {.lex_state = 0},
  [952] = {.lex_state = 0},
  [953] = {.lex_state = 0},
  [954] = {.lex_state = 0},
  [955] = {.lex_state = 11},
  [956] = {.lex_state = 0},
  [957] = {.lex_state = 0},
  [958] = {.lex_state = 11},
  [959] = {.lex_state = 0},
  [960] = {.lex_state = 0},
  [961] = {.lex_state = 0},
  [962] = {.lex_state = 0},
  [963] = {.lex_state = 0},
  [964] = {.lex_state = 11},
  [965] = {(TSStateId)(-1)},
  [966] = {(TSStateId)(-1)},
  [967] = {(TSStateId)(-1)},
  [968] = {(TSStateId)(-1)},
  [969] = {(TSStateId)(-1)},
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_annotation] = STATE(0),
    [sym_comment_block] = STATE(0),
    [sym_comment_line] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_align] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [sym_align_offset_value] = ACTIONS(1),
    [anon_sym_LPAREN_AT] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_block] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_loop] = ACTIONS(1),
    [anon_sym_LPAREN_SEMI] = ACTIONS(5),
    [anon_sym_SEMI_RPAREN] = ACTIONS(1),
    [aux_sym_comment_line_token1] = ACTIONS(7),
    [sym_dec_nat] = ACTIONS(1),
    [anon_sym_item] = ACTIONS(1),
    [anon_sym_func] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_memory] = ACTIONS(1),
    [anon_sym_table] = ACTIONS(1),
    [anon_sym_call_indirect] = ACTIONS(1),
    [anon_sym_inf] = ACTIONS(1),
    [anon_sym_local] = ACTIONS(1),
    [anon_sym_param] = ACTIONS(1),
    [anon_sym_result] = ACTIONS(1),
    [anon_sym_mut] = ACTIONS(1),
    [sym_hex_float] = ACTIONS(1),
    [sym_hex_nat] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_br_table] = ACTIONS(1),
    [anon_sym_ref_DOTextern] = ACTIONS(1),
    [anon_sym_ref_DOTnull] = ACTIONS(1),
    [sym_op_index] = ACTIONS(1),
    [sym_op_index_opt] = ACTIONS(1),
    [sym_op_simd_offset_opt_align_opt] = ACTIONS(1),
    [aux_sym_op_const_token1] = ACTIONS(1),
    [aux_sym_op_const_token2] = ACTIONS(1),
    [anon_sym_func_DOTbind] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_select] = ACTIONS(1),
    [anon_sym_v128_DOTconst] = ACTIONS(1),
    [anon_sym_f32x4] = ACTIONS(1),
    [anon_sym_f64x2] = ACTIONS(1),
    [anon_sym_i8x16] = ACTIONS(1),
    [anon_sym_i16x8] = ACTIONS(1),
    [anon_sym_i32x4] = ACTIONS(1),
    [anon_sym_i64x2] = ACTIONS(1),
    [anon_sym_DOTshuffle] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_extract_lane] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [aux_sym_op_simd_lane_token1] = ACTIONS(1),
    [anon_sym_replace_lane] = ACTIONS(1),
    [anon_sym_table_DOTcopy] = ACTIONS(1),
    [anon_sym_table_DOTinit] = ACTIONS(1),
    [anon_sym_data] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_elem] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_start] = ACTIONS(1),
    [sym_nan] = ACTIONS(1),
    [anon_sym_f32] = ACTIONS(1),
    [anon_sym_f64] = ACTIONS(1),
    [anon_sym_i32] = ACTIONS(1),
    [anon_sym_i64] = ACTIONS(1),
    [sym_num_type_v128] = ACTIONS(1),
    [anon_sym_offset] = ACTIONS(1),
    [sym_ref_kind] = ACTIONS(1),
    [anon_sym_ref] = ACTIONS(1),
    [anon_sym_null] = ACTIONS(1),
    [sym_share] = ACTIONS(1),
    [sym_sign] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_invoke] = ACTIONS(1),
    [anon_sym_assert_exhaustion] = ACTIONS(1),
    [anon_sym_assert_invalid] = ACTIONS(1),
    [anon_sym_assert_malformed] = ACTIONS(1),
    [anon_sym_assert_return] = ACTIONS(1),
    [anon_sym_assert_return_arithmetic_nan] = ACTIONS(1),
    [anon_sym_assert_return_canonical_nan] = ACTIONS(1),
    [anon_sym_assert_trap] = ACTIONS(1),
    [anon_sym_assert_unlinkable] = ACTIONS(1),
    [sym_literal_nan_arithmetic] = ACTIONS(1),
    [sym_literal_nan_canonical] = ACTIONS(1),
    [anon_sym_input] = ACTIONS(1),
    [anon_sym_output] = ACTIONS(1),
    [anon_sym_script] = ACTIONS(1),
    [anon_sym_register] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [sym_result_ref_func] = ACTIONS(1),
    [anon_sym_binary] = ACTIONS(1),
    [anon_sym_quote] = ACTIONS(1),
  },
  [1] = {
    [sym_ROOT] = STATE(898),
    [sym_annotation] = STATE(1),
    [sym_comment_block] = STATE(1),
    [sym_comment_line] = STATE(1),
    [sym_module] = STATE(569),
    [sym_module_field] = STATE(680),
    [sym_module_field_data] = STATE(686),
    [sym_module_field_elem] = STATE(686),
    [sym_module_field_export] = STATE(686),
    [sym_module_field_func] = STATE(686),
    [sym_module_field_global] = STATE(686),
    [sym_module_field_import] = STATE(686),
    [sym_module_field_memory] = STATE(686),
    [sym_module_field_start] = STATE(686),
    [sym_module_field_table] = STATE(686),
    [sym_module_field_type] = STATE(686),
    [sym_action] = STATE(687),
    [sym_action_get] = STATE(565),
    [sym_action_invoke] = STATE(565),
    [sym_assert_exhaustion] = STATE(692),
    [sym_assert_invalid] = STATE(692),
    [sym_assert_malformed] = STATE(692),
    [sym_assert_return] = STATE(692),
    [sym_assert_return_arithmetic_nan] = STATE(692),
    [sym_assert_return_canonical_nan] = STATE(692),
    [sym_assert_trap_action] = STATE(692),
    [sym_assert_trap_module] = STATE(692),
    [sym_assert_unlinkable] = STATE(692),
    [sym_assertion] = STATE(687),
    [sym_command] = STATE(699),
    [sym_meta] = STATE(687),
    [sym_meta_input] = STATE(703),
    [sym_meta_output] = STATE(703),
    [sym_meta_script] = STATE(703),
    [sym_register] = STATE(687),
    [sym_script_module] = STATE(687),
    [sym_script_module_binary] = STATE(569),
    [sym_script_module_quote] = STATE(569),
    [aux_sym_ROOT_repeat1] = STATE(321),
    [aux_sym_ROOT_repeat2] = STATE(362),
    [ts_builtin_sym_end] = ACTIONS(9),
    [anon_sym_LPAREN_AT] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_SEMI] = ACTIONS(5),
    [aux_sym_comment_line_token1] = ACTIONS(7),
  },
  [2] = {
    [sym_annotation] = STATE(2),
    [sym_block_block] = STATE(289),
    [sym_block_if] = STATE(289),
    [sym_block_loop] = STATE(289),
    [sym_comment_block] = STATE(2),
    [sym_comment_line] = STATE(2),
    [sym_export] = STATE(213),
    [sym_expr] = STATE(290),
    [sym_func_locals] = STATE(292),
    [sym_func_locals_many] = STATE(295),
    [sym_func_locals_one] = STATE(295),
    [sym_func_type_params] = STATE(296),
    [sym_func_type_params_many] = STATE(297),
    [sym_func_type_params_one] = STATE(297),
    [sym_func_type_results] = STATE(298),
    [sym_import] = STATE(7),
    [sym_instr] = STATE(300),
    [sym_instr_block] = STATE(290),
    [sym_instr_call] = STATE(290),
    [sym_instr_list] = STATE(823),
    [sym_instr_list_call] = STATE(300),
    [sym_instr_plain] = STATE(290),
    [sym_op_const] = STATE(281),
    [sym_op_func_bind] = STATE(281),
    [sym_op_let] = STATE(281),
    [sym_op_select] = STATE(281),
    [sym_op_simd_const] = STATE(281),
    [sym_op_simd_lane] = STATE(281),
    [sym_op_table_copy] = STATE(281),
    [sym_op_table_init] = STATE(281),
    [sym_type_use] = STATE(14),
    [aux_sym_block_block_repeat2] = STATE(26),
    [aux_sym_instr_list_repeat1] = STATE(106),
    [aux_sym_op_let_repeat1] = STATE(12),
    [aux_sym_op_let_repeat2] = STATE(49),
    [aux_sym_module_field_func_repeat1] = STATE(5),
    [anon_sym_LPAREN_AT] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_block] = ACTIONS(17),
    [anon_sym_if] = ACTIONS(19),
    [anon_sym_loop] = ACTIONS(21),
    [anon_sym_LPAREN_SEMI] = ACTIONS(5),
    [aux_sym_comment_line_token1] = ACTIONS(7),
    [anon_sym_call_indirect] = ACTIONS(23),
    [sym_identifier] = ACTIONS(25),
    [anon_sym_br_table] = ACTIONS(27),
    [anon_sym_ref_DOTextern] = ACTIONS(29),
    [anon_sym_ref_DOTnull] = ACTIONS(31),
    [sym_op_nullary] = ACTIONS(33),
    [sym_op_index] = ACTIONS(35),
    [sym_op_index_opt] = ACTIONS(37),
    [sym_op_index_opt_offset_opt_align_opt] = ACTIONS(39),
    [sym_op_simd_offset_opt_align_opt] = ACTIONS(41),
    [aux_sym_op_const_token1] = ACTIONS(43),
    [aux_sym_op_const_token2] = ACTIONS(45),
    [anon_sym_func_DOTbind] = ACTIONS(47),
    [anon_sym_let] = ACTIONS(49),
    [anon_sym_select] = ACTIONS(51),
    [anon_sym_v128_DOTconst] = ACTIONS(53),
    [anon_sym_f32x4] = ACTIONS(55),
    [anon_sym_f64x2] = ACTIONS(55),
    [anon_sym_i8x16] = ACTIONS(57),
    [anon_sym_i16x8] = ACTIONS(59),
    [anon_sym_i32x4] = ACTIONS(55),
    [anon_sym_i64x2] = ACTIONS(55),
    [anon_sym_table_DOTcopy] = ACTIONS(61),
    [anon_sym_table_DOTinit] = ACTIONS(63),
  },
  [3] = {
    [sym_annotation] = STATE(3),
    [sym_block_block] = STATE(289),
    [sym_block_if] = STATE(289),
    [sym_block_loop] = STATE(289),
    [sym_comment_block] = STATE(3),
    [sym_comment_line] = STATE(3),
    [sym_export] = STATE(213),
    [sym_expr] = STATE(290),
    [sym_func_locals] = STATE(292),
    [sym_func_locals_many] = STATE(295),
    [sym_func_locals_one] = STATE(295),
    [sym_func_type_params] = STATE(296),
    [sym_func_type_params_many] = STATE(297),
    [sym_func_type_params_one] = STATE(297),
    [sym_func_type_results] = STATE(298),
    [sym_import] = STATE(8),
    [sym_instr] = STATE(300),
    [sym_instr_block] = STATE(290),
    [sym_instr_call] = STATE(290),
    [sym_instr_list] = STATE(945),
    [sym_instr_list_call] = STATE(300),
    [sym_instr_plain] = STATE(290),
    [sym_op_const] = STATE(281),
    [sym_op_func_bind] = STATE(281),
    [sym_op_let] = STATE(281),
    [sym_op_select] = STATE(281),
    [sym_op_simd_const] = STATE(281),
    [sym_op_simd_lane] = STATE(281),
    [sym_op_table_copy] = STATE(281),
    [sym_op_table_init] = STATE(281),
    [sym_type_use] = STATE(15),
    [aux_sym_block_block_repeat2] = STATE(27),
    [aux_sym_instr_list_repeat1] = STATE(106),
    [aux_sym_op_let_repeat1] = STATE(20),
    [aux_sym_op_let_repeat2] = STATE(57),
    [aux_sym_module_field_func_repeat1] = STATE(207),
    [anon_sym_LPAREN_AT] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(65),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_block] = ACTIONS(17),
    [anon_sym_if] = ACTIONS(19),
    [anon_sym_loop] = ACTIONS(21),
    [anon_sym_LPAREN_SEMI] = ACTIONS(5),
    [aux_sym_comment_line_token1] = ACTIONS(7),
    [anon_sym_call_indirect] = ACTIONS(23),
    [anon_sym_br_table] = ACTIONS(27),
    [anon_sym_ref_DOTextern] = ACTIONS(29),
    [anon_sym_ref_DOTnull] = ACTIONS(31),
    [sym_op_nullary] = ACTIONS(33),
    [sym_op_index] = ACTIONS(35),
    [sym_op_index_opt] = ACTIONS(37),
    [sym_op_index_opt_offset_opt_align_opt] = ACTIONS(39),
    [sym_op_simd_offset_opt_align_opt] = ACTIONS(41),
    [aux_sym_op_const_token1] = ACTIONS(43),
    [aux_sym_op_const_token2] = ACTIONS(45),
    [anon_sym_func_DOTbind] = ACTIONS(47),
    [anon_sym_let] = ACTIONS(49),
    [anon_sym_select] = ACTIONS(51),
    [anon_sym_v128_DOTconst] = ACTIONS(53),
    [anon_sym_f32x4] = ACTIONS(55),
    [anon_sym_f64x2] = ACTIONS(55),
    [anon_sym_i8x16] = ACTIONS(57),
    [anon_sym_i16x8] = ACTIONS(59),
    [anon_sym_i32x4] = ACTIONS(55),
    [anon_sym_i64x2] = ACTIONS(55),
    [anon_sym_table_DOTcopy] = ACTIONS(61),
    [anon_sym_table_DOTinit] = ACTIONS(63),
  },
  [4] = {
    [sym_annotation] = STATE(4),
    [sym_block_block] = STATE(289),
    [sym_block_if] = STATE(289),
    [sym_block_loop] = STATE(289),
    [sym_comment_block] = STATE(4),
    [sym_comment_line] = STATE(4),
    [sym_export] = STATE(213),
    [sym_expr] = STATE(290),
    [sym_func_locals] = STATE(292),
    [sym_func_locals_many] = STATE(295),
    [sym_func_locals_one] = STATE(295),
    [sym_func_type_params] = STATE(296),
    [sym_func_type_params_many] = STATE(297),
    [sym_func_type_params_one] = STATE(297),
    [sym_func_type_results] = STATE(298),
    [sym_import] = STATE(6),
    [sym_instr] = STATE(300),
    [sym_instr_block] = STATE(290),
    [sym_instr_call] = STATE(290),
    [sym_instr_list] = STATE(901),
    [sym_instr_list_call] = STATE(300),
    [sym_instr_plain] = STATE(290),
    [sym_op_const] = STATE(281),
    [sym_op_func_bind] = STATE(281),
    [sym_op_let] = STATE(281),
    [sym_op_select] = STATE(281),
    [sym_op_simd_const] = STATE(281),
    [sym_op_simd_lane] = STATE(281),
    [sym_op_table_copy] = STATE(281),
    [sym_op_table_init] = STATE(281),
    [sym_type_use] = STATE(10),
    [aux_sym_block_block_repeat2] = STATE(29),
    [aux_sym_instr_list_repeat1] = STATE(106),
    [aux_sym_op_let_repeat1] = STATE(22),
    [aux_sym_op_let_repeat2] = STATE(58),
    [aux_sym_module_field_func_repeat1] = STATE(3),
    [anon_sym_LPAREN_AT] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_block] = ACTIONS(17),
    [anon_sym_if] = ACTIONS(19),
    [anon_sym_loop] = ACTIONS(21),
    [anon_sym_LPAREN_SEMI] = ACTIONS(5),
    [aux_sym_comment_line_token1] = ACTIONS(7),
    [anon_sym_call_indirect] = ACTIONS(23),
    [anon_sym_br_table] = ACTIONS(27),
    [anon_sym_ref_DOTextern] = ACTIONS(29),
    [anon_sym_ref_DOTnull] = ACTIONS(31),
    [sym_op_nullary] = ACTIONS(33),
    [sym_op_index] = ACTIONS(35),
    [sym_op_index_opt] = ACTIONS(37),
    [sym_op_index_opt_offset_opt_align_opt] = ACTIONS(39),
    [sym_op_simd_offset_opt_align_opt] = ACTIONS(41),
    [aux_sym_op_const_token1] = ACTIONS(43),
    [aux_sym_op_const_token2] = ACTIONS(45),
    [anon_sym_func_DOTbind] = ACTIONS(47),
    [anon_sym_let] = ACTIONS(49),
    [anon_sym_select] = ACTIONS(51),
    [anon_sym_v128_DOTconst] = ACTIONS(53),
    [anon_sym_f32x4] = ACTIONS(55),
    [anon_sym_f64x2] = ACTIONS(55),
    [anon_sym_i8x16] = ACTIONS(57),
    [anon_sym_i16x8] = ACTIONS(59),
    [anon_sym_i32x4] = ACTIONS(55),
    [anon_sym_i64x2] = ACTIONS(55),
    [anon_sym_table_DOTcopy] = ACTIONS(61),
    [anon_sym_table_DOTinit] = ACTIONS(63),
  },
  [5] = {
    [sym_annotation] = STATE(5),
    [sym_block_block] = STATE(289),
    [sym_block_if] = STATE(289),
    [sym_block_loop] = STATE(289),
    [sym_comment_block] = STATE(5),
    [sym_comment_line] = STATE(5),
    [sym_export] = STATE(213),
    [sym_expr] = STATE(290),
    [sym_func_locals] = STATE(292),
    [sym_func_locals_many] = STATE(295),
    [sym_func_locals_one] = STATE(295),
    [sym_func_type_params] = STATE(296),
    [sym_func_type_params_many] = STATE(297),
    [sym_func_type_params_one] = STATE(297),
    [sym_func_type_results] = STATE(298),
    [sym_import] = STATE(9),
    [sym_instr] = STATE(300),
    [sym_instr_block] = STATE(290),
    [sym_instr_call] = STATE(290),
    [sym_instr_list] = STATE(838),
    [sym_instr_list_call] = STATE(300),
    [sym_instr_plain] = STATE(290),
    [sym_op_const] = STATE(281),
    [sym_op_func_bind] = STATE(281),
    [sym_op_let] = STATE(281),
    [sym_op_select] = STATE(281),
    [sym_op_simd_const] = STATE(281),
    [sym_op_simd_lane] = STATE(281),
    [sym_op_table_copy] = STATE(281),
    [sym_op_table_init] = STATE(281),
    [sym_type_use] = STATE(17),
    [aux_sym_block_block_repeat2] = STATE(28),
    [aux_sym_instr_list_repeat1] = STATE(106),
    [aux_sym_op_let_repeat1] = STATE(23),
    [aux_sym_op_let_repeat2] = STATE(74),
    [aux_sym_module_field_func_repeat1] = STATE(207),
    [anon_sym_LPAREN_AT] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(69),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_block] = ACTIONS(17),
    [anon_sym_if] = ACTIONS(19),
    [anon_sym_loop] = ACTIONS(21),
    [anon_sym_LPAREN_SEMI] = ACTIONS(5),
    [aux_sym_comment_line_token1] = ACTIONS(7),
    [anon_sym_call_indirect] = ACTIONS(23),
    [anon_sym_br_table] = ACTIONS(27),
    [anon_sym_ref_DOTextern] = ACTIONS(29),
    [anon_sym_ref_DOTnull] = ACTIONS(31),
    [sym_op_nullary] = ACTIONS(33),
    [sym_op_index] = ACTIONS(35),
    [sym_op_index_opt] = ACTIONS(37),
    [sym_op_index_opt_offset_opt_align_opt] = ACTIONS(39),
    [sym_op_simd_offset_opt_align_opt] = ACTIONS(41),
    [aux_sym_op_const_token1] = ACTIONS(43),
    [aux_sym_op_const_token2] = ACTIONS(45),
    [anon_sym_func_DOTbind] = ACTIONS(47),
    [anon_sym_let] = ACTIONS(49),
    [anon_sym_select] = ACTIONS(51),
    [anon_sym_v128_DOTconst] = ACTIONS(53),
    [anon_sym_f32x4] = ACTIONS(55),
    [anon_sym_f64x2] = ACTIONS(55),
    [anon_sym_i8x16] = ACTIONS(57),
    [anon_sym_i16x8] = ACTIONS(59),
    [anon_sym_i32x4] = ACTIONS(55),
    [anon_sym_i64x2] = ACTIONS(55),
    [anon_sym_table_DOTcopy] = ACTIONS(61),
    [anon_sym_table_DOTinit] = ACTIONS(63),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 44,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(65), 1,
      anon_sym_RPAREN,
    ACTIONS(71), 1,
      anon_sym_LPAREN,
    STATE(15), 1,
      sym_type_use,
    STATE(20), 1,
      aux_sym_op_let_repeat1,
    STATE(27), 1,
      aux_sym_block_block_repeat2,
    STATE(57), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(292), 1,
      sym_func_locals,
    STATE(296), 1,
      sym_func_type_params,
    STATE(298), 1,
      sym_func_type_results,
    STATE(945), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(6), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [153] = 44,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(69), 1,
      anon_sym_RPAREN,
    ACTIONS(71), 1,
      anon_sym_LPAREN,
    STATE(17), 1,
      sym_type_use,
    STATE(23), 1,
      aux_sym_op_let_repeat1,
    STATE(28), 1,
      aux_sym_block_block_repeat2,
    STATE(74), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(292), 1,
      sym_func_locals,
    STATE(296), 1,
      sym_func_type_params,
    STATE(298), 1,
      sym_func_type_results,
    STATE(838), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(7), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [306] = 44,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(71), 1,
      anon_sym_LPAREN,
    ACTIONS(73), 1,
      anon_sym_RPAREN,
    STATE(19), 1,
      aux_sym_op_let_repeat1,
    STATE(21), 1,
      sym_type_use,
    STATE(34), 1,
      aux_sym_block_block_repeat2,
    STATE(78), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(292), 1,
      sym_func_locals,
    STATE(296), 1,
      sym_func_type_params,
    STATE(298), 1,
      sym_func_type_results,
    STATE(952), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(8), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [459] = 44,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(71), 1,
      anon_sym_LPAREN,
    ACTIONS(75), 1,
      anon_sym_RPAREN,
    STATE(11), 1,
      sym_type_use,
    STATE(16), 1,
      aux_sym_op_let_repeat1,
    STATE(31), 1,
      aux_sym_block_block_repeat2,
    STATE(61), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(292), 1,
      sym_func_locals,
    STATE(296), 1,
      sym_func_type_params,
    STATE(298), 1,
      sym_func_type_results,
    STATE(926), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(9), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [612] = 43,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(65), 1,
      anon_sym_RPAREN,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    STATE(20), 1,
      aux_sym_op_let_repeat1,
    STATE(27), 1,
      aux_sym_block_block_repeat2,
    STATE(57), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(292), 1,
      sym_func_locals,
    STATE(296), 1,
      sym_func_type_params,
    STATE(298), 1,
      sym_func_type_results,
    STATE(945), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(10), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [762] = 43,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(79), 1,
      anon_sym_RPAREN,
    STATE(18), 1,
      aux_sym_op_let_repeat1,
    STATE(30), 1,
      aux_sym_block_block_repeat2,
    STATE(75), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(292), 1,
      sym_func_locals,
    STATE(296), 1,
      sym_func_type_params,
    STATE(298), 1,
      sym_func_type_results,
    STATE(933), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(11), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [912] = 43,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(69), 1,
      anon_sym_RPAREN,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    STATE(28), 1,
      aux_sym_block_block_repeat2,
    STATE(74), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(204), 1,
      aux_sym_op_let_repeat1,
    STATE(292), 1,
      sym_func_locals,
    STATE(296), 1,
      sym_func_type_params,
    STATE(298), 1,
      sym_func_type_results,
    STATE(838), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(12), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [1062] = 43,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(81), 1,
      anon_sym_RPAREN,
    STATE(33), 1,
      aux_sym_block_block_repeat2,
    STATE(81), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(204), 1,
      aux_sym_op_let_repeat1,
    STATE(292), 1,
      sym_func_locals,
    STATE(296), 1,
      sym_func_type_params,
    STATE(298), 1,
      sym_func_type_results,
    STATE(808), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(13), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [1212] = 43,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(69), 1,
      anon_sym_RPAREN,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    STATE(23), 1,
      aux_sym_op_let_repeat1,
    STATE(28), 1,
      aux_sym_block_block_repeat2,
    STATE(74), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(292), 1,
      sym_func_locals,
    STATE(296), 1,
      sym_func_type_params,
    STATE(298), 1,
      sym_func_type_results,
    STATE(838), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(14), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [1362] = 43,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(73), 1,
      anon_sym_RPAREN,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    STATE(19), 1,
      aux_sym_op_let_repeat1,
    STATE(34), 1,
      aux_sym_block_block_repeat2,
    STATE(78), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(292), 1,
      sym_func_locals,
    STATE(296), 1,
      sym_func_type_params,
    STATE(298), 1,
      sym_func_type_results,
    STATE(952), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(15), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [1512] = 43,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(79), 1,
      anon_sym_RPAREN,
    STATE(30), 1,
      aux_sym_block_block_repeat2,
    STATE(75), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(204), 1,
      aux_sym_op_let_repeat1,
    STATE(292), 1,
      sym_func_locals,
    STATE(296), 1,
      sym_func_type_params,
    STATE(298), 1,
      sym_func_type_results,
    STATE(933), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(16), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [1662] = 43,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(75), 1,
      anon_sym_RPAREN,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    STATE(16), 1,
      aux_sym_op_let_repeat1,
    STATE(31), 1,
      aux_sym_block_block_repeat2,
    STATE(61), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(292), 1,
      sym_func_locals,
    STATE(296), 1,
      sym_func_type_params,
    STATE(298), 1,
      sym_func_type_results,
    STATE(926), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(17), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [1812] = 43,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(83), 1,
      anon_sym_RPAREN,
    STATE(25), 1,
      aux_sym_block_block_repeat2,
    STATE(69), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(204), 1,
      aux_sym_op_let_repeat1,
    STATE(292), 1,
      sym_func_locals,
    STATE(296), 1,
      sym_func_type_params,
    STATE(298), 1,
      sym_func_type_results,
    STATE(778), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(18), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [1962] = 43,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(85), 1,
      anon_sym_RPAREN,
    STATE(39), 1,
      aux_sym_block_block_repeat2,
    STATE(67), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(204), 1,
      aux_sym_op_let_repeat1,
    STATE(292), 1,
      sym_func_locals,
    STATE(296), 1,
      sym_func_type_params,
    STATE(298), 1,
      sym_func_type_results,
    STATE(815), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(19), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [2112] = 43,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(73), 1,
      anon_sym_RPAREN,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    STATE(34), 1,
      aux_sym_block_block_repeat2,
    STATE(78), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(204), 1,
      aux_sym_op_let_repeat1,
    STATE(292), 1,
      sym_func_locals,
    STATE(296), 1,
      sym_func_type_params,
    STATE(298), 1,
      sym_func_type_results,
    STATE(952), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(20), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [2262] = 43,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    ACTIONS(85), 1,
      anon_sym_RPAREN,
    STATE(13), 1,
      aux_sym_op_let_repeat1,
    STATE(39), 1,
      aux_sym_block_block_repeat2,
    STATE(67), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(292), 1,
      sym_func_locals,
    STATE(296), 1,
      sym_func_type_params,
    STATE(298), 1,
      sym_func_type_results,
    STATE(815), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(21), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [2412] = 43,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(65), 1,
      anon_sym_RPAREN,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    STATE(27), 1,
      aux_sym_block_block_repeat2,
    STATE(57), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(204), 1,
      aux_sym_op_let_repeat1,
    STATE(292), 1,
      sym_func_locals,
    STATE(296), 1,
      sym_func_type_params,
    STATE(298), 1,
      sym_func_type_results,
    STATE(945), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(22), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [2562] = 43,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(75), 1,
      anon_sym_RPAREN,
    ACTIONS(77), 1,
      anon_sym_LPAREN,
    STATE(31), 1,
      aux_sym_block_block_repeat2,
    STATE(61), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(204), 1,
      aux_sym_op_let_repeat1,
    STATE(292), 1,
      sym_func_locals,
    STATE(296), 1,
      sym_func_type_params,
    STATE(298), 1,
      sym_func_type_results,
    STATE(926), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(23), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [2712] = 42,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(87), 1,
      anon_sym_LPAREN,
    ACTIONS(89), 1,
      anon_sym_end,
    ACTIONS(91), 1,
      anon_sym_else,
    ACTIONS(93), 1,
      sym_identifier,
    STATE(40), 1,
      sym_type_use,
    STATE(42), 1,
      aux_sym_block_block_repeat1,
    STATE(83), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(751), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(24), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [2857] = 40,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(95), 1,
      anon_sym_RPAREN,
    ACTIONS(97), 1,
      anon_sym_LPAREN,
    STATE(73), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(298), 1,
      sym_func_type_results,
    STATE(817), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(25), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [2997] = 40,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(69), 1,
      anon_sym_RPAREN,
    ACTIONS(97), 1,
      anon_sym_LPAREN,
    STATE(74), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(298), 1,
      sym_func_type_results,
    STATE(838), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(26), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [3137] = 40,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(73), 1,
      anon_sym_RPAREN,
    ACTIONS(97), 1,
      anon_sym_LPAREN,
    STATE(78), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(298), 1,
      sym_func_type_results,
    STATE(952), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(27), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [3277] = 40,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(75), 1,
      anon_sym_RPAREN,
    ACTIONS(97), 1,
      anon_sym_LPAREN,
    STATE(61), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(298), 1,
      sym_func_type_results,
    STATE(926), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(28), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [3417] = 40,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(65), 1,
      anon_sym_RPAREN,
    ACTIONS(97), 1,
      anon_sym_LPAREN,
    STATE(57), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(298), 1,
      sym_func_type_results,
    STATE(945), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(29), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [3557] = 40,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(83), 1,
      anon_sym_RPAREN,
    ACTIONS(97), 1,
      anon_sym_LPAREN,
    STATE(69), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(298), 1,
      sym_func_type_results,
    STATE(778), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(30), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [3697] = 40,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(79), 1,
      anon_sym_RPAREN,
    ACTIONS(97), 1,
      anon_sym_LPAREN,
    STATE(75), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(298), 1,
      sym_func_type_results,
    STATE(933), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(31), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [3837] = 41,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(87), 1,
      anon_sym_LPAREN,
    ACTIONS(99), 1,
      anon_sym_end,
    ACTIONS(101), 1,
      sym_identifier,
    STATE(52), 1,
      aux_sym_block_block_repeat1,
    STATE(56), 1,
      sym_type_use,
    STATE(102), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(931), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(32), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [3979] = 40,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(97), 1,
      anon_sym_LPAREN,
    ACTIONS(103), 1,
      anon_sym_RPAREN,
    STATE(68), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(298), 1,
      sym_func_type_results,
    STATE(852), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(33), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [4119] = 40,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(85), 1,
      anon_sym_RPAREN,
    ACTIONS(97), 1,
      anon_sym_LPAREN,
    STATE(67), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(298), 1,
      sym_func_type_results,
    STATE(815), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(34), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [4259] = 41,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(87), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_end,
    ACTIONS(107), 1,
      anon_sym_else,
    STATE(44), 1,
      sym_type_use,
    STATE(45), 1,
      aux_sym_block_block_repeat1,
    STATE(82), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(761), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(35), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [4401] = 41,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(87), 1,
      anon_sym_LPAREN,
    ACTIONS(109), 1,
      anon_sym_end,
    ACTIONS(111), 1,
      sym_identifier,
    STATE(59), 1,
      sym_type_use,
    STATE(62), 1,
      aux_sym_block_block_repeat1,
    STATE(97), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(904), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(36), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [4543] = 41,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(87), 1,
      anon_sym_LPAREN,
    ACTIONS(113), 1,
      anon_sym_RPAREN,
    ACTIONS(115), 1,
      sym_identifier,
    STATE(79), 1,
      sym_type_use,
    STATE(80), 1,
      aux_sym_block_block_repeat1,
    STATE(101), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(819), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(37), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [4685] = 41,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(87), 1,
      anon_sym_LPAREN,
    ACTIONS(117), 1,
      anon_sym_RPAREN,
    ACTIONS(119), 1,
      sym_identifier,
    STATE(53), 1,
      sym_type_use,
    STATE(77), 1,
      aux_sym_block_block_repeat1,
    STATE(104), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(885), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(38), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [4827] = 40,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(81), 1,
      anon_sym_RPAREN,
    ACTIONS(97), 1,
      anon_sym_LPAREN,
    STATE(81), 1,
      aux_sym_op_let_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(298), 1,
      sym_func_type_results,
    STATE(808), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(39), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [4967] = 40,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(105), 1,
      anon_sym_end,
    ACTIONS(107), 1,
      anon_sym_else,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    STATE(45), 1,
      aux_sym_block_block_repeat1,
    STATE(82), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(761), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(40), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [5106] = 40,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_end,
    ACTIONS(125), 1,
      anon_sym_else,
    STATE(88), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(211), 1,
      aux_sym_block_block_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(732), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(41), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [5245] = 40,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(105), 1,
      anon_sym_end,
    ACTIONS(107), 1,
      anon_sym_else,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    STATE(82), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(211), 1,
      aux_sym_block_block_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(761), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(42), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [5384] = 40,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(87), 1,
      anon_sym_LPAREN,
    ACTIONS(127), 1,
      anon_sym_RPAREN,
    STATE(70), 1,
      sym_type_use,
    STATE(71), 1,
      aux_sym_block_block_repeat1,
    STATE(100), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(870), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(43), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [5523] = 40,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(129), 1,
      anon_sym_end,
    ACTIONS(131), 1,
      anon_sym_else,
    STATE(41), 1,
      aux_sym_block_block_repeat1,
    STATE(86), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(774), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(44), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [5662] = 40,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(129), 1,
      anon_sym_end,
    ACTIONS(131), 1,
      anon_sym_else,
    STATE(86), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(211), 1,
      aux_sym_block_block_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(774), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(45), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [5801] = 40,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(87), 1,
      anon_sym_LPAREN,
    ACTIONS(133), 1,
      anon_sym_RPAREN,
    STATE(64), 1,
      sym_type_use,
    STATE(66), 1,
      aux_sym_block_block_repeat1,
    STATE(98), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(836), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(46), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [5940] = 40,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(87), 1,
      anon_sym_LPAREN,
    ACTIONS(135), 1,
      anon_sym_end,
    STATE(72), 1,
      aux_sym_block_block_repeat1,
    STATE(76), 1,
      sym_type_use,
    STATE(103), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(796), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(47), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [6079] = 40,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(87), 1,
      anon_sym_LPAREN,
    ACTIONS(137), 1,
      anon_sym_end,
    STATE(51), 1,
      sym_type_use,
    STATE(54), 1,
      aux_sym_block_block_repeat1,
    STATE(91), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(813), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(48), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [6218] = 38,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(69), 1,
      anon_sym_RPAREN,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(199), 1,
      aux_sym_op_let_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(838), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(49), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [6352] = 39,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(141), 1,
      anon_sym_end,
    STATE(92), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(211), 1,
      aux_sym_block_block_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(834), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(50), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [6488] = 39,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_end,
    STATE(55), 1,
      aux_sym_block_block_repeat1,
    STATE(93), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(963), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(51), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [6624] = 39,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(135), 1,
      anon_sym_end,
    STATE(103), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(211), 1,
      aux_sym_block_block_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(796), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(52), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [6760] = 39,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(127), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      aux_sym_block_block_repeat1,
    STATE(100), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(870), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(53), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [6896] = 39,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(143), 1,
      anon_sym_end,
    STATE(93), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(211), 1,
      aux_sym_block_block_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(963), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(54), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [7032] = 39,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(145), 1,
      anon_sym_end,
    STATE(94), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(211), 1,
      aux_sym_block_block_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(816), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(55), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [7168] = 39,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(135), 1,
      anon_sym_end,
    STATE(72), 1,
      aux_sym_block_block_repeat1,
    STATE(103), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(796), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(56), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [7304] = 38,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(73), 1,
      anon_sym_RPAREN,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(199), 1,
      aux_sym_op_let_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(952), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(57), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [7438] = 38,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(65), 1,
      anon_sym_RPAREN,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(199), 1,
      aux_sym_op_let_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(945), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(58), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [7572] = 39,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(137), 1,
      anon_sym_end,
    STATE(54), 1,
      aux_sym_block_block_repeat1,
    STATE(91), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(813), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(59), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [7708] = 39,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(147), 1,
      anon_sym_RPAREN,
    STATE(89), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(211), 1,
      aux_sym_block_block_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(791), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(60), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [7844] = 38,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(79), 1,
      anon_sym_RPAREN,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(199), 1,
      aux_sym_op_let_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(933), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(61), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [7978] = 39,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(137), 1,
      anon_sym_end,
    STATE(91), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(211), 1,
      aux_sym_block_block_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(813), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(62), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [8114] = 39,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(149), 1,
      anon_sym_RPAREN,
    STATE(99), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(211), 1,
      aux_sym_block_block_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(782), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(63), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [8250] = 39,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(151), 1,
      anon_sym_RPAREN,
    STATE(63), 1,
      aux_sym_block_block_repeat1,
    STATE(96), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(851), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(64), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [8386] = 38,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(87), 1,
      anon_sym_LPAREN,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    STATE(84), 1,
      sym_type_use,
    STATE(85), 1,
      aux_sym_block_block_repeat1,
    STATE(112), 1,
      aux_sym_block_block_repeat2,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(249), 1,
      sym_instr,
    STATE(298), 1,
      sym_func_type_results,
    ACTIONS(153), 3,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_else,
    STATE(65), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [8520] = 39,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(151), 1,
      anon_sym_RPAREN,
    STATE(96), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(211), 1,
      aux_sym_block_block_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(851), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(66), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [8656] = 38,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(81), 1,
      anon_sym_RPAREN,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(199), 1,
      aux_sym_op_let_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(808), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(67), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [8790] = 38,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(157), 1,
      anon_sym_RPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(199), 1,
      aux_sym_op_let_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(878), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(68), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [8924] = 38,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(95), 1,
      anon_sym_RPAREN,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(199), 1,
      aux_sym_op_let_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(817), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(69), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [9058] = 39,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(159), 1,
      anon_sym_RPAREN,
    STATE(60), 1,
      aux_sym_block_block_repeat1,
    STATE(95), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(841), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(70), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [9194] = 39,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(159), 1,
      anon_sym_RPAREN,
    STATE(95), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(211), 1,
      aux_sym_block_block_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(841), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(71), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [9330] = 39,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(161), 1,
      anon_sym_end,
    STATE(90), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(211), 1,
      aux_sym_block_block_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(936), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(72), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [9466] = 38,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    ACTIONS(163), 1,
      anon_sym_RPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(199), 1,
      aux_sym_op_let_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(858), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(73), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [9600] = 38,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(75), 1,
      anon_sym_RPAREN,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(199), 1,
      aux_sym_op_let_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(926), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(74), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [9734] = 38,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(83), 1,
      anon_sym_RPAREN,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(199), 1,
      aux_sym_op_let_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(778), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(75), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [9868] = 39,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(161), 1,
      anon_sym_end,
    STATE(50), 1,
      aux_sym_block_block_repeat1,
    STATE(90), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(936), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(76), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [10004] = 39,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(127), 1,
      anon_sym_RPAREN,
    STATE(100), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(211), 1,
      aux_sym_block_block_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(870), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(77), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [10140] = 38,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(85), 1,
      anon_sym_RPAREN,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(199), 1,
      aux_sym_op_let_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(815), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(78), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [10274] = 39,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(133), 1,
      anon_sym_RPAREN,
    STATE(66), 1,
      aux_sym_block_block_repeat1,
    STATE(98), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(836), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(79), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [10410] = 39,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(133), 1,
      anon_sym_RPAREN,
    STATE(98), 1,
      aux_sym_block_block_repeat2,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(211), 1,
      aux_sym_block_block_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(836), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(80), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [10546] = 38,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(103), 1,
      anon_sym_RPAREN,
    ACTIONS(139), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(199), 1,
      aux_sym_op_let_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(852), 1,
      sym_instr_list,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(81), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [10680] = 38,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(129), 1,
      anon_sym_end,
    ACTIONS(131), 1,
      anon_sym_else,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(774), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(82), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [10813] = 38,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(105), 1,
      anon_sym_end,
    ACTIONS(107), 1,
      anon_sym_else,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(761), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(83), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [10946] = 37,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    STATE(87), 1,
      aux_sym_block_block_repeat1,
    STATE(110), 1,
      aux_sym_block_block_repeat2,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(270), 1,
      sym_instr,
    STATE(298), 1,
      sym_func_type_results,
    ACTIONS(167), 3,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_else,
    STATE(84), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [11077] = 37,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    STATE(110), 1,
      aux_sym_block_block_repeat2,
    STATE(211), 1,
      aux_sym_block_block_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(270), 1,
      sym_instr,
    STATE(298), 1,
      sym_func_type_results,
    ACTIONS(167), 3,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_else,
    STATE(85), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [11208] = 38,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(123), 1,
      anon_sym_end,
    ACTIONS(125), 1,
      anon_sym_else,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(732), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(86), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [11341] = 37,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    STATE(114), 1,
      aux_sym_block_block_repeat2,
    STATE(211), 1,
      aux_sym_block_block_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(291), 1,
      sym_instr,
    STATE(298), 1,
      sym_func_type_results,
    ACTIONS(169), 3,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_else,
    STATE(87), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [11472] = 38,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    ACTIONS(171), 1,
      anon_sym_end,
    ACTIONS(173), 1,
      anon_sym_else,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(736), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(88), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [11605] = 37,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    ACTIONS(175), 1,
      anon_sym_RPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(840), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(89), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [11735] = 37,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(141), 1,
      anon_sym_end,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(834), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(90), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [11865] = 37,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(143), 1,
      anon_sym_end,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(963), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(91), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [11995] = 37,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    ACTIONS(177), 1,
      anon_sym_end,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(797), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(92), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [12125] = 37,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(145), 1,
      anon_sym_end,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(816), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(93), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [12255] = 37,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    ACTIONS(179), 1,
      anon_sym_end,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(806), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(94), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [12385] = 37,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(147), 1,
      anon_sym_RPAREN,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(791), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(95), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [12515] = 37,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(149), 1,
      anon_sym_RPAREN,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(782), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(96), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [12645] = 37,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(137), 1,
      anon_sym_end,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(813), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(97), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [12775] = 37,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(151), 1,
      anon_sym_RPAREN,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(851), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(98), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [12905] = 37,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    ACTIONS(181), 1,
      anon_sym_RPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(833), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(99), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [13035] = 37,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(159), 1,
      anon_sym_RPAREN,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(841), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(100), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [13165] = 37,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(133), 1,
      anon_sym_RPAREN,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(836), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(101), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [13295] = 37,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(135), 1,
      anon_sym_end,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(796), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(102), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [13425] = 37,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(161), 1,
      anon_sym_end,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(936), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(103), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [13555] = 37,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(127), 1,
      anon_sym_RPAREN,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(870), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(104), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [13685] = 36,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(129), 1,
      anon_sym_end,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(185), 1,
      sym_identifier,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(873), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(105), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [13812] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    STATE(111), 1,
      aux_sym_instr_list_repeat1,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    ACTIONS(187), 3,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_else,
    STATE(106), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [13935] = 37,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(87), 1,
      anon_sym_LPAREN,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    STATE(133), 1,
      aux_sym_block_block_repeat1,
    STATE(134), 1,
      sym_type_use,
    STATE(149), 1,
      aux_sym_block_block_repeat2,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(249), 1,
      sym_instr,
    STATE(298), 1,
      sym_func_type_results,
    STATE(107), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [14064] = 36,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(171), 1,
      anon_sym_end,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(189), 1,
      sym_identifier,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(800), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(108), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [14191] = 36,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(191), 1,
      anon_sym_end,
    ACTIONS(193), 1,
      sym_identifier,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(846), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(109), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [14318] = 35,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(291), 1,
      sym_instr,
    STATE(298), 1,
      sym_func_type_results,
    ACTIONS(169), 3,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_else,
    STATE(110), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [14443] = 33,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(197), 1,
      anon_sym_LPAREN,
    ACTIONS(200), 1,
      anon_sym_block,
    ACTIONS(203), 1,
      anon_sym_if,
    ACTIONS(206), 1,
      anon_sym_loop,
    ACTIONS(209), 1,
      anon_sym_call_indirect,
    ACTIONS(212), 1,
      anon_sym_br_table,
    ACTIONS(215), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(218), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(221), 1,
      sym_op_nullary,
    ACTIONS(224), 1,
      sym_op_index,
    ACTIONS(227), 1,
      sym_op_index_opt,
    ACTIONS(230), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(233), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(236), 1,
      aux_sym_op_const_token1,
    ACTIONS(239), 1,
      aux_sym_op_const_token2,
    ACTIONS(242), 1,
      anon_sym_func_DOTbind,
    ACTIONS(245), 1,
      anon_sym_let,
    ACTIONS(248), 1,
      anon_sym_select,
    ACTIONS(251), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(257), 1,
      anon_sym_i8x16,
    ACTIONS(260), 1,
      anon_sym_i16x8,
    ACTIONS(263), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(266), 1,
      anon_sym_table_DOTinit,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    ACTIONS(195), 3,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_else,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(254), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(111), 4,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
      aux_sym_instr_list_repeat1,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [14564] = 35,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(270), 1,
      sym_instr,
    STATE(298), 1,
      sym_func_type_results,
    ACTIONS(167), 3,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_else,
    STATE(112), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [14689] = 36,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(123), 1,
      anon_sym_end,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(269), 1,
      sym_identifier,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(818), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(113), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [14816] = 35,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(272), 1,
      sym_instr,
    STATE(298), 1,
      sym_func_type_results,
    ACTIONS(271), 3,
      anon_sym_RPAREN,
      anon_sym_end,
      anon_sym_else,
    STATE(114), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [14941] = 36,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(105), 1,
      anon_sym_end,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(273), 1,
      sym_identifier,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(798), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(115), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [15068] = 36,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(275), 1,
      anon_sym_end,
    ACTIONS(277), 1,
      sym_identifier,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(874), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(116), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [15195] = 37,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(279), 1,
      anon_sym_block,
    ACTIONS(281), 1,
      anon_sym_if,
    ACTIONS(283), 1,
      anon_sym_loop,
    ACTIONS(285), 1,
      anon_sym_export,
    ACTIONS(287), 1,
      anon_sym_call_indirect,
    ACTIONS(289), 1,
      anon_sym_local,
    ACTIONS(291), 1,
      anon_sym_param,
    ACTIONS(293), 1,
      anon_sym_result,
    ACTIONS(295), 1,
      anon_sym_import,
    ACTIONS(297), 1,
      anon_sym_type,
    STATE(586), 1,
      sym_instr_plain,
    STATE(953), 1,
      sym_expr1,
    STATE(117), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(811), 5,
      sym_expr1_block,
      sym_expr1_call,
      sym_expr1_if,
      sym_expr1_loop,
      sym_expr1_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [15323] = 35,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(299), 1,
      anon_sym_RPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(869), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(118), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [15447] = 35,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(301), 1,
      anon_sym_RPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(850), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(119), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [15571] = 35,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(303), 1,
      anon_sym_RPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(919), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(120), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [15695] = 35,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(305), 1,
      anon_sym_RPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(884), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(121), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [15819] = 35,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(307), 1,
      anon_sym_RPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(888), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(122), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [15943] = 35,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(275), 1,
      anon_sym_end,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(874), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(123), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [16067] = 35,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(309), 1,
      anon_sym_end,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(891), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(124), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [16191] = 35,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(311), 1,
      anon_sym_RPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(897), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(125), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [16315] = 35,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(313), 1,
      anon_sym_RPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(786), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(126), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [16439] = 35,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(123), 1,
      anon_sym_end,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(818), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(127), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [16563] = 35,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(315), 1,
      anon_sym_RPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(907), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(128), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [16687] = 35,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(129), 1,
      anon_sym_end,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(873), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(129), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [16811] = 35,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(317), 1,
      anon_sym_RPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(914), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(130), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [16935] = 35,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_RPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(837), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(131), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [17059] = 35,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(321), 1,
      anon_sym_RPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(865), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(132), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [17183] = 36,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    STATE(143), 1,
      aux_sym_block_block_repeat2,
    STATE(211), 1,
      aux_sym_block_block_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(270), 1,
      sym_instr,
    STATE(298), 1,
      sym_func_type_results,
    STATE(133), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [17309] = 36,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    STATE(135), 1,
      aux_sym_block_block_repeat1,
    STATE(143), 1,
      aux_sym_block_block_repeat2,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(270), 1,
      sym_instr,
    STATE(298), 1,
      sym_func_type_results,
    STATE(134), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [17435] = 36,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    STATE(150), 1,
      aux_sym_block_block_repeat2,
    STATE(211), 1,
      aux_sym_block_block_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(291), 1,
      sym_instr,
    STATE(298), 1,
      sym_func_type_results,
    STATE(135), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [17561] = 35,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(171), 1,
      anon_sym_end,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(800), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(136), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [17685] = 35,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(23), 1,
      anon_sym_call_indirect,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(191), 1,
      anon_sym_end,
    STATE(106), 1,
      aux_sym_instr_list_repeat1,
    STATE(846), 1,
      sym_instr_list,
    STATE(300), 2,
      sym_instr,
      sym_instr_list_call,
    STATE(137), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [17809] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(323), 1,
      anon_sym_RPAREN,
    STATE(154), 1,
      aux_sym_elem_expr_item_repeat1,
    STATE(304), 1,
      sym_instr,
    STATE(138), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [17929] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(325), 1,
      anon_sym_RPAREN,
    STATE(140), 1,
      aux_sym_elem_expr_item_repeat1,
    STATE(304), 1,
      sym_instr,
    STATE(139), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [18049] = 33,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(327), 1,
      anon_sym_RPAREN,
    ACTIONS(329), 1,
      anon_sym_LPAREN,
    ACTIONS(332), 1,
      anon_sym_block,
    ACTIONS(335), 1,
      anon_sym_if,
    ACTIONS(338), 1,
      anon_sym_loop,
    ACTIONS(341), 1,
      anon_sym_call_indirect,
    ACTIONS(344), 1,
      anon_sym_br_table,
    ACTIONS(347), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(350), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(353), 1,
      sym_op_nullary,
    ACTIONS(356), 1,
      sym_op_index,
    ACTIONS(359), 1,
      sym_op_index_opt,
    ACTIONS(362), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(365), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(368), 1,
      aux_sym_op_const_token1,
    ACTIONS(371), 1,
      aux_sym_op_const_token2,
    ACTIONS(374), 1,
      anon_sym_func_DOTbind,
    ACTIONS(377), 1,
      anon_sym_let,
    ACTIONS(380), 1,
      anon_sym_select,
    ACTIONS(383), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(389), 1,
      anon_sym_i8x16,
    ACTIONS(392), 1,
      anon_sym_i16x8,
    ACTIONS(395), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(398), 1,
      anon_sym_table_DOTinit,
    STATE(304), 1,
      sym_instr,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(386), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(140), 4,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
      aux_sym_elem_expr_item_repeat1,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [18167] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(401), 1,
      anon_sym_RPAREN,
    STATE(159), 1,
      aux_sym_elem_expr_item_repeat1,
    STATE(304), 1,
      sym_instr,
    STATE(141), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [18287] = 35,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(279), 1,
      anon_sym_block,
    ACTIONS(281), 1,
      anon_sym_if,
    ACTIONS(283), 1,
      anon_sym_loop,
    ACTIONS(287), 1,
      anon_sym_call_indirect,
    ACTIONS(293), 1,
      anon_sym_result,
    ACTIONS(297), 1,
      anon_sym_type,
    ACTIONS(403), 1,
      anon_sym_param,
    ACTIONS(405), 1,
      anon_sym_then,
    STATE(586), 1,
      sym_instr_plain,
    STATE(953), 1,
      sym_expr1,
    STATE(142), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(811), 5,
      sym_expr1_block,
      sym_expr1_call,
      sym_expr1_if,
      sym_expr1_loop,
      sym_expr1_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [18409] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(291), 1,
      sym_instr,
    STATE(298), 1,
      sym_func_type_results,
    STATE(143), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [18529] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(401), 1,
      anon_sym_RPAREN,
    STATE(140), 1,
      aux_sym_elem_expr_item_repeat1,
    STATE(304), 1,
      sym_instr,
    STATE(144), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [18649] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(407), 1,
      anon_sym_RPAREN,
    STATE(140), 1,
      aux_sym_elem_expr_item_repeat1,
    STATE(304), 1,
      sym_instr,
    STATE(145), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [18769] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(409), 1,
      anon_sym_RPAREN,
    STATE(140), 1,
      aux_sym_elem_expr_item_repeat1,
    STATE(304), 1,
      sym_instr,
    STATE(146), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [18889] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(411), 1,
      anon_sym_RPAREN,
    STATE(139), 1,
      aux_sym_elem_expr_item_repeat1,
    STATE(304), 1,
      sym_instr,
    STATE(147), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [19009] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(411), 1,
      anon_sym_RPAREN,
    STATE(140), 1,
      aux_sym_elem_expr_item_repeat1,
    STATE(304), 1,
      sym_instr,
    STATE(148), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [19129] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(270), 1,
      sym_instr,
    STATE(298), 1,
      sym_func_type_results,
    STATE(149), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [19249] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(272), 1,
      sym_instr,
    STATE(298), 1,
      sym_func_type_results,
    STATE(150), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [19369] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(413), 1,
      anon_sym_RPAREN,
    STATE(146), 1,
      aux_sym_elem_expr_item_repeat1,
    STATE(304), 1,
      sym_instr,
    STATE(151), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [19489] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(415), 1,
      anon_sym_RPAREN,
    STATE(140), 1,
      aux_sym_elem_expr_item_repeat1,
    STATE(304), 1,
      sym_instr,
    STATE(152), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [19609] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(417), 1,
      anon_sym_RPAREN,
    STATE(144), 1,
      aux_sym_elem_expr_item_repeat1,
    STATE(304), 1,
      sym_instr,
    STATE(153), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [19729] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(419), 1,
      anon_sym_RPAREN,
    STATE(140), 1,
      aux_sym_elem_expr_item_repeat1,
    STATE(304), 1,
      sym_instr,
    STATE(154), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [19849] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(415), 1,
      anon_sym_RPAREN,
    STATE(148), 1,
      aux_sym_elem_expr_item_repeat1,
    STATE(304), 1,
      sym_instr,
    STATE(155), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [19969] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(421), 1,
      anon_sym_RPAREN,
    STATE(152), 1,
      aux_sym_elem_expr_item_repeat1,
    STATE(304), 1,
      sym_instr,
    STATE(156), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [20089] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(423), 1,
      anon_sym_RPAREN,
    STATE(145), 1,
      aux_sym_elem_expr_item_repeat1,
    STATE(304), 1,
      sym_instr,
    STATE(157), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [20209] = 35,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(279), 1,
      anon_sym_block,
    ACTIONS(281), 1,
      anon_sym_if,
    ACTIONS(283), 1,
      anon_sym_loop,
    ACTIONS(287), 1,
      anon_sym_call_indirect,
    ACTIONS(289), 1,
      anon_sym_local,
    ACTIONS(291), 1,
      anon_sym_param,
    ACTIONS(293), 1,
      anon_sym_result,
    ACTIONS(297), 1,
      anon_sym_type,
    STATE(586), 1,
      sym_instr_plain,
    STATE(953), 1,
      sym_expr1,
    STATE(158), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(811), 5,
      sym_expr1_block,
      sym_expr1_call,
      sym_expr1_if,
      sym_expr1_loop,
      sym_expr1_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [20331] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(17), 1,
      anon_sym_block,
    ACTIONS(19), 1,
      anon_sym_if,
    ACTIONS(21), 1,
      anon_sym_loop,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(155), 1,
      anon_sym_call_indirect,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(423), 1,
      anon_sym_RPAREN,
    STATE(140), 1,
      aux_sym_elem_expr_item_repeat1,
    STATE(304), 1,
      sym_instr,
    STATE(159), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(289), 3,
      sym_block_block,
      sym_block_if,
      sym_block_loop,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(290), 4,
      sym_expr,
      sym_instr_block,
      sym_instr_call,
      sym_instr_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [20451] = 20,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(427), 1,
      anon_sym_LPAREN,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    STATE(182), 1,
      sym_index,
    STATE(183), 1,
      aux_sym_op_let_repeat1,
    STATE(185), 1,
      sym_nat,
    STATE(188), 1,
      aux_sym_block_block_repeat2,
    STATE(202), 1,
      aux_sym_op_let_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(296), 1,
      sym_func_type_params,
    STATE(298), 1,
      sym_func_type_results,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(160), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(436), 9,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(425), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [20543] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(279), 1,
      anon_sym_block,
    ACTIONS(281), 1,
      anon_sym_if,
    ACTIONS(283), 1,
      anon_sym_loop,
    ACTIONS(287), 1,
      anon_sym_call_indirect,
    ACTIONS(289), 1,
      anon_sym_local,
    ACTIONS(291), 1,
      anon_sym_param,
    ACTIONS(293), 1,
      anon_sym_result,
    STATE(586), 1,
      sym_instr_plain,
    STATE(953), 1,
      sym_expr1,
    STATE(161), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(811), 5,
      sym_expr1_block,
      sym_expr1_call,
      sym_expr1_if,
      sym_expr1_loop,
      sym_expr1_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [20662] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(279), 1,
      anon_sym_block,
    ACTIONS(281), 1,
      anon_sym_if,
    ACTIONS(283), 1,
      anon_sym_loop,
    ACTIONS(287), 1,
      anon_sym_call_indirect,
    ACTIONS(293), 1,
      anon_sym_result,
    ACTIONS(403), 1,
      anon_sym_param,
    ACTIONS(438), 1,
      anon_sym_then,
    STATE(586), 1,
      sym_instr_plain,
    STATE(953), 1,
      sym_expr1,
    STATE(162), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(811), 5,
      sym_expr1_block,
      sym_expr1_call,
      sym_expr1_if,
      sym_expr1_loop,
      sym_expr1_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [20781] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(279), 1,
      anon_sym_block,
    ACTIONS(281), 1,
      anon_sym_if,
    ACTIONS(283), 1,
      anon_sym_loop,
    ACTIONS(287), 1,
      anon_sym_call_indirect,
    ACTIONS(440), 1,
      anon_sym_table,
    ACTIONS(442), 1,
      anon_sym_offset,
    ACTIONS(444), 1,
      anon_sym_ref,
    STATE(586), 1,
      sym_instr_plain,
    STATE(953), 1,
      sym_expr1,
    STATE(163), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(811), 5,
      sym_expr1_block,
      sym_expr1_call,
      sym_expr1_if,
      sym_expr1_loop,
      sym_expr1_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [20900] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(279), 1,
      anon_sym_block,
    ACTIONS(281), 1,
      anon_sym_if,
    ACTIONS(283), 1,
      anon_sym_loop,
    ACTIONS(287), 1,
      anon_sym_call_indirect,
    ACTIONS(293), 1,
      anon_sym_result,
    ACTIONS(297), 1,
      anon_sym_type,
    ACTIONS(403), 1,
      anon_sym_param,
    STATE(586), 1,
      sym_instr_plain,
    STATE(953), 1,
      sym_expr1,
    STATE(164), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(811), 5,
      sym_expr1_block,
      sym_expr1_call,
      sym_expr1_if,
      sym_expr1_loop,
      sym_expr1_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [21019] = 34,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(279), 1,
      anon_sym_block,
    ACTIONS(281), 1,
      anon_sym_if,
    ACTIONS(283), 1,
      anon_sym_loop,
    ACTIONS(287), 1,
      anon_sym_call_indirect,
    ACTIONS(293), 1,
      anon_sym_result,
    ACTIONS(403), 1,
      anon_sym_param,
    ACTIONS(446), 1,
      anon_sym_then,
    STATE(586), 1,
      sym_instr_plain,
    STATE(953), 1,
      sym_expr1,
    STATE(165), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(811), 5,
      sym_expr1_block,
      sym_expr1_call,
      sym_expr1_if,
      sym_expr1_loop,
      sym_expr1_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [21138] = 33,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(279), 1,
      anon_sym_block,
    ACTIONS(281), 1,
      anon_sym_if,
    ACTIONS(283), 1,
      anon_sym_loop,
    ACTIONS(287), 1,
      anon_sym_call_indirect,
    ACTIONS(293), 1,
      anon_sym_result,
    ACTIONS(438), 1,
      anon_sym_then,
    STATE(586), 1,
      sym_instr_plain,
    STATE(953), 1,
      sym_expr1,
    STATE(166), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(811), 5,
      sym_expr1_block,
      sym_expr1_call,
      sym_expr1_if,
      sym_expr1_loop,
      sym_expr1_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [21254] = 33,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(279), 1,
      anon_sym_block,
    ACTIONS(281), 1,
      anon_sym_if,
    ACTIONS(283), 1,
      anon_sym_loop,
    ACTIONS(287), 1,
      anon_sym_call_indirect,
    ACTIONS(289), 1,
      anon_sym_local,
    ACTIONS(293), 1,
      anon_sym_result,
    STATE(586), 1,
      sym_instr_plain,
    STATE(953), 1,
      sym_expr1,
    STATE(167), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(811), 5,
      sym_expr1_block,
      sym_expr1_call,
      sym_expr1_if,
      sym_expr1_loop,
      sym_expr1_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [21370] = 33,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(279), 1,
      anon_sym_block,
    ACTIONS(281), 1,
      anon_sym_if,
    ACTIONS(283), 1,
      anon_sym_loop,
    ACTIONS(287), 1,
      anon_sym_call_indirect,
    ACTIONS(293), 1,
      anon_sym_result,
    ACTIONS(403), 1,
      anon_sym_param,
    STATE(586), 1,
      sym_instr_plain,
    STATE(953), 1,
      sym_expr1,
    STATE(168), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(811), 5,
      sym_expr1_block,
      sym_expr1_call,
      sym_expr1_if,
      sym_expr1_loop,
      sym_expr1_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [21486] = 33,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(279), 1,
      anon_sym_block,
    ACTIONS(281), 1,
      anon_sym_if,
    ACTIONS(283), 1,
      anon_sym_loop,
    ACTIONS(287), 1,
      anon_sym_call_indirect,
    ACTIONS(293), 1,
      anon_sym_result,
    ACTIONS(446), 1,
      anon_sym_then,
    STATE(586), 1,
      sym_instr_plain,
    STATE(953), 1,
      sym_expr1,
    STATE(169), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(811), 5,
      sym_expr1_block,
      sym_expr1_call,
      sym_expr1_if,
      sym_expr1_loop,
      sym_expr1_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [21602] = 33,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(279), 1,
      anon_sym_block,
    ACTIONS(281), 1,
      anon_sym_if,
    ACTIONS(283), 1,
      anon_sym_loop,
    ACTIONS(287), 1,
      anon_sym_call_indirect,
    ACTIONS(293), 1,
      anon_sym_result,
    ACTIONS(448), 1,
      anon_sym_then,
    STATE(586), 1,
      sym_instr_plain,
    STATE(953), 1,
      sym_expr1,
    STATE(170), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(811), 5,
      sym_expr1_block,
      sym_expr1_call,
      sym_expr1_if,
      sym_expr1_loop,
      sym_expr1_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [21718] = 33,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(279), 1,
      anon_sym_block,
    ACTIONS(281), 1,
      anon_sym_if,
    ACTIONS(283), 1,
      anon_sym_loop,
    ACTIONS(287), 1,
      anon_sym_call_indirect,
    ACTIONS(442), 1,
      anon_sym_offset,
    ACTIONS(450), 1,
      anon_sym_memory,
    STATE(586), 1,
      sym_instr_plain,
    STATE(953), 1,
      sym_expr1,
    STATE(171), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(811), 5,
      sym_expr1_block,
      sym_expr1_call,
      sym_expr1_if,
      sym_expr1_loop,
      sym_expr1_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [21834] = 32,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(279), 1,
      anon_sym_block,
    ACTIONS(281), 1,
      anon_sym_if,
    ACTIONS(283), 1,
      anon_sym_loop,
    ACTIONS(287), 1,
      anon_sym_call_indirect,
    ACTIONS(293), 1,
      anon_sym_result,
    STATE(586), 1,
      sym_instr_plain,
    STATE(953), 1,
      sym_expr1,
    STATE(172), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(811), 5,
      sym_expr1_block,
      sym_expr1_call,
      sym_expr1_if,
      sym_expr1_loop,
      sym_expr1_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [21947] = 32,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(279), 1,
      anon_sym_block,
    ACTIONS(281), 1,
      anon_sym_if,
    ACTIONS(283), 1,
      anon_sym_loop,
    ACTIONS(287), 1,
      anon_sym_call_indirect,
    ACTIONS(452), 1,
      anon_sym_then,
    STATE(586), 1,
      sym_instr_plain,
    STATE(953), 1,
      sym_expr1,
    STATE(173), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(811), 5,
      sym_expr1_block,
      sym_expr1_call,
      sym_expr1_if,
      sym_expr1_loop,
      sym_expr1_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [22060] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(174), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(456), 12,
      anon_sym_LPAREN,
      sym_dec_nat,
      anon_sym_func,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(454), 30,
      anon_sym_align,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      sym_hex_nat,
      sym_identifier,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
      anon_sym_declare,
      anon_sym_offset,
      sym_ref_type_externref,
      sym_ref_type_funcref,
      sym_share,
      sym_sign,
      anon_sym_DQUOTE,
  [22121] = 32,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(279), 1,
      anon_sym_block,
    ACTIONS(281), 1,
      anon_sym_if,
    ACTIONS(283), 1,
      anon_sym_loop,
    ACTIONS(287), 1,
      anon_sym_call_indirect,
    ACTIONS(448), 1,
      anon_sym_then,
    STATE(586), 1,
      sym_instr_plain,
    STATE(953), 1,
      sym_expr1,
    STATE(175), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(811), 5,
      sym_expr1_block,
      sym_expr1_call,
      sym_expr1_if,
      sym_expr1_loop,
      sym_expr1_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [22234] = 32,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(279), 1,
      anon_sym_block,
    ACTIONS(281), 1,
      anon_sym_if,
    ACTIONS(283), 1,
      anon_sym_loop,
    ACTIONS(287), 1,
      anon_sym_call_indirect,
    ACTIONS(446), 1,
      anon_sym_then,
    STATE(586), 1,
      sym_instr_plain,
    STATE(953), 1,
      sym_expr1,
    STATE(176), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(811), 5,
      sym_expr1_block,
      sym_expr1_call,
      sym_expr1_if,
      sym_expr1_loop,
      sym_expr1_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [22347] = 32,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(279), 1,
      anon_sym_block,
    ACTIONS(281), 1,
      anon_sym_if,
    ACTIONS(283), 1,
      anon_sym_loop,
    ACTIONS(287), 1,
      anon_sym_call_indirect,
    ACTIONS(458), 1,
      anon_sym_item,
    STATE(586), 1,
      sym_instr_plain,
    STATE(953), 1,
      sym_expr1,
    STATE(177), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(811), 5,
      sym_expr1_block,
      sym_expr1_call,
      sym_expr1_if,
      sym_expr1_loop,
      sym_expr1_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [22460] = 32,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(279), 1,
      anon_sym_block,
    ACTIONS(281), 1,
      anon_sym_if,
    ACTIONS(283), 1,
      anon_sym_loop,
    ACTIONS(287), 1,
      anon_sym_call_indirect,
    ACTIONS(442), 1,
      anon_sym_offset,
    STATE(586), 1,
      sym_instr_plain,
    STATE(953), 1,
      sym_expr1,
    STATE(178), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(811), 5,
      sym_expr1_block,
      sym_expr1_call,
      sym_expr1_if,
      sym_expr1_loop,
      sym_expr1_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [22573] = 32,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(279), 1,
      anon_sym_block,
    ACTIONS(281), 1,
      anon_sym_if,
    ACTIONS(283), 1,
      anon_sym_loop,
    ACTIONS(287), 1,
      anon_sym_call_indirect,
    ACTIONS(289), 1,
      anon_sym_local,
    STATE(586), 1,
      sym_instr_plain,
    STATE(953), 1,
      sym_expr1,
    STATE(179), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(811), 5,
      sym_expr1_block,
      sym_expr1_call,
      sym_expr1_if,
      sym_expr1_loop,
      sym_expr1_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [22686] = 32,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(279), 1,
      anon_sym_block,
    ACTIONS(281), 1,
      anon_sym_if,
    ACTIONS(283), 1,
      anon_sym_loop,
    ACTIONS(287), 1,
      anon_sym_call_indirect,
    ACTIONS(438), 1,
      anon_sym_then,
    STATE(586), 1,
      sym_instr_plain,
    STATE(953), 1,
      sym_expr1,
    STATE(180), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(811), 5,
      sym_expr1_block,
      sym_expr1_call,
      sym_expr1_if,
      sym_expr1_loop,
      sym_expr1_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [22799] = 31,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(27), 1,
      anon_sym_br_table,
    ACTIONS(29), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(31), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(33), 1,
      sym_op_nullary,
    ACTIONS(35), 1,
      sym_op_index,
    ACTIONS(37), 1,
      sym_op_index_opt,
    ACTIONS(39), 1,
      sym_op_index_opt_offset_opt_align_opt,
    ACTIONS(41), 1,
      sym_op_simd_offset_opt_align_opt,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(47), 1,
      anon_sym_func_DOTbind,
    ACTIONS(49), 1,
      anon_sym_let,
    ACTIONS(51), 1,
      anon_sym_select,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(57), 1,
      anon_sym_i8x16,
    ACTIONS(59), 1,
      anon_sym_i16x8,
    ACTIONS(61), 1,
      anon_sym_table_DOTcopy,
    ACTIONS(63), 1,
      anon_sym_table_DOTinit,
    ACTIONS(279), 1,
      anon_sym_block,
    ACTIONS(281), 1,
      anon_sym_if,
    ACTIONS(283), 1,
      anon_sym_loop,
    ACTIONS(287), 1,
      anon_sym_call_indirect,
    STATE(586), 1,
      sym_instr_plain,
    STATE(953), 1,
      sym_expr1,
    STATE(181), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(55), 4,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i32x4,
      anon_sym_i64x2,
    STATE(811), 5,
      sym_expr1_block,
      sym_expr1_call,
      sym_expr1_if,
      sym_expr1_loop,
      sym_expr1_plain,
    STATE(281), 8,
      sym_op_const,
      sym_op_func_bind,
      sym_op_let,
      sym_op_select,
      sym_op_simd_const,
      sym_op_simd_lane,
      sym_op_table_copy,
      sym_op_table_init,
  [22909] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(462), 1,
      anon_sym_LPAREN,
    STATE(184), 1,
      aux_sym_op_let_repeat1,
    STATE(190), 1,
      aux_sym_block_block_repeat2,
    STATE(205), 1,
      aux_sym_op_let_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(296), 1,
      sym_func_type_params,
    STATE(298), 1,
      sym_func_type_results,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(182), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(465), 9,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(460), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [22986] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(462), 1,
      anon_sym_LPAREN,
    STATE(190), 1,
      aux_sym_block_block_repeat2,
    STATE(204), 1,
      aux_sym_op_let_repeat1,
    STATE(205), 1,
      aux_sym_op_let_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(296), 1,
      sym_func_type_params,
    STATE(298), 1,
      sym_func_type_results,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(183), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(465), 9,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(460), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [23063] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(469), 1,
      anon_sym_LPAREN,
    STATE(192), 1,
      aux_sym_block_block_repeat2,
    STATE(203), 1,
      aux_sym_op_let_repeat2,
    STATE(204), 1,
      aux_sym_op_let_repeat1,
    STATE(292), 1,
      sym_func_locals,
    STATE(296), 1,
      sym_func_type_params,
    STATE(298), 1,
      sym_func_type_results,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(184), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(472), 9,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(467), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [23140] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(185), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(476), 12,
      anon_sym_LPAREN,
      sym_dec_nat,
      anon_sym_func,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(474), 28,
      anon_sym_align,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      sym_hex_nat,
      sym_identifier,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
      anon_sym_declare,
      anon_sym_offset,
      sym_ref_type_externref,
      sym_ref_type_funcref,
      anon_sym_DQUOTE,
  [23199] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(478), 1,
      anon_sym_align,
    ACTIONS(484), 1,
      anon_sym_offset,
    STATE(185), 1,
      sym_nat,
    STATE(201), 1,
      sym_index,
    STATE(212), 1,
      sym_offset_value,
    STATE(252), 1,
      sym_align_value,
    STATE(186), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(482), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(480), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [23275] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(187), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(488), 12,
      anon_sym_LPAREN,
      sym_dec_nat,
      anon_sym_func,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(486), 25,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      sym_hex_nat,
      sym_identifier,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
      sym_ref_type_externref,
      sym_ref_type_funcref,
      anon_sym_DQUOTE,
  [23331] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(490), 1,
      anon_sym_LPAREN,
    STATE(205), 1,
      aux_sym_op_let_repeat2,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(298), 1,
      sym_func_type_results,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(188), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(465), 9,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(460), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [23398] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    STATE(185), 1,
      sym_nat,
    STATE(191), 1,
      aux_sym_elem_list_repeat1,
    STATE(210), 1,
      sym_index,
    STATE(189), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(495), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(493), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [23465] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(497), 1,
      anon_sym_LPAREN,
    STATE(203), 1,
      aux_sym_op_let_repeat2,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(298), 1,
      sym_func_type_results,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(190), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(472), 9,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(467), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [23532] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    STATE(185), 1,
      sym_nat,
    STATE(193), 1,
      aux_sym_elem_list_repeat1,
    STATE(210), 1,
      sym_index,
    STATE(191), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(502), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(500), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [23599] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(506), 1,
      anon_sym_LPAREN,
    STATE(206), 1,
      aux_sym_op_let_repeat2,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(298), 1,
      sym_func_type_results,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(192), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(509), 9,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(504), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [23666] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(515), 1,
      sym_dec_nat,
    ACTIONS(518), 1,
      sym_hex_nat,
    ACTIONS(521), 1,
      sym_identifier,
    STATE(185), 1,
      sym_nat,
    STATE(210), 1,
      sym_index,
    STATE(193), 4,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
      aux_sym_elem_list_repeat1,
    ACTIONS(513), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(511), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [23731] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(194), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(526), 11,
      anon_sym_LPAREN,
      sym_dec_float,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(524), 24,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_inf,
      sym_hex_float,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
      sym_nan,
      sym_sign,
  [23785] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(195), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(530), 11,
      anon_sym_LPAREN,
      sym_dec_float,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(528), 24,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_inf,
      sym_hex_float,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
      sym_nan,
      sym_sign,
  [23839] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    STATE(185), 1,
      sym_nat,
    STATE(494), 1,
      sym_index,
    STATE(196), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(534), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(532), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [23903] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    STATE(185), 1,
      sym_nat,
    STATE(280), 1,
      sym_index,
    STATE(197), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(538), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(536), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [23967] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    STATE(185), 1,
      sym_nat,
    STATE(252), 1,
      sym_index,
    STATE(198), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(482), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(480), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [24031] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(542), 1,
      anon_sym_LPAREN,
    STATE(292), 1,
      sym_func_locals,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(199), 4,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
      aux_sym_op_let_repeat2,
    ACTIONS(545), 9,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(540), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [24090] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(478), 1,
      anon_sym_align,
    ACTIONS(484), 1,
      anon_sym_offset,
    STATE(212), 1,
      sym_offset_value,
    STATE(252), 1,
      sym_align_value,
    STATE(200), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(482), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(480), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [24151] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(478), 1,
      anon_sym_align,
    ACTIONS(484), 1,
      anon_sym_offset,
    STATE(216), 1,
      sym_offset_value,
    STATE(273), 1,
      sym_align_value,
    STATE(201), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(495), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(493), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [24212] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(547), 1,
      anon_sym_LPAREN,
    STATE(199), 1,
      aux_sym_op_let_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(202), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(465), 9,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(460), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [24273] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(550), 1,
      anon_sym_LPAREN,
    STATE(199), 1,
      aux_sym_op_let_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(203), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(509), 9,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(504), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [24334] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    STATE(296), 1,
      sym_func_type_params,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(204), 4,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
      aux_sym_op_let_repeat1,
    ACTIONS(558), 9,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(553), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [24393] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(560), 1,
      anon_sym_LPAREN,
    STATE(199), 1,
      aux_sym_op_let_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(205), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(472), 9,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(467), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [24454] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(565), 1,
      anon_sym_LPAREN,
    STATE(199), 1,
      aux_sym_op_let_repeat2,
    STATE(292), 1,
      sym_func_locals,
    STATE(295), 2,
      sym_func_locals_many,
      sym_func_locals_one,
    STATE(206), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(568), 9,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(563), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [24515] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(572), 1,
      anon_sym_LPAREN,
    STATE(213), 1,
      sym_export,
    STATE(207), 4,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
      aux_sym_module_field_func_repeat1,
    ACTIONS(575), 10,
      sym_dec_nat,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(570), 21,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_call_indirect,
      sym_hex_nat,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
      sym_ref_type_externref,
      sym_ref_type_funcref,
  [24572] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(208), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(579), 11,
      anon_sym_LPAREN,
      sym_dec_nat,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(577), 22,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      sym_hex_nat,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
      sym_sign,
  [24624] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(209), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(583), 11,
      anon_sym_LPAREN,
      sym_dec_nat,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(581), 22,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      sym_hex_nat,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
      sym_sign,
  [24676] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(210), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(587), 11,
      anon_sym_LPAREN,
      sym_dec_nat,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(585), 22,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      sym_hex_nat,
      sym_identifier,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [24728] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(591), 1,
      anon_sym_LPAREN,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(211), 4,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
      aux_sym_block_block_repeat1,
    ACTIONS(594), 9,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(589), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [24783] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(478), 1,
      anon_sym_align,
    STATE(273), 1,
      sym_align_value,
    STATE(212), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(495), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(493), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [24838] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(213), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(598), 11,
      anon_sym_LPAREN,
      sym_dec_nat,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(596), 21,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_call_indirect,
      sym_hex_nat,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
      sym_ref_type_externref,
      sym_ref_type_funcref,
  [24889] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(602), 1,
      anon_sym_LPAREN,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(214), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(605), 9,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(600), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [24946] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(609), 1,
      anon_sym_LPAREN,
    STATE(298), 1,
      sym_func_type_results,
    STATE(215), 4,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
      aux_sym_block_block_repeat2,
    ACTIONS(612), 9,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(607), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [25001] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(478), 1,
      anon_sym_align,
    STATE(287), 1,
      sym_align_value,
    STATE(216), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(502), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(500), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [25056] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(616), 1,
      anon_sym_LPAREN,
    STATE(214), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(217), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(619), 9,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(614), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [25113] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(218), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(623), 11,
      anon_sym_LPAREN,
      sym_dec_nat,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(621), 21,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_call_indirect,
      sym_hex_nat,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
      sym_ref_type_externref,
      sym_ref_type_funcref,
  [25164] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(629), 1,
      sym_identifier,
    STATE(219), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(627), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(625), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [25216] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(635), 1,
      sym_identifier,
    STATE(220), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(633), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(631), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [25268] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(641), 1,
      sym_identifier,
    STATE(221), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(639), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(637), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [25320] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(647), 1,
      sym_identifier,
    STATE(222), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(645), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(643), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [25372] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(653), 1,
      sym_identifier,
    STATE(223), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(651), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(649), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [25424] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(659), 1,
      sym_identifier,
    STATE(224), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(657), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(655), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [25476] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(665), 1,
      sym_identifier,
    STATE(225), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(663), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(661), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [25528] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(226), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(669), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(667), 21,
      anon_sym_align,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [25578] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(675), 1,
      sym_identifier,
    STATE(227), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(673), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(671), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [25630] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(681), 1,
      sym_identifier,
    STATE(228), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(679), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(677), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [25682] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(687), 1,
      sym_identifier,
    STATE(229), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(685), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(683), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [25734] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(693), 1,
      sym_identifier,
    STATE(230), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(691), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(689), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [25786] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(699), 1,
      sym_identifier,
    STATE(231), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(697), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(695), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [25838] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(705), 1,
      sym_identifier,
    STATE(232), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(703), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(701), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [25890] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(711), 1,
      sym_identifier,
    STATE(233), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(709), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(707), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [25942] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(717), 1,
      sym_identifier,
    STATE(234), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(715), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(713), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [25994] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(723), 1,
      sym_identifier,
    STATE(235), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(721), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(719), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [26046] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(729), 1,
      sym_identifier,
    STATE(236), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(727), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(725), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [26098] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(735), 1,
      sym_identifier,
    STATE(237), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(733), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(731), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [26150] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(741), 1,
      sym_identifier,
    STATE(238), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(739), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(737), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [26202] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(747), 1,
      sym_identifier,
    STATE(239), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(745), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(743), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [26254] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(753), 1,
      sym_identifier,
    STATE(240), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(751), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(749), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [26306] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(241), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(627), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(625), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [26355] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(242), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(757), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(755), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [26404] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(243), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(761), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(759), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [26453] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(244), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(765), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(763), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [26502] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(245), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(769), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(767), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [26551] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(246), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(773), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(771), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [26600] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(247), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(777), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(775), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [26649] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(248), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(781), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(779), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [26698] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(249), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(785), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(783), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [26747] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(250), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(751), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(749), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [26796] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(251), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(745), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(743), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [26845] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(252), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(495), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(493), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [26894] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(253), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(789), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(787), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [26943] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(254), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(739), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(737), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [26992] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(255), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(793), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(791), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [27041] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(256), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(797), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(795), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [27090] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(257), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(733), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(731), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [27139] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(258), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(801), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(799), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [27188] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(259), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(721), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(719), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [27237] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(260), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(715), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(713), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [27286] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(261), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(805), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(803), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [27335] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(262), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(809), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(807), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [27384] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(263), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(813), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(811), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [27433] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(264), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(673), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(671), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [27482] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(265), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(703), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(701), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [27531] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(266), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(651), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(649), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [27580] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(267), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(633), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(631), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [27629] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(268), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(679), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(677), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [27678] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(269), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(663), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(661), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [27727] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(270), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(817), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(815), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [27776] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(271), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(821), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(819), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [27825] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(272), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(825), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(823), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [27874] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(273), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(502), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(500), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [27923] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(274), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(639), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(637), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [27972] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(275), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(829), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(827), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [28021] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(276), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(691), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(689), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [28070] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(277), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(833), 11,
      anon_sym_LPAREN,
      sym_dec_nat,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(831), 19,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_call_indirect,
      sym_hex_nat,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [28119] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(278), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(837), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(835), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [28168] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(279), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(841), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(839), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [28217] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(280), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(845), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(843), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [28266] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(281), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(482), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(480), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [28315] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(282), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(849), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(847), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [28364] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(283), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(853), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(851), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [28413] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(284), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(857), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(855), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [28462] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(285), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(861), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(859), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [28511] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(865), 1,
      anon_sym_LPAREN,
    STATE(286), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(867), 9,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(863), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [28562] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(287), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(871), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(869), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [28611] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(288), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(875), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(873), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [28660] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(289), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(879), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(877), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [28709] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(290), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(883), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(881), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [28758] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(291), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(887), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(885), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [28807] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(292), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(891), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(889), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [28856] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(293), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(895), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(893), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [28905] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(294), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(727), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(725), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [28954] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(295), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(899), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(897), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [29003] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(296), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(903), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(901), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [29052] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(297), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(907), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(905), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [29101] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(298), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(911), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(909), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [29150] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(299), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(697), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(695), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [29199] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(300), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(915), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(913), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [29248] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(301), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(709), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(707), 20,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_end,
      anon_sym_if,
      anon_sym_else,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [29297] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(302), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(919), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(917), 18,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [29344] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(303), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(923), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(921), 18,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [29391] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(304), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(927), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(925), 18,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [29438] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(305), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(931), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(929), 18,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [29485] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(306), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(935), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(933), 18,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [29532] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(307), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(939), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(937), 18,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [29579] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(308), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(943), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(941), 18,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [29626] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(309), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(947), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(945), 18,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [29673] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(310), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(951), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(949), 18,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [29720] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(311), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(955), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(953), 18,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [29767] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(312), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(959), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(957), 18,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [29814] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(313), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(963), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(961), 18,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [29861] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(314), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(967), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(965), 18,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [29908] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(315), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(971), 10,
      anon_sym_LPAREN,
      sym_op_nullary,
      sym_op_index,
      sym_op_index_opt,
      anon_sym_f32x4,
      anon_sym_f64x2,
      anon_sym_i8x16,
      anon_sym_i16x8,
      anon_sym_i32x4,
      anon_sym_i64x2,
    ACTIONS(969), 18,
      anon_sym_RPAREN,
      anon_sym_block,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_call_indirect,
      anon_sym_br_table,
      anon_sym_ref_DOTextern,
      anon_sym_ref_DOTnull,
      sym_op_index_opt_offset_opt_align_opt,
      sym_op_simd_offset_opt_align_opt,
      aux_sym_op_const_token1,
      aux_sym_op_const_token2,
      anon_sym_func_DOTbind,
      anon_sym_let,
      anon_sym_select,
      anon_sym_v128_DOTconst,
      anon_sym_table_DOTcopy,
      anon_sym_table_DOTinit,
  [29955] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(975), 1,
      anon_sym_LPAREN,
    STATE(699), 1,
      sym_command,
    ACTIONS(973), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(565), 2,
      sym_action_get,
      sym_action_invoke,
    STATE(569), 3,
      sym_module,
      sym_script_module_binary,
      sym_script_module_quote,
    STATE(703), 3,
      sym_meta_input,
      sym_meta_output,
      sym_meta_script,
    STATE(316), 4,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
      aux_sym_ROOT_repeat1,
    STATE(687), 5,
      sym_action,
      sym_assertion,
      sym_meta,
      sym_register,
      sym_script_module,
    STATE(692), 9,
      sym_assert_exhaustion,
      sym_assert_invalid,
      sym_assert_malformed,
      sym_assert_return,
      sym_assert_return_arithmetic_nan,
      sym_assert_return_canonical_nan,
      sym_assert_trap_action,
      sym_assert_trap_module,
      sym_assert_unlinkable,
  [30013] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(978), 1,
      anon_sym_RPAREN,
    ACTIONS(980), 1,
      anon_sym_LPAREN,
    ACTIONS(982), 1,
      sym_identifier,
    STATE(319), 1,
      aux_sym_ROOT_repeat1,
    STATE(699), 1,
      sym_command,
    STATE(565), 2,
      sym_action_get,
      sym_action_invoke,
    STATE(317), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(569), 3,
      sym_module,
      sym_script_module_binary,
      sym_script_module_quote,
    STATE(703), 3,
      sym_meta_input,
      sym_meta_output,
      sym_meta_script,
    STATE(687), 5,
      sym_action,
      sym_assertion,
      sym_meta,
      sym_register,
      sym_script_module,
    STATE(692), 9,
      sym_assert_exhaustion,
      sym_assert_invalid,
      sym_assert_malformed,
      sym_assert_return,
      sym_assert_return_arithmetic_nan,
      sym_assert_return_canonical_nan,
      sym_assert_trap_action,
      sym_assert_trap_module,
      sym_assert_unlinkable,
  [30075] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(980), 1,
      anon_sym_LPAREN,
    ACTIONS(984), 1,
      anon_sym_RPAREN,
    STATE(316), 1,
      aux_sym_ROOT_repeat1,
    STATE(699), 1,
      sym_command,
    STATE(565), 2,
      sym_action_get,
      sym_action_invoke,
    STATE(318), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(569), 3,
      sym_module,
      sym_script_module_binary,
      sym_script_module_quote,
    STATE(703), 3,
      sym_meta_input,
      sym_meta_output,
      sym_meta_script,
    STATE(687), 5,
      sym_action,
      sym_assertion,
      sym_meta,
      sym_register,
      sym_script_module,
    STATE(692), 9,
      sym_assert_exhaustion,
      sym_assert_invalid,
      sym_assert_malformed,
      sym_assert_return,
      sym_assert_return_arithmetic_nan,
      sym_assert_return_canonical_nan,
      sym_assert_trap_action,
      sym_assert_trap_module,
      sym_assert_unlinkable,
  [30134] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(980), 1,
      anon_sym_LPAREN,
    ACTIONS(986), 1,
      anon_sym_RPAREN,
    STATE(316), 1,
      aux_sym_ROOT_repeat1,
    STATE(699), 1,
      sym_command,
    STATE(565), 2,
      sym_action_get,
      sym_action_invoke,
    STATE(319), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(569), 3,
      sym_module,
      sym_script_module_binary,
      sym_script_module_quote,
    STATE(703), 3,
      sym_meta_input,
      sym_meta_output,
      sym_meta_script,
    STATE(687), 5,
      sym_action,
      sym_assertion,
      sym_meta,
      sym_register,
      sym_script_module,
    STATE(692), 9,
      sym_assert_exhaustion,
      sym_assert_invalid,
      sym_assert_malformed,
      sym_assert_return,
      sym_assert_return_arithmetic_nan,
      sym_assert_return_canonical_nan,
      sym_assert_trap_action,
      sym_assert_trap_module,
      sym_assert_unlinkable,
  [30193] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(980), 1,
      anon_sym_LPAREN,
    ACTIONS(986), 1,
      anon_sym_RPAREN,
    STATE(318), 1,
      aux_sym_ROOT_repeat1,
    STATE(699), 1,
      sym_command,
    STATE(565), 2,
      sym_action_get,
      sym_action_invoke,
    STATE(320), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(569), 3,
      sym_module,
      sym_script_module_binary,
      sym_script_module_quote,
    STATE(703), 3,
      sym_meta_input,
      sym_meta_output,
      sym_meta_script,
    STATE(687), 5,
      sym_action,
      sym_assertion,
      sym_meta,
      sym_register,
      sym_script_module,
    STATE(692), 9,
      sym_assert_exhaustion,
      sym_assert_invalid,
      sym_assert_malformed,
      sym_assert_return,
      sym_assert_return_arithmetic_nan,
      sym_assert_return_canonical_nan,
      sym_assert_trap_action,
      sym_assert_trap_module,
      sym_assert_unlinkable,
  [30252] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(980), 1,
      anon_sym_LPAREN,
    ACTIONS(988), 1,
      ts_builtin_sym_end,
    STATE(316), 1,
      aux_sym_ROOT_repeat1,
    STATE(699), 1,
      sym_command,
    STATE(565), 2,
      sym_action_get,
      sym_action_invoke,
    STATE(321), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(569), 3,
      sym_module,
      sym_script_module_binary,
      sym_script_module_quote,
    STATE(703), 3,
      sym_meta_input,
      sym_meta_output,
      sym_meta_script,
    STATE(687), 5,
      sym_action,
      sym_assertion,
      sym_meta,
      sym_register,
      sym_script_module,
    STATE(692), 9,
      sym_assert_exhaustion,
      sym_assert_invalid,
      sym_assert_malformed,
      sym_assert_return,
      sym_assert_return_arithmetic_nan,
      sym_assert_return_canonical_nan,
      sym_assert_trap_action,
      sym_assert_trap_module,
      sym_assert_unlinkable,
  [30311] = 29,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(990), 1,
      anon_sym_func,
    ACTIONS(992), 1,
      anon_sym_export,
    ACTIONS(994), 1,
      anon_sym_global,
    ACTIONS(996), 1,
      anon_sym_memory,
    ACTIONS(998), 1,
      anon_sym_table,
    ACTIONS(1000), 1,
      anon_sym_import,
    ACTIONS(1002), 1,
      anon_sym_type,
    ACTIONS(1004), 1,
      anon_sym_data,
    ACTIONS(1006), 1,
      anon_sym_module,
    ACTIONS(1008), 1,
      anon_sym_elem,
    ACTIONS(1010), 1,
      anon_sym_start,
    ACTIONS(1012), 1,
      anon_sym_get,
    ACTIONS(1014), 1,
      anon_sym_invoke,
    ACTIONS(1016), 1,
      anon_sym_assert_exhaustion,
    ACTIONS(1018), 1,
      anon_sym_assert_invalid,
    ACTIONS(1020), 1,
      anon_sym_assert_malformed,
    ACTIONS(1022), 1,
      anon_sym_assert_return,
    ACTIONS(1024), 1,
      anon_sym_assert_return_arithmetic_nan,
    ACTIONS(1026), 1,
      anon_sym_assert_return_canonical_nan,
    ACTIONS(1028), 1,
      anon_sym_assert_trap,
    ACTIONS(1030), 1,
      anon_sym_assert_unlinkable,
    ACTIONS(1032), 1,
      anon_sym_input,
    ACTIONS(1034), 1,
      anon_sym_output,
    ACTIONS(1036), 1,
      anon_sym_script,
    ACTIONS(1038), 1,
      anon_sym_register,
    STATE(322), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [30401] = 22,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1040), 1,
      anon_sym_LPAREN,
    ACTIONS(1042), 1,
      sym_identifier,
    ACTIONS(1044), 1,
      anon_sym_f32,
    ACTIONS(1046), 1,
      anon_sym_f64,
    ACTIONS(1048), 1,
      anon_sym_i32,
    ACTIONS(1050), 1,
      anon_sym_i64,
    ACTIONS(1052), 1,
      sym_num_type_v128,
    STATE(156), 1,
      sym_global_type,
    STATE(308), 1,
      sym_value_type,
    STATE(309), 1,
      sym_ref_type,
    STATE(311), 1,
      sym_ref_type_ref,
    STATE(324), 1,
      aux_sym_module_field_func_repeat1,
    STATE(329), 1,
      sym_import,
    STATE(410), 1,
      sym_export,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(305), 2,
      sym_value_type_num_type,
      sym_value_type_ref_type,
    STATE(310), 2,
      sym_global_type_imm,
      sym_global_type_mut,
    STATE(323), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(302), 4,
      sym_num_type_f32,
      sym_num_type_f64,
      sym_num_type_i32,
      sym_num_type_i64,
  [30476] = 21,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1040), 1,
      anon_sym_LPAREN,
    ACTIONS(1044), 1,
      anon_sym_f32,
    ACTIONS(1046), 1,
      anon_sym_f64,
    ACTIONS(1048), 1,
      anon_sym_i32,
    ACTIONS(1050), 1,
      anon_sym_i64,
    ACTIONS(1052), 1,
      sym_num_type_v128,
    STATE(155), 1,
      sym_global_type,
    STATE(308), 1,
      sym_value_type,
    STATE(309), 1,
      sym_ref_type,
    STATE(311), 1,
      sym_ref_type_ref,
    STATE(330), 1,
      sym_import,
    STATE(373), 1,
      aux_sym_module_field_func_repeat1,
    STATE(410), 1,
      sym_export,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(305), 2,
      sym_value_type_num_type,
      sym_value_type_ref_type,
    STATE(310), 2,
      sym_global_type_imm,
      sym_global_type_mut,
    STATE(324), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(302), 4,
      sym_num_type_f32,
      sym_num_type_f64,
      sym_num_type_i32,
      sym_num_type_i64,
  [30548] = 21,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1040), 1,
      anon_sym_LPAREN,
    ACTIONS(1044), 1,
      anon_sym_f32,
    ACTIONS(1046), 1,
      anon_sym_f64,
    ACTIONS(1048), 1,
      anon_sym_i32,
    ACTIONS(1050), 1,
      anon_sym_i64,
    ACTIONS(1052), 1,
      sym_num_type_v128,
    STATE(141), 1,
      sym_global_type,
    STATE(308), 1,
      sym_value_type,
    STATE(309), 1,
      sym_ref_type,
    STATE(311), 1,
      sym_ref_type_ref,
    STATE(331), 1,
      sym_import,
    STATE(373), 1,
      aux_sym_module_field_func_repeat1,
    STATE(410), 1,
      sym_export,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(305), 2,
      sym_value_type_num_type,
      sym_value_type_ref_type,
    STATE(310), 2,
      sym_global_type_imm,
      sym_global_type_mut,
    STATE(325), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(302), 4,
      sym_num_type_f32,
      sym_num_type_f64,
      sym_num_type_i32,
      sym_num_type_i64,
  [30620] = 21,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1040), 1,
      anon_sym_LPAREN,
    ACTIONS(1044), 1,
      anon_sym_f32,
    ACTIONS(1046), 1,
      anon_sym_f64,
    ACTIONS(1048), 1,
      anon_sym_i32,
    ACTIONS(1050), 1,
      anon_sym_i64,
    ACTIONS(1052), 1,
      sym_num_type_v128,
    STATE(153), 1,
      sym_global_type,
    STATE(308), 1,
      sym_value_type,
    STATE(309), 1,
      sym_ref_type,
    STATE(311), 1,
      sym_ref_type_ref,
    STATE(325), 1,
      aux_sym_module_field_func_repeat1,
    STATE(328), 1,
      sym_import,
    STATE(410), 1,
      sym_export,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(305), 2,
      sym_value_type_num_type,
      sym_value_type_ref_type,
    STATE(310), 2,
      sym_global_type_imm,
      sym_global_type_mut,
    STATE(326), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(302), 4,
      sym_num_type_f32,
      sym_num_type_f64,
      sym_num_type_i32,
      sym_num_type_i64,
  [30692] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1044), 1,
      anon_sym_f32,
    ACTIONS(1046), 1,
      anon_sym_f64,
    ACTIONS(1048), 1,
      anon_sym_i32,
    ACTIONS(1050), 1,
      anon_sym_i64,
    ACTIONS(1052), 1,
      sym_num_type_v128,
    ACTIONS(1056), 1,
      anon_sym_LPAREN,
    ACTIONS(1058), 1,
      sym_identifier,
    STATE(308), 1,
      sym_value_type,
    STATE(309), 1,
      sym_ref_type,
    STATE(311), 1,
      sym_ref_type_ref,
    STATE(799), 1,
      sym_global_type,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(305), 2,
      sym_value_type_num_type,
      sym_value_type_ref_type,
    STATE(310), 2,
      sym_global_type_imm,
      sym_global_type_mut,
    STATE(327), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(302), 4,
      sym_num_type_f32,
      sym_num_type_f64,
      sym_num_type_i32,
      sym_num_type_i64,
  [30758] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1044), 1,
      anon_sym_f32,
    ACTIONS(1046), 1,
      anon_sym_f64,
    ACTIONS(1048), 1,
      anon_sym_i32,
    ACTIONS(1050), 1,
      anon_sym_i64,
    ACTIONS(1052), 1,
      sym_num_type_v128,
    ACTIONS(1056), 1,
      anon_sym_LPAREN,
    STATE(141), 1,
      sym_global_type,
    STATE(308), 1,
      sym_value_type,
    STATE(309), 1,
      sym_ref_type,
    STATE(311), 1,
      sym_ref_type_ref,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(305), 2,
      sym_value_type_num_type,
      sym_value_type_ref_type,
    STATE(310), 2,
      sym_global_type_imm,
      sym_global_type_mut,
    STATE(328), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(302), 4,
      sym_num_type_f32,
      sym_num_type_f64,
      sym_num_type_i32,
      sym_num_type_i64,
  [30821] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1044), 1,
      anon_sym_f32,
    ACTIONS(1046), 1,
      anon_sym_f64,
    ACTIONS(1048), 1,
      anon_sym_i32,
    ACTIONS(1050), 1,
      anon_sym_i64,
    ACTIONS(1052), 1,
      sym_num_type_v128,
    ACTIONS(1056), 1,
      anon_sym_LPAREN,
    STATE(155), 1,
      sym_global_type,
    STATE(308), 1,
      sym_value_type,
    STATE(309), 1,
      sym_ref_type,
    STATE(311), 1,
      sym_ref_type_ref,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(305), 2,
      sym_value_type_num_type,
      sym_value_type_ref_type,
    STATE(310), 2,
      sym_global_type_imm,
      sym_global_type_mut,
    STATE(329), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(302), 4,
      sym_num_type_f32,
      sym_num_type_f64,
      sym_num_type_i32,
      sym_num_type_i64,
  [30884] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1044), 1,
      anon_sym_f32,
    ACTIONS(1046), 1,
      anon_sym_f64,
    ACTIONS(1048), 1,
      anon_sym_i32,
    ACTIONS(1050), 1,
      anon_sym_i64,
    ACTIONS(1052), 1,
      sym_num_type_v128,
    ACTIONS(1056), 1,
      anon_sym_LPAREN,
    STATE(147), 1,
      sym_global_type,
    STATE(308), 1,
      sym_value_type,
    STATE(309), 1,
      sym_ref_type,
    STATE(311), 1,
      sym_ref_type_ref,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(305), 2,
      sym_value_type_num_type,
      sym_value_type_ref_type,
    STATE(310), 2,
      sym_global_type_imm,
      sym_global_type_mut,
    STATE(330), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(302), 4,
      sym_num_type_f32,
      sym_num_type_f64,
      sym_num_type_i32,
      sym_num_type_i64,
  [30947] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1044), 1,
      anon_sym_f32,
    ACTIONS(1046), 1,
      anon_sym_f64,
    ACTIONS(1048), 1,
      anon_sym_i32,
    ACTIONS(1050), 1,
      anon_sym_i64,
    ACTIONS(1052), 1,
      sym_num_type_v128,
    ACTIONS(1056), 1,
      anon_sym_LPAREN,
    STATE(157), 1,
      sym_global_type,
    STATE(308), 1,
      sym_value_type,
    STATE(309), 1,
      sym_ref_type,
    STATE(311), 1,
      sym_ref_type_ref,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(305), 2,
      sym_value_type_num_type,
      sym_value_type_ref_type,
    STATE(310), 2,
      sym_global_type_imm,
      sym_global_type_mut,
    STATE(331), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(302), 4,
      sym_num_type_f32,
      sym_num_type_f64,
      sym_num_type_i32,
      sym_num_type_i64,
  [31010] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1044), 1,
      anon_sym_f32,
    ACTIONS(1046), 1,
      anon_sym_f64,
    ACTIONS(1048), 1,
      anon_sym_i32,
    ACTIONS(1050), 1,
      anon_sym_i64,
    ACTIONS(1052), 1,
      sym_num_type_v128,
    ACTIONS(1056), 1,
      anon_sym_LPAREN,
    STATE(308), 1,
      sym_value_type,
    STATE(309), 1,
      sym_ref_type,
    STATE(311), 1,
      sym_ref_type_ref,
    STATE(825), 1,
      sym_global_type,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(305), 2,
      sym_value_type_num_type,
      sym_value_type_ref_type,
    STATE(310), 2,
      sym_global_type_imm,
      sym_global_type_mut,
    STATE(332), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(302), 4,
      sym_num_type_f32,
      sym_num_type_f64,
      sym_num_type_i32,
      sym_num_type_i64,
  [31073] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1060), 1,
      anon_sym_RPAREN,
    ACTIONS(1062), 1,
      anon_sym_LPAREN,
    ACTIONS(1064), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_f32,
    ACTIONS(1068), 1,
      anon_sym_f64,
    ACTIONS(1070), 1,
      anon_sym_i32,
    ACTIONS(1072), 1,
      anon_sym_i64,
    ACTIONS(1074), 1,
      sym_num_type_v128,
    STATE(338), 1,
      aux_sym_func_locals_many_repeat1,
    STATE(379), 1,
      sym_ref_type,
    STATE(380), 1,
      sym_value_type,
    STATE(394), 1,
      sym_ref_type_ref,
    ACTIONS(1076), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(395), 2,
      sym_value_type_num_type,
      sym_value_type_ref_type,
    STATE(333), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(391), 4,
      sym_num_type_f32,
      sym_num_type_f64,
      sym_num_type_i32,
      sym_num_type_i64,
  [31138] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1062), 1,
      anon_sym_LPAREN,
    ACTIONS(1066), 1,
      anon_sym_f32,
    ACTIONS(1068), 1,
      anon_sym_f64,
    ACTIONS(1070), 1,
      anon_sym_i32,
    ACTIONS(1072), 1,
      anon_sym_i64,
    ACTIONS(1074), 1,
      sym_num_type_v128,
    ACTIONS(1078), 1,
      anon_sym_RPAREN,
    ACTIONS(1080), 1,
      sym_identifier,
    STATE(339), 1,
      aux_sym_func_locals_many_repeat1,
    STATE(379), 1,
      sym_ref_type,
    STATE(380), 1,
      sym_value_type,
    STATE(394), 1,
      sym_ref_type_ref,
    ACTIONS(1076), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(395), 2,
      sym_value_type_num_type,
      sym_value_type_ref_type,
    STATE(334), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(391), 4,
      sym_num_type_f32,
      sym_num_type_f64,
      sym_num_type_i32,
      sym_num_type_i64,
  [31203] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1082), 1,
      anon_sym_RPAREN,
    ACTIONS(1084), 1,
      anon_sym_LPAREN,
    ACTIONS(1087), 1,
      anon_sym_f32,
    ACTIONS(1090), 1,
      anon_sym_f64,
    ACTIONS(1093), 1,
      anon_sym_i32,
    ACTIONS(1096), 1,
      anon_sym_i64,
    ACTIONS(1099), 1,
      sym_num_type_v128,
    STATE(379), 1,
      sym_ref_type,
    STATE(380), 1,
      sym_value_type,
    STATE(394), 1,
      sym_ref_type_ref,
    ACTIONS(1102), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(395), 2,
      sym_value_type_num_type,
      sym_value_type_ref_type,
    STATE(335), 4,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
      aux_sym_func_locals_many_repeat1,
    STATE(391), 4,
      sym_num_type_f32,
      sym_num_type_f64,
      sym_num_type_i32,
      sym_num_type_i64,
  [31263] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1062), 1,
      anon_sym_LPAREN,
    ACTIONS(1066), 1,
      anon_sym_f32,
    ACTIONS(1068), 1,
      anon_sym_f64,
    ACTIONS(1070), 1,
      anon_sym_i32,
    ACTIONS(1072), 1,
      anon_sym_i64,
    ACTIONS(1074), 1,
      sym_num_type_v128,
    ACTIONS(1105), 1,
      anon_sym_RPAREN,
    STATE(341), 1,
      aux_sym_func_locals_many_repeat1,
    STATE(379), 1,
      sym_ref_type,
    STATE(380), 1,
      sym_value_type,
    STATE(394), 1,
      sym_ref_type_ref,
    ACTIONS(1076), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(395), 2,
      sym_value_type_num_type,
      sym_value_type_ref_type,
    STATE(336), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(391), 4,
      sym_num_type_f32,
      sym_num_type_f64,
      sym_num_type_i32,
      sym_num_type_i64,
  [31325] = 21,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(1107), 1,
      anon_sym_LPAREN,
    ACTIONS(1109), 1,
      anon_sym_func,
    ACTIONS(1111), 1,
      anon_sym_declare,
    STATE(185), 1,
      sym_nat,
    STATE(311), 1,
      sym_ref_type_ref,
    STATE(351), 1,
      sym_offset,
    STATE(359), 1,
      sym_index,
    STATE(381), 1,
      sym_expr,
    STATE(419), 1,
      sym_elem_kind,
    STATE(421), 1,
      sym_ref_type,
    STATE(516), 1,
      sym_table_use,
    STATE(872), 1,
      sym_elem_list,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(382), 2,
      sym_offset_const_expr,
      sym_offset_expr,
    STATE(337), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [31393] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1062), 1,
      anon_sym_LPAREN,
    ACTIONS(1066), 1,
      anon_sym_f32,
    ACTIONS(1068), 1,
      anon_sym_f64,
    ACTIONS(1070), 1,
      anon_sym_i32,
    ACTIONS(1072), 1,
      anon_sym_i64,
    ACTIONS(1074), 1,
      sym_num_type_v128,
    ACTIONS(1113), 1,
      anon_sym_RPAREN,
    STATE(335), 1,
      aux_sym_func_locals_many_repeat1,
    STATE(379), 1,
      sym_ref_type,
    STATE(380), 1,
      sym_value_type,
    STATE(394), 1,
      sym_ref_type_ref,
    ACTIONS(1076), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(395), 2,
      sym_value_type_num_type,
      sym_value_type_ref_type,
    STATE(338), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(391), 4,
      sym_num_type_f32,
      sym_num_type_f64,
      sym_num_type_i32,
      sym_num_type_i64,
  [31455] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1062), 1,
      anon_sym_LPAREN,
    ACTIONS(1066), 1,
      anon_sym_f32,
    ACTIONS(1068), 1,
      anon_sym_f64,
    ACTIONS(1070), 1,
      anon_sym_i32,
    ACTIONS(1072), 1,
      anon_sym_i64,
    ACTIONS(1074), 1,
      sym_num_type_v128,
    ACTIONS(1115), 1,
      anon_sym_RPAREN,
    STATE(335), 1,
      aux_sym_func_locals_many_repeat1,
    STATE(379), 1,
      sym_ref_type,
    STATE(380), 1,
      sym_value_type,
    STATE(394), 1,
      sym_ref_type_ref,
    ACTIONS(1076), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(395), 2,
      sym_value_type_num_type,
      sym_value_type_ref_type,
    STATE(339), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(391), 4,
      sym_num_type_f32,
      sym_num_type_f64,
      sym_num_type_i32,
      sym_num_type_i64,
  [31517] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1062), 1,
      anon_sym_LPAREN,
    ACTIONS(1066), 1,
      anon_sym_f32,
    ACTIONS(1068), 1,
      anon_sym_f64,
    ACTIONS(1070), 1,
      anon_sym_i32,
    ACTIONS(1072), 1,
      anon_sym_i64,
    ACTIONS(1074), 1,
      sym_num_type_v128,
    ACTIONS(1078), 1,
      anon_sym_RPAREN,
    STATE(339), 1,
      aux_sym_func_locals_many_repeat1,
    STATE(379), 1,
      sym_ref_type,
    STATE(380), 1,
      sym_value_type,
    STATE(394), 1,
      sym_ref_type_ref,
    ACTIONS(1076), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(395), 2,
      sym_value_type_num_type,
      sym_value_type_ref_type,
    STATE(340), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(391), 4,
      sym_num_type_f32,
      sym_num_type_f64,
      sym_num_type_i32,
      sym_num_type_i64,
  [31579] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1062), 1,
      anon_sym_LPAREN,
    ACTIONS(1066), 1,
      anon_sym_f32,
    ACTIONS(1068), 1,
      anon_sym_f64,
    ACTIONS(1070), 1,
      anon_sym_i32,
    ACTIONS(1072), 1,
      anon_sym_i64,
    ACTIONS(1074), 1,
      sym_num_type_v128,
    ACTIONS(1117), 1,
      anon_sym_RPAREN,
    STATE(335), 1,
      aux_sym_func_locals_many_repeat1,
    STATE(379), 1,
      sym_ref_type,
    STATE(380), 1,
      sym_value_type,
    STATE(394), 1,
      sym_ref_type_ref,
    ACTIONS(1076), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(395), 2,
      sym_value_type_num_type,
      sym_value_type_ref_type,
    STATE(341), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(391), 4,
      sym_num_type_f32,
      sym_num_type_f64,
      sym_num_type_i32,
      sym_num_type_i64,
  [31641] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1044), 1,
      anon_sym_f32,
    ACTIONS(1046), 1,
      anon_sym_f64,
    ACTIONS(1048), 1,
      anon_sym_i32,
    ACTIONS(1050), 1,
      anon_sym_i64,
    ACTIONS(1052), 1,
      sym_num_type_v128,
    ACTIONS(1119), 1,
      anon_sym_LPAREN,
    STATE(309), 1,
      sym_ref_type,
    STATE(311), 1,
      sym_ref_type_ref,
    STATE(916), 1,
      sym_value_type,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(305), 2,
      sym_value_type_num_type,
      sym_value_type_ref_type,
    STATE(342), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(302), 4,
      sym_num_type_f32,
      sym_num_type_f64,
      sym_num_type_i32,
      sym_num_type_i64,
  [31697] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(1121), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(1123), 1,
      anon_sym_ref_DOTnull,
    ACTIONS(1127), 1,
      sym_result_ref_func,
    STATE(802), 1,
      sym_op_const,
    STATE(814), 2,
      sym_op_simd_const,
      sym_op_const_ref,
    STATE(343), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(1125), 4,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_i32,
      anon_sym_i64,
    STATE(812), 4,
      sym_result_const,
      sym_result_const_nan,
      sym_result_ref_extern,
      sym_result_ref_null,
  [31749] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1129), 1,
      anon_sym_RPAREN,
    ACTIONS(1131), 1,
      anon_sym_LPAREN,
    ACTIONS(1133), 1,
      sym_identifier,
    ACTIONS(1135), 1,
      anon_sym_binary,
    ACTIONS(1137), 1,
      anon_sym_quote,
    STATE(360), 1,
      aux_sym_ROOT_repeat2,
    STATE(680), 1,
      sym_module_field,
    STATE(344), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(686), 10,
      sym_module_field_data,
      sym_module_field_elem,
      sym_module_field_export,
      sym_module_field_func,
      sym_module_field_global,
      sym_module_field_import,
      sym_module_field_memory,
      sym_module_field_start,
      sym_module_field_table,
      sym_module_field_type,
  [31797] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1044), 1,
      anon_sym_f32,
    ACTIONS(1046), 1,
      anon_sym_f64,
    ACTIONS(1048), 1,
      anon_sym_i32,
    ACTIONS(1050), 1,
      anon_sym_i64,
    ACTIONS(1052), 1,
      sym_num_type_v128,
    ACTIONS(1119), 1,
      anon_sym_LPAREN,
    STATE(309), 1,
      sym_ref_type,
    STATE(311), 1,
      sym_ref_type_ref,
    STATE(908), 1,
      sym_value_type,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(305), 2,
      sym_value_type_num_type,
      sym_value_type_ref_type,
    STATE(345), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(302), 4,
      sym_num_type_f32,
      sym_num_type_f64,
      sym_num_type_i32,
      sym_num_type_i64,
  [31853] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1044), 1,
      anon_sym_f32,
    ACTIONS(1046), 1,
      anon_sym_f64,
    ACTIONS(1048), 1,
      anon_sym_i32,
    ACTIONS(1050), 1,
      anon_sym_i64,
    ACTIONS(1052), 1,
      sym_num_type_v128,
    ACTIONS(1119), 1,
      anon_sym_LPAREN,
    STATE(309), 1,
      sym_ref_type,
    STATE(311), 1,
      sym_ref_type_ref,
    STATE(947), 1,
      sym_value_type,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(305), 2,
      sym_value_type_num_type,
      sym_value_type_ref_type,
    STATE(346), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(302), 4,
      sym_num_type_f32,
      sym_num_type_f64,
      sym_num_type_i32,
      sym_num_type_i64,
  [31909] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1131), 1,
      anon_sym_LPAREN,
    ACTIONS(1139), 1,
      anon_sym_RPAREN,
    ACTIONS(1141), 1,
      anon_sym_binary,
    ACTIONS(1143), 1,
      anon_sym_quote,
    STATE(361), 1,
      aux_sym_ROOT_repeat2,
    STATE(680), 1,
      sym_module_field,
    STATE(347), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(686), 10,
      sym_module_field_data,
      sym_module_field_elem,
      sym_module_field_export,
      sym_module_field_func,
      sym_module_field_global,
      sym_module_field_import,
      sym_module_field_memory,
      sym_module_field_start,
      sym_module_field_table,
      sym_module_field_type,
  [31954] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1145), 1,
      anon_sym_LPAREN,
    ACTIONS(1147), 1,
      sym_identifier,
    STATE(213), 1,
      sym_export,
    STATE(311), 1,
      sym_ref_type_ref,
    STATE(357), 1,
      aux_sym_module_field_func_repeat1,
    STATE(396), 1,
      sym_nat,
    STATE(497), 1,
      sym_limits,
    STATE(498), 1,
      sym_import,
    STATE(925), 1,
      sym_ref_type,
    STATE(951), 1,
      sym_table_type,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(950), 2,
      sym_table_fields_elem,
      sym_table_fields_type,
    STATE(348), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [32013] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      anon_sym_RPAREN,
    ACTIONS(1151), 1,
      anon_sym_LPAREN,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    STATE(185), 1,
      sym_nat,
    STATE(376), 1,
      sym_index,
    STATE(381), 1,
      sym_expr,
    STATE(529), 1,
      sym_memory_use,
    STATE(574), 1,
      aux_sym_memory_fields_data_repeat1,
    STATE(604), 1,
      sym_offset,
    STATE(754), 1,
      sym_string,
    STATE(382), 2,
      sym_offset_const_expr,
      sym_offset_expr,
    STATE(349), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [32071] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1145), 1,
      anon_sym_LPAREN,
    STATE(213), 1,
      sym_export,
    STATE(311), 1,
      sym_ref_type_ref,
    STATE(353), 1,
      aux_sym_module_field_func_repeat1,
    STATE(396), 1,
      sym_nat,
    STATE(497), 1,
      sym_limits,
    STATE(498), 1,
      sym_import,
    STATE(925), 1,
      sym_ref_type,
    STATE(951), 1,
      sym_table_type,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(879), 2,
      sym_table_fields_elem,
      sym_table_fields_type,
    STATE(350), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [32127] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(1109), 1,
      anon_sym_func,
    ACTIONS(1119), 1,
      anon_sym_LPAREN,
    ACTIONS(1155), 1,
      anon_sym_RPAREN,
    STATE(185), 1,
      sym_nat,
    STATE(210), 1,
      sym_index,
    STATE(311), 1,
      sym_ref_type_ref,
    STATE(419), 1,
      sym_elem_kind,
    STATE(421), 1,
      sym_ref_type,
    STATE(429), 1,
      aux_sym_elem_list_repeat1,
    STATE(942), 1,
      sym_elem_list,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(351), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [32185] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1159), 1,
      anon_sym_LPAREN,
    STATE(680), 1,
      sym_module_field,
    ACTIONS(1157), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(352), 4,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
      aux_sym_ROOT_repeat2,
    STATE(686), 10,
      sym_module_field_data,
      sym_module_field_elem,
      sym_module_field_export,
      sym_module_field_func,
      sym_module_field_global,
      sym_module_field_import,
      sym_module_field_memory,
      sym_module_field_start,
      sym_module_field_table,
      sym_module_field_type,
  [32223] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1145), 1,
      anon_sym_LPAREN,
    STATE(207), 1,
      aux_sym_module_field_func_repeat1,
    STATE(213), 1,
      sym_export,
    STATE(311), 1,
      sym_ref_type_ref,
    STATE(396), 1,
      sym_nat,
    STATE(497), 1,
      sym_limits,
    STATE(498), 1,
      sym_import,
    STATE(925), 1,
      sym_ref_type,
    STATE(951), 1,
      sym_table_type,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(854), 2,
      sym_table_fields_elem,
      sym_table_fields_type,
    STATE(353), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [32279] = 19,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1006), 1,
      anon_sym_module,
    ACTIONS(1012), 1,
      anon_sym_get,
    ACTIONS(1014), 1,
      anon_sym_invoke,
    ACTIONS(1016), 1,
      anon_sym_assert_exhaustion,
    ACTIONS(1018), 1,
      anon_sym_assert_invalid,
    ACTIONS(1020), 1,
      anon_sym_assert_malformed,
    ACTIONS(1022), 1,
      anon_sym_assert_return,
    ACTIONS(1024), 1,
      anon_sym_assert_return_arithmetic_nan,
    ACTIONS(1026), 1,
      anon_sym_assert_return_canonical_nan,
    ACTIONS(1028), 1,
      anon_sym_assert_trap,
    ACTIONS(1030), 1,
      anon_sym_assert_unlinkable,
    ACTIONS(1032), 1,
      anon_sym_input,
    ACTIONS(1034), 1,
      anon_sym_output,
    ACTIONS(1036), 1,
      anon_sym_script,
    ACTIONS(1038), 1,
      anon_sym_register,
    STATE(354), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [32339] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(1109), 1,
      anon_sym_func,
    ACTIONS(1119), 1,
      anon_sym_LPAREN,
    ACTIONS(1162), 1,
      anon_sym_RPAREN,
    STATE(185), 1,
      sym_nat,
    STATE(210), 1,
      sym_index,
    STATE(311), 1,
      sym_ref_type_ref,
    STATE(419), 1,
      sym_elem_kind,
    STATE(420), 1,
      aux_sym_elem_list_repeat1,
    STATE(421), 1,
      sym_ref_type,
    STATE(787), 1,
      sym_elem_list,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(355), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [32397] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(1109), 1,
      anon_sym_func,
    ACTIONS(1119), 1,
      anon_sym_LPAREN,
    ACTIONS(1164), 1,
      anon_sym_RPAREN,
    STATE(185), 1,
      sym_nat,
    STATE(210), 1,
      sym_index,
    STATE(311), 1,
      sym_ref_type_ref,
    STATE(414), 1,
      aux_sym_elem_list_repeat1,
    STATE(419), 1,
      sym_elem_kind,
    STATE(421), 1,
      sym_ref_type,
    STATE(866), 1,
      sym_elem_list,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(356), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [32455] = 17,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1145), 1,
      anon_sym_LPAREN,
    STATE(207), 1,
      aux_sym_module_field_func_repeat1,
    STATE(213), 1,
      sym_export,
    STATE(311), 1,
      sym_ref_type_ref,
    STATE(396), 1,
      sym_nat,
    STATE(497), 1,
      sym_limits,
    STATE(498), 1,
      sym_import,
    STATE(925), 1,
      sym_ref_type,
    STATE(951), 1,
      sym_table_type,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(935), 2,
      sym_table_fields_elem,
      sym_table_fields_type,
    STATE(357), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [32511] = 18,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(87), 1,
      anon_sym_LPAREN,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(1166), 1,
      anon_sym_RPAREN,
    STATE(185), 1,
      sym_nat,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(387), 1,
      sym_index,
    STATE(411), 1,
      sym_type_use,
    STATE(412), 1,
      aux_sym_block_block_repeat1,
    STATE(452), 1,
      aux_sym_block_block_repeat2,
    STATE(619), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(358), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [32568] = 16,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1107), 1,
      anon_sym_LPAREN,
    ACTIONS(1109), 1,
      anon_sym_func,
    ACTIONS(1168), 1,
      anon_sym_declare,
    STATE(311), 1,
      sym_ref_type_ref,
    STATE(355), 1,
      sym_offset,
    STATE(381), 1,
      sym_expr,
    STATE(419), 1,
      sym_elem_kind,
    STATE(421), 1,
      sym_ref_type,
    STATE(486), 1,
      sym_table_use,
    STATE(942), 1,
      sym_elem_list,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(382), 2,
      sym_offset_const_expr,
      sym_offset_expr,
    STATE(359), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [32621] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1131), 1,
      anon_sym_LPAREN,
    ACTIONS(1170), 1,
      anon_sym_RPAREN,
    STATE(352), 1,
      aux_sym_ROOT_repeat2,
    STATE(680), 1,
      sym_module_field,
    STATE(360), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(686), 10,
      sym_module_field_data,
      sym_module_field_elem,
      sym_module_field_export,
      sym_module_field_func,
      sym_module_field_global,
      sym_module_field_import,
      sym_module_field_memory,
      sym_module_field_start,
      sym_module_field_table,
      sym_module_field_type,
  [32660] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1131), 1,
      anon_sym_LPAREN,
    ACTIONS(1172), 1,
      anon_sym_RPAREN,
    STATE(352), 1,
      aux_sym_ROOT_repeat2,
    STATE(680), 1,
      sym_module_field,
    STATE(361), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(686), 10,
      sym_module_field_data,
      sym_module_field_elem,
      sym_module_field_export,
      sym_module_field_func,
      sym_module_field_global,
      sym_module_field_import,
      sym_module_field_memory,
      sym_module_field_start,
      sym_module_field_table,
      sym_module_field_type,
  [32699] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(988), 1,
      ts_builtin_sym_end,
    ACTIONS(1131), 1,
      anon_sym_LPAREN,
    STATE(352), 1,
      aux_sym_ROOT_repeat2,
    STATE(680), 1,
      sym_module_field,
    STATE(362), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(686), 10,
      sym_module_field_data,
      sym_module_field_elem,
      sym_module_field_export,
      sym_module_field_func,
      sym_module_field_global,
      sym_module_field_import,
      sym_module_field_memory,
      sym_module_field_start,
      sym_module_field_table,
      sym_module_field_type,
  [32738] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1174), 1,
      anon_sym_LPAREN,
    ACTIONS(1176), 1,
      sym_identifier,
    STATE(213), 1,
      sym_export,
    STATE(371), 1,
      aux_sym_module_field_func_repeat1,
    STATE(396), 1,
      sym_nat,
    STATE(532), 1,
      sym_import,
    STATE(893), 1,
      sym_memory_type,
    STATE(923), 1,
      sym_limits,
    STATE(890), 2,
      sym_memory_fields_data,
      sym_memory_fields_type,
    STATE(363), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [32787] = 15,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(1178), 1,
      anon_sym_RPAREN,
    ACTIONS(1180), 1,
      anon_sym_LPAREN,
    STATE(185), 1,
      sym_nat,
    STATE(210), 1,
      sym_index,
    STATE(423), 1,
      sym_elem_expr,
    STATE(427), 1,
      aux_sym_elem_list_repeat1,
    STATE(757), 1,
      sym_expr,
    STATE(758), 2,
      sym_elem_expr_expr,
      sym_elem_expr_item,
    STATE(364), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [32836] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1182), 1,
      anon_sym_RPAREN,
    ACTIONS(1184), 1,
      anon_sym_LPAREN,
    ACTIONS(1187), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(1190), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1193), 1,
      sym_identifier,
    ACTIONS(1196), 1,
      sym_reserved,
    ACTIONS(1199), 1,
      anon_sym_DQUOTE,
    STATE(489), 1,
      sym_annotation_part,
    STATE(365), 4,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
      aux_sym_annotation_repeat1,
    STATE(490), 4,
      sym_annotation_parens,
      sym_comment_block_annot,
      sym_comment_line_annot,
      sym_string,
  [32876] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1202), 1,
      anon_sym_RPAREN,
    ACTIONS(1204), 1,
      anon_sym_LPAREN,
    ACTIONS(1206), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(1208), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1210), 1,
      sym_identifier,
    ACTIONS(1212), 1,
      sym_reserved,
    ACTIONS(1214), 1,
      anon_sym_DQUOTE,
    STATE(365), 1,
      aux_sym_annotation_repeat1,
    STATE(489), 1,
      sym_annotation_part,
    STATE(366), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(490), 4,
      sym_annotation_parens,
      sym_comment_block_annot,
      sym_comment_line_annot,
      sym_string,
  [32918] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1174), 1,
      anon_sym_LPAREN,
    STATE(207), 1,
      aux_sym_module_field_func_repeat1,
    STATE(213), 1,
      sym_export,
    STATE(396), 1,
      sym_nat,
    STATE(532), 1,
      sym_import,
    STATE(893), 1,
      sym_memory_type,
    STATE(923), 1,
      sym_limits,
    STATE(776), 2,
      sym_memory_fields_data,
      sym_memory_fields_type,
    STATE(367), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [32964] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1174), 1,
      anon_sym_LPAREN,
    STATE(213), 1,
      sym_export,
    STATE(367), 1,
      aux_sym_module_field_func_repeat1,
    STATE(396), 1,
      sym_nat,
    STATE(532), 1,
      sym_import,
    STATE(893), 1,
      sym_memory_type,
    STATE(923), 1,
      sym_limits,
    STATE(937), 2,
      sym_memory_fields_data,
      sym_memory_fields_type,
    STATE(368), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [33010] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1204), 1,
      anon_sym_LPAREN,
    ACTIONS(1206), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(1208), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1210), 1,
      sym_identifier,
    ACTIONS(1212), 1,
      sym_reserved,
    ACTIONS(1214), 1,
      anon_sym_DQUOTE,
    ACTIONS(1216), 1,
      anon_sym_RPAREN,
    STATE(372), 1,
      aux_sym_annotation_repeat1,
    STATE(489), 1,
      sym_annotation_part,
    STATE(369), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(490), 4,
      sym_annotation_parens,
      sym_comment_block_annot,
      sym_comment_line_annot,
      sym_string,
  [33052] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1204), 1,
      anon_sym_LPAREN,
    ACTIONS(1206), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(1208), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1210), 1,
      sym_identifier,
    ACTIONS(1212), 1,
      sym_reserved,
    ACTIONS(1214), 1,
      anon_sym_DQUOTE,
    ACTIONS(1218), 1,
      anon_sym_RPAREN,
    STATE(366), 1,
      aux_sym_annotation_repeat1,
    STATE(489), 1,
      sym_annotation_part,
    STATE(370), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(490), 4,
      sym_annotation_parens,
      sym_comment_block_annot,
      sym_comment_line_annot,
      sym_string,
  [33094] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1174), 1,
      anon_sym_LPAREN,
    STATE(207), 1,
      aux_sym_module_field_func_repeat1,
    STATE(213), 1,
      sym_export,
    STATE(396), 1,
      sym_nat,
    STATE(532), 1,
      sym_import,
    STATE(893), 1,
      sym_memory_type,
    STATE(923), 1,
      sym_limits,
    STATE(847), 2,
      sym_memory_fields_data,
      sym_memory_fields_type,
    STATE(371), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [33140] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1204), 1,
      anon_sym_LPAREN,
    ACTIONS(1206), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(1208), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1210), 1,
      sym_identifier,
    ACTIONS(1212), 1,
      sym_reserved,
    ACTIONS(1214), 1,
      anon_sym_DQUOTE,
    ACTIONS(1220), 1,
      anon_sym_RPAREN,
    STATE(365), 1,
      aux_sym_annotation_repeat1,
    STATE(489), 1,
      sym_annotation_part,
    STATE(372), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(490), 4,
      sym_annotation_parens,
      sym_comment_block_annot,
      sym_comment_line_annot,
      sym_string,
  [33182] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1222), 1,
      anon_sym_LPAREN,
    STATE(410), 1,
      sym_export,
    STATE(373), 4,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
      aux_sym_module_field_func_repeat1,
    ACTIONS(570), 7,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_i32,
      anon_sym_i64,
      sym_num_type_v128,
      sym_ref_type_externref,
      sym_ref_type_funcref,
  [33213] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1225), 1,
      anon_sym_RPAREN,
    ACTIONS(1227), 1,
      anon_sym_LPAREN,
    ACTIONS(1229), 1,
      sym_identifier,
    STATE(401), 1,
      aux_sym_import_desc_func_type_repeat1,
    STATE(731), 1,
      sym_func_type,
    STATE(793), 1,
      sym_type_use,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(741), 2,
      sym_func_type_params,
      sym_func_type_results,
    STATE(374), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [33254] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1231), 1,
      anon_sym_LPAREN,
    ACTIONS(1233), 1,
      sym_identifier,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(428), 1,
      sym_type_use,
    STATE(431), 1,
      aux_sym_block_block_repeat1,
    STATE(473), 1,
      aux_sym_block_block_repeat2,
    STATE(682), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(875), 1,
      sym_if_block,
    STATE(375), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [33299] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1151), 1,
      anon_sym_LPAREN,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1235), 1,
      anon_sym_RPAREN,
    STATE(381), 1,
      sym_expr,
    STATE(481), 1,
      sym_memory_use,
    STATE(555), 1,
      aux_sym_memory_fields_data_repeat1,
    STATE(611), 1,
      sym_offset,
    STATE(754), 1,
      sym_string,
    STATE(382), 2,
      sym_offset_const_expr,
      sym_offset_expr,
    STATE(376), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [33342] = 14,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(990), 1,
      anon_sym_func,
    ACTIONS(992), 1,
      anon_sym_export,
    ACTIONS(994), 1,
      anon_sym_global,
    ACTIONS(996), 1,
      anon_sym_memory,
    ACTIONS(998), 1,
      anon_sym_table,
    ACTIONS(1000), 1,
      anon_sym_import,
    ACTIONS(1002), 1,
      anon_sym_type,
    ACTIONS(1004), 1,
      anon_sym_data,
    ACTIONS(1008), 1,
      anon_sym_elem,
    ACTIONS(1010), 1,
      anon_sym_start,
    STATE(377), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [33387] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1231), 1,
      anon_sym_LPAREN,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(428), 1,
      sym_type_use,
    STATE(431), 1,
      aux_sym_block_block_repeat1,
    STATE(473), 1,
      aux_sym_block_block_repeat2,
    STATE(682), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(871), 1,
      sym_if_block,
    STATE(378), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [33429] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(947), 1,
      anon_sym_LPAREN,
    STATE(379), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(945), 8,
      anon_sym_RPAREN,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_i32,
      anon_sym_i64,
      sym_num_type_v128,
      sym_ref_type_externref,
      sym_ref_type_funcref,
  [33457] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1239), 1,
      anon_sym_LPAREN,
    STATE(380), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(1237), 8,
      anon_sym_RPAREN,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_i32,
      anon_sym_i64,
      sym_num_type_v128,
      sym_ref_type_externref,
      sym_ref_type_funcref,
  [33485] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1243), 3,
      anon_sym_LPAREN,
      sym_dec_nat,
      anon_sym_func,
    STATE(381), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(1241), 6,
      anon_sym_RPAREN,
      sym_hex_nat,
      sym_identifier,
      sym_ref_type_externref,
      sym_ref_type_funcref,
      anon_sym_DQUOTE,
  [33513] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1247), 3,
      anon_sym_LPAREN,
      sym_dec_nat,
      anon_sym_func,
    STATE(382), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(1245), 6,
      anon_sym_RPAREN,
      sym_hex_nat,
      sym_identifier,
      sym_ref_type_externref,
      sym_ref_type_funcref,
      anon_sym_DQUOTE,
  [33541] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(935), 1,
      anon_sym_LPAREN,
    STATE(383), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(933), 8,
      anon_sym_RPAREN,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_i32,
      anon_sym_i64,
      sym_num_type_v128,
      sym_ref_type_externref,
      sym_ref_type_funcref,
  [33569] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(923), 1,
      anon_sym_LPAREN,
    STATE(384), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(921), 8,
      anon_sym_RPAREN,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_i32,
      anon_sym_i64,
      sym_num_type_v128,
      sym_ref_type_externref,
      sym_ref_type_funcref,
  [33597] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(939), 1,
      anon_sym_LPAREN,
    STATE(385), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(937), 8,
      anon_sym_RPAREN,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_i32,
      anon_sym_i64,
      sym_num_type_v128,
      sym_ref_type_externref,
      sym_ref_type_funcref,
  [33625] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(967), 1,
      anon_sym_LPAREN,
    STATE(386), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(965), 8,
      anon_sym_RPAREN,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_i32,
      anon_sym_i64,
      sym_num_type_v128,
      sym_ref_type_externref,
      sym_ref_type_funcref,
  [33653] = 13,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(87), 1,
      anon_sym_LPAREN,
    ACTIONS(1249), 1,
      anon_sym_RPAREN,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(404), 1,
      sym_type_use,
    STATE(405), 1,
      aux_sym_block_block_repeat1,
    STATE(434), 1,
      aux_sym_block_block_repeat2,
    STATE(599), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(387), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [33695] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(963), 1,
      anon_sym_LPAREN,
    STATE(388), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(961), 8,
      anon_sym_RPAREN,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_i32,
      anon_sym_i64,
      sym_num_type_v128,
      sym_ref_type_externref,
      sym_ref_type_funcref,
  [33723] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1253), 3,
      anon_sym_LPAREN,
      sym_dec_nat,
      anon_sym_func,
    STATE(389), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(1251), 6,
      anon_sym_RPAREN,
      sym_hex_nat,
      sym_identifier,
      sym_ref_type_externref,
      sym_ref_type_funcref,
      anon_sym_DQUOTE,
  [33751] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    STATE(390), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(969), 8,
      anon_sym_RPAREN,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_i32,
      anon_sym_i64,
      sym_num_type_v128,
      sym_ref_type_externref,
      sym_ref_type_funcref,
  [33779] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(919), 1,
      anon_sym_LPAREN,
    STATE(391), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(917), 8,
      anon_sym_RPAREN,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_i32,
      anon_sym_i64,
      sym_num_type_v128,
      sym_ref_type_externref,
      sym_ref_type_funcref,
  [33807] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1227), 1,
      anon_sym_LPAREN,
    ACTIONS(1255), 1,
      anon_sym_RPAREN,
    STATE(408), 1,
      aux_sym_import_desc_func_type_repeat1,
    STATE(731), 1,
      sym_func_type,
    STATE(822), 1,
      sym_type_use,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(741), 2,
      sym_func_type_params,
      sym_func_type_results,
    STATE(392), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [33845] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1259), 3,
      anon_sym_LPAREN,
      sym_dec_nat,
      anon_sym_func,
    STATE(393), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(1257), 6,
      anon_sym_RPAREN,
      sym_hex_nat,
      sym_identifier,
      sym_ref_type_externref,
      sym_ref_type_funcref,
      anon_sym_DQUOTE,
  [33873] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(955), 1,
      anon_sym_LPAREN,
    STATE(394), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(953), 8,
      anon_sym_RPAREN,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_i32,
      anon_sym_i64,
      sym_num_type_v128,
      sym_ref_type_externref,
      sym_ref_type_funcref,
  [33901] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(931), 1,
      anon_sym_LPAREN,
    STATE(395), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(929), 8,
      anon_sym_RPAREN,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_i32,
      anon_sym_i64,
      sym_num_type_v128,
      sym_ref_type_externref,
      sym_ref_type_funcref,
  [33929] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1263), 1,
      anon_sym_LPAREN,
    ACTIONS(1265), 1,
      sym_share,
    STATE(482), 1,
      sym_nat,
    ACTIONS(1261), 3,
      anon_sym_RPAREN,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(396), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [33964] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(43), 1,
      aux_sym_op_const_token1,
    ACTIONS(45), 1,
      aux_sym_op_const_token2,
    ACTIONS(53), 1,
      anon_sym_v128_DOTconst,
    ACTIONS(1267), 1,
      anon_sym_ref_DOTextern,
    ACTIONS(1269), 1,
      anon_sym_ref_DOTnull,
    STATE(802), 1,
      sym_op_const,
    STATE(779), 2,
      sym_op_simd_const,
      sym_op_const_ref,
    STATE(397), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [34001] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1271), 1,
      anon_sym_LPAREN,
    STATE(729), 1,
      sym_action,
    STATE(730), 1,
      sym_script_module,
    STATE(565), 2,
      sym_action_get,
      sym_action_invoke,
    STATE(398), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(569), 3,
      sym_module,
      sym_script_module_binary,
      sym_script_module_quote,
  [34034] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(1273), 1,
      anon_sym_RPAREN,
    STATE(211), 1,
      aux_sym_block_block_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(453), 1,
      aux_sym_block_block_repeat2,
    STATE(540), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(399), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [34073] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1109), 1,
      anon_sym_func,
    ACTIONS(1119), 1,
      anon_sym_LPAREN,
    STATE(311), 1,
      sym_ref_type_ref,
    STATE(419), 1,
      sym_elem_kind,
    STATE(421), 1,
      sym_ref_type,
    STATE(942), 1,
      sym_elem_list,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(400), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [34110] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1255), 1,
      anon_sym_RPAREN,
    ACTIONS(1275), 1,
      anon_sym_LPAREN,
    STATE(403), 1,
      aux_sym_import_desc_func_type_repeat1,
    STATE(731), 1,
      sym_func_type,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(741), 2,
      sym_func_type_params,
      sym_func_type_results,
    STATE(401), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [34145] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1275), 1,
      anon_sym_LPAREN,
    ACTIONS(1277), 1,
      anon_sym_RPAREN,
    STATE(403), 1,
      aux_sym_import_desc_func_type_repeat1,
    STATE(731), 1,
      sym_func_type,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(741), 2,
      sym_func_type_params,
      sym_func_type_results,
    STATE(402), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [34180] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1279), 1,
      anon_sym_RPAREN,
    ACTIONS(1281), 1,
      anon_sym_LPAREN,
    STATE(731), 1,
      sym_func_type,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(741), 2,
      sym_func_type_params,
      sym_func_type_results,
    STATE(403), 4,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
      aux_sym_import_desc_func_type_repeat1,
  [34213] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(1284), 1,
      anon_sym_RPAREN,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(399), 1,
      aux_sym_block_block_repeat1,
    STATE(446), 1,
      aux_sym_block_block_repeat2,
    STATE(583), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(404), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [34252] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(1284), 1,
      anon_sym_RPAREN,
    STATE(211), 1,
      aux_sym_block_block_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(446), 1,
      aux_sym_block_block_repeat2,
    STATE(583), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(405), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [34291] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1109), 1,
      anon_sym_func,
    ACTIONS(1119), 1,
      anon_sym_LPAREN,
    STATE(311), 1,
      sym_ref_type_ref,
    STATE(419), 1,
      sym_elem_kind,
    STATE(421), 1,
      sym_ref_type,
    STATE(787), 1,
      sym_elem_list,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(406), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [34328] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(623), 1,
      anon_sym_LPAREN,
    STATE(407), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(621), 7,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_i32,
      anon_sym_i64,
      sym_num_type_v128,
      sym_ref_type_externref,
      sym_ref_type_funcref,
  [34355] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1275), 1,
      anon_sym_LPAREN,
    ACTIONS(1286), 1,
      anon_sym_RPAREN,
    STATE(403), 1,
      aux_sym_import_desc_func_type_repeat1,
    STATE(731), 1,
      sym_func_type,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(741), 2,
      sym_func_type_params,
      sym_func_type_results,
    STATE(408), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [34390] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    STATE(409), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(831), 7,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_i32,
      anon_sym_i64,
      sym_num_type_v128,
      sym_ref_type_externref,
      sym_ref_type_funcref,
  [34417] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(598), 1,
      anon_sym_LPAREN,
    STATE(410), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(596), 7,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_i32,
      anon_sym_i64,
      sym_num_type_v128,
      sym_ref_type_externref,
      sym_ref_type_funcref,
  [34444] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(1249), 1,
      anon_sym_RPAREN,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(405), 1,
      aux_sym_block_block_repeat1,
    STATE(434), 1,
      aux_sym_block_block_repeat2,
    STATE(599), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(411), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [34483] = 12,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(121), 1,
      anon_sym_LPAREN,
    ACTIONS(1249), 1,
      anon_sym_RPAREN,
    STATE(211), 1,
      aux_sym_block_block_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(434), 1,
      aux_sym_block_block_repeat2,
    STATE(599), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(412), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [34522] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1275), 1,
      anon_sym_LPAREN,
    ACTIONS(1288), 1,
      anon_sym_RPAREN,
    STATE(402), 1,
      aux_sym_import_desc_func_type_repeat1,
    STATE(731), 1,
      sym_func_type,
    STATE(297), 2,
      sym_func_type_params_many,
      sym_func_type_params_one,
    STATE(741), 2,
      sym_func_type_params,
      sym_func_type_results,
    STATE(413), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [34557] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(1290), 1,
      anon_sym_RPAREN,
    STATE(185), 1,
      sym_nat,
    STATE(193), 1,
      aux_sym_elem_list_repeat1,
    STATE(210), 1,
      sym_index,
    STATE(414), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [34593] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1292), 1,
      anon_sym_RPAREN,
    ACTIONS(1294), 1,
      anon_sym_LPAREN,
    STATE(757), 1,
      sym_expr,
    STATE(760), 1,
      sym_elem_expr,
    STATE(758), 2,
      sym_elem_expr_expr,
      sym_elem_expr_item,
    STATE(415), 4,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
      aux_sym_elem_list_repeat2,
  [34625] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(1297), 1,
      sym_ref_kind,
    ACTIONS(1299), 1,
      anon_sym_null,
    STATE(185), 1,
      sym_nat,
    STATE(960), 1,
      sym_index,
    STATE(416), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [34661] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1301), 1,
      anon_sym_LPAREN,
    STATE(845), 1,
      sym_import_desc,
    STATE(417), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(844), 5,
      sym_import_desc_func_type,
      sym_import_desc_global_type,
      sym_import_desc_memory_type,
      sym_import_desc_table_type,
      sym_import_desc_type_use,
  [34689] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1180), 1,
      anon_sym_LPAREN,
    ACTIONS(1303), 1,
      anon_sym_RPAREN,
    STATE(415), 1,
      aux_sym_elem_list_repeat2,
    STATE(757), 1,
      sym_expr,
    STATE(760), 1,
      sym_elem_expr,
    STATE(758), 2,
      sym_elem_expr_expr,
      sym_elem_expr_item,
    STATE(418), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [34723] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(1305), 1,
      anon_sym_RPAREN,
    STATE(185), 1,
      sym_nat,
    STATE(210), 1,
      sym_index,
    STATE(425), 1,
      aux_sym_elem_list_repeat1,
    STATE(419), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [34759] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(1164), 1,
      anon_sym_RPAREN,
    STATE(185), 1,
      sym_nat,
    STATE(193), 1,
      aux_sym_elem_list_repeat1,
    STATE(210), 1,
      sym_index,
    STATE(420), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [34795] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1180), 1,
      anon_sym_LPAREN,
    ACTIONS(1305), 1,
      anon_sym_RPAREN,
    STATE(422), 1,
      aux_sym_elem_list_repeat2,
    STATE(757), 1,
      sym_expr,
    STATE(760), 1,
      sym_elem_expr,
    STATE(758), 2,
      sym_elem_expr_expr,
      sym_elem_expr_item,
    STATE(421), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [34829] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1180), 1,
      anon_sym_LPAREN,
    ACTIONS(1307), 1,
      anon_sym_RPAREN,
    STATE(415), 1,
      aux_sym_elem_list_repeat2,
    STATE(757), 1,
      sym_expr,
    STATE(760), 1,
      sym_elem_expr,
    STATE(758), 2,
      sym_elem_expr_expr,
      sym_elem_expr_item,
    STATE(422), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [34863] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1180), 1,
      anon_sym_LPAREN,
    ACTIONS(1309), 1,
      anon_sym_RPAREN,
    STATE(418), 1,
      aux_sym_elem_list_repeat2,
    STATE(757), 1,
      sym_expr,
    STATE(760), 1,
      sym_elem_expr,
    STATE(758), 2,
      sym_elem_expr_expr,
      sym_elem_expr_item,
    STATE(423), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [34897] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(1311), 1,
      anon_sym_RPAREN,
    ACTIONS(1313), 1,
      sym_ref_kind,
    STATE(185), 1,
      sym_nat,
    STATE(855), 1,
      sym_index,
    STATE(424), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [34933] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(1307), 1,
      anon_sym_RPAREN,
    STATE(185), 1,
      sym_nat,
    STATE(193), 1,
      aux_sym_elem_list_repeat1,
    STATE(210), 1,
      sym_index,
    STATE(425), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [34969] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1315), 1,
      anon_sym_LPAREN,
    STATE(211), 1,
      aux_sym_block_block_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(488), 1,
      aux_sym_block_block_repeat2,
    STATE(711), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(426), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35005] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(1309), 1,
      anon_sym_RPAREN,
    STATE(185), 1,
      sym_nat,
    STATE(193), 1,
      aux_sym_elem_list_repeat1,
    STATE(210), 1,
      sym_index,
    STATE(427), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35041] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1317), 1,
      anon_sym_LPAREN,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(426), 1,
      aux_sym_block_block_repeat1,
    STATE(487), 1,
      aux_sym_block_block_repeat2,
    STATE(709), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(428), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35077] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(1162), 1,
      anon_sym_RPAREN,
    STATE(185), 1,
      sym_nat,
    STATE(193), 1,
      aux_sym_elem_list_repeat1,
    STATE(210), 1,
      sym_index,
    STATE(429), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35113] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(1319), 1,
      sym_ref_kind,
    ACTIONS(1321), 1,
      anon_sym_null,
    STATE(185), 1,
      sym_nat,
    STATE(912), 1,
      sym_index,
    STATE(430), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35149] = 11,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1317), 1,
      anon_sym_LPAREN,
    STATE(211), 1,
      aux_sym_block_block_repeat1,
    STATE(245), 1,
      sym_func_type_params_many,
    STATE(298), 1,
      sym_func_type_results,
    STATE(487), 1,
      aux_sym_block_block_repeat2,
    STATE(709), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(431), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35185] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1323), 1,
      sym_dec_float,
    ACTIONS(1327), 1,
      sym_sign,
    STATE(451), 1,
      sym_float,
    ACTIONS(1325), 3,
      anon_sym_inf,
      sym_hex_float,
      sym_nan,
    STATE(432), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35214] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1323), 1,
      sym_dec_float,
    ACTIONS(1327), 1,
      sym_sign,
    STATE(458), 1,
      sym_float,
    ACTIONS(1325), 3,
      anon_sym_inf,
      sym_hex_float,
      sym_nan,
    STATE(433), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35243] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    ACTIONS(1284), 1,
      anon_sym_RPAREN,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(583), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(434), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35276] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1323), 1,
      sym_dec_float,
    ACTIONS(1327), 1,
      sym_sign,
    STATE(437), 1,
      sym_float,
    ACTIONS(1325), 3,
      anon_sym_inf,
      sym_hex_float,
      sym_nan,
    STATE(435), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35305] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1329), 1,
      anon_sym_LPAREN,
    STATE(956), 1,
      sym_export_desc,
    STATE(436), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(957), 4,
      sym_export_desc_func,
      sym_export_desc_global,
      sym_export_desc_memory,
      sym_export_desc_table,
  [35332] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1323), 1,
      sym_dec_float,
    ACTIONS(1327), 1,
      sym_sign,
    STATE(456), 1,
      sym_float,
    ACTIONS(1325), 3,
      anon_sym_inf,
      sym_hex_float,
      sym_nan,
    STATE(437), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35361] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1331), 1,
      anon_sym_f32x4,
    ACTIONS(1333), 1,
      anon_sym_f64x2,
    ACTIONS(1335), 1,
      anon_sym_i8x16,
    ACTIONS(1337), 1,
      anon_sym_i16x8,
    ACTIONS(1339), 1,
      anon_sym_i32x4,
    ACTIONS(1341), 1,
      anon_sym_i64x2,
    STATE(438), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35394] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1323), 1,
      sym_dec_float,
    ACTIONS(1327), 1,
      sym_sign,
    STATE(445), 1,
      sym_float,
    ACTIONS(1325), 3,
      anon_sym_inf,
      sym_hex_float,
      sym_nan,
    STATE(439), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35423] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1323), 1,
      sym_dec_float,
    ACTIONS(1327), 1,
      sym_sign,
    STATE(243), 1,
      sym_float,
    ACTIONS(1325), 3,
      anon_sym_inf,
      sym_hex_float,
      sym_nan,
    STATE(440), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35452] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(1313), 1,
      sym_ref_kind,
    STATE(185), 1,
      sym_nat,
    STATE(855), 1,
      sym_index,
    STATE(441), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35485] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1323), 1,
      sym_dec_float,
    ACTIONS(1327), 1,
      sym_sign,
    STATE(457), 1,
      sym_float,
    ACTIONS(1325), 3,
      anon_sym_inf,
      sym_hex_float,
      sym_nan,
    STATE(442), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35514] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1323), 1,
      sym_dec_float,
    ACTIONS(1327), 1,
      sym_sign,
    STATE(440), 1,
      sym_float,
    ACTIONS(1325), 3,
      anon_sym_inf,
      sym_hex_float,
      sym_nan,
    STATE(443), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35543] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(1343), 1,
      sym_ref_kind,
    STATE(185), 1,
      sym_nat,
    STATE(962), 1,
      sym_index,
    STATE(444), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35576] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1323), 1,
      sym_dec_float,
    ACTIONS(1327), 1,
      sym_sign,
    STATE(435), 1,
      sym_float,
    ACTIONS(1325), 3,
      anon_sym_inf,
      sym_hex_float,
      sym_nan,
    STATE(445), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35605] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    ACTIONS(1273), 1,
      anon_sym_RPAREN,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(540), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(446), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35638] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1323), 1,
      sym_dec_float,
    ACTIONS(1327), 1,
      sym_sign,
    STATE(461), 1,
      sym_float,
    ACTIONS(1325), 3,
      anon_sym_inf,
      sym_hex_float,
      sym_nan,
    STATE(447), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35667] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1345), 1,
      sym_identifier,
    STATE(396), 1,
      sym_nat,
    STATE(497), 1,
      sym_limits,
    STATE(777), 1,
      sym_table_type,
    STATE(448), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35700] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1347), 1,
      sym_identifier,
    STATE(396), 1,
      sym_nat,
    STATE(803), 1,
      sym_memory_type,
    STATE(923), 1,
      sym_limits,
    STATE(449), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35733] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1323), 1,
      sym_dec_float,
    ACTIONS(1327), 1,
      sym_sign,
    STATE(256), 1,
      sym_float,
    ACTIONS(1325), 3,
      anon_sym_inf,
      sym_hex_float,
      sym_nan,
    STATE(450), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35762] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1323), 1,
      sym_dec_float,
    ACTIONS(1327), 1,
      sym_sign,
    STATE(433), 1,
      sym_float,
    ACTIONS(1325), 3,
      anon_sym_inf,
      sym_hex_float,
      sym_nan,
    STATE(451), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35791] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    ACTIONS(1249), 1,
      anon_sym_RPAREN,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(599), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(452), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35824] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(165), 1,
      anon_sym_LPAREN,
    ACTIONS(1349), 1,
      anon_sym_RPAREN,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(552), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(453), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35857] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1323), 1,
      sym_dec_float,
    ACTIONS(1327), 1,
      sym_sign,
    STATE(463), 1,
      sym_float,
    ACTIONS(1325), 3,
      anon_sym_inf,
      sym_hex_float,
      sym_nan,
    STATE(454), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35886] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1323), 1,
      sym_dec_float,
    ACTIONS(1327), 1,
      sym_sign,
    STATE(464), 1,
      sym_float,
    ACTIONS(1325), 3,
      anon_sym_inf,
      sym_hex_float,
      sym_nan,
    STATE(455), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35915] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1323), 1,
      sym_dec_float,
    ACTIONS(1327), 1,
      sym_sign,
    STATE(443), 1,
      sym_float,
    ACTIONS(1325), 3,
      anon_sym_inf,
      sym_hex_float,
      sym_nan,
    STATE(456), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35944] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1323), 1,
      sym_dec_float,
    ACTIONS(1327), 1,
      sym_sign,
    STATE(263), 1,
      sym_float,
    ACTIONS(1325), 3,
      anon_sym_inf,
      sym_hex_float,
      sym_nan,
    STATE(457), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [35973] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1323), 1,
      sym_dec_float,
    ACTIONS(1327), 1,
      sym_sign,
    STATE(460), 1,
      sym_float,
    ACTIONS(1325), 3,
      anon_sym_inf,
      sym_hex_float,
      sym_nan,
    STATE(458), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36002] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(1351), 1,
      sym_ref_kind,
    STATE(185), 1,
      sym_nat,
    STATE(910), 1,
      sym_index,
    STATE(459), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36035] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1323), 1,
      sym_dec_float,
    ACTIONS(1327), 1,
      sym_sign,
    STATE(462), 1,
      sym_float,
    ACTIONS(1325), 3,
      anon_sym_inf,
      sym_hex_float,
      sym_nan,
    STATE(460), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36064] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1323), 1,
      sym_dec_float,
    ACTIONS(1327), 1,
      sym_sign,
    STATE(432), 1,
      sym_float,
    ACTIONS(1325), 3,
      anon_sym_inf,
      sym_hex_float,
      sym_nan,
    STATE(461), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36093] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1323), 1,
      sym_dec_float,
    ACTIONS(1327), 1,
      sym_sign,
    STATE(466), 1,
      sym_float,
    ACTIONS(1325), 3,
      anon_sym_inf,
      sym_hex_float,
      sym_nan,
    STATE(462), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36122] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1323), 1,
      sym_dec_float,
    ACTIONS(1327), 1,
      sym_sign,
    STATE(285), 1,
      sym_float,
    ACTIONS(1325), 3,
      anon_sym_inf,
      sym_hex_float,
      sym_nan,
    STATE(463), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36151] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1323), 1,
      sym_dec_float,
    ACTIONS(1327), 1,
      sym_sign,
    STATE(442), 1,
      sym_float,
    ACTIONS(1325), 3,
      anon_sym_inf,
      sym_hex_float,
      sym_nan,
    STATE(464), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36180] = 10,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    ACTIONS(1353), 1,
      sym_ref_kind,
    STATE(185), 1,
      sym_nat,
    STATE(252), 1,
      sym_index,
    STATE(465), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36213] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1323), 1,
      sym_dec_float,
    ACTIONS(1327), 1,
      sym_sign,
    STATE(439), 1,
      sym_float,
    ACTIONS(1325), 3,
      anon_sym_inf,
      sym_hex_float,
      sym_nan,
    STATE(466), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36242] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(519), 1,
      sym_int,
    STATE(467), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36272] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    STATE(185), 1,
      sym_nat,
    STATE(946), 1,
      sym_index,
    STATE(468), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36302] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    STATE(185), 1,
      sym_nat,
    STATE(792), 1,
      sym_index,
    STATE(469), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36332] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(477), 1,
      sym_int,
    STATE(470), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36362] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(476), 1,
      sym_int,
    STATE(471), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36392] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(467), 1,
      sym_int,
    STATE(472), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36422] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1357), 1,
      anon_sym_LPAREN,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(709), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(473), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36452] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(256), 1,
      sym_int,
    STATE(474), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36482] = 4,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1361), 2,
      anon_sym_LPAREN,
      sym_reserved,
    STATE(475), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(1359), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN_SEMI,
      aux_sym_comment_line_token1,
      sym_identifier,
      anon_sym_DQUOTE,
  [36502] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(515), 1,
      sym_int,
    STATE(476), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36532] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(513), 1,
      sym_int,
    STATE(477), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36562] = 4,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1365), 2,
      anon_sym_LPAREN,
      sym_reserved,
    STATE(478), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(1363), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN_SEMI,
      aux_sym_comment_line_token1,
      sym_identifier,
      anon_sym_DQUOTE,
  [36582] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    STATE(185), 1,
      sym_nat,
    STATE(197), 1,
      sym_index,
    STATE(479), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36612] = 4,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1369), 2,
      anon_sym_LPAREN,
      sym_reserved,
    STATE(480), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(1367), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN_SEMI,
      aux_sym_comment_line_token1,
      sym_identifier,
      anon_sym_DQUOTE,
  [36632] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1371), 1,
      anon_sym_LPAREN,
    STATE(381), 1,
      sym_expr,
    STATE(542), 1,
      sym_offset,
    STATE(382), 2,
      sym_offset_const_expr,
      sym_offset_expr,
    STATE(481), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36660] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1375), 1,
      anon_sym_LPAREN,
    ACTIONS(1377), 1,
      sym_share,
    ACTIONS(1373), 3,
      anon_sym_RPAREN,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(482), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36686] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    STATE(185), 1,
      sym_nat,
    STATE(189), 1,
      sym_index,
    STATE(483), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36716] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(285), 1,
      sym_int,
    STATE(484), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36746] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(284), 1,
      sym_int,
    STATE(485), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36776] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1371), 1,
      anon_sym_LPAREN,
    STATE(356), 1,
      sym_offset,
    STATE(381), 1,
      sym_expr,
    STATE(382), 2,
      sym_offset_const_expr,
      sym_offset_expr,
    STATE(486), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36804] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1379), 1,
      anon_sym_LPAREN,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(711), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(487), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36834] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1381), 1,
      anon_sym_LPAREN,
    STATE(215), 1,
      aux_sym_block_block_repeat2,
    STATE(298), 1,
      sym_func_type_results,
    STATE(639), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(488), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36864] = 4,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1385), 2,
      anon_sym_LPAREN,
      sym_reserved,
    STATE(489), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(1383), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN_SEMI,
      aux_sym_comment_line_token1,
      sym_identifier,
      anon_sym_DQUOTE,
  [36884] = 4,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1389), 2,
      anon_sym_LPAREN,
      sym_reserved,
    STATE(490), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(1387), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN_SEMI,
      aux_sym_comment_line_token1,
      sym_identifier,
      anon_sym_DQUOTE,
  [36904] = 4,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1393), 2,
      anon_sym_LPAREN,
      sym_reserved,
    STATE(491), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(1391), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN_SEMI,
      aux_sym_comment_line_token1,
      sym_identifier,
      anon_sym_DQUOTE,
  [36924] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(244), 1,
      sym_int,
    STATE(492), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36954] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(492), 1,
      sym_int,
    STATE(493), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [36984] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    STATE(185), 1,
      sym_nat,
    STATE(275), 1,
      sym_index,
    STATE(494), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37014] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(493), 1,
      sym_int,
    STATE(495), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37044] = 4,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1397), 2,
      anon_sym_LPAREN,
      sym_reserved,
    STATE(496), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(1395), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN_SEMI,
      aux_sym_comment_line_token1,
      sym_identifier,
      anon_sym_DQUOTE,
  [37064] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1119), 1,
      anon_sym_LPAREN,
    STATE(311), 1,
      sym_ref_type_ref,
    STATE(805), 1,
      sym_ref_type,
    ACTIONS(1054), 2,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(497), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37092] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    STATE(396), 1,
      sym_nat,
    STATE(497), 1,
      sym_limits,
    STATE(857), 1,
      sym_table_type,
    STATE(498), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37122] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(495), 1,
      sym_int,
    STATE(499), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37152] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1399), 1,
      anon_sym_LPAREN,
    STATE(762), 1,
      sym_script_module,
    STATE(500), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(569), 3,
      sym_module,
      sym_script_module_binary,
      sym_script_module_quote,
  [37178] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(499), 1,
      sym_int,
    STATE(501), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37208] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    STATE(185), 1,
      sym_nat,
    STATE(929), 1,
      sym_index,
    STATE(502), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37238] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    STATE(185), 1,
      sym_nat,
    STATE(927), 1,
      sym_index,
    STATE(503), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37268] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    STATE(185), 1,
      sym_nat,
    STATE(920), 1,
      sym_index,
    STATE(504), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37298] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    STATE(185), 1,
      sym_nat,
    STATE(917), 1,
      sym_index,
    STATE(505), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37328] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(501), 1,
      sym_int,
    STATE(506), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37358] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(484), 1,
      sym_int,
    STATE(507), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37388] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(506), 1,
      sym_int,
    STATE(508), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37418] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    STATE(185), 1,
      sym_nat,
    STATE(795), 1,
      sym_index,
    STATE(509), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37448] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(508), 1,
      sym_int,
    STATE(510), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37478] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(247), 1,
      sym_int,
    STATE(511), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37508] = 4,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1403), 2,
      anon_sym_LPAREN,
      sym_reserved,
    STATE(512), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(1401), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN_SEMI,
      aux_sym_comment_line_token1,
      sym_identifier,
      anon_sym_DQUOTE,
  [37528] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(535), 1,
      sym_int,
    STATE(513), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37558] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(510), 1,
      sym_int,
    STATE(514), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37588] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(534), 1,
      sym_int,
    STATE(515), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37618] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1371), 1,
      anon_sym_LPAREN,
    STATE(355), 1,
      sym_offset,
    STATE(381), 1,
      sym_expr,
    STATE(382), 2,
      sym_offset_const_expr,
      sym_offset_expr,
    STATE(516), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37646] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(511), 1,
      sym_int,
    STATE(517), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37676] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(514), 1,
      sym_int,
    STATE(518), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37706] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(263), 1,
      sym_int,
    STATE(519), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37736] = 4,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1407), 2,
      anon_sym_LPAREN,
      sym_reserved,
    STATE(520), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    ACTIONS(1405), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN_SEMI,
      aux_sym_comment_line_token1,
      sym_identifier,
      anon_sym_DQUOTE,
  [37756] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(262), 1,
      sym_int,
    STATE(521), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37786] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(472), 1,
      sym_int,
    STATE(522), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37816] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(517), 1,
      sym_int,
    STATE(523), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37846] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(518), 1,
      sym_int,
    STATE(524), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37876] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1399), 1,
      anon_sym_LPAREN,
    STATE(747), 1,
      sym_script_module,
    STATE(525), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(569), 3,
      sym_module,
      sym_script_module_binary,
      sym_script_module_quote,
  [37902] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(471), 1,
      sym_int,
    STATE(526), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37932] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    STATE(396), 1,
      sym_nat,
    STATE(827), 1,
      sym_memory_type,
    STATE(923), 1,
      sym_limits,
    STATE(527), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37962] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    STATE(396), 1,
      sym_nat,
    STATE(497), 1,
      sym_limits,
    STATE(829), 1,
      sym_table_type,
    STATE(528), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [37992] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1371), 1,
      anon_sym_LPAREN,
    STATE(381), 1,
      sym_expr,
    STATE(611), 1,
      sym_offset,
    STATE(382), 2,
      sym_offset_const_expr,
      sym_offset_expr,
    STATE(529), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38020] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    STATE(185), 1,
      sym_nat,
    STATE(949), 1,
      sym_index,
    STATE(530), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38050] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1399), 1,
      anon_sym_LPAREN,
    STATE(748), 1,
      sym_script_module,
    STATE(531), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
    STATE(569), 3,
      sym_module,
      sym_script_module_binary,
      sym_script_module_quote,
  [38076] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    STATE(396), 1,
      sym_nat,
    STATE(923), 1,
      sym_limits,
    STATE(940), 1,
      sym_memory_type,
    STATE(532), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38106] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    STATE(185), 1,
      sym_nat,
    STATE(252), 1,
      sym_index,
    STATE(533), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38136] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(523), 1,
      sym_int,
    STATE(534), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38166] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(524), 1,
      sym_int,
    STATE(535), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38196] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1355), 1,
      sym_sign,
    STATE(208), 1,
      sym_nat,
    STATE(470), 1,
      sym_int,
    STATE(536), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38226] = 9,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(434), 1,
      sym_identifier,
    STATE(185), 1,
      sym_nat,
    STATE(941), 1,
      sym_index,
    STATE(537), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38256] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1409), 1,
      anon_sym_RPAREN,
    STATE(614), 1,
      aux_sym_memory_fields_data_repeat1,
    STATE(754), 1,
      sym_string,
    STATE(538), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38283] = 7,
    ACTIONS(1411), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1413), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(1415), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1417), 1,
      sym_escape_sequence,
    ACTIONS(1420), 1,
      anon_sym_DQUOTE,
    ACTIONS(1422), 1,
      aux_sym_string_token1,
    STATE(539), 4,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
      aux_sym_string_repeat1,
  [38308] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(1349), 1,
      anon_sym_RPAREN,
    STATE(595), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(540), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38335] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1427), 1,
      sym_dec_nat,
    ACTIONS(1425), 3,
      anon_sym_RPAREN,
      sym_hex_nat,
      sym_identifier,
    STATE(541), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38358] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1429), 1,
      anon_sym_RPAREN,
    STATE(550), 1,
      aux_sym_memory_fields_data_repeat1,
    STATE(754), 1,
      sym_string,
    STATE(542), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38385] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1429), 1,
      anon_sym_RPAREN,
    STATE(614), 1,
      aux_sym_memory_fields_data_repeat1,
    STATE(754), 1,
      sym_string,
    STATE(543), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38412] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1433), 1,
      anon_sym_LPAREN,
    ACTIONS(1431), 3,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
    STATE(544), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38435] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1437), 1,
      anon_sym_LPAREN,
    ACTIONS(1435), 3,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
    STATE(545), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38458] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1439), 1,
      anon_sym_RPAREN,
    STATE(614), 1,
      aux_sym_memory_fields_data_repeat1,
    STATE(754), 1,
      sym_string,
    STATE(546), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38485] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1443), 1,
      anon_sym_LPAREN,
    ACTIONS(1441), 3,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
    STATE(547), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38508] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1445), 1,
      sym_identifier,
    STATE(603), 1,
      sym_string,
    STATE(954), 1,
      sym_name,
    STATE(548), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38535] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1447), 1,
      anon_sym_LPAREN,
    STATE(773), 1,
      sym_action,
    STATE(565), 2,
      sym_action_get,
      sym_action_invoke,
    STATE(549), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38560] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1449), 1,
      anon_sym_RPAREN,
    STATE(614), 1,
      aux_sym_memory_fields_data_repeat1,
    STATE(754), 1,
      sym_string,
    STATE(550), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38587] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1451), 1,
      anon_sym_RPAREN,
    ACTIONS(1453), 1,
      anon_sym_LPAREN,
    STATE(573), 1,
      aux_sym_assert_return_repeat1,
    STATE(738), 1,
      sym_result,
    STATE(551), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38614] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(1455), 1,
      anon_sym_RPAREN,
    STATE(595), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(552), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38641] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1457), 1,
      anon_sym_func,
    ACTIONS(1459), 1,
      anon_sym_global,
    ACTIONS(1461), 1,
      anon_sym_memory,
    ACTIONS(1463), 1,
      anon_sym_table,
    STATE(553), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38668] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1465), 3,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
    STATE(554), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38691] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1469), 1,
      anon_sym_RPAREN,
    STATE(614), 1,
      aux_sym_memory_fields_data_repeat1,
    STATE(754), 1,
      sym_string,
    STATE(555), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38718] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1473), 1,
      anon_sym_LPAREN,
    ACTIONS(1471), 3,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
    STATE(556), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38741] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1475), 3,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
    STATE(557), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38764] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1479), 1,
      anon_sym_RPAREN,
    ACTIONS(1481), 1,
      anon_sym_LPAREN,
    STATE(563), 1,
      aux_sym_action_invoke_repeat1,
    STATE(752), 1,
      sym_expr_plain_const,
    STATE(558), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38791] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1483), 1,
      anon_sym_RPAREN,
    STATE(593), 1,
      aux_sym_memory_fields_data_repeat1,
    STATE(754), 1,
      sym_string,
    STATE(559), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38818] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1453), 1,
      anon_sym_LPAREN,
    ACTIONS(1485), 1,
      anon_sym_RPAREN,
    STATE(573), 1,
      aux_sym_assert_return_repeat1,
    STATE(738), 1,
      sym_result,
    STATE(560), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38845] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1447), 1,
      anon_sym_LPAREN,
    STATE(582), 1,
      sym_action,
    STATE(565), 2,
      sym_action_get,
      sym_action_invoke,
    STATE(561), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38870] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1447), 1,
      anon_sym_LPAREN,
    STATE(590), 1,
      sym_action,
    STATE(565), 2,
      sym_action_get,
      sym_action_invoke,
    STATE(562), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38895] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1487), 1,
      anon_sym_RPAREN,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    STATE(752), 1,
      sym_expr_plain_const,
    STATE(563), 4,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
      aux_sym_action_invoke_repeat1,
  [38920] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1494), 1,
      anon_sym_LPAREN,
    ACTIONS(1492), 3,
      anon_sym_RPAREN,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(564), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38943] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1498), 1,
      anon_sym_LPAREN,
    ACTIONS(1496), 3,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
    STATE(565), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38966] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1500), 1,
      sym_dec_float,
    ACTIONS(1502), 3,
      anon_sym_inf,
      sym_hex_float,
      sym_nan,
    STATE(566), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [38989] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    ACTIONS(1504), 1,
      anon_sym_RPAREN,
    STATE(855), 1,
      sym_nat,
    STATE(567), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39016] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1506), 1,
      anon_sym_RPAREN,
    STATE(614), 1,
      aux_sym_memory_fields_data_repeat1,
    STATE(754), 1,
      sym_string,
    STATE(568), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39043] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1510), 1,
      anon_sym_LPAREN,
    ACTIONS(1508), 3,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
    STATE(569), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39066] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1512), 1,
      anon_sym_RPAREN,
    STATE(607), 1,
      aux_sym_memory_fields_data_repeat1,
    STATE(754), 1,
      sym_string,
    STATE(570), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39093] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1516), 1,
      anon_sym_LPAREN,
    ACTIONS(1514), 3,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
    STATE(571), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39116] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1447), 1,
      anon_sym_LPAREN,
    STATE(585), 1,
      sym_action,
    STATE(565), 2,
      sym_action_get,
      sym_action_invoke,
    STATE(572), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39141] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1518), 1,
      anon_sym_RPAREN,
    ACTIONS(1520), 1,
      anon_sym_LPAREN,
    STATE(738), 1,
      sym_result,
    STATE(573), 4,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
      aux_sym_assert_return_repeat1,
  [39166] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1235), 1,
      anon_sym_RPAREN,
    STATE(614), 1,
      aux_sym_memory_fields_data_repeat1,
    STATE(754), 1,
      sym_string,
    STATE(574), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39193] = 7,
    ACTIONS(1411), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1415), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1523), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(1526), 1,
      anon_sym_SEMI_RPAREN,
    ACTIONS(1528), 1,
      sym_comment_block_inner,
    STATE(763), 1,
      sym_comment_block_annot,
    STATE(575), 4,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
      aux_sym_comment_block_annot_repeat1,
  [39218] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1481), 1,
      anon_sym_LPAREN,
    ACTIONS(1531), 1,
      anon_sym_RPAREN,
    STATE(563), 1,
      aux_sym_action_invoke_repeat1,
    STATE(752), 1,
      sym_expr_plain_const,
    STATE(576), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39245] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1533), 1,
      anon_sym_RPAREN,
    ACTIONS(1535), 1,
      sym_identifier,
    STATE(903), 1,
      sym_string,
    STATE(577), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39272] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1539), 1,
      anon_sym_LPAREN,
    ACTIONS(1537), 3,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
    STATE(578), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39295] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1453), 1,
      anon_sym_LPAREN,
    ACTIONS(1541), 1,
      anon_sym_RPAREN,
    STATE(573), 1,
      aux_sym_assert_return_repeat1,
    STATE(738), 1,
      sym_result,
    STATE(579), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39322] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1481), 1,
      anon_sym_LPAREN,
    ACTIONS(1531), 1,
      anon_sym_RPAREN,
    STATE(558), 1,
      aux_sym_action_invoke_repeat1,
    STATE(752), 1,
      sym_expr_plain_const,
    STATE(580), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39349] = 8,
    ACTIONS(1411), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1415), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1543), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(1545), 1,
      anon_sym_SEMI_RPAREN,
    ACTIONS(1547), 1,
      sym_comment_block_inner,
    STATE(610), 1,
      aux_sym_comment_block_annot_repeat1,
    STATE(763), 1,
      sym_comment_block_annot,
    STATE(581), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39376] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1453), 1,
      anon_sym_LPAREN,
    ACTIONS(1549), 1,
      anon_sym_RPAREN,
    STATE(560), 1,
      aux_sym_assert_return_repeat1,
    STATE(738), 1,
      sym_result,
    STATE(582), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39403] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(1273), 1,
      anon_sym_RPAREN,
    STATE(595), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(583), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39430] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1553), 1,
      anon_sym_LPAREN,
    ACTIONS(1551), 3,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
    STATE(584), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39453] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1453), 1,
      anon_sym_LPAREN,
    ACTIONS(1555), 1,
      anon_sym_RPAREN,
    STATE(579), 1,
      aux_sym_assert_return_repeat1,
    STATE(738), 1,
      sym_result,
    STATE(585), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39480] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(1557), 1,
      anon_sym_RPAREN,
    STATE(605), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(586), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39507] = 8,
    ACTIONS(1411), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1413), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(1415), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1559), 1,
      sym_escape_sequence,
    ACTIONS(1561), 1,
      anon_sym_DQUOTE,
    ACTIONS(1563), 1,
      aux_sym_string_token1,
    STATE(618), 1,
      aux_sym_string_repeat1,
    STATE(587), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39534] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1361), 1,
      anon_sym_LPAREN,
    ACTIONS(1359), 3,
      anon_sym_RPAREN,
      sym_identifier,
      anon_sym_DQUOTE,
    STATE(588), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39557] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1567), 1,
      anon_sym_LPAREN,
    ACTIONS(1565), 3,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
    STATE(589), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39580] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1453), 1,
      anon_sym_LPAREN,
    ACTIONS(1569), 1,
      anon_sym_RPAREN,
    STATE(551), 1,
      aux_sym_assert_return_repeat1,
    STATE(738), 1,
      sym_result,
    STATE(590), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39607] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1397), 1,
      anon_sym_LPAREN,
    ACTIONS(1395), 3,
      anon_sym_RPAREN,
      sym_identifier,
      anon_sym_DQUOTE,
    STATE(591), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39630] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1573), 1,
      anon_sym_LPAREN,
    ACTIONS(1571), 3,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
    STATE(592), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39653] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1575), 1,
      anon_sym_RPAREN,
    STATE(614), 1,
      aux_sym_memory_fields_data_repeat1,
    STATE(754), 1,
      sym_string,
    STATE(593), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39680] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1579), 1,
      anon_sym_LPAREN,
    ACTIONS(1577), 3,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
    STATE(594), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39703] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1581), 1,
      anon_sym_RPAREN,
    ACTIONS(1583), 1,
      anon_sym_LPAREN,
    STATE(745), 1,
      sym_expr,
    STATE(595), 4,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
      aux_sym_expr1_call_repeat1,
  [39728] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1588), 1,
      anon_sym_LPAREN,
    ACTIONS(1586), 3,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
    STATE(596), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39751] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1592), 1,
      anon_sym_LPAREN,
    ACTIONS(1590), 3,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
    STATE(597), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39774] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1481), 1,
      anon_sym_LPAREN,
    ACTIONS(1594), 1,
      anon_sym_RPAREN,
    STATE(576), 1,
      aux_sym_action_invoke_repeat1,
    STATE(752), 1,
      sym_expr_plain_const,
    STATE(598), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39801] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(1284), 1,
      anon_sym_RPAREN,
    STATE(595), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(599), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39828] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1375), 1,
      anon_sym_LPAREN,
    ACTIONS(1373), 3,
      anon_sym_RPAREN,
      sym_ref_type_externref,
      sym_ref_type_funcref,
    STATE(600), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39851] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1596), 1,
      anon_sym_RPAREN,
    STATE(568), 1,
      aux_sym_memory_fields_data_repeat1,
    STATE(754), 1,
      sym_string,
    STATE(601), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39878] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1598), 1,
      anon_sym_export,
    ACTIONS(1600), 1,
      anon_sym_mut,
    ACTIONS(1602), 1,
      anon_sym_import,
    ACTIONS(1604), 1,
      anon_sym_ref,
    STATE(602), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39905] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1608), 1,
      anon_sym_LPAREN,
    ACTIONS(1606), 3,
      anon_sym_RPAREN,
      sym_identifier,
      anon_sym_DQUOTE,
    STATE(603), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39928] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1235), 1,
      anon_sym_RPAREN,
    STATE(555), 1,
      aux_sym_memory_fields_data_repeat1,
    STATE(754), 1,
      sym_string,
    STATE(604), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39955] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(1610), 1,
      anon_sym_RPAREN,
    STATE(595), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(605), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [39982] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1612), 1,
      anon_sym_func,
    ACTIONS(1614), 1,
      anon_sym_global,
    ACTIONS(1616), 1,
      anon_sym_memory,
    ACTIONS(1618), 1,
      anon_sym_table,
    STATE(606), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40009] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1620), 1,
      anon_sym_RPAREN,
    STATE(614), 1,
      aux_sym_memory_fields_data_repeat1,
    STATE(754), 1,
      sym_string,
    STATE(607), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40036] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1624), 1,
      anon_sym_LPAREN,
    ACTIONS(1622), 3,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
    STATE(608), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40059] = 8,
    ACTIONS(1411), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1415), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1543), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(1547), 1,
      sym_comment_block_inner,
    ACTIONS(1626), 1,
      anon_sym_SEMI_RPAREN,
    STATE(613), 1,
      aux_sym_comment_block_annot_repeat1,
    STATE(763), 1,
      sym_comment_block_annot,
    STATE(609), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40086] = 8,
    ACTIONS(1411), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1415), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1543), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(1547), 1,
      sym_comment_block_inner,
    ACTIONS(1628), 1,
      anon_sym_SEMI_RPAREN,
    STATE(575), 1,
      aux_sym_comment_block_annot_repeat1,
    STATE(763), 1,
      sym_comment_block_annot,
    STATE(610), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40113] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1469), 1,
      anon_sym_RPAREN,
    STATE(543), 1,
      aux_sym_memory_fields_data_repeat1,
    STATE(754), 1,
      sym_string,
    STATE(611), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40140] = 8,
    ACTIONS(1411), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1413), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(1415), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1559), 1,
      sym_escape_sequence,
    ACTIONS(1563), 1,
      aux_sym_string_token1,
    ACTIONS(1630), 1,
      anon_sym_DQUOTE,
    STATE(615), 1,
      aux_sym_string_repeat1,
    STATE(612), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40167] = 8,
    ACTIONS(1411), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1415), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1543), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(1547), 1,
      sym_comment_block_inner,
    ACTIONS(1632), 1,
      anon_sym_SEMI_RPAREN,
    STATE(575), 1,
      aux_sym_comment_block_annot_repeat1,
    STATE(763), 1,
      sym_comment_block_annot,
    STATE(613), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40194] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1634), 1,
      anon_sym_RPAREN,
    ACTIONS(1636), 1,
      anon_sym_DQUOTE,
    STATE(754), 1,
      sym_string,
    STATE(614), 4,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
      aux_sym_memory_fields_data_repeat1,
  [40219] = 8,
    ACTIONS(1411), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1413), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(1415), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1559), 1,
      sym_escape_sequence,
    ACTIONS(1563), 1,
      aux_sym_string_token1,
    ACTIONS(1639), 1,
      anon_sym_DQUOTE,
    STATE(539), 1,
      aux_sym_string_repeat1,
    STATE(615), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40246] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1575), 1,
      anon_sym_RPAREN,
    STATE(546), 1,
      aux_sym_memory_fields_data_repeat1,
    STATE(754), 1,
      sym_string,
    STATE(616), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40273] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1641), 1,
      sym_identifier,
    STATE(598), 1,
      sym_name,
    STATE(603), 1,
      sym_string,
    STATE(617), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40300] = 8,
    ACTIONS(1411), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1413), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(1415), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1559), 1,
      sym_escape_sequence,
    ACTIONS(1563), 1,
      aux_sym_string_token1,
    ACTIONS(1643), 1,
      anon_sym_DQUOTE,
    STATE(539), 1,
      aux_sym_string_repeat1,
    STATE(618), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40327] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(183), 1,
      anon_sym_LPAREN,
    ACTIONS(1249), 1,
      anon_sym_RPAREN,
    STATE(595), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(619), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40354] = 8,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1620), 1,
      anon_sym_RPAREN,
    STATE(538), 1,
      aux_sym_memory_fields_data_repeat1,
    STATE(754), 1,
      sym_string,
    STATE(620), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40381] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(291), 1,
      anon_sym_param,
    ACTIONS(293), 1,
      anon_sym_result,
    ACTIONS(1645), 1,
      anon_sym_local,
    STATE(621), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40405] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1649), 1,
      anon_sym_LPAREN,
    ACTIONS(1647), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(622), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40427] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    STATE(603), 1,
      sym_string,
    STATE(625), 1,
      sym_name,
    STATE(623), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40451] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1651), 1,
      anon_sym_LPAREN,
    ACTIONS(1653), 1,
      sym_identifier,
    STATE(843), 1,
      sym_type_field,
    STATE(624), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40475] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    STATE(603), 1,
      sym_string,
    STATE(961), 1,
      sym_name,
    STATE(625), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40499] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1657), 1,
      anon_sym_LPAREN,
    ACTIONS(1655), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(626), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40521] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1661), 1,
      anon_sym_LPAREN,
    ACTIONS(1659), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(627), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40543] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    STATE(603), 1,
      sym_string,
    STATE(959), 1,
      sym_name,
    STATE(628), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40567] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1665), 1,
      anon_sym_LPAREN,
    ACTIONS(1663), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(629), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40589] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1669), 1,
      anon_sym_LPAREN,
    ACTIONS(1667), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(630), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40611] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1673), 1,
      anon_sym_LPAREN,
    ACTIONS(1671), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(631), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40633] = 7,
    ACTIONS(1411), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1415), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1675), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(1677), 1,
      anon_sym_SEMI_RPAREN,
    ACTIONS(1679), 1,
      sym_comment_block_inner,
    STATE(705), 1,
      aux_sym_comment_block_repeat1,
    STATE(632), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40657] = 7,
    ACTIONS(1411), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1415), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1675), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(1679), 1,
      sym_comment_block_inner,
    ACTIONS(1681), 1,
      anon_sym_SEMI_RPAREN,
    STATE(632), 1,
      aux_sym_comment_block_repeat1,
    STATE(633), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40681] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1685), 1,
      anon_sym_LPAREN,
    ACTIONS(1683), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(634), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40703] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    STATE(417), 1,
      sym_name,
    STATE(603), 1,
      sym_string,
    STATE(635), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40727] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1689), 1,
      anon_sym_LPAREN,
    ACTIONS(1687), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(636), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40749] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1693), 1,
      anon_sym_LPAREN,
    ACTIONS(1691), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(637), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40771] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1697), 1,
      anon_sym_LPAREN,
    ACTIONS(1695), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(638), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40793] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1699), 1,
      anon_sym_LPAREN,
    STATE(595), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(639), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40817] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1703), 1,
      anon_sym_LPAREN,
    ACTIONS(1701), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(640), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40839] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1707), 1,
      anon_sym_LPAREN,
    ACTIONS(1705), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(641), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40861] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1711), 1,
      anon_sym_LPAREN,
    ACTIONS(1709), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(642), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40883] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    STATE(832), 1,
      sym_literal_nan,
    ACTIONS(1713), 2,
      sym_literal_nan_arithmetic,
      sym_literal_nan_canonical,
    STATE(643), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40905] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1717), 1,
      anon_sym_LPAREN,
    ACTIONS(1715), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(644), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40927] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1721), 1,
      anon_sym_LPAREN,
    ACTIONS(1719), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(645), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40949] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    STATE(603), 1,
      sym_string,
    STATE(938), 1,
      sym_name,
    STATE(646), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40973] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1725), 1,
      anon_sym_LPAREN,
    ACTIONS(1723), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(647), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [40995] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    STATE(855), 1,
      sym_nat,
    STATE(648), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41019] = 6,
    ACTIONS(1411), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1413), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(1415), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1729), 1,
      aux_sym_string_token1,
    ACTIONS(1727), 2,
      sym_escape_sequence,
      anon_sym_DQUOTE,
    STATE(649), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41041] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1733), 1,
      anon_sym_LPAREN,
    ACTIONS(1731), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(650), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41063] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(291), 1,
      anon_sym_param,
    ACTIONS(293), 1,
      anon_sym_result,
    ACTIONS(297), 1,
      anon_sym_type,
    STATE(651), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41087] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    STATE(580), 1,
      sym_name,
    STATE(603), 1,
      sym_string,
    STATE(652), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41111] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1737), 1,
      anon_sym_LPAREN,
    ACTIONS(1735), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(653), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41133] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1741), 1,
      anon_sym_LPAREN,
    ACTIONS(1739), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(654), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41155] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1745), 1,
      anon_sym_LPAREN,
    ACTIONS(1743), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(655), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41177] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1749), 1,
      anon_sym_LPAREN,
    ACTIONS(1747), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(656), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41199] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1753), 1,
      anon_sym_LPAREN,
    ACTIONS(1751), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(657), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41221] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1755), 1,
      anon_sym_RPAREN,
    STATE(775), 1,
      sym_string,
    STATE(658), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41245] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1759), 1,
      anon_sym_LPAREN,
    ACTIONS(1757), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(659), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41267] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1763), 1,
      anon_sym_LPAREN,
    ACTIONS(1761), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(660), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41289] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1767), 1,
      anon_sym_LPAREN,
    ACTIONS(1765), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(661), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41311] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1771), 1,
      anon_sym_LPAREN,
    ACTIONS(1769), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(662), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41333] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1775), 1,
      anon_sym_LPAREN,
    ACTIONS(1773), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(663), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41355] = 7,
    ACTIONS(1411), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1415), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1675), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(1679), 1,
      sym_comment_block_inner,
    ACTIONS(1777), 1,
      anon_sym_SEMI_RPAREN,
    STATE(715), 1,
      aux_sym_comment_block_repeat1,
    STATE(664), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41379] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1781), 1,
      anon_sym_LPAREN,
    ACTIONS(1779), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(665), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41401] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1785), 1,
      anon_sym_LPAREN,
    ACTIONS(1783), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(666), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41423] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(285), 1,
      anon_sym_export,
    ACTIONS(295), 1,
      anon_sym_import,
    ACTIONS(1604), 1,
      anon_sym_ref,
    STATE(667), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41447] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1789), 1,
      anon_sym_LPAREN,
    ACTIONS(1787), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(668), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41469] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1793), 1,
      anon_sym_LPAREN,
    ACTIONS(1791), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(669), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41491] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    STATE(603), 1,
      sym_string,
    STATE(635), 1,
      sym_name,
    STATE(670), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41515] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1797), 1,
      anon_sym_LPAREN,
    ACTIONS(1795), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(671), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41537] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    STATE(252), 1,
      sym_nat,
    STATE(672), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41561] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1801), 1,
      anon_sym_LPAREN,
    ACTIONS(1799), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(673), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41583] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1805), 1,
      anon_sym_LPAREN,
    ACTIONS(1803), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(674), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41605] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1809), 1,
      anon_sym_LPAREN,
    ACTIONS(1807), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(675), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41627] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1813), 1,
      anon_sym_LPAREN,
    ACTIONS(1811), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(676), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41649] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1817), 1,
      anon_sym_LPAREN,
    ACTIONS(1815), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(677), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41671] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1821), 1,
      anon_sym_LPAREN,
    ACTIONS(1819), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(678), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41693] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1825), 1,
      anon_sym_LPAREN,
    ACTIONS(1823), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(679), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41715] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1827), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(680), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41737] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1833), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(681), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41759] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1835), 1,
      anon_sym_LPAREN,
    STATE(595), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(682), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41783] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1839), 1,
      anon_sym_LPAREN,
    ACTIONS(1837), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(683), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41805] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1843), 1,
      anon_sym_LPAREN,
    ACTIONS(1841), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(684), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41827] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1847), 1,
      anon_sym_LPAREN,
    ACTIONS(1845), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(685), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41849] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1851), 1,
      anon_sym_LPAREN,
    ACTIONS(1849), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(686), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41871] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1855), 1,
      anon_sym_LPAREN,
    ACTIONS(1853), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(687), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41893] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1859), 1,
      anon_sym_LPAREN,
    ACTIONS(1857), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(688), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41915] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(430), 1,
      sym_dec_nat,
    ACTIONS(432), 1,
      sym_hex_nat,
    STATE(209), 1,
      sym_nat,
    STATE(689), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41939] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1863), 1,
      anon_sym_LPAREN,
    ACTIONS(1861), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(690), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41961] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1867), 1,
      anon_sym_LPAREN,
    ACTIONS(1865), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(691), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [41983] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1871), 1,
      anon_sym_LPAREN,
    ACTIONS(1869), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(692), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42005] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1875), 1,
      anon_sym_LPAREN,
    ACTIONS(1873), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(693), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42027] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1879), 1,
      anon_sym_LPAREN,
    ACTIONS(1877), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(694), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42049] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1883), 1,
      anon_sym_LPAREN,
    ACTIONS(1881), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(695), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42071] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1887), 1,
      anon_sym_LPAREN,
    ACTIONS(1885), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(696), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42093] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    ACTIONS(1889), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(697), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42115] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1895), 1,
      anon_sym_LPAREN,
    ACTIONS(1893), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(698), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42137] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1899), 1,
      anon_sym_LPAREN,
    ACTIONS(1897), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(699), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42159] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1903), 1,
      anon_sym_LPAREN,
    ACTIONS(1901), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(700), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42181] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1907), 1,
      anon_sym_LPAREN,
    ACTIONS(1905), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(701), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42203] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1909), 1,
      sym_identifier,
    STATE(930), 1,
      sym_string,
    STATE(702), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42227] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1913), 1,
      anon_sym_LPAREN,
    ACTIONS(1911), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(703), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42249] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1917), 1,
      anon_sym_LPAREN,
    ACTIONS(1915), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(704), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42271] = 6,
    ACTIONS(1411), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1415), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1919), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(1922), 1,
      anon_sym_SEMI_RPAREN,
    ACTIONS(1924), 1,
      sym_comment_block_inner,
    STATE(705), 4,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
      aux_sym_comment_block_repeat1,
  [42293] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1929), 1,
      anon_sym_LPAREN,
    ACTIONS(1927), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(706), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42315] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1933), 1,
      anon_sym_LPAREN,
    ACTIONS(1931), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(707), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42337] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1937), 1,
      anon_sym_LPAREN,
    ACTIONS(1935), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(708), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42359] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1939), 1,
      anon_sym_LPAREN,
    STATE(595), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(709), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42383] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    STATE(603), 1,
      sym_string,
    STATE(928), 1,
      sym_name,
    STATE(710), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42407] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1941), 1,
      anon_sym_LPAREN,
    STATE(595), 1,
      aux_sym_expr1_call_repeat1,
    STATE(745), 1,
      sym_expr,
    STATE(711), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42431] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1945), 1,
      anon_sym_LPAREN,
    ACTIONS(1943), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(712), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42453] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1949), 1,
      anon_sym_LPAREN,
    ACTIONS(1947), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(713), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42475] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    STATE(603), 1,
      sym_string,
    STATE(771), 1,
      sym_name,
    STATE(714), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42499] = 7,
    ACTIONS(1411), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1415), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1675), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(1679), 1,
      sym_comment_block_inner,
    ACTIONS(1951), 1,
      anon_sym_SEMI_RPAREN,
    STATE(705), 1,
      aux_sym_comment_block_repeat1,
    STATE(715), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42523] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1955), 1,
      anon_sym_LPAREN,
    ACTIONS(1953), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(716), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42545] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1959), 1,
      anon_sym_LPAREN,
    ACTIONS(1957), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(717), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42567] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1006), 1,
      anon_sym_module,
    ACTIONS(1012), 1,
      anon_sym_get,
    ACTIONS(1014), 1,
      anon_sym_invoke,
    STATE(718), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42591] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(285), 1,
      anon_sym_export,
    ACTIONS(295), 1,
      anon_sym_import,
    ACTIONS(1961), 1,
      anon_sym_data,
    STATE(719), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42615] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1965), 1,
      anon_sym_LPAREN,
    ACTIONS(1963), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(720), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42637] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    STATE(603), 1,
      sym_string,
    STATE(902), 1,
      sym_name,
    STATE(721), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42661] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1969), 1,
      anon_sym_LPAREN,
    ACTIONS(1967), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(722), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42683] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    STATE(436), 1,
      sym_name,
    STATE(603), 1,
      sym_string,
    STATE(723), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42707] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1973), 1,
      anon_sym_LPAREN,
    ACTIONS(1971), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(724), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42729] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1977), 1,
      anon_sym_LPAREN,
    ACTIONS(1975), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(725), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42751] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1981), 1,
      anon_sym_LPAREN,
    ACTIONS(1979), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(726), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42773] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1985), 1,
      anon_sym_LPAREN,
    ACTIONS(1983), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
    STATE(727), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42795] = 7,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    STATE(603), 1,
      sym_string,
    STATE(646), 1,
      sym_name,
    STATE(728), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42819] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    STATE(810), 1,
      sym_string,
    STATE(729), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42840] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    STATE(809), 1,
      sym_string,
    STATE(730), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42861] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1987), 1,
      anon_sym_RPAREN,
    ACTIONS(1989), 1,
      anon_sym_LPAREN,
    STATE(731), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42882] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(171), 1,
      anon_sym_end,
    ACTIONS(173), 1,
      anon_sym_else,
    STATE(732), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42903] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1991), 1,
      anon_sym_RPAREN,
    ACTIONS(1993), 1,
      anon_sym_LPAREN,
    STATE(733), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42924] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1995), 1,
      anon_sym_extract_lane,
    ACTIONS(1997), 1,
      anon_sym_replace_lane,
    STATE(734), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42945] = 4,
    ACTIONS(1411), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1415), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1999), 3,
      anon_sym_LPAREN_SEMI,
      anon_sym_SEMI_RPAREN,
      sym_comment_block_inner,
    STATE(735), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42962] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(191), 1,
      anon_sym_end,
    ACTIONS(2001), 1,
      anon_sym_else,
    STATE(736), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [42983] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(291), 1,
      anon_sym_param,
    ACTIONS(293), 1,
      anon_sym_result,
    STATE(737), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43004] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2003), 1,
      anon_sym_RPAREN,
    ACTIONS(2005), 1,
      anon_sym_LPAREN,
    STATE(738), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43025] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1997), 2,
      anon_sym_extract_lane,
      anon_sym_replace_lane,
    STATE(739), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43044] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2007), 1,
      anon_sym_RPAREN,
    ACTIONS(2009), 1,
      anon_sym_LPAREN,
    STATE(740), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43065] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2011), 1,
      anon_sym_RPAREN,
    ACTIONS(2013), 1,
      anon_sym_LPAREN,
    STATE(741), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43086] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2015), 1,
      anon_sym_RPAREN,
    ACTIONS(2017), 1,
      anon_sym_LPAREN,
    STATE(742), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43107] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2019), 1,
      anon_sym_RPAREN,
    ACTIONS(2021), 1,
      anon_sym_LPAREN,
    STATE(743), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43128] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2023), 1,
      anon_sym_RPAREN,
    ACTIONS(2025), 1,
      anon_sym_LPAREN,
    STATE(744), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43149] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2027), 1,
      anon_sym_RPAREN,
    ACTIONS(2029), 1,
      anon_sym_LPAREN,
    STATE(745), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43170] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2031), 1,
      anon_sym_RPAREN,
    ACTIONS(2033), 1,
      anon_sym_LPAREN,
    STATE(746), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43191] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    STATE(881), 1,
      sym_string,
    STATE(747), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43212] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    STATE(895), 1,
      sym_string,
    STATE(748), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43233] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2035), 1,
      anon_sym_RPAREN,
    ACTIONS(2037), 1,
      anon_sym_LPAREN,
    STATE(749), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43254] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2039), 1,
      anon_sym_RPAREN,
    ACTIONS(2041), 1,
      anon_sym_LPAREN,
    STATE(750), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43275] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(105), 1,
      anon_sym_end,
    ACTIONS(107), 1,
      anon_sym_else,
    STATE(751), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43296] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2043), 1,
      anon_sym_RPAREN,
    ACTIONS(2045), 1,
      anon_sym_LPAREN,
    STATE(752), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43317] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1600), 1,
      anon_sym_mut,
    ACTIONS(1604), 1,
      anon_sym_ref,
    STATE(753), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43338] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2047), 2,
      anon_sym_RPAREN,
      anon_sym_DQUOTE,
    STATE(754), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43357] = 4,
    ACTIONS(1411), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1415), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2049), 3,
      anon_sym_LPAREN_SEMI,
      anon_sym_SEMI_RPAREN,
      sym_comment_block_inner,
    STATE(755), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43374] = 4,
    ACTIONS(1411), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1415), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2051), 3,
      anon_sym_LPAREN_SEMI,
      anon_sym_SEMI_RPAREN,
      sym_comment_block_inner,
    STATE(756), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43391] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2053), 1,
      anon_sym_RPAREN,
    ACTIONS(2055), 1,
      anon_sym_LPAREN,
    STATE(757), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43412] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2057), 1,
      anon_sym_RPAREN,
    ACTIONS(2059), 1,
      anon_sym_LPAREN,
    STATE(758), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43433] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1012), 1,
      anon_sym_get,
    ACTIONS(1014), 1,
      anon_sym_invoke,
    STATE(759), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43454] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2061), 1,
      anon_sym_RPAREN,
    ACTIONS(2063), 1,
      anon_sym_LPAREN,
    STATE(760), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43475] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(129), 1,
      anon_sym_end,
    ACTIONS(131), 1,
      anon_sym_else,
    STATE(761), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43496] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    STATE(804), 1,
      sym_string,
    STATE(762), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43517] = 4,
    ACTIONS(1411), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1415), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2065), 3,
      anon_sym_LPAREN_SEMI,
      anon_sym_SEMI_RPAREN,
      sym_comment_block_inner,
    STATE(763), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43534] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2067), 1,
      anon_sym_RPAREN,
    ACTIONS(2069), 1,
      anon_sym_LPAREN,
    STATE(764), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43555] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    STATE(801), 1,
      sym_string,
    STATE(765), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43576] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2071), 1,
      anon_sym_DOTshuffle,
    ACTIONS(2073), 1,
      anon_sym_DOT,
    STATE(766), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43597] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2075), 1,
      anon_sym_RPAREN,
    ACTIONS(2077), 1,
      anon_sym_LPAREN,
    STATE(767), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43618] = 4,
    ACTIONS(1411), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1415), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1365), 3,
      anon_sym_LPAREN_SEMI,
      anon_sym_SEMI_RPAREN,
      sym_comment_block_inner,
    STATE(768), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43635] = 4,
    ACTIONS(1411), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(1415), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1403), 3,
      anon_sym_LPAREN_SEMI,
      anon_sym_SEMI_RPAREN,
      sym_comment_block_inner,
    STATE(769), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43652] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(293), 1,
      anon_sym_result,
    ACTIONS(1645), 1,
      anon_sym_local,
    STATE(770), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43673] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2079), 1,
      anon_sym_RPAREN,
    ACTIONS(2081), 1,
      sym_identifier,
    STATE(771), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43694] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1651), 1,
      anon_sym_LPAREN,
    STATE(932), 1,
      sym_type_field,
    STATE(772), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43715] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    STATE(905), 1,
      sym_string,
    STATE(773), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43736] = 6,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(123), 1,
      anon_sym_end,
    ACTIONS(125), 1,
      anon_sym_else,
    STATE(774), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43757] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2083), 1,
      anon_sym_RPAREN,
    STATE(775), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43775] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2085), 1,
      anon_sym_RPAREN,
    STATE(776), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43793] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2087), 1,
      anon_sym_RPAREN,
    STATE(777), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43811] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(95), 1,
      anon_sym_RPAREN,
    STATE(778), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43829] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2089), 1,
      anon_sym_RPAREN,
    STATE(779), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43847] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2091), 1,
      anon_sym_RPAREN,
    STATE(780), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43865] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2093), 1,
      anon_sym_RPAREN,
    STATE(781), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43883] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(181), 1,
      anon_sym_RPAREN,
    STATE(782), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43901] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2095), 1,
      anon_sym_RPAREN,
    STATE(783), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43919] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2097), 1,
      anon_sym_else,
    STATE(784), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43937] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2099), 1,
      anon_sym_RPAREN,
    STATE(785), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43955] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(319), 1,
      anon_sym_RPAREN,
    STATE(786), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43973] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1164), 1,
      anon_sym_RPAREN,
    STATE(787), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [43991] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2101), 1,
      sym_identifier_pattern,
    STATE(788), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44009] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2103), 1,
      anon_sym_RPAREN,
    STATE(789), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44027] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2105), 1,
      anon_sym_RPAREN,
    STATE(790), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44045] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(175), 1,
      anon_sym_RPAREN,
    STATE(791), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44063] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2107), 1,
      anon_sym_RPAREN,
    STATE(792), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44081] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2109), 1,
      anon_sym_RPAREN,
    STATE(793), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44099] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2111), 1,
      anon_sym_RPAREN,
    STATE(794), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44117] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2113), 1,
      anon_sym_RPAREN,
    STATE(795), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44135] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(161), 1,
      anon_sym_end,
    STATE(796), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44153] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2115), 1,
      anon_sym_end,
    STATE(797), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44171] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(129), 1,
      anon_sym_end,
    STATE(798), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44189] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2117), 1,
      anon_sym_RPAREN,
    STATE(799), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44207] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(191), 1,
      anon_sym_end,
    STATE(800), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44225] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2119), 1,
      anon_sym_RPAREN,
    STATE(801), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44243] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2121), 1,
      anon_sym_RPAREN,
    STATE(802), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44261] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2123), 1,
      anon_sym_RPAREN,
    STATE(803), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44279] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2125), 1,
      anon_sym_RPAREN,
    STATE(804), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44297] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2127), 1,
      anon_sym_RPAREN,
    STATE(805), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44315] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2129), 1,
      anon_sym_end,
    STATE(806), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44333] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2131), 1,
      anon_sym_DOT,
    STATE(807), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44351] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(103), 1,
      anon_sym_RPAREN,
    STATE(808), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44369] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2133), 1,
      anon_sym_RPAREN,
    STATE(809), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44387] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2135), 1,
      anon_sym_RPAREN,
    STATE(810), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44405] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2137), 1,
      anon_sym_RPAREN,
    STATE(811), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44423] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2139), 1,
      anon_sym_RPAREN,
    STATE(812), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44441] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(143), 1,
      anon_sym_end,
    STATE(813), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44459] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2141), 1,
      anon_sym_RPAREN,
    STATE(814), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44477] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(81), 1,
      anon_sym_RPAREN,
    STATE(815), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44495] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(179), 1,
      anon_sym_end,
    STATE(816), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44513] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(163), 1,
      anon_sym_RPAREN,
    STATE(817), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44531] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(171), 1,
      anon_sym_end,
    STATE(818), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44549] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(133), 1,
      anon_sym_RPAREN,
    STATE(819), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44567] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2143), 1,
      anon_sym_RPAREN,
    STATE(820), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44585] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2145), 1,
      anon_sym_RPAREN,
    STATE(821), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44603] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2147), 1,
      anon_sym_RPAREN,
    STATE(822), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44621] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(69), 1,
      anon_sym_RPAREN,
    STATE(823), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44639] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2149), 1,
      anon_sym_RPAREN,
    STATE(824), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44657] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2151), 1,
      anon_sym_RPAREN,
    STATE(825), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44675] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2153), 1,
      anon_sym_RPAREN,
    STATE(826), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44693] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2155), 1,
      anon_sym_RPAREN,
    STATE(827), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44711] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2157), 1,
      anon_sym_RPAREN,
    STATE(828), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44729] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2159), 1,
      anon_sym_RPAREN,
    STATE(829), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44747] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2161), 1,
      anon_sym_RPAREN,
    STATE(830), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44765] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2163), 1,
      anon_sym_RPAREN,
    STATE(831), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44783] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2165), 1,
      anon_sym_RPAREN,
    STATE(832), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44801] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2167), 1,
      anon_sym_RPAREN,
    STATE(833), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44819] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(177), 1,
      anon_sym_end,
    STATE(834), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44837] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2169), 1,
      anon_sym_else,
    STATE(835), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44855] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(151), 1,
      anon_sym_RPAREN,
    STATE(836), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44873] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(299), 1,
      anon_sym_RPAREN,
    STATE(837), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44891] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(75), 1,
      anon_sym_RPAREN,
    STATE(838), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44909] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2171), 1,
      anon_sym_elem,
    STATE(839), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44927] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2173), 1,
      anon_sym_RPAREN,
    STATE(840), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44945] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(147), 1,
      anon_sym_RPAREN,
    STATE(841), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44963] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2175), 1,
      anon_sym_RPAREN,
    STATE(842), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44981] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2177), 1,
      anon_sym_RPAREN,
    STATE(843), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [44999] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2179), 1,
      anon_sym_RPAREN,
    STATE(844), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45017] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2181), 1,
      anon_sym_RPAREN,
    STATE(845), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45035] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(275), 1,
      anon_sym_end,
    STATE(846), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45053] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2183), 1,
      anon_sym_RPAREN,
    STATE(847), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45071] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2185), 1,
      anon_sym_type,
    STATE(848), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45089] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1598), 1,
      anon_sym_export,
    STATE(849), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45107] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(313), 1,
      anon_sym_RPAREN,
    STATE(850), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45125] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(149), 1,
      anon_sym_RPAREN,
    STATE(851), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45143] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(157), 1,
      anon_sym_RPAREN,
    STATE(852), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45161] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2187), 1,
      anon_sym_const,
    STATE(853), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45179] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2189), 1,
      anon_sym_RPAREN,
    STATE(854), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45197] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2191), 1,
      anon_sym_RPAREN,
    STATE(855), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45215] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1604), 1,
      anon_sym_ref,
    STATE(856), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45233] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2193), 1,
      anon_sym_RPAREN,
    STATE(857), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45251] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2195), 1,
      anon_sym_RPAREN,
    STATE(858), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45269] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2197), 1,
      anon_sym_RPAREN,
    STATE(859), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45287] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2199), 1,
      anon_sym_RPAREN,
    STATE(860), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45305] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2201), 1,
      anon_sym_RPAREN,
    STATE(861), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45323] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2203), 1,
      anon_sym_RPAREN,
    STATE(862), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45341] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2205), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45359] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2031), 1,
      anon_sym_RPAREN,
    STATE(864), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45377] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(305), 1,
      anon_sym_RPAREN,
    STATE(865), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45395] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1290), 1,
      anon_sym_RPAREN,
    STATE(866), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45413] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2207), 1,
      anon_sym_else,
    STATE(867), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45431] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2209), 1,
      anon_sym_LPAREN,
    STATE(868), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45449] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(307), 1,
      anon_sym_RPAREN,
    STATE(869), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45467] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(159), 1,
      anon_sym_RPAREN,
    STATE(870), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45485] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2211), 1,
      anon_sym_RPAREN,
    STATE(871), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45503] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1155), 1,
      anon_sym_RPAREN,
    STATE(872), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45521] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(123), 1,
      anon_sym_end,
    STATE(873), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45539] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(309), 1,
      anon_sym_end,
    STATE(874), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45557] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2213), 1,
      anon_sym_RPAREN,
    STATE(875), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45575] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2215), 1,
      anon_sym_EQ,
    STATE(876), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45593] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2217), 1,
      anon_sym_LPAREN,
    STATE(877), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45611] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2219), 1,
      anon_sym_RPAREN,
    STATE(878), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45629] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2221), 1,
      anon_sym_RPAREN,
    STATE(879), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45647] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2223), 1,
      anon_sym_RPAREN,
    STATE(880), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45665] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2225), 1,
      anon_sym_RPAREN,
    STATE(881), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45683] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2227), 1,
      anon_sym_RPAREN,
    STATE(882), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45701] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2035), 1,
      anon_sym_RPAREN,
    STATE(883), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45719] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(311), 1,
      anon_sym_RPAREN,
    STATE(884), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45737] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(127), 1,
      anon_sym_RPAREN,
    STATE(885), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45755] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2229), 1,
      anon_sym_else,
    STATE(886), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45773] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(293), 1,
      anon_sym_result,
    STATE(887), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45791] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2231), 1,
      anon_sym_RPAREN,
    STATE(888), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45809] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2233), 1,
      anon_sym_EQ,
    STATE(889), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45827] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2235), 1,
      anon_sym_RPAREN,
    STATE(890), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45845] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2237), 1,
      anon_sym_end,
    STATE(891), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45863] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1006), 1,
      anon_sym_module,
    STATE(892), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45881] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2239), 1,
      anon_sym_RPAREN,
    STATE(893), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45899] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2241), 1,
      anon_sym_RPAREN,
    STATE(894), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45917] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2243), 1,
      anon_sym_RPAREN,
    STATE(895), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45935] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2039), 1,
      anon_sym_RPAREN,
    STATE(896), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45953] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(315), 1,
      anon_sym_RPAREN,
    STATE(897), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45971] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2245), 1,
      ts_builtin_sym_end,
    STATE(898), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [45989] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2247), 1,
      anon_sym_else,
    STATE(899), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46007] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2249), 1,
      anon_sym_RPAREN,
    STATE(900), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46025] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(65), 1,
      anon_sym_RPAREN,
    STATE(901), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46043] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2251), 1,
      anon_sym_RPAREN,
    STATE(902), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46061] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1755), 1,
      anon_sym_RPAREN,
    STATE(903), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46079] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(137), 1,
      anon_sym_end,
    STATE(904), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46097] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2253), 1,
      anon_sym_RPAREN,
    STATE(905), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46115] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2255), 1,
      anon_sym_RPAREN,
    STATE(906), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46133] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(317), 1,
      anon_sym_RPAREN,
    STATE(907), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46151] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2257), 1,
      anon_sym_RPAREN,
    STATE(908), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46169] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2259), 1,
      anon_sym_else,
    STATE(909), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46187] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2261), 1,
      anon_sym_RPAREN,
    STATE(910), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46205] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2263), 1,
      anon_sym_ref,
    STATE(911), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46223] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2265), 1,
      anon_sym_RPAREN,
    STATE(912), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46241] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2267), 1,
      anon_sym_RPAREN,
    STATE(913), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46259] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(303), 1,
      anon_sym_RPAREN,
    STATE(914), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46277] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(403), 1,
      anon_sym_param,
    STATE(915), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46295] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2269), 1,
      anon_sym_RPAREN,
    STATE(916), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46313] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2271), 1,
      anon_sym_RPAREN,
    STATE(917), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46331] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2273), 1,
      anon_sym_RPAREN,
    STATE(918), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46349] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2275), 1,
      anon_sym_RPAREN,
    STATE(919), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46367] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2277), 1,
      anon_sym_RPAREN,
    STATE(920), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46385] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(285), 1,
      anon_sym_export,
    STATE(921), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46403] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2279), 1,
      anon_sym_RPAREN,
    STATE(922), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46421] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2281), 1,
      anon_sym_RPAREN,
    STATE(923), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46439] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(291), 1,
      anon_sym_param,
    STATE(924), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46457] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2283), 1,
      anon_sym_LPAREN,
    STATE(925), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46475] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(79), 1,
      anon_sym_RPAREN,
    STATE(926), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46493] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2285), 1,
      anon_sym_RPAREN,
    STATE(927), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46511] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2287), 1,
      anon_sym_RPAREN,
    STATE(928), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46529] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2289), 1,
      anon_sym_RPAREN,
    STATE(929), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46547] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2291), 1,
      anon_sym_RPAREN,
    STATE(930), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46565] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(135), 1,
      anon_sym_end,
    STATE(931), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46583] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2293), 1,
      anon_sym_RPAREN,
    STATE(932), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46601] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(83), 1,
      anon_sym_RPAREN,
    STATE(933), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46619] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2295), 1,
      aux_sym_op_simd_lane_token1,
    STATE(934), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46637] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2297), 1,
      anon_sym_RPAREN,
    STATE(935), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46655] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(141), 1,
      anon_sym_end,
    STATE(936), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46673] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2299), 1,
      anon_sym_RPAREN,
    STATE(937), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46691] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2301), 1,
      anon_sym_RPAREN,
    STATE(938), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46709] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2303), 1,
      anon_sym__,
    STATE(939), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46727] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2305), 1,
      anon_sym_RPAREN,
    STATE(940), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46745] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2307), 1,
      anon_sym_RPAREN,
    STATE(941), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46763] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1162), 1,
      anon_sym_RPAREN,
    STATE(942), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46781] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2309), 1,
      anon_sym_DOT,
    STATE(943), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46799] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2311), 1,
      anon_sym_DOT,
    STATE(944), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46817] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(73), 1,
      anon_sym_RPAREN,
    STATE(945), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46835] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2313), 1,
      anon_sym_RPAREN,
    STATE(946), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46853] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2315), 1,
      anon_sym_RPAREN,
    STATE(947), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46871] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(1645), 1,
      anon_sym_local,
    STATE(948), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46889] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2317), 1,
      anon_sym_RPAREN,
    STATE(949), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46907] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2319), 1,
      anon_sym_RPAREN,
    STATE(950), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46925] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2321), 1,
      anon_sym_RPAREN,
    STATE(951), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46943] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(85), 1,
      anon_sym_RPAREN,
    STATE(952), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46961] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2323), 1,
      anon_sym_RPAREN,
    STATE(953), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46979] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2325), 1,
      anon_sym_RPAREN,
    STATE(954), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [46997] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2327), 1,
      anon_sym_func,
    STATE(955), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [47015] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2329), 1,
      anon_sym_RPAREN,
    STATE(956), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [47033] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2331), 1,
      anon_sym_RPAREN,
    STATE(957), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [47051] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2333), 1,
      sym_align_offset_value,
    STATE(958), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [47069] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2335), 1,
      anon_sym_RPAREN,
    STATE(959), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [47087] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2337), 1,
      anon_sym_RPAREN,
    STATE(960), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [47105] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2339), 1,
      anon_sym_RPAREN,
    STATE(961), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [47123] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2341), 1,
      anon_sym_RPAREN,
    STATE(962), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [47141] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(145), 1,
      anon_sym_end,
    STATE(963), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [47159] = 5,
    ACTIONS(3), 1,
      anon_sym_LPAREN_AT,
    ACTIONS(5), 1,
      anon_sym_LPAREN_SEMI,
    ACTIONS(7), 1,
      aux_sym_comment_line_token1,
    ACTIONS(2343), 1,
      sym_align_offset_value,
    STATE(964), 3,
      sym_annotation,
      sym_comment_block,
      sym_comment_line,
  [47177] = 1,
    ACTIONS(2345), 1,
      ts_builtin_sym_end,
  [47181] = 1,
    ACTIONS(2347), 1,
      ts_builtin_sym_end,
  [47185] = 1,
    ACTIONS(2349), 1,
      ts_builtin_sym_end,
  [47189] = 1,
    ACTIONS(2351), 1,
      ts_builtin_sym_end,
  [47193] = 1,
    ACTIONS(2353), 1,
      ts_builtin_sym_end,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(6)] = 0,
  [SMALL_STATE(7)] = 153,
  [SMALL_STATE(8)] = 306,
  [SMALL_STATE(9)] = 459,
  [SMALL_STATE(10)] = 612,
  [SMALL_STATE(11)] = 762,
  [SMALL_STATE(12)] = 912,
  [SMALL_STATE(13)] = 1062,
  [SMALL_STATE(14)] = 1212,
  [SMALL_STATE(15)] = 1362,
  [SMALL_STATE(16)] = 1512,
  [SMALL_STATE(17)] = 1662,
  [SMALL_STATE(18)] = 1812,
  [SMALL_STATE(19)] = 1962,
  [SMALL_STATE(20)] = 2112,
  [SMALL_STATE(21)] = 2262,
  [SMALL_STATE(22)] = 2412,
  [SMALL_STATE(23)] = 2562,
  [SMALL_STATE(24)] = 2712,
  [SMALL_STATE(25)] = 2857,
  [SMALL_STATE(26)] = 2997,
  [SMALL_STATE(27)] = 3137,
  [SMALL_STATE(28)] = 3277,
  [SMALL_STATE(29)] = 3417,
  [SMALL_STATE(30)] = 3557,
  [SMALL_STATE(31)] = 3697,
  [SMALL_STATE(32)] = 3837,
  [SMALL_STATE(33)] = 3979,
  [SMALL_STATE(34)] = 4119,
  [SMALL_STATE(35)] = 4259,
  [SMALL_STATE(36)] = 4401,
  [SMALL_STATE(37)] = 4543,
  [SMALL_STATE(38)] = 4685,
  [SMALL_STATE(39)] = 4827,
  [SMALL_STATE(40)] = 4967,
  [SMALL_STATE(41)] = 5106,
  [SMALL_STATE(42)] = 5245,
  [SMALL_STATE(43)] = 5384,
  [SMALL_STATE(44)] = 5523,
  [SMALL_STATE(45)] = 5662,
  [SMALL_STATE(46)] = 5801,
  [SMALL_STATE(47)] = 5940,
  [SMALL_STATE(48)] = 6079,
  [SMALL_STATE(49)] = 6218,
  [SMALL_STATE(50)] = 6352,
  [SMALL_STATE(51)] = 6488,
  [SMALL_STATE(52)] = 6624,
  [SMALL_STATE(53)] = 6760,
  [SMALL_STATE(54)] = 6896,
  [SMALL_STATE(55)] = 7032,
  [SMALL_STATE(56)] = 7168,
  [SMALL_STATE(57)] = 7304,
  [SMALL_STATE(58)] = 7438,
  [SMALL_STATE(59)] = 7572,
  [SMALL_STATE(60)] = 7708,
  [SMALL_STATE(61)] = 7844,
  [SMALL_STATE(62)] = 7978,
  [SMALL_STATE(63)] = 8114,
  [SMALL_STATE(64)] = 8250,
  [SMALL_STATE(65)] = 8386,
  [SMALL_STATE(66)] = 8520,
  [SMALL_STATE(67)] = 8656,
  [SMALL_STATE(68)] = 8790,
  [SMALL_STATE(69)] = 8924,
  [SMALL_STATE(70)] = 9058,
  [SMALL_STATE(71)] = 9194,
  [SMALL_STATE(72)] = 9330,
  [SMALL_STATE(73)] = 9466,
  [SMALL_STATE(74)] = 9600,
  [SMALL_STATE(75)] = 9734,
  [SMALL_STATE(76)] = 9868,
  [SMALL_STATE(77)] = 10004,
  [SMALL_STATE(78)] = 10140,
  [SMALL_STATE(79)] = 10274,
  [SMALL_STATE(80)] = 10410,
  [SMALL_STATE(81)] = 10546,
  [SMALL_STATE(82)] = 10680,
  [SMALL_STATE(83)] = 10813,
  [SMALL_STATE(84)] = 10946,
  [SMALL_STATE(85)] = 11077,
  [SMALL_STATE(86)] = 11208,
  [SMALL_STATE(87)] = 11341,
  [SMALL_STATE(88)] = 11472,
  [SMALL_STATE(89)] = 11605,
  [SMALL_STATE(90)] = 11735,
  [SMALL_STATE(91)] = 11865,
  [SMALL_STATE(92)] = 11995,
  [SMALL_STATE(93)] = 12125,
  [SMALL_STATE(94)] = 12255,
  [SMALL_STATE(95)] = 12385,
  [SMALL_STATE(96)] = 12515,
  [SMALL_STATE(97)] = 12645,
  [SMALL_STATE(98)] = 12775,
  [SMALL_STATE(99)] = 12905,
  [SMALL_STATE(100)] = 13035,
  [SMALL_STATE(101)] = 13165,
  [SMALL_STATE(102)] = 13295,
  [SMALL_STATE(103)] = 13425,
  [SMALL_STATE(104)] = 13555,
  [SMALL_STATE(105)] = 13685,
  [SMALL_STATE(106)] = 13812,
  [SMALL_STATE(107)] = 13935,
  [SMALL_STATE(108)] = 14064,
  [SMALL_STATE(109)] = 14191,
  [SMALL_STATE(110)] = 14318,
  [SMALL_STATE(111)] = 14443,
  [SMALL_STATE(112)] = 14564,
  [SMALL_STATE(113)] = 14689,
  [SMALL_STATE(114)] = 14816,
  [SMALL_STATE(115)] = 14941,
  [SMALL_STATE(116)] = 15068,
  [SMALL_STATE(117)] = 15195,
  [SMALL_STATE(118)] = 15323,
  [SMALL_STATE(119)] = 15447,
  [SMALL_STATE(120)] = 15571,
  [SMALL_STATE(121)] = 15695,
  [SMALL_STATE(122)] = 15819,
  [SMALL_STATE(123)] = 15943,
  [SMALL_STATE(124)] = 16067,
  [SMALL_STATE(125)] = 16191,
  [SMALL_STATE(126)] = 16315,
  [SMALL_STATE(127)] = 16439,
  [SMALL_STATE(128)] = 16563,
  [SMALL_STATE(129)] = 16687,
  [SMALL_STATE(130)] = 16811,
  [SMALL_STATE(131)] = 16935,
  [SMALL_STATE(132)] = 17059,
  [SMALL_STATE(133)] = 17183,
  [SMALL_STATE(134)] = 17309,
  [SMALL_STATE(135)] = 17435,
  [SMALL_STATE(136)] = 17561,
  [SMALL_STATE(137)] = 17685,
  [SMALL_STATE(138)] = 17809,
  [SMALL_STATE(139)] = 17929,
  [SMALL_STATE(140)] = 18049,
  [SMALL_STATE(141)] = 18167,
  [SMALL_STATE(142)] = 18287,
  [SMALL_STATE(143)] = 18409,
  [SMALL_STATE(144)] = 18529,
  [SMALL_STATE(145)] = 18649,
  [SMALL_STATE(146)] = 18769,
  [SMALL_STATE(147)] = 18889,
  [SMALL_STATE(148)] = 19009,
  [SMALL_STATE(149)] = 19129,
  [SMALL_STATE(150)] = 19249,
  [SMALL_STATE(151)] = 19369,
  [SMALL_STATE(152)] = 19489,
  [SMALL_STATE(153)] = 19609,
  [SMALL_STATE(154)] = 19729,
  [SMALL_STATE(155)] = 19849,
  [SMALL_STATE(156)] = 19969,
  [SMALL_STATE(157)] = 20089,
  [SMALL_STATE(158)] = 20209,
  [SMALL_STATE(159)] = 20331,
  [SMALL_STATE(160)] = 20451,
  [SMALL_STATE(161)] = 20543,
  [SMALL_STATE(162)] = 20662,
  [SMALL_STATE(163)] = 20781,
  [SMALL_STATE(164)] = 20900,
  [SMALL_STATE(165)] = 21019,
  [SMALL_STATE(166)] = 21138,
  [SMALL_STATE(167)] = 21254,
  [SMALL_STATE(168)] = 21370,
  [SMALL_STATE(169)] = 21486,
  [SMALL_STATE(170)] = 21602,
  [SMALL_STATE(171)] = 21718,
  [SMALL_STATE(172)] = 21834,
  [SMALL_STATE(173)] = 21947,
  [SMALL_STATE(174)] = 22060,
  [SMALL_STATE(175)] = 22121,
  [SMALL_STATE(176)] = 22234,
  [SMALL_STATE(177)] = 22347,
  [SMALL_STATE(178)] = 22460,
  [SMALL_STATE(179)] = 22573,
  [SMALL_STATE(180)] = 22686,
  [SMALL_STATE(181)] = 22799,
  [SMALL_STATE(182)] = 22909,
  [SMALL_STATE(183)] = 22986,
  [SMALL_STATE(184)] = 23063,
  [SMALL_STATE(185)] = 23140,
  [SMALL_STATE(186)] = 23199,
  [SMALL_STATE(187)] = 23275,
  [SMALL_STATE(188)] = 23331,
  [SMALL_STATE(189)] = 23398,
  [SMALL_STATE(190)] = 23465,
  [SMALL_STATE(191)] = 23532,
  [SMALL_STATE(192)] = 23599,
  [SMALL_STATE(193)] = 23666,
  [SMALL_STATE(194)] = 23731,
  [SMALL_STATE(195)] = 23785,
  [SMALL_STATE(196)] = 23839,
  [SMALL_STATE(197)] = 23903,
  [SMALL_STATE(198)] = 23967,
  [SMALL_STATE(199)] = 24031,
  [SMALL_STATE(200)] = 24090,
  [SMALL_STATE(201)] = 24151,
  [SMALL_STATE(202)] = 24212,
  [SMALL_STATE(203)] = 24273,
  [SMALL_STATE(204)] = 24334,
  [SMALL_STATE(205)] = 24393,
  [SMALL_STATE(206)] = 24454,
  [SMALL_STATE(207)] = 24515,
  [SMALL_STATE(208)] = 24572,
  [SMALL_STATE(209)] = 24624,
  [SMALL_STATE(210)] = 24676,
  [SMALL_STATE(211)] = 24728,
  [SMALL_STATE(212)] = 24783,
  [SMALL_STATE(213)] = 24838,
  [SMALL_STATE(214)] = 24889,
  [SMALL_STATE(215)] = 24946,
  [SMALL_STATE(216)] = 25001,
  [SMALL_STATE(217)] = 25056,
  [SMALL_STATE(218)] = 25113,
  [SMALL_STATE(219)] = 25164,
  [SMALL_STATE(220)] = 25216,
  [SMALL_STATE(221)] = 25268,
  [SMALL_STATE(222)] = 25320,
  [SMALL_STATE(223)] = 25372,
  [SMALL_STATE(224)] = 25424,
  [SMALL_STATE(225)] = 25476,
  [SMALL_STATE(226)] = 25528,
  [SMALL_STATE(227)] = 25578,
  [SMALL_STATE(228)] = 25630,
  [SMALL_STATE(229)] = 25682,
  [SMALL_STATE(230)] = 25734,
  [SMALL_STATE(231)] = 25786,
  [SMALL_STATE(232)] = 25838,
  [SMALL_STATE(233)] = 25890,
  [SMALL_STATE(234)] = 25942,
  [SMALL_STATE(235)] = 25994,
  [SMALL_STATE(236)] = 26046,
  [SMALL_STATE(237)] = 26098,
  [SMALL_STATE(238)] = 26150,
  [SMALL_STATE(239)] = 26202,
  [SMALL_STATE(240)] = 26254,
  [SMALL_STATE(241)] = 26306,
  [SMALL_STATE(242)] = 26355,
  [SMALL_STATE(243)] = 26404,
  [SMALL_STATE(244)] = 26453,
  [SMALL_STATE(245)] = 26502,
  [SMALL_STATE(246)] = 26551,
  [SMALL_STATE(247)] = 26600,
  [SMALL_STATE(248)] = 26649,
  [SMALL_STATE(249)] = 26698,
  [SMALL_STATE(250)] = 26747,
  [SMALL_STATE(251)] = 26796,
  [SMALL_STATE(252)] = 26845,
  [SMALL_STATE(253)] = 26894,
  [SMALL_STATE(254)] = 26943,
  [SMALL_STATE(255)] = 26992,
  [SMALL_STATE(256)] = 27041,
  [SMALL_STATE(257)] = 27090,
  [SMALL_STATE(258)] = 27139,
  [SMALL_STATE(259)] = 27188,
  [SMALL_STATE(260)] = 27237,
  [SMALL_STATE(261)] = 27286,
  [SMALL_STATE(262)] = 27335,
  [SMALL_STATE(263)] = 27384,
  [SMALL_STATE(264)] = 27433,
  [SMALL_STATE(265)] = 27482,
  [SMALL_STATE(266)] = 27531,
  [SMALL_STATE(267)] = 27580,
  [SMALL_STATE(268)] = 27629,
  [SMALL_STATE(269)] = 27678,
  [SMALL_STATE(270)] = 27727,
  [SMALL_STATE(271)] = 27776,
  [SMALL_STATE(272)] = 27825,
  [SMALL_STATE(273)] = 27874,
  [SMALL_STATE(274)] = 27923,
  [SMALL_STATE(275)] = 27972,
  [SMALL_STATE(276)] = 28021,
  [SMALL_STATE(277)] = 28070,
  [SMALL_STATE(278)] = 28119,
  [SMALL_STATE(279)] = 28168,
  [SMALL_STATE(280)] = 28217,
  [SMALL_STATE(281)] = 28266,
  [SMALL_STATE(282)] = 28315,
  [SMALL_STATE(283)] = 28364,
  [SMALL_STATE(284)] = 28413,
  [SMALL_STATE(285)] = 28462,
  [SMALL_STATE(286)] = 28511,
  [SMALL_STATE(287)] = 28562,
  [SMALL_STATE(288)] = 28611,
  [SMALL_STATE(289)] = 28660,
  [SMALL_STATE(290)] = 28709,
  [SMALL_STATE(291)] = 28758,
  [SMALL_STATE(292)] = 28807,
  [SMALL_STATE(293)] = 28856,
  [SMALL_STATE(294)] = 28905,
  [SMALL_STATE(295)] = 28954,
  [SMALL_STATE(296)] = 29003,
  [SMALL_STATE(297)] = 29052,
  [SMALL_STATE(298)] = 29101,
  [SMALL_STATE(299)] = 29150,
  [SMALL_STATE(300)] = 29199,
  [SMALL_STATE(301)] = 29248,
  [SMALL_STATE(302)] = 29297,
  [SMALL_STATE(303)] = 29344,
  [SMALL_STATE(304)] = 29391,
  [SMALL_STATE(305)] = 29438,
  [SMALL_STATE(306)] = 29485,
  [SMALL_STATE(307)] = 29532,
  [SMALL_STATE(308)] = 29579,
  [SMALL_STATE(309)] = 29626,
  [SMALL_STATE(310)] = 29673,
  [SMALL_STATE(311)] = 29720,
  [SMALL_STATE(312)] = 29767,
  [SMALL_STATE(313)] = 29814,
  [SMALL_STATE(314)] = 29861,
  [SMALL_STATE(315)] = 29908,
  [SMALL_STATE(316)] = 29955,
  [SMALL_STATE(317)] = 30013,
  [SMALL_STATE(318)] = 30075,
  [SMALL_STATE(319)] = 30134,
  [SMALL_STATE(320)] = 30193,
  [SMALL_STATE(321)] = 30252,
  [SMALL_STATE(322)] = 30311,
  [SMALL_STATE(323)] = 30401,
  [SMALL_STATE(324)] = 30476,
  [SMALL_STATE(325)] = 30548,
  [SMALL_STATE(326)] = 30620,
  [SMALL_STATE(327)] = 30692,
  [SMALL_STATE(328)] = 30758,
  [SMALL_STATE(329)] = 30821,
  [SMALL_STATE(330)] = 30884,
  [SMALL_STATE(331)] = 30947,
  [SMALL_STATE(332)] = 31010,
  [SMALL_STATE(333)] = 31073,
  [SMALL_STATE(334)] = 31138,
  [SMALL_STATE(335)] = 31203,
  [SMALL_STATE(336)] = 31263,
  [SMALL_STATE(337)] = 31325,
  [SMALL_STATE(338)] = 31393,
  [SMALL_STATE(339)] = 31455,
  [SMALL_STATE(340)] = 31517,
  [SMALL_STATE(341)] = 31579,
  [SMALL_STATE(342)] = 31641,
  [SMALL_STATE(343)] = 31697,
  [SMALL_STATE(344)] = 31749,
  [SMALL_STATE(345)] = 31797,
  [SMALL_STATE(346)] = 31853,
  [SMALL_STATE(347)] = 31909,
  [SMALL_STATE(348)] = 31954,
  [SMALL_STATE(349)] = 32013,
  [SMALL_STATE(350)] = 32071,
  [SMALL_STATE(351)] = 32127,
  [SMALL_STATE(352)] = 32185,
  [SMALL_STATE(353)] = 32223,
  [SMALL_STATE(354)] = 32279,
  [SMALL_STATE(355)] = 32339,
  [SMALL_STATE(356)] = 32397,
  [SMALL_STATE(357)] = 32455,
  [SMALL_STATE(358)] = 32511,
  [SMALL_STATE(359)] = 32568,
  [SMALL_STATE(360)] = 32621,
  [SMALL_STATE(361)] = 32660,
  [SMALL_STATE(362)] = 32699,
  [SMALL_STATE(363)] = 32738,
  [SMALL_STATE(364)] = 32787,
  [SMALL_STATE(365)] = 32836,
  [SMALL_STATE(366)] = 32876,
  [SMALL_STATE(367)] = 32918,
  [SMALL_STATE(368)] = 32964,
  [SMALL_STATE(369)] = 33010,
  [SMALL_STATE(370)] = 33052,
  [SMALL_STATE(371)] = 33094,
  [SMALL_STATE(372)] = 33140,
  [SMALL_STATE(373)] = 33182,
  [SMALL_STATE(374)] = 33213,
  [SMALL_STATE(375)] = 33254,
  [SMALL_STATE(376)] = 33299,
  [SMALL_STATE(377)] = 33342,
  [SMALL_STATE(378)] = 33387,
  [SMALL_STATE(379)] = 33429,
  [SMALL_STATE(380)] = 33457,
  [SMALL_STATE(381)] = 33485,
  [SMALL_STATE(382)] = 33513,
  [SMALL_STATE(383)] = 33541,
  [SMALL_STATE(384)] = 33569,
  [SMALL_STATE(385)] = 33597,
  [SMALL_STATE(386)] = 33625,
  [SMALL_STATE(387)] = 33653,
  [SMALL_STATE(388)] = 33695,
  [SMALL_STATE(389)] = 33723,
  [SMALL_STATE(390)] = 33751,
  [SMALL_STATE(391)] = 33779,
  [SMALL_STATE(392)] = 33807,
  [SMALL_STATE(393)] = 33845,
  [SMALL_STATE(394)] = 33873,
  [SMALL_STATE(395)] = 33901,
  [SMALL_STATE(396)] = 33929,
  [SMALL_STATE(397)] = 33964,
  [SMALL_STATE(398)] = 34001,
  [SMALL_STATE(399)] = 34034,
  [SMALL_STATE(400)] = 34073,
  [SMALL_STATE(401)] = 34110,
  [SMALL_STATE(402)] = 34145,
  [SMALL_STATE(403)] = 34180,
  [SMALL_STATE(404)] = 34213,
  [SMALL_STATE(405)] = 34252,
  [SMALL_STATE(406)] = 34291,
  [SMALL_STATE(407)] = 34328,
  [SMALL_STATE(408)] = 34355,
  [SMALL_STATE(409)] = 34390,
  [SMALL_STATE(410)] = 34417,
  [SMALL_STATE(411)] = 34444,
  [SMALL_STATE(412)] = 34483,
  [SMALL_STATE(413)] = 34522,
  [SMALL_STATE(414)] = 34557,
  [SMALL_STATE(415)] = 34593,
  [SMALL_STATE(416)] = 34625,
  [SMALL_STATE(417)] = 34661,
  [SMALL_STATE(418)] = 34689,
  [SMALL_STATE(419)] = 34723,
  [SMALL_STATE(420)] = 34759,
  [SMALL_STATE(421)] = 34795,
  [SMALL_STATE(422)] = 34829,
  [SMALL_STATE(423)] = 34863,
  [SMALL_STATE(424)] = 34897,
  [SMALL_STATE(425)] = 34933,
  [SMALL_STATE(426)] = 34969,
  [SMALL_STATE(427)] = 35005,
  [SMALL_STATE(428)] = 35041,
  [SMALL_STATE(429)] = 35077,
  [SMALL_STATE(430)] = 35113,
  [SMALL_STATE(431)] = 35149,
  [SMALL_STATE(432)] = 35185,
  [SMALL_STATE(433)] = 35214,
  [SMALL_STATE(434)] = 35243,
  [SMALL_STATE(435)] = 35276,
  [SMALL_STATE(436)] = 35305,
  [SMALL_STATE(437)] = 35332,
  [SMALL_STATE(438)] = 35361,
  [SMALL_STATE(439)] = 35394,
  [SMALL_STATE(440)] = 35423,
  [SMALL_STATE(441)] = 35452,
  [SMALL_STATE(442)] = 35485,
  [SMALL_STATE(443)] = 35514,
  [SMALL_STATE(444)] = 35543,
  [SMALL_STATE(445)] = 35576,
  [SMALL_STATE(446)] = 35605,
  [SMALL_STATE(447)] = 35638,
  [SMALL_STATE(448)] = 35667,
  [SMALL_STATE(449)] = 35700,
  [SMALL_STATE(450)] = 35733,
  [SMALL_STATE(451)] = 35762,
  [SMALL_STATE(452)] = 35791,
  [SMALL_STATE(453)] = 35824,
  [SMALL_STATE(454)] = 35857,
  [SMALL_STATE(455)] = 35886,
  [SMALL_STATE(456)] = 35915,
  [SMALL_STATE(457)] = 35944,
  [SMALL_STATE(458)] = 35973,
  [SMALL_STATE(459)] = 36002,
  [SMALL_STATE(460)] = 36035,
  [SMALL_STATE(461)] = 36064,
  [SMALL_STATE(462)] = 36093,
  [SMALL_STATE(463)] = 36122,
  [SMALL_STATE(464)] = 36151,
  [SMALL_STATE(465)] = 36180,
  [SMALL_STATE(466)] = 36213,
  [SMALL_STATE(467)] = 36242,
  [SMALL_STATE(468)] = 36272,
  [SMALL_STATE(469)] = 36302,
  [SMALL_STATE(470)] = 36332,
  [SMALL_STATE(471)] = 36362,
  [SMALL_STATE(472)] = 36392,
  [SMALL_STATE(473)] = 36422,
  [SMALL_STATE(474)] = 36452,
  [SMALL_STATE(475)] = 36482,
  [SMALL_STATE(476)] = 36502,
  [SMALL_STATE(477)] = 36532,
  [SMALL_STATE(478)] = 36562,
  [SMALL_STATE(479)] = 36582,
  [SMALL_STATE(480)] = 36612,
  [SMALL_STATE(481)] = 36632,
  [SMALL_STATE(482)] = 36660,
  [SMALL_STATE(483)] = 36686,
  [SMALL_STATE(484)] = 36716,
  [SMALL_STATE(485)] = 36746,
  [SMALL_STATE(486)] = 36776,
  [SMALL_STATE(487)] = 36804,
  [SMALL_STATE(488)] = 36834,
  [SMALL_STATE(489)] = 36864,
  [SMALL_STATE(490)] = 36884,
  [SMALL_STATE(491)] = 36904,
  [SMALL_STATE(492)] = 36924,
  [SMALL_STATE(493)] = 36954,
  [SMALL_STATE(494)] = 36984,
  [SMALL_STATE(495)] = 37014,
  [SMALL_STATE(496)] = 37044,
  [SMALL_STATE(497)] = 37064,
  [SMALL_STATE(498)] = 37092,
  [SMALL_STATE(499)] = 37122,
  [SMALL_STATE(500)] = 37152,
  [SMALL_STATE(501)] = 37178,
  [SMALL_STATE(502)] = 37208,
  [SMALL_STATE(503)] = 37238,
  [SMALL_STATE(504)] = 37268,
  [SMALL_STATE(505)] = 37298,
  [SMALL_STATE(506)] = 37328,
  [SMALL_STATE(507)] = 37358,
  [SMALL_STATE(508)] = 37388,
  [SMALL_STATE(509)] = 37418,
  [SMALL_STATE(510)] = 37448,
  [SMALL_STATE(511)] = 37478,
  [SMALL_STATE(512)] = 37508,
  [SMALL_STATE(513)] = 37528,
  [SMALL_STATE(514)] = 37558,
  [SMALL_STATE(515)] = 37588,
  [SMALL_STATE(516)] = 37618,
  [SMALL_STATE(517)] = 37646,
  [SMALL_STATE(518)] = 37676,
  [SMALL_STATE(519)] = 37706,
  [SMALL_STATE(520)] = 37736,
  [SMALL_STATE(521)] = 37756,
  [SMALL_STATE(522)] = 37786,
  [SMALL_STATE(523)] = 37816,
  [SMALL_STATE(524)] = 37846,
  [SMALL_STATE(525)] = 37876,
  [SMALL_STATE(526)] = 37902,
  [SMALL_STATE(527)] = 37932,
  [SMALL_STATE(528)] = 37962,
  [SMALL_STATE(529)] = 37992,
  [SMALL_STATE(530)] = 38020,
  [SMALL_STATE(531)] = 38050,
  [SMALL_STATE(532)] = 38076,
  [SMALL_STATE(533)] = 38106,
  [SMALL_STATE(534)] = 38136,
  [SMALL_STATE(535)] = 38166,
  [SMALL_STATE(536)] = 38196,
  [SMALL_STATE(537)] = 38226,
  [SMALL_STATE(538)] = 38256,
  [SMALL_STATE(539)] = 38283,
  [SMALL_STATE(540)] = 38308,
  [SMALL_STATE(541)] = 38335,
  [SMALL_STATE(542)] = 38358,
  [SMALL_STATE(543)] = 38385,
  [SMALL_STATE(544)] = 38412,
  [SMALL_STATE(545)] = 38435,
  [SMALL_STATE(546)] = 38458,
  [SMALL_STATE(547)] = 38485,
  [SMALL_STATE(548)] = 38508,
  [SMALL_STATE(549)] = 38535,
  [SMALL_STATE(550)] = 38560,
  [SMALL_STATE(551)] = 38587,
  [SMALL_STATE(552)] = 38614,
  [SMALL_STATE(553)] = 38641,
  [SMALL_STATE(554)] = 38668,
  [SMALL_STATE(555)] = 38691,
  [SMALL_STATE(556)] = 38718,
  [SMALL_STATE(557)] = 38741,
  [SMALL_STATE(558)] = 38764,
  [SMALL_STATE(559)] = 38791,
  [SMALL_STATE(560)] = 38818,
  [SMALL_STATE(561)] = 38845,
  [SMALL_STATE(562)] = 38870,
  [SMALL_STATE(563)] = 38895,
  [SMALL_STATE(564)] = 38920,
  [SMALL_STATE(565)] = 38943,
  [SMALL_STATE(566)] = 38966,
  [SMALL_STATE(567)] = 38989,
  [SMALL_STATE(568)] = 39016,
  [SMALL_STATE(569)] = 39043,
  [SMALL_STATE(570)] = 39066,
  [SMALL_STATE(571)] = 39093,
  [SMALL_STATE(572)] = 39116,
  [SMALL_STATE(573)] = 39141,
  [SMALL_STATE(574)] = 39166,
  [SMALL_STATE(575)] = 39193,
  [SMALL_STATE(576)] = 39218,
  [SMALL_STATE(577)] = 39245,
  [SMALL_STATE(578)] = 39272,
  [SMALL_STATE(579)] = 39295,
  [SMALL_STATE(580)] = 39322,
  [SMALL_STATE(581)] = 39349,
  [SMALL_STATE(582)] = 39376,
  [SMALL_STATE(583)] = 39403,
  [SMALL_STATE(584)] = 39430,
  [SMALL_STATE(585)] = 39453,
  [SMALL_STATE(586)] = 39480,
  [SMALL_STATE(587)] = 39507,
  [SMALL_STATE(588)] = 39534,
  [SMALL_STATE(589)] = 39557,
  [SMALL_STATE(590)] = 39580,
  [SMALL_STATE(591)] = 39607,
  [SMALL_STATE(592)] = 39630,
  [SMALL_STATE(593)] = 39653,
  [SMALL_STATE(594)] = 39680,
  [SMALL_STATE(595)] = 39703,
  [SMALL_STATE(596)] = 39728,
  [SMALL_STATE(597)] = 39751,
  [SMALL_STATE(598)] = 39774,
  [SMALL_STATE(599)] = 39801,
  [SMALL_STATE(600)] = 39828,
  [SMALL_STATE(601)] = 39851,
  [SMALL_STATE(602)] = 39878,
  [SMALL_STATE(603)] = 39905,
  [SMALL_STATE(604)] = 39928,
  [SMALL_STATE(605)] = 39955,
  [SMALL_STATE(606)] = 39982,
  [SMALL_STATE(607)] = 40009,
  [SMALL_STATE(608)] = 40036,
  [SMALL_STATE(609)] = 40059,
  [SMALL_STATE(610)] = 40086,
  [SMALL_STATE(611)] = 40113,
  [SMALL_STATE(612)] = 40140,
  [SMALL_STATE(613)] = 40167,
  [SMALL_STATE(614)] = 40194,
  [SMALL_STATE(615)] = 40219,
  [SMALL_STATE(616)] = 40246,
  [SMALL_STATE(617)] = 40273,
  [SMALL_STATE(618)] = 40300,
  [SMALL_STATE(619)] = 40327,
  [SMALL_STATE(620)] = 40354,
  [SMALL_STATE(621)] = 40381,
  [SMALL_STATE(622)] = 40405,
  [SMALL_STATE(623)] = 40427,
  [SMALL_STATE(624)] = 40451,
  [SMALL_STATE(625)] = 40475,
  [SMALL_STATE(626)] = 40499,
  [SMALL_STATE(627)] = 40521,
  [SMALL_STATE(628)] = 40543,
  [SMALL_STATE(629)] = 40567,
  [SMALL_STATE(630)] = 40589,
  [SMALL_STATE(631)] = 40611,
  [SMALL_STATE(632)] = 40633,
  [SMALL_STATE(633)] = 40657,
  [SMALL_STATE(634)] = 40681,
  [SMALL_STATE(635)] = 40703,
  [SMALL_STATE(636)] = 40727,
  [SMALL_STATE(637)] = 40749,
  [SMALL_STATE(638)] = 40771,
  [SMALL_STATE(639)] = 40793,
  [SMALL_STATE(640)] = 40817,
  [SMALL_STATE(641)] = 40839,
  [SMALL_STATE(642)] = 40861,
  [SMALL_STATE(643)] = 40883,
  [SMALL_STATE(644)] = 40905,
  [SMALL_STATE(645)] = 40927,
  [SMALL_STATE(646)] = 40949,
  [SMALL_STATE(647)] = 40973,
  [SMALL_STATE(648)] = 40995,
  [SMALL_STATE(649)] = 41019,
  [SMALL_STATE(650)] = 41041,
  [SMALL_STATE(651)] = 41063,
  [SMALL_STATE(652)] = 41087,
  [SMALL_STATE(653)] = 41111,
  [SMALL_STATE(654)] = 41133,
  [SMALL_STATE(655)] = 41155,
  [SMALL_STATE(656)] = 41177,
  [SMALL_STATE(657)] = 41199,
  [SMALL_STATE(658)] = 41221,
  [SMALL_STATE(659)] = 41245,
  [SMALL_STATE(660)] = 41267,
  [SMALL_STATE(661)] = 41289,
  [SMALL_STATE(662)] = 41311,
  [SMALL_STATE(663)] = 41333,
  [SMALL_STATE(664)] = 41355,
  [SMALL_STATE(665)] = 41379,
  [SMALL_STATE(666)] = 41401,
  [SMALL_STATE(667)] = 41423,
  [SMALL_STATE(668)] = 41447,
  [SMALL_STATE(669)] = 41469,
  [SMALL_STATE(670)] = 41491,
  [SMALL_STATE(671)] = 41515,
  [SMALL_STATE(672)] = 41537,
  [SMALL_STATE(673)] = 41561,
  [SMALL_STATE(674)] = 41583,
  [SMALL_STATE(675)] = 41605,
  [SMALL_STATE(676)] = 41627,
  [SMALL_STATE(677)] = 41649,
  [SMALL_STATE(678)] = 41671,
  [SMALL_STATE(679)] = 41693,
  [SMALL_STATE(680)] = 41715,
  [SMALL_STATE(681)] = 41737,
  [SMALL_STATE(682)] = 41759,
  [SMALL_STATE(683)] = 41783,
  [SMALL_STATE(684)] = 41805,
  [SMALL_STATE(685)] = 41827,
  [SMALL_STATE(686)] = 41849,
  [SMALL_STATE(687)] = 41871,
  [SMALL_STATE(688)] = 41893,
  [SMALL_STATE(689)] = 41915,
  [SMALL_STATE(690)] = 41939,
  [SMALL_STATE(691)] = 41961,
  [SMALL_STATE(692)] = 41983,
  [SMALL_STATE(693)] = 42005,
  [SMALL_STATE(694)] = 42027,
  [SMALL_STATE(695)] = 42049,
  [SMALL_STATE(696)] = 42071,
  [SMALL_STATE(697)] = 42093,
  [SMALL_STATE(698)] = 42115,
  [SMALL_STATE(699)] = 42137,
  [SMALL_STATE(700)] = 42159,
  [SMALL_STATE(701)] = 42181,
  [SMALL_STATE(702)] = 42203,
  [SMALL_STATE(703)] = 42227,
  [SMALL_STATE(704)] = 42249,
  [SMALL_STATE(705)] = 42271,
  [SMALL_STATE(706)] = 42293,
  [SMALL_STATE(707)] = 42315,
  [SMALL_STATE(708)] = 42337,
  [SMALL_STATE(709)] = 42359,
  [SMALL_STATE(710)] = 42383,
  [SMALL_STATE(711)] = 42407,
  [SMALL_STATE(712)] = 42431,
  [SMALL_STATE(713)] = 42453,
  [SMALL_STATE(714)] = 42475,
  [SMALL_STATE(715)] = 42499,
  [SMALL_STATE(716)] = 42523,
  [SMALL_STATE(717)] = 42545,
  [SMALL_STATE(718)] = 42567,
  [SMALL_STATE(719)] = 42591,
  [SMALL_STATE(720)] = 42615,
  [SMALL_STATE(721)] = 42637,
  [SMALL_STATE(722)] = 42661,
  [SMALL_STATE(723)] = 42683,
  [SMALL_STATE(724)] = 42707,
  [SMALL_STATE(725)] = 42729,
  [SMALL_STATE(726)] = 42751,
  [SMALL_STATE(727)] = 42773,
  [SMALL_STATE(728)] = 42795,
  [SMALL_STATE(729)] = 42819,
  [SMALL_STATE(730)] = 42840,
  [SMALL_STATE(731)] = 42861,
  [SMALL_STATE(732)] = 42882,
  [SMALL_STATE(733)] = 42903,
  [SMALL_STATE(734)] = 42924,
  [SMALL_STATE(735)] = 42945,
  [SMALL_STATE(736)] = 42962,
  [SMALL_STATE(737)] = 42983,
  [SMALL_STATE(738)] = 43004,
  [SMALL_STATE(739)] = 43025,
  [SMALL_STATE(740)] = 43044,
  [SMALL_STATE(741)] = 43065,
  [SMALL_STATE(742)] = 43086,
  [SMALL_STATE(743)] = 43107,
  [SMALL_STATE(744)] = 43128,
  [SMALL_STATE(745)] = 43149,
  [SMALL_STATE(746)] = 43170,
  [SMALL_STATE(747)] = 43191,
  [SMALL_STATE(748)] = 43212,
  [SMALL_STATE(749)] = 43233,
  [SMALL_STATE(750)] = 43254,
  [SMALL_STATE(751)] = 43275,
  [SMALL_STATE(752)] = 43296,
  [SMALL_STATE(753)] = 43317,
  [SMALL_STATE(754)] = 43338,
  [SMALL_STATE(755)] = 43357,
  [SMALL_STATE(756)] = 43374,
  [SMALL_STATE(757)] = 43391,
  [SMALL_STATE(758)] = 43412,
  [SMALL_STATE(759)] = 43433,
  [SMALL_STATE(760)] = 43454,
  [SMALL_STATE(761)] = 43475,
  [SMALL_STATE(762)] = 43496,
  [SMALL_STATE(763)] = 43517,
  [SMALL_STATE(764)] = 43534,
  [SMALL_STATE(765)] = 43555,
  [SMALL_STATE(766)] = 43576,
  [SMALL_STATE(767)] = 43597,
  [SMALL_STATE(768)] = 43618,
  [SMALL_STATE(769)] = 43635,
  [SMALL_STATE(770)] = 43652,
  [SMALL_STATE(771)] = 43673,
  [SMALL_STATE(772)] = 43694,
  [SMALL_STATE(773)] = 43715,
  [SMALL_STATE(774)] = 43736,
  [SMALL_STATE(775)] = 43757,
  [SMALL_STATE(776)] = 43775,
  [SMALL_STATE(777)] = 43793,
  [SMALL_STATE(778)] = 43811,
  [SMALL_STATE(779)] = 43829,
  [SMALL_STATE(780)] = 43847,
  [SMALL_STATE(781)] = 43865,
  [SMALL_STATE(782)] = 43883,
  [SMALL_STATE(783)] = 43901,
  [SMALL_STATE(784)] = 43919,
  [SMALL_STATE(785)] = 43937,
  [SMALL_STATE(786)] = 43955,
  [SMALL_STATE(787)] = 43973,
  [SMALL_STATE(788)] = 43991,
  [SMALL_STATE(789)] = 44009,
  [SMALL_STATE(790)] = 44027,
  [SMALL_STATE(791)] = 44045,
  [SMALL_STATE(792)] = 44063,
  [SMALL_STATE(793)] = 44081,
  [SMALL_STATE(794)] = 44099,
  [SMALL_STATE(795)] = 44117,
  [SMALL_STATE(796)] = 44135,
  [SMALL_STATE(797)] = 44153,
  [SMALL_STATE(798)] = 44171,
  [SMALL_STATE(799)] = 44189,
  [SMALL_STATE(800)] = 44207,
  [SMALL_STATE(801)] = 44225,
  [SMALL_STATE(802)] = 44243,
  [SMALL_STATE(803)] = 44261,
  [SMALL_STATE(804)] = 44279,
  [SMALL_STATE(805)] = 44297,
  [SMALL_STATE(806)] = 44315,
  [SMALL_STATE(807)] = 44333,
  [SMALL_STATE(808)] = 44351,
  [SMALL_STATE(809)] = 44369,
  [SMALL_STATE(810)] = 44387,
  [SMALL_STATE(811)] = 44405,
  [SMALL_STATE(812)] = 44423,
  [SMALL_STATE(813)] = 44441,
  [SMALL_STATE(814)] = 44459,
  [SMALL_STATE(815)] = 44477,
  [SMALL_STATE(816)] = 44495,
  [SMALL_STATE(817)] = 44513,
  [SMALL_STATE(818)] = 44531,
  [SMALL_STATE(819)] = 44549,
  [SMALL_STATE(820)] = 44567,
  [SMALL_STATE(821)] = 44585,
  [SMALL_STATE(822)] = 44603,
  [SMALL_STATE(823)] = 44621,
  [SMALL_STATE(824)] = 44639,
  [SMALL_STATE(825)] = 44657,
  [SMALL_STATE(826)] = 44675,
  [SMALL_STATE(827)] = 44693,
  [SMALL_STATE(828)] = 44711,
  [SMALL_STATE(829)] = 44729,
  [SMALL_STATE(830)] = 44747,
  [SMALL_STATE(831)] = 44765,
  [SMALL_STATE(832)] = 44783,
  [SMALL_STATE(833)] = 44801,
  [SMALL_STATE(834)] = 44819,
  [SMALL_STATE(835)] = 44837,
  [SMALL_STATE(836)] = 44855,
  [SMALL_STATE(837)] = 44873,
  [SMALL_STATE(838)] = 44891,
  [SMALL_STATE(839)] = 44909,
  [SMALL_STATE(840)] = 44927,
  [SMALL_STATE(841)] = 44945,
  [SMALL_STATE(842)] = 44963,
  [SMALL_STATE(843)] = 44981,
  [SMALL_STATE(844)] = 44999,
  [SMALL_STATE(845)] = 45017,
  [SMALL_STATE(846)] = 45035,
  [SMALL_STATE(847)] = 45053,
  [SMALL_STATE(848)] = 45071,
  [SMALL_STATE(849)] = 45089,
  [SMALL_STATE(850)] = 45107,
  [SMALL_STATE(851)] = 45125,
  [SMALL_STATE(852)] = 45143,
  [SMALL_STATE(853)] = 45161,
  [SMALL_STATE(854)] = 45179,
  [SMALL_STATE(855)] = 45197,
  [SMALL_STATE(856)] = 45215,
  [SMALL_STATE(857)] = 45233,
  [SMALL_STATE(858)] = 45251,
  [SMALL_STATE(859)] = 45269,
  [SMALL_STATE(860)] = 45287,
  [SMALL_STATE(861)] = 45305,
  [SMALL_STATE(862)] = 45323,
  [SMALL_STATE(863)] = 45341,
  [SMALL_STATE(864)] = 45359,
  [SMALL_STATE(865)] = 45377,
  [SMALL_STATE(866)] = 45395,
  [SMALL_STATE(867)] = 45413,
  [SMALL_STATE(868)] = 45431,
  [SMALL_STATE(869)] = 45449,
  [SMALL_STATE(870)] = 45467,
  [SMALL_STATE(871)] = 45485,
  [SMALL_STATE(872)] = 45503,
  [SMALL_STATE(873)] = 45521,
  [SMALL_STATE(874)] = 45539,
  [SMALL_STATE(875)] = 45557,
  [SMALL_STATE(876)] = 45575,
  [SMALL_STATE(877)] = 45593,
  [SMALL_STATE(878)] = 45611,
  [SMALL_STATE(879)] = 45629,
  [SMALL_STATE(880)] = 45647,
  [SMALL_STATE(881)] = 45665,
  [SMALL_STATE(882)] = 45683,
  [SMALL_STATE(883)] = 45701,
  [SMALL_STATE(884)] = 45719,
  [SMALL_STATE(885)] = 45737,
  [SMALL_STATE(886)] = 45755,
  [SMALL_STATE(887)] = 45773,
  [SMALL_STATE(888)] = 45791,
  [SMALL_STATE(889)] = 45809,
  [SMALL_STATE(890)] = 45827,
  [SMALL_STATE(891)] = 45845,
  [SMALL_STATE(892)] = 45863,
  [SMALL_STATE(893)] = 45881,
  [SMALL_STATE(894)] = 45899,
  [SMALL_STATE(895)] = 45917,
  [SMALL_STATE(896)] = 45935,
  [SMALL_STATE(897)] = 45953,
  [SMALL_STATE(898)] = 45971,
  [SMALL_STATE(899)] = 45989,
  [SMALL_STATE(900)] = 46007,
  [SMALL_STATE(901)] = 46025,
  [SMALL_STATE(902)] = 46043,
  [SMALL_STATE(903)] = 46061,
  [SMALL_STATE(904)] = 46079,
  [SMALL_STATE(905)] = 46097,
  [SMALL_STATE(906)] = 46115,
  [SMALL_STATE(907)] = 46133,
  [SMALL_STATE(908)] = 46151,
  [SMALL_STATE(909)] = 46169,
  [SMALL_STATE(910)] = 46187,
  [SMALL_STATE(911)] = 46205,
  [SMALL_STATE(912)] = 46223,
  [SMALL_STATE(913)] = 46241,
  [SMALL_STATE(914)] = 46259,
  [SMALL_STATE(915)] = 46277,
  [SMALL_STATE(916)] = 46295,
  [SMALL_STATE(917)] = 46313,
  [SMALL_STATE(918)] = 46331,
  [SMALL_STATE(919)] = 46349,
  [SMALL_STATE(920)] = 46367,
  [SMALL_STATE(921)] = 46385,
  [SMALL_STATE(922)] = 46403,
  [SMALL_STATE(923)] = 46421,
  [SMALL_STATE(924)] = 46439,
  [SMALL_STATE(925)] = 46457,
  [SMALL_STATE(926)] = 46475,
  [SMALL_STATE(927)] = 46493,
  [SMALL_STATE(928)] = 46511,
  [SMALL_STATE(929)] = 46529,
  [SMALL_STATE(930)] = 46547,
  [SMALL_STATE(931)] = 46565,
  [SMALL_STATE(932)] = 46583,
  [SMALL_STATE(933)] = 46601,
  [SMALL_STATE(934)] = 46619,
  [SMALL_STATE(935)] = 46637,
  [SMALL_STATE(936)] = 46655,
  [SMALL_STATE(937)] = 46673,
  [SMALL_STATE(938)] = 46691,
  [SMALL_STATE(939)] = 46709,
  [SMALL_STATE(940)] = 46727,
  [SMALL_STATE(941)] = 46745,
  [SMALL_STATE(942)] = 46763,
  [SMALL_STATE(943)] = 46781,
  [SMALL_STATE(944)] = 46799,
  [SMALL_STATE(945)] = 46817,
  [SMALL_STATE(946)] = 46835,
  [SMALL_STATE(947)] = 46853,
  [SMALL_STATE(948)] = 46871,
  [SMALL_STATE(949)] = 46889,
  [SMALL_STATE(950)] = 46907,
  [SMALL_STATE(951)] = 46925,
  [SMALL_STATE(952)] = 46943,
  [SMALL_STATE(953)] = 46961,
  [SMALL_STATE(954)] = 46979,
  [SMALL_STATE(955)] = 46997,
  [SMALL_STATE(956)] = 47015,
  [SMALL_STATE(957)] = 47033,
  [SMALL_STATE(958)] = 47051,
  [SMALL_STATE(959)] = 47069,
  [SMALL_STATE(960)] = 47087,
  [SMALL_STATE(961)] = 47105,
  [SMALL_STATE(962)] = 47123,
  [SMALL_STATE(963)] = 47141,
  [SMALL_STATE(964)] = 47159,
  [SMALL_STATE(965)] = 47177,
  [SMALL_STATE(966)] = 47181,
  [SMALL_STATE(967)] = 47185,
  [SMALL_STATE(968)] = 47189,
  [SMALL_STATE(969)] = 47193,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [9] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ROOT, 0),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(943),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr1_block, 1),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr1_loop, 1),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr1_loop, 2),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr1_block, 2),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr1_loop, 4),
  [149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr1_block, 4),
  [151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr1_block, 3),
  [153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instr_list_call, 1),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr1_loop, 3),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instr_list_call, 2),
  [169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instr_list_call, 3),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr1_loop, 5),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr1_block, 5),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(181),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instr_list, 1),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instr_list_repeat1, 2),
  [197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_instr_list_repeat1, 2), SHIFT_REPEAT(181),
  [200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instr_list_repeat1, 2), SHIFT_REPEAT(32),
  [203] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instr_list_repeat1, 2), SHIFT_REPEAT(24),
  [206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instr_list_repeat1, 2), SHIFT_REPEAT(36),
  [209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instr_list_repeat1, 2), SHIFT_REPEAT(65),
  [212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instr_list_repeat1, 2), SHIFT_REPEAT(483),
  [215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instr_list_repeat1, 2), SHIFT_REPEAT(672),
  [218] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instr_list_repeat1, 2), SHIFT_REPEAT(465),
  [221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_instr_list_repeat1, 2), SHIFT_REPEAT(281),
  [224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_instr_list_repeat1, 2), SHIFT_REPEAT(533),
  [227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_instr_list_repeat1, 2), SHIFT_REPEAT(198),
  [230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instr_list_repeat1, 2), SHIFT_REPEAT(186),
  [233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instr_list_repeat1, 2), SHIFT_REPEAT(200),
  [236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instr_list_repeat1, 2), SHIFT_REPEAT(450),
  [239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instr_list_repeat1, 2), SHIFT_REPEAT(474),
  [242] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instr_list_repeat1, 2), SHIFT_REPEAT(286),
  [245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instr_list_repeat1, 2), SHIFT_REPEAT(160),
  [248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instr_list_repeat1, 2), SHIFT_REPEAT(217),
  [251] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instr_list_repeat1, 2), SHIFT_REPEAT(438),
  [254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_instr_list_repeat1, 2), SHIFT_REPEAT(943),
  [257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_instr_list_repeat1, 2), SHIFT_REPEAT(766),
  [260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_instr_list_repeat1, 2), SHIFT_REPEAT(944),
  [263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instr_list_repeat1, 2), SHIFT_REPEAT(196),
  [266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_instr_list_repeat1, 2), SHIFT_REPEAT(479),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instr_list_call, 4),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2),
  [329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2), SHIFT_REPEAT(181),
  [332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2), SHIFT_REPEAT(32),
  [335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2), SHIFT_REPEAT(24),
  [338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2), SHIFT_REPEAT(36),
  [341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2), SHIFT_REPEAT(107),
  [344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2), SHIFT_REPEAT(483),
  [347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2), SHIFT_REPEAT(672),
  [350] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2), SHIFT_REPEAT(465),
  [353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2), SHIFT_REPEAT(281),
  [356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2), SHIFT_REPEAT(533),
  [359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2), SHIFT_REPEAT(198),
  [362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2), SHIFT_REPEAT(186),
  [365] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2), SHIFT_REPEAT(200),
  [368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2), SHIFT_REPEAT(450),
  [371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2), SHIFT_REPEAT(474),
  [374] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2), SHIFT_REPEAT(286),
  [377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2), SHIFT_REPEAT(160),
  [380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2), SHIFT_REPEAT(217),
  [383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2), SHIFT_REPEAT(438),
  [386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2), SHIFT_REPEAT(943),
  [389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2), SHIFT_REPEAT(766),
  [392] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2), SHIFT_REPEAT(944),
  [395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2), SHIFT_REPEAT(196),
  [398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_elem_expr_item_repeat1, 2), SHIFT_REPEAT(479),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_let, 1),
  [427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_op_let, 1), SHIFT(621),
  [430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_let, 1),
  [438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nat, 1),
  [456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nat, 1),
  [458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_let, 2),
  [462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_op_let, 2), SHIFT(621),
  [465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_let, 2),
  [467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_let, 3),
  [469] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_op_let, 3), SHIFT(621),
  [472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_let, 3),
  [474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index, 1),
  [476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index, 1),
  [478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instr_plain, 1),
  [482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instr_plain, 1),
  [484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr, 3),
  [488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expr, 3),
  [490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_op_let, 2), SHIFT(770),
  [493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instr_plain, 2),
  [495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instr_plain, 2),
  [497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_op_let, 3), SHIFT(770),
  [500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instr_plain, 3),
  [502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instr_plain, 3),
  [504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_let, 4),
  [506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_op_let, 4), SHIFT(770),
  [509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_let, 4),
  [511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_elem_list_repeat1, 2),
  [513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_elem_list_repeat1, 2),
  [515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_elem_list_repeat1, 2), SHIFT_REPEAT(174),
  [518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_elem_list_repeat1, 2), SHIFT_REPEAT(174),
  [521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_elem_list_repeat1, 2), SHIFT_REPEAT(185),
  [524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float, 1),
  [526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float, 1),
  [528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float, 2),
  [530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float, 2),
  [532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_table_copy, 1),
  [534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_table_copy, 1),
  [536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_table_init, 2),
  [538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_table_init, 2),
  [540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_op_let_repeat2, 2),
  [542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_op_let_repeat2, 2), SHIFT_REPEAT(948),
  [545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_op_let_repeat2, 2),
  [547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_op_let, 2), SHIFT(948),
  [550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_op_let, 4), SHIFT(948),
  [553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_op_let_repeat1, 2),
  [555] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_op_let_repeat1, 2), SHIFT_REPEAT(924),
  [558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_op_let_repeat1, 2),
  [560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_op_let, 3), SHIFT(948),
  [563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_let, 5),
  [565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_op_let, 5), SHIFT(948),
  [568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_let, 5),
  [570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_field_func_repeat1, 2),
  [572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_field_func_repeat1, 2), SHIFT_REPEAT(921),
  [575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_module_field_func_repeat1, 2),
  [577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_int, 1),
  [579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_int, 1),
  [581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_int, 2),
  [583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_int, 2),
  [585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_elem_list_repeat1, 1),
  [587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_elem_list_repeat1, 1),
  [589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_block_repeat1, 2),
  [591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_block_repeat1, 2), SHIFT_REPEAT(915),
  [594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_block_repeat1, 2),
  [596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_field_func_repeat1, 1),
  [598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_module_field_func_repeat1, 1),
  [600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_select, 2),
  [602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_op_select, 2), SHIFT(887),
  [605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_select, 2),
  [607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_block_repeat2, 2),
  [609] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_block_repeat2, 2), SHIFT_REPEAT(887),
  [612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_block_repeat2, 2),
  [614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_select, 1),
  [616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_op_select, 1), SHIFT(887),
  [619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_select, 1),
  [621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 4),
  [623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export, 4),
  [625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_if, 5),
  [627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_if, 5),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_if, 6),
  [633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_if, 6),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_loop, 5),
  [639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_loop, 5),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_if, 2),
  [645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_if, 2),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_if, 3),
  [651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_if, 3),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_block, 2),
  [657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_block, 2),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_loop, 3),
  [663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_loop, 3),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_offset_value, 3),
  [669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_offset_value, 3),
  [671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_block, 3),
  [673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_block, 3),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_block, 6),
  [679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_block, 6),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_loop, 2),
  [685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_loop, 2),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_block, 5),
  [691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_block, 5),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_loop, 4),
  [697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_loop, 4),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_loop, 6),
  [703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_loop, 6),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_if, 4),
  [709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_if, 4),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_block, 7),
  [715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_block, 7),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_if, 7),
  [721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_if, 7),
  [723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_block, 4),
  [727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_block, 4),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_loop, 7),
  [733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_loop, 7),
  [735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_if, 8),
  [739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_if, 8),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_if, 9),
  [745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_if, 9),
  [747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_if, 10),
  [751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_if, 10),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_type_results, 4),
  [757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_type_results, 4),
  [759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_simd_lane, 18),
  [761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_simd_lane, 18),
  [763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_simd_const, 18),
  [765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_simd_const, 18),
  [767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_block_repeat1, 1),
  [769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_block_repeat1, 1),
  [771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_if, 11),
  [773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_if, 11),
  [775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_simd_const, 10),
  [777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_simd_const, 10),
  [779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_locals_many, 3),
  [781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_locals_many, 3),
  [783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instr_call, 2),
  [785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instr_call, 2),
  [787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_loop, 8),
  [789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_loop, 8),
  [791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_block, 8),
  [793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_block, 8),
  [795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_const, 2),
  [797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_const, 2),
  [799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_type_params_many, 3),
  [801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_type_params_many, 3),
  [803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_type_results, 3),
  [805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_type_results, 3),
  [807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_simd_lane, 6),
  [809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_simd_lane, 6),
  [811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_simd_const, 6),
  [813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_simd_const, 6),
  [815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instr_call, 3),
  [817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instr_call, 3),
  [819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_func_bind, 5),
  [821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_func_bind, 5),
  [823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instr_call, 5),
  [825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instr_call, 5),
  [827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_table_copy, 3),
  [829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_table_copy, 3),
  [831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 5),
  [833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 5),
  [835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_type_params_one, 5),
  [837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_type_params_one, 5),
  [839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_locals_one, 5),
  [841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_locals_one, 5),
  [843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_table_init, 3),
  [845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_table_init, 3),
  [847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_locals_many, 4),
  [849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_locals_many, 4),
  [851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_type_params_many, 4),
  [853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_type_params_many, 4),
  [855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_simd_lane, 4),
  [857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_simd_lane, 4),
  [859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_simd_const, 4),
  [861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_simd_const, 4),
  [863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_func_bind, 1),
  [865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_func_bind, 1),
  [869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instr_plain, 4),
  [871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instr_plain, 4),
  [873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_align_value, 3),
  [875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_align_value, 3),
  [877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instr_block, 1),
  [879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instr_block, 1),
  [881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instr, 1),
  [883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instr, 1),
  [885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instr_call, 4),
  [887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instr_call, 4),
  [889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_op_let_repeat2, 1),
  [891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_op_let_repeat2, 1),
  [893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_use, 4),
  [895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_use, 4),
  [897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_locals, 1),
  [899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_locals, 1),
  [901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_op_let_repeat1, 1),
  [903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_op_let_repeat1, 1),
  [905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_type_params, 1),
  [907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_type_params, 1),
  [909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_block_repeat2, 1),
  [911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_block_repeat2, 1),
  [913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_instr_list_repeat1, 1),
  [915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_instr_list_repeat1, 1),
  [917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_type_num_type, 1),
  [919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_type_num_type, 1),
  [921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_type_ref, 5),
  [923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_type_ref, 5),
  [925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_elem_expr_item_repeat1, 1),
  [927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_elem_expr_item_repeat1, 1),
  [929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_type, 1),
  [931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_type, 1),
  [933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_num_type_f32, 1),
  [935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_num_type_f32, 1),
  [937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_num_type_f64, 1),
  [939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_num_type_f64, 1),
  [941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_type_imm, 1),
  [943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_type_imm, 1),
  [945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_value_type_ref_type, 1),
  [947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_value_type_ref_type, 1),
  [949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_type, 1),
  [951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_type, 1),
  [953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_type, 1),
  [955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_type, 1),
  [957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_type_mut, 4),
  [959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_type_mut, 4),
  [961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_type_ref, 4),
  [963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_type_ref, 4),
  [965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_num_type_i32, 1),
  [967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_num_type_i32, 1),
  [969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_num_type_i64, 1),
  [971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_num_type_i64, 1),
  [973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ROOT_repeat1, 2),
  [975] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ROOT_repeat1, 2), SHIFT_REPEAT(354),
  [978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ROOT, 1),
  [990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [1000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [1002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [1004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [1006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [1010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [1012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [1014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [1016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [1018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [1020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [1022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [1024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [1026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [1028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [1030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [1034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [1036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [1038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [1040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(602),
  [1042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [1044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [1046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [1050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [1052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [1054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [1056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [1058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [1060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [1062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [1064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [1066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [1068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [1070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [1072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [1074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [1076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [1078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [1080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [1082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_func_locals_many_repeat1, 2),
  [1084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_func_locals_many_repeat1, 2), SHIFT_REPEAT(911),
  [1087] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_func_locals_many_repeat1, 2), SHIFT_REPEAT(383),
  [1090] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_func_locals_many_repeat1, 2), SHIFT_REPEAT(385),
  [1093] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_func_locals_many_repeat1, 2), SHIFT_REPEAT(386),
  [1096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_func_locals_many_repeat1, 2), SHIFT_REPEAT(390),
  [1099] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_func_locals_many_repeat1, 2), SHIFT_REPEAT(391),
  [1102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_func_locals_many_repeat1, 2), SHIFT_REPEAT(394),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [1113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [1115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [1117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [1121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [1123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [1127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [1129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [1135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [1139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [1157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ROOT_repeat2, 2),
  [1159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_ROOT_repeat2, 2), SHIFT_REPEAT(377),
  [1162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [1164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [1166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr1_call, 1),
  [1168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [1170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [1172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [1174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [1176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [1178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [1180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [1182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 2),
  [1184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_repeat1, 2), SHIFT_REPEAT(370),
  [1187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 2), SHIFT_REPEAT(581),
  [1190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 2), SHIFT_REPEAT(491),
  [1193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 2), SHIFT_REPEAT(490),
  [1196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_repeat1, 2), SHIFT_REPEAT(490),
  [1199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 2), SHIFT_REPEAT(587),
  [1202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [1204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [1206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [1208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [1210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [1212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [1214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [1216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [1218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [1220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [1222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_field_func_repeat1, 2), SHIFT_REPEAT(849),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [1227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [1231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [1237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_func_locals_many_repeat1, 1),
  [1239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_func_locals_many_repeat1, 1),
  [1241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_offset_expr, 1),
  [1243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_offset_expr, 1),
  [1245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_offset, 1),
  [1247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_offset, 1),
  [1249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr1_call, 2),
  [1251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_offset_const_expr, 4),
  [1253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_offset_const_expr, 4),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [1257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_offset_const_expr, 3),
  [1259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_offset_const_expr, 3),
  [1261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_limits, 1),
  [1263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_limits, 1),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [1271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [1273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr1_call, 4),
  [1275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [1279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_desc_func_type_repeat1, 2),
  [1281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_desc_func_type_repeat1, 2), SHIFT_REPEAT(737),
  [1284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr1_call, 3),
  [1286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [1288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [1290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [1292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_elem_list_repeat2, 2),
  [1294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_elem_list_repeat2, 2), SHIFT_REPEAT(177),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [1301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [1305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elem_list, 1),
  [1307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elem_list, 2),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [1311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_result_ref_null, 1),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [1315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [1317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [1329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [1349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr1_call, 5),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [1357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [1359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [1361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [1363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment_block_annot, 2),
  [1365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comment_block_annot, 2),
  [1367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_parens, 2),
  [1369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_parens, 2),
  [1371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [1373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_limits, 2),
  [1375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_limits, 2),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [1379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [1381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [1383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_repeat1, 1),
  [1385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_annotation_repeat1, 1),
  [1387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_part, 1),
  [1389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_part, 1),
  [1391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment_line_annot, 1),
  [1393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comment_line_annot, 1),
  [1395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [1397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [1399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [1401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment_block_annot, 3),
  [1403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comment_block_annot, 3),
  [1405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_parens, 3),
  [1407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_parens, 3),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [1411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [1413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [1415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [1417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(649),
  [1420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [1422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(649),
  [1425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elem_kind, 1),
  [1427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elem_kind, 1),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [1431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_module_binary, 5),
  [1433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_module_binary, 5),
  [1435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_module_quote, 5),
  [1437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_module_quote, 5),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [1441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 5, .production_id = 1),
  [1443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 5, .production_id = 1),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [1447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [1453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [1455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr1_call, 6),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [1465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 4, .production_id = 1),
  [1467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 4, .production_id = 1),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [1471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_action_get, 5),
  [1473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_action_get, 5),
  [1475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_action_invoke, 5),
  [1477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_action_invoke, 5),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [1481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [1487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_action_invoke_repeat1, 2),
  [1489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_action_invoke_repeat1, 2), SHIFT_REPEAT(397),
  [1492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_limits, 3),
  [1494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_limits, 3),
  [1496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_action, 1),
  [1498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_action, 1),
  [1500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [1502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [1504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_result_ref_extern, 1),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [1508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_module, 1),
  [1510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_module, 1),
  [1512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [1514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 3),
  [1516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 3),
  [1518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_assert_return_repeat1, 2),
  [1520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assert_return_repeat1, 2), SHIFT_REPEAT(343),
  [1523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comment_block_annot_repeat1, 2), SHIFT_REPEAT(609),
  [1526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comment_block_annot_repeat1, 2),
  [1528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comment_block_annot_repeat1, 2), SHIFT_REPEAT(763),
  [1531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [1533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [1537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_action_invoke, 4),
  [1539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_action_invoke, 4),
  [1541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [1543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [1545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [1547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [1549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [1551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_action_get, 4),
  [1553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_action_get, 4),
  [1555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [1557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr1_plain, 1),
  [1559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [1561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [1563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [1565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 4),
  [1567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module, 4),
  [1569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [1571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_action_invoke, 6),
  [1573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_action_invoke, 6),
  [1575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [1577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_module_quote, 6),
  [1579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_module_quote, 6),
  [1581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expr1_call_repeat1, 2),
  [1583] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_expr1_call_repeat1, 2), SHIFT_REPEAT(181),
  [1586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_module_binary, 6),
  [1588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_module_binary, 6),
  [1590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_module_quote, 4),
  [1592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_module_quote, 4),
  [1594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [1596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [1598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [1600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [1602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [1604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [1606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_name, 1),
  [1608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_name, 1),
  [1610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr1_plain, 2),
  [1612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [1614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [1616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [1618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [1620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [1622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_script_module_binary, 4),
  [1624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_script_module_binary, 4),
  [1626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [1628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [1630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [1632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [1634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_memory_fields_data_repeat1, 2),
  [1636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_memory_fields_data_repeat1, 2), SHIFT_REPEAT(612),
  [1639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [1641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [1643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [1645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [1647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_return_canonical_nan, 4),
  [1649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_return_canonical_nan, 4),
  [1651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [1653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [1655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_global, 4),
  [1657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_global, 4),
  [1659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_script, 3),
  [1661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_script, 3),
  [1663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_type, 4),
  [1665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_type, 4),
  [1667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_input, 4),
  [1669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_input, 4),
  [1671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_output, 4),
  [1673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_output, 4),
  [1675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [1677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [1679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [1681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [1683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_data, 5),
  [1685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_data, 5),
  [1687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_func, 6, .production_id = 1),
  [1689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_func, 6, .production_id = 1),
  [1691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_script, 4),
  [1693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_script, 4),
  [1695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_elem, 5),
  [1697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_elem, 5),
  [1699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [1701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_func, 5, .production_id = 1),
  [1703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_func, 5, .production_id = 1),
  [1705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_output, 3),
  [1707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_output, 3),
  [1709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_memory, 4),
  [1711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_memory, 4),
  [1713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [1715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_elem, 7),
  [1717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_elem, 7),
  [1719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_elem, 4),
  [1721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_elem, 4),
  [1723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_data, 7),
  [1725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_data, 7),
  [1727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 1),
  [1729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 1),
  [1731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_register, 4),
  [1733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_register, 4),
  [1735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_global, 7),
  [1737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_global, 7),
  [1739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_data, 4),
  [1741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_data, 4),
  [1743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_global, 7, .production_id = 1),
  [1745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_global, 7, .production_id = 1),
  [1747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_func, 6),
  [1749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_func, 6),
  [1751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_start, 4),
  [1753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_start, 4),
  [1755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [1757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_exhaustion, 5),
  [1759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_exhaustion, 5),
  [1761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_func, 7),
  [1763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_func, 7),
  [1765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_func, 5),
  [1767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_func, 5),
  [1769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_export, 5),
  [1771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_export, 5),
  [1773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_invalid, 5),
  [1775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_invalid, 5),
  [1777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [1779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_global, 5, .production_id = 1),
  [1781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_global, 5, .production_id = 1),
  [1783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_malformed, 5),
  [1785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_malformed, 5),
  [1787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_global, 6, .production_id = 1),
  [1789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_global, 6, .production_id = 1),
  [1791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_func, 4, .production_id = 1),
  [1793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_func, 4, .production_id = 1),
  [1795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_global, 6),
  [1797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_global, 6),
  [1799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_global, 5),
  [1801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_global, 5),
  [1803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_memory, 6, .production_id = 1),
  [1805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_memory, 6, .production_id = 1),
  [1807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_table, 6, .production_id = 1),
  [1809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_table, 6, .production_id = 1),
  [1811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_func, 11, .production_id = 1),
  [1813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_func, 11, .production_id = 1),
  [1815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_func, 8, .production_id = 1),
  [1817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_func, 8, .production_id = 1),
  [1819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_type, 5, .production_id = 1),
  [1821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_type, 5, .production_id = 1),
  [1823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_return, 5),
  [1825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_return, 5),
  [1827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ROOT_repeat2, 1),
  [1829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_ROOT_repeat2, 1),
  [1831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_func, 10),
  [1833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_func, 10),
  [1835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [1837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_import, 6),
  [1839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_import, 6),
  [1841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_memory, 5, .production_id = 1),
  [1843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_memory, 5, .production_id = 1),
  [1845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_func, 10, .production_id = 1),
  [1847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_func, 10, .production_id = 1),
  [1849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field, 1),
  [1851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field, 1),
  [1853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command, 1),
  [1855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command, 1),
  [1857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_data, 6),
  [1859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_data, 6),
  [1861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_memory, 5),
  [1863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_memory, 5),
  [1865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_return_arithmetic_nan, 5),
  [1867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_return_arithmetic_nan, 5),
  [1869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assertion, 1),
  [1871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assertion, 1),
  [1873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_elem, 6),
  [1875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_elem, 6),
  [1877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_func, 9),
  [1879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_func, 9),
  [1881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_return_canonical_nan, 5),
  [1883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_return_canonical_nan, 5),
  [1885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_trap_action, 5),
  [1887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_trap_action, 5),
  [1889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_return, 4),
  [1891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_return, 4),
  [1893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_table, 5, .production_id = 1),
  [1895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_table, 5, .production_id = 1),
  [1897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ROOT_repeat1, 1),
  [1899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_ROOT_repeat1, 1),
  [1901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_trap_module, 5),
  [1903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_trap_module, 5),
  [1905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_func, 9, .production_id = 1),
  [1907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_func, 9, .production_id = 1),
  [1909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [1911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta, 1),
  [1913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta, 1),
  [1915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_func, 3),
  [1917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_func, 3),
  [1919] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comment_block_repeat1, 2), SHIFT_REPEAT(633),
  [1922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comment_block_repeat1, 2),
  [1924] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comment_block_repeat1, 2), SHIFT_REPEAT(735),
  [1927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_func, 7, .production_id = 1),
  [1929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_func, 7, .production_id = 1),
  [1931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_unlinkable, 5),
  [1933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_unlinkable, 5),
  [1935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_table, 5),
  [1937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_table, 5),
  [1939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [1941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [1943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_data, 3),
  [1945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_data, 3),
  [1947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_input, 5),
  [1949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_input, 5),
  [1951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [1953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_table, 4),
  [1955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_table, 4),
  [1957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_return_arithmetic_nan, 4),
  [1959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_return_arithmetic_nan, 4),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [1963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_output, 5),
  [1965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_output, 5),
  [1967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_func, 4),
  [1969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_func, 4),
  [1971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_register, 5),
  [1973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_register, 5),
  [1975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_script, 5),
  [1977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_script, 5),
  [1979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_func, 8),
  [1981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_func, 8),
  [1983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_field_global, 8, .production_id = 1),
  [1985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_field_global, 8, .production_id = 1),
  [1987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_desc_func_type_repeat1, 1),
  [1989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_import_desc_func_type_repeat1, 1),
  [1991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_block, 5),
  [1993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [1999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comment_block_repeat1, 1),
  [2001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [2003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_assert_return_repeat1, 1),
  [2005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_assert_return_repeat1, 1),
  [2007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_block, 3),
  [2009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [2011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_type, 1),
  [2013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_type, 1),
  [2015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_result, 3),
  [2017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_result, 3),
  [2019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr_plain_const, 3),
  [2021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expr_plain_const, 3),
  [2023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elem_expr_item, 3),
  [2025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elem_expr_item, 3),
  [2027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expr1_call_repeat1, 1),
  [2029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_expr1_call_repeat1, 1),
  [2031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_block, 6),
  [2033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [2035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_block, 7),
  [2037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(899),
  [2039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_block, 8),
  [2041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [2043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_action_invoke_repeat1, 1),
  [2045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_action_invoke_repeat1, 1),
  [2047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_memory_fields_data_repeat1, 1),
  [2049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comment_block, 2),
  [2051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comment_block, 3),
  [2053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elem_expr_expr, 1),
  [2055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elem_expr_expr, 1),
  [2057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elem_expr, 1),
  [2059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elem_expr, 1),
  [2061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_elem_list_repeat2, 1),
  [2063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_elem_list_repeat2, 1),
  [2065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comment_block_annot_repeat1, 1),
  [2067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elem_expr_item, 4),
  [2069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elem_expr_item, 4),
  [2071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [2073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [2075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_block, 4),
  [2077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [2079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [2081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [2083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [2085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [2087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [2089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [2091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_desc_func, 4),
  [2093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_fields_elem, 5),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [2099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_desc_func_type, 3),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [2103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_desc_global, 4),
  [2105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_desc_memory, 4),
  [2107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [2109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [2111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_desc_table, 4),
  [2113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [2115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [2117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [2119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [2121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_const_ref, 1),
  [2123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [2125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [2127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_type, 2),
  [2129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [2131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [2133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [2137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr1, 1),
  [2139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [2141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_result_const, 1),
  [2143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_fields_elem, 6),
  [2145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_desc_func_type, 4),
  [2147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [2149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_desc_type_use, 4),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [2153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_desc_global_type, 4),
  [2155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [2157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_desc_memory_type, 4),
  [2159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [2161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_desc_table_type, 4),
  [2163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_nan, 1),
  [2165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_result_const_nan, 4),
  [2167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr1_block, 6),
  [2169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [2171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [2173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr1_loop, 6),
  [2175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_field, 3),
  [2177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [2179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_desc, 1),
  [2181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [2183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [2185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [2187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [2189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [2191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_const_ref, 2),
  [2193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_fields_type, 2),
  [2195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [2197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_desc_type_use, 5),
  [2199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_desc_func_type, 5),
  [2201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_desc_global_type, 5),
  [2203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_desc_memory_type, 5),
  [2205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_desc_table_type, 5),
  [2207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [2209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_use, 4),
  [2211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr1_if, 3),
  [2213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expr1_if, 2),
  [2215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [2217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_memory_use, 4),
  [2219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [2221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [2223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_memory_fields_data, 3),
  [2225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [2227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_field, 4),
  [2229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [2231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [2233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [2235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [2237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [2239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_memory_fields_type, 1),
  [2241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_fields_elem, 4),
  [2243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [2245] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [2247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [2249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_memory_fields_data, 4),
  [2251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [2253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [2255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_block, 9),
  [2257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [2259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [2261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [2263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [2265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [2267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_block, 10),
  [2269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [2271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [2273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_block, 11),
  [2275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [2277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [2279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_block, 12),
  [2281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_memory_type, 1),
  [2283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [2285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [2287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [2289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [2291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [2293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [2295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [2297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [2299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [2301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [2303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [2305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_memory_fields_type, 2),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [2319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [2321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_fields_type, 1),
  [2323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [2327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [2329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [2331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_desc, 1),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [2335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [2337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [2339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [2341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [2343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [2345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 4),
  [2347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment_line, 1),
  [2349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment_block, 3),
  [2351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment_block, 2),
  [2353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 3),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_wast(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = (const uint16_t *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
