#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 2214
#define LARGE_STATE_COUNT 1044
#define SYMBOL_COUNT 270
#define ALIAS_COUNT 0
#define TOKEN_COUNT 151
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 12
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 47

enum {
  anon_sym_COMMA = 1,
  anon_sym_pub = 2,
  anon_sym_test = 3,
  anon_sym_comptime = 4,
  anon_sym_export = 5,
  anon_sym_extern = 6,
  anon_sym_inline = 7,
  anon_sym_noinline = 8,
  anon_sym_SEMI = 9,
  anon_sym_threadlocal = 10,
  anon_sym_usingnamespace = 11,
  anon_sym_fn = 12,
  anon_sym_BANG = 13,
  anon_sym_const = 14,
  anon_sym_var = 15,
  anon_sym_COLON = 16,
  anon_sym_EQ = 17,
  anon_sym_nosuspend = 18,
  anon_sym_defer = 19,
  anon_sym_suspend = 20,
  anon_sym_errdefer = 21,
  anon_sym_else = 22,
  anon_sym_or = 23,
  anon_sym_and = 24,
  anon_sym_break = 25,
  anon_sym_continue = 26,
  anon_sym_resume = 27,
  anon_sym_return = 28,
  anon_sym_LBRACE = 29,
  anon_sym_RBRACE = 30,
  anon_sym_async = 31,
  anon_sym_DOT = 32,
  anon_sym_error = 33,
  anon_sym_false = 34,
  anon_sym_null = 35,
  anon_sym_anyframe = 36,
  anon_sym_true = 37,
  anon_sym_undefined = 38,
  anon_sym_unreachable = 39,
  sym_BuildinTypeExpr = 40,
  anon_sym_packed = 41,
  anon_sym_LPAREN = 42,
  anon_sym_RPAREN = 43,
  anon_sym_switch = 44,
  anon_sym_asm = 45,
  anon_sym_volatile = 46,
  anon_sym_LBRACK = 47,
  anon_sym_RBRACK = 48,
  anon_sym_DASH_GT = 49,
  anon_sym_linksection = 50,
  anon_sym_addrspace = 51,
  anon_sym_callconv = 52,
  anon_sym_noalias = 53,
  anon_sym_DOT_DOT_DOT = 54,
  anon_sym_anytype = 55,
  anon_sym_if = 56,
  anon_sym_while = 57,
  anon_sym_for = 58,
  anon_sym_PIPE = 59,
  anon_sym_STAR = 60,
  anon_sym_EQ_GT = 61,
  anon_sym_DOT_DOT = 62,
  anon_sym_STAR_EQ = 63,
  anon_sym_STAR_PIPE_EQ = 64,
  anon_sym_SLASH_EQ = 65,
  anon_sym_PERCENT_EQ = 66,
  anon_sym_PLUS_EQ = 67,
  anon_sym_PLUS_PIPE_EQ = 68,
  anon_sym_DASH_EQ = 69,
  anon_sym_DASH_PIPE_EQ = 70,
  anon_sym_LT_LT_EQ = 71,
  anon_sym_LT_LT_PIPE_EQ = 72,
  anon_sym_GT_GT_EQ = 73,
  anon_sym_AMP_EQ = 74,
  anon_sym_CARET_EQ = 75,
  anon_sym_PIPE_EQ = 76,
  anon_sym_STAR_PERCENT_EQ = 77,
  anon_sym_PLUS_PERCENT_EQ = 78,
  anon_sym_DASH_PERCENT_EQ = 79,
  anon_sym_EQ_EQ = 80,
  anon_sym_BANG_EQ = 81,
  anon_sym_LT = 82,
  anon_sym_GT = 83,
  anon_sym_LT_EQ = 84,
  anon_sym_GT_EQ = 85,
  anon_sym_AMP = 86,
  anon_sym_CARET = 87,
  anon_sym_orelse = 88,
  anon_sym_catch = 89,
  anon_sym_LT_LT = 90,
  anon_sym_GT_GT = 91,
  anon_sym_LT_LT_PIPE = 92,
  anon_sym_PLUS = 93,
  anon_sym_DASH = 94,
  anon_sym_PLUS_PLUS = 95,
  anon_sym_PLUS_PERCENT = 96,
  anon_sym_DASH_PERCENT = 97,
  anon_sym_PLUS_PIPE = 98,
  anon_sym_DASH_PIPE = 99,
  anon_sym_PIPE_PIPE = 100,
  anon_sym_SLASH = 101,
  anon_sym_PERCENT = 102,
  anon_sym_STAR_STAR = 103,
  anon_sym_STAR_PERCENT = 104,
  anon_sym_STAR_PIPE = 105,
  anon_sym_TILDE = 106,
  anon_sym_try = 107,
  anon_sym_await = 108,
  anon_sym_QMARK = 109,
  anon_sym_allowzero = 110,
  anon_sym_align = 111,
  anon_sym_DOT_STAR = 112,
  anon_sym_DOT_QMARK = 113,
  anon_sym_c = 114,
  anon_sym_struct = 115,
  anon_sym_opaque = 116,
  anon_sym_enum = 117,
  anon_sym_union = 118,
  sym_container_doc_comment = 119,
  sym_doc_comment = 120,
  sym_line_comment = 121,
  anon_sym_SQUOTE = 122,
  aux_sym_CHAR_LITERAL_token1 = 123,
  aux_sym_FLOAT_token1 = 124,
  aux_sym_FLOAT_token2 = 125,
  aux_sym_FLOAT_token3 = 126,
  aux_sym_FLOAT_token4 = 127,
  aux_sym_INTEGER_token1 = 128,
  aux_sym_INTEGER_token2 = 129,
  aux_sym_INTEGER_token3 = 130,
  aux_sym_INTEGER_token4 = 131,
  anon_sym_BSLASH = 132,
  aux_sym_EscapeSequence_token1 = 133,
  aux_sym_EscapeSequence_token2 = 134,
  aux_sym_EscapeSequence_token3 = 135,
  anon_sym_LBRACE_LBRACE = 136,
  anon_sym_RBRACE_RBRACE = 137,
  aux_sym_FormatSequence_token1 = 138,
  aux_sym_FormatSequence_token2 = 139,
  anon_sym_any = 140,
  aux_sym_FormatSequence_token3 = 141,
  aux_sym_FormatSequence_token4 = 142,
  anon_sym_DQUOTE = 143,
  aux_sym_STRINGLITERALSINGLE_token1 = 144,
  anon_sym_LBRACE2 = 145,
  anon_sym_RBRACE2 = 146,
  anon_sym_BSLASH_BSLASH = 147,
  aux_sym_LINESTRING_token1 = 148,
  aux_sym_IDENTIFIER_token1 = 149,
  anon_sym_AT = 150,
  sym_source_file = 151,
  aux_sym__ContainerMembers = 152,
  sym__ContainerDeclarations = 153,
  sym_TestDecl = 154,
  sym_ComptimeDecl = 155,
  sym_Decl = 156,
  sym_FnProto = 157,
  sym_VarDecl = 158,
  sym_ContainerField = 159,
  sym_Statement = 160,
  sym_IfStatement = 161,
  sym__ElseStatementTail = 162,
  sym_LabeledStatement = 163,
  sym_LoopStatement = 164,
  sym_ForStatement = 165,
  sym_WhileStatement = 166,
  sym_BlockExprStatement = 167,
  sym_BlockExpr = 168,
  sym_AssignExpr = 169,
  sym__Expr = 170,
  sym_BinaryExpr = 171,
  sym_UnaryExpr = 172,
  sym__PrimaryExpr = 173,
  sym_IfExpr = 174,
  sym__ElseExprTail = 175,
  sym_Block = 176,
  sym_LoopExpr = 177,
  sym_ForExpr = 178,
  sym_WhileExpr = 179,
  sym__CurlySuffixExpr = 180,
  sym_InitList = 181,
  sym__TypeExpr = 182,
  sym_ErrorUnionExpr = 183,
  sym_SuffixExpr = 184,
  sym_FieldOrFnCall = 185,
  sym__PrimaryTypeExpr = 186,
  sym_ContainerDecl = 187,
  sym_ErrorSetDecl = 188,
  sym_GroupedExpr = 189,
  sym_IfTypeExpr = 190,
  sym__ElseTypeExprTail = 191,
  sym_LabeledTypeExpr = 192,
  sym_LoopTypeExpr = 193,
  sym_ForTypeExpr = 194,
  sym_WhileTypeExpr = 195,
  sym_SwitchExpr = 196,
  sym_AsmExpr = 197,
  sym_AsmOutput = 198,
  sym_AsmOutputItem = 199,
  sym_AsmInput = 200,
  sym_AsmInputItem = 201,
  sym_AsmClobbers = 202,
  sym_BreakLabel = 203,
  sym_BlockLabel = 204,
  sym_FieldInit = 205,
  sym_WhileContinueExpr = 206,
  sym_LinkSection = 207,
  sym_AddrSpace = 208,
  sym_CallConv = 209,
  sym_ParamDecl = 210,
  sym_ParamType = 211,
  sym_IfPrefix = 212,
  sym_WhilePrefix = 213,
  sym_ForPrefix = 214,
  sym_Payload = 215,
  sym_PtrPayload = 216,
  sym_PtrIndexPayload = 217,
  sym_PtrListPayload = 218,
  sym_SwitchProng = 219,
  sym_SwitchCase = 220,
  sym_SwitchItem = 221,
  sym_ForArgumentsList = 222,
  sym_ForItem = 223,
  sym_AssignOp = 224,
  sym_CompareOp = 225,
  sym_BitwiseOp = 226,
  sym_BitShiftOp = 227,
  sym_AdditionOp = 228,
  sym_MultiplyOp = 229,
  sym_PrefixOp = 230,
  sym_PrefixTypeOp = 231,
  sym__SentinelTerminatedExpr = 232,
  sym_SuffixOp = 233,
  sym_FnCallArguments = 234,
  sym_SliceTypeStart = 235,
  sym_PtrTypeStart = 236,
  sym_ArrayTypeStart = 237,
  sym__ContainerDeclAuto = 238,
  sym_ContainerDeclType = 239,
  sym_ByteAlign = 240,
  sym_ParamDeclList = 241,
  sym_CHAR_LITERAL = 242,
  sym_FLOAT = 243,
  sym_INTEGER = 244,
  sym_EscapeSequence = 245,
  sym_FormatSequence = 246,
  sym_STRINGLITERALSINGLE = 247,
  sym_LINESTRING = 248,
  sym__STRINGLITERAL = 249,
  sym_IDENTIFIER = 250,
  sym_BUILTINIDENTIFIER = 251,
  aux_sym_Block_repeat1 = 252,
  aux_sym_InitList_repeat1 = 253,
  aux_sym_InitList_repeat2 = 254,
  aux_sym__TypeExpr_repeat1 = 255,
  aux_sym_SuffixExpr_repeat1 = 256,
  aux_sym_ErrorSetDecl_repeat1 = 257,
  aux_sym_SwitchExpr_repeat1 = 258,
  aux_sym_AsmOutput_repeat1 = 259,
  aux_sym_AsmInput_repeat1 = 260,
  aux_sym_AsmClobbers_repeat1 = 261,
  aux_sym_PtrListPayload_repeat1 = 262,
  aux_sym_SwitchCase_repeat1 = 263,
  aux_sym_ForArgumentsList_repeat1 = 264,
  aux_sym_PrefixTypeOp_repeat1 = 265,
  aux_sym_PrefixTypeOp_repeat2 = 266,
  aux_sym_ParamDeclList_repeat1 = 267,
  aux_sym_STRINGLITERALSINGLE_repeat1 = 268,
  aux_sym__STRINGLITERAL_repeat1 = 269,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_COMMA] = ",",
  [anon_sym_pub] = "pub",
  [anon_sym_test] = "test",
  [anon_sym_comptime] = "comptime",
  [anon_sym_export] = "export",
  [anon_sym_extern] = "extern",
  [anon_sym_inline] = "inline",
  [anon_sym_noinline] = "noinline",
  [anon_sym_SEMI] = ";",
  [anon_sym_threadlocal] = "threadlocal",
  [anon_sym_usingnamespace] = "usingnamespace",
  [anon_sym_fn] = "fn",
  [anon_sym_BANG] = "!",
  [anon_sym_const] = "const",
  [anon_sym_var] = "var",
  [anon_sym_COLON] = ":",
  [anon_sym_EQ] = "=",
  [anon_sym_nosuspend] = "nosuspend",
  [anon_sym_defer] = "defer",
  [anon_sym_suspend] = "suspend",
  [anon_sym_errdefer] = "errdefer",
  [anon_sym_else] = "else",
  [anon_sym_or] = "or",
  [anon_sym_and] = "and",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_resume] = "resume",
  [anon_sym_return] = "return",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_async] = "async",
  [anon_sym_DOT] = ".",
  [anon_sym_error] = "error",
  [anon_sym_false] = "false",
  [anon_sym_null] = "null",
  [anon_sym_anyframe] = "anyframe",
  [anon_sym_true] = "true",
  [anon_sym_undefined] = "undefined",
  [anon_sym_unreachable] = "unreachable",
  [sym_BuildinTypeExpr] = "BuildinTypeExpr",
  [anon_sym_packed] = "packed",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_switch] = "switch",
  [anon_sym_asm] = "asm",
  [anon_sym_volatile] = "volatile",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_linksection] = "linksection",
  [anon_sym_addrspace] = "addrspace",
  [anon_sym_callconv] = "callconv",
  [anon_sym_noalias] = "noalias",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_anytype] = "anytype",
  [anon_sym_if] = "if",
  [anon_sym_while] = "while",
  [anon_sym_for] = "for",
  [anon_sym_PIPE] = "|",
  [anon_sym_STAR] = "*",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_STAR_PIPE_EQ] = "*|=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_PLUS_PIPE_EQ] = "+|=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_DASH_PIPE_EQ] = "-|=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_LT_LT_PIPE_EQ] = "<<|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_STAR_PERCENT_EQ] = "*%=",
  [anon_sym_PLUS_PERCENT_EQ] = "+%=",
  [anon_sym_DASH_PERCENT_EQ] = "-%=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_orelse] = "orelse",
  [anon_sym_catch] = "catch",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_LT_LT_PIPE] = "<<|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_PLUS_PERCENT] = "+%",
  [anon_sym_DASH_PERCENT] = "-%",
  [anon_sym_PLUS_PIPE] = "+|",
  [anon_sym_DASH_PIPE] = "-|",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_STAR_PERCENT] = "*%",
  [anon_sym_STAR_PIPE] = "*|",
  [anon_sym_TILDE] = "~",
  [anon_sym_try] = "try",
  [anon_sym_await] = "await",
  [anon_sym_QMARK] = "\?",
  [anon_sym_allowzero] = "allowzero",
  [anon_sym_align] = "align",
  [anon_sym_DOT_STAR] = ".*",
  [anon_sym_DOT_QMARK] = ".\?",
  [anon_sym_c] = "c",
  [anon_sym_struct] = "struct",
  [anon_sym_opaque] = "opaque",
  [anon_sym_enum] = "enum",
  [anon_sym_union] = "union",
  [sym_container_doc_comment] = "container_doc_comment",
  [sym_doc_comment] = "doc_comment",
  [sym_line_comment] = "line_comment",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_CHAR_LITERAL_token1] = "CHAR_LITERAL_token1",
  [aux_sym_FLOAT_token1] = "FLOAT_token1",
  [aux_sym_FLOAT_token2] = "FLOAT_token2",
  [aux_sym_FLOAT_token3] = "FLOAT_token3",
  [aux_sym_FLOAT_token4] = "FLOAT_token4",
  [aux_sym_INTEGER_token1] = "INTEGER_token1",
  [aux_sym_INTEGER_token2] = "INTEGER_token2",
  [aux_sym_INTEGER_token3] = "INTEGER_token3",
  [aux_sym_INTEGER_token4] = "INTEGER_token4",
  [anon_sym_BSLASH] = "\\",
  [aux_sym_EscapeSequence_token1] = "EscapeSequence_token1",
  [aux_sym_EscapeSequence_token2] = "EscapeSequence_token2",
  [aux_sym_EscapeSequence_token3] = "EscapeSequence_token3",
  [anon_sym_LBRACE_LBRACE] = "{{",
  [anon_sym_RBRACE_RBRACE] = "}}",
  [aux_sym_FormatSequence_token1] = "FormatSequence_token1",
  [aux_sym_FormatSequence_token2] = "FormatSequence_token2",
  [anon_sym_any] = "any",
  [aux_sym_FormatSequence_token3] = "FormatSequence_token3",
  [aux_sym_FormatSequence_token4] = "FormatSequence_token4",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_STRINGLITERALSINGLE_token1] = "STRINGLITERALSINGLE_token1",
  [anon_sym_LBRACE2] = "{",
  [anon_sym_RBRACE2] = "}",
  [anon_sym_BSLASH_BSLASH] = "\\\\",
  [aux_sym_LINESTRING_token1] = "LINESTRING_token1",
  [aux_sym_IDENTIFIER_token1] = "IDENTIFIER_token1",
  [anon_sym_AT] = "@",
  [sym_source_file] = "source_file",
  [aux_sym__ContainerMembers] = "_ContainerMembers",
  [sym__ContainerDeclarations] = "_ContainerDeclarations",
  [sym_TestDecl] = "TestDecl",
  [sym_ComptimeDecl] = "ComptimeDecl",
  [sym_Decl] = "Decl",
  [sym_FnProto] = "FnProto",
  [sym_VarDecl] = "VarDecl",
  [sym_ContainerField] = "ContainerField",
  [sym_Statement] = "Statement",
  [sym_IfStatement] = "IfStatement",
  [sym__ElseStatementTail] = "_ElseStatementTail",
  [sym_LabeledStatement] = "LabeledStatement",
  [sym_LoopStatement] = "LoopStatement",
  [sym_ForStatement] = "ForStatement",
  [sym_WhileStatement] = "WhileStatement",
  [sym_BlockExprStatement] = "BlockExprStatement",
  [sym_BlockExpr] = "BlockExpr",
  [sym_AssignExpr] = "AssignExpr",
  [sym__Expr] = "_Expr",
  [sym_BinaryExpr] = "BinaryExpr",
  [sym_UnaryExpr] = "UnaryExpr",
  [sym__PrimaryExpr] = "_PrimaryExpr",
  [sym_IfExpr] = "IfExpr",
  [sym__ElseExprTail] = "_ElseExprTail",
  [sym_Block] = "Block",
  [sym_LoopExpr] = "LoopExpr",
  [sym_ForExpr] = "ForExpr",
  [sym_WhileExpr] = "WhileExpr",
  [sym__CurlySuffixExpr] = "_CurlySuffixExpr",
  [sym_InitList] = "InitList",
  [sym__TypeExpr] = "_TypeExpr",
  [sym_ErrorUnionExpr] = "ErrorUnionExpr",
  [sym_SuffixExpr] = "SuffixExpr",
  [sym_FieldOrFnCall] = "FieldOrFnCall",
  [sym__PrimaryTypeExpr] = "_PrimaryTypeExpr",
  [sym_ContainerDecl] = "ContainerDecl",
  [sym_ErrorSetDecl] = "ErrorSetDecl",
  [sym_GroupedExpr] = "GroupedExpr",
  [sym_IfTypeExpr] = "IfTypeExpr",
  [sym__ElseTypeExprTail] = "_ElseTypeExprTail",
  [sym_LabeledTypeExpr] = "LabeledTypeExpr",
  [sym_LoopTypeExpr] = "LoopTypeExpr",
  [sym_ForTypeExpr] = "ForTypeExpr",
  [sym_WhileTypeExpr] = "WhileTypeExpr",
  [sym_SwitchExpr] = "SwitchExpr",
  [sym_AsmExpr] = "AsmExpr",
  [sym_AsmOutput] = "AsmOutput",
  [sym_AsmOutputItem] = "AsmOutputItem",
  [sym_AsmInput] = "AsmInput",
  [sym_AsmInputItem] = "AsmInputItem",
  [sym_AsmClobbers] = "AsmClobbers",
  [sym_BreakLabel] = "BreakLabel",
  [sym_BlockLabel] = "BlockLabel",
  [sym_FieldInit] = "FieldInit",
  [sym_WhileContinueExpr] = "WhileContinueExpr",
  [sym_LinkSection] = "LinkSection",
  [sym_AddrSpace] = "AddrSpace",
  [sym_CallConv] = "CallConv",
  [sym_ParamDecl] = "ParamDecl",
  [sym_ParamType] = "ParamType",
  [sym_IfPrefix] = "IfPrefix",
  [sym_WhilePrefix] = "WhilePrefix",
  [sym_ForPrefix] = "ForPrefix",
  [sym_Payload] = "Payload",
  [sym_PtrPayload] = "PtrPayload",
  [sym_PtrIndexPayload] = "PtrIndexPayload",
  [sym_PtrListPayload] = "PtrListPayload",
  [sym_SwitchProng] = "SwitchProng",
  [sym_SwitchCase] = "SwitchCase",
  [sym_SwitchItem] = "SwitchItem",
  [sym_ForArgumentsList] = "ForArgumentsList",
  [sym_ForItem] = "ForItem",
  [sym_AssignOp] = "AssignOp",
  [sym_CompareOp] = "CompareOp",
  [sym_BitwiseOp] = "BitwiseOp",
  [sym_BitShiftOp] = "BitShiftOp",
  [sym_AdditionOp] = "AdditionOp",
  [sym_MultiplyOp] = "MultiplyOp",
  [sym_PrefixOp] = "PrefixOp",
  [sym_PrefixTypeOp] = "PrefixTypeOp",
  [sym__SentinelTerminatedExpr] = "_SentinelTerminatedExpr",
  [sym_SuffixOp] = "SuffixOp",
  [sym_FnCallArguments] = "FnCallArguments",
  [sym_SliceTypeStart] = "SliceTypeStart",
  [sym_PtrTypeStart] = "PtrTypeStart",
  [sym_ArrayTypeStart] = "ArrayTypeStart",
  [sym__ContainerDeclAuto] = "_ContainerDeclAuto",
  [sym_ContainerDeclType] = "ContainerDeclType",
  [sym_ByteAlign] = "ByteAlign",
  [sym_ParamDeclList] = "ParamDeclList",
  [sym_CHAR_LITERAL] = "CHAR_LITERAL",
  [sym_FLOAT] = "FLOAT",
  [sym_INTEGER] = "INTEGER",
  [sym_EscapeSequence] = "EscapeSequence",
  [sym_FormatSequence] = "FormatSequence",
  [sym_STRINGLITERALSINGLE] = "STRINGLITERALSINGLE",
  [sym_LINESTRING] = "LINESTRING",
  [sym__STRINGLITERAL] = "_STRINGLITERAL",
  [sym_IDENTIFIER] = "IDENTIFIER",
  [sym_BUILTINIDENTIFIER] = "BUILTINIDENTIFIER",
  [aux_sym_Block_repeat1] = "Block_repeat1",
  [aux_sym_InitList_repeat1] = "InitList_repeat1",
  [aux_sym_InitList_repeat2] = "InitList_repeat2",
  [aux_sym__TypeExpr_repeat1] = "_TypeExpr_repeat1",
  [aux_sym_SuffixExpr_repeat1] = "SuffixExpr_repeat1",
  [aux_sym_ErrorSetDecl_repeat1] = "ErrorSetDecl_repeat1",
  [aux_sym_SwitchExpr_repeat1] = "SwitchExpr_repeat1",
  [aux_sym_AsmOutput_repeat1] = "AsmOutput_repeat1",
  [aux_sym_AsmInput_repeat1] = "AsmInput_repeat1",
  [aux_sym_AsmClobbers_repeat1] = "AsmClobbers_repeat1",
  [aux_sym_PtrListPayload_repeat1] = "PtrListPayload_repeat1",
  [aux_sym_SwitchCase_repeat1] = "SwitchCase_repeat1",
  [aux_sym_ForArgumentsList_repeat1] = "ForArgumentsList_repeat1",
  [aux_sym_PrefixTypeOp_repeat1] = "PrefixTypeOp_repeat1",
  [aux_sym_PrefixTypeOp_repeat2] = "PrefixTypeOp_repeat2",
  [aux_sym_ParamDeclList_repeat1] = "ParamDeclList_repeat1",
  [aux_sym_STRINGLITERALSINGLE_repeat1] = "STRINGLITERALSINGLE_repeat1",
  [aux_sym__STRINGLITERAL_repeat1] = "_STRINGLITERAL_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_pub] = anon_sym_pub,
  [anon_sym_test] = anon_sym_test,
  [anon_sym_comptime] = anon_sym_comptime,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym_inline] = anon_sym_inline,
  [anon_sym_noinline] = anon_sym_noinline,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_threadlocal] = anon_sym_threadlocal,
  [anon_sym_usingnamespace] = anon_sym_usingnamespace,
  [anon_sym_fn] = anon_sym_fn,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_nosuspend] = anon_sym_nosuspend,
  [anon_sym_defer] = anon_sym_defer,
  [anon_sym_suspend] = anon_sym_suspend,
  [anon_sym_errdefer] = anon_sym_errdefer,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_resume] = anon_sym_resume,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_error] = anon_sym_error,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_null] = anon_sym_null,
  [anon_sym_anyframe] = anon_sym_anyframe,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_undefined] = anon_sym_undefined,
  [anon_sym_unreachable] = anon_sym_unreachable,
  [sym_BuildinTypeExpr] = sym_BuildinTypeExpr,
  [anon_sym_packed] = anon_sym_packed,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_asm] = anon_sym_asm,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_linksection] = anon_sym_linksection,
  [anon_sym_addrspace] = anon_sym_addrspace,
  [anon_sym_callconv] = anon_sym_callconv,
  [anon_sym_noalias] = anon_sym_noalias,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_anytype] = anon_sym_anytype,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_STAR_PIPE_EQ] = anon_sym_STAR_PIPE_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_PLUS_PIPE_EQ] = anon_sym_PLUS_PIPE_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_DASH_PIPE_EQ] = anon_sym_DASH_PIPE_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_LT_LT_PIPE_EQ] = anon_sym_LT_LT_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_STAR_PERCENT_EQ] = anon_sym_STAR_PERCENT_EQ,
  [anon_sym_PLUS_PERCENT_EQ] = anon_sym_PLUS_PERCENT_EQ,
  [anon_sym_DASH_PERCENT_EQ] = anon_sym_DASH_PERCENT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_orelse] = anon_sym_orelse,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_LT_LT_PIPE] = anon_sym_LT_LT_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_PLUS_PERCENT] = anon_sym_PLUS_PERCENT,
  [anon_sym_DASH_PERCENT] = anon_sym_DASH_PERCENT,
  [anon_sym_PLUS_PIPE] = anon_sym_PLUS_PIPE,
  [anon_sym_DASH_PIPE] = anon_sym_DASH_PIPE,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_STAR_PERCENT] = anon_sym_STAR_PERCENT,
  [anon_sym_STAR_PIPE] = anon_sym_STAR_PIPE,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_allowzero] = anon_sym_allowzero,
  [anon_sym_align] = anon_sym_align,
  [anon_sym_DOT_STAR] = anon_sym_DOT_STAR,
  [anon_sym_DOT_QMARK] = anon_sym_DOT_QMARK,
  [anon_sym_c] = anon_sym_c,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_opaque] = anon_sym_opaque,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_union] = anon_sym_union,
  [sym_container_doc_comment] = sym_container_doc_comment,
  [sym_doc_comment] = sym_doc_comment,
  [sym_line_comment] = sym_line_comment,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_CHAR_LITERAL_token1] = aux_sym_CHAR_LITERAL_token1,
  [aux_sym_FLOAT_token1] = aux_sym_FLOAT_token1,
  [aux_sym_FLOAT_token2] = aux_sym_FLOAT_token2,
  [aux_sym_FLOAT_token3] = aux_sym_FLOAT_token3,
  [aux_sym_FLOAT_token4] = aux_sym_FLOAT_token4,
  [aux_sym_INTEGER_token1] = aux_sym_INTEGER_token1,
  [aux_sym_INTEGER_token2] = aux_sym_INTEGER_token2,
  [aux_sym_INTEGER_token3] = aux_sym_INTEGER_token3,
  [aux_sym_INTEGER_token4] = aux_sym_INTEGER_token4,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [aux_sym_EscapeSequence_token1] = aux_sym_EscapeSequence_token1,
  [aux_sym_EscapeSequence_token2] = aux_sym_EscapeSequence_token2,
  [aux_sym_EscapeSequence_token3] = aux_sym_EscapeSequence_token3,
  [anon_sym_LBRACE_LBRACE] = anon_sym_LBRACE_LBRACE,
  [anon_sym_RBRACE_RBRACE] = anon_sym_RBRACE_RBRACE,
  [aux_sym_FormatSequence_token1] = aux_sym_FormatSequence_token1,
  [aux_sym_FormatSequence_token2] = aux_sym_FormatSequence_token2,
  [anon_sym_any] = anon_sym_any,
  [aux_sym_FormatSequence_token3] = aux_sym_FormatSequence_token3,
  [aux_sym_FormatSequence_token4] = aux_sym_FormatSequence_token4,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_STRINGLITERALSINGLE_token1] = aux_sym_STRINGLITERALSINGLE_token1,
  [anon_sym_LBRACE2] = anon_sym_LBRACE,
  [anon_sym_RBRACE2] = anon_sym_RBRACE,
  [anon_sym_BSLASH_BSLASH] = anon_sym_BSLASH_BSLASH,
  [aux_sym_LINESTRING_token1] = aux_sym_LINESTRING_token1,
  [aux_sym_IDENTIFIER_token1] = aux_sym_IDENTIFIER_token1,
  [anon_sym_AT] = anon_sym_AT,
  [sym_source_file] = sym_source_file,
  [aux_sym__ContainerMembers] = aux_sym__ContainerMembers,
  [sym__ContainerDeclarations] = sym__ContainerDeclarations,
  [sym_TestDecl] = sym_TestDecl,
  [sym_ComptimeDecl] = sym_ComptimeDecl,
  [sym_Decl] = sym_Decl,
  [sym_FnProto] = sym_FnProto,
  [sym_VarDecl] = sym_VarDecl,
  [sym_ContainerField] = sym_ContainerField,
  [sym_Statement] = sym_Statement,
  [sym_IfStatement] = sym_IfStatement,
  [sym__ElseStatementTail] = sym__ElseStatementTail,
  [sym_LabeledStatement] = sym_LabeledStatement,
  [sym_LoopStatement] = sym_LoopStatement,
  [sym_ForStatement] = sym_ForStatement,
  [sym_WhileStatement] = sym_WhileStatement,
  [sym_BlockExprStatement] = sym_BlockExprStatement,
  [sym_BlockExpr] = sym_BlockExpr,
  [sym_AssignExpr] = sym_AssignExpr,
  [sym__Expr] = sym__Expr,
  [sym_BinaryExpr] = sym_BinaryExpr,
  [sym_UnaryExpr] = sym_UnaryExpr,
  [sym__PrimaryExpr] = sym__PrimaryExpr,
  [sym_IfExpr] = sym_IfExpr,
  [sym__ElseExprTail] = sym__ElseExprTail,
  [sym_Block] = sym_Block,
  [sym_LoopExpr] = sym_LoopExpr,
  [sym_ForExpr] = sym_ForExpr,
  [sym_WhileExpr] = sym_WhileExpr,
  [sym__CurlySuffixExpr] = sym__CurlySuffixExpr,
  [sym_InitList] = sym_InitList,
  [sym__TypeExpr] = sym__TypeExpr,
  [sym_ErrorUnionExpr] = sym_ErrorUnionExpr,
  [sym_SuffixExpr] = sym_SuffixExpr,
  [sym_FieldOrFnCall] = sym_FieldOrFnCall,
  [sym__PrimaryTypeExpr] = sym__PrimaryTypeExpr,
  [sym_ContainerDecl] = sym_ContainerDecl,
  [sym_ErrorSetDecl] = sym_ErrorSetDecl,
  [sym_GroupedExpr] = sym_GroupedExpr,
  [sym_IfTypeExpr] = sym_IfTypeExpr,
  [sym__ElseTypeExprTail] = sym__ElseTypeExprTail,
  [sym_LabeledTypeExpr] = sym_LabeledTypeExpr,
  [sym_LoopTypeExpr] = sym_LoopTypeExpr,
  [sym_ForTypeExpr] = sym_ForTypeExpr,
  [sym_WhileTypeExpr] = sym_WhileTypeExpr,
  [sym_SwitchExpr] = sym_SwitchExpr,
  [sym_AsmExpr] = sym_AsmExpr,
  [sym_AsmOutput] = sym_AsmOutput,
  [sym_AsmOutputItem] = sym_AsmOutputItem,
  [sym_AsmInput] = sym_AsmInput,
  [sym_AsmInputItem] = sym_AsmInputItem,
  [sym_AsmClobbers] = sym_AsmClobbers,
  [sym_BreakLabel] = sym_BreakLabel,
  [sym_BlockLabel] = sym_BlockLabel,
  [sym_FieldInit] = sym_FieldInit,
  [sym_WhileContinueExpr] = sym_WhileContinueExpr,
  [sym_LinkSection] = sym_LinkSection,
  [sym_AddrSpace] = sym_AddrSpace,
  [sym_CallConv] = sym_CallConv,
  [sym_ParamDecl] = sym_ParamDecl,
  [sym_ParamType] = sym_ParamType,
  [sym_IfPrefix] = sym_IfPrefix,
  [sym_WhilePrefix] = sym_WhilePrefix,
  [sym_ForPrefix] = sym_ForPrefix,
  [sym_Payload] = sym_Payload,
  [sym_PtrPayload] = sym_PtrPayload,
  [sym_PtrIndexPayload] = sym_PtrIndexPayload,
  [sym_PtrListPayload] = sym_PtrListPayload,
  [sym_SwitchProng] = sym_SwitchProng,
  [sym_SwitchCase] = sym_SwitchCase,
  [sym_SwitchItem] = sym_SwitchItem,
  [sym_ForArgumentsList] = sym_ForArgumentsList,
  [sym_ForItem] = sym_ForItem,
  [sym_AssignOp] = sym_AssignOp,
  [sym_CompareOp] = sym_CompareOp,
  [sym_BitwiseOp] = sym_BitwiseOp,
  [sym_BitShiftOp] = sym_BitShiftOp,
  [sym_AdditionOp] = sym_AdditionOp,
  [sym_MultiplyOp] = sym_MultiplyOp,
  [sym_PrefixOp] = sym_PrefixOp,
  [sym_PrefixTypeOp] = sym_PrefixTypeOp,
  [sym__SentinelTerminatedExpr] = sym__SentinelTerminatedExpr,
  [sym_SuffixOp] = sym_SuffixOp,
  [sym_FnCallArguments] = sym_FnCallArguments,
  [sym_SliceTypeStart] = sym_SliceTypeStart,
  [sym_PtrTypeStart] = sym_PtrTypeStart,
  [sym_ArrayTypeStart] = sym_ArrayTypeStart,
  [sym__ContainerDeclAuto] = sym__ContainerDeclAuto,
  [sym_ContainerDeclType] = sym_ContainerDeclType,
  [sym_ByteAlign] = sym_ByteAlign,
  [sym_ParamDeclList] = sym_ParamDeclList,
  [sym_CHAR_LITERAL] = sym_CHAR_LITERAL,
  [sym_FLOAT] = sym_FLOAT,
  [sym_INTEGER] = sym_INTEGER,
  [sym_EscapeSequence] = sym_EscapeSequence,
  [sym_FormatSequence] = sym_FormatSequence,
  [sym_STRINGLITERALSINGLE] = sym_STRINGLITERALSINGLE,
  [sym_LINESTRING] = sym_LINESTRING,
  [sym__STRINGLITERAL] = sym__STRINGLITERAL,
  [sym_IDENTIFIER] = sym_IDENTIFIER,
  [sym_BUILTINIDENTIFIER] = sym_BUILTINIDENTIFIER,
  [aux_sym_Block_repeat1] = aux_sym_Block_repeat1,
  [aux_sym_InitList_repeat1] = aux_sym_InitList_repeat1,
  [aux_sym_InitList_repeat2] = aux_sym_InitList_repeat2,
  [aux_sym__TypeExpr_repeat1] = aux_sym__TypeExpr_repeat1,
  [aux_sym_SuffixExpr_repeat1] = aux_sym_SuffixExpr_repeat1,
  [aux_sym_ErrorSetDecl_repeat1] = aux_sym_ErrorSetDecl_repeat1,
  [aux_sym_SwitchExpr_repeat1] = aux_sym_SwitchExpr_repeat1,
  [aux_sym_AsmOutput_repeat1] = aux_sym_AsmOutput_repeat1,
  [aux_sym_AsmInput_repeat1] = aux_sym_AsmInput_repeat1,
  [aux_sym_AsmClobbers_repeat1] = aux_sym_AsmClobbers_repeat1,
  [aux_sym_PtrListPayload_repeat1] = aux_sym_PtrListPayload_repeat1,
  [aux_sym_SwitchCase_repeat1] = aux_sym_SwitchCase_repeat1,
  [aux_sym_ForArgumentsList_repeat1] = aux_sym_ForArgumentsList_repeat1,
  [aux_sym_PrefixTypeOp_repeat1] = aux_sym_PrefixTypeOp_repeat1,
  [aux_sym_PrefixTypeOp_repeat2] = aux_sym_PrefixTypeOp_repeat2,
  [aux_sym_ParamDeclList_repeat1] = aux_sym_ParamDeclList_repeat1,
  [aux_sym_STRINGLITERALSINGLE_repeat1] = aux_sym_STRINGLITERALSINGLE_repeat1,
  [aux_sym__STRINGLITERAL_repeat1] = aux_sym__STRINGLITERAL_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pub] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_test] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_comptime] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noinline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_threadlocal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_usingnamespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nosuspend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_suspend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_errdefer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_resume] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_error] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_null] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_anyframe] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_undefined] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unreachable] = {
    .visible = true,
    .named = false,
  },
  [sym_BuildinTypeExpr] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_packed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_linksection] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_addrspace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_callconv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noalias] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_anytype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_orelse] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_allowzero] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_align] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_c] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_opaque] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [sym_container_doc_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_doc_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_CHAR_LITERAL_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_FLOAT_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_FLOAT_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_FLOAT_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_FLOAT_token4] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_INTEGER_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_INTEGER_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_INTEGER_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_INTEGER_token4] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_EscapeSequence_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_EscapeSequence_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_EscapeSequence_token3] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LBRACE_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_FormatSequence_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_FormatSequence_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_FormatSequence_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_FormatSequence_token4] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_STRINGLITERALSINGLE_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LBRACE2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_LINESTRING_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_IDENTIFIER_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__ContainerMembers] = {
    .visible = false,
    .named = false,
  },
  [sym__ContainerDeclarations] = {
    .visible = false,
    .named = true,
  },
  [sym_TestDecl] = {
    .visible = true,
    .named = true,
  },
  [sym_ComptimeDecl] = {
    .visible = true,
    .named = true,
  },
  [sym_Decl] = {
    .visible = true,
    .named = true,
  },
  [sym_FnProto] = {
    .visible = true,
    .named = true,
  },
  [sym_VarDecl] = {
    .visible = true,
    .named = true,
  },
  [sym_ContainerField] = {
    .visible = true,
    .named = true,
  },
  [sym_Statement] = {
    .visible = true,
    .named = true,
  },
  [sym_IfStatement] = {
    .visible = true,
    .named = true,
  },
  [sym__ElseStatementTail] = {
    .visible = false,
    .named = true,
  },
  [sym_LabeledStatement] = {
    .visible = true,
    .named = true,
  },
  [sym_LoopStatement] = {
    .visible = true,
    .named = true,
  },
  [sym_ForStatement] = {
    .visible = true,
    .named = true,
  },
  [sym_WhileStatement] = {
    .visible = true,
    .named = true,
  },
  [sym_BlockExprStatement] = {
    .visible = true,
    .named = true,
  },
  [sym_BlockExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_AssignExpr] = {
    .visible = true,
    .named = true,
  },
  [sym__Expr] = {
    .visible = false,
    .named = true,
  },
  [sym_BinaryExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_UnaryExpr] = {
    .visible = true,
    .named = true,
  },
  [sym__PrimaryExpr] = {
    .visible = false,
    .named = true,
  },
  [sym_IfExpr] = {
    .visible = true,
    .named = true,
  },
  [sym__ElseExprTail] = {
    .visible = false,
    .named = true,
  },
  [sym_Block] = {
    .visible = true,
    .named = true,
  },
  [sym_LoopExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_ForExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_WhileExpr] = {
    .visible = true,
    .named = true,
  },
  [sym__CurlySuffixExpr] = {
    .visible = false,
    .named = true,
  },
  [sym_InitList] = {
    .visible = true,
    .named = true,
  },
  [sym__TypeExpr] = {
    .visible = false,
    .named = true,
  },
  [sym_ErrorUnionExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_SuffixExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_FieldOrFnCall] = {
    .visible = true,
    .named = true,
  },
  [sym__PrimaryTypeExpr] = {
    .visible = false,
    .named = true,
  },
  [sym_ContainerDecl] = {
    .visible = true,
    .named = true,
  },
  [sym_ErrorSetDecl] = {
    .visible = true,
    .named = true,
  },
  [sym_GroupedExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_IfTypeExpr] = {
    .visible = true,
    .named = true,
  },
  [sym__ElseTypeExprTail] = {
    .visible = false,
    .named = true,
  },
  [sym_LabeledTypeExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_LoopTypeExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_ForTypeExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_WhileTypeExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_SwitchExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_AsmExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_AsmOutput] = {
    .visible = true,
    .named = true,
  },
  [sym_AsmOutputItem] = {
    .visible = true,
    .named = true,
  },
  [sym_AsmInput] = {
    .visible = true,
    .named = true,
  },
  [sym_AsmInputItem] = {
    .visible = true,
    .named = true,
  },
  [sym_AsmClobbers] = {
    .visible = true,
    .named = true,
  },
  [sym_BreakLabel] = {
    .visible = true,
    .named = true,
  },
  [sym_BlockLabel] = {
    .visible = true,
    .named = true,
  },
  [sym_FieldInit] = {
    .visible = true,
    .named = true,
  },
  [sym_WhileContinueExpr] = {
    .visible = true,
    .named = true,
  },
  [sym_LinkSection] = {
    .visible = true,
    .named = true,
  },
  [sym_AddrSpace] = {
    .visible = true,
    .named = true,
  },
  [sym_CallConv] = {
    .visible = true,
    .named = true,
  },
  [sym_ParamDecl] = {
    .visible = true,
    .named = true,
  },
  [sym_ParamType] = {
    .visible = true,
    .named = true,
  },
  [sym_IfPrefix] = {
    .visible = true,
    .named = true,
  },
  [sym_WhilePrefix] = {
    .visible = true,
    .named = true,
  },
  [sym_ForPrefix] = {
    .visible = true,
    .named = true,
  },
  [sym_Payload] = {
    .visible = true,
    .named = true,
  },
  [sym_PtrPayload] = {
    .visible = true,
    .named = true,
  },
  [sym_PtrIndexPayload] = {
    .visible = true,
    .named = true,
  },
  [sym_PtrListPayload] = {
    .visible = true,
    .named = true,
  },
  [sym_SwitchProng] = {
    .visible = true,
    .named = true,
  },
  [sym_SwitchCase] = {
    .visible = true,
    .named = true,
  },
  [sym_SwitchItem] = {
    .visible = true,
    .named = true,
  },
  [sym_ForArgumentsList] = {
    .visible = true,
    .named = true,
  },
  [sym_ForItem] = {
    .visible = true,
    .named = true,
  },
  [sym_AssignOp] = {
    .visible = true,
    .named = true,
  },
  [sym_CompareOp] = {
    .visible = true,
    .named = true,
  },
  [sym_BitwiseOp] = {
    .visible = true,
    .named = true,
  },
  [sym_BitShiftOp] = {
    .visible = true,
    .named = true,
  },
  [sym_AdditionOp] = {
    .visible = true,
    .named = true,
  },
  [sym_MultiplyOp] = {
    .visible = true,
    .named = true,
  },
  [sym_PrefixOp] = {
    .visible = true,
    .named = true,
  },
  [sym_PrefixTypeOp] = {
    .visible = true,
    .named = true,
  },
  [sym__SentinelTerminatedExpr] = {
    .visible = false,
    .named = true,
  },
  [sym_SuffixOp] = {
    .visible = true,
    .named = true,
  },
  [sym_FnCallArguments] = {
    .visible = true,
    .named = true,
  },
  [sym_SliceTypeStart] = {
    .visible = true,
    .named = true,
  },
  [sym_PtrTypeStart] = {
    .visible = true,
    .named = true,
  },
  [sym_ArrayTypeStart] = {
    .visible = true,
    .named = true,
  },
  [sym__ContainerDeclAuto] = {
    .visible = false,
    .named = true,
  },
  [sym_ContainerDeclType] = {
    .visible = true,
    .named = true,
  },
  [sym_ByteAlign] = {
    .visible = true,
    .named = true,
  },
  [sym_ParamDeclList] = {
    .visible = true,
    .named = true,
  },
  [sym_CHAR_LITERAL] = {
    .visible = true,
    .named = true,
  },
  [sym_FLOAT] = {
    .visible = true,
    .named = true,
  },
  [sym_INTEGER] = {
    .visible = true,
    .named = true,
  },
  [sym_EscapeSequence] = {
    .visible = true,
    .named = true,
  },
  [sym_FormatSequence] = {
    .visible = true,
    .named = true,
  },
  [sym_STRINGLITERALSINGLE] = {
    .visible = true,
    .named = true,
  },
  [sym_LINESTRING] = {
    .visible = true,
    .named = true,
  },
  [sym__STRINGLITERAL] = {
    .visible = false,
    .named = true,
  },
  [sym_IDENTIFIER] = {
    .visible = true,
    .named = true,
  },
  [sym_BUILTINIDENTIFIER] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_Block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_InitList_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_InitList_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__TypeExpr_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SuffixExpr_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_ErrorSetDecl_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SwitchExpr_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_AsmOutput_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_AsmInput_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_AsmClobbers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_PtrListPayload_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SwitchCase_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_ForArgumentsList_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_PrefixTypeOp_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_PrefixTypeOp_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_ParamDeclList_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_STRINGLITERALSINGLE_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__STRINGLITERAL_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_exception = 1,
  field_field_access = 2,
  field_field_constant = 3,
  field_field_member = 4,
  field_function = 5,
  field_function_call = 6,
  field_left = 7,
  field_operator = 8,
  field_parameter = 9,
  field_right = 10,
  field_variable = 11,
  field_variable_type_function = 12,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_exception] = "exception",
  [field_field_access] = "field_access",
  [field_field_constant] = "field_constant",
  [field_field_member] = "field_member",
  [field_function] = "function",
  [field_function_call] = "function_call",
  [field_left] = "left",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_right] = "right",
  [field_variable] = "variable",
  [field_variable_type_function] = "variable_type_function",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 1},
  [4] = {.index = 3, .length = 1},
  [5] = {.index = 4, .length = 1},
  [6] = {.index = 5, .length = 2},
  [7] = {.index = 7, .length = 1},
  [8] = {.index = 8, .length = 1},
  [9] = {.index = 9, .length = 1},
  [10] = {.index = 10, .length = 1},
  [11] = {.index = 8, .length = 1},
  [12] = {.index = 11, .length = 1},
  [13] = {.index = 11, .length = 1},
  [14] = {.index = 12, .length = 3},
  [15] = {.index = 15, .length = 1},
  [16] = {.index = 16, .length = 1},
  [17] = {.index = 17, .length = 1},
  [18] = {.index = 18, .length = 1},
  [19] = {.index = 18, .length = 1},
  [20] = {.index = 19, .length = 1},
  [21] = {.index = 20, .length = 2},
  [22] = {.index = 22, .length = 1},
  [23] = {.index = 23, .length = 2},
  [24] = {.index = 25, .length = 2},
  [25] = {.index = 27, .length = 1},
  [26] = {.index = 27, .length = 1},
  [27] = {.index = 28, .length = 1},
  [28] = {.index = 29, .length = 1},
  [29] = {.index = 29, .length = 1},
  [30] = {.index = 30, .length = 1},
  [31] = {.index = 31, .length = 2},
  [32] = {.index = 33, .length = 2},
  [33] = {.index = 35, .length = 1},
  [34] = {.index = 35, .length = 1},
  [35] = {.index = 36, .length = 1},
  [36] = {.index = 37, .length = 2},
  [37] = {.index = 39, .length = 1},
  [38] = {.index = 40, .length = 2},
  [39] = {.index = 42, .length = 1},
  [40] = {.index = 43, .length = 2},
  [41] = {.index = 45, .length = 2},
  [42] = {.index = 47, .length = 2},
  [43] = {.index = 49, .length = 2},
  [44] = {.index = 51, .length = 2},
  [45] = {.index = 53, .length = 2},
  [46] = {.index = 55, .length = 2},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_field_constant, 0, .inherited = true},
  [1] =
    {field_variable_type_function, 0},
  [2] =
    {field_field_constant, 1, .inherited = true},
  [3] =
    {field_variable_type_function, 1},
  [4] =
    {field_field_constant, 1},
  [5] =
    {field_left, 1},
    {field_operator, 0},
  [7] =
    {field_field_constant, 2},
  [8] =
    {field_field_member, 0},
  [9] =
    {field_exception, 1},
  [10] =
    {field_field_access, 1},
  [11] =
    {field_field_member, 1},
  [12] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [15] =
    {field_exception, 2},
  [16] =
    {field_function, 1},
  [17] =
    {field_function_call, 1},
  [18] =
    {field_parameter, 0},
  [19] =
    {field_exception, 3},
  [20] =
    {field_exception, 3},
    {field_function, 1},
  [22] =
    {field_field_constant, 3},
  [23] =
    {field_field_constant, 2},
    {field_field_constant, 3, .inherited = true},
  [25] =
    {field_field_constant, 0, .inherited = true},
    {field_field_constant, 1, .inherited = true},
  [27] =
    {field_field_member, 2},
  [28] =
    {field_variable, 1},
  [29] =
    {field_parameter, 1},
  [30] =
    {field_exception, 4},
  [31] =
    {field_exception, 4},
    {field_function, 1},
  [33] =
    {field_field_constant, 3},
    {field_field_constant, 4, .inherited = true},
  [35] =
    {field_parameter, 2},
  [36] =
    {field_exception, 5},
  [37] =
    {field_exception, 5},
    {field_function, 1},
  [39] =
    {field_exception, 6},
  [40] =
    {field_exception, 6},
    {field_function, 1},
  [42] =
    {field_variable, 2},
  [43] =
    {field_variable, 1},
    {field_variable, 2, .inherited = true},
  [45] =
    {field_variable, 0, .inherited = true},
    {field_variable, 1, .inherited = true},
  [47] =
    {field_exception, 7},
    {field_function, 1},
  [49] =
    {field_variable, 2},
    {field_variable, 3, .inherited = true},
  [51] =
    {field_variable, 1},
    {field_variable, 5},
  [53] =
    {field_variable, 1},
    {field_variable, 3},
  [55] =
    {field_variable, 2},
    {field_variable, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [8] = {
    [0] = sym_IDENTIFIER,
  },
  [12] = {
    [1] = sym_IDENTIFIER,
  },
  [18] = {
    [0] = sym_IDENTIFIER,
  },
  [25] = {
    [2] = sym_IDENTIFIER,
  },
  [28] = {
    [1] = sym_IDENTIFIER,
  },
  [33] = {
    [2] = sym_IDENTIFIER,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 2,
  [6] = 4,
  [7] = 3,
  [8] = 2,
  [9] = 2,
  [10] = 3,
  [11] = 4,
  [12] = 3,
  [13] = 4,
  [14] = 2,
  [15] = 2,
  [16] = 3,
  [17] = 4,
  [18] = 3,
  [19] = 4,
  [20] = 20,
  [21] = 21,
  [22] = 21,
  [23] = 21,
  [24] = 20,
  [25] = 20,
  [26] = 21,
  [27] = 20,
  [28] = 20,
  [29] = 29,
  [30] = 21,
  [31] = 20,
  [32] = 21,
  [33] = 20,
  [34] = 21,
  [35] = 21,
  [36] = 21,
  [37] = 20,
  [38] = 38,
  [39] = 20,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 42,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 43,
  [57] = 57,
  [58] = 41,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 55,
  [63] = 60,
  [64] = 48,
  [65] = 44,
  [66] = 66,
  [67] = 59,
  [68] = 60,
  [69] = 66,
  [70] = 59,
  [71] = 59,
  [72] = 60,
  [73] = 49,
  [74] = 66,
  [75] = 50,
  [76] = 66,
  [77] = 59,
  [78] = 66,
  [79] = 66,
  [80] = 60,
  [81] = 66,
  [82] = 59,
  [83] = 83,
  [84] = 60,
  [85] = 60,
  [86] = 59,
  [87] = 87,
  [88] = 61,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 90,
  [96] = 96,
  [97] = 90,
  [98] = 90,
  [99] = 90,
  [100] = 100,
  [101] = 90,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 104,
  [106] = 102,
  [107] = 107,
  [108] = 108,
  [109] = 102,
  [110] = 104,
  [111] = 104,
  [112] = 112,
  [113] = 102,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 102,
  [119] = 119,
  [120] = 120,
  [121] = 102,
  [122] = 104,
  [123] = 104,
  [124] = 117,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 127,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 130,
  [134] = 130,
  [135] = 128,
  [136] = 131,
  [137] = 128,
  [138] = 125,
  [139] = 125,
  [140] = 126,
  [141] = 128,
  [142] = 127,
  [143] = 125,
  [144] = 131,
  [145] = 130,
  [146] = 130,
  [147] = 147,
  [148] = 127,
  [149] = 127,
  [150] = 131,
  [151] = 131,
  [152] = 128,
  [153] = 125,
  [154] = 154,
  [155] = 130,
  [156] = 156,
  [157] = 127,
  [158] = 131,
  [159] = 128,
  [160] = 125,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 164,
  [171] = 164,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 175,
  [178] = 164,
  [179] = 164,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 182,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 176,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 174,
  [194] = 162,
  [195] = 195,
  [196] = 163,
  [197] = 197,
  [198] = 163,
  [199] = 197,
  [200] = 182,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 161,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 164,
  [216] = 216,
  [217] = 190,
  [218] = 218,
  [219] = 169,
  [220] = 192,
  [221] = 182,
  [222] = 190,
  [223] = 161,
  [224] = 205,
  [225] = 204,
  [226] = 203,
  [227] = 202,
  [228] = 195,
  [229] = 162,
  [230] = 163,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 197,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 169,
  [239] = 233,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 161,
  [246] = 205,
  [247] = 204,
  [248] = 203,
  [249] = 202,
  [250] = 195,
  [251] = 162,
  [252] = 174,
  [253] = 253,
  [254] = 218,
  [255] = 255,
  [256] = 256,
  [257] = 190,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 233,
  [265] = 175,
  [266] = 176,
  [267] = 267,
  [268] = 192,
  [269] = 182,
  [270] = 190,
  [271] = 174,
  [272] = 175,
  [273] = 197,
  [274] = 274,
  [275] = 169,
  [276] = 276,
  [277] = 163,
  [278] = 278,
  [279] = 176,
  [280] = 259,
  [281] = 267,
  [282] = 163,
  [283] = 244,
  [284] = 284,
  [285] = 211,
  [286] = 161,
  [287] = 205,
  [288] = 204,
  [289] = 203,
  [290] = 202,
  [291] = 291,
  [292] = 195,
  [293] = 293,
  [294] = 162,
  [295] = 197,
  [296] = 176,
  [297] = 175,
  [298] = 174,
  [299] = 233,
  [300] = 167,
  [301] = 197,
  [302] = 195,
  [303] = 303,
  [304] = 304,
  [305] = 164,
  [306] = 233,
  [307] = 202,
  [308] = 203,
  [309] = 190,
  [310] = 204,
  [311] = 311,
  [312] = 169,
  [313] = 176,
  [314] = 175,
  [315] = 205,
  [316] = 161,
  [317] = 276,
  [318] = 311,
  [319] = 218,
  [320] = 291,
  [321] = 174,
  [322] = 259,
  [323] = 210,
  [324] = 209,
  [325] = 205,
  [326] = 204,
  [327] = 203,
  [328] = 328,
  [329] = 202,
  [330] = 195,
  [331] = 162,
  [332] = 182,
  [333] = 169,
  [334] = 236,
  [335] = 218,
  [336] = 192,
  [337] = 233,
  [338] = 338,
  [339] = 338,
  [340] = 338,
  [341] = 338,
  [342] = 338,
  [343] = 55,
  [344] = 50,
  [345] = 49,
  [346] = 44,
  [347] = 347,
  [348] = 48,
  [349] = 338,
  [350] = 350,
  [351] = 351,
  [352] = 352,
  [353] = 353,
  [354] = 352,
  [355] = 351,
  [356] = 350,
  [357] = 351,
  [358] = 350,
  [359] = 351,
  [360] = 350,
  [361] = 350,
  [362] = 350,
  [363] = 352,
  [364] = 48,
  [365] = 44,
  [366] = 366,
  [367] = 351,
  [368] = 352,
  [369] = 49,
  [370] = 370,
  [371] = 352,
  [372] = 50,
  [373] = 55,
  [374] = 352,
  [375] = 351,
  [376] = 376,
  [377] = 377,
  [378] = 376,
  [379] = 379,
  [380] = 377,
  [381] = 381,
  [382] = 382,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 385,
  [388] = 381,
  [389] = 384,
  [390] = 386,
  [391] = 379,
  [392] = 383,
  [393] = 382,
  [394] = 394,
  [395] = 394,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 399,
  [400] = 400,
  [401] = 396,
  [402] = 402,
  [403] = 397,
  [404] = 398,
  [405] = 399,
  [406] = 400,
  [407] = 407,
  [408] = 408,
  [409] = 49,
  [410] = 50,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 44,
  [415] = 402,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 421,
  [422] = 422,
  [423] = 423,
  [424] = 48,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 428,
  [429] = 425,
  [430] = 413,
  [431] = 421,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 420,
  [437] = 419,
  [438] = 416,
  [439] = 417,
  [440] = 418,
  [441] = 407,
  [442] = 426,
  [443] = 412,
  [444] = 423,
  [445] = 408,
  [446] = 432,
  [447] = 427,
  [448] = 411,
  [449] = 428,
  [450] = 450,
  [451] = 50,
  [452] = 49,
  [453] = 44,
  [454] = 48,
  [455] = 422,
  [456] = 456,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 466,
  [467] = 467,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 472,
  [473] = 473,
  [474] = 474,
  [475] = 475,
  [476] = 476,
  [477] = 477,
  [478] = 478,
  [479] = 479,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 491,
  [492] = 42,
  [493] = 43,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 53,
  [498] = 52,
  [499] = 499,
  [500] = 54,
  [501] = 501,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 45,
  [506] = 506,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 510,
  [511] = 511,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 526,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 42,
  [548] = 53,
  [549] = 549,
  [550] = 464,
  [551] = 52,
  [552] = 465,
  [553] = 467,
  [554] = 468,
  [555] = 469,
  [556] = 470,
  [557] = 54,
  [558] = 471,
  [559] = 472,
  [560] = 473,
  [561] = 474,
  [562] = 475,
  [563] = 476,
  [564] = 477,
  [565] = 478,
  [566] = 480,
  [567] = 481,
  [568] = 482,
  [569] = 483,
  [570] = 484,
  [571] = 485,
  [572] = 45,
  [573] = 486,
  [574] = 487,
  [575] = 488,
  [576] = 489,
  [577] = 490,
  [578] = 491,
  [579] = 494,
  [580] = 499,
  [581] = 502,
  [582] = 504,
  [583] = 506,
  [584] = 507,
  [585] = 508,
  [586] = 510,
  [587] = 511,
  [588] = 512,
  [589] = 513,
  [590] = 514,
  [591] = 515,
  [592] = 516,
  [593] = 517,
  [594] = 518,
  [595] = 519,
  [596] = 520,
  [597] = 522,
  [598] = 523,
  [599] = 524,
  [600] = 525,
  [601] = 526,
  [602] = 527,
  [603] = 528,
  [604] = 529,
  [605] = 530,
  [606] = 531,
  [607] = 532,
  [608] = 533,
  [609] = 534,
  [610] = 535,
  [611] = 536,
  [612] = 537,
  [613] = 538,
  [614] = 539,
  [615] = 540,
  [616] = 541,
  [617] = 542,
  [618] = 544,
  [619] = 545,
  [620] = 43,
  [621] = 49,
  [622] = 48,
  [623] = 50,
  [624] = 624,
  [625] = 624,
  [626] = 626,
  [627] = 624,
  [628] = 624,
  [629] = 626,
  [630] = 626,
  [631] = 626,
  [632] = 44,
  [633] = 633,
  [634] = 626,
  [635] = 624,
  [636] = 636,
  [637] = 626,
  [638] = 624,
  [639] = 55,
  [640] = 55,
  [641] = 50,
  [642] = 49,
  [643] = 636,
  [644] = 44,
  [645] = 48,
  [646] = 633,
  [647] = 647,
  [648] = 648,
  [649] = 649,
  [650] = 648,
  [651] = 651,
  [652] = 652,
  [653] = 55,
  [654] = 647,
  [655] = 655,
  [656] = 648,
  [657] = 657,
  [658] = 658,
  [659] = 659,
  [660] = 648,
  [661] = 648,
  [662] = 647,
  [663] = 647,
  [664] = 648,
  [665] = 665,
  [666] = 666,
  [667] = 647,
  [668] = 668,
  [669] = 647,
  [670] = 670,
  [671] = 671,
  [672] = 672,
  [673] = 649,
  [674] = 651,
  [675] = 55,
  [676] = 659,
  [677] = 658,
  [678] = 671,
  [679] = 665,
  [680] = 655,
  [681] = 681,
  [682] = 670,
  [683] = 652,
  [684] = 672,
  [685] = 685,
  [686] = 686,
  [687] = 687,
  [688] = 688,
  [689] = 686,
  [690] = 687,
  [691] = 688,
  [692] = 685,
  [693] = 688,
  [694] = 685,
  [695] = 687,
  [696] = 686,
  [697] = 688,
  [698] = 686,
  [699] = 687,
  [700] = 686,
  [701] = 688,
  [702] = 685,
  [703] = 685,
  [704] = 687,
  [705] = 686,
  [706] = 688,
  [707] = 685,
  [708] = 687,
  [709] = 709,
  [710] = 710,
  [711] = 711,
  [712] = 711,
  [713] = 709,
  [714] = 714,
  [715] = 715,
  [716] = 709,
  [717] = 709,
  [718] = 714,
  [719] = 710,
  [720] = 715,
  [721] = 715,
  [722] = 710,
  [723] = 715,
  [724] = 715,
  [725] = 725,
  [726] = 711,
  [727] = 727,
  [728] = 725,
  [729] = 714,
  [730] = 709,
  [731] = 709,
  [732] = 711,
  [733] = 733,
  [734] = 734,
  [735] = 715,
  [736] = 710,
  [737] = 710,
  [738] = 725,
  [739] = 725,
  [740] = 740,
  [741] = 710,
  [742] = 711,
  [743] = 725,
  [744] = 725,
  [745] = 714,
  [746] = 714,
  [747] = 711,
  [748] = 714,
  [749] = 749,
  [750] = 750,
  [751] = 751,
  [752] = 752,
  [753] = 753,
  [754] = 753,
  [755] = 753,
  [756] = 756,
  [757] = 753,
  [758] = 758,
  [759] = 753,
  [760] = 760,
  [761] = 753,
  [762] = 762,
  [763] = 763,
  [764] = 763,
  [765] = 765,
  [766] = 763,
  [767] = 767,
  [768] = 767,
  [769] = 769,
  [770] = 765,
  [771] = 771,
  [772] = 767,
  [773] = 773,
  [774] = 774,
  [775] = 767,
  [776] = 776,
  [777] = 769,
  [778] = 765,
  [779] = 776,
  [780] = 780,
  [781] = 780,
  [782] = 769,
  [783] = 773,
  [784] = 776,
  [785] = 773,
  [786] = 780,
  [787] = 773,
  [788] = 788,
  [789] = 763,
  [790] = 763,
  [791] = 765,
  [792] = 773,
  [793] = 763,
  [794] = 767,
  [795] = 780,
  [796] = 780,
  [797] = 767,
  [798] = 788,
  [799] = 769,
  [800] = 776,
  [801] = 788,
  [802] = 776,
  [803] = 769,
  [804] = 773,
  [805] = 780,
  [806] = 806,
  [807] = 788,
  [808] = 788,
  [809] = 788,
  [810] = 769,
  [811] = 765,
  [812] = 765,
  [813] = 776,
  [814] = 814,
  [815] = 814,
  [816] = 816,
  [817] = 817,
  [818] = 818,
  [819] = 819,
  [820] = 820,
  [821] = 821,
  [822] = 822,
  [823] = 816,
  [824] = 824,
  [825] = 814,
  [826] = 826,
  [827] = 817,
  [828] = 828,
  [829] = 816,
  [830] = 819,
  [831] = 817,
  [832] = 822,
  [833] = 828,
  [834] = 821,
  [835] = 821,
  [836] = 836,
  [837] = 837,
  [838] = 838,
  [839] = 814,
  [840] = 840,
  [841] = 818,
  [842] = 836,
  [843] = 843,
  [844] = 828,
  [845] = 822,
  [846] = 846,
  [847] = 824,
  [848] = 848,
  [849] = 836,
  [850] = 838,
  [851] = 843,
  [852] = 836,
  [853] = 853,
  [854] = 818,
  [855] = 855,
  [856] = 856,
  [857] = 826,
  [858] = 858,
  [859] = 826,
  [860] = 836,
  [861] = 821,
  [862] = 824,
  [863] = 820,
  [864] = 824,
  [865] = 817,
  [866] = 866,
  [867] = 858,
  [868] = 822,
  [869] = 814,
  [870] = 819,
  [871] = 838,
  [872] = 820,
  [873] = 873,
  [874] = 837,
  [875] = 820,
  [876] = 821,
  [877] = 824,
  [878] = 820,
  [879] = 879,
  [880] = 837,
  [881] = 858,
  [882] = 838,
  [883] = 837,
  [884] = 843,
  [885] = 819,
  [886] = 814,
  [887] = 817,
  [888] = 816,
  [889] = 822,
  [890] = 838,
  [891] = 836,
  [892] = 843,
  [893] = 837,
  [894] = 826,
  [895] = 853,
  [896] = 822,
  [897] = 858,
  [898] = 821,
  [899] = 819,
  [900] = 843,
  [901] = 818,
  [902] = 902,
  [903] = 824,
  [904] = 858,
  [905] = 817,
  [906] = 816,
  [907] = 819,
  [908] = 820,
  [909] = 909,
  [910] = 828,
  [911] = 826,
  [912] = 837,
  [913] = 843,
  [914] = 818,
  [915] = 915,
  [916] = 828,
  [917] = 816,
  [918] = 838,
  [919] = 826,
  [920] = 828,
  [921] = 818,
  [922] = 858,
  [923] = 923,
  [924] = 923,
  [925] = 923,
  [926] = 923,
  [927] = 923,
  [928] = 923,
  [929] = 381,
  [930] = 48,
  [931] = 382,
  [932] = 383,
  [933] = 377,
  [934] = 379,
  [935] = 384,
  [936] = 386,
  [937] = 49,
  [938] = 376,
  [939] = 385,
  [940] = 402,
  [941] = 941,
  [942] = 422,
  [943] = 428,
  [944] = 421,
  [945] = 413,
  [946] = 425,
  [947] = 475,
  [948] = 506,
  [949] = 54,
  [950] = 491,
  [951] = 522,
  [952] = 523,
  [953] = 524,
  [954] = 490,
  [955] = 525,
  [956] = 50,
  [957] = 489,
  [958] = 488,
  [959] = 526,
  [960] = 517,
  [961] = 527,
  [962] = 487,
  [963] = 528,
  [964] = 516,
  [965] = 529,
  [966] = 515,
  [967] = 514,
  [968] = 486,
  [969] = 530,
  [970] = 531,
  [971] = 42,
  [972] = 533,
  [973] = 45,
  [974] = 485,
  [975] = 534,
  [976] = 535,
  [977] = 513,
  [978] = 536,
  [979] = 484,
  [980] = 537,
  [981] = 538,
  [982] = 483,
  [983] = 539,
  [984] = 465,
  [985] = 482,
  [986] = 540,
  [987] = 507,
  [988] = 481,
  [989] = 480,
  [990] = 541,
  [991] = 542,
  [992] = 43,
  [993] = 544,
  [994] = 494,
  [995] = 52,
  [996] = 478,
  [997] = 499,
  [998] = 502,
  [999] = 520,
  [1000] = 473,
  [1001] = 545,
  [1002] = 518,
  [1003] = 53,
  [1004] = 504,
  [1005] = 477,
  [1006] = 476,
  [1007] = 44,
  [1008] = 474,
  [1009] = 508,
  [1010] = 512,
  [1011] = 472,
  [1012] = 471,
  [1013] = 464,
  [1014] = 470,
  [1015] = 469,
  [1016] = 468,
  [1017] = 532,
  [1018] = 467,
  [1019] = 511,
  [1020] = 519,
  [1021] = 510,
  [1022] = 396,
  [1023] = 377,
  [1024] = 376,
  [1025] = 398,
  [1026] = 400,
  [1027] = 381,
  [1028] = 376,
  [1029] = 385,
  [1030] = 432,
  [1031] = 382,
  [1032] = 383,
  [1033] = 384,
  [1034] = 386,
  [1035] = 379,
  [1036] = 377,
  [1037] = 384,
  [1038] = 383,
  [1039] = 379,
  [1040] = 386,
  [1041] = 381,
  [1042] = 382,
  [1043] = 385,
  [1044] = 1044,
  [1045] = 399,
  [1046] = 394,
  [1047] = 1047,
  [1048] = 402,
  [1049] = 397,
  [1050] = 1050,
  [1051] = 399,
  [1052] = 397,
  [1053] = 1053,
  [1054] = 394,
  [1055] = 1055,
  [1056] = 1056,
  [1057] = 423,
  [1058] = 412,
  [1059] = 421,
  [1060] = 419,
  [1061] = 1061,
  [1062] = 402,
  [1063] = 416,
  [1064] = 417,
  [1065] = 1061,
  [1066] = 425,
  [1067] = 418,
  [1068] = 1061,
  [1069] = 1061,
  [1070] = 1061,
  [1071] = 408,
  [1072] = 420,
  [1073] = 426,
  [1074] = 428,
  [1075] = 407,
  [1076] = 427,
  [1077] = 50,
  [1078] = 44,
  [1079] = 1061,
  [1080] = 421,
  [1081] = 411,
  [1082] = 413,
  [1083] = 49,
  [1084] = 48,
  [1085] = 413,
  [1086] = 422,
  [1087] = 425,
  [1088] = 518,
  [1089] = 42,
  [1090] = 488,
  [1091] = 489,
  [1092] = 490,
  [1093] = 491,
  [1094] = 44,
  [1095] = 408,
  [1096] = 1096,
  [1097] = 487,
  [1098] = 1098,
  [1099] = 486,
  [1100] = 1100,
  [1101] = 49,
  [1102] = 485,
  [1103] = 1103,
  [1104] = 1104,
  [1105] = 484,
  [1106] = 483,
  [1107] = 482,
  [1108] = 494,
  [1109] = 48,
  [1110] = 499,
  [1111] = 481,
  [1112] = 1112,
  [1113] = 1113,
  [1114] = 472,
  [1115] = 502,
  [1116] = 480,
  [1117] = 1117,
  [1118] = 1118,
  [1119] = 1119,
  [1120] = 504,
  [1121] = 506,
  [1122] = 507,
  [1123] = 508,
  [1124] = 510,
  [1125] = 511,
  [1126] = 1126,
  [1127] = 512,
  [1128] = 427,
  [1129] = 428,
  [1130] = 422,
  [1131] = 513,
  [1132] = 1132,
  [1133] = 514,
  [1134] = 1134,
  [1135] = 411,
  [1136] = 515,
  [1137] = 1137,
  [1138] = 516,
  [1139] = 1139,
  [1140] = 423,
  [1141] = 464,
  [1142] = 517,
  [1143] = 465,
  [1144] = 519,
  [1145] = 520,
  [1146] = 1146,
  [1147] = 522,
  [1148] = 523,
  [1149] = 524,
  [1150] = 525,
  [1151] = 1151,
  [1152] = 467,
  [1153] = 1153,
  [1154] = 526,
  [1155] = 426,
  [1156] = 527,
  [1157] = 43,
  [1158] = 528,
  [1159] = 412,
  [1160] = 529,
  [1161] = 407,
  [1162] = 468,
  [1163] = 530,
  [1164] = 531,
  [1165] = 532,
  [1166] = 533,
  [1167] = 45,
  [1168] = 534,
  [1169] = 535,
  [1170] = 469,
  [1171] = 536,
  [1172] = 1172,
  [1173] = 537,
  [1174] = 538,
  [1175] = 478,
  [1176] = 539,
  [1177] = 1177,
  [1178] = 540,
  [1179] = 54,
  [1180] = 541,
  [1181] = 542,
  [1182] = 470,
  [1183] = 544,
  [1184] = 52,
  [1185] = 545,
  [1186] = 53,
  [1187] = 418,
  [1188] = 471,
  [1189] = 417,
  [1190] = 477,
  [1191] = 476,
  [1192] = 1192,
  [1193] = 1193,
  [1194] = 475,
  [1195] = 474,
  [1196] = 473,
  [1197] = 50,
  [1198] = 416,
  [1199] = 419,
  [1200] = 1200,
  [1201] = 420,
  [1202] = 468,
  [1203] = 45,
  [1204] = 475,
  [1205] = 541,
  [1206] = 485,
  [1207] = 542,
  [1208] = 465,
  [1209] = 522,
  [1210] = 544,
  [1211] = 476,
  [1212] = 477,
  [1213] = 508,
  [1214] = 52,
  [1215] = 54,
  [1216] = 467,
  [1217] = 484,
  [1218] = 504,
  [1219] = 523,
  [1220] = 42,
  [1221] = 510,
  [1222] = 524,
  [1223] = 474,
  [1224] = 483,
  [1225] = 502,
  [1226] = 482,
  [1227] = 512,
  [1228] = 516,
  [1229] = 480,
  [1230] = 511,
  [1231] = 507,
  [1232] = 491,
  [1233] = 43,
  [1234] = 518,
  [1235] = 490,
  [1236] = 489,
  [1237] = 488,
  [1238] = 469,
  [1239] = 525,
  [1240] = 506,
  [1241] = 540,
  [1242] = 473,
  [1243] = 1243,
  [1244] = 539,
  [1245] = 538,
  [1246] = 537,
  [1247] = 536,
  [1248] = 481,
  [1249] = 514,
  [1250] = 478,
  [1251] = 470,
  [1252] = 472,
  [1253] = 545,
  [1254] = 499,
  [1255] = 494,
  [1256] = 471,
  [1257] = 515,
  [1258] = 53,
  [1259] = 526,
  [1260] = 527,
  [1261] = 528,
  [1262] = 529,
  [1263] = 535,
  [1264] = 530,
  [1265] = 487,
  [1266] = 534,
  [1267] = 486,
  [1268] = 519,
  [1269] = 531,
  [1270] = 532,
  [1271] = 533,
  [1272] = 513,
  [1273] = 464,
  [1274] = 520,
  [1275] = 517,
  [1276] = 1276,
  [1277] = 633,
  [1278] = 1278,
  [1279] = 1279,
  [1280] = 1280,
  [1281] = 1281,
  [1282] = 1282,
  [1283] = 636,
  [1284] = 1284,
  [1285] = 658,
  [1286] = 652,
  [1287] = 1287,
  [1288] = 55,
  [1289] = 670,
  [1290] = 1290,
  [1291] = 1291,
  [1292] = 1292,
  [1293] = 1293,
  [1294] = 671,
  [1295] = 1295,
  [1296] = 659,
  [1297] = 649,
  [1298] = 665,
  [1299] = 655,
  [1300] = 672,
  [1301] = 651,
  [1302] = 1302,
  [1303] = 1303,
  [1304] = 1304,
  [1305] = 1305,
  [1306] = 1306,
  [1307] = 1307,
  [1308] = 1308,
  [1309] = 1309,
  [1310] = 1310,
  [1311] = 1311,
  [1312] = 1312,
  [1313] = 1313,
  [1314] = 1314,
  [1315] = 1315,
  [1316] = 1316,
  [1317] = 1317,
  [1318] = 1318,
  [1319] = 1319,
  [1320] = 1243,
  [1321] = 1321,
  [1322] = 1322,
  [1323] = 1323,
  [1324] = 1324,
  [1325] = 1325,
  [1326] = 1326,
  [1327] = 1327,
  [1328] = 1328,
  [1329] = 1329,
  [1330] = 1330,
  [1331] = 1331,
  [1332] = 1332,
  [1333] = 1333,
  [1334] = 1334,
  [1335] = 1335,
  [1336] = 1336,
  [1337] = 1337,
  [1338] = 1338,
  [1339] = 1339,
  [1340] = 1340,
  [1341] = 1341,
  [1342] = 1342,
  [1343] = 1343,
  [1344] = 1344,
  [1345] = 1345,
  [1346] = 1346,
  [1347] = 1347,
  [1348] = 1348,
  [1349] = 1349,
  [1350] = 1350,
  [1351] = 1351,
  [1352] = 1352,
  [1353] = 1353,
  [1354] = 1354,
  [1355] = 1355,
  [1356] = 1356,
  [1357] = 1357,
  [1358] = 1358,
  [1359] = 1359,
  [1360] = 1360,
  [1361] = 1361,
  [1362] = 1132,
  [1363] = 1096,
  [1364] = 1364,
  [1365] = 1112,
  [1366] = 1100,
  [1367] = 1367,
  [1368] = 42,
  [1369] = 1098,
  [1370] = 43,
  [1371] = 1371,
  [1372] = 1372,
  [1373] = 1373,
  [1374] = 1139,
  [1375] = 1375,
  [1376] = 1376,
  [1377] = 1377,
  [1378] = 1103,
  [1379] = 1379,
  [1380] = 1380,
  [1381] = 1381,
  [1382] = 1119,
  [1383] = 1383,
  [1384] = 1384,
  [1385] = 1385,
  [1386] = 1386,
  [1387] = 1387,
  [1388] = 1388,
  [1389] = 1389,
  [1390] = 1359,
  [1391] = 1391,
  [1392] = 1392,
  [1393] = 1393,
  [1394] = 1391,
  [1395] = 1359,
  [1396] = 1396,
  [1397] = 1397,
  [1398] = 1398,
  [1399] = 1399,
  [1400] = 1400,
  [1401] = 1401,
  [1402] = 1402,
  [1403] = 1403,
  [1404] = 1404,
  [1405] = 1405,
  [1406] = 376,
  [1407] = 1407,
  [1408] = 377,
  [1409] = 381,
  [1410] = 384,
  [1411] = 1282,
  [1412] = 382,
  [1413] = 383,
  [1414] = 385,
  [1415] = 386,
  [1416] = 379,
  [1417] = 1417,
  [1418] = 941,
  [1419] = 1419,
  [1420] = 402,
  [1421] = 396,
  [1422] = 400,
  [1423] = 1423,
  [1424] = 398,
  [1425] = 1292,
  [1426] = 1426,
  [1427] = 1427,
  [1428] = 1295,
  [1429] = 475,
  [1430] = 432,
  [1431] = 48,
  [1432] = 421,
  [1433] = 428,
  [1434] = 1434,
  [1435] = 1309,
  [1436] = 1312,
  [1437] = 44,
  [1438] = 425,
  [1439] = 413,
  [1440] = 50,
  [1441] = 422,
  [1442] = 49,
  [1443] = 506,
  [1444] = 524,
  [1445] = 1445,
  [1446] = 1243,
  [1447] = 53,
  [1448] = 52,
  [1449] = 54,
  [1450] = 45,
  [1451] = 42,
  [1452] = 1322,
  [1453] = 545,
  [1454] = 544,
  [1455] = 542,
  [1456] = 1324,
  [1457] = 541,
  [1458] = 540,
  [1459] = 1459,
  [1460] = 539,
  [1461] = 538,
  [1462] = 537,
  [1463] = 536,
  [1464] = 535,
  [1465] = 534,
  [1466] = 1466,
  [1467] = 533,
  [1468] = 532,
  [1469] = 531,
  [1470] = 530,
  [1471] = 529,
  [1472] = 528,
  [1473] = 1321,
  [1474] = 1341,
  [1475] = 527,
  [1476] = 526,
  [1477] = 525,
  [1478] = 523,
  [1479] = 522,
  [1480] = 520,
  [1481] = 1338,
  [1482] = 519,
  [1483] = 1333,
  [1484] = 518,
  [1485] = 517,
  [1486] = 1343,
  [1487] = 516,
  [1488] = 515,
  [1489] = 1340,
  [1490] = 514,
  [1491] = 513,
  [1492] = 512,
  [1493] = 511,
  [1494] = 510,
  [1495] = 508,
  [1496] = 507,
  [1497] = 504,
  [1498] = 502,
  [1499] = 1499,
  [1500] = 499,
  [1501] = 1337,
  [1502] = 464,
  [1503] = 465,
  [1504] = 494,
  [1505] = 467,
  [1506] = 491,
  [1507] = 468,
  [1508] = 469,
  [1509] = 470,
  [1510] = 490,
  [1511] = 489,
  [1512] = 471,
  [1513] = 472,
  [1514] = 488,
  [1515] = 487,
  [1516] = 43,
  [1517] = 486,
  [1518] = 1339,
  [1519] = 1332,
  [1520] = 1325,
  [1521] = 473,
  [1522] = 474,
  [1523] = 485,
  [1524] = 484,
  [1525] = 483,
  [1526] = 482,
  [1527] = 481,
  [1528] = 480,
  [1529] = 476,
  [1530] = 1530,
  [1531] = 477,
  [1532] = 1532,
  [1533] = 478,
  [1534] = 1319,
  [1535] = 1535,
  [1536] = 1536,
  [1537] = 394,
  [1538] = 397,
  [1539] = 394,
  [1540] = 399,
  [1541] = 399,
  [1542] = 397,
  [1543] = 418,
  [1544] = 417,
  [1545] = 411,
  [1546] = 423,
  [1547] = 408,
  [1548] = 420,
  [1549] = 427,
  [1550] = 419,
  [1551] = 416,
  [1552] = 426,
  [1553] = 412,
  [1554] = 1554,
  [1555] = 407,
  [1556] = 1556,
  [1557] = 419,
  [1558] = 412,
  [1559] = 1559,
  [1560] = 1560,
  [1561] = 1561,
  [1562] = 1561,
  [1563] = 423,
  [1564] = 1560,
  [1565] = 1560,
  [1566] = 1560,
  [1567] = 1559,
  [1568] = 1556,
  [1569] = 408,
  [1570] = 426,
  [1571] = 427,
  [1572] = 1561,
  [1573] = 1573,
  [1574] = 1574,
  [1575] = 1556,
  [1576] = 420,
  [1577] = 1559,
  [1578] = 1559,
  [1579] = 1579,
  [1580] = 1560,
  [1581] = 416,
  [1582] = 1559,
  [1583] = 1560,
  [1584] = 1561,
  [1585] = 411,
  [1586] = 417,
  [1587] = 418,
  [1588] = 1588,
  [1589] = 1559,
  [1590] = 1556,
  [1591] = 407,
  [1592] = 1592,
  [1593] = 1592,
  [1594] = 1594,
  [1595] = 1592,
  [1596] = 1592,
  [1597] = 1592,
  [1598] = 1592,
  [1599] = 1599,
  [1600] = 1600,
  [1601] = 1554,
  [1602] = 1602,
  [1603] = 1603,
  [1604] = 1604,
  [1605] = 1605,
  [1606] = 1606,
  [1607] = 1607,
  [1608] = 1608,
  [1609] = 1609,
  [1610] = 1610,
  [1611] = 1606,
  [1612] = 1612,
  [1613] = 1613,
  [1614] = 1614,
  [1615] = 1615,
  [1616] = 1616,
  [1617] = 1617,
  [1618] = 1617,
  [1619] = 1606,
  [1620] = 1606,
  [1621] = 1621,
  [1622] = 1622,
  [1623] = 1623,
  [1624] = 1624,
  [1625] = 1625,
  [1626] = 1606,
  [1627] = 1606,
  [1628] = 1628,
  [1629] = 1629,
  [1630] = 1621,
  [1631] = 1631,
  [1632] = 636,
  [1633] = 1621,
  [1634] = 1609,
  [1635] = 1621,
  [1636] = 1636,
  [1637] = 1629,
  [1638] = 1638,
  [1639] = 1639,
  [1640] = 1639,
  [1641] = 1610,
  [1642] = 1605,
  [1643] = 1643,
  [1644] = 633,
  [1645] = 1624,
  [1646] = 1613,
  [1647] = 1617,
  [1648] = 1636,
  [1649] = 1649,
  [1650] = 1628,
  [1651] = 1606,
  [1652] = 1621,
  [1653] = 1621,
  [1654] = 651,
  [1655] = 652,
  [1656] = 659,
  [1657] = 649,
  [1658] = 55,
  [1659] = 671,
  [1660] = 655,
  [1661] = 672,
  [1662] = 665,
  [1663] = 658,
  [1664] = 670,
  [1665] = 1665,
  [1666] = 1666,
  [1667] = 1667,
  [1668] = 1668,
  [1669] = 1669,
  [1670] = 1670,
  [1671] = 1670,
  [1672] = 1669,
  [1673] = 1673,
  [1674] = 1670,
  [1675] = 1675,
  [1676] = 1670,
  [1677] = 1670,
  [1678] = 1670,
  [1679] = 1679,
  [1680] = 1680,
  [1681] = 1681,
  [1682] = 1681,
  [1683] = 1683,
  [1684] = 1683,
  [1685] = 1681,
  [1686] = 1683,
  [1687] = 1683,
  [1688] = 1688,
  [1689] = 1683,
  [1690] = 1683,
  [1691] = 1681,
  [1692] = 1683,
  [1693] = 1683,
  [1694] = 1681,
  [1695] = 1683,
  [1696] = 1681,
  [1697] = 1681,
  [1698] = 1681,
  [1699] = 1681,
  [1700] = 1683,
  [1701] = 1683,
  [1702] = 1681,
  [1703] = 1681,
  [1704] = 1681,
  [1705] = 1683,
  [1706] = 1706,
  [1707] = 1707,
  [1708] = 1707,
  [1709] = 1707,
  [1710] = 1707,
  [1711] = 1707,
  [1712] = 1707,
  [1713] = 1713,
  [1714] = 1714,
  [1715] = 1715,
  [1716] = 1713,
  [1717] = 1717,
  [1718] = 1718,
  [1719] = 1719,
  [1720] = 1718,
  [1721] = 1718,
  [1722] = 1722,
  [1723] = 1723,
  [1724] = 1718,
  [1725] = 1725,
  [1726] = 1726,
  [1727] = 1718,
  [1728] = 1718,
  [1729] = 1729,
  [1730] = 1719,
  [1731] = 1731,
  [1732] = 1732,
  [1733] = 1733,
  [1734] = 1734,
  [1735] = 1735,
  [1736] = 1736,
  [1737] = 1737,
  [1738] = 1738,
  [1739] = 1739,
  [1740] = 1740,
  [1741] = 1741,
  [1742] = 1742,
  [1743] = 1743,
  [1744] = 1742,
  [1745] = 1741,
  [1746] = 1741,
  [1747] = 1741,
  [1748] = 1742,
  [1749] = 1749,
  [1750] = 1750,
  [1751] = 1742,
  [1752] = 1752,
  [1753] = 1742,
  [1754] = 1752,
  [1755] = 1742,
  [1756] = 1756,
  [1757] = 1757,
  [1758] = 1741,
  [1759] = 1741,
  [1760] = 1756,
  [1761] = 1761,
  [1762] = 1762,
  [1763] = 1763,
  [1764] = 1764,
  [1765] = 1765,
  [1766] = 1766,
  [1767] = 1767,
  [1768] = 1768,
  [1769] = 1764,
  [1770] = 1766,
  [1771] = 1771,
  [1772] = 1764,
  [1773] = 1763,
  [1774] = 1766,
  [1775] = 1768,
  [1776] = 1776,
  [1777] = 1763,
  [1778] = 1778,
  [1779] = 1767,
  [1780] = 1768,
  [1781] = 1767,
  [1782] = 1765,
  [1783] = 1763,
  [1784] = 1767,
  [1785] = 1785,
  [1786] = 1786,
  [1787] = 1787,
  [1788] = 1763,
  [1789] = 1789,
  [1790] = 1790,
  [1791] = 1764,
  [1792] = 1792,
  [1793] = 1778,
  [1794] = 1766,
  [1795] = 1762,
  [1796] = 1796,
  [1797] = 1796,
  [1798] = 1768,
  [1799] = 1787,
  [1800] = 1767,
  [1801] = 1785,
  [1802] = 1765,
  [1803] = 1766,
  [1804] = 1764,
  [1805] = 1768,
  [1806] = 1765,
  [1807] = 1762,
  [1808] = 1808,
  [1809] = 1809,
  [1810] = 1765,
  [1811] = 1809,
  [1812] = 1812,
  [1813] = 1765,
  [1814] = 1809,
  [1815] = 1815,
  [1816] = 1762,
  [1817] = 1817,
  [1818] = 1767,
  [1819] = 1819,
  [1820] = 1763,
  [1821] = 1762,
  [1822] = 1764,
  [1823] = 1809,
  [1824] = 1766,
  [1825] = 1809,
  [1826] = 1768,
  [1827] = 1809,
  [1828] = 1762,
  [1829] = 1829,
  [1830] = 1829,
  [1831] = 1831,
  [1832] = 1831,
  [1833] = 1833,
  [1834] = 1834,
  [1835] = 1833,
  [1836] = 1836,
  [1837] = 1837,
  [1838] = 1838,
  [1839] = 1839,
  [1840] = 1840,
  [1841] = 1839,
  [1842] = 1842,
  [1843] = 1843,
  [1844] = 1840,
  [1845] = 1845,
  [1846] = 1846,
  [1847] = 1847,
  [1848] = 1843,
  [1849] = 1849,
  [1850] = 1850,
  [1851] = 1851,
  [1852] = 1852,
  [1853] = 1853,
  [1854] = 1854,
  [1855] = 1855,
  [1856] = 1851,
  [1857] = 1857,
  [1858] = 1858,
  [1859] = 1859,
  [1860] = 1860,
  [1861] = 1861,
  [1862] = 1862,
  [1863] = 1863,
  [1864] = 1864,
  [1865] = 1853,
  [1866] = 1866,
  [1867] = 1867,
  [1868] = 1853,
  [1869] = 1864,
  [1870] = 1853,
  [1871] = 1850,
  [1872] = 1872,
  [1873] = 1854,
  [1874] = 1854,
  [1875] = 1875,
  [1876] = 1853,
  [1877] = 1877,
  [1878] = 1878,
  [1879] = 1879,
  [1880] = 1878,
  [1881] = 1851,
  [1882] = 1859,
  [1883] = 1883,
  [1884] = 1878,
  [1885] = 1885,
  [1886] = 1886,
  [1887] = 1887,
  [1888] = 1888,
  [1889] = 1889,
  [1890] = 1890,
  [1891] = 1891,
  [1892] = 1892,
  [1893] = 1877,
  [1894] = 1894,
  [1895] = 1895,
  [1896] = 1854,
  [1897] = 1875,
  [1898] = 1898,
  [1899] = 1875,
  [1900] = 1900,
  [1901] = 1852,
  [1902] = 1902,
  [1903] = 1864,
  [1904] = 1853,
  [1905] = 1905,
  [1906] = 1878,
  [1907] = 1907,
  [1908] = 1850,
  [1909] = 1909,
  [1910] = 1910,
  [1911] = 1892,
  [1912] = 1912,
  [1913] = 1854,
  [1914] = 1914,
  [1915] = 1864,
  [1916] = 1916,
  [1917] = 1867,
  [1918] = 1879,
  [1919] = 1919,
  [1920] = 1895,
  [1921] = 1879,
  [1922] = 1916,
  [1923] = 1879,
  [1924] = 1879,
  [1925] = 1925,
  [1926] = 1854,
  [1927] = 1879,
  [1928] = 1851,
  [1929] = 1859,
  [1930] = 1930,
  [1931] = 1850,
  [1932] = 1851,
  [1933] = 1933,
  [1934] = 1907,
  [1935] = 1891,
  [1936] = 1889,
  [1937] = 1890,
  [1938] = 1891,
  [1939] = 1892,
  [1940] = 1859,
  [1941] = 1877,
  [1942] = 1890,
  [1943] = 1895,
  [1944] = 1879,
  [1945] = 1889,
  [1946] = 1878,
  [1947] = 1947,
  [1948] = 1948,
  [1949] = 1852,
  [1950] = 1902,
  [1951] = 1902,
  [1952] = 1952,
  [1953] = 1907,
  [1954] = 1878,
  [1955] = 1879,
  [1956] = 1956,
  [1957] = 1957,
  [1958] = 1907,
  [1959] = 1885,
  [1960] = 1850,
  [1961] = 1902,
  [1962] = 1962,
  [1963] = 1852,
  [1964] = 1964,
  [1965] = 1965,
  [1966] = 1966,
  [1967] = 1887,
  [1968] = 1894,
  [1969] = 1895,
  [1970] = 1864,
  [1971] = 1888,
  [1972] = 1964,
  [1973] = 1877,
  [1974] = 1892,
  [1975] = 1891,
  [1976] = 1976,
  [1977] = 1890,
  [1978] = 1889,
  [1979] = 1859,
  [1980] = 1850,
  [1981] = 1981,
  [1982] = 1957,
  [1983] = 1983,
  [1984] = 1907,
  [1985] = 1879,
  [1986] = 1851,
  [1987] = 1859,
  [1988] = 1907,
  [1989] = 1989,
  [1990] = 1889,
  [1991] = 1890,
  [1992] = 1891,
  [1993] = 1892,
  [1994] = 1877,
  [1995] = 1995,
  [1996] = 1895,
  [1997] = 1902,
  [1998] = 1852,
  [1999] = 1852,
  [2000] = 1902,
  [2001] = 1907,
  [2002] = 1850,
  [2003] = 2003,
  [2004] = 2004,
  [2005] = 1895,
  [2006] = 1864,
  [2007] = 1877,
  [2008] = 2008,
  [2009] = 2009,
  [2010] = 1892,
  [2011] = 2011,
  [2012] = 1891,
  [2013] = 1890,
  [2014] = 1889,
  [2015] = 1879,
  [2016] = 2016,
  [2017] = 2017,
  [2018] = 2018,
  [2019] = 2019,
  [2020] = 2020,
  [2021] = 2021,
  [2022] = 2022,
  [2023] = 2021,
  [2024] = 2024,
  [2025] = 2025,
  [2026] = 2026,
  [2027] = 2017,
  [2028] = 2028,
  [2029] = 2029,
  [2030] = 2017,
  [2031] = 2031,
  [2032] = 2032,
  [2033] = 2033,
  [2034] = 2034,
  [2035] = 2035,
  [2036] = 2036,
  [2037] = 2037,
  [2038] = 2032,
  [2039] = 2031,
  [2040] = 2040,
  [2041] = 2032,
  [2042] = 2042,
  [2043] = 2032,
  [2044] = 2031,
  [2045] = 2045,
  [2046] = 2046,
  [2047] = 2017,
  [2048] = 2048,
  [2049] = 2026,
  [2050] = 2042,
  [2051] = 2033,
  [2052] = 2052,
  [2053] = 2022,
  [2054] = 2054,
  [2055] = 2055,
  [2056] = 2056,
  [2057] = 2057,
  [2058] = 2035,
  [2059] = 2035,
  [2060] = 2033,
  [2061] = 2061,
  [2062] = 2031,
  [2063] = 2063,
  [2064] = 2033,
  [2065] = 2035,
  [2066] = 2035,
  [2067] = 2017,
  [2068] = 2068,
  [2069] = 2069,
  [2070] = 2070,
  [2071] = 2071,
  [2072] = 2072,
  [2073] = 2073,
  [2074] = 2074,
  [2075] = 2075,
  [2076] = 2031,
  [2077] = 2077,
  [2078] = 2017,
  [2079] = 2033,
  [2080] = 2080,
  [2081] = 2081,
  [2082] = 2035,
  [2083] = 2083,
  [2084] = 2084,
  [2085] = 2033,
  [2086] = 2086,
  [2087] = 2035,
  [2088] = 2088,
  [2089] = 2016,
  [2090] = 2090,
  [2091] = 2091,
  [2092] = 2092,
  [2093] = 2035,
  [2094] = 2081,
  [2095] = 2035,
  [2096] = 2035,
  [2097] = 2035,
  [2098] = 2031,
  [2099] = 2035,
  [2100] = 2100,
  [2101] = 2101,
  [2102] = 2102,
  [2103] = 1729,
  [2104] = 2104,
  [2105] = 2105,
  [2106] = 2106,
  [2107] = 2107,
  [2108] = 2108,
  [2109] = 2109,
  [2110] = 2110,
  [2111] = 2111,
  [2112] = 2112,
  [2113] = 2113,
  [2114] = 2114,
  [2115] = 2115,
  [2116] = 2116,
  [2117] = 2117,
  [2118] = 2118,
  [2119] = 2115,
  [2120] = 2120,
  [2121] = 2121,
  [2122] = 2101,
  [2123] = 2123,
  [2124] = 2124,
  [2125] = 2125,
  [2126] = 2126,
  [2127] = 2127,
  [2128] = 2128,
  [2129] = 2129,
  [2130] = 2130,
  [2131] = 2131,
  [2132] = 2132,
  [2133] = 2133,
  [2134] = 2101,
  [2135] = 2105,
  [2136] = 2110,
  [2137] = 2137,
  [2138] = 2113,
  [2139] = 2129,
  [2140] = 2116,
  [2141] = 2141,
  [2142] = 2127,
  [2143] = 2143,
  [2144] = 1722,
  [2145] = 2129,
  [2146] = 2146,
  [2147] = 2147,
  [2148] = 2130,
  [2149] = 2149,
  [2150] = 2150,
  [2151] = 2115,
  [2152] = 2152,
  [2153] = 2153,
  [2154] = 2154,
  [2155] = 2155,
  [2156] = 2156,
  [2157] = 2105,
  [2158] = 2158,
  [2159] = 2101,
  [2160] = 2143,
  [2161] = 2115,
  [2162] = 2105,
  [2163] = 2163,
  [2164] = 2164,
  [2165] = 2113,
  [2166] = 2110,
  [2167] = 2129,
  [2168] = 2127,
  [2169] = 2115,
  [2170] = 2149,
  [2171] = 2171,
  [2172] = 2110,
  [2173] = 2173,
  [2174] = 2101,
  [2175] = 2115,
  [2176] = 2176,
  [2177] = 2129,
  [2178] = 2110,
  [2179] = 2110,
  [2180] = 2155,
  [2181] = 2153,
  [2182] = 2113,
  [2183] = 2105,
  [2184] = 2127,
  [2185] = 2101,
  [2186] = 2133,
  [2187] = 2100,
  [2188] = 2107,
  [2189] = 2189,
  [2190] = 2190,
  [2191] = 2154,
  [2192] = 2133,
  [2193] = 2107,
  [2194] = 2105,
  [2195] = 2195,
  [2196] = 2107,
  [2197] = 2197,
  [2198] = 2110,
  [2199] = 2199,
  [2200] = 2200,
  [2201] = 2152,
  [2202] = 2202,
  [2203] = 2203,
  [2204] = 2204,
  [2205] = 2190,
  [2206] = 2116,
  [2207] = 2129,
  [2208] = 2156,
  [2209] = 2156,
  [2210] = 2156,
  [2211] = 2156,
  [2212] = 2156,
  [2213] = 2156,
};

static inline bool aux_sym_FormatSequence_token2_character_set_1(int32_t c) {
  return (c < 'b'
    ? (c < '?'
      ? (c < '*'
        ? c == '!'
        : c <= '*')
      : (c <= '?' || c == 'X'))
    : (c <= 'e' || (c < 'u'
      ? (c < 's'
        ? c == 'o'
        : c <= 's')
      : (c <= 'u' || c == 'x'))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(273);
      if (lookahead == '!') ADVANCE(296);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '%') ADVANCE(450);
      if (lookahead == '&') ADVANCE(415);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == ')') ADVANCE(354);
      if (lookahead == '*') ADVANCE(384);
      if (lookahead == '+') ADVANCE(428);
      if (lookahead == ',') ADVANCE(274);
      if (lookahead == '-') ADVANCE(430);
      if (lookahead == '.') ADVANCE(330);
      if (lookahead == '/') ADVANCE(446);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == ':') ADVANCE(301);
      if (lookahead == ';') ADVANCE(288);
      if (lookahead == '<') ADVANCE(408);
      if (lookahead == '=') ADVANCE(304);
      if (lookahead == '>') ADVANCE(410);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == 'X') ADVANCE(506);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(499);
      if (lookahead == ']') ADVANCE(362);
      if (lookahead == '^') ADVANCE(417);
      if (lookahead == 'a') ADVANCE(74);
      if (lookahead == 'b') ADVANCE(511);
      if (lookahead == 'c') ADVANCE(468);
      if (lookahead == 'd') ADVANCE(507);
      if (lookahead == 'e') ADVANCE(508);
      if (lookahead == 'f') ADVANCE(44);
      if (lookahead == 'i') ADVANCE(114);
      if (lookahead == 'l') ADVANCE(125);
      if (lookahead == 'o') ADVANCE(510);
      if (lookahead == 'p') ADVANCE(45);
      if (lookahead == 's') ADVANCE(512);
      if (lookahead == 'u') ADVANCE(509);
      if (lookahead == 'v') ADVANCE(51);
      if (lookahead == 'w') ADVANCE(122);
      if (lookahead == 'x') ADVANCE(513);
      if (lookahead == '{') ADVANCE(530);
      if (lookahead == '|') ADVANCE(381);
      if (lookahead == '}') ADVANCE(531);
      if (lookahead == '~') ADVANCE(456);
      if (lookahead == 'n' ||
          ('r' <= lookahead && lookahead <= 't')) ADVANCE(502);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(263)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 1:
      if (lookahead == '!') ADVANCE(296);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '%') ADVANCE(450);
      if (lookahead == '&') ADVANCE(415);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == ')') ADVANCE(354);
      if (lookahead == '*') ADVANCE(384);
      if (lookahead == '+') ADVANCE(428);
      if (lookahead == ',') ADVANCE(274);
      if (lookahead == '-') ADVANCE(431);
      if (lookahead == '.') ADVANCE(333);
      if (lookahead == '/') ADVANCE(448);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == ':') ADVANCE(301);
      if (lookahead == ';') ADVANCE(288);
      if (lookahead == '<') ADVANCE(408);
      if (lookahead == '=') ADVANCE(304);
      if (lookahead == '>') ADVANCE(410);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == ']') ADVANCE(362);
      if (lookahead == '^') ADVANCE(417);
      if (lookahead == 'a') ADVANCE(719);
      if (lookahead == 'b') ADVANCE(746);
      if (lookahead == 'c') ADVANCE(543);
      if (lookahead == 'e') ADVANCE(711);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(741);
      if (lookahead == 'o') ADVANCE(765);
      if (lookahead == 'p') ADVANCE(551);
      if (lookahead == 'r') ADVANCE(610);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(782);
      if (lookahead == 'u') ADVANCE(713);
      if (lookahead == 'v') ADVANCE(750);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '{') ADVANCE(324);
      if (lookahead == '|') ADVANCE(381);
      if (lookahead == '}') ADVANCE(326);
      if (lookahead == '~') ADVANCE(456);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 2:
      if (lookahead == '!') ADVANCE(296);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '%') ADVANCE(450);
      if (lookahead == '&') ADVANCE(415);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(384);
      if (lookahead == '+') ADVANCE(428);
      if (lookahead == '-') ADVANCE(431);
      if (lookahead == '.') ADVANCE(332);
      if (lookahead == '/') ADVANCE(448);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == ';') ADVANCE(288);
      if (lookahead == '<') ADVANCE(408);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '>') ADVANCE(410);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == '^') ADVANCE(417);
      if (lookahead == 'a') ADVANCE(719);
      if (lookahead == 'b') ADVANCE(746);
      if (lookahead == 'c') ADVANCE(544);
      if (lookahead == 'd') ADVANCE(620);
      if (lookahead == 'e') ADVANCE(712);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(741);
      if (lookahead == 'o') ADVANCE(765);
      if (lookahead == 'p') ADVANCE(551);
      if (lookahead == 'r') ADVANCE(610);
      if (lookahead == 's') ADVANCE(822);
      if (lookahead == 't') ADVANCE(782);
      if (lookahead == 'u') ADVANCE(713);
      if (lookahead == 'v') ADVANCE(558);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '{') ADVANCE(324);
      if (lookahead == '|') ADVANCE(381);
      if (lookahead == '}') ADVANCE(326);
      if (lookahead == '~') ADVANCE(456);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(2)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(296);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '%') ADVANCE(450);
      if (lookahead == '&') ADVANCE(415);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(384);
      if (lookahead == '+') ADVANCE(428);
      if (lookahead == '-') ADVANCE(431);
      if (lookahead == '.') ADVANCE(332);
      if (lookahead == '/') ADVANCE(448);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == ';') ADVANCE(288);
      if (lookahead == '<') ADVANCE(408);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '>') ADVANCE(410);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == '^') ADVANCE(417);
      if (lookahead == 'a') ADVANCE(719);
      if (lookahead == 'b') ADVANCE(746);
      if (lookahead == 'c') ADVANCE(544);
      if (lookahead == 'd') ADVANCE(620);
      if (lookahead == 'e') ADVANCE(694);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(741);
      if (lookahead == 'o') ADVANCE(765);
      if (lookahead == 'p') ADVANCE(551);
      if (lookahead == 'r') ADVANCE(610);
      if (lookahead == 's') ADVANCE(822);
      if (lookahead == 't') ADVANCE(782);
      if (lookahead == 'u') ADVANCE(713);
      if (lookahead == 'v') ADVANCE(558);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '{') ADVANCE(324);
      if (lookahead == '|') ADVANCE(381);
      if (lookahead == '}') ADVANCE(326);
      if (lookahead == '~') ADVANCE(456);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(296);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '%') ADVANCE(450);
      if (lookahead == '&') ADVANCE(415);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == ')') ADVANCE(354);
      if (lookahead == '*') ADVANCE(384);
      if (lookahead == '+') ADVANCE(428);
      if (lookahead == ',') ADVANCE(274);
      if (lookahead == '-') ADVANCE(430);
      if (lookahead == '.') ADVANCE(330);
      if (lookahead == '/') ADVANCE(448);
      if (lookahead == ':') ADVANCE(301);
      if (lookahead == ';') ADVANCE(288);
      if (lookahead == '<') ADVANCE(408);
      if (lookahead == '=') ADVANCE(304);
      if (lookahead == '>') ADVANCE(410);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == ']') ADVANCE(362);
      if (lookahead == '^') ADVANCE(417);
      if (lookahead == 'a') ADVANCE(75);
      if (lookahead == 'c') ADVANCE(58);
      if (lookahead == 'e') ADVANCE(145);
      if (lookahead == 'f') ADVANCE(164);
      if (lookahead == 'i') ADVANCE(171);
      if (lookahead == 'l') ADVANCE(125);
      if (lookahead == 'n') ADVANCE(192);
      if (lookahead == 'o') ADVANCE(193);
      if (lookahead == 's') ADVANCE(229);
      if (lookahead == 't') ADVANCE(124);
      if (lookahead == 'u') ADVANCE(182);
      if (lookahead == 'v') ADVANCE(51);
      if (lookahead == 'w') ADVANCE(122);
      if (lookahead == '{') ADVANCE(324);
      if (lookahead == '|') ADVANCE(381);
      if (lookahead == '}') ADVANCE(326);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(4)
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(296);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '%') ADVANCE(449);
      if (lookahead == '&') ADVANCE(414);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(385);
      if (lookahead == '+') ADVANCE(429);
      if (lookahead == ',') ADVANCE(274);
      if (lookahead == '-') ADVANCE(434);
      if (lookahead == '.') ADVANCE(334);
      if (lookahead == '/') ADVANCE(447);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == ':') ADVANCE(301);
      if (lookahead == '<') ADVANCE(409);
      if (lookahead == '=') ADVANCE(40);
      if (lookahead == '>') ADVANCE(411);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == '^') ADVANCE(416);
      if (lookahead == 'a') ADVANCE(719);
      if (lookahead == 'b') ADVANCE(746);
      if (lookahead == 'c') ADVANCE(543);
      if (lookahead == 'e') ADVANCE(693);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(741);
      if (lookahead == 'o') ADVANCE(765);
      if (lookahead == 'p') ADVANCE(551);
      if (lookahead == 'r') ADVANCE(610);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(782);
      if (lookahead == 'u') ADVANCE(713);
      if (lookahead == 'v') ADVANCE(750);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '{') ADVANCE(324);
      if (lookahead == '|') ADVANCE(382);
      if (lookahead == '~') ADVANCE(456);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(5)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(296);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '%') ADVANCE(449);
      if (lookahead == '&') ADVANCE(414);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(385);
      if (lookahead == '+') ADVANCE(429);
      if (lookahead == ',') ADVANCE(274);
      if (lookahead == '-') ADVANCE(434);
      if (lookahead == '.') ADVANCE(334);
      if (lookahead == '/') ADVANCE(447);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == ':') ADVANCE(301);
      if (lookahead == '<') ADVANCE(409);
      if (lookahead == '=') ADVANCE(40);
      if (lookahead == '>') ADVANCE(411);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == '^') ADVANCE(416);
      if (lookahead == 'a') ADVANCE(719);
      if (lookahead == 'b') ADVANCE(746);
      if (lookahead == 'c') ADVANCE(543);
      if (lookahead == 'e') ADVANCE(711);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(741);
      if (lookahead == 'o') ADVANCE(765);
      if (lookahead == 'p') ADVANCE(551);
      if (lookahead == 'r') ADVANCE(610);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(782);
      if (lookahead == 'u') ADVANCE(713);
      if (lookahead == 'v') ADVANCE(750);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '{') ADVANCE(324);
      if (lookahead == '|') ADVANCE(382);
      if (lookahead == '~') ADVANCE(456);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(6)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(296);
      if (lookahead == '%') ADVANCE(450);
      if (lookahead == '&') ADVANCE(415);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == ')') ADVANCE(354);
      if (lookahead == '*') ADVANCE(384);
      if (lookahead == '+') ADVANCE(428);
      if (lookahead == ',') ADVANCE(274);
      if (lookahead == '-') ADVANCE(431);
      if (lookahead == '.') ADVANCE(332);
      if (lookahead == '/') ADVANCE(448);
      if (lookahead == ';') ADVANCE(288);
      if (lookahead == '<') ADVANCE(408);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '>') ADVANCE(410);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '^') ADVANCE(417);
      if (lookahead == 'a') ADVANCE(176);
      if (lookahead == 'c') ADVANCE(57);
      if (lookahead == 'e') ADVANCE(144);
      if (lookahead == 'o') ADVANCE(201);
      if (lookahead == 'u') ADVANCE(243);
      if (lookahead == 'x') ADVANCE(261);
      if (lookahead == '{') ADVANCE(324);
      if (lookahead == '|') ADVANCE(381);
      if (lookahead == '}') ADVANCE(326);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(7)
      if (lookahead == '"' ||
          lookahead == '\'' ||
          lookahead == '\\' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          lookahead == 't') ADVANCE(502);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(296);
      if (lookahead == '%') ADVANCE(449);
      if (lookahead == '&') ADVANCE(414);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(385);
      if (lookahead == '+') ADVANCE(429);
      if (lookahead == ',') ADVANCE(274);
      if (lookahead == '-') ADVANCE(433);
      if (lookahead == '.') ADVANCE(331);
      if (lookahead == '/') ADVANCE(447);
      if (lookahead == ':') ADVANCE(301);
      if (lookahead == '<') ADVANCE(409);
      if (lookahead == '=') ADVANCE(40);
      if (lookahead == '>') ADVANCE(411);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == '^') ADVANCE(416);
      if (lookahead == 'a') ADVANCE(176);
      if (lookahead == 'c') ADVANCE(57);
      if (lookahead == 'e') ADVANCE(144);
      if (lookahead == 'o') ADVANCE(201);
      if (lookahead == '{') ADVANCE(324);
      if (lookahead == '|') ADVANCE(382);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(8)
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(479);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(295);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '&') ADVANCE(414);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == ')') ADVANCE(354);
      if (lookahead == '*') ADVANCE(386);
      if (lookahead == ',') ADVANCE(274);
      if (lookahead == '-') ADVANCE(432);
      if (lookahead == '.') ADVANCE(329);
      if (lookahead == '/') ADVANCE(32);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == ':') ADVANCE(301);
      if (lookahead == '=') ADVANCE(42);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == ']') ADVANCE(362);
      if (lookahead == 'a') ADVANCE(707);
      if (lookahead == 'b') ADVANCE(746);
      if (lookahead == 'c') ADVANCE(547);
      if (lookahead == 'e') ADVANCE(711);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(741);
      if (lookahead == 'o') ADVANCE(766);
      if (lookahead == 'p') ADVANCE(551);
      if (lookahead == 'r') ADVANCE(610);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(782);
      if (lookahead == 'u') ADVANCE(713);
      if (lookahead == 'v') ADVANCE(750);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '{') ADVANCE(324);
      if (lookahead == '|') ADVANCE(380);
      if (lookahead == '}') ADVANCE(326);
      if (lookahead == '~') ADVANCE(456);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(10)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(295);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '&') ADVANCE(414);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(386);
      if (lookahead == '-') ADVANCE(432);
      if (lookahead == '.') ADVANCE(329);
      if (lookahead == '/') ADVANCE(32);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == ';') ADVANCE(288);
      if (lookahead == '=') ADVANCE(302);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == 'a') ADVANCE(707);
      if (lookahead == 'b') ADVANCE(746);
      if (lookahead == 'c') ADVANCE(548);
      if (lookahead == 'd') ADVANCE(620);
      if (lookahead == 'e') ADVANCE(712);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(741);
      if (lookahead == 'o') ADVANCE(766);
      if (lookahead == 'p') ADVANCE(551);
      if (lookahead == 'r') ADVANCE(610);
      if (lookahead == 's') ADVANCE(822);
      if (lookahead == 't') ADVANCE(782);
      if (lookahead == 'u') ADVANCE(713);
      if (lookahead == 'v') ADVANCE(558);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '{') ADVANCE(324);
      if (lookahead == '|') ADVANCE(380);
      if (lookahead == '}') ADVANCE(326);
      if (lookahead == '~') ADVANCE(456);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(11)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(295);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '&') ADVANCE(414);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(386);
      if (lookahead == '-') ADVANCE(432);
      if (lookahead == '.') ADVANCE(329);
      if (lookahead == '/') ADVANCE(32);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == 'a') ADVANCE(707);
      if (lookahead == 'b') ADVANCE(746);
      if (lookahead == 'c') ADVANCE(548);
      if (lookahead == 'd') ADVANCE(620);
      if (lookahead == 'e') ADVANCE(694);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(741);
      if (lookahead == 'o') ADVANCE(766);
      if (lookahead == 'p') ADVANCE(551);
      if (lookahead == 'r') ADVANCE(610);
      if (lookahead == 's') ADVANCE(822);
      if (lookahead == 't') ADVANCE(782);
      if (lookahead == 'u') ADVANCE(713);
      if (lookahead == 'v') ADVANCE(558);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '{') ADVANCE(324);
      if (lookahead == '}') ADVANCE(326);
      if (lookahead == '~') ADVANCE(456);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(12)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(295);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '&') ADVANCE(414);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(386);
      if (lookahead == '-') ADVANCE(432);
      if (lookahead == '.') ADVANCE(329);
      if (lookahead == '/') ADVANCE(32);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == 'a') ADVANCE(707);
      if (lookahead == 'b') ADVANCE(746);
      if (lookahead == 'c') ADVANCE(548);
      if (lookahead == 'e') ADVANCE(711);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(741);
      if (lookahead == 'o') ADVANCE(766);
      if (lookahead == 'p') ADVANCE(551);
      if (lookahead == 'r') ADVANCE(610);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(782);
      if (lookahead == 'u') ADVANCE(713);
      if (lookahead == 'v') ADVANCE(558);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '{') ADVANCE(324);
      if (lookahead == '~') ADVANCE(456);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(13)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(295);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '&') ADVANCE(414);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(386);
      if (lookahead == '-') ADVANCE(432);
      if (lookahead == '.') ADVANCE(329);
      if (lookahead == '/') ADVANCE(32);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == 'a') ADVANCE(707);
      if (lookahead == 'b') ADVANCE(746);
      if (lookahead == 'c') ADVANCE(547);
      if (lookahead == 'e') ADVANCE(693);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(741);
      if (lookahead == 'o') ADVANCE(766);
      if (lookahead == 'p') ADVANCE(551);
      if (lookahead == 'r') ADVANCE(610);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(782);
      if (lookahead == 'u') ADVANCE(713);
      if (lookahead == 'v') ADVANCE(750);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '{') ADVANCE(324);
      if (lookahead == '}') ADVANCE(326);
      if (lookahead == '~') ADVANCE(456);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(14)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 15:
      if (lookahead == '!') ADVANCE(295);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(386);
      if (lookahead == '.') ADVANCE(329);
      if (lookahead == '/') ADVANCE(32);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == ':') ADVANCE(301);
      if (lookahead == ';') ADVANCE(288);
      if (lookahead == '=') ADVANCE(302);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == 'a') ADVANCE(592);
      if (lookahead == 'b') ADVANCE(747);
      if (lookahead == 'c') ADVANCE(545);
      if (lookahead == 'e') ADVANCE(711);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'l') ADVANCE(665);
      if (lookahead == 'n') ADVANCE(762);
      if (lookahead == 'o') ADVANCE(766);
      if (lookahead == 'p') ADVANCE(551);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(786);
      if (lookahead == 'u') ADVANCE(713);
      if (lookahead == 'v') ADVANCE(750);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(15)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 16:
      if (lookahead == '!') ADVANCE(295);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(386);
      if (lookahead == '.') ADVANCE(329);
      if (lookahead == '/') ADVANCE(32);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == ':') ADVANCE(301);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == 'a') ADVANCE(708);
      if (lookahead == 'b') ADVANCE(747);
      if (lookahead == 'c') ADVANCE(549);
      if (lookahead == 'e') ADVANCE(711);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(762);
      if (lookahead == 'o') ADVANCE(766);
      if (lookahead == 'p') ADVANCE(551);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(786);
      if (lookahead == 'u') ADVANCE(713);
      if (lookahead == 'v') ADVANCE(750);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '{') ADVANCE(324);
      if (lookahead == '|') ADVANCE(380);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(16)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 17:
      if (lookahead == '!') ADVANCE(295);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(386);
      if (lookahead == '.') ADVANCE(329);
      if (lookahead == '/') ADVANCE(32);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == ';') ADVANCE(288);
      if (lookahead == '=') ADVANCE(302);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == 'a') ADVANCE(708);
      if (lookahead == 'b') ADVANCE(747);
      if (lookahead == 'c') ADVANCE(545);
      if (lookahead == 'e') ADVANCE(711);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'l') ADVANCE(665);
      if (lookahead == 'n') ADVANCE(762);
      if (lookahead == 'o') ADVANCE(766);
      if (lookahead == 'p') ADVANCE(551);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(786);
      if (lookahead == 'u') ADVANCE(713);
      if (lookahead == 'v') ADVANCE(750);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(17)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 18:
      if (lookahead == '!') ADVANCE(295);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(386);
      if (lookahead == '.') ADVANCE(329);
      if (lookahead == '/') ADVANCE(32);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == ';') ADVANCE(288);
      if (lookahead == '=') ADVANCE(302);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == 'a') ADVANCE(708);
      if (lookahead == 'b') ADVANCE(747);
      if (lookahead == 'c') ADVANCE(545);
      if (lookahead == 'e') ADVANCE(711);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(762);
      if (lookahead == 'o') ADVANCE(766);
      if (lookahead == 'p') ADVANCE(551);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(786);
      if (lookahead == 'u') ADVANCE(713);
      if (lookahead == 'v') ADVANCE(750);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(18)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 19:
      if (lookahead == '!') ADVANCE(295);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(386);
      if (lookahead == '.') ADVANCE(329);
      if (lookahead == '/') ADVANCE(32);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == ';') ADVANCE(288);
      if (lookahead == '=') ADVANCE(302);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == 'a') ADVANCE(593);
      if (lookahead == 'b') ADVANCE(747);
      if (lookahead == 'c') ADVANCE(545);
      if (lookahead == 'e') ADVANCE(711);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'l') ADVANCE(665);
      if (lookahead == 'n') ADVANCE(762);
      if (lookahead == 'o') ADVANCE(766);
      if (lookahead == 'p') ADVANCE(551);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(786);
      if (lookahead == 'u') ADVANCE(713);
      if (lookahead == 'v') ADVANCE(750);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(19)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 20:
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == ')') ADVANCE(354);
      if (lookahead == '*') ADVANCE(386);
      if (lookahead == '.') ADVANCE(334);
      if (lookahead == '/') ADVANCE(30);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == 'a') ADVANCE(727);
      if (lookahead == 'b') ADVANCE(747);
      if (lookahead == 'c') ADVANCE(549);
      if (lookahead == 'e') ADVANCE(711);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(743);
      if (lookahead == 'o') ADVANCE(766);
      if (lookahead == 'p') ADVANCE(551);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(786);
      if (lookahead == 'u') ADVANCE(713);
      if (lookahead == 'v') ADVANCE(750);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(20)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 21:
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(386);
      if (lookahead == '.') ADVANCE(329);
      if (lookahead == '/') ADVANCE(32);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == ':') ADVANCE(301);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == ']') ADVANCE(362);
      if (lookahead == 'a') ADVANCE(591);
      if (lookahead == 'b') ADVANCE(747);
      if (lookahead == 'c') ADVANCE(467);
      if (lookahead == 'e') ADVANCE(711);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(762);
      if (lookahead == 'o') ADVANCE(766);
      if (lookahead == 'p') ADVANCE(551);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(786);
      if (lookahead == 'u') ADVANCE(713);
      if (lookahead == 'v') ADVANCE(748);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(21)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 22:
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(386);
      if (lookahead == '.') ADVANCE(329);
      if (lookahead == '/') ADVANCE(32);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == 'a') ADVANCE(708);
      if (lookahead == 'b') ADVANCE(747);
      if (lookahead == 'c') ADVANCE(546);
      if (lookahead == 'e') ADVANCE(710);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(740);
      if (lookahead == 'o') ADVANCE(766);
      if (lookahead == 'p') ADVANCE(550);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(597);
      if (lookahead == 'u') ADVANCE(714);
      if (lookahead == 'v') ADVANCE(558);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(22)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 23:
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(386);
      if (lookahead == '.') ADVANCE(329);
      if (lookahead == '/') ADVANCE(32);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == 'a') ADVANCE(591);
      if (lookahead == 'b') ADVANCE(747);
      if (lookahead == 'c') ADVANCE(546);
      if (lookahead == 'e') ADVANCE(711);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(762);
      if (lookahead == 'o') ADVANCE(766);
      if (lookahead == 'p') ADVANCE(551);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(786);
      if (lookahead == 'u') ADVANCE(713);
      if (lookahead == 'v') ADVANCE(748);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(23)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 24:
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(386);
      if (lookahead == '.') ADVANCE(329);
      if (lookahead == '/') ADVANCE(32);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == 'a') ADVANCE(727);
      if (lookahead == 'b') ADVANCE(747);
      if (lookahead == 'c') ADVANCE(549);
      if (lookahead == 'e') ADVANCE(711);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(762);
      if (lookahead == 'o') ADVANCE(766);
      if (lookahead == 'p') ADVANCE(551);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(786);
      if (lookahead == 'u') ADVANCE(713);
      if (lookahead == 'v') ADVANCE(750);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '{') ADVANCE(324);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(24)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 25:
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(386);
      if (lookahead == '.') ADVANCE(329);
      if (lookahead == '/') ADVANCE(32);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == 'a') ADVANCE(727);
      if (lookahead == 'b') ADVANCE(747);
      if (lookahead == 'c') ADVANCE(549);
      if (lookahead == 'e') ADVANCE(711);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(743);
      if (lookahead == 'o') ADVANCE(766);
      if (lookahead == 'p') ADVANCE(551);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(786);
      if (lookahead == 'u') ADVANCE(713);
      if (lookahead == 'v') ADVANCE(750);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(25)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 26:
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '.') ADVANCE(329);
      if (lookahead == '/') ADVANCE(32);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == 'a') ADVANCE(709);
      if (lookahead == 'b') ADVANCE(747);
      if (lookahead == 'c') ADVANCE(549);
      if (lookahead == 'e') ADVANCE(711);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(762);
      if (lookahead == 'o') ADVANCE(766);
      if (lookahead == 'p') ADVANCE(551);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(786);
      if (lookahead == 'u') ADVANCE(713);
      if (lookahead == 'v') ADVANCE(750);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(26)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 27:
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(383);
      if (lookahead == '-') ADVANCE(41);
      if (lookahead == '/') ADVANCE(32);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '{') ADVANCE(324);
      if (lookahead == '|') ADVANCE(380);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(27)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 28:
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '/') ADVANCE(528);
      if (lookahead == '\\') ADVANCE(499);
      if (lookahead == '{') ADVANCE(530);
      if (lookahead == '}') ADVANCE(532);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(527);
      if (lookahead != 0) ADVANCE(529);
      END_STATE();
    case 29:
      if (lookahead == '.') ADVANCE(371);
      END_STATE();
    case 30:
      if (lookahead == '/') ADVANCE(484);
      END_STATE();
    case 31:
      if (lookahead == '/') ADVANCE(481);
      END_STATE();
    case 32:
      if (lookahead == '/') ADVANCE(485);
      END_STATE();
    case 33:
      if (lookahead == '/') ADVANCE(483);
      END_STATE();
    case 34:
      if (lookahead == '/') ADVANCE(9);
      END_STATE();
    case 35:
      if (lookahead == '/') ADVANCE(487);
      if (lookahead == '\\') ADVANCE(499);
      if (lookahead == '{') ADVANCE(487);
      if (lookahead == '}') ADVANCE(487);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(487);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(487);
      END_STATE();
    case 36:
      if (lookahead == '/') ADVANCE(31);
      END_STATE();
    case 37:
      if (lookahead == '/') ADVANCE(32);
      if (lookahead == ':') ADVANCE(301);
      if (lookahead == 'a') ADVANCE(172);
      if (lookahead == '}') ADVANCE(326);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(37)
      if (aux_sym_FormatSequence_token2_character_set_1(lookahead)) ADVANCE(506);
      END_STATE();
    case 38:
      if (lookahead == '/') ADVANCE(30);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '}') ADVANCE(326);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(38)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 39:
      if (lookahead == '=') ADVANCE(406);
      END_STATE();
    case 40:
      if (lookahead == '=') ADVANCE(406);
      if (lookahead == '>') ADVANCE(387);
      END_STATE();
    case 41:
      if (lookahead == '>') ADVANCE(363);
      END_STATE();
    case 42:
      if (lookahead == '>') ADVANCE(387);
      END_STATE();
    case 43:
      if (lookahead == '\\') ADVANCE(533);
      END_STATE();
    case 44:
      if (lookahead == 'a') ADVANCE(154);
      if (lookahead == 'n') ADVANCE(293);
      if (lookahead == 'o') ADVANCE(203);
      END_STATE();
    case 45:
      if (lookahead == 'a') ADVANCE(65);
      if (lookahead == 'u') ADVANCE(61);
      END_STATE();
    case 46:
      if (lookahead == 'a') ADVANCE(200);
      END_STATE();
    case 47:
      if (lookahead == 'a') ADVANCE(62);
      END_STATE();
    case 48:
      if (lookahead == 'a') ADVANCE(161);
      END_STATE();
    case 49:
      if (lookahead == 'a') ADVANCE(141);
      END_STATE();
    case 50:
      if (lookahead == 'a') ADVANCE(129);
      END_STATE();
    case 51:
      if (lookahead == 'a') ADVANCE(204);
      if (lookahead == 'o') ADVANCE(147);
      END_STATE();
    case 52:
      if (lookahead == 'a') ADVANCE(233);
      END_STATE();
    case 53:
      if (lookahead == 'a') ADVANCE(84);
      END_STATE();
    case 54:
      if (lookahead == 'a') ADVANCE(146);
      END_STATE();
    case 55:
      if (lookahead == 'a') ADVANCE(67);
      END_STATE();
    case 56:
      if (lookahead == 'a') ADVANCE(70);
      END_STATE();
    case 57:
      if (lookahead == 'a') ADVANCE(228);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(228);
      if (lookahead == 'o') ADVANCE(174);
      END_STATE();
    case 59:
      if (lookahead == 'a') ADVANCE(71);
      END_STATE();
    case 60:
      if (lookahead == 'a') ADVANCE(163);
      END_STATE();
    case 61:
      if (lookahead == 'b') ADVANCE(275);
      END_STATE();
    case 62:
      if (lookahead == 'b') ADVANCE(153);
      END_STATE();
    case 63:
      if (lookahead == 'c') ADVANCE(327);
      END_STATE();
    case 64:
      if (lookahead == 'c') ADVANCE(120);
      END_STATE();
    case 65:
      if (lookahead == 'c') ADVANCE(142);
      END_STATE();
    case 66:
      if (lookahead == 'c') ADVANCE(121);
      END_STATE();
    case 67:
      if (lookahead == 'c') ADVANCE(123);
      END_STATE();
    case 68:
      if (lookahead == 'c') ADVANCE(227);
      END_STATE();
    case 69:
      if (lookahead == 'c') ADVANCE(54);
      END_STATE();
    case 70:
      if (lookahead == 'c') ADVANCE(96);
      END_STATE();
    case 71:
      if (lookahead == 'c') ADVANCE(98);
      END_STATE();
    case 72:
      if (lookahead == 'c') ADVANCE(190);
      END_STATE();
    case 73:
      if (lookahead == 'c') ADVANCE(231);
      END_STATE();
    case 74:
      if (lookahead == 'd') ADVANCE(83);
      if (lookahead == 'l') ADVANCE(127);
      if (lookahead == 'n') ADVANCE(77);
      if (lookahead == 's') ADVANCE(158);
      if (lookahead == 'w') ADVANCE(50);
      END_STATE();
    case 75:
      if (lookahead == 'd') ADVANCE(83);
      if (lookahead == 'l') ADVANCE(126);
      if (lookahead == 'n') ADVANCE(76);
      END_STATE();
    case 76:
      if (lookahead == 'd') ADVANCE(316);
      END_STATE();
    case 77:
      if (lookahead == 'd') ADVANCE(316);
      if (lookahead == 'y') ADVANCE(515);
      END_STATE();
    case 78:
      if (lookahead == 'd') ADVANCE(351);
      END_STATE();
    case 79:
      if (lookahead == 'd') ADVANCE(308);
      END_STATE();
    case 80:
      if (lookahead == 'd') ADVANCE(343);
      END_STATE();
    case 81:
      if (lookahead == 'd') ADVANCE(101);
      if (lookahead == 'i') ADVANCE(187);
      if (lookahead == 'r') ADVANCE(104);
      END_STATE();
    case 82:
      if (lookahead == 'd') ADVANCE(112);
      if (lookahead == 'o') ADVANCE(206);
      END_STATE();
    case 83:
      if (lookahead == 'd') ADVANCE(213);
      END_STATE();
    case 84:
      if (lookahead == 'd') ADVANCE(150);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(312);
      END_STATE();
    case 86:
      if (lookahead == 'e') ADVANCE(337);
      END_STATE();
    case 87:
      if (lookahead == 'e') ADVANCE(376);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(284);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(471);
      END_STATE();
    case 90:
      if (lookahead == 'e') ADVANCE(418);
      END_STATE();
    case 91:
      if (lookahead == 'e') ADVANCE(372);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(340);
      END_STATE();
    case 93:
      if (lookahead == 'e') ADVANCE(278);
      END_STATE();
    case 94:
      if (lookahead == 'e') ADVANCE(320);
      END_STATE();
    case 95:
      if (lookahead == 'e') ADVANCE(359);
      END_STATE();
    case 96:
      if (lookahead == 'e') ADVANCE(366);
      END_STATE();
    case 97:
      if (lookahead == 'e') ADVANCE(345);
      END_STATE();
    case 98:
      if (lookahead == 'e') ADVANCE(291);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(286);
      END_STATE();
    case 100:
      if (lookahead == 'e') ADVANCE(78);
      END_STATE();
    case 101:
      if (lookahead == 'e') ADVANCE(117);
      END_STATE();
    case 102:
      if (lookahead == 'e') ADVANCE(49);
      END_STATE();
    case 103:
      if (lookahead == 'e') ADVANCE(80);
      END_STATE();
    case 104:
      if (lookahead == 'e') ADVANCE(55);
      END_STATE();
    case 105:
      if (lookahead == 'e') ADVANCE(205);
      END_STATE();
    case 106:
      if (lookahead == 'e') ADVANCE(53);
      END_STATE();
    case 107:
      if (lookahead == 'e') ADVANCE(73);
      END_STATE();
    case 108:
      if (lookahead == 'e') ADVANCE(173);
      END_STATE();
    case 109:
      if (lookahead == 'e') ADVANCE(212);
      END_STATE();
    case 110:
      if (lookahead == 'e') ADVANCE(209);
      END_STATE();
    case 111:
      if (lookahead == 'e') ADVANCE(207);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(116);
      END_STATE();
    case 113:
      if (lookahead == 'e') ADVANCE(223);
      END_STATE();
    case 114:
      if (lookahead == 'f') ADVANCE(374);
      if (lookahead == 'n') ADVANCE(155);
      END_STATE();
    case 115:
      if (lookahead == 'f') ADVANCE(105);
      END_STATE();
    case 116:
      if (lookahead == 'f') ADVANCE(111);
      END_STATE();
    case 117:
      if (lookahead == 'f') ADVANCE(137);
      END_STATE();
    case 118:
      if (lookahead == 'g') ADVANCE(166);
      END_STATE();
    case 119:
      if (lookahead == 'g') ADVANCE(183);
      END_STATE();
    case 120:
      if (lookahead == 'h') ADVANCE(420);
      END_STATE();
    case 121:
      if (lookahead == 'h') ADVANCE(355);
      END_STATE();
    case 122:
      if (lookahead == 'h') ADVANCE(132);
      END_STATE();
    case 123:
      if (lookahead == 'h') ADVANCE(47);
      END_STATE();
    case 124:
      if (lookahead == 'h') ADVANCE(214);
      END_STATE();
    case 125:
      if (lookahead == 'i') ADVANCE(165);
      END_STATE();
    case 126:
      if (lookahead == 'i') ADVANCE(118);
      END_STATE();
    case 127:
      if (lookahead == 'i') ADVANCE(118);
      if (lookahead == 'l') ADVANCE(185);
      END_STATE();
    case 128:
      if (lookahead == 'i') ADVANCE(232);
      END_STATE();
    case 129:
      if (lookahead == 'i') ADVANCE(224);
      END_STATE();
    case 130:
      if (lookahead == 'i') ADVANCE(180);
      END_STATE();
    case 131:
      if (lookahead == 'i') ADVANCE(187);
      END_STATE();
    case 132:
      if (lookahead == 'i') ADVANCE(151);
      END_STATE();
    case 133:
      if (lookahead == 'i') ADVANCE(177);
      END_STATE();
    case 134:
      if (lookahead == 'i') ADVANCE(181);
      END_STATE();
    case 135:
      if (lookahead == 'i') ADVANCE(162);
      END_STATE();
    case 136:
      if (lookahead == 'i') ADVANCE(152);
      END_STATE();
    case 137:
      if (lookahead == 'i') ADVANCE(178);
      END_STATE();
    case 138:
      if (lookahead == 'i') ADVANCE(191);
      END_STATE();
    case 139:
      if (lookahead == 'i') ADVANCE(179);
      END_STATE();
    case 140:
      if (lookahead == 'i') ADVANCE(184);
      END_STATE();
    case 141:
      if (lookahead == 'k') ADVANCE(318);
      END_STATE();
    case 142:
      if (lookahead == 'k') ADVANCE(100);
      END_STATE();
    case 143:
      if (lookahead == 'k') ADVANCE(221);
      END_STATE();
    case 144:
      if (lookahead == 'l') ADVANCE(216);
      END_STATE();
    case 145:
      if (lookahead == 'l') ADVANCE(216);
      if (lookahead == 'n') ADVANCE(234);
      if (lookahead == 'x') ADVANCE(194);
      END_STATE();
    case 146:
      if (lookahead == 'l') ADVANCE(289);
      END_STATE();
    case 147:
      if (lookahead == 'l') ADVANCE(52);
      END_STATE();
    case 148:
      if (lookahead == 'l') ADVANCE(149);
      if (lookahead == 't') ADVANCE(64);
      END_STATE();
    case 149:
      if (lookahead == 'l') ADVANCE(72);
      END_STATE();
    case 150:
      if (lookahead == 'l') ADVANCE(189);
      END_STATE();
    case 151:
      if (lookahead == 'l') ADVANCE(87);
      END_STATE();
    case 152:
      if (lookahead == 'l') ADVANCE(95);
      END_STATE();
    case 153:
      if (lookahead == 'l') ADVANCE(97);
      END_STATE();
    case 154:
      if (lookahead == 'l') ADVANCE(220);
      END_STATE();
    case 155:
      if (lookahead == 'l') ADVANCE(133);
      END_STATE();
    case 156:
      if (lookahead == 'l') ADVANCE(222);
      END_STATE();
    case 157:
      if (lookahead == 'l') ADVANCE(139);
      END_STATE();
    case 158:
      if (lookahead == 'm') ADVANCE(357);
      if (lookahead == 'y') ADVANCE(175);
      END_STATE();
    case 159:
      if (lookahead == 'm') ADVANCE(195);
      if (lookahead == 'n') ADVANCE(219);
      END_STATE();
    case 160:
      if (lookahead == 'm') ADVANCE(473);
      END_STATE();
    case 161:
      if (lookahead == 'm') ADVANCE(92);
      END_STATE();
    case 162:
      if (lookahead == 'm') ADVANCE(93);
      END_STATE();
    case 163:
      if (lookahead == 'm') ADVANCE(113);
      END_STATE();
    case 164:
      if (lookahead == 'n') ADVANCE(293);
      if (lookahead == 'o') ADVANCE(203);
      END_STATE();
    case 165:
      if (lookahead == 'n') ADVANCE(143);
      END_STATE();
    case 166:
      if (lookahead == 'n') ADVANCE(463);
      END_STATE();
    case 167:
      if (lookahead == 'n') ADVANCE(475);
      END_STATE();
    case 168:
      if (lookahead == 'n') ADVANCE(282);
      END_STATE();
    case 169:
      if (lookahead == 'n') ADVANCE(238);
      END_STATE();
    case 170:
      if (lookahead == 'n') ADVANCE(364);
      END_STATE();
    case 171:
      if (lookahead == 'n') ADVANCE(155);
      END_STATE();
    case 172:
      if (lookahead == 'n') ADVANCE(240);
      END_STATE();
    case 173:
      if (lookahead == 'n') ADVANCE(79);
      END_STATE();
    case 174:
      if (lookahead == 'n') ADVANCE(218);
      END_STATE();
    case 175:
      if (lookahead == 'n') ADVANCE(63);
      END_STATE();
    case 176:
      if (lookahead == 'n') ADVANCE(76);
      END_STATE();
    case 177:
      if (lookahead == 'n') ADVANCE(88);
      END_STATE();
    case 178:
      if (lookahead == 'n') ADVANCE(103);
      END_STATE();
    case 179:
      if (lookahead == 'n') ADVANCE(99);
      END_STATE();
    case 180:
      if (lookahead == 'n') ADVANCE(119);
      END_STATE();
    case 181:
      if (lookahead == 'n') ADVANCE(237);
      END_STATE();
    case 182:
      if (lookahead == 'n') ADVANCE(131);
      if (lookahead == 's') ADVANCE(130);
      END_STATE();
    case 183:
      if (lookahead == 'n') ADVANCE(60);
      END_STATE();
    case 184:
      if (lookahead == 'n') ADVANCE(157);
      END_STATE();
    case 185:
      if (lookahead == 'o') ADVANCE(239);
      END_STATE();
    case 186:
      if (lookahead == 'o') ADVANCE(461);
      END_STATE();
    case 187:
      if (lookahead == 'o') ADVANCE(167);
      END_STATE();
    case 188:
      if (lookahead == 'o') ADVANCE(211);
      END_STATE();
    case 189:
      if (lookahead == 'o') ADVANCE(69);
      END_STATE();
    case 190:
      if (lookahead == 'o') ADVANCE(169);
      END_STATE();
    case 191:
      if (lookahead == 'o') ADVANCE(170);
      END_STATE();
    case 192:
      if (lookahead == 'o') ADVANCE(140);
      END_STATE();
    case 193:
      if (lookahead == 'p') ADVANCE(46);
      if (lookahead == 'r') ADVANCE(314);
      END_STATE();
    case 194:
      if (lookahead == 'p') ADVANCE(188);
      if (lookahead == 't') ADVANCE(109);
      END_STATE();
    case 195:
      if (lookahead == 'p') ADVANCE(230);
      END_STATE();
    case 196:
      if (lookahead == 'p') ADVANCE(108);
      END_STATE();
    case 197:
      if (lookahead == 'p') ADVANCE(91);
      END_STATE();
    case 198:
      if (lookahead == 'p') ADVANCE(56);
      END_STATE();
    case 199:
      if (lookahead == 'p') ADVANCE(59);
      END_STATE();
    case 200:
      if (lookahead == 'q') ADVANCE(236);
      END_STATE();
    case 201:
      if (lookahead == 'r') ADVANCE(314);
      END_STATE();
    case 202:
      if (lookahead == 'r') ADVANCE(82);
      END_STATE();
    case 203:
      if (lookahead == 'r') ADVANCE(378);
      END_STATE();
    case 204:
      if (lookahead == 'r') ADVANCE(299);
      END_STATE();
    case 205:
      if (lookahead == 'r') ADVANCE(306);
      END_STATE();
    case 206:
      if (lookahead == 'r') ADVANCE(335);
      END_STATE();
    case 207:
      if (lookahead == 'r') ADVANCE(310);
      END_STATE();
    case 208:
      if (lookahead == 'r') ADVANCE(235);
      END_STATE();
    case 209:
      if (lookahead == 'r') ADVANCE(186);
      END_STATE();
    case 210:
      if (lookahead == 'r') ADVANCE(48);
      END_STATE();
    case 211:
      if (lookahead == 'r') ADVANCE(226);
      END_STATE();
    case 212:
      if (lookahead == 'r') ADVANCE(168);
      END_STATE();
    case 213:
      if (lookahead == 'r') ADVANCE(217);
      END_STATE();
    case 214:
      if (lookahead == 'r') ADVANCE(106);
      END_STATE();
    case 215:
      if (lookahead == 's') ADVANCE(196);
      END_STATE();
    case 216:
      if (lookahead == 's') ADVANCE(85);
      END_STATE();
    case 217:
      if (lookahead == 's') ADVANCE(198);
      END_STATE();
    case 218:
      if (lookahead == 's') ADVANCE(225);
      END_STATE();
    case 219:
      if (lookahead == 's') ADVANCE(225);
      if (lookahead == 't') ADVANCE(134);
      END_STATE();
    case 220:
      if (lookahead == 's') ADVANCE(86);
      END_STATE();
    case 221:
      if (lookahead == 's') ADVANCE(107);
      END_STATE();
    case 222:
      if (lookahead == 's') ADVANCE(90);
      END_STATE();
    case 223:
      if (lookahead == 's') ADVANCE(199);
      END_STATE();
    case 224:
      if (lookahead == 't') ADVANCE(458);
      END_STATE();
    case 225:
      if (lookahead == 't') ADVANCE(297);
      END_STATE();
    case 226:
      if (lookahead == 't') ADVANCE(280);
      END_STATE();
    case 227:
      if (lookahead == 't') ADVANCE(469);
      END_STATE();
    case 228:
      if (lookahead == 't') ADVANCE(64);
      END_STATE();
    case 229:
      if (lookahead == 't') ADVANCE(208);
      END_STATE();
    case 230:
      if (lookahead == 't') ADVANCE(135);
      END_STATE();
    case 231:
      if (lookahead == 't') ADVANCE(138);
      END_STATE();
    case 232:
      if (lookahead == 't') ADVANCE(66);
      END_STATE();
    case 233:
      if (lookahead == 't') ADVANCE(136);
      END_STATE();
    case 234:
      if (lookahead == 'u') ADVANCE(160);
      END_STATE();
    case 235:
      if (lookahead == 'u') ADVANCE(68);
      END_STATE();
    case 236:
      if (lookahead == 'u') ADVANCE(89);
      END_STATE();
    case 237:
      if (lookahead == 'u') ADVANCE(94);
      END_STATE();
    case 238:
      if (lookahead == 'v') ADVANCE(368);
      END_STATE();
    case 239:
      if (lookahead == 'w') ADVANCE(242);
      END_STATE();
    case 240:
      if (lookahead == 'y') ADVANCE(514);
      END_STATE();
    case 241:
      if (lookahead == 'y') ADVANCE(197);
      END_STATE();
    case 242:
      if (lookahead == 'z') ADVANCE(110);
      END_STATE();
    case 243:
      if (lookahead == '{') ADVANCE(259);
      END_STATE();
    case 244:
      if (lookahead == '}') ADVANCE(501);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(244);
      END_STATE();
    case 245:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(253);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(493);
      END_STATE();
    case 246:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(254);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(491);
      END_STATE();
    case 247:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(255);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(492);
      END_STATE();
    case 248:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(256);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(489);
      END_STATE();
    case 249:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(494);
      END_STATE();
    case 250:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(495);
      END_STATE();
    case 251:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 252:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(490);
      END_STATE();
    case 253:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(493);
      END_STATE();
    case 254:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(491);
      END_STATE();
    case 255:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(492);
      END_STATE();
    case 256:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(489);
      END_STATE();
    case 257:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(516);
      END_STATE();
    case 258:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(496);
      END_STATE();
    case 259:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(244);
      END_STATE();
    case 260:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(488);
      END_STATE();
    case 261:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'f')) ADVANCE(262);
      END_STATE();
    case 262:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'f')) ADVANCE(500);
      END_STATE();
    case 263:
      if (eof) ADVANCE(273);
      if (lookahead == '!') ADVANCE(296);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '%') ADVANCE(450);
      if (lookahead == '&') ADVANCE(415);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == ')') ADVANCE(354);
      if (lookahead == '*') ADVANCE(384);
      if (lookahead == '+') ADVANCE(428);
      if (lookahead == ',') ADVANCE(274);
      if (lookahead == '-') ADVANCE(430);
      if (lookahead == '.') ADVANCE(330);
      if (lookahead == '/') ADVANCE(446);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == ':') ADVANCE(301);
      if (lookahead == ';') ADVANCE(288);
      if (lookahead == '<') ADVANCE(408);
      if (lookahead == '=') ADVANCE(304);
      if (lookahead == '>') ADVANCE(410);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == 'X') ADVANCE(506);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(499);
      if (lookahead == ']') ADVANCE(362);
      if (lookahead == '^') ADVANCE(417);
      if (lookahead == 'a') ADVANCE(74);
      if (lookahead == 'b') ADVANCE(511);
      if (lookahead == 'c') ADVANCE(468);
      if (lookahead == 'd') ADVANCE(507);
      if (lookahead == 'e') ADVANCE(508);
      if (lookahead == 'f') ADVANCE(44);
      if (lookahead == 'i') ADVANCE(114);
      if (lookahead == 'l') ADVANCE(125);
      if (lookahead == 'o') ADVANCE(510);
      if (lookahead == 'p') ADVANCE(45);
      if (lookahead == 's') ADVANCE(512);
      if (lookahead == 'u') ADVANCE(509);
      if (lookahead == 'v') ADVANCE(51);
      if (lookahead == 'w') ADVANCE(122);
      if (lookahead == 'x') ADVANCE(513);
      if (lookahead == '{') ADVANCE(325);
      if (lookahead == '|') ADVANCE(381);
      if (lookahead == '}') ADVANCE(326);
      if (lookahead == '~') ADVANCE(456);
      if (lookahead == 'n' ||
          ('r' <= lookahead && lookahead <= 't')) ADVANCE(502);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(263)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 264:
      if (eof) ADVANCE(273);
      if (lookahead == '!') ADVANCE(296);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '%') ADVANCE(450);
      if (lookahead == '&') ADVANCE(415);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == ')') ADVANCE(354);
      if (lookahead == '*') ADVANCE(384);
      if (lookahead == '+') ADVANCE(428);
      if (lookahead == ',') ADVANCE(274);
      if (lookahead == '-') ADVANCE(430);
      if (lookahead == '.') ADVANCE(330);
      if (lookahead == '/') ADVANCE(448);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == ':') ADVANCE(301);
      if (lookahead == ';') ADVANCE(288);
      if (lookahead == '<') ADVANCE(408);
      if (lookahead == '=') ADVANCE(304);
      if (lookahead == '>') ADVANCE(410);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == ']') ADVANCE(362);
      if (lookahead == '^') ADVANCE(417);
      if (lookahead == 'a') ADVANCE(719);
      if (lookahead == 'b') ADVANCE(746);
      if (lookahead == 'c') ADVANCE(543);
      if (lookahead == 'e') ADVANCE(693);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(741);
      if (lookahead == 'o') ADVANCE(765);
      if (lookahead == 'p') ADVANCE(551);
      if (lookahead == 'r') ADVANCE(610);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(782);
      if (lookahead == 'u') ADVANCE(713);
      if (lookahead == 'v') ADVANCE(750);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '{') ADVANCE(324);
      if (lookahead == '|') ADVANCE(381);
      if (lookahead == '}') ADVANCE(326);
      if (lookahead == '~') ADVANCE(456);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(264)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 265:
      if (eof) ADVANCE(273);
      if (lookahead == '!') ADVANCE(296);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '%') ADVANCE(449);
      if (lookahead == '&') ADVANCE(414);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(385);
      if (lookahead == '+') ADVANCE(429);
      if (lookahead == ',') ADVANCE(274);
      if (lookahead == '-') ADVANCE(434);
      if (lookahead == '.') ADVANCE(329);
      if (lookahead == '/') ADVANCE(445);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == ':') ADVANCE(301);
      if (lookahead == '<') ADVANCE(409);
      if (lookahead == '=') ADVANCE(39);
      if (lookahead == '>') ADVANCE(411);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == '^') ADVANCE(416);
      if (lookahead == 'a') ADVANCE(719);
      if (lookahead == 'b') ADVANCE(746);
      if (lookahead == 'c') ADVANCE(544);
      if (lookahead == 'e') ADVANCE(710);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(742);
      if (lookahead == 'o') ADVANCE(765);
      if (lookahead == 'p') ADVANCE(550);
      if (lookahead == 'r') ADVANCE(610);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(596);
      if (lookahead == 'u') ADVANCE(714);
      if (lookahead == 'v') ADVANCE(558);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '{') ADVANCE(324);
      if (lookahead == '|') ADVANCE(382);
      if (lookahead == '}') ADVANCE(326);
      if (lookahead == '~') ADVANCE(456);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(265)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 266:
      if (eof) ADVANCE(273);
      if (lookahead == '!') ADVANCE(296);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '%') ADVANCE(449);
      if (lookahead == '&') ADVANCE(414);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(385);
      if (lookahead == '+') ADVANCE(429);
      if (lookahead == ',') ADVANCE(274);
      if (lookahead == '-') ADVANCE(434);
      if (lookahead == '.') ADVANCE(329);
      if (lookahead == '/') ADVANCE(445);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == ':') ADVANCE(301);
      if (lookahead == '<') ADVANCE(409);
      if (lookahead == '=') ADVANCE(39);
      if (lookahead == '>') ADVANCE(411);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == '^') ADVANCE(416);
      if (lookahead == 'a') ADVANCE(719);
      if (lookahead == 'b') ADVANCE(746);
      if (lookahead == 'c') ADVANCE(544);
      if (lookahead == 'e') ADVANCE(692);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(742);
      if (lookahead == 'o') ADVANCE(765);
      if (lookahead == 'p') ADVANCE(550);
      if (lookahead == 'r') ADVANCE(610);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(596);
      if (lookahead == 'u') ADVANCE(714);
      if (lookahead == 'v') ADVANCE(558);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '{') ADVANCE(324);
      if (lookahead == '|') ADVANCE(382);
      if (lookahead == '}') ADVANCE(326);
      if (lookahead == '~') ADVANCE(456);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(266)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 267:
      if (eof) ADVANCE(273);
      if (lookahead == '!') ADVANCE(296);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '%') ADVANCE(449);
      if (lookahead == '&') ADVANCE(414);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(385);
      if (lookahead == '+') ADVANCE(429);
      if (lookahead == ',') ADVANCE(274);
      if (lookahead == '-') ADVANCE(433);
      if (lookahead == '.') ADVANCE(332);
      if (lookahead == '/') ADVANCE(445);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == ':') ADVANCE(301);
      if (lookahead == '<') ADVANCE(409);
      if (lookahead == '=') ADVANCE(39);
      if (lookahead == '>') ADVANCE(411);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == '^') ADVANCE(416);
      if (lookahead == 'a') ADVANCE(720);
      if (lookahead == 'b') ADVANCE(747);
      if (lookahead == 'c') ADVANCE(542);
      if (lookahead == 'e') ADVANCE(710);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(740);
      if (lookahead == 'o') ADVANCE(765);
      if (lookahead == 'p') ADVANCE(550);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(597);
      if (lookahead == 'u') ADVANCE(714);
      if (lookahead == 'v') ADVANCE(558);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '{') ADVANCE(324);
      if (lookahead == '|') ADVANCE(382);
      if (lookahead == '}') ADVANCE(326);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(267)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 268:
      if (eof) ADVANCE(273);
      if (lookahead == '!') ADVANCE(296);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '%') ADVANCE(449);
      if (lookahead == '&') ADVANCE(414);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(385);
      if (lookahead == '+') ADVANCE(429);
      if (lookahead == ',') ADVANCE(274);
      if (lookahead == '-') ADVANCE(433);
      if (lookahead == '.') ADVANCE(332);
      if (lookahead == '/') ADVANCE(445);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == ':') ADVANCE(301);
      if (lookahead == '<') ADVANCE(409);
      if (lookahead == '=') ADVANCE(39);
      if (lookahead == '>') ADVANCE(411);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == '^') ADVANCE(416);
      if (lookahead == 'a') ADVANCE(720);
      if (lookahead == 'b') ADVANCE(747);
      if (lookahead == 'c') ADVANCE(542);
      if (lookahead == 'e') ADVANCE(692);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(740);
      if (lookahead == 'o') ADVANCE(765);
      if (lookahead == 'p') ADVANCE(550);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(597);
      if (lookahead == 'u') ADVANCE(714);
      if (lookahead == 'v') ADVANCE(558);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '{') ADVANCE(324);
      if (lookahead == '|') ADVANCE(382);
      if (lookahead == '}') ADVANCE(326);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(268)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 269:
      if (eof) ADVANCE(273);
      if (lookahead == '!') ADVANCE(295);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(386);
      if (lookahead == ',') ADVANCE(274);
      if (lookahead == '-') ADVANCE(41);
      if (lookahead == '.') ADVANCE(332);
      if (lookahead == '/') ADVANCE(30);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == ':') ADVANCE(301);
      if (lookahead == ';') ADVANCE(288);
      if (lookahead == '=') ADVANCE(302);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == 'a') ADVANCE(686);
      if (lookahead == 'b') ADVANCE(747);
      if (lookahead == 'c') ADVANCE(546);
      if (lookahead == 'e') ADVANCE(710);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(740);
      if (lookahead == 'o') ADVANCE(766);
      if (lookahead == 'p') ADVANCE(550);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(597);
      if (lookahead == 'u') ADVANCE(714);
      if (lookahead == 'v') ADVANCE(558);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '{') ADVANCE(324);
      if (lookahead == '}') ADVANCE(326);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(269)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 270:
      if (eof) ADVANCE(273);
      if (lookahead == '!') ADVANCE(295);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(386);
      if (lookahead == ',') ADVANCE(274);
      if (lookahead == '-') ADVANCE(41);
      if (lookahead == '.') ADVANCE(332);
      if (lookahead == '/') ADVANCE(30);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == ':') ADVANCE(301);
      if (lookahead == ';') ADVANCE(288);
      if (lookahead == '=') ADVANCE(302);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == 'a') ADVANCE(686);
      if (lookahead == 'b') ADVANCE(747);
      if (lookahead == 'c') ADVANCE(546);
      if (lookahead == 'e') ADVANCE(692);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(740);
      if (lookahead == 'o') ADVANCE(766);
      if (lookahead == 'p') ADVANCE(550);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(597);
      if (lookahead == 'u') ADVANCE(714);
      if (lookahead == 'v') ADVANCE(558);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '{') ADVANCE(324);
      if (lookahead == '}') ADVANCE(326);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(270)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 271:
      if (eof) ADVANCE(273);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(386);
      if (lookahead == ',') ADVANCE(274);
      if (lookahead == '.') ADVANCE(329);
      if (lookahead == '/') ADVANCE(30);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == '=') ADVANCE(302);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == 'a') ADVANCE(708);
      if (lookahead == 'b') ADVANCE(747);
      if (lookahead == 'c') ADVANCE(546);
      if (lookahead == 'e') ADVANCE(710);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(740);
      if (lookahead == 'o') ADVANCE(766);
      if (lookahead == 'p') ADVANCE(550);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(597);
      if (lookahead == 'u') ADVANCE(714);
      if (lookahead == 'v') ADVANCE(558);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '}') ADVANCE(326);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(271)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 272:
      if (eof) ADVANCE(273);
      if (lookahead == '"') ADVANCE(525);
      if (lookahead == '\'') ADVANCE(486);
      if (lookahead == '(') ADVANCE(353);
      if (lookahead == '*') ADVANCE(386);
      if (lookahead == '.') ADVANCE(329);
      if (lookahead == '/') ADVANCE(33);
      if (lookahead == '0') ADVANCE(497);
      if (lookahead == '?') ADVANCE(460);
      if (lookahead == '@') ADVANCE(852);
      if (lookahead == '[') ADVANCE(361);
      if (lookahead == '\\') ADVANCE(43);
      if (lookahead == 'a') ADVANCE(708);
      if (lookahead == 'b') ADVANCE(747);
      if (lookahead == 'c') ADVANCE(546);
      if (lookahead == 'e') ADVANCE(710);
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'i') ADVANCE(636);
      if (lookahead == 'n') ADVANCE(740);
      if (lookahead == 'o') ADVANCE(766);
      if (lookahead == 'p') ADVANCE(550);
      if (lookahead == 's') ADVANCE(823);
      if (lookahead == 't') ADVANCE(597);
      if (lookahead == 'u') ADVANCE(714);
      if (lookahead == 'v') ADVANCE(558);
      if (lookahead == 'w') ADVANCE(648);
      if (lookahead == '}') ADVANCE(326);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(272)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(anon_sym_pub);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_pub);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_test);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_comptime);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_comptime);
      if (lookahead == '_') ADVANCE(637);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_export);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(anon_sym_extern);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(anon_sym_inline);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_inline);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_noinline);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_noinline);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_threadlocal);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_threadlocal);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_usingnamespace);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_usingnamespace);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_fn);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(anon_sym_fn);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(407);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_const);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_var);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(406);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(406);
      if (lookahead == '>') ADVANCE(387);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_nosuspend);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(anon_sym_defer);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_defer);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_suspend);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(anon_sym_suspend);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_errdefer);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_errdefer);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_else);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == 'e') ADVANCE(156);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == 'e') ADVANCE(696);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(anon_sym_and);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(anon_sym_break);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(anon_sym_continue);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(anon_sym_resume);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(anon_sym_return);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '{') ADVANCE(503);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(anon_sym_async);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '*') ADVANCE(465);
      if (lookahead == '.') ADVANCE(388);
      if (lookahead == '?') ADVANCE(466);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '*') ADVANCE(465);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '?') ADVANCE(466);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '*') ADVANCE(465);
      if (lookahead == '?') ADVANCE(466);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(388);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(29);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(anon_sym_error);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(anon_sym_error);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(anon_sym_false);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(anon_sym_null);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(anon_sym_anyframe);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(anon_sym_anyframe);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(anon_sym_true);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(anon_sym_undefined);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(anon_sym_undefined);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_unreachable);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(anon_sym_unreachable);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(sym_BuildinTypeExpr);
      if (lookahead == 'd') ADVANCE(752);
      if (lookahead == 'l') ADVANCE(760);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(sym_BuildinTypeExpr);
      if (lookahead == 'l') ADVANCE(760);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(sym_BuildinTypeExpr);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(349);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(sym_BuildinTypeExpr);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(anon_sym_packed);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(anon_sym_packed);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(anon_sym_switch);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(anon_sym_asm);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(anon_sym_asm);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(anon_sym_volatile);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(anon_sym_linksection);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(anon_sym_linksection);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(anon_sym_addrspace);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(anon_sym_addrspace);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(anon_sym_callconv);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(anon_sym_callconv);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(anon_sym_noalias);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(anon_sym_anytype);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(anon_sym_anytype);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(anon_sym_if);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(anon_sym_while);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(anon_sym_for);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(402);
      if (lookahead == '|') ADVANCE(444);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(444);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '%') ADVANCE(453);
      if (lookahead == '*') ADVANCE(451);
      if (lookahead == '=') ADVANCE(389);
      if (lookahead == '|') ADVANCE(455);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '%') ADVANCE(452);
      if (lookahead == '*') ADVANCE(451);
      if (lookahead == '|') ADVANCE(454);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(451);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(anon_sym_STAR_PIPE_EQ);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(anon_sym_PLUS_PIPE_EQ);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(anon_sym_DASH_PIPE_EQ);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(anon_sym_LT_LT_PIPE_EQ);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(anon_sym_STAR_PERCENT_EQ);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(anon_sym_PLUS_PERCENT_EQ);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(anon_sym_DASH_PERCENT_EQ);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(422);
      if (lookahead == '=') ADVANCE(412);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(423);
      if (lookahead == '=') ADVANCE(412);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(413);
      if (lookahead == '>') ADVANCE(425);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(413);
      if (lookahead == '>') ADVANCE(424);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '=') ADVANCE(400);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(401);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(anon_sym_orelse);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(anon_sym_orelse);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(anon_sym_catch);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(397);
      if (lookahead == '|') ADVANCE(427);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '|') ADVANCE(426);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(399);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(anon_sym_LT_LT_PIPE);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(anon_sym_LT_LT_PIPE);
      if (lookahead == '=') ADVANCE(398);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '%') ADVANCE(437);
      if (lookahead == '+') ADVANCE(435);
      if (lookahead == '=') ADVANCE(393);
      if (lookahead == '|') ADVANCE(441);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '%') ADVANCE(436);
      if (lookahead == '+') ADVANCE(435);
      if (lookahead == '|') ADVANCE(440);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '%') ADVANCE(439);
      if (lookahead == '=') ADVANCE(395);
      if (lookahead == '>') ADVANCE(363);
      if (lookahead == '|') ADVANCE(443);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '%') ADVANCE(439);
      if (lookahead == '=') ADVANCE(395);
      if (lookahead == '|') ADVANCE(443);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '%') ADVANCE(438);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '%') ADVANCE(438);
      if (lookahead == '>') ADVANCE(363);
      if (lookahead == '|') ADVANCE(442);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '%') ADVANCE(438);
      if (lookahead == '|') ADVANCE(442);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(anon_sym_PLUS_PERCENT);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(anon_sym_PLUS_PERCENT);
      if (lookahead == '=') ADVANCE(404);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(anon_sym_DASH_PERCENT);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(anon_sym_DASH_PERCENT);
      if (lookahead == '=') ADVANCE(405);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(anon_sym_PLUS_PIPE);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(anon_sym_PLUS_PIPE);
      if (lookahead == '=') ADVANCE(394);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(anon_sym_DASH_PIPE);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(anon_sym_DASH_PIPE);
      if (lookahead == '=') ADVANCE(396);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(484);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(484);
      if (lookahead == '=') ADVANCE(391);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(485);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(485);
      if (lookahead == '=') ADVANCE(391);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(392);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(anon_sym_STAR_PERCENT);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(anon_sym_STAR_PERCENT);
      if (lookahead == '=') ADVANCE(403);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(anon_sym_STAR_PIPE);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym_STAR_PIPE);
      if (lookahead == '=') ADVANCE(390);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(anon_sym_try);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_await);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(anon_sym_allowzero);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_allowzero);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(anon_sym_align);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_align);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_DOT_STAR);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(anon_sym_DOT_QMARK);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_c);
      if (lookahead == '_') ADVANCE(656);
      if (lookahead == 'o') ADVANCE(700);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_c);
      if (lookahead == 'a') ADVANCE(148);
      if (lookahead == 'o') ADVANCE(159);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(anon_sym_struct);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_opaque);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_opaque);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_enum);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(anon_sym_union);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(sym_container_doc_comment);
      if (lookahead == '\n') ADVANCE(480);
      if (lookahead == ' ') ADVANCE(479);
      if (lookahead == '!') ADVANCE(479);
      if (lookahead == '/') ADVANCE(477);
      if (lookahead != 0) ADVANCE(479);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(sym_container_doc_comment);
      if (lookahead == '\n') ADVANCE(480);
      if (lookahead == ' ') ADVANCE(479);
      if (lookahead == '/') ADVANCE(477);
      if (lookahead != 0) ADVANCE(479);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(sym_container_doc_comment);
      if (lookahead == '\n') ADVANCE(480);
      if (lookahead == ' ') ADVANCE(479);
      if (lookahead == '/') ADVANCE(478);
      if (lookahead != 0) ADVANCE(479);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(sym_container_doc_comment);
      if (lookahead == '/') ADVANCE(34);
      if (lookahead == '\n' ||
          lookahead == ' ') ADVANCE(480);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(sym_doc_comment);
      if (lookahead == '\n') ADVANCE(482);
      if (lookahead == ' ') ADVANCE(481);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead != 0) ADVANCE(481);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(sym_doc_comment);
      if (lookahead == '/') ADVANCE(36);
      if (lookahead == '\n' ||
          lookahead == ' ') ADVANCE(482);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead == '!') ADVANCE(479);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(485);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead == '/') ADVANCE(481);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(485);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(485);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(aux_sym_CHAR_LITERAL_token1);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(aux_sym_FLOAT_token1);
      if (lookahead == '_') ADVANCE(260);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(248);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(488);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(aux_sym_FLOAT_token1);
      if (lookahead == '_') ADVANCE(256);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(489);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(aux_sym_FLOAT_token2);
      if (lookahead == '_') ADVANCE(252);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(246);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(490);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(aux_sym_FLOAT_token2);
      if (lookahead == '_') ADVANCE(254);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(491);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(aux_sym_FLOAT_token3);
      if (lookahead == '_') ADVANCE(255);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(492);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(aux_sym_FLOAT_token4);
      if (lookahead == '_') ADVANCE(253);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(493);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(aux_sym_INTEGER_token1);
      if (lookahead == '_') ADVANCE(249);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(494);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(aux_sym_INTEGER_token2);
      if (lookahead == '_') ADVANCE(250);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(495);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(aux_sym_INTEGER_token3);
      if (lookahead == '.') ADVANCE(260);
      if (lookahead == '_') ADVANCE(258);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(247);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(496);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(aux_sym_INTEGER_token4);
      if (lookahead == '.') ADVANCE(252);
      if (lookahead == '_') ADVANCE(251);
      if (lookahead == 'b') ADVANCE(249);
      if (lookahead == 'o') ADVANCE(250);
      if (lookahead == 'x') ADVANCE(258);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(245);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(aux_sym_INTEGER_token4);
      if (lookahead == '.') ADVANCE(252);
      if (lookahead == '_') ADVANCE(251);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(245);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(aux_sym_EscapeSequence_token1);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(aux_sym_EscapeSequence_token2);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(aux_sym_EscapeSequence_token3);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(anon_sym_LBRACE_LBRACE);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(anon_sym_RBRACE_RBRACE);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(aux_sym_FormatSequence_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(505);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(aux_sym_FormatSequence_token2);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(aux_sym_FormatSequence_token2);
      if (lookahead == 'e') ADVANCE(115);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(aux_sym_FormatSequence_token2);
      if (lookahead == 'l') ADVANCE(216);
      if (lookahead == 'n') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(202);
      if (lookahead == 'x') ADVANCE(194);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(aux_sym_FormatSequence_token2);
      if (lookahead == 'n') ADVANCE(81);
      if (lookahead == 's') ADVANCE(130);
      if (lookahead == '{') ADVANCE(259);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(aux_sym_FormatSequence_token2);
      if (lookahead == 'p') ADVANCE(46);
      if (lookahead == 'r') ADVANCE(314);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(aux_sym_FormatSequence_token2);
      if (lookahead == 'r') ADVANCE(102);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(aux_sym_FormatSequence_token2);
      if (lookahead == 't') ADVANCE(208);
      if (lookahead == 'u') ADVANCE(215);
      if (lookahead == 'w') ADVANCE(128);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(aux_sym_FormatSequence_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'f')) ADVANCE(262);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(anon_sym_any);
      if (lookahead == 'f') ADVANCE(210);
      if (lookahead == 't') ADVANCE(241);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(aux_sym_FormatSequence_token3);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(516);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(aux_sym_FormatSequence_token4);
      if (lookahead == '\n') ADVANCE(517);
      if (lookahead == '/') ADVANCE(519);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(517);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(523);
      if (lookahead == '"' ||
          lookahead == '\\' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(524);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(522);
      if (lookahead != 0) ADVANCE(522);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(aux_sym_FormatSequence_token4);
      if (lookahead == '\n') ADVANCE(517);
      if (lookahead == '/') ADVANCE(519);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(517);
      if (lookahead == '"' ||
          lookahead == '\\' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(524);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(522);
      if (lookahead != 0) ADVANCE(522);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(aux_sym_FormatSequence_token4);
      if (lookahead == '/') ADVANCE(485);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(257);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(524);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(aux_sym_FormatSequence_token4);
      if (lookahead == '/') ADVANCE(485);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(524);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(aux_sym_FormatSequence_token4);
      if (lookahead == '/') ADVANCE(520);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(521);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(524);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(524);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(aux_sym_FormatSequence_token4);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(257);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(524);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(aux_sym_FormatSequence_token4);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '^') ADVANCE(257);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(516);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(aux_sym_FormatSequence_token4);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(524);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(aux_sym_STRINGLITERALSINGLE_token1);
      if (lookahead == '\n') ADVANCE(529);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(526);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(aux_sym_STRINGLITERALSINGLE_token1);
      if (lookahead == '/') ADVANCE(528);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(527);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(529);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(aux_sym_STRINGLITERALSINGLE_token1);
      if (lookahead == '/') ADVANCE(526);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(529);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(aux_sym_STRINGLITERALSINGLE_token1);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(529);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(anon_sym_LBRACE2);
      if (lookahead == '{') ADVANCE(503);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(anon_sym_RBRACE2);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(anon_sym_RBRACE2);
      if (lookahead == '}') ADVANCE(504);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(anon_sym_BSLASH_BSLASH);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(aux_sym_LINESTRING_token1);
      if (lookahead == '/') ADVANCE(485);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(536);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(aux_sym_LINESTRING_token1);
      if (lookahead == '/') ADVANCE(534);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(535);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(536);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(aux_sym_LINESTRING_token1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(536);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == '1') ADVANCE(538);
      if (lookahead == '3') ADVANCE(539);
      if (lookahead == '6') ADVANCE(540);
      if (lookahead == 'a') ADVANCE(679);
      if (lookahead == 'n') ADVANCE(294);
      if (lookahead == 'o') ADVANCE(779);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == '2') ADVANCE(541);
      if (lookahead == '6') ADVANCE(350);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == '2') ADVANCE(350);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == '4') ADVANCE(350);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == '8') ADVANCE(350);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == '_') ADVANCE(656);
      if (lookahead == 'a') ADVANCE(827);
      if (lookahead == 'o') ADVANCE(700);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == '_') ADVANCE(656);
      if (lookahead == 'a') ADVANCE(827);
      if (lookahead == 'o') ADVANCE(701);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == '_') ADVANCE(656);
      if (lookahead == 'a') ADVANCE(827);
      if (lookahead == 'o') ADVANCE(699);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == '_') ADVANCE(656);
      if (lookahead == 'a') ADVANCE(688);
      if (lookahead == 'o') ADVANCE(702);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == '_') ADVANCE(656);
      if (lookahead == 'o') ADVANCE(700);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == '_') ADVANCE(656);
      if (lookahead == 'o') ADVANCE(701);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == '_') ADVANCE(656);
      if (lookahead == 'o') ADVANCE(699);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == '_') ADVANCE(656);
      if (lookahead == 'o') ADVANCE(702);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'a') ADVANCE(572);
      if (lookahead == 'u') ADVANCE(569);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'a') ADVANCE(572);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'a') ADVANCE(776);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'a') ADVANCE(571);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'a') ADVANCE(703);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'a') ADVANCE(673);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'a') ADVANCE(816);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 557:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'a') ADVANCE(590);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'a') ADVANCE(780);
      if (lookahead == 'o') ADVANCE(655);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'a') ADVANCE(575);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'a') ADVANCE(802);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'a') ADVANCE(579);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'a') ADVANCE(662);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'a') ADVANCE(678);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'a') ADVANCE(689);
      if (lookahead == 'r') ADVANCE(626);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'a') ADVANCE(580);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'a') ADVANCE(705);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'a') ADVANCE(830);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'a') ADVANCE(777);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'b') ADVANCE(276);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'b') ADVANCE(681);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'b') ADVANCE(690);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'c') ADVANCE(674);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'c') ADVANCE(328);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'c') ADVANCE(646);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'c') ADVANCE(649);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'c') ADVANCE(647);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'c') ADVANCE(563);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'c') ADVANCE(820);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'c') ADVANCE(609);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'c') ADVANCE(615);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 581:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'c') ADVANCE(829);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'c') ADVANCE(763);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'd') ADVANCE(350);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'd') ADVANCE(352);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'd') ADVANCE(344);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'd') ADVANCE(317);
      if (lookahead == 'y') ADVANCE(625);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'd') ADVANCE(305);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'd') ADVANCE(309);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'd') ADVANCE(600);
      if (lookahead == 'i') ADVANCE(754);
      if (lookahead == 'r') ADVANCE(621);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'd') ADVANCE(682);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'd') ADVANCE(594);
      if (lookahead == 'l') ADVANCE(666);
      if (lookahead == 'n') ADVANCE(845);
      if (lookahead == 's') ADVANCE(846);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'd') ADVANCE(594);
      if (lookahead == 'l') ADVANCE(667);
      if (lookahead == 'n') ADVANCE(845);
      if (lookahead == 's') ADVANCE(846);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'd') ADVANCE(594);
      if (lookahead == 'n') ADVANCE(845);
      if (lookahead == 's') ADVANCE(846);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'd') ADVANCE(801);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'd') ADVANCE(635);
      if (lookahead == 'o') ADVANCE(781);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(803);
      if (lookahead == 'h') ADVANCE(790);
      if (lookahead == 'r') ADVANCE(834);
      if (lookahead == 'y') ADVANCE(768);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(803);
      if (lookahead == 'h') ADVANCE(790);
      if (lookahead == 'r') ADVANCE(835);
      if (lookahead == 'y') ADVANCE(768);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(350);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(342);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(640);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(338);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(377);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(285);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(472);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(341);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(287);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(346);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(292);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(811);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(313);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 612:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(419);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(322);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(321);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(367);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(373);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(360);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(557);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(584);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(638);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 621:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(559);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(810);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 623:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(585);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(800);
      if (lookahead == 'f') ADVANCE(793);
      if (lookahead == 'o') ADVANCE(775);
      if (lookahead == 't') ADVANCE(848);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 625:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(800);
      if (lookahead == 'f') ADVANCE(793);
      if (lookahead == 'o') ADVANCE(775);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(824);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 627:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(795);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(555);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(732);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(733);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(784);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(785);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(797);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 634:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(581);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 635:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'e') ADVANCE(639);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'f') ADVANCE(375);
      if (lookahead == 'n') ADVANCE(683);
      if (lookahead == 's') ADVANCE(651);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(349);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 637:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'f') ADVANCE(684);
      if (lookahead == 'i') ADVANCE(729);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 638:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'f') ADVANCE(631);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'f') ADVANCE(632);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 640:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'f') ADVANCE(670);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 641:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'g') ADVANCE(350);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 642:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'g') ADVANCE(347);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'g') ADVANCE(348);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 644:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'g') ADVANCE(737);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 645:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'g') ADVANCE(722);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 646:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'h') ADVANCE(356);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 647:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'h') ADVANCE(421);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 648:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'h') ADVANCE(661);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 649:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'h') ADVANCE(553);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 650:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'h') ADVANCE(759);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 651:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'i') ADVANCE(849);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 652:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'i') ADVANCE(825);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 653:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'i') ADVANCE(716);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'i') ADVANCE(583);
      if (lookahead == 'l') ADVANCE(567);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 655:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'i') ADVANCE(583);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 656:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'i') ADVANCE(729);
      if (lookahead == 'l') ADVANCE(751);
      if (lookahead == 's') ADVANCE(650);
      if (lookahead == 'u') ADVANCE(657);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'i') ADVANCE(729);
      if (lookahead == 'l') ADVANCE(756);
      if (lookahead == 's') ADVANCE(650);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'i') ADVANCE(739);
      if (lookahead == 'r') ADVANCE(626);
      if (lookahead == 's') ADVANCE(833);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 659:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'i') ADVANCE(739);
      if (lookahead == 'r') ADVANCE(626);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 660:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'i') ADVANCE(734);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 661:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'i') ADVANCE(687);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 662:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'i') ADVANCE(821);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 663:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'i') ADVANCE(560);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 664:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'i') ADVANCE(738);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 665:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'i') ADVANCE(728);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 666:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'i') ADVANCE(645);
      if (lookahead == 'l') ADVANCE(744);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 667:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'i') ADVANCE(645);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 668:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'i') ADVANCE(704);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 669:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'i') ADVANCE(735);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 670:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'i') ADVANCE(736);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 671:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'i') ADVANCE(691);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 672:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'i') ADVANCE(764);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 673:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'k') ADVANCE(319);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 674:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'k') ADVANCE(619);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 675:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'k') ADVANCE(809);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 676:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'l') ADVANCE(350);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 677:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'l') ADVANCE(339);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 678:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'l') ADVANCE(290);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 679:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'l') ADVANCE(806);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 680:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'l') ADVANCE(677);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 681:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'l') ADVANCE(598);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 682:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'l') ADVANCE(753);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 683:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'l') ADVANCE(660);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 684:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'l') ADVANCE(755);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 685:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'l') ADVANCE(582);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 686:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'l') ADVANCE(667);
      if (lookahead == 'n') ADVANCE(845);
      if (lookahead == 's') ADVANCE(846);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 687:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'l') ADVANCE(602);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 688:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'l') ADVANCE(685);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 689:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'l') ADVANCE(663);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 690:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'l') ADVANCE(608);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 691:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'l') ADVANCE(617);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 692:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'l') ADVANCE(807);
      if (lookahead == 'n') ADVANCE(831);
      if (lookahead == 'r') ADVANCE(792);
      if (lookahead == 'x') ADVANCE(773);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 693:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'l') ADVANCE(807);
      if (lookahead == 'n') ADVANCE(831);
      if (lookahead == 'r') ADVANCE(792);
      if (lookahead == 'x') ADVANCE(815);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 694:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'l') ADVANCE(807);
      if (lookahead == 'n') ADVANCE(831);
      if (lookahead == 'r') ADVANCE(783);
      if (lookahead == 'x') ADVANCE(815);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 695:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'l') ADVANCE(669);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 696:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'l') ADVANCE(808);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 697:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'm') ADVANCE(474);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 698:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'm') ADVANCE(358);
      if (lookahead == 'y') ADVANCE(725);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 699:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'm') ADVANCE(767);
      if (lookahead == 'n') ADVANCE(804);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 700:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'm') ADVANCE(767);
      if (lookahead == 'n') ADVANCE(805);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 701:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'm') ADVANCE(767);
      if (lookahead == 'n') ADVANCE(828);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 702:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'm') ADVANCE(767);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 703:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'm') ADVANCE(605);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 704:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'm') ADVANCE(606);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 705:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'm') ADVANCE(622);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 706:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'm') ADVANCE(613);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 707:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(845);
      if (lookahead == 's') ADVANCE(698);
      if (lookahead == 'w') ADVANCE(562);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 708:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(845);
      if (lookahead == 's') ADVANCE(846);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 709:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(845);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 710:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(831);
      if (lookahead == 'r') ADVANCE(792);
      if (lookahead == 'x') ADVANCE(773);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 711:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(831);
      if (lookahead == 'r') ADVANCE(792);
      if (lookahead == 'x') ADVANCE(815);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 712:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(831);
      if (lookahead == 'r') ADVANCE(783);
      if (lookahead == 'x') ADVANCE(815);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 713:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(589);
      if (lookahead == 's') ADVANCE(651);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(349);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 714:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(589);
      if (lookahead == 's') ADVANCE(653);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(349);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 715:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(350);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 716:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(644);
      if (lookahead == 'z') ADVANCE(598);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(851);
      END_STATE();
    case 717:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(476);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 718:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(283);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 719:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(586);
      if (lookahead == 's') ADVANCE(698);
      if (lookahead == 'w') ADVANCE(562);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 720:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(586);
      if (lookahead == 's') ADVANCE(846);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 721:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(323);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 722:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(464);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 723:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(843);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 724:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(365);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 725:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(573);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 726:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(642);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 727:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(847);
      if (lookahead == 's') ADVANCE(846);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 728:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(675);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 729:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(816);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 730:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(643);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 731:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(641);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 732:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(587);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 733:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(588);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 734:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(603);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 735:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(607);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 736:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(623);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 737:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(566);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 738:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(840);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 739:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'n') ADVANCE(695);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 740:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(659);
      if (lookahead == 'u') ADVANCE(680);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 741:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(787);
      if (lookahead == 'u') ADVANCE(680);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 742:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(658);
      if (lookahead == 'u') ADVANCE(680);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 743:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(564);
      if (lookahead == 'u') ADVANCE(680);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 744:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(844);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 745:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(462);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 746:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(749);
      if (lookahead == 'r') ADVANCE(628);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 747:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(749);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 748:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(654);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 749:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(676);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 750:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(655);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 751:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(726);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 752:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(841);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 753:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(577);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 754:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(717);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 755:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(556);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 756:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(730);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 757:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(781);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 758:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(794);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 759:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(791);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 760:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(731);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 761:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(778);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 762:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(788);
      if (lookahead == 'u') ADVANCE(680);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 763:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(723);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 764:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'o') ADVANCE(724);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 765:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'p') ADVANCE(552);
      if (lookahead == 'r') ADVANCE(315);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 766:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'p') ADVANCE(552);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 767:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'p') ADVANCE(826);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 768:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'p') ADVANCE(598);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 769:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'p') ADVANCE(629);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 770:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'p') ADVANCE(630);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 771:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'p') ADVANCE(616);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 772:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'p') ADVANCE(561);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 773:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'p') ADVANCE(758);
      if (lookahead == 't') ADVANCE(627);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 774:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'p') ADVANCE(565);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 775:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'p') ADVANCE(568);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 776:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'q') ADVANCE(838);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 777:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'q') ADVANCE(836);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 778:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'r') ADVANCE(350);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 779:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'r') ADVANCE(379);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 780:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'r') ADVANCE(300);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 781:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'r') ADVANCE(336);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 782:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'r') ADVANCE(834);
      if (lookahead == 'y') ADVANCE(768);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 783:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'r') ADVANCE(595);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 784:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'r') ADVANCE(307);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 785:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'r') ADVANCE(311);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 786:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'r') ADVANCE(835);
      if (lookahead == 'y') ADVANCE(768);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 787:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'r') ADVANCE(626);
      if (lookahead == 's') ADVANCE(833);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 788:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'r') ADVANCE(626);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 789:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'r') ADVANCE(832);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 790:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'r') ADVANCE(618);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 791:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'r') ADVANCE(816);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 792:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'r') ADVANCE(757);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 793:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'r') ADVANCE(554);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 794:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'r') ADVANCE(819);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 795:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'r') ADVANCE(718);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 796:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'r') ADVANCE(715);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 797:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'r') ADVANCE(745);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 798:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'r') ADVANCE(721);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 799:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'r') ADVANCE(761);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 800:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'r') ADVANCE(799);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 801:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'r') ADVANCE(814);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 802:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 's') ADVANCE(370);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 803:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 's') ADVANCE(817);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 804:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 's') ADVANCE(818);
      if (lookahead == 't') ADVANCE(664);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 805:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 's') ADVANCE(818);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 806:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 's') ADVANCE(601);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 807:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 's') ADVANCE(611);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 808:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 's') ADVANCE(612);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 809:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 's') ADVANCE(634);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 810:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 's') ADVANCE(772);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 811:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 's') ADVANCE(842);
      if (lookahead == 't') ADVANCE(839);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 812:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 's') ADVANCE(769);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 813:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 's') ADVANCE(770);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 814:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 's') ADVANCE(774);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 815:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 't') ADVANCE(627);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 816:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 't') ADVANCE(350);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 817:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 't') ADVANCE(277);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 818:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 't') ADVANCE(298);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 819:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 't') ADVANCE(281);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 820:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 't') ADVANCE(470);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 821:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 't') ADVANCE(459);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 822:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 't') ADVANCE(789);
      if (lookahead == 'u') ADVANCE(813);
      if (lookahead == 'w') ADVANCE(652);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 823:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 't') ADVANCE(789);
      if (lookahead == 'w') ADVANCE(652);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 824:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 't') ADVANCE(837);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 825:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 't') ADVANCE(574);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 826:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 't') ADVANCE(668);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 827:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 't') ADVANCE(576);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 828:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 't') ADVANCE(664);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 829:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 't') ADVANCE(672);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 830:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 't') ADVANCE(671);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 831:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'u') ADVANCE(697);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 832:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'u') ADVANCE(578);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 833:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'u') ADVANCE(812);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 834:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'u') ADVANCE(599);
      if (lookahead == 'y') ADVANCE(457);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 835:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'u') ADVANCE(599);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 836:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'u') ADVANCE(598);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 837:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'u') ADVANCE(796);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 838:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'u') ADVANCE(604);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 839:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'u') ADVANCE(798);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 840:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'u') ADVANCE(614);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 841:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'u') ADVANCE(570);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 842:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'u') ADVANCE(706);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 843:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'v') ADVANCE(369);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 844:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'w') ADVANCE(850);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 845:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'y') ADVANCE(625);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 846:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'y') ADVANCE(725);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 847:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'y') ADVANCE(624);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 848:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'y') ADVANCE(771);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 849:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'z') ADVANCE(598);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(851);
      END_STATE();
    case 850:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (lookahead == 'z') ADVANCE(633);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(851);
      END_STATE();
    case 851:
      ACCEPT_TOKEN(aux_sym_IDENTIFIER_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(851);
      END_STATE();
    case 852:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 272},
  [2] = {.lex_state = 264},
  [3] = {.lex_state = 264},
  [4] = {.lex_state = 264},
  [5] = {.lex_state = 1},
  [6] = {.lex_state = 1},
  [7] = {.lex_state = 1},
  [8] = {.lex_state = 266},
  [9] = {.lex_state = 265},
  [10] = {.lex_state = 266},
  [11] = {.lex_state = 266},
  [12] = {.lex_state = 265},
  [13] = {.lex_state = 265},
  [14] = {.lex_state = 5},
  [15] = {.lex_state = 6},
  [16] = {.lex_state = 5},
  [17] = {.lex_state = 5},
  [18] = {.lex_state = 6},
  [19] = {.lex_state = 6},
  [20] = {.lex_state = 11},
  [21] = {.lex_state = 11},
  [22] = {.lex_state = 11},
  [23] = {.lex_state = 11},
  [24] = {.lex_state = 11},
  [25] = {.lex_state = 11},
  [26] = {.lex_state = 11},
  [27] = {.lex_state = 11},
  [28] = {.lex_state = 11},
  [29] = {.lex_state = 11},
  [30] = {.lex_state = 11},
  [31] = {.lex_state = 11},
  [32] = {.lex_state = 11},
  [33] = {.lex_state = 11},
  [34] = {.lex_state = 11},
  [35] = {.lex_state = 11},
  [36] = {.lex_state = 11},
  [37] = {.lex_state = 11},
  [38] = {.lex_state = 11},
  [39] = {.lex_state = 11},
  [40] = {.lex_state = 11},
  [41] = {.lex_state = 3},
  [42] = {.lex_state = 3},
  [43] = {.lex_state = 3},
  [44] = {.lex_state = 264},
  [45] = {.lex_state = 2},
  [46] = {.lex_state = 13},
  [47] = {.lex_state = 2},
  [48] = {.lex_state = 264},
  [49] = {.lex_state = 264},
  [50] = {.lex_state = 264},
  [51] = {.lex_state = 2},
  [52] = {.lex_state = 2},
  [53] = {.lex_state = 2},
  [54] = {.lex_state = 2},
  [55] = {.lex_state = 264},
  [56] = {.lex_state = 2},
  [57] = {.lex_state = 2},
  [58] = {.lex_state = 2},
  [59] = {.lex_state = 14},
  [60] = {.lex_state = 14},
  [61] = {.lex_state = 3},
  [62] = {.lex_state = 1},
  [63] = {.lex_state = 14},
  [64] = {.lex_state = 1},
  [65] = {.lex_state = 1},
  [66] = {.lex_state = 14},
  [67] = {.lex_state = 14},
  [68] = {.lex_state = 14},
  [69] = {.lex_state = 14},
  [70] = {.lex_state = 14},
  [71] = {.lex_state = 14},
  [72] = {.lex_state = 14},
  [73] = {.lex_state = 1},
  [74] = {.lex_state = 14},
  [75] = {.lex_state = 1},
  [76] = {.lex_state = 14},
  [77] = {.lex_state = 14},
  [78] = {.lex_state = 14},
  [79] = {.lex_state = 14},
  [80] = {.lex_state = 14},
  [81] = {.lex_state = 14},
  [82] = {.lex_state = 14},
  [83] = {.lex_state = 10},
  [84] = {.lex_state = 14},
  [85] = {.lex_state = 14},
  [86] = {.lex_state = 14},
  [87] = {.lex_state = 2},
  [88] = {.lex_state = 2},
  [89] = {.lex_state = 14},
  [90] = {.lex_state = 10},
  [91] = {.lex_state = 10},
  [92] = {.lex_state = 14},
  [93] = {.lex_state = 10},
  [94] = {.lex_state = 10},
  [95] = {.lex_state = 10},
  [96] = {.lex_state = 10},
  [97] = {.lex_state = 10},
  [98] = {.lex_state = 10},
  [99] = {.lex_state = 10},
  [100] = {.lex_state = 10},
  [101] = {.lex_state = 10},
  [102] = {.lex_state = 10},
  [103] = {.lex_state = 10},
  [104] = {.lex_state = 10},
  [105] = {.lex_state = 10},
  [106] = {.lex_state = 10},
  [107] = {.lex_state = 10},
  [108] = {.lex_state = 10},
  [109] = {.lex_state = 10},
  [110] = {.lex_state = 10},
  [111] = {.lex_state = 10},
  [112] = {.lex_state = 10},
  [113] = {.lex_state = 10},
  [114] = {.lex_state = 10},
  [115] = {.lex_state = 10},
  [116] = {.lex_state = 10},
  [117] = {.lex_state = 10},
  [118] = {.lex_state = 10},
  [119] = {.lex_state = 10},
  [120] = {.lex_state = 10},
  [121] = {.lex_state = 10},
  [122] = {.lex_state = 10},
  [123] = {.lex_state = 10},
  [124] = {.lex_state = 10},
  [125] = {.lex_state = 10},
  [126] = {.lex_state = 10},
  [127] = {.lex_state = 10},
  [128] = {.lex_state = 10},
  [129] = {.lex_state = 10},
  [130] = {.lex_state = 10},
  [131] = {.lex_state = 10},
  [132] = {.lex_state = 10},
  [133] = {.lex_state = 10},
  [134] = {.lex_state = 10},
  [135] = {.lex_state = 10},
  [136] = {.lex_state = 10},
  [137] = {.lex_state = 10},
  [138] = {.lex_state = 10},
  [139] = {.lex_state = 10},
  [140] = {.lex_state = 10},
  [141] = {.lex_state = 10},
  [142] = {.lex_state = 10},
  [143] = {.lex_state = 10},
  [144] = {.lex_state = 10},
  [145] = {.lex_state = 10},
  [146] = {.lex_state = 10},
  [147] = {.lex_state = 10},
  [148] = {.lex_state = 10},
  [149] = {.lex_state = 10},
  [150] = {.lex_state = 10},
  [151] = {.lex_state = 10},
  [152] = {.lex_state = 10},
  [153] = {.lex_state = 10},
  [154] = {.lex_state = 10},
  [155] = {.lex_state = 10},
  [156] = {.lex_state = 10},
  [157] = {.lex_state = 10},
  [158] = {.lex_state = 10},
  [159] = {.lex_state = 10},
  [160] = {.lex_state = 10},
  [161] = {.lex_state = 10},
  [162] = {.lex_state = 10},
  [163] = {.lex_state = 10},
  [164] = {.lex_state = 10},
  [165] = {.lex_state = 10},
  [166] = {.lex_state = 10},
  [167] = {.lex_state = 10},
  [168] = {.lex_state = 10},
  [169] = {.lex_state = 10},
  [170] = {.lex_state = 10},
  [171] = {.lex_state = 10},
  [172] = {.lex_state = 10},
  [173] = {.lex_state = 10},
  [174] = {.lex_state = 10},
  [175] = {.lex_state = 10},
  [176] = {.lex_state = 10},
  [177] = {.lex_state = 10},
  [178] = {.lex_state = 10},
  [179] = {.lex_state = 10},
  [180] = {.lex_state = 10},
  [181] = {.lex_state = 10},
  [182] = {.lex_state = 10},
  [183] = {.lex_state = 10},
  [184] = {.lex_state = 10},
  [185] = {.lex_state = 10},
  [186] = {.lex_state = 10},
  [187] = {.lex_state = 10},
  [188] = {.lex_state = 10},
  [189] = {.lex_state = 10},
  [190] = {.lex_state = 10},
  [191] = {.lex_state = 10},
  [192] = {.lex_state = 10},
  [193] = {.lex_state = 10},
  [194] = {.lex_state = 10},
  [195] = {.lex_state = 10},
  [196] = {.lex_state = 10},
  [197] = {.lex_state = 10},
  [198] = {.lex_state = 10},
  [199] = {.lex_state = 10},
  [200] = {.lex_state = 10},
  [201] = {.lex_state = 10},
  [202] = {.lex_state = 10},
  [203] = {.lex_state = 10},
  [204] = {.lex_state = 10},
  [205] = {.lex_state = 10},
  [206] = {.lex_state = 10},
  [207] = {.lex_state = 10},
  [208] = {.lex_state = 10},
  [209] = {.lex_state = 10},
  [210] = {.lex_state = 10},
  [211] = {.lex_state = 10},
  [212] = {.lex_state = 10},
  [213] = {.lex_state = 10},
  [214] = {.lex_state = 10},
  [215] = {.lex_state = 10},
  [216] = {.lex_state = 10},
  [217] = {.lex_state = 10},
  [218] = {.lex_state = 10},
  [219] = {.lex_state = 10},
  [220] = {.lex_state = 10},
  [221] = {.lex_state = 10},
  [222] = {.lex_state = 10},
  [223] = {.lex_state = 10},
  [224] = {.lex_state = 10},
  [225] = {.lex_state = 10},
  [226] = {.lex_state = 10},
  [227] = {.lex_state = 10},
  [228] = {.lex_state = 10},
  [229] = {.lex_state = 10},
  [230] = {.lex_state = 10},
  [231] = {.lex_state = 10},
  [232] = {.lex_state = 10},
  [233] = {.lex_state = 10},
  [234] = {.lex_state = 10},
  [235] = {.lex_state = 10},
  [236] = {.lex_state = 10},
  [237] = {.lex_state = 10},
  [238] = {.lex_state = 10},
  [239] = {.lex_state = 10},
  [240] = {.lex_state = 10},
  [241] = {.lex_state = 10},
  [242] = {.lex_state = 10},
  [243] = {.lex_state = 10},
  [244] = {.lex_state = 10},
  [245] = {.lex_state = 10},
  [246] = {.lex_state = 10},
  [247] = {.lex_state = 10},
  [248] = {.lex_state = 10},
  [249] = {.lex_state = 10},
  [250] = {.lex_state = 10},
  [251] = {.lex_state = 10},
  [252] = {.lex_state = 10},
  [253] = {.lex_state = 10},
  [254] = {.lex_state = 10},
  [255] = {.lex_state = 10},
  [256] = {.lex_state = 10},
  [257] = {.lex_state = 10},
  [258] = {.lex_state = 10},
  [259] = {.lex_state = 10},
  [260] = {.lex_state = 10},
  [261] = {.lex_state = 10},
  [262] = {.lex_state = 10},
  [263] = {.lex_state = 10},
  [264] = {.lex_state = 10},
  [265] = {.lex_state = 10},
  [266] = {.lex_state = 10},
  [267] = {.lex_state = 10},
  [268] = {.lex_state = 10},
  [269] = {.lex_state = 10},
  [270] = {.lex_state = 10},
  [271] = {.lex_state = 10},
  [272] = {.lex_state = 10},
  [273] = {.lex_state = 10},
  [274] = {.lex_state = 10},
  [275] = {.lex_state = 10},
  [276] = {.lex_state = 10},
  [277] = {.lex_state = 10},
  [278] = {.lex_state = 10},
  [279] = {.lex_state = 10},
  [280] = {.lex_state = 10},
  [281] = {.lex_state = 10},
  [282] = {.lex_state = 10},
  [283] = {.lex_state = 10},
  [284] = {.lex_state = 10},
  [285] = {.lex_state = 10},
  [286] = {.lex_state = 10},
  [287] = {.lex_state = 10},
  [288] = {.lex_state = 10},
  [289] = {.lex_state = 10},
  [290] = {.lex_state = 10},
  [291] = {.lex_state = 10},
  [292] = {.lex_state = 10},
  [293] = {.lex_state = 10},
  [294] = {.lex_state = 10},
  [295] = {.lex_state = 10},
  [296] = {.lex_state = 10},
  [297] = {.lex_state = 10},
  [298] = {.lex_state = 10},
  [299] = {.lex_state = 10},
  [300] = {.lex_state = 10},
  [301] = {.lex_state = 10},
  [302] = {.lex_state = 10},
  [303] = {.lex_state = 10},
  [304] = {.lex_state = 10},
  [305] = {.lex_state = 10},
  [306] = {.lex_state = 10},
  [307] = {.lex_state = 10},
  [308] = {.lex_state = 10},
  [309] = {.lex_state = 10},
  [310] = {.lex_state = 10},
  [311] = {.lex_state = 10},
  [312] = {.lex_state = 10},
  [313] = {.lex_state = 10},
  [314] = {.lex_state = 10},
  [315] = {.lex_state = 10},
  [316] = {.lex_state = 10},
  [317] = {.lex_state = 10},
  [318] = {.lex_state = 10},
  [319] = {.lex_state = 10},
  [320] = {.lex_state = 10},
  [321] = {.lex_state = 10},
  [322] = {.lex_state = 10},
  [323] = {.lex_state = 10},
  [324] = {.lex_state = 10},
  [325] = {.lex_state = 10},
  [326] = {.lex_state = 10},
  [327] = {.lex_state = 10},
  [328] = {.lex_state = 10},
  [329] = {.lex_state = 10},
  [330] = {.lex_state = 10},
  [331] = {.lex_state = 10},
  [332] = {.lex_state = 10},
  [333] = {.lex_state = 10},
  [334] = {.lex_state = 10},
  [335] = {.lex_state = 10},
  [336] = {.lex_state = 10},
  [337] = {.lex_state = 10},
  [338] = {.lex_state = 272},
  [339] = {.lex_state = 272},
  [340] = {.lex_state = 272},
  [341] = {.lex_state = 272},
  [342] = {.lex_state = 272},
  [343] = {.lex_state = 266},
  [344] = {.lex_state = 266},
  [345] = {.lex_state = 266},
  [346] = {.lex_state = 266},
  [347] = {.lex_state = 271},
  [348] = {.lex_state = 266},
  [349] = {.lex_state = 272},
  [350] = {.lex_state = 271},
  [351] = {.lex_state = 271},
  [352] = {.lex_state = 271},
  [353] = {.lex_state = 271},
  [354] = {.lex_state = 271},
  [355] = {.lex_state = 271},
  [356] = {.lex_state = 271},
  [357] = {.lex_state = 271},
  [358] = {.lex_state = 271},
  [359] = {.lex_state = 271},
  [360] = {.lex_state = 271},
  [361] = {.lex_state = 271},
  [362] = {.lex_state = 271},
  [363] = {.lex_state = 271},
  [364] = {.lex_state = 265},
  [365] = {.lex_state = 265},
  [366] = {.lex_state = 271},
  [367] = {.lex_state = 271},
  [368] = {.lex_state = 271},
  [369] = {.lex_state = 265},
  [370] = {.lex_state = 271},
  [371] = {.lex_state = 271},
  [372] = {.lex_state = 265},
  [373] = {.lex_state = 265},
  [374] = {.lex_state = 271},
  [375] = {.lex_state = 271},
  [376] = {.lex_state = 268},
  [377] = {.lex_state = 268},
  [378] = {.lex_state = 267},
  [379] = {.lex_state = 268},
  [380] = {.lex_state = 267},
  [381] = {.lex_state = 268},
  [382] = {.lex_state = 268},
  [383] = {.lex_state = 268},
  [384] = {.lex_state = 268},
  [385] = {.lex_state = 268},
  [386] = {.lex_state = 268},
  [387] = {.lex_state = 267},
  [388] = {.lex_state = 267},
  [389] = {.lex_state = 267},
  [390] = {.lex_state = 267},
  [391] = {.lex_state = 267},
  [392] = {.lex_state = 267},
  [393] = {.lex_state = 267},
  [394] = {.lex_state = 268},
  [395] = {.lex_state = 268},
  [396] = {.lex_state = 268},
  [397] = {.lex_state = 268},
  [398] = {.lex_state = 268},
  [399] = {.lex_state = 268},
  [400] = {.lex_state = 268},
  [401] = {.lex_state = 268},
  [402] = {.lex_state = 268},
  [403] = {.lex_state = 268},
  [404] = {.lex_state = 268},
  [405] = {.lex_state = 268},
  [406] = {.lex_state = 268},
  [407] = {.lex_state = 268},
  [408] = {.lex_state = 268},
  [409] = {.lex_state = 268},
  [410] = {.lex_state = 268},
  [411] = {.lex_state = 268},
  [412] = {.lex_state = 268},
  [413] = {.lex_state = 268},
  [414] = {.lex_state = 268},
  [415] = {.lex_state = 267},
  [416] = {.lex_state = 268},
  [417] = {.lex_state = 268},
  [418] = {.lex_state = 268},
  [419] = {.lex_state = 268},
  [420] = {.lex_state = 268},
  [421] = {.lex_state = 268},
  [422] = {.lex_state = 268},
  [423] = {.lex_state = 268},
  [424] = {.lex_state = 268},
  [425] = {.lex_state = 268},
  [426] = {.lex_state = 268},
  [427] = {.lex_state = 268},
  [428] = {.lex_state = 268},
  [429] = {.lex_state = 268},
  [430] = {.lex_state = 268},
  [431] = {.lex_state = 268},
  [432] = {.lex_state = 268},
  [433] = {.lex_state = 267},
  [434] = {.lex_state = 267},
  [435] = {.lex_state = 267},
  [436] = {.lex_state = 267},
  [437] = {.lex_state = 267},
  [438] = {.lex_state = 267},
  [439] = {.lex_state = 267},
  [440] = {.lex_state = 267},
  [441] = {.lex_state = 267},
  [442] = {.lex_state = 267},
  [443] = {.lex_state = 267},
  [444] = {.lex_state = 267},
  [445] = {.lex_state = 267},
  [446] = {.lex_state = 267},
  [447] = {.lex_state = 267},
  [448] = {.lex_state = 267},
  [449] = {.lex_state = 267},
  [450] = {.lex_state = 267},
  [451] = {.lex_state = 267},
  [452] = {.lex_state = 267},
  [453] = {.lex_state = 267},
  [454] = {.lex_state = 267},
  [455] = {.lex_state = 267},
  [456] = {.lex_state = 267},
  [457] = {.lex_state = 267},
  [458] = {.lex_state = 267},
  [459] = {.lex_state = 267},
  [460] = {.lex_state = 267},
  [461] = {.lex_state = 267},
  [462] = {.lex_state = 267},
  [463] = {.lex_state = 267},
  [464] = {.lex_state = 268},
  [465] = {.lex_state = 268},
  [466] = {.lex_state = 267},
  [467] = {.lex_state = 268},
  [468] = {.lex_state = 268},
  [469] = {.lex_state = 268},
  [470] = {.lex_state = 268},
  [471] = {.lex_state = 268},
  [472] = {.lex_state = 268},
  [473] = {.lex_state = 268},
  [474] = {.lex_state = 268},
  [475] = {.lex_state = 268},
  [476] = {.lex_state = 268},
  [477] = {.lex_state = 268},
  [478] = {.lex_state = 268},
  [479] = {.lex_state = 267},
  [480] = {.lex_state = 268},
  [481] = {.lex_state = 268},
  [482] = {.lex_state = 268},
  [483] = {.lex_state = 268},
  [484] = {.lex_state = 268},
  [485] = {.lex_state = 268},
  [486] = {.lex_state = 268},
  [487] = {.lex_state = 268},
  [488] = {.lex_state = 268},
  [489] = {.lex_state = 268},
  [490] = {.lex_state = 268},
  [491] = {.lex_state = 268},
  [492] = {.lex_state = 268},
  [493] = {.lex_state = 268},
  [494] = {.lex_state = 268},
  [495] = {.lex_state = 267},
  [496] = {.lex_state = 267},
  [497] = {.lex_state = 268},
  [498] = {.lex_state = 268},
  [499] = {.lex_state = 268},
  [500] = {.lex_state = 268},
  [501] = {.lex_state = 267},
  [502] = {.lex_state = 268},
  [503] = {.lex_state = 267},
  [504] = {.lex_state = 268},
  [505] = {.lex_state = 268},
  [506] = {.lex_state = 268},
  [507] = {.lex_state = 268},
  [508] = {.lex_state = 268},
  [509] = {.lex_state = 267},
  [510] = {.lex_state = 268},
  [511] = {.lex_state = 268},
  [512] = {.lex_state = 268},
  [513] = {.lex_state = 268},
  [514] = {.lex_state = 268},
  [515] = {.lex_state = 268},
  [516] = {.lex_state = 268},
  [517] = {.lex_state = 268},
  [518] = {.lex_state = 268},
  [519] = {.lex_state = 268},
  [520] = {.lex_state = 268},
  [521] = {.lex_state = 267},
  [522] = {.lex_state = 268},
  [523] = {.lex_state = 268},
  [524] = {.lex_state = 268},
  [525] = {.lex_state = 268},
  [526] = {.lex_state = 268},
  [527] = {.lex_state = 268},
  [528] = {.lex_state = 268},
  [529] = {.lex_state = 268},
  [530] = {.lex_state = 268},
  [531] = {.lex_state = 268},
  [532] = {.lex_state = 268},
  [533] = {.lex_state = 268},
  [534] = {.lex_state = 268},
  [535] = {.lex_state = 268},
  [536] = {.lex_state = 268},
  [537] = {.lex_state = 268},
  [538] = {.lex_state = 268},
  [539] = {.lex_state = 268},
  [540] = {.lex_state = 268},
  [541] = {.lex_state = 268},
  [542] = {.lex_state = 268},
  [543] = {.lex_state = 267},
  [544] = {.lex_state = 268},
  [545] = {.lex_state = 268},
  [546] = {.lex_state = 267},
  [547] = {.lex_state = 267},
  [548] = {.lex_state = 267},
  [549] = {.lex_state = 22},
  [550] = {.lex_state = 267},
  [551] = {.lex_state = 267},
  [552] = {.lex_state = 267},
  [553] = {.lex_state = 267},
  [554] = {.lex_state = 267},
  [555] = {.lex_state = 267},
  [556] = {.lex_state = 267},
  [557] = {.lex_state = 267},
  [558] = {.lex_state = 267},
  [559] = {.lex_state = 267},
  [560] = {.lex_state = 267},
  [561] = {.lex_state = 267},
  [562] = {.lex_state = 267},
  [563] = {.lex_state = 267},
  [564] = {.lex_state = 267},
  [565] = {.lex_state = 267},
  [566] = {.lex_state = 267},
  [567] = {.lex_state = 267},
  [568] = {.lex_state = 267},
  [569] = {.lex_state = 267},
  [570] = {.lex_state = 267},
  [571] = {.lex_state = 267},
  [572] = {.lex_state = 267},
  [573] = {.lex_state = 267},
  [574] = {.lex_state = 267},
  [575] = {.lex_state = 267},
  [576] = {.lex_state = 267},
  [577] = {.lex_state = 267},
  [578] = {.lex_state = 267},
  [579] = {.lex_state = 267},
  [580] = {.lex_state = 267},
  [581] = {.lex_state = 267},
  [582] = {.lex_state = 267},
  [583] = {.lex_state = 267},
  [584] = {.lex_state = 267},
  [585] = {.lex_state = 267},
  [586] = {.lex_state = 267},
  [587] = {.lex_state = 267},
  [588] = {.lex_state = 267},
  [589] = {.lex_state = 267},
  [590] = {.lex_state = 267},
  [591] = {.lex_state = 267},
  [592] = {.lex_state = 267},
  [593] = {.lex_state = 267},
  [594] = {.lex_state = 267},
  [595] = {.lex_state = 267},
  [596] = {.lex_state = 267},
  [597] = {.lex_state = 267},
  [598] = {.lex_state = 267},
  [599] = {.lex_state = 267},
  [600] = {.lex_state = 267},
  [601] = {.lex_state = 267},
  [602] = {.lex_state = 267},
  [603] = {.lex_state = 267},
  [604] = {.lex_state = 267},
  [605] = {.lex_state = 267},
  [606] = {.lex_state = 267},
  [607] = {.lex_state = 267},
  [608] = {.lex_state = 267},
  [609] = {.lex_state = 267},
  [610] = {.lex_state = 267},
  [611] = {.lex_state = 267},
  [612] = {.lex_state = 267},
  [613] = {.lex_state = 267},
  [614] = {.lex_state = 267},
  [615] = {.lex_state = 267},
  [616] = {.lex_state = 267},
  [617] = {.lex_state = 267},
  [618] = {.lex_state = 267},
  [619] = {.lex_state = 267},
  [620] = {.lex_state = 267},
  [621] = {.lex_state = 5},
  [622] = {.lex_state = 5},
  [623] = {.lex_state = 5},
  [624] = {.lex_state = 15},
  [625] = {.lex_state = 15},
  [626] = {.lex_state = 15},
  [627] = {.lex_state = 15},
  [628] = {.lex_state = 15},
  [629] = {.lex_state = 15},
  [630] = {.lex_state = 15},
  [631] = {.lex_state = 15},
  [632] = {.lex_state = 5},
  [633] = {.lex_state = 268},
  [634] = {.lex_state = 15},
  [635] = {.lex_state = 15},
  [636] = {.lex_state = 268},
  [637] = {.lex_state = 15},
  [638] = {.lex_state = 15},
  [639] = {.lex_state = 5},
  [640] = {.lex_state = 6},
  [641] = {.lex_state = 6},
  [642] = {.lex_state = 6},
  [643] = {.lex_state = 267},
  [644] = {.lex_state = 6},
  [645] = {.lex_state = 6},
  [646] = {.lex_state = 267},
  [647] = {.lex_state = 19},
  [648] = {.lex_state = 19},
  [649] = {.lex_state = 268},
  [650] = {.lex_state = 19},
  [651] = {.lex_state = 268},
  [652] = {.lex_state = 268},
  [653] = {.lex_state = 268},
  [654] = {.lex_state = 19},
  [655] = {.lex_state = 268},
  [656] = {.lex_state = 19},
  [657] = {.lex_state = 20},
  [658] = {.lex_state = 268},
  [659] = {.lex_state = 268},
  [660] = {.lex_state = 19},
  [661] = {.lex_state = 19},
  [662] = {.lex_state = 19},
  [663] = {.lex_state = 19},
  [664] = {.lex_state = 19},
  [665] = {.lex_state = 268},
  [666] = {.lex_state = 20},
  [667] = {.lex_state = 19},
  [668] = {.lex_state = 20},
  [669] = {.lex_state = 19},
  [670] = {.lex_state = 268},
  [671] = {.lex_state = 268},
  [672] = {.lex_state = 268},
  [673] = {.lex_state = 267},
  [674] = {.lex_state = 267},
  [675] = {.lex_state = 267},
  [676] = {.lex_state = 267},
  [677] = {.lex_state = 267},
  [678] = {.lex_state = 267},
  [679] = {.lex_state = 267},
  [680] = {.lex_state = 267},
  [681] = {.lex_state = 20},
  [682] = {.lex_state = 267},
  [683] = {.lex_state = 267},
  [684] = {.lex_state = 267},
  [685] = {.lex_state = 17},
  [686] = {.lex_state = 17},
  [687] = {.lex_state = 17},
  [688] = {.lex_state = 17},
  [689] = {.lex_state = 17},
  [690] = {.lex_state = 17},
  [691] = {.lex_state = 17},
  [692] = {.lex_state = 17},
  [693] = {.lex_state = 17},
  [694] = {.lex_state = 17},
  [695] = {.lex_state = 17},
  [696] = {.lex_state = 17},
  [697] = {.lex_state = 17},
  [698] = {.lex_state = 17},
  [699] = {.lex_state = 17},
  [700] = {.lex_state = 17},
  [701] = {.lex_state = 17},
  [702] = {.lex_state = 17},
  [703] = {.lex_state = 17},
  [704] = {.lex_state = 17},
  [705] = {.lex_state = 17},
  [706] = {.lex_state = 17},
  [707] = {.lex_state = 17},
  [708] = {.lex_state = 17},
  [709] = {.lex_state = 18},
  [710] = {.lex_state = 18},
  [711] = {.lex_state = 18},
  [712] = {.lex_state = 18},
  [713] = {.lex_state = 18},
  [714] = {.lex_state = 18},
  [715] = {.lex_state = 18},
  [716] = {.lex_state = 18},
  [717] = {.lex_state = 18},
  [718] = {.lex_state = 18},
  [719] = {.lex_state = 18},
  [720] = {.lex_state = 18},
  [721] = {.lex_state = 18},
  [722] = {.lex_state = 18},
  [723] = {.lex_state = 18},
  [724] = {.lex_state = 18},
  [725] = {.lex_state = 18},
  [726] = {.lex_state = 18},
  [727] = {.lex_state = 24},
  [728] = {.lex_state = 18},
  [729] = {.lex_state = 18},
  [730] = {.lex_state = 18},
  [731] = {.lex_state = 18},
  [732] = {.lex_state = 18},
  [733] = {.lex_state = 24},
  [734] = {.lex_state = 25},
  [735] = {.lex_state = 18},
  [736] = {.lex_state = 18},
  [737] = {.lex_state = 18},
  [738] = {.lex_state = 18},
  [739] = {.lex_state = 18},
  [740] = {.lex_state = 24},
  [741] = {.lex_state = 18},
  [742] = {.lex_state = 18},
  [743] = {.lex_state = 18},
  [744] = {.lex_state = 18},
  [745] = {.lex_state = 18},
  [746] = {.lex_state = 18},
  [747] = {.lex_state = 18},
  [748] = {.lex_state = 18},
  [749] = {.lex_state = 24},
  [750] = {.lex_state = 16},
  [751] = {.lex_state = 24},
  [752] = {.lex_state = 24},
  [753] = {.lex_state = 16},
  [754] = {.lex_state = 16},
  [755] = {.lex_state = 16},
  [756] = {.lex_state = 24},
  [757] = {.lex_state = 16},
  [758] = {.lex_state = 24},
  [759] = {.lex_state = 16},
  [760] = {.lex_state = 24},
  [761] = {.lex_state = 16},
  [762] = {.lex_state = 24},
  [763] = {.lex_state = 16},
  [764] = {.lex_state = 16},
  [765] = {.lex_state = 16},
  [766] = {.lex_state = 16},
  [767] = {.lex_state = 16},
  [768] = {.lex_state = 16},
  [769] = {.lex_state = 16},
  [770] = {.lex_state = 16},
  [771] = {.lex_state = 16},
  [772] = {.lex_state = 16},
  [773] = {.lex_state = 16},
  [774] = {.lex_state = 16},
  [775] = {.lex_state = 16},
  [776] = {.lex_state = 16},
  [777] = {.lex_state = 16},
  [778] = {.lex_state = 16},
  [779] = {.lex_state = 16},
  [780] = {.lex_state = 16},
  [781] = {.lex_state = 16},
  [782] = {.lex_state = 16},
  [783] = {.lex_state = 16},
  [784] = {.lex_state = 16},
  [785] = {.lex_state = 16},
  [786] = {.lex_state = 16},
  [787] = {.lex_state = 16},
  [788] = {.lex_state = 16},
  [789] = {.lex_state = 16},
  [790] = {.lex_state = 16},
  [791] = {.lex_state = 16},
  [792] = {.lex_state = 16},
  [793] = {.lex_state = 16},
  [794] = {.lex_state = 16},
  [795] = {.lex_state = 16},
  [796] = {.lex_state = 16},
  [797] = {.lex_state = 16},
  [798] = {.lex_state = 16},
  [799] = {.lex_state = 16},
  [800] = {.lex_state = 16},
  [801] = {.lex_state = 16},
  [802] = {.lex_state = 16},
  [803] = {.lex_state = 16},
  [804] = {.lex_state = 16},
  [805] = {.lex_state = 16},
  [806] = {.lex_state = 16},
  [807] = {.lex_state = 16},
  [808] = {.lex_state = 16},
  [809] = {.lex_state = 16},
  [810] = {.lex_state = 16},
  [811] = {.lex_state = 16},
  [812] = {.lex_state = 16},
  [813] = {.lex_state = 16},
  [814] = {.lex_state = 16},
  [815] = {.lex_state = 16},
  [816] = {.lex_state = 16},
  [817] = {.lex_state = 16},
  [818] = {.lex_state = 16},
  [819] = {.lex_state = 16},
  [820] = {.lex_state = 16},
  [821] = {.lex_state = 16},
  [822] = {.lex_state = 16},
  [823] = {.lex_state = 16},
  [824] = {.lex_state = 16},
  [825] = {.lex_state = 16},
  [826] = {.lex_state = 16},
  [827] = {.lex_state = 16},
  [828] = {.lex_state = 16},
  [829] = {.lex_state = 16},
  [830] = {.lex_state = 16},
  [831] = {.lex_state = 16},
  [832] = {.lex_state = 16},
  [833] = {.lex_state = 16},
  [834] = {.lex_state = 16},
  [835] = {.lex_state = 16},
  [836] = {.lex_state = 16},
  [837] = {.lex_state = 16},
  [838] = {.lex_state = 16},
  [839] = {.lex_state = 16},
  [840] = {.lex_state = 16},
  [841] = {.lex_state = 16},
  [842] = {.lex_state = 16},
  [843] = {.lex_state = 16},
  [844] = {.lex_state = 16},
  [845] = {.lex_state = 16},
  [846] = {.lex_state = 16},
  [847] = {.lex_state = 16},
  [848] = {.lex_state = 16},
  [849] = {.lex_state = 16},
  [850] = {.lex_state = 16},
  [851] = {.lex_state = 16},
  [852] = {.lex_state = 16},
  [853] = {.lex_state = 16},
  [854] = {.lex_state = 16},
  [855] = {.lex_state = 16},
  [856] = {.lex_state = 16},
  [857] = {.lex_state = 16},
  [858] = {.lex_state = 16},
  [859] = {.lex_state = 16},
  [860] = {.lex_state = 16},
  [861] = {.lex_state = 16},
  [862] = {.lex_state = 16},
  [863] = {.lex_state = 16},
  [864] = {.lex_state = 16},
  [865] = {.lex_state = 16},
  [866] = {.lex_state = 16},
  [867] = {.lex_state = 16},
  [868] = {.lex_state = 16},
  [869] = {.lex_state = 16},
  [870] = {.lex_state = 16},
  [871] = {.lex_state = 16},
  [872] = {.lex_state = 16},
  [873] = {.lex_state = 16},
  [874] = {.lex_state = 16},
  [875] = {.lex_state = 16},
  [876] = {.lex_state = 16},
  [877] = {.lex_state = 16},
  [878] = {.lex_state = 16},
  [879] = {.lex_state = 16},
  [880] = {.lex_state = 16},
  [881] = {.lex_state = 16},
  [882] = {.lex_state = 16},
  [883] = {.lex_state = 16},
  [884] = {.lex_state = 16},
  [885] = {.lex_state = 16},
  [886] = {.lex_state = 16},
  [887] = {.lex_state = 16},
  [888] = {.lex_state = 16},
  [889] = {.lex_state = 16},
  [890] = {.lex_state = 16},
  [891] = {.lex_state = 16},
  [892] = {.lex_state = 16},
  [893] = {.lex_state = 16},
  [894] = {.lex_state = 16},
  [895] = {.lex_state = 16},
  [896] = {.lex_state = 16},
  [897] = {.lex_state = 16},
  [898] = {.lex_state = 16},
  [899] = {.lex_state = 16},
  [900] = {.lex_state = 16},
  [901] = {.lex_state = 16},
  [902] = {.lex_state = 16},
  [903] = {.lex_state = 16},
  [904] = {.lex_state = 16},
  [905] = {.lex_state = 16},
  [906] = {.lex_state = 16},
  [907] = {.lex_state = 16},
  [908] = {.lex_state = 16},
  [909] = {.lex_state = 16},
  [910] = {.lex_state = 16},
  [911] = {.lex_state = 16},
  [912] = {.lex_state = 16},
  [913] = {.lex_state = 16},
  [914] = {.lex_state = 16},
  [915] = {.lex_state = 16},
  [916] = {.lex_state = 16},
  [917] = {.lex_state = 16},
  [918] = {.lex_state = 16},
  [919] = {.lex_state = 16},
  [920] = {.lex_state = 16},
  [921] = {.lex_state = 16},
  [922] = {.lex_state = 16},
  [923] = {.lex_state = 16},
  [924] = {.lex_state = 16},
  [925] = {.lex_state = 16},
  [926] = {.lex_state = 16},
  [927] = {.lex_state = 16},
  [928] = {.lex_state = 16},
  [929] = {.lex_state = 4},
  [930] = {.lex_state = 4},
  [931] = {.lex_state = 4},
  [932] = {.lex_state = 4},
  [933] = {.lex_state = 4},
  [934] = {.lex_state = 4},
  [935] = {.lex_state = 4},
  [936] = {.lex_state = 4},
  [937] = {.lex_state = 4},
  [938] = {.lex_state = 4},
  [939] = {.lex_state = 4},
  [940] = {.lex_state = 4},
  [941] = {.lex_state = 4},
  [942] = {.lex_state = 4},
  [943] = {.lex_state = 4},
  [944] = {.lex_state = 4},
  [945] = {.lex_state = 4},
  [946] = {.lex_state = 4},
  [947] = {.lex_state = 4},
  [948] = {.lex_state = 4},
  [949] = {.lex_state = 4},
  [950] = {.lex_state = 4},
  [951] = {.lex_state = 4},
  [952] = {.lex_state = 4},
  [953] = {.lex_state = 4},
  [954] = {.lex_state = 4},
  [955] = {.lex_state = 4},
  [956] = {.lex_state = 4},
  [957] = {.lex_state = 4},
  [958] = {.lex_state = 4},
  [959] = {.lex_state = 4},
  [960] = {.lex_state = 4},
  [961] = {.lex_state = 4},
  [962] = {.lex_state = 4},
  [963] = {.lex_state = 4},
  [964] = {.lex_state = 4},
  [965] = {.lex_state = 4},
  [966] = {.lex_state = 4},
  [967] = {.lex_state = 4},
  [968] = {.lex_state = 4},
  [969] = {.lex_state = 4},
  [970] = {.lex_state = 4},
  [971] = {.lex_state = 4},
  [972] = {.lex_state = 4},
  [973] = {.lex_state = 4},
  [974] = {.lex_state = 4},
  [975] = {.lex_state = 4},
  [976] = {.lex_state = 4},
  [977] = {.lex_state = 4},
  [978] = {.lex_state = 4},
  [979] = {.lex_state = 4},
  [980] = {.lex_state = 4},
  [981] = {.lex_state = 4},
  [982] = {.lex_state = 4},
  [983] = {.lex_state = 4},
  [984] = {.lex_state = 4},
  [985] = {.lex_state = 4},
  [986] = {.lex_state = 4},
  [987] = {.lex_state = 4},
  [988] = {.lex_state = 4},
  [989] = {.lex_state = 4},
  [990] = {.lex_state = 4},
  [991] = {.lex_state = 4},
  [992] = {.lex_state = 4},
  [993] = {.lex_state = 4},
  [994] = {.lex_state = 4},
  [995] = {.lex_state = 4},
  [996] = {.lex_state = 4},
  [997] = {.lex_state = 4},
  [998] = {.lex_state = 4},
  [999] = {.lex_state = 4},
  [1000] = {.lex_state = 4},
  [1001] = {.lex_state = 4},
  [1002] = {.lex_state = 4},
  [1003] = {.lex_state = 4},
  [1004] = {.lex_state = 4},
  [1005] = {.lex_state = 4},
  [1006] = {.lex_state = 4},
  [1007] = {.lex_state = 4},
  [1008] = {.lex_state = 4},
  [1009] = {.lex_state = 4},
  [1010] = {.lex_state = 4},
  [1011] = {.lex_state = 4},
  [1012] = {.lex_state = 4},
  [1013] = {.lex_state = 4},
  [1014] = {.lex_state = 4},
  [1015] = {.lex_state = 4},
  [1016] = {.lex_state = 4},
  [1017] = {.lex_state = 4},
  [1018] = {.lex_state = 4},
  [1019] = {.lex_state = 4},
  [1020] = {.lex_state = 4},
  [1021] = {.lex_state = 4},
  [1022] = {.lex_state = 4},
  [1023] = {.lex_state = 270},
  [1024] = {.lex_state = 270},
  [1025] = {.lex_state = 4},
  [1026] = {.lex_state = 4},
  [1027] = {.lex_state = 270},
  [1028] = {.lex_state = 269},
  [1029] = {.lex_state = 270},
  [1030] = {.lex_state = 4},
  [1031] = {.lex_state = 270},
  [1032] = {.lex_state = 270},
  [1033] = {.lex_state = 270},
  [1034] = {.lex_state = 270},
  [1035] = {.lex_state = 270},
  [1036] = {.lex_state = 269},
  [1037] = {.lex_state = 269},
  [1038] = {.lex_state = 269},
  [1039] = {.lex_state = 269},
  [1040] = {.lex_state = 269},
  [1041] = {.lex_state = 269},
  [1042] = {.lex_state = 269},
  [1043] = {.lex_state = 269},
  [1044] = {.lex_state = 12},
  [1045] = {.lex_state = 4},
  [1046] = {.lex_state = 4},
  [1047] = {.lex_state = 269},
  [1048] = {.lex_state = 270},
  [1049] = {.lex_state = 4},
  [1050] = {.lex_state = 12},
  [1051] = {.lex_state = 4},
  [1052] = {.lex_state = 4},
  [1053] = {.lex_state = 12},
  [1054] = {.lex_state = 4},
  [1055] = {.lex_state = 269},
  [1056] = {.lex_state = 269},
  [1057] = {.lex_state = 4},
  [1058] = {.lex_state = 4},
  [1059] = {.lex_state = 270},
  [1060] = {.lex_state = 4},
  [1061] = {.lex_state = 26},
  [1062] = {.lex_state = 269},
  [1063] = {.lex_state = 4},
  [1064] = {.lex_state = 4},
  [1065] = {.lex_state = 26},
  [1066] = {.lex_state = 270},
  [1067] = {.lex_state = 4},
  [1068] = {.lex_state = 26},
  [1069] = {.lex_state = 26},
  [1070] = {.lex_state = 26},
  [1071] = {.lex_state = 4},
  [1072] = {.lex_state = 4},
  [1073] = {.lex_state = 4},
  [1074] = {.lex_state = 270},
  [1075] = {.lex_state = 4},
  [1076] = {.lex_state = 4},
  [1077] = {.lex_state = 270},
  [1078] = {.lex_state = 270},
  [1079] = {.lex_state = 26},
  [1080] = {.lex_state = 270},
  [1081] = {.lex_state = 4},
  [1082] = {.lex_state = 270},
  [1083] = {.lex_state = 270},
  [1084] = {.lex_state = 270},
  [1085] = {.lex_state = 270},
  [1086] = {.lex_state = 270},
  [1087] = {.lex_state = 270},
  [1088] = {.lex_state = 270},
  [1089] = {.lex_state = 270},
  [1090] = {.lex_state = 270},
  [1091] = {.lex_state = 270},
  [1092] = {.lex_state = 270},
  [1093] = {.lex_state = 270},
  [1094] = {.lex_state = 269},
  [1095] = {.lex_state = 4},
  [1096] = {.lex_state = 11},
  [1097] = {.lex_state = 270},
  [1098] = {.lex_state = 11},
  [1099] = {.lex_state = 270},
  [1100] = {.lex_state = 11},
  [1101] = {.lex_state = 269},
  [1102] = {.lex_state = 270},
  [1103] = {.lex_state = 11},
  [1104] = {.lex_state = 11},
  [1105] = {.lex_state = 270},
  [1106] = {.lex_state = 270},
  [1107] = {.lex_state = 270},
  [1108] = {.lex_state = 270},
  [1109] = {.lex_state = 269},
  [1110] = {.lex_state = 270},
  [1111] = {.lex_state = 270},
  [1112] = {.lex_state = 11},
  [1113] = {.lex_state = 11},
  [1114] = {.lex_state = 270},
  [1115] = {.lex_state = 270},
  [1116] = {.lex_state = 270},
  [1117] = {.lex_state = 11},
  [1118] = {.lex_state = 11},
  [1119] = {.lex_state = 11},
  [1120] = {.lex_state = 270},
  [1121] = {.lex_state = 270},
  [1122] = {.lex_state = 270},
  [1123] = {.lex_state = 270},
  [1124] = {.lex_state = 270},
  [1125] = {.lex_state = 270},
  [1126] = {.lex_state = 11},
  [1127] = {.lex_state = 270},
  [1128] = {.lex_state = 4},
  [1129] = {.lex_state = 269},
  [1130] = {.lex_state = 269},
  [1131] = {.lex_state = 270},
  [1132] = {.lex_state = 11},
  [1133] = {.lex_state = 270},
  [1134] = {.lex_state = 11},
  [1135] = {.lex_state = 4},
  [1136] = {.lex_state = 270},
  [1137] = {.lex_state = 11},
  [1138] = {.lex_state = 270},
  [1139] = {.lex_state = 11},
  [1140] = {.lex_state = 4},
  [1141] = {.lex_state = 270},
  [1142] = {.lex_state = 270},
  [1143] = {.lex_state = 270},
  [1144] = {.lex_state = 270},
  [1145] = {.lex_state = 270},
  [1146] = {.lex_state = 11},
  [1147] = {.lex_state = 270},
  [1148] = {.lex_state = 270},
  [1149] = {.lex_state = 270},
  [1150] = {.lex_state = 270},
  [1151] = {.lex_state = 11},
  [1152] = {.lex_state = 270},
  [1153] = {.lex_state = 11},
  [1154] = {.lex_state = 270},
  [1155] = {.lex_state = 4},
  [1156] = {.lex_state = 270},
  [1157] = {.lex_state = 270},
  [1158] = {.lex_state = 270},
  [1159] = {.lex_state = 4},
  [1160] = {.lex_state = 270},
  [1161] = {.lex_state = 4},
  [1162] = {.lex_state = 270},
  [1163] = {.lex_state = 270},
  [1164] = {.lex_state = 270},
  [1165] = {.lex_state = 270},
  [1166] = {.lex_state = 270},
  [1167] = {.lex_state = 270},
  [1168] = {.lex_state = 270},
  [1169] = {.lex_state = 270},
  [1170] = {.lex_state = 270},
  [1171] = {.lex_state = 270},
  [1172] = {.lex_state = 11},
  [1173] = {.lex_state = 270},
  [1174] = {.lex_state = 270},
  [1175] = {.lex_state = 270},
  [1176] = {.lex_state = 270},
  [1177] = {.lex_state = 11},
  [1178] = {.lex_state = 270},
  [1179] = {.lex_state = 270},
  [1180] = {.lex_state = 270},
  [1181] = {.lex_state = 270},
  [1182] = {.lex_state = 270},
  [1183] = {.lex_state = 270},
  [1184] = {.lex_state = 270},
  [1185] = {.lex_state = 270},
  [1186] = {.lex_state = 270},
  [1187] = {.lex_state = 4},
  [1188] = {.lex_state = 270},
  [1189] = {.lex_state = 4},
  [1190] = {.lex_state = 270},
  [1191] = {.lex_state = 270},
  [1192] = {.lex_state = 11},
  [1193] = {.lex_state = 11},
  [1194] = {.lex_state = 270},
  [1195] = {.lex_state = 270},
  [1196] = {.lex_state = 270},
  [1197] = {.lex_state = 269},
  [1198] = {.lex_state = 4},
  [1199] = {.lex_state = 4},
  [1200] = {.lex_state = 269},
  [1201] = {.lex_state = 4},
  [1202] = {.lex_state = 269},
  [1203] = {.lex_state = 269},
  [1204] = {.lex_state = 269},
  [1205] = {.lex_state = 269},
  [1206] = {.lex_state = 269},
  [1207] = {.lex_state = 269},
  [1208] = {.lex_state = 269},
  [1209] = {.lex_state = 269},
  [1210] = {.lex_state = 269},
  [1211] = {.lex_state = 269},
  [1212] = {.lex_state = 269},
  [1213] = {.lex_state = 269},
  [1214] = {.lex_state = 269},
  [1215] = {.lex_state = 269},
  [1216] = {.lex_state = 269},
  [1217] = {.lex_state = 269},
  [1218] = {.lex_state = 269},
  [1219] = {.lex_state = 269},
  [1220] = {.lex_state = 269},
  [1221] = {.lex_state = 269},
  [1222] = {.lex_state = 269},
  [1223] = {.lex_state = 269},
  [1224] = {.lex_state = 269},
  [1225] = {.lex_state = 269},
  [1226] = {.lex_state = 269},
  [1227] = {.lex_state = 269},
  [1228] = {.lex_state = 269},
  [1229] = {.lex_state = 269},
  [1230] = {.lex_state = 269},
  [1231] = {.lex_state = 269},
  [1232] = {.lex_state = 269},
  [1233] = {.lex_state = 269},
  [1234] = {.lex_state = 269},
  [1235] = {.lex_state = 269},
  [1236] = {.lex_state = 269},
  [1237] = {.lex_state = 269},
  [1238] = {.lex_state = 269},
  [1239] = {.lex_state = 269},
  [1240] = {.lex_state = 269},
  [1241] = {.lex_state = 269},
  [1242] = {.lex_state = 269},
  [1243] = {.lex_state = 11},
  [1244] = {.lex_state = 269},
  [1245] = {.lex_state = 269},
  [1246] = {.lex_state = 269},
  [1247] = {.lex_state = 269},
  [1248] = {.lex_state = 269},
  [1249] = {.lex_state = 269},
  [1250] = {.lex_state = 269},
  [1251] = {.lex_state = 269},
  [1252] = {.lex_state = 269},
  [1253] = {.lex_state = 269},
  [1254] = {.lex_state = 269},
  [1255] = {.lex_state = 269},
  [1256] = {.lex_state = 269},
  [1257] = {.lex_state = 269},
  [1258] = {.lex_state = 269},
  [1259] = {.lex_state = 269},
  [1260] = {.lex_state = 269},
  [1261] = {.lex_state = 269},
  [1262] = {.lex_state = 269},
  [1263] = {.lex_state = 269},
  [1264] = {.lex_state = 269},
  [1265] = {.lex_state = 269},
  [1266] = {.lex_state = 269},
  [1267] = {.lex_state = 269},
  [1268] = {.lex_state = 269},
  [1269] = {.lex_state = 269},
  [1270] = {.lex_state = 269},
  [1271] = {.lex_state = 269},
  [1272] = {.lex_state = 269},
  [1273] = {.lex_state = 269},
  [1274] = {.lex_state = 269},
  [1275] = {.lex_state = 269},
  [1276] = {.lex_state = 269},
  [1277] = {.lex_state = 4},
  [1278] = {.lex_state = 269},
  [1279] = {.lex_state = 269},
  [1280] = {.lex_state = 269},
  [1281] = {.lex_state = 269},
  [1282] = {.lex_state = 10},
  [1283] = {.lex_state = 4},
  [1284] = {.lex_state = 7},
  [1285] = {.lex_state = 4},
  [1286] = {.lex_state = 4},
  [1287] = {.lex_state = 7},
  [1288] = {.lex_state = 4},
  [1289] = {.lex_state = 4},
  [1290] = {.lex_state = 7},
  [1291] = {.lex_state = 7},
  [1292] = {.lex_state = 10},
  [1293] = {.lex_state = 10},
  [1294] = {.lex_state = 4},
  [1295] = {.lex_state = 10},
  [1296] = {.lex_state = 4},
  [1297] = {.lex_state = 4},
  [1298] = {.lex_state = 4},
  [1299] = {.lex_state = 4},
  [1300] = {.lex_state = 4},
  [1301] = {.lex_state = 4},
  [1302] = {.lex_state = 269},
  [1303] = {.lex_state = 269},
  [1304] = {.lex_state = 269},
  [1305] = {.lex_state = 269},
  [1306] = {.lex_state = 269},
  [1307] = {.lex_state = 269},
  [1308] = {.lex_state = 269},
  [1309] = {.lex_state = 10},
  [1310] = {.lex_state = 269},
  [1311] = {.lex_state = 269},
  [1312] = {.lex_state = 10},
  [1313] = {.lex_state = 269},
  [1314] = {.lex_state = 269},
  [1315] = {.lex_state = 269},
  [1316] = {.lex_state = 269},
  [1317] = {.lex_state = 269},
  [1318] = {.lex_state = 10},
  [1319] = {.lex_state = 10},
  [1320] = {.lex_state = 10},
  [1321] = {.lex_state = 10},
  [1322] = {.lex_state = 10},
  [1323] = {.lex_state = 10},
  [1324] = {.lex_state = 10},
  [1325] = {.lex_state = 10},
  [1326] = {.lex_state = 10},
  [1327] = {.lex_state = 10},
  [1328] = {.lex_state = 10},
  [1329] = {.lex_state = 10},
  [1330] = {.lex_state = 10},
  [1331] = {.lex_state = 10},
  [1332] = {.lex_state = 10},
  [1333] = {.lex_state = 10},
  [1334] = {.lex_state = 7},
  [1335] = {.lex_state = 10},
  [1336] = {.lex_state = 10},
  [1337] = {.lex_state = 10},
  [1338] = {.lex_state = 10},
  [1339] = {.lex_state = 10},
  [1340] = {.lex_state = 10},
  [1341] = {.lex_state = 10},
  [1342] = {.lex_state = 10},
  [1343] = {.lex_state = 10},
  [1344] = {.lex_state = 10},
  [1345] = {.lex_state = 271},
  [1346] = {.lex_state = 271},
  [1347] = {.lex_state = 271},
  [1348] = {.lex_state = 271},
  [1349] = {.lex_state = 271},
  [1350] = {.lex_state = 271},
  [1351] = {.lex_state = 271},
  [1352] = {.lex_state = 271},
  [1353] = {.lex_state = 271},
  [1354] = {.lex_state = 271},
  [1355] = {.lex_state = 271},
  [1356] = {.lex_state = 271},
  [1357] = {.lex_state = 271},
  [1358] = {.lex_state = 271},
  [1359] = {.lex_state = 271},
  [1360] = {.lex_state = 271},
  [1361] = {.lex_state = 271},
  [1362] = {.lex_state = 271},
  [1363] = {.lex_state = 271},
  [1364] = {.lex_state = 271},
  [1365] = {.lex_state = 271},
  [1366] = {.lex_state = 271},
  [1367] = {.lex_state = 271},
  [1368] = {.lex_state = 271},
  [1369] = {.lex_state = 271},
  [1370] = {.lex_state = 271},
  [1371] = {.lex_state = 271},
  [1372] = {.lex_state = 271},
  [1373] = {.lex_state = 271},
  [1374] = {.lex_state = 271},
  [1375] = {.lex_state = 271},
  [1376] = {.lex_state = 271},
  [1377] = {.lex_state = 271},
  [1378] = {.lex_state = 271},
  [1379] = {.lex_state = 271},
  [1380] = {.lex_state = 271},
  [1381] = {.lex_state = 271},
  [1382] = {.lex_state = 271},
  [1383] = {.lex_state = 23},
  [1384] = {.lex_state = 21},
  [1385] = {.lex_state = 23},
  [1386] = {.lex_state = 23},
  [1387] = {.lex_state = 23},
  [1388] = {.lex_state = 23},
  [1389] = {.lex_state = 23},
  [1390] = {.lex_state = 19},
  [1391] = {.lex_state = 17},
  [1392] = {.lex_state = 23},
  [1393] = {.lex_state = 23},
  [1394] = {.lex_state = 23},
  [1395] = {.lex_state = 23},
  [1396] = {.lex_state = 23},
  [1397] = {.lex_state = 16},
  [1398] = {.lex_state = 23},
  [1399] = {.lex_state = 23},
  [1400] = {.lex_state = 15},
  [1401] = {.lex_state = 15},
  [1402] = {.lex_state = 23},
  [1403] = {.lex_state = 23},
  [1404] = {.lex_state = 15},
  [1405] = {.lex_state = 23},
  [1406] = {.lex_state = 8},
  [1407] = {.lex_state = 15},
  [1408] = {.lex_state = 8},
  [1409] = {.lex_state = 8},
  [1410] = {.lex_state = 8},
  [1411] = {.lex_state = 16},
  [1412] = {.lex_state = 8},
  [1413] = {.lex_state = 8},
  [1414] = {.lex_state = 8},
  [1415] = {.lex_state = 8},
  [1416] = {.lex_state = 8},
  [1417] = {.lex_state = 18},
  [1418] = {.lex_state = 8},
  [1419] = {.lex_state = 4},
  [1420] = {.lex_state = 8},
  [1421] = {.lex_state = 8},
  [1422] = {.lex_state = 8},
  [1423] = {.lex_state = 4},
  [1424] = {.lex_state = 8},
  [1425] = {.lex_state = 16},
  [1426] = {.lex_state = 4},
  [1427] = {.lex_state = 4},
  [1428] = {.lex_state = 16},
  [1429] = {.lex_state = 8},
  [1430] = {.lex_state = 8},
  [1431] = {.lex_state = 8},
  [1432] = {.lex_state = 8},
  [1433] = {.lex_state = 8},
  [1434] = {.lex_state = 16},
  [1435] = {.lex_state = 16},
  [1436] = {.lex_state = 16},
  [1437] = {.lex_state = 8},
  [1438] = {.lex_state = 8},
  [1439] = {.lex_state = 8},
  [1440] = {.lex_state = 8},
  [1441] = {.lex_state = 8},
  [1442] = {.lex_state = 8},
  [1443] = {.lex_state = 8},
  [1444] = {.lex_state = 8},
  [1445] = {.lex_state = 16},
  [1446] = {.lex_state = 16},
  [1447] = {.lex_state = 8},
  [1448] = {.lex_state = 8},
  [1449] = {.lex_state = 8},
  [1450] = {.lex_state = 8},
  [1451] = {.lex_state = 8},
  [1452] = {.lex_state = 16},
  [1453] = {.lex_state = 8},
  [1454] = {.lex_state = 8},
  [1455] = {.lex_state = 8},
  [1456] = {.lex_state = 16},
  [1457] = {.lex_state = 8},
  [1458] = {.lex_state = 8},
  [1459] = {.lex_state = 16},
  [1460] = {.lex_state = 8},
  [1461] = {.lex_state = 8},
  [1462] = {.lex_state = 8},
  [1463] = {.lex_state = 8},
  [1464] = {.lex_state = 8},
  [1465] = {.lex_state = 8},
  [1466] = {.lex_state = 16},
  [1467] = {.lex_state = 8},
  [1468] = {.lex_state = 8},
  [1469] = {.lex_state = 8},
  [1470] = {.lex_state = 8},
  [1471] = {.lex_state = 8},
  [1472] = {.lex_state = 8},
  [1473] = {.lex_state = 16},
  [1474] = {.lex_state = 16},
  [1475] = {.lex_state = 8},
  [1476] = {.lex_state = 8},
  [1477] = {.lex_state = 8},
  [1478] = {.lex_state = 8},
  [1479] = {.lex_state = 8},
  [1480] = {.lex_state = 8},
  [1481] = {.lex_state = 16},
  [1482] = {.lex_state = 8},
  [1483] = {.lex_state = 16},
  [1484] = {.lex_state = 8},
  [1485] = {.lex_state = 8},
  [1486] = {.lex_state = 16},
  [1487] = {.lex_state = 8},
  [1488] = {.lex_state = 8},
  [1489] = {.lex_state = 16},
  [1490] = {.lex_state = 8},
  [1491] = {.lex_state = 8},
  [1492] = {.lex_state = 8},
  [1493] = {.lex_state = 8},
  [1494] = {.lex_state = 8},
  [1495] = {.lex_state = 8},
  [1496] = {.lex_state = 8},
  [1497] = {.lex_state = 8},
  [1498] = {.lex_state = 8},
  [1499] = {.lex_state = 16},
  [1500] = {.lex_state = 8},
  [1501] = {.lex_state = 16},
  [1502] = {.lex_state = 8},
  [1503] = {.lex_state = 8},
  [1504] = {.lex_state = 8},
  [1505] = {.lex_state = 8},
  [1506] = {.lex_state = 8},
  [1507] = {.lex_state = 8},
  [1508] = {.lex_state = 8},
  [1509] = {.lex_state = 8},
  [1510] = {.lex_state = 8},
  [1511] = {.lex_state = 8},
  [1512] = {.lex_state = 8},
  [1513] = {.lex_state = 8},
  [1514] = {.lex_state = 8},
  [1515] = {.lex_state = 8},
  [1516] = {.lex_state = 8},
  [1517] = {.lex_state = 8},
  [1518] = {.lex_state = 16},
  [1519] = {.lex_state = 16},
  [1520] = {.lex_state = 16},
  [1521] = {.lex_state = 8},
  [1522] = {.lex_state = 8},
  [1523] = {.lex_state = 8},
  [1524] = {.lex_state = 8},
  [1525] = {.lex_state = 8},
  [1526] = {.lex_state = 8},
  [1527] = {.lex_state = 8},
  [1528] = {.lex_state = 8},
  [1529] = {.lex_state = 8},
  [1530] = {.lex_state = 16},
  [1531] = {.lex_state = 8},
  [1532] = {.lex_state = 16},
  [1533] = {.lex_state = 8},
  [1534] = {.lex_state = 16},
  [1535] = {.lex_state = 7},
  [1536] = {.lex_state = 8},
  [1537] = {.lex_state = 8},
  [1538] = {.lex_state = 8},
  [1539] = {.lex_state = 8},
  [1540] = {.lex_state = 8},
  [1541] = {.lex_state = 8},
  [1542] = {.lex_state = 8},
  [1543] = {.lex_state = 8},
  [1544] = {.lex_state = 8},
  [1545] = {.lex_state = 8},
  [1546] = {.lex_state = 8},
  [1547] = {.lex_state = 8},
  [1548] = {.lex_state = 8},
  [1549] = {.lex_state = 8},
  [1550] = {.lex_state = 8},
  [1551] = {.lex_state = 8},
  [1552] = {.lex_state = 8},
  [1553] = {.lex_state = 8},
  [1554] = {.lex_state = 4},
  [1555] = {.lex_state = 8},
  [1556] = {.lex_state = 4},
  [1557] = {.lex_state = 8},
  [1558] = {.lex_state = 8},
  [1559] = {.lex_state = 4},
  [1560] = {.lex_state = 4},
  [1561] = {.lex_state = 4},
  [1562] = {.lex_state = 4},
  [1563] = {.lex_state = 8},
  [1564] = {.lex_state = 4},
  [1565] = {.lex_state = 4},
  [1566] = {.lex_state = 4},
  [1567] = {.lex_state = 4},
  [1568] = {.lex_state = 4},
  [1569] = {.lex_state = 8},
  [1570] = {.lex_state = 8},
  [1571] = {.lex_state = 8},
  [1572] = {.lex_state = 4},
  [1573] = {.lex_state = 4},
  [1574] = {.lex_state = 8},
  [1575] = {.lex_state = 4},
  [1576] = {.lex_state = 8},
  [1577] = {.lex_state = 4},
  [1578] = {.lex_state = 4},
  [1579] = {.lex_state = 4},
  [1580] = {.lex_state = 4},
  [1581] = {.lex_state = 8},
  [1582] = {.lex_state = 4},
  [1583] = {.lex_state = 4},
  [1584] = {.lex_state = 4},
  [1585] = {.lex_state = 8},
  [1586] = {.lex_state = 8},
  [1587] = {.lex_state = 8},
  [1588] = {.lex_state = 4},
  [1589] = {.lex_state = 4},
  [1590] = {.lex_state = 4},
  [1591] = {.lex_state = 8},
  [1592] = {.lex_state = 4},
  [1593] = {.lex_state = 4},
  [1594] = {.lex_state = 4},
  [1595] = {.lex_state = 4},
  [1596] = {.lex_state = 4},
  [1597] = {.lex_state = 4},
  [1598] = {.lex_state = 4},
  [1599] = {.lex_state = 8},
  [1600] = {.lex_state = 4},
  [1601] = {.lex_state = 4},
  [1602] = {.lex_state = 4},
  [1603] = {.lex_state = 4},
  [1604] = {.lex_state = 4},
  [1605] = {.lex_state = 4},
  [1606] = {.lex_state = 4},
  [1607] = {.lex_state = 4},
  [1608] = {.lex_state = 4},
  [1609] = {.lex_state = 4},
  [1610] = {.lex_state = 4},
  [1611] = {.lex_state = 4},
  [1612] = {.lex_state = 4},
  [1613] = {.lex_state = 4},
  [1614] = {.lex_state = 4},
  [1615] = {.lex_state = 4},
  [1616] = {.lex_state = 4},
  [1617] = {.lex_state = 4},
  [1618] = {.lex_state = 4},
  [1619] = {.lex_state = 4},
  [1620] = {.lex_state = 4},
  [1621] = {.lex_state = 4},
  [1622] = {.lex_state = 4},
  [1623] = {.lex_state = 4},
  [1624] = {.lex_state = 4},
  [1625] = {.lex_state = 4},
  [1626] = {.lex_state = 4},
  [1627] = {.lex_state = 4},
  [1628] = {.lex_state = 4},
  [1629] = {.lex_state = 4},
  [1630] = {.lex_state = 4},
  [1631] = {.lex_state = 4},
  [1632] = {.lex_state = 8},
  [1633] = {.lex_state = 4},
  [1634] = {.lex_state = 4},
  [1635] = {.lex_state = 4},
  [1636] = {.lex_state = 4},
  [1637] = {.lex_state = 4},
  [1638] = {.lex_state = 4},
  [1639] = {.lex_state = 4},
  [1640] = {.lex_state = 4},
  [1641] = {.lex_state = 4},
  [1642] = {.lex_state = 4},
  [1643] = {.lex_state = 4},
  [1644] = {.lex_state = 8},
  [1645] = {.lex_state = 4},
  [1646] = {.lex_state = 4},
  [1647] = {.lex_state = 4},
  [1648] = {.lex_state = 4},
  [1649] = {.lex_state = 4},
  [1650] = {.lex_state = 4},
  [1651] = {.lex_state = 4},
  [1652] = {.lex_state = 4},
  [1653] = {.lex_state = 4},
  [1654] = {.lex_state = 8},
  [1655] = {.lex_state = 8},
  [1656] = {.lex_state = 8},
  [1657] = {.lex_state = 8},
  [1658] = {.lex_state = 8},
  [1659] = {.lex_state = 8},
  [1660] = {.lex_state = 8},
  [1661] = {.lex_state = 8},
  [1662] = {.lex_state = 8},
  [1663] = {.lex_state = 8},
  [1664] = {.lex_state = 8},
  [1665] = {.lex_state = 8},
  [1666] = {.lex_state = 4},
  [1667] = {.lex_state = 4},
  [1668] = {.lex_state = 264},
  [1669] = {.lex_state = 4},
  [1670] = {.lex_state = 4},
  [1671] = {.lex_state = 4},
  [1672] = {.lex_state = 4},
  [1673] = {.lex_state = 264},
  [1674] = {.lex_state = 4},
  [1675] = {.lex_state = 264},
  [1676] = {.lex_state = 4},
  [1677] = {.lex_state = 4},
  [1678] = {.lex_state = 4},
  [1679] = {.lex_state = 4},
  [1680] = {.lex_state = 4},
  [1681] = {.lex_state = 28},
  [1682] = {.lex_state = 28},
  [1683] = {.lex_state = 28},
  [1684] = {.lex_state = 28},
  [1685] = {.lex_state = 28},
  [1686] = {.lex_state = 28},
  [1687] = {.lex_state = 28},
  [1688] = {.lex_state = 28},
  [1689] = {.lex_state = 28},
  [1690] = {.lex_state = 28},
  [1691] = {.lex_state = 28},
  [1692] = {.lex_state = 28},
  [1693] = {.lex_state = 28},
  [1694] = {.lex_state = 28},
  [1695] = {.lex_state = 28},
  [1696] = {.lex_state = 28},
  [1697] = {.lex_state = 28},
  [1698] = {.lex_state = 28},
  [1699] = {.lex_state = 28},
  [1700] = {.lex_state = 28},
  [1701] = {.lex_state = 28},
  [1702] = {.lex_state = 28},
  [1703] = {.lex_state = 28},
  [1704] = {.lex_state = 28},
  [1705] = {.lex_state = 28},
  [1706] = {.lex_state = 264},
  [1707] = {.lex_state = 4},
  [1708] = {.lex_state = 4},
  [1709] = {.lex_state = 4},
  [1710] = {.lex_state = 4},
  [1711] = {.lex_state = 4},
  [1712] = {.lex_state = 4},
  [1713] = {.lex_state = 15},
  [1714] = {.lex_state = 264},
  [1715] = {.lex_state = 264},
  [1716] = {.lex_state = 15},
  [1717] = {.lex_state = 264},
  [1718] = {.lex_state = 264},
  [1719] = {.lex_state = 15},
  [1720] = {.lex_state = 264},
  [1721] = {.lex_state = 264},
  [1722] = {.lex_state = 28},
  [1723] = {.lex_state = 28},
  [1724] = {.lex_state = 264},
  [1725] = {.lex_state = 4},
  [1726] = {.lex_state = 28},
  [1727] = {.lex_state = 264},
  [1728] = {.lex_state = 264},
  [1729] = {.lex_state = 28},
  [1730] = {.lex_state = 15},
  [1731] = {.lex_state = 28},
  [1732] = {.lex_state = 28},
  [1733] = {.lex_state = 28},
  [1734] = {.lex_state = 264},
  [1735] = {.lex_state = 4},
  [1736] = {.lex_state = 264},
  [1737] = {.lex_state = 27},
  [1738] = {.lex_state = 264},
  [1739] = {.lex_state = 264},
  [1740] = {.lex_state = 27},
  [1741] = {.lex_state = 264},
  [1742] = {.lex_state = 264},
  [1743] = {.lex_state = 264},
  [1744] = {.lex_state = 264},
  [1745] = {.lex_state = 264},
  [1746] = {.lex_state = 264},
  [1747] = {.lex_state = 264},
  [1748] = {.lex_state = 264},
  [1749] = {.lex_state = 264},
  [1750] = {.lex_state = 4},
  [1751] = {.lex_state = 264},
  [1752] = {.lex_state = 15},
  [1753] = {.lex_state = 264},
  [1754] = {.lex_state = 15},
  [1755] = {.lex_state = 264},
  [1756] = {.lex_state = 15},
  [1757] = {.lex_state = 264},
  [1758] = {.lex_state = 264},
  [1759] = {.lex_state = 264},
  [1760] = {.lex_state = 15},
  [1761] = {.lex_state = 4},
  [1762] = {.lex_state = 27},
  [1763] = {.lex_state = 38},
  [1764] = {.lex_state = 38},
  [1765] = {.lex_state = 38},
  [1766] = {.lex_state = 38},
  [1767] = {.lex_state = 38},
  [1768] = {.lex_state = 27},
  [1769] = {.lex_state = 38},
  [1770] = {.lex_state = 38},
  [1771] = {.lex_state = 264},
  [1772] = {.lex_state = 38},
  [1773] = {.lex_state = 38},
  [1774] = {.lex_state = 38},
  [1775] = {.lex_state = 27},
  [1776] = {.lex_state = 264},
  [1777] = {.lex_state = 38},
  [1778] = {.lex_state = 27},
  [1779] = {.lex_state = 38},
  [1780] = {.lex_state = 27},
  [1781] = {.lex_state = 38},
  [1782] = {.lex_state = 38},
  [1783] = {.lex_state = 38},
  [1784] = {.lex_state = 38},
  [1785] = {.lex_state = 27},
  [1786] = {.lex_state = 264},
  [1787] = {.lex_state = 27},
  [1788] = {.lex_state = 38},
  [1789] = {.lex_state = 264},
  [1790] = {.lex_state = 264},
  [1791] = {.lex_state = 38},
  [1792] = {.lex_state = 264},
  [1793] = {.lex_state = 27},
  [1794] = {.lex_state = 38},
  [1795] = {.lex_state = 27},
  [1796] = {.lex_state = 27},
  [1797] = {.lex_state = 27},
  [1798] = {.lex_state = 27},
  [1799] = {.lex_state = 27},
  [1800] = {.lex_state = 38},
  [1801] = {.lex_state = 27},
  [1802] = {.lex_state = 38},
  [1803] = {.lex_state = 38},
  [1804] = {.lex_state = 38},
  [1805] = {.lex_state = 27},
  [1806] = {.lex_state = 38},
  [1807] = {.lex_state = 27},
  [1808] = {.lex_state = 264},
  [1809] = {.lex_state = 35},
  [1810] = {.lex_state = 38},
  [1811] = {.lex_state = 35},
  [1812] = {.lex_state = 264},
  [1813] = {.lex_state = 38},
  [1814] = {.lex_state = 35},
  [1815] = {.lex_state = 264},
  [1816] = {.lex_state = 27},
  [1817] = {.lex_state = 264},
  [1818] = {.lex_state = 38},
  [1819] = {.lex_state = 27},
  [1820] = {.lex_state = 38},
  [1821] = {.lex_state = 27},
  [1822] = {.lex_state = 38},
  [1823] = {.lex_state = 35},
  [1824] = {.lex_state = 38},
  [1825] = {.lex_state = 35},
  [1826] = {.lex_state = 27},
  [1827] = {.lex_state = 35},
  [1828] = {.lex_state = 27},
  [1829] = {.lex_state = 27},
  [1830] = {.lex_state = 27},
  [1831] = {.lex_state = 27},
  [1832] = {.lex_state = 27},
  [1833] = {.lex_state = 15},
  [1834] = {.lex_state = 27},
  [1835] = {.lex_state = 15},
  [1836] = {.lex_state = 264},
  [1837] = {.lex_state = 27},
  [1838] = {.lex_state = 27},
  [1839] = {.lex_state = 15},
  [1840] = {.lex_state = 15},
  [1841] = {.lex_state = 15},
  [1842] = {.lex_state = 37},
  [1843] = {.lex_state = 15},
  [1844] = {.lex_state = 15},
  [1845] = {.lex_state = 38},
  [1846] = {.lex_state = 264},
  [1847] = {.lex_state = 4},
  [1848] = {.lex_state = 15},
  [1849] = {.lex_state = 264},
  [1850] = {.lex_state = 264},
  [1851] = {.lex_state = 264},
  [1852] = {.lex_state = 264},
  [1853] = {.lex_state = 27},
  [1854] = {.lex_state = 27},
  [1855] = {.lex_state = 27},
  [1856] = {.lex_state = 264},
  [1857] = {.lex_state = 27},
  [1858] = {.lex_state = 4},
  [1859] = {.lex_state = 264},
  [1860] = {.lex_state = 4},
  [1861] = {.lex_state = 4},
  [1862] = {.lex_state = 4},
  [1863] = {.lex_state = 264},
  [1864] = {.lex_state = 27},
  [1865] = {.lex_state = 27},
  [1866] = {.lex_state = 264},
  [1867] = {.lex_state = 27},
  [1868] = {.lex_state = 27},
  [1869] = {.lex_state = 27},
  [1870] = {.lex_state = 27},
  [1871] = {.lex_state = 264},
  [1872] = {.lex_state = 264},
  [1873] = {.lex_state = 27},
  [1874] = {.lex_state = 27},
  [1875] = {.lex_state = 27},
  [1876] = {.lex_state = 27},
  [1877] = {.lex_state = 264},
  [1878] = {.lex_state = 27},
  [1879] = {.lex_state = 27},
  [1880] = {.lex_state = 27},
  [1881] = {.lex_state = 264},
  [1882] = {.lex_state = 264},
  [1883] = {.lex_state = 5},
  [1884] = {.lex_state = 27},
  [1885] = {.lex_state = 27},
  [1886] = {.lex_state = 264},
  [1887] = {.lex_state = 27},
  [1888] = {.lex_state = 264},
  [1889] = {.lex_state = 264},
  [1890] = {.lex_state = 264},
  [1891] = {.lex_state = 264},
  [1892] = {.lex_state = 264},
  [1893] = {.lex_state = 264},
  [1894] = {.lex_state = 264},
  [1895] = {.lex_state = 264},
  [1896] = {.lex_state = 27},
  [1897] = {.lex_state = 27},
  [1898] = {.lex_state = 264},
  [1899] = {.lex_state = 27},
  [1900] = {.lex_state = 264},
  [1901] = {.lex_state = 264},
  [1902] = {.lex_state = 264},
  [1903] = {.lex_state = 27},
  [1904] = {.lex_state = 27},
  [1905] = {.lex_state = 264},
  [1906] = {.lex_state = 27},
  [1907] = {.lex_state = 264},
  [1908] = {.lex_state = 264},
  [1909] = {.lex_state = 264},
  [1910] = {.lex_state = 264},
  [1911] = {.lex_state = 264},
  [1912] = {.lex_state = 264},
  [1913] = {.lex_state = 27},
  [1914] = {.lex_state = 27},
  [1915] = {.lex_state = 27},
  [1916] = {.lex_state = 7},
  [1917] = {.lex_state = 27},
  [1918] = {.lex_state = 27},
  [1919] = {.lex_state = 264},
  [1920] = {.lex_state = 264},
  [1921] = {.lex_state = 27},
  [1922] = {.lex_state = 7},
  [1923] = {.lex_state = 27},
  [1924] = {.lex_state = 27},
  [1925] = {.lex_state = 27},
  [1926] = {.lex_state = 27},
  [1927] = {.lex_state = 27},
  [1928] = {.lex_state = 264},
  [1929] = {.lex_state = 264},
  [1930] = {.lex_state = 264},
  [1931] = {.lex_state = 264},
  [1932] = {.lex_state = 264},
  [1933] = {.lex_state = 27},
  [1934] = {.lex_state = 264},
  [1935] = {.lex_state = 264},
  [1936] = {.lex_state = 264},
  [1937] = {.lex_state = 264},
  [1938] = {.lex_state = 264},
  [1939] = {.lex_state = 264},
  [1940] = {.lex_state = 264},
  [1941] = {.lex_state = 264},
  [1942] = {.lex_state = 264},
  [1943] = {.lex_state = 264},
  [1944] = {.lex_state = 27},
  [1945] = {.lex_state = 264},
  [1946] = {.lex_state = 27},
  [1947] = {.lex_state = 264},
  [1948] = {.lex_state = 264},
  [1949] = {.lex_state = 264},
  [1950] = {.lex_state = 264},
  [1951] = {.lex_state = 264},
  [1952] = {.lex_state = 264},
  [1953] = {.lex_state = 264},
  [1954] = {.lex_state = 27},
  [1955] = {.lex_state = 27},
  [1956] = {.lex_state = 27},
  [1957] = {.lex_state = 264},
  [1958] = {.lex_state = 264},
  [1959] = {.lex_state = 27},
  [1960] = {.lex_state = 264},
  [1961] = {.lex_state = 264},
  [1962] = {.lex_state = 5},
  [1963] = {.lex_state = 264},
  [1964] = {.lex_state = 264},
  [1965] = {.lex_state = 264},
  [1966] = {.lex_state = 264},
  [1967] = {.lex_state = 27},
  [1968] = {.lex_state = 264},
  [1969] = {.lex_state = 264},
  [1970] = {.lex_state = 27},
  [1971] = {.lex_state = 264},
  [1972] = {.lex_state = 264},
  [1973] = {.lex_state = 264},
  [1974] = {.lex_state = 264},
  [1975] = {.lex_state = 264},
  [1976] = {.lex_state = 27},
  [1977] = {.lex_state = 264},
  [1978] = {.lex_state = 264},
  [1979] = {.lex_state = 264},
  [1980] = {.lex_state = 264},
  [1981] = {.lex_state = 5},
  [1982] = {.lex_state = 264},
  [1983] = {.lex_state = 264},
  [1984] = {.lex_state = 264},
  [1985] = {.lex_state = 27},
  [1986] = {.lex_state = 264},
  [1987] = {.lex_state = 264},
  [1988] = {.lex_state = 264},
  [1989] = {.lex_state = 264},
  [1990] = {.lex_state = 264},
  [1991] = {.lex_state = 264},
  [1992] = {.lex_state = 264},
  [1993] = {.lex_state = 264},
  [1994] = {.lex_state = 264},
  [1995] = {.lex_state = 264},
  [1996] = {.lex_state = 264},
  [1997] = {.lex_state = 264},
  [1998] = {.lex_state = 264},
  [1999] = {.lex_state = 264},
  [2000] = {.lex_state = 264},
  [2001] = {.lex_state = 264},
  [2002] = {.lex_state = 264},
  [2003] = {.lex_state = 4},
  [2004] = {.lex_state = 264},
  [2005] = {.lex_state = 264},
  [2006] = {.lex_state = 27},
  [2007] = {.lex_state = 264},
  [2008] = {.lex_state = 264},
  [2009] = {.lex_state = 4},
  [2010] = {.lex_state = 264},
  [2011] = {.lex_state = 27},
  [2012] = {.lex_state = 264},
  [2013] = {.lex_state = 264},
  [2014] = {.lex_state = 264},
  [2015] = {.lex_state = 27},
  [2016] = {.lex_state = 264},
  [2017] = {.lex_state = 264},
  [2018] = {.lex_state = 264},
  [2019] = {.lex_state = 264},
  [2020] = {.lex_state = 264},
  [2021] = {.lex_state = 11},
  [2022] = {.lex_state = 11},
  [2023] = {.lex_state = 11},
  [2024] = {.lex_state = 264},
  [2025] = {.lex_state = 264},
  [2026] = {.lex_state = 11},
  [2027] = {.lex_state = 264},
  [2028] = {.lex_state = 4},
  [2029] = {.lex_state = 264},
  [2030] = {.lex_state = 264},
  [2031] = {.lex_state = 264},
  [2032] = {.lex_state = 4},
  [2033] = {.lex_state = 264},
  [2034] = {.lex_state = 264},
  [2035] = {.lex_state = 264},
  [2036] = {.lex_state = 264},
  [2037] = {.lex_state = 264},
  [2038] = {.lex_state = 4},
  [2039] = {.lex_state = 264},
  [2040] = {.lex_state = 264},
  [2041] = {.lex_state = 4},
  [2042] = {.lex_state = 11},
  [2043] = {.lex_state = 4},
  [2044] = {.lex_state = 264},
  [2045] = {.lex_state = 264},
  [2046] = {.lex_state = 264},
  [2047] = {.lex_state = 264},
  [2048] = {.lex_state = 264},
  [2049] = {.lex_state = 11},
  [2050] = {.lex_state = 11},
  [2051] = {.lex_state = 264},
  [2052] = {.lex_state = 264},
  [2053] = {.lex_state = 11},
  [2054] = {.lex_state = 264},
  [2055] = {.lex_state = 264},
  [2056] = {.lex_state = 264},
  [2057] = {.lex_state = 264},
  [2058] = {.lex_state = 264},
  [2059] = {.lex_state = 264},
  [2060] = {.lex_state = 264},
  [2061] = {.lex_state = 264},
  [2062] = {.lex_state = 264},
  [2063] = {.lex_state = 264},
  [2064] = {.lex_state = 264},
  [2065] = {.lex_state = 264},
  [2066] = {.lex_state = 264},
  [2067] = {.lex_state = 264},
  [2068] = {.lex_state = 264},
  [2069] = {.lex_state = 264},
  [2070] = {.lex_state = 264},
  [2071] = {.lex_state = 5},
  [2072] = {.lex_state = 264},
  [2073] = {.lex_state = 518},
  [2074] = {.lex_state = 264},
  [2075] = {.lex_state = 264},
  [2076] = {.lex_state = 264},
  [2077] = {.lex_state = 264},
  [2078] = {.lex_state = 264},
  [2079] = {.lex_state = 264},
  [2080] = {.lex_state = 264},
  [2081] = {.lex_state = 11},
  [2082] = {.lex_state = 264},
  [2083] = {.lex_state = 264},
  [2084] = {.lex_state = 264},
  [2085] = {.lex_state = 264},
  [2086] = {.lex_state = 264},
  [2087] = {.lex_state = 264},
  [2088] = {.lex_state = 518},
  [2089] = {.lex_state = 264},
  [2090] = {.lex_state = 264},
  [2091] = {.lex_state = 264},
  [2092] = {.lex_state = 264},
  [2093] = {.lex_state = 264},
  [2094] = {.lex_state = 11},
  [2095] = {.lex_state = 264},
  [2096] = {.lex_state = 264},
  [2097] = {.lex_state = 264},
  [2098] = {.lex_state = 264},
  [2099] = {.lex_state = 264},
  [2100] = {.lex_state = 264},
  [2101] = {.lex_state = 535},
  [2102] = {.lex_state = 264},
  [2103] = {.lex_state = 264},
  [2104] = {.lex_state = 264},
  [2105] = {.lex_state = 264},
  [2106] = {.lex_state = 505},
  [2107] = {.lex_state = 264},
  [2108] = {.lex_state = 264},
  [2109] = {.lex_state = 264},
  [2110] = {.lex_state = 264},
  [2111] = {.lex_state = 264},
  [2112] = {.lex_state = 264},
  [2113] = {.lex_state = 264},
  [2114] = {.lex_state = 264},
  [2115] = {.lex_state = 264},
  [2116] = {.lex_state = 264},
  [2117] = {.lex_state = 264},
  [2118] = {.lex_state = 264},
  [2119] = {.lex_state = 264},
  [2120] = {.lex_state = 264},
  [2121] = {.lex_state = 264},
  [2122] = {.lex_state = 535},
  [2123] = {.lex_state = 264},
  [2124] = {.lex_state = 264},
  [2125] = {.lex_state = 264},
  [2126] = {.lex_state = 264},
  [2127] = {.lex_state = 264},
  [2128] = {.lex_state = 264},
  [2129] = {.lex_state = 264},
  [2130] = {.lex_state = 264},
  [2131] = {.lex_state = 264},
  [2132] = {.lex_state = 264},
  [2133] = {.lex_state = 264},
  [2134] = {.lex_state = 535},
  [2135] = {.lex_state = 264},
  [2136] = {.lex_state = 264},
  [2137] = {.lex_state = 521},
  [2138] = {.lex_state = 264},
  [2139] = {.lex_state = 264},
  [2140] = {.lex_state = 264},
  [2141] = {.lex_state = 264},
  [2142] = {.lex_state = 264},
  [2143] = {.lex_state = 264},
  [2144] = {.lex_state = 264},
  [2145] = {.lex_state = 264},
  [2146] = {.lex_state = 264},
  [2147] = {.lex_state = 264},
  [2148] = {.lex_state = 264},
  [2149] = {.lex_state = 264},
  [2150] = {.lex_state = 264},
  [2151] = {.lex_state = 264},
  [2152] = {.lex_state = 264},
  [2153] = {.lex_state = 264},
  [2154] = {.lex_state = 264},
  [2155] = {.lex_state = 264},
  [2156] = {.lex_state = 264},
  [2157] = {.lex_state = 264},
  [2158] = {.lex_state = 521},
  [2159] = {.lex_state = 535},
  [2160] = {.lex_state = 264},
  [2161] = {.lex_state = 264},
  [2162] = {.lex_state = 264},
  [2163] = {.lex_state = 264},
  [2164] = {.lex_state = 264},
  [2165] = {.lex_state = 264},
  [2166] = {.lex_state = 264},
  [2167] = {.lex_state = 264},
  [2168] = {.lex_state = 264},
  [2169] = {.lex_state = 264},
  [2170] = {.lex_state = 264},
  [2171] = {.lex_state = 264},
  [2172] = {.lex_state = 264},
  [2173] = {.lex_state = 264},
  [2174] = {.lex_state = 535},
  [2175] = {.lex_state = 264},
  [2176] = {.lex_state = 5},
  [2177] = {.lex_state = 264},
  [2178] = {.lex_state = 264},
  [2179] = {.lex_state = 264},
  [2180] = {.lex_state = 264},
  [2181] = {.lex_state = 264},
  [2182] = {.lex_state = 264},
  [2183] = {.lex_state = 264},
  [2184] = {.lex_state = 264},
  [2185] = {.lex_state = 535},
  [2186] = {.lex_state = 264},
  [2187] = {.lex_state = 264},
  [2188] = {.lex_state = 264},
  [2189] = {.lex_state = 264},
  [2190] = {.lex_state = 264},
  [2191] = {.lex_state = 264},
  [2192] = {.lex_state = 264},
  [2193] = {.lex_state = 264},
  [2194] = {.lex_state = 264},
  [2195] = {.lex_state = 264},
  [2196] = {.lex_state = 264},
  [2197] = {.lex_state = 264},
  [2198] = {.lex_state = 264},
  [2199] = {.lex_state = 5},
  [2200] = {.lex_state = 11},
  [2201] = {.lex_state = 264},
  [2202] = {.lex_state = 264},
  [2203] = {.lex_state = 264},
  [2204] = {.lex_state = 5},
  [2205] = {.lex_state = 264},
  [2206] = {.lex_state = 264},
  [2207] = {.lex_state = 264},
  [2208] = {.lex_state = 264},
  [2209] = {.lex_state = 264},
  [2210] = {.lex_state = 264},
  [2211] = {.lex_state = 264},
  [2212] = {.lex_state = 264},
  [2213] = {.lex_state = 264},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_pub] = ACTIONS(1),
    [anon_sym_comptime] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym_inline] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_usingnamespace] = ACTIONS(1),
    [anon_sym_fn] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_defer] = ACTIONS(1),
    [anon_sym_suspend] = ACTIONS(1),
    [anon_sym_errdefer] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_error] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_anyframe] = ACTIONS(1),
    [anon_sym_undefined] = ACTIONS(1),
    [anon_sym_unreachable] = ACTIONS(1),
    [anon_sym_packed] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_asm] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_linksection] = ACTIONS(1),
    [anon_sym_addrspace] = ACTIONS(1),
    [anon_sym_callconv] = ACTIONS(1),
    [anon_sym_anytype] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_orelse] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1),
    [anon_sym_DASH_PERCENT] = ACTIONS(1),
    [anon_sym_PLUS_PIPE] = ACTIONS(1),
    [anon_sym_DASH_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_STAR_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_PIPE] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_allowzero] = ACTIONS(1),
    [anon_sym_align] = ACTIONS(1),
    [anon_sym_DOT_STAR] = ACTIONS(1),
    [anon_sym_DOT_QMARK] = ACTIONS(1),
    [anon_sym_c] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_opaque] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [sym_doc_comment] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [aux_sym_FLOAT_token1] = ACTIONS(1),
    [aux_sym_FLOAT_token2] = ACTIONS(1),
    [aux_sym_FLOAT_token3] = ACTIONS(1),
    [aux_sym_FLOAT_token4] = ACTIONS(1),
    [aux_sym_INTEGER_token1] = ACTIONS(1),
    [aux_sym_INTEGER_token2] = ACTIONS(1),
    [aux_sym_INTEGER_token3] = ACTIONS(1),
    [aux_sym_INTEGER_token4] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [aux_sym_EscapeSequence_token1] = ACTIONS(1),
    [aux_sym_EscapeSequence_token2] = ACTIONS(1),
    [aux_sym_EscapeSequence_token3] = ACTIONS(1),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(1),
    [aux_sym_FormatSequence_token2] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_LBRACE2] = ACTIONS(1),
    [anon_sym_RBRACE2] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(2128),
    [aux_sym__ContainerMembers] = STATE(366),
    [sym__ContainerDeclarations] = STATE(366),
    [sym_TestDecl] = STATE(366),
    [sym_ComptimeDecl] = STATE(366),
    [sym_Decl] = STATE(366),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [ts_builtin_sym_end] = ACTIONS(5),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_container_doc_comment] = ACTIONS(67),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [2] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1076),
    [sym_BinaryExpr] = STATE(1076),
    [sym_UnaryExpr] = STATE(1076),
    [sym__PrimaryExpr] = STATE(1076),
    [sym_IfExpr] = STATE(1076),
    [sym_Block] = STATE(1076),
    [sym_LoopExpr] = STATE(1076),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1076),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1076),
    [sym_BreakLabel] = STATE(3),
    [sym_BlockLabel] = STATE(1678),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(97),
    [anon_sym_COLON] = ACTIONS(99),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(87),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(87),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_EQ_GT] = ACTIONS(87),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_STAR_EQ] = ACTIONS(87),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(87),
    [anon_sym_SLASH_EQ] = ACTIONS(87),
    [anon_sym_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_PLUS_EQ] = ACTIONS(87),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(87),
    [anon_sym_DASH_EQ] = ACTIONS(87),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(87),
    [anon_sym_LT_LT_EQ] = ACTIONS(87),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(87),
    [anon_sym_GT_GT_EQ] = ACTIONS(87),
    [anon_sym_AMP_EQ] = ACTIONS(87),
    [anon_sym_CARET_EQ] = ACTIONS(87),
    [anon_sym_PIPE_EQ] = ACTIONS(87),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(87),
    [anon_sym_BANG_EQ] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(101),
    [anon_sym_GT] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(87),
    [anon_sym_GT_EQ] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(101),
    [anon_sym_orelse] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(101),
    [anon_sym_LT_LT_PIPE] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_PLUS_PERCENT] = ACTIONS(101),
    [anon_sym_DASH_PERCENT] = ACTIONS(97),
    [anon_sym_PLUS_PIPE] = ACTIONS(101),
    [anon_sym_DASH_PIPE] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_STAR_PERCENT] = ACTIONS(101),
    [anon_sym_STAR_PIPE] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [3] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1073),
    [sym_BinaryExpr] = STATE(1073),
    [sym_UnaryExpr] = STATE(1073),
    [sym__PrimaryExpr] = STATE(1073),
    [sym_IfExpr] = STATE(1073),
    [sym_Block] = STATE(1073),
    [sym_LoopExpr] = STATE(1073),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1073),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1073),
    [sym_BlockLabel] = STATE(1678),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_COMMA] = ACTIONS(155),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(97),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_else] = ACTIONS(157),
    [anon_sym_or] = ACTIONS(157),
    [anon_sym_and] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(155),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_EQ_GT] = ACTIONS(155),
    [anon_sym_DOT_DOT] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_AMP] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(157),
    [anon_sym_orelse] = ACTIONS(157),
    [anon_sym_catch] = ACTIONS(157),
    [anon_sym_LT_LT] = ACTIONS(157),
    [anon_sym_GT_GT] = ACTIONS(157),
    [anon_sym_LT_LT_PIPE] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_PLUS_PLUS] = ACTIONS(155),
    [anon_sym_PLUS_PERCENT] = ACTIONS(157),
    [anon_sym_DASH_PERCENT] = ACTIONS(97),
    [anon_sym_PLUS_PIPE] = ACTIONS(157),
    [anon_sym_DASH_PIPE] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_PERCENT] = ACTIONS(157),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_STAR_PERCENT] = ACTIONS(157),
    [anon_sym_STAR_PIPE] = ACTIONS(157),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [4] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1076),
    [sym_BinaryExpr] = STATE(1076),
    [sym_UnaryExpr] = STATE(1076),
    [sym__PrimaryExpr] = STATE(1076),
    [sym_IfExpr] = STATE(1076),
    [sym_Block] = STATE(1076),
    [sym_LoopExpr] = STATE(1076),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1076),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1076),
    [sym_BlockLabel] = STATE(1678),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(97),
    [anon_sym_COLON] = ACTIONS(87),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(87),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(87),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_EQ_GT] = ACTIONS(87),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_STAR_EQ] = ACTIONS(87),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(87),
    [anon_sym_SLASH_EQ] = ACTIONS(87),
    [anon_sym_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_PLUS_EQ] = ACTIONS(87),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(87),
    [anon_sym_DASH_EQ] = ACTIONS(87),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(87),
    [anon_sym_LT_LT_EQ] = ACTIONS(87),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(87),
    [anon_sym_GT_GT_EQ] = ACTIONS(87),
    [anon_sym_AMP_EQ] = ACTIONS(87),
    [anon_sym_CARET_EQ] = ACTIONS(87),
    [anon_sym_PIPE_EQ] = ACTIONS(87),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(87),
    [anon_sym_BANG_EQ] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(101),
    [anon_sym_GT] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(87),
    [anon_sym_GT_EQ] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(101),
    [anon_sym_orelse] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(101),
    [anon_sym_LT_LT_PIPE] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_PLUS_PERCENT] = ACTIONS(101),
    [anon_sym_DASH_PERCENT] = ACTIONS(97),
    [anon_sym_PLUS_PIPE] = ACTIONS(101),
    [anon_sym_DASH_PIPE] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_STAR_PERCENT] = ACTIONS(101),
    [anon_sym_STAR_PIPE] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [5] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1128),
    [sym_BinaryExpr] = STATE(1128),
    [sym_UnaryExpr] = STATE(1128),
    [sym__PrimaryExpr] = STATE(1128),
    [sym_IfExpr] = STATE(1128),
    [sym_Block] = STATE(1128),
    [sym_LoopExpr] = STATE(1128),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1128),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1128),
    [sym_BreakLabel] = STATE(7),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(97),
    [anon_sym_COLON] = ACTIONS(163),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(87),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(87),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_EQ_GT] = ACTIONS(87),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_STAR_EQ] = ACTIONS(87),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(87),
    [anon_sym_SLASH_EQ] = ACTIONS(87),
    [anon_sym_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_PLUS_EQ] = ACTIONS(87),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(87),
    [anon_sym_DASH_EQ] = ACTIONS(87),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(87),
    [anon_sym_LT_LT_EQ] = ACTIONS(87),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(87),
    [anon_sym_GT_GT_EQ] = ACTIONS(87),
    [anon_sym_AMP_EQ] = ACTIONS(87),
    [anon_sym_CARET_EQ] = ACTIONS(87),
    [anon_sym_PIPE_EQ] = ACTIONS(87),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(87),
    [anon_sym_BANG_EQ] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(101),
    [anon_sym_GT] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(87),
    [anon_sym_GT_EQ] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(101),
    [anon_sym_orelse] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(101),
    [anon_sym_LT_LT_PIPE] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_PLUS_PERCENT] = ACTIONS(101),
    [anon_sym_DASH_PERCENT] = ACTIONS(97),
    [anon_sym_PLUS_PIPE] = ACTIONS(101),
    [anon_sym_DASH_PIPE] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_STAR_PERCENT] = ACTIONS(101),
    [anon_sym_STAR_PIPE] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [6] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1128),
    [sym_BinaryExpr] = STATE(1128),
    [sym_UnaryExpr] = STATE(1128),
    [sym__PrimaryExpr] = STATE(1128),
    [sym_IfExpr] = STATE(1128),
    [sym_Block] = STATE(1128),
    [sym_LoopExpr] = STATE(1128),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1128),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1128),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(97),
    [anon_sym_COLON] = ACTIONS(87),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(87),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(87),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_EQ_GT] = ACTIONS(87),
    [anon_sym_DOT_DOT] = ACTIONS(87),
    [anon_sym_STAR_EQ] = ACTIONS(87),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(87),
    [anon_sym_SLASH_EQ] = ACTIONS(87),
    [anon_sym_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_PLUS_EQ] = ACTIONS(87),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(87),
    [anon_sym_DASH_EQ] = ACTIONS(87),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(87),
    [anon_sym_LT_LT_EQ] = ACTIONS(87),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(87),
    [anon_sym_GT_GT_EQ] = ACTIONS(87),
    [anon_sym_AMP_EQ] = ACTIONS(87),
    [anon_sym_CARET_EQ] = ACTIONS(87),
    [anon_sym_PIPE_EQ] = ACTIONS(87),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(87),
    [anon_sym_BANG_EQ] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(101),
    [anon_sym_GT] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(87),
    [anon_sym_GT_EQ] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(101),
    [anon_sym_orelse] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(101),
    [anon_sym_LT_LT_PIPE] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_PLUS_PERCENT] = ACTIONS(101),
    [anon_sym_DASH_PERCENT] = ACTIONS(97),
    [anon_sym_PLUS_PIPE] = ACTIONS(101),
    [anon_sym_DASH_PIPE] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_STAR_PERCENT] = ACTIONS(101),
    [anon_sym_STAR_PIPE] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [7] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1155),
    [sym_BinaryExpr] = STATE(1155),
    [sym_UnaryExpr] = STATE(1155),
    [sym__PrimaryExpr] = STATE(1155),
    [sym_IfExpr] = STATE(1155),
    [sym_Block] = STATE(1155),
    [sym_LoopExpr] = STATE(1155),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1155),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1155),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_COMMA] = ACTIONS(155),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(97),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_EQ] = ACTIONS(157),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_or] = ACTIONS(157),
    [anon_sym_and] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(155),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_EQ_GT] = ACTIONS(155),
    [anon_sym_DOT_DOT] = ACTIONS(155),
    [anon_sym_STAR_EQ] = ACTIONS(155),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(155),
    [anon_sym_SLASH_EQ] = ACTIONS(155),
    [anon_sym_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_PLUS_EQ] = ACTIONS(155),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(155),
    [anon_sym_DASH_EQ] = ACTIONS(155),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_EQ] = ACTIONS(155),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(155),
    [anon_sym_GT_GT_EQ] = ACTIONS(155),
    [anon_sym_AMP_EQ] = ACTIONS(155),
    [anon_sym_CARET_EQ] = ACTIONS(155),
    [anon_sym_PIPE_EQ] = ACTIONS(155),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_AMP] = ACTIONS(97),
    [anon_sym_CARET] = ACTIONS(157),
    [anon_sym_orelse] = ACTIONS(157),
    [anon_sym_catch] = ACTIONS(157),
    [anon_sym_LT_LT] = ACTIONS(157),
    [anon_sym_GT_GT] = ACTIONS(157),
    [anon_sym_LT_LT_PIPE] = ACTIONS(157),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_PLUS_PLUS] = ACTIONS(155),
    [anon_sym_PLUS_PERCENT] = ACTIONS(157),
    [anon_sym_DASH_PERCENT] = ACTIONS(97),
    [anon_sym_PLUS_PIPE] = ACTIONS(157),
    [anon_sym_DASH_PIPE] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_PERCENT] = ACTIONS(157),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_STAR_PERCENT] = ACTIONS(157),
    [anon_sym_STAR_PIPE] = ACTIONS(157),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [8] = {
    [sym_FnProto] = STATE(384),
    [sym__Expr] = STATE(427),
    [sym_BinaryExpr] = STATE(427),
    [sym_UnaryExpr] = STATE(427),
    [sym__PrimaryExpr] = STATE(427),
    [sym_IfExpr] = STATE(427),
    [sym_Block] = STATE(427),
    [sym_LoopExpr] = STATE(427),
    [sym_ForExpr] = STATE(671),
    [sym_WhileExpr] = STATE(671),
    [sym__CurlySuffixExpr] = STATE(427),
    [sym__TypeExpr] = STATE(633),
    [sym_ErrorUnionExpr] = STATE(633),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_AsmExpr] = STATE(427),
    [sym_BreakLabel] = STATE(10),
    [sym_BlockLabel] = STATE(1676),
    [sym_IfPrefix] = STATE(279),
    [sym_WhilePrefix] = STATE(272),
    [sym_ForPrefix] = STATE(271),
    [sym_PrefixOp] = STATE(306),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [ts_builtin_sym_end] = ACTIONS(87),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_pub] = ACTIONS(101),
    [anon_sym_test] = ACTIONS(101),
    [anon_sym_comptime] = ACTIONS(171),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(175),
    [anon_sym_noinline] = ACTIONS(101),
    [anon_sym_threadlocal] = ACTIONS(101),
    [anon_sym_usingnamespace] = ACTIONS(101),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(97),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_var] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(179),
    [anon_sym_nosuspend] = ACTIONS(181),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_break] = ACTIONS(183),
    [anon_sym_continue] = ACTIONS(185),
    [anon_sym_resume] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_RBRACE] = ACTIONS(87),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_asm] = ACTIONS(205),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_EQ_EQ] = ACTIONS(87),
    [anon_sym_BANG_EQ] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(101),
    [anon_sym_GT] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(87),
    [anon_sym_GT_EQ] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(87),
    [anon_sym_orelse] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(87),
    [anon_sym_LT_LT_PIPE] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_PLUS_PERCENT] = ACTIONS(87),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_PLUS_PIPE] = ACTIONS(87),
    [anon_sym_DASH_PIPE] = ACTIONS(87),
    [anon_sym_PIPE_PIPE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(87),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_STAR_PERCENT] = ACTIONS(87),
    [anon_sym_STAR_PIPE] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(87),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [9] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(447),
    [sym_BinaryExpr] = STATE(447),
    [sym_UnaryExpr] = STATE(447),
    [sym__PrimaryExpr] = STATE(447),
    [sym_IfExpr] = STATE(447),
    [sym_Block] = STATE(447),
    [sym_LoopExpr] = STATE(447),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(447),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(447),
    [sym_BreakLabel] = STATE(12),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [ts_builtin_sym_end] = ACTIONS(87),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_pub] = ACTIONS(101),
    [anon_sym_test] = ACTIONS(101),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_noinline] = ACTIONS(101),
    [anon_sym_threadlocal] = ACTIONS(101),
    [anon_sym_usingnamespace] = ACTIONS(101),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(97),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_var] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_RBRACE] = ACTIONS(87),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_EQ_EQ] = ACTIONS(87),
    [anon_sym_BANG_EQ] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(101),
    [anon_sym_GT] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(87),
    [anon_sym_GT_EQ] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(87),
    [anon_sym_orelse] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(87),
    [anon_sym_LT_LT_PIPE] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_PLUS_PERCENT] = ACTIONS(87),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_PLUS_PIPE] = ACTIONS(87),
    [anon_sym_DASH_PIPE] = ACTIONS(87),
    [anon_sym_PIPE_PIPE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(87),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_STAR_PERCENT] = ACTIONS(87),
    [anon_sym_STAR_PIPE] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(87),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [10] = {
    [sym_FnProto] = STATE(384),
    [sym__Expr] = STATE(426),
    [sym_BinaryExpr] = STATE(426),
    [sym_UnaryExpr] = STATE(426),
    [sym__PrimaryExpr] = STATE(426),
    [sym_IfExpr] = STATE(426),
    [sym_Block] = STATE(426),
    [sym_LoopExpr] = STATE(426),
    [sym_ForExpr] = STATE(671),
    [sym_WhileExpr] = STATE(671),
    [sym__CurlySuffixExpr] = STATE(426),
    [sym__TypeExpr] = STATE(633),
    [sym_ErrorUnionExpr] = STATE(633),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_AsmExpr] = STATE(426),
    [sym_BlockLabel] = STATE(1676),
    [sym_IfPrefix] = STATE(279),
    [sym_WhilePrefix] = STATE(272),
    [sym_ForPrefix] = STATE(271),
    [sym_PrefixOp] = STATE(306),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [ts_builtin_sym_end] = ACTIONS(155),
    [anon_sym_COMMA] = ACTIONS(155),
    [anon_sym_pub] = ACTIONS(157),
    [anon_sym_test] = ACTIONS(157),
    [anon_sym_comptime] = ACTIONS(171),
    [anon_sym_export] = ACTIONS(157),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(175),
    [anon_sym_noinline] = ACTIONS(157),
    [anon_sym_threadlocal] = ACTIONS(157),
    [anon_sym_usingnamespace] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(97),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_var] = ACTIONS(157),
    [anon_sym_nosuspend] = ACTIONS(181),
    [anon_sym_else] = ACTIONS(157),
    [anon_sym_or] = ACTIONS(157),
    [anon_sym_and] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(183),
    [anon_sym_continue] = ACTIONS(185),
    [anon_sym_resume] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_RBRACE] = ACTIONS(155),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_asm] = ACTIONS(205),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(155),
    [anon_sym_orelse] = ACTIONS(157),
    [anon_sym_catch] = ACTIONS(157),
    [anon_sym_LT_LT] = ACTIONS(157),
    [anon_sym_GT_GT] = ACTIONS(155),
    [anon_sym_LT_LT_PIPE] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_PLUS_PLUS] = ACTIONS(155),
    [anon_sym_PLUS_PERCENT] = ACTIONS(155),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_PLUS_PIPE] = ACTIONS(155),
    [anon_sym_DASH_PIPE] = ACTIONS(155),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_PERCENT] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_STAR_PERCENT] = ACTIONS(155),
    [anon_sym_STAR_PIPE] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(155),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [11] = {
    [sym_FnProto] = STATE(384),
    [sym__Expr] = STATE(427),
    [sym_BinaryExpr] = STATE(427),
    [sym_UnaryExpr] = STATE(427),
    [sym__PrimaryExpr] = STATE(427),
    [sym_IfExpr] = STATE(427),
    [sym_Block] = STATE(427),
    [sym_LoopExpr] = STATE(427),
    [sym_ForExpr] = STATE(671),
    [sym_WhileExpr] = STATE(671),
    [sym__CurlySuffixExpr] = STATE(427),
    [sym__TypeExpr] = STATE(633),
    [sym_ErrorUnionExpr] = STATE(633),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_AsmExpr] = STATE(427),
    [sym_BlockLabel] = STATE(1676),
    [sym_IfPrefix] = STATE(279),
    [sym_WhilePrefix] = STATE(272),
    [sym_ForPrefix] = STATE(271),
    [sym_PrefixOp] = STATE(306),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [ts_builtin_sym_end] = ACTIONS(87),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_pub] = ACTIONS(101),
    [anon_sym_test] = ACTIONS(101),
    [anon_sym_comptime] = ACTIONS(171),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(175),
    [anon_sym_noinline] = ACTIONS(101),
    [anon_sym_threadlocal] = ACTIONS(101),
    [anon_sym_usingnamespace] = ACTIONS(101),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(97),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_var] = ACTIONS(101),
    [anon_sym_nosuspend] = ACTIONS(181),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_break] = ACTIONS(183),
    [anon_sym_continue] = ACTIONS(185),
    [anon_sym_resume] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_RBRACE] = ACTIONS(87),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_asm] = ACTIONS(205),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_EQ_EQ] = ACTIONS(87),
    [anon_sym_BANG_EQ] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(101),
    [anon_sym_GT] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(87),
    [anon_sym_GT_EQ] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(87),
    [anon_sym_orelse] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(87),
    [anon_sym_LT_LT_PIPE] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_PLUS_PERCENT] = ACTIONS(87),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_PLUS_PIPE] = ACTIONS(87),
    [anon_sym_DASH_PIPE] = ACTIONS(87),
    [anon_sym_PIPE_PIPE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(87),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_STAR_PERCENT] = ACTIONS(87),
    [anon_sym_STAR_PIPE] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(87),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [12] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(442),
    [sym_BinaryExpr] = STATE(442),
    [sym_UnaryExpr] = STATE(442),
    [sym__PrimaryExpr] = STATE(442),
    [sym_IfExpr] = STATE(442),
    [sym_Block] = STATE(442),
    [sym_LoopExpr] = STATE(442),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(442),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(442),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [ts_builtin_sym_end] = ACTIONS(155),
    [anon_sym_COMMA] = ACTIONS(155),
    [anon_sym_pub] = ACTIONS(157),
    [anon_sym_test] = ACTIONS(157),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_export] = ACTIONS(157),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_noinline] = ACTIONS(157),
    [anon_sym_threadlocal] = ACTIONS(157),
    [anon_sym_usingnamespace] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(97),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_var] = ACTIONS(157),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_or] = ACTIONS(157),
    [anon_sym_and] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_RBRACE] = ACTIONS(155),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(155),
    [anon_sym_orelse] = ACTIONS(157),
    [anon_sym_catch] = ACTIONS(157),
    [anon_sym_LT_LT] = ACTIONS(157),
    [anon_sym_GT_GT] = ACTIONS(155),
    [anon_sym_LT_LT_PIPE] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_PLUS_PLUS] = ACTIONS(155),
    [anon_sym_PLUS_PERCENT] = ACTIONS(155),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_PLUS_PIPE] = ACTIONS(155),
    [anon_sym_DASH_PIPE] = ACTIONS(155),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_PERCENT] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_STAR_PERCENT] = ACTIONS(155),
    [anon_sym_STAR_PIPE] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(155),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [13] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(447),
    [sym_BinaryExpr] = STATE(447),
    [sym_UnaryExpr] = STATE(447),
    [sym__PrimaryExpr] = STATE(447),
    [sym_IfExpr] = STATE(447),
    [sym_Block] = STATE(447),
    [sym_LoopExpr] = STATE(447),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(447),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(447),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [ts_builtin_sym_end] = ACTIONS(87),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_pub] = ACTIONS(101),
    [anon_sym_test] = ACTIONS(101),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_noinline] = ACTIONS(101),
    [anon_sym_threadlocal] = ACTIONS(101),
    [anon_sym_usingnamespace] = ACTIONS(101),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(97),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_var] = ACTIONS(101),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_RBRACE] = ACTIONS(87),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_EQ_EQ] = ACTIONS(87),
    [anon_sym_BANG_EQ] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(101),
    [anon_sym_GT] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(87),
    [anon_sym_GT_EQ] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(87),
    [anon_sym_orelse] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(87),
    [anon_sym_LT_LT_PIPE] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_PLUS_PERCENT] = ACTIONS(87),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_PLUS_PIPE] = ACTIONS(87),
    [anon_sym_DASH_PIPE] = ACTIONS(87),
    [anon_sym_PIPE_PIPE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(87),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_STAR_PERCENT] = ACTIONS(87),
    [anon_sym_STAR_PIPE] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(87),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [14] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1549),
    [sym_BinaryExpr] = STATE(1549),
    [sym_UnaryExpr] = STATE(1549),
    [sym__PrimaryExpr] = STATE(1549),
    [sym_IfExpr] = STATE(1549),
    [sym_Block] = STATE(1549),
    [sym_LoopExpr] = STATE(1549),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1549),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1549),
    [sym_BreakLabel] = STATE(16),
    [sym_BlockLabel] = STATE(1671),
    [sym_IfPrefix] = STATE(189),
    [sym_WhilePrefix] = STATE(177),
    [sym_ForPrefix] = STATE(193),
    [sym_PrefixOp] = STATE(233),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_comptime] = ACTIONS(275),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(279),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(97),
    [anon_sym_COLON] = ACTIONS(283),
    [anon_sym_nosuspend] = ACTIONS(285),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_break] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_EQ_GT] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(87),
    [anon_sym_BANG_EQ] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(101),
    [anon_sym_GT] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(87),
    [anon_sym_GT_EQ] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(87),
    [anon_sym_orelse] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(87),
    [anon_sym_LT_LT_PIPE] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_PLUS_PERCENT] = ACTIONS(87),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_PLUS_PIPE] = ACTIONS(87),
    [anon_sym_DASH_PIPE] = ACTIONS(87),
    [anon_sym_PIPE_PIPE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(87),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_STAR_PERCENT] = ACTIONS(87),
    [anon_sym_STAR_PIPE] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [15] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1571),
    [sym_BinaryExpr] = STATE(1571),
    [sym_UnaryExpr] = STATE(1571),
    [sym__PrimaryExpr] = STATE(1571),
    [sym_IfExpr] = STATE(1571),
    [sym_Block] = STATE(1571),
    [sym_LoopExpr] = STATE(1571),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1571),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1571),
    [sym_BreakLabel] = STATE(18),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(329),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(97),
    [anon_sym_COLON] = ACTIONS(331),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_EQ_GT] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(87),
    [anon_sym_BANG_EQ] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(101),
    [anon_sym_GT] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(87),
    [anon_sym_GT_EQ] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(87),
    [anon_sym_orelse] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(87),
    [anon_sym_LT_LT_PIPE] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_PLUS_PERCENT] = ACTIONS(87),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_PLUS_PIPE] = ACTIONS(87),
    [anon_sym_DASH_PIPE] = ACTIONS(87),
    [anon_sym_PIPE_PIPE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(87),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_STAR_PERCENT] = ACTIONS(87),
    [anon_sym_STAR_PIPE] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [16] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1552),
    [sym_BinaryExpr] = STATE(1552),
    [sym_UnaryExpr] = STATE(1552),
    [sym__PrimaryExpr] = STATE(1552),
    [sym_IfExpr] = STATE(1552),
    [sym_Block] = STATE(1552),
    [sym_LoopExpr] = STATE(1552),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1552),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1552),
    [sym_BlockLabel] = STATE(1671),
    [sym_IfPrefix] = STATE(189),
    [sym_WhilePrefix] = STATE(177),
    [sym_ForPrefix] = STATE(193),
    [sym_PrefixOp] = STATE(233),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_COMMA] = ACTIONS(155),
    [anon_sym_comptime] = ACTIONS(275),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(279),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(97),
    [anon_sym_nosuspend] = ACTIONS(285),
    [anon_sym_else] = ACTIONS(157),
    [anon_sym_or] = ACTIONS(157),
    [anon_sym_and] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_EQ_GT] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(155),
    [anon_sym_orelse] = ACTIONS(157),
    [anon_sym_catch] = ACTIONS(157),
    [anon_sym_LT_LT] = ACTIONS(157),
    [anon_sym_GT_GT] = ACTIONS(155),
    [anon_sym_LT_LT_PIPE] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_PLUS_PLUS] = ACTIONS(155),
    [anon_sym_PLUS_PERCENT] = ACTIONS(155),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_PLUS_PIPE] = ACTIONS(155),
    [anon_sym_DASH_PIPE] = ACTIONS(155),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_PERCENT] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_STAR_PERCENT] = ACTIONS(155),
    [anon_sym_STAR_PIPE] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [17] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1549),
    [sym_BinaryExpr] = STATE(1549),
    [sym_UnaryExpr] = STATE(1549),
    [sym__PrimaryExpr] = STATE(1549),
    [sym_IfExpr] = STATE(1549),
    [sym_Block] = STATE(1549),
    [sym_LoopExpr] = STATE(1549),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1549),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1549),
    [sym_BlockLabel] = STATE(1671),
    [sym_IfPrefix] = STATE(189),
    [sym_WhilePrefix] = STATE(177),
    [sym_ForPrefix] = STATE(193),
    [sym_PrefixOp] = STATE(233),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_comptime] = ACTIONS(275),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(279),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(97),
    [anon_sym_nosuspend] = ACTIONS(285),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_break] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_EQ_GT] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(87),
    [anon_sym_BANG_EQ] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(101),
    [anon_sym_GT] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(87),
    [anon_sym_GT_EQ] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(87),
    [anon_sym_orelse] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(87),
    [anon_sym_LT_LT_PIPE] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_PLUS_PERCENT] = ACTIONS(87),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_PLUS_PIPE] = ACTIONS(87),
    [anon_sym_DASH_PIPE] = ACTIONS(87),
    [anon_sym_PIPE_PIPE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(87),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_STAR_PERCENT] = ACTIONS(87),
    [anon_sym_STAR_PIPE] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [18] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1570),
    [sym_BinaryExpr] = STATE(1570),
    [sym_UnaryExpr] = STATE(1570),
    [sym__PrimaryExpr] = STATE(1570),
    [sym_IfExpr] = STATE(1570),
    [sym_Block] = STATE(1570),
    [sym_LoopExpr] = STATE(1570),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1570),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1570),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_COMMA] = ACTIONS(155),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(329),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(97),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(157),
    [anon_sym_and] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_EQ_GT] = ACTIONS(155),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(155),
    [anon_sym_orelse] = ACTIONS(157),
    [anon_sym_catch] = ACTIONS(157),
    [anon_sym_LT_LT] = ACTIONS(157),
    [anon_sym_GT_GT] = ACTIONS(155),
    [anon_sym_LT_LT_PIPE] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_PLUS_PLUS] = ACTIONS(155),
    [anon_sym_PLUS_PERCENT] = ACTIONS(155),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_PLUS_PIPE] = ACTIONS(155),
    [anon_sym_DASH_PIPE] = ACTIONS(155),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_PERCENT] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_STAR_PERCENT] = ACTIONS(155),
    [anon_sym_STAR_PIPE] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [19] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1571),
    [sym_BinaryExpr] = STATE(1571),
    [sym_UnaryExpr] = STATE(1571),
    [sym__PrimaryExpr] = STATE(1571),
    [sym_IfExpr] = STATE(1571),
    [sym_Block] = STATE(1571),
    [sym_LoopExpr] = STATE(1571),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1571),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1571),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(329),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(97),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(297),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_EQ_GT] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(87),
    [anon_sym_BANG_EQ] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(101),
    [anon_sym_GT] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(87),
    [anon_sym_GT_EQ] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(87),
    [anon_sym_orelse] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(87),
    [anon_sym_LT_LT_PIPE] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_PLUS_PERCENT] = ACTIONS(87),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_PLUS_PIPE] = ACTIONS(87),
    [anon_sym_DASH_PIPE] = ACTIONS(87),
    [anon_sym_PIPE_PIPE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(87),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_STAR_PERCENT] = ACTIONS(87),
    [anon_sym_STAR_PIPE] = ACTIONS(87),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [20] = {
    [sym_FnProto] = STATE(935),
    [sym_VarDecl] = STATE(1113),
    [sym_Statement] = STATE(29),
    [sym_IfStatement] = STATE(1113),
    [sym_LabeledStatement] = STATE(1113),
    [sym_LoopStatement] = STATE(1118),
    [sym_ForStatement] = STATE(1126),
    [sym_WhileStatement] = STATE(1126),
    [sym_AssignExpr] = STATE(2173),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(87),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(47),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1666),
    [sym_IfPrefix] = STATE(112),
    [sym_WhilePrefix] = STATE(115),
    [sym_ForPrefix] = STATE(119),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym_Block_repeat1] = STATE(29),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(339),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(341),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_var] = ACTIONS(343),
    [anon_sym_nosuspend] = ACTIONS(345),
    [anon_sym_defer] = ACTIONS(347),
    [anon_sym_suspend] = ACTIONS(347),
    [anon_sym_errdefer] = ACTIONS(349),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_RBRACE] = ACTIONS(353),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [21] = {
    [sym_FnProto] = STATE(935),
    [sym_VarDecl] = STATE(1113),
    [sym_Statement] = STATE(28),
    [sym_IfStatement] = STATE(1113),
    [sym_LabeledStatement] = STATE(1113),
    [sym_LoopStatement] = STATE(1118),
    [sym_ForStatement] = STATE(1126),
    [sym_WhileStatement] = STATE(1126),
    [sym_AssignExpr] = STATE(2173),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(87),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(47),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1666),
    [sym_IfPrefix] = STATE(112),
    [sym_WhilePrefix] = STATE(115),
    [sym_ForPrefix] = STATE(119),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym_Block_repeat1] = STATE(28),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(339),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(341),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_var] = ACTIONS(343),
    [anon_sym_nosuspend] = ACTIONS(345),
    [anon_sym_defer] = ACTIONS(347),
    [anon_sym_suspend] = ACTIONS(347),
    [anon_sym_errdefer] = ACTIONS(349),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_RBRACE] = ACTIONS(359),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [22] = {
    [sym_FnProto] = STATE(935),
    [sym_VarDecl] = STATE(1113),
    [sym_Statement] = STATE(24),
    [sym_IfStatement] = STATE(1113),
    [sym_LabeledStatement] = STATE(1113),
    [sym_LoopStatement] = STATE(1118),
    [sym_ForStatement] = STATE(1126),
    [sym_WhileStatement] = STATE(1126),
    [sym_AssignExpr] = STATE(2173),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(87),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(47),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1666),
    [sym_IfPrefix] = STATE(112),
    [sym_WhilePrefix] = STATE(115),
    [sym_ForPrefix] = STATE(119),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym_Block_repeat1] = STATE(24),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(339),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(341),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_var] = ACTIONS(343),
    [anon_sym_nosuspend] = ACTIONS(345),
    [anon_sym_defer] = ACTIONS(347),
    [anon_sym_suspend] = ACTIONS(347),
    [anon_sym_errdefer] = ACTIONS(349),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_RBRACE] = ACTIONS(361),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [23] = {
    [sym_FnProto] = STATE(935),
    [sym_VarDecl] = STATE(1113),
    [sym_Statement] = STATE(37),
    [sym_IfStatement] = STATE(1113),
    [sym_LabeledStatement] = STATE(1113),
    [sym_LoopStatement] = STATE(1118),
    [sym_ForStatement] = STATE(1126),
    [sym_WhileStatement] = STATE(1126),
    [sym_AssignExpr] = STATE(2173),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(87),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(47),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1666),
    [sym_IfPrefix] = STATE(112),
    [sym_WhilePrefix] = STATE(115),
    [sym_ForPrefix] = STATE(119),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym_Block_repeat1] = STATE(37),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(339),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(341),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_var] = ACTIONS(343),
    [anon_sym_nosuspend] = ACTIONS(345),
    [anon_sym_defer] = ACTIONS(347),
    [anon_sym_suspend] = ACTIONS(347),
    [anon_sym_errdefer] = ACTIONS(349),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [24] = {
    [sym_FnProto] = STATE(935),
    [sym_VarDecl] = STATE(1113),
    [sym_Statement] = STATE(29),
    [sym_IfStatement] = STATE(1113),
    [sym_LabeledStatement] = STATE(1113),
    [sym_LoopStatement] = STATE(1118),
    [sym_ForStatement] = STATE(1126),
    [sym_WhileStatement] = STATE(1126),
    [sym_AssignExpr] = STATE(2173),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(87),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(47),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1666),
    [sym_IfPrefix] = STATE(112),
    [sym_WhilePrefix] = STATE(115),
    [sym_ForPrefix] = STATE(119),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym_Block_repeat1] = STATE(29),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(339),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(341),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_var] = ACTIONS(343),
    [anon_sym_nosuspend] = ACTIONS(345),
    [anon_sym_defer] = ACTIONS(347),
    [anon_sym_suspend] = ACTIONS(347),
    [anon_sym_errdefer] = ACTIONS(349),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [25] = {
    [sym_FnProto] = STATE(935),
    [sym_VarDecl] = STATE(1113),
    [sym_Statement] = STATE(29),
    [sym_IfStatement] = STATE(1113),
    [sym_LabeledStatement] = STATE(1113),
    [sym_LoopStatement] = STATE(1118),
    [sym_ForStatement] = STATE(1126),
    [sym_WhileStatement] = STATE(1126),
    [sym_AssignExpr] = STATE(2173),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(87),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(47),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1666),
    [sym_IfPrefix] = STATE(112),
    [sym_WhilePrefix] = STATE(115),
    [sym_ForPrefix] = STATE(119),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym_Block_repeat1] = STATE(29),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(339),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(341),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_var] = ACTIONS(343),
    [anon_sym_nosuspend] = ACTIONS(345),
    [anon_sym_defer] = ACTIONS(347),
    [anon_sym_suspend] = ACTIONS(347),
    [anon_sym_errdefer] = ACTIONS(349),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_RBRACE] = ACTIONS(367),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [26] = {
    [sym_FnProto] = STATE(935),
    [sym_VarDecl] = STATE(1113),
    [sym_Statement] = STATE(39),
    [sym_IfStatement] = STATE(1113),
    [sym_LabeledStatement] = STATE(1113),
    [sym_LoopStatement] = STATE(1118),
    [sym_ForStatement] = STATE(1126),
    [sym_WhileStatement] = STATE(1126),
    [sym_AssignExpr] = STATE(2173),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(87),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(47),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1666),
    [sym_IfPrefix] = STATE(112),
    [sym_WhilePrefix] = STATE(115),
    [sym_ForPrefix] = STATE(119),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym_Block_repeat1] = STATE(39),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(339),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(341),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_var] = ACTIONS(343),
    [anon_sym_nosuspend] = ACTIONS(345),
    [anon_sym_defer] = ACTIONS(347),
    [anon_sym_suspend] = ACTIONS(347),
    [anon_sym_errdefer] = ACTIONS(349),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_RBRACE] = ACTIONS(369),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [27] = {
    [sym_FnProto] = STATE(935),
    [sym_VarDecl] = STATE(1113),
    [sym_Statement] = STATE(29),
    [sym_IfStatement] = STATE(1113),
    [sym_LabeledStatement] = STATE(1113),
    [sym_LoopStatement] = STATE(1118),
    [sym_ForStatement] = STATE(1126),
    [sym_WhileStatement] = STATE(1126),
    [sym_AssignExpr] = STATE(2173),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(87),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(47),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1666),
    [sym_IfPrefix] = STATE(112),
    [sym_WhilePrefix] = STATE(115),
    [sym_ForPrefix] = STATE(119),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym_Block_repeat1] = STATE(29),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(339),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(341),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_var] = ACTIONS(343),
    [anon_sym_nosuspend] = ACTIONS(345),
    [anon_sym_defer] = ACTIONS(347),
    [anon_sym_suspend] = ACTIONS(347),
    [anon_sym_errdefer] = ACTIONS(349),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_RBRACE] = ACTIONS(371),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [28] = {
    [sym_FnProto] = STATE(935),
    [sym_VarDecl] = STATE(1113),
    [sym_Statement] = STATE(29),
    [sym_IfStatement] = STATE(1113),
    [sym_LabeledStatement] = STATE(1113),
    [sym_LoopStatement] = STATE(1118),
    [sym_ForStatement] = STATE(1126),
    [sym_WhileStatement] = STATE(1126),
    [sym_AssignExpr] = STATE(2173),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(87),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(47),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1666),
    [sym_IfPrefix] = STATE(112),
    [sym_WhilePrefix] = STATE(115),
    [sym_ForPrefix] = STATE(119),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym_Block_repeat1] = STATE(29),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(339),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(341),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_var] = ACTIONS(343),
    [anon_sym_nosuspend] = ACTIONS(345),
    [anon_sym_defer] = ACTIONS(347),
    [anon_sym_suspend] = ACTIONS(347),
    [anon_sym_errdefer] = ACTIONS(349),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_RBRACE] = ACTIONS(373),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [29] = {
    [sym_FnProto] = STATE(935),
    [sym_VarDecl] = STATE(1113),
    [sym_Statement] = STATE(29),
    [sym_IfStatement] = STATE(1113),
    [sym_LabeledStatement] = STATE(1113),
    [sym_LoopStatement] = STATE(1118),
    [sym_ForStatement] = STATE(1126),
    [sym_WhileStatement] = STATE(1126),
    [sym_AssignExpr] = STATE(2173),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(87),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(47),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1666),
    [sym_IfPrefix] = STATE(112),
    [sym_WhilePrefix] = STATE(115),
    [sym_ForPrefix] = STATE(119),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym_Block_repeat1] = STATE(29),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(375),
    [anon_sym_extern] = ACTIONS(378),
    [anon_sym_inline] = ACTIONS(381),
    [anon_sym_fn] = ACTIONS(384),
    [anon_sym_BANG] = ACTIONS(387),
    [anon_sym_const] = ACTIONS(390),
    [anon_sym_var] = ACTIONS(390),
    [anon_sym_nosuspend] = ACTIONS(393),
    [anon_sym_defer] = ACTIONS(396),
    [anon_sym_suspend] = ACTIONS(396),
    [anon_sym_errdefer] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(402),
    [anon_sym_continue] = ACTIONS(405),
    [anon_sym_resume] = ACTIONS(408),
    [anon_sym_return] = ACTIONS(411),
    [anon_sym_LBRACE] = ACTIONS(414),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_async] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(422),
    [anon_sym_error] = ACTIONS(425),
    [anon_sym_false] = ACTIONS(428),
    [anon_sym_null] = ACTIONS(428),
    [anon_sym_anyframe] = ACTIONS(431),
    [anon_sym_true] = ACTIONS(428),
    [anon_sym_undefined] = ACTIONS(428),
    [anon_sym_unreachable] = ACTIONS(428),
    [sym_BuildinTypeExpr] = ACTIONS(428),
    [anon_sym_packed] = ACTIONS(378),
    [anon_sym_LPAREN] = ACTIONS(434),
    [anon_sym_switch] = ACTIONS(437),
    [anon_sym_asm] = ACTIONS(440),
    [anon_sym_LBRACK] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(446),
    [anon_sym_while] = ACTIONS(449),
    [anon_sym_for] = ACTIONS(452),
    [anon_sym_STAR] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(458),
    [anon_sym_DASH_PERCENT] = ACTIONS(387),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_TILDE] = ACTIONS(387),
    [anon_sym_try] = ACTIONS(458),
    [anon_sym_await] = ACTIONS(458),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_struct] = ACTIONS(467),
    [anon_sym_opaque] = ACTIONS(470),
    [anon_sym_enum] = ACTIONS(467),
    [anon_sym_union] = ACTIONS(473),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(476),
    [aux_sym_FLOAT_token1] = ACTIONS(479),
    [aux_sym_FLOAT_token2] = ACTIONS(479),
    [aux_sym_FLOAT_token3] = ACTIONS(479),
    [aux_sym_FLOAT_token4] = ACTIONS(479),
    [aux_sym_INTEGER_token1] = ACTIONS(482),
    [aux_sym_INTEGER_token2] = ACTIONS(482),
    [aux_sym_INTEGER_token3] = ACTIONS(485),
    [aux_sym_INTEGER_token4] = ACTIONS(485),
    [anon_sym_DQUOTE] = ACTIONS(488),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(491),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(494),
    [anon_sym_AT] = ACTIONS(497),
  },
  [30] = {
    [sym_FnProto] = STATE(935),
    [sym_VarDecl] = STATE(1113),
    [sym_Statement] = STATE(20),
    [sym_IfStatement] = STATE(1113),
    [sym_LabeledStatement] = STATE(1113),
    [sym_LoopStatement] = STATE(1118),
    [sym_ForStatement] = STATE(1126),
    [sym_WhileStatement] = STATE(1126),
    [sym_AssignExpr] = STATE(2173),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(87),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(47),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1666),
    [sym_IfPrefix] = STATE(112),
    [sym_WhilePrefix] = STATE(115),
    [sym_ForPrefix] = STATE(119),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym_Block_repeat1] = STATE(20),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(339),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(341),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_var] = ACTIONS(343),
    [anon_sym_nosuspend] = ACTIONS(345),
    [anon_sym_defer] = ACTIONS(347),
    [anon_sym_suspend] = ACTIONS(347),
    [anon_sym_errdefer] = ACTIONS(349),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_RBRACE] = ACTIONS(500),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [31] = {
    [sym_FnProto] = STATE(935),
    [sym_VarDecl] = STATE(1113),
    [sym_Statement] = STATE(29),
    [sym_IfStatement] = STATE(1113),
    [sym_LabeledStatement] = STATE(1113),
    [sym_LoopStatement] = STATE(1118),
    [sym_ForStatement] = STATE(1126),
    [sym_WhileStatement] = STATE(1126),
    [sym_AssignExpr] = STATE(2173),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(87),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(47),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1666),
    [sym_IfPrefix] = STATE(112),
    [sym_WhilePrefix] = STATE(115),
    [sym_ForPrefix] = STATE(119),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym_Block_repeat1] = STATE(29),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(339),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(341),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_var] = ACTIONS(343),
    [anon_sym_nosuspend] = ACTIONS(345),
    [anon_sym_defer] = ACTIONS(347),
    [anon_sym_suspend] = ACTIONS(347),
    [anon_sym_errdefer] = ACTIONS(349),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_RBRACE] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [32] = {
    [sym_FnProto] = STATE(935),
    [sym_VarDecl] = STATE(1113),
    [sym_Statement] = STATE(27),
    [sym_IfStatement] = STATE(1113),
    [sym_LabeledStatement] = STATE(1113),
    [sym_LoopStatement] = STATE(1118),
    [sym_ForStatement] = STATE(1126),
    [sym_WhileStatement] = STATE(1126),
    [sym_AssignExpr] = STATE(2173),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(87),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(47),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1666),
    [sym_IfPrefix] = STATE(112),
    [sym_WhilePrefix] = STATE(115),
    [sym_ForPrefix] = STATE(119),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym_Block_repeat1] = STATE(27),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(339),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(341),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_var] = ACTIONS(343),
    [anon_sym_nosuspend] = ACTIONS(345),
    [anon_sym_defer] = ACTIONS(347),
    [anon_sym_suspend] = ACTIONS(347),
    [anon_sym_errdefer] = ACTIONS(349),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_RBRACE] = ACTIONS(504),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [33] = {
    [sym_FnProto] = STATE(935),
    [sym_VarDecl] = STATE(1113),
    [sym_Statement] = STATE(29),
    [sym_IfStatement] = STATE(1113),
    [sym_LabeledStatement] = STATE(1113),
    [sym_LoopStatement] = STATE(1118),
    [sym_ForStatement] = STATE(1126),
    [sym_WhileStatement] = STATE(1126),
    [sym_AssignExpr] = STATE(2173),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(87),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(47),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1666),
    [sym_IfPrefix] = STATE(112),
    [sym_WhilePrefix] = STATE(115),
    [sym_ForPrefix] = STATE(119),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym_Block_repeat1] = STATE(29),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(339),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(341),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_var] = ACTIONS(343),
    [anon_sym_nosuspend] = ACTIONS(345),
    [anon_sym_defer] = ACTIONS(347),
    [anon_sym_suspend] = ACTIONS(347),
    [anon_sym_errdefer] = ACTIONS(349),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_RBRACE] = ACTIONS(506),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [34] = {
    [sym_FnProto] = STATE(935),
    [sym_VarDecl] = STATE(1113),
    [sym_Statement] = STATE(33),
    [sym_IfStatement] = STATE(1113),
    [sym_LabeledStatement] = STATE(1113),
    [sym_LoopStatement] = STATE(1118),
    [sym_ForStatement] = STATE(1126),
    [sym_WhileStatement] = STATE(1126),
    [sym_AssignExpr] = STATE(2173),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(87),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(47),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1666),
    [sym_IfPrefix] = STATE(112),
    [sym_WhilePrefix] = STATE(115),
    [sym_ForPrefix] = STATE(119),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym_Block_repeat1] = STATE(33),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(339),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(341),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_var] = ACTIONS(343),
    [anon_sym_nosuspend] = ACTIONS(345),
    [anon_sym_defer] = ACTIONS(347),
    [anon_sym_suspend] = ACTIONS(347),
    [anon_sym_errdefer] = ACTIONS(349),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_RBRACE] = ACTIONS(508),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [35] = {
    [sym_FnProto] = STATE(935),
    [sym_VarDecl] = STATE(1113),
    [sym_Statement] = STATE(25),
    [sym_IfStatement] = STATE(1113),
    [sym_LabeledStatement] = STATE(1113),
    [sym_LoopStatement] = STATE(1118),
    [sym_ForStatement] = STATE(1126),
    [sym_WhileStatement] = STATE(1126),
    [sym_AssignExpr] = STATE(2173),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(87),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(47),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1666),
    [sym_IfPrefix] = STATE(112),
    [sym_WhilePrefix] = STATE(115),
    [sym_ForPrefix] = STATE(119),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym_Block_repeat1] = STATE(25),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(339),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(341),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_var] = ACTIONS(343),
    [anon_sym_nosuspend] = ACTIONS(345),
    [anon_sym_defer] = ACTIONS(347),
    [anon_sym_suspend] = ACTIONS(347),
    [anon_sym_errdefer] = ACTIONS(349),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_RBRACE] = ACTIONS(510),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [36] = {
    [sym_FnProto] = STATE(935),
    [sym_VarDecl] = STATE(1113),
    [sym_Statement] = STATE(31),
    [sym_IfStatement] = STATE(1113),
    [sym_LabeledStatement] = STATE(1113),
    [sym_LoopStatement] = STATE(1118),
    [sym_ForStatement] = STATE(1126),
    [sym_WhileStatement] = STATE(1126),
    [sym_AssignExpr] = STATE(2173),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(87),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(47),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1666),
    [sym_IfPrefix] = STATE(112),
    [sym_WhilePrefix] = STATE(115),
    [sym_ForPrefix] = STATE(119),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym_Block_repeat1] = STATE(31),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(339),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(341),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_var] = ACTIONS(343),
    [anon_sym_nosuspend] = ACTIONS(345),
    [anon_sym_defer] = ACTIONS(347),
    [anon_sym_suspend] = ACTIONS(347),
    [anon_sym_errdefer] = ACTIONS(349),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_RBRACE] = ACTIONS(512),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [37] = {
    [sym_FnProto] = STATE(935),
    [sym_VarDecl] = STATE(1113),
    [sym_Statement] = STATE(29),
    [sym_IfStatement] = STATE(1113),
    [sym_LabeledStatement] = STATE(1113),
    [sym_LoopStatement] = STATE(1118),
    [sym_ForStatement] = STATE(1126),
    [sym_WhileStatement] = STATE(1126),
    [sym_AssignExpr] = STATE(2173),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(87),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(47),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1666),
    [sym_IfPrefix] = STATE(112),
    [sym_WhilePrefix] = STATE(115),
    [sym_ForPrefix] = STATE(119),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym_Block_repeat1] = STATE(29),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(339),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(341),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_var] = ACTIONS(343),
    [anon_sym_nosuspend] = ACTIONS(345),
    [anon_sym_defer] = ACTIONS(347),
    [anon_sym_suspend] = ACTIONS(347),
    [anon_sym_errdefer] = ACTIONS(349),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_RBRACE] = ACTIONS(514),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [38] = {
    [sym_FnProto] = STATE(935),
    [sym_VarDecl] = STATE(1113),
    [sym_Statement] = STATE(1146),
    [sym_IfStatement] = STATE(1113),
    [sym_LabeledStatement] = STATE(1113),
    [sym_LoopStatement] = STATE(1118),
    [sym_ForStatement] = STATE(1126),
    [sym_WhileStatement] = STATE(1126),
    [sym_AssignExpr] = STATE(2173),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(87),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(47),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1666),
    [sym_IfPrefix] = STATE(112),
    [sym_WhilePrefix] = STATE(115),
    [sym_ForPrefix] = STATE(119),
    [sym_Payload] = STATE(40),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(339),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(341),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_var] = ACTIONS(343),
    [anon_sym_nosuspend] = ACTIONS(345),
    [anon_sym_defer] = ACTIONS(347),
    [anon_sym_suspend] = ACTIONS(347),
    [anon_sym_errdefer] = ACTIONS(349),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [39] = {
    [sym_FnProto] = STATE(935),
    [sym_VarDecl] = STATE(1113),
    [sym_Statement] = STATE(29),
    [sym_IfStatement] = STATE(1113),
    [sym_LabeledStatement] = STATE(1113),
    [sym_LoopStatement] = STATE(1118),
    [sym_ForStatement] = STATE(1126),
    [sym_WhileStatement] = STATE(1126),
    [sym_AssignExpr] = STATE(2173),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(87),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(47),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1666),
    [sym_IfPrefix] = STATE(112),
    [sym_WhilePrefix] = STATE(115),
    [sym_ForPrefix] = STATE(119),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym_Block_repeat1] = STATE(29),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(339),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(341),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_var] = ACTIONS(343),
    [anon_sym_nosuspend] = ACTIONS(345),
    [anon_sym_defer] = ACTIONS(347),
    [anon_sym_suspend] = ACTIONS(347),
    [anon_sym_errdefer] = ACTIONS(349),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_RBRACE] = ACTIONS(518),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [40] = {
    [sym_FnProto] = STATE(935),
    [sym_VarDecl] = STATE(1113),
    [sym_Statement] = STATE(1117),
    [sym_IfStatement] = STATE(1113),
    [sym_LabeledStatement] = STATE(1113),
    [sym_LoopStatement] = STATE(1118),
    [sym_ForStatement] = STATE(1126),
    [sym_WhileStatement] = STATE(1126),
    [sym_AssignExpr] = STATE(2173),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(87),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(47),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1666),
    [sym_IfPrefix] = STATE(112),
    [sym_WhilePrefix] = STATE(115),
    [sym_ForPrefix] = STATE(119),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(339),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(341),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_var] = ACTIONS(343),
    [anon_sym_nosuspend] = ACTIONS(345),
    [anon_sym_defer] = ACTIONS(347),
    [anon_sym_suspend] = ACTIONS(347),
    [anon_sym_errdefer] = ACTIONS(349),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [41] = {
    [anon_sym_comptime] = ACTIONS(520),
    [anon_sym_extern] = ACTIONS(520),
    [anon_sym_inline] = ACTIONS(520),
    [anon_sym_SEMI] = ACTIONS(522),
    [anon_sym_fn] = ACTIONS(520),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_const] = ACTIONS(520),
    [anon_sym_var] = ACTIONS(520),
    [anon_sym_EQ] = ACTIONS(524),
    [anon_sym_nosuspend] = ACTIONS(520),
    [anon_sym_defer] = ACTIONS(520),
    [anon_sym_suspend] = ACTIONS(520),
    [anon_sym_errdefer] = ACTIONS(520),
    [anon_sym_else] = ACTIONS(520),
    [anon_sym_or] = ACTIONS(524),
    [anon_sym_and] = ACTIONS(524),
    [anon_sym_break] = ACTIONS(520),
    [anon_sym_continue] = ACTIONS(520),
    [anon_sym_resume] = ACTIONS(520),
    [anon_sym_return] = ACTIONS(520),
    [anon_sym_LBRACE] = ACTIONS(526),
    [anon_sym_RBRACE] = ACTIONS(526),
    [anon_sym_async] = ACTIONS(520),
    [anon_sym_DOT] = ACTIONS(520),
    [anon_sym_error] = ACTIONS(520),
    [anon_sym_false] = ACTIONS(520),
    [anon_sym_null] = ACTIONS(520),
    [anon_sym_anyframe] = ACTIONS(520),
    [anon_sym_true] = ACTIONS(520),
    [anon_sym_undefined] = ACTIONS(520),
    [anon_sym_unreachable] = ACTIONS(520),
    [sym_BuildinTypeExpr] = ACTIONS(520),
    [anon_sym_packed] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(526),
    [anon_sym_switch] = ACTIONS(520),
    [anon_sym_asm] = ACTIONS(520),
    [anon_sym_LBRACK] = ACTIONS(526),
    [anon_sym_if] = ACTIONS(520),
    [anon_sym_while] = ACTIONS(520),
    [anon_sym_for] = ACTIONS(520),
    [anon_sym_PIPE] = ACTIONS(524),
    [anon_sym_STAR] = ACTIONS(520),
    [anon_sym_STAR_EQ] = ACTIONS(522),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(522),
    [anon_sym_SLASH_EQ] = ACTIONS(522),
    [anon_sym_PERCENT_EQ] = ACTIONS(522),
    [anon_sym_PLUS_EQ] = ACTIONS(522),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(522),
    [anon_sym_DASH_EQ] = ACTIONS(522),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(522),
    [anon_sym_LT_LT_EQ] = ACTIONS(522),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(522),
    [anon_sym_GT_GT_EQ] = ACTIONS(522),
    [anon_sym_AMP_EQ] = ACTIONS(522),
    [anon_sym_CARET_EQ] = ACTIONS(522),
    [anon_sym_PIPE_EQ] = ACTIONS(522),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(522),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(522),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(522),
    [anon_sym_EQ_EQ] = ACTIONS(522),
    [anon_sym_BANG_EQ] = ACTIONS(522),
    [anon_sym_LT] = ACTIONS(524),
    [anon_sym_GT] = ACTIONS(524),
    [anon_sym_LT_EQ] = ACTIONS(522),
    [anon_sym_GT_EQ] = ACTIONS(522),
    [anon_sym_AMP] = ACTIONS(520),
    [anon_sym_CARET] = ACTIONS(524),
    [anon_sym_orelse] = ACTIONS(524),
    [anon_sym_catch] = ACTIONS(524),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_GT_GT] = ACTIONS(524),
    [anon_sym_LT_LT_PIPE] = ACTIONS(524),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_PLUS_PLUS] = ACTIONS(522),
    [anon_sym_PLUS_PERCENT] = ACTIONS(524),
    [anon_sym_DASH_PERCENT] = ACTIONS(520),
    [anon_sym_PLUS_PIPE] = ACTIONS(524),
    [anon_sym_DASH_PIPE] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(522),
    [anon_sym_SLASH] = ACTIONS(524),
    [anon_sym_PERCENT] = ACTIONS(524),
    [anon_sym_STAR_STAR] = ACTIONS(526),
    [anon_sym_STAR_PERCENT] = ACTIONS(524),
    [anon_sym_STAR_PIPE] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(526),
    [anon_sym_try] = ACTIONS(520),
    [anon_sym_await] = ACTIONS(520),
    [anon_sym_QMARK] = ACTIONS(526),
    [anon_sym_DOT_STAR] = ACTIONS(522),
    [anon_sym_DOT_QMARK] = ACTIONS(522),
    [anon_sym_struct] = ACTIONS(520),
    [anon_sym_opaque] = ACTIONS(520),
    [anon_sym_enum] = ACTIONS(520),
    [anon_sym_union] = ACTIONS(520),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(526),
    [aux_sym_FLOAT_token1] = ACTIONS(526),
    [aux_sym_FLOAT_token2] = ACTIONS(526),
    [aux_sym_FLOAT_token3] = ACTIONS(526),
    [aux_sym_FLOAT_token4] = ACTIONS(526),
    [aux_sym_INTEGER_token1] = ACTIONS(526),
    [aux_sym_INTEGER_token2] = ACTIONS(526),
    [aux_sym_INTEGER_token3] = ACTIONS(520),
    [aux_sym_INTEGER_token4] = ACTIONS(520),
    [anon_sym_DQUOTE] = ACTIONS(526),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(526),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(520),
    [anon_sym_AT] = ACTIONS(526),
  },
  [42] = {
    [anon_sym_comptime] = ACTIONS(528),
    [anon_sym_extern] = ACTIONS(528),
    [anon_sym_inline] = ACTIONS(528),
    [anon_sym_SEMI] = ACTIONS(530),
    [anon_sym_fn] = ACTIONS(528),
    [anon_sym_BANG] = ACTIONS(528),
    [anon_sym_const] = ACTIONS(528),
    [anon_sym_var] = ACTIONS(528),
    [anon_sym_EQ] = ACTIONS(528),
    [anon_sym_nosuspend] = ACTIONS(528),
    [anon_sym_defer] = ACTIONS(528),
    [anon_sym_suspend] = ACTIONS(528),
    [anon_sym_errdefer] = ACTIONS(528),
    [anon_sym_else] = ACTIONS(528),
    [anon_sym_or] = ACTIONS(528),
    [anon_sym_and] = ACTIONS(528),
    [anon_sym_break] = ACTIONS(528),
    [anon_sym_continue] = ACTIONS(528),
    [anon_sym_resume] = ACTIONS(528),
    [anon_sym_return] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(528),
    [anon_sym_DOT] = ACTIONS(528),
    [anon_sym_error] = ACTIONS(528),
    [anon_sym_false] = ACTIONS(528),
    [anon_sym_null] = ACTIONS(528),
    [anon_sym_anyframe] = ACTIONS(528),
    [anon_sym_true] = ACTIONS(528),
    [anon_sym_undefined] = ACTIONS(528),
    [anon_sym_unreachable] = ACTIONS(528),
    [sym_BuildinTypeExpr] = ACTIONS(528),
    [anon_sym_packed] = ACTIONS(528),
    [anon_sym_LPAREN] = ACTIONS(530),
    [anon_sym_switch] = ACTIONS(528),
    [anon_sym_asm] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(530),
    [anon_sym_if] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(528),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_STAR_EQ] = ACTIONS(530),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(530),
    [anon_sym_SLASH_EQ] = ACTIONS(530),
    [anon_sym_PERCENT_EQ] = ACTIONS(530),
    [anon_sym_PLUS_EQ] = ACTIONS(530),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(530),
    [anon_sym_DASH_EQ] = ACTIONS(530),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(530),
    [anon_sym_LT_LT_EQ] = ACTIONS(530),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(530),
    [anon_sym_GT_GT_EQ] = ACTIONS(530),
    [anon_sym_AMP_EQ] = ACTIONS(530),
    [anon_sym_CARET_EQ] = ACTIONS(530),
    [anon_sym_PIPE_EQ] = ACTIONS(530),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(530),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(530),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(530),
    [anon_sym_EQ_EQ] = ACTIONS(530),
    [anon_sym_BANG_EQ] = ACTIONS(530),
    [anon_sym_LT] = ACTIONS(528),
    [anon_sym_GT] = ACTIONS(528),
    [anon_sym_LT_EQ] = ACTIONS(530),
    [anon_sym_GT_EQ] = ACTIONS(530),
    [anon_sym_AMP] = ACTIONS(528),
    [anon_sym_CARET] = ACTIONS(528),
    [anon_sym_orelse] = ACTIONS(528),
    [anon_sym_catch] = ACTIONS(528),
    [anon_sym_LT_LT] = ACTIONS(528),
    [anon_sym_GT_GT] = ACTIONS(528),
    [anon_sym_LT_LT_PIPE] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(528),
    [anon_sym_DASH] = ACTIONS(528),
    [anon_sym_PLUS_PLUS] = ACTIONS(530),
    [anon_sym_PLUS_PERCENT] = ACTIONS(528),
    [anon_sym_DASH_PERCENT] = ACTIONS(528),
    [anon_sym_PLUS_PIPE] = ACTIONS(528),
    [anon_sym_DASH_PIPE] = ACTIONS(528),
    [anon_sym_PIPE_PIPE] = ACTIONS(530),
    [anon_sym_SLASH] = ACTIONS(528),
    [anon_sym_PERCENT] = ACTIONS(528),
    [anon_sym_STAR_STAR] = ACTIONS(530),
    [anon_sym_STAR_PERCENT] = ACTIONS(528),
    [anon_sym_STAR_PIPE] = ACTIONS(528),
    [anon_sym_TILDE] = ACTIONS(530),
    [anon_sym_try] = ACTIONS(528),
    [anon_sym_await] = ACTIONS(528),
    [anon_sym_QMARK] = ACTIONS(530),
    [anon_sym_DOT_STAR] = ACTIONS(530),
    [anon_sym_DOT_QMARK] = ACTIONS(530),
    [anon_sym_struct] = ACTIONS(528),
    [anon_sym_opaque] = ACTIONS(528),
    [anon_sym_enum] = ACTIONS(528),
    [anon_sym_union] = ACTIONS(528),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(530),
    [aux_sym_FLOAT_token1] = ACTIONS(530),
    [aux_sym_FLOAT_token2] = ACTIONS(530),
    [aux_sym_FLOAT_token3] = ACTIONS(530),
    [aux_sym_FLOAT_token4] = ACTIONS(530),
    [aux_sym_INTEGER_token1] = ACTIONS(530),
    [aux_sym_INTEGER_token2] = ACTIONS(530),
    [aux_sym_INTEGER_token3] = ACTIONS(528),
    [aux_sym_INTEGER_token4] = ACTIONS(528),
    [anon_sym_DQUOTE] = ACTIONS(530),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(530),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(528),
    [anon_sym_AT] = ACTIONS(530),
  },
  [43] = {
    [anon_sym_comptime] = ACTIONS(532),
    [anon_sym_extern] = ACTIONS(532),
    [anon_sym_inline] = ACTIONS(532),
    [anon_sym_SEMI] = ACTIONS(534),
    [anon_sym_fn] = ACTIONS(532),
    [anon_sym_BANG] = ACTIONS(532),
    [anon_sym_const] = ACTIONS(532),
    [anon_sym_var] = ACTIONS(532),
    [anon_sym_EQ] = ACTIONS(532),
    [anon_sym_nosuspend] = ACTIONS(532),
    [anon_sym_defer] = ACTIONS(532),
    [anon_sym_suspend] = ACTIONS(532),
    [anon_sym_errdefer] = ACTIONS(532),
    [anon_sym_else] = ACTIONS(532),
    [anon_sym_or] = ACTIONS(532),
    [anon_sym_and] = ACTIONS(532),
    [anon_sym_break] = ACTIONS(532),
    [anon_sym_continue] = ACTIONS(532),
    [anon_sym_resume] = ACTIONS(532),
    [anon_sym_return] = ACTIONS(532),
    [anon_sym_LBRACE] = ACTIONS(534),
    [anon_sym_RBRACE] = ACTIONS(534),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_DOT] = ACTIONS(532),
    [anon_sym_error] = ACTIONS(532),
    [anon_sym_false] = ACTIONS(532),
    [anon_sym_null] = ACTIONS(532),
    [anon_sym_anyframe] = ACTIONS(532),
    [anon_sym_true] = ACTIONS(532),
    [anon_sym_undefined] = ACTIONS(532),
    [anon_sym_unreachable] = ACTIONS(532),
    [sym_BuildinTypeExpr] = ACTIONS(532),
    [anon_sym_packed] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_switch] = ACTIONS(532),
    [anon_sym_asm] = ACTIONS(532),
    [anon_sym_LBRACK] = ACTIONS(534),
    [anon_sym_if] = ACTIONS(532),
    [anon_sym_while] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(532),
    [anon_sym_PIPE] = ACTIONS(532),
    [anon_sym_STAR] = ACTIONS(532),
    [anon_sym_STAR_EQ] = ACTIONS(534),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(534),
    [anon_sym_SLASH_EQ] = ACTIONS(534),
    [anon_sym_PERCENT_EQ] = ACTIONS(534),
    [anon_sym_PLUS_EQ] = ACTIONS(534),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(534),
    [anon_sym_DASH_EQ] = ACTIONS(534),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(534),
    [anon_sym_LT_LT_EQ] = ACTIONS(534),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(534),
    [anon_sym_GT_GT_EQ] = ACTIONS(534),
    [anon_sym_AMP_EQ] = ACTIONS(534),
    [anon_sym_CARET_EQ] = ACTIONS(534),
    [anon_sym_PIPE_EQ] = ACTIONS(534),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(534),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(534),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(534),
    [anon_sym_EQ_EQ] = ACTIONS(534),
    [anon_sym_BANG_EQ] = ACTIONS(534),
    [anon_sym_LT] = ACTIONS(532),
    [anon_sym_GT] = ACTIONS(532),
    [anon_sym_LT_EQ] = ACTIONS(534),
    [anon_sym_GT_EQ] = ACTIONS(534),
    [anon_sym_AMP] = ACTIONS(532),
    [anon_sym_CARET] = ACTIONS(532),
    [anon_sym_orelse] = ACTIONS(532),
    [anon_sym_catch] = ACTIONS(532),
    [anon_sym_LT_LT] = ACTIONS(532),
    [anon_sym_GT_GT] = ACTIONS(532),
    [anon_sym_LT_LT_PIPE] = ACTIONS(532),
    [anon_sym_PLUS] = ACTIONS(532),
    [anon_sym_DASH] = ACTIONS(532),
    [anon_sym_PLUS_PLUS] = ACTIONS(534),
    [anon_sym_PLUS_PERCENT] = ACTIONS(532),
    [anon_sym_DASH_PERCENT] = ACTIONS(532),
    [anon_sym_PLUS_PIPE] = ACTIONS(532),
    [anon_sym_DASH_PIPE] = ACTIONS(532),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [anon_sym_SLASH] = ACTIONS(532),
    [anon_sym_PERCENT] = ACTIONS(532),
    [anon_sym_STAR_STAR] = ACTIONS(534),
    [anon_sym_STAR_PERCENT] = ACTIONS(532),
    [anon_sym_STAR_PIPE] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(534),
    [anon_sym_try] = ACTIONS(532),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_QMARK] = ACTIONS(534),
    [anon_sym_DOT_STAR] = ACTIONS(534),
    [anon_sym_DOT_QMARK] = ACTIONS(534),
    [anon_sym_struct] = ACTIONS(532),
    [anon_sym_opaque] = ACTIONS(532),
    [anon_sym_enum] = ACTIONS(532),
    [anon_sym_union] = ACTIONS(532),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(534),
    [aux_sym_FLOAT_token1] = ACTIONS(534),
    [aux_sym_FLOAT_token2] = ACTIONS(534),
    [aux_sym_FLOAT_token3] = ACTIONS(534),
    [aux_sym_FLOAT_token4] = ACTIONS(534),
    [aux_sym_INTEGER_token1] = ACTIONS(534),
    [aux_sym_INTEGER_token2] = ACTIONS(534),
    [aux_sym_INTEGER_token3] = ACTIONS(532),
    [aux_sym_INTEGER_token4] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(534),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(534),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(532),
    [anon_sym_AT] = ACTIONS(534),
  },
  [44] = {
    [anon_sym_COMMA] = ACTIONS(536),
    [anon_sym_comptime] = ACTIONS(538),
    [anon_sym_extern] = ACTIONS(538),
    [anon_sym_inline] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(536),
    [anon_sym_fn] = ACTIONS(538),
    [anon_sym_BANG] = ACTIONS(538),
    [anon_sym_COLON] = ACTIONS(536),
    [anon_sym_EQ] = ACTIONS(538),
    [anon_sym_nosuspend] = ACTIONS(538),
    [anon_sym_else] = ACTIONS(538),
    [anon_sym_or] = ACTIONS(538),
    [anon_sym_and] = ACTIONS(538),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(538),
    [anon_sym_resume] = ACTIONS(538),
    [anon_sym_return] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(536),
    [anon_sym_RBRACE] = ACTIONS(536),
    [anon_sym_async] = ACTIONS(538),
    [anon_sym_DOT] = ACTIONS(538),
    [anon_sym_error] = ACTIONS(538),
    [anon_sym_false] = ACTIONS(538),
    [anon_sym_null] = ACTIONS(538),
    [anon_sym_anyframe] = ACTIONS(538),
    [anon_sym_true] = ACTIONS(538),
    [anon_sym_undefined] = ACTIONS(538),
    [anon_sym_unreachable] = ACTIONS(538),
    [sym_BuildinTypeExpr] = ACTIONS(538),
    [anon_sym_packed] = ACTIONS(538),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_RPAREN] = ACTIONS(536),
    [anon_sym_switch] = ACTIONS(538),
    [anon_sym_asm] = ACTIONS(538),
    [anon_sym_LBRACK] = ACTIONS(536),
    [anon_sym_RBRACK] = ACTIONS(536),
    [anon_sym_if] = ACTIONS(538),
    [anon_sym_while] = ACTIONS(538),
    [anon_sym_for] = ACTIONS(538),
    [anon_sym_PIPE] = ACTIONS(538),
    [anon_sym_STAR] = ACTIONS(538),
    [anon_sym_EQ_GT] = ACTIONS(536),
    [anon_sym_DOT_DOT] = ACTIONS(536),
    [anon_sym_STAR_EQ] = ACTIONS(536),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(536),
    [anon_sym_SLASH_EQ] = ACTIONS(536),
    [anon_sym_PERCENT_EQ] = ACTIONS(536),
    [anon_sym_PLUS_EQ] = ACTIONS(536),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(536),
    [anon_sym_DASH_EQ] = ACTIONS(536),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(536),
    [anon_sym_LT_LT_EQ] = ACTIONS(536),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(536),
    [anon_sym_GT_GT_EQ] = ACTIONS(536),
    [anon_sym_AMP_EQ] = ACTIONS(536),
    [anon_sym_CARET_EQ] = ACTIONS(536),
    [anon_sym_PIPE_EQ] = ACTIONS(536),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(536),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(536),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(536),
    [anon_sym_EQ_EQ] = ACTIONS(536),
    [anon_sym_BANG_EQ] = ACTIONS(536),
    [anon_sym_LT] = ACTIONS(538),
    [anon_sym_GT] = ACTIONS(538),
    [anon_sym_LT_EQ] = ACTIONS(536),
    [anon_sym_GT_EQ] = ACTIONS(536),
    [anon_sym_AMP] = ACTIONS(538),
    [anon_sym_CARET] = ACTIONS(538),
    [anon_sym_orelse] = ACTIONS(538),
    [anon_sym_catch] = ACTIONS(538),
    [anon_sym_LT_LT] = ACTIONS(538),
    [anon_sym_GT_GT] = ACTIONS(538),
    [anon_sym_LT_LT_PIPE] = ACTIONS(538),
    [anon_sym_PLUS] = ACTIONS(538),
    [anon_sym_DASH] = ACTIONS(538),
    [anon_sym_PLUS_PLUS] = ACTIONS(536),
    [anon_sym_PLUS_PERCENT] = ACTIONS(538),
    [anon_sym_DASH_PERCENT] = ACTIONS(538),
    [anon_sym_PLUS_PIPE] = ACTIONS(538),
    [anon_sym_DASH_PIPE] = ACTIONS(538),
    [anon_sym_PIPE_PIPE] = ACTIONS(536),
    [anon_sym_SLASH] = ACTIONS(538),
    [anon_sym_PERCENT] = ACTIONS(538),
    [anon_sym_STAR_STAR] = ACTIONS(536),
    [anon_sym_STAR_PERCENT] = ACTIONS(538),
    [anon_sym_STAR_PIPE] = ACTIONS(538),
    [anon_sym_TILDE] = ACTIONS(536),
    [anon_sym_try] = ACTIONS(538),
    [anon_sym_await] = ACTIONS(538),
    [anon_sym_QMARK] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_opaque] = ACTIONS(538),
    [anon_sym_enum] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(538),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(536),
    [aux_sym_FLOAT_token1] = ACTIONS(536),
    [aux_sym_FLOAT_token2] = ACTIONS(536),
    [aux_sym_FLOAT_token3] = ACTIONS(536),
    [aux_sym_FLOAT_token4] = ACTIONS(536),
    [aux_sym_INTEGER_token1] = ACTIONS(536),
    [aux_sym_INTEGER_token2] = ACTIONS(536),
    [aux_sym_INTEGER_token3] = ACTIONS(538),
    [aux_sym_INTEGER_token4] = ACTIONS(538),
    [anon_sym_DQUOTE] = ACTIONS(536),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(536),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(538),
    [anon_sym_AT] = ACTIONS(536),
  },
  [45] = {
    [anon_sym_comptime] = ACTIONS(540),
    [anon_sym_extern] = ACTIONS(540),
    [anon_sym_inline] = ACTIONS(540),
    [anon_sym_SEMI] = ACTIONS(542),
    [anon_sym_fn] = ACTIONS(540),
    [anon_sym_BANG] = ACTIONS(540),
    [anon_sym_const] = ACTIONS(540),
    [anon_sym_var] = ACTIONS(540),
    [anon_sym_EQ] = ACTIONS(540),
    [anon_sym_nosuspend] = ACTIONS(540),
    [anon_sym_defer] = ACTIONS(540),
    [anon_sym_suspend] = ACTIONS(540),
    [anon_sym_errdefer] = ACTIONS(540),
    [anon_sym_or] = ACTIONS(540),
    [anon_sym_and] = ACTIONS(540),
    [anon_sym_break] = ACTIONS(540),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_resume] = ACTIONS(540),
    [anon_sym_return] = ACTIONS(540),
    [anon_sym_LBRACE] = ACTIONS(542),
    [anon_sym_RBRACE] = ACTIONS(542),
    [anon_sym_async] = ACTIONS(540),
    [anon_sym_DOT] = ACTIONS(540),
    [anon_sym_error] = ACTIONS(540),
    [anon_sym_false] = ACTIONS(540),
    [anon_sym_null] = ACTIONS(540),
    [anon_sym_anyframe] = ACTIONS(540),
    [anon_sym_true] = ACTIONS(540),
    [anon_sym_undefined] = ACTIONS(540),
    [anon_sym_unreachable] = ACTIONS(540),
    [sym_BuildinTypeExpr] = ACTIONS(540),
    [anon_sym_packed] = ACTIONS(540),
    [anon_sym_LPAREN] = ACTIONS(542),
    [anon_sym_switch] = ACTIONS(540),
    [anon_sym_asm] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(542),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_while] = ACTIONS(540),
    [anon_sym_for] = ACTIONS(540),
    [anon_sym_PIPE] = ACTIONS(540),
    [anon_sym_STAR] = ACTIONS(540),
    [anon_sym_STAR_EQ] = ACTIONS(542),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(542),
    [anon_sym_SLASH_EQ] = ACTIONS(542),
    [anon_sym_PERCENT_EQ] = ACTIONS(542),
    [anon_sym_PLUS_EQ] = ACTIONS(542),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(542),
    [anon_sym_DASH_EQ] = ACTIONS(542),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(542),
    [anon_sym_LT_LT_EQ] = ACTIONS(542),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(542),
    [anon_sym_GT_GT_EQ] = ACTIONS(542),
    [anon_sym_AMP_EQ] = ACTIONS(542),
    [anon_sym_CARET_EQ] = ACTIONS(542),
    [anon_sym_PIPE_EQ] = ACTIONS(542),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(542),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(542),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(542),
    [anon_sym_EQ_EQ] = ACTIONS(542),
    [anon_sym_BANG_EQ] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(540),
    [anon_sym_GT] = ACTIONS(540),
    [anon_sym_LT_EQ] = ACTIONS(542),
    [anon_sym_GT_EQ] = ACTIONS(542),
    [anon_sym_AMP] = ACTIONS(540),
    [anon_sym_CARET] = ACTIONS(540),
    [anon_sym_orelse] = ACTIONS(540),
    [anon_sym_catch] = ACTIONS(540),
    [anon_sym_LT_LT] = ACTIONS(540),
    [anon_sym_GT_GT] = ACTIONS(540),
    [anon_sym_LT_LT_PIPE] = ACTIONS(540),
    [anon_sym_PLUS] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(540),
    [anon_sym_PLUS_PLUS] = ACTIONS(542),
    [anon_sym_PLUS_PERCENT] = ACTIONS(540),
    [anon_sym_DASH_PERCENT] = ACTIONS(540),
    [anon_sym_PLUS_PIPE] = ACTIONS(540),
    [anon_sym_DASH_PIPE] = ACTIONS(540),
    [anon_sym_PIPE_PIPE] = ACTIONS(542),
    [anon_sym_SLASH] = ACTIONS(540),
    [anon_sym_PERCENT] = ACTIONS(540),
    [anon_sym_STAR_STAR] = ACTIONS(542),
    [anon_sym_STAR_PERCENT] = ACTIONS(540),
    [anon_sym_STAR_PIPE] = ACTIONS(540),
    [anon_sym_TILDE] = ACTIONS(542),
    [anon_sym_try] = ACTIONS(540),
    [anon_sym_await] = ACTIONS(540),
    [anon_sym_QMARK] = ACTIONS(542),
    [anon_sym_DOT_STAR] = ACTIONS(542),
    [anon_sym_DOT_QMARK] = ACTIONS(542),
    [anon_sym_struct] = ACTIONS(540),
    [anon_sym_opaque] = ACTIONS(540),
    [anon_sym_enum] = ACTIONS(540),
    [anon_sym_union] = ACTIONS(540),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(542),
    [aux_sym_FLOAT_token1] = ACTIONS(542),
    [aux_sym_FLOAT_token2] = ACTIONS(542),
    [aux_sym_FLOAT_token3] = ACTIONS(542),
    [aux_sym_FLOAT_token4] = ACTIONS(542),
    [aux_sym_INTEGER_token1] = ACTIONS(542),
    [aux_sym_INTEGER_token2] = ACTIONS(542),
    [aux_sym_INTEGER_token3] = ACTIONS(540),
    [aux_sym_INTEGER_token4] = ACTIONS(540),
    [anon_sym_DQUOTE] = ACTIONS(542),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(542),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(540),
    [anon_sym_AT] = ACTIONS(542),
  },
  [46] = {
    [sym_FnProto] = STATE(935),
    [sym_VarDecl] = STATE(1177),
    [sym_BlockExprStatement] = STATE(1177),
    [sym_BlockExpr] = STATE(1192),
    [sym_AssignExpr] = STATE(2132),
    [sym__Expr] = STATE(1334),
    [sym_BinaryExpr] = STATE(1334),
    [sym_UnaryExpr] = STATE(1334),
    [sym__PrimaryExpr] = STATE(1334),
    [sym_IfExpr] = STATE(1334),
    [sym_Block] = STATE(88),
    [sym_LoopExpr] = STATE(1334),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1334),
    [sym__TypeExpr] = STATE(1030),
    [sym_ErrorUnionExpr] = STATE(1030),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1334),
    [sym_BlockLabel] = STATE(1669),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(343),
    [anon_sym_var] = ACTIONS(343),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [47] = {
    [anon_sym_comptime] = ACTIONS(544),
    [anon_sym_extern] = ACTIONS(544),
    [anon_sym_inline] = ACTIONS(544),
    [anon_sym_SEMI] = ACTIONS(546),
    [anon_sym_fn] = ACTIONS(544),
    [anon_sym_BANG] = ACTIONS(544),
    [anon_sym_const] = ACTIONS(544),
    [anon_sym_var] = ACTIONS(544),
    [anon_sym_EQ] = ACTIONS(548),
    [anon_sym_nosuspend] = ACTIONS(544),
    [anon_sym_defer] = ACTIONS(544),
    [anon_sym_suspend] = ACTIONS(544),
    [anon_sym_errdefer] = ACTIONS(544),
    [anon_sym_or] = ACTIONS(548),
    [anon_sym_and] = ACTIONS(548),
    [anon_sym_break] = ACTIONS(544),
    [anon_sym_continue] = ACTIONS(544),
    [anon_sym_resume] = ACTIONS(544),
    [anon_sym_return] = ACTIONS(544),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_RBRACE] = ACTIONS(550),
    [anon_sym_async] = ACTIONS(544),
    [anon_sym_DOT] = ACTIONS(544),
    [anon_sym_error] = ACTIONS(544),
    [anon_sym_false] = ACTIONS(544),
    [anon_sym_null] = ACTIONS(544),
    [anon_sym_anyframe] = ACTIONS(544),
    [anon_sym_true] = ACTIONS(544),
    [anon_sym_undefined] = ACTIONS(544),
    [anon_sym_unreachable] = ACTIONS(544),
    [sym_BuildinTypeExpr] = ACTIONS(544),
    [anon_sym_packed] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(544),
    [anon_sym_asm] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(550),
    [anon_sym_if] = ACTIONS(544),
    [anon_sym_while] = ACTIONS(544),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_PIPE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(544),
    [anon_sym_STAR_EQ] = ACTIONS(546),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(546),
    [anon_sym_SLASH_EQ] = ACTIONS(546),
    [anon_sym_PERCENT_EQ] = ACTIONS(546),
    [anon_sym_PLUS_EQ] = ACTIONS(546),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(546),
    [anon_sym_DASH_EQ] = ACTIONS(546),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(546),
    [anon_sym_LT_LT_EQ] = ACTIONS(546),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(546),
    [anon_sym_GT_GT_EQ] = ACTIONS(546),
    [anon_sym_AMP_EQ] = ACTIONS(546),
    [anon_sym_CARET_EQ] = ACTIONS(546),
    [anon_sym_PIPE_EQ] = ACTIONS(546),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(546),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(546),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(546),
    [anon_sym_EQ_EQ] = ACTIONS(546),
    [anon_sym_BANG_EQ] = ACTIONS(546),
    [anon_sym_LT] = ACTIONS(548),
    [anon_sym_GT] = ACTIONS(548),
    [anon_sym_LT_EQ] = ACTIONS(546),
    [anon_sym_GT_EQ] = ACTIONS(546),
    [anon_sym_AMP] = ACTIONS(544),
    [anon_sym_CARET] = ACTIONS(548),
    [anon_sym_orelse] = ACTIONS(548),
    [anon_sym_catch] = ACTIONS(548),
    [anon_sym_LT_LT] = ACTIONS(548),
    [anon_sym_GT_GT] = ACTIONS(548),
    [anon_sym_LT_LT_PIPE] = ACTIONS(548),
    [anon_sym_PLUS] = ACTIONS(548),
    [anon_sym_DASH] = ACTIONS(544),
    [anon_sym_PLUS_PLUS] = ACTIONS(546),
    [anon_sym_PLUS_PERCENT] = ACTIONS(548),
    [anon_sym_DASH_PERCENT] = ACTIONS(544),
    [anon_sym_PLUS_PIPE] = ACTIONS(548),
    [anon_sym_DASH_PIPE] = ACTIONS(548),
    [anon_sym_PIPE_PIPE] = ACTIONS(546),
    [anon_sym_SLASH] = ACTIONS(548),
    [anon_sym_PERCENT] = ACTIONS(548),
    [anon_sym_STAR_STAR] = ACTIONS(550),
    [anon_sym_STAR_PERCENT] = ACTIONS(548),
    [anon_sym_STAR_PIPE] = ACTIONS(548),
    [anon_sym_TILDE] = ACTIONS(550),
    [anon_sym_try] = ACTIONS(544),
    [anon_sym_await] = ACTIONS(544),
    [anon_sym_QMARK] = ACTIONS(550),
    [anon_sym_DOT_STAR] = ACTIONS(546),
    [anon_sym_DOT_QMARK] = ACTIONS(546),
    [anon_sym_struct] = ACTIONS(544),
    [anon_sym_opaque] = ACTIONS(544),
    [anon_sym_enum] = ACTIONS(544),
    [anon_sym_union] = ACTIONS(544),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(550),
    [aux_sym_FLOAT_token1] = ACTIONS(550),
    [aux_sym_FLOAT_token2] = ACTIONS(550),
    [aux_sym_FLOAT_token3] = ACTIONS(550),
    [aux_sym_FLOAT_token4] = ACTIONS(550),
    [aux_sym_INTEGER_token1] = ACTIONS(550),
    [aux_sym_INTEGER_token2] = ACTIONS(550),
    [aux_sym_INTEGER_token3] = ACTIONS(544),
    [aux_sym_INTEGER_token4] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(550),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(550),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(544),
    [anon_sym_AT] = ACTIONS(550),
  },
  [48] = {
    [anon_sym_COMMA] = ACTIONS(552),
    [anon_sym_comptime] = ACTIONS(554),
    [anon_sym_extern] = ACTIONS(554),
    [anon_sym_inline] = ACTIONS(554),
    [anon_sym_SEMI] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(554),
    [anon_sym_BANG] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(552),
    [anon_sym_EQ] = ACTIONS(554),
    [anon_sym_nosuspend] = ACTIONS(554),
    [anon_sym_else] = ACTIONS(554),
    [anon_sym_or] = ACTIONS(554),
    [anon_sym_and] = ACTIONS(554),
    [anon_sym_break] = ACTIONS(554),
    [anon_sym_continue] = ACTIONS(554),
    [anon_sym_resume] = ACTIONS(554),
    [anon_sym_return] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(552),
    [anon_sym_RBRACE] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(554),
    [anon_sym_DOT] = ACTIONS(554),
    [anon_sym_error] = ACTIONS(554),
    [anon_sym_false] = ACTIONS(554),
    [anon_sym_null] = ACTIONS(554),
    [anon_sym_anyframe] = ACTIONS(554),
    [anon_sym_true] = ACTIONS(554),
    [anon_sym_undefined] = ACTIONS(554),
    [anon_sym_unreachable] = ACTIONS(554),
    [sym_BuildinTypeExpr] = ACTIONS(554),
    [anon_sym_packed] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_RPAREN] = ACTIONS(552),
    [anon_sym_switch] = ACTIONS(554),
    [anon_sym_asm] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(552),
    [anon_sym_RBRACK] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(554),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_PIPE] = ACTIONS(554),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_EQ_GT] = ACTIONS(552),
    [anon_sym_DOT_DOT] = ACTIONS(552),
    [anon_sym_STAR_EQ] = ACTIONS(552),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(552),
    [anon_sym_SLASH_EQ] = ACTIONS(552),
    [anon_sym_PERCENT_EQ] = ACTIONS(552),
    [anon_sym_PLUS_EQ] = ACTIONS(552),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(552),
    [anon_sym_DASH_EQ] = ACTIONS(552),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(552),
    [anon_sym_LT_LT_EQ] = ACTIONS(552),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(552),
    [anon_sym_GT_GT_EQ] = ACTIONS(552),
    [anon_sym_AMP_EQ] = ACTIONS(552),
    [anon_sym_CARET_EQ] = ACTIONS(552),
    [anon_sym_PIPE_EQ] = ACTIONS(552),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(552),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(552),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(552),
    [anon_sym_EQ_EQ] = ACTIONS(552),
    [anon_sym_BANG_EQ] = ACTIONS(552),
    [anon_sym_LT] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(552),
    [anon_sym_GT_EQ] = ACTIONS(552),
    [anon_sym_AMP] = ACTIONS(554),
    [anon_sym_CARET] = ACTIONS(554),
    [anon_sym_orelse] = ACTIONS(554),
    [anon_sym_catch] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(554),
    [anon_sym_GT_GT] = ACTIONS(554),
    [anon_sym_LT_LT_PIPE] = ACTIONS(554),
    [anon_sym_PLUS] = ACTIONS(554),
    [anon_sym_DASH] = ACTIONS(554),
    [anon_sym_PLUS_PLUS] = ACTIONS(552),
    [anon_sym_PLUS_PERCENT] = ACTIONS(554),
    [anon_sym_DASH_PERCENT] = ACTIONS(554),
    [anon_sym_PLUS_PIPE] = ACTIONS(554),
    [anon_sym_DASH_PIPE] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(552),
    [anon_sym_SLASH] = ACTIONS(554),
    [anon_sym_PERCENT] = ACTIONS(554),
    [anon_sym_STAR_STAR] = ACTIONS(552),
    [anon_sym_STAR_PERCENT] = ACTIONS(554),
    [anon_sym_STAR_PIPE] = ACTIONS(554),
    [anon_sym_TILDE] = ACTIONS(552),
    [anon_sym_try] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(554),
    [anon_sym_QMARK] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_opaque] = ACTIONS(554),
    [anon_sym_enum] = ACTIONS(554),
    [anon_sym_union] = ACTIONS(554),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [aux_sym_FLOAT_token1] = ACTIONS(552),
    [aux_sym_FLOAT_token2] = ACTIONS(552),
    [aux_sym_FLOAT_token3] = ACTIONS(552),
    [aux_sym_FLOAT_token4] = ACTIONS(552),
    [aux_sym_INTEGER_token1] = ACTIONS(552),
    [aux_sym_INTEGER_token2] = ACTIONS(552),
    [aux_sym_INTEGER_token3] = ACTIONS(554),
    [aux_sym_INTEGER_token4] = ACTIONS(554),
    [anon_sym_DQUOTE] = ACTIONS(552),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(552),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(552),
  },
  [49] = {
    [anon_sym_COMMA] = ACTIONS(556),
    [anon_sym_comptime] = ACTIONS(558),
    [anon_sym_extern] = ACTIONS(558),
    [anon_sym_inline] = ACTIONS(558),
    [anon_sym_SEMI] = ACTIONS(556),
    [anon_sym_fn] = ACTIONS(558),
    [anon_sym_BANG] = ACTIONS(558),
    [anon_sym_COLON] = ACTIONS(556),
    [anon_sym_EQ] = ACTIONS(558),
    [anon_sym_nosuspend] = ACTIONS(558),
    [anon_sym_else] = ACTIONS(558),
    [anon_sym_or] = ACTIONS(558),
    [anon_sym_and] = ACTIONS(558),
    [anon_sym_break] = ACTIONS(558),
    [anon_sym_continue] = ACTIONS(558),
    [anon_sym_resume] = ACTIONS(558),
    [anon_sym_return] = ACTIONS(558),
    [anon_sym_LBRACE] = ACTIONS(556),
    [anon_sym_RBRACE] = ACTIONS(556),
    [anon_sym_async] = ACTIONS(558),
    [anon_sym_DOT] = ACTIONS(558),
    [anon_sym_error] = ACTIONS(558),
    [anon_sym_false] = ACTIONS(558),
    [anon_sym_null] = ACTIONS(558),
    [anon_sym_anyframe] = ACTIONS(558),
    [anon_sym_true] = ACTIONS(558),
    [anon_sym_undefined] = ACTIONS(558),
    [anon_sym_unreachable] = ACTIONS(558),
    [sym_BuildinTypeExpr] = ACTIONS(558),
    [anon_sym_packed] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_RPAREN] = ACTIONS(556),
    [anon_sym_switch] = ACTIONS(558),
    [anon_sym_asm] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(556),
    [anon_sym_RBRACK] = ACTIONS(556),
    [anon_sym_if] = ACTIONS(558),
    [anon_sym_while] = ACTIONS(558),
    [anon_sym_for] = ACTIONS(558),
    [anon_sym_PIPE] = ACTIONS(558),
    [anon_sym_STAR] = ACTIONS(558),
    [anon_sym_EQ_GT] = ACTIONS(556),
    [anon_sym_DOT_DOT] = ACTIONS(556),
    [anon_sym_STAR_EQ] = ACTIONS(556),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(556),
    [anon_sym_SLASH_EQ] = ACTIONS(556),
    [anon_sym_PERCENT_EQ] = ACTIONS(556),
    [anon_sym_PLUS_EQ] = ACTIONS(556),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(556),
    [anon_sym_DASH_EQ] = ACTIONS(556),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(556),
    [anon_sym_LT_LT_EQ] = ACTIONS(556),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(556),
    [anon_sym_GT_GT_EQ] = ACTIONS(556),
    [anon_sym_AMP_EQ] = ACTIONS(556),
    [anon_sym_CARET_EQ] = ACTIONS(556),
    [anon_sym_PIPE_EQ] = ACTIONS(556),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(556),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(556),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(556),
    [anon_sym_EQ_EQ] = ACTIONS(556),
    [anon_sym_BANG_EQ] = ACTIONS(556),
    [anon_sym_LT] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(558),
    [anon_sym_LT_EQ] = ACTIONS(556),
    [anon_sym_GT_EQ] = ACTIONS(556),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_CARET] = ACTIONS(558),
    [anon_sym_orelse] = ACTIONS(558),
    [anon_sym_catch] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(558),
    [anon_sym_GT_GT] = ACTIONS(558),
    [anon_sym_LT_LT_PIPE] = ACTIONS(558),
    [anon_sym_PLUS] = ACTIONS(558),
    [anon_sym_DASH] = ACTIONS(558),
    [anon_sym_PLUS_PLUS] = ACTIONS(556),
    [anon_sym_PLUS_PERCENT] = ACTIONS(558),
    [anon_sym_DASH_PERCENT] = ACTIONS(558),
    [anon_sym_PLUS_PIPE] = ACTIONS(558),
    [anon_sym_DASH_PIPE] = ACTIONS(558),
    [anon_sym_PIPE_PIPE] = ACTIONS(556),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_PERCENT] = ACTIONS(558),
    [anon_sym_STAR_STAR] = ACTIONS(556),
    [anon_sym_STAR_PERCENT] = ACTIONS(558),
    [anon_sym_STAR_PIPE] = ACTIONS(558),
    [anon_sym_TILDE] = ACTIONS(556),
    [anon_sym_try] = ACTIONS(558),
    [anon_sym_await] = ACTIONS(558),
    [anon_sym_QMARK] = ACTIONS(556),
    [anon_sym_struct] = ACTIONS(558),
    [anon_sym_opaque] = ACTIONS(558),
    [anon_sym_enum] = ACTIONS(558),
    [anon_sym_union] = ACTIONS(558),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(556),
    [aux_sym_FLOAT_token1] = ACTIONS(556),
    [aux_sym_FLOAT_token2] = ACTIONS(556),
    [aux_sym_FLOAT_token3] = ACTIONS(556),
    [aux_sym_FLOAT_token4] = ACTIONS(556),
    [aux_sym_INTEGER_token1] = ACTIONS(556),
    [aux_sym_INTEGER_token2] = ACTIONS(556),
    [aux_sym_INTEGER_token3] = ACTIONS(558),
    [aux_sym_INTEGER_token4] = ACTIONS(558),
    [anon_sym_DQUOTE] = ACTIONS(556),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(556),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(558),
    [anon_sym_AT] = ACTIONS(556),
  },
  [50] = {
    [anon_sym_COMMA] = ACTIONS(560),
    [anon_sym_comptime] = ACTIONS(562),
    [anon_sym_extern] = ACTIONS(562),
    [anon_sym_inline] = ACTIONS(562),
    [anon_sym_SEMI] = ACTIONS(560),
    [anon_sym_fn] = ACTIONS(562),
    [anon_sym_BANG] = ACTIONS(562),
    [anon_sym_COLON] = ACTIONS(560),
    [anon_sym_EQ] = ACTIONS(562),
    [anon_sym_nosuspend] = ACTIONS(562),
    [anon_sym_else] = ACTIONS(562),
    [anon_sym_or] = ACTIONS(562),
    [anon_sym_and] = ACTIONS(562),
    [anon_sym_break] = ACTIONS(562),
    [anon_sym_continue] = ACTIONS(562),
    [anon_sym_resume] = ACTIONS(562),
    [anon_sym_return] = ACTIONS(562),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_RBRACE] = ACTIONS(560),
    [anon_sym_async] = ACTIONS(562),
    [anon_sym_DOT] = ACTIONS(562),
    [anon_sym_error] = ACTIONS(562),
    [anon_sym_false] = ACTIONS(562),
    [anon_sym_null] = ACTIONS(562),
    [anon_sym_anyframe] = ACTIONS(562),
    [anon_sym_true] = ACTIONS(562),
    [anon_sym_undefined] = ACTIONS(562),
    [anon_sym_unreachable] = ACTIONS(562),
    [sym_BuildinTypeExpr] = ACTIONS(562),
    [anon_sym_packed] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(560),
    [anon_sym_RPAREN] = ACTIONS(560),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_asm] = ACTIONS(562),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(560),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_while] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(562),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_STAR] = ACTIONS(562),
    [anon_sym_EQ_GT] = ACTIONS(560),
    [anon_sym_DOT_DOT] = ACTIONS(560),
    [anon_sym_STAR_EQ] = ACTIONS(560),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(560),
    [anon_sym_SLASH_EQ] = ACTIONS(560),
    [anon_sym_PERCENT_EQ] = ACTIONS(560),
    [anon_sym_PLUS_EQ] = ACTIONS(560),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(560),
    [anon_sym_DASH_EQ] = ACTIONS(560),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(560),
    [anon_sym_LT_LT_EQ] = ACTIONS(560),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(560),
    [anon_sym_GT_GT_EQ] = ACTIONS(560),
    [anon_sym_AMP_EQ] = ACTIONS(560),
    [anon_sym_CARET_EQ] = ACTIONS(560),
    [anon_sym_PIPE_EQ] = ACTIONS(560),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(560),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(560),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(560),
    [anon_sym_EQ_EQ] = ACTIONS(560),
    [anon_sym_BANG_EQ] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_LT_EQ] = ACTIONS(560),
    [anon_sym_GT_EQ] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(562),
    [anon_sym_orelse] = ACTIONS(562),
    [anon_sym_catch] = ACTIONS(562),
    [anon_sym_LT_LT] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(562),
    [anon_sym_LT_LT_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(560),
    [anon_sym_PLUS_PERCENT] = ACTIONS(562),
    [anon_sym_DASH_PERCENT] = ACTIONS(562),
    [anon_sym_PLUS_PIPE] = ACTIONS(562),
    [anon_sym_DASH_PIPE] = ACTIONS(562),
    [anon_sym_PIPE_PIPE] = ACTIONS(560),
    [anon_sym_SLASH] = ACTIONS(562),
    [anon_sym_PERCENT] = ACTIONS(562),
    [anon_sym_STAR_STAR] = ACTIONS(560),
    [anon_sym_STAR_PERCENT] = ACTIONS(562),
    [anon_sym_STAR_PIPE] = ACTIONS(562),
    [anon_sym_TILDE] = ACTIONS(560),
    [anon_sym_try] = ACTIONS(562),
    [anon_sym_await] = ACTIONS(562),
    [anon_sym_QMARK] = ACTIONS(560),
    [anon_sym_struct] = ACTIONS(562),
    [anon_sym_opaque] = ACTIONS(562),
    [anon_sym_enum] = ACTIONS(562),
    [anon_sym_union] = ACTIONS(562),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(560),
    [aux_sym_FLOAT_token1] = ACTIONS(560),
    [aux_sym_FLOAT_token2] = ACTIONS(560),
    [aux_sym_FLOAT_token3] = ACTIONS(560),
    [aux_sym_FLOAT_token4] = ACTIONS(560),
    [aux_sym_INTEGER_token1] = ACTIONS(560),
    [aux_sym_INTEGER_token2] = ACTIONS(560),
    [aux_sym_INTEGER_token3] = ACTIONS(562),
    [aux_sym_INTEGER_token4] = ACTIONS(562),
    [anon_sym_DQUOTE] = ACTIONS(560),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(560),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(562),
    [anon_sym_AT] = ACTIONS(560),
  },
  [51] = {
    [anon_sym_comptime] = ACTIONS(528),
    [anon_sym_extern] = ACTIONS(528),
    [anon_sym_inline] = ACTIONS(528),
    [anon_sym_SEMI] = ACTIONS(530),
    [anon_sym_fn] = ACTIONS(528),
    [anon_sym_BANG] = ACTIONS(528),
    [anon_sym_const] = ACTIONS(528),
    [anon_sym_var] = ACTIONS(528),
    [anon_sym_EQ] = ACTIONS(528),
    [anon_sym_nosuspend] = ACTIONS(528),
    [anon_sym_defer] = ACTIONS(528),
    [anon_sym_suspend] = ACTIONS(528),
    [anon_sym_errdefer] = ACTIONS(528),
    [anon_sym_or] = ACTIONS(528),
    [anon_sym_and] = ACTIONS(528),
    [anon_sym_break] = ACTIONS(528),
    [anon_sym_continue] = ACTIONS(528),
    [anon_sym_resume] = ACTIONS(528),
    [anon_sym_return] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(528),
    [anon_sym_DOT] = ACTIONS(528),
    [anon_sym_error] = ACTIONS(528),
    [anon_sym_false] = ACTIONS(528),
    [anon_sym_null] = ACTIONS(528),
    [anon_sym_anyframe] = ACTIONS(528),
    [anon_sym_true] = ACTIONS(528),
    [anon_sym_undefined] = ACTIONS(528),
    [anon_sym_unreachable] = ACTIONS(528),
    [sym_BuildinTypeExpr] = ACTIONS(528),
    [anon_sym_packed] = ACTIONS(528),
    [anon_sym_LPAREN] = ACTIONS(530),
    [anon_sym_switch] = ACTIONS(528),
    [anon_sym_asm] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(530),
    [anon_sym_if] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(528),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_STAR_EQ] = ACTIONS(530),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(530),
    [anon_sym_SLASH_EQ] = ACTIONS(530),
    [anon_sym_PERCENT_EQ] = ACTIONS(530),
    [anon_sym_PLUS_EQ] = ACTIONS(530),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(530),
    [anon_sym_DASH_EQ] = ACTIONS(530),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(530),
    [anon_sym_LT_LT_EQ] = ACTIONS(530),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(530),
    [anon_sym_GT_GT_EQ] = ACTIONS(530),
    [anon_sym_AMP_EQ] = ACTIONS(530),
    [anon_sym_CARET_EQ] = ACTIONS(530),
    [anon_sym_PIPE_EQ] = ACTIONS(530),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(530),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(530),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(530),
    [anon_sym_EQ_EQ] = ACTIONS(530),
    [anon_sym_BANG_EQ] = ACTIONS(530),
    [anon_sym_LT] = ACTIONS(528),
    [anon_sym_GT] = ACTIONS(528),
    [anon_sym_LT_EQ] = ACTIONS(530),
    [anon_sym_GT_EQ] = ACTIONS(530),
    [anon_sym_AMP] = ACTIONS(528),
    [anon_sym_CARET] = ACTIONS(528),
    [anon_sym_orelse] = ACTIONS(528),
    [anon_sym_catch] = ACTIONS(528),
    [anon_sym_LT_LT] = ACTIONS(528),
    [anon_sym_GT_GT] = ACTIONS(528),
    [anon_sym_LT_LT_PIPE] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(528),
    [anon_sym_DASH] = ACTIONS(528),
    [anon_sym_PLUS_PLUS] = ACTIONS(530),
    [anon_sym_PLUS_PERCENT] = ACTIONS(528),
    [anon_sym_DASH_PERCENT] = ACTIONS(528),
    [anon_sym_PLUS_PIPE] = ACTIONS(528),
    [anon_sym_DASH_PIPE] = ACTIONS(528),
    [anon_sym_PIPE_PIPE] = ACTIONS(530),
    [anon_sym_SLASH] = ACTIONS(528),
    [anon_sym_PERCENT] = ACTIONS(528),
    [anon_sym_STAR_STAR] = ACTIONS(530),
    [anon_sym_STAR_PERCENT] = ACTIONS(528),
    [anon_sym_STAR_PIPE] = ACTIONS(528),
    [anon_sym_TILDE] = ACTIONS(530),
    [anon_sym_try] = ACTIONS(528),
    [anon_sym_await] = ACTIONS(528),
    [anon_sym_QMARK] = ACTIONS(530),
    [anon_sym_DOT_STAR] = ACTIONS(530),
    [anon_sym_DOT_QMARK] = ACTIONS(530),
    [anon_sym_struct] = ACTIONS(528),
    [anon_sym_opaque] = ACTIONS(528),
    [anon_sym_enum] = ACTIONS(528),
    [anon_sym_union] = ACTIONS(528),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(530),
    [aux_sym_FLOAT_token1] = ACTIONS(530),
    [aux_sym_FLOAT_token2] = ACTIONS(530),
    [aux_sym_FLOAT_token3] = ACTIONS(530),
    [aux_sym_FLOAT_token4] = ACTIONS(530),
    [aux_sym_INTEGER_token1] = ACTIONS(530),
    [aux_sym_INTEGER_token2] = ACTIONS(530),
    [aux_sym_INTEGER_token3] = ACTIONS(528),
    [aux_sym_INTEGER_token4] = ACTIONS(528),
    [anon_sym_DQUOTE] = ACTIONS(530),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(530),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(528),
    [anon_sym_AT] = ACTIONS(530),
  },
  [52] = {
    [anon_sym_comptime] = ACTIONS(564),
    [anon_sym_extern] = ACTIONS(564),
    [anon_sym_inline] = ACTIONS(564),
    [anon_sym_SEMI] = ACTIONS(566),
    [anon_sym_fn] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_const] = ACTIONS(564),
    [anon_sym_var] = ACTIONS(564),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_nosuspend] = ACTIONS(564),
    [anon_sym_defer] = ACTIONS(564),
    [anon_sym_suspend] = ACTIONS(564),
    [anon_sym_errdefer] = ACTIONS(564),
    [anon_sym_or] = ACTIONS(564),
    [anon_sym_and] = ACTIONS(564),
    [anon_sym_break] = ACTIONS(564),
    [anon_sym_continue] = ACTIONS(564),
    [anon_sym_resume] = ACTIONS(564),
    [anon_sym_return] = ACTIONS(564),
    [anon_sym_LBRACE] = ACTIONS(566),
    [anon_sym_RBRACE] = ACTIONS(566),
    [anon_sym_async] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_error] = ACTIONS(564),
    [anon_sym_false] = ACTIONS(564),
    [anon_sym_null] = ACTIONS(564),
    [anon_sym_anyframe] = ACTIONS(564),
    [anon_sym_true] = ACTIONS(564),
    [anon_sym_undefined] = ACTIONS(564),
    [anon_sym_unreachable] = ACTIONS(564),
    [sym_BuildinTypeExpr] = ACTIONS(564),
    [anon_sym_packed] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_switch] = ACTIONS(564),
    [anon_sym_asm] = ACTIONS(564),
    [anon_sym_LBRACK] = ACTIONS(566),
    [anon_sym_if] = ACTIONS(564),
    [anon_sym_while] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_STAR_EQ] = ACTIONS(566),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(566),
    [anon_sym_SLASH_EQ] = ACTIONS(566),
    [anon_sym_PERCENT_EQ] = ACTIONS(566),
    [anon_sym_PLUS_EQ] = ACTIONS(566),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(566),
    [anon_sym_DASH_EQ] = ACTIONS(566),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(566),
    [anon_sym_LT_LT_EQ] = ACTIONS(566),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(566),
    [anon_sym_GT_GT_EQ] = ACTIONS(566),
    [anon_sym_AMP_EQ] = ACTIONS(566),
    [anon_sym_CARET_EQ] = ACTIONS(566),
    [anon_sym_PIPE_EQ] = ACTIONS(566),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(566),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(566),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(566),
    [anon_sym_EQ_EQ] = ACTIONS(566),
    [anon_sym_BANG_EQ] = ACTIONS(566),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT_EQ] = ACTIONS(566),
    [anon_sym_GT_EQ] = ACTIONS(566),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_orelse] = ACTIONS(564),
    [anon_sym_catch] = ACTIONS(564),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_LT_LT_PIPE] = ACTIONS(564),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_PLUS_PLUS] = ACTIONS(566),
    [anon_sym_PLUS_PERCENT] = ACTIONS(564),
    [anon_sym_DASH_PERCENT] = ACTIONS(564),
    [anon_sym_PLUS_PIPE] = ACTIONS(564),
    [anon_sym_DASH_PIPE] = ACTIONS(564),
    [anon_sym_PIPE_PIPE] = ACTIONS(566),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_STAR_STAR] = ACTIONS(566),
    [anon_sym_STAR_PERCENT] = ACTIONS(564),
    [anon_sym_STAR_PIPE] = ACTIONS(564),
    [anon_sym_TILDE] = ACTIONS(566),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_await] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(566),
    [anon_sym_DOT_STAR] = ACTIONS(566),
    [anon_sym_DOT_QMARK] = ACTIONS(566),
    [anon_sym_struct] = ACTIONS(564),
    [anon_sym_opaque] = ACTIONS(564),
    [anon_sym_enum] = ACTIONS(564),
    [anon_sym_union] = ACTIONS(564),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(566),
    [aux_sym_FLOAT_token1] = ACTIONS(566),
    [aux_sym_FLOAT_token2] = ACTIONS(566),
    [aux_sym_FLOAT_token3] = ACTIONS(566),
    [aux_sym_FLOAT_token4] = ACTIONS(566),
    [aux_sym_INTEGER_token1] = ACTIONS(566),
    [aux_sym_INTEGER_token2] = ACTIONS(566),
    [aux_sym_INTEGER_token3] = ACTIONS(564),
    [aux_sym_INTEGER_token4] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(566),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(566),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(564),
    [anon_sym_AT] = ACTIONS(566),
  },
  [53] = {
    [anon_sym_comptime] = ACTIONS(568),
    [anon_sym_extern] = ACTIONS(568),
    [anon_sym_inline] = ACTIONS(568),
    [anon_sym_SEMI] = ACTIONS(570),
    [anon_sym_fn] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(568),
    [anon_sym_const] = ACTIONS(568),
    [anon_sym_var] = ACTIONS(568),
    [anon_sym_EQ] = ACTIONS(568),
    [anon_sym_nosuspend] = ACTIONS(568),
    [anon_sym_defer] = ACTIONS(568),
    [anon_sym_suspend] = ACTIONS(568),
    [anon_sym_errdefer] = ACTIONS(568),
    [anon_sym_or] = ACTIONS(568),
    [anon_sym_and] = ACTIONS(568),
    [anon_sym_break] = ACTIONS(568),
    [anon_sym_continue] = ACTIONS(568),
    [anon_sym_resume] = ACTIONS(568),
    [anon_sym_return] = ACTIONS(568),
    [anon_sym_LBRACE] = ACTIONS(570),
    [anon_sym_RBRACE] = ACTIONS(570),
    [anon_sym_async] = ACTIONS(568),
    [anon_sym_DOT] = ACTIONS(568),
    [anon_sym_error] = ACTIONS(568),
    [anon_sym_false] = ACTIONS(568),
    [anon_sym_null] = ACTIONS(568),
    [anon_sym_anyframe] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(568),
    [anon_sym_undefined] = ACTIONS(568),
    [anon_sym_unreachable] = ACTIONS(568),
    [sym_BuildinTypeExpr] = ACTIONS(568),
    [anon_sym_packed] = ACTIONS(568),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_switch] = ACTIONS(568),
    [anon_sym_asm] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(568),
    [anon_sym_while] = ACTIONS(568),
    [anon_sym_for] = ACTIONS(568),
    [anon_sym_PIPE] = ACTIONS(568),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_STAR_EQ] = ACTIONS(570),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(570),
    [anon_sym_SLASH_EQ] = ACTIONS(570),
    [anon_sym_PERCENT_EQ] = ACTIONS(570),
    [anon_sym_PLUS_EQ] = ACTIONS(570),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(570),
    [anon_sym_DASH_EQ] = ACTIONS(570),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(570),
    [anon_sym_LT_LT_EQ] = ACTIONS(570),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_AMP_EQ] = ACTIONS(570),
    [anon_sym_CARET_EQ] = ACTIONS(570),
    [anon_sym_PIPE_EQ] = ACTIONS(570),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(570),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(570),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(570),
    [anon_sym_EQ_EQ] = ACTIONS(570),
    [anon_sym_BANG_EQ] = ACTIONS(570),
    [anon_sym_LT] = ACTIONS(568),
    [anon_sym_GT] = ACTIONS(568),
    [anon_sym_LT_EQ] = ACTIONS(570),
    [anon_sym_GT_EQ] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_CARET] = ACTIONS(568),
    [anon_sym_orelse] = ACTIONS(568),
    [anon_sym_catch] = ACTIONS(568),
    [anon_sym_LT_LT] = ACTIONS(568),
    [anon_sym_GT_GT] = ACTIONS(568),
    [anon_sym_LT_LT_PIPE] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(568),
    [anon_sym_DASH] = ACTIONS(568),
    [anon_sym_PLUS_PLUS] = ACTIONS(570),
    [anon_sym_PLUS_PERCENT] = ACTIONS(568),
    [anon_sym_DASH_PERCENT] = ACTIONS(568),
    [anon_sym_PLUS_PIPE] = ACTIONS(568),
    [anon_sym_DASH_PIPE] = ACTIONS(568),
    [anon_sym_PIPE_PIPE] = ACTIONS(570),
    [anon_sym_SLASH] = ACTIONS(568),
    [anon_sym_PERCENT] = ACTIONS(568),
    [anon_sym_STAR_STAR] = ACTIONS(570),
    [anon_sym_STAR_PERCENT] = ACTIONS(568),
    [anon_sym_STAR_PIPE] = ACTIONS(568),
    [anon_sym_TILDE] = ACTIONS(570),
    [anon_sym_try] = ACTIONS(568),
    [anon_sym_await] = ACTIONS(568),
    [anon_sym_QMARK] = ACTIONS(570),
    [anon_sym_DOT_STAR] = ACTIONS(570),
    [anon_sym_DOT_QMARK] = ACTIONS(570),
    [anon_sym_struct] = ACTIONS(568),
    [anon_sym_opaque] = ACTIONS(568),
    [anon_sym_enum] = ACTIONS(568),
    [anon_sym_union] = ACTIONS(568),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(570),
    [aux_sym_FLOAT_token1] = ACTIONS(570),
    [aux_sym_FLOAT_token2] = ACTIONS(570),
    [aux_sym_FLOAT_token3] = ACTIONS(570),
    [aux_sym_FLOAT_token4] = ACTIONS(570),
    [aux_sym_INTEGER_token1] = ACTIONS(570),
    [aux_sym_INTEGER_token2] = ACTIONS(570),
    [aux_sym_INTEGER_token3] = ACTIONS(568),
    [aux_sym_INTEGER_token4] = ACTIONS(568),
    [anon_sym_DQUOTE] = ACTIONS(570),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(570),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(568),
    [anon_sym_AT] = ACTIONS(570),
  },
  [54] = {
    [anon_sym_comptime] = ACTIONS(572),
    [anon_sym_extern] = ACTIONS(572),
    [anon_sym_inline] = ACTIONS(572),
    [anon_sym_SEMI] = ACTIONS(574),
    [anon_sym_fn] = ACTIONS(572),
    [anon_sym_BANG] = ACTIONS(572),
    [anon_sym_const] = ACTIONS(572),
    [anon_sym_var] = ACTIONS(572),
    [anon_sym_EQ] = ACTIONS(572),
    [anon_sym_nosuspend] = ACTIONS(572),
    [anon_sym_defer] = ACTIONS(572),
    [anon_sym_suspend] = ACTIONS(572),
    [anon_sym_errdefer] = ACTIONS(572),
    [anon_sym_or] = ACTIONS(572),
    [anon_sym_and] = ACTIONS(572),
    [anon_sym_break] = ACTIONS(572),
    [anon_sym_continue] = ACTIONS(572),
    [anon_sym_resume] = ACTIONS(572),
    [anon_sym_return] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(574),
    [anon_sym_RBRACE] = ACTIONS(574),
    [anon_sym_async] = ACTIONS(572),
    [anon_sym_DOT] = ACTIONS(572),
    [anon_sym_error] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_null] = ACTIONS(572),
    [anon_sym_anyframe] = ACTIONS(572),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_undefined] = ACTIONS(572),
    [anon_sym_unreachable] = ACTIONS(572),
    [sym_BuildinTypeExpr] = ACTIONS(572),
    [anon_sym_packed] = ACTIONS(572),
    [anon_sym_LPAREN] = ACTIONS(574),
    [anon_sym_switch] = ACTIONS(572),
    [anon_sym_asm] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_if] = ACTIONS(572),
    [anon_sym_while] = ACTIONS(572),
    [anon_sym_for] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_STAR] = ACTIONS(572),
    [anon_sym_STAR_EQ] = ACTIONS(574),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(574),
    [anon_sym_SLASH_EQ] = ACTIONS(574),
    [anon_sym_PERCENT_EQ] = ACTIONS(574),
    [anon_sym_PLUS_EQ] = ACTIONS(574),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(574),
    [anon_sym_DASH_EQ] = ACTIONS(574),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(574),
    [anon_sym_LT_LT_EQ] = ACTIONS(574),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(574),
    [anon_sym_GT_GT_EQ] = ACTIONS(574),
    [anon_sym_AMP_EQ] = ACTIONS(574),
    [anon_sym_CARET_EQ] = ACTIONS(574),
    [anon_sym_PIPE_EQ] = ACTIONS(574),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(574),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(574),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(574),
    [anon_sym_EQ_EQ] = ACTIONS(574),
    [anon_sym_BANG_EQ] = ACTIONS(574),
    [anon_sym_LT] = ACTIONS(572),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_LT_EQ] = ACTIONS(574),
    [anon_sym_GT_EQ] = ACTIONS(574),
    [anon_sym_AMP] = ACTIONS(572),
    [anon_sym_CARET] = ACTIONS(572),
    [anon_sym_orelse] = ACTIONS(572),
    [anon_sym_catch] = ACTIONS(572),
    [anon_sym_LT_LT] = ACTIONS(572),
    [anon_sym_GT_GT] = ACTIONS(572),
    [anon_sym_LT_LT_PIPE] = ACTIONS(572),
    [anon_sym_PLUS] = ACTIONS(572),
    [anon_sym_DASH] = ACTIONS(572),
    [anon_sym_PLUS_PLUS] = ACTIONS(574),
    [anon_sym_PLUS_PERCENT] = ACTIONS(572),
    [anon_sym_DASH_PERCENT] = ACTIONS(572),
    [anon_sym_PLUS_PIPE] = ACTIONS(572),
    [anon_sym_DASH_PIPE] = ACTIONS(572),
    [anon_sym_PIPE_PIPE] = ACTIONS(574),
    [anon_sym_SLASH] = ACTIONS(572),
    [anon_sym_PERCENT] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(574),
    [anon_sym_STAR_PERCENT] = ACTIONS(572),
    [anon_sym_STAR_PIPE] = ACTIONS(572),
    [anon_sym_TILDE] = ACTIONS(574),
    [anon_sym_try] = ACTIONS(572),
    [anon_sym_await] = ACTIONS(572),
    [anon_sym_QMARK] = ACTIONS(574),
    [anon_sym_DOT_STAR] = ACTIONS(574),
    [anon_sym_DOT_QMARK] = ACTIONS(574),
    [anon_sym_struct] = ACTIONS(572),
    [anon_sym_opaque] = ACTIONS(572),
    [anon_sym_enum] = ACTIONS(572),
    [anon_sym_union] = ACTIONS(572),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(574),
    [aux_sym_FLOAT_token1] = ACTIONS(574),
    [aux_sym_FLOAT_token2] = ACTIONS(574),
    [aux_sym_FLOAT_token3] = ACTIONS(574),
    [aux_sym_FLOAT_token4] = ACTIONS(574),
    [aux_sym_INTEGER_token1] = ACTIONS(574),
    [aux_sym_INTEGER_token2] = ACTIONS(574),
    [aux_sym_INTEGER_token3] = ACTIONS(572),
    [aux_sym_INTEGER_token4] = ACTIONS(572),
    [anon_sym_DQUOTE] = ACTIONS(574),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(574),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(572),
    [anon_sym_AT] = ACTIONS(574),
  },
  [55] = {
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_comptime] = ACTIONS(578),
    [anon_sym_extern] = ACTIONS(578),
    [anon_sym_inline] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(576),
    [anon_sym_fn] = ACTIONS(578),
    [anon_sym_BANG] = ACTIONS(578),
    [anon_sym_COLON] = ACTIONS(576),
    [anon_sym_EQ] = ACTIONS(578),
    [anon_sym_nosuspend] = ACTIONS(578),
    [anon_sym_else] = ACTIONS(578),
    [anon_sym_or] = ACTIONS(578),
    [anon_sym_and] = ACTIONS(578),
    [anon_sym_break] = ACTIONS(578),
    [anon_sym_continue] = ACTIONS(578),
    [anon_sym_resume] = ACTIONS(578),
    [anon_sym_return] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(576),
    [anon_sym_RBRACE] = ACTIONS(576),
    [anon_sym_async] = ACTIONS(578),
    [anon_sym_DOT] = ACTIONS(578),
    [anon_sym_error] = ACTIONS(578),
    [anon_sym_false] = ACTIONS(578),
    [anon_sym_null] = ACTIONS(578),
    [anon_sym_anyframe] = ACTIONS(578),
    [anon_sym_true] = ACTIONS(578),
    [anon_sym_undefined] = ACTIONS(578),
    [anon_sym_unreachable] = ACTIONS(578),
    [sym_BuildinTypeExpr] = ACTIONS(578),
    [anon_sym_packed] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(576),
    [anon_sym_RPAREN] = ACTIONS(576),
    [anon_sym_switch] = ACTIONS(578),
    [anon_sym_asm] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_RBRACK] = ACTIONS(576),
    [anon_sym_if] = ACTIONS(578),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_for] = ACTIONS(578),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(578),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_DOT_DOT] = ACTIONS(576),
    [anon_sym_STAR_EQ] = ACTIONS(576),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(576),
    [anon_sym_SLASH_EQ] = ACTIONS(576),
    [anon_sym_PERCENT_EQ] = ACTIONS(576),
    [anon_sym_PLUS_EQ] = ACTIONS(576),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(576),
    [anon_sym_DASH_EQ] = ACTIONS(576),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(576),
    [anon_sym_LT_LT_EQ] = ACTIONS(576),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(576),
    [anon_sym_GT_GT_EQ] = ACTIONS(576),
    [anon_sym_AMP_EQ] = ACTIONS(576),
    [anon_sym_CARET_EQ] = ACTIONS(576),
    [anon_sym_PIPE_EQ] = ACTIONS(576),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(576),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(576),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(576),
    [anon_sym_BANG_EQ] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_GT] = ACTIONS(578),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_AMP] = ACTIONS(578),
    [anon_sym_CARET] = ACTIONS(578),
    [anon_sym_orelse] = ACTIONS(578),
    [anon_sym_catch] = ACTIONS(578),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_GT_GT] = ACTIONS(578),
    [anon_sym_LT_LT_PIPE] = ACTIONS(578),
    [anon_sym_PLUS] = ACTIONS(578),
    [anon_sym_DASH] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_PLUS_PERCENT] = ACTIONS(578),
    [anon_sym_DASH_PERCENT] = ACTIONS(578),
    [anon_sym_PLUS_PIPE] = ACTIONS(578),
    [anon_sym_DASH_PIPE] = ACTIONS(578),
    [anon_sym_PIPE_PIPE] = ACTIONS(576),
    [anon_sym_SLASH] = ACTIONS(578),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_STAR_STAR] = ACTIONS(576),
    [anon_sym_STAR_PERCENT] = ACTIONS(578),
    [anon_sym_STAR_PIPE] = ACTIONS(578),
    [anon_sym_TILDE] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(578),
    [anon_sym_await] = ACTIONS(578),
    [anon_sym_QMARK] = ACTIONS(576),
    [anon_sym_struct] = ACTIONS(578),
    [anon_sym_opaque] = ACTIONS(578),
    [anon_sym_enum] = ACTIONS(578),
    [anon_sym_union] = ACTIONS(578),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(576),
    [aux_sym_FLOAT_token1] = ACTIONS(576),
    [aux_sym_FLOAT_token2] = ACTIONS(576),
    [aux_sym_FLOAT_token3] = ACTIONS(576),
    [aux_sym_FLOAT_token4] = ACTIONS(576),
    [aux_sym_INTEGER_token1] = ACTIONS(576),
    [aux_sym_INTEGER_token2] = ACTIONS(576),
    [aux_sym_INTEGER_token3] = ACTIONS(578),
    [aux_sym_INTEGER_token4] = ACTIONS(578),
    [anon_sym_DQUOTE] = ACTIONS(576),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(576),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(578),
    [anon_sym_AT] = ACTIONS(576),
  },
  [56] = {
    [anon_sym_comptime] = ACTIONS(532),
    [anon_sym_extern] = ACTIONS(532),
    [anon_sym_inline] = ACTIONS(532),
    [anon_sym_SEMI] = ACTIONS(534),
    [anon_sym_fn] = ACTIONS(532),
    [anon_sym_BANG] = ACTIONS(532),
    [anon_sym_const] = ACTIONS(532),
    [anon_sym_var] = ACTIONS(532),
    [anon_sym_EQ] = ACTIONS(532),
    [anon_sym_nosuspend] = ACTIONS(532),
    [anon_sym_defer] = ACTIONS(532),
    [anon_sym_suspend] = ACTIONS(532),
    [anon_sym_errdefer] = ACTIONS(532),
    [anon_sym_or] = ACTIONS(532),
    [anon_sym_and] = ACTIONS(532),
    [anon_sym_break] = ACTIONS(532),
    [anon_sym_continue] = ACTIONS(532),
    [anon_sym_resume] = ACTIONS(532),
    [anon_sym_return] = ACTIONS(532),
    [anon_sym_LBRACE] = ACTIONS(534),
    [anon_sym_RBRACE] = ACTIONS(534),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_DOT] = ACTIONS(532),
    [anon_sym_error] = ACTIONS(532),
    [anon_sym_false] = ACTIONS(532),
    [anon_sym_null] = ACTIONS(532),
    [anon_sym_anyframe] = ACTIONS(532),
    [anon_sym_true] = ACTIONS(532),
    [anon_sym_undefined] = ACTIONS(532),
    [anon_sym_unreachable] = ACTIONS(532),
    [sym_BuildinTypeExpr] = ACTIONS(532),
    [anon_sym_packed] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_switch] = ACTIONS(532),
    [anon_sym_asm] = ACTIONS(532),
    [anon_sym_LBRACK] = ACTIONS(534),
    [anon_sym_if] = ACTIONS(532),
    [anon_sym_while] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(532),
    [anon_sym_PIPE] = ACTIONS(532),
    [anon_sym_STAR] = ACTIONS(532),
    [anon_sym_STAR_EQ] = ACTIONS(534),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(534),
    [anon_sym_SLASH_EQ] = ACTIONS(534),
    [anon_sym_PERCENT_EQ] = ACTIONS(534),
    [anon_sym_PLUS_EQ] = ACTIONS(534),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(534),
    [anon_sym_DASH_EQ] = ACTIONS(534),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(534),
    [anon_sym_LT_LT_EQ] = ACTIONS(534),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(534),
    [anon_sym_GT_GT_EQ] = ACTIONS(534),
    [anon_sym_AMP_EQ] = ACTIONS(534),
    [anon_sym_CARET_EQ] = ACTIONS(534),
    [anon_sym_PIPE_EQ] = ACTIONS(534),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(534),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(534),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(534),
    [anon_sym_EQ_EQ] = ACTIONS(534),
    [anon_sym_BANG_EQ] = ACTIONS(534),
    [anon_sym_LT] = ACTIONS(532),
    [anon_sym_GT] = ACTIONS(532),
    [anon_sym_LT_EQ] = ACTIONS(534),
    [anon_sym_GT_EQ] = ACTIONS(534),
    [anon_sym_AMP] = ACTIONS(532),
    [anon_sym_CARET] = ACTIONS(532),
    [anon_sym_orelse] = ACTIONS(532),
    [anon_sym_catch] = ACTIONS(532),
    [anon_sym_LT_LT] = ACTIONS(532),
    [anon_sym_GT_GT] = ACTIONS(532),
    [anon_sym_LT_LT_PIPE] = ACTIONS(532),
    [anon_sym_PLUS] = ACTIONS(532),
    [anon_sym_DASH] = ACTIONS(532),
    [anon_sym_PLUS_PLUS] = ACTIONS(534),
    [anon_sym_PLUS_PERCENT] = ACTIONS(532),
    [anon_sym_DASH_PERCENT] = ACTIONS(532),
    [anon_sym_PLUS_PIPE] = ACTIONS(532),
    [anon_sym_DASH_PIPE] = ACTIONS(532),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [anon_sym_SLASH] = ACTIONS(532),
    [anon_sym_PERCENT] = ACTIONS(532),
    [anon_sym_STAR_STAR] = ACTIONS(534),
    [anon_sym_STAR_PERCENT] = ACTIONS(532),
    [anon_sym_STAR_PIPE] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(534),
    [anon_sym_try] = ACTIONS(532),
    [anon_sym_await] = ACTIONS(532),
    [anon_sym_QMARK] = ACTIONS(534),
    [anon_sym_DOT_STAR] = ACTIONS(534),
    [anon_sym_DOT_QMARK] = ACTIONS(534),
    [anon_sym_struct] = ACTIONS(532),
    [anon_sym_opaque] = ACTIONS(532),
    [anon_sym_enum] = ACTIONS(532),
    [anon_sym_union] = ACTIONS(532),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(534),
    [aux_sym_FLOAT_token1] = ACTIONS(534),
    [aux_sym_FLOAT_token2] = ACTIONS(534),
    [aux_sym_FLOAT_token3] = ACTIONS(534),
    [aux_sym_FLOAT_token4] = ACTIONS(534),
    [aux_sym_INTEGER_token1] = ACTIONS(534),
    [aux_sym_INTEGER_token2] = ACTIONS(534),
    [aux_sym_INTEGER_token3] = ACTIONS(532),
    [aux_sym_INTEGER_token4] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(534),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(534),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(532),
    [anon_sym_AT] = ACTIONS(534),
  },
  [57] = {
    [anon_sym_comptime] = ACTIONS(580),
    [anon_sym_extern] = ACTIONS(580),
    [anon_sym_inline] = ACTIONS(580),
    [anon_sym_SEMI] = ACTIONS(522),
    [anon_sym_fn] = ACTIONS(580),
    [anon_sym_BANG] = ACTIONS(580),
    [anon_sym_const] = ACTIONS(580),
    [anon_sym_var] = ACTIONS(580),
    [anon_sym_EQ] = ACTIONS(524),
    [anon_sym_nosuspend] = ACTIONS(580),
    [anon_sym_defer] = ACTIONS(580),
    [anon_sym_suspend] = ACTIONS(580),
    [anon_sym_errdefer] = ACTIONS(580),
    [anon_sym_or] = ACTIONS(524),
    [anon_sym_and] = ACTIONS(524),
    [anon_sym_break] = ACTIONS(580),
    [anon_sym_continue] = ACTIONS(580),
    [anon_sym_resume] = ACTIONS(580),
    [anon_sym_return] = ACTIONS(580),
    [anon_sym_LBRACE] = ACTIONS(582),
    [anon_sym_RBRACE] = ACTIONS(582),
    [anon_sym_async] = ACTIONS(580),
    [anon_sym_DOT] = ACTIONS(580),
    [anon_sym_error] = ACTIONS(580),
    [anon_sym_false] = ACTIONS(580),
    [anon_sym_null] = ACTIONS(580),
    [anon_sym_anyframe] = ACTIONS(580),
    [anon_sym_true] = ACTIONS(580),
    [anon_sym_undefined] = ACTIONS(580),
    [anon_sym_unreachable] = ACTIONS(580),
    [sym_BuildinTypeExpr] = ACTIONS(580),
    [anon_sym_packed] = ACTIONS(580),
    [anon_sym_LPAREN] = ACTIONS(582),
    [anon_sym_switch] = ACTIONS(580),
    [anon_sym_asm] = ACTIONS(580),
    [anon_sym_LBRACK] = ACTIONS(582),
    [anon_sym_if] = ACTIONS(580),
    [anon_sym_while] = ACTIONS(580),
    [anon_sym_for] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(524),
    [anon_sym_STAR] = ACTIONS(580),
    [anon_sym_STAR_EQ] = ACTIONS(522),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(522),
    [anon_sym_SLASH_EQ] = ACTIONS(522),
    [anon_sym_PERCENT_EQ] = ACTIONS(522),
    [anon_sym_PLUS_EQ] = ACTIONS(522),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(522),
    [anon_sym_DASH_EQ] = ACTIONS(522),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(522),
    [anon_sym_LT_LT_EQ] = ACTIONS(522),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(522),
    [anon_sym_GT_GT_EQ] = ACTIONS(522),
    [anon_sym_AMP_EQ] = ACTIONS(522),
    [anon_sym_CARET_EQ] = ACTIONS(522),
    [anon_sym_PIPE_EQ] = ACTIONS(522),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(522),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(522),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(522),
    [anon_sym_EQ_EQ] = ACTIONS(522),
    [anon_sym_BANG_EQ] = ACTIONS(522),
    [anon_sym_LT] = ACTIONS(524),
    [anon_sym_GT] = ACTIONS(524),
    [anon_sym_LT_EQ] = ACTIONS(522),
    [anon_sym_GT_EQ] = ACTIONS(522),
    [anon_sym_AMP] = ACTIONS(580),
    [anon_sym_CARET] = ACTIONS(524),
    [anon_sym_orelse] = ACTIONS(524),
    [anon_sym_catch] = ACTIONS(524),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_GT_GT] = ACTIONS(524),
    [anon_sym_LT_LT_PIPE] = ACTIONS(524),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_PLUS_PLUS] = ACTIONS(522),
    [anon_sym_PLUS_PERCENT] = ACTIONS(524),
    [anon_sym_DASH_PERCENT] = ACTIONS(580),
    [anon_sym_PLUS_PIPE] = ACTIONS(524),
    [anon_sym_DASH_PIPE] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(522),
    [anon_sym_SLASH] = ACTIONS(524),
    [anon_sym_PERCENT] = ACTIONS(524),
    [anon_sym_STAR_STAR] = ACTIONS(582),
    [anon_sym_STAR_PERCENT] = ACTIONS(524),
    [anon_sym_STAR_PIPE] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(582),
    [anon_sym_try] = ACTIONS(580),
    [anon_sym_await] = ACTIONS(580),
    [anon_sym_QMARK] = ACTIONS(582),
    [anon_sym_DOT_STAR] = ACTIONS(522),
    [anon_sym_DOT_QMARK] = ACTIONS(522),
    [anon_sym_struct] = ACTIONS(580),
    [anon_sym_opaque] = ACTIONS(580),
    [anon_sym_enum] = ACTIONS(580),
    [anon_sym_union] = ACTIONS(580),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(582),
    [aux_sym_FLOAT_token1] = ACTIONS(582),
    [aux_sym_FLOAT_token2] = ACTIONS(582),
    [aux_sym_FLOAT_token3] = ACTIONS(582),
    [aux_sym_FLOAT_token4] = ACTIONS(582),
    [aux_sym_INTEGER_token1] = ACTIONS(582),
    [aux_sym_INTEGER_token2] = ACTIONS(582),
    [aux_sym_INTEGER_token3] = ACTIONS(580),
    [aux_sym_INTEGER_token4] = ACTIONS(580),
    [anon_sym_DQUOTE] = ACTIONS(582),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(582),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(580),
    [anon_sym_AT] = ACTIONS(582),
  },
  [58] = {
    [anon_sym_comptime] = ACTIONS(520),
    [anon_sym_extern] = ACTIONS(520),
    [anon_sym_inline] = ACTIONS(520),
    [anon_sym_SEMI] = ACTIONS(522),
    [anon_sym_fn] = ACTIONS(520),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_const] = ACTIONS(520),
    [anon_sym_var] = ACTIONS(520),
    [anon_sym_EQ] = ACTIONS(524),
    [anon_sym_nosuspend] = ACTIONS(520),
    [anon_sym_defer] = ACTIONS(520),
    [anon_sym_suspend] = ACTIONS(520),
    [anon_sym_errdefer] = ACTIONS(520),
    [anon_sym_or] = ACTIONS(524),
    [anon_sym_and] = ACTIONS(524),
    [anon_sym_break] = ACTIONS(520),
    [anon_sym_continue] = ACTIONS(520),
    [anon_sym_resume] = ACTIONS(520),
    [anon_sym_return] = ACTIONS(520),
    [anon_sym_LBRACE] = ACTIONS(526),
    [anon_sym_RBRACE] = ACTIONS(526),
    [anon_sym_async] = ACTIONS(520),
    [anon_sym_DOT] = ACTIONS(520),
    [anon_sym_error] = ACTIONS(520),
    [anon_sym_false] = ACTIONS(520),
    [anon_sym_null] = ACTIONS(520),
    [anon_sym_anyframe] = ACTIONS(520),
    [anon_sym_true] = ACTIONS(520),
    [anon_sym_undefined] = ACTIONS(520),
    [anon_sym_unreachable] = ACTIONS(520),
    [sym_BuildinTypeExpr] = ACTIONS(520),
    [anon_sym_packed] = ACTIONS(520),
    [anon_sym_LPAREN] = ACTIONS(526),
    [anon_sym_switch] = ACTIONS(520),
    [anon_sym_asm] = ACTIONS(520),
    [anon_sym_LBRACK] = ACTIONS(526),
    [anon_sym_if] = ACTIONS(520),
    [anon_sym_while] = ACTIONS(520),
    [anon_sym_for] = ACTIONS(520),
    [anon_sym_PIPE] = ACTIONS(524),
    [anon_sym_STAR] = ACTIONS(520),
    [anon_sym_STAR_EQ] = ACTIONS(522),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(522),
    [anon_sym_SLASH_EQ] = ACTIONS(522),
    [anon_sym_PERCENT_EQ] = ACTIONS(522),
    [anon_sym_PLUS_EQ] = ACTIONS(522),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(522),
    [anon_sym_DASH_EQ] = ACTIONS(522),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(522),
    [anon_sym_LT_LT_EQ] = ACTIONS(522),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(522),
    [anon_sym_GT_GT_EQ] = ACTIONS(522),
    [anon_sym_AMP_EQ] = ACTIONS(522),
    [anon_sym_CARET_EQ] = ACTIONS(522),
    [anon_sym_PIPE_EQ] = ACTIONS(522),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(522),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(522),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(522),
    [anon_sym_EQ_EQ] = ACTIONS(522),
    [anon_sym_BANG_EQ] = ACTIONS(522),
    [anon_sym_LT] = ACTIONS(524),
    [anon_sym_GT] = ACTIONS(524),
    [anon_sym_LT_EQ] = ACTIONS(522),
    [anon_sym_GT_EQ] = ACTIONS(522),
    [anon_sym_AMP] = ACTIONS(520),
    [anon_sym_CARET] = ACTIONS(524),
    [anon_sym_orelse] = ACTIONS(524),
    [anon_sym_catch] = ACTIONS(524),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_GT_GT] = ACTIONS(524),
    [anon_sym_LT_LT_PIPE] = ACTIONS(524),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(520),
    [anon_sym_PLUS_PLUS] = ACTIONS(522),
    [anon_sym_PLUS_PERCENT] = ACTIONS(524),
    [anon_sym_DASH_PERCENT] = ACTIONS(520),
    [anon_sym_PLUS_PIPE] = ACTIONS(524),
    [anon_sym_DASH_PIPE] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(522),
    [anon_sym_SLASH] = ACTIONS(524),
    [anon_sym_PERCENT] = ACTIONS(524),
    [anon_sym_STAR_STAR] = ACTIONS(526),
    [anon_sym_STAR_PERCENT] = ACTIONS(524),
    [anon_sym_STAR_PIPE] = ACTIONS(524),
    [anon_sym_TILDE] = ACTIONS(526),
    [anon_sym_try] = ACTIONS(520),
    [anon_sym_await] = ACTIONS(520),
    [anon_sym_QMARK] = ACTIONS(526),
    [anon_sym_DOT_STAR] = ACTIONS(522),
    [anon_sym_DOT_QMARK] = ACTIONS(522),
    [anon_sym_struct] = ACTIONS(520),
    [anon_sym_opaque] = ACTIONS(520),
    [anon_sym_enum] = ACTIONS(520),
    [anon_sym_union] = ACTIONS(520),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(526),
    [aux_sym_FLOAT_token1] = ACTIONS(526),
    [aux_sym_FLOAT_token2] = ACTIONS(526),
    [aux_sym_FLOAT_token3] = ACTIONS(526),
    [aux_sym_FLOAT_token4] = ACTIONS(526),
    [aux_sym_INTEGER_token1] = ACTIONS(526),
    [aux_sym_INTEGER_token2] = ACTIONS(526),
    [aux_sym_INTEGER_token3] = ACTIONS(520),
    [aux_sym_INTEGER_token4] = ACTIONS(520),
    [anon_sym_DQUOTE] = ACTIONS(526),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(526),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(520),
    [anon_sym_AT] = ACTIONS(526),
  },
  [59] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchProng] = STATE(2086),
    [sym_SwitchCase] = STATE(2204),
    [sym_SwitchItem] = STATE(1981),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(584),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(588),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [60] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchProng] = STATE(1907),
    [sym_SwitchCase] = STATE(2204),
    [sym_SwitchItem] = STATE(1981),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(584),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(592),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [61] = {
    [anon_sym_comptime] = ACTIONS(594),
    [anon_sym_extern] = ACTIONS(594),
    [anon_sym_inline] = ACTIONS(594),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_fn] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_const] = ACTIONS(594),
    [anon_sym_var] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_nosuspend] = ACTIONS(594),
    [anon_sym_defer] = ACTIONS(594),
    [anon_sym_suspend] = ACTIONS(594),
    [anon_sym_errdefer] = ACTIONS(594),
    [anon_sym_else] = ACTIONS(594),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_break] = ACTIONS(594),
    [anon_sym_continue] = ACTIONS(594),
    [anon_sym_resume] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(594),
    [anon_sym_LBRACE] = ACTIONS(596),
    [anon_sym_RBRACE] = ACTIONS(596),
    [anon_sym_async] = ACTIONS(594),
    [anon_sym_DOT] = ACTIONS(596),
    [anon_sym_error] = ACTIONS(594),
    [anon_sym_false] = ACTIONS(594),
    [anon_sym_null] = ACTIONS(594),
    [anon_sym_anyframe] = ACTIONS(594),
    [anon_sym_true] = ACTIONS(594),
    [anon_sym_undefined] = ACTIONS(594),
    [anon_sym_unreachable] = ACTIONS(594),
    [sym_BuildinTypeExpr] = ACTIONS(594),
    [anon_sym_packed] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(596),
    [anon_sym_switch] = ACTIONS(594),
    [anon_sym_asm] = ACTIONS(594),
    [anon_sym_LBRACK] = ACTIONS(596),
    [anon_sym_if] = ACTIONS(594),
    [anon_sym_while] = ACTIONS(594),
    [anon_sym_for] = ACTIONS(594),
    [anon_sym_PIPE] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(594),
    [anon_sym_STAR_EQ] = ACTIONS(87),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(87),
    [anon_sym_SLASH_EQ] = ACTIONS(87),
    [anon_sym_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_PLUS_EQ] = ACTIONS(87),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(87),
    [anon_sym_DASH_EQ] = ACTIONS(87),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(87),
    [anon_sym_LT_LT_EQ] = ACTIONS(87),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(87),
    [anon_sym_GT_GT_EQ] = ACTIONS(87),
    [anon_sym_AMP_EQ] = ACTIONS(87),
    [anon_sym_CARET_EQ] = ACTIONS(87),
    [anon_sym_PIPE_EQ] = ACTIONS(87),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(87),
    [anon_sym_BANG_EQ] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(101),
    [anon_sym_GT] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(87),
    [anon_sym_GT_EQ] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(594),
    [anon_sym_CARET] = ACTIONS(101),
    [anon_sym_orelse] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(101),
    [anon_sym_LT_LT_PIPE] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_DASH] = ACTIONS(594),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_PLUS_PERCENT] = ACTIONS(101),
    [anon_sym_DASH_PERCENT] = ACTIONS(594),
    [anon_sym_PLUS_PIPE] = ACTIONS(101),
    [anon_sym_DASH_PIPE] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(596),
    [anon_sym_STAR_PERCENT] = ACTIONS(101),
    [anon_sym_STAR_PIPE] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(596),
    [anon_sym_try] = ACTIONS(594),
    [anon_sym_await] = ACTIONS(594),
    [anon_sym_QMARK] = ACTIONS(596),
    [anon_sym_struct] = ACTIONS(594),
    [anon_sym_opaque] = ACTIONS(594),
    [anon_sym_enum] = ACTIONS(594),
    [anon_sym_union] = ACTIONS(594),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(596),
    [aux_sym_FLOAT_token1] = ACTIONS(596),
    [aux_sym_FLOAT_token2] = ACTIONS(596),
    [aux_sym_FLOAT_token3] = ACTIONS(596),
    [aux_sym_FLOAT_token4] = ACTIONS(596),
    [aux_sym_INTEGER_token1] = ACTIONS(596),
    [aux_sym_INTEGER_token2] = ACTIONS(596),
    [aux_sym_INTEGER_token3] = ACTIONS(594),
    [aux_sym_INTEGER_token4] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(596),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(596),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(594),
    [anon_sym_AT] = ACTIONS(596),
  },
  [62] = {
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_comptime] = ACTIONS(578),
    [anon_sym_extern] = ACTIONS(578),
    [anon_sym_inline] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(576),
    [anon_sym_fn] = ACTIONS(578),
    [anon_sym_BANG] = ACTIONS(578),
    [anon_sym_COLON] = ACTIONS(576),
    [anon_sym_EQ] = ACTIONS(578),
    [anon_sym_nosuspend] = ACTIONS(578),
    [anon_sym_or] = ACTIONS(578),
    [anon_sym_and] = ACTIONS(578),
    [anon_sym_break] = ACTIONS(578),
    [anon_sym_continue] = ACTIONS(578),
    [anon_sym_resume] = ACTIONS(578),
    [anon_sym_return] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(576),
    [anon_sym_RBRACE] = ACTIONS(576),
    [anon_sym_async] = ACTIONS(578),
    [anon_sym_DOT] = ACTIONS(578),
    [anon_sym_error] = ACTIONS(578),
    [anon_sym_false] = ACTIONS(578),
    [anon_sym_null] = ACTIONS(578),
    [anon_sym_anyframe] = ACTIONS(578),
    [anon_sym_true] = ACTIONS(578),
    [anon_sym_undefined] = ACTIONS(578),
    [anon_sym_unreachable] = ACTIONS(578),
    [sym_BuildinTypeExpr] = ACTIONS(578),
    [anon_sym_packed] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(576),
    [anon_sym_RPAREN] = ACTIONS(576),
    [anon_sym_switch] = ACTIONS(578),
    [anon_sym_asm] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_RBRACK] = ACTIONS(576),
    [anon_sym_if] = ACTIONS(578),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_for] = ACTIONS(578),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(578),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_DOT_DOT] = ACTIONS(576),
    [anon_sym_STAR_EQ] = ACTIONS(576),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(576),
    [anon_sym_SLASH_EQ] = ACTIONS(576),
    [anon_sym_PERCENT_EQ] = ACTIONS(576),
    [anon_sym_PLUS_EQ] = ACTIONS(576),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(576),
    [anon_sym_DASH_EQ] = ACTIONS(576),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(576),
    [anon_sym_LT_LT_EQ] = ACTIONS(576),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(576),
    [anon_sym_GT_GT_EQ] = ACTIONS(576),
    [anon_sym_AMP_EQ] = ACTIONS(576),
    [anon_sym_CARET_EQ] = ACTIONS(576),
    [anon_sym_PIPE_EQ] = ACTIONS(576),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(576),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(576),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(576),
    [anon_sym_BANG_EQ] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_GT] = ACTIONS(578),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_AMP] = ACTIONS(578),
    [anon_sym_CARET] = ACTIONS(578),
    [anon_sym_orelse] = ACTIONS(578),
    [anon_sym_catch] = ACTIONS(578),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_GT_GT] = ACTIONS(578),
    [anon_sym_LT_LT_PIPE] = ACTIONS(578),
    [anon_sym_PLUS] = ACTIONS(578),
    [anon_sym_DASH] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_PLUS_PERCENT] = ACTIONS(578),
    [anon_sym_DASH_PERCENT] = ACTIONS(578),
    [anon_sym_PLUS_PIPE] = ACTIONS(578),
    [anon_sym_DASH_PIPE] = ACTIONS(578),
    [anon_sym_PIPE_PIPE] = ACTIONS(576),
    [anon_sym_SLASH] = ACTIONS(578),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_STAR_STAR] = ACTIONS(576),
    [anon_sym_STAR_PERCENT] = ACTIONS(578),
    [anon_sym_STAR_PIPE] = ACTIONS(578),
    [anon_sym_TILDE] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(578),
    [anon_sym_await] = ACTIONS(578),
    [anon_sym_QMARK] = ACTIONS(576),
    [anon_sym_struct] = ACTIONS(578),
    [anon_sym_opaque] = ACTIONS(578),
    [anon_sym_enum] = ACTIONS(578),
    [anon_sym_union] = ACTIONS(578),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(576),
    [aux_sym_FLOAT_token1] = ACTIONS(576),
    [aux_sym_FLOAT_token2] = ACTIONS(576),
    [aux_sym_FLOAT_token3] = ACTIONS(576),
    [aux_sym_FLOAT_token4] = ACTIONS(576),
    [aux_sym_INTEGER_token1] = ACTIONS(576),
    [aux_sym_INTEGER_token2] = ACTIONS(576),
    [aux_sym_INTEGER_token3] = ACTIONS(578),
    [aux_sym_INTEGER_token4] = ACTIONS(578),
    [anon_sym_DQUOTE] = ACTIONS(576),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(576),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(578),
    [anon_sym_AT] = ACTIONS(576),
  },
  [63] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchProng] = STATE(1988),
    [sym_SwitchCase] = STATE(2204),
    [sym_SwitchItem] = STATE(1981),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(584),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(598),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [64] = {
    [anon_sym_COMMA] = ACTIONS(552),
    [anon_sym_comptime] = ACTIONS(554),
    [anon_sym_extern] = ACTIONS(554),
    [anon_sym_inline] = ACTIONS(554),
    [anon_sym_SEMI] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(554),
    [anon_sym_BANG] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(552),
    [anon_sym_EQ] = ACTIONS(554),
    [anon_sym_nosuspend] = ACTIONS(554),
    [anon_sym_or] = ACTIONS(554),
    [anon_sym_and] = ACTIONS(554),
    [anon_sym_break] = ACTIONS(554),
    [anon_sym_continue] = ACTIONS(554),
    [anon_sym_resume] = ACTIONS(554),
    [anon_sym_return] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(552),
    [anon_sym_RBRACE] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(554),
    [anon_sym_DOT] = ACTIONS(554),
    [anon_sym_error] = ACTIONS(554),
    [anon_sym_false] = ACTIONS(554),
    [anon_sym_null] = ACTIONS(554),
    [anon_sym_anyframe] = ACTIONS(554),
    [anon_sym_true] = ACTIONS(554),
    [anon_sym_undefined] = ACTIONS(554),
    [anon_sym_unreachable] = ACTIONS(554),
    [sym_BuildinTypeExpr] = ACTIONS(554),
    [anon_sym_packed] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_RPAREN] = ACTIONS(552),
    [anon_sym_switch] = ACTIONS(554),
    [anon_sym_asm] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(552),
    [anon_sym_RBRACK] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(554),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_PIPE] = ACTIONS(554),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_EQ_GT] = ACTIONS(552),
    [anon_sym_DOT_DOT] = ACTIONS(552),
    [anon_sym_STAR_EQ] = ACTIONS(552),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(552),
    [anon_sym_SLASH_EQ] = ACTIONS(552),
    [anon_sym_PERCENT_EQ] = ACTIONS(552),
    [anon_sym_PLUS_EQ] = ACTIONS(552),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(552),
    [anon_sym_DASH_EQ] = ACTIONS(552),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(552),
    [anon_sym_LT_LT_EQ] = ACTIONS(552),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(552),
    [anon_sym_GT_GT_EQ] = ACTIONS(552),
    [anon_sym_AMP_EQ] = ACTIONS(552),
    [anon_sym_CARET_EQ] = ACTIONS(552),
    [anon_sym_PIPE_EQ] = ACTIONS(552),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(552),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(552),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(552),
    [anon_sym_EQ_EQ] = ACTIONS(552),
    [anon_sym_BANG_EQ] = ACTIONS(552),
    [anon_sym_LT] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(552),
    [anon_sym_GT_EQ] = ACTIONS(552),
    [anon_sym_AMP] = ACTIONS(554),
    [anon_sym_CARET] = ACTIONS(554),
    [anon_sym_orelse] = ACTIONS(554),
    [anon_sym_catch] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(554),
    [anon_sym_GT_GT] = ACTIONS(554),
    [anon_sym_LT_LT_PIPE] = ACTIONS(554),
    [anon_sym_PLUS] = ACTIONS(554),
    [anon_sym_DASH] = ACTIONS(554),
    [anon_sym_PLUS_PLUS] = ACTIONS(552),
    [anon_sym_PLUS_PERCENT] = ACTIONS(554),
    [anon_sym_DASH_PERCENT] = ACTIONS(554),
    [anon_sym_PLUS_PIPE] = ACTIONS(554),
    [anon_sym_DASH_PIPE] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(552),
    [anon_sym_SLASH] = ACTIONS(554),
    [anon_sym_PERCENT] = ACTIONS(554),
    [anon_sym_STAR_STAR] = ACTIONS(552),
    [anon_sym_STAR_PERCENT] = ACTIONS(554),
    [anon_sym_STAR_PIPE] = ACTIONS(554),
    [anon_sym_TILDE] = ACTIONS(552),
    [anon_sym_try] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(554),
    [anon_sym_QMARK] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_opaque] = ACTIONS(554),
    [anon_sym_enum] = ACTIONS(554),
    [anon_sym_union] = ACTIONS(554),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [aux_sym_FLOAT_token1] = ACTIONS(552),
    [aux_sym_FLOAT_token2] = ACTIONS(552),
    [aux_sym_FLOAT_token3] = ACTIONS(552),
    [aux_sym_FLOAT_token4] = ACTIONS(552),
    [aux_sym_INTEGER_token1] = ACTIONS(552),
    [aux_sym_INTEGER_token2] = ACTIONS(552),
    [aux_sym_INTEGER_token3] = ACTIONS(554),
    [aux_sym_INTEGER_token4] = ACTIONS(554),
    [anon_sym_DQUOTE] = ACTIONS(552),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(552),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(552),
  },
  [65] = {
    [anon_sym_COMMA] = ACTIONS(536),
    [anon_sym_comptime] = ACTIONS(538),
    [anon_sym_extern] = ACTIONS(538),
    [anon_sym_inline] = ACTIONS(538),
    [anon_sym_SEMI] = ACTIONS(536),
    [anon_sym_fn] = ACTIONS(538),
    [anon_sym_BANG] = ACTIONS(538),
    [anon_sym_COLON] = ACTIONS(536),
    [anon_sym_EQ] = ACTIONS(538),
    [anon_sym_nosuspend] = ACTIONS(538),
    [anon_sym_or] = ACTIONS(538),
    [anon_sym_and] = ACTIONS(538),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(538),
    [anon_sym_resume] = ACTIONS(538),
    [anon_sym_return] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(536),
    [anon_sym_RBRACE] = ACTIONS(536),
    [anon_sym_async] = ACTIONS(538),
    [anon_sym_DOT] = ACTIONS(538),
    [anon_sym_error] = ACTIONS(538),
    [anon_sym_false] = ACTIONS(538),
    [anon_sym_null] = ACTIONS(538),
    [anon_sym_anyframe] = ACTIONS(538),
    [anon_sym_true] = ACTIONS(538),
    [anon_sym_undefined] = ACTIONS(538),
    [anon_sym_unreachable] = ACTIONS(538),
    [sym_BuildinTypeExpr] = ACTIONS(538),
    [anon_sym_packed] = ACTIONS(538),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_RPAREN] = ACTIONS(536),
    [anon_sym_switch] = ACTIONS(538),
    [anon_sym_asm] = ACTIONS(538),
    [anon_sym_LBRACK] = ACTIONS(536),
    [anon_sym_RBRACK] = ACTIONS(536),
    [anon_sym_if] = ACTIONS(538),
    [anon_sym_while] = ACTIONS(538),
    [anon_sym_for] = ACTIONS(538),
    [anon_sym_PIPE] = ACTIONS(538),
    [anon_sym_STAR] = ACTIONS(538),
    [anon_sym_EQ_GT] = ACTIONS(536),
    [anon_sym_DOT_DOT] = ACTIONS(536),
    [anon_sym_STAR_EQ] = ACTIONS(536),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(536),
    [anon_sym_SLASH_EQ] = ACTIONS(536),
    [anon_sym_PERCENT_EQ] = ACTIONS(536),
    [anon_sym_PLUS_EQ] = ACTIONS(536),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(536),
    [anon_sym_DASH_EQ] = ACTIONS(536),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(536),
    [anon_sym_LT_LT_EQ] = ACTIONS(536),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(536),
    [anon_sym_GT_GT_EQ] = ACTIONS(536),
    [anon_sym_AMP_EQ] = ACTIONS(536),
    [anon_sym_CARET_EQ] = ACTIONS(536),
    [anon_sym_PIPE_EQ] = ACTIONS(536),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(536),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(536),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(536),
    [anon_sym_EQ_EQ] = ACTIONS(536),
    [anon_sym_BANG_EQ] = ACTIONS(536),
    [anon_sym_LT] = ACTIONS(538),
    [anon_sym_GT] = ACTIONS(538),
    [anon_sym_LT_EQ] = ACTIONS(536),
    [anon_sym_GT_EQ] = ACTIONS(536),
    [anon_sym_AMP] = ACTIONS(538),
    [anon_sym_CARET] = ACTIONS(538),
    [anon_sym_orelse] = ACTIONS(538),
    [anon_sym_catch] = ACTIONS(538),
    [anon_sym_LT_LT] = ACTIONS(538),
    [anon_sym_GT_GT] = ACTIONS(538),
    [anon_sym_LT_LT_PIPE] = ACTIONS(538),
    [anon_sym_PLUS] = ACTIONS(538),
    [anon_sym_DASH] = ACTIONS(538),
    [anon_sym_PLUS_PLUS] = ACTIONS(536),
    [anon_sym_PLUS_PERCENT] = ACTIONS(538),
    [anon_sym_DASH_PERCENT] = ACTIONS(538),
    [anon_sym_PLUS_PIPE] = ACTIONS(538),
    [anon_sym_DASH_PIPE] = ACTIONS(538),
    [anon_sym_PIPE_PIPE] = ACTIONS(536),
    [anon_sym_SLASH] = ACTIONS(538),
    [anon_sym_PERCENT] = ACTIONS(538),
    [anon_sym_STAR_STAR] = ACTIONS(536),
    [anon_sym_STAR_PERCENT] = ACTIONS(538),
    [anon_sym_STAR_PIPE] = ACTIONS(538),
    [anon_sym_TILDE] = ACTIONS(536),
    [anon_sym_try] = ACTIONS(538),
    [anon_sym_await] = ACTIONS(538),
    [anon_sym_QMARK] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_opaque] = ACTIONS(538),
    [anon_sym_enum] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(538),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(536),
    [aux_sym_FLOAT_token1] = ACTIONS(536),
    [aux_sym_FLOAT_token2] = ACTIONS(536),
    [aux_sym_FLOAT_token3] = ACTIONS(536),
    [aux_sym_FLOAT_token4] = ACTIONS(536),
    [aux_sym_INTEGER_token1] = ACTIONS(536),
    [aux_sym_INTEGER_token2] = ACTIONS(536),
    [aux_sym_INTEGER_token3] = ACTIONS(538),
    [aux_sym_INTEGER_token4] = ACTIONS(538),
    [anon_sym_DQUOTE] = ACTIONS(536),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(536),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(538),
    [anon_sym_AT] = ACTIONS(536),
  },
  [66] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchProng] = STATE(2086),
    [sym_SwitchCase] = STATE(2204),
    [sym_SwitchItem] = STATE(1981),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(584),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(600),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [67] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchProng] = STATE(2086),
    [sym_SwitchCase] = STATE(2204),
    [sym_SwitchItem] = STATE(1981),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(584),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(602),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [68] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchProng] = STATE(1934),
    [sym_SwitchCase] = STATE(2204),
    [sym_SwitchItem] = STATE(1981),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(584),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(604),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [69] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchProng] = STATE(2086),
    [sym_SwitchCase] = STATE(2204),
    [sym_SwitchItem] = STATE(1981),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(584),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(606),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [70] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchProng] = STATE(2086),
    [sym_SwitchCase] = STATE(2204),
    [sym_SwitchItem] = STATE(1981),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(584),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(608),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [71] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchProng] = STATE(2086),
    [sym_SwitchCase] = STATE(2204),
    [sym_SwitchItem] = STATE(1981),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(584),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(610),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [72] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchProng] = STATE(1953),
    [sym_SwitchCase] = STATE(2204),
    [sym_SwitchItem] = STATE(1981),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(584),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(612),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [73] = {
    [anon_sym_COMMA] = ACTIONS(556),
    [anon_sym_comptime] = ACTIONS(558),
    [anon_sym_extern] = ACTIONS(558),
    [anon_sym_inline] = ACTIONS(558),
    [anon_sym_SEMI] = ACTIONS(556),
    [anon_sym_fn] = ACTIONS(558),
    [anon_sym_BANG] = ACTIONS(558),
    [anon_sym_COLON] = ACTIONS(556),
    [anon_sym_EQ] = ACTIONS(558),
    [anon_sym_nosuspend] = ACTIONS(558),
    [anon_sym_or] = ACTIONS(558),
    [anon_sym_and] = ACTIONS(558),
    [anon_sym_break] = ACTIONS(558),
    [anon_sym_continue] = ACTIONS(558),
    [anon_sym_resume] = ACTIONS(558),
    [anon_sym_return] = ACTIONS(558),
    [anon_sym_LBRACE] = ACTIONS(556),
    [anon_sym_RBRACE] = ACTIONS(556),
    [anon_sym_async] = ACTIONS(558),
    [anon_sym_DOT] = ACTIONS(558),
    [anon_sym_error] = ACTIONS(558),
    [anon_sym_false] = ACTIONS(558),
    [anon_sym_null] = ACTIONS(558),
    [anon_sym_anyframe] = ACTIONS(558),
    [anon_sym_true] = ACTIONS(558),
    [anon_sym_undefined] = ACTIONS(558),
    [anon_sym_unreachable] = ACTIONS(558),
    [sym_BuildinTypeExpr] = ACTIONS(558),
    [anon_sym_packed] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_RPAREN] = ACTIONS(556),
    [anon_sym_switch] = ACTIONS(558),
    [anon_sym_asm] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(556),
    [anon_sym_RBRACK] = ACTIONS(556),
    [anon_sym_if] = ACTIONS(558),
    [anon_sym_while] = ACTIONS(558),
    [anon_sym_for] = ACTIONS(558),
    [anon_sym_PIPE] = ACTIONS(558),
    [anon_sym_STAR] = ACTIONS(558),
    [anon_sym_EQ_GT] = ACTIONS(556),
    [anon_sym_DOT_DOT] = ACTIONS(556),
    [anon_sym_STAR_EQ] = ACTIONS(556),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(556),
    [anon_sym_SLASH_EQ] = ACTIONS(556),
    [anon_sym_PERCENT_EQ] = ACTIONS(556),
    [anon_sym_PLUS_EQ] = ACTIONS(556),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(556),
    [anon_sym_DASH_EQ] = ACTIONS(556),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(556),
    [anon_sym_LT_LT_EQ] = ACTIONS(556),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(556),
    [anon_sym_GT_GT_EQ] = ACTIONS(556),
    [anon_sym_AMP_EQ] = ACTIONS(556),
    [anon_sym_CARET_EQ] = ACTIONS(556),
    [anon_sym_PIPE_EQ] = ACTIONS(556),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(556),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(556),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(556),
    [anon_sym_EQ_EQ] = ACTIONS(556),
    [anon_sym_BANG_EQ] = ACTIONS(556),
    [anon_sym_LT] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(558),
    [anon_sym_LT_EQ] = ACTIONS(556),
    [anon_sym_GT_EQ] = ACTIONS(556),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_CARET] = ACTIONS(558),
    [anon_sym_orelse] = ACTIONS(558),
    [anon_sym_catch] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(558),
    [anon_sym_GT_GT] = ACTIONS(558),
    [anon_sym_LT_LT_PIPE] = ACTIONS(558),
    [anon_sym_PLUS] = ACTIONS(558),
    [anon_sym_DASH] = ACTIONS(558),
    [anon_sym_PLUS_PLUS] = ACTIONS(556),
    [anon_sym_PLUS_PERCENT] = ACTIONS(558),
    [anon_sym_DASH_PERCENT] = ACTIONS(558),
    [anon_sym_PLUS_PIPE] = ACTIONS(558),
    [anon_sym_DASH_PIPE] = ACTIONS(558),
    [anon_sym_PIPE_PIPE] = ACTIONS(556),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_PERCENT] = ACTIONS(558),
    [anon_sym_STAR_STAR] = ACTIONS(556),
    [anon_sym_STAR_PERCENT] = ACTIONS(558),
    [anon_sym_STAR_PIPE] = ACTIONS(558),
    [anon_sym_TILDE] = ACTIONS(556),
    [anon_sym_try] = ACTIONS(558),
    [anon_sym_await] = ACTIONS(558),
    [anon_sym_QMARK] = ACTIONS(556),
    [anon_sym_struct] = ACTIONS(558),
    [anon_sym_opaque] = ACTIONS(558),
    [anon_sym_enum] = ACTIONS(558),
    [anon_sym_union] = ACTIONS(558),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(556),
    [aux_sym_FLOAT_token1] = ACTIONS(556),
    [aux_sym_FLOAT_token2] = ACTIONS(556),
    [aux_sym_FLOAT_token3] = ACTIONS(556),
    [aux_sym_FLOAT_token4] = ACTIONS(556),
    [aux_sym_INTEGER_token1] = ACTIONS(556),
    [aux_sym_INTEGER_token2] = ACTIONS(556),
    [aux_sym_INTEGER_token3] = ACTIONS(558),
    [aux_sym_INTEGER_token4] = ACTIONS(558),
    [anon_sym_DQUOTE] = ACTIONS(556),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(556),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(558),
    [anon_sym_AT] = ACTIONS(556),
  },
  [74] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchProng] = STATE(2086),
    [sym_SwitchCase] = STATE(2204),
    [sym_SwitchItem] = STATE(1981),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(584),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(614),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [75] = {
    [anon_sym_COMMA] = ACTIONS(560),
    [anon_sym_comptime] = ACTIONS(562),
    [anon_sym_extern] = ACTIONS(562),
    [anon_sym_inline] = ACTIONS(562),
    [anon_sym_SEMI] = ACTIONS(560),
    [anon_sym_fn] = ACTIONS(562),
    [anon_sym_BANG] = ACTIONS(562),
    [anon_sym_COLON] = ACTIONS(560),
    [anon_sym_EQ] = ACTIONS(562),
    [anon_sym_nosuspend] = ACTIONS(562),
    [anon_sym_or] = ACTIONS(562),
    [anon_sym_and] = ACTIONS(562),
    [anon_sym_break] = ACTIONS(562),
    [anon_sym_continue] = ACTIONS(562),
    [anon_sym_resume] = ACTIONS(562),
    [anon_sym_return] = ACTIONS(562),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_RBRACE] = ACTIONS(560),
    [anon_sym_async] = ACTIONS(562),
    [anon_sym_DOT] = ACTIONS(562),
    [anon_sym_error] = ACTIONS(562),
    [anon_sym_false] = ACTIONS(562),
    [anon_sym_null] = ACTIONS(562),
    [anon_sym_anyframe] = ACTIONS(562),
    [anon_sym_true] = ACTIONS(562),
    [anon_sym_undefined] = ACTIONS(562),
    [anon_sym_unreachable] = ACTIONS(562),
    [sym_BuildinTypeExpr] = ACTIONS(562),
    [anon_sym_packed] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(560),
    [anon_sym_RPAREN] = ACTIONS(560),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_asm] = ACTIONS(562),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(560),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_while] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(562),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_STAR] = ACTIONS(562),
    [anon_sym_EQ_GT] = ACTIONS(560),
    [anon_sym_DOT_DOT] = ACTIONS(560),
    [anon_sym_STAR_EQ] = ACTIONS(560),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(560),
    [anon_sym_SLASH_EQ] = ACTIONS(560),
    [anon_sym_PERCENT_EQ] = ACTIONS(560),
    [anon_sym_PLUS_EQ] = ACTIONS(560),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(560),
    [anon_sym_DASH_EQ] = ACTIONS(560),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(560),
    [anon_sym_LT_LT_EQ] = ACTIONS(560),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(560),
    [anon_sym_GT_GT_EQ] = ACTIONS(560),
    [anon_sym_AMP_EQ] = ACTIONS(560),
    [anon_sym_CARET_EQ] = ACTIONS(560),
    [anon_sym_PIPE_EQ] = ACTIONS(560),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(560),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(560),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(560),
    [anon_sym_EQ_EQ] = ACTIONS(560),
    [anon_sym_BANG_EQ] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_LT_EQ] = ACTIONS(560),
    [anon_sym_GT_EQ] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(562),
    [anon_sym_orelse] = ACTIONS(562),
    [anon_sym_catch] = ACTIONS(562),
    [anon_sym_LT_LT] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(562),
    [anon_sym_LT_LT_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(560),
    [anon_sym_PLUS_PERCENT] = ACTIONS(562),
    [anon_sym_DASH_PERCENT] = ACTIONS(562),
    [anon_sym_PLUS_PIPE] = ACTIONS(562),
    [anon_sym_DASH_PIPE] = ACTIONS(562),
    [anon_sym_PIPE_PIPE] = ACTIONS(560),
    [anon_sym_SLASH] = ACTIONS(562),
    [anon_sym_PERCENT] = ACTIONS(562),
    [anon_sym_STAR_STAR] = ACTIONS(560),
    [anon_sym_STAR_PERCENT] = ACTIONS(562),
    [anon_sym_STAR_PIPE] = ACTIONS(562),
    [anon_sym_TILDE] = ACTIONS(560),
    [anon_sym_try] = ACTIONS(562),
    [anon_sym_await] = ACTIONS(562),
    [anon_sym_QMARK] = ACTIONS(560),
    [anon_sym_struct] = ACTIONS(562),
    [anon_sym_opaque] = ACTIONS(562),
    [anon_sym_enum] = ACTIONS(562),
    [anon_sym_union] = ACTIONS(562),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(560),
    [aux_sym_FLOAT_token1] = ACTIONS(560),
    [aux_sym_FLOAT_token2] = ACTIONS(560),
    [aux_sym_FLOAT_token3] = ACTIONS(560),
    [aux_sym_FLOAT_token4] = ACTIONS(560),
    [aux_sym_INTEGER_token1] = ACTIONS(560),
    [aux_sym_INTEGER_token2] = ACTIONS(560),
    [aux_sym_INTEGER_token3] = ACTIONS(562),
    [aux_sym_INTEGER_token4] = ACTIONS(562),
    [anon_sym_DQUOTE] = ACTIONS(560),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(560),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(562),
    [anon_sym_AT] = ACTIONS(560),
  },
  [76] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchProng] = STATE(2086),
    [sym_SwitchCase] = STATE(2204),
    [sym_SwitchItem] = STATE(1981),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(584),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(616),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [77] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchProng] = STATE(2086),
    [sym_SwitchCase] = STATE(2204),
    [sym_SwitchItem] = STATE(1981),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(584),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(618),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [78] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchProng] = STATE(2086),
    [sym_SwitchCase] = STATE(2204),
    [sym_SwitchItem] = STATE(1981),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(584),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(620),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [79] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchProng] = STATE(2086),
    [sym_SwitchCase] = STATE(2204),
    [sym_SwitchItem] = STATE(1981),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(584),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(622),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [80] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchProng] = STATE(1958),
    [sym_SwitchCase] = STATE(2204),
    [sym_SwitchItem] = STATE(1981),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(584),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(624),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [81] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchProng] = STATE(2086),
    [sym_SwitchCase] = STATE(2204),
    [sym_SwitchItem] = STATE(1981),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(584),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(626),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [82] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchProng] = STATE(2086),
    [sym_SwitchCase] = STATE(2204),
    [sym_SwitchItem] = STATE(1981),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(584),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(628),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [83] = {
    [sym_FnProto] = STATE(935),
    [sym_BlockExprStatement] = STATE(1177),
    [sym_BlockExpr] = STATE(1192),
    [sym_AssignExpr] = STATE(2132),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(88),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1669),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_Payload] = STATE(93),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(630),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [84] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchProng] = STATE(2001),
    [sym_SwitchCase] = STATE(2204),
    [sym_SwitchItem] = STATE(1981),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(584),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(632),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [85] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchProng] = STATE(1984),
    [sym_SwitchCase] = STATE(2204),
    [sym_SwitchItem] = STATE(1981),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(584),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(634),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [86] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchProng] = STATE(2086),
    [sym_SwitchCase] = STATE(2204),
    [sym_SwitchItem] = STATE(1981),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(584),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_RBRACE] = ACTIONS(636),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [87] = {
    [anon_sym_comptime] = ACTIONS(638),
    [anon_sym_extern] = ACTIONS(638),
    [anon_sym_inline] = ACTIONS(638),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_fn] = ACTIONS(638),
    [anon_sym_BANG] = ACTIONS(638),
    [anon_sym_const] = ACTIONS(638),
    [anon_sym_var] = ACTIONS(638),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_nosuspend] = ACTIONS(638),
    [anon_sym_defer] = ACTIONS(638),
    [anon_sym_suspend] = ACTIONS(638),
    [anon_sym_errdefer] = ACTIONS(638),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_break] = ACTIONS(638),
    [anon_sym_continue] = ACTIONS(638),
    [anon_sym_resume] = ACTIONS(638),
    [anon_sym_return] = ACTIONS(638),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(640),
    [anon_sym_async] = ACTIONS(638),
    [anon_sym_DOT] = ACTIONS(640),
    [anon_sym_error] = ACTIONS(638),
    [anon_sym_false] = ACTIONS(638),
    [anon_sym_null] = ACTIONS(638),
    [anon_sym_anyframe] = ACTIONS(638),
    [anon_sym_true] = ACTIONS(638),
    [anon_sym_undefined] = ACTIONS(638),
    [anon_sym_unreachable] = ACTIONS(638),
    [sym_BuildinTypeExpr] = ACTIONS(638),
    [anon_sym_packed] = ACTIONS(638),
    [anon_sym_LPAREN] = ACTIONS(640),
    [anon_sym_switch] = ACTIONS(638),
    [anon_sym_asm] = ACTIONS(638),
    [anon_sym_LBRACK] = ACTIONS(640),
    [anon_sym_if] = ACTIONS(638),
    [anon_sym_while] = ACTIONS(638),
    [anon_sym_for] = ACTIONS(638),
    [anon_sym_PIPE] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(638),
    [anon_sym_STAR_EQ] = ACTIONS(87),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(87),
    [anon_sym_SLASH_EQ] = ACTIONS(87),
    [anon_sym_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_PLUS_EQ] = ACTIONS(87),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(87),
    [anon_sym_DASH_EQ] = ACTIONS(87),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(87),
    [anon_sym_LT_LT_EQ] = ACTIONS(87),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(87),
    [anon_sym_GT_GT_EQ] = ACTIONS(87),
    [anon_sym_AMP_EQ] = ACTIONS(87),
    [anon_sym_CARET_EQ] = ACTIONS(87),
    [anon_sym_PIPE_EQ] = ACTIONS(87),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(87),
    [anon_sym_BANG_EQ] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(101),
    [anon_sym_GT] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(87),
    [anon_sym_GT_EQ] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(638),
    [anon_sym_CARET] = ACTIONS(101),
    [anon_sym_orelse] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(101),
    [anon_sym_LT_LT_PIPE] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_DASH] = ACTIONS(638),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_PLUS_PERCENT] = ACTIONS(101),
    [anon_sym_DASH_PERCENT] = ACTIONS(638),
    [anon_sym_PLUS_PIPE] = ACTIONS(101),
    [anon_sym_DASH_PIPE] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(640),
    [anon_sym_STAR_PERCENT] = ACTIONS(101),
    [anon_sym_STAR_PIPE] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(640),
    [anon_sym_try] = ACTIONS(638),
    [anon_sym_await] = ACTIONS(638),
    [anon_sym_QMARK] = ACTIONS(640),
    [anon_sym_struct] = ACTIONS(638),
    [anon_sym_opaque] = ACTIONS(638),
    [anon_sym_enum] = ACTIONS(638),
    [anon_sym_union] = ACTIONS(638),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(640),
    [aux_sym_FLOAT_token1] = ACTIONS(640),
    [aux_sym_FLOAT_token2] = ACTIONS(640),
    [aux_sym_FLOAT_token3] = ACTIONS(640),
    [aux_sym_FLOAT_token4] = ACTIONS(640),
    [aux_sym_INTEGER_token1] = ACTIONS(640),
    [aux_sym_INTEGER_token2] = ACTIONS(640),
    [aux_sym_INTEGER_token3] = ACTIONS(638),
    [aux_sym_INTEGER_token4] = ACTIONS(638),
    [anon_sym_DQUOTE] = ACTIONS(640),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(640),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(638),
    [anon_sym_AT] = ACTIONS(640),
  },
  [88] = {
    [anon_sym_comptime] = ACTIONS(594),
    [anon_sym_extern] = ACTIONS(594),
    [anon_sym_inline] = ACTIONS(594),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_fn] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(594),
    [anon_sym_const] = ACTIONS(594),
    [anon_sym_var] = ACTIONS(594),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_nosuspend] = ACTIONS(594),
    [anon_sym_defer] = ACTIONS(594),
    [anon_sym_suspend] = ACTIONS(594),
    [anon_sym_errdefer] = ACTIONS(594),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_break] = ACTIONS(594),
    [anon_sym_continue] = ACTIONS(594),
    [anon_sym_resume] = ACTIONS(594),
    [anon_sym_return] = ACTIONS(594),
    [anon_sym_LBRACE] = ACTIONS(596),
    [anon_sym_RBRACE] = ACTIONS(596),
    [anon_sym_async] = ACTIONS(594),
    [anon_sym_DOT] = ACTIONS(596),
    [anon_sym_error] = ACTIONS(594),
    [anon_sym_false] = ACTIONS(594),
    [anon_sym_null] = ACTIONS(594),
    [anon_sym_anyframe] = ACTIONS(594),
    [anon_sym_true] = ACTIONS(594),
    [anon_sym_undefined] = ACTIONS(594),
    [anon_sym_unreachable] = ACTIONS(594),
    [sym_BuildinTypeExpr] = ACTIONS(594),
    [anon_sym_packed] = ACTIONS(594),
    [anon_sym_LPAREN] = ACTIONS(596),
    [anon_sym_switch] = ACTIONS(594),
    [anon_sym_asm] = ACTIONS(594),
    [anon_sym_LBRACK] = ACTIONS(596),
    [anon_sym_if] = ACTIONS(594),
    [anon_sym_while] = ACTIONS(594),
    [anon_sym_for] = ACTIONS(594),
    [anon_sym_PIPE] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(594),
    [anon_sym_STAR_EQ] = ACTIONS(87),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(87),
    [anon_sym_SLASH_EQ] = ACTIONS(87),
    [anon_sym_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_PLUS_EQ] = ACTIONS(87),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(87),
    [anon_sym_DASH_EQ] = ACTIONS(87),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(87),
    [anon_sym_LT_LT_EQ] = ACTIONS(87),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(87),
    [anon_sym_GT_GT_EQ] = ACTIONS(87),
    [anon_sym_AMP_EQ] = ACTIONS(87),
    [anon_sym_CARET_EQ] = ACTIONS(87),
    [anon_sym_PIPE_EQ] = ACTIONS(87),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(87),
    [anon_sym_BANG_EQ] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(101),
    [anon_sym_GT] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(87),
    [anon_sym_GT_EQ] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(594),
    [anon_sym_CARET] = ACTIONS(101),
    [anon_sym_orelse] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(101),
    [anon_sym_LT_LT_PIPE] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_DASH] = ACTIONS(594),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_PLUS_PERCENT] = ACTIONS(101),
    [anon_sym_DASH_PERCENT] = ACTIONS(594),
    [anon_sym_PLUS_PIPE] = ACTIONS(101),
    [anon_sym_DASH_PIPE] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(596),
    [anon_sym_STAR_PERCENT] = ACTIONS(101),
    [anon_sym_STAR_PIPE] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(596),
    [anon_sym_try] = ACTIONS(594),
    [anon_sym_await] = ACTIONS(594),
    [anon_sym_QMARK] = ACTIONS(596),
    [anon_sym_struct] = ACTIONS(594),
    [anon_sym_opaque] = ACTIONS(594),
    [anon_sym_enum] = ACTIONS(594),
    [anon_sym_union] = ACTIONS(594),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(596),
    [aux_sym_FLOAT_token1] = ACTIONS(596),
    [aux_sym_FLOAT_token2] = ACTIONS(596),
    [aux_sym_FLOAT_token3] = ACTIONS(596),
    [aux_sym_FLOAT_token4] = ACTIONS(596),
    [aux_sym_INTEGER_token1] = ACTIONS(596),
    [aux_sym_INTEGER_token2] = ACTIONS(596),
    [aux_sym_INTEGER_token3] = ACTIONS(594),
    [aux_sym_INTEGER_token4] = ACTIONS(594),
    [anon_sym_DQUOTE] = ACTIONS(596),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(596),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(594),
    [anon_sym_AT] = ACTIONS(596),
  },
  [89] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchProng] = STATE(2086),
    [sym_SwitchCase] = STATE(2204),
    [sym_SwitchItem] = STATE(1981),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(584),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [90] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1602),
    [sym_BinaryExpr] = STATE(1602),
    [sym_UnaryExpr] = STATE(1602),
    [sym__PrimaryExpr] = STATE(1602),
    [sym_IfExpr] = STATE(1602),
    [sym_Block] = STATE(1602),
    [sym_LoopExpr] = STATE(1602),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1602),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1602),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym__SentinelTerminatedExpr] = STATE(2139),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(1423),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(642),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(644),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [91] = {
    [sym_FnProto] = STATE(935),
    [sym_BlockExprStatement] = STATE(1177),
    [sym_BlockExpr] = STATE(1192),
    [sym_AssignExpr] = STATE(2132),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(88),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1669),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [92] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1665),
    [sym_WhileExpr] = STATE(1665),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1536),
    [sym_WhileTypeExpr] = STATE(1536),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchCase] = STATE(2199),
    [sym_SwitchItem] = STATE(1981),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(329),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(586),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [93] = {
    [sym_FnProto] = STATE(935),
    [sym_BlockExprStatement] = STATE(1151),
    [sym_BlockExpr] = STATE(1192),
    [sym_AssignExpr] = STATE(2132),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(88),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1669),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [94] = {
    [sym_FnProto] = STATE(935),
    [sym_AssignExpr] = STATE(2037),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(1284),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PtrIndexPayload] = STATE(132),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(646),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [95] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1602),
    [sym_BinaryExpr] = STATE(1602),
    [sym_UnaryExpr] = STATE(1602),
    [sym__PrimaryExpr] = STATE(1602),
    [sym_IfExpr] = STATE(1602),
    [sym_Block] = STATE(1602),
    [sym_LoopExpr] = STATE(1602),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1602),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1602),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym__SentinelTerminatedExpr] = STATE(2145),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(1423),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(642),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(648),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [96] = {
    [sym_FnProto] = STATE(935),
    [sym_AssignExpr] = STATE(2029),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(1284),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PtrIndexPayload] = STATE(154),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(646),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [97] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1602),
    [sym_BinaryExpr] = STATE(1602),
    [sym_UnaryExpr] = STATE(1602),
    [sym__PrimaryExpr] = STATE(1602),
    [sym_IfExpr] = STATE(1602),
    [sym_Block] = STATE(1602),
    [sym_LoopExpr] = STATE(1602),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1602),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1602),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym__SentinelTerminatedExpr] = STATE(2177),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(1423),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(642),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(650),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [98] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1602),
    [sym_BinaryExpr] = STATE(1602),
    [sym_UnaryExpr] = STATE(1602),
    [sym__PrimaryExpr] = STATE(1602),
    [sym_IfExpr] = STATE(1602),
    [sym_Block] = STATE(1602),
    [sym_LoopExpr] = STATE(1602),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1602),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1602),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym__SentinelTerminatedExpr] = STATE(2129),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(1423),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(642),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(652),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [99] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1602),
    [sym_BinaryExpr] = STATE(1602),
    [sym_UnaryExpr] = STATE(1602),
    [sym__PrimaryExpr] = STATE(1602),
    [sym_IfExpr] = STATE(1602),
    [sym_Block] = STATE(1602),
    [sym_LoopExpr] = STATE(1602),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1602),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1602),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym__SentinelTerminatedExpr] = STATE(2167),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(1423),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(642),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(654),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [100] = {
    [sym_FnProto] = STATE(935),
    [sym_BlockExprStatement] = STATE(1177),
    [sym_BlockExpr] = STATE(1192),
    [sym_AssignExpr] = STATE(2132),
    [sym__Expr] = STATE(1334),
    [sym_BinaryExpr] = STATE(1334),
    [sym_UnaryExpr] = STATE(1334),
    [sym__PrimaryExpr] = STATE(1334),
    [sym_IfExpr] = STATE(1334),
    [sym_Block] = STATE(88),
    [sym_LoopExpr] = STATE(1334),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1334),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1334),
    [sym_BlockLabel] = STATE(1669),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [101] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1602),
    [sym_BinaryExpr] = STATE(1602),
    [sym_UnaryExpr] = STATE(1602),
    [sym__PrimaryExpr] = STATE(1602),
    [sym_IfExpr] = STATE(1602),
    [sym_Block] = STATE(1602),
    [sym_LoopExpr] = STATE(1602),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1602),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1602),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym__SentinelTerminatedExpr] = STATE(2207),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(1423),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(642),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(656),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [102] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1095),
    [sym_BinaryExpr] = STATE(1095),
    [sym_UnaryExpr] = STATE(1095),
    [sym__PrimaryExpr] = STATE(1095),
    [sym_IfExpr] = STATE(1095),
    [sym_Block] = STATE(1095),
    [sym_LoopExpr] = STATE(1095),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1095),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1095),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_Payload] = STATE(169),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(630),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [103] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchItem] = STATE(2071),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(329),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_EQ_GT] = ACTIONS(658),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [104] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1580),
    [sym_BinaryExpr] = STATE(1580),
    [sym_UnaryExpr] = STATE(1580),
    [sym__PrimaryExpr] = STATE(1580),
    [sym_IfExpr] = STATE(1580),
    [sym_Block] = STATE(1580),
    [sym_LoopExpr] = STATE(1580),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1580),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1580),
    [sym_BlockLabel] = STATE(1670),
    [sym_FieldInit] = STATE(1881),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(660),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(662),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [105] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1564),
    [sym_BinaryExpr] = STATE(1564),
    [sym_UnaryExpr] = STATE(1564),
    [sym__PrimaryExpr] = STATE(1564),
    [sym_IfExpr] = STATE(1564),
    [sym_Block] = STATE(1564),
    [sym_LoopExpr] = STATE(1564),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1564),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1564),
    [sym_BlockLabel] = STATE(1670),
    [sym_FieldInit] = STATE(1856),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(664),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(662),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [106] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1071),
    [sym_BinaryExpr] = STATE(1071),
    [sym_UnaryExpr] = STATE(1071),
    [sym__PrimaryExpr] = STATE(1071),
    [sym_IfExpr] = STATE(1071),
    [sym_Block] = STATE(1071),
    [sym_LoopExpr] = STATE(1071),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1071),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1071),
    [sym_BlockLabel] = STATE(1678),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_Payload] = STATE(333),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(630),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [107] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1588),
    [sym_BinaryExpr] = STATE(1588),
    [sym_UnaryExpr] = STATE(1588),
    [sym__PrimaryExpr] = STATE(1588),
    [sym_IfExpr] = STATE(1588),
    [sym_Block] = STATE(1588),
    [sym_LoopExpr] = STATE(1588),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1588),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1588),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(1419),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(666),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(668),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(670),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [108] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1603),
    [sym_BinaryExpr] = STATE(1603),
    [sym_UnaryExpr] = STATE(1603),
    [sym__PrimaryExpr] = STATE(1603),
    [sym_IfExpr] = STATE(1603),
    [sym_Block] = STATE(1603),
    [sym_LoopExpr] = STATE(1603),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1603),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1603),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_COMMA] = ACTIONS(672),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(672),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [109] = {
    [sym_FnProto] = STATE(384),
    [sym__Expr] = STATE(408),
    [sym_BinaryExpr] = STATE(408),
    [sym_UnaryExpr] = STATE(408),
    [sym__PrimaryExpr] = STATE(408),
    [sym_IfExpr] = STATE(408),
    [sym_Block] = STATE(408),
    [sym_LoopExpr] = STATE(408),
    [sym_ForExpr] = STATE(671),
    [sym_WhileExpr] = STATE(671),
    [sym__CurlySuffixExpr] = STATE(408),
    [sym__TypeExpr] = STATE(633),
    [sym_ErrorUnionExpr] = STATE(633),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_AsmExpr] = STATE(408),
    [sym_BlockLabel] = STATE(1676),
    [sym_IfPrefix] = STATE(279),
    [sym_WhilePrefix] = STATE(272),
    [sym_ForPrefix] = STATE(271),
    [sym_Payload] = STATE(275),
    [sym_PrefixOp] = STATE(306),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(175),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(181),
    [anon_sym_break] = ACTIONS(183),
    [anon_sym_continue] = ACTIONS(185),
    [anon_sym_resume] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_asm] = ACTIONS(205),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(630),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [110] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1583),
    [sym_BinaryExpr] = STATE(1583),
    [sym_UnaryExpr] = STATE(1583),
    [sym__PrimaryExpr] = STATE(1583),
    [sym_IfExpr] = STATE(1583),
    [sym_Block] = STATE(1583),
    [sym_LoopExpr] = STATE(1583),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1583),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1583),
    [sym_BlockLabel] = STATE(1670),
    [sym_FieldInit] = STATE(1986),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(674),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(662),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [111] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1566),
    [sym_BinaryExpr] = STATE(1566),
    [sym_UnaryExpr] = STATE(1566),
    [sym__PrimaryExpr] = STATE(1566),
    [sym_IfExpr] = STATE(1566),
    [sym_Block] = STATE(1566),
    [sym_LoopExpr] = STATE(1566),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1566),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1566),
    [sym_BlockLabel] = STATE(1670),
    [sym_FieldInit] = STATE(1851),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(676),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(662),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [112] = {
    [sym_FnProto] = STATE(935),
    [sym_BlockExpr] = STATE(1050),
    [sym_AssignExpr] = STATE(1861),
    [sym__Expr] = STATE(1291),
    [sym_BinaryExpr] = STATE(1291),
    [sym_UnaryExpr] = STATE(1291),
    [sym__PrimaryExpr] = STATE(1291),
    [sym_IfExpr] = STATE(1291),
    [sym_Block] = STATE(61),
    [sym_LoopExpr] = STATE(1291),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1291),
    [sym__TypeExpr] = STATE(1026),
    [sym_ErrorUnionExpr] = STATE(1026),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1291),
    [sym_BlockLabel] = STATE(1672),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(678),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [113] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1547),
    [sym_BinaryExpr] = STATE(1547),
    [sym_UnaryExpr] = STATE(1547),
    [sym__PrimaryExpr] = STATE(1547),
    [sym_IfExpr] = STATE(1547),
    [sym_Block] = STATE(1547),
    [sym_LoopExpr] = STATE(1547),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1547),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1547),
    [sym_BlockLabel] = STATE(1671),
    [sym_IfPrefix] = STATE(189),
    [sym_WhilePrefix] = STATE(177),
    [sym_ForPrefix] = STATE(193),
    [sym_Payload] = STATE(219),
    [sym_PrefixOp] = STATE(233),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(275),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(279),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(285),
    [anon_sym_break] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(630),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [114] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1579),
    [sym_BinaryExpr] = STATE(1579),
    [sym_UnaryExpr] = STATE(1579),
    [sym__PrimaryExpr] = STATE(1579),
    [sym_IfExpr] = STATE(1579),
    [sym_Block] = STATE(1579),
    [sym_LoopExpr] = STATE(1579),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1579),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1579),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_ForItem] = STATE(2069),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(680),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [115] = {
    [sym_FnProto] = STATE(935),
    [sym_BlockExpr] = STATE(1044),
    [sym_AssignExpr] = STATE(1860),
    [sym__Expr] = STATE(1290),
    [sym_BinaryExpr] = STATE(1290),
    [sym_UnaryExpr] = STATE(1290),
    [sym__PrimaryExpr] = STATE(1290),
    [sym_IfExpr] = STATE(1290),
    [sym_Block] = STATE(61),
    [sym_LoopExpr] = STATE(1290),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1290),
    [sym__TypeExpr] = STATE(1025),
    [sym_ErrorUnionExpr] = STATE(1025),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1290),
    [sym_BlockLabel] = STATE(1672),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(678),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [116] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchItem] = STATE(2071),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(329),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_EQ_GT] = ACTIONS(682),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [117] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1579),
    [sym_BinaryExpr] = STATE(1579),
    [sym_UnaryExpr] = STATE(1579),
    [sym__PrimaryExpr] = STATE(1579),
    [sym_IfExpr] = STATE(1579),
    [sym_Block] = STATE(1579),
    [sym_LoopExpr] = STATE(1579),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1579),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1579),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_ForArgumentsList] = STATE(2148),
    [sym_ForItem] = STATE(1886),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [118] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(445),
    [sym_BinaryExpr] = STATE(445),
    [sym_UnaryExpr] = STATE(445),
    [sym__PrimaryExpr] = STATE(445),
    [sym_IfExpr] = STATE(445),
    [sym_Block] = STATE(445),
    [sym_LoopExpr] = STATE(445),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(445),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(445),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_Payload] = STATE(312),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(630),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [119] = {
    [sym_FnProto] = STATE(935),
    [sym_BlockExpr] = STATE(1053),
    [sym_AssignExpr] = STATE(1858),
    [sym__Expr] = STATE(1287),
    [sym_BinaryExpr] = STATE(1287),
    [sym_UnaryExpr] = STATE(1287),
    [sym__PrimaryExpr] = STATE(1287),
    [sym_IfExpr] = STATE(1287),
    [sym_Block] = STATE(61),
    [sym_LoopExpr] = STATE(1287),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1287),
    [sym__TypeExpr] = STATE(1022),
    [sym_ErrorUnionExpr] = STATE(1022),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1287),
    [sym_BlockLabel] = STATE(1672),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(678),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [120] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1579),
    [sym_BinaryExpr] = STATE(1579),
    [sym_UnaryExpr] = STATE(1579),
    [sym__PrimaryExpr] = STATE(1579),
    [sym_IfExpr] = STATE(1579),
    [sym_Block] = STATE(1579),
    [sym_LoopExpr] = STATE(1579),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1579),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1579),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_ForItem] = STATE(2069),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(684),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [121] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1569),
    [sym_BinaryExpr] = STATE(1569),
    [sym_UnaryExpr] = STATE(1569),
    [sym__PrimaryExpr] = STATE(1569),
    [sym_IfExpr] = STATE(1569),
    [sym_Block] = STATE(1569),
    [sym_LoopExpr] = STATE(1569),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1569),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1569),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_Payload] = STATE(238),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(329),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_PIPE] = ACTIONS(630),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [122] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1560),
    [sym_BinaryExpr] = STATE(1560),
    [sym_UnaryExpr] = STATE(1560),
    [sym__PrimaryExpr] = STATE(1560),
    [sym_IfExpr] = STATE(1560),
    [sym_Block] = STATE(1560),
    [sym_LoopExpr] = STATE(1560),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1560),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1560),
    [sym_BlockLabel] = STATE(1670),
    [sym_FieldInit] = STATE(1928),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(686),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(662),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [123] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1565),
    [sym_BinaryExpr] = STATE(1565),
    [sym_UnaryExpr] = STATE(1565),
    [sym__PrimaryExpr] = STATE(1565),
    [sym_IfExpr] = STATE(1565),
    [sym_Block] = STATE(1565),
    [sym_LoopExpr] = STATE(1565),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1565),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1565),
    [sym_BlockLabel] = STATE(1670),
    [sym_FieldInit] = STATE(1932),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(688),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(662),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [124] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1579),
    [sym_BinaryExpr] = STATE(1579),
    [sym_UnaryExpr] = STATE(1579),
    [sym__PrimaryExpr] = STATE(1579),
    [sym_IfExpr] = STATE(1579),
    [sym_Block] = STATE(1579),
    [sym_LoopExpr] = STATE(1579),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1579),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1579),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_ForArgumentsList] = STATE(2130),
    [sym_ForItem] = STATE(1886),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [125] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(690),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [126] = {
    [sym_FnProto] = STATE(935),
    [sym_AssignExpr] = STATE(2160),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(1284),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [127] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1577),
    [sym_BinaryExpr] = STATE(1577),
    [sym_UnaryExpr] = STATE(1577),
    [sym__PrimaryExpr] = STATE(1577),
    [sym_IfExpr] = STATE(1577),
    [sym_Block] = STATE(1577),
    [sym_LoopExpr] = STATE(1577),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1577),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1577),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(692),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [128] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(694),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [129] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1559),
    [sym_BinaryExpr] = STATE(1559),
    [sym_UnaryExpr] = STATE(1559),
    [sym__PrimaryExpr] = STATE(1559),
    [sym_IfExpr] = STATE(1559),
    [sym_Block] = STATE(1559),
    [sym_LoopExpr] = STATE(1559),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1559),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1559),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(696),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [130] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(698),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [131] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(700),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [132] = {
    [sym_FnProto] = STATE(935),
    [sym_AssignExpr] = STATE(2090),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(1284),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [133] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(702),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [134] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(704),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [135] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(706),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [136] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(708),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [137] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(710),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [138] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(712),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [139] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(714),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [140] = {
    [sym_FnProto] = STATE(935),
    [sym_AssignExpr] = STATE(2143),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(1284),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [141] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(716),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [142] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1567),
    [sym_BinaryExpr] = STATE(1567),
    [sym_UnaryExpr] = STATE(1567),
    [sym__PrimaryExpr] = STATE(1567),
    [sym_IfExpr] = STATE(1567),
    [sym_Block] = STATE(1567),
    [sym_LoopExpr] = STATE(1567),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1567),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1567),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(718),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [143] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(720),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [144] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(722),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [145] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(724),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [146] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(726),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [147] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1579),
    [sym_BinaryExpr] = STATE(1579),
    [sym_UnaryExpr] = STATE(1579),
    [sym__PrimaryExpr] = STATE(1579),
    [sym_IfExpr] = STATE(1579),
    [sym_Block] = STATE(1579),
    [sym_LoopExpr] = STATE(1579),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1579),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1579),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_ForItem] = STATE(2069),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [148] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1589),
    [sym_BinaryExpr] = STATE(1589),
    [sym_UnaryExpr] = STATE(1589),
    [sym__PrimaryExpr] = STATE(1589),
    [sym_IfExpr] = STATE(1589),
    [sym_Block] = STATE(1589),
    [sym_LoopExpr] = STATE(1589),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1589),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1589),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(728),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [149] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1582),
    [sym_BinaryExpr] = STATE(1582),
    [sym_UnaryExpr] = STATE(1582),
    [sym__PrimaryExpr] = STATE(1582),
    [sym_IfExpr] = STATE(1582),
    [sym_Block] = STATE(1582),
    [sym_LoopExpr] = STATE(1582),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1582),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1582),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(730),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [150] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(732),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [151] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(734),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [152] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(736),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [153] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(738),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [154] = {
    [sym_FnProto] = STATE(935),
    [sym_AssignExpr] = STATE(2037),
    [sym__Expr] = STATE(1284),
    [sym_BinaryExpr] = STATE(1284),
    [sym_UnaryExpr] = STATE(1284),
    [sym__PrimaryExpr] = STATE(1284),
    [sym_IfExpr] = STATE(1284),
    [sym_Block] = STATE(1284),
    [sym_LoopExpr] = STATE(1284),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1284),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1284),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [155] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(740),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [156] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1574),
    [sym_BinaryExpr] = STATE(1574),
    [sym_UnaryExpr] = STATE(1574),
    [sym__PrimaryExpr] = STATE(1574),
    [sym_IfExpr] = STATE(1574),
    [sym_Block] = STATE(1574),
    [sym_LoopExpr] = STATE(1574),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1574),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1574),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_SwitchItem] = STATE(2071),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(329),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [157] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1578),
    [sym_BinaryExpr] = STATE(1578),
    [sym_UnaryExpr] = STATE(1578),
    [sym__PrimaryExpr] = STATE(1578),
    [sym_IfExpr] = STATE(1578),
    [sym_Block] = STATE(1578),
    [sym_LoopExpr] = STATE(1578),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1578),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1578),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(742),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [158] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(744),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [159] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(746),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [160] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(748),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [161] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(436),
    [sym_BinaryExpr] = STATE(436),
    [sym_UnaryExpr] = STATE(436),
    [sym__PrimaryExpr] = STATE(436),
    [sym_IfExpr] = STATE(436),
    [sym_Block] = STATE(436),
    [sym_LoopExpr] = STATE(436),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(436),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(436),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [162] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1058),
    [sym_BinaryExpr] = STATE(1058),
    [sym_UnaryExpr] = STATE(1058),
    [sym__PrimaryExpr] = STATE(1058),
    [sym_IfExpr] = STATE(1058),
    [sym_Block] = STATE(1058),
    [sym_LoopExpr] = STATE(1058),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1058),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1058),
    [sym_BlockLabel] = STATE(1678),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [163] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(447),
    [sym_BinaryExpr] = STATE(447),
    [sym_UnaryExpr] = STATE(447),
    [sym__PrimaryExpr] = STATE(447),
    [sym_IfExpr] = STATE(447),
    [sym_Block] = STATE(447),
    [sym_LoopExpr] = STATE(447),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(447),
    [sym__TypeExpr] = STATE(446),
    [sym_ErrorUnionExpr] = STATE(446),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(447),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [164] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1651),
    [sym_BinaryExpr] = STATE(1651),
    [sym_UnaryExpr] = STATE(1651),
    [sym__PrimaryExpr] = STATE(1651),
    [sym_IfExpr] = STATE(1651),
    [sym_Block] = STATE(1651),
    [sym_LoopExpr] = STATE(1651),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1651),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1651),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [165] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1594),
    [sym_BinaryExpr] = STATE(1594),
    [sym_UnaryExpr] = STATE(1594),
    [sym__PrimaryExpr] = STATE(1594),
    [sym_IfExpr] = STATE(1594),
    [sym_Block] = STATE(1594),
    [sym_LoopExpr] = STATE(1594),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1594),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1594),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [166] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(546),
    [sym_BinaryExpr] = STATE(546),
    [sym_UnaryExpr] = STATE(546),
    [sym__PrimaryExpr] = STATE(546),
    [sym_IfExpr] = STATE(546),
    [sym_Block] = STATE(546),
    [sym_LoopExpr] = STATE(546),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(546),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(546),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [167] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1609),
    [sym_BinaryExpr] = STATE(1609),
    [sym_UnaryExpr] = STATE(1609),
    [sym__PrimaryExpr] = STATE(1609),
    [sym_IfExpr] = STATE(1609),
    [sym_Block] = STATE(1609),
    [sym_LoopExpr] = STATE(1609),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1609),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1609),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [168] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(543),
    [sym_BinaryExpr] = STATE(543),
    [sym_UnaryExpr] = STATE(543),
    [sym__PrimaryExpr] = STATE(543),
    [sym_IfExpr] = STATE(543),
    [sym_Block] = STATE(543),
    [sym_LoopExpr] = STATE(543),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(543),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(543),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [169] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1135),
    [sym_BinaryExpr] = STATE(1135),
    [sym_UnaryExpr] = STATE(1135),
    [sym__PrimaryExpr] = STATE(1135),
    [sym_IfExpr] = STATE(1135),
    [sym_Block] = STATE(1135),
    [sym_LoopExpr] = STATE(1135),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1135),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1135),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [170] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1619),
    [sym_BinaryExpr] = STATE(1619),
    [sym_UnaryExpr] = STATE(1619),
    [sym__PrimaryExpr] = STATE(1619),
    [sym_IfExpr] = STATE(1619),
    [sym_Block] = STATE(1619),
    [sym_LoopExpr] = STATE(1619),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1619),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1619),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [171] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1620),
    [sym_BinaryExpr] = STATE(1620),
    [sym_UnaryExpr] = STATE(1620),
    [sym__PrimaryExpr] = STATE(1620),
    [sym_IfExpr] = STATE(1620),
    [sym_Block] = STATE(1620),
    [sym_LoopExpr] = STATE(1620),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1620),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1620),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [172] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(433),
    [sym_BinaryExpr] = STATE(433),
    [sym_UnaryExpr] = STATE(433),
    [sym__PrimaryExpr] = STATE(433),
    [sym_IfExpr] = STATE(433),
    [sym_Block] = STATE(433),
    [sym_LoopExpr] = STATE(433),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(433),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(433),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [173] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(521),
    [sym_BinaryExpr] = STATE(521),
    [sym_UnaryExpr] = STATE(521),
    [sym__PrimaryExpr] = STATE(521),
    [sym_IfExpr] = STATE(521),
    [sym_Block] = STATE(521),
    [sym_LoopExpr] = STATE(521),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(521),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(521),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [174] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1542),
    [sym_BinaryExpr] = STATE(1542),
    [sym_UnaryExpr] = STATE(1542),
    [sym__PrimaryExpr] = STATE(1542),
    [sym_IfExpr] = STATE(1542),
    [sym_Block] = STATE(1542),
    [sym_LoopExpr] = STATE(1542),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1542),
    [sym__TypeExpr] = STATE(1421),
    [sym_ErrorUnionExpr] = STATE(1421),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1542),
    [sym_BlockLabel] = STATE(1671),
    [sym_IfPrefix] = STATE(189),
    [sym_WhilePrefix] = STATE(177),
    [sym_ForPrefix] = STATE(193),
    [sym_PrefixOp] = STATE(233),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(275),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(279),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(285),
    [anon_sym_break] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [175] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1541),
    [sym_BinaryExpr] = STATE(1541),
    [sym_UnaryExpr] = STATE(1541),
    [sym__PrimaryExpr] = STATE(1541),
    [sym_IfExpr] = STATE(1541),
    [sym_Block] = STATE(1541),
    [sym_LoopExpr] = STATE(1541),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1541),
    [sym__TypeExpr] = STATE(1424),
    [sym_ErrorUnionExpr] = STATE(1424),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1541),
    [sym_BlockLabel] = STATE(1671),
    [sym_IfPrefix] = STATE(189),
    [sym_WhilePrefix] = STATE(177),
    [sym_ForPrefix] = STATE(193),
    [sym_PrefixOp] = STATE(233),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(275),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(279),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(285),
    [anon_sym_break] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [176] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1539),
    [sym_BinaryExpr] = STATE(1539),
    [sym_UnaryExpr] = STATE(1539),
    [sym__PrimaryExpr] = STATE(1539),
    [sym_IfExpr] = STATE(1539),
    [sym_Block] = STATE(1539),
    [sym_LoopExpr] = STATE(1539),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1539),
    [sym__TypeExpr] = STATE(1422),
    [sym_ErrorUnionExpr] = STATE(1422),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1539),
    [sym_BlockLabel] = STATE(1671),
    [sym_IfPrefix] = STATE(189),
    [sym_WhilePrefix] = STATE(177),
    [sym_ForPrefix] = STATE(193),
    [sym_PrefixOp] = STATE(233),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(275),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(279),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(285),
    [anon_sym_break] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [177] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1540),
    [sym_BinaryExpr] = STATE(1540),
    [sym_UnaryExpr] = STATE(1540),
    [sym__PrimaryExpr] = STATE(1540),
    [sym_IfExpr] = STATE(1540),
    [sym_Block] = STATE(1540),
    [sym_LoopExpr] = STATE(1540),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1540),
    [sym__TypeExpr] = STATE(1424),
    [sym_ErrorUnionExpr] = STATE(1424),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1540),
    [sym_BlockLabel] = STATE(1671),
    [sym_IfPrefix] = STATE(189),
    [sym_WhilePrefix] = STATE(177),
    [sym_ForPrefix] = STATE(193),
    [sym_PrefixOp] = STATE(233),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(275),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(279),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(285),
    [anon_sym_break] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [178] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1626),
    [sym_BinaryExpr] = STATE(1626),
    [sym_UnaryExpr] = STATE(1626),
    [sym__PrimaryExpr] = STATE(1626),
    [sym_IfExpr] = STATE(1626),
    [sym_Block] = STATE(1626),
    [sym_LoopExpr] = STATE(1626),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1626),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1626),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [179] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1627),
    [sym_BinaryExpr] = STATE(1627),
    [sym_UnaryExpr] = STATE(1627),
    [sym__PrimaryExpr] = STATE(1627),
    [sym_IfExpr] = STATE(1627),
    [sym_Block] = STATE(1627),
    [sym_LoopExpr] = STATE(1627),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1627),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1627),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [180] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(435),
    [sym_BinaryExpr] = STATE(435),
    [sym_UnaryExpr] = STATE(435),
    [sym__PrimaryExpr] = STATE(435),
    [sym_IfExpr] = STATE(435),
    [sym_Block] = STATE(435),
    [sym_LoopExpr] = STATE(435),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(435),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(435),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [181] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(509),
    [sym_BinaryExpr] = STATE(509),
    [sym_UnaryExpr] = STATE(509),
    [sym__PrimaryExpr] = STATE(509),
    [sym_IfExpr] = STATE(509),
    [sym_Block] = STATE(509),
    [sym_LoopExpr] = STATE(509),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(509),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(509),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [182] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1592),
    [sym_BinaryExpr] = STATE(1592),
    [sym_UnaryExpr] = STATE(1592),
    [sym__PrimaryExpr] = STATE(1592),
    [sym_IfExpr] = STATE(1592),
    [sym_Block] = STATE(1592),
    [sym_LoopExpr] = STATE(1592),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1592),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1592),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [183] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1597),
    [sym_BinaryExpr] = STATE(1597),
    [sym_UnaryExpr] = STATE(1597),
    [sym__PrimaryExpr] = STATE(1597),
    [sym_IfExpr] = STATE(1597),
    [sym_Block] = STATE(1597),
    [sym_LoopExpr] = STATE(1597),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1597),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1597),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [184] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1607),
    [sym_BinaryExpr] = STATE(1607),
    [sym_UnaryExpr] = STATE(1607),
    [sym__PrimaryExpr] = STATE(1607),
    [sym_IfExpr] = STATE(1607),
    [sym_Block] = STATE(1607),
    [sym_LoopExpr] = STATE(1607),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1607),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1607),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [185] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(458),
    [sym_BinaryExpr] = STATE(458),
    [sym_UnaryExpr] = STATE(458),
    [sym__PrimaryExpr] = STATE(458),
    [sym_IfExpr] = STATE(458),
    [sym_Block] = STATE(458),
    [sym_LoopExpr] = STATE(458),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(458),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(458),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [186] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1615),
    [sym_BinaryExpr] = STATE(1615),
    [sym_UnaryExpr] = STATE(1615),
    [sym__PrimaryExpr] = STATE(1615),
    [sym_IfExpr] = STATE(1615),
    [sym_Block] = STATE(1615),
    [sym_LoopExpr] = STATE(1615),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1615),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1615),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [187] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1612),
    [sym_BinaryExpr] = STATE(1612),
    [sym_UnaryExpr] = STATE(1612),
    [sym__PrimaryExpr] = STATE(1612),
    [sym_IfExpr] = STATE(1612),
    [sym_Block] = STATE(1612),
    [sym_LoopExpr] = STATE(1612),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1612),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1612),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [188] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(501),
    [sym_BinaryExpr] = STATE(501),
    [sym_UnaryExpr] = STATE(501),
    [sym__PrimaryExpr] = STATE(501),
    [sym_IfExpr] = STATE(501),
    [sym_Block] = STATE(501),
    [sym_LoopExpr] = STATE(501),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(501),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(501),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [189] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1537),
    [sym_BinaryExpr] = STATE(1537),
    [sym_UnaryExpr] = STATE(1537),
    [sym__PrimaryExpr] = STATE(1537),
    [sym_IfExpr] = STATE(1537),
    [sym_Block] = STATE(1537),
    [sym_LoopExpr] = STATE(1537),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1537),
    [sym__TypeExpr] = STATE(1422),
    [sym_ErrorUnionExpr] = STATE(1422),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1537),
    [sym_BlockLabel] = STATE(1671),
    [sym_IfPrefix] = STATE(189),
    [sym_WhilePrefix] = STATE(177),
    [sym_ForPrefix] = STATE(193),
    [sym_PrefixOp] = STATE(233),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(275),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(279),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(285),
    [anon_sym_break] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [190] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1653),
    [sym_BinaryExpr] = STATE(1653),
    [sym_UnaryExpr] = STATE(1653),
    [sym__PrimaryExpr] = STATE(1653),
    [sym_IfExpr] = STATE(1653),
    [sym_Block] = STATE(1653),
    [sym_LoopExpr] = STATE(1653),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1653),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1653),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [191] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(496),
    [sym_BinaryExpr] = STATE(496),
    [sym_UnaryExpr] = STATE(496),
    [sym__PrimaryExpr] = STATE(496),
    [sym_IfExpr] = STATE(496),
    [sym_Block] = STATE(496),
    [sym_LoopExpr] = STATE(496),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(496),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(496),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [192] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1568),
    [sym_BinaryExpr] = STATE(1568),
    [sym_UnaryExpr] = STATE(1568),
    [sym__PrimaryExpr] = STATE(1568),
    [sym_IfExpr] = STATE(1568),
    [sym_Block] = STATE(1568),
    [sym_LoopExpr] = STATE(1568),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1568),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1568),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [193] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1538),
    [sym_BinaryExpr] = STATE(1538),
    [sym_UnaryExpr] = STATE(1538),
    [sym__PrimaryExpr] = STATE(1538),
    [sym_IfExpr] = STATE(1538),
    [sym_Block] = STATE(1538),
    [sym_LoopExpr] = STATE(1538),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1538),
    [sym__TypeExpr] = STATE(1421),
    [sym_ErrorUnionExpr] = STATE(1421),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1538),
    [sym_BlockLabel] = STATE(1671),
    [sym_IfPrefix] = STATE(189),
    [sym_WhilePrefix] = STATE(177),
    [sym_ForPrefix] = STATE(193),
    [sym_PrefixOp] = STATE(233),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(275),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(279),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(285),
    [anon_sym_break] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [194] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1159),
    [sym_BinaryExpr] = STATE(1159),
    [sym_UnaryExpr] = STATE(1159),
    [sym__PrimaryExpr] = STATE(1159),
    [sym_IfExpr] = STATE(1159),
    [sym_Block] = STATE(1159),
    [sym_LoopExpr] = STATE(1159),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1159),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1159),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [195] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1161),
    [sym_BinaryExpr] = STATE(1161),
    [sym_UnaryExpr] = STATE(1161),
    [sym__PrimaryExpr] = STATE(1161),
    [sym_IfExpr] = STATE(1161),
    [sym_Block] = STATE(1161),
    [sym_LoopExpr] = STATE(1161),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1161),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1161),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [196] = {
    [sym_FnProto] = STATE(384),
    [sym__Expr] = STATE(427),
    [sym_BinaryExpr] = STATE(427),
    [sym_UnaryExpr] = STATE(427),
    [sym__PrimaryExpr] = STATE(427),
    [sym_IfExpr] = STATE(427),
    [sym_Block] = STATE(427),
    [sym_LoopExpr] = STATE(427),
    [sym_ForExpr] = STATE(671),
    [sym_WhileExpr] = STATE(671),
    [sym__CurlySuffixExpr] = STATE(427),
    [sym__TypeExpr] = STATE(432),
    [sym_ErrorUnionExpr] = STATE(432),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_AsmExpr] = STATE(427),
    [sym_BlockLabel] = STATE(1676),
    [sym_IfPrefix] = STATE(279),
    [sym_WhilePrefix] = STATE(272),
    [sym_ForPrefix] = STATE(271),
    [sym_PrefixOp] = STATE(306),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(175),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(181),
    [anon_sym_break] = ACTIONS(183),
    [anon_sym_continue] = ACTIONS(185),
    [anon_sym_resume] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_asm] = ACTIONS(205),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [197] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1076),
    [sym_BinaryExpr] = STATE(1076),
    [sym_UnaryExpr] = STATE(1076),
    [sym__PrimaryExpr] = STATE(1076),
    [sym_IfExpr] = STATE(1076),
    [sym_Block] = STATE(1076),
    [sym_LoopExpr] = STATE(1076),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1076),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1076),
    [sym_BlockLabel] = STATE(1678),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [198] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1076),
    [sym_BinaryExpr] = STATE(1076),
    [sym_UnaryExpr] = STATE(1076),
    [sym__PrimaryExpr] = STATE(1076),
    [sym_IfExpr] = STATE(1076),
    [sym_Block] = STATE(1076),
    [sym_LoopExpr] = STATE(1076),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1076),
    [sym__TypeExpr] = STATE(1030),
    [sym_ErrorUnionExpr] = STATE(1030),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1076),
    [sym_BlockLabel] = STATE(1678),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [199] = {
    [sym_FnProto] = STATE(384),
    [sym__Expr] = STATE(427),
    [sym_BinaryExpr] = STATE(427),
    [sym_UnaryExpr] = STATE(427),
    [sym__PrimaryExpr] = STATE(427),
    [sym_IfExpr] = STATE(427),
    [sym_Block] = STATE(427),
    [sym_LoopExpr] = STATE(427),
    [sym_ForExpr] = STATE(671),
    [sym_WhileExpr] = STATE(671),
    [sym__CurlySuffixExpr] = STATE(427),
    [sym__TypeExpr] = STATE(633),
    [sym_ErrorUnionExpr] = STATE(633),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_AsmExpr] = STATE(427),
    [sym_BlockLabel] = STATE(1676),
    [sym_IfPrefix] = STATE(279),
    [sym_WhilePrefix] = STATE(272),
    [sym_ForPrefix] = STATE(271),
    [sym_PrefixOp] = STATE(306),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(175),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(181),
    [anon_sym_break] = ACTIONS(183),
    [anon_sym_continue] = ACTIONS(185),
    [anon_sym_resume] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_asm] = ACTIONS(205),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [200] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1595),
    [sym_BinaryExpr] = STATE(1595),
    [sym_UnaryExpr] = STATE(1595),
    [sym__PrimaryExpr] = STATE(1595),
    [sym_IfExpr] = STATE(1595),
    [sym_Block] = STATE(1595),
    [sym_LoopExpr] = STATE(1595),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1595),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1595),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [201] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(495),
    [sym_BinaryExpr] = STATE(495),
    [sym_UnaryExpr] = STATE(495),
    [sym__PrimaryExpr] = STATE(495),
    [sym_IfExpr] = STATE(495),
    [sym_Block] = STATE(495),
    [sym_LoopExpr] = STATE(495),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(495),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(495),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [202] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1187),
    [sym_BinaryExpr] = STATE(1187),
    [sym_UnaryExpr] = STATE(1187),
    [sym__PrimaryExpr] = STATE(1187),
    [sym_IfExpr] = STATE(1187),
    [sym_Block] = STATE(1187),
    [sym_LoopExpr] = STATE(1187),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1187),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1187),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [203] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1189),
    [sym_BinaryExpr] = STATE(1189),
    [sym_UnaryExpr] = STATE(1189),
    [sym__PrimaryExpr] = STATE(1189),
    [sym_IfExpr] = STATE(1189),
    [sym_Block] = STATE(1189),
    [sym_LoopExpr] = STATE(1189),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1189),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1189),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [204] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1198),
    [sym_BinaryExpr] = STATE(1198),
    [sym_UnaryExpr] = STATE(1198),
    [sym__PrimaryExpr] = STATE(1198),
    [sym_IfExpr] = STATE(1198),
    [sym_Block] = STATE(1198),
    [sym_LoopExpr] = STATE(1198),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1198),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1198),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [205] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1199),
    [sym_BinaryExpr] = STATE(1199),
    [sym_UnaryExpr] = STATE(1199),
    [sym__PrimaryExpr] = STATE(1199),
    [sym_IfExpr] = STATE(1199),
    [sym_Block] = STATE(1199),
    [sym_LoopExpr] = STATE(1199),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1199),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1199),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [206] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1201),
    [sym_BinaryExpr] = STATE(1201),
    [sym_UnaryExpr] = STATE(1201),
    [sym__PrimaryExpr] = STATE(1201),
    [sym_IfExpr] = STATE(1201),
    [sym_Block] = STATE(1201),
    [sym_LoopExpr] = STATE(1201),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1201),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1201),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [207] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1622),
    [sym_BinaryExpr] = STATE(1622),
    [sym_UnaryExpr] = STATE(1622),
    [sym__PrimaryExpr] = STATE(1622),
    [sym_IfExpr] = STATE(1622),
    [sym_Block] = STATE(1622),
    [sym_LoopExpr] = STATE(1622),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1622),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1622),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(750),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [208] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1622),
    [sym_BinaryExpr] = STATE(1622),
    [sym_UnaryExpr] = STATE(1622),
    [sym__PrimaryExpr] = STATE(1622),
    [sym_IfExpr] = STATE(1622),
    [sym_Block] = STATE(1622),
    [sym_LoopExpr] = STATE(1622),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1622),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1622),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [209] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1636),
    [sym_BinaryExpr] = STATE(1636),
    [sym_UnaryExpr] = STATE(1636),
    [sym__PrimaryExpr] = STATE(1636),
    [sym_IfExpr] = STATE(1636),
    [sym_Block] = STATE(1636),
    [sym_LoopExpr] = STATE(1636),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1636),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1636),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [210] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1628),
    [sym_BinaryExpr] = STATE(1628),
    [sym_UnaryExpr] = STATE(1628),
    [sym__PrimaryExpr] = STATE(1628),
    [sym_IfExpr] = STATE(1628),
    [sym_Block] = STATE(1628),
    [sym_LoopExpr] = STATE(1628),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1628),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1628),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [211] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1642),
    [sym_BinaryExpr] = STATE(1642),
    [sym_UnaryExpr] = STATE(1642),
    [sym__PrimaryExpr] = STATE(1642),
    [sym_IfExpr] = STATE(1642),
    [sym_Block] = STATE(1642),
    [sym_LoopExpr] = STATE(1642),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1642),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1642),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [212] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1573),
    [sym_BinaryExpr] = STATE(1573),
    [sym_UnaryExpr] = STATE(1573),
    [sym__PrimaryExpr] = STATE(1573),
    [sym_IfExpr] = STATE(1573),
    [sym_Block] = STATE(1573),
    [sym_LoopExpr] = STATE(1573),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1573),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1573),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [213] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1614),
    [sym_BinaryExpr] = STATE(1614),
    [sym_UnaryExpr] = STATE(1614),
    [sym__PrimaryExpr] = STATE(1614),
    [sym_IfExpr] = STATE(1614),
    [sym_Block] = STATE(1614),
    [sym_LoopExpr] = STATE(1614),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1614),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1614),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [214] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1625),
    [sym_BinaryExpr] = STATE(1625),
    [sym_UnaryExpr] = STATE(1625),
    [sym__PrimaryExpr] = STATE(1625),
    [sym_IfExpr] = STATE(1625),
    [sym_Block] = STATE(1625),
    [sym_LoopExpr] = STATE(1625),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1625),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1625),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [215] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1611),
    [sym_BinaryExpr] = STATE(1611),
    [sym_UnaryExpr] = STATE(1611),
    [sym__PrimaryExpr] = STATE(1611),
    [sym_IfExpr] = STATE(1611),
    [sym_Block] = STATE(1611),
    [sym_LoopExpr] = STATE(1611),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1611),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1611),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [216] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(479),
    [sym_BinaryExpr] = STATE(479),
    [sym_UnaryExpr] = STATE(479),
    [sym__PrimaryExpr] = STATE(479),
    [sym_IfExpr] = STATE(479),
    [sym_Block] = STATE(479),
    [sym_LoopExpr] = STATE(479),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(479),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(479),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [217] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1633),
    [sym_BinaryExpr] = STATE(1633),
    [sym_UnaryExpr] = STATE(1633),
    [sym__PrimaryExpr] = STATE(1633),
    [sym_IfExpr] = STATE(1633),
    [sym_Block] = STATE(1633),
    [sym_LoopExpr] = STATE(1633),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1633),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1633),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [218] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1562),
    [sym_BinaryExpr] = STATE(1562),
    [sym_UnaryExpr] = STATE(1562),
    [sym__PrimaryExpr] = STATE(1562),
    [sym_IfExpr] = STATE(1562),
    [sym_Block] = STATE(1562),
    [sym_LoopExpr] = STATE(1562),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1562),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1562),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [219] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1545),
    [sym_BinaryExpr] = STATE(1545),
    [sym_UnaryExpr] = STATE(1545),
    [sym__PrimaryExpr] = STATE(1545),
    [sym_IfExpr] = STATE(1545),
    [sym_Block] = STATE(1545),
    [sym_LoopExpr] = STATE(1545),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1545),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1545),
    [sym_BlockLabel] = STATE(1671),
    [sym_IfPrefix] = STATE(189),
    [sym_WhilePrefix] = STATE(177),
    [sym_ForPrefix] = STATE(193),
    [sym_PrefixOp] = STATE(233),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(275),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(279),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(285),
    [anon_sym_break] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [220] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1575),
    [sym_BinaryExpr] = STATE(1575),
    [sym_UnaryExpr] = STATE(1575),
    [sym__PrimaryExpr] = STATE(1575),
    [sym_IfExpr] = STATE(1575),
    [sym_Block] = STATE(1575),
    [sym_LoopExpr] = STATE(1575),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1575),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1575),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [221] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1593),
    [sym_BinaryExpr] = STATE(1593),
    [sym_UnaryExpr] = STATE(1593),
    [sym__PrimaryExpr] = STATE(1593),
    [sym_IfExpr] = STATE(1593),
    [sym_Block] = STATE(1593),
    [sym_LoopExpr] = STATE(1593),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1593),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1593),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [222] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1652),
    [sym_BinaryExpr] = STATE(1652),
    [sym_UnaryExpr] = STATE(1652),
    [sym__PrimaryExpr] = STATE(1652),
    [sym_IfExpr] = STATE(1652),
    [sym_Block] = STATE(1652),
    [sym_LoopExpr] = STATE(1652),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1652),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1652),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [223] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1548),
    [sym_BinaryExpr] = STATE(1548),
    [sym_UnaryExpr] = STATE(1548),
    [sym__PrimaryExpr] = STATE(1548),
    [sym_IfExpr] = STATE(1548),
    [sym_Block] = STATE(1548),
    [sym_LoopExpr] = STATE(1548),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1548),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1548),
    [sym_BlockLabel] = STATE(1671),
    [sym_IfPrefix] = STATE(189),
    [sym_WhilePrefix] = STATE(177),
    [sym_ForPrefix] = STATE(193),
    [sym_PrefixOp] = STATE(233),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(275),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(279),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(285),
    [anon_sym_break] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [224] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1550),
    [sym_BinaryExpr] = STATE(1550),
    [sym_UnaryExpr] = STATE(1550),
    [sym__PrimaryExpr] = STATE(1550),
    [sym_IfExpr] = STATE(1550),
    [sym_Block] = STATE(1550),
    [sym_LoopExpr] = STATE(1550),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1550),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1550),
    [sym_BlockLabel] = STATE(1671),
    [sym_IfPrefix] = STATE(189),
    [sym_WhilePrefix] = STATE(177),
    [sym_ForPrefix] = STATE(193),
    [sym_PrefixOp] = STATE(233),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(275),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(279),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(285),
    [anon_sym_break] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [225] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1551),
    [sym_BinaryExpr] = STATE(1551),
    [sym_UnaryExpr] = STATE(1551),
    [sym__PrimaryExpr] = STATE(1551),
    [sym_IfExpr] = STATE(1551),
    [sym_Block] = STATE(1551),
    [sym_LoopExpr] = STATE(1551),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1551),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1551),
    [sym_BlockLabel] = STATE(1671),
    [sym_IfPrefix] = STATE(189),
    [sym_WhilePrefix] = STATE(177),
    [sym_ForPrefix] = STATE(193),
    [sym_PrefixOp] = STATE(233),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(275),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(279),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(285),
    [anon_sym_break] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [226] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1544),
    [sym_BinaryExpr] = STATE(1544),
    [sym_UnaryExpr] = STATE(1544),
    [sym__PrimaryExpr] = STATE(1544),
    [sym_IfExpr] = STATE(1544),
    [sym_Block] = STATE(1544),
    [sym_LoopExpr] = STATE(1544),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1544),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1544),
    [sym_BlockLabel] = STATE(1671),
    [sym_IfPrefix] = STATE(189),
    [sym_WhilePrefix] = STATE(177),
    [sym_ForPrefix] = STATE(193),
    [sym_PrefixOp] = STATE(233),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(275),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(279),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(285),
    [anon_sym_break] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [227] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1543),
    [sym_BinaryExpr] = STATE(1543),
    [sym_UnaryExpr] = STATE(1543),
    [sym__PrimaryExpr] = STATE(1543),
    [sym_IfExpr] = STATE(1543),
    [sym_Block] = STATE(1543),
    [sym_LoopExpr] = STATE(1543),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1543),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1543),
    [sym_BlockLabel] = STATE(1671),
    [sym_IfPrefix] = STATE(189),
    [sym_WhilePrefix] = STATE(177),
    [sym_ForPrefix] = STATE(193),
    [sym_PrefixOp] = STATE(233),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(275),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(279),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(285),
    [anon_sym_break] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [228] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1555),
    [sym_BinaryExpr] = STATE(1555),
    [sym_UnaryExpr] = STATE(1555),
    [sym__PrimaryExpr] = STATE(1555),
    [sym_IfExpr] = STATE(1555),
    [sym_Block] = STATE(1555),
    [sym_LoopExpr] = STATE(1555),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1555),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1555),
    [sym_BlockLabel] = STATE(1671),
    [sym_IfPrefix] = STATE(189),
    [sym_WhilePrefix] = STATE(177),
    [sym_ForPrefix] = STATE(193),
    [sym_PrefixOp] = STATE(233),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(275),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(279),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(285),
    [anon_sym_break] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [229] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1553),
    [sym_BinaryExpr] = STATE(1553),
    [sym_UnaryExpr] = STATE(1553),
    [sym__PrimaryExpr] = STATE(1553),
    [sym_IfExpr] = STATE(1553),
    [sym_Block] = STATE(1553),
    [sym_LoopExpr] = STATE(1553),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1553),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1553),
    [sym_BlockLabel] = STATE(1671),
    [sym_IfPrefix] = STATE(189),
    [sym_WhilePrefix] = STATE(177),
    [sym_ForPrefix] = STATE(193),
    [sym_PrefixOp] = STATE(233),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(275),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(279),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(285),
    [anon_sym_break] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [230] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1571),
    [sym_BinaryExpr] = STATE(1571),
    [sym_UnaryExpr] = STATE(1571),
    [sym__PrimaryExpr] = STATE(1571),
    [sym_IfExpr] = STATE(1571),
    [sym_Block] = STATE(1571),
    [sym_LoopExpr] = STATE(1571),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1571),
    [sym__TypeExpr] = STATE(1430),
    [sym_ErrorUnionExpr] = STATE(1430),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1571),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(329),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [231] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(466),
    [sym_BinaryExpr] = STATE(466),
    [sym_UnaryExpr] = STATE(466),
    [sym__PrimaryExpr] = STATE(466),
    [sym_IfExpr] = STATE(466),
    [sym_Block] = STATE(466),
    [sym_LoopExpr] = STATE(466),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(466),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(466),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [232] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(463),
    [sym_BinaryExpr] = STATE(463),
    [sym_UnaryExpr] = STATE(463),
    [sym__PrimaryExpr] = STATE(463),
    [sym_IfExpr] = STATE(463),
    [sym_Block] = STATE(463),
    [sym_LoopExpr] = STATE(463),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(463),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(463),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [233] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1546),
    [sym_BinaryExpr] = STATE(1546),
    [sym_UnaryExpr] = STATE(1546),
    [sym__PrimaryExpr] = STATE(1546),
    [sym_IfExpr] = STATE(1546),
    [sym_Block] = STATE(1546),
    [sym_LoopExpr] = STATE(1546),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1546),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1546),
    [sym_BlockLabel] = STATE(1671),
    [sym_IfPrefix] = STATE(189),
    [sym_WhilePrefix] = STATE(177),
    [sym_ForPrefix] = STATE(193),
    [sym_PrefixOp] = STATE(233),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(275),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(279),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(285),
    [anon_sym_break] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [234] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1571),
    [sym_BinaryExpr] = STATE(1571),
    [sym_UnaryExpr] = STATE(1571),
    [sym__PrimaryExpr] = STATE(1571),
    [sym_IfExpr] = STATE(1571),
    [sym_Block] = STATE(1571),
    [sym_LoopExpr] = STATE(1571),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1571),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1571),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(329),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [235] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1623),
    [sym_BinaryExpr] = STATE(1623),
    [sym_UnaryExpr] = STATE(1623),
    [sym__PrimaryExpr] = STATE(1623),
    [sym_IfExpr] = STATE(1623),
    [sym_Block] = STATE(1623),
    [sym_LoopExpr] = STATE(1623),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1623),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1623),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(1427),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [236] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1646),
    [sym_BinaryExpr] = STATE(1646),
    [sym_UnaryExpr] = STATE(1646),
    [sym__PrimaryExpr] = STATE(1646),
    [sym_IfExpr] = STATE(1646),
    [sym_Block] = STATE(1646),
    [sym_LoopExpr] = STATE(1646),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1646),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1646),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [237] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1631),
    [sym_BinaryExpr] = STATE(1631),
    [sym_UnaryExpr] = STATE(1631),
    [sym__PrimaryExpr] = STATE(1631),
    [sym_IfExpr] = STATE(1631),
    [sym_Block] = STATE(1631),
    [sym_LoopExpr] = STATE(1631),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1631),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1631),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [238] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1585),
    [sym_BinaryExpr] = STATE(1585),
    [sym_UnaryExpr] = STATE(1585),
    [sym__PrimaryExpr] = STATE(1585),
    [sym_IfExpr] = STATE(1585),
    [sym_Block] = STATE(1585),
    [sym_LoopExpr] = STATE(1585),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1585),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1585),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(329),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [239] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1140),
    [sym_BinaryExpr] = STATE(1140),
    [sym_UnaryExpr] = STATE(1140),
    [sym__PrimaryExpr] = STATE(1140),
    [sym_IfExpr] = STATE(1140),
    [sym_Block] = STATE(1140),
    [sym_LoopExpr] = STATE(1140),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1140),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1140),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [240] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1631),
    [sym_BinaryExpr] = STATE(1631),
    [sym_UnaryExpr] = STATE(1631),
    [sym__PrimaryExpr] = STATE(1631),
    [sym_IfExpr] = STATE(1631),
    [sym_Block] = STATE(1631),
    [sym_LoopExpr] = STATE(1631),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1631),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1631),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(752),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(754),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(752),
    [anon_sym_for] = ACTIONS(752),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [241] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(462),
    [sym_BinaryExpr] = STATE(462),
    [sym_UnaryExpr] = STATE(462),
    [sym__PrimaryExpr] = STATE(462),
    [sym_IfExpr] = STATE(462),
    [sym_Block] = STATE(462),
    [sym_LoopExpr] = STATE(462),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(462),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(462),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [242] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(434),
    [sym_BinaryExpr] = STATE(434),
    [sym_UnaryExpr] = STATE(434),
    [sym__PrimaryExpr] = STATE(434),
    [sym_IfExpr] = STATE(434),
    [sym_Block] = STATE(434),
    [sym_LoopExpr] = STATE(434),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(434),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(434),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [243] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(461),
    [sym_BinaryExpr] = STATE(461),
    [sym_UnaryExpr] = STATE(461),
    [sym__PrimaryExpr] = STATE(461),
    [sym_IfExpr] = STATE(461),
    [sym_Block] = STATE(461),
    [sym_LoopExpr] = STATE(461),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(461),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(461),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [244] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1639),
    [sym_BinaryExpr] = STATE(1639),
    [sym_UnaryExpr] = STATE(1639),
    [sym__PrimaryExpr] = STATE(1639),
    [sym_IfExpr] = STATE(1639),
    [sym_Block] = STATE(1639),
    [sym_LoopExpr] = STATE(1639),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1639),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1639),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [245] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1576),
    [sym_BinaryExpr] = STATE(1576),
    [sym_UnaryExpr] = STATE(1576),
    [sym__PrimaryExpr] = STATE(1576),
    [sym_IfExpr] = STATE(1576),
    [sym_Block] = STATE(1576),
    [sym_LoopExpr] = STATE(1576),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1576),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1576),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(329),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [246] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1557),
    [sym_BinaryExpr] = STATE(1557),
    [sym_UnaryExpr] = STATE(1557),
    [sym__PrimaryExpr] = STATE(1557),
    [sym_IfExpr] = STATE(1557),
    [sym_Block] = STATE(1557),
    [sym_LoopExpr] = STATE(1557),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1557),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1557),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(329),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [247] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1581),
    [sym_BinaryExpr] = STATE(1581),
    [sym_UnaryExpr] = STATE(1581),
    [sym__PrimaryExpr] = STATE(1581),
    [sym_IfExpr] = STATE(1581),
    [sym_Block] = STATE(1581),
    [sym_LoopExpr] = STATE(1581),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1581),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1581),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(329),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [248] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1586),
    [sym_BinaryExpr] = STATE(1586),
    [sym_UnaryExpr] = STATE(1586),
    [sym__PrimaryExpr] = STATE(1586),
    [sym_IfExpr] = STATE(1586),
    [sym_Block] = STATE(1586),
    [sym_LoopExpr] = STATE(1586),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1586),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1586),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(329),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [249] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1587),
    [sym_BinaryExpr] = STATE(1587),
    [sym_UnaryExpr] = STATE(1587),
    [sym__PrimaryExpr] = STATE(1587),
    [sym_IfExpr] = STATE(1587),
    [sym_Block] = STATE(1587),
    [sym_LoopExpr] = STATE(1587),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1587),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1587),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(329),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [250] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1591),
    [sym_BinaryExpr] = STATE(1591),
    [sym_UnaryExpr] = STATE(1591),
    [sym__PrimaryExpr] = STATE(1591),
    [sym_IfExpr] = STATE(1591),
    [sym_Block] = STATE(1591),
    [sym_LoopExpr] = STATE(1591),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1591),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1591),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(329),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [251] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1558),
    [sym_BinaryExpr] = STATE(1558),
    [sym_UnaryExpr] = STATE(1558),
    [sym__PrimaryExpr] = STATE(1558),
    [sym_IfExpr] = STATE(1558),
    [sym_Block] = STATE(1558),
    [sym_LoopExpr] = STATE(1558),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1558),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1558),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(329),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [252] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1052),
    [sym_BinaryExpr] = STATE(1052),
    [sym_UnaryExpr] = STATE(1052),
    [sym__PrimaryExpr] = STATE(1052),
    [sym_IfExpr] = STATE(1052),
    [sym_Block] = STATE(1052),
    [sym_LoopExpr] = STATE(1052),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1052),
    [sym__TypeExpr] = STATE(1022),
    [sym_ErrorUnionExpr] = STATE(1022),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1052),
    [sym_BlockLabel] = STATE(1678),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [253] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1599),
    [sym_BinaryExpr] = STATE(1599),
    [sym_UnaryExpr] = STATE(1599),
    [sym__PrimaryExpr] = STATE(1599),
    [sym_IfExpr] = STATE(1599),
    [sym_Block] = STATE(1599),
    [sym_LoopExpr] = STATE(1599),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1599),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1599),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [254] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1572),
    [sym_BinaryExpr] = STATE(1572),
    [sym_UnaryExpr] = STATE(1572),
    [sym__PrimaryExpr] = STATE(1572),
    [sym_IfExpr] = STATE(1572),
    [sym_Block] = STATE(1572),
    [sym_LoopExpr] = STATE(1572),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1572),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1572),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [255] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1608),
    [sym_BinaryExpr] = STATE(1608),
    [sym_UnaryExpr] = STATE(1608),
    [sym__PrimaryExpr] = STATE(1608),
    [sym_IfExpr] = STATE(1608),
    [sym_Block] = STATE(1608),
    [sym_LoopExpr] = STATE(1608),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1608),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1608),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [256] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(503),
    [sym_BinaryExpr] = STATE(503),
    [sym_UnaryExpr] = STATE(503),
    [sym__PrimaryExpr] = STATE(503),
    [sym_IfExpr] = STATE(503),
    [sym_Block] = STATE(503),
    [sym_LoopExpr] = STATE(503),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(503),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(503),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [257] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1621),
    [sym_BinaryExpr] = STATE(1621),
    [sym_UnaryExpr] = STATE(1621),
    [sym__PrimaryExpr] = STATE(1621),
    [sym_IfExpr] = STATE(1621),
    [sym_Block] = STATE(1621),
    [sym_LoopExpr] = STATE(1621),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1621),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1621),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [258] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1604),
    [sym_BinaryExpr] = STATE(1604),
    [sym_UnaryExpr] = STATE(1604),
    [sym__PrimaryExpr] = STATE(1604),
    [sym_IfExpr] = STATE(1604),
    [sym_Block] = STATE(1604),
    [sym_LoopExpr] = STATE(1604),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1604),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1604),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(1426),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [259] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1647),
    [sym_BinaryExpr] = STATE(1647),
    [sym_UnaryExpr] = STATE(1647),
    [sym__PrimaryExpr] = STATE(1647),
    [sym_IfExpr] = STATE(1647),
    [sym_Block] = STATE(1647),
    [sym_LoopExpr] = STATE(1647),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1647),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1647),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [260] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(460),
    [sym_BinaryExpr] = STATE(460),
    [sym_UnaryExpr] = STATE(460),
    [sym__PrimaryExpr] = STATE(460),
    [sym_IfExpr] = STATE(460),
    [sym_Block] = STATE(460),
    [sym_LoopExpr] = STATE(460),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(460),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(460),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [261] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1604),
    [sym_BinaryExpr] = STATE(1604),
    [sym_UnaryExpr] = STATE(1604),
    [sym__PrimaryExpr] = STATE(1604),
    [sym_IfExpr] = STATE(1604),
    [sym_Block] = STATE(1604),
    [sym_LoopExpr] = STATE(1604),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1604),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1604),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(1426),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(752),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(754),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(752),
    [anon_sym_for] = ACTIONS(752),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [262] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(459),
    [sym_BinaryExpr] = STATE(459),
    [sym_UnaryExpr] = STATE(459),
    [sym__PrimaryExpr] = STATE(459),
    [sym_IfExpr] = STATE(459),
    [sym_Block] = STATE(459),
    [sym_LoopExpr] = STATE(459),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(459),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(459),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [263] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1649),
    [sym_BinaryExpr] = STATE(1649),
    [sym_UnaryExpr] = STATE(1649),
    [sym__PrimaryExpr] = STATE(1649),
    [sym_IfExpr] = STATE(1649),
    [sym_Block] = STATE(1649),
    [sym_LoopExpr] = STATE(1649),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1649),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1649),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [264] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1563),
    [sym_BinaryExpr] = STATE(1563),
    [sym_UnaryExpr] = STATE(1563),
    [sym__PrimaryExpr] = STATE(1563),
    [sym_IfExpr] = STATE(1563),
    [sym_Block] = STATE(1563),
    [sym_LoopExpr] = STATE(1563),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1563),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1563),
    [sym_BlockLabel] = STATE(1677),
    [sym_IfPrefix] = STATE(176),
    [sym_WhilePrefix] = STATE(175),
    [sym_ForPrefix] = STATE(174),
    [sym_PrefixOp] = STATE(264),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(327),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(329),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(333),
    [anon_sym_break] = ACTIONS(335),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [265] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1045),
    [sym_BinaryExpr] = STATE(1045),
    [sym_UnaryExpr] = STATE(1045),
    [sym__PrimaryExpr] = STATE(1045),
    [sym_IfExpr] = STATE(1045),
    [sym_Block] = STATE(1045),
    [sym_LoopExpr] = STATE(1045),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1045),
    [sym__TypeExpr] = STATE(1025),
    [sym_ErrorUnionExpr] = STATE(1025),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1045),
    [sym_BlockLabel] = STATE(1678),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [266] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1046),
    [sym_BinaryExpr] = STATE(1046),
    [sym_UnaryExpr] = STATE(1046),
    [sym__PrimaryExpr] = STATE(1046),
    [sym_IfExpr] = STATE(1046),
    [sym_Block] = STATE(1046),
    [sym_LoopExpr] = STATE(1046),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1046),
    [sym__TypeExpr] = STATE(1026),
    [sym_ErrorUnionExpr] = STATE(1026),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1046),
    [sym_BlockLabel] = STATE(1678),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [267] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1610),
    [sym_BinaryExpr] = STATE(1610),
    [sym_UnaryExpr] = STATE(1610),
    [sym__PrimaryExpr] = STATE(1610),
    [sym_IfExpr] = STATE(1610),
    [sym_Block] = STATE(1610),
    [sym_LoopExpr] = STATE(1610),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1610),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1610),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [268] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1556),
    [sym_BinaryExpr] = STATE(1556),
    [sym_UnaryExpr] = STATE(1556),
    [sym__PrimaryExpr] = STATE(1556),
    [sym_IfExpr] = STATE(1556),
    [sym_Block] = STATE(1556),
    [sym_LoopExpr] = STATE(1556),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1556),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1556),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [269] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1596),
    [sym_BinaryExpr] = STATE(1596),
    [sym_UnaryExpr] = STATE(1596),
    [sym__PrimaryExpr] = STATE(1596),
    [sym_IfExpr] = STATE(1596),
    [sym_Block] = STATE(1596),
    [sym_LoopExpr] = STATE(1596),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1596),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1596),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [270] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1635),
    [sym_BinaryExpr] = STATE(1635),
    [sym_UnaryExpr] = STATE(1635),
    [sym__PrimaryExpr] = STATE(1635),
    [sym_IfExpr] = STATE(1635),
    [sym_Block] = STATE(1635),
    [sym_LoopExpr] = STATE(1635),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1635),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1635),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [271] = {
    [sym_FnProto] = STATE(384),
    [sym__Expr] = STATE(397),
    [sym_BinaryExpr] = STATE(397),
    [sym_UnaryExpr] = STATE(397),
    [sym__PrimaryExpr] = STATE(397),
    [sym_IfExpr] = STATE(397),
    [sym_Block] = STATE(397),
    [sym_LoopExpr] = STATE(397),
    [sym_ForExpr] = STATE(671),
    [sym_WhileExpr] = STATE(671),
    [sym__CurlySuffixExpr] = STATE(397),
    [sym__TypeExpr] = STATE(396),
    [sym_ErrorUnionExpr] = STATE(396),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_AsmExpr] = STATE(397),
    [sym_BlockLabel] = STATE(1676),
    [sym_IfPrefix] = STATE(279),
    [sym_WhilePrefix] = STATE(272),
    [sym_ForPrefix] = STATE(271),
    [sym_PrefixOp] = STATE(306),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(175),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(181),
    [anon_sym_break] = ACTIONS(183),
    [anon_sym_continue] = ACTIONS(185),
    [anon_sym_resume] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_asm] = ACTIONS(205),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [272] = {
    [sym_FnProto] = STATE(384),
    [sym__Expr] = STATE(399),
    [sym_BinaryExpr] = STATE(399),
    [sym_UnaryExpr] = STATE(399),
    [sym__PrimaryExpr] = STATE(399),
    [sym_IfExpr] = STATE(399),
    [sym_Block] = STATE(399),
    [sym_LoopExpr] = STATE(399),
    [sym_ForExpr] = STATE(671),
    [sym_WhileExpr] = STATE(671),
    [sym__CurlySuffixExpr] = STATE(399),
    [sym__TypeExpr] = STATE(398),
    [sym_ErrorUnionExpr] = STATE(398),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_AsmExpr] = STATE(399),
    [sym_BlockLabel] = STATE(1676),
    [sym_IfPrefix] = STATE(279),
    [sym_WhilePrefix] = STATE(272),
    [sym_ForPrefix] = STATE(271),
    [sym_PrefixOp] = STATE(306),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(175),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(181),
    [anon_sym_break] = ACTIONS(183),
    [anon_sym_continue] = ACTIONS(185),
    [anon_sym_resume] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_asm] = ACTIONS(205),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [273] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1128),
    [sym_BinaryExpr] = STATE(1128),
    [sym_UnaryExpr] = STATE(1128),
    [sym__PrimaryExpr] = STATE(1128),
    [sym_IfExpr] = STATE(1128),
    [sym_Block] = STATE(1128),
    [sym_LoopExpr] = STATE(1128),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1128),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1128),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [274] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(457),
    [sym_BinaryExpr] = STATE(457),
    [sym_UnaryExpr] = STATE(457),
    [sym__PrimaryExpr] = STATE(457),
    [sym_IfExpr] = STATE(457),
    [sym_Block] = STATE(457),
    [sym_LoopExpr] = STATE(457),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(457),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(457),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [275] = {
    [sym_FnProto] = STATE(384),
    [sym__Expr] = STATE(411),
    [sym_BinaryExpr] = STATE(411),
    [sym_UnaryExpr] = STATE(411),
    [sym__PrimaryExpr] = STATE(411),
    [sym_IfExpr] = STATE(411),
    [sym_Block] = STATE(411),
    [sym_LoopExpr] = STATE(411),
    [sym_ForExpr] = STATE(671),
    [sym_WhileExpr] = STATE(671),
    [sym__CurlySuffixExpr] = STATE(411),
    [sym__TypeExpr] = STATE(633),
    [sym_ErrorUnionExpr] = STATE(633),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_AsmExpr] = STATE(411),
    [sym_BlockLabel] = STATE(1676),
    [sym_IfPrefix] = STATE(279),
    [sym_WhilePrefix] = STATE(272),
    [sym_ForPrefix] = STATE(271),
    [sym_PrefixOp] = STATE(306),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(175),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(181),
    [anon_sym_break] = ACTIONS(183),
    [anon_sym_continue] = ACTIONS(185),
    [anon_sym_resume] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_asm] = ACTIONS(205),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [276] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1637),
    [sym_BinaryExpr] = STATE(1637),
    [sym_UnaryExpr] = STATE(1637),
    [sym__PrimaryExpr] = STATE(1637),
    [sym_IfExpr] = STATE(1637),
    [sym_Block] = STATE(1637),
    [sym_LoopExpr] = STATE(1637),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1637),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1637),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [277] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1128),
    [sym_BinaryExpr] = STATE(1128),
    [sym_UnaryExpr] = STATE(1128),
    [sym__PrimaryExpr] = STATE(1128),
    [sym_IfExpr] = STATE(1128),
    [sym_Block] = STATE(1128),
    [sym_LoopExpr] = STATE(1128),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1128),
    [sym__TypeExpr] = STATE(1030),
    [sym_ErrorUnionExpr] = STATE(1030),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1128),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [278] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(456),
    [sym_BinaryExpr] = STATE(456),
    [sym_UnaryExpr] = STATE(456),
    [sym__PrimaryExpr] = STATE(456),
    [sym_IfExpr] = STATE(456),
    [sym_Block] = STATE(456),
    [sym_LoopExpr] = STATE(456),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(456),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(456),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [279] = {
    [sym_FnProto] = STATE(384),
    [sym__Expr] = STATE(395),
    [sym_BinaryExpr] = STATE(395),
    [sym_UnaryExpr] = STATE(395),
    [sym__PrimaryExpr] = STATE(395),
    [sym_IfExpr] = STATE(395),
    [sym_Block] = STATE(395),
    [sym_LoopExpr] = STATE(395),
    [sym_ForExpr] = STATE(671),
    [sym_WhileExpr] = STATE(671),
    [sym__CurlySuffixExpr] = STATE(395),
    [sym__TypeExpr] = STATE(400),
    [sym_ErrorUnionExpr] = STATE(400),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_AsmExpr] = STATE(395),
    [sym_BlockLabel] = STATE(1676),
    [sym_IfPrefix] = STATE(279),
    [sym_WhilePrefix] = STATE(272),
    [sym_ForPrefix] = STATE(271),
    [sym_PrefixOp] = STATE(306),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(175),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(181),
    [anon_sym_break] = ACTIONS(183),
    [anon_sym_continue] = ACTIONS(185),
    [anon_sym_resume] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_asm] = ACTIONS(205),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [280] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1617),
    [sym_BinaryExpr] = STATE(1617),
    [sym_UnaryExpr] = STATE(1617),
    [sym__PrimaryExpr] = STATE(1617),
    [sym_IfExpr] = STATE(1617),
    [sym_Block] = STATE(1617),
    [sym_LoopExpr] = STATE(1617),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1617),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1617),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [281] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1641),
    [sym_BinaryExpr] = STATE(1641),
    [sym_UnaryExpr] = STATE(1641),
    [sym__PrimaryExpr] = STATE(1641),
    [sym_IfExpr] = STATE(1641),
    [sym_Block] = STATE(1641),
    [sym_LoopExpr] = STATE(1641),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1641),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1641),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [282] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1549),
    [sym_BinaryExpr] = STATE(1549),
    [sym_UnaryExpr] = STATE(1549),
    [sym__PrimaryExpr] = STATE(1549),
    [sym_IfExpr] = STATE(1549),
    [sym_Block] = STATE(1549),
    [sym_LoopExpr] = STATE(1549),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1549),
    [sym__TypeExpr] = STATE(1430),
    [sym_ErrorUnionExpr] = STATE(1430),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1549),
    [sym_BlockLabel] = STATE(1671),
    [sym_IfPrefix] = STATE(189),
    [sym_WhilePrefix] = STATE(177),
    [sym_ForPrefix] = STATE(193),
    [sym_PrefixOp] = STATE(233),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(275),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(279),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(285),
    [anon_sym_break] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [283] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1640),
    [sym_BinaryExpr] = STATE(1640),
    [sym_UnaryExpr] = STATE(1640),
    [sym__PrimaryExpr] = STATE(1640),
    [sym_IfExpr] = STATE(1640),
    [sym_Block] = STATE(1640),
    [sym_LoopExpr] = STATE(1640),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1640),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1640),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [284] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1616),
    [sym_BinaryExpr] = STATE(1616),
    [sym_UnaryExpr] = STATE(1616),
    [sym__PrimaryExpr] = STATE(1616),
    [sym_IfExpr] = STATE(1616),
    [sym_Block] = STATE(1616),
    [sym_LoopExpr] = STATE(1616),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1616),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1616),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [285] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1605),
    [sym_BinaryExpr] = STATE(1605),
    [sym_UnaryExpr] = STATE(1605),
    [sym__PrimaryExpr] = STATE(1605),
    [sym_IfExpr] = STATE(1605),
    [sym_Block] = STATE(1605),
    [sym_LoopExpr] = STATE(1605),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1605),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1605),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [286] = {
    [sym_FnProto] = STATE(384),
    [sym__Expr] = STATE(420),
    [sym_BinaryExpr] = STATE(420),
    [sym_UnaryExpr] = STATE(420),
    [sym__PrimaryExpr] = STATE(420),
    [sym_IfExpr] = STATE(420),
    [sym_Block] = STATE(420),
    [sym_LoopExpr] = STATE(420),
    [sym_ForExpr] = STATE(671),
    [sym_WhileExpr] = STATE(671),
    [sym__CurlySuffixExpr] = STATE(420),
    [sym__TypeExpr] = STATE(633),
    [sym_ErrorUnionExpr] = STATE(633),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_AsmExpr] = STATE(420),
    [sym_BlockLabel] = STATE(1676),
    [sym_IfPrefix] = STATE(279),
    [sym_WhilePrefix] = STATE(272),
    [sym_ForPrefix] = STATE(271),
    [sym_PrefixOp] = STATE(306),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(175),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(181),
    [anon_sym_break] = ACTIONS(183),
    [anon_sym_continue] = ACTIONS(185),
    [anon_sym_resume] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_asm] = ACTIONS(205),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [287] = {
    [sym_FnProto] = STATE(384),
    [sym__Expr] = STATE(419),
    [sym_BinaryExpr] = STATE(419),
    [sym_UnaryExpr] = STATE(419),
    [sym__PrimaryExpr] = STATE(419),
    [sym_IfExpr] = STATE(419),
    [sym_Block] = STATE(419),
    [sym_LoopExpr] = STATE(419),
    [sym_ForExpr] = STATE(671),
    [sym_WhileExpr] = STATE(671),
    [sym__CurlySuffixExpr] = STATE(419),
    [sym__TypeExpr] = STATE(633),
    [sym_ErrorUnionExpr] = STATE(633),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_AsmExpr] = STATE(419),
    [sym_BlockLabel] = STATE(1676),
    [sym_IfPrefix] = STATE(279),
    [sym_WhilePrefix] = STATE(272),
    [sym_ForPrefix] = STATE(271),
    [sym_PrefixOp] = STATE(306),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(175),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(181),
    [anon_sym_break] = ACTIONS(183),
    [anon_sym_continue] = ACTIONS(185),
    [anon_sym_resume] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_asm] = ACTIONS(205),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [288] = {
    [sym_FnProto] = STATE(384),
    [sym__Expr] = STATE(416),
    [sym_BinaryExpr] = STATE(416),
    [sym_UnaryExpr] = STATE(416),
    [sym__PrimaryExpr] = STATE(416),
    [sym_IfExpr] = STATE(416),
    [sym_Block] = STATE(416),
    [sym_LoopExpr] = STATE(416),
    [sym_ForExpr] = STATE(671),
    [sym_WhileExpr] = STATE(671),
    [sym__CurlySuffixExpr] = STATE(416),
    [sym__TypeExpr] = STATE(633),
    [sym_ErrorUnionExpr] = STATE(633),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_AsmExpr] = STATE(416),
    [sym_BlockLabel] = STATE(1676),
    [sym_IfPrefix] = STATE(279),
    [sym_WhilePrefix] = STATE(272),
    [sym_ForPrefix] = STATE(271),
    [sym_PrefixOp] = STATE(306),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(175),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(181),
    [anon_sym_break] = ACTIONS(183),
    [anon_sym_continue] = ACTIONS(185),
    [anon_sym_resume] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_asm] = ACTIONS(205),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [289] = {
    [sym_FnProto] = STATE(384),
    [sym__Expr] = STATE(417),
    [sym_BinaryExpr] = STATE(417),
    [sym_UnaryExpr] = STATE(417),
    [sym__PrimaryExpr] = STATE(417),
    [sym_IfExpr] = STATE(417),
    [sym_Block] = STATE(417),
    [sym_LoopExpr] = STATE(417),
    [sym_ForExpr] = STATE(671),
    [sym_WhileExpr] = STATE(671),
    [sym__CurlySuffixExpr] = STATE(417),
    [sym__TypeExpr] = STATE(633),
    [sym_ErrorUnionExpr] = STATE(633),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_AsmExpr] = STATE(417),
    [sym_BlockLabel] = STATE(1676),
    [sym_IfPrefix] = STATE(279),
    [sym_WhilePrefix] = STATE(272),
    [sym_ForPrefix] = STATE(271),
    [sym_PrefixOp] = STATE(306),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(175),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(181),
    [anon_sym_break] = ACTIONS(183),
    [anon_sym_continue] = ACTIONS(185),
    [anon_sym_resume] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_asm] = ACTIONS(205),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [290] = {
    [sym_FnProto] = STATE(384),
    [sym__Expr] = STATE(418),
    [sym_BinaryExpr] = STATE(418),
    [sym_UnaryExpr] = STATE(418),
    [sym__PrimaryExpr] = STATE(418),
    [sym_IfExpr] = STATE(418),
    [sym_Block] = STATE(418),
    [sym_LoopExpr] = STATE(418),
    [sym_ForExpr] = STATE(671),
    [sym_WhileExpr] = STATE(671),
    [sym__CurlySuffixExpr] = STATE(418),
    [sym__TypeExpr] = STATE(633),
    [sym_ErrorUnionExpr] = STATE(633),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_AsmExpr] = STATE(418),
    [sym_BlockLabel] = STATE(1676),
    [sym_IfPrefix] = STATE(279),
    [sym_WhilePrefix] = STATE(272),
    [sym_ForPrefix] = STATE(271),
    [sym_PrefixOp] = STATE(306),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(175),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(181),
    [anon_sym_break] = ACTIONS(183),
    [anon_sym_continue] = ACTIONS(185),
    [anon_sym_resume] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_asm] = ACTIONS(205),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [291] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1645),
    [sym_BinaryExpr] = STATE(1645),
    [sym_UnaryExpr] = STATE(1645),
    [sym__PrimaryExpr] = STATE(1645),
    [sym_IfExpr] = STATE(1645),
    [sym_Block] = STATE(1645),
    [sym_LoopExpr] = STATE(1645),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1645),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1645),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [292] = {
    [sym_FnProto] = STATE(384),
    [sym__Expr] = STATE(407),
    [sym_BinaryExpr] = STATE(407),
    [sym_UnaryExpr] = STATE(407),
    [sym__PrimaryExpr] = STATE(407),
    [sym_IfExpr] = STATE(407),
    [sym_Block] = STATE(407),
    [sym_LoopExpr] = STATE(407),
    [sym_ForExpr] = STATE(671),
    [sym_WhileExpr] = STATE(671),
    [sym__CurlySuffixExpr] = STATE(407),
    [sym__TypeExpr] = STATE(633),
    [sym_ErrorUnionExpr] = STATE(633),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_AsmExpr] = STATE(407),
    [sym_BlockLabel] = STATE(1676),
    [sym_IfPrefix] = STATE(279),
    [sym_WhilePrefix] = STATE(272),
    [sym_ForPrefix] = STATE(271),
    [sym_PrefixOp] = STATE(306),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(175),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(181),
    [anon_sym_break] = ACTIONS(183),
    [anon_sym_continue] = ACTIONS(185),
    [anon_sym_resume] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_asm] = ACTIONS(205),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [293] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1600),
    [sym_BinaryExpr] = STATE(1600),
    [sym_UnaryExpr] = STATE(1600),
    [sym__PrimaryExpr] = STATE(1600),
    [sym_IfExpr] = STATE(1600),
    [sym_Block] = STATE(1600),
    [sym_LoopExpr] = STATE(1600),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1600),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1600),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [294] = {
    [sym_FnProto] = STATE(384),
    [sym__Expr] = STATE(412),
    [sym_BinaryExpr] = STATE(412),
    [sym_UnaryExpr] = STATE(412),
    [sym__PrimaryExpr] = STATE(412),
    [sym_IfExpr] = STATE(412),
    [sym_Block] = STATE(412),
    [sym_LoopExpr] = STATE(412),
    [sym_ForExpr] = STATE(671),
    [sym_WhileExpr] = STATE(671),
    [sym__CurlySuffixExpr] = STATE(412),
    [sym__TypeExpr] = STATE(633),
    [sym_ErrorUnionExpr] = STATE(633),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_AsmExpr] = STATE(412),
    [sym_BlockLabel] = STATE(1676),
    [sym_IfPrefix] = STATE(279),
    [sym_WhilePrefix] = STATE(272),
    [sym_ForPrefix] = STATE(271),
    [sym_PrefixOp] = STATE(306),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(175),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(181),
    [anon_sym_break] = ACTIONS(183),
    [anon_sym_continue] = ACTIONS(185),
    [anon_sym_resume] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_asm] = ACTIONS(205),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [295] = {
    [sym_FnProto] = STATE(1410),
    [sym__Expr] = STATE(1549),
    [sym_BinaryExpr] = STATE(1549),
    [sym_UnaryExpr] = STATE(1549),
    [sym__PrimaryExpr] = STATE(1549),
    [sym_IfExpr] = STATE(1549),
    [sym_Block] = STATE(1549),
    [sym_LoopExpr] = STATE(1549),
    [sym_ForExpr] = STATE(1659),
    [sym_WhileExpr] = STATE(1659),
    [sym__CurlySuffixExpr] = STATE(1549),
    [sym__TypeExpr] = STATE(1644),
    [sym_ErrorUnionExpr] = STATE(1644),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_AsmExpr] = STATE(1549),
    [sym_BlockLabel] = STATE(1671),
    [sym_IfPrefix] = STATE(189),
    [sym_WhilePrefix] = STATE(177),
    [sym_ForPrefix] = STATE(193),
    [sym_PrefixOp] = STATE(233),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(275),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(279),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(285),
    [anon_sym_break] = ACTIONS(287),
    [anon_sym_continue] = ACTIONS(289),
    [anon_sym_resume] = ACTIONS(285),
    [anon_sym_return] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_asm] = ACTIONS(309),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [296] = {
    [sym_FnProto] = STATE(384),
    [sym__Expr] = STATE(394),
    [sym_BinaryExpr] = STATE(394),
    [sym_UnaryExpr] = STATE(394),
    [sym__PrimaryExpr] = STATE(394),
    [sym_IfExpr] = STATE(394),
    [sym_Block] = STATE(394),
    [sym_LoopExpr] = STATE(394),
    [sym_ForExpr] = STATE(671),
    [sym_WhileExpr] = STATE(671),
    [sym__CurlySuffixExpr] = STATE(394),
    [sym__TypeExpr] = STATE(406),
    [sym_ErrorUnionExpr] = STATE(406),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_AsmExpr] = STATE(394),
    [sym_BlockLabel] = STATE(1676),
    [sym_IfPrefix] = STATE(279),
    [sym_WhilePrefix] = STATE(272),
    [sym_ForPrefix] = STATE(271),
    [sym_PrefixOp] = STATE(306),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(175),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(181),
    [anon_sym_break] = ACTIONS(183),
    [anon_sym_continue] = ACTIONS(185),
    [anon_sym_resume] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_asm] = ACTIONS(205),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [297] = {
    [sym_FnProto] = STATE(384),
    [sym__Expr] = STATE(405),
    [sym_BinaryExpr] = STATE(405),
    [sym_UnaryExpr] = STATE(405),
    [sym__PrimaryExpr] = STATE(405),
    [sym_IfExpr] = STATE(405),
    [sym_Block] = STATE(405),
    [sym_LoopExpr] = STATE(405),
    [sym_ForExpr] = STATE(671),
    [sym_WhileExpr] = STATE(671),
    [sym__CurlySuffixExpr] = STATE(405),
    [sym__TypeExpr] = STATE(404),
    [sym_ErrorUnionExpr] = STATE(404),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_AsmExpr] = STATE(405),
    [sym_BlockLabel] = STATE(1676),
    [sym_IfPrefix] = STATE(279),
    [sym_WhilePrefix] = STATE(272),
    [sym_ForPrefix] = STATE(271),
    [sym_PrefixOp] = STATE(306),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(175),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(181),
    [anon_sym_break] = ACTIONS(183),
    [anon_sym_continue] = ACTIONS(185),
    [anon_sym_resume] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_asm] = ACTIONS(205),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [298] = {
    [sym_FnProto] = STATE(384),
    [sym__Expr] = STATE(403),
    [sym_BinaryExpr] = STATE(403),
    [sym_UnaryExpr] = STATE(403),
    [sym__PrimaryExpr] = STATE(403),
    [sym_IfExpr] = STATE(403),
    [sym_Block] = STATE(403),
    [sym_LoopExpr] = STATE(403),
    [sym_ForExpr] = STATE(671),
    [sym_WhileExpr] = STATE(671),
    [sym__CurlySuffixExpr] = STATE(403),
    [sym__TypeExpr] = STATE(401),
    [sym_ErrorUnionExpr] = STATE(401),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_AsmExpr] = STATE(403),
    [sym_BlockLabel] = STATE(1676),
    [sym_IfPrefix] = STATE(279),
    [sym_WhilePrefix] = STATE(272),
    [sym_ForPrefix] = STATE(271),
    [sym_PrefixOp] = STATE(306),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(175),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(181),
    [anon_sym_break] = ACTIONS(183),
    [anon_sym_continue] = ACTIONS(185),
    [anon_sym_resume] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_asm] = ACTIONS(205),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [299] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1057),
    [sym_BinaryExpr] = STATE(1057),
    [sym_UnaryExpr] = STATE(1057),
    [sym__PrimaryExpr] = STATE(1057),
    [sym_IfExpr] = STATE(1057),
    [sym_Block] = STATE(1057),
    [sym_LoopExpr] = STATE(1057),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1057),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1057),
    [sym_BlockLabel] = STATE(1678),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [300] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1634),
    [sym_BinaryExpr] = STATE(1634),
    [sym_UnaryExpr] = STATE(1634),
    [sym__PrimaryExpr] = STATE(1634),
    [sym_IfExpr] = STATE(1634),
    [sym_Block] = STATE(1634),
    [sym_LoopExpr] = STATE(1634),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1634),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1634),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [301] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(447),
    [sym_BinaryExpr] = STATE(447),
    [sym_UnaryExpr] = STATE(447),
    [sym__PrimaryExpr] = STATE(447),
    [sym_IfExpr] = STATE(447),
    [sym_Block] = STATE(447),
    [sym_LoopExpr] = STATE(447),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(447),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(447),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [302] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1075),
    [sym_BinaryExpr] = STATE(1075),
    [sym_UnaryExpr] = STATE(1075),
    [sym__PrimaryExpr] = STATE(1075),
    [sym_IfExpr] = STATE(1075),
    [sym_Block] = STATE(1075),
    [sym_LoopExpr] = STATE(1075),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1075),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1075),
    [sym_BlockLabel] = STATE(1678),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [303] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1638),
    [sym_BinaryExpr] = STATE(1638),
    [sym_UnaryExpr] = STATE(1638),
    [sym__PrimaryExpr] = STATE(1638),
    [sym_IfExpr] = STATE(1638),
    [sym_Block] = STATE(1638),
    [sym_LoopExpr] = STATE(1638),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1638),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1638),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [304] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1643),
    [sym_BinaryExpr] = STATE(1643),
    [sym_UnaryExpr] = STATE(1643),
    [sym__PrimaryExpr] = STATE(1643),
    [sym_IfExpr] = STATE(1643),
    [sym_Block] = STATE(1643),
    [sym_LoopExpr] = STATE(1643),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1643),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1643),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [305] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1606),
    [sym_BinaryExpr] = STATE(1606),
    [sym_UnaryExpr] = STATE(1606),
    [sym__PrimaryExpr] = STATE(1606),
    [sym_IfExpr] = STATE(1606),
    [sym_Block] = STATE(1606),
    [sym_LoopExpr] = STATE(1606),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1606),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1606),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [306] = {
    [sym_FnProto] = STATE(384),
    [sym__Expr] = STATE(423),
    [sym_BinaryExpr] = STATE(423),
    [sym_UnaryExpr] = STATE(423),
    [sym__PrimaryExpr] = STATE(423),
    [sym_IfExpr] = STATE(423),
    [sym_Block] = STATE(423),
    [sym_LoopExpr] = STATE(423),
    [sym_ForExpr] = STATE(671),
    [sym_WhileExpr] = STATE(671),
    [sym__CurlySuffixExpr] = STATE(423),
    [sym__TypeExpr] = STATE(633),
    [sym_ErrorUnionExpr] = STATE(633),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_AsmExpr] = STATE(423),
    [sym_BlockLabel] = STATE(1676),
    [sym_IfPrefix] = STATE(279),
    [sym_WhilePrefix] = STATE(272),
    [sym_ForPrefix] = STATE(271),
    [sym_PrefixOp] = STATE(306),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(171),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(175),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(181),
    [anon_sym_break] = ACTIONS(183),
    [anon_sym_continue] = ACTIONS(185),
    [anon_sym_resume] = ACTIONS(181),
    [anon_sym_return] = ACTIONS(187),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_asm] = ACTIONS(205),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [307] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1067),
    [sym_BinaryExpr] = STATE(1067),
    [sym_UnaryExpr] = STATE(1067),
    [sym__PrimaryExpr] = STATE(1067),
    [sym_IfExpr] = STATE(1067),
    [sym_Block] = STATE(1067),
    [sym_LoopExpr] = STATE(1067),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1067),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1067),
    [sym_BlockLabel] = STATE(1678),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [308] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1064),
    [sym_BinaryExpr] = STATE(1064),
    [sym_UnaryExpr] = STATE(1064),
    [sym__PrimaryExpr] = STATE(1064),
    [sym_IfExpr] = STATE(1064),
    [sym_Block] = STATE(1064),
    [sym_LoopExpr] = STATE(1064),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1064),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1064),
    [sym_BlockLabel] = STATE(1678),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [309] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1630),
    [sym_BinaryExpr] = STATE(1630),
    [sym_UnaryExpr] = STATE(1630),
    [sym__PrimaryExpr] = STATE(1630),
    [sym_IfExpr] = STATE(1630),
    [sym_Block] = STATE(1630),
    [sym_LoopExpr] = STATE(1630),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1630),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1630),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [310] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1063),
    [sym_BinaryExpr] = STATE(1063),
    [sym_UnaryExpr] = STATE(1063),
    [sym__PrimaryExpr] = STATE(1063),
    [sym_IfExpr] = STATE(1063),
    [sym_Block] = STATE(1063),
    [sym_LoopExpr] = STATE(1063),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1063),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1063),
    [sym_BlockLabel] = STATE(1678),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [311] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1554),
    [sym_BinaryExpr] = STATE(1554),
    [sym_UnaryExpr] = STATE(1554),
    [sym__PrimaryExpr] = STATE(1554),
    [sym_IfExpr] = STATE(1554),
    [sym_Block] = STATE(1554),
    [sym_LoopExpr] = STATE(1554),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1554),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1554),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [312] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(448),
    [sym_BinaryExpr] = STATE(448),
    [sym_UnaryExpr] = STATE(448),
    [sym__PrimaryExpr] = STATE(448),
    [sym_IfExpr] = STATE(448),
    [sym_Block] = STATE(448),
    [sym_LoopExpr] = STATE(448),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(448),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(448),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [313] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1054),
    [sym_BinaryExpr] = STATE(1054),
    [sym_UnaryExpr] = STATE(1054),
    [sym__PrimaryExpr] = STATE(1054),
    [sym_IfExpr] = STATE(1054),
    [sym_Block] = STATE(1054),
    [sym_LoopExpr] = STATE(1054),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1054),
    [sym__TypeExpr] = STATE(1026),
    [sym_ErrorUnionExpr] = STATE(1026),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1054),
    [sym_BlockLabel] = STATE(1678),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [314] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1051),
    [sym_BinaryExpr] = STATE(1051),
    [sym_UnaryExpr] = STATE(1051),
    [sym__PrimaryExpr] = STATE(1051),
    [sym_IfExpr] = STATE(1051),
    [sym_Block] = STATE(1051),
    [sym_LoopExpr] = STATE(1051),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1051),
    [sym__TypeExpr] = STATE(1025),
    [sym_ErrorUnionExpr] = STATE(1025),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1051),
    [sym_BlockLabel] = STATE(1678),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [315] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1060),
    [sym_BinaryExpr] = STATE(1060),
    [sym_UnaryExpr] = STATE(1060),
    [sym__PrimaryExpr] = STATE(1060),
    [sym_IfExpr] = STATE(1060),
    [sym_Block] = STATE(1060),
    [sym_LoopExpr] = STATE(1060),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1060),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1060),
    [sym_BlockLabel] = STATE(1678),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [316] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1072),
    [sym_BinaryExpr] = STATE(1072),
    [sym_UnaryExpr] = STATE(1072),
    [sym__PrimaryExpr] = STATE(1072),
    [sym_IfExpr] = STATE(1072),
    [sym_Block] = STATE(1072),
    [sym_LoopExpr] = STATE(1072),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1072),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1072),
    [sym_BlockLabel] = STATE(1678),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [317] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1629),
    [sym_BinaryExpr] = STATE(1629),
    [sym_UnaryExpr] = STATE(1629),
    [sym__PrimaryExpr] = STATE(1629),
    [sym_IfExpr] = STATE(1629),
    [sym_Block] = STATE(1629),
    [sym_LoopExpr] = STATE(1629),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1629),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1629),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [318] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1601),
    [sym_BinaryExpr] = STATE(1601),
    [sym_UnaryExpr] = STATE(1601),
    [sym__PrimaryExpr] = STATE(1601),
    [sym_IfExpr] = STATE(1601),
    [sym_Block] = STATE(1601),
    [sym_LoopExpr] = STATE(1601),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1601),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1601),
    [sym_BlockLabel] = STATE(1678),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [319] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1584),
    [sym_BinaryExpr] = STATE(1584),
    [sym_UnaryExpr] = STATE(1584),
    [sym__PrimaryExpr] = STATE(1584),
    [sym_IfExpr] = STATE(1584),
    [sym_Block] = STATE(1584),
    [sym_LoopExpr] = STATE(1584),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1584),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1584),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [320] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1624),
    [sym_BinaryExpr] = STATE(1624),
    [sym_UnaryExpr] = STATE(1624),
    [sym__PrimaryExpr] = STATE(1624),
    [sym_IfExpr] = STATE(1624),
    [sym_Block] = STATE(1624),
    [sym_LoopExpr] = STATE(1624),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1624),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1624),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [321] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1049),
    [sym_BinaryExpr] = STATE(1049),
    [sym_UnaryExpr] = STATE(1049),
    [sym__PrimaryExpr] = STATE(1049),
    [sym_IfExpr] = STATE(1049),
    [sym_Block] = STATE(1049),
    [sym_LoopExpr] = STATE(1049),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1049),
    [sym__TypeExpr] = STATE(1022),
    [sym_ErrorUnionExpr] = STATE(1022),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1049),
    [sym_BlockLabel] = STATE(1678),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [322] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1618),
    [sym_BinaryExpr] = STATE(1618),
    [sym_UnaryExpr] = STATE(1618),
    [sym__PrimaryExpr] = STATE(1618),
    [sym_IfExpr] = STATE(1618),
    [sym_Block] = STATE(1618),
    [sym_LoopExpr] = STATE(1618),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1618),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1618),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [323] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1650),
    [sym_BinaryExpr] = STATE(1650),
    [sym_UnaryExpr] = STATE(1650),
    [sym__PrimaryExpr] = STATE(1650),
    [sym_IfExpr] = STATE(1650),
    [sym_Block] = STATE(1650),
    [sym_LoopExpr] = STATE(1650),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1650),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1650),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [324] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1648),
    [sym_BinaryExpr] = STATE(1648),
    [sym_UnaryExpr] = STATE(1648),
    [sym__PrimaryExpr] = STATE(1648),
    [sym_IfExpr] = STATE(1648),
    [sym_Block] = STATE(1648),
    [sym_LoopExpr] = STATE(1648),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1648),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1648),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [325] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(437),
    [sym_BinaryExpr] = STATE(437),
    [sym_UnaryExpr] = STATE(437),
    [sym__PrimaryExpr] = STATE(437),
    [sym_IfExpr] = STATE(437),
    [sym_Block] = STATE(437),
    [sym_LoopExpr] = STATE(437),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(437),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(437),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [326] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(438),
    [sym_BinaryExpr] = STATE(438),
    [sym_UnaryExpr] = STATE(438),
    [sym__PrimaryExpr] = STATE(438),
    [sym_IfExpr] = STATE(438),
    [sym_Block] = STATE(438),
    [sym_LoopExpr] = STATE(438),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(438),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(438),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [327] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(439),
    [sym_BinaryExpr] = STATE(439),
    [sym_UnaryExpr] = STATE(439),
    [sym__PrimaryExpr] = STATE(439),
    [sym_IfExpr] = STATE(439),
    [sym_Block] = STATE(439),
    [sym_LoopExpr] = STATE(439),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(439),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(439),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [328] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(450),
    [sym_BinaryExpr] = STATE(450),
    [sym_UnaryExpr] = STATE(450),
    [sym__PrimaryExpr] = STATE(450),
    [sym_IfExpr] = STATE(450),
    [sym_Block] = STATE(450),
    [sym_LoopExpr] = STATE(450),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(450),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(450),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [329] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(440),
    [sym_BinaryExpr] = STATE(440),
    [sym_UnaryExpr] = STATE(440),
    [sym__PrimaryExpr] = STATE(440),
    [sym_IfExpr] = STATE(440),
    [sym_Block] = STATE(440),
    [sym_LoopExpr] = STATE(440),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(440),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(440),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [330] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(441),
    [sym_BinaryExpr] = STATE(441),
    [sym_UnaryExpr] = STATE(441),
    [sym__PrimaryExpr] = STATE(441),
    [sym_IfExpr] = STATE(441),
    [sym_Block] = STATE(441),
    [sym_LoopExpr] = STATE(441),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(441),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(441),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [331] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(443),
    [sym_BinaryExpr] = STATE(443),
    [sym_UnaryExpr] = STATE(443),
    [sym__PrimaryExpr] = STATE(443),
    [sym_IfExpr] = STATE(443),
    [sym_Block] = STATE(443),
    [sym_LoopExpr] = STATE(443),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(443),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(443),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [332] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1598),
    [sym_BinaryExpr] = STATE(1598),
    [sym_UnaryExpr] = STATE(1598),
    [sym__PrimaryExpr] = STATE(1598),
    [sym_IfExpr] = STATE(1598),
    [sym_Block] = STATE(1598),
    [sym_LoopExpr] = STATE(1598),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1598),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1598),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [333] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1081),
    [sym_BinaryExpr] = STATE(1081),
    [sym_UnaryExpr] = STATE(1081),
    [sym__PrimaryExpr] = STATE(1081),
    [sym_IfExpr] = STATE(1081),
    [sym_Block] = STATE(1081),
    [sym_LoopExpr] = STATE(1081),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1081),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1081),
    [sym_BlockLabel] = STATE(1678),
    [sym_IfPrefix] = STATE(313),
    [sym_WhilePrefix] = STATE(314),
    [sym_ForPrefix] = STATE(321),
    [sym_PrefixOp] = STATE(299),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(89),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(93),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(103),
    [anon_sym_break] = ACTIONS(105),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(103),
    [anon_sym_return] = ACTIONS(109),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [334] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1613),
    [sym_BinaryExpr] = STATE(1613),
    [sym_UnaryExpr] = STATE(1613),
    [sym__PrimaryExpr] = STATE(1613),
    [sym_IfExpr] = STATE(1613),
    [sym_Block] = STATE(1613),
    [sym_LoopExpr] = STATE(1613),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1613),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1613),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [335] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1561),
    [sym_BinaryExpr] = STATE(1561),
    [sym_UnaryExpr] = STATE(1561),
    [sym__PrimaryExpr] = STATE(1561),
    [sym_IfExpr] = STATE(1561),
    [sym_Block] = STATE(1561),
    [sym_LoopExpr] = STATE(1561),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1561),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1561),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [336] = {
    [sym_FnProto] = STATE(935),
    [sym__Expr] = STATE(1590),
    [sym_BinaryExpr] = STATE(1590),
    [sym_UnaryExpr] = STATE(1590),
    [sym__PrimaryExpr] = STATE(1590),
    [sym_IfExpr] = STATE(1590),
    [sym_Block] = STATE(1590),
    [sym_LoopExpr] = STATE(1590),
    [sym_ForExpr] = STATE(1294),
    [sym_WhileExpr] = STATE(1294),
    [sym__CurlySuffixExpr] = STATE(1590),
    [sym__TypeExpr] = STATE(1277),
    [sym_ErrorUnionExpr] = STATE(1277),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_AsmExpr] = STATE(1590),
    [sym_BlockLabel] = STATE(1670),
    [sym_IfPrefix] = STATE(266),
    [sym_WhilePrefix] = STATE(265),
    [sym_ForPrefix] = STATE(252),
    [sym_PrefixOp] = STATE(239),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(159),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(165),
    [anon_sym_break] = ACTIONS(167),
    [anon_sym_continue] = ACTIONS(107),
    [anon_sym_resume] = ACTIONS(165),
    [anon_sym_return] = ACTIONS(169),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_asm] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [337] = {
    [sym_FnProto] = STATE(389),
    [sym__Expr] = STATE(444),
    [sym_BinaryExpr] = STATE(444),
    [sym_UnaryExpr] = STATE(444),
    [sym__PrimaryExpr] = STATE(444),
    [sym_IfExpr] = STATE(444),
    [sym_Block] = STATE(444),
    [sym_LoopExpr] = STATE(444),
    [sym_ForExpr] = STATE(678),
    [sym_WhileExpr] = STATE(678),
    [sym__CurlySuffixExpr] = STATE(444),
    [sym__TypeExpr] = STATE(646),
    [sym_ErrorUnionExpr] = STATE(646),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_AsmExpr] = STATE(444),
    [sym_BlockLabel] = STATE(1674),
    [sym_IfPrefix] = STATE(296),
    [sym_WhilePrefix] = STATE(297),
    [sym_ForPrefix] = STATE(298),
    [sym_PrefixOp] = STATE(337),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(223),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(227),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(135),
    [anon_sym_nosuspend] = ACTIONS(233),
    [anon_sym_break] = ACTIONS(235),
    [anon_sym_continue] = ACTIONS(237),
    [anon_sym_resume] = ACTIONS(233),
    [anon_sym_return] = ACTIONS(239),
    [anon_sym_LBRACE] = ACTIONS(241),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_asm] = ACTIONS(257),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [anon_sym_for] = ACTIONS(133),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(97),
    [anon_sym_DASH_PERCENT] = ACTIONS(135),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_try] = ACTIONS(97),
    [anon_sym_await] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [338] = {
    [aux_sym__ContainerMembers] = STATE(355),
    [sym__ContainerDeclarations] = STATE(355),
    [sym_TestDecl] = STATE(355),
    [sym_ComptimeDecl] = STATE(355),
    [sym_Decl] = STATE(355),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(756),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_container_doc_comment] = ACTIONS(758),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [339] = {
    [aux_sym__ContainerMembers] = STATE(367),
    [sym__ContainerDeclarations] = STATE(367),
    [sym_TestDecl] = STATE(367),
    [sym_ComptimeDecl] = STATE(367),
    [sym_Decl] = STATE(367),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(760),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_container_doc_comment] = ACTIONS(762),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [340] = {
    [aux_sym__ContainerMembers] = STATE(375),
    [sym__ContainerDeclarations] = STATE(375),
    [sym_TestDecl] = STATE(375),
    [sym_ComptimeDecl] = STATE(375),
    [sym_Decl] = STATE(375),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(764),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_container_doc_comment] = ACTIONS(766),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [341] = {
    [aux_sym__ContainerMembers] = STATE(351),
    [sym__ContainerDeclarations] = STATE(351),
    [sym_TestDecl] = STATE(351),
    [sym_ComptimeDecl] = STATE(351),
    [sym_Decl] = STATE(351),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(768),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_container_doc_comment] = ACTIONS(770),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [342] = {
    [aux_sym__ContainerMembers] = STATE(359),
    [sym__ContainerDeclarations] = STATE(359),
    [sym_TestDecl] = STATE(359),
    [sym_ComptimeDecl] = STATE(359),
    [sym_Decl] = STATE(359),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(772),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_container_doc_comment] = ACTIONS(774),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [343] = {
    [ts_builtin_sym_end] = ACTIONS(576),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_pub] = ACTIONS(578),
    [anon_sym_test] = ACTIONS(578),
    [anon_sym_comptime] = ACTIONS(578),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_extern] = ACTIONS(578),
    [anon_sym_inline] = ACTIONS(578),
    [anon_sym_noinline] = ACTIONS(578),
    [anon_sym_threadlocal] = ACTIONS(578),
    [anon_sym_usingnamespace] = ACTIONS(578),
    [anon_sym_fn] = ACTIONS(578),
    [anon_sym_BANG] = ACTIONS(578),
    [anon_sym_const] = ACTIONS(578),
    [anon_sym_var] = ACTIONS(578),
    [anon_sym_nosuspend] = ACTIONS(578),
    [anon_sym_else] = ACTIONS(578),
    [anon_sym_or] = ACTIONS(578),
    [anon_sym_and] = ACTIONS(578),
    [anon_sym_break] = ACTIONS(578),
    [anon_sym_continue] = ACTIONS(578),
    [anon_sym_resume] = ACTIONS(578),
    [anon_sym_return] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(576),
    [anon_sym_RBRACE] = ACTIONS(576),
    [anon_sym_async] = ACTIONS(578),
    [anon_sym_DOT] = ACTIONS(576),
    [anon_sym_error] = ACTIONS(578),
    [anon_sym_false] = ACTIONS(578),
    [anon_sym_null] = ACTIONS(578),
    [anon_sym_anyframe] = ACTIONS(578),
    [anon_sym_true] = ACTIONS(578),
    [anon_sym_undefined] = ACTIONS(578),
    [anon_sym_unreachable] = ACTIONS(578),
    [sym_BuildinTypeExpr] = ACTIONS(578),
    [anon_sym_packed] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(576),
    [anon_sym_switch] = ACTIONS(578),
    [anon_sym_asm] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_if] = ACTIONS(578),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_for] = ACTIONS(578),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(578),
    [anon_sym_EQ_EQ] = ACTIONS(576),
    [anon_sym_BANG_EQ] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_GT] = ACTIONS(578),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_AMP] = ACTIONS(576),
    [anon_sym_CARET] = ACTIONS(576),
    [anon_sym_orelse] = ACTIONS(578),
    [anon_sym_catch] = ACTIONS(578),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_GT_GT] = ACTIONS(576),
    [anon_sym_LT_LT_PIPE] = ACTIONS(576),
    [anon_sym_PLUS] = ACTIONS(578),
    [anon_sym_DASH] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_PLUS_PERCENT] = ACTIONS(576),
    [anon_sym_DASH_PERCENT] = ACTIONS(576),
    [anon_sym_PLUS_PIPE] = ACTIONS(576),
    [anon_sym_DASH_PIPE] = ACTIONS(576),
    [anon_sym_PIPE_PIPE] = ACTIONS(576),
    [anon_sym_SLASH] = ACTIONS(578),
    [anon_sym_PERCENT] = ACTIONS(576),
    [anon_sym_STAR_STAR] = ACTIONS(576),
    [anon_sym_STAR_PERCENT] = ACTIONS(576),
    [anon_sym_STAR_PIPE] = ACTIONS(576),
    [anon_sym_TILDE] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(578),
    [anon_sym_await] = ACTIONS(578),
    [anon_sym_QMARK] = ACTIONS(576),
    [anon_sym_struct] = ACTIONS(578),
    [anon_sym_opaque] = ACTIONS(578),
    [anon_sym_enum] = ACTIONS(578),
    [anon_sym_union] = ACTIONS(578),
    [sym_doc_comment] = ACTIONS(576),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(576),
    [aux_sym_FLOAT_token1] = ACTIONS(576),
    [aux_sym_FLOAT_token2] = ACTIONS(576),
    [aux_sym_FLOAT_token3] = ACTIONS(576),
    [aux_sym_FLOAT_token4] = ACTIONS(576),
    [aux_sym_INTEGER_token1] = ACTIONS(576),
    [aux_sym_INTEGER_token2] = ACTIONS(576),
    [aux_sym_INTEGER_token3] = ACTIONS(578),
    [aux_sym_INTEGER_token4] = ACTIONS(578),
    [anon_sym_DQUOTE] = ACTIONS(576),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(576),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(578),
    [anon_sym_AT] = ACTIONS(576),
  },
  [344] = {
    [ts_builtin_sym_end] = ACTIONS(560),
    [anon_sym_COMMA] = ACTIONS(560),
    [anon_sym_pub] = ACTIONS(562),
    [anon_sym_test] = ACTIONS(562),
    [anon_sym_comptime] = ACTIONS(562),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_extern] = ACTIONS(562),
    [anon_sym_inline] = ACTIONS(562),
    [anon_sym_noinline] = ACTIONS(562),
    [anon_sym_threadlocal] = ACTIONS(562),
    [anon_sym_usingnamespace] = ACTIONS(562),
    [anon_sym_fn] = ACTIONS(562),
    [anon_sym_BANG] = ACTIONS(562),
    [anon_sym_const] = ACTIONS(562),
    [anon_sym_var] = ACTIONS(562),
    [anon_sym_nosuspend] = ACTIONS(562),
    [anon_sym_else] = ACTIONS(562),
    [anon_sym_or] = ACTIONS(562),
    [anon_sym_and] = ACTIONS(562),
    [anon_sym_break] = ACTIONS(562),
    [anon_sym_continue] = ACTIONS(562),
    [anon_sym_resume] = ACTIONS(562),
    [anon_sym_return] = ACTIONS(562),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_RBRACE] = ACTIONS(560),
    [anon_sym_async] = ACTIONS(562),
    [anon_sym_DOT] = ACTIONS(560),
    [anon_sym_error] = ACTIONS(562),
    [anon_sym_false] = ACTIONS(562),
    [anon_sym_null] = ACTIONS(562),
    [anon_sym_anyframe] = ACTIONS(562),
    [anon_sym_true] = ACTIONS(562),
    [anon_sym_undefined] = ACTIONS(562),
    [anon_sym_unreachable] = ACTIONS(562),
    [sym_BuildinTypeExpr] = ACTIONS(562),
    [anon_sym_packed] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(560),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_asm] = ACTIONS(562),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_while] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(562),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_STAR] = ACTIONS(562),
    [anon_sym_EQ_EQ] = ACTIONS(560),
    [anon_sym_BANG_EQ] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_LT_EQ] = ACTIONS(560),
    [anon_sym_GT_EQ] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(560),
    [anon_sym_CARET] = ACTIONS(560),
    [anon_sym_orelse] = ACTIONS(562),
    [anon_sym_catch] = ACTIONS(562),
    [anon_sym_LT_LT] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(560),
    [anon_sym_LT_LT_PIPE] = ACTIONS(560),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(560),
    [anon_sym_PLUS_PERCENT] = ACTIONS(560),
    [anon_sym_DASH_PERCENT] = ACTIONS(560),
    [anon_sym_PLUS_PIPE] = ACTIONS(560),
    [anon_sym_DASH_PIPE] = ACTIONS(560),
    [anon_sym_PIPE_PIPE] = ACTIONS(560),
    [anon_sym_SLASH] = ACTIONS(562),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_STAR_STAR] = ACTIONS(560),
    [anon_sym_STAR_PERCENT] = ACTIONS(560),
    [anon_sym_STAR_PIPE] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(560),
    [anon_sym_try] = ACTIONS(562),
    [anon_sym_await] = ACTIONS(562),
    [anon_sym_QMARK] = ACTIONS(560),
    [anon_sym_struct] = ACTIONS(562),
    [anon_sym_opaque] = ACTIONS(562),
    [anon_sym_enum] = ACTIONS(562),
    [anon_sym_union] = ACTIONS(562),
    [sym_doc_comment] = ACTIONS(560),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(560),
    [aux_sym_FLOAT_token1] = ACTIONS(560),
    [aux_sym_FLOAT_token2] = ACTIONS(560),
    [aux_sym_FLOAT_token3] = ACTIONS(560),
    [aux_sym_FLOAT_token4] = ACTIONS(560),
    [aux_sym_INTEGER_token1] = ACTIONS(560),
    [aux_sym_INTEGER_token2] = ACTIONS(560),
    [aux_sym_INTEGER_token3] = ACTIONS(562),
    [aux_sym_INTEGER_token4] = ACTIONS(562),
    [anon_sym_DQUOTE] = ACTIONS(560),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(560),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(562),
    [anon_sym_AT] = ACTIONS(560),
  },
  [345] = {
    [ts_builtin_sym_end] = ACTIONS(556),
    [anon_sym_COMMA] = ACTIONS(556),
    [anon_sym_pub] = ACTIONS(558),
    [anon_sym_test] = ACTIONS(558),
    [anon_sym_comptime] = ACTIONS(558),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_extern] = ACTIONS(558),
    [anon_sym_inline] = ACTIONS(558),
    [anon_sym_noinline] = ACTIONS(558),
    [anon_sym_threadlocal] = ACTIONS(558),
    [anon_sym_usingnamespace] = ACTIONS(558),
    [anon_sym_fn] = ACTIONS(558),
    [anon_sym_BANG] = ACTIONS(558),
    [anon_sym_const] = ACTIONS(558),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_nosuspend] = ACTIONS(558),
    [anon_sym_else] = ACTIONS(558),
    [anon_sym_or] = ACTIONS(558),
    [anon_sym_and] = ACTIONS(558),
    [anon_sym_break] = ACTIONS(558),
    [anon_sym_continue] = ACTIONS(558),
    [anon_sym_resume] = ACTIONS(558),
    [anon_sym_return] = ACTIONS(558),
    [anon_sym_LBRACE] = ACTIONS(556),
    [anon_sym_RBRACE] = ACTIONS(556),
    [anon_sym_async] = ACTIONS(558),
    [anon_sym_DOT] = ACTIONS(556),
    [anon_sym_error] = ACTIONS(558),
    [anon_sym_false] = ACTIONS(558),
    [anon_sym_null] = ACTIONS(558),
    [anon_sym_anyframe] = ACTIONS(558),
    [anon_sym_true] = ACTIONS(558),
    [anon_sym_undefined] = ACTIONS(558),
    [anon_sym_unreachable] = ACTIONS(558),
    [sym_BuildinTypeExpr] = ACTIONS(558),
    [anon_sym_packed] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_switch] = ACTIONS(558),
    [anon_sym_asm] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(556),
    [anon_sym_if] = ACTIONS(558),
    [anon_sym_while] = ACTIONS(558),
    [anon_sym_for] = ACTIONS(558),
    [anon_sym_PIPE] = ACTIONS(558),
    [anon_sym_STAR] = ACTIONS(558),
    [anon_sym_EQ_EQ] = ACTIONS(556),
    [anon_sym_BANG_EQ] = ACTIONS(556),
    [anon_sym_LT] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(558),
    [anon_sym_LT_EQ] = ACTIONS(556),
    [anon_sym_GT_EQ] = ACTIONS(556),
    [anon_sym_AMP] = ACTIONS(556),
    [anon_sym_CARET] = ACTIONS(556),
    [anon_sym_orelse] = ACTIONS(558),
    [anon_sym_catch] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(558),
    [anon_sym_GT_GT] = ACTIONS(556),
    [anon_sym_LT_LT_PIPE] = ACTIONS(556),
    [anon_sym_PLUS] = ACTIONS(558),
    [anon_sym_DASH] = ACTIONS(558),
    [anon_sym_PLUS_PLUS] = ACTIONS(556),
    [anon_sym_PLUS_PERCENT] = ACTIONS(556),
    [anon_sym_DASH_PERCENT] = ACTIONS(556),
    [anon_sym_PLUS_PIPE] = ACTIONS(556),
    [anon_sym_DASH_PIPE] = ACTIONS(556),
    [anon_sym_PIPE_PIPE] = ACTIONS(556),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_PERCENT] = ACTIONS(556),
    [anon_sym_STAR_STAR] = ACTIONS(556),
    [anon_sym_STAR_PERCENT] = ACTIONS(556),
    [anon_sym_STAR_PIPE] = ACTIONS(556),
    [anon_sym_TILDE] = ACTIONS(556),
    [anon_sym_try] = ACTIONS(558),
    [anon_sym_await] = ACTIONS(558),
    [anon_sym_QMARK] = ACTIONS(556),
    [anon_sym_struct] = ACTIONS(558),
    [anon_sym_opaque] = ACTIONS(558),
    [anon_sym_enum] = ACTIONS(558),
    [anon_sym_union] = ACTIONS(558),
    [sym_doc_comment] = ACTIONS(556),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(556),
    [aux_sym_FLOAT_token1] = ACTIONS(556),
    [aux_sym_FLOAT_token2] = ACTIONS(556),
    [aux_sym_FLOAT_token3] = ACTIONS(556),
    [aux_sym_FLOAT_token4] = ACTIONS(556),
    [aux_sym_INTEGER_token1] = ACTIONS(556),
    [aux_sym_INTEGER_token2] = ACTIONS(556),
    [aux_sym_INTEGER_token3] = ACTIONS(558),
    [aux_sym_INTEGER_token4] = ACTIONS(558),
    [anon_sym_DQUOTE] = ACTIONS(556),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(556),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(558),
    [anon_sym_AT] = ACTIONS(556),
  },
  [346] = {
    [ts_builtin_sym_end] = ACTIONS(536),
    [anon_sym_COMMA] = ACTIONS(536),
    [anon_sym_pub] = ACTIONS(538),
    [anon_sym_test] = ACTIONS(538),
    [anon_sym_comptime] = ACTIONS(538),
    [anon_sym_export] = ACTIONS(538),
    [anon_sym_extern] = ACTIONS(538),
    [anon_sym_inline] = ACTIONS(538),
    [anon_sym_noinline] = ACTIONS(538),
    [anon_sym_threadlocal] = ACTIONS(538),
    [anon_sym_usingnamespace] = ACTIONS(538),
    [anon_sym_fn] = ACTIONS(538),
    [anon_sym_BANG] = ACTIONS(538),
    [anon_sym_const] = ACTIONS(538),
    [anon_sym_var] = ACTIONS(538),
    [anon_sym_nosuspend] = ACTIONS(538),
    [anon_sym_else] = ACTIONS(538),
    [anon_sym_or] = ACTIONS(538),
    [anon_sym_and] = ACTIONS(538),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(538),
    [anon_sym_resume] = ACTIONS(538),
    [anon_sym_return] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(536),
    [anon_sym_RBRACE] = ACTIONS(536),
    [anon_sym_async] = ACTIONS(538),
    [anon_sym_DOT] = ACTIONS(536),
    [anon_sym_error] = ACTIONS(538),
    [anon_sym_false] = ACTIONS(538),
    [anon_sym_null] = ACTIONS(538),
    [anon_sym_anyframe] = ACTIONS(538),
    [anon_sym_true] = ACTIONS(538),
    [anon_sym_undefined] = ACTIONS(538),
    [anon_sym_unreachable] = ACTIONS(538),
    [sym_BuildinTypeExpr] = ACTIONS(538),
    [anon_sym_packed] = ACTIONS(538),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_switch] = ACTIONS(538),
    [anon_sym_asm] = ACTIONS(538),
    [anon_sym_LBRACK] = ACTIONS(536),
    [anon_sym_if] = ACTIONS(538),
    [anon_sym_while] = ACTIONS(538),
    [anon_sym_for] = ACTIONS(538),
    [anon_sym_PIPE] = ACTIONS(538),
    [anon_sym_STAR] = ACTIONS(538),
    [anon_sym_EQ_EQ] = ACTIONS(536),
    [anon_sym_BANG_EQ] = ACTIONS(536),
    [anon_sym_LT] = ACTIONS(538),
    [anon_sym_GT] = ACTIONS(538),
    [anon_sym_LT_EQ] = ACTIONS(536),
    [anon_sym_GT_EQ] = ACTIONS(536),
    [anon_sym_AMP] = ACTIONS(536),
    [anon_sym_CARET] = ACTIONS(536),
    [anon_sym_orelse] = ACTIONS(538),
    [anon_sym_catch] = ACTIONS(538),
    [anon_sym_LT_LT] = ACTIONS(538),
    [anon_sym_GT_GT] = ACTIONS(536),
    [anon_sym_LT_LT_PIPE] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(538),
    [anon_sym_DASH] = ACTIONS(538),
    [anon_sym_PLUS_PLUS] = ACTIONS(536),
    [anon_sym_PLUS_PERCENT] = ACTIONS(536),
    [anon_sym_DASH_PERCENT] = ACTIONS(536),
    [anon_sym_PLUS_PIPE] = ACTIONS(536),
    [anon_sym_DASH_PIPE] = ACTIONS(536),
    [anon_sym_PIPE_PIPE] = ACTIONS(536),
    [anon_sym_SLASH] = ACTIONS(538),
    [anon_sym_PERCENT] = ACTIONS(536),
    [anon_sym_STAR_STAR] = ACTIONS(536),
    [anon_sym_STAR_PERCENT] = ACTIONS(536),
    [anon_sym_STAR_PIPE] = ACTIONS(536),
    [anon_sym_TILDE] = ACTIONS(536),
    [anon_sym_try] = ACTIONS(538),
    [anon_sym_await] = ACTIONS(538),
    [anon_sym_QMARK] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_opaque] = ACTIONS(538),
    [anon_sym_enum] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(538),
    [sym_doc_comment] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(536),
    [aux_sym_FLOAT_token1] = ACTIONS(536),
    [aux_sym_FLOAT_token2] = ACTIONS(536),
    [aux_sym_FLOAT_token3] = ACTIONS(536),
    [aux_sym_FLOAT_token4] = ACTIONS(536),
    [aux_sym_INTEGER_token1] = ACTIONS(536),
    [aux_sym_INTEGER_token2] = ACTIONS(536),
    [aux_sym_INTEGER_token3] = ACTIONS(538),
    [aux_sym_INTEGER_token4] = ACTIONS(538),
    [anon_sym_DQUOTE] = ACTIONS(536),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(536),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(538),
    [anon_sym_AT] = ACTIONS(536),
  },
  [347] = {
    [aux_sym__ContainerMembers] = STATE(347),
    [sym__ContainerDeclarations] = STATE(347),
    [sym_TestDecl] = STATE(347),
    [sym_ComptimeDecl] = STATE(347),
    [sym_Decl] = STATE(347),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [ts_builtin_sym_end] = ACTIONS(776),
    [anon_sym_pub] = ACTIONS(778),
    [anon_sym_test] = ACTIONS(781),
    [anon_sym_comptime] = ACTIONS(784),
    [anon_sym_export] = ACTIONS(787),
    [anon_sym_extern] = ACTIONS(790),
    [anon_sym_inline] = ACTIONS(793),
    [anon_sym_noinline] = ACTIONS(796),
    [anon_sym_threadlocal] = ACTIONS(799),
    [anon_sym_usingnamespace] = ACTIONS(802),
    [anon_sym_fn] = ACTIONS(805),
    [anon_sym_const] = ACTIONS(808),
    [anon_sym_var] = ACTIONS(808),
    [anon_sym_RBRACE] = ACTIONS(776),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(814),
    [anon_sym_error] = ACTIONS(817),
    [anon_sym_false] = ACTIONS(820),
    [anon_sym_null] = ACTIONS(820),
    [anon_sym_anyframe] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(820),
    [anon_sym_undefined] = ACTIONS(820),
    [anon_sym_unreachable] = ACTIONS(820),
    [sym_BuildinTypeExpr] = ACTIONS(826),
    [anon_sym_packed] = ACTIONS(829),
    [anon_sym_LPAREN] = ACTIONS(832),
    [anon_sym_switch] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(838),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_while] = ACTIONS(844),
    [anon_sym_for] = ACTIONS(847),
    [anon_sym_STAR] = ACTIONS(850),
    [anon_sym_STAR_STAR] = ACTIONS(853),
    [anon_sym_QMARK] = ACTIONS(856),
    [anon_sym_struct] = ACTIONS(859),
    [anon_sym_opaque] = ACTIONS(862),
    [anon_sym_enum] = ACTIONS(859),
    [anon_sym_union] = ACTIONS(865),
    [sym_doc_comment] = ACTIONS(868),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(871),
    [aux_sym_FLOAT_token1] = ACTIONS(874),
    [aux_sym_FLOAT_token2] = ACTIONS(874),
    [aux_sym_FLOAT_token3] = ACTIONS(874),
    [aux_sym_FLOAT_token4] = ACTIONS(874),
    [aux_sym_INTEGER_token1] = ACTIONS(877),
    [aux_sym_INTEGER_token2] = ACTIONS(877),
    [aux_sym_INTEGER_token3] = ACTIONS(880),
    [aux_sym_INTEGER_token4] = ACTIONS(880),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(886),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(889),
    [anon_sym_AT] = ACTIONS(892),
  },
  [348] = {
    [ts_builtin_sym_end] = ACTIONS(552),
    [anon_sym_COMMA] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(554),
    [anon_sym_test] = ACTIONS(554),
    [anon_sym_comptime] = ACTIONS(554),
    [anon_sym_export] = ACTIONS(554),
    [anon_sym_extern] = ACTIONS(554),
    [anon_sym_inline] = ACTIONS(554),
    [anon_sym_noinline] = ACTIONS(554),
    [anon_sym_threadlocal] = ACTIONS(554),
    [anon_sym_usingnamespace] = ACTIONS(554),
    [anon_sym_fn] = ACTIONS(554),
    [anon_sym_BANG] = ACTIONS(554),
    [anon_sym_const] = ACTIONS(554),
    [anon_sym_var] = ACTIONS(554),
    [anon_sym_nosuspend] = ACTIONS(554),
    [anon_sym_else] = ACTIONS(554),
    [anon_sym_or] = ACTIONS(554),
    [anon_sym_and] = ACTIONS(554),
    [anon_sym_break] = ACTIONS(554),
    [anon_sym_continue] = ACTIONS(554),
    [anon_sym_resume] = ACTIONS(554),
    [anon_sym_return] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(552),
    [anon_sym_RBRACE] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(554),
    [anon_sym_DOT] = ACTIONS(552),
    [anon_sym_error] = ACTIONS(554),
    [anon_sym_false] = ACTIONS(554),
    [anon_sym_null] = ACTIONS(554),
    [anon_sym_anyframe] = ACTIONS(554),
    [anon_sym_true] = ACTIONS(554),
    [anon_sym_undefined] = ACTIONS(554),
    [anon_sym_unreachable] = ACTIONS(554),
    [sym_BuildinTypeExpr] = ACTIONS(554),
    [anon_sym_packed] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_switch] = ACTIONS(554),
    [anon_sym_asm] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(554),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_PIPE] = ACTIONS(554),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_EQ_EQ] = ACTIONS(552),
    [anon_sym_BANG_EQ] = ACTIONS(552),
    [anon_sym_LT] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(552),
    [anon_sym_GT_EQ] = ACTIONS(552),
    [anon_sym_AMP] = ACTIONS(552),
    [anon_sym_CARET] = ACTIONS(552),
    [anon_sym_orelse] = ACTIONS(554),
    [anon_sym_catch] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(554),
    [anon_sym_GT_GT] = ACTIONS(552),
    [anon_sym_LT_LT_PIPE] = ACTIONS(552),
    [anon_sym_PLUS] = ACTIONS(554),
    [anon_sym_DASH] = ACTIONS(554),
    [anon_sym_PLUS_PLUS] = ACTIONS(552),
    [anon_sym_PLUS_PERCENT] = ACTIONS(552),
    [anon_sym_DASH_PERCENT] = ACTIONS(552),
    [anon_sym_PLUS_PIPE] = ACTIONS(552),
    [anon_sym_DASH_PIPE] = ACTIONS(552),
    [anon_sym_PIPE_PIPE] = ACTIONS(552),
    [anon_sym_SLASH] = ACTIONS(554),
    [anon_sym_PERCENT] = ACTIONS(552),
    [anon_sym_STAR_STAR] = ACTIONS(552),
    [anon_sym_STAR_PERCENT] = ACTIONS(552),
    [anon_sym_STAR_PIPE] = ACTIONS(552),
    [anon_sym_TILDE] = ACTIONS(552),
    [anon_sym_try] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(554),
    [anon_sym_QMARK] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_opaque] = ACTIONS(554),
    [anon_sym_enum] = ACTIONS(554),
    [anon_sym_union] = ACTIONS(554),
    [sym_doc_comment] = ACTIONS(552),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [aux_sym_FLOAT_token1] = ACTIONS(552),
    [aux_sym_FLOAT_token2] = ACTIONS(552),
    [aux_sym_FLOAT_token3] = ACTIONS(552),
    [aux_sym_FLOAT_token4] = ACTIONS(552),
    [aux_sym_INTEGER_token1] = ACTIONS(552),
    [aux_sym_INTEGER_token2] = ACTIONS(552),
    [aux_sym_INTEGER_token3] = ACTIONS(554),
    [aux_sym_INTEGER_token4] = ACTIONS(554),
    [anon_sym_DQUOTE] = ACTIONS(552),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(552),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(552),
  },
  [349] = {
    [aux_sym__ContainerMembers] = STATE(357),
    [sym__ContainerDeclarations] = STATE(357),
    [sym_TestDecl] = STATE(357),
    [sym_ComptimeDecl] = STATE(357),
    [sym_Decl] = STATE(357),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(895),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_container_doc_comment] = ACTIONS(897),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [350] = {
    [aux_sym__ContainerMembers] = STATE(347),
    [sym__ContainerDeclarations] = STATE(347),
    [sym_TestDecl] = STATE(347),
    [sym_ComptimeDecl] = STATE(347),
    [sym_Decl] = STATE(347),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(899),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [351] = {
    [aux_sym__ContainerMembers] = STATE(347),
    [sym__ContainerDeclarations] = STATE(347),
    [sym_TestDecl] = STATE(347),
    [sym_ComptimeDecl] = STATE(347),
    [sym_Decl] = STATE(347),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(901),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [352] = {
    [aux_sym__ContainerMembers] = STATE(350),
    [sym__ContainerDeclarations] = STATE(350),
    [sym_TestDecl] = STATE(350),
    [sym_ComptimeDecl] = STATE(350),
    [sym_Decl] = STATE(350),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(903),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [353] = {
    [aux_sym__ContainerMembers] = STATE(347),
    [sym__ContainerDeclarations] = STATE(347),
    [sym_TestDecl] = STATE(347),
    [sym_ComptimeDecl] = STATE(347),
    [sym_Decl] = STATE(347),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [ts_builtin_sym_end] = ACTIONS(905),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [354] = {
    [aux_sym__ContainerMembers] = STATE(362),
    [sym__ContainerDeclarations] = STATE(362),
    [sym_TestDecl] = STATE(362),
    [sym_ComptimeDecl] = STATE(362),
    [sym_Decl] = STATE(362),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(907),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [355] = {
    [aux_sym__ContainerMembers] = STATE(347),
    [sym__ContainerDeclarations] = STATE(347),
    [sym_TestDecl] = STATE(347),
    [sym_ComptimeDecl] = STATE(347),
    [sym_Decl] = STATE(347),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(907),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [356] = {
    [aux_sym__ContainerMembers] = STATE(347),
    [sym__ContainerDeclarations] = STATE(347),
    [sym_TestDecl] = STATE(347),
    [sym_ComptimeDecl] = STATE(347),
    [sym_Decl] = STATE(347),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [357] = {
    [aux_sym__ContainerMembers] = STATE(347),
    [sym__ContainerDeclarations] = STATE(347),
    [sym_TestDecl] = STATE(347),
    [sym_ComptimeDecl] = STATE(347),
    [sym_Decl] = STATE(347),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(911),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [358] = {
    [aux_sym__ContainerMembers] = STATE(347),
    [sym__ContainerDeclarations] = STATE(347),
    [sym_TestDecl] = STATE(347),
    [sym_ComptimeDecl] = STATE(347),
    [sym_Decl] = STATE(347),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [359] = {
    [aux_sym__ContainerMembers] = STATE(347),
    [sym__ContainerDeclarations] = STATE(347),
    [sym_TestDecl] = STATE(347),
    [sym_ComptimeDecl] = STATE(347),
    [sym_Decl] = STATE(347),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(903),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [360] = {
    [aux_sym__ContainerMembers] = STATE(347),
    [sym__ContainerDeclarations] = STATE(347),
    [sym_TestDecl] = STATE(347),
    [sym_ComptimeDecl] = STATE(347),
    [sym_Decl] = STATE(347),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(915),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [361] = {
    [aux_sym__ContainerMembers] = STATE(347),
    [sym__ContainerDeclarations] = STATE(347),
    [sym_TestDecl] = STATE(347),
    [sym_ComptimeDecl] = STATE(347),
    [sym_Decl] = STATE(347),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(917),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [362] = {
    [aux_sym__ContainerMembers] = STATE(347),
    [sym__ContainerDeclarations] = STATE(347),
    [sym_TestDecl] = STATE(347),
    [sym_ComptimeDecl] = STATE(347),
    [sym_Decl] = STATE(347),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(919),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [363] = {
    [aux_sym__ContainerMembers] = STATE(361),
    [sym__ContainerDeclarations] = STATE(361),
    [sym_TestDecl] = STATE(361),
    [sym_ComptimeDecl] = STATE(361),
    [sym_Decl] = STATE(361),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(911),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [364] = {
    [ts_builtin_sym_end] = ACTIONS(552),
    [anon_sym_COMMA] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(554),
    [anon_sym_test] = ACTIONS(554),
    [anon_sym_comptime] = ACTIONS(554),
    [anon_sym_export] = ACTIONS(554),
    [anon_sym_extern] = ACTIONS(554),
    [anon_sym_inline] = ACTIONS(554),
    [anon_sym_noinline] = ACTIONS(554),
    [anon_sym_threadlocal] = ACTIONS(554),
    [anon_sym_usingnamespace] = ACTIONS(554),
    [anon_sym_fn] = ACTIONS(554),
    [anon_sym_BANG] = ACTIONS(554),
    [anon_sym_const] = ACTIONS(554),
    [anon_sym_var] = ACTIONS(554),
    [anon_sym_nosuspend] = ACTIONS(554),
    [anon_sym_or] = ACTIONS(554),
    [anon_sym_and] = ACTIONS(554),
    [anon_sym_break] = ACTIONS(554),
    [anon_sym_continue] = ACTIONS(554),
    [anon_sym_resume] = ACTIONS(554),
    [anon_sym_return] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(552),
    [anon_sym_RBRACE] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(554),
    [anon_sym_DOT] = ACTIONS(552),
    [anon_sym_error] = ACTIONS(554),
    [anon_sym_false] = ACTIONS(554),
    [anon_sym_null] = ACTIONS(554),
    [anon_sym_anyframe] = ACTIONS(554),
    [anon_sym_true] = ACTIONS(554),
    [anon_sym_undefined] = ACTIONS(554),
    [anon_sym_unreachable] = ACTIONS(554),
    [sym_BuildinTypeExpr] = ACTIONS(554),
    [anon_sym_packed] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_switch] = ACTIONS(554),
    [anon_sym_asm] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(554),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_PIPE] = ACTIONS(554),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_EQ_EQ] = ACTIONS(552),
    [anon_sym_BANG_EQ] = ACTIONS(552),
    [anon_sym_LT] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(552),
    [anon_sym_GT_EQ] = ACTIONS(552),
    [anon_sym_AMP] = ACTIONS(552),
    [anon_sym_CARET] = ACTIONS(552),
    [anon_sym_orelse] = ACTIONS(554),
    [anon_sym_catch] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(554),
    [anon_sym_GT_GT] = ACTIONS(552),
    [anon_sym_LT_LT_PIPE] = ACTIONS(552),
    [anon_sym_PLUS] = ACTIONS(554),
    [anon_sym_DASH] = ACTIONS(554),
    [anon_sym_PLUS_PLUS] = ACTIONS(552),
    [anon_sym_PLUS_PERCENT] = ACTIONS(552),
    [anon_sym_DASH_PERCENT] = ACTIONS(552),
    [anon_sym_PLUS_PIPE] = ACTIONS(552),
    [anon_sym_DASH_PIPE] = ACTIONS(552),
    [anon_sym_PIPE_PIPE] = ACTIONS(552),
    [anon_sym_SLASH] = ACTIONS(554),
    [anon_sym_PERCENT] = ACTIONS(552),
    [anon_sym_STAR_STAR] = ACTIONS(552),
    [anon_sym_STAR_PERCENT] = ACTIONS(552),
    [anon_sym_STAR_PIPE] = ACTIONS(552),
    [anon_sym_TILDE] = ACTIONS(552),
    [anon_sym_try] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(554),
    [anon_sym_QMARK] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_opaque] = ACTIONS(554),
    [anon_sym_enum] = ACTIONS(554),
    [anon_sym_union] = ACTIONS(554),
    [sym_doc_comment] = ACTIONS(552),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [aux_sym_FLOAT_token1] = ACTIONS(552),
    [aux_sym_FLOAT_token2] = ACTIONS(552),
    [aux_sym_FLOAT_token3] = ACTIONS(552),
    [aux_sym_FLOAT_token4] = ACTIONS(552),
    [aux_sym_INTEGER_token1] = ACTIONS(552),
    [aux_sym_INTEGER_token2] = ACTIONS(552),
    [aux_sym_INTEGER_token3] = ACTIONS(554),
    [aux_sym_INTEGER_token4] = ACTIONS(554),
    [anon_sym_DQUOTE] = ACTIONS(552),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(552),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(552),
  },
  [365] = {
    [ts_builtin_sym_end] = ACTIONS(536),
    [anon_sym_COMMA] = ACTIONS(536),
    [anon_sym_pub] = ACTIONS(538),
    [anon_sym_test] = ACTIONS(538),
    [anon_sym_comptime] = ACTIONS(538),
    [anon_sym_export] = ACTIONS(538),
    [anon_sym_extern] = ACTIONS(538),
    [anon_sym_inline] = ACTIONS(538),
    [anon_sym_noinline] = ACTIONS(538),
    [anon_sym_threadlocal] = ACTIONS(538),
    [anon_sym_usingnamespace] = ACTIONS(538),
    [anon_sym_fn] = ACTIONS(538),
    [anon_sym_BANG] = ACTIONS(538),
    [anon_sym_const] = ACTIONS(538),
    [anon_sym_var] = ACTIONS(538),
    [anon_sym_nosuspend] = ACTIONS(538),
    [anon_sym_or] = ACTIONS(538),
    [anon_sym_and] = ACTIONS(538),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(538),
    [anon_sym_resume] = ACTIONS(538),
    [anon_sym_return] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(536),
    [anon_sym_RBRACE] = ACTIONS(536),
    [anon_sym_async] = ACTIONS(538),
    [anon_sym_DOT] = ACTIONS(536),
    [anon_sym_error] = ACTIONS(538),
    [anon_sym_false] = ACTIONS(538),
    [anon_sym_null] = ACTIONS(538),
    [anon_sym_anyframe] = ACTIONS(538),
    [anon_sym_true] = ACTIONS(538),
    [anon_sym_undefined] = ACTIONS(538),
    [anon_sym_unreachable] = ACTIONS(538),
    [sym_BuildinTypeExpr] = ACTIONS(538),
    [anon_sym_packed] = ACTIONS(538),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_switch] = ACTIONS(538),
    [anon_sym_asm] = ACTIONS(538),
    [anon_sym_LBRACK] = ACTIONS(536),
    [anon_sym_if] = ACTIONS(538),
    [anon_sym_while] = ACTIONS(538),
    [anon_sym_for] = ACTIONS(538),
    [anon_sym_PIPE] = ACTIONS(538),
    [anon_sym_STAR] = ACTIONS(538),
    [anon_sym_EQ_EQ] = ACTIONS(536),
    [anon_sym_BANG_EQ] = ACTIONS(536),
    [anon_sym_LT] = ACTIONS(538),
    [anon_sym_GT] = ACTIONS(538),
    [anon_sym_LT_EQ] = ACTIONS(536),
    [anon_sym_GT_EQ] = ACTIONS(536),
    [anon_sym_AMP] = ACTIONS(536),
    [anon_sym_CARET] = ACTIONS(536),
    [anon_sym_orelse] = ACTIONS(538),
    [anon_sym_catch] = ACTIONS(538),
    [anon_sym_LT_LT] = ACTIONS(538),
    [anon_sym_GT_GT] = ACTIONS(536),
    [anon_sym_LT_LT_PIPE] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(538),
    [anon_sym_DASH] = ACTIONS(538),
    [anon_sym_PLUS_PLUS] = ACTIONS(536),
    [anon_sym_PLUS_PERCENT] = ACTIONS(536),
    [anon_sym_DASH_PERCENT] = ACTIONS(536),
    [anon_sym_PLUS_PIPE] = ACTIONS(536),
    [anon_sym_DASH_PIPE] = ACTIONS(536),
    [anon_sym_PIPE_PIPE] = ACTIONS(536),
    [anon_sym_SLASH] = ACTIONS(538),
    [anon_sym_PERCENT] = ACTIONS(536),
    [anon_sym_STAR_STAR] = ACTIONS(536),
    [anon_sym_STAR_PERCENT] = ACTIONS(536),
    [anon_sym_STAR_PIPE] = ACTIONS(536),
    [anon_sym_TILDE] = ACTIONS(536),
    [anon_sym_try] = ACTIONS(538),
    [anon_sym_await] = ACTIONS(538),
    [anon_sym_QMARK] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_opaque] = ACTIONS(538),
    [anon_sym_enum] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(538),
    [sym_doc_comment] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(536),
    [aux_sym_FLOAT_token1] = ACTIONS(536),
    [aux_sym_FLOAT_token2] = ACTIONS(536),
    [aux_sym_FLOAT_token3] = ACTIONS(536),
    [aux_sym_FLOAT_token4] = ACTIONS(536),
    [aux_sym_INTEGER_token1] = ACTIONS(536),
    [aux_sym_INTEGER_token2] = ACTIONS(536),
    [aux_sym_INTEGER_token3] = ACTIONS(538),
    [aux_sym_INTEGER_token4] = ACTIONS(538),
    [anon_sym_DQUOTE] = ACTIONS(536),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(536),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(538),
    [anon_sym_AT] = ACTIONS(536),
  },
  [366] = {
    [aux_sym__ContainerMembers] = STATE(347),
    [sym__ContainerDeclarations] = STATE(347),
    [sym_TestDecl] = STATE(347),
    [sym_ComptimeDecl] = STATE(347),
    [sym_Decl] = STATE(347),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [ts_builtin_sym_end] = ACTIONS(921),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [367] = {
    [aux_sym__ContainerMembers] = STATE(347),
    [sym__ContainerDeclarations] = STATE(347),
    [sym_TestDecl] = STATE(347),
    [sym_ComptimeDecl] = STATE(347),
    [sym_Decl] = STATE(347),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [368] = {
    [aux_sym__ContainerMembers] = STATE(356),
    [sym__ContainerDeclarations] = STATE(356),
    [sym_TestDecl] = STATE(356),
    [sym_ComptimeDecl] = STATE(356),
    [sym_Decl] = STATE(356),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [369] = {
    [ts_builtin_sym_end] = ACTIONS(556),
    [anon_sym_COMMA] = ACTIONS(556),
    [anon_sym_pub] = ACTIONS(558),
    [anon_sym_test] = ACTIONS(558),
    [anon_sym_comptime] = ACTIONS(558),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_extern] = ACTIONS(558),
    [anon_sym_inline] = ACTIONS(558),
    [anon_sym_noinline] = ACTIONS(558),
    [anon_sym_threadlocal] = ACTIONS(558),
    [anon_sym_usingnamespace] = ACTIONS(558),
    [anon_sym_fn] = ACTIONS(558),
    [anon_sym_BANG] = ACTIONS(558),
    [anon_sym_const] = ACTIONS(558),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_nosuspend] = ACTIONS(558),
    [anon_sym_or] = ACTIONS(558),
    [anon_sym_and] = ACTIONS(558),
    [anon_sym_break] = ACTIONS(558),
    [anon_sym_continue] = ACTIONS(558),
    [anon_sym_resume] = ACTIONS(558),
    [anon_sym_return] = ACTIONS(558),
    [anon_sym_LBRACE] = ACTIONS(556),
    [anon_sym_RBRACE] = ACTIONS(556),
    [anon_sym_async] = ACTIONS(558),
    [anon_sym_DOT] = ACTIONS(556),
    [anon_sym_error] = ACTIONS(558),
    [anon_sym_false] = ACTIONS(558),
    [anon_sym_null] = ACTIONS(558),
    [anon_sym_anyframe] = ACTIONS(558),
    [anon_sym_true] = ACTIONS(558),
    [anon_sym_undefined] = ACTIONS(558),
    [anon_sym_unreachable] = ACTIONS(558),
    [sym_BuildinTypeExpr] = ACTIONS(558),
    [anon_sym_packed] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_switch] = ACTIONS(558),
    [anon_sym_asm] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(556),
    [anon_sym_if] = ACTIONS(558),
    [anon_sym_while] = ACTIONS(558),
    [anon_sym_for] = ACTIONS(558),
    [anon_sym_PIPE] = ACTIONS(558),
    [anon_sym_STAR] = ACTIONS(558),
    [anon_sym_EQ_EQ] = ACTIONS(556),
    [anon_sym_BANG_EQ] = ACTIONS(556),
    [anon_sym_LT] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(558),
    [anon_sym_LT_EQ] = ACTIONS(556),
    [anon_sym_GT_EQ] = ACTIONS(556),
    [anon_sym_AMP] = ACTIONS(556),
    [anon_sym_CARET] = ACTIONS(556),
    [anon_sym_orelse] = ACTIONS(558),
    [anon_sym_catch] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(558),
    [anon_sym_GT_GT] = ACTIONS(556),
    [anon_sym_LT_LT_PIPE] = ACTIONS(556),
    [anon_sym_PLUS] = ACTIONS(558),
    [anon_sym_DASH] = ACTIONS(558),
    [anon_sym_PLUS_PLUS] = ACTIONS(556),
    [anon_sym_PLUS_PERCENT] = ACTIONS(556),
    [anon_sym_DASH_PERCENT] = ACTIONS(556),
    [anon_sym_PLUS_PIPE] = ACTIONS(556),
    [anon_sym_DASH_PIPE] = ACTIONS(556),
    [anon_sym_PIPE_PIPE] = ACTIONS(556),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_PERCENT] = ACTIONS(556),
    [anon_sym_STAR_STAR] = ACTIONS(556),
    [anon_sym_STAR_PERCENT] = ACTIONS(556),
    [anon_sym_STAR_PIPE] = ACTIONS(556),
    [anon_sym_TILDE] = ACTIONS(556),
    [anon_sym_try] = ACTIONS(558),
    [anon_sym_await] = ACTIONS(558),
    [anon_sym_QMARK] = ACTIONS(556),
    [anon_sym_struct] = ACTIONS(558),
    [anon_sym_opaque] = ACTIONS(558),
    [anon_sym_enum] = ACTIONS(558),
    [anon_sym_union] = ACTIONS(558),
    [sym_doc_comment] = ACTIONS(556),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(556),
    [aux_sym_FLOAT_token1] = ACTIONS(556),
    [aux_sym_FLOAT_token2] = ACTIONS(556),
    [aux_sym_FLOAT_token3] = ACTIONS(556),
    [aux_sym_FLOAT_token4] = ACTIONS(556),
    [aux_sym_INTEGER_token1] = ACTIONS(556),
    [aux_sym_INTEGER_token2] = ACTIONS(556),
    [aux_sym_INTEGER_token3] = ACTIONS(558),
    [aux_sym_INTEGER_token4] = ACTIONS(558),
    [anon_sym_DQUOTE] = ACTIONS(556),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(556),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(558),
    [anon_sym_AT] = ACTIONS(556),
  },
  [370] = {
    [aux_sym__ContainerMembers] = STATE(353),
    [sym__ContainerDeclarations] = STATE(353),
    [sym_TestDecl] = STATE(353),
    [sym_ComptimeDecl] = STATE(353),
    [sym_Decl] = STATE(353),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [ts_builtin_sym_end] = ACTIONS(921),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [371] = {
    [aux_sym__ContainerMembers] = STATE(360),
    [sym__ContainerDeclarations] = STATE(360),
    [sym_TestDecl] = STATE(360),
    [sym_ComptimeDecl] = STATE(360),
    [sym_Decl] = STATE(360),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(901),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [372] = {
    [ts_builtin_sym_end] = ACTIONS(560),
    [anon_sym_COMMA] = ACTIONS(560),
    [anon_sym_pub] = ACTIONS(562),
    [anon_sym_test] = ACTIONS(562),
    [anon_sym_comptime] = ACTIONS(562),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_extern] = ACTIONS(562),
    [anon_sym_inline] = ACTIONS(562),
    [anon_sym_noinline] = ACTIONS(562),
    [anon_sym_threadlocal] = ACTIONS(562),
    [anon_sym_usingnamespace] = ACTIONS(562),
    [anon_sym_fn] = ACTIONS(562),
    [anon_sym_BANG] = ACTIONS(562),
    [anon_sym_const] = ACTIONS(562),
    [anon_sym_var] = ACTIONS(562),
    [anon_sym_nosuspend] = ACTIONS(562),
    [anon_sym_or] = ACTIONS(562),
    [anon_sym_and] = ACTIONS(562),
    [anon_sym_break] = ACTIONS(562),
    [anon_sym_continue] = ACTIONS(562),
    [anon_sym_resume] = ACTIONS(562),
    [anon_sym_return] = ACTIONS(562),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_RBRACE] = ACTIONS(560),
    [anon_sym_async] = ACTIONS(562),
    [anon_sym_DOT] = ACTIONS(560),
    [anon_sym_error] = ACTIONS(562),
    [anon_sym_false] = ACTIONS(562),
    [anon_sym_null] = ACTIONS(562),
    [anon_sym_anyframe] = ACTIONS(562),
    [anon_sym_true] = ACTIONS(562),
    [anon_sym_undefined] = ACTIONS(562),
    [anon_sym_unreachable] = ACTIONS(562),
    [sym_BuildinTypeExpr] = ACTIONS(562),
    [anon_sym_packed] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(560),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_asm] = ACTIONS(562),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_while] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(562),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_STAR] = ACTIONS(562),
    [anon_sym_EQ_EQ] = ACTIONS(560),
    [anon_sym_BANG_EQ] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_LT_EQ] = ACTIONS(560),
    [anon_sym_GT_EQ] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(560),
    [anon_sym_CARET] = ACTIONS(560),
    [anon_sym_orelse] = ACTIONS(562),
    [anon_sym_catch] = ACTIONS(562),
    [anon_sym_LT_LT] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(560),
    [anon_sym_LT_LT_PIPE] = ACTIONS(560),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(560),
    [anon_sym_PLUS_PERCENT] = ACTIONS(560),
    [anon_sym_DASH_PERCENT] = ACTIONS(560),
    [anon_sym_PLUS_PIPE] = ACTIONS(560),
    [anon_sym_DASH_PIPE] = ACTIONS(560),
    [anon_sym_PIPE_PIPE] = ACTIONS(560),
    [anon_sym_SLASH] = ACTIONS(562),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_STAR_STAR] = ACTIONS(560),
    [anon_sym_STAR_PERCENT] = ACTIONS(560),
    [anon_sym_STAR_PIPE] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(560),
    [anon_sym_try] = ACTIONS(562),
    [anon_sym_await] = ACTIONS(562),
    [anon_sym_QMARK] = ACTIONS(560),
    [anon_sym_struct] = ACTIONS(562),
    [anon_sym_opaque] = ACTIONS(562),
    [anon_sym_enum] = ACTIONS(562),
    [anon_sym_union] = ACTIONS(562),
    [sym_doc_comment] = ACTIONS(560),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(560),
    [aux_sym_FLOAT_token1] = ACTIONS(560),
    [aux_sym_FLOAT_token2] = ACTIONS(560),
    [aux_sym_FLOAT_token3] = ACTIONS(560),
    [aux_sym_FLOAT_token4] = ACTIONS(560),
    [aux_sym_INTEGER_token1] = ACTIONS(560),
    [aux_sym_INTEGER_token2] = ACTIONS(560),
    [aux_sym_INTEGER_token3] = ACTIONS(562),
    [aux_sym_INTEGER_token4] = ACTIONS(562),
    [anon_sym_DQUOTE] = ACTIONS(560),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(560),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(562),
    [anon_sym_AT] = ACTIONS(560),
  },
  [373] = {
    [ts_builtin_sym_end] = ACTIONS(576),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_pub] = ACTIONS(578),
    [anon_sym_test] = ACTIONS(578),
    [anon_sym_comptime] = ACTIONS(578),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_extern] = ACTIONS(578),
    [anon_sym_inline] = ACTIONS(578),
    [anon_sym_noinline] = ACTIONS(578),
    [anon_sym_threadlocal] = ACTIONS(578),
    [anon_sym_usingnamespace] = ACTIONS(578),
    [anon_sym_fn] = ACTIONS(578),
    [anon_sym_BANG] = ACTIONS(578),
    [anon_sym_const] = ACTIONS(578),
    [anon_sym_var] = ACTIONS(578),
    [anon_sym_nosuspend] = ACTIONS(578),
    [anon_sym_or] = ACTIONS(578),
    [anon_sym_and] = ACTIONS(578),
    [anon_sym_break] = ACTIONS(578),
    [anon_sym_continue] = ACTIONS(578),
    [anon_sym_resume] = ACTIONS(578),
    [anon_sym_return] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(576),
    [anon_sym_RBRACE] = ACTIONS(576),
    [anon_sym_async] = ACTIONS(578),
    [anon_sym_DOT] = ACTIONS(576),
    [anon_sym_error] = ACTIONS(578),
    [anon_sym_false] = ACTIONS(578),
    [anon_sym_null] = ACTIONS(578),
    [anon_sym_anyframe] = ACTIONS(578),
    [anon_sym_true] = ACTIONS(578),
    [anon_sym_undefined] = ACTIONS(578),
    [anon_sym_unreachable] = ACTIONS(578),
    [sym_BuildinTypeExpr] = ACTIONS(578),
    [anon_sym_packed] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(576),
    [anon_sym_switch] = ACTIONS(578),
    [anon_sym_asm] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_if] = ACTIONS(578),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_for] = ACTIONS(578),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(578),
    [anon_sym_EQ_EQ] = ACTIONS(576),
    [anon_sym_BANG_EQ] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_GT] = ACTIONS(578),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_AMP] = ACTIONS(576),
    [anon_sym_CARET] = ACTIONS(576),
    [anon_sym_orelse] = ACTIONS(578),
    [anon_sym_catch] = ACTIONS(578),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_GT_GT] = ACTIONS(576),
    [anon_sym_LT_LT_PIPE] = ACTIONS(576),
    [anon_sym_PLUS] = ACTIONS(578),
    [anon_sym_DASH] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_PLUS_PERCENT] = ACTIONS(576),
    [anon_sym_DASH_PERCENT] = ACTIONS(576),
    [anon_sym_PLUS_PIPE] = ACTIONS(576),
    [anon_sym_DASH_PIPE] = ACTIONS(576),
    [anon_sym_PIPE_PIPE] = ACTIONS(576),
    [anon_sym_SLASH] = ACTIONS(578),
    [anon_sym_PERCENT] = ACTIONS(576),
    [anon_sym_STAR_STAR] = ACTIONS(576),
    [anon_sym_STAR_PERCENT] = ACTIONS(576),
    [anon_sym_STAR_PIPE] = ACTIONS(576),
    [anon_sym_TILDE] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(578),
    [anon_sym_await] = ACTIONS(578),
    [anon_sym_QMARK] = ACTIONS(576),
    [anon_sym_struct] = ACTIONS(578),
    [anon_sym_opaque] = ACTIONS(578),
    [anon_sym_enum] = ACTIONS(578),
    [anon_sym_union] = ACTIONS(578),
    [sym_doc_comment] = ACTIONS(576),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(576),
    [aux_sym_FLOAT_token1] = ACTIONS(576),
    [aux_sym_FLOAT_token2] = ACTIONS(576),
    [aux_sym_FLOAT_token3] = ACTIONS(576),
    [aux_sym_FLOAT_token4] = ACTIONS(576),
    [aux_sym_INTEGER_token1] = ACTIONS(576),
    [aux_sym_INTEGER_token2] = ACTIONS(576),
    [aux_sym_INTEGER_token3] = ACTIONS(578),
    [aux_sym_INTEGER_token4] = ACTIONS(578),
    [anon_sym_DQUOTE] = ACTIONS(576),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(576),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(578),
    [anon_sym_AT] = ACTIONS(576),
  },
  [374] = {
    [aux_sym__ContainerMembers] = STATE(358),
    [sym__ContainerDeclarations] = STATE(358),
    [sym_TestDecl] = STATE(358),
    [sym_ComptimeDecl] = STATE(358),
    [sym_Decl] = STATE(358),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(925),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [375] = {
    [aux_sym__ContainerMembers] = STATE(347),
    [sym__ContainerDeclarations] = STATE(347),
    [sym_TestDecl] = STATE(347),
    [sym_ComptimeDecl] = STATE(347),
    [sym_Decl] = STATE(347),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym_ContainerField] = STATE(1361),
    [sym__TypeExpr] = STATE(1303),
    [sym_ErrorUnionExpr] = STATE(1303),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1047),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(7),
    [anon_sym_test] = ACTIONS(9),
    [anon_sym_comptime] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(925),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(39),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(69),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [376] = {
    [sym_FieldOrFnCall] = STATE(382),
    [sym_SuffixOp] = STATE(382),
    [sym_FnCallArguments] = STATE(382),
    [aux_sym_SuffixExpr_repeat1] = STATE(382),
    [ts_builtin_sym_end] = ACTIONS(927),
    [anon_sym_COMMA] = ACTIONS(927),
    [anon_sym_pub] = ACTIONS(929),
    [anon_sym_test] = ACTIONS(929),
    [anon_sym_comptime] = ACTIONS(929),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_extern] = ACTIONS(929),
    [anon_sym_inline] = ACTIONS(929),
    [anon_sym_noinline] = ACTIONS(929),
    [anon_sym_threadlocal] = ACTIONS(929),
    [anon_sym_usingnamespace] = ACTIONS(929),
    [anon_sym_fn] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_const] = ACTIONS(929),
    [anon_sym_var] = ACTIONS(929),
    [anon_sym_COLON] = ACTIONS(931),
    [anon_sym_else] = ACTIONS(929),
    [anon_sym_or] = ACTIONS(929),
    [anon_sym_and] = ACTIONS(929),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_RBRACE] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(933),
    [anon_sym_error] = ACTIONS(929),
    [anon_sym_false] = ACTIONS(929),
    [anon_sym_null] = ACTIONS(929),
    [anon_sym_anyframe] = ACTIONS(929),
    [anon_sym_true] = ACTIONS(929),
    [anon_sym_undefined] = ACTIONS(929),
    [anon_sym_unreachable] = ACTIONS(929),
    [sym_BuildinTypeExpr] = ACTIONS(929),
    [anon_sym_packed] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_switch] = ACTIONS(929),
    [anon_sym_LBRACK] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(929),
    [anon_sym_while] = ACTIONS(929),
    [anon_sym_for] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_EQ_EQ] = ACTIONS(927),
    [anon_sym_BANG_EQ] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_LT_EQ] = ACTIONS(927),
    [anon_sym_GT_EQ] = ACTIONS(927),
    [anon_sym_AMP] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(927),
    [anon_sym_orelse] = ACTIONS(929),
    [anon_sym_catch] = ACTIONS(929),
    [anon_sym_LT_LT] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_LT_LT_PIPE] = ACTIONS(927),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_PLUS_PERCENT] = ACTIONS(927),
    [anon_sym_DASH_PERCENT] = ACTIONS(927),
    [anon_sym_PLUS_PIPE] = ACTIONS(927),
    [anon_sym_DASH_PIPE] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_PERCENT] = ACTIONS(927),
    [anon_sym_STAR_STAR] = ACTIONS(927),
    [anon_sym_STAR_PERCENT] = ACTIONS(927),
    [anon_sym_STAR_PIPE] = ACTIONS(927),
    [anon_sym_QMARK] = ACTIONS(927),
    [anon_sym_DOT_STAR] = ACTIONS(939),
    [anon_sym_DOT_QMARK] = ACTIONS(939),
    [anon_sym_struct] = ACTIONS(929),
    [anon_sym_opaque] = ACTIONS(929),
    [anon_sym_enum] = ACTIONS(929),
    [anon_sym_union] = ACTIONS(929),
    [sym_doc_comment] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(927),
    [aux_sym_FLOAT_token1] = ACTIONS(927),
    [aux_sym_FLOAT_token2] = ACTIONS(927),
    [aux_sym_FLOAT_token3] = ACTIONS(927),
    [aux_sym_FLOAT_token4] = ACTIONS(927),
    [aux_sym_INTEGER_token1] = ACTIONS(927),
    [aux_sym_INTEGER_token2] = ACTIONS(927),
    [aux_sym_INTEGER_token3] = ACTIONS(929),
    [aux_sym_INTEGER_token4] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(927),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(927),
  },
  [377] = {
    [sym_FieldOrFnCall] = STATE(379),
    [sym_SuffixOp] = STATE(379),
    [sym_FnCallArguments] = STATE(379),
    [aux_sym_SuffixExpr_repeat1] = STATE(379),
    [ts_builtin_sym_end] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(941),
    [anon_sym_pub] = ACTIONS(943),
    [anon_sym_test] = ACTIONS(943),
    [anon_sym_comptime] = ACTIONS(943),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_extern] = ACTIONS(943),
    [anon_sym_inline] = ACTIONS(943),
    [anon_sym_noinline] = ACTIONS(943),
    [anon_sym_threadlocal] = ACTIONS(943),
    [anon_sym_usingnamespace] = ACTIONS(943),
    [anon_sym_fn] = ACTIONS(943),
    [anon_sym_BANG] = ACTIONS(943),
    [anon_sym_const] = ACTIONS(943),
    [anon_sym_var] = ACTIONS(943),
    [anon_sym_COLON] = ACTIONS(931),
    [anon_sym_else] = ACTIONS(943),
    [anon_sym_or] = ACTIONS(943),
    [anon_sym_and] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(941),
    [anon_sym_RBRACE] = ACTIONS(941),
    [anon_sym_async] = ACTIONS(943),
    [anon_sym_DOT] = ACTIONS(933),
    [anon_sym_error] = ACTIONS(943),
    [anon_sym_false] = ACTIONS(943),
    [anon_sym_null] = ACTIONS(943),
    [anon_sym_anyframe] = ACTIONS(943),
    [anon_sym_true] = ACTIONS(943),
    [anon_sym_undefined] = ACTIONS(943),
    [anon_sym_unreachable] = ACTIONS(943),
    [sym_BuildinTypeExpr] = ACTIONS(943),
    [anon_sym_packed] = ACTIONS(943),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_switch] = ACTIONS(943),
    [anon_sym_LBRACK] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_while] = ACTIONS(943),
    [anon_sym_for] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(943),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(943),
    [anon_sym_GT] = ACTIONS(943),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_orelse] = ACTIONS(943),
    [anon_sym_catch] = ACTIONS(943),
    [anon_sym_LT_LT] = ACTIONS(943),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT_PIPE] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(943),
    [anon_sym_DASH] = ACTIONS(943),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_PLUS_PERCENT] = ACTIONS(941),
    [anon_sym_DASH_PERCENT] = ACTIONS(941),
    [anon_sym_PLUS_PIPE] = ACTIONS(941),
    [anon_sym_DASH_PIPE] = ACTIONS(941),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(943),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(941),
    [anon_sym_STAR_PERCENT] = ACTIONS(941),
    [anon_sym_STAR_PIPE] = ACTIONS(941),
    [anon_sym_QMARK] = ACTIONS(941),
    [anon_sym_DOT_STAR] = ACTIONS(939),
    [anon_sym_DOT_QMARK] = ACTIONS(939),
    [anon_sym_struct] = ACTIONS(943),
    [anon_sym_opaque] = ACTIONS(943),
    [anon_sym_enum] = ACTIONS(943),
    [anon_sym_union] = ACTIONS(943),
    [sym_doc_comment] = ACTIONS(941),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(941),
    [aux_sym_FLOAT_token1] = ACTIONS(941),
    [aux_sym_FLOAT_token2] = ACTIONS(941),
    [aux_sym_FLOAT_token3] = ACTIONS(941),
    [aux_sym_FLOAT_token4] = ACTIONS(941),
    [aux_sym_INTEGER_token1] = ACTIONS(941),
    [aux_sym_INTEGER_token2] = ACTIONS(941),
    [aux_sym_INTEGER_token3] = ACTIONS(943),
    [aux_sym_INTEGER_token4] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(941),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(941),
  },
  [378] = {
    [sym_FieldOrFnCall] = STATE(393),
    [sym_SuffixOp] = STATE(393),
    [sym_FnCallArguments] = STATE(393),
    [aux_sym_SuffixExpr_repeat1] = STATE(393),
    [ts_builtin_sym_end] = ACTIONS(927),
    [anon_sym_COMMA] = ACTIONS(927),
    [anon_sym_pub] = ACTIONS(929),
    [anon_sym_test] = ACTIONS(929),
    [anon_sym_comptime] = ACTIONS(929),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_extern] = ACTIONS(929),
    [anon_sym_inline] = ACTIONS(929),
    [anon_sym_noinline] = ACTIONS(929),
    [anon_sym_threadlocal] = ACTIONS(929),
    [anon_sym_usingnamespace] = ACTIONS(929),
    [anon_sym_fn] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_const] = ACTIONS(929),
    [anon_sym_var] = ACTIONS(929),
    [anon_sym_COLON] = ACTIONS(931),
    [anon_sym_or] = ACTIONS(929),
    [anon_sym_and] = ACTIONS(929),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_RBRACE] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_error] = ACTIONS(929),
    [anon_sym_false] = ACTIONS(929),
    [anon_sym_null] = ACTIONS(929),
    [anon_sym_anyframe] = ACTIONS(929),
    [anon_sym_true] = ACTIONS(929),
    [anon_sym_undefined] = ACTIONS(929),
    [anon_sym_unreachable] = ACTIONS(929),
    [sym_BuildinTypeExpr] = ACTIONS(929),
    [anon_sym_packed] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(947),
    [anon_sym_switch] = ACTIONS(929),
    [anon_sym_LBRACK] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(929),
    [anon_sym_while] = ACTIONS(929),
    [anon_sym_for] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_EQ_EQ] = ACTIONS(927),
    [anon_sym_BANG_EQ] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_LT_EQ] = ACTIONS(927),
    [anon_sym_GT_EQ] = ACTIONS(927),
    [anon_sym_AMP] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(927),
    [anon_sym_orelse] = ACTIONS(929),
    [anon_sym_catch] = ACTIONS(929),
    [anon_sym_LT_LT] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_LT_LT_PIPE] = ACTIONS(927),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_PLUS_PERCENT] = ACTIONS(927),
    [anon_sym_DASH_PERCENT] = ACTIONS(927),
    [anon_sym_PLUS_PIPE] = ACTIONS(927),
    [anon_sym_DASH_PIPE] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_PERCENT] = ACTIONS(927),
    [anon_sym_STAR_STAR] = ACTIONS(927),
    [anon_sym_STAR_PERCENT] = ACTIONS(927),
    [anon_sym_STAR_PIPE] = ACTIONS(927),
    [anon_sym_QMARK] = ACTIONS(927),
    [anon_sym_DOT_STAR] = ACTIONS(951),
    [anon_sym_DOT_QMARK] = ACTIONS(951),
    [anon_sym_struct] = ACTIONS(929),
    [anon_sym_opaque] = ACTIONS(929),
    [anon_sym_enum] = ACTIONS(929),
    [anon_sym_union] = ACTIONS(929),
    [sym_doc_comment] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(927),
    [aux_sym_FLOAT_token1] = ACTIONS(927),
    [aux_sym_FLOAT_token2] = ACTIONS(927),
    [aux_sym_FLOAT_token3] = ACTIONS(927),
    [aux_sym_FLOAT_token4] = ACTIONS(927),
    [aux_sym_INTEGER_token1] = ACTIONS(927),
    [aux_sym_INTEGER_token2] = ACTIONS(927),
    [aux_sym_INTEGER_token3] = ACTIONS(929),
    [aux_sym_INTEGER_token4] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(927),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(927),
  },
  [379] = {
    [sym_FieldOrFnCall] = STATE(381),
    [sym_SuffixOp] = STATE(381),
    [sym_FnCallArguments] = STATE(381),
    [aux_sym_SuffixExpr_repeat1] = STATE(381),
    [ts_builtin_sym_end] = ACTIONS(953),
    [anon_sym_COMMA] = ACTIONS(953),
    [anon_sym_pub] = ACTIONS(955),
    [anon_sym_test] = ACTIONS(955),
    [anon_sym_comptime] = ACTIONS(955),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_extern] = ACTIONS(955),
    [anon_sym_inline] = ACTIONS(955),
    [anon_sym_noinline] = ACTIONS(955),
    [anon_sym_threadlocal] = ACTIONS(955),
    [anon_sym_usingnamespace] = ACTIONS(955),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_BANG] = ACTIONS(955),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_var] = ACTIONS(955),
    [anon_sym_else] = ACTIONS(955),
    [anon_sym_or] = ACTIONS(955),
    [anon_sym_and] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(953),
    [anon_sym_RBRACE] = ACTIONS(953),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_DOT] = ACTIONS(933),
    [anon_sym_error] = ACTIONS(955),
    [anon_sym_false] = ACTIONS(955),
    [anon_sym_null] = ACTIONS(955),
    [anon_sym_anyframe] = ACTIONS(955),
    [anon_sym_true] = ACTIONS(955),
    [anon_sym_undefined] = ACTIONS(955),
    [anon_sym_unreachable] = ACTIONS(955),
    [sym_BuildinTypeExpr] = ACTIONS(955),
    [anon_sym_packed] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_switch] = ACTIONS(955),
    [anon_sym_LBRACK] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(955),
    [anon_sym_while] = ACTIONS(955),
    [anon_sym_for] = ACTIONS(955),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_STAR] = ACTIONS(955),
    [anon_sym_EQ_EQ] = ACTIONS(953),
    [anon_sym_BANG_EQ] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_GT] = ACTIONS(955),
    [anon_sym_LT_EQ] = ACTIONS(953),
    [anon_sym_GT_EQ] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(953),
    [anon_sym_orelse] = ACTIONS(955),
    [anon_sym_catch] = ACTIONS(955),
    [anon_sym_LT_LT] = ACTIONS(955),
    [anon_sym_GT_GT] = ACTIONS(953),
    [anon_sym_LT_LT_PIPE] = ACTIONS(953),
    [anon_sym_PLUS] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(955),
    [anon_sym_PLUS_PLUS] = ACTIONS(953),
    [anon_sym_PLUS_PERCENT] = ACTIONS(953),
    [anon_sym_DASH_PERCENT] = ACTIONS(953),
    [anon_sym_PLUS_PIPE] = ACTIONS(953),
    [anon_sym_DASH_PIPE] = ACTIONS(953),
    [anon_sym_PIPE_PIPE] = ACTIONS(953),
    [anon_sym_SLASH] = ACTIONS(955),
    [anon_sym_PERCENT] = ACTIONS(953),
    [anon_sym_STAR_STAR] = ACTIONS(953),
    [anon_sym_STAR_PERCENT] = ACTIONS(953),
    [anon_sym_STAR_PIPE] = ACTIONS(953),
    [anon_sym_QMARK] = ACTIONS(953),
    [anon_sym_DOT_STAR] = ACTIONS(939),
    [anon_sym_DOT_QMARK] = ACTIONS(939),
    [anon_sym_struct] = ACTIONS(955),
    [anon_sym_opaque] = ACTIONS(955),
    [anon_sym_enum] = ACTIONS(955),
    [anon_sym_union] = ACTIONS(955),
    [sym_doc_comment] = ACTIONS(953),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(953),
    [aux_sym_FLOAT_token1] = ACTIONS(953),
    [aux_sym_FLOAT_token2] = ACTIONS(953),
    [aux_sym_FLOAT_token3] = ACTIONS(953),
    [aux_sym_FLOAT_token4] = ACTIONS(953),
    [aux_sym_INTEGER_token1] = ACTIONS(953),
    [aux_sym_INTEGER_token2] = ACTIONS(953),
    [aux_sym_INTEGER_token3] = ACTIONS(955),
    [aux_sym_INTEGER_token4] = ACTIONS(955),
    [anon_sym_DQUOTE] = ACTIONS(953),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(953),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(955),
    [anon_sym_AT] = ACTIONS(953),
  },
  [380] = {
    [sym_FieldOrFnCall] = STATE(391),
    [sym_SuffixOp] = STATE(391),
    [sym_FnCallArguments] = STATE(391),
    [aux_sym_SuffixExpr_repeat1] = STATE(391),
    [ts_builtin_sym_end] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(941),
    [anon_sym_pub] = ACTIONS(943),
    [anon_sym_test] = ACTIONS(943),
    [anon_sym_comptime] = ACTIONS(943),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_extern] = ACTIONS(943),
    [anon_sym_inline] = ACTIONS(943),
    [anon_sym_noinline] = ACTIONS(943),
    [anon_sym_threadlocal] = ACTIONS(943),
    [anon_sym_usingnamespace] = ACTIONS(943),
    [anon_sym_fn] = ACTIONS(943),
    [anon_sym_BANG] = ACTIONS(943),
    [anon_sym_const] = ACTIONS(943),
    [anon_sym_var] = ACTIONS(943),
    [anon_sym_COLON] = ACTIONS(931),
    [anon_sym_or] = ACTIONS(943),
    [anon_sym_and] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(941),
    [anon_sym_RBRACE] = ACTIONS(941),
    [anon_sym_async] = ACTIONS(943),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_error] = ACTIONS(943),
    [anon_sym_false] = ACTIONS(943),
    [anon_sym_null] = ACTIONS(943),
    [anon_sym_anyframe] = ACTIONS(943),
    [anon_sym_true] = ACTIONS(943),
    [anon_sym_undefined] = ACTIONS(943),
    [anon_sym_unreachable] = ACTIONS(943),
    [sym_BuildinTypeExpr] = ACTIONS(943),
    [anon_sym_packed] = ACTIONS(943),
    [anon_sym_LPAREN] = ACTIONS(947),
    [anon_sym_switch] = ACTIONS(943),
    [anon_sym_LBRACK] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_while] = ACTIONS(943),
    [anon_sym_for] = ACTIONS(943),
    [anon_sym_PIPE] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(943),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(943),
    [anon_sym_GT] = ACTIONS(943),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_orelse] = ACTIONS(943),
    [anon_sym_catch] = ACTIONS(943),
    [anon_sym_LT_LT] = ACTIONS(943),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_LT_LT_PIPE] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(943),
    [anon_sym_DASH] = ACTIONS(943),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_PLUS_PERCENT] = ACTIONS(941),
    [anon_sym_DASH_PERCENT] = ACTIONS(941),
    [anon_sym_PLUS_PIPE] = ACTIONS(941),
    [anon_sym_DASH_PIPE] = ACTIONS(941),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(943),
    [anon_sym_PERCENT] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(941),
    [anon_sym_STAR_PERCENT] = ACTIONS(941),
    [anon_sym_STAR_PIPE] = ACTIONS(941),
    [anon_sym_QMARK] = ACTIONS(941),
    [anon_sym_DOT_STAR] = ACTIONS(951),
    [anon_sym_DOT_QMARK] = ACTIONS(951),
    [anon_sym_struct] = ACTIONS(943),
    [anon_sym_opaque] = ACTIONS(943),
    [anon_sym_enum] = ACTIONS(943),
    [anon_sym_union] = ACTIONS(943),
    [sym_doc_comment] = ACTIONS(941),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(941),
    [aux_sym_FLOAT_token1] = ACTIONS(941),
    [aux_sym_FLOAT_token2] = ACTIONS(941),
    [aux_sym_FLOAT_token3] = ACTIONS(941),
    [aux_sym_FLOAT_token4] = ACTIONS(941),
    [aux_sym_INTEGER_token1] = ACTIONS(941),
    [aux_sym_INTEGER_token2] = ACTIONS(941),
    [aux_sym_INTEGER_token3] = ACTIONS(943),
    [aux_sym_INTEGER_token4] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(941),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(941),
  },
  [381] = {
    [sym_FieldOrFnCall] = STATE(381),
    [sym_SuffixOp] = STATE(381),
    [sym_FnCallArguments] = STATE(381),
    [aux_sym_SuffixExpr_repeat1] = STATE(381),
    [ts_builtin_sym_end] = ACTIONS(957),
    [anon_sym_COMMA] = ACTIONS(957),
    [anon_sym_pub] = ACTIONS(959),
    [anon_sym_test] = ACTIONS(959),
    [anon_sym_comptime] = ACTIONS(959),
    [anon_sym_export] = ACTIONS(959),
    [anon_sym_extern] = ACTIONS(959),
    [anon_sym_inline] = ACTIONS(959),
    [anon_sym_noinline] = ACTIONS(959),
    [anon_sym_threadlocal] = ACTIONS(959),
    [anon_sym_usingnamespace] = ACTIONS(959),
    [anon_sym_fn] = ACTIONS(959),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_var] = ACTIONS(959),
    [anon_sym_else] = ACTIONS(959),
    [anon_sym_or] = ACTIONS(959),
    [anon_sym_and] = ACTIONS(959),
    [anon_sym_LBRACE] = ACTIONS(957),
    [anon_sym_RBRACE] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_DOT] = ACTIONS(961),
    [anon_sym_error] = ACTIONS(959),
    [anon_sym_false] = ACTIONS(959),
    [anon_sym_null] = ACTIONS(959),
    [anon_sym_anyframe] = ACTIONS(959),
    [anon_sym_true] = ACTIONS(959),
    [anon_sym_undefined] = ACTIONS(959),
    [anon_sym_unreachable] = ACTIONS(959),
    [sym_BuildinTypeExpr] = ACTIONS(959),
    [anon_sym_packed] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(964),
    [anon_sym_switch] = ACTIONS(959),
    [anon_sym_LBRACK] = ACTIONS(967),
    [anon_sym_if] = ACTIONS(959),
    [anon_sym_while] = ACTIONS(959),
    [anon_sym_for] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(957),
    [anon_sym_BANG_EQ] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_LT_EQ] = ACTIONS(957),
    [anon_sym_GT_EQ] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_orelse] = ACTIONS(959),
    [anon_sym_catch] = ACTIONS(959),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_LT_LT_PIPE] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(959),
    [anon_sym_DASH] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(957),
    [anon_sym_PLUS_PERCENT] = ACTIONS(957),
    [anon_sym_DASH_PERCENT] = ACTIONS(957),
    [anon_sym_PLUS_PIPE] = ACTIONS(957),
    [anon_sym_DASH_PIPE] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_SLASH] = ACTIONS(959),
    [anon_sym_PERCENT] = ACTIONS(957),
    [anon_sym_STAR_STAR] = ACTIONS(957),
    [anon_sym_STAR_PERCENT] = ACTIONS(957),
    [anon_sym_STAR_PIPE] = ACTIONS(957),
    [anon_sym_QMARK] = ACTIONS(957),
    [anon_sym_DOT_STAR] = ACTIONS(970),
    [anon_sym_DOT_QMARK] = ACTIONS(970),
    [anon_sym_struct] = ACTIONS(959),
    [anon_sym_opaque] = ACTIONS(959),
    [anon_sym_enum] = ACTIONS(959),
    [anon_sym_union] = ACTIONS(959),
    [sym_doc_comment] = ACTIONS(957),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(957),
    [aux_sym_FLOAT_token1] = ACTIONS(957),
    [aux_sym_FLOAT_token2] = ACTIONS(957),
    [aux_sym_FLOAT_token3] = ACTIONS(957),
    [aux_sym_FLOAT_token4] = ACTIONS(957),
    [aux_sym_INTEGER_token1] = ACTIONS(957),
    [aux_sym_INTEGER_token2] = ACTIONS(957),
    [aux_sym_INTEGER_token3] = ACTIONS(959),
    [aux_sym_INTEGER_token4] = ACTIONS(959),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(957),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(959),
    [anon_sym_AT] = ACTIONS(957),
  },
  [382] = {
    [sym_FieldOrFnCall] = STATE(381),
    [sym_SuffixOp] = STATE(381),
    [sym_FnCallArguments] = STATE(381),
    [aux_sym_SuffixExpr_repeat1] = STATE(381),
    [ts_builtin_sym_end] = ACTIONS(973),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_pub] = ACTIONS(975),
    [anon_sym_test] = ACTIONS(975),
    [anon_sym_comptime] = ACTIONS(975),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_extern] = ACTIONS(975),
    [anon_sym_inline] = ACTIONS(975),
    [anon_sym_noinline] = ACTIONS(975),
    [anon_sym_threadlocal] = ACTIONS(975),
    [anon_sym_usingnamespace] = ACTIONS(975),
    [anon_sym_fn] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_const] = ACTIONS(975),
    [anon_sym_var] = ACTIONS(975),
    [anon_sym_else] = ACTIONS(975),
    [anon_sym_or] = ACTIONS(975),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(975),
    [anon_sym_DOT] = ACTIONS(933),
    [anon_sym_error] = ACTIONS(975),
    [anon_sym_false] = ACTIONS(975),
    [anon_sym_null] = ACTIONS(975),
    [anon_sym_anyframe] = ACTIONS(975),
    [anon_sym_true] = ACTIONS(975),
    [anon_sym_undefined] = ACTIONS(975),
    [anon_sym_unreachable] = ACTIONS(975),
    [sym_BuildinTypeExpr] = ACTIONS(975),
    [anon_sym_packed] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_switch] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(975),
    [anon_sym_while] = ACTIONS(975),
    [anon_sym_for] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(975),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_EQ_EQ] = ACTIONS(973),
    [anon_sym_BANG_EQ] = ACTIONS(973),
    [anon_sym_LT] = ACTIONS(975),
    [anon_sym_GT] = ACTIONS(975),
    [anon_sym_LT_EQ] = ACTIONS(973),
    [anon_sym_GT_EQ] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(973),
    [anon_sym_CARET] = ACTIONS(973),
    [anon_sym_orelse] = ACTIONS(975),
    [anon_sym_catch] = ACTIONS(975),
    [anon_sym_LT_LT] = ACTIONS(975),
    [anon_sym_GT_GT] = ACTIONS(973),
    [anon_sym_LT_LT_PIPE] = ACTIONS(973),
    [anon_sym_PLUS] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_PLUS_PLUS] = ACTIONS(973),
    [anon_sym_PLUS_PERCENT] = ACTIONS(973),
    [anon_sym_DASH_PERCENT] = ACTIONS(973),
    [anon_sym_PLUS_PIPE] = ACTIONS(973),
    [anon_sym_DASH_PIPE] = ACTIONS(973),
    [anon_sym_PIPE_PIPE] = ACTIONS(973),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_STAR_STAR] = ACTIONS(973),
    [anon_sym_STAR_PERCENT] = ACTIONS(973),
    [anon_sym_STAR_PIPE] = ACTIONS(973),
    [anon_sym_QMARK] = ACTIONS(973),
    [anon_sym_DOT_STAR] = ACTIONS(939),
    [anon_sym_DOT_QMARK] = ACTIONS(939),
    [anon_sym_struct] = ACTIONS(975),
    [anon_sym_opaque] = ACTIONS(975),
    [anon_sym_enum] = ACTIONS(975),
    [anon_sym_union] = ACTIONS(975),
    [sym_doc_comment] = ACTIONS(973),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [aux_sym_FLOAT_token1] = ACTIONS(973),
    [aux_sym_FLOAT_token2] = ACTIONS(973),
    [aux_sym_FLOAT_token3] = ACTIONS(973),
    [aux_sym_FLOAT_token4] = ACTIONS(973),
    [aux_sym_INTEGER_token1] = ACTIONS(973),
    [aux_sym_INTEGER_token2] = ACTIONS(973),
    [aux_sym_INTEGER_token3] = ACTIONS(975),
    [aux_sym_INTEGER_token4] = ACTIONS(975),
    [anon_sym_DQUOTE] = ACTIONS(973),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(973),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(975),
    [anon_sym_AT] = ACTIONS(973),
  },
  [383] = {
    [sym_FieldOrFnCall] = STATE(381),
    [sym_SuffixOp] = STATE(381),
    [sym_FnCallArguments] = STATE(381),
    [aux_sym_SuffixExpr_repeat1] = STATE(381),
    [ts_builtin_sym_end] = ACTIONS(977),
    [anon_sym_COMMA] = ACTIONS(977),
    [anon_sym_pub] = ACTIONS(979),
    [anon_sym_test] = ACTIONS(979),
    [anon_sym_comptime] = ACTIONS(979),
    [anon_sym_export] = ACTIONS(979),
    [anon_sym_extern] = ACTIONS(979),
    [anon_sym_inline] = ACTIONS(979),
    [anon_sym_noinline] = ACTIONS(979),
    [anon_sym_threadlocal] = ACTIONS(979),
    [anon_sym_usingnamespace] = ACTIONS(979),
    [anon_sym_fn] = ACTIONS(979),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_const] = ACTIONS(979),
    [anon_sym_var] = ACTIONS(979),
    [anon_sym_else] = ACTIONS(979),
    [anon_sym_or] = ACTIONS(979),
    [anon_sym_and] = ACTIONS(979),
    [anon_sym_LBRACE] = ACTIONS(977),
    [anon_sym_RBRACE] = ACTIONS(977),
    [anon_sym_async] = ACTIONS(979),
    [anon_sym_DOT] = ACTIONS(933),
    [anon_sym_error] = ACTIONS(979),
    [anon_sym_false] = ACTIONS(979),
    [anon_sym_null] = ACTIONS(979),
    [anon_sym_anyframe] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(979),
    [anon_sym_undefined] = ACTIONS(979),
    [anon_sym_unreachable] = ACTIONS(979),
    [sym_BuildinTypeExpr] = ACTIONS(979),
    [anon_sym_packed] = ACTIONS(979),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_switch] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(979),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(979),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_EQ_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(979),
    [anon_sym_LT_EQ] = ACTIONS(977),
    [anon_sym_GT_EQ] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(977),
    [anon_sym_orelse] = ACTIONS(979),
    [anon_sym_catch] = ACTIONS(979),
    [anon_sym_LT_LT] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_LT_LT_PIPE] = ACTIONS(977),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(977),
    [anon_sym_PLUS_PERCENT] = ACTIONS(977),
    [anon_sym_DASH_PERCENT] = ACTIONS(977),
    [anon_sym_PLUS_PIPE] = ACTIONS(977),
    [anon_sym_DASH_PIPE] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(977),
    [anon_sym_STAR_PERCENT] = ACTIONS(977),
    [anon_sym_STAR_PIPE] = ACTIONS(977),
    [anon_sym_QMARK] = ACTIONS(977),
    [anon_sym_DOT_STAR] = ACTIONS(939),
    [anon_sym_DOT_QMARK] = ACTIONS(939),
    [anon_sym_struct] = ACTIONS(979),
    [anon_sym_opaque] = ACTIONS(979),
    [anon_sym_enum] = ACTIONS(979),
    [anon_sym_union] = ACTIONS(979),
    [sym_doc_comment] = ACTIONS(977),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(977),
    [aux_sym_FLOAT_token1] = ACTIONS(977),
    [aux_sym_FLOAT_token2] = ACTIONS(977),
    [aux_sym_FLOAT_token3] = ACTIONS(977),
    [aux_sym_FLOAT_token4] = ACTIONS(977),
    [aux_sym_INTEGER_token1] = ACTIONS(977),
    [aux_sym_INTEGER_token2] = ACTIONS(977),
    [aux_sym_INTEGER_token3] = ACTIONS(979),
    [aux_sym_INTEGER_token4] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(977),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(979),
    [anon_sym_AT] = ACTIONS(977),
  },
  [384] = {
    [sym_FieldOrFnCall] = STATE(386),
    [sym_SuffixOp] = STATE(386),
    [sym_FnCallArguments] = STATE(386),
    [aux_sym_SuffixExpr_repeat1] = STATE(386),
    [ts_builtin_sym_end] = ACTIONS(981),
    [anon_sym_COMMA] = ACTIONS(981),
    [anon_sym_pub] = ACTIONS(983),
    [anon_sym_test] = ACTIONS(983),
    [anon_sym_comptime] = ACTIONS(983),
    [anon_sym_export] = ACTIONS(983),
    [anon_sym_extern] = ACTIONS(983),
    [anon_sym_inline] = ACTIONS(983),
    [anon_sym_noinline] = ACTIONS(983),
    [anon_sym_threadlocal] = ACTIONS(983),
    [anon_sym_usingnamespace] = ACTIONS(983),
    [anon_sym_fn] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(983),
    [anon_sym_const] = ACTIONS(983),
    [anon_sym_var] = ACTIONS(983),
    [anon_sym_else] = ACTIONS(983),
    [anon_sym_or] = ACTIONS(983),
    [anon_sym_and] = ACTIONS(983),
    [anon_sym_LBRACE] = ACTIONS(981),
    [anon_sym_RBRACE] = ACTIONS(981),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_DOT] = ACTIONS(933),
    [anon_sym_error] = ACTIONS(983),
    [anon_sym_false] = ACTIONS(983),
    [anon_sym_null] = ACTIONS(983),
    [anon_sym_anyframe] = ACTIONS(983),
    [anon_sym_true] = ACTIONS(983),
    [anon_sym_undefined] = ACTIONS(983),
    [anon_sym_unreachable] = ACTIONS(983),
    [sym_BuildinTypeExpr] = ACTIONS(983),
    [anon_sym_packed] = ACTIONS(983),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_switch] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(983),
    [anon_sym_while] = ACTIONS(983),
    [anon_sym_for] = ACTIONS(983),
    [anon_sym_PIPE] = ACTIONS(983),
    [anon_sym_STAR] = ACTIONS(983),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_EQ] = ACTIONS(981),
    [anon_sym_LT] = ACTIONS(983),
    [anon_sym_GT] = ACTIONS(983),
    [anon_sym_LT_EQ] = ACTIONS(981),
    [anon_sym_GT_EQ] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(981),
    [anon_sym_CARET] = ACTIONS(981),
    [anon_sym_orelse] = ACTIONS(983),
    [anon_sym_catch] = ACTIONS(983),
    [anon_sym_LT_LT] = ACTIONS(983),
    [anon_sym_GT_GT] = ACTIONS(981),
    [anon_sym_LT_LT_PIPE] = ACTIONS(981),
    [anon_sym_PLUS] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(983),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_PLUS_PERCENT] = ACTIONS(981),
    [anon_sym_DASH_PERCENT] = ACTIONS(981),
    [anon_sym_PLUS_PIPE] = ACTIONS(981),
    [anon_sym_DASH_PIPE] = ACTIONS(981),
    [anon_sym_PIPE_PIPE] = ACTIONS(981),
    [anon_sym_SLASH] = ACTIONS(983),
    [anon_sym_PERCENT] = ACTIONS(981),
    [anon_sym_STAR_STAR] = ACTIONS(981),
    [anon_sym_STAR_PERCENT] = ACTIONS(981),
    [anon_sym_STAR_PIPE] = ACTIONS(981),
    [anon_sym_QMARK] = ACTIONS(981),
    [anon_sym_DOT_STAR] = ACTIONS(939),
    [anon_sym_DOT_QMARK] = ACTIONS(939),
    [anon_sym_struct] = ACTIONS(983),
    [anon_sym_opaque] = ACTIONS(983),
    [anon_sym_enum] = ACTIONS(983),
    [anon_sym_union] = ACTIONS(983),
    [sym_doc_comment] = ACTIONS(981),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(981),
    [aux_sym_FLOAT_token1] = ACTIONS(981),
    [aux_sym_FLOAT_token2] = ACTIONS(981),
    [aux_sym_FLOAT_token3] = ACTIONS(981),
    [aux_sym_FLOAT_token4] = ACTIONS(981),
    [aux_sym_INTEGER_token1] = ACTIONS(981),
    [aux_sym_INTEGER_token2] = ACTIONS(981),
    [aux_sym_INTEGER_token3] = ACTIONS(983),
    [aux_sym_INTEGER_token4] = ACTIONS(983),
    [anon_sym_DQUOTE] = ACTIONS(981),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(981),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(981),
  },
  [385] = {
    [sym_FieldOrFnCall] = STATE(383),
    [sym_SuffixOp] = STATE(383),
    [sym_FnCallArguments] = STATE(383),
    [aux_sym_SuffixExpr_repeat1] = STATE(383),
    [ts_builtin_sym_end] = ACTIONS(985),
    [anon_sym_COMMA] = ACTIONS(985),
    [anon_sym_pub] = ACTIONS(987),
    [anon_sym_test] = ACTIONS(987),
    [anon_sym_comptime] = ACTIONS(987),
    [anon_sym_export] = ACTIONS(987),
    [anon_sym_extern] = ACTIONS(987),
    [anon_sym_inline] = ACTIONS(987),
    [anon_sym_noinline] = ACTIONS(987),
    [anon_sym_threadlocal] = ACTIONS(987),
    [anon_sym_usingnamespace] = ACTIONS(987),
    [anon_sym_fn] = ACTIONS(987),
    [anon_sym_BANG] = ACTIONS(987),
    [anon_sym_const] = ACTIONS(987),
    [anon_sym_var] = ACTIONS(987),
    [anon_sym_else] = ACTIONS(987),
    [anon_sym_or] = ACTIONS(987),
    [anon_sym_and] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(985),
    [anon_sym_RBRACE] = ACTIONS(985),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_DOT] = ACTIONS(933),
    [anon_sym_error] = ACTIONS(987),
    [anon_sym_false] = ACTIONS(987),
    [anon_sym_null] = ACTIONS(987),
    [anon_sym_anyframe] = ACTIONS(987),
    [anon_sym_true] = ACTIONS(987),
    [anon_sym_undefined] = ACTIONS(987),
    [anon_sym_unreachable] = ACTIONS(987),
    [sym_BuildinTypeExpr] = ACTIONS(987),
    [anon_sym_packed] = ACTIONS(987),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_switch] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(987),
    [anon_sym_while] = ACTIONS(987),
    [anon_sym_for] = ACTIONS(987),
    [anon_sym_PIPE] = ACTIONS(987),
    [anon_sym_STAR] = ACTIONS(987),
    [anon_sym_EQ_EQ] = ACTIONS(985),
    [anon_sym_BANG_EQ] = ACTIONS(985),
    [anon_sym_LT] = ACTIONS(987),
    [anon_sym_GT] = ACTIONS(987),
    [anon_sym_LT_EQ] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_CARET] = ACTIONS(985),
    [anon_sym_orelse] = ACTIONS(987),
    [anon_sym_catch] = ACTIONS(987),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_GT_GT] = ACTIONS(985),
    [anon_sym_LT_LT_PIPE] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(987),
    [anon_sym_DASH] = ACTIONS(987),
    [anon_sym_PLUS_PLUS] = ACTIONS(985),
    [anon_sym_PLUS_PERCENT] = ACTIONS(985),
    [anon_sym_DASH_PERCENT] = ACTIONS(985),
    [anon_sym_PLUS_PIPE] = ACTIONS(985),
    [anon_sym_DASH_PIPE] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [anon_sym_SLASH] = ACTIONS(987),
    [anon_sym_PERCENT] = ACTIONS(985),
    [anon_sym_STAR_STAR] = ACTIONS(985),
    [anon_sym_STAR_PERCENT] = ACTIONS(985),
    [anon_sym_STAR_PIPE] = ACTIONS(985),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_DOT_STAR] = ACTIONS(939),
    [anon_sym_DOT_QMARK] = ACTIONS(939),
    [anon_sym_struct] = ACTIONS(987),
    [anon_sym_opaque] = ACTIONS(987),
    [anon_sym_enum] = ACTIONS(987),
    [anon_sym_union] = ACTIONS(987),
    [sym_doc_comment] = ACTIONS(985),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(985),
    [aux_sym_FLOAT_token1] = ACTIONS(985),
    [aux_sym_FLOAT_token2] = ACTIONS(985),
    [aux_sym_FLOAT_token3] = ACTIONS(985),
    [aux_sym_FLOAT_token4] = ACTIONS(985),
    [aux_sym_INTEGER_token1] = ACTIONS(985),
    [aux_sym_INTEGER_token2] = ACTIONS(985),
    [aux_sym_INTEGER_token3] = ACTIONS(987),
    [aux_sym_INTEGER_token4] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(985),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(985),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(987),
    [anon_sym_AT] = ACTIONS(985),
  },
  [386] = {
    [sym_FieldOrFnCall] = STATE(381),
    [sym_SuffixOp] = STATE(381),
    [sym_FnCallArguments] = STATE(381),
    [aux_sym_SuffixExpr_repeat1] = STATE(381),
    [ts_builtin_sym_end] = ACTIONS(989),
    [anon_sym_COMMA] = ACTIONS(989),
    [anon_sym_pub] = ACTIONS(991),
    [anon_sym_test] = ACTIONS(991),
    [anon_sym_comptime] = ACTIONS(991),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_extern] = ACTIONS(991),
    [anon_sym_inline] = ACTIONS(991),
    [anon_sym_noinline] = ACTIONS(991),
    [anon_sym_threadlocal] = ACTIONS(991),
    [anon_sym_usingnamespace] = ACTIONS(991),
    [anon_sym_fn] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_const] = ACTIONS(991),
    [anon_sym_var] = ACTIONS(991),
    [anon_sym_else] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_RBRACE] = ACTIONS(989),
    [anon_sym_async] = ACTIONS(991),
    [anon_sym_DOT] = ACTIONS(933),
    [anon_sym_error] = ACTIONS(991),
    [anon_sym_false] = ACTIONS(991),
    [anon_sym_null] = ACTIONS(991),
    [anon_sym_anyframe] = ACTIONS(991),
    [anon_sym_true] = ACTIONS(991),
    [anon_sym_undefined] = ACTIONS(991),
    [anon_sym_unreachable] = ACTIONS(991),
    [sym_BuildinTypeExpr] = ACTIONS(991),
    [anon_sym_packed] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_switch] = ACTIONS(991),
    [anon_sym_LBRACK] = ACTIONS(937),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_while] = ACTIONS(991),
    [anon_sym_for] = ACTIONS(991),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(991),
    [anon_sym_EQ_EQ] = ACTIONS(989),
    [anon_sym_BANG_EQ] = ACTIONS(989),
    [anon_sym_LT] = ACTIONS(991),
    [anon_sym_GT] = ACTIONS(991),
    [anon_sym_LT_EQ] = ACTIONS(989),
    [anon_sym_GT_EQ] = ACTIONS(989),
    [anon_sym_AMP] = ACTIONS(989),
    [anon_sym_CARET] = ACTIONS(989),
    [anon_sym_orelse] = ACTIONS(991),
    [anon_sym_catch] = ACTIONS(991),
    [anon_sym_LT_LT] = ACTIONS(991),
    [anon_sym_GT_GT] = ACTIONS(989),
    [anon_sym_LT_LT_PIPE] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(989),
    [anon_sym_PLUS_PERCENT] = ACTIONS(989),
    [anon_sym_DASH_PERCENT] = ACTIONS(989),
    [anon_sym_PLUS_PIPE] = ACTIONS(989),
    [anon_sym_DASH_PIPE] = ACTIONS(989),
    [anon_sym_PIPE_PIPE] = ACTIONS(989),
    [anon_sym_SLASH] = ACTIONS(991),
    [anon_sym_PERCENT] = ACTIONS(989),
    [anon_sym_STAR_STAR] = ACTIONS(989),
    [anon_sym_STAR_PERCENT] = ACTIONS(989),
    [anon_sym_STAR_PIPE] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(989),
    [anon_sym_DOT_STAR] = ACTIONS(939),
    [anon_sym_DOT_QMARK] = ACTIONS(939),
    [anon_sym_struct] = ACTIONS(991),
    [anon_sym_opaque] = ACTIONS(991),
    [anon_sym_enum] = ACTIONS(991),
    [anon_sym_union] = ACTIONS(991),
    [sym_doc_comment] = ACTIONS(989),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(989),
    [aux_sym_FLOAT_token1] = ACTIONS(989),
    [aux_sym_FLOAT_token2] = ACTIONS(989),
    [aux_sym_FLOAT_token3] = ACTIONS(989),
    [aux_sym_FLOAT_token4] = ACTIONS(989),
    [aux_sym_INTEGER_token1] = ACTIONS(989),
    [aux_sym_INTEGER_token2] = ACTIONS(989),
    [aux_sym_INTEGER_token3] = ACTIONS(991),
    [aux_sym_INTEGER_token4] = ACTIONS(991),
    [anon_sym_DQUOTE] = ACTIONS(989),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(989),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(991),
    [anon_sym_AT] = ACTIONS(989),
  },
  [387] = {
    [sym_FieldOrFnCall] = STATE(392),
    [sym_SuffixOp] = STATE(392),
    [sym_FnCallArguments] = STATE(392),
    [aux_sym_SuffixExpr_repeat1] = STATE(392),
    [ts_builtin_sym_end] = ACTIONS(985),
    [anon_sym_COMMA] = ACTIONS(985),
    [anon_sym_pub] = ACTIONS(987),
    [anon_sym_test] = ACTIONS(987),
    [anon_sym_comptime] = ACTIONS(987),
    [anon_sym_export] = ACTIONS(987),
    [anon_sym_extern] = ACTIONS(987),
    [anon_sym_inline] = ACTIONS(987),
    [anon_sym_noinline] = ACTIONS(987),
    [anon_sym_threadlocal] = ACTIONS(987),
    [anon_sym_usingnamespace] = ACTIONS(987),
    [anon_sym_fn] = ACTIONS(987),
    [anon_sym_BANG] = ACTIONS(987),
    [anon_sym_const] = ACTIONS(987),
    [anon_sym_var] = ACTIONS(987),
    [anon_sym_or] = ACTIONS(987),
    [anon_sym_and] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(985),
    [anon_sym_RBRACE] = ACTIONS(985),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_error] = ACTIONS(987),
    [anon_sym_false] = ACTIONS(987),
    [anon_sym_null] = ACTIONS(987),
    [anon_sym_anyframe] = ACTIONS(987),
    [anon_sym_true] = ACTIONS(987),
    [anon_sym_undefined] = ACTIONS(987),
    [anon_sym_unreachable] = ACTIONS(987),
    [sym_BuildinTypeExpr] = ACTIONS(987),
    [anon_sym_packed] = ACTIONS(987),
    [anon_sym_LPAREN] = ACTIONS(947),
    [anon_sym_switch] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(987),
    [anon_sym_while] = ACTIONS(987),
    [anon_sym_for] = ACTIONS(987),
    [anon_sym_PIPE] = ACTIONS(987),
    [anon_sym_STAR] = ACTIONS(987),
    [anon_sym_EQ_EQ] = ACTIONS(985),
    [anon_sym_BANG_EQ] = ACTIONS(985),
    [anon_sym_LT] = ACTIONS(987),
    [anon_sym_GT] = ACTIONS(987),
    [anon_sym_LT_EQ] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(985),
    [anon_sym_CARET] = ACTIONS(985),
    [anon_sym_orelse] = ACTIONS(987),
    [anon_sym_catch] = ACTIONS(987),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_GT_GT] = ACTIONS(985),
    [anon_sym_LT_LT_PIPE] = ACTIONS(985),
    [anon_sym_PLUS] = ACTIONS(987),
    [anon_sym_DASH] = ACTIONS(987),
    [anon_sym_PLUS_PLUS] = ACTIONS(985),
    [anon_sym_PLUS_PERCENT] = ACTIONS(985),
    [anon_sym_DASH_PERCENT] = ACTIONS(985),
    [anon_sym_PLUS_PIPE] = ACTIONS(985),
    [anon_sym_DASH_PIPE] = ACTIONS(985),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [anon_sym_SLASH] = ACTIONS(987),
    [anon_sym_PERCENT] = ACTIONS(985),
    [anon_sym_STAR_STAR] = ACTIONS(985),
    [anon_sym_STAR_PERCENT] = ACTIONS(985),
    [anon_sym_STAR_PIPE] = ACTIONS(985),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_DOT_STAR] = ACTIONS(951),
    [anon_sym_DOT_QMARK] = ACTIONS(951),
    [anon_sym_struct] = ACTIONS(987),
    [anon_sym_opaque] = ACTIONS(987),
    [anon_sym_enum] = ACTIONS(987),
    [anon_sym_union] = ACTIONS(987),
    [sym_doc_comment] = ACTIONS(985),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(985),
    [aux_sym_FLOAT_token1] = ACTIONS(985),
    [aux_sym_FLOAT_token2] = ACTIONS(985),
    [aux_sym_FLOAT_token3] = ACTIONS(985),
    [aux_sym_FLOAT_token4] = ACTIONS(985),
    [aux_sym_INTEGER_token1] = ACTIONS(985),
    [aux_sym_INTEGER_token2] = ACTIONS(985),
    [aux_sym_INTEGER_token3] = ACTIONS(987),
    [aux_sym_INTEGER_token4] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(985),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(985),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(987),
    [anon_sym_AT] = ACTIONS(985),
  },
  [388] = {
    [sym_FieldOrFnCall] = STATE(388),
    [sym_SuffixOp] = STATE(388),
    [sym_FnCallArguments] = STATE(388),
    [aux_sym_SuffixExpr_repeat1] = STATE(388),
    [ts_builtin_sym_end] = ACTIONS(957),
    [anon_sym_COMMA] = ACTIONS(957),
    [anon_sym_pub] = ACTIONS(959),
    [anon_sym_test] = ACTIONS(959),
    [anon_sym_comptime] = ACTIONS(959),
    [anon_sym_export] = ACTIONS(959),
    [anon_sym_extern] = ACTIONS(959),
    [anon_sym_inline] = ACTIONS(959),
    [anon_sym_noinline] = ACTIONS(959),
    [anon_sym_threadlocal] = ACTIONS(959),
    [anon_sym_usingnamespace] = ACTIONS(959),
    [anon_sym_fn] = ACTIONS(959),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_var] = ACTIONS(959),
    [anon_sym_or] = ACTIONS(959),
    [anon_sym_and] = ACTIONS(959),
    [anon_sym_LBRACE] = ACTIONS(957),
    [anon_sym_RBRACE] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_DOT] = ACTIONS(993),
    [anon_sym_error] = ACTIONS(959),
    [anon_sym_false] = ACTIONS(959),
    [anon_sym_null] = ACTIONS(959),
    [anon_sym_anyframe] = ACTIONS(959),
    [anon_sym_true] = ACTIONS(959),
    [anon_sym_undefined] = ACTIONS(959),
    [anon_sym_unreachable] = ACTIONS(959),
    [sym_BuildinTypeExpr] = ACTIONS(959),
    [anon_sym_packed] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(996),
    [anon_sym_switch] = ACTIONS(959),
    [anon_sym_LBRACK] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(959),
    [anon_sym_while] = ACTIONS(959),
    [anon_sym_for] = ACTIONS(959),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_EQ_EQ] = ACTIONS(957),
    [anon_sym_BANG_EQ] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_LT_EQ] = ACTIONS(957),
    [anon_sym_GT_EQ] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(957),
    [anon_sym_CARET] = ACTIONS(957),
    [anon_sym_orelse] = ACTIONS(959),
    [anon_sym_catch] = ACTIONS(959),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(957),
    [anon_sym_LT_LT_PIPE] = ACTIONS(957),
    [anon_sym_PLUS] = ACTIONS(959),
    [anon_sym_DASH] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(957),
    [anon_sym_PLUS_PERCENT] = ACTIONS(957),
    [anon_sym_DASH_PERCENT] = ACTIONS(957),
    [anon_sym_PLUS_PIPE] = ACTIONS(957),
    [anon_sym_DASH_PIPE] = ACTIONS(957),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_SLASH] = ACTIONS(959),
    [anon_sym_PERCENT] = ACTIONS(957),
    [anon_sym_STAR_STAR] = ACTIONS(957),
    [anon_sym_STAR_PERCENT] = ACTIONS(957),
    [anon_sym_STAR_PIPE] = ACTIONS(957),
    [anon_sym_QMARK] = ACTIONS(957),
    [anon_sym_DOT_STAR] = ACTIONS(1002),
    [anon_sym_DOT_QMARK] = ACTIONS(1002),
    [anon_sym_struct] = ACTIONS(959),
    [anon_sym_opaque] = ACTIONS(959),
    [anon_sym_enum] = ACTIONS(959),
    [anon_sym_union] = ACTIONS(959),
    [sym_doc_comment] = ACTIONS(957),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(957),
    [aux_sym_FLOAT_token1] = ACTIONS(957),
    [aux_sym_FLOAT_token2] = ACTIONS(957),
    [aux_sym_FLOAT_token3] = ACTIONS(957),
    [aux_sym_FLOAT_token4] = ACTIONS(957),
    [aux_sym_INTEGER_token1] = ACTIONS(957),
    [aux_sym_INTEGER_token2] = ACTIONS(957),
    [aux_sym_INTEGER_token3] = ACTIONS(959),
    [aux_sym_INTEGER_token4] = ACTIONS(959),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(957),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(959),
    [anon_sym_AT] = ACTIONS(957),
  },
  [389] = {
    [sym_FieldOrFnCall] = STATE(390),
    [sym_SuffixOp] = STATE(390),
    [sym_FnCallArguments] = STATE(390),
    [aux_sym_SuffixExpr_repeat1] = STATE(390),
    [ts_builtin_sym_end] = ACTIONS(981),
    [anon_sym_COMMA] = ACTIONS(981),
    [anon_sym_pub] = ACTIONS(983),
    [anon_sym_test] = ACTIONS(983),
    [anon_sym_comptime] = ACTIONS(983),
    [anon_sym_export] = ACTIONS(983),
    [anon_sym_extern] = ACTIONS(983),
    [anon_sym_inline] = ACTIONS(983),
    [anon_sym_noinline] = ACTIONS(983),
    [anon_sym_threadlocal] = ACTIONS(983),
    [anon_sym_usingnamespace] = ACTIONS(983),
    [anon_sym_fn] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(983),
    [anon_sym_const] = ACTIONS(983),
    [anon_sym_var] = ACTIONS(983),
    [anon_sym_or] = ACTIONS(983),
    [anon_sym_and] = ACTIONS(983),
    [anon_sym_LBRACE] = ACTIONS(981),
    [anon_sym_RBRACE] = ACTIONS(981),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_error] = ACTIONS(983),
    [anon_sym_false] = ACTIONS(983),
    [anon_sym_null] = ACTIONS(983),
    [anon_sym_anyframe] = ACTIONS(983),
    [anon_sym_true] = ACTIONS(983),
    [anon_sym_undefined] = ACTIONS(983),
    [anon_sym_unreachable] = ACTIONS(983),
    [sym_BuildinTypeExpr] = ACTIONS(983),
    [anon_sym_packed] = ACTIONS(983),
    [anon_sym_LPAREN] = ACTIONS(947),
    [anon_sym_switch] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(983),
    [anon_sym_while] = ACTIONS(983),
    [anon_sym_for] = ACTIONS(983),
    [anon_sym_PIPE] = ACTIONS(983),
    [anon_sym_STAR] = ACTIONS(983),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_EQ] = ACTIONS(981),
    [anon_sym_LT] = ACTIONS(983),
    [anon_sym_GT] = ACTIONS(983),
    [anon_sym_LT_EQ] = ACTIONS(981),
    [anon_sym_GT_EQ] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(981),
    [anon_sym_CARET] = ACTIONS(981),
    [anon_sym_orelse] = ACTIONS(983),
    [anon_sym_catch] = ACTIONS(983),
    [anon_sym_LT_LT] = ACTIONS(983),
    [anon_sym_GT_GT] = ACTIONS(981),
    [anon_sym_LT_LT_PIPE] = ACTIONS(981),
    [anon_sym_PLUS] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(983),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_PLUS_PERCENT] = ACTIONS(981),
    [anon_sym_DASH_PERCENT] = ACTIONS(981),
    [anon_sym_PLUS_PIPE] = ACTIONS(981),
    [anon_sym_DASH_PIPE] = ACTIONS(981),
    [anon_sym_PIPE_PIPE] = ACTIONS(981),
    [anon_sym_SLASH] = ACTIONS(983),
    [anon_sym_PERCENT] = ACTIONS(981),
    [anon_sym_STAR_STAR] = ACTIONS(981),
    [anon_sym_STAR_PERCENT] = ACTIONS(981),
    [anon_sym_STAR_PIPE] = ACTIONS(981),
    [anon_sym_QMARK] = ACTIONS(981),
    [anon_sym_DOT_STAR] = ACTIONS(951),
    [anon_sym_DOT_QMARK] = ACTIONS(951),
    [anon_sym_struct] = ACTIONS(983),
    [anon_sym_opaque] = ACTIONS(983),
    [anon_sym_enum] = ACTIONS(983),
    [anon_sym_union] = ACTIONS(983),
    [sym_doc_comment] = ACTIONS(981),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(981),
    [aux_sym_FLOAT_token1] = ACTIONS(981),
    [aux_sym_FLOAT_token2] = ACTIONS(981),
    [aux_sym_FLOAT_token3] = ACTIONS(981),
    [aux_sym_FLOAT_token4] = ACTIONS(981),
    [aux_sym_INTEGER_token1] = ACTIONS(981),
    [aux_sym_INTEGER_token2] = ACTIONS(981),
    [aux_sym_INTEGER_token3] = ACTIONS(983),
    [aux_sym_INTEGER_token4] = ACTIONS(983),
    [anon_sym_DQUOTE] = ACTIONS(981),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(981),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(981),
  },
  [390] = {
    [sym_FieldOrFnCall] = STATE(388),
    [sym_SuffixOp] = STATE(388),
    [sym_FnCallArguments] = STATE(388),
    [aux_sym_SuffixExpr_repeat1] = STATE(388),
    [ts_builtin_sym_end] = ACTIONS(989),
    [anon_sym_COMMA] = ACTIONS(989),
    [anon_sym_pub] = ACTIONS(991),
    [anon_sym_test] = ACTIONS(991),
    [anon_sym_comptime] = ACTIONS(991),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_extern] = ACTIONS(991),
    [anon_sym_inline] = ACTIONS(991),
    [anon_sym_noinline] = ACTIONS(991),
    [anon_sym_threadlocal] = ACTIONS(991),
    [anon_sym_usingnamespace] = ACTIONS(991),
    [anon_sym_fn] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_const] = ACTIONS(991),
    [anon_sym_var] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_RBRACE] = ACTIONS(989),
    [anon_sym_async] = ACTIONS(991),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_error] = ACTIONS(991),
    [anon_sym_false] = ACTIONS(991),
    [anon_sym_null] = ACTIONS(991),
    [anon_sym_anyframe] = ACTIONS(991),
    [anon_sym_true] = ACTIONS(991),
    [anon_sym_undefined] = ACTIONS(991),
    [anon_sym_unreachable] = ACTIONS(991),
    [sym_BuildinTypeExpr] = ACTIONS(991),
    [anon_sym_packed] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(947),
    [anon_sym_switch] = ACTIONS(991),
    [anon_sym_LBRACK] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_while] = ACTIONS(991),
    [anon_sym_for] = ACTIONS(991),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(991),
    [anon_sym_EQ_EQ] = ACTIONS(989),
    [anon_sym_BANG_EQ] = ACTIONS(989),
    [anon_sym_LT] = ACTIONS(991),
    [anon_sym_GT] = ACTIONS(991),
    [anon_sym_LT_EQ] = ACTIONS(989),
    [anon_sym_GT_EQ] = ACTIONS(989),
    [anon_sym_AMP] = ACTIONS(989),
    [anon_sym_CARET] = ACTIONS(989),
    [anon_sym_orelse] = ACTIONS(991),
    [anon_sym_catch] = ACTIONS(991),
    [anon_sym_LT_LT] = ACTIONS(991),
    [anon_sym_GT_GT] = ACTIONS(989),
    [anon_sym_LT_LT_PIPE] = ACTIONS(989),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(989),
    [anon_sym_PLUS_PERCENT] = ACTIONS(989),
    [anon_sym_DASH_PERCENT] = ACTIONS(989),
    [anon_sym_PLUS_PIPE] = ACTIONS(989),
    [anon_sym_DASH_PIPE] = ACTIONS(989),
    [anon_sym_PIPE_PIPE] = ACTIONS(989),
    [anon_sym_SLASH] = ACTIONS(991),
    [anon_sym_PERCENT] = ACTIONS(989),
    [anon_sym_STAR_STAR] = ACTIONS(989),
    [anon_sym_STAR_PERCENT] = ACTIONS(989),
    [anon_sym_STAR_PIPE] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(989),
    [anon_sym_DOT_STAR] = ACTIONS(951),
    [anon_sym_DOT_QMARK] = ACTIONS(951),
    [anon_sym_struct] = ACTIONS(991),
    [anon_sym_opaque] = ACTIONS(991),
    [anon_sym_enum] = ACTIONS(991),
    [anon_sym_union] = ACTIONS(991),
    [sym_doc_comment] = ACTIONS(989),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(989),
    [aux_sym_FLOAT_token1] = ACTIONS(989),
    [aux_sym_FLOAT_token2] = ACTIONS(989),
    [aux_sym_FLOAT_token3] = ACTIONS(989),
    [aux_sym_FLOAT_token4] = ACTIONS(989),
    [aux_sym_INTEGER_token1] = ACTIONS(989),
    [aux_sym_INTEGER_token2] = ACTIONS(989),
    [aux_sym_INTEGER_token3] = ACTIONS(991),
    [aux_sym_INTEGER_token4] = ACTIONS(991),
    [anon_sym_DQUOTE] = ACTIONS(989),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(989),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(991),
    [anon_sym_AT] = ACTIONS(989),
  },
  [391] = {
    [sym_FieldOrFnCall] = STATE(388),
    [sym_SuffixOp] = STATE(388),
    [sym_FnCallArguments] = STATE(388),
    [aux_sym_SuffixExpr_repeat1] = STATE(388),
    [ts_builtin_sym_end] = ACTIONS(953),
    [anon_sym_COMMA] = ACTIONS(953),
    [anon_sym_pub] = ACTIONS(955),
    [anon_sym_test] = ACTIONS(955),
    [anon_sym_comptime] = ACTIONS(955),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_extern] = ACTIONS(955),
    [anon_sym_inline] = ACTIONS(955),
    [anon_sym_noinline] = ACTIONS(955),
    [anon_sym_threadlocal] = ACTIONS(955),
    [anon_sym_usingnamespace] = ACTIONS(955),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_BANG] = ACTIONS(955),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_var] = ACTIONS(955),
    [anon_sym_or] = ACTIONS(955),
    [anon_sym_and] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(953),
    [anon_sym_RBRACE] = ACTIONS(953),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_error] = ACTIONS(955),
    [anon_sym_false] = ACTIONS(955),
    [anon_sym_null] = ACTIONS(955),
    [anon_sym_anyframe] = ACTIONS(955),
    [anon_sym_true] = ACTIONS(955),
    [anon_sym_undefined] = ACTIONS(955),
    [anon_sym_unreachable] = ACTIONS(955),
    [sym_BuildinTypeExpr] = ACTIONS(955),
    [anon_sym_packed] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(947),
    [anon_sym_switch] = ACTIONS(955),
    [anon_sym_LBRACK] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(955),
    [anon_sym_while] = ACTIONS(955),
    [anon_sym_for] = ACTIONS(955),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_STAR] = ACTIONS(955),
    [anon_sym_EQ_EQ] = ACTIONS(953),
    [anon_sym_BANG_EQ] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_GT] = ACTIONS(955),
    [anon_sym_LT_EQ] = ACTIONS(953),
    [anon_sym_GT_EQ] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(953),
    [anon_sym_CARET] = ACTIONS(953),
    [anon_sym_orelse] = ACTIONS(955),
    [anon_sym_catch] = ACTIONS(955),
    [anon_sym_LT_LT] = ACTIONS(955),
    [anon_sym_GT_GT] = ACTIONS(953),
    [anon_sym_LT_LT_PIPE] = ACTIONS(953),
    [anon_sym_PLUS] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(955),
    [anon_sym_PLUS_PLUS] = ACTIONS(953),
    [anon_sym_PLUS_PERCENT] = ACTIONS(953),
    [anon_sym_DASH_PERCENT] = ACTIONS(953),
    [anon_sym_PLUS_PIPE] = ACTIONS(953),
    [anon_sym_DASH_PIPE] = ACTIONS(953),
    [anon_sym_PIPE_PIPE] = ACTIONS(953),
    [anon_sym_SLASH] = ACTIONS(955),
    [anon_sym_PERCENT] = ACTIONS(953),
    [anon_sym_STAR_STAR] = ACTIONS(953),
    [anon_sym_STAR_PERCENT] = ACTIONS(953),
    [anon_sym_STAR_PIPE] = ACTIONS(953),
    [anon_sym_QMARK] = ACTIONS(953),
    [anon_sym_DOT_STAR] = ACTIONS(951),
    [anon_sym_DOT_QMARK] = ACTIONS(951),
    [anon_sym_struct] = ACTIONS(955),
    [anon_sym_opaque] = ACTIONS(955),
    [anon_sym_enum] = ACTIONS(955),
    [anon_sym_union] = ACTIONS(955),
    [sym_doc_comment] = ACTIONS(953),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(953),
    [aux_sym_FLOAT_token1] = ACTIONS(953),
    [aux_sym_FLOAT_token2] = ACTIONS(953),
    [aux_sym_FLOAT_token3] = ACTIONS(953),
    [aux_sym_FLOAT_token4] = ACTIONS(953),
    [aux_sym_INTEGER_token1] = ACTIONS(953),
    [aux_sym_INTEGER_token2] = ACTIONS(953),
    [aux_sym_INTEGER_token3] = ACTIONS(955),
    [aux_sym_INTEGER_token4] = ACTIONS(955),
    [anon_sym_DQUOTE] = ACTIONS(953),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(953),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(955),
    [anon_sym_AT] = ACTIONS(953),
  },
  [392] = {
    [sym_FieldOrFnCall] = STATE(388),
    [sym_SuffixOp] = STATE(388),
    [sym_FnCallArguments] = STATE(388),
    [aux_sym_SuffixExpr_repeat1] = STATE(388),
    [ts_builtin_sym_end] = ACTIONS(977),
    [anon_sym_COMMA] = ACTIONS(977),
    [anon_sym_pub] = ACTIONS(979),
    [anon_sym_test] = ACTIONS(979),
    [anon_sym_comptime] = ACTIONS(979),
    [anon_sym_export] = ACTIONS(979),
    [anon_sym_extern] = ACTIONS(979),
    [anon_sym_inline] = ACTIONS(979),
    [anon_sym_noinline] = ACTIONS(979),
    [anon_sym_threadlocal] = ACTIONS(979),
    [anon_sym_usingnamespace] = ACTIONS(979),
    [anon_sym_fn] = ACTIONS(979),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_const] = ACTIONS(979),
    [anon_sym_var] = ACTIONS(979),
    [anon_sym_or] = ACTIONS(979),
    [anon_sym_and] = ACTIONS(979),
    [anon_sym_LBRACE] = ACTIONS(977),
    [anon_sym_RBRACE] = ACTIONS(977),
    [anon_sym_async] = ACTIONS(979),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_error] = ACTIONS(979),
    [anon_sym_false] = ACTIONS(979),
    [anon_sym_null] = ACTIONS(979),
    [anon_sym_anyframe] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(979),
    [anon_sym_undefined] = ACTIONS(979),
    [anon_sym_unreachable] = ACTIONS(979),
    [sym_BuildinTypeExpr] = ACTIONS(979),
    [anon_sym_packed] = ACTIONS(979),
    [anon_sym_LPAREN] = ACTIONS(947),
    [anon_sym_switch] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(979),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_PIPE] = ACTIONS(979),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_EQ_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(979),
    [anon_sym_LT_EQ] = ACTIONS(977),
    [anon_sym_GT_EQ] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(977),
    [anon_sym_CARET] = ACTIONS(977),
    [anon_sym_orelse] = ACTIONS(979),
    [anon_sym_catch] = ACTIONS(979),
    [anon_sym_LT_LT] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(977),
    [anon_sym_LT_LT_PIPE] = ACTIONS(977),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(977),
    [anon_sym_PLUS_PERCENT] = ACTIONS(977),
    [anon_sym_DASH_PERCENT] = ACTIONS(977),
    [anon_sym_PLUS_PIPE] = ACTIONS(977),
    [anon_sym_DASH_PIPE] = ACTIONS(977),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(977),
    [anon_sym_STAR_STAR] = ACTIONS(977),
    [anon_sym_STAR_PERCENT] = ACTIONS(977),
    [anon_sym_STAR_PIPE] = ACTIONS(977),
    [anon_sym_QMARK] = ACTIONS(977),
    [anon_sym_DOT_STAR] = ACTIONS(951),
    [anon_sym_DOT_QMARK] = ACTIONS(951),
    [anon_sym_struct] = ACTIONS(979),
    [anon_sym_opaque] = ACTIONS(979),
    [anon_sym_enum] = ACTIONS(979),
    [anon_sym_union] = ACTIONS(979),
    [sym_doc_comment] = ACTIONS(977),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(977),
    [aux_sym_FLOAT_token1] = ACTIONS(977),
    [aux_sym_FLOAT_token2] = ACTIONS(977),
    [aux_sym_FLOAT_token3] = ACTIONS(977),
    [aux_sym_FLOAT_token4] = ACTIONS(977),
    [aux_sym_INTEGER_token1] = ACTIONS(977),
    [aux_sym_INTEGER_token2] = ACTIONS(977),
    [aux_sym_INTEGER_token3] = ACTIONS(979),
    [aux_sym_INTEGER_token4] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(977),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(979),
    [anon_sym_AT] = ACTIONS(977),
  },
  [393] = {
    [sym_FieldOrFnCall] = STATE(388),
    [sym_SuffixOp] = STATE(388),
    [sym_FnCallArguments] = STATE(388),
    [aux_sym_SuffixExpr_repeat1] = STATE(388),
    [ts_builtin_sym_end] = ACTIONS(973),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_pub] = ACTIONS(975),
    [anon_sym_test] = ACTIONS(975),
    [anon_sym_comptime] = ACTIONS(975),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_extern] = ACTIONS(975),
    [anon_sym_inline] = ACTIONS(975),
    [anon_sym_noinline] = ACTIONS(975),
    [anon_sym_threadlocal] = ACTIONS(975),
    [anon_sym_usingnamespace] = ACTIONS(975),
    [anon_sym_fn] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_const] = ACTIONS(975),
    [anon_sym_var] = ACTIONS(975),
    [anon_sym_or] = ACTIONS(975),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(975),
    [anon_sym_DOT] = ACTIONS(945),
    [anon_sym_error] = ACTIONS(975),
    [anon_sym_false] = ACTIONS(975),
    [anon_sym_null] = ACTIONS(975),
    [anon_sym_anyframe] = ACTIONS(975),
    [anon_sym_true] = ACTIONS(975),
    [anon_sym_undefined] = ACTIONS(975),
    [anon_sym_unreachable] = ACTIONS(975),
    [sym_BuildinTypeExpr] = ACTIONS(975),
    [anon_sym_packed] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(947),
    [anon_sym_switch] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(949),
    [anon_sym_if] = ACTIONS(975),
    [anon_sym_while] = ACTIONS(975),
    [anon_sym_for] = ACTIONS(975),
    [anon_sym_PIPE] = ACTIONS(975),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_EQ_EQ] = ACTIONS(973),
    [anon_sym_BANG_EQ] = ACTIONS(973),
    [anon_sym_LT] = ACTIONS(975),
    [anon_sym_GT] = ACTIONS(975),
    [anon_sym_LT_EQ] = ACTIONS(973),
    [anon_sym_GT_EQ] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(973),
    [anon_sym_CARET] = ACTIONS(973),
    [anon_sym_orelse] = ACTIONS(975),
    [anon_sym_catch] = ACTIONS(975),
    [anon_sym_LT_LT] = ACTIONS(975),
    [anon_sym_GT_GT] = ACTIONS(973),
    [anon_sym_LT_LT_PIPE] = ACTIONS(973),
    [anon_sym_PLUS] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_PLUS_PLUS] = ACTIONS(973),
    [anon_sym_PLUS_PERCENT] = ACTIONS(973),
    [anon_sym_DASH_PERCENT] = ACTIONS(973),
    [anon_sym_PLUS_PIPE] = ACTIONS(973),
    [anon_sym_DASH_PIPE] = ACTIONS(973),
    [anon_sym_PIPE_PIPE] = ACTIONS(973),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(973),
    [anon_sym_STAR_STAR] = ACTIONS(973),
    [anon_sym_STAR_PERCENT] = ACTIONS(973),
    [anon_sym_STAR_PIPE] = ACTIONS(973),
    [anon_sym_QMARK] = ACTIONS(973),
    [anon_sym_DOT_STAR] = ACTIONS(951),
    [anon_sym_DOT_QMARK] = ACTIONS(951),
    [anon_sym_struct] = ACTIONS(975),
    [anon_sym_opaque] = ACTIONS(975),
    [anon_sym_enum] = ACTIONS(975),
    [anon_sym_union] = ACTIONS(975),
    [sym_doc_comment] = ACTIONS(973),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [aux_sym_FLOAT_token1] = ACTIONS(973),
    [aux_sym_FLOAT_token2] = ACTIONS(973),
    [aux_sym_FLOAT_token3] = ACTIONS(973),
    [aux_sym_FLOAT_token4] = ACTIONS(973),
    [aux_sym_INTEGER_token1] = ACTIONS(973),
    [aux_sym_INTEGER_token2] = ACTIONS(973),
    [aux_sym_INTEGER_token3] = ACTIONS(975),
    [aux_sym_INTEGER_token4] = ACTIONS(975),
    [anon_sym_DQUOTE] = ACTIONS(973),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(973),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(975),
    [anon_sym_AT] = ACTIONS(973),
  },
  [394] = {
    [sym__ElseExprTail] = STATE(673),
    [sym_CompareOp] = STATE(290),
    [sym_BitwiseOp] = STATE(289),
    [sym_BitShiftOp] = STATE(288),
    [sym_AdditionOp] = STATE(287),
    [sym_MultiplyOp] = STATE(286),
    [ts_builtin_sym_end] = ACTIONS(1005),
    [anon_sym_COMMA] = ACTIONS(1005),
    [anon_sym_pub] = ACTIONS(1007),
    [anon_sym_test] = ACTIONS(1007),
    [anon_sym_comptime] = ACTIONS(1007),
    [anon_sym_export] = ACTIONS(1007),
    [anon_sym_extern] = ACTIONS(1007),
    [anon_sym_inline] = ACTIONS(1007),
    [anon_sym_noinline] = ACTIONS(1007),
    [anon_sym_threadlocal] = ACTIONS(1007),
    [anon_sym_usingnamespace] = ACTIONS(1007),
    [anon_sym_fn] = ACTIONS(1007),
    [anon_sym_const] = ACTIONS(1007),
    [anon_sym_var] = ACTIONS(1007),
    [anon_sym_else] = ACTIONS(1009),
    [anon_sym_or] = ACTIONS(1011),
    [anon_sym_and] = ACTIONS(1013),
    [anon_sym_RBRACE] = ACTIONS(1005),
    [anon_sym_async] = ACTIONS(1007),
    [anon_sym_DOT] = ACTIONS(1005),
    [anon_sym_error] = ACTIONS(1007),
    [anon_sym_false] = ACTIONS(1007),
    [anon_sym_null] = ACTIONS(1007),
    [anon_sym_anyframe] = ACTIONS(1007),
    [anon_sym_true] = ACTIONS(1007),
    [anon_sym_undefined] = ACTIONS(1007),
    [anon_sym_unreachable] = ACTIONS(1007),
    [sym_BuildinTypeExpr] = ACTIONS(1007),
    [anon_sym_packed] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_switch] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [anon_sym_if] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1005),
    [anon_sym_struct] = ACTIONS(1007),
    [anon_sym_opaque] = ACTIONS(1007),
    [anon_sym_enum] = ACTIONS(1007),
    [anon_sym_union] = ACTIONS(1007),
    [sym_doc_comment] = ACTIONS(1005),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [aux_sym_FLOAT_token1] = ACTIONS(1005),
    [aux_sym_FLOAT_token2] = ACTIONS(1005),
    [aux_sym_FLOAT_token3] = ACTIONS(1005),
    [aux_sym_FLOAT_token4] = ACTIONS(1005),
    [aux_sym_INTEGER_token1] = ACTIONS(1005),
    [aux_sym_INTEGER_token2] = ACTIONS(1005),
    [aux_sym_INTEGER_token3] = ACTIONS(1007),
    [aux_sym_INTEGER_token4] = ACTIONS(1007),
    [anon_sym_DQUOTE] = ACTIONS(1005),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1005),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1007),
    [anon_sym_AT] = ACTIONS(1005),
  },
  [395] = {
    [sym__ElseExprTail] = STATE(649),
    [sym_CompareOp] = STATE(290),
    [sym_BitwiseOp] = STATE(289),
    [sym_BitShiftOp] = STATE(288),
    [sym_AdditionOp] = STATE(287),
    [sym_MultiplyOp] = STATE(286),
    [ts_builtin_sym_end] = ACTIONS(1005),
    [anon_sym_COMMA] = ACTIONS(1005),
    [anon_sym_pub] = ACTIONS(1007),
    [anon_sym_test] = ACTIONS(1007),
    [anon_sym_comptime] = ACTIONS(1007),
    [anon_sym_export] = ACTIONS(1007),
    [anon_sym_extern] = ACTIONS(1007),
    [anon_sym_inline] = ACTIONS(1007),
    [anon_sym_noinline] = ACTIONS(1007),
    [anon_sym_threadlocal] = ACTIONS(1007),
    [anon_sym_usingnamespace] = ACTIONS(1007),
    [anon_sym_fn] = ACTIONS(1007),
    [anon_sym_const] = ACTIONS(1007),
    [anon_sym_var] = ACTIONS(1007),
    [anon_sym_else] = ACTIONS(1037),
    [anon_sym_or] = ACTIONS(1011),
    [anon_sym_and] = ACTIONS(1013),
    [anon_sym_RBRACE] = ACTIONS(1005),
    [anon_sym_async] = ACTIONS(1007),
    [anon_sym_DOT] = ACTIONS(1005),
    [anon_sym_error] = ACTIONS(1007),
    [anon_sym_false] = ACTIONS(1007),
    [anon_sym_null] = ACTIONS(1007),
    [anon_sym_anyframe] = ACTIONS(1007),
    [anon_sym_true] = ACTIONS(1007),
    [anon_sym_undefined] = ACTIONS(1007),
    [anon_sym_unreachable] = ACTIONS(1007),
    [sym_BuildinTypeExpr] = ACTIONS(1007),
    [anon_sym_packed] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(1005),
    [anon_sym_switch] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1005),
    [anon_sym_if] = ACTIONS(1007),
    [anon_sym_while] = ACTIONS(1007),
    [anon_sym_for] = ACTIONS(1007),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1005),
    [anon_sym_struct] = ACTIONS(1007),
    [anon_sym_opaque] = ACTIONS(1007),
    [anon_sym_enum] = ACTIONS(1007),
    [anon_sym_union] = ACTIONS(1007),
    [sym_doc_comment] = ACTIONS(1005),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [aux_sym_FLOAT_token1] = ACTIONS(1005),
    [aux_sym_FLOAT_token2] = ACTIONS(1005),
    [aux_sym_FLOAT_token3] = ACTIONS(1005),
    [aux_sym_FLOAT_token4] = ACTIONS(1005),
    [aux_sym_INTEGER_token1] = ACTIONS(1005),
    [aux_sym_INTEGER_token2] = ACTIONS(1005),
    [aux_sym_INTEGER_token3] = ACTIONS(1007),
    [aux_sym_INTEGER_token4] = ACTIONS(1007),
    [anon_sym_DQUOTE] = ACTIONS(1005),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1005),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1007),
    [anon_sym_AT] = ACTIONS(1005),
  },
  [396] = {
    [sym_InitList] = STATE(658),
    [sym__ElseTypeExprTail] = STATE(490),
    [ts_builtin_sym_end] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(1039),
    [anon_sym_pub] = ACTIONS(1041),
    [anon_sym_test] = ACTIONS(1041),
    [anon_sym_comptime] = ACTIONS(1041),
    [anon_sym_export] = ACTIONS(1041),
    [anon_sym_extern] = ACTIONS(1041),
    [anon_sym_inline] = ACTIONS(1041),
    [anon_sym_noinline] = ACTIONS(1041),
    [anon_sym_threadlocal] = ACTIONS(1041),
    [anon_sym_usingnamespace] = ACTIONS(1041),
    [anon_sym_fn] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_const] = ACTIONS(1041),
    [anon_sym_var] = ACTIONS(1041),
    [anon_sym_else] = ACTIONS(1041),
    [anon_sym_or] = ACTIONS(1041),
    [anon_sym_and] = ACTIONS(1041),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_async] = ACTIONS(1041),
    [anon_sym_DOT] = ACTIONS(1041),
    [anon_sym_error] = ACTIONS(1041),
    [anon_sym_false] = ACTIONS(1041),
    [anon_sym_null] = ACTIONS(1041),
    [anon_sym_anyframe] = ACTIONS(1041),
    [anon_sym_true] = ACTIONS(1041),
    [anon_sym_undefined] = ACTIONS(1041),
    [anon_sym_unreachable] = ACTIONS(1041),
    [sym_BuildinTypeExpr] = ACTIONS(1041),
    [anon_sym_packed] = ACTIONS(1041),
    [anon_sym_LPAREN] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_while] = ACTIONS(1041),
    [anon_sym_for] = ACTIONS(1041),
    [anon_sym_PIPE] = ACTIONS(1041),
    [anon_sym_STAR] = ACTIONS(1041),
    [anon_sym_EQ_EQ] = ACTIONS(1039),
    [anon_sym_BANG_EQ] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_GT] = ACTIONS(1041),
    [anon_sym_LT_EQ] = ACTIONS(1039),
    [anon_sym_GT_EQ] = ACTIONS(1039),
    [anon_sym_AMP] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(1039),
    [anon_sym_orelse] = ACTIONS(1041),
    [anon_sym_catch] = ACTIONS(1041),
    [anon_sym_LT_LT] = ACTIONS(1041),
    [anon_sym_GT_GT] = ACTIONS(1039),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1039),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1039),
    [anon_sym_DASH_PERCENT] = ACTIONS(1039),
    [anon_sym_PLUS_PIPE] = ACTIONS(1039),
    [anon_sym_DASH_PIPE] = ACTIONS(1039),
    [anon_sym_PIPE_PIPE] = ACTIONS(1039),
    [anon_sym_SLASH] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1039),
    [anon_sym_STAR_STAR] = ACTIONS(1039),
    [anon_sym_STAR_PERCENT] = ACTIONS(1039),
    [anon_sym_STAR_PIPE] = ACTIONS(1039),
    [anon_sym_QMARK] = ACTIONS(1039),
    [anon_sym_DOT_STAR] = ACTIONS(1047),
    [anon_sym_DOT_QMARK] = ACTIONS(1047),
    [anon_sym_struct] = ACTIONS(1041),
    [anon_sym_opaque] = ACTIONS(1041),
    [anon_sym_enum] = ACTIONS(1041),
    [anon_sym_union] = ACTIONS(1041),
    [sym_doc_comment] = ACTIONS(1039),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1039),
    [aux_sym_FLOAT_token1] = ACTIONS(1039),
    [aux_sym_FLOAT_token2] = ACTIONS(1039),
    [aux_sym_FLOAT_token3] = ACTIONS(1039),
    [aux_sym_FLOAT_token4] = ACTIONS(1039),
    [aux_sym_INTEGER_token1] = ACTIONS(1039),
    [aux_sym_INTEGER_token2] = ACTIONS(1039),
    [aux_sym_INTEGER_token3] = ACTIONS(1041),
    [aux_sym_INTEGER_token4] = ACTIONS(1041),
    [anon_sym_DQUOTE] = ACTIONS(1039),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1039),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(1039),
  },
  [397] = {
    [sym__ElseExprTail] = STATE(652),
    [sym_CompareOp] = STATE(290),
    [sym_BitwiseOp] = STATE(289),
    [sym_BitShiftOp] = STATE(288),
    [sym_AdditionOp] = STATE(287),
    [sym_MultiplyOp] = STATE(286),
    [ts_builtin_sym_end] = ACTIONS(1049),
    [anon_sym_COMMA] = ACTIONS(1049),
    [anon_sym_pub] = ACTIONS(1051),
    [anon_sym_test] = ACTIONS(1051),
    [anon_sym_comptime] = ACTIONS(1051),
    [anon_sym_export] = ACTIONS(1051),
    [anon_sym_extern] = ACTIONS(1051),
    [anon_sym_inline] = ACTIONS(1051),
    [anon_sym_noinline] = ACTIONS(1051),
    [anon_sym_threadlocal] = ACTIONS(1051),
    [anon_sym_usingnamespace] = ACTIONS(1051),
    [anon_sym_fn] = ACTIONS(1051),
    [anon_sym_const] = ACTIONS(1051),
    [anon_sym_var] = ACTIONS(1051),
    [anon_sym_else] = ACTIONS(1037),
    [anon_sym_or] = ACTIONS(1011),
    [anon_sym_and] = ACTIONS(1013),
    [anon_sym_RBRACE] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_DOT] = ACTIONS(1049),
    [anon_sym_error] = ACTIONS(1051),
    [anon_sym_false] = ACTIONS(1051),
    [anon_sym_null] = ACTIONS(1051),
    [anon_sym_anyframe] = ACTIONS(1051),
    [anon_sym_true] = ACTIONS(1051),
    [anon_sym_undefined] = ACTIONS(1051),
    [anon_sym_unreachable] = ACTIONS(1051),
    [sym_BuildinTypeExpr] = ACTIONS(1051),
    [anon_sym_packed] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(1049),
    [anon_sym_switch] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1049),
    [anon_sym_struct] = ACTIONS(1051),
    [anon_sym_opaque] = ACTIONS(1051),
    [anon_sym_enum] = ACTIONS(1051),
    [anon_sym_union] = ACTIONS(1051),
    [sym_doc_comment] = ACTIONS(1049),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1049),
    [aux_sym_FLOAT_token1] = ACTIONS(1049),
    [aux_sym_FLOAT_token2] = ACTIONS(1049),
    [aux_sym_FLOAT_token3] = ACTIONS(1049),
    [aux_sym_FLOAT_token4] = ACTIONS(1049),
    [aux_sym_INTEGER_token1] = ACTIONS(1049),
    [aux_sym_INTEGER_token2] = ACTIONS(1049),
    [aux_sym_INTEGER_token3] = ACTIONS(1051),
    [aux_sym_INTEGER_token4] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1049),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1051),
    [anon_sym_AT] = ACTIONS(1049),
  },
  [398] = {
    [sym_InitList] = STATE(658),
    [sym__ElseTypeExprTail] = STATE(489),
    [ts_builtin_sym_end] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(1039),
    [anon_sym_pub] = ACTIONS(1041),
    [anon_sym_test] = ACTIONS(1041),
    [anon_sym_comptime] = ACTIONS(1041),
    [anon_sym_export] = ACTIONS(1041),
    [anon_sym_extern] = ACTIONS(1041),
    [anon_sym_inline] = ACTIONS(1041),
    [anon_sym_noinline] = ACTIONS(1041),
    [anon_sym_threadlocal] = ACTIONS(1041),
    [anon_sym_usingnamespace] = ACTIONS(1041),
    [anon_sym_fn] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1041),
    [anon_sym_var] = ACTIONS(1041),
    [anon_sym_else] = ACTIONS(1041),
    [anon_sym_or] = ACTIONS(1041),
    [anon_sym_and] = ACTIONS(1041),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_async] = ACTIONS(1041),
    [anon_sym_DOT] = ACTIONS(1041),
    [anon_sym_error] = ACTIONS(1041),
    [anon_sym_false] = ACTIONS(1041),
    [anon_sym_null] = ACTIONS(1041),
    [anon_sym_anyframe] = ACTIONS(1041),
    [anon_sym_true] = ACTIONS(1041),
    [anon_sym_undefined] = ACTIONS(1041),
    [anon_sym_unreachable] = ACTIONS(1041),
    [sym_BuildinTypeExpr] = ACTIONS(1041),
    [anon_sym_packed] = ACTIONS(1041),
    [anon_sym_LPAREN] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_while] = ACTIONS(1041),
    [anon_sym_for] = ACTIONS(1041),
    [anon_sym_PIPE] = ACTIONS(1041),
    [anon_sym_STAR] = ACTIONS(1041),
    [anon_sym_EQ_EQ] = ACTIONS(1039),
    [anon_sym_BANG_EQ] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_GT] = ACTIONS(1041),
    [anon_sym_LT_EQ] = ACTIONS(1039),
    [anon_sym_GT_EQ] = ACTIONS(1039),
    [anon_sym_AMP] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(1039),
    [anon_sym_orelse] = ACTIONS(1041),
    [anon_sym_catch] = ACTIONS(1041),
    [anon_sym_LT_LT] = ACTIONS(1041),
    [anon_sym_GT_GT] = ACTIONS(1039),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1039),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1039),
    [anon_sym_DASH_PERCENT] = ACTIONS(1039),
    [anon_sym_PLUS_PIPE] = ACTIONS(1039),
    [anon_sym_DASH_PIPE] = ACTIONS(1039),
    [anon_sym_PIPE_PIPE] = ACTIONS(1039),
    [anon_sym_SLASH] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1039),
    [anon_sym_STAR_STAR] = ACTIONS(1039),
    [anon_sym_STAR_PERCENT] = ACTIONS(1039),
    [anon_sym_STAR_PIPE] = ACTIONS(1039),
    [anon_sym_QMARK] = ACTIONS(1039),
    [anon_sym_DOT_STAR] = ACTIONS(1055),
    [anon_sym_DOT_QMARK] = ACTIONS(1055),
    [anon_sym_struct] = ACTIONS(1041),
    [anon_sym_opaque] = ACTIONS(1041),
    [anon_sym_enum] = ACTIONS(1041),
    [anon_sym_union] = ACTIONS(1041),
    [sym_doc_comment] = ACTIONS(1039),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1039),
    [aux_sym_FLOAT_token1] = ACTIONS(1039),
    [aux_sym_FLOAT_token2] = ACTIONS(1039),
    [aux_sym_FLOAT_token3] = ACTIONS(1039),
    [aux_sym_FLOAT_token4] = ACTIONS(1039),
    [aux_sym_INTEGER_token1] = ACTIONS(1039),
    [aux_sym_INTEGER_token2] = ACTIONS(1039),
    [aux_sym_INTEGER_token3] = ACTIONS(1041),
    [aux_sym_INTEGER_token4] = ACTIONS(1041),
    [anon_sym_DQUOTE] = ACTIONS(1039),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1039),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(1039),
  },
  [399] = {
    [sym__ElseExprTail] = STATE(651),
    [sym_CompareOp] = STATE(290),
    [sym_BitwiseOp] = STATE(289),
    [sym_BitShiftOp] = STATE(288),
    [sym_AdditionOp] = STATE(287),
    [sym_MultiplyOp] = STATE(286),
    [ts_builtin_sym_end] = ACTIONS(1057),
    [anon_sym_COMMA] = ACTIONS(1057),
    [anon_sym_pub] = ACTIONS(1059),
    [anon_sym_test] = ACTIONS(1059),
    [anon_sym_comptime] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(1059),
    [anon_sym_extern] = ACTIONS(1059),
    [anon_sym_inline] = ACTIONS(1059),
    [anon_sym_noinline] = ACTIONS(1059),
    [anon_sym_threadlocal] = ACTIONS(1059),
    [anon_sym_usingnamespace] = ACTIONS(1059),
    [anon_sym_fn] = ACTIONS(1059),
    [anon_sym_const] = ACTIONS(1059),
    [anon_sym_var] = ACTIONS(1059),
    [anon_sym_else] = ACTIONS(1037),
    [anon_sym_or] = ACTIONS(1011),
    [anon_sym_and] = ACTIONS(1013),
    [anon_sym_RBRACE] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_DOT] = ACTIONS(1057),
    [anon_sym_error] = ACTIONS(1059),
    [anon_sym_false] = ACTIONS(1059),
    [anon_sym_null] = ACTIONS(1059),
    [anon_sym_anyframe] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(1059),
    [anon_sym_undefined] = ACTIONS(1059),
    [anon_sym_unreachable] = ACTIONS(1059),
    [sym_BuildinTypeExpr] = ACTIONS(1059),
    [anon_sym_packed] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_switch] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_if] = ACTIONS(1059),
    [anon_sym_while] = ACTIONS(1059),
    [anon_sym_for] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1057),
    [anon_sym_struct] = ACTIONS(1059),
    [anon_sym_opaque] = ACTIONS(1059),
    [anon_sym_enum] = ACTIONS(1059),
    [anon_sym_union] = ACTIONS(1059),
    [sym_doc_comment] = ACTIONS(1057),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1057),
    [aux_sym_FLOAT_token1] = ACTIONS(1057),
    [aux_sym_FLOAT_token2] = ACTIONS(1057),
    [aux_sym_FLOAT_token3] = ACTIONS(1057),
    [aux_sym_FLOAT_token4] = ACTIONS(1057),
    [aux_sym_INTEGER_token1] = ACTIONS(1057),
    [aux_sym_INTEGER_token2] = ACTIONS(1057),
    [aux_sym_INTEGER_token3] = ACTIONS(1059),
    [aux_sym_INTEGER_token4] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1057),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1059),
    [anon_sym_AT] = ACTIONS(1057),
  },
  [400] = {
    [sym_InitList] = STATE(658),
    [sym__ElseTypeExprTail] = STATE(488),
    [ts_builtin_sym_end] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(1039),
    [anon_sym_pub] = ACTIONS(1041),
    [anon_sym_test] = ACTIONS(1041),
    [anon_sym_comptime] = ACTIONS(1041),
    [anon_sym_export] = ACTIONS(1041),
    [anon_sym_extern] = ACTIONS(1041),
    [anon_sym_inline] = ACTIONS(1041),
    [anon_sym_noinline] = ACTIONS(1041),
    [anon_sym_threadlocal] = ACTIONS(1041),
    [anon_sym_usingnamespace] = ACTIONS(1041),
    [anon_sym_fn] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_const] = ACTIONS(1041),
    [anon_sym_var] = ACTIONS(1041),
    [anon_sym_else] = ACTIONS(1041),
    [anon_sym_or] = ACTIONS(1041),
    [anon_sym_and] = ACTIONS(1041),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_async] = ACTIONS(1041),
    [anon_sym_DOT] = ACTIONS(1041),
    [anon_sym_error] = ACTIONS(1041),
    [anon_sym_false] = ACTIONS(1041),
    [anon_sym_null] = ACTIONS(1041),
    [anon_sym_anyframe] = ACTIONS(1041),
    [anon_sym_true] = ACTIONS(1041),
    [anon_sym_undefined] = ACTIONS(1041),
    [anon_sym_unreachable] = ACTIONS(1041),
    [sym_BuildinTypeExpr] = ACTIONS(1041),
    [anon_sym_packed] = ACTIONS(1041),
    [anon_sym_LPAREN] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_while] = ACTIONS(1041),
    [anon_sym_for] = ACTIONS(1041),
    [anon_sym_PIPE] = ACTIONS(1041),
    [anon_sym_STAR] = ACTIONS(1041),
    [anon_sym_EQ_EQ] = ACTIONS(1039),
    [anon_sym_BANG_EQ] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_GT] = ACTIONS(1041),
    [anon_sym_LT_EQ] = ACTIONS(1039),
    [anon_sym_GT_EQ] = ACTIONS(1039),
    [anon_sym_AMP] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(1039),
    [anon_sym_orelse] = ACTIONS(1041),
    [anon_sym_catch] = ACTIONS(1041),
    [anon_sym_LT_LT] = ACTIONS(1041),
    [anon_sym_GT_GT] = ACTIONS(1039),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1039),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1039),
    [anon_sym_DASH_PERCENT] = ACTIONS(1039),
    [anon_sym_PLUS_PIPE] = ACTIONS(1039),
    [anon_sym_DASH_PIPE] = ACTIONS(1039),
    [anon_sym_PIPE_PIPE] = ACTIONS(1039),
    [anon_sym_SLASH] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1039),
    [anon_sym_STAR_STAR] = ACTIONS(1039),
    [anon_sym_STAR_PERCENT] = ACTIONS(1039),
    [anon_sym_STAR_PIPE] = ACTIONS(1039),
    [anon_sym_QMARK] = ACTIONS(1039),
    [anon_sym_DOT_STAR] = ACTIONS(1063),
    [anon_sym_DOT_QMARK] = ACTIONS(1063),
    [anon_sym_struct] = ACTIONS(1041),
    [anon_sym_opaque] = ACTIONS(1041),
    [anon_sym_enum] = ACTIONS(1041),
    [anon_sym_union] = ACTIONS(1041),
    [sym_doc_comment] = ACTIONS(1039),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1039),
    [aux_sym_FLOAT_token1] = ACTIONS(1039),
    [aux_sym_FLOAT_token2] = ACTIONS(1039),
    [aux_sym_FLOAT_token3] = ACTIONS(1039),
    [aux_sym_FLOAT_token4] = ACTIONS(1039),
    [aux_sym_INTEGER_token1] = ACTIONS(1039),
    [aux_sym_INTEGER_token2] = ACTIONS(1039),
    [aux_sym_INTEGER_token3] = ACTIONS(1041),
    [aux_sym_INTEGER_token4] = ACTIONS(1041),
    [anon_sym_DQUOTE] = ACTIONS(1039),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1039),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(1039),
  },
  [401] = {
    [sym_InitList] = STATE(658),
    [sym__ElseTypeExprTail] = STATE(577),
    [ts_builtin_sym_end] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(1039),
    [anon_sym_pub] = ACTIONS(1041),
    [anon_sym_test] = ACTIONS(1041),
    [anon_sym_comptime] = ACTIONS(1041),
    [anon_sym_export] = ACTIONS(1041),
    [anon_sym_extern] = ACTIONS(1041),
    [anon_sym_inline] = ACTIONS(1041),
    [anon_sym_noinline] = ACTIONS(1041),
    [anon_sym_threadlocal] = ACTIONS(1041),
    [anon_sym_usingnamespace] = ACTIONS(1041),
    [anon_sym_fn] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_const] = ACTIONS(1041),
    [anon_sym_var] = ACTIONS(1041),
    [anon_sym_else] = ACTIONS(1041),
    [anon_sym_or] = ACTIONS(1041),
    [anon_sym_and] = ACTIONS(1041),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_async] = ACTIONS(1041),
    [anon_sym_DOT] = ACTIONS(1041),
    [anon_sym_error] = ACTIONS(1041),
    [anon_sym_false] = ACTIONS(1041),
    [anon_sym_null] = ACTIONS(1041),
    [anon_sym_anyframe] = ACTIONS(1041),
    [anon_sym_true] = ACTIONS(1041),
    [anon_sym_undefined] = ACTIONS(1041),
    [anon_sym_unreachable] = ACTIONS(1041),
    [sym_BuildinTypeExpr] = ACTIONS(1041),
    [anon_sym_packed] = ACTIONS(1041),
    [anon_sym_LPAREN] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_while] = ACTIONS(1041),
    [anon_sym_for] = ACTIONS(1041),
    [anon_sym_PIPE] = ACTIONS(1041),
    [anon_sym_STAR] = ACTIONS(1041),
    [anon_sym_EQ_EQ] = ACTIONS(1039),
    [anon_sym_BANG_EQ] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_GT] = ACTIONS(1041),
    [anon_sym_LT_EQ] = ACTIONS(1039),
    [anon_sym_GT_EQ] = ACTIONS(1039),
    [anon_sym_AMP] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(1039),
    [anon_sym_orelse] = ACTIONS(1041),
    [anon_sym_catch] = ACTIONS(1041),
    [anon_sym_LT_LT] = ACTIONS(1041),
    [anon_sym_GT_GT] = ACTIONS(1039),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1039),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1039),
    [anon_sym_DASH_PERCENT] = ACTIONS(1039),
    [anon_sym_PLUS_PIPE] = ACTIONS(1039),
    [anon_sym_DASH_PIPE] = ACTIONS(1039),
    [anon_sym_PIPE_PIPE] = ACTIONS(1039),
    [anon_sym_SLASH] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1039),
    [anon_sym_STAR_STAR] = ACTIONS(1039),
    [anon_sym_STAR_PERCENT] = ACTIONS(1039),
    [anon_sym_STAR_PIPE] = ACTIONS(1039),
    [anon_sym_QMARK] = ACTIONS(1039),
    [anon_sym_DOT_STAR] = ACTIONS(1047),
    [anon_sym_DOT_QMARK] = ACTIONS(1047),
    [anon_sym_struct] = ACTIONS(1041),
    [anon_sym_opaque] = ACTIONS(1041),
    [anon_sym_enum] = ACTIONS(1041),
    [anon_sym_union] = ACTIONS(1041),
    [sym_doc_comment] = ACTIONS(1039),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1039),
    [aux_sym_FLOAT_token1] = ACTIONS(1039),
    [aux_sym_FLOAT_token2] = ACTIONS(1039),
    [aux_sym_FLOAT_token3] = ACTIONS(1039),
    [aux_sym_FLOAT_token4] = ACTIONS(1039),
    [aux_sym_INTEGER_token1] = ACTIONS(1039),
    [aux_sym_INTEGER_token2] = ACTIONS(1039),
    [aux_sym_INTEGER_token3] = ACTIONS(1041),
    [aux_sym_INTEGER_token4] = ACTIONS(1041),
    [anon_sym_DQUOTE] = ACTIONS(1039),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1039),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(1039),
  },
  [402] = {
    [sym_LINESTRING] = STATE(402),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(402),
    [ts_builtin_sym_end] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_pub] = ACTIONS(1067),
    [anon_sym_test] = ACTIONS(1067),
    [anon_sym_comptime] = ACTIONS(1067),
    [anon_sym_export] = ACTIONS(1067),
    [anon_sym_extern] = ACTIONS(1067),
    [anon_sym_inline] = ACTIONS(1067),
    [anon_sym_noinline] = ACTIONS(1067),
    [anon_sym_threadlocal] = ACTIONS(1067),
    [anon_sym_usingnamespace] = ACTIONS(1067),
    [anon_sym_fn] = ACTIONS(1067),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_const] = ACTIONS(1067),
    [anon_sym_var] = ACTIONS(1067),
    [anon_sym_else] = ACTIONS(1067),
    [anon_sym_or] = ACTIONS(1067),
    [anon_sym_and] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_async] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_error] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [anon_sym_null] = ACTIONS(1067),
    [anon_sym_anyframe] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_undefined] = ACTIONS(1067),
    [anon_sym_unreachable] = ACTIONS(1067),
    [sym_BuildinTypeExpr] = ACTIONS(1067),
    [anon_sym_packed] = ACTIONS(1067),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_switch] = ACTIONS(1067),
    [anon_sym_LBRACK] = ACTIONS(1065),
    [anon_sym_if] = ACTIONS(1067),
    [anon_sym_while] = ACTIONS(1067),
    [anon_sym_for] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_BANG_EQ] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_LT_EQ] = ACTIONS(1065),
    [anon_sym_GT_EQ] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1065),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym_orelse] = ACTIONS(1067),
    [anon_sym_catch] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1065),
    [anon_sym_DASH_PERCENT] = ACTIONS(1065),
    [anon_sym_PLUS_PIPE] = ACTIONS(1065),
    [anon_sym_DASH_PIPE] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1067),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_STAR_STAR] = ACTIONS(1065),
    [anon_sym_STAR_PERCENT] = ACTIONS(1065),
    [anon_sym_STAR_PIPE] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_DOT_STAR] = ACTIONS(1065),
    [anon_sym_DOT_QMARK] = ACTIONS(1065),
    [anon_sym_struct] = ACTIONS(1067),
    [anon_sym_opaque] = ACTIONS(1067),
    [anon_sym_enum] = ACTIONS(1067),
    [anon_sym_union] = ACTIONS(1067),
    [sym_doc_comment] = ACTIONS(1065),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [aux_sym_FLOAT_token1] = ACTIONS(1065),
    [aux_sym_FLOAT_token2] = ACTIONS(1065),
    [aux_sym_FLOAT_token3] = ACTIONS(1065),
    [aux_sym_FLOAT_token4] = ACTIONS(1065),
    [aux_sym_INTEGER_token1] = ACTIONS(1065),
    [aux_sym_INTEGER_token2] = ACTIONS(1065),
    [aux_sym_INTEGER_token3] = ACTIONS(1067),
    [aux_sym_INTEGER_token4] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1069),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1065),
  },
  [403] = {
    [sym__ElseExprTail] = STATE(683),
    [sym_CompareOp] = STATE(290),
    [sym_BitwiseOp] = STATE(289),
    [sym_BitShiftOp] = STATE(288),
    [sym_AdditionOp] = STATE(287),
    [sym_MultiplyOp] = STATE(286),
    [ts_builtin_sym_end] = ACTIONS(1049),
    [anon_sym_COMMA] = ACTIONS(1049),
    [anon_sym_pub] = ACTIONS(1051),
    [anon_sym_test] = ACTIONS(1051),
    [anon_sym_comptime] = ACTIONS(1051),
    [anon_sym_export] = ACTIONS(1051),
    [anon_sym_extern] = ACTIONS(1051),
    [anon_sym_inline] = ACTIONS(1051),
    [anon_sym_noinline] = ACTIONS(1051),
    [anon_sym_threadlocal] = ACTIONS(1051),
    [anon_sym_usingnamespace] = ACTIONS(1051),
    [anon_sym_fn] = ACTIONS(1051),
    [anon_sym_const] = ACTIONS(1051),
    [anon_sym_var] = ACTIONS(1051),
    [anon_sym_else] = ACTIONS(1009),
    [anon_sym_or] = ACTIONS(1011),
    [anon_sym_and] = ACTIONS(1013),
    [anon_sym_RBRACE] = ACTIONS(1049),
    [anon_sym_async] = ACTIONS(1051),
    [anon_sym_DOT] = ACTIONS(1049),
    [anon_sym_error] = ACTIONS(1051),
    [anon_sym_false] = ACTIONS(1051),
    [anon_sym_null] = ACTIONS(1051),
    [anon_sym_anyframe] = ACTIONS(1051),
    [anon_sym_true] = ACTIONS(1051),
    [anon_sym_undefined] = ACTIONS(1051),
    [anon_sym_unreachable] = ACTIONS(1051),
    [sym_BuildinTypeExpr] = ACTIONS(1051),
    [anon_sym_packed] = ACTIONS(1051),
    [anon_sym_LPAREN] = ACTIONS(1049),
    [anon_sym_switch] = ACTIONS(1051),
    [anon_sym_LBRACK] = ACTIONS(1049),
    [anon_sym_if] = ACTIONS(1051),
    [anon_sym_while] = ACTIONS(1051),
    [anon_sym_for] = ACTIONS(1051),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1049),
    [anon_sym_struct] = ACTIONS(1051),
    [anon_sym_opaque] = ACTIONS(1051),
    [anon_sym_enum] = ACTIONS(1051),
    [anon_sym_union] = ACTIONS(1051),
    [sym_doc_comment] = ACTIONS(1049),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1049),
    [aux_sym_FLOAT_token1] = ACTIONS(1049),
    [aux_sym_FLOAT_token2] = ACTIONS(1049),
    [aux_sym_FLOAT_token3] = ACTIONS(1049),
    [aux_sym_FLOAT_token4] = ACTIONS(1049),
    [aux_sym_INTEGER_token1] = ACTIONS(1049),
    [aux_sym_INTEGER_token2] = ACTIONS(1049),
    [aux_sym_INTEGER_token3] = ACTIONS(1051),
    [aux_sym_INTEGER_token4] = ACTIONS(1051),
    [anon_sym_DQUOTE] = ACTIONS(1049),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1049),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1051),
    [anon_sym_AT] = ACTIONS(1049),
  },
  [404] = {
    [sym_InitList] = STATE(658),
    [sym__ElseTypeExprTail] = STATE(576),
    [ts_builtin_sym_end] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(1039),
    [anon_sym_pub] = ACTIONS(1041),
    [anon_sym_test] = ACTIONS(1041),
    [anon_sym_comptime] = ACTIONS(1041),
    [anon_sym_export] = ACTIONS(1041),
    [anon_sym_extern] = ACTIONS(1041),
    [anon_sym_inline] = ACTIONS(1041),
    [anon_sym_noinline] = ACTIONS(1041),
    [anon_sym_threadlocal] = ACTIONS(1041),
    [anon_sym_usingnamespace] = ACTIONS(1041),
    [anon_sym_fn] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1041),
    [anon_sym_var] = ACTIONS(1041),
    [anon_sym_else] = ACTIONS(1041),
    [anon_sym_or] = ACTIONS(1041),
    [anon_sym_and] = ACTIONS(1041),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_async] = ACTIONS(1041),
    [anon_sym_DOT] = ACTIONS(1041),
    [anon_sym_error] = ACTIONS(1041),
    [anon_sym_false] = ACTIONS(1041),
    [anon_sym_null] = ACTIONS(1041),
    [anon_sym_anyframe] = ACTIONS(1041),
    [anon_sym_true] = ACTIONS(1041),
    [anon_sym_undefined] = ACTIONS(1041),
    [anon_sym_unreachable] = ACTIONS(1041),
    [sym_BuildinTypeExpr] = ACTIONS(1041),
    [anon_sym_packed] = ACTIONS(1041),
    [anon_sym_LPAREN] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_while] = ACTIONS(1041),
    [anon_sym_for] = ACTIONS(1041),
    [anon_sym_PIPE] = ACTIONS(1041),
    [anon_sym_STAR] = ACTIONS(1041),
    [anon_sym_EQ_EQ] = ACTIONS(1039),
    [anon_sym_BANG_EQ] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_GT] = ACTIONS(1041),
    [anon_sym_LT_EQ] = ACTIONS(1039),
    [anon_sym_GT_EQ] = ACTIONS(1039),
    [anon_sym_AMP] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(1039),
    [anon_sym_orelse] = ACTIONS(1041),
    [anon_sym_catch] = ACTIONS(1041),
    [anon_sym_LT_LT] = ACTIONS(1041),
    [anon_sym_GT_GT] = ACTIONS(1039),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1039),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1039),
    [anon_sym_DASH_PERCENT] = ACTIONS(1039),
    [anon_sym_PLUS_PIPE] = ACTIONS(1039),
    [anon_sym_DASH_PIPE] = ACTIONS(1039),
    [anon_sym_PIPE_PIPE] = ACTIONS(1039),
    [anon_sym_SLASH] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1039),
    [anon_sym_STAR_STAR] = ACTIONS(1039),
    [anon_sym_STAR_PERCENT] = ACTIONS(1039),
    [anon_sym_STAR_PIPE] = ACTIONS(1039),
    [anon_sym_QMARK] = ACTIONS(1039),
    [anon_sym_DOT_STAR] = ACTIONS(1055),
    [anon_sym_DOT_QMARK] = ACTIONS(1055),
    [anon_sym_struct] = ACTIONS(1041),
    [anon_sym_opaque] = ACTIONS(1041),
    [anon_sym_enum] = ACTIONS(1041),
    [anon_sym_union] = ACTIONS(1041),
    [sym_doc_comment] = ACTIONS(1039),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1039),
    [aux_sym_FLOAT_token1] = ACTIONS(1039),
    [aux_sym_FLOAT_token2] = ACTIONS(1039),
    [aux_sym_FLOAT_token3] = ACTIONS(1039),
    [aux_sym_FLOAT_token4] = ACTIONS(1039),
    [aux_sym_INTEGER_token1] = ACTIONS(1039),
    [aux_sym_INTEGER_token2] = ACTIONS(1039),
    [aux_sym_INTEGER_token3] = ACTIONS(1041),
    [aux_sym_INTEGER_token4] = ACTIONS(1041),
    [anon_sym_DQUOTE] = ACTIONS(1039),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1039),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(1039),
  },
  [405] = {
    [sym__ElseExprTail] = STATE(674),
    [sym_CompareOp] = STATE(290),
    [sym_BitwiseOp] = STATE(289),
    [sym_BitShiftOp] = STATE(288),
    [sym_AdditionOp] = STATE(287),
    [sym_MultiplyOp] = STATE(286),
    [ts_builtin_sym_end] = ACTIONS(1057),
    [anon_sym_COMMA] = ACTIONS(1057),
    [anon_sym_pub] = ACTIONS(1059),
    [anon_sym_test] = ACTIONS(1059),
    [anon_sym_comptime] = ACTIONS(1059),
    [anon_sym_export] = ACTIONS(1059),
    [anon_sym_extern] = ACTIONS(1059),
    [anon_sym_inline] = ACTIONS(1059),
    [anon_sym_noinline] = ACTIONS(1059),
    [anon_sym_threadlocal] = ACTIONS(1059),
    [anon_sym_usingnamespace] = ACTIONS(1059),
    [anon_sym_fn] = ACTIONS(1059),
    [anon_sym_const] = ACTIONS(1059),
    [anon_sym_var] = ACTIONS(1059),
    [anon_sym_else] = ACTIONS(1009),
    [anon_sym_or] = ACTIONS(1011),
    [anon_sym_and] = ACTIONS(1013),
    [anon_sym_RBRACE] = ACTIONS(1057),
    [anon_sym_async] = ACTIONS(1059),
    [anon_sym_DOT] = ACTIONS(1057),
    [anon_sym_error] = ACTIONS(1059),
    [anon_sym_false] = ACTIONS(1059),
    [anon_sym_null] = ACTIONS(1059),
    [anon_sym_anyframe] = ACTIONS(1059),
    [anon_sym_true] = ACTIONS(1059),
    [anon_sym_undefined] = ACTIONS(1059),
    [anon_sym_unreachable] = ACTIONS(1059),
    [sym_BuildinTypeExpr] = ACTIONS(1059),
    [anon_sym_packed] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_switch] = ACTIONS(1059),
    [anon_sym_LBRACK] = ACTIONS(1057),
    [anon_sym_if] = ACTIONS(1059),
    [anon_sym_while] = ACTIONS(1059),
    [anon_sym_for] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1057),
    [anon_sym_struct] = ACTIONS(1059),
    [anon_sym_opaque] = ACTIONS(1059),
    [anon_sym_enum] = ACTIONS(1059),
    [anon_sym_union] = ACTIONS(1059),
    [sym_doc_comment] = ACTIONS(1057),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1057),
    [aux_sym_FLOAT_token1] = ACTIONS(1057),
    [aux_sym_FLOAT_token2] = ACTIONS(1057),
    [aux_sym_FLOAT_token3] = ACTIONS(1057),
    [aux_sym_FLOAT_token4] = ACTIONS(1057),
    [aux_sym_INTEGER_token1] = ACTIONS(1057),
    [aux_sym_INTEGER_token2] = ACTIONS(1057),
    [aux_sym_INTEGER_token3] = ACTIONS(1059),
    [aux_sym_INTEGER_token4] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1057),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1057),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1059),
    [anon_sym_AT] = ACTIONS(1057),
  },
  [406] = {
    [sym_InitList] = STATE(658),
    [sym__ElseTypeExprTail] = STATE(575),
    [ts_builtin_sym_end] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(1039),
    [anon_sym_pub] = ACTIONS(1041),
    [anon_sym_test] = ACTIONS(1041),
    [anon_sym_comptime] = ACTIONS(1041),
    [anon_sym_export] = ACTIONS(1041),
    [anon_sym_extern] = ACTIONS(1041),
    [anon_sym_inline] = ACTIONS(1041),
    [anon_sym_noinline] = ACTIONS(1041),
    [anon_sym_threadlocal] = ACTIONS(1041),
    [anon_sym_usingnamespace] = ACTIONS(1041),
    [anon_sym_fn] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_const] = ACTIONS(1041),
    [anon_sym_var] = ACTIONS(1041),
    [anon_sym_else] = ACTIONS(1041),
    [anon_sym_or] = ACTIONS(1041),
    [anon_sym_and] = ACTIONS(1041),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_async] = ACTIONS(1041),
    [anon_sym_DOT] = ACTIONS(1041),
    [anon_sym_error] = ACTIONS(1041),
    [anon_sym_false] = ACTIONS(1041),
    [anon_sym_null] = ACTIONS(1041),
    [anon_sym_anyframe] = ACTIONS(1041),
    [anon_sym_true] = ACTIONS(1041),
    [anon_sym_undefined] = ACTIONS(1041),
    [anon_sym_unreachable] = ACTIONS(1041),
    [sym_BuildinTypeExpr] = ACTIONS(1041),
    [anon_sym_packed] = ACTIONS(1041),
    [anon_sym_LPAREN] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_while] = ACTIONS(1041),
    [anon_sym_for] = ACTIONS(1041),
    [anon_sym_PIPE] = ACTIONS(1041),
    [anon_sym_STAR] = ACTIONS(1041),
    [anon_sym_EQ_EQ] = ACTIONS(1039),
    [anon_sym_BANG_EQ] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_GT] = ACTIONS(1041),
    [anon_sym_LT_EQ] = ACTIONS(1039),
    [anon_sym_GT_EQ] = ACTIONS(1039),
    [anon_sym_AMP] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(1039),
    [anon_sym_orelse] = ACTIONS(1041),
    [anon_sym_catch] = ACTIONS(1041),
    [anon_sym_LT_LT] = ACTIONS(1041),
    [anon_sym_GT_GT] = ACTIONS(1039),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1039),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1039),
    [anon_sym_DASH_PERCENT] = ACTIONS(1039),
    [anon_sym_PLUS_PIPE] = ACTIONS(1039),
    [anon_sym_DASH_PIPE] = ACTIONS(1039),
    [anon_sym_PIPE_PIPE] = ACTIONS(1039),
    [anon_sym_SLASH] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1039),
    [anon_sym_STAR_STAR] = ACTIONS(1039),
    [anon_sym_STAR_PERCENT] = ACTIONS(1039),
    [anon_sym_STAR_PIPE] = ACTIONS(1039),
    [anon_sym_QMARK] = ACTIONS(1039),
    [anon_sym_DOT_STAR] = ACTIONS(1063),
    [anon_sym_DOT_QMARK] = ACTIONS(1063),
    [anon_sym_struct] = ACTIONS(1041),
    [anon_sym_opaque] = ACTIONS(1041),
    [anon_sym_enum] = ACTIONS(1041),
    [anon_sym_union] = ACTIONS(1041),
    [sym_doc_comment] = ACTIONS(1039),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1039),
    [aux_sym_FLOAT_token1] = ACTIONS(1039),
    [aux_sym_FLOAT_token2] = ACTIONS(1039),
    [aux_sym_FLOAT_token3] = ACTIONS(1039),
    [aux_sym_FLOAT_token4] = ACTIONS(1039),
    [aux_sym_INTEGER_token1] = ACTIONS(1039),
    [aux_sym_INTEGER_token2] = ACTIONS(1039),
    [aux_sym_INTEGER_token3] = ACTIONS(1041),
    [aux_sym_INTEGER_token4] = ACTIONS(1041),
    [anon_sym_DQUOTE] = ACTIONS(1039),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1039),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(1039),
  },
  [407] = {
    [sym_CompareOp] = STATE(290),
    [sym_BitwiseOp] = STATE(289),
    [sym_BitShiftOp] = STATE(288),
    [sym_AdditionOp] = STATE(287),
    [sym_MultiplyOp] = STATE(286),
    [ts_builtin_sym_end] = ACTIONS(1072),
    [anon_sym_COMMA] = ACTIONS(1072),
    [anon_sym_pub] = ACTIONS(1074),
    [anon_sym_test] = ACTIONS(1074),
    [anon_sym_comptime] = ACTIONS(1074),
    [anon_sym_export] = ACTIONS(1074),
    [anon_sym_extern] = ACTIONS(1074),
    [anon_sym_inline] = ACTIONS(1074),
    [anon_sym_noinline] = ACTIONS(1074),
    [anon_sym_threadlocal] = ACTIONS(1074),
    [anon_sym_usingnamespace] = ACTIONS(1074),
    [anon_sym_fn] = ACTIONS(1074),
    [anon_sym_const] = ACTIONS(1074),
    [anon_sym_var] = ACTIONS(1074),
    [anon_sym_else] = ACTIONS(1074),
    [anon_sym_or] = ACTIONS(1074),
    [anon_sym_and] = ACTIONS(1074),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [anon_sym_async] = ACTIONS(1074),
    [anon_sym_DOT] = ACTIONS(1072),
    [anon_sym_error] = ACTIONS(1074),
    [anon_sym_false] = ACTIONS(1074),
    [anon_sym_null] = ACTIONS(1074),
    [anon_sym_anyframe] = ACTIONS(1074),
    [anon_sym_true] = ACTIONS(1074),
    [anon_sym_undefined] = ACTIONS(1074),
    [anon_sym_unreachable] = ACTIONS(1074),
    [sym_BuildinTypeExpr] = ACTIONS(1074),
    [anon_sym_packed] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1074),
    [anon_sym_while] = ACTIONS(1074),
    [anon_sym_for] = ACTIONS(1074),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1074),
    [anon_sym_opaque] = ACTIONS(1074),
    [anon_sym_enum] = ACTIONS(1074),
    [anon_sym_union] = ACTIONS(1074),
    [sym_doc_comment] = ACTIONS(1072),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1072),
    [aux_sym_FLOAT_token1] = ACTIONS(1072),
    [aux_sym_FLOAT_token2] = ACTIONS(1072),
    [aux_sym_FLOAT_token3] = ACTIONS(1072),
    [aux_sym_FLOAT_token4] = ACTIONS(1072),
    [aux_sym_INTEGER_token1] = ACTIONS(1072),
    [aux_sym_INTEGER_token2] = ACTIONS(1072),
    [aux_sym_INTEGER_token3] = ACTIONS(1074),
    [aux_sym_INTEGER_token4] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1072),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(1072),
  },
  [408] = {
    [sym_CompareOp] = STATE(290),
    [sym_BitwiseOp] = STATE(289),
    [sym_BitShiftOp] = STATE(288),
    [sym_AdditionOp] = STATE(287),
    [sym_MultiplyOp] = STATE(286),
    [ts_builtin_sym_end] = ACTIONS(1076),
    [anon_sym_COMMA] = ACTIONS(1076),
    [anon_sym_pub] = ACTIONS(1078),
    [anon_sym_test] = ACTIONS(1078),
    [anon_sym_comptime] = ACTIONS(1078),
    [anon_sym_export] = ACTIONS(1078),
    [anon_sym_extern] = ACTIONS(1078),
    [anon_sym_inline] = ACTIONS(1078),
    [anon_sym_noinline] = ACTIONS(1078),
    [anon_sym_threadlocal] = ACTIONS(1078),
    [anon_sym_usingnamespace] = ACTIONS(1078),
    [anon_sym_fn] = ACTIONS(1078),
    [anon_sym_const] = ACTIONS(1078),
    [anon_sym_var] = ACTIONS(1078),
    [anon_sym_else] = ACTIONS(1078),
    [anon_sym_or] = ACTIONS(1011),
    [anon_sym_and] = ACTIONS(1013),
    [anon_sym_RBRACE] = ACTIONS(1076),
    [anon_sym_async] = ACTIONS(1078),
    [anon_sym_DOT] = ACTIONS(1076),
    [anon_sym_error] = ACTIONS(1078),
    [anon_sym_false] = ACTIONS(1078),
    [anon_sym_null] = ACTIONS(1078),
    [anon_sym_anyframe] = ACTIONS(1078),
    [anon_sym_true] = ACTIONS(1078),
    [anon_sym_undefined] = ACTIONS(1078),
    [anon_sym_unreachable] = ACTIONS(1078),
    [sym_BuildinTypeExpr] = ACTIONS(1078),
    [anon_sym_packed] = ACTIONS(1078),
    [anon_sym_LPAREN] = ACTIONS(1076),
    [anon_sym_switch] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_if] = ACTIONS(1078),
    [anon_sym_while] = ACTIONS(1078),
    [anon_sym_for] = ACTIONS(1078),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1076),
    [anon_sym_struct] = ACTIONS(1078),
    [anon_sym_opaque] = ACTIONS(1078),
    [anon_sym_enum] = ACTIONS(1078),
    [anon_sym_union] = ACTIONS(1078),
    [sym_doc_comment] = ACTIONS(1076),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1076),
    [aux_sym_FLOAT_token1] = ACTIONS(1076),
    [aux_sym_FLOAT_token2] = ACTIONS(1076),
    [aux_sym_FLOAT_token3] = ACTIONS(1076),
    [aux_sym_FLOAT_token4] = ACTIONS(1076),
    [aux_sym_INTEGER_token1] = ACTIONS(1076),
    [aux_sym_INTEGER_token2] = ACTIONS(1076),
    [aux_sym_INTEGER_token3] = ACTIONS(1078),
    [aux_sym_INTEGER_token4] = ACTIONS(1078),
    [anon_sym_DQUOTE] = ACTIONS(1076),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1076),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1078),
    [anon_sym_AT] = ACTIONS(1076),
  },
  [409] = {
    [ts_builtin_sym_end] = ACTIONS(556),
    [anon_sym_COMMA] = ACTIONS(556),
    [anon_sym_pub] = ACTIONS(558),
    [anon_sym_test] = ACTIONS(558),
    [anon_sym_comptime] = ACTIONS(558),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_extern] = ACTIONS(558),
    [anon_sym_inline] = ACTIONS(558),
    [anon_sym_noinline] = ACTIONS(558),
    [anon_sym_threadlocal] = ACTIONS(558),
    [anon_sym_usingnamespace] = ACTIONS(558),
    [anon_sym_fn] = ACTIONS(558),
    [anon_sym_BANG] = ACTIONS(558),
    [anon_sym_const] = ACTIONS(558),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_COLON] = ACTIONS(556),
    [anon_sym_else] = ACTIONS(558),
    [anon_sym_or] = ACTIONS(558),
    [anon_sym_and] = ACTIONS(558),
    [anon_sym_LBRACE] = ACTIONS(556),
    [anon_sym_RBRACE] = ACTIONS(556),
    [anon_sym_async] = ACTIONS(558),
    [anon_sym_DOT] = ACTIONS(558),
    [anon_sym_error] = ACTIONS(558),
    [anon_sym_false] = ACTIONS(558),
    [anon_sym_null] = ACTIONS(558),
    [anon_sym_anyframe] = ACTIONS(558),
    [anon_sym_true] = ACTIONS(558),
    [anon_sym_undefined] = ACTIONS(558),
    [anon_sym_unreachable] = ACTIONS(558),
    [sym_BuildinTypeExpr] = ACTIONS(558),
    [anon_sym_packed] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_switch] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(556),
    [anon_sym_if] = ACTIONS(558),
    [anon_sym_while] = ACTIONS(558),
    [anon_sym_for] = ACTIONS(558),
    [anon_sym_PIPE] = ACTIONS(558),
    [anon_sym_STAR] = ACTIONS(558),
    [anon_sym_EQ_EQ] = ACTIONS(556),
    [anon_sym_BANG_EQ] = ACTIONS(556),
    [anon_sym_LT] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(558),
    [anon_sym_LT_EQ] = ACTIONS(556),
    [anon_sym_GT_EQ] = ACTIONS(556),
    [anon_sym_AMP] = ACTIONS(556),
    [anon_sym_CARET] = ACTIONS(556),
    [anon_sym_orelse] = ACTIONS(558),
    [anon_sym_catch] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(558),
    [anon_sym_GT_GT] = ACTIONS(556),
    [anon_sym_LT_LT_PIPE] = ACTIONS(556),
    [anon_sym_PLUS] = ACTIONS(558),
    [anon_sym_DASH] = ACTIONS(558),
    [anon_sym_PLUS_PLUS] = ACTIONS(556),
    [anon_sym_PLUS_PERCENT] = ACTIONS(556),
    [anon_sym_DASH_PERCENT] = ACTIONS(556),
    [anon_sym_PLUS_PIPE] = ACTIONS(556),
    [anon_sym_DASH_PIPE] = ACTIONS(556),
    [anon_sym_PIPE_PIPE] = ACTIONS(556),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_PERCENT] = ACTIONS(556),
    [anon_sym_STAR_STAR] = ACTIONS(556),
    [anon_sym_STAR_PERCENT] = ACTIONS(556),
    [anon_sym_STAR_PIPE] = ACTIONS(556),
    [anon_sym_QMARK] = ACTIONS(556),
    [anon_sym_DOT_STAR] = ACTIONS(556),
    [anon_sym_DOT_QMARK] = ACTIONS(556),
    [anon_sym_struct] = ACTIONS(558),
    [anon_sym_opaque] = ACTIONS(558),
    [anon_sym_enum] = ACTIONS(558),
    [anon_sym_union] = ACTIONS(558),
    [sym_doc_comment] = ACTIONS(556),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(556),
    [aux_sym_FLOAT_token1] = ACTIONS(556),
    [aux_sym_FLOAT_token2] = ACTIONS(556),
    [aux_sym_FLOAT_token3] = ACTIONS(556),
    [aux_sym_FLOAT_token4] = ACTIONS(556),
    [aux_sym_INTEGER_token1] = ACTIONS(556),
    [aux_sym_INTEGER_token2] = ACTIONS(556),
    [aux_sym_INTEGER_token3] = ACTIONS(558),
    [aux_sym_INTEGER_token4] = ACTIONS(558),
    [anon_sym_DQUOTE] = ACTIONS(556),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(556),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(558),
    [anon_sym_AT] = ACTIONS(556),
  },
  [410] = {
    [ts_builtin_sym_end] = ACTIONS(560),
    [anon_sym_COMMA] = ACTIONS(560),
    [anon_sym_pub] = ACTIONS(562),
    [anon_sym_test] = ACTIONS(562),
    [anon_sym_comptime] = ACTIONS(562),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_extern] = ACTIONS(562),
    [anon_sym_inline] = ACTIONS(562),
    [anon_sym_noinline] = ACTIONS(562),
    [anon_sym_threadlocal] = ACTIONS(562),
    [anon_sym_usingnamespace] = ACTIONS(562),
    [anon_sym_fn] = ACTIONS(562),
    [anon_sym_BANG] = ACTIONS(562),
    [anon_sym_const] = ACTIONS(562),
    [anon_sym_var] = ACTIONS(562),
    [anon_sym_COLON] = ACTIONS(560),
    [anon_sym_else] = ACTIONS(562),
    [anon_sym_or] = ACTIONS(562),
    [anon_sym_and] = ACTIONS(562),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_RBRACE] = ACTIONS(560),
    [anon_sym_async] = ACTIONS(562),
    [anon_sym_DOT] = ACTIONS(562),
    [anon_sym_error] = ACTIONS(562),
    [anon_sym_false] = ACTIONS(562),
    [anon_sym_null] = ACTIONS(562),
    [anon_sym_anyframe] = ACTIONS(562),
    [anon_sym_true] = ACTIONS(562),
    [anon_sym_undefined] = ACTIONS(562),
    [anon_sym_unreachable] = ACTIONS(562),
    [sym_BuildinTypeExpr] = ACTIONS(562),
    [anon_sym_packed] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(560),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_while] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(562),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_STAR] = ACTIONS(562),
    [anon_sym_EQ_EQ] = ACTIONS(560),
    [anon_sym_BANG_EQ] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_LT_EQ] = ACTIONS(560),
    [anon_sym_GT_EQ] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(560),
    [anon_sym_CARET] = ACTIONS(560),
    [anon_sym_orelse] = ACTIONS(562),
    [anon_sym_catch] = ACTIONS(562),
    [anon_sym_LT_LT] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(560),
    [anon_sym_LT_LT_PIPE] = ACTIONS(560),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(560),
    [anon_sym_PLUS_PERCENT] = ACTIONS(560),
    [anon_sym_DASH_PERCENT] = ACTIONS(560),
    [anon_sym_PLUS_PIPE] = ACTIONS(560),
    [anon_sym_DASH_PIPE] = ACTIONS(560),
    [anon_sym_PIPE_PIPE] = ACTIONS(560),
    [anon_sym_SLASH] = ACTIONS(562),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_STAR_STAR] = ACTIONS(560),
    [anon_sym_STAR_PERCENT] = ACTIONS(560),
    [anon_sym_STAR_PIPE] = ACTIONS(560),
    [anon_sym_QMARK] = ACTIONS(560),
    [anon_sym_DOT_STAR] = ACTIONS(560),
    [anon_sym_DOT_QMARK] = ACTIONS(560),
    [anon_sym_struct] = ACTIONS(562),
    [anon_sym_opaque] = ACTIONS(562),
    [anon_sym_enum] = ACTIONS(562),
    [anon_sym_union] = ACTIONS(562),
    [sym_doc_comment] = ACTIONS(560),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(560),
    [aux_sym_FLOAT_token1] = ACTIONS(560),
    [aux_sym_FLOAT_token2] = ACTIONS(560),
    [aux_sym_FLOAT_token3] = ACTIONS(560),
    [aux_sym_FLOAT_token4] = ACTIONS(560),
    [aux_sym_INTEGER_token1] = ACTIONS(560),
    [aux_sym_INTEGER_token2] = ACTIONS(560),
    [aux_sym_INTEGER_token3] = ACTIONS(562),
    [aux_sym_INTEGER_token4] = ACTIONS(562),
    [anon_sym_DQUOTE] = ACTIONS(560),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(560),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(562),
    [anon_sym_AT] = ACTIONS(560),
  },
  [411] = {
    [sym_CompareOp] = STATE(290),
    [sym_BitwiseOp] = STATE(289),
    [sym_BitShiftOp] = STATE(288),
    [sym_AdditionOp] = STATE(287),
    [sym_MultiplyOp] = STATE(286),
    [ts_builtin_sym_end] = ACTIONS(1080),
    [anon_sym_COMMA] = ACTIONS(1080),
    [anon_sym_pub] = ACTIONS(1082),
    [anon_sym_test] = ACTIONS(1082),
    [anon_sym_comptime] = ACTIONS(1082),
    [anon_sym_export] = ACTIONS(1082),
    [anon_sym_extern] = ACTIONS(1082),
    [anon_sym_inline] = ACTIONS(1082),
    [anon_sym_noinline] = ACTIONS(1082),
    [anon_sym_threadlocal] = ACTIONS(1082),
    [anon_sym_usingnamespace] = ACTIONS(1082),
    [anon_sym_fn] = ACTIONS(1082),
    [anon_sym_const] = ACTIONS(1082),
    [anon_sym_var] = ACTIONS(1082),
    [anon_sym_else] = ACTIONS(1082),
    [anon_sym_or] = ACTIONS(1011),
    [anon_sym_and] = ACTIONS(1013),
    [anon_sym_RBRACE] = ACTIONS(1080),
    [anon_sym_async] = ACTIONS(1082),
    [anon_sym_DOT] = ACTIONS(1080),
    [anon_sym_error] = ACTIONS(1082),
    [anon_sym_false] = ACTIONS(1082),
    [anon_sym_null] = ACTIONS(1082),
    [anon_sym_anyframe] = ACTIONS(1082),
    [anon_sym_true] = ACTIONS(1082),
    [anon_sym_undefined] = ACTIONS(1082),
    [anon_sym_unreachable] = ACTIONS(1082),
    [sym_BuildinTypeExpr] = ACTIONS(1082),
    [anon_sym_packed] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1080),
    [anon_sym_switch] = ACTIONS(1082),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [anon_sym_if] = ACTIONS(1082),
    [anon_sym_while] = ACTIONS(1082),
    [anon_sym_for] = ACTIONS(1082),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1080),
    [anon_sym_struct] = ACTIONS(1082),
    [anon_sym_opaque] = ACTIONS(1082),
    [anon_sym_enum] = ACTIONS(1082),
    [anon_sym_union] = ACTIONS(1082),
    [sym_doc_comment] = ACTIONS(1080),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1080),
    [aux_sym_FLOAT_token1] = ACTIONS(1080),
    [aux_sym_FLOAT_token2] = ACTIONS(1080),
    [aux_sym_FLOAT_token3] = ACTIONS(1080),
    [aux_sym_FLOAT_token4] = ACTIONS(1080),
    [aux_sym_INTEGER_token1] = ACTIONS(1080),
    [aux_sym_INTEGER_token2] = ACTIONS(1080),
    [aux_sym_INTEGER_token3] = ACTIONS(1082),
    [aux_sym_INTEGER_token4] = ACTIONS(1082),
    [anon_sym_DQUOTE] = ACTIONS(1080),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1080),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1082),
    [anon_sym_AT] = ACTIONS(1080),
  },
  [412] = {
    [sym_CompareOp] = STATE(290),
    [sym_BitwiseOp] = STATE(289),
    [sym_BitShiftOp] = STATE(288),
    [sym_AdditionOp] = STATE(287),
    [sym_MultiplyOp] = STATE(286),
    [ts_builtin_sym_end] = ACTIONS(1072),
    [anon_sym_COMMA] = ACTIONS(1072),
    [anon_sym_pub] = ACTIONS(1074),
    [anon_sym_test] = ACTIONS(1074),
    [anon_sym_comptime] = ACTIONS(1074),
    [anon_sym_export] = ACTIONS(1074),
    [anon_sym_extern] = ACTIONS(1074),
    [anon_sym_inline] = ACTIONS(1074),
    [anon_sym_noinline] = ACTIONS(1074),
    [anon_sym_threadlocal] = ACTIONS(1074),
    [anon_sym_usingnamespace] = ACTIONS(1074),
    [anon_sym_fn] = ACTIONS(1074),
    [anon_sym_const] = ACTIONS(1074),
    [anon_sym_var] = ACTIONS(1074),
    [anon_sym_else] = ACTIONS(1074),
    [anon_sym_or] = ACTIONS(1074),
    [anon_sym_and] = ACTIONS(1013),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [anon_sym_async] = ACTIONS(1074),
    [anon_sym_DOT] = ACTIONS(1072),
    [anon_sym_error] = ACTIONS(1074),
    [anon_sym_false] = ACTIONS(1074),
    [anon_sym_null] = ACTIONS(1074),
    [anon_sym_anyframe] = ACTIONS(1074),
    [anon_sym_true] = ACTIONS(1074),
    [anon_sym_undefined] = ACTIONS(1074),
    [anon_sym_unreachable] = ACTIONS(1074),
    [sym_BuildinTypeExpr] = ACTIONS(1074),
    [anon_sym_packed] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1074),
    [anon_sym_while] = ACTIONS(1074),
    [anon_sym_for] = ACTIONS(1074),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1074),
    [anon_sym_opaque] = ACTIONS(1074),
    [anon_sym_enum] = ACTIONS(1074),
    [anon_sym_union] = ACTIONS(1074),
    [sym_doc_comment] = ACTIONS(1072),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1072),
    [aux_sym_FLOAT_token1] = ACTIONS(1072),
    [aux_sym_FLOAT_token2] = ACTIONS(1072),
    [aux_sym_FLOAT_token3] = ACTIONS(1072),
    [aux_sym_FLOAT_token4] = ACTIONS(1072),
    [aux_sym_INTEGER_token1] = ACTIONS(1072),
    [aux_sym_INTEGER_token2] = ACTIONS(1072),
    [aux_sym_INTEGER_token3] = ACTIONS(1074),
    [aux_sym_INTEGER_token4] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1072),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(1072),
  },
  [413] = {
    [sym__ElseTypeExprTail] = STATE(576),
    [ts_builtin_sym_end] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1055),
    [anon_sym_pub] = ACTIONS(1053),
    [anon_sym_test] = ACTIONS(1053),
    [anon_sym_comptime] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1053),
    [anon_sym_extern] = ACTIONS(1053),
    [anon_sym_inline] = ACTIONS(1053),
    [anon_sym_noinline] = ACTIONS(1053),
    [anon_sym_threadlocal] = ACTIONS(1053),
    [anon_sym_usingnamespace] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1053),
    [anon_sym_var] = ACTIONS(1053),
    [anon_sym_else] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(1053),
    [anon_sym_and] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [anon_sym_RBRACE] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(1053),
    [anon_sym_error] = ACTIONS(1053),
    [anon_sym_false] = ACTIONS(1053),
    [anon_sym_null] = ACTIONS(1053),
    [anon_sym_anyframe] = ACTIONS(1053),
    [anon_sym_true] = ACTIONS(1053),
    [anon_sym_undefined] = ACTIONS(1053),
    [anon_sym_unreachable] = ACTIONS(1053),
    [sym_BuildinTypeExpr] = ACTIONS(1053),
    [anon_sym_packed] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1055),
    [anon_sym_switch] = ACTIONS(1053),
    [anon_sym_LBRACK] = ACTIONS(1055),
    [anon_sym_if] = ACTIONS(1053),
    [anon_sym_while] = ACTIONS(1053),
    [anon_sym_for] = ACTIONS(1053),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_EQ_EQ] = ACTIONS(1055),
    [anon_sym_BANG_EQ] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_LT_EQ] = ACTIONS(1055),
    [anon_sym_GT_EQ] = ACTIONS(1055),
    [anon_sym_AMP] = ACTIONS(1055),
    [anon_sym_CARET] = ACTIONS(1055),
    [anon_sym_orelse] = ACTIONS(1053),
    [anon_sym_catch] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_DASH] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1055),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1055),
    [anon_sym_DASH_PERCENT] = ACTIONS(1055),
    [anon_sym_PLUS_PIPE] = ACTIONS(1055),
    [anon_sym_DASH_PIPE] = ACTIONS(1055),
    [anon_sym_PIPE_PIPE] = ACTIONS(1055),
    [anon_sym_SLASH] = ACTIONS(1053),
    [anon_sym_PERCENT] = ACTIONS(1055),
    [anon_sym_STAR_STAR] = ACTIONS(1055),
    [anon_sym_STAR_PERCENT] = ACTIONS(1055),
    [anon_sym_STAR_PIPE] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1055),
    [anon_sym_DOT_STAR] = ACTIONS(1055),
    [anon_sym_DOT_QMARK] = ACTIONS(1055),
    [anon_sym_struct] = ACTIONS(1053),
    [anon_sym_opaque] = ACTIONS(1053),
    [anon_sym_enum] = ACTIONS(1053),
    [anon_sym_union] = ACTIONS(1053),
    [sym_doc_comment] = ACTIONS(1055),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1055),
    [aux_sym_FLOAT_token1] = ACTIONS(1055),
    [aux_sym_FLOAT_token2] = ACTIONS(1055),
    [aux_sym_FLOAT_token3] = ACTIONS(1055),
    [aux_sym_FLOAT_token4] = ACTIONS(1055),
    [aux_sym_INTEGER_token1] = ACTIONS(1055),
    [aux_sym_INTEGER_token2] = ACTIONS(1055),
    [aux_sym_INTEGER_token3] = ACTIONS(1053),
    [aux_sym_INTEGER_token4] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1055),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1055),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1053),
    [anon_sym_AT] = ACTIONS(1055),
  },
  [414] = {
    [ts_builtin_sym_end] = ACTIONS(536),
    [anon_sym_COMMA] = ACTIONS(536),
    [anon_sym_pub] = ACTIONS(538),
    [anon_sym_test] = ACTIONS(538),
    [anon_sym_comptime] = ACTIONS(538),
    [anon_sym_export] = ACTIONS(538),
    [anon_sym_extern] = ACTIONS(538),
    [anon_sym_inline] = ACTIONS(538),
    [anon_sym_noinline] = ACTIONS(538),
    [anon_sym_threadlocal] = ACTIONS(538),
    [anon_sym_usingnamespace] = ACTIONS(538),
    [anon_sym_fn] = ACTIONS(538),
    [anon_sym_BANG] = ACTIONS(538),
    [anon_sym_const] = ACTIONS(538),
    [anon_sym_var] = ACTIONS(538),
    [anon_sym_COLON] = ACTIONS(536),
    [anon_sym_else] = ACTIONS(538),
    [anon_sym_or] = ACTIONS(538),
    [anon_sym_and] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(536),
    [anon_sym_RBRACE] = ACTIONS(536),
    [anon_sym_async] = ACTIONS(538),
    [anon_sym_DOT] = ACTIONS(538),
    [anon_sym_error] = ACTIONS(538),
    [anon_sym_false] = ACTIONS(538),
    [anon_sym_null] = ACTIONS(538),
    [anon_sym_anyframe] = ACTIONS(538),
    [anon_sym_true] = ACTIONS(538),
    [anon_sym_undefined] = ACTIONS(538),
    [anon_sym_unreachable] = ACTIONS(538),
    [sym_BuildinTypeExpr] = ACTIONS(538),
    [anon_sym_packed] = ACTIONS(538),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_switch] = ACTIONS(538),
    [anon_sym_LBRACK] = ACTIONS(536),
    [anon_sym_if] = ACTIONS(538),
    [anon_sym_while] = ACTIONS(538),
    [anon_sym_for] = ACTIONS(538),
    [anon_sym_PIPE] = ACTIONS(538),
    [anon_sym_STAR] = ACTIONS(538),
    [anon_sym_EQ_EQ] = ACTIONS(536),
    [anon_sym_BANG_EQ] = ACTIONS(536),
    [anon_sym_LT] = ACTIONS(538),
    [anon_sym_GT] = ACTIONS(538),
    [anon_sym_LT_EQ] = ACTIONS(536),
    [anon_sym_GT_EQ] = ACTIONS(536),
    [anon_sym_AMP] = ACTIONS(536),
    [anon_sym_CARET] = ACTIONS(536),
    [anon_sym_orelse] = ACTIONS(538),
    [anon_sym_catch] = ACTIONS(538),
    [anon_sym_LT_LT] = ACTIONS(538),
    [anon_sym_GT_GT] = ACTIONS(536),
    [anon_sym_LT_LT_PIPE] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(538),
    [anon_sym_DASH] = ACTIONS(538),
    [anon_sym_PLUS_PLUS] = ACTIONS(536),
    [anon_sym_PLUS_PERCENT] = ACTIONS(536),
    [anon_sym_DASH_PERCENT] = ACTIONS(536),
    [anon_sym_PLUS_PIPE] = ACTIONS(536),
    [anon_sym_DASH_PIPE] = ACTIONS(536),
    [anon_sym_PIPE_PIPE] = ACTIONS(536),
    [anon_sym_SLASH] = ACTIONS(538),
    [anon_sym_PERCENT] = ACTIONS(536),
    [anon_sym_STAR_STAR] = ACTIONS(536),
    [anon_sym_STAR_PERCENT] = ACTIONS(536),
    [anon_sym_STAR_PIPE] = ACTIONS(536),
    [anon_sym_QMARK] = ACTIONS(536),
    [anon_sym_DOT_STAR] = ACTIONS(536),
    [anon_sym_DOT_QMARK] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_opaque] = ACTIONS(538),
    [anon_sym_enum] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(538),
    [sym_doc_comment] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(536),
    [aux_sym_FLOAT_token1] = ACTIONS(536),
    [aux_sym_FLOAT_token2] = ACTIONS(536),
    [aux_sym_FLOAT_token3] = ACTIONS(536),
    [aux_sym_FLOAT_token4] = ACTIONS(536),
    [aux_sym_INTEGER_token1] = ACTIONS(536),
    [aux_sym_INTEGER_token2] = ACTIONS(536),
    [aux_sym_INTEGER_token3] = ACTIONS(538),
    [aux_sym_INTEGER_token4] = ACTIONS(538),
    [anon_sym_DQUOTE] = ACTIONS(536),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(536),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(538),
    [anon_sym_AT] = ACTIONS(536),
  },
  [415] = {
    [sym_LINESTRING] = STATE(415),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(415),
    [ts_builtin_sym_end] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_pub] = ACTIONS(1067),
    [anon_sym_test] = ACTIONS(1067),
    [anon_sym_comptime] = ACTIONS(1067),
    [anon_sym_export] = ACTIONS(1067),
    [anon_sym_extern] = ACTIONS(1067),
    [anon_sym_inline] = ACTIONS(1067),
    [anon_sym_noinline] = ACTIONS(1067),
    [anon_sym_threadlocal] = ACTIONS(1067),
    [anon_sym_usingnamespace] = ACTIONS(1067),
    [anon_sym_fn] = ACTIONS(1067),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_const] = ACTIONS(1067),
    [anon_sym_var] = ACTIONS(1067),
    [anon_sym_or] = ACTIONS(1067),
    [anon_sym_and] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_async] = ACTIONS(1067),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_error] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [anon_sym_null] = ACTIONS(1067),
    [anon_sym_anyframe] = ACTIONS(1067),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_undefined] = ACTIONS(1067),
    [anon_sym_unreachable] = ACTIONS(1067),
    [sym_BuildinTypeExpr] = ACTIONS(1067),
    [anon_sym_packed] = ACTIONS(1067),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_switch] = ACTIONS(1067),
    [anon_sym_LBRACK] = ACTIONS(1065),
    [anon_sym_if] = ACTIONS(1067),
    [anon_sym_while] = ACTIONS(1067),
    [anon_sym_for] = ACTIONS(1067),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_BANG_EQ] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_LT_EQ] = ACTIONS(1065),
    [anon_sym_GT_EQ] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1065),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym_orelse] = ACTIONS(1067),
    [anon_sym_catch] = ACTIONS(1067),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1065),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1065),
    [anon_sym_DASH_PERCENT] = ACTIONS(1065),
    [anon_sym_PLUS_PIPE] = ACTIONS(1065),
    [anon_sym_DASH_PIPE] = ACTIONS(1065),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1067),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_STAR_STAR] = ACTIONS(1065),
    [anon_sym_STAR_PERCENT] = ACTIONS(1065),
    [anon_sym_STAR_PIPE] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_DOT_STAR] = ACTIONS(1065),
    [anon_sym_DOT_QMARK] = ACTIONS(1065),
    [anon_sym_struct] = ACTIONS(1067),
    [anon_sym_opaque] = ACTIONS(1067),
    [anon_sym_enum] = ACTIONS(1067),
    [anon_sym_union] = ACTIONS(1067),
    [sym_doc_comment] = ACTIONS(1065),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [aux_sym_FLOAT_token1] = ACTIONS(1065),
    [aux_sym_FLOAT_token2] = ACTIONS(1065),
    [aux_sym_FLOAT_token3] = ACTIONS(1065),
    [aux_sym_FLOAT_token4] = ACTIONS(1065),
    [aux_sym_INTEGER_token1] = ACTIONS(1065),
    [aux_sym_INTEGER_token2] = ACTIONS(1065),
    [aux_sym_INTEGER_token3] = ACTIONS(1067),
    [aux_sym_INTEGER_token4] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1086),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1065),
  },
  [416] = {
    [sym_CompareOp] = STATE(290),
    [sym_BitwiseOp] = STATE(289),
    [sym_BitShiftOp] = STATE(288),
    [sym_AdditionOp] = STATE(287),
    [sym_MultiplyOp] = STATE(286),
    [ts_builtin_sym_end] = ACTIONS(1072),
    [anon_sym_COMMA] = ACTIONS(1072),
    [anon_sym_pub] = ACTIONS(1074),
    [anon_sym_test] = ACTIONS(1074),
    [anon_sym_comptime] = ACTIONS(1074),
    [anon_sym_export] = ACTIONS(1074),
    [anon_sym_extern] = ACTIONS(1074),
    [anon_sym_inline] = ACTIONS(1074),
    [anon_sym_noinline] = ACTIONS(1074),
    [anon_sym_threadlocal] = ACTIONS(1074),
    [anon_sym_usingnamespace] = ACTIONS(1074),
    [anon_sym_fn] = ACTIONS(1074),
    [anon_sym_const] = ACTIONS(1074),
    [anon_sym_var] = ACTIONS(1074),
    [anon_sym_else] = ACTIONS(1074),
    [anon_sym_or] = ACTIONS(1074),
    [anon_sym_and] = ACTIONS(1074),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [anon_sym_async] = ACTIONS(1074),
    [anon_sym_DOT] = ACTIONS(1072),
    [anon_sym_error] = ACTIONS(1074),
    [anon_sym_false] = ACTIONS(1074),
    [anon_sym_null] = ACTIONS(1074),
    [anon_sym_anyframe] = ACTIONS(1074),
    [anon_sym_true] = ACTIONS(1074),
    [anon_sym_undefined] = ACTIONS(1074),
    [anon_sym_unreachable] = ACTIONS(1074),
    [sym_BuildinTypeExpr] = ACTIONS(1074),
    [anon_sym_packed] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1074),
    [anon_sym_while] = ACTIONS(1074),
    [anon_sym_for] = ACTIONS(1074),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1072),
    [anon_sym_BANG_EQ] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_LT_EQ] = ACTIONS(1072),
    [anon_sym_GT_EQ] = ACTIONS(1072),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_orelse] = ACTIONS(1074),
    [anon_sym_catch] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(1074),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1074),
    [anon_sym_opaque] = ACTIONS(1074),
    [anon_sym_enum] = ACTIONS(1074),
    [anon_sym_union] = ACTIONS(1074),
    [sym_doc_comment] = ACTIONS(1072),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1072),
    [aux_sym_FLOAT_token1] = ACTIONS(1072),
    [aux_sym_FLOAT_token2] = ACTIONS(1072),
    [aux_sym_FLOAT_token3] = ACTIONS(1072),
    [aux_sym_FLOAT_token4] = ACTIONS(1072),
    [aux_sym_INTEGER_token1] = ACTIONS(1072),
    [aux_sym_INTEGER_token2] = ACTIONS(1072),
    [aux_sym_INTEGER_token3] = ACTIONS(1074),
    [aux_sym_INTEGER_token4] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1072),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(1072),
  },
  [417] = {
    [sym_CompareOp] = STATE(290),
    [sym_BitwiseOp] = STATE(289),
    [sym_BitShiftOp] = STATE(288),
    [sym_AdditionOp] = STATE(287),
    [sym_MultiplyOp] = STATE(286),
    [ts_builtin_sym_end] = ACTIONS(1072),
    [anon_sym_COMMA] = ACTIONS(1072),
    [anon_sym_pub] = ACTIONS(1074),
    [anon_sym_test] = ACTIONS(1074),
    [anon_sym_comptime] = ACTIONS(1074),
    [anon_sym_export] = ACTIONS(1074),
    [anon_sym_extern] = ACTIONS(1074),
    [anon_sym_inline] = ACTIONS(1074),
    [anon_sym_noinline] = ACTIONS(1074),
    [anon_sym_threadlocal] = ACTIONS(1074),
    [anon_sym_usingnamespace] = ACTIONS(1074),
    [anon_sym_fn] = ACTIONS(1074),
    [anon_sym_const] = ACTIONS(1074),
    [anon_sym_var] = ACTIONS(1074),
    [anon_sym_else] = ACTIONS(1074),
    [anon_sym_or] = ACTIONS(1074),
    [anon_sym_and] = ACTIONS(1074),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [anon_sym_async] = ACTIONS(1074),
    [anon_sym_DOT] = ACTIONS(1072),
    [anon_sym_error] = ACTIONS(1074),
    [anon_sym_false] = ACTIONS(1074),
    [anon_sym_null] = ACTIONS(1074),
    [anon_sym_anyframe] = ACTIONS(1074),
    [anon_sym_true] = ACTIONS(1074),
    [anon_sym_undefined] = ACTIONS(1074),
    [anon_sym_unreachable] = ACTIONS(1074),
    [sym_BuildinTypeExpr] = ACTIONS(1074),
    [anon_sym_packed] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1074),
    [anon_sym_while] = ACTIONS(1074),
    [anon_sym_for] = ACTIONS(1074),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1072),
    [anon_sym_BANG_EQ] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_LT_EQ] = ACTIONS(1072),
    [anon_sym_GT_EQ] = ACTIONS(1072),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_orelse] = ACTIONS(1074),
    [anon_sym_catch] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1074),
    [anon_sym_opaque] = ACTIONS(1074),
    [anon_sym_enum] = ACTIONS(1074),
    [anon_sym_union] = ACTIONS(1074),
    [sym_doc_comment] = ACTIONS(1072),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1072),
    [aux_sym_FLOAT_token1] = ACTIONS(1072),
    [aux_sym_FLOAT_token2] = ACTIONS(1072),
    [aux_sym_FLOAT_token3] = ACTIONS(1072),
    [aux_sym_FLOAT_token4] = ACTIONS(1072),
    [aux_sym_INTEGER_token1] = ACTIONS(1072),
    [aux_sym_INTEGER_token2] = ACTIONS(1072),
    [aux_sym_INTEGER_token3] = ACTIONS(1074),
    [aux_sym_INTEGER_token4] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1072),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(1072),
  },
  [418] = {
    [sym_CompareOp] = STATE(290),
    [sym_BitwiseOp] = STATE(289),
    [sym_BitShiftOp] = STATE(288),
    [sym_AdditionOp] = STATE(287),
    [sym_MultiplyOp] = STATE(286),
    [ts_builtin_sym_end] = ACTIONS(1072),
    [anon_sym_COMMA] = ACTIONS(1072),
    [anon_sym_pub] = ACTIONS(1074),
    [anon_sym_test] = ACTIONS(1074),
    [anon_sym_comptime] = ACTIONS(1074),
    [anon_sym_export] = ACTIONS(1074),
    [anon_sym_extern] = ACTIONS(1074),
    [anon_sym_inline] = ACTIONS(1074),
    [anon_sym_noinline] = ACTIONS(1074),
    [anon_sym_threadlocal] = ACTIONS(1074),
    [anon_sym_usingnamespace] = ACTIONS(1074),
    [anon_sym_fn] = ACTIONS(1074),
    [anon_sym_const] = ACTIONS(1074),
    [anon_sym_var] = ACTIONS(1074),
    [anon_sym_else] = ACTIONS(1074),
    [anon_sym_or] = ACTIONS(1074),
    [anon_sym_and] = ACTIONS(1074),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [anon_sym_async] = ACTIONS(1074),
    [anon_sym_DOT] = ACTIONS(1072),
    [anon_sym_error] = ACTIONS(1074),
    [anon_sym_false] = ACTIONS(1074),
    [anon_sym_null] = ACTIONS(1074),
    [anon_sym_anyframe] = ACTIONS(1074),
    [anon_sym_true] = ACTIONS(1074),
    [anon_sym_undefined] = ACTIONS(1074),
    [anon_sym_unreachable] = ACTIONS(1074),
    [sym_BuildinTypeExpr] = ACTIONS(1074),
    [anon_sym_packed] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1074),
    [anon_sym_while] = ACTIONS(1074),
    [anon_sym_for] = ACTIONS(1074),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1072),
    [anon_sym_BANG_EQ] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_LT_EQ] = ACTIONS(1072),
    [anon_sym_GT_EQ] = ACTIONS(1072),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1074),
    [anon_sym_opaque] = ACTIONS(1074),
    [anon_sym_enum] = ACTIONS(1074),
    [anon_sym_union] = ACTIONS(1074),
    [sym_doc_comment] = ACTIONS(1072),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1072),
    [aux_sym_FLOAT_token1] = ACTIONS(1072),
    [aux_sym_FLOAT_token2] = ACTIONS(1072),
    [aux_sym_FLOAT_token3] = ACTIONS(1072),
    [aux_sym_FLOAT_token4] = ACTIONS(1072),
    [aux_sym_INTEGER_token1] = ACTIONS(1072),
    [aux_sym_INTEGER_token2] = ACTIONS(1072),
    [aux_sym_INTEGER_token3] = ACTIONS(1074),
    [aux_sym_INTEGER_token4] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1072),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(1072),
  },
  [419] = {
    [sym_CompareOp] = STATE(290),
    [sym_BitwiseOp] = STATE(289),
    [sym_BitShiftOp] = STATE(288),
    [sym_AdditionOp] = STATE(287),
    [sym_MultiplyOp] = STATE(286),
    [ts_builtin_sym_end] = ACTIONS(1072),
    [anon_sym_COMMA] = ACTIONS(1072),
    [anon_sym_pub] = ACTIONS(1074),
    [anon_sym_test] = ACTIONS(1074),
    [anon_sym_comptime] = ACTIONS(1074),
    [anon_sym_export] = ACTIONS(1074),
    [anon_sym_extern] = ACTIONS(1074),
    [anon_sym_inline] = ACTIONS(1074),
    [anon_sym_noinline] = ACTIONS(1074),
    [anon_sym_threadlocal] = ACTIONS(1074),
    [anon_sym_usingnamespace] = ACTIONS(1074),
    [anon_sym_fn] = ACTIONS(1074),
    [anon_sym_const] = ACTIONS(1074),
    [anon_sym_var] = ACTIONS(1074),
    [anon_sym_else] = ACTIONS(1074),
    [anon_sym_or] = ACTIONS(1074),
    [anon_sym_and] = ACTIONS(1074),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [anon_sym_async] = ACTIONS(1074),
    [anon_sym_DOT] = ACTIONS(1072),
    [anon_sym_error] = ACTIONS(1074),
    [anon_sym_false] = ACTIONS(1074),
    [anon_sym_null] = ACTIONS(1074),
    [anon_sym_anyframe] = ACTIONS(1074),
    [anon_sym_true] = ACTIONS(1074),
    [anon_sym_undefined] = ACTIONS(1074),
    [anon_sym_unreachable] = ACTIONS(1074),
    [sym_BuildinTypeExpr] = ACTIONS(1074),
    [anon_sym_packed] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1074),
    [anon_sym_while] = ACTIONS(1074),
    [anon_sym_for] = ACTIONS(1074),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1072),
    [anon_sym_BANG_EQ] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_LT_EQ] = ACTIONS(1072),
    [anon_sym_GT_EQ] = ACTIONS(1072),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_orelse] = ACTIONS(1074),
    [anon_sym_catch] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(1074),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1074),
    [anon_sym_PLUS_PLUS] = ACTIONS(1072),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_PERCENT] = ACTIONS(1072),
    [anon_sym_PLUS_PIPE] = ACTIONS(1072),
    [anon_sym_DASH_PIPE] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1074),
    [anon_sym_opaque] = ACTIONS(1074),
    [anon_sym_enum] = ACTIONS(1074),
    [anon_sym_union] = ACTIONS(1074),
    [sym_doc_comment] = ACTIONS(1072),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1072),
    [aux_sym_FLOAT_token1] = ACTIONS(1072),
    [aux_sym_FLOAT_token2] = ACTIONS(1072),
    [aux_sym_FLOAT_token3] = ACTIONS(1072),
    [aux_sym_FLOAT_token4] = ACTIONS(1072),
    [aux_sym_INTEGER_token1] = ACTIONS(1072),
    [aux_sym_INTEGER_token2] = ACTIONS(1072),
    [aux_sym_INTEGER_token3] = ACTIONS(1074),
    [aux_sym_INTEGER_token4] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1072),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(1072),
  },
  [420] = {
    [sym_CompareOp] = STATE(290),
    [sym_BitwiseOp] = STATE(289),
    [sym_BitShiftOp] = STATE(288),
    [sym_AdditionOp] = STATE(287),
    [sym_MultiplyOp] = STATE(286),
    [ts_builtin_sym_end] = ACTIONS(1072),
    [anon_sym_COMMA] = ACTIONS(1072),
    [anon_sym_pub] = ACTIONS(1074),
    [anon_sym_test] = ACTIONS(1074),
    [anon_sym_comptime] = ACTIONS(1074),
    [anon_sym_export] = ACTIONS(1074),
    [anon_sym_extern] = ACTIONS(1074),
    [anon_sym_inline] = ACTIONS(1074),
    [anon_sym_noinline] = ACTIONS(1074),
    [anon_sym_threadlocal] = ACTIONS(1074),
    [anon_sym_usingnamespace] = ACTIONS(1074),
    [anon_sym_fn] = ACTIONS(1074),
    [anon_sym_const] = ACTIONS(1074),
    [anon_sym_var] = ACTIONS(1074),
    [anon_sym_else] = ACTIONS(1074),
    [anon_sym_or] = ACTIONS(1074),
    [anon_sym_and] = ACTIONS(1074),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [anon_sym_async] = ACTIONS(1074),
    [anon_sym_DOT] = ACTIONS(1072),
    [anon_sym_error] = ACTIONS(1074),
    [anon_sym_false] = ACTIONS(1074),
    [anon_sym_null] = ACTIONS(1074),
    [anon_sym_anyframe] = ACTIONS(1074),
    [anon_sym_true] = ACTIONS(1074),
    [anon_sym_undefined] = ACTIONS(1074),
    [anon_sym_unreachable] = ACTIONS(1074),
    [sym_BuildinTypeExpr] = ACTIONS(1074),
    [anon_sym_packed] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1074),
    [anon_sym_while] = ACTIONS(1074),
    [anon_sym_for] = ACTIONS(1074),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_STAR] = ACTIONS(1074),
    [anon_sym_EQ_EQ] = ACTIONS(1072),
    [anon_sym_BANG_EQ] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_LT_EQ] = ACTIONS(1072),
    [anon_sym_GT_EQ] = ACTIONS(1072),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_orelse] = ACTIONS(1074),
    [anon_sym_catch] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(1074),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1074),
    [anon_sym_PLUS_PLUS] = ACTIONS(1072),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_PERCENT] = ACTIONS(1072),
    [anon_sym_PLUS_PIPE] = ACTIONS(1072),
    [anon_sym_DASH_PIPE] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1074),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_STAR_STAR] = ACTIONS(1072),
    [anon_sym_STAR_PERCENT] = ACTIONS(1072),
    [anon_sym_STAR_PIPE] = ACTIONS(1072),
    [anon_sym_QMARK] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1074),
    [anon_sym_opaque] = ACTIONS(1074),
    [anon_sym_enum] = ACTIONS(1074),
    [anon_sym_union] = ACTIONS(1074),
    [sym_doc_comment] = ACTIONS(1072),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1072),
    [aux_sym_FLOAT_token1] = ACTIONS(1072),
    [aux_sym_FLOAT_token2] = ACTIONS(1072),
    [aux_sym_FLOAT_token3] = ACTIONS(1072),
    [aux_sym_FLOAT_token4] = ACTIONS(1072),
    [aux_sym_INTEGER_token1] = ACTIONS(1072),
    [aux_sym_INTEGER_token2] = ACTIONS(1072),
    [aux_sym_INTEGER_token3] = ACTIONS(1074),
    [aux_sym_INTEGER_token4] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1072),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(1072),
  },
  [421] = {
    [sym__ElseTypeExprTail] = STATE(577),
    [ts_builtin_sym_end] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1047),
    [anon_sym_pub] = ACTIONS(1043),
    [anon_sym_test] = ACTIONS(1043),
    [anon_sym_comptime] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(1043),
    [anon_sym_extern] = ACTIONS(1043),
    [anon_sym_inline] = ACTIONS(1043),
    [anon_sym_noinline] = ACTIONS(1043),
    [anon_sym_threadlocal] = ACTIONS(1043),
    [anon_sym_usingnamespace] = ACTIONS(1043),
    [anon_sym_fn] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_const] = ACTIONS(1043),
    [anon_sym_var] = ACTIONS(1043),
    [anon_sym_else] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(1043),
    [anon_sym_and] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_DOT] = ACTIONS(1043),
    [anon_sym_error] = ACTIONS(1043),
    [anon_sym_false] = ACTIONS(1043),
    [anon_sym_null] = ACTIONS(1043),
    [anon_sym_anyframe] = ACTIONS(1043),
    [anon_sym_true] = ACTIONS(1043),
    [anon_sym_undefined] = ACTIONS(1043),
    [anon_sym_unreachable] = ACTIONS(1043),
    [sym_BuildinTypeExpr] = ACTIONS(1043),
    [anon_sym_packed] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1047),
    [anon_sym_switch] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_while] = ACTIONS(1043),
    [anon_sym_for] = ACTIONS(1043),
    [anon_sym_PIPE] = ACTIONS(1043),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_EQ_EQ] = ACTIONS(1047),
    [anon_sym_BANG_EQ] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1043),
    [anon_sym_GT] = ACTIONS(1043),
    [anon_sym_LT_EQ] = ACTIONS(1047),
    [anon_sym_GT_EQ] = ACTIONS(1047),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_CARET] = ACTIONS(1047),
    [anon_sym_orelse] = ACTIONS(1043),
    [anon_sym_catch] = ACTIONS(1043),
    [anon_sym_LT_LT] = ACTIONS(1043),
    [anon_sym_GT_GT] = ACTIONS(1047),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1047),
    [anon_sym_PLUS] = ACTIONS(1043),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_PLUS_PLUS] = ACTIONS(1047),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1047),
    [anon_sym_DASH_PERCENT] = ACTIONS(1047),
    [anon_sym_PLUS_PIPE] = ACTIONS(1047),
    [anon_sym_DASH_PIPE] = ACTIONS(1047),
    [anon_sym_PIPE_PIPE] = ACTIONS(1047),
    [anon_sym_SLASH] = ACTIONS(1043),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_STAR_STAR] = ACTIONS(1047),
    [anon_sym_STAR_PERCENT] = ACTIONS(1047),
    [anon_sym_STAR_PIPE] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1047),
    [anon_sym_DOT_STAR] = ACTIONS(1047),
    [anon_sym_DOT_QMARK] = ACTIONS(1047),
    [anon_sym_struct] = ACTIONS(1043),
    [anon_sym_opaque] = ACTIONS(1043),
    [anon_sym_enum] = ACTIONS(1043),
    [anon_sym_union] = ACTIONS(1043),
    [sym_doc_comment] = ACTIONS(1047),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1047),
    [aux_sym_FLOAT_token1] = ACTIONS(1047),
    [aux_sym_FLOAT_token2] = ACTIONS(1047),
    [aux_sym_FLOAT_token3] = ACTIONS(1047),
    [aux_sym_FLOAT_token4] = ACTIONS(1047),
    [aux_sym_INTEGER_token1] = ACTIONS(1047),
    [aux_sym_INTEGER_token2] = ACTIONS(1047),
    [aux_sym_INTEGER_token3] = ACTIONS(1043),
    [aux_sym_INTEGER_token4] = ACTIONS(1043),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1047),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(1047),
  },
  [422] = {
    [sym_FnCallArguments] = STATE(507),
    [ts_builtin_sym_end] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_pub] = ACTIONS(1091),
    [anon_sym_test] = ACTIONS(1091),
    [anon_sym_comptime] = ACTIONS(1091),
    [anon_sym_export] = ACTIONS(1091),
    [anon_sym_extern] = ACTIONS(1091),
    [anon_sym_inline] = ACTIONS(1091),
    [anon_sym_noinline] = ACTIONS(1091),
    [anon_sym_threadlocal] = ACTIONS(1091),
    [anon_sym_usingnamespace] = ACTIONS(1091),
    [anon_sym_fn] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_const] = ACTIONS(1091),
    [anon_sym_var] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_async] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_error] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_null] = ACTIONS(1091),
    [anon_sym_anyframe] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_undefined] = ACTIONS(1091),
    [anon_sym_unreachable] = ACTIONS(1091),
    [sym_BuildinTypeExpr] = ACTIONS(1091),
    [anon_sym_packed] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(935),
    [anon_sym_switch] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1089),
    [anon_sym_orelse] = ACTIONS(1091),
    [anon_sym_catch] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1089),
    [anon_sym_DASH_PERCENT] = ACTIONS(1089),
    [anon_sym_PLUS_PIPE] = ACTIONS(1089),
    [anon_sym_DASH_PIPE] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1089),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_STAR_PERCENT] = ACTIONS(1089),
    [anon_sym_STAR_PIPE] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_DOT_STAR] = ACTIONS(1089),
    [anon_sym_DOT_QMARK] = ACTIONS(1089),
    [anon_sym_struct] = ACTIONS(1091),
    [anon_sym_opaque] = ACTIONS(1091),
    [anon_sym_enum] = ACTIONS(1091),
    [anon_sym_union] = ACTIONS(1091),
    [sym_doc_comment] = ACTIONS(1089),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1089),
    [aux_sym_FLOAT_token1] = ACTIONS(1089),
    [aux_sym_FLOAT_token2] = ACTIONS(1089),
    [aux_sym_FLOAT_token3] = ACTIONS(1089),
    [aux_sym_FLOAT_token4] = ACTIONS(1089),
    [aux_sym_INTEGER_token1] = ACTIONS(1089),
    [aux_sym_INTEGER_token2] = ACTIONS(1089),
    [aux_sym_INTEGER_token3] = ACTIONS(1091),
    [aux_sym_INTEGER_token4] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1089),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1091),
    [anon_sym_AT] = ACTIONS(1089),
  },
  [423] = {
    [sym_CompareOp] = STATE(290),
    [sym_BitwiseOp] = STATE(289),
    [sym_BitShiftOp] = STATE(288),
    [sym_AdditionOp] = STATE(287),
    [sym_MultiplyOp] = STATE(286),
    [ts_builtin_sym_end] = ACTIONS(1093),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_pub] = ACTIONS(1095),
    [anon_sym_test] = ACTIONS(1095),
    [anon_sym_comptime] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_extern] = ACTIONS(1095),
    [anon_sym_inline] = ACTIONS(1095),
    [anon_sym_noinline] = ACTIONS(1095),
    [anon_sym_threadlocal] = ACTIONS(1095),
    [anon_sym_usingnamespace] = ACTIONS(1095),
    [anon_sym_fn] = ACTIONS(1095),
    [anon_sym_const] = ACTIONS(1095),
    [anon_sym_var] = ACTIONS(1095),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_error] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_null] = ACTIONS(1095),
    [anon_sym_anyframe] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_undefined] = ACTIONS(1095),
    [anon_sym_unreachable] = ACTIONS(1095),
    [sym_BuildinTypeExpr] = ACTIONS(1095),
    [anon_sym_packed] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_switch] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_LT_EQ] = ACTIONS(1093),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1093),
    [anon_sym_orelse] = ACTIONS(1095),
    [anon_sym_catch] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_PLUS_PLUS] = ACTIONS(1093),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1093),
    [anon_sym_DASH_PERCENT] = ACTIONS(1093),
    [anon_sym_PLUS_PIPE] = ACTIONS(1093),
    [anon_sym_DASH_PIPE] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1093),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_STAR_PERCENT] = ACTIONS(1093),
    [anon_sym_STAR_PIPE] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1093),
    [anon_sym_struct] = ACTIONS(1095),
    [anon_sym_opaque] = ACTIONS(1095),
    [anon_sym_enum] = ACTIONS(1095),
    [anon_sym_union] = ACTIONS(1095),
    [sym_doc_comment] = ACTIONS(1093),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1093),
    [aux_sym_FLOAT_token1] = ACTIONS(1093),
    [aux_sym_FLOAT_token2] = ACTIONS(1093),
    [aux_sym_FLOAT_token3] = ACTIONS(1093),
    [aux_sym_FLOAT_token4] = ACTIONS(1093),
    [aux_sym_INTEGER_token1] = ACTIONS(1093),
    [aux_sym_INTEGER_token2] = ACTIONS(1093),
    [aux_sym_INTEGER_token3] = ACTIONS(1095),
    [aux_sym_INTEGER_token4] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1093),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1095),
    [anon_sym_AT] = ACTIONS(1093),
  },
  [424] = {
    [ts_builtin_sym_end] = ACTIONS(552),
    [anon_sym_COMMA] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(554),
    [anon_sym_test] = ACTIONS(554),
    [anon_sym_comptime] = ACTIONS(554),
    [anon_sym_export] = ACTIONS(554),
    [anon_sym_extern] = ACTIONS(554),
    [anon_sym_inline] = ACTIONS(554),
    [anon_sym_noinline] = ACTIONS(554),
    [anon_sym_threadlocal] = ACTIONS(554),
    [anon_sym_usingnamespace] = ACTIONS(554),
    [anon_sym_fn] = ACTIONS(554),
    [anon_sym_BANG] = ACTIONS(554),
    [anon_sym_const] = ACTIONS(554),
    [anon_sym_var] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(552),
    [anon_sym_else] = ACTIONS(554),
    [anon_sym_or] = ACTIONS(554),
    [anon_sym_and] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(552),
    [anon_sym_RBRACE] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(554),
    [anon_sym_DOT] = ACTIONS(554),
    [anon_sym_error] = ACTIONS(554),
    [anon_sym_false] = ACTIONS(554),
    [anon_sym_null] = ACTIONS(554),
    [anon_sym_anyframe] = ACTIONS(554),
    [anon_sym_true] = ACTIONS(554),
    [anon_sym_undefined] = ACTIONS(554),
    [anon_sym_unreachable] = ACTIONS(554),
    [sym_BuildinTypeExpr] = ACTIONS(554),
    [anon_sym_packed] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_switch] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(554),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_PIPE] = ACTIONS(554),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_EQ_EQ] = ACTIONS(552),
    [anon_sym_BANG_EQ] = ACTIONS(552),
    [anon_sym_LT] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(552),
    [anon_sym_GT_EQ] = ACTIONS(552),
    [anon_sym_AMP] = ACTIONS(552),
    [anon_sym_CARET] = ACTIONS(552),
    [anon_sym_orelse] = ACTIONS(554),
    [anon_sym_catch] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(554),
    [anon_sym_GT_GT] = ACTIONS(552),
    [anon_sym_LT_LT_PIPE] = ACTIONS(552),
    [anon_sym_PLUS] = ACTIONS(554),
    [anon_sym_DASH] = ACTIONS(554),
    [anon_sym_PLUS_PLUS] = ACTIONS(552),
    [anon_sym_PLUS_PERCENT] = ACTIONS(552),
    [anon_sym_DASH_PERCENT] = ACTIONS(552),
    [anon_sym_PLUS_PIPE] = ACTIONS(552),
    [anon_sym_DASH_PIPE] = ACTIONS(552),
    [anon_sym_PIPE_PIPE] = ACTIONS(552),
    [anon_sym_SLASH] = ACTIONS(554),
    [anon_sym_PERCENT] = ACTIONS(552),
    [anon_sym_STAR_STAR] = ACTIONS(552),
    [anon_sym_STAR_PERCENT] = ACTIONS(552),
    [anon_sym_STAR_PIPE] = ACTIONS(552),
    [anon_sym_QMARK] = ACTIONS(552),
    [anon_sym_DOT_STAR] = ACTIONS(552),
    [anon_sym_DOT_QMARK] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_opaque] = ACTIONS(554),
    [anon_sym_enum] = ACTIONS(554),
    [anon_sym_union] = ACTIONS(554),
    [sym_doc_comment] = ACTIONS(552),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [aux_sym_FLOAT_token1] = ACTIONS(552),
    [aux_sym_FLOAT_token2] = ACTIONS(552),
    [aux_sym_FLOAT_token3] = ACTIONS(552),
    [aux_sym_FLOAT_token4] = ACTIONS(552),
    [aux_sym_INTEGER_token1] = ACTIONS(552),
    [aux_sym_INTEGER_token2] = ACTIONS(552),
    [aux_sym_INTEGER_token3] = ACTIONS(554),
    [aux_sym_INTEGER_token4] = ACTIONS(554),
    [anon_sym_DQUOTE] = ACTIONS(552),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(552),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(552),
  },
  [425] = {
    [sym__ElseTypeExprTail] = STATE(575),
    [ts_builtin_sym_end] = ACTIONS(1063),
    [anon_sym_COMMA] = ACTIONS(1063),
    [anon_sym_pub] = ACTIONS(1061),
    [anon_sym_test] = ACTIONS(1061),
    [anon_sym_comptime] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(1061),
    [anon_sym_extern] = ACTIONS(1061),
    [anon_sym_inline] = ACTIONS(1061),
    [anon_sym_noinline] = ACTIONS(1061),
    [anon_sym_threadlocal] = ACTIONS(1061),
    [anon_sym_usingnamespace] = ACTIONS(1061),
    [anon_sym_fn] = ACTIONS(1061),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_const] = ACTIONS(1061),
    [anon_sym_var] = ACTIONS(1061),
    [anon_sym_else] = ACTIONS(1084),
    [anon_sym_or] = ACTIONS(1061),
    [anon_sym_and] = ACTIONS(1061),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_RBRACE] = ACTIONS(1063),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_DOT] = ACTIONS(1061),
    [anon_sym_error] = ACTIONS(1061),
    [anon_sym_false] = ACTIONS(1061),
    [anon_sym_null] = ACTIONS(1061),
    [anon_sym_anyframe] = ACTIONS(1061),
    [anon_sym_true] = ACTIONS(1061),
    [anon_sym_undefined] = ACTIONS(1061),
    [anon_sym_unreachable] = ACTIONS(1061),
    [sym_BuildinTypeExpr] = ACTIONS(1061),
    [anon_sym_packed] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_switch] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [anon_sym_if] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(1061),
    [anon_sym_for] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1061),
    [anon_sym_EQ_EQ] = ACTIONS(1063),
    [anon_sym_BANG_EQ] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1063),
    [anon_sym_CARET] = ACTIONS(1063),
    [anon_sym_orelse] = ACTIONS(1061),
    [anon_sym_catch] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1063),
    [anon_sym_DASH_PERCENT] = ACTIONS(1063),
    [anon_sym_PLUS_PIPE] = ACTIONS(1063),
    [anon_sym_DASH_PIPE] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_SLASH] = ACTIONS(1061),
    [anon_sym_PERCENT] = ACTIONS(1063),
    [anon_sym_STAR_STAR] = ACTIONS(1063),
    [anon_sym_STAR_PERCENT] = ACTIONS(1063),
    [anon_sym_STAR_PIPE] = ACTIONS(1063),
    [anon_sym_QMARK] = ACTIONS(1063),
    [anon_sym_DOT_STAR] = ACTIONS(1063),
    [anon_sym_DOT_QMARK] = ACTIONS(1063),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_opaque] = ACTIONS(1061),
    [anon_sym_enum] = ACTIONS(1061),
    [anon_sym_union] = ACTIONS(1061),
    [sym_doc_comment] = ACTIONS(1063),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1063),
    [aux_sym_FLOAT_token1] = ACTIONS(1063),
    [aux_sym_FLOAT_token2] = ACTIONS(1063),
    [aux_sym_FLOAT_token3] = ACTIONS(1063),
    [aux_sym_FLOAT_token4] = ACTIONS(1063),
    [aux_sym_INTEGER_token1] = ACTIONS(1063),
    [aux_sym_INTEGER_token2] = ACTIONS(1063),
    [aux_sym_INTEGER_token3] = ACTIONS(1061),
    [aux_sym_INTEGER_token4] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1063),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1061),
    [anon_sym_AT] = ACTIONS(1063),
  },
  [426] = {
    [sym_CompareOp] = STATE(290),
    [sym_BitwiseOp] = STATE(289),
    [sym_BitShiftOp] = STATE(288),
    [sym_AdditionOp] = STATE(287),
    [sym_MultiplyOp] = STATE(286),
    [ts_builtin_sym_end] = ACTIONS(1097),
    [anon_sym_COMMA] = ACTIONS(1097),
    [anon_sym_pub] = ACTIONS(1099),
    [anon_sym_test] = ACTIONS(1099),
    [anon_sym_comptime] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(1099),
    [anon_sym_extern] = ACTIONS(1099),
    [anon_sym_inline] = ACTIONS(1099),
    [anon_sym_noinline] = ACTIONS(1099),
    [anon_sym_threadlocal] = ACTIONS(1099),
    [anon_sym_usingnamespace] = ACTIONS(1099),
    [anon_sym_fn] = ACTIONS(1099),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_var] = ACTIONS(1099),
    [anon_sym_else] = ACTIONS(1099),
    [anon_sym_or] = ACTIONS(1011),
    [anon_sym_and] = ACTIONS(1013),
    [anon_sym_RBRACE] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1099),
    [anon_sym_DOT] = ACTIONS(1097),
    [anon_sym_error] = ACTIONS(1099),
    [anon_sym_false] = ACTIONS(1099),
    [anon_sym_null] = ACTIONS(1099),
    [anon_sym_anyframe] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(1099),
    [anon_sym_undefined] = ACTIONS(1099),
    [anon_sym_unreachable] = ACTIONS(1099),
    [sym_BuildinTypeExpr] = ACTIONS(1099),
    [anon_sym_packed] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_LBRACK] = ACTIONS(1097),
    [anon_sym_if] = ACTIONS(1099),
    [anon_sym_while] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_struct] = ACTIONS(1099),
    [anon_sym_opaque] = ACTIONS(1099),
    [anon_sym_enum] = ACTIONS(1099),
    [anon_sym_union] = ACTIONS(1099),
    [sym_doc_comment] = ACTIONS(1097),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [aux_sym_FLOAT_token1] = ACTIONS(1097),
    [aux_sym_FLOAT_token2] = ACTIONS(1097),
    [aux_sym_FLOAT_token3] = ACTIONS(1097),
    [aux_sym_FLOAT_token4] = ACTIONS(1097),
    [aux_sym_INTEGER_token1] = ACTIONS(1097),
    [aux_sym_INTEGER_token2] = ACTIONS(1097),
    [aux_sym_INTEGER_token3] = ACTIONS(1099),
    [aux_sym_INTEGER_token4] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1097),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(1097),
  },
  [427] = {
    [sym_CompareOp] = STATE(290),
    [sym_BitwiseOp] = STATE(289),
    [sym_BitShiftOp] = STATE(288),
    [sym_AdditionOp] = STATE(287),
    [sym_MultiplyOp] = STATE(286),
    [ts_builtin_sym_end] = ACTIONS(155),
    [anon_sym_COMMA] = ACTIONS(155),
    [anon_sym_pub] = ACTIONS(157),
    [anon_sym_test] = ACTIONS(157),
    [anon_sym_comptime] = ACTIONS(157),
    [anon_sym_export] = ACTIONS(157),
    [anon_sym_extern] = ACTIONS(157),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_noinline] = ACTIONS(157),
    [anon_sym_threadlocal] = ACTIONS(157),
    [anon_sym_usingnamespace] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(157),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_var] = ACTIONS(157),
    [anon_sym_else] = ACTIONS(157),
    [anon_sym_or] = ACTIONS(1011),
    [anon_sym_and] = ACTIONS(1013),
    [anon_sym_RBRACE] = ACTIONS(155),
    [anon_sym_async] = ACTIONS(157),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_error] = ACTIONS(157),
    [anon_sym_false] = ACTIONS(157),
    [anon_sym_null] = ACTIONS(157),
    [anon_sym_anyframe] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(157),
    [anon_sym_undefined] = ACTIONS(157),
    [anon_sym_unreachable] = ACTIONS(157),
    [sym_BuildinTypeExpr] = ACTIONS(157),
    [anon_sym_packed] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(157),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(157),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(155),
    [anon_sym_struct] = ACTIONS(157),
    [anon_sym_opaque] = ACTIONS(157),
    [anon_sym_enum] = ACTIONS(157),
    [anon_sym_union] = ACTIONS(157),
    [sym_doc_comment] = ACTIONS(155),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [aux_sym_FLOAT_token1] = ACTIONS(155),
    [aux_sym_FLOAT_token2] = ACTIONS(155),
    [aux_sym_FLOAT_token3] = ACTIONS(155),
    [aux_sym_FLOAT_token4] = ACTIONS(155),
    [aux_sym_INTEGER_token1] = ACTIONS(155),
    [aux_sym_INTEGER_token2] = ACTIONS(155),
    [aux_sym_INTEGER_token3] = ACTIONS(157),
    [aux_sym_INTEGER_token4] = ACTIONS(157),
    [anon_sym_DQUOTE] = ACTIONS(155),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(155),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(157),
    [anon_sym_AT] = ACTIONS(155),
  },
  [428] = {
    [ts_builtin_sym_end] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(546),
    [anon_sym_pub] = ACTIONS(548),
    [anon_sym_test] = ACTIONS(548),
    [anon_sym_comptime] = ACTIONS(548),
    [anon_sym_export] = ACTIONS(548),
    [anon_sym_extern] = ACTIONS(548),
    [anon_sym_inline] = ACTIONS(548),
    [anon_sym_noinline] = ACTIONS(548),
    [anon_sym_threadlocal] = ACTIONS(548),
    [anon_sym_usingnamespace] = ACTIONS(548),
    [anon_sym_fn] = ACTIONS(548),
    [anon_sym_BANG] = ACTIONS(548),
    [anon_sym_const] = ACTIONS(548),
    [anon_sym_var] = ACTIONS(548),
    [anon_sym_else] = ACTIONS(548),
    [anon_sym_or] = ACTIONS(548),
    [anon_sym_and] = ACTIONS(548),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_RBRACE] = ACTIONS(546),
    [anon_sym_async] = ACTIONS(548),
    [anon_sym_DOT] = ACTIONS(548),
    [anon_sym_error] = ACTIONS(548),
    [anon_sym_false] = ACTIONS(548),
    [anon_sym_null] = ACTIONS(548),
    [anon_sym_anyframe] = ACTIONS(548),
    [anon_sym_true] = ACTIONS(548),
    [anon_sym_undefined] = ACTIONS(548),
    [anon_sym_unreachable] = ACTIONS(548),
    [sym_BuildinTypeExpr] = ACTIONS(548),
    [anon_sym_packed] = ACTIONS(548),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_switch] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(546),
    [anon_sym_DASH_GT] = ACTIONS(1101),
    [anon_sym_if] = ACTIONS(548),
    [anon_sym_while] = ACTIONS(548),
    [anon_sym_for] = ACTIONS(548),
    [anon_sym_PIPE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(548),
    [anon_sym_EQ_EQ] = ACTIONS(546),
    [anon_sym_BANG_EQ] = ACTIONS(546),
    [anon_sym_LT] = ACTIONS(548),
    [anon_sym_GT] = ACTIONS(548),
    [anon_sym_LT_EQ] = ACTIONS(546),
    [anon_sym_GT_EQ] = ACTIONS(546),
    [anon_sym_AMP] = ACTIONS(546),
    [anon_sym_CARET] = ACTIONS(546),
    [anon_sym_orelse] = ACTIONS(548),
    [anon_sym_catch] = ACTIONS(548),
    [anon_sym_LT_LT] = ACTIONS(548),
    [anon_sym_GT_GT] = ACTIONS(546),
    [anon_sym_LT_LT_PIPE] = ACTIONS(546),
    [anon_sym_PLUS] = ACTIONS(548),
    [anon_sym_DASH] = ACTIONS(548),
    [anon_sym_PLUS_PLUS] = ACTIONS(546),
    [anon_sym_PLUS_PERCENT] = ACTIONS(546),
    [anon_sym_DASH_PERCENT] = ACTIONS(546),
    [anon_sym_PLUS_PIPE] = ACTIONS(546),
    [anon_sym_DASH_PIPE] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(546),
    [anon_sym_SLASH] = ACTIONS(548),
    [anon_sym_PERCENT] = ACTIONS(546),
    [anon_sym_STAR_STAR] = ACTIONS(546),
    [anon_sym_STAR_PERCENT] = ACTIONS(546),
    [anon_sym_STAR_PIPE] = ACTIONS(546),
    [anon_sym_QMARK] = ACTIONS(546),
    [anon_sym_DOT_STAR] = ACTIONS(546),
    [anon_sym_DOT_QMARK] = ACTIONS(546),
    [anon_sym_struct] = ACTIONS(548),
    [anon_sym_opaque] = ACTIONS(548),
    [anon_sym_enum] = ACTIONS(548),
    [anon_sym_union] = ACTIONS(548),
    [sym_doc_comment] = ACTIONS(546),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(546),
    [aux_sym_FLOAT_token1] = ACTIONS(546),
    [aux_sym_FLOAT_token2] = ACTIONS(546),
    [aux_sym_FLOAT_token3] = ACTIONS(546),
    [aux_sym_FLOAT_token4] = ACTIONS(546),
    [aux_sym_INTEGER_token1] = ACTIONS(546),
    [aux_sym_INTEGER_token2] = ACTIONS(546),
    [aux_sym_INTEGER_token3] = ACTIONS(548),
    [aux_sym_INTEGER_token4] = ACTIONS(548),
    [anon_sym_DQUOTE] = ACTIONS(546),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(546),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(548),
    [anon_sym_AT] = ACTIONS(546),
  },
  [429] = {
    [sym__ElseTypeExprTail] = STATE(488),
    [ts_builtin_sym_end] = ACTIONS(1063),
    [anon_sym_COMMA] = ACTIONS(1063),
    [anon_sym_pub] = ACTIONS(1061),
    [anon_sym_test] = ACTIONS(1061),
    [anon_sym_comptime] = ACTIONS(1061),
    [anon_sym_export] = ACTIONS(1061),
    [anon_sym_extern] = ACTIONS(1061),
    [anon_sym_inline] = ACTIONS(1061),
    [anon_sym_noinline] = ACTIONS(1061),
    [anon_sym_threadlocal] = ACTIONS(1061),
    [anon_sym_usingnamespace] = ACTIONS(1061),
    [anon_sym_fn] = ACTIONS(1061),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_const] = ACTIONS(1061),
    [anon_sym_var] = ACTIONS(1061),
    [anon_sym_else] = ACTIONS(1103),
    [anon_sym_or] = ACTIONS(1061),
    [anon_sym_and] = ACTIONS(1061),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_RBRACE] = ACTIONS(1063),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_DOT] = ACTIONS(1061),
    [anon_sym_error] = ACTIONS(1061),
    [anon_sym_false] = ACTIONS(1061),
    [anon_sym_null] = ACTIONS(1061),
    [anon_sym_anyframe] = ACTIONS(1061),
    [anon_sym_true] = ACTIONS(1061),
    [anon_sym_undefined] = ACTIONS(1061),
    [anon_sym_unreachable] = ACTIONS(1061),
    [sym_BuildinTypeExpr] = ACTIONS(1061),
    [anon_sym_packed] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_switch] = ACTIONS(1061),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [anon_sym_if] = ACTIONS(1061),
    [anon_sym_while] = ACTIONS(1061),
    [anon_sym_for] = ACTIONS(1061),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1061),
    [anon_sym_EQ_EQ] = ACTIONS(1063),
    [anon_sym_BANG_EQ] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1063),
    [anon_sym_CARET] = ACTIONS(1063),
    [anon_sym_orelse] = ACTIONS(1061),
    [anon_sym_catch] = ACTIONS(1061),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1063),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1063),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1063),
    [anon_sym_DASH_PERCENT] = ACTIONS(1063),
    [anon_sym_PLUS_PIPE] = ACTIONS(1063),
    [anon_sym_DASH_PIPE] = ACTIONS(1063),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_SLASH] = ACTIONS(1061),
    [anon_sym_PERCENT] = ACTIONS(1063),
    [anon_sym_STAR_STAR] = ACTIONS(1063),
    [anon_sym_STAR_PERCENT] = ACTIONS(1063),
    [anon_sym_STAR_PIPE] = ACTIONS(1063),
    [anon_sym_QMARK] = ACTIONS(1063),
    [anon_sym_DOT_STAR] = ACTIONS(1063),
    [anon_sym_DOT_QMARK] = ACTIONS(1063),
    [anon_sym_struct] = ACTIONS(1061),
    [anon_sym_opaque] = ACTIONS(1061),
    [anon_sym_enum] = ACTIONS(1061),
    [anon_sym_union] = ACTIONS(1061),
    [sym_doc_comment] = ACTIONS(1063),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1063),
    [aux_sym_FLOAT_token1] = ACTIONS(1063),
    [aux_sym_FLOAT_token2] = ACTIONS(1063),
    [aux_sym_FLOAT_token3] = ACTIONS(1063),
    [aux_sym_FLOAT_token4] = ACTIONS(1063),
    [aux_sym_INTEGER_token1] = ACTIONS(1063),
    [aux_sym_INTEGER_token2] = ACTIONS(1063),
    [aux_sym_INTEGER_token3] = ACTIONS(1061),
    [aux_sym_INTEGER_token4] = ACTIONS(1061),
    [anon_sym_DQUOTE] = ACTIONS(1063),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1063),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1061),
    [anon_sym_AT] = ACTIONS(1063),
  },
  [430] = {
    [sym__ElseTypeExprTail] = STATE(489),
    [ts_builtin_sym_end] = ACTIONS(1055),
    [anon_sym_COMMA] = ACTIONS(1055),
    [anon_sym_pub] = ACTIONS(1053),
    [anon_sym_test] = ACTIONS(1053),
    [anon_sym_comptime] = ACTIONS(1053),
    [anon_sym_export] = ACTIONS(1053),
    [anon_sym_extern] = ACTIONS(1053),
    [anon_sym_inline] = ACTIONS(1053),
    [anon_sym_noinline] = ACTIONS(1053),
    [anon_sym_threadlocal] = ACTIONS(1053),
    [anon_sym_usingnamespace] = ACTIONS(1053),
    [anon_sym_fn] = ACTIONS(1053),
    [anon_sym_BANG] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1053),
    [anon_sym_var] = ACTIONS(1053),
    [anon_sym_else] = ACTIONS(1103),
    [anon_sym_or] = ACTIONS(1053),
    [anon_sym_and] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [anon_sym_RBRACE] = ACTIONS(1055),
    [anon_sym_async] = ACTIONS(1053),
    [anon_sym_DOT] = ACTIONS(1053),
    [anon_sym_error] = ACTIONS(1053),
    [anon_sym_false] = ACTIONS(1053),
    [anon_sym_null] = ACTIONS(1053),
    [anon_sym_anyframe] = ACTIONS(1053),
    [anon_sym_true] = ACTIONS(1053),
    [anon_sym_undefined] = ACTIONS(1053),
    [anon_sym_unreachable] = ACTIONS(1053),
    [sym_BuildinTypeExpr] = ACTIONS(1053),
    [anon_sym_packed] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1055),
    [anon_sym_switch] = ACTIONS(1053),
    [anon_sym_LBRACK] = ACTIONS(1055),
    [anon_sym_if] = ACTIONS(1053),
    [anon_sym_while] = ACTIONS(1053),
    [anon_sym_for] = ACTIONS(1053),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_EQ_EQ] = ACTIONS(1055),
    [anon_sym_BANG_EQ] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_LT_EQ] = ACTIONS(1055),
    [anon_sym_GT_EQ] = ACTIONS(1055),
    [anon_sym_AMP] = ACTIONS(1055),
    [anon_sym_CARET] = ACTIONS(1055),
    [anon_sym_orelse] = ACTIONS(1053),
    [anon_sym_catch] = ACTIONS(1053),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1055),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1055),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_DASH] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1055),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1055),
    [anon_sym_DASH_PERCENT] = ACTIONS(1055),
    [anon_sym_PLUS_PIPE] = ACTIONS(1055),
    [anon_sym_DASH_PIPE] = ACTIONS(1055),
    [anon_sym_PIPE_PIPE] = ACTIONS(1055),
    [anon_sym_SLASH] = ACTIONS(1053),
    [anon_sym_PERCENT] = ACTIONS(1055),
    [anon_sym_STAR_STAR] = ACTIONS(1055),
    [anon_sym_STAR_PERCENT] = ACTIONS(1055),
    [anon_sym_STAR_PIPE] = ACTIONS(1055),
    [anon_sym_QMARK] = ACTIONS(1055),
    [anon_sym_DOT_STAR] = ACTIONS(1055),
    [anon_sym_DOT_QMARK] = ACTIONS(1055),
    [anon_sym_struct] = ACTIONS(1053),
    [anon_sym_opaque] = ACTIONS(1053),
    [anon_sym_enum] = ACTIONS(1053),
    [anon_sym_union] = ACTIONS(1053),
    [sym_doc_comment] = ACTIONS(1055),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1055),
    [aux_sym_FLOAT_token1] = ACTIONS(1055),
    [aux_sym_FLOAT_token2] = ACTIONS(1055),
    [aux_sym_FLOAT_token3] = ACTIONS(1055),
    [aux_sym_FLOAT_token4] = ACTIONS(1055),
    [aux_sym_INTEGER_token1] = ACTIONS(1055),
    [aux_sym_INTEGER_token2] = ACTIONS(1055),
    [aux_sym_INTEGER_token3] = ACTIONS(1053),
    [aux_sym_INTEGER_token4] = ACTIONS(1053),
    [anon_sym_DQUOTE] = ACTIONS(1055),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1055),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1053),
    [anon_sym_AT] = ACTIONS(1055),
  },
  [431] = {
    [sym__ElseTypeExprTail] = STATE(490),
    [ts_builtin_sym_end] = ACTIONS(1047),
    [anon_sym_COMMA] = ACTIONS(1047),
    [anon_sym_pub] = ACTIONS(1043),
    [anon_sym_test] = ACTIONS(1043),
    [anon_sym_comptime] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(1043),
    [anon_sym_extern] = ACTIONS(1043),
    [anon_sym_inline] = ACTIONS(1043),
    [anon_sym_noinline] = ACTIONS(1043),
    [anon_sym_threadlocal] = ACTIONS(1043),
    [anon_sym_usingnamespace] = ACTIONS(1043),
    [anon_sym_fn] = ACTIONS(1043),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_const] = ACTIONS(1043),
    [anon_sym_var] = ACTIONS(1043),
    [anon_sym_else] = ACTIONS(1103),
    [anon_sym_or] = ACTIONS(1043),
    [anon_sym_and] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(1047),
    [anon_sym_async] = ACTIONS(1043),
    [anon_sym_DOT] = ACTIONS(1043),
    [anon_sym_error] = ACTIONS(1043),
    [anon_sym_false] = ACTIONS(1043),
    [anon_sym_null] = ACTIONS(1043),
    [anon_sym_anyframe] = ACTIONS(1043),
    [anon_sym_true] = ACTIONS(1043),
    [anon_sym_undefined] = ACTIONS(1043),
    [anon_sym_unreachable] = ACTIONS(1043),
    [sym_BuildinTypeExpr] = ACTIONS(1043),
    [anon_sym_packed] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1047),
    [anon_sym_switch] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_if] = ACTIONS(1043),
    [anon_sym_while] = ACTIONS(1043),
    [anon_sym_for] = ACTIONS(1043),
    [anon_sym_PIPE] = ACTIONS(1043),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_EQ_EQ] = ACTIONS(1047),
    [anon_sym_BANG_EQ] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1043),
    [anon_sym_GT] = ACTIONS(1043),
    [anon_sym_LT_EQ] = ACTIONS(1047),
    [anon_sym_GT_EQ] = ACTIONS(1047),
    [anon_sym_AMP] = ACTIONS(1047),
    [anon_sym_CARET] = ACTIONS(1047),
    [anon_sym_orelse] = ACTIONS(1043),
    [anon_sym_catch] = ACTIONS(1043),
    [anon_sym_LT_LT] = ACTIONS(1043),
    [anon_sym_GT_GT] = ACTIONS(1047),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1047),
    [anon_sym_PLUS] = ACTIONS(1043),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_PLUS_PLUS] = ACTIONS(1047),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1047),
    [anon_sym_DASH_PERCENT] = ACTIONS(1047),
    [anon_sym_PLUS_PIPE] = ACTIONS(1047),
    [anon_sym_DASH_PIPE] = ACTIONS(1047),
    [anon_sym_PIPE_PIPE] = ACTIONS(1047),
    [anon_sym_SLASH] = ACTIONS(1043),
    [anon_sym_PERCENT] = ACTIONS(1047),
    [anon_sym_STAR_STAR] = ACTIONS(1047),
    [anon_sym_STAR_PERCENT] = ACTIONS(1047),
    [anon_sym_STAR_PIPE] = ACTIONS(1047),
    [anon_sym_QMARK] = ACTIONS(1047),
    [anon_sym_DOT_STAR] = ACTIONS(1047),
    [anon_sym_DOT_QMARK] = ACTIONS(1047),
    [anon_sym_struct] = ACTIONS(1043),
    [anon_sym_opaque] = ACTIONS(1043),
    [anon_sym_enum] = ACTIONS(1043),
    [anon_sym_union] = ACTIONS(1043),
    [sym_doc_comment] = ACTIONS(1047),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1047),
    [aux_sym_FLOAT_token1] = ACTIONS(1047),
    [aux_sym_FLOAT_token2] = ACTIONS(1047),
    [aux_sym_FLOAT_token3] = ACTIONS(1047),
    [aux_sym_FLOAT_token4] = ACTIONS(1047),
    [aux_sym_INTEGER_token1] = ACTIONS(1047),
    [aux_sym_INTEGER_token2] = ACTIONS(1047),
    [aux_sym_INTEGER_token3] = ACTIONS(1043),
    [aux_sym_INTEGER_token4] = ACTIONS(1043),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1047),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(1047),
  },
  [432] = {
    [sym_InitList] = STATE(658),
    [ts_builtin_sym_end] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(1039),
    [anon_sym_pub] = ACTIONS(1041),
    [anon_sym_test] = ACTIONS(1041),
    [anon_sym_comptime] = ACTIONS(1041),
    [anon_sym_export] = ACTIONS(1041),
    [anon_sym_extern] = ACTIONS(1041),
    [anon_sym_inline] = ACTIONS(1041),
    [anon_sym_noinline] = ACTIONS(1041),
    [anon_sym_threadlocal] = ACTIONS(1041),
    [anon_sym_usingnamespace] = ACTIONS(1041),
    [anon_sym_fn] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1105),
    [anon_sym_const] = ACTIONS(1041),
    [anon_sym_var] = ACTIONS(1041),
    [anon_sym_else] = ACTIONS(1041),
    [anon_sym_or] = ACTIONS(1041),
    [anon_sym_and] = ACTIONS(1041),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_async] = ACTIONS(1041),
    [anon_sym_DOT] = ACTIONS(1041),
    [anon_sym_error] = ACTIONS(1041),
    [anon_sym_false] = ACTIONS(1041),
    [anon_sym_null] = ACTIONS(1041),
    [anon_sym_anyframe] = ACTIONS(1041),
    [anon_sym_true] = ACTIONS(1041),
    [anon_sym_undefined] = ACTIONS(1041),
    [anon_sym_unreachable] = ACTIONS(1041),
    [sym_BuildinTypeExpr] = ACTIONS(1041),
    [anon_sym_packed] = ACTIONS(1041),
    [anon_sym_LPAREN] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_while] = ACTIONS(1041),
    [anon_sym_for] = ACTIONS(1041),
    [anon_sym_PIPE] = ACTIONS(1041),
    [anon_sym_STAR] = ACTIONS(1041),
    [anon_sym_EQ_EQ] = ACTIONS(1039),
    [anon_sym_BANG_EQ] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_GT] = ACTIONS(1041),
    [anon_sym_LT_EQ] = ACTIONS(1039),
    [anon_sym_GT_EQ] = ACTIONS(1039),
    [anon_sym_AMP] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(1039),
    [anon_sym_orelse] = ACTIONS(1041),
    [anon_sym_catch] = ACTIONS(1041),
    [anon_sym_LT_LT] = ACTIONS(1041),
    [anon_sym_GT_GT] = ACTIONS(1039),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1039),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1039),
    [anon_sym_DASH_PERCENT] = ACTIONS(1039),
    [anon_sym_PLUS_PIPE] = ACTIONS(1039),
    [anon_sym_DASH_PIPE] = ACTIONS(1039),
    [anon_sym_PIPE_PIPE] = ACTIONS(1039),
    [anon_sym_SLASH] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1039),
    [anon_sym_STAR_STAR] = ACTIONS(1039),
    [anon_sym_STAR_PERCENT] = ACTIONS(1039),
    [anon_sym_STAR_PIPE] = ACTIONS(1039),
    [anon_sym_QMARK] = ACTIONS(1039),
    [anon_sym_DOT_STAR] = ACTIONS(1107),
    [anon_sym_DOT_QMARK] = ACTIONS(1107),
    [anon_sym_struct] = ACTIONS(1041),
    [anon_sym_opaque] = ACTIONS(1041),
    [anon_sym_enum] = ACTIONS(1041),
    [anon_sym_union] = ACTIONS(1041),
    [sym_doc_comment] = ACTIONS(1039),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1039),
    [aux_sym_FLOAT_token1] = ACTIONS(1039),
    [aux_sym_FLOAT_token2] = ACTIONS(1039),
    [aux_sym_FLOAT_token3] = ACTIONS(1039),
    [aux_sym_FLOAT_token4] = ACTIONS(1039),
    [aux_sym_INTEGER_token1] = ACTIONS(1039),
    [aux_sym_INTEGER_token2] = ACTIONS(1039),
    [aux_sym_INTEGER_token3] = ACTIONS(1041),
    [aux_sym_INTEGER_token4] = ACTIONS(1041),
    [anon_sym_DQUOTE] = ACTIONS(1039),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1039),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(1039),
  },
  [433] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1109),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_pub] = ACTIONS(1111),
    [anon_sym_test] = ACTIONS(1111),
    [anon_sym_comptime] = ACTIONS(1111),
    [anon_sym_export] = ACTIONS(1111),
    [anon_sym_extern] = ACTIONS(1111),
    [anon_sym_inline] = ACTIONS(1111),
    [anon_sym_noinline] = ACTIONS(1111),
    [anon_sym_threadlocal] = ACTIONS(1111),
    [anon_sym_usingnamespace] = ACTIONS(1111),
    [anon_sym_fn] = ACTIONS(1111),
    [anon_sym_const] = ACTIONS(1111),
    [anon_sym_var] = ACTIONS(1111),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1109),
    [anon_sym_async] = ACTIONS(1111),
    [anon_sym_DOT] = ACTIONS(1109),
    [anon_sym_error] = ACTIONS(1111),
    [anon_sym_false] = ACTIONS(1111),
    [anon_sym_null] = ACTIONS(1111),
    [anon_sym_anyframe] = ACTIONS(1111),
    [anon_sym_true] = ACTIONS(1111),
    [anon_sym_undefined] = ACTIONS(1111),
    [anon_sym_unreachable] = ACTIONS(1111),
    [sym_BuildinTypeExpr] = ACTIONS(1111),
    [anon_sym_packed] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(1109),
    [anon_sym_switch] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(1109),
    [anon_sym_if] = ACTIONS(1111),
    [anon_sym_while] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1111),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1109),
    [anon_sym_struct] = ACTIONS(1111),
    [anon_sym_opaque] = ACTIONS(1111),
    [anon_sym_enum] = ACTIONS(1111),
    [anon_sym_union] = ACTIONS(1111),
    [sym_doc_comment] = ACTIONS(1109),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1109),
    [aux_sym_FLOAT_token1] = ACTIONS(1109),
    [aux_sym_FLOAT_token2] = ACTIONS(1109),
    [aux_sym_FLOAT_token3] = ACTIONS(1109),
    [aux_sym_FLOAT_token4] = ACTIONS(1109),
    [aux_sym_INTEGER_token1] = ACTIONS(1109),
    [aux_sym_INTEGER_token2] = ACTIONS(1109),
    [aux_sym_INTEGER_token3] = ACTIONS(1111),
    [aux_sym_INTEGER_token4] = ACTIONS(1111),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1109),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1111),
    [anon_sym_AT] = ACTIONS(1109),
  },
  [434] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1117),
    [anon_sym_COMMA] = ACTIONS(1117),
    [anon_sym_pub] = ACTIONS(1119),
    [anon_sym_test] = ACTIONS(1119),
    [anon_sym_comptime] = ACTIONS(1119),
    [anon_sym_export] = ACTIONS(1119),
    [anon_sym_extern] = ACTIONS(1119),
    [anon_sym_inline] = ACTIONS(1119),
    [anon_sym_noinline] = ACTIONS(1119),
    [anon_sym_threadlocal] = ACTIONS(1119),
    [anon_sym_usingnamespace] = ACTIONS(1119),
    [anon_sym_fn] = ACTIONS(1119),
    [anon_sym_const] = ACTIONS(1119),
    [anon_sym_var] = ACTIONS(1119),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1117),
    [anon_sym_async] = ACTIONS(1119),
    [anon_sym_DOT] = ACTIONS(1117),
    [anon_sym_error] = ACTIONS(1119),
    [anon_sym_false] = ACTIONS(1119),
    [anon_sym_null] = ACTIONS(1119),
    [anon_sym_anyframe] = ACTIONS(1119),
    [anon_sym_true] = ACTIONS(1119),
    [anon_sym_undefined] = ACTIONS(1119),
    [anon_sym_unreachable] = ACTIONS(1119),
    [sym_BuildinTypeExpr] = ACTIONS(1119),
    [anon_sym_packed] = ACTIONS(1119),
    [anon_sym_LPAREN] = ACTIONS(1117),
    [anon_sym_switch] = ACTIONS(1119),
    [anon_sym_LBRACK] = ACTIONS(1117),
    [anon_sym_if] = ACTIONS(1119),
    [anon_sym_while] = ACTIONS(1119),
    [anon_sym_for] = ACTIONS(1119),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1117),
    [anon_sym_struct] = ACTIONS(1119),
    [anon_sym_opaque] = ACTIONS(1119),
    [anon_sym_enum] = ACTIONS(1119),
    [anon_sym_union] = ACTIONS(1119),
    [sym_doc_comment] = ACTIONS(1117),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1117),
    [aux_sym_FLOAT_token1] = ACTIONS(1117),
    [aux_sym_FLOAT_token2] = ACTIONS(1117),
    [aux_sym_FLOAT_token3] = ACTIONS(1117),
    [aux_sym_FLOAT_token4] = ACTIONS(1117),
    [aux_sym_INTEGER_token1] = ACTIONS(1117),
    [aux_sym_INTEGER_token2] = ACTIONS(1117),
    [aux_sym_INTEGER_token3] = ACTIONS(1119),
    [aux_sym_INTEGER_token4] = ACTIONS(1119),
    [anon_sym_DQUOTE] = ACTIONS(1117),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1117),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1119),
    [anon_sym_AT] = ACTIONS(1117),
  },
  [435] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1121),
    [anon_sym_COMMA] = ACTIONS(1121),
    [anon_sym_pub] = ACTIONS(1123),
    [anon_sym_test] = ACTIONS(1123),
    [anon_sym_comptime] = ACTIONS(1123),
    [anon_sym_export] = ACTIONS(1123),
    [anon_sym_extern] = ACTIONS(1123),
    [anon_sym_inline] = ACTIONS(1123),
    [anon_sym_noinline] = ACTIONS(1123),
    [anon_sym_threadlocal] = ACTIONS(1123),
    [anon_sym_usingnamespace] = ACTIONS(1123),
    [anon_sym_fn] = ACTIONS(1123),
    [anon_sym_const] = ACTIONS(1123),
    [anon_sym_var] = ACTIONS(1123),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1121),
    [anon_sym_async] = ACTIONS(1123),
    [anon_sym_DOT] = ACTIONS(1121),
    [anon_sym_error] = ACTIONS(1123),
    [anon_sym_false] = ACTIONS(1123),
    [anon_sym_null] = ACTIONS(1123),
    [anon_sym_anyframe] = ACTIONS(1123),
    [anon_sym_true] = ACTIONS(1123),
    [anon_sym_undefined] = ACTIONS(1123),
    [anon_sym_unreachable] = ACTIONS(1123),
    [sym_BuildinTypeExpr] = ACTIONS(1123),
    [anon_sym_packed] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(1121),
    [anon_sym_switch] = ACTIONS(1123),
    [anon_sym_LBRACK] = ACTIONS(1121),
    [anon_sym_if] = ACTIONS(1123),
    [anon_sym_while] = ACTIONS(1123),
    [anon_sym_for] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1121),
    [anon_sym_struct] = ACTIONS(1123),
    [anon_sym_opaque] = ACTIONS(1123),
    [anon_sym_enum] = ACTIONS(1123),
    [anon_sym_union] = ACTIONS(1123),
    [sym_doc_comment] = ACTIONS(1121),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1121),
    [aux_sym_FLOAT_token1] = ACTIONS(1121),
    [aux_sym_FLOAT_token2] = ACTIONS(1121),
    [aux_sym_FLOAT_token3] = ACTIONS(1121),
    [aux_sym_FLOAT_token4] = ACTIONS(1121),
    [aux_sym_INTEGER_token1] = ACTIONS(1121),
    [aux_sym_INTEGER_token2] = ACTIONS(1121),
    [aux_sym_INTEGER_token3] = ACTIONS(1123),
    [aux_sym_INTEGER_token4] = ACTIONS(1123),
    [anon_sym_DQUOTE] = ACTIONS(1121),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1121),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1123),
    [anon_sym_AT] = ACTIONS(1121),
  },
  [436] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1072),
    [anon_sym_COMMA] = ACTIONS(1072),
    [anon_sym_pub] = ACTIONS(1074),
    [anon_sym_test] = ACTIONS(1074),
    [anon_sym_comptime] = ACTIONS(1074),
    [anon_sym_export] = ACTIONS(1074),
    [anon_sym_extern] = ACTIONS(1074),
    [anon_sym_inline] = ACTIONS(1074),
    [anon_sym_noinline] = ACTIONS(1074),
    [anon_sym_threadlocal] = ACTIONS(1074),
    [anon_sym_usingnamespace] = ACTIONS(1074),
    [anon_sym_fn] = ACTIONS(1074),
    [anon_sym_const] = ACTIONS(1074),
    [anon_sym_var] = ACTIONS(1074),
    [anon_sym_or] = ACTIONS(1074),
    [anon_sym_and] = ACTIONS(1074),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [anon_sym_async] = ACTIONS(1074),
    [anon_sym_DOT] = ACTIONS(1072),
    [anon_sym_error] = ACTIONS(1074),
    [anon_sym_false] = ACTIONS(1074),
    [anon_sym_null] = ACTIONS(1074),
    [anon_sym_anyframe] = ACTIONS(1074),
    [anon_sym_true] = ACTIONS(1074),
    [anon_sym_undefined] = ACTIONS(1074),
    [anon_sym_unreachable] = ACTIONS(1074),
    [sym_BuildinTypeExpr] = ACTIONS(1074),
    [anon_sym_packed] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1074),
    [anon_sym_while] = ACTIONS(1074),
    [anon_sym_for] = ACTIONS(1074),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_STAR] = ACTIONS(1074),
    [anon_sym_EQ_EQ] = ACTIONS(1072),
    [anon_sym_BANG_EQ] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_LT_EQ] = ACTIONS(1072),
    [anon_sym_GT_EQ] = ACTIONS(1072),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_orelse] = ACTIONS(1074),
    [anon_sym_catch] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(1074),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1074),
    [anon_sym_PLUS_PLUS] = ACTIONS(1072),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_PERCENT] = ACTIONS(1072),
    [anon_sym_PLUS_PIPE] = ACTIONS(1072),
    [anon_sym_DASH_PIPE] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1072),
    [anon_sym_SLASH] = ACTIONS(1074),
    [anon_sym_PERCENT] = ACTIONS(1072),
    [anon_sym_STAR_STAR] = ACTIONS(1072),
    [anon_sym_STAR_PERCENT] = ACTIONS(1072),
    [anon_sym_STAR_PIPE] = ACTIONS(1072),
    [anon_sym_QMARK] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1074),
    [anon_sym_opaque] = ACTIONS(1074),
    [anon_sym_enum] = ACTIONS(1074),
    [anon_sym_union] = ACTIONS(1074),
    [sym_doc_comment] = ACTIONS(1072),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1072),
    [aux_sym_FLOAT_token1] = ACTIONS(1072),
    [aux_sym_FLOAT_token2] = ACTIONS(1072),
    [aux_sym_FLOAT_token3] = ACTIONS(1072),
    [aux_sym_FLOAT_token4] = ACTIONS(1072),
    [aux_sym_INTEGER_token1] = ACTIONS(1072),
    [aux_sym_INTEGER_token2] = ACTIONS(1072),
    [aux_sym_INTEGER_token3] = ACTIONS(1074),
    [aux_sym_INTEGER_token4] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1072),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(1072),
  },
  [437] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1072),
    [anon_sym_COMMA] = ACTIONS(1072),
    [anon_sym_pub] = ACTIONS(1074),
    [anon_sym_test] = ACTIONS(1074),
    [anon_sym_comptime] = ACTIONS(1074),
    [anon_sym_export] = ACTIONS(1074),
    [anon_sym_extern] = ACTIONS(1074),
    [anon_sym_inline] = ACTIONS(1074),
    [anon_sym_noinline] = ACTIONS(1074),
    [anon_sym_threadlocal] = ACTIONS(1074),
    [anon_sym_usingnamespace] = ACTIONS(1074),
    [anon_sym_fn] = ACTIONS(1074),
    [anon_sym_const] = ACTIONS(1074),
    [anon_sym_var] = ACTIONS(1074),
    [anon_sym_or] = ACTIONS(1074),
    [anon_sym_and] = ACTIONS(1074),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [anon_sym_async] = ACTIONS(1074),
    [anon_sym_DOT] = ACTIONS(1072),
    [anon_sym_error] = ACTIONS(1074),
    [anon_sym_false] = ACTIONS(1074),
    [anon_sym_null] = ACTIONS(1074),
    [anon_sym_anyframe] = ACTIONS(1074),
    [anon_sym_true] = ACTIONS(1074),
    [anon_sym_undefined] = ACTIONS(1074),
    [anon_sym_unreachable] = ACTIONS(1074),
    [sym_BuildinTypeExpr] = ACTIONS(1074),
    [anon_sym_packed] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1074),
    [anon_sym_while] = ACTIONS(1074),
    [anon_sym_for] = ACTIONS(1074),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1072),
    [anon_sym_BANG_EQ] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_LT_EQ] = ACTIONS(1072),
    [anon_sym_GT_EQ] = ACTIONS(1072),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_orelse] = ACTIONS(1074),
    [anon_sym_catch] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(1074),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1074),
    [anon_sym_PLUS_PLUS] = ACTIONS(1072),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1072),
    [anon_sym_DASH_PERCENT] = ACTIONS(1072),
    [anon_sym_PLUS_PIPE] = ACTIONS(1072),
    [anon_sym_DASH_PIPE] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1074),
    [anon_sym_opaque] = ACTIONS(1074),
    [anon_sym_enum] = ACTIONS(1074),
    [anon_sym_union] = ACTIONS(1074),
    [sym_doc_comment] = ACTIONS(1072),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1072),
    [aux_sym_FLOAT_token1] = ACTIONS(1072),
    [aux_sym_FLOAT_token2] = ACTIONS(1072),
    [aux_sym_FLOAT_token3] = ACTIONS(1072),
    [aux_sym_FLOAT_token4] = ACTIONS(1072),
    [aux_sym_INTEGER_token1] = ACTIONS(1072),
    [aux_sym_INTEGER_token2] = ACTIONS(1072),
    [aux_sym_INTEGER_token3] = ACTIONS(1074),
    [aux_sym_INTEGER_token4] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1072),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(1072),
  },
  [438] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1072),
    [anon_sym_COMMA] = ACTIONS(1072),
    [anon_sym_pub] = ACTIONS(1074),
    [anon_sym_test] = ACTIONS(1074),
    [anon_sym_comptime] = ACTIONS(1074),
    [anon_sym_export] = ACTIONS(1074),
    [anon_sym_extern] = ACTIONS(1074),
    [anon_sym_inline] = ACTIONS(1074),
    [anon_sym_noinline] = ACTIONS(1074),
    [anon_sym_threadlocal] = ACTIONS(1074),
    [anon_sym_usingnamespace] = ACTIONS(1074),
    [anon_sym_fn] = ACTIONS(1074),
    [anon_sym_const] = ACTIONS(1074),
    [anon_sym_var] = ACTIONS(1074),
    [anon_sym_or] = ACTIONS(1074),
    [anon_sym_and] = ACTIONS(1074),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [anon_sym_async] = ACTIONS(1074),
    [anon_sym_DOT] = ACTIONS(1072),
    [anon_sym_error] = ACTIONS(1074),
    [anon_sym_false] = ACTIONS(1074),
    [anon_sym_null] = ACTIONS(1074),
    [anon_sym_anyframe] = ACTIONS(1074),
    [anon_sym_true] = ACTIONS(1074),
    [anon_sym_undefined] = ACTIONS(1074),
    [anon_sym_unreachable] = ACTIONS(1074),
    [sym_BuildinTypeExpr] = ACTIONS(1074),
    [anon_sym_packed] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1074),
    [anon_sym_while] = ACTIONS(1074),
    [anon_sym_for] = ACTIONS(1074),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1072),
    [anon_sym_BANG_EQ] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_LT_EQ] = ACTIONS(1072),
    [anon_sym_GT_EQ] = ACTIONS(1072),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_orelse] = ACTIONS(1074),
    [anon_sym_catch] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(1074),
    [anon_sym_GT_GT] = ACTIONS(1072),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1072),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1074),
    [anon_sym_opaque] = ACTIONS(1074),
    [anon_sym_enum] = ACTIONS(1074),
    [anon_sym_union] = ACTIONS(1074),
    [sym_doc_comment] = ACTIONS(1072),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1072),
    [aux_sym_FLOAT_token1] = ACTIONS(1072),
    [aux_sym_FLOAT_token2] = ACTIONS(1072),
    [aux_sym_FLOAT_token3] = ACTIONS(1072),
    [aux_sym_FLOAT_token4] = ACTIONS(1072),
    [aux_sym_INTEGER_token1] = ACTIONS(1072),
    [aux_sym_INTEGER_token2] = ACTIONS(1072),
    [aux_sym_INTEGER_token3] = ACTIONS(1074),
    [aux_sym_INTEGER_token4] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1072),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(1072),
  },
  [439] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1072),
    [anon_sym_COMMA] = ACTIONS(1072),
    [anon_sym_pub] = ACTIONS(1074),
    [anon_sym_test] = ACTIONS(1074),
    [anon_sym_comptime] = ACTIONS(1074),
    [anon_sym_export] = ACTIONS(1074),
    [anon_sym_extern] = ACTIONS(1074),
    [anon_sym_inline] = ACTIONS(1074),
    [anon_sym_noinline] = ACTIONS(1074),
    [anon_sym_threadlocal] = ACTIONS(1074),
    [anon_sym_usingnamespace] = ACTIONS(1074),
    [anon_sym_fn] = ACTIONS(1074),
    [anon_sym_const] = ACTIONS(1074),
    [anon_sym_var] = ACTIONS(1074),
    [anon_sym_or] = ACTIONS(1074),
    [anon_sym_and] = ACTIONS(1074),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [anon_sym_async] = ACTIONS(1074),
    [anon_sym_DOT] = ACTIONS(1072),
    [anon_sym_error] = ACTIONS(1074),
    [anon_sym_false] = ACTIONS(1074),
    [anon_sym_null] = ACTIONS(1074),
    [anon_sym_anyframe] = ACTIONS(1074),
    [anon_sym_true] = ACTIONS(1074),
    [anon_sym_undefined] = ACTIONS(1074),
    [anon_sym_unreachable] = ACTIONS(1074),
    [sym_BuildinTypeExpr] = ACTIONS(1074),
    [anon_sym_packed] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1074),
    [anon_sym_while] = ACTIONS(1074),
    [anon_sym_for] = ACTIONS(1074),
    [anon_sym_PIPE] = ACTIONS(1074),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1072),
    [anon_sym_BANG_EQ] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_LT_EQ] = ACTIONS(1072),
    [anon_sym_GT_EQ] = ACTIONS(1072),
    [anon_sym_AMP] = ACTIONS(1072),
    [anon_sym_CARET] = ACTIONS(1072),
    [anon_sym_orelse] = ACTIONS(1074),
    [anon_sym_catch] = ACTIONS(1074),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1074),
    [anon_sym_opaque] = ACTIONS(1074),
    [anon_sym_enum] = ACTIONS(1074),
    [anon_sym_union] = ACTIONS(1074),
    [sym_doc_comment] = ACTIONS(1072),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1072),
    [aux_sym_FLOAT_token1] = ACTIONS(1072),
    [aux_sym_FLOAT_token2] = ACTIONS(1072),
    [aux_sym_FLOAT_token3] = ACTIONS(1072),
    [aux_sym_FLOAT_token4] = ACTIONS(1072),
    [aux_sym_INTEGER_token1] = ACTIONS(1072),
    [aux_sym_INTEGER_token2] = ACTIONS(1072),
    [aux_sym_INTEGER_token3] = ACTIONS(1074),
    [aux_sym_INTEGER_token4] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1072),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(1072),
  },
  [440] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1072),
    [anon_sym_COMMA] = ACTIONS(1072),
    [anon_sym_pub] = ACTIONS(1074),
    [anon_sym_test] = ACTIONS(1074),
    [anon_sym_comptime] = ACTIONS(1074),
    [anon_sym_export] = ACTIONS(1074),
    [anon_sym_extern] = ACTIONS(1074),
    [anon_sym_inline] = ACTIONS(1074),
    [anon_sym_noinline] = ACTIONS(1074),
    [anon_sym_threadlocal] = ACTIONS(1074),
    [anon_sym_usingnamespace] = ACTIONS(1074),
    [anon_sym_fn] = ACTIONS(1074),
    [anon_sym_const] = ACTIONS(1074),
    [anon_sym_var] = ACTIONS(1074),
    [anon_sym_or] = ACTIONS(1074),
    [anon_sym_and] = ACTIONS(1074),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [anon_sym_async] = ACTIONS(1074),
    [anon_sym_DOT] = ACTIONS(1072),
    [anon_sym_error] = ACTIONS(1074),
    [anon_sym_false] = ACTIONS(1074),
    [anon_sym_null] = ACTIONS(1074),
    [anon_sym_anyframe] = ACTIONS(1074),
    [anon_sym_true] = ACTIONS(1074),
    [anon_sym_undefined] = ACTIONS(1074),
    [anon_sym_unreachable] = ACTIONS(1074),
    [sym_BuildinTypeExpr] = ACTIONS(1074),
    [anon_sym_packed] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1074),
    [anon_sym_while] = ACTIONS(1074),
    [anon_sym_for] = ACTIONS(1074),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1072),
    [anon_sym_BANG_EQ] = ACTIONS(1072),
    [anon_sym_LT] = ACTIONS(1074),
    [anon_sym_GT] = ACTIONS(1074),
    [anon_sym_LT_EQ] = ACTIONS(1072),
    [anon_sym_GT_EQ] = ACTIONS(1072),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1074),
    [anon_sym_opaque] = ACTIONS(1074),
    [anon_sym_enum] = ACTIONS(1074),
    [anon_sym_union] = ACTIONS(1074),
    [sym_doc_comment] = ACTIONS(1072),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1072),
    [aux_sym_FLOAT_token1] = ACTIONS(1072),
    [aux_sym_FLOAT_token2] = ACTIONS(1072),
    [aux_sym_FLOAT_token3] = ACTIONS(1072),
    [aux_sym_FLOAT_token4] = ACTIONS(1072),
    [aux_sym_INTEGER_token1] = ACTIONS(1072),
    [aux_sym_INTEGER_token2] = ACTIONS(1072),
    [aux_sym_INTEGER_token3] = ACTIONS(1074),
    [aux_sym_INTEGER_token4] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1072),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(1072),
  },
  [441] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1072),
    [anon_sym_COMMA] = ACTIONS(1072),
    [anon_sym_pub] = ACTIONS(1074),
    [anon_sym_test] = ACTIONS(1074),
    [anon_sym_comptime] = ACTIONS(1074),
    [anon_sym_export] = ACTIONS(1074),
    [anon_sym_extern] = ACTIONS(1074),
    [anon_sym_inline] = ACTIONS(1074),
    [anon_sym_noinline] = ACTIONS(1074),
    [anon_sym_threadlocal] = ACTIONS(1074),
    [anon_sym_usingnamespace] = ACTIONS(1074),
    [anon_sym_fn] = ACTIONS(1074),
    [anon_sym_const] = ACTIONS(1074),
    [anon_sym_var] = ACTIONS(1074),
    [anon_sym_or] = ACTIONS(1074),
    [anon_sym_and] = ACTIONS(1074),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [anon_sym_async] = ACTIONS(1074),
    [anon_sym_DOT] = ACTIONS(1072),
    [anon_sym_error] = ACTIONS(1074),
    [anon_sym_false] = ACTIONS(1074),
    [anon_sym_null] = ACTIONS(1074),
    [anon_sym_anyframe] = ACTIONS(1074),
    [anon_sym_true] = ACTIONS(1074),
    [anon_sym_undefined] = ACTIONS(1074),
    [anon_sym_unreachable] = ACTIONS(1074),
    [sym_BuildinTypeExpr] = ACTIONS(1074),
    [anon_sym_packed] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1074),
    [anon_sym_while] = ACTIONS(1074),
    [anon_sym_for] = ACTIONS(1074),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1074),
    [anon_sym_opaque] = ACTIONS(1074),
    [anon_sym_enum] = ACTIONS(1074),
    [anon_sym_union] = ACTIONS(1074),
    [sym_doc_comment] = ACTIONS(1072),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1072),
    [aux_sym_FLOAT_token1] = ACTIONS(1072),
    [aux_sym_FLOAT_token2] = ACTIONS(1072),
    [aux_sym_FLOAT_token3] = ACTIONS(1072),
    [aux_sym_FLOAT_token4] = ACTIONS(1072),
    [aux_sym_INTEGER_token1] = ACTIONS(1072),
    [aux_sym_INTEGER_token2] = ACTIONS(1072),
    [aux_sym_INTEGER_token3] = ACTIONS(1074),
    [aux_sym_INTEGER_token4] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1072),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(1072),
  },
  [442] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1097),
    [anon_sym_COMMA] = ACTIONS(1097),
    [anon_sym_pub] = ACTIONS(1099),
    [anon_sym_test] = ACTIONS(1099),
    [anon_sym_comptime] = ACTIONS(1099),
    [anon_sym_export] = ACTIONS(1099),
    [anon_sym_extern] = ACTIONS(1099),
    [anon_sym_inline] = ACTIONS(1099),
    [anon_sym_noinline] = ACTIONS(1099),
    [anon_sym_threadlocal] = ACTIONS(1099),
    [anon_sym_usingnamespace] = ACTIONS(1099),
    [anon_sym_fn] = ACTIONS(1099),
    [anon_sym_const] = ACTIONS(1099),
    [anon_sym_var] = ACTIONS(1099),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1097),
    [anon_sym_async] = ACTIONS(1099),
    [anon_sym_DOT] = ACTIONS(1097),
    [anon_sym_error] = ACTIONS(1099),
    [anon_sym_false] = ACTIONS(1099),
    [anon_sym_null] = ACTIONS(1099),
    [anon_sym_anyframe] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(1099),
    [anon_sym_undefined] = ACTIONS(1099),
    [anon_sym_unreachable] = ACTIONS(1099),
    [sym_BuildinTypeExpr] = ACTIONS(1099),
    [anon_sym_packed] = ACTIONS(1099),
    [anon_sym_LPAREN] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1099),
    [anon_sym_LBRACK] = ACTIONS(1097),
    [anon_sym_if] = ACTIONS(1099),
    [anon_sym_while] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_struct] = ACTIONS(1099),
    [anon_sym_opaque] = ACTIONS(1099),
    [anon_sym_enum] = ACTIONS(1099),
    [anon_sym_union] = ACTIONS(1099),
    [sym_doc_comment] = ACTIONS(1097),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1097),
    [aux_sym_FLOAT_token1] = ACTIONS(1097),
    [aux_sym_FLOAT_token2] = ACTIONS(1097),
    [aux_sym_FLOAT_token3] = ACTIONS(1097),
    [aux_sym_FLOAT_token4] = ACTIONS(1097),
    [aux_sym_INTEGER_token1] = ACTIONS(1097),
    [aux_sym_INTEGER_token2] = ACTIONS(1097),
    [aux_sym_INTEGER_token3] = ACTIONS(1099),
    [aux_sym_INTEGER_token4] = ACTIONS(1099),
    [anon_sym_DQUOTE] = ACTIONS(1097),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1097),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1099),
    [anon_sym_AT] = ACTIONS(1097),
  },
  [443] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1072),
    [anon_sym_COMMA] = ACTIONS(1072),
    [anon_sym_pub] = ACTIONS(1074),
    [anon_sym_test] = ACTIONS(1074),
    [anon_sym_comptime] = ACTIONS(1074),
    [anon_sym_export] = ACTIONS(1074),
    [anon_sym_extern] = ACTIONS(1074),
    [anon_sym_inline] = ACTIONS(1074),
    [anon_sym_noinline] = ACTIONS(1074),
    [anon_sym_threadlocal] = ACTIONS(1074),
    [anon_sym_usingnamespace] = ACTIONS(1074),
    [anon_sym_fn] = ACTIONS(1074),
    [anon_sym_const] = ACTIONS(1074),
    [anon_sym_var] = ACTIONS(1074),
    [anon_sym_or] = ACTIONS(1074),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1072),
    [anon_sym_async] = ACTIONS(1074),
    [anon_sym_DOT] = ACTIONS(1072),
    [anon_sym_error] = ACTIONS(1074),
    [anon_sym_false] = ACTIONS(1074),
    [anon_sym_null] = ACTIONS(1074),
    [anon_sym_anyframe] = ACTIONS(1074),
    [anon_sym_true] = ACTIONS(1074),
    [anon_sym_undefined] = ACTIONS(1074),
    [anon_sym_unreachable] = ACTIONS(1074),
    [sym_BuildinTypeExpr] = ACTIONS(1074),
    [anon_sym_packed] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1072),
    [anon_sym_switch] = ACTIONS(1074),
    [anon_sym_LBRACK] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1074),
    [anon_sym_while] = ACTIONS(1074),
    [anon_sym_for] = ACTIONS(1074),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1072),
    [anon_sym_struct] = ACTIONS(1074),
    [anon_sym_opaque] = ACTIONS(1074),
    [anon_sym_enum] = ACTIONS(1074),
    [anon_sym_union] = ACTIONS(1074),
    [sym_doc_comment] = ACTIONS(1072),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1072),
    [aux_sym_FLOAT_token1] = ACTIONS(1072),
    [aux_sym_FLOAT_token2] = ACTIONS(1072),
    [aux_sym_FLOAT_token3] = ACTIONS(1072),
    [aux_sym_FLOAT_token4] = ACTIONS(1072),
    [aux_sym_INTEGER_token1] = ACTIONS(1072),
    [aux_sym_INTEGER_token2] = ACTIONS(1072),
    [aux_sym_INTEGER_token3] = ACTIONS(1074),
    [aux_sym_INTEGER_token4] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1072),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1072),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(1072),
  },
  [444] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1093),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_pub] = ACTIONS(1095),
    [anon_sym_test] = ACTIONS(1095),
    [anon_sym_comptime] = ACTIONS(1095),
    [anon_sym_export] = ACTIONS(1095),
    [anon_sym_extern] = ACTIONS(1095),
    [anon_sym_inline] = ACTIONS(1095),
    [anon_sym_noinline] = ACTIONS(1095),
    [anon_sym_threadlocal] = ACTIONS(1095),
    [anon_sym_usingnamespace] = ACTIONS(1095),
    [anon_sym_fn] = ACTIONS(1095),
    [anon_sym_const] = ACTIONS(1095),
    [anon_sym_var] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_error] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_null] = ACTIONS(1095),
    [anon_sym_anyframe] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_undefined] = ACTIONS(1095),
    [anon_sym_unreachable] = ACTIONS(1095),
    [sym_BuildinTypeExpr] = ACTIONS(1095),
    [anon_sym_packed] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_switch] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_LT_EQ] = ACTIONS(1093),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_AMP] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1093),
    [anon_sym_orelse] = ACTIONS(1095),
    [anon_sym_catch] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1093),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_DASH] = ACTIONS(1095),
    [anon_sym_PLUS_PLUS] = ACTIONS(1093),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1093),
    [anon_sym_DASH_PERCENT] = ACTIONS(1093),
    [anon_sym_PLUS_PIPE] = ACTIONS(1093),
    [anon_sym_DASH_PIPE] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE] = ACTIONS(1093),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1093),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_STAR_PERCENT] = ACTIONS(1093),
    [anon_sym_STAR_PIPE] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1093),
    [anon_sym_struct] = ACTIONS(1095),
    [anon_sym_opaque] = ACTIONS(1095),
    [anon_sym_enum] = ACTIONS(1095),
    [anon_sym_union] = ACTIONS(1095),
    [sym_doc_comment] = ACTIONS(1093),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1093),
    [aux_sym_FLOAT_token1] = ACTIONS(1093),
    [aux_sym_FLOAT_token2] = ACTIONS(1093),
    [aux_sym_FLOAT_token3] = ACTIONS(1093),
    [aux_sym_FLOAT_token4] = ACTIONS(1093),
    [aux_sym_INTEGER_token1] = ACTIONS(1093),
    [aux_sym_INTEGER_token2] = ACTIONS(1093),
    [aux_sym_INTEGER_token3] = ACTIONS(1095),
    [aux_sym_INTEGER_token4] = ACTIONS(1095),
    [anon_sym_DQUOTE] = ACTIONS(1093),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1093),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1095),
    [anon_sym_AT] = ACTIONS(1093),
  },
  [445] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1076),
    [anon_sym_COMMA] = ACTIONS(1076),
    [anon_sym_pub] = ACTIONS(1078),
    [anon_sym_test] = ACTIONS(1078),
    [anon_sym_comptime] = ACTIONS(1078),
    [anon_sym_export] = ACTIONS(1078),
    [anon_sym_extern] = ACTIONS(1078),
    [anon_sym_inline] = ACTIONS(1078),
    [anon_sym_noinline] = ACTIONS(1078),
    [anon_sym_threadlocal] = ACTIONS(1078),
    [anon_sym_usingnamespace] = ACTIONS(1078),
    [anon_sym_fn] = ACTIONS(1078),
    [anon_sym_const] = ACTIONS(1078),
    [anon_sym_var] = ACTIONS(1078),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1076),
    [anon_sym_async] = ACTIONS(1078),
    [anon_sym_DOT] = ACTIONS(1076),
    [anon_sym_error] = ACTIONS(1078),
    [anon_sym_false] = ACTIONS(1078),
    [anon_sym_null] = ACTIONS(1078),
    [anon_sym_anyframe] = ACTIONS(1078),
    [anon_sym_true] = ACTIONS(1078),
    [anon_sym_undefined] = ACTIONS(1078),
    [anon_sym_unreachable] = ACTIONS(1078),
    [sym_BuildinTypeExpr] = ACTIONS(1078),
    [anon_sym_packed] = ACTIONS(1078),
    [anon_sym_LPAREN] = ACTIONS(1076),
    [anon_sym_switch] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_if] = ACTIONS(1078),
    [anon_sym_while] = ACTIONS(1078),
    [anon_sym_for] = ACTIONS(1078),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1076),
    [anon_sym_struct] = ACTIONS(1078),
    [anon_sym_opaque] = ACTIONS(1078),
    [anon_sym_enum] = ACTIONS(1078),
    [anon_sym_union] = ACTIONS(1078),
    [sym_doc_comment] = ACTIONS(1076),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1076),
    [aux_sym_FLOAT_token1] = ACTIONS(1076),
    [aux_sym_FLOAT_token2] = ACTIONS(1076),
    [aux_sym_FLOAT_token3] = ACTIONS(1076),
    [aux_sym_FLOAT_token4] = ACTIONS(1076),
    [aux_sym_INTEGER_token1] = ACTIONS(1076),
    [aux_sym_INTEGER_token2] = ACTIONS(1076),
    [aux_sym_INTEGER_token3] = ACTIONS(1078),
    [aux_sym_INTEGER_token4] = ACTIONS(1078),
    [anon_sym_DQUOTE] = ACTIONS(1076),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1076),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1078),
    [anon_sym_AT] = ACTIONS(1076),
  },
  [446] = {
    [sym_InitList] = STATE(677),
    [ts_builtin_sym_end] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(1039),
    [anon_sym_pub] = ACTIONS(1041),
    [anon_sym_test] = ACTIONS(1041),
    [anon_sym_comptime] = ACTIONS(1041),
    [anon_sym_export] = ACTIONS(1041),
    [anon_sym_extern] = ACTIONS(1041),
    [anon_sym_inline] = ACTIONS(1041),
    [anon_sym_noinline] = ACTIONS(1041),
    [anon_sym_threadlocal] = ACTIONS(1041),
    [anon_sym_usingnamespace] = ACTIONS(1041),
    [anon_sym_fn] = ACTIONS(1041),
    [anon_sym_BANG] = ACTIONS(1105),
    [anon_sym_const] = ACTIONS(1041),
    [anon_sym_var] = ACTIONS(1041),
    [anon_sym_or] = ACTIONS(1041),
    [anon_sym_and] = ACTIONS(1041),
    [anon_sym_LBRACE] = ACTIONS(1125),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_async] = ACTIONS(1041),
    [anon_sym_DOT] = ACTIONS(1041),
    [anon_sym_error] = ACTIONS(1041),
    [anon_sym_false] = ACTIONS(1041),
    [anon_sym_null] = ACTIONS(1041),
    [anon_sym_anyframe] = ACTIONS(1041),
    [anon_sym_true] = ACTIONS(1041),
    [anon_sym_undefined] = ACTIONS(1041),
    [anon_sym_unreachable] = ACTIONS(1041),
    [sym_BuildinTypeExpr] = ACTIONS(1041),
    [anon_sym_packed] = ACTIONS(1041),
    [anon_sym_LPAREN] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_while] = ACTIONS(1041),
    [anon_sym_for] = ACTIONS(1041),
    [anon_sym_PIPE] = ACTIONS(1041),
    [anon_sym_STAR] = ACTIONS(1041),
    [anon_sym_EQ_EQ] = ACTIONS(1039),
    [anon_sym_BANG_EQ] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_GT] = ACTIONS(1041),
    [anon_sym_LT_EQ] = ACTIONS(1039),
    [anon_sym_GT_EQ] = ACTIONS(1039),
    [anon_sym_AMP] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(1039),
    [anon_sym_orelse] = ACTIONS(1041),
    [anon_sym_catch] = ACTIONS(1041),
    [anon_sym_LT_LT] = ACTIONS(1041),
    [anon_sym_GT_GT] = ACTIONS(1039),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1039),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1039),
    [anon_sym_DASH_PERCENT] = ACTIONS(1039),
    [anon_sym_PLUS_PIPE] = ACTIONS(1039),
    [anon_sym_DASH_PIPE] = ACTIONS(1039),
    [anon_sym_PIPE_PIPE] = ACTIONS(1039),
    [anon_sym_SLASH] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1039),
    [anon_sym_STAR_STAR] = ACTIONS(1039),
    [anon_sym_STAR_PERCENT] = ACTIONS(1039),
    [anon_sym_STAR_PIPE] = ACTIONS(1039),
    [anon_sym_QMARK] = ACTIONS(1039),
    [anon_sym_DOT_STAR] = ACTIONS(1107),
    [anon_sym_DOT_QMARK] = ACTIONS(1107),
    [anon_sym_struct] = ACTIONS(1041),
    [anon_sym_opaque] = ACTIONS(1041),
    [anon_sym_enum] = ACTIONS(1041),
    [anon_sym_union] = ACTIONS(1041),
    [sym_doc_comment] = ACTIONS(1039),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1039),
    [aux_sym_FLOAT_token1] = ACTIONS(1039),
    [aux_sym_FLOAT_token2] = ACTIONS(1039),
    [aux_sym_FLOAT_token3] = ACTIONS(1039),
    [aux_sym_FLOAT_token4] = ACTIONS(1039),
    [aux_sym_INTEGER_token1] = ACTIONS(1039),
    [aux_sym_INTEGER_token2] = ACTIONS(1039),
    [aux_sym_INTEGER_token3] = ACTIONS(1041),
    [aux_sym_INTEGER_token4] = ACTIONS(1041),
    [anon_sym_DQUOTE] = ACTIONS(1039),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1039),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(1039),
  },
  [447] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(155),
    [anon_sym_COMMA] = ACTIONS(155),
    [anon_sym_pub] = ACTIONS(157),
    [anon_sym_test] = ACTIONS(157),
    [anon_sym_comptime] = ACTIONS(157),
    [anon_sym_export] = ACTIONS(157),
    [anon_sym_extern] = ACTIONS(157),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_noinline] = ACTIONS(157),
    [anon_sym_threadlocal] = ACTIONS(157),
    [anon_sym_usingnamespace] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(157),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_var] = ACTIONS(157),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(155),
    [anon_sym_async] = ACTIONS(157),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_error] = ACTIONS(157),
    [anon_sym_false] = ACTIONS(157),
    [anon_sym_null] = ACTIONS(157),
    [anon_sym_anyframe] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(157),
    [anon_sym_undefined] = ACTIONS(157),
    [anon_sym_unreachable] = ACTIONS(157),
    [sym_BuildinTypeExpr] = ACTIONS(157),
    [anon_sym_packed] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(157),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(157),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(155),
    [anon_sym_struct] = ACTIONS(157),
    [anon_sym_opaque] = ACTIONS(157),
    [anon_sym_enum] = ACTIONS(157),
    [anon_sym_union] = ACTIONS(157),
    [sym_doc_comment] = ACTIONS(155),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [aux_sym_FLOAT_token1] = ACTIONS(155),
    [aux_sym_FLOAT_token2] = ACTIONS(155),
    [aux_sym_FLOAT_token3] = ACTIONS(155),
    [aux_sym_FLOAT_token4] = ACTIONS(155),
    [aux_sym_INTEGER_token1] = ACTIONS(155),
    [aux_sym_INTEGER_token2] = ACTIONS(155),
    [aux_sym_INTEGER_token3] = ACTIONS(157),
    [aux_sym_INTEGER_token4] = ACTIONS(157),
    [anon_sym_DQUOTE] = ACTIONS(155),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(155),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(157),
    [anon_sym_AT] = ACTIONS(155),
  },
  [448] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1080),
    [anon_sym_COMMA] = ACTIONS(1080),
    [anon_sym_pub] = ACTIONS(1082),
    [anon_sym_test] = ACTIONS(1082),
    [anon_sym_comptime] = ACTIONS(1082),
    [anon_sym_export] = ACTIONS(1082),
    [anon_sym_extern] = ACTIONS(1082),
    [anon_sym_inline] = ACTIONS(1082),
    [anon_sym_noinline] = ACTIONS(1082),
    [anon_sym_threadlocal] = ACTIONS(1082),
    [anon_sym_usingnamespace] = ACTIONS(1082),
    [anon_sym_fn] = ACTIONS(1082),
    [anon_sym_const] = ACTIONS(1082),
    [anon_sym_var] = ACTIONS(1082),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1080),
    [anon_sym_async] = ACTIONS(1082),
    [anon_sym_DOT] = ACTIONS(1080),
    [anon_sym_error] = ACTIONS(1082),
    [anon_sym_false] = ACTIONS(1082),
    [anon_sym_null] = ACTIONS(1082),
    [anon_sym_anyframe] = ACTIONS(1082),
    [anon_sym_true] = ACTIONS(1082),
    [anon_sym_undefined] = ACTIONS(1082),
    [anon_sym_unreachable] = ACTIONS(1082),
    [sym_BuildinTypeExpr] = ACTIONS(1082),
    [anon_sym_packed] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1080),
    [anon_sym_switch] = ACTIONS(1082),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [anon_sym_if] = ACTIONS(1082),
    [anon_sym_while] = ACTIONS(1082),
    [anon_sym_for] = ACTIONS(1082),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1080),
    [anon_sym_struct] = ACTIONS(1082),
    [anon_sym_opaque] = ACTIONS(1082),
    [anon_sym_enum] = ACTIONS(1082),
    [anon_sym_union] = ACTIONS(1082),
    [sym_doc_comment] = ACTIONS(1080),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1080),
    [aux_sym_FLOAT_token1] = ACTIONS(1080),
    [aux_sym_FLOAT_token2] = ACTIONS(1080),
    [aux_sym_FLOAT_token3] = ACTIONS(1080),
    [aux_sym_FLOAT_token4] = ACTIONS(1080),
    [aux_sym_INTEGER_token1] = ACTIONS(1080),
    [aux_sym_INTEGER_token2] = ACTIONS(1080),
    [aux_sym_INTEGER_token3] = ACTIONS(1082),
    [aux_sym_INTEGER_token4] = ACTIONS(1082),
    [anon_sym_DQUOTE] = ACTIONS(1080),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1080),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1082),
    [anon_sym_AT] = ACTIONS(1080),
  },
  [449] = {
    [ts_builtin_sym_end] = ACTIONS(546),
    [anon_sym_COMMA] = ACTIONS(546),
    [anon_sym_pub] = ACTIONS(548),
    [anon_sym_test] = ACTIONS(548),
    [anon_sym_comptime] = ACTIONS(548),
    [anon_sym_export] = ACTIONS(548),
    [anon_sym_extern] = ACTIONS(548),
    [anon_sym_inline] = ACTIONS(548),
    [anon_sym_noinline] = ACTIONS(548),
    [anon_sym_threadlocal] = ACTIONS(548),
    [anon_sym_usingnamespace] = ACTIONS(548),
    [anon_sym_fn] = ACTIONS(548),
    [anon_sym_BANG] = ACTIONS(548),
    [anon_sym_const] = ACTIONS(548),
    [anon_sym_var] = ACTIONS(548),
    [anon_sym_or] = ACTIONS(548),
    [anon_sym_and] = ACTIONS(548),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_RBRACE] = ACTIONS(546),
    [anon_sym_async] = ACTIONS(548),
    [anon_sym_DOT] = ACTIONS(548),
    [anon_sym_error] = ACTIONS(548),
    [anon_sym_false] = ACTIONS(548),
    [anon_sym_null] = ACTIONS(548),
    [anon_sym_anyframe] = ACTIONS(548),
    [anon_sym_true] = ACTIONS(548),
    [anon_sym_undefined] = ACTIONS(548),
    [anon_sym_unreachable] = ACTIONS(548),
    [sym_BuildinTypeExpr] = ACTIONS(548),
    [anon_sym_packed] = ACTIONS(548),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_switch] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(546),
    [anon_sym_DASH_GT] = ACTIONS(1101),
    [anon_sym_if] = ACTIONS(548),
    [anon_sym_while] = ACTIONS(548),
    [anon_sym_for] = ACTIONS(548),
    [anon_sym_PIPE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(548),
    [anon_sym_EQ_EQ] = ACTIONS(546),
    [anon_sym_BANG_EQ] = ACTIONS(546),
    [anon_sym_LT] = ACTIONS(548),
    [anon_sym_GT] = ACTIONS(548),
    [anon_sym_LT_EQ] = ACTIONS(546),
    [anon_sym_GT_EQ] = ACTIONS(546),
    [anon_sym_AMP] = ACTIONS(546),
    [anon_sym_CARET] = ACTIONS(546),
    [anon_sym_orelse] = ACTIONS(548),
    [anon_sym_catch] = ACTIONS(548),
    [anon_sym_LT_LT] = ACTIONS(548),
    [anon_sym_GT_GT] = ACTIONS(546),
    [anon_sym_LT_LT_PIPE] = ACTIONS(546),
    [anon_sym_PLUS] = ACTIONS(548),
    [anon_sym_DASH] = ACTIONS(548),
    [anon_sym_PLUS_PLUS] = ACTIONS(546),
    [anon_sym_PLUS_PERCENT] = ACTIONS(546),
    [anon_sym_DASH_PERCENT] = ACTIONS(546),
    [anon_sym_PLUS_PIPE] = ACTIONS(546),
    [anon_sym_DASH_PIPE] = ACTIONS(546),
    [anon_sym_PIPE_PIPE] = ACTIONS(546),
    [anon_sym_SLASH] = ACTIONS(548),
    [anon_sym_PERCENT] = ACTIONS(546),
    [anon_sym_STAR_STAR] = ACTIONS(546),
    [anon_sym_STAR_PERCENT] = ACTIONS(546),
    [anon_sym_STAR_PIPE] = ACTIONS(546),
    [anon_sym_QMARK] = ACTIONS(546),
    [anon_sym_DOT_STAR] = ACTIONS(546),
    [anon_sym_DOT_QMARK] = ACTIONS(546),
    [anon_sym_struct] = ACTIONS(548),
    [anon_sym_opaque] = ACTIONS(548),
    [anon_sym_enum] = ACTIONS(548),
    [anon_sym_union] = ACTIONS(548),
    [sym_doc_comment] = ACTIONS(546),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(546),
    [aux_sym_FLOAT_token1] = ACTIONS(546),
    [aux_sym_FLOAT_token2] = ACTIONS(546),
    [aux_sym_FLOAT_token3] = ACTIONS(546),
    [aux_sym_FLOAT_token4] = ACTIONS(546),
    [aux_sym_INTEGER_token1] = ACTIONS(546),
    [aux_sym_INTEGER_token2] = ACTIONS(546),
    [aux_sym_INTEGER_token3] = ACTIONS(548),
    [aux_sym_INTEGER_token4] = ACTIONS(548),
    [anon_sym_DQUOTE] = ACTIONS(546),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(546),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(548),
    [anon_sym_AT] = ACTIONS(546),
  },
  [450] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1127),
    [anon_sym_COMMA] = ACTIONS(1127),
    [anon_sym_pub] = ACTIONS(1129),
    [anon_sym_test] = ACTIONS(1129),
    [anon_sym_comptime] = ACTIONS(1129),
    [anon_sym_export] = ACTIONS(1129),
    [anon_sym_extern] = ACTIONS(1129),
    [anon_sym_inline] = ACTIONS(1129),
    [anon_sym_noinline] = ACTIONS(1129),
    [anon_sym_threadlocal] = ACTIONS(1129),
    [anon_sym_usingnamespace] = ACTIONS(1129),
    [anon_sym_fn] = ACTIONS(1129),
    [anon_sym_const] = ACTIONS(1129),
    [anon_sym_var] = ACTIONS(1129),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1127),
    [anon_sym_async] = ACTIONS(1129),
    [anon_sym_DOT] = ACTIONS(1127),
    [anon_sym_error] = ACTIONS(1129),
    [anon_sym_false] = ACTIONS(1129),
    [anon_sym_null] = ACTIONS(1129),
    [anon_sym_anyframe] = ACTIONS(1129),
    [anon_sym_true] = ACTIONS(1129),
    [anon_sym_undefined] = ACTIONS(1129),
    [anon_sym_unreachable] = ACTIONS(1129),
    [sym_BuildinTypeExpr] = ACTIONS(1129),
    [anon_sym_packed] = ACTIONS(1129),
    [anon_sym_LPAREN] = ACTIONS(1127),
    [anon_sym_switch] = ACTIONS(1129),
    [anon_sym_LBRACK] = ACTIONS(1127),
    [anon_sym_if] = ACTIONS(1129),
    [anon_sym_while] = ACTIONS(1129),
    [anon_sym_for] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1127),
    [anon_sym_struct] = ACTIONS(1129),
    [anon_sym_opaque] = ACTIONS(1129),
    [anon_sym_enum] = ACTIONS(1129),
    [anon_sym_union] = ACTIONS(1129),
    [sym_doc_comment] = ACTIONS(1127),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1127),
    [aux_sym_FLOAT_token1] = ACTIONS(1127),
    [aux_sym_FLOAT_token2] = ACTIONS(1127),
    [aux_sym_FLOAT_token3] = ACTIONS(1127),
    [aux_sym_FLOAT_token4] = ACTIONS(1127),
    [aux_sym_INTEGER_token1] = ACTIONS(1127),
    [aux_sym_INTEGER_token2] = ACTIONS(1127),
    [aux_sym_INTEGER_token3] = ACTIONS(1129),
    [aux_sym_INTEGER_token4] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1127),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1129),
    [anon_sym_AT] = ACTIONS(1127),
  },
  [451] = {
    [ts_builtin_sym_end] = ACTIONS(560),
    [anon_sym_COMMA] = ACTIONS(560),
    [anon_sym_pub] = ACTIONS(562),
    [anon_sym_test] = ACTIONS(562),
    [anon_sym_comptime] = ACTIONS(562),
    [anon_sym_export] = ACTIONS(562),
    [anon_sym_extern] = ACTIONS(562),
    [anon_sym_inline] = ACTIONS(562),
    [anon_sym_noinline] = ACTIONS(562),
    [anon_sym_threadlocal] = ACTIONS(562),
    [anon_sym_usingnamespace] = ACTIONS(562),
    [anon_sym_fn] = ACTIONS(562),
    [anon_sym_BANG] = ACTIONS(562),
    [anon_sym_const] = ACTIONS(562),
    [anon_sym_var] = ACTIONS(562),
    [anon_sym_COLON] = ACTIONS(560),
    [anon_sym_or] = ACTIONS(562),
    [anon_sym_and] = ACTIONS(562),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_RBRACE] = ACTIONS(560),
    [anon_sym_async] = ACTIONS(562),
    [anon_sym_DOT] = ACTIONS(562),
    [anon_sym_error] = ACTIONS(562),
    [anon_sym_false] = ACTIONS(562),
    [anon_sym_null] = ACTIONS(562),
    [anon_sym_anyframe] = ACTIONS(562),
    [anon_sym_true] = ACTIONS(562),
    [anon_sym_undefined] = ACTIONS(562),
    [anon_sym_unreachable] = ACTIONS(562),
    [sym_BuildinTypeExpr] = ACTIONS(562),
    [anon_sym_packed] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(560),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_while] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(562),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_STAR] = ACTIONS(562),
    [anon_sym_EQ_EQ] = ACTIONS(560),
    [anon_sym_BANG_EQ] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_LT_EQ] = ACTIONS(560),
    [anon_sym_GT_EQ] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(560),
    [anon_sym_CARET] = ACTIONS(560),
    [anon_sym_orelse] = ACTIONS(562),
    [anon_sym_catch] = ACTIONS(562),
    [anon_sym_LT_LT] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(560),
    [anon_sym_LT_LT_PIPE] = ACTIONS(560),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(560),
    [anon_sym_PLUS_PERCENT] = ACTIONS(560),
    [anon_sym_DASH_PERCENT] = ACTIONS(560),
    [anon_sym_PLUS_PIPE] = ACTIONS(560),
    [anon_sym_DASH_PIPE] = ACTIONS(560),
    [anon_sym_PIPE_PIPE] = ACTIONS(560),
    [anon_sym_SLASH] = ACTIONS(562),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_STAR_STAR] = ACTIONS(560),
    [anon_sym_STAR_PERCENT] = ACTIONS(560),
    [anon_sym_STAR_PIPE] = ACTIONS(560),
    [anon_sym_QMARK] = ACTIONS(560),
    [anon_sym_DOT_STAR] = ACTIONS(560),
    [anon_sym_DOT_QMARK] = ACTIONS(560),
    [anon_sym_struct] = ACTIONS(562),
    [anon_sym_opaque] = ACTIONS(562),
    [anon_sym_enum] = ACTIONS(562),
    [anon_sym_union] = ACTIONS(562),
    [sym_doc_comment] = ACTIONS(560),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(560),
    [aux_sym_FLOAT_token1] = ACTIONS(560),
    [aux_sym_FLOAT_token2] = ACTIONS(560),
    [aux_sym_FLOAT_token3] = ACTIONS(560),
    [aux_sym_FLOAT_token4] = ACTIONS(560),
    [aux_sym_INTEGER_token1] = ACTIONS(560),
    [aux_sym_INTEGER_token2] = ACTIONS(560),
    [aux_sym_INTEGER_token3] = ACTIONS(562),
    [aux_sym_INTEGER_token4] = ACTIONS(562),
    [anon_sym_DQUOTE] = ACTIONS(560),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(560),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(562),
    [anon_sym_AT] = ACTIONS(560),
  },
  [452] = {
    [ts_builtin_sym_end] = ACTIONS(556),
    [anon_sym_COMMA] = ACTIONS(556),
    [anon_sym_pub] = ACTIONS(558),
    [anon_sym_test] = ACTIONS(558),
    [anon_sym_comptime] = ACTIONS(558),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_extern] = ACTIONS(558),
    [anon_sym_inline] = ACTIONS(558),
    [anon_sym_noinline] = ACTIONS(558),
    [anon_sym_threadlocal] = ACTIONS(558),
    [anon_sym_usingnamespace] = ACTIONS(558),
    [anon_sym_fn] = ACTIONS(558),
    [anon_sym_BANG] = ACTIONS(558),
    [anon_sym_const] = ACTIONS(558),
    [anon_sym_var] = ACTIONS(558),
    [anon_sym_COLON] = ACTIONS(556),
    [anon_sym_or] = ACTIONS(558),
    [anon_sym_and] = ACTIONS(558),
    [anon_sym_LBRACE] = ACTIONS(556),
    [anon_sym_RBRACE] = ACTIONS(556),
    [anon_sym_async] = ACTIONS(558),
    [anon_sym_DOT] = ACTIONS(558),
    [anon_sym_error] = ACTIONS(558),
    [anon_sym_false] = ACTIONS(558),
    [anon_sym_null] = ACTIONS(558),
    [anon_sym_anyframe] = ACTIONS(558),
    [anon_sym_true] = ACTIONS(558),
    [anon_sym_undefined] = ACTIONS(558),
    [anon_sym_unreachable] = ACTIONS(558),
    [sym_BuildinTypeExpr] = ACTIONS(558),
    [anon_sym_packed] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_switch] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(556),
    [anon_sym_if] = ACTIONS(558),
    [anon_sym_while] = ACTIONS(558),
    [anon_sym_for] = ACTIONS(558),
    [anon_sym_PIPE] = ACTIONS(558),
    [anon_sym_STAR] = ACTIONS(558),
    [anon_sym_EQ_EQ] = ACTIONS(556),
    [anon_sym_BANG_EQ] = ACTIONS(556),
    [anon_sym_LT] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(558),
    [anon_sym_LT_EQ] = ACTIONS(556),
    [anon_sym_GT_EQ] = ACTIONS(556),
    [anon_sym_AMP] = ACTIONS(556),
    [anon_sym_CARET] = ACTIONS(556),
    [anon_sym_orelse] = ACTIONS(558),
    [anon_sym_catch] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(558),
    [anon_sym_GT_GT] = ACTIONS(556),
    [anon_sym_LT_LT_PIPE] = ACTIONS(556),
    [anon_sym_PLUS] = ACTIONS(558),
    [anon_sym_DASH] = ACTIONS(558),
    [anon_sym_PLUS_PLUS] = ACTIONS(556),
    [anon_sym_PLUS_PERCENT] = ACTIONS(556),
    [anon_sym_DASH_PERCENT] = ACTIONS(556),
    [anon_sym_PLUS_PIPE] = ACTIONS(556),
    [anon_sym_DASH_PIPE] = ACTIONS(556),
    [anon_sym_PIPE_PIPE] = ACTIONS(556),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_PERCENT] = ACTIONS(556),
    [anon_sym_STAR_STAR] = ACTIONS(556),
    [anon_sym_STAR_PERCENT] = ACTIONS(556),
    [anon_sym_STAR_PIPE] = ACTIONS(556),
    [anon_sym_QMARK] = ACTIONS(556),
    [anon_sym_DOT_STAR] = ACTIONS(556),
    [anon_sym_DOT_QMARK] = ACTIONS(556),
    [anon_sym_struct] = ACTIONS(558),
    [anon_sym_opaque] = ACTIONS(558),
    [anon_sym_enum] = ACTIONS(558),
    [anon_sym_union] = ACTIONS(558),
    [sym_doc_comment] = ACTIONS(556),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(556),
    [aux_sym_FLOAT_token1] = ACTIONS(556),
    [aux_sym_FLOAT_token2] = ACTIONS(556),
    [aux_sym_FLOAT_token3] = ACTIONS(556),
    [aux_sym_FLOAT_token4] = ACTIONS(556),
    [aux_sym_INTEGER_token1] = ACTIONS(556),
    [aux_sym_INTEGER_token2] = ACTIONS(556),
    [aux_sym_INTEGER_token3] = ACTIONS(558),
    [aux_sym_INTEGER_token4] = ACTIONS(558),
    [anon_sym_DQUOTE] = ACTIONS(556),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(556),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(558),
    [anon_sym_AT] = ACTIONS(556),
  },
  [453] = {
    [ts_builtin_sym_end] = ACTIONS(536),
    [anon_sym_COMMA] = ACTIONS(536),
    [anon_sym_pub] = ACTIONS(538),
    [anon_sym_test] = ACTIONS(538),
    [anon_sym_comptime] = ACTIONS(538),
    [anon_sym_export] = ACTIONS(538),
    [anon_sym_extern] = ACTIONS(538),
    [anon_sym_inline] = ACTIONS(538),
    [anon_sym_noinline] = ACTIONS(538),
    [anon_sym_threadlocal] = ACTIONS(538),
    [anon_sym_usingnamespace] = ACTIONS(538),
    [anon_sym_fn] = ACTIONS(538),
    [anon_sym_BANG] = ACTIONS(538),
    [anon_sym_const] = ACTIONS(538),
    [anon_sym_var] = ACTIONS(538),
    [anon_sym_COLON] = ACTIONS(536),
    [anon_sym_or] = ACTIONS(538),
    [anon_sym_and] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(536),
    [anon_sym_RBRACE] = ACTIONS(536),
    [anon_sym_async] = ACTIONS(538),
    [anon_sym_DOT] = ACTIONS(538),
    [anon_sym_error] = ACTIONS(538),
    [anon_sym_false] = ACTIONS(538),
    [anon_sym_null] = ACTIONS(538),
    [anon_sym_anyframe] = ACTIONS(538),
    [anon_sym_true] = ACTIONS(538),
    [anon_sym_undefined] = ACTIONS(538),
    [anon_sym_unreachable] = ACTIONS(538),
    [sym_BuildinTypeExpr] = ACTIONS(538),
    [anon_sym_packed] = ACTIONS(538),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_switch] = ACTIONS(538),
    [anon_sym_LBRACK] = ACTIONS(536),
    [anon_sym_if] = ACTIONS(538),
    [anon_sym_while] = ACTIONS(538),
    [anon_sym_for] = ACTIONS(538),
    [anon_sym_PIPE] = ACTIONS(538),
    [anon_sym_STAR] = ACTIONS(538),
    [anon_sym_EQ_EQ] = ACTIONS(536),
    [anon_sym_BANG_EQ] = ACTIONS(536),
    [anon_sym_LT] = ACTIONS(538),
    [anon_sym_GT] = ACTIONS(538),
    [anon_sym_LT_EQ] = ACTIONS(536),
    [anon_sym_GT_EQ] = ACTIONS(536),
    [anon_sym_AMP] = ACTIONS(536),
    [anon_sym_CARET] = ACTIONS(536),
    [anon_sym_orelse] = ACTIONS(538),
    [anon_sym_catch] = ACTIONS(538),
    [anon_sym_LT_LT] = ACTIONS(538),
    [anon_sym_GT_GT] = ACTIONS(536),
    [anon_sym_LT_LT_PIPE] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(538),
    [anon_sym_DASH] = ACTIONS(538),
    [anon_sym_PLUS_PLUS] = ACTIONS(536),
    [anon_sym_PLUS_PERCENT] = ACTIONS(536),
    [anon_sym_DASH_PERCENT] = ACTIONS(536),
    [anon_sym_PLUS_PIPE] = ACTIONS(536),
    [anon_sym_DASH_PIPE] = ACTIONS(536),
    [anon_sym_PIPE_PIPE] = ACTIONS(536),
    [anon_sym_SLASH] = ACTIONS(538),
    [anon_sym_PERCENT] = ACTIONS(536),
    [anon_sym_STAR_STAR] = ACTIONS(536),
    [anon_sym_STAR_PERCENT] = ACTIONS(536),
    [anon_sym_STAR_PIPE] = ACTIONS(536),
    [anon_sym_QMARK] = ACTIONS(536),
    [anon_sym_DOT_STAR] = ACTIONS(536),
    [anon_sym_DOT_QMARK] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_opaque] = ACTIONS(538),
    [anon_sym_enum] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(538),
    [sym_doc_comment] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(536),
    [aux_sym_FLOAT_token1] = ACTIONS(536),
    [aux_sym_FLOAT_token2] = ACTIONS(536),
    [aux_sym_FLOAT_token3] = ACTIONS(536),
    [aux_sym_FLOAT_token4] = ACTIONS(536),
    [aux_sym_INTEGER_token1] = ACTIONS(536),
    [aux_sym_INTEGER_token2] = ACTIONS(536),
    [aux_sym_INTEGER_token3] = ACTIONS(538),
    [aux_sym_INTEGER_token4] = ACTIONS(538),
    [anon_sym_DQUOTE] = ACTIONS(536),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(536),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(538),
    [anon_sym_AT] = ACTIONS(536),
  },
  [454] = {
    [ts_builtin_sym_end] = ACTIONS(552),
    [anon_sym_COMMA] = ACTIONS(552),
    [anon_sym_pub] = ACTIONS(554),
    [anon_sym_test] = ACTIONS(554),
    [anon_sym_comptime] = ACTIONS(554),
    [anon_sym_export] = ACTIONS(554),
    [anon_sym_extern] = ACTIONS(554),
    [anon_sym_inline] = ACTIONS(554),
    [anon_sym_noinline] = ACTIONS(554),
    [anon_sym_threadlocal] = ACTIONS(554),
    [anon_sym_usingnamespace] = ACTIONS(554),
    [anon_sym_fn] = ACTIONS(554),
    [anon_sym_BANG] = ACTIONS(554),
    [anon_sym_const] = ACTIONS(554),
    [anon_sym_var] = ACTIONS(554),
    [anon_sym_COLON] = ACTIONS(552),
    [anon_sym_or] = ACTIONS(554),
    [anon_sym_and] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(552),
    [anon_sym_RBRACE] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(554),
    [anon_sym_DOT] = ACTIONS(554),
    [anon_sym_error] = ACTIONS(554),
    [anon_sym_false] = ACTIONS(554),
    [anon_sym_null] = ACTIONS(554),
    [anon_sym_anyframe] = ACTIONS(554),
    [anon_sym_true] = ACTIONS(554),
    [anon_sym_undefined] = ACTIONS(554),
    [anon_sym_unreachable] = ACTIONS(554),
    [sym_BuildinTypeExpr] = ACTIONS(554),
    [anon_sym_packed] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_switch] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(554),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_PIPE] = ACTIONS(554),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_EQ_EQ] = ACTIONS(552),
    [anon_sym_BANG_EQ] = ACTIONS(552),
    [anon_sym_LT] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(552),
    [anon_sym_GT_EQ] = ACTIONS(552),
    [anon_sym_AMP] = ACTIONS(552),
    [anon_sym_CARET] = ACTIONS(552),
    [anon_sym_orelse] = ACTIONS(554),
    [anon_sym_catch] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(554),
    [anon_sym_GT_GT] = ACTIONS(552),
    [anon_sym_LT_LT_PIPE] = ACTIONS(552),
    [anon_sym_PLUS] = ACTIONS(554),
    [anon_sym_DASH] = ACTIONS(554),
    [anon_sym_PLUS_PLUS] = ACTIONS(552),
    [anon_sym_PLUS_PERCENT] = ACTIONS(552),
    [anon_sym_DASH_PERCENT] = ACTIONS(552),
    [anon_sym_PLUS_PIPE] = ACTIONS(552),
    [anon_sym_DASH_PIPE] = ACTIONS(552),
    [anon_sym_PIPE_PIPE] = ACTIONS(552),
    [anon_sym_SLASH] = ACTIONS(554),
    [anon_sym_PERCENT] = ACTIONS(552),
    [anon_sym_STAR_STAR] = ACTIONS(552),
    [anon_sym_STAR_PERCENT] = ACTIONS(552),
    [anon_sym_STAR_PIPE] = ACTIONS(552),
    [anon_sym_QMARK] = ACTIONS(552),
    [anon_sym_DOT_STAR] = ACTIONS(552),
    [anon_sym_DOT_QMARK] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_opaque] = ACTIONS(554),
    [anon_sym_enum] = ACTIONS(554),
    [anon_sym_union] = ACTIONS(554),
    [sym_doc_comment] = ACTIONS(552),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [aux_sym_FLOAT_token1] = ACTIONS(552),
    [aux_sym_FLOAT_token2] = ACTIONS(552),
    [aux_sym_FLOAT_token3] = ACTIONS(552),
    [aux_sym_FLOAT_token4] = ACTIONS(552),
    [aux_sym_INTEGER_token1] = ACTIONS(552),
    [aux_sym_INTEGER_token2] = ACTIONS(552),
    [aux_sym_INTEGER_token3] = ACTIONS(554),
    [aux_sym_INTEGER_token4] = ACTIONS(554),
    [anon_sym_DQUOTE] = ACTIONS(552),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(552),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(552),
  },
  [455] = {
    [sym_FnCallArguments] = STATE(584),
    [ts_builtin_sym_end] = ACTIONS(1089),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_pub] = ACTIONS(1091),
    [anon_sym_test] = ACTIONS(1091),
    [anon_sym_comptime] = ACTIONS(1091),
    [anon_sym_export] = ACTIONS(1091),
    [anon_sym_extern] = ACTIONS(1091),
    [anon_sym_inline] = ACTIONS(1091),
    [anon_sym_noinline] = ACTIONS(1091),
    [anon_sym_threadlocal] = ACTIONS(1091),
    [anon_sym_usingnamespace] = ACTIONS(1091),
    [anon_sym_fn] = ACTIONS(1091),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_const] = ACTIONS(1091),
    [anon_sym_var] = ACTIONS(1091),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_and] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_async] = ACTIONS(1091),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_error] = ACTIONS(1091),
    [anon_sym_false] = ACTIONS(1091),
    [anon_sym_null] = ACTIONS(1091),
    [anon_sym_anyframe] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1091),
    [anon_sym_undefined] = ACTIONS(1091),
    [anon_sym_unreachable] = ACTIONS(1091),
    [sym_BuildinTypeExpr] = ACTIONS(1091),
    [anon_sym_packed] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(947),
    [anon_sym_switch] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_if] = ACTIONS(1091),
    [anon_sym_while] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1091),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1089),
    [anon_sym_CARET] = ACTIONS(1089),
    [anon_sym_orelse] = ACTIONS(1091),
    [anon_sym_catch] = ACTIONS(1091),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1089),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1089),
    [anon_sym_DASH_PERCENT] = ACTIONS(1089),
    [anon_sym_PLUS_PIPE] = ACTIONS(1089),
    [anon_sym_DASH_PIPE] = ACTIONS(1089),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1089),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_STAR_PERCENT] = ACTIONS(1089),
    [anon_sym_STAR_PIPE] = ACTIONS(1089),
    [anon_sym_QMARK] = ACTIONS(1089),
    [anon_sym_DOT_STAR] = ACTIONS(1089),
    [anon_sym_DOT_QMARK] = ACTIONS(1089),
    [anon_sym_struct] = ACTIONS(1091),
    [anon_sym_opaque] = ACTIONS(1091),
    [anon_sym_enum] = ACTIONS(1091),
    [anon_sym_union] = ACTIONS(1091),
    [sym_doc_comment] = ACTIONS(1089),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1089),
    [aux_sym_FLOAT_token1] = ACTIONS(1089),
    [aux_sym_FLOAT_token2] = ACTIONS(1089),
    [aux_sym_FLOAT_token3] = ACTIONS(1089),
    [aux_sym_FLOAT_token4] = ACTIONS(1089),
    [aux_sym_INTEGER_token1] = ACTIONS(1089),
    [aux_sym_INTEGER_token2] = ACTIONS(1089),
    [aux_sym_INTEGER_token3] = ACTIONS(1091),
    [aux_sym_INTEGER_token4] = ACTIONS(1091),
    [anon_sym_DQUOTE] = ACTIONS(1089),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1089),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1091),
    [anon_sym_AT] = ACTIONS(1089),
  },
  [456] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1131),
    [anon_sym_COMMA] = ACTIONS(1131),
    [anon_sym_pub] = ACTIONS(1133),
    [anon_sym_test] = ACTIONS(1133),
    [anon_sym_comptime] = ACTIONS(1133),
    [anon_sym_export] = ACTIONS(1133),
    [anon_sym_extern] = ACTIONS(1133),
    [anon_sym_inline] = ACTIONS(1133),
    [anon_sym_noinline] = ACTIONS(1133),
    [anon_sym_threadlocal] = ACTIONS(1133),
    [anon_sym_usingnamespace] = ACTIONS(1133),
    [anon_sym_fn] = ACTIONS(1133),
    [anon_sym_const] = ACTIONS(1133),
    [anon_sym_var] = ACTIONS(1133),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1131),
    [anon_sym_async] = ACTIONS(1133),
    [anon_sym_DOT] = ACTIONS(1131),
    [anon_sym_error] = ACTIONS(1133),
    [anon_sym_false] = ACTIONS(1133),
    [anon_sym_null] = ACTIONS(1133),
    [anon_sym_anyframe] = ACTIONS(1133),
    [anon_sym_true] = ACTIONS(1133),
    [anon_sym_undefined] = ACTIONS(1133),
    [anon_sym_unreachable] = ACTIONS(1133),
    [sym_BuildinTypeExpr] = ACTIONS(1133),
    [anon_sym_packed] = ACTIONS(1133),
    [anon_sym_LPAREN] = ACTIONS(1131),
    [anon_sym_switch] = ACTIONS(1133),
    [anon_sym_LBRACK] = ACTIONS(1131),
    [anon_sym_if] = ACTIONS(1133),
    [anon_sym_while] = ACTIONS(1133),
    [anon_sym_for] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1131),
    [anon_sym_struct] = ACTIONS(1133),
    [anon_sym_opaque] = ACTIONS(1133),
    [anon_sym_enum] = ACTIONS(1133),
    [anon_sym_union] = ACTIONS(1133),
    [sym_doc_comment] = ACTIONS(1131),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1131),
    [aux_sym_FLOAT_token1] = ACTIONS(1131),
    [aux_sym_FLOAT_token2] = ACTIONS(1131),
    [aux_sym_FLOAT_token3] = ACTIONS(1131),
    [aux_sym_FLOAT_token4] = ACTIONS(1131),
    [aux_sym_INTEGER_token1] = ACTIONS(1131),
    [aux_sym_INTEGER_token2] = ACTIONS(1131),
    [aux_sym_INTEGER_token3] = ACTIONS(1133),
    [aux_sym_INTEGER_token4] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1131),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1133),
    [anon_sym_AT] = ACTIONS(1131),
  },
  [457] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1135),
    [anon_sym_COMMA] = ACTIONS(1135),
    [anon_sym_pub] = ACTIONS(1137),
    [anon_sym_test] = ACTIONS(1137),
    [anon_sym_comptime] = ACTIONS(1137),
    [anon_sym_export] = ACTIONS(1137),
    [anon_sym_extern] = ACTIONS(1137),
    [anon_sym_inline] = ACTIONS(1137),
    [anon_sym_noinline] = ACTIONS(1137),
    [anon_sym_threadlocal] = ACTIONS(1137),
    [anon_sym_usingnamespace] = ACTIONS(1137),
    [anon_sym_fn] = ACTIONS(1137),
    [anon_sym_const] = ACTIONS(1137),
    [anon_sym_var] = ACTIONS(1137),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1135),
    [anon_sym_async] = ACTIONS(1137),
    [anon_sym_DOT] = ACTIONS(1135),
    [anon_sym_error] = ACTIONS(1137),
    [anon_sym_false] = ACTIONS(1137),
    [anon_sym_null] = ACTIONS(1137),
    [anon_sym_anyframe] = ACTIONS(1137),
    [anon_sym_true] = ACTIONS(1137),
    [anon_sym_undefined] = ACTIONS(1137),
    [anon_sym_unreachable] = ACTIONS(1137),
    [sym_BuildinTypeExpr] = ACTIONS(1137),
    [anon_sym_packed] = ACTIONS(1137),
    [anon_sym_LPAREN] = ACTIONS(1135),
    [anon_sym_switch] = ACTIONS(1137),
    [anon_sym_LBRACK] = ACTIONS(1135),
    [anon_sym_if] = ACTIONS(1137),
    [anon_sym_while] = ACTIONS(1137),
    [anon_sym_for] = ACTIONS(1137),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1135),
    [anon_sym_struct] = ACTIONS(1137),
    [anon_sym_opaque] = ACTIONS(1137),
    [anon_sym_enum] = ACTIONS(1137),
    [anon_sym_union] = ACTIONS(1137),
    [sym_doc_comment] = ACTIONS(1135),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [aux_sym_FLOAT_token1] = ACTIONS(1135),
    [aux_sym_FLOAT_token2] = ACTIONS(1135),
    [aux_sym_FLOAT_token3] = ACTIONS(1135),
    [aux_sym_FLOAT_token4] = ACTIONS(1135),
    [aux_sym_INTEGER_token1] = ACTIONS(1135),
    [aux_sym_INTEGER_token2] = ACTIONS(1135),
    [aux_sym_INTEGER_token3] = ACTIONS(1137),
    [aux_sym_INTEGER_token4] = ACTIONS(1137),
    [anon_sym_DQUOTE] = ACTIONS(1135),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1135),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1137),
    [anon_sym_AT] = ACTIONS(1135),
  },
  [458] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1139),
    [anon_sym_COMMA] = ACTIONS(1139),
    [anon_sym_pub] = ACTIONS(1141),
    [anon_sym_test] = ACTIONS(1141),
    [anon_sym_comptime] = ACTIONS(1141),
    [anon_sym_export] = ACTIONS(1141),
    [anon_sym_extern] = ACTIONS(1141),
    [anon_sym_inline] = ACTIONS(1141),
    [anon_sym_noinline] = ACTIONS(1141),
    [anon_sym_threadlocal] = ACTIONS(1141),
    [anon_sym_usingnamespace] = ACTIONS(1141),
    [anon_sym_fn] = ACTIONS(1141),
    [anon_sym_const] = ACTIONS(1141),
    [anon_sym_var] = ACTIONS(1141),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1139),
    [anon_sym_async] = ACTIONS(1141),
    [anon_sym_DOT] = ACTIONS(1139),
    [anon_sym_error] = ACTIONS(1141),
    [anon_sym_false] = ACTIONS(1141),
    [anon_sym_null] = ACTIONS(1141),
    [anon_sym_anyframe] = ACTIONS(1141),
    [anon_sym_true] = ACTIONS(1141),
    [anon_sym_undefined] = ACTIONS(1141),
    [anon_sym_unreachable] = ACTIONS(1141),
    [sym_BuildinTypeExpr] = ACTIONS(1141),
    [anon_sym_packed] = ACTIONS(1141),
    [anon_sym_LPAREN] = ACTIONS(1139),
    [anon_sym_switch] = ACTIONS(1141),
    [anon_sym_LBRACK] = ACTIONS(1139),
    [anon_sym_if] = ACTIONS(1141),
    [anon_sym_while] = ACTIONS(1141),
    [anon_sym_for] = ACTIONS(1141),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1139),
    [anon_sym_struct] = ACTIONS(1141),
    [anon_sym_opaque] = ACTIONS(1141),
    [anon_sym_enum] = ACTIONS(1141),
    [anon_sym_union] = ACTIONS(1141),
    [sym_doc_comment] = ACTIONS(1139),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1139),
    [aux_sym_FLOAT_token1] = ACTIONS(1139),
    [aux_sym_FLOAT_token2] = ACTIONS(1139),
    [aux_sym_FLOAT_token3] = ACTIONS(1139),
    [aux_sym_FLOAT_token4] = ACTIONS(1139),
    [aux_sym_INTEGER_token1] = ACTIONS(1139),
    [aux_sym_INTEGER_token2] = ACTIONS(1139),
    [aux_sym_INTEGER_token3] = ACTIONS(1141),
    [aux_sym_INTEGER_token4] = ACTIONS(1141),
    [anon_sym_DQUOTE] = ACTIONS(1139),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1139),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1141),
    [anon_sym_AT] = ACTIONS(1139),
  },
  [459] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1143),
    [anon_sym_COMMA] = ACTIONS(1143),
    [anon_sym_pub] = ACTIONS(1145),
    [anon_sym_test] = ACTIONS(1145),
    [anon_sym_comptime] = ACTIONS(1145),
    [anon_sym_export] = ACTIONS(1145),
    [anon_sym_extern] = ACTIONS(1145),
    [anon_sym_inline] = ACTIONS(1145),
    [anon_sym_noinline] = ACTIONS(1145),
    [anon_sym_threadlocal] = ACTIONS(1145),
    [anon_sym_usingnamespace] = ACTIONS(1145),
    [anon_sym_fn] = ACTIONS(1145),
    [anon_sym_const] = ACTIONS(1145),
    [anon_sym_var] = ACTIONS(1145),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1143),
    [anon_sym_async] = ACTIONS(1145),
    [anon_sym_DOT] = ACTIONS(1143),
    [anon_sym_error] = ACTIONS(1145),
    [anon_sym_false] = ACTIONS(1145),
    [anon_sym_null] = ACTIONS(1145),
    [anon_sym_anyframe] = ACTIONS(1145),
    [anon_sym_true] = ACTIONS(1145),
    [anon_sym_undefined] = ACTIONS(1145),
    [anon_sym_unreachable] = ACTIONS(1145),
    [sym_BuildinTypeExpr] = ACTIONS(1145),
    [anon_sym_packed] = ACTIONS(1145),
    [anon_sym_LPAREN] = ACTIONS(1143),
    [anon_sym_switch] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1143),
    [anon_sym_if] = ACTIONS(1145),
    [anon_sym_while] = ACTIONS(1145),
    [anon_sym_for] = ACTIONS(1145),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1143),
    [anon_sym_struct] = ACTIONS(1145),
    [anon_sym_opaque] = ACTIONS(1145),
    [anon_sym_enum] = ACTIONS(1145),
    [anon_sym_union] = ACTIONS(1145),
    [sym_doc_comment] = ACTIONS(1143),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1143),
    [aux_sym_FLOAT_token1] = ACTIONS(1143),
    [aux_sym_FLOAT_token2] = ACTIONS(1143),
    [aux_sym_FLOAT_token3] = ACTIONS(1143),
    [aux_sym_FLOAT_token4] = ACTIONS(1143),
    [aux_sym_INTEGER_token1] = ACTIONS(1143),
    [aux_sym_INTEGER_token2] = ACTIONS(1143),
    [aux_sym_INTEGER_token3] = ACTIONS(1145),
    [aux_sym_INTEGER_token4] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1143),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1145),
    [anon_sym_AT] = ACTIONS(1143),
  },
  [460] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1147),
    [anon_sym_COMMA] = ACTIONS(1147),
    [anon_sym_pub] = ACTIONS(1149),
    [anon_sym_test] = ACTIONS(1149),
    [anon_sym_comptime] = ACTIONS(1149),
    [anon_sym_export] = ACTIONS(1149),
    [anon_sym_extern] = ACTIONS(1149),
    [anon_sym_inline] = ACTIONS(1149),
    [anon_sym_noinline] = ACTIONS(1149),
    [anon_sym_threadlocal] = ACTIONS(1149),
    [anon_sym_usingnamespace] = ACTIONS(1149),
    [anon_sym_fn] = ACTIONS(1149),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_var] = ACTIONS(1149),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1147),
    [anon_sym_async] = ACTIONS(1149),
    [anon_sym_DOT] = ACTIONS(1147),
    [anon_sym_error] = ACTIONS(1149),
    [anon_sym_false] = ACTIONS(1149),
    [anon_sym_null] = ACTIONS(1149),
    [anon_sym_anyframe] = ACTIONS(1149),
    [anon_sym_true] = ACTIONS(1149),
    [anon_sym_undefined] = ACTIONS(1149),
    [anon_sym_unreachable] = ACTIONS(1149),
    [sym_BuildinTypeExpr] = ACTIONS(1149),
    [anon_sym_packed] = ACTIONS(1149),
    [anon_sym_LPAREN] = ACTIONS(1147),
    [anon_sym_switch] = ACTIONS(1149),
    [anon_sym_LBRACK] = ACTIONS(1147),
    [anon_sym_if] = ACTIONS(1149),
    [anon_sym_while] = ACTIONS(1149),
    [anon_sym_for] = ACTIONS(1149),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1147),
    [anon_sym_struct] = ACTIONS(1149),
    [anon_sym_opaque] = ACTIONS(1149),
    [anon_sym_enum] = ACTIONS(1149),
    [anon_sym_union] = ACTIONS(1149),
    [sym_doc_comment] = ACTIONS(1147),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1147),
    [aux_sym_FLOAT_token1] = ACTIONS(1147),
    [aux_sym_FLOAT_token2] = ACTIONS(1147),
    [aux_sym_FLOAT_token3] = ACTIONS(1147),
    [aux_sym_FLOAT_token4] = ACTIONS(1147),
    [aux_sym_INTEGER_token1] = ACTIONS(1147),
    [aux_sym_INTEGER_token2] = ACTIONS(1147),
    [aux_sym_INTEGER_token3] = ACTIONS(1149),
    [aux_sym_INTEGER_token4] = ACTIONS(1149),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1147),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1149),
    [anon_sym_AT] = ACTIONS(1147),
  },
  [461] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1151),
    [anon_sym_COMMA] = ACTIONS(1151),
    [anon_sym_pub] = ACTIONS(1153),
    [anon_sym_test] = ACTIONS(1153),
    [anon_sym_comptime] = ACTIONS(1153),
    [anon_sym_export] = ACTIONS(1153),
    [anon_sym_extern] = ACTIONS(1153),
    [anon_sym_inline] = ACTIONS(1153),
    [anon_sym_noinline] = ACTIONS(1153),
    [anon_sym_threadlocal] = ACTIONS(1153),
    [anon_sym_usingnamespace] = ACTIONS(1153),
    [anon_sym_fn] = ACTIONS(1153),
    [anon_sym_const] = ACTIONS(1153),
    [anon_sym_var] = ACTIONS(1153),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1151),
    [anon_sym_async] = ACTIONS(1153),
    [anon_sym_DOT] = ACTIONS(1151),
    [anon_sym_error] = ACTIONS(1153),
    [anon_sym_false] = ACTIONS(1153),
    [anon_sym_null] = ACTIONS(1153),
    [anon_sym_anyframe] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1153),
    [anon_sym_undefined] = ACTIONS(1153),
    [anon_sym_unreachable] = ACTIONS(1153),
    [sym_BuildinTypeExpr] = ACTIONS(1153),
    [anon_sym_packed] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(1151),
    [anon_sym_switch] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(1151),
    [anon_sym_if] = ACTIONS(1153),
    [anon_sym_while] = ACTIONS(1153),
    [anon_sym_for] = ACTIONS(1153),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1151),
    [anon_sym_struct] = ACTIONS(1153),
    [anon_sym_opaque] = ACTIONS(1153),
    [anon_sym_enum] = ACTIONS(1153),
    [anon_sym_union] = ACTIONS(1153),
    [sym_doc_comment] = ACTIONS(1151),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1151),
    [aux_sym_FLOAT_token1] = ACTIONS(1151),
    [aux_sym_FLOAT_token2] = ACTIONS(1151),
    [aux_sym_FLOAT_token3] = ACTIONS(1151),
    [aux_sym_FLOAT_token4] = ACTIONS(1151),
    [aux_sym_INTEGER_token1] = ACTIONS(1151),
    [aux_sym_INTEGER_token2] = ACTIONS(1151),
    [aux_sym_INTEGER_token3] = ACTIONS(1153),
    [aux_sym_INTEGER_token4] = ACTIONS(1153),
    [anon_sym_DQUOTE] = ACTIONS(1151),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1151),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1153),
    [anon_sym_AT] = ACTIONS(1151),
  },
  [462] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1155),
    [anon_sym_COMMA] = ACTIONS(1155),
    [anon_sym_pub] = ACTIONS(1157),
    [anon_sym_test] = ACTIONS(1157),
    [anon_sym_comptime] = ACTIONS(1157),
    [anon_sym_export] = ACTIONS(1157),
    [anon_sym_extern] = ACTIONS(1157),
    [anon_sym_inline] = ACTIONS(1157),
    [anon_sym_noinline] = ACTIONS(1157),
    [anon_sym_threadlocal] = ACTIONS(1157),
    [anon_sym_usingnamespace] = ACTIONS(1157),
    [anon_sym_fn] = ACTIONS(1157),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_var] = ACTIONS(1157),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_DOT] = ACTIONS(1155),
    [anon_sym_error] = ACTIONS(1157),
    [anon_sym_false] = ACTIONS(1157),
    [anon_sym_null] = ACTIONS(1157),
    [anon_sym_anyframe] = ACTIONS(1157),
    [anon_sym_true] = ACTIONS(1157),
    [anon_sym_undefined] = ACTIONS(1157),
    [anon_sym_unreachable] = ACTIONS(1157),
    [sym_BuildinTypeExpr] = ACTIONS(1157),
    [anon_sym_packed] = ACTIONS(1157),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_switch] = ACTIONS(1157),
    [anon_sym_LBRACK] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(1157),
    [anon_sym_while] = ACTIONS(1157),
    [anon_sym_for] = ACTIONS(1157),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1155),
    [anon_sym_struct] = ACTIONS(1157),
    [anon_sym_opaque] = ACTIONS(1157),
    [anon_sym_enum] = ACTIONS(1157),
    [anon_sym_union] = ACTIONS(1157),
    [sym_doc_comment] = ACTIONS(1155),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1155),
    [aux_sym_FLOAT_token1] = ACTIONS(1155),
    [aux_sym_FLOAT_token2] = ACTIONS(1155),
    [aux_sym_FLOAT_token3] = ACTIONS(1155),
    [aux_sym_FLOAT_token4] = ACTIONS(1155),
    [aux_sym_INTEGER_token1] = ACTIONS(1155),
    [aux_sym_INTEGER_token2] = ACTIONS(1155),
    [aux_sym_INTEGER_token3] = ACTIONS(1157),
    [aux_sym_INTEGER_token4] = ACTIONS(1157),
    [anon_sym_DQUOTE] = ACTIONS(1155),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1155),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1157),
    [anon_sym_AT] = ACTIONS(1155),
  },
  [463] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_pub] = ACTIONS(1161),
    [anon_sym_test] = ACTIONS(1161),
    [anon_sym_comptime] = ACTIONS(1161),
    [anon_sym_export] = ACTIONS(1161),
    [anon_sym_extern] = ACTIONS(1161),
    [anon_sym_inline] = ACTIONS(1161),
    [anon_sym_noinline] = ACTIONS(1161),
    [anon_sym_threadlocal] = ACTIONS(1161),
    [anon_sym_usingnamespace] = ACTIONS(1161),
    [anon_sym_fn] = ACTIONS(1161),
    [anon_sym_const] = ACTIONS(1161),
    [anon_sym_var] = ACTIONS(1161),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1159),
    [anon_sym_async] = ACTIONS(1161),
    [anon_sym_DOT] = ACTIONS(1159),
    [anon_sym_error] = ACTIONS(1161),
    [anon_sym_false] = ACTIONS(1161),
    [anon_sym_null] = ACTIONS(1161),
    [anon_sym_anyframe] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(1161),
    [anon_sym_undefined] = ACTIONS(1161),
    [anon_sym_unreachable] = ACTIONS(1161),
    [sym_BuildinTypeExpr] = ACTIONS(1161),
    [anon_sym_packed] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [anon_sym_switch] = ACTIONS(1161),
    [anon_sym_LBRACK] = ACTIONS(1159),
    [anon_sym_if] = ACTIONS(1161),
    [anon_sym_while] = ACTIONS(1161),
    [anon_sym_for] = ACTIONS(1161),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1159),
    [anon_sym_struct] = ACTIONS(1161),
    [anon_sym_opaque] = ACTIONS(1161),
    [anon_sym_enum] = ACTIONS(1161),
    [anon_sym_union] = ACTIONS(1161),
    [sym_doc_comment] = ACTIONS(1159),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1159),
    [aux_sym_FLOAT_token1] = ACTIONS(1159),
    [aux_sym_FLOAT_token2] = ACTIONS(1159),
    [aux_sym_FLOAT_token3] = ACTIONS(1159),
    [aux_sym_FLOAT_token4] = ACTIONS(1159),
    [aux_sym_INTEGER_token1] = ACTIONS(1159),
    [aux_sym_INTEGER_token2] = ACTIONS(1159),
    [aux_sym_INTEGER_token3] = ACTIONS(1161),
    [aux_sym_INTEGER_token4] = ACTIONS(1161),
    [anon_sym_DQUOTE] = ACTIONS(1159),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1159),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1161),
    [anon_sym_AT] = ACTIONS(1159),
  },
  [464] = {
    [ts_builtin_sym_end] = ACTIONS(1163),
    [anon_sym_COMMA] = ACTIONS(1163),
    [anon_sym_pub] = ACTIONS(1165),
    [anon_sym_test] = ACTIONS(1165),
    [anon_sym_comptime] = ACTIONS(1165),
    [anon_sym_export] = ACTIONS(1165),
    [anon_sym_extern] = ACTIONS(1165),
    [anon_sym_inline] = ACTIONS(1165),
    [anon_sym_noinline] = ACTIONS(1165),
    [anon_sym_threadlocal] = ACTIONS(1165),
    [anon_sym_usingnamespace] = ACTIONS(1165),
    [anon_sym_fn] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_var] = ACTIONS(1165),
    [anon_sym_else] = ACTIONS(1165),
    [anon_sym_or] = ACTIONS(1165),
    [anon_sym_and] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(1163),
    [anon_sym_async] = ACTIONS(1165),
    [anon_sym_DOT] = ACTIONS(1165),
    [anon_sym_error] = ACTIONS(1165),
    [anon_sym_false] = ACTIONS(1165),
    [anon_sym_null] = ACTIONS(1165),
    [anon_sym_anyframe] = ACTIONS(1165),
    [anon_sym_true] = ACTIONS(1165),
    [anon_sym_undefined] = ACTIONS(1165),
    [anon_sym_unreachable] = ACTIONS(1165),
    [sym_BuildinTypeExpr] = ACTIONS(1165),
    [anon_sym_packed] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_switch] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1163),
    [anon_sym_if] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(1165),
    [anon_sym_for] = ACTIONS(1165),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_EQ_EQ] = ACTIONS(1163),
    [anon_sym_BANG_EQ] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_GT] = ACTIONS(1165),
    [anon_sym_LT_EQ] = ACTIONS(1163),
    [anon_sym_GT_EQ] = ACTIONS(1163),
    [anon_sym_AMP] = ACTIONS(1163),
    [anon_sym_CARET] = ACTIONS(1163),
    [anon_sym_orelse] = ACTIONS(1165),
    [anon_sym_catch] = ACTIONS(1165),
    [anon_sym_LT_LT] = ACTIONS(1165),
    [anon_sym_GT_GT] = ACTIONS(1163),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_PLUS_PLUS] = ACTIONS(1163),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1163),
    [anon_sym_DASH_PERCENT] = ACTIONS(1163),
    [anon_sym_PLUS_PIPE] = ACTIONS(1163),
    [anon_sym_DASH_PIPE] = ACTIONS(1163),
    [anon_sym_PIPE_PIPE] = ACTIONS(1163),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_STAR_STAR] = ACTIONS(1163),
    [anon_sym_STAR_PERCENT] = ACTIONS(1163),
    [anon_sym_STAR_PIPE] = ACTIONS(1163),
    [anon_sym_QMARK] = ACTIONS(1163),
    [anon_sym_DOT_STAR] = ACTIONS(1163),
    [anon_sym_DOT_QMARK] = ACTIONS(1163),
    [anon_sym_struct] = ACTIONS(1165),
    [anon_sym_opaque] = ACTIONS(1165),
    [anon_sym_enum] = ACTIONS(1165),
    [anon_sym_union] = ACTIONS(1165),
    [sym_doc_comment] = ACTIONS(1163),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1163),
    [aux_sym_FLOAT_token1] = ACTIONS(1163),
    [aux_sym_FLOAT_token2] = ACTIONS(1163),
    [aux_sym_FLOAT_token3] = ACTIONS(1163),
    [aux_sym_FLOAT_token4] = ACTIONS(1163),
    [aux_sym_INTEGER_token1] = ACTIONS(1163),
    [aux_sym_INTEGER_token2] = ACTIONS(1163),
    [aux_sym_INTEGER_token3] = ACTIONS(1165),
    [aux_sym_INTEGER_token4] = ACTIONS(1165),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1163),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(1163),
  },
  [465] = {
    [ts_builtin_sym_end] = ACTIONS(1167),
    [anon_sym_COMMA] = ACTIONS(1167),
    [anon_sym_pub] = ACTIONS(1169),
    [anon_sym_test] = ACTIONS(1169),
    [anon_sym_comptime] = ACTIONS(1169),
    [anon_sym_export] = ACTIONS(1169),
    [anon_sym_extern] = ACTIONS(1169),
    [anon_sym_inline] = ACTIONS(1169),
    [anon_sym_noinline] = ACTIONS(1169),
    [anon_sym_threadlocal] = ACTIONS(1169),
    [anon_sym_usingnamespace] = ACTIONS(1169),
    [anon_sym_fn] = ACTIONS(1169),
    [anon_sym_BANG] = ACTIONS(1169),
    [anon_sym_const] = ACTIONS(1169),
    [anon_sym_var] = ACTIONS(1169),
    [anon_sym_else] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(1167),
    [anon_sym_async] = ACTIONS(1169),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_error] = ACTIONS(1169),
    [anon_sym_false] = ACTIONS(1169),
    [anon_sym_null] = ACTIONS(1169),
    [anon_sym_anyframe] = ACTIONS(1169),
    [anon_sym_true] = ACTIONS(1169),
    [anon_sym_undefined] = ACTIONS(1169),
    [anon_sym_unreachable] = ACTIONS(1169),
    [sym_BuildinTypeExpr] = ACTIONS(1169),
    [anon_sym_packed] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_if] = ACTIONS(1169),
    [anon_sym_while] = ACTIONS(1169),
    [anon_sym_for] = ACTIONS(1169),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_STAR] = ACTIONS(1169),
    [anon_sym_EQ_EQ] = ACTIONS(1167),
    [anon_sym_BANG_EQ] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_LT_EQ] = ACTIONS(1167),
    [anon_sym_GT_EQ] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1167),
    [anon_sym_CARET] = ACTIONS(1167),
    [anon_sym_orelse] = ACTIONS(1169),
    [anon_sym_catch] = ACTIONS(1169),
    [anon_sym_LT_LT] = ACTIONS(1169),
    [anon_sym_GT_GT] = ACTIONS(1167),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1167),
    [anon_sym_PLUS] = ACTIONS(1169),
    [anon_sym_DASH] = ACTIONS(1169),
    [anon_sym_PLUS_PLUS] = ACTIONS(1167),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1167),
    [anon_sym_DASH_PERCENT] = ACTIONS(1167),
    [anon_sym_PLUS_PIPE] = ACTIONS(1167),
    [anon_sym_DASH_PIPE] = ACTIONS(1167),
    [anon_sym_PIPE_PIPE] = ACTIONS(1167),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1167),
    [anon_sym_STAR_STAR] = ACTIONS(1167),
    [anon_sym_STAR_PERCENT] = ACTIONS(1167),
    [anon_sym_STAR_PIPE] = ACTIONS(1167),
    [anon_sym_QMARK] = ACTIONS(1167),
    [anon_sym_DOT_STAR] = ACTIONS(1167),
    [anon_sym_DOT_QMARK] = ACTIONS(1167),
    [anon_sym_struct] = ACTIONS(1169),
    [anon_sym_opaque] = ACTIONS(1169),
    [anon_sym_enum] = ACTIONS(1169),
    [anon_sym_union] = ACTIONS(1169),
    [sym_doc_comment] = ACTIONS(1167),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1167),
    [aux_sym_FLOAT_token1] = ACTIONS(1167),
    [aux_sym_FLOAT_token2] = ACTIONS(1167),
    [aux_sym_FLOAT_token3] = ACTIONS(1167),
    [aux_sym_FLOAT_token4] = ACTIONS(1167),
    [aux_sym_INTEGER_token1] = ACTIONS(1167),
    [aux_sym_INTEGER_token2] = ACTIONS(1167),
    [aux_sym_INTEGER_token3] = ACTIONS(1169),
    [aux_sym_INTEGER_token4] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1167),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1167),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1169),
    [anon_sym_AT] = ACTIONS(1167),
  },
  [466] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1171),
    [anon_sym_COMMA] = ACTIONS(1171),
    [anon_sym_pub] = ACTIONS(1173),
    [anon_sym_test] = ACTIONS(1173),
    [anon_sym_comptime] = ACTIONS(1173),
    [anon_sym_export] = ACTIONS(1173),
    [anon_sym_extern] = ACTIONS(1173),
    [anon_sym_inline] = ACTIONS(1173),
    [anon_sym_noinline] = ACTIONS(1173),
    [anon_sym_threadlocal] = ACTIONS(1173),
    [anon_sym_usingnamespace] = ACTIONS(1173),
    [anon_sym_fn] = ACTIONS(1173),
    [anon_sym_const] = ACTIONS(1173),
    [anon_sym_var] = ACTIONS(1173),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1171),
    [anon_sym_async] = ACTIONS(1173),
    [anon_sym_DOT] = ACTIONS(1171),
    [anon_sym_error] = ACTIONS(1173),
    [anon_sym_false] = ACTIONS(1173),
    [anon_sym_null] = ACTIONS(1173),
    [anon_sym_anyframe] = ACTIONS(1173),
    [anon_sym_true] = ACTIONS(1173),
    [anon_sym_undefined] = ACTIONS(1173),
    [anon_sym_unreachable] = ACTIONS(1173),
    [sym_BuildinTypeExpr] = ACTIONS(1173),
    [anon_sym_packed] = ACTIONS(1173),
    [anon_sym_LPAREN] = ACTIONS(1171),
    [anon_sym_switch] = ACTIONS(1173),
    [anon_sym_LBRACK] = ACTIONS(1171),
    [anon_sym_if] = ACTIONS(1173),
    [anon_sym_while] = ACTIONS(1173),
    [anon_sym_for] = ACTIONS(1173),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1171),
    [anon_sym_struct] = ACTIONS(1173),
    [anon_sym_opaque] = ACTIONS(1173),
    [anon_sym_enum] = ACTIONS(1173),
    [anon_sym_union] = ACTIONS(1173),
    [sym_doc_comment] = ACTIONS(1171),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1171),
    [aux_sym_FLOAT_token1] = ACTIONS(1171),
    [aux_sym_FLOAT_token2] = ACTIONS(1171),
    [aux_sym_FLOAT_token3] = ACTIONS(1171),
    [aux_sym_FLOAT_token4] = ACTIONS(1171),
    [aux_sym_INTEGER_token1] = ACTIONS(1171),
    [aux_sym_INTEGER_token2] = ACTIONS(1171),
    [aux_sym_INTEGER_token3] = ACTIONS(1173),
    [aux_sym_INTEGER_token4] = ACTIONS(1173),
    [anon_sym_DQUOTE] = ACTIONS(1171),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1171),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1173),
    [anon_sym_AT] = ACTIONS(1171),
  },
  [467] = {
    [ts_builtin_sym_end] = ACTIONS(1175),
    [anon_sym_COMMA] = ACTIONS(1175),
    [anon_sym_pub] = ACTIONS(1177),
    [anon_sym_test] = ACTIONS(1177),
    [anon_sym_comptime] = ACTIONS(1177),
    [anon_sym_export] = ACTIONS(1177),
    [anon_sym_extern] = ACTIONS(1177),
    [anon_sym_inline] = ACTIONS(1177),
    [anon_sym_noinline] = ACTIONS(1177),
    [anon_sym_threadlocal] = ACTIONS(1177),
    [anon_sym_usingnamespace] = ACTIONS(1177),
    [anon_sym_fn] = ACTIONS(1177),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_const] = ACTIONS(1177),
    [anon_sym_var] = ACTIONS(1177),
    [anon_sym_else] = ACTIONS(1177),
    [anon_sym_or] = ACTIONS(1177),
    [anon_sym_and] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1175),
    [anon_sym_RBRACE] = ACTIONS(1175),
    [anon_sym_async] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(1177),
    [anon_sym_error] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_null] = ACTIONS(1177),
    [anon_sym_anyframe] = ACTIONS(1177),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_undefined] = ACTIONS(1177),
    [anon_sym_unreachable] = ACTIONS(1177),
    [sym_BuildinTypeExpr] = ACTIONS(1177),
    [anon_sym_packed] = ACTIONS(1177),
    [anon_sym_LPAREN] = ACTIONS(1175),
    [anon_sym_switch] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1175),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_while] = ACTIONS(1177),
    [anon_sym_for] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1177),
    [anon_sym_EQ_EQ] = ACTIONS(1175),
    [anon_sym_BANG_EQ] = ACTIONS(1175),
    [anon_sym_LT] = ACTIONS(1177),
    [anon_sym_GT] = ACTIONS(1177),
    [anon_sym_LT_EQ] = ACTIONS(1175),
    [anon_sym_GT_EQ] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_orelse] = ACTIONS(1177),
    [anon_sym_catch] = ACTIONS(1177),
    [anon_sym_LT_LT] = ACTIONS(1177),
    [anon_sym_GT_GT] = ACTIONS(1175),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1175),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1175),
    [anon_sym_DASH_PERCENT] = ACTIONS(1175),
    [anon_sym_PLUS_PIPE] = ACTIONS(1175),
    [anon_sym_DASH_PIPE] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1175),
    [anon_sym_SLASH] = ACTIONS(1177),
    [anon_sym_PERCENT] = ACTIONS(1175),
    [anon_sym_STAR_STAR] = ACTIONS(1175),
    [anon_sym_STAR_PERCENT] = ACTIONS(1175),
    [anon_sym_STAR_PIPE] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(1175),
    [anon_sym_DOT_STAR] = ACTIONS(1175),
    [anon_sym_DOT_QMARK] = ACTIONS(1175),
    [anon_sym_struct] = ACTIONS(1177),
    [anon_sym_opaque] = ACTIONS(1177),
    [anon_sym_enum] = ACTIONS(1177),
    [anon_sym_union] = ACTIONS(1177),
    [sym_doc_comment] = ACTIONS(1175),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [aux_sym_FLOAT_token1] = ACTIONS(1175),
    [aux_sym_FLOAT_token2] = ACTIONS(1175),
    [aux_sym_FLOAT_token3] = ACTIONS(1175),
    [aux_sym_FLOAT_token4] = ACTIONS(1175),
    [aux_sym_INTEGER_token1] = ACTIONS(1175),
    [aux_sym_INTEGER_token2] = ACTIONS(1175),
    [aux_sym_INTEGER_token3] = ACTIONS(1177),
    [aux_sym_INTEGER_token4] = ACTIONS(1177),
    [anon_sym_DQUOTE] = ACTIONS(1175),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1175),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1177),
    [anon_sym_AT] = ACTIONS(1175),
  },
  [468] = {
    [ts_builtin_sym_end] = ACTIONS(1181),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_pub] = ACTIONS(1183),
    [anon_sym_test] = ACTIONS(1183),
    [anon_sym_comptime] = ACTIONS(1183),
    [anon_sym_export] = ACTIONS(1183),
    [anon_sym_extern] = ACTIONS(1183),
    [anon_sym_inline] = ACTIONS(1183),
    [anon_sym_noinline] = ACTIONS(1183),
    [anon_sym_threadlocal] = ACTIONS(1183),
    [anon_sym_usingnamespace] = ACTIONS(1183),
    [anon_sym_fn] = ACTIONS(1183),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_const] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(1183),
    [anon_sym_else] = ACTIONS(1183),
    [anon_sym_or] = ACTIONS(1183),
    [anon_sym_and] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym_async] = ACTIONS(1183),
    [anon_sym_DOT] = ACTIONS(1183),
    [anon_sym_error] = ACTIONS(1183),
    [anon_sym_false] = ACTIONS(1183),
    [anon_sym_null] = ACTIONS(1183),
    [anon_sym_anyframe] = ACTIONS(1183),
    [anon_sym_true] = ACTIONS(1183),
    [anon_sym_undefined] = ACTIONS(1183),
    [anon_sym_unreachable] = ACTIONS(1183),
    [sym_BuildinTypeExpr] = ACTIONS(1183),
    [anon_sym_packed] = ACTIONS(1183),
    [anon_sym_LPAREN] = ACTIONS(1181),
    [anon_sym_switch] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_while] = ACTIONS(1183),
    [anon_sym_for] = ACTIONS(1183),
    [anon_sym_PIPE] = ACTIONS(1183),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1181),
    [anon_sym_BANG_EQ] = ACTIONS(1181),
    [anon_sym_LT] = ACTIONS(1183),
    [anon_sym_GT] = ACTIONS(1183),
    [anon_sym_LT_EQ] = ACTIONS(1181),
    [anon_sym_GT_EQ] = ACTIONS(1181),
    [anon_sym_AMP] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_orelse] = ACTIONS(1183),
    [anon_sym_catch] = ACTIONS(1183),
    [anon_sym_LT_LT] = ACTIONS(1183),
    [anon_sym_GT_GT] = ACTIONS(1181),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1183),
    [anon_sym_PLUS_PLUS] = ACTIONS(1181),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1181),
    [anon_sym_DASH_PERCENT] = ACTIONS(1181),
    [anon_sym_PLUS_PIPE] = ACTIONS(1181),
    [anon_sym_DASH_PIPE] = ACTIONS(1181),
    [anon_sym_PIPE_PIPE] = ACTIONS(1181),
    [anon_sym_SLASH] = ACTIONS(1183),
    [anon_sym_PERCENT] = ACTIONS(1181),
    [anon_sym_STAR_STAR] = ACTIONS(1181),
    [anon_sym_STAR_PERCENT] = ACTIONS(1181),
    [anon_sym_STAR_PIPE] = ACTIONS(1181),
    [anon_sym_QMARK] = ACTIONS(1181),
    [anon_sym_DOT_STAR] = ACTIONS(1181),
    [anon_sym_DOT_QMARK] = ACTIONS(1181),
    [anon_sym_struct] = ACTIONS(1183),
    [anon_sym_opaque] = ACTIONS(1183),
    [anon_sym_enum] = ACTIONS(1183),
    [anon_sym_union] = ACTIONS(1183),
    [sym_doc_comment] = ACTIONS(1181),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1181),
    [aux_sym_FLOAT_token1] = ACTIONS(1181),
    [aux_sym_FLOAT_token2] = ACTIONS(1181),
    [aux_sym_FLOAT_token3] = ACTIONS(1181),
    [aux_sym_FLOAT_token4] = ACTIONS(1181),
    [aux_sym_INTEGER_token1] = ACTIONS(1181),
    [aux_sym_INTEGER_token2] = ACTIONS(1181),
    [aux_sym_INTEGER_token3] = ACTIONS(1183),
    [aux_sym_INTEGER_token4] = ACTIONS(1183),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1181),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1183),
    [anon_sym_AT] = ACTIONS(1181),
  },
  [469] = {
    [ts_builtin_sym_end] = ACTIONS(1185),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_pub] = ACTIONS(1187),
    [anon_sym_test] = ACTIONS(1187),
    [anon_sym_comptime] = ACTIONS(1187),
    [anon_sym_export] = ACTIONS(1187),
    [anon_sym_extern] = ACTIONS(1187),
    [anon_sym_inline] = ACTIONS(1187),
    [anon_sym_noinline] = ACTIONS(1187),
    [anon_sym_threadlocal] = ACTIONS(1187),
    [anon_sym_usingnamespace] = ACTIONS(1187),
    [anon_sym_fn] = ACTIONS(1187),
    [anon_sym_BANG] = ACTIONS(1187),
    [anon_sym_const] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(1187),
    [anon_sym_else] = ACTIONS(1187),
    [anon_sym_or] = ACTIONS(1187),
    [anon_sym_and] = ACTIONS(1187),
    [anon_sym_LBRACE] = ACTIONS(1185),
    [anon_sym_RBRACE] = ACTIONS(1185),
    [anon_sym_async] = ACTIONS(1187),
    [anon_sym_DOT] = ACTIONS(1187),
    [anon_sym_error] = ACTIONS(1187),
    [anon_sym_false] = ACTIONS(1187),
    [anon_sym_null] = ACTIONS(1187),
    [anon_sym_anyframe] = ACTIONS(1187),
    [anon_sym_true] = ACTIONS(1187),
    [anon_sym_undefined] = ACTIONS(1187),
    [anon_sym_unreachable] = ACTIONS(1187),
    [sym_BuildinTypeExpr] = ACTIONS(1187),
    [anon_sym_packed] = ACTIONS(1187),
    [anon_sym_LPAREN] = ACTIONS(1185),
    [anon_sym_switch] = ACTIONS(1187),
    [anon_sym_LBRACK] = ACTIONS(1185),
    [anon_sym_if] = ACTIONS(1187),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_for] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_STAR] = ACTIONS(1187),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1185),
    [anon_sym_GT_EQ] = ACTIONS(1185),
    [anon_sym_AMP] = ACTIONS(1185),
    [anon_sym_CARET] = ACTIONS(1185),
    [anon_sym_orelse] = ACTIONS(1187),
    [anon_sym_catch] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1185),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1185),
    [anon_sym_PLUS] = ACTIONS(1187),
    [anon_sym_DASH] = ACTIONS(1187),
    [anon_sym_PLUS_PLUS] = ACTIONS(1185),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1185),
    [anon_sym_DASH_PERCENT] = ACTIONS(1185),
    [anon_sym_PLUS_PIPE] = ACTIONS(1185),
    [anon_sym_DASH_PIPE] = ACTIONS(1185),
    [anon_sym_PIPE_PIPE] = ACTIONS(1185),
    [anon_sym_SLASH] = ACTIONS(1187),
    [anon_sym_PERCENT] = ACTIONS(1185),
    [anon_sym_STAR_STAR] = ACTIONS(1185),
    [anon_sym_STAR_PERCENT] = ACTIONS(1185),
    [anon_sym_STAR_PIPE] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(1185),
    [anon_sym_DOT_STAR] = ACTIONS(1185),
    [anon_sym_DOT_QMARK] = ACTIONS(1185),
    [anon_sym_struct] = ACTIONS(1187),
    [anon_sym_opaque] = ACTIONS(1187),
    [anon_sym_enum] = ACTIONS(1187),
    [anon_sym_union] = ACTIONS(1187),
    [sym_doc_comment] = ACTIONS(1185),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1185),
    [aux_sym_FLOAT_token1] = ACTIONS(1185),
    [aux_sym_FLOAT_token2] = ACTIONS(1185),
    [aux_sym_FLOAT_token3] = ACTIONS(1185),
    [aux_sym_FLOAT_token4] = ACTIONS(1185),
    [aux_sym_INTEGER_token1] = ACTIONS(1185),
    [aux_sym_INTEGER_token2] = ACTIONS(1185),
    [aux_sym_INTEGER_token3] = ACTIONS(1187),
    [aux_sym_INTEGER_token4] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1185),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1185),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1187),
    [anon_sym_AT] = ACTIONS(1185),
  },
  [470] = {
    [ts_builtin_sym_end] = ACTIONS(1189),
    [anon_sym_COMMA] = ACTIONS(1189),
    [anon_sym_pub] = ACTIONS(1191),
    [anon_sym_test] = ACTIONS(1191),
    [anon_sym_comptime] = ACTIONS(1191),
    [anon_sym_export] = ACTIONS(1191),
    [anon_sym_extern] = ACTIONS(1191),
    [anon_sym_inline] = ACTIONS(1191),
    [anon_sym_noinline] = ACTIONS(1191),
    [anon_sym_threadlocal] = ACTIONS(1191),
    [anon_sym_usingnamespace] = ACTIONS(1191),
    [anon_sym_fn] = ACTIONS(1191),
    [anon_sym_BANG] = ACTIONS(1191),
    [anon_sym_const] = ACTIONS(1191),
    [anon_sym_var] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1191),
    [anon_sym_or] = ACTIONS(1191),
    [anon_sym_and] = ACTIONS(1191),
    [anon_sym_LBRACE] = ACTIONS(1189),
    [anon_sym_RBRACE] = ACTIONS(1189),
    [anon_sym_async] = ACTIONS(1191),
    [anon_sym_DOT] = ACTIONS(1191),
    [anon_sym_error] = ACTIONS(1191),
    [anon_sym_false] = ACTIONS(1191),
    [anon_sym_null] = ACTIONS(1191),
    [anon_sym_anyframe] = ACTIONS(1191),
    [anon_sym_true] = ACTIONS(1191),
    [anon_sym_undefined] = ACTIONS(1191),
    [anon_sym_unreachable] = ACTIONS(1191),
    [sym_BuildinTypeExpr] = ACTIONS(1191),
    [anon_sym_packed] = ACTIONS(1191),
    [anon_sym_LPAREN] = ACTIONS(1189),
    [anon_sym_switch] = ACTIONS(1191),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_if] = ACTIONS(1191),
    [anon_sym_while] = ACTIONS(1191),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_PIPE] = ACTIONS(1191),
    [anon_sym_STAR] = ACTIONS(1191),
    [anon_sym_EQ_EQ] = ACTIONS(1189),
    [anon_sym_BANG_EQ] = ACTIONS(1189),
    [anon_sym_LT] = ACTIONS(1191),
    [anon_sym_GT] = ACTIONS(1191),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_AMP] = ACTIONS(1189),
    [anon_sym_CARET] = ACTIONS(1189),
    [anon_sym_orelse] = ACTIONS(1191),
    [anon_sym_catch] = ACTIONS(1191),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_PLUS_PLUS] = ACTIONS(1189),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1189),
    [anon_sym_DASH_PERCENT] = ACTIONS(1189),
    [anon_sym_PLUS_PIPE] = ACTIONS(1189),
    [anon_sym_DASH_PIPE] = ACTIONS(1189),
    [anon_sym_PIPE_PIPE] = ACTIONS(1189),
    [anon_sym_SLASH] = ACTIONS(1191),
    [anon_sym_PERCENT] = ACTIONS(1189),
    [anon_sym_STAR_STAR] = ACTIONS(1189),
    [anon_sym_STAR_PERCENT] = ACTIONS(1189),
    [anon_sym_STAR_PIPE] = ACTIONS(1189),
    [anon_sym_QMARK] = ACTIONS(1189),
    [anon_sym_DOT_STAR] = ACTIONS(1189),
    [anon_sym_DOT_QMARK] = ACTIONS(1189),
    [anon_sym_struct] = ACTIONS(1191),
    [anon_sym_opaque] = ACTIONS(1191),
    [anon_sym_enum] = ACTIONS(1191),
    [anon_sym_union] = ACTIONS(1191),
    [sym_doc_comment] = ACTIONS(1189),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1189),
    [aux_sym_FLOAT_token1] = ACTIONS(1189),
    [aux_sym_FLOAT_token2] = ACTIONS(1189),
    [aux_sym_FLOAT_token3] = ACTIONS(1189),
    [aux_sym_FLOAT_token4] = ACTIONS(1189),
    [aux_sym_INTEGER_token1] = ACTIONS(1189),
    [aux_sym_INTEGER_token2] = ACTIONS(1189),
    [aux_sym_INTEGER_token3] = ACTIONS(1191),
    [aux_sym_INTEGER_token4] = ACTIONS(1191),
    [anon_sym_DQUOTE] = ACTIONS(1189),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1189),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1191),
    [anon_sym_AT] = ACTIONS(1189),
  },
  [471] = {
    [ts_builtin_sym_end] = ACTIONS(1193),
    [anon_sym_COMMA] = ACTIONS(1193),
    [anon_sym_pub] = ACTIONS(1195),
    [anon_sym_test] = ACTIONS(1195),
    [anon_sym_comptime] = ACTIONS(1195),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_extern] = ACTIONS(1195),
    [anon_sym_inline] = ACTIONS(1195),
    [anon_sym_noinline] = ACTIONS(1195),
    [anon_sym_threadlocal] = ACTIONS(1195),
    [anon_sym_usingnamespace] = ACTIONS(1195),
    [anon_sym_fn] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1195),
    [anon_sym_var] = ACTIONS(1195),
    [anon_sym_else] = ACTIONS(1195),
    [anon_sym_or] = ACTIONS(1195),
    [anon_sym_and] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1193),
    [anon_sym_RBRACE] = ACTIONS(1193),
    [anon_sym_async] = ACTIONS(1195),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_error] = ACTIONS(1195),
    [anon_sym_false] = ACTIONS(1195),
    [anon_sym_null] = ACTIONS(1195),
    [anon_sym_anyframe] = ACTIONS(1195),
    [anon_sym_true] = ACTIONS(1195),
    [anon_sym_undefined] = ACTIONS(1195),
    [anon_sym_unreachable] = ACTIONS(1195),
    [sym_BuildinTypeExpr] = ACTIONS(1195),
    [anon_sym_packed] = ACTIONS(1195),
    [anon_sym_LPAREN] = ACTIONS(1193),
    [anon_sym_switch] = ACTIONS(1195),
    [anon_sym_LBRACK] = ACTIONS(1193),
    [anon_sym_if] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1195),
    [anon_sym_for] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1195),
    [anon_sym_STAR] = ACTIONS(1195),
    [anon_sym_EQ_EQ] = ACTIONS(1193),
    [anon_sym_BANG_EQ] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_GT] = ACTIONS(1195),
    [anon_sym_LT_EQ] = ACTIONS(1193),
    [anon_sym_GT_EQ] = ACTIONS(1193),
    [anon_sym_AMP] = ACTIONS(1193),
    [anon_sym_CARET] = ACTIONS(1193),
    [anon_sym_orelse] = ACTIONS(1195),
    [anon_sym_catch] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1193),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1193),
    [anon_sym_PLUS] = ACTIONS(1195),
    [anon_sym_DASH] = ACTIONS(1195),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1193),
    [anon_sym_DASH_PERCENT] = ACTIONS(1193),
    [anon_sym_PLUS_PIPE] = ACTIONS(1193),
    [anon_sym_DASH_PIPE] = ACTIONS(1193),
    [anon_sym_PIPE_PIPE] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1195),
    [anon_sym_PERCENT] = ACTIONS(1193),
    [anon_sym_STAR_STAR] = ACTIONS(1193),
    [anon_sym_STAR_PERCENT] = ACTIONS(1193),
    [anon_sym_STAR_PIPE] = ACTIONS(1193),
    [anon_sym_QMARK] = ACTIONS(1193),
    [anon_sym_DOT_STAR] = ACTIONS(1193),
    [anon_sym_DOT_QMARK] = ACTIONS(1193),
    [anon_sym_struct] = ACTIONS(1195),
    [anon_sym_opaque] = ACTIONS(1195),
    [anon_sym_enum] = ACTIONS(1195),
    [anon_sym_union] = ACTIONS(1195),
    [sym_doc_comment] = ACTIONS(1193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1193),
    [aux_sym_FLOAT_token1] = ACTIONS(1193),
    [aux_sym_FLOAT_token2] = ACTIONS(1193),
    [aux_sym_FLOAT_token3] = ACTIONS(1193),
    [aux_sym_FLOAT_token4] = ACTIONS(1193),
    [aux_sym_INTEGER_token1] = ACTIONS(1193),
    [aux_sym_INTEGER_token2] = ACTIONS(1193),
    [aux_sym_INTEGER_token3] = ACTIONS(1195),
    [aux_sym_INTEGER_token4] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(1193),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1193),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1195),
    [anon_sym_AT] = ACTIONS(1193),
  },
  [472] = {
    [ts_builtin_sym_end] = ACTIONS(1197),
    [anon_sym_COMMA] = ACTIONS(1197),
    [anon_sym_pub] = ACTIONS(1199),
    [anon_sym_test] = ACTIONS(1199),
    [anon_sym_comptime] = ACTIONS(1199),
    [anon_sym_export] = ACTIONS(1199),
    [anon_sym_extern] = ACTIONS(1199),
    [anon_sym_inline] = ACTIONS(1199),
    [anon_sym_noinline] = ACTIONS(1199),
    [anon_sym_threadlocal] = ACTIONS(1199),
    [anon_sym_usingnamespace] = ACTIONS(1199),
    [anon_sym_fn] = ACTIONS(1199),
    [anon_sym_BANG] = ACTIONS(1199),
    [anon_sym_const] = ACTIONS(1199),
    [anon_sym_var] = ACTIONS(1199),
    [anon_sym_else] = ACTIONS(1199),
    [anon_sym_or] = ACTIONS(1199),
    [anon_sym_and] = ACTIONS(1199),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_RBRACE] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1199),
    [anon_sym_DOT] = ACTIONS(1199),
    [anon_sym_error] = ACTIONS(1199),
    [anon_sym_false] = ACTIONS(1199),
    [anon_sym_null] = ACTIONS(1199),
    [anon_sym_anyframe] = ACTIONS(1199),
    [anon_sym_true] = ACTIONS(1199),
    [anon_sym_undefined] = ACTIONS(1199),
    [anon_sym_unreachable] = ACTIONS(1199),
    [sym_BuildinTypeExpr] = ACTIONS(1199),
    [anon_sym_packed] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1197),
    [anon_sym_switch] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(1197),
    [anon_sym_if] = ACTIONS(1199),
    [anon_sym_while] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1199),
    [anon_sym_PIPE] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1197),
    [anon_sym_BANG_EQ] = ACTIONS(1197),
    [anon_sym_LT] = ACTIONS(1199),
    [anon_sym_GT] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1197),
    [anon_sym_GT_EQ] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_orelse] = ACTIONS(1199),
    [anon_sym_catch] = ACTIONS(1199),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1197),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1197),
    [anon_sym_DASH_PERCENT] = ACTIONS(1197),
    [anon_sym_PLUS_PIPE] = ACTIONS(1197),
    [anon_sym_DASH_PIPE] = ACTIONS(1197),
    [anon_sym_PIPE_PIPE] = ACTIONS(1197),
    [anon_sym_SLASH] = ACTIONS(1199),
    [anon_sym_PERCENT] = ACTIONS(1197),
    [anon_sym_STAR_STAR] = ACTIONS(1197),
    [anon_sym_STAR_PERCENT] = ACTIONS(1197),
    [anon_sym_STAR_PIPE] = ACTIONS(1197),
    [anon_sym_QMARK] = ACTIONS(1197),
    [anon_sym_DOT_STAR] = ACTIONS(1197),
    [anon_sym_DOT_QMARK] = ACTIONS(1197),
    [anon_sym_struct] = ACTIONS(1199),
    [anon_sym_opaque] = ACTIONS(1199),
    [anon_sym_enum] = ACTIONS(1199),
    [anon_sym_union] = ACTIONS(1199),
    [sym_doc_comment] = ACTIONS(1197),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1197),
    [aux_sym_FLOAT_token1] = ACTIONS(1197),
    [aux_sym_FLOAT_token2] = ACTIONS(1197),
    [aux_sym_FLOAT_token3] = ACTIONS(1197),
    [aux_sym_FLOAT_token4] = ACTIONS(1197),
    [aux_sym_INTEGER_token1] = ACTIONS(1197),
    [aux_sym_INTEGER_token2] = ACTIONS(1197),
    [aux_sym_INTEGER_token3] = ACTIONS(1199),
    [aux_sym_INTEGER_token4] = ACTIONS(1199),
    [anon_sym_DQUOTE] = ACTIONS(1197),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1197),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1199),
    [anon_sym_AT] = ACTIONS(1197),
  },
  [473] = {
    [ts_builtin_sym_end] = ACTIONS(1107),
    [anon_sym_COMMA] = ACTIONS(1107),
    [anon_sym_pub] = ACTIONS(1105),
    [anon_sym_test] = ACTIONS(1105),
    [anon_sym_comptime] = ACTIONS(1105),
    [anon_sym_export] = ACTIONS(1105),
    [anon_sym_extern] = ACTIONS(1105),
    [anon_sym_inline] = ACTIONS(1105),
    [anon_sym_noinline] = ACTIONS(1105),
    [anon_sym_threadlocal] = ACTIONS(1105),
    [anon_sym_usingnamespace] = ACTIONS(1105),
    [anon_sym_fn] = ACTIONS(1105),
    [anon_sym_BANG] = ACTIONS(1105),
    [anon_sym_const] = ACTIONS(1105),
    [anon_sym_var] = ACTIONS(1105),
    [anon_sym_else] = ACTIONS(1105),
    [anon_sym_or] = ACTIONS(1105),
    [anon_sym_and] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(1107),
    [anon_sym_RBRACE] = ACTIONS(1107),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_error] = ACTIONS(1105),
    [anon_sym_false] = ACTIONS(1105),
    [anon_sym_null] = ACTIONS(1105),
    [anon_sym_anyframe] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1105),
    [anon_sym_undefined] = ACTIONS(1105),
    [anon_sym_unreachable] = ACTIONS(1105),
    [sym_BuildinTypeExpr] = ACTIONS(1105),
    [anon_sym_packed] = ACTIONS(1105),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_switch] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_if] = ACTIONS(1105),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_for] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1105),
    [anon_sym_STAR] = ACTIONS(1105),
    [anon_sym_EQ_EQ] = ACTIONS(1107),
    [anon_sym_BANG_EQ] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(1105),
    [anon_sym_LT_EQ] = ACTIONS(1107),
    [anon_sym_GT_EQ] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1107),
    [anon_sym_CARET] = ACTIONS(1107),
    [anon_sym_orelse] = ACTIONS(1105),
    [anon_sym_catch] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1105),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1107),
    [anon_sym_DASH_PERCENT] = ACTIONS(1107),
    [anon_sym_PLUS_PIPE] = ACTIONS(1107),
    [anon_sym_DASH_PIPE] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1107),
    [anon_sym_STAR_STAR] = ACTIONS(1107),
    [anon_sym_STAR_PERCENT] = ACTIONS(1107),
    [anon_sym_STAR_PIPE] = ACTIONS(1107),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_DOT_STAR] = ACTIONS(1107),
    [anon_sym_DOT_QMARK] = ACTIONS(1107),
    [anon_sym_struct] = ACTIONS(1105),
    [anon_sym_opaque] = ACTIONS(1105),
    [anon_sym_enum] = ACTIONS(1105),
    [anon_sym_union] = ACTIONS(1105),
    [sym_doc_comment] = ACTIONS(1107),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1107),
    [aux_sym_FLOAT_token1] = ACTIONS(1107),
    [aux_sym_FLOAT_token2] = ACTIONS(1107),
    [aux_sym_FLOAT_token3] = ACTIONS(1107),
    [aux_sym_FLOAT_token4] = ACTIONS(1107),
    [aux_sym_INTEGER_token1] = ACTIONS(1107),
    [aux_sym_INTEGER_token2] = ACTIONS(1107),
    [aux_sym_INTEGER_token3] = ACTIONS(1105),
    [aux_sym_INTEGER_token4] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1107),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1105),
    [anon_sym_AT] = ACTIONS(1107),
  },
  [474] = {
    [ts_builtin_sym_end] = ACTIONS(1201),
    [anon_sym_COMMA] = ACTIONS(1201),
    [anon_sym_pub] = ACTIONS(1203),
    [anon_sym_test] = ACTIONS(1203),
    [anon_sym_comptime] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(1203),
    [anon_sym_extern] = ACTIONS(1203),
    [anon_sym_inline] = ACTIONS(1203),
    [anon_sym_noinline] = ACTIONS(1203),
    [anon_sym_threadlocal] = ACTIONS(1203),
    [anon_sym_usingnamespace] = ACTIONS(1203),
    [anon_sym_fn] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1203),
    [anon_sym_const] = ACTIONS(1203),
    [anon_sym_var] = ACTIONS(1203),
    [anon_sym_else] = ACTIONS(1203),
    [anon_sym_or] = ACTIONS(1203),
    [anon_sym_and] = ACTIONS(1203),
    [anon_sym_LBRACE] = ACTIONS(1201),
    [anon_sym_RBRACE] = ACTIONS(1201),
    [anon_sym_async] = ACTIONS(1203),
    [anon_sym_DOT] = ACTIONS(1203),
    [anon_sym_error] = ACTIONS(1203),
    [anon_sym_false] = ACTIONS(1203),
    [anon_sym_null] = ACTIONS(1203),
    [anon_sym_anyframe] = ACTIONS(1203),
    [anon_sym_true] = ACTIONS(1203),
    [anon_sym_undefined] = ACTIONS(1203),
    [anon_sym_unreachable] = ACTIONS(1203),
    [sym_BuildinTypeExpr] = ACTIONS(1203),
    [anon_sym_packed] = ACTIONS(1203),
    [anon_sym_LPAREN] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1203),
    [anon_sym_LBRACK] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1203),
    [anon_sym_while] = ACTIONS(1203),
    [anon_sym_for] = ACTIONS(1203),
    [anon_sym_PIPE] = ACTIONS(1203),
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_EQ_EQ] = ACTIONS(1201),
    [anon_sym_BANG_EQ] = ACTIONS(1201),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(1203),
    [anon_sym_LT_EQ] = ACTIONS(1201),
    [anon_sym_GT_EQ] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1201),
    [anon_sym_CARET] = ACTIONS(1201),
    [anon_sym_orelse] = ACTIONS(1203),
    [anon_sym_catch] = ACTIONS(1203),
    [anon_sym_LT_LT] = ACTIONS(1203),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1203),
    [anon_sym_DASH] = ACTIONS(1203),
    [anon_sym_PLUS_PLUS] = ACTIONS(1201),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1201),
    [anon_sym_DASH_PERCENT] = ACTIONS(1201),
    [anon_sym_PLUS_PIPE] = ACTIONS(1201),
    [anon_sym_DASH_PIPE] = ACTIONS(1201),
    [anon_sym_PIPE_PIPE] = ACTIONS(1201),
    [anon_sym_SLASH] = ACTIONS(1203),
    [anon_sym_PERCENT] = ACTIONS(1201),
    [anon_sym_STAR_STAR] = ACTIONS(1201),
    [anon_sym_STAR_PERCENT] = ACTIONS(1201),
    [anon_sym_STAR_PIPE] = ACTIONS(1201),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_DOT_STAR] = ACTIONS(1201),
    [anon_sym_DOT_QMARK] = ACTIONS(1201),
    [anon_sym_struct] = ACTIONS(1203),
    [anon_sym_opaque] = ACTIONS(1203),
    [anon_sym_enum] = ACTIONS(1203),
    [anon_sym_union] = ACTIONS(1203),
    [sym_doc_comment] = ACTIONS(1201),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1201),
    [aux_sym_FLOAT_token1] = ACTIONS(1201),
    [aux_sym_FLOAT_token2] = ACTIONS(1201),
    [aux_sym_FLOAT_token3] = ACTIONS(1201),
    [aux_sym_FLOAT_token4] = ACTIONS(1201),
    [aux_sym_INTEGER_token1] = ACTIONS(1201),
    [aux_sym_INTEGER_token2] = ACTIONS(1201),
    [aux_sym_INTEGER_token3] = ACTIONS(1203),
    [aux_sym_INTEGER_token4] = ACTIONS(1203),
    [anon_sym_DQUOTE] = ACTIONS(1201),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1201),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1203),
    [anon_sym_AT] = ACTIONS(1201),
  },
  [475] = {
    [ts_builtin_sym_end] = ACTIONS(1205),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_pub] = ACTIONS(1207),
    [anon_sym_test] = ACTIONS(1207),
    [anon_sym_comptime] = ACTIONS(1207),
    [anon_sym_export] = ACTIONS(1207),
    [anon_sym_extern] = ACTIONS(1207),
    [anon_sym_inline] = ACTIONS(1207),
    [anon_sym_noinline] = ACTIONS(1207),
    [anon_sym_threadlocal] = ACTIONS(1207),
    [anon_sym_usingnamespace] = ACTIONS(1207),
    [anon_sym_fn] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_const] = ACTIONS(1207),
    [anon_sym_var] = ACTIONS(1207),
    [anon_sym_else] = ACTIONS(1207),
    [anon_sym_or] = ACTIONS(1207),
    [anon_sym_and] = ACTIONS(1207),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_error] = ACTIONS(1207),
    [anon_sym_false] = ACTIONS(1207),
    [anon_sym_null] = ACTIONS(1207),
    [anon_sym_anyframe] = ACTIONS(1207),
    [anon_sym_true] = ACTIONS(1207),
    [anon_sym_undefined] = ACTIONS(1207),
    [anon_sym_unreachable] = ACTIONS(1207),
    [sym_BuildinTypeExpr] = ACTIONS(1207),
    [anon_sym_packed] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1205),
    [anon_sym_switch] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1207),
    [anon_sym_while] = ACTIONS(1207),
    [anon_sym_for] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ_EQ] = ACTIONS(1205),
    [anon_sym_BANG_EQ] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1205),
    [anon_sym_GT_EQ] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(1205),
    [anon_sym_CARET] = ACTIONS(1205),
    [anon_sym_orelse] = ACTIONS(1207),
    [anon_sym_catch] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_GT_GT] = ACTIONS(1205),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1205),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1205),
    [anon_sym_DASH_PERCENT] = ACTIONS(1205),
    [anon_sym_PLUS_PIPE] = ACTIONS(1205),
    [anon_sym_DASH_PIPE] = ACTIONS(1205),
    [anon_sym_PIPE_PIPE] = ACTIONS(1205),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1205),
    [anon_sym_STAR_STAR] = ACTIONS(1205),
    [anon_sym_STAR_PERCENT] = ACTIONS(1205),
    [anon_sym_STAR_PIPE] = ACTIONS(1205),
    [anon_sym_QMARK] = ACTIONS(1205),
    [anon_sym_DOT_STAR] = ACTIONS(1205),
    [anon_sym_DOT_QMARK] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1207),
    [anon_sym_opaque] = ACTIONS(1207),
    [anon_sym_enum] = ACTIONS(1207),
    [anon_sym_union] = ACTIONS(1207),
    [sym_doc_comment] = ACTIONS(1205),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1205),
    [aux_sym_FLOAT_token1] = ACTIONS(1205),
    [aux_sym_FLOAT_token2] = ACTIONS(1205),
    [aux_sym_FLOAT_token3] = ACTIONS(1205),
    [aux_sym_FLOAT_token4] = ACTIONS(1205),
    [aux_sym_INTEGER_token1] = ACTIONS(1205),
    [aux_sym_INTEGER_token2] = ACTIONS(1205),
    [aux_sym_INTEGER_token3] = ACTIONS(1207),
    [aux_sym_INTEGER_token4] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(1205),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1205),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1205),
  },
  [476] = {
    [ts_builtin_sym_end] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_pub] = ACTIONS(1211),
    [anon_sym_test] = ACTIONS(1211),
    [anon_sym_comptime] = ACTIONS(1211),
    [anon_sym_export] = ACTIONS(1211),
    [anon_sym_extern] = ACTIONS(1211),
    [anon_sym_inline] = ACTIONS(1211),
    [anon_sym_noinline] = ACTIONS(1211),
    [anon_sym_threadlocal] = ACTIONS(1211),
    [anon_sym_usingnamespace] = ACTIONS(1211),
    [anon_sym_fn] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1211),
    [anon_sym_const] = ACTIONS(1211),
    [anon_sym_var] = ACTIONS(1211),
    [anon_sym_else] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1211),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_DOT] = ACTIONS(1211),
    [anon_sym_error] = ACTIONS(1211),
    [anon_sym_false] = ACTIONS(1211),
    [anon_sym_null] = ACTIONS(1211),
    [anon_sym_anyframe] = ACTIONS(1211),
    [anon_sym_true] = ACTIONS(1211),
    [anon_sym_undefined] = ACTIONS(1211),
    [anon_sym_unreachable] = ACTIONS(1211),
    [sym_BuildinTypeExpr] = ACTIONS(1211),
    [anon_sym_packed] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_switch] = ACTIONS(1211),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_if] = ACTIONS(1211),
    [anon_sym_while] = ACTIONS(1211),
    [anon_sym_for] = ACTIONS(1211),
    [anon_sym_PIPE] = ACTIONS(1211),
    [anon_sym_STAR] = ACTIONS(1211),
    [anon_sym_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_GT] = ACTIONS(1211),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1209),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_orelse] = ACTIONS(1211),
    [anon_sym_catch] = ACTIONS(1211),
    [anon_sym_LT_LT] = ACTIONS(1211),
    [anon_sym_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1209),
    [anon_sym_PLUS] = ACTIONS(1211),
    [anon_sym_DASH] = ACTIONS(1211),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1209),
    [anon_sym_DASH_PERCENT] = ACTIONS(1209),
    [anon_sym_PLUS_PIPE] = ACTIONS(1209),
    [anon_sym_DASH_PIPE] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_SLASH] = ACTIONS(1211),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_STAR_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_PIPE] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_DOT_STAR] = ACTIONS(1209),
    [anon_sym_DOT_QMARK] = ACTIONS(1209),
    [anon_sym_struct] = ACTIONS(1211),
    [anon_sym_opaque] = ACTIONS(1211),
    [anon_sym_enum] = ACTIONS(1211),
    [anon_sym_union] = ACTIONS(1211),
    [sym_doc_comment] = ACTIONS(1209),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1209),
    [aux_sym_FLOAT_token1] = ACTIONS(1209),
    [aux_sym_FLOAT_token2] = ACTIONS(1209),
    [aux_sym_FLOAT_token3] = ACTIONS(1209),
    [aux_sym_FLOAT_token4] = ACTIONS(1209),
    [aux_sym_INTEGER_token1] = ACTIONS(1209),
    [aux_sym_INTEGER_token2] = ACTIONS(1209),
    [aux_sym_INTEGER_token3] = ACTIONS(1211),
    [aux_sym_INTEGER_token4] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(1209),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1209),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1211),
    [anon_sym_AT] = ACTIONS(1209),
  },
  [477] = {
    [ts_builtin_sym_end] = ACTIONS(522),
    [anon_sym_COMMA] = ACTIONS(522),
    [anon_sym_pub] = ACTIONS(524),
    [anon_sym_test] = ACTIONS(524),
    [anon_sym_comptime] = ACTIONS(524),
    [anon_sym_export] = ACTIONS(524),
    [anon_sym_extern] = ACTIONS(524),
    [anon_sym_inline] = ACTIONS(524),
    [anon_sym_noinline] = ACTIONS(524),
    [anon_sym_threadlocal] = ACTIONS(524),
    [anon_sym_usingnamespace] = ACTIONS(524),
    [anon_sym_fn] = ACTIONS(524),
    [anon_sym_BANG] = ACTIONS(524),
    [anon_sym_const] = ACTIONS(524),
    [anon_sym_var] = ACTIONS(524),
    [anon_sym_else] = ACTIONS(524),
    [anon_sym_or] = ACTIONS(524),
    [anon_sym_and] = ACTIONS(524),
    [anon_sym_LBRACE] = ACTIONS(522),
    [anon_sym_RBRACE] = ACTIONS(522),
    [anon_sym_async] = ACTIONS(524),
    [anon_sym_DOT] = ACTIONS(524),
    [anon_sym_error] = ACTIONS(524),
    [anon_sym_false] = ACTIONS(524),
    [anon_sym_null] = ACTIONS(524),
    [anon_sym_anyframe] = ACTIONS(524),
    [anon_sym_true] = ACTIONS(524),
    [anon_sym_undefined] = ACTIONS(524),
    [anon_sym_unreachable] = ACTIONS(524),
    [sym_BuildinTypeExpr] = ACTIONS(524),
    [anon_sym_packed] = ACTIONS(524),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_LBRACK] = ACTIONS(522),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_while] = ACTIONS(524),
    [anon_sym_for] = ACTIONS(524),
    [anon_sym_PIPE] = ACTIONS(524),
    [anon_sym_STAR] = ACTIONS(524),
    [anon_sym_EQ_EQ] = ACTIONS(522),
    [anon_sym_BANG_EQ] = ACTIONS(522),
    [anon_sym_LT] = ACTIONS(524),
    [anon_sym_GT] = ACTIONS(524),
    [anon_sym_LT_EQ] = ACTIONS(522),
    [anon_sym_GT_EQ] = ACTIONS(522),
    [anon_sym_AMP] = ACTIONS(522),
    [anon_sym_CARET] = ACTIONS(522),
    [anon_sym_orelse] = ACTIONS(524),
    [anon_sym_catch] = ACTIONS(524),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_GT_GT] = ACTIONS(522),
    [anon_sym_LT_LT_PIPE] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_PLUS_PLUS] = ACTIONS(522),
    [anon_sym_PLUS_PERCENT] = ACTIONS(522),
    [anon_sym_DASH_PERCENT] = ACTIONS(522),
    [anon_sym_PLUS_PIPE] = ACTIONS(522),
    [anon_sym_DASH_PIPE] = ACTIONS(522),
    [anon_sym_PIPE_PIPE] = ACTIONS(522),
    [anon_sym_SLASH] = ACTIONS(524),
    [anon_sym_PERCENT] = ACTIONS(522),
    [anon_sym_STAR_STAR] = ACTIONS(522),
    [anon_sym_STAR_PERCENT] = ACTIONS(522),
    [anon_sym_STAR_PIPE] = ACTIONS(522),
    [anon_sym_QMARK] = ACTIONS(522),
    [anon_sym_DOT_STAR] = ACTIONS(522),
    [anon_sym_DOT_QMARK] = ACTIONS(522),
    [anon_sym_struct] = ACTIONS(524),
    [anon_sym_opaque] = ACTIONS(524),
    [anon_sym_enum] = ACTIONS(524),
    [anon_sym_union] = ACTIONS(524),
    [sym_doc_comment] = ACTIONS(522),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(522),
    [aux_sym_FLOAT_token1] = ACTIONS(522),
    [aux_sym_FLOAT_token2] = ACTIONS(522),
    [aux_sym_FLOAT_token3] = ACTIONS(522),
    [aux_sym_FLOAT_token4] = ACTIONS(522),
    [aux_sym_INTEGER_token1] = ACTIONS(522),
    [aux_sym_INTEGER_token2] = ACTIONS(522),
    [aux_sym_INTEGER_token3] = ACTIONS(524),
    [aux_sym_INTEGER_token4] = ACTIONS(524),
    [anon_sym_DQUOTE] = ACTIONS(522),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(522),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(524),
    [anon_sym_AT] = ACTIONS(522),
  },
  [478] = {
    [ts_builtin_sym_end] = ACTIONS(1213),
    [anon_sym_COMMA] = ACTIONS(1213),
    [anon_sym_pub] = ACTIONS(1215),
    [anon_sym_test] = ACTIONS(1215),
    [anon_sym_comptime] = ACTIONS(1215),
    [anon_sym_export] = ACTIONS(1215),
    [anon_sym_extern] = ACTIONS(1215),
    [anon_sym_inline] = ACTIONS(1215),
    [anon_sym_noinline] = ACTIONS(1215),
    [anon_sym_threadlocal] = ACTIONS(1215),
    [anon_sym_usingnamespace] = ACTIONS(1215),
    [anon_sym_fn] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_const] = ACTIONS(1215),
    [anon_sym_var] = ACTIONS(1215),
    [anon_sym_else] = ACTIONS(1215),
    [anon_sym_or] = ACTIONS(1215),
    [anon_sym_and] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1213),
    [anon_sym_RBRACE] = ACTIONS(1213),
    [anon_sym_async] = ACTIONS(1215),
    [anon_sym_DOT] = ACTIONS(1215),
    [anon_sym_error] = ACTIONS(1215),
    [anon_sym_false] = ACTIONS(1215),
    [anon_sym_null] = ACTIONS(1215),
    [anon_sym_anyframe] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1215),
    [anon_sym_undefined] = ACTIONS(1215),
    [anon_sym_unreachable] = ACTIONS(1215),
    [sym_BuildinTypeExpr] = ACTIONS(1215),
    [anon_sym_packed] = ACTIONS(1215),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_switch] = ACTIONS(1215),
    [anon_sym_LBRACK] = ACTIONS(1213),
    [anon_sym_if] = ACTIONS(1215),
    [anon_sym_while] = ACTIONS(1215),
    [anon_sym_for] = ACTIONS(1215),
    [anon_sym_PIPE] = ACTIONS(1215),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_EQ_EQ] = ACTIONS(1213),
    [anon_sym_BANG_EQ] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(1215),
    [anon_sym_GT] = ACTIONS(1215),
    [anon_sym_LT_EQ] = ACTIONS(1213),
    [anon_sym_GT_EQ] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(1213),
    [anon_sym_CARET] = ACTIONS(1213),
    [anon_sym_orelse] = ACTIONS(1215),
    [anon_sym_catch] = ACTIONS(1215),
    [anon_sym_LT_LT] = ACTIONS(1215),
    [anon_sym_GT_GT] = ACTIONS(1213),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1213),
    [anon_sym_PLUS] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1213),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1213),
    [anon_sym_DASH_PERCENT] = ACTIONS(1213),
    [anon_sym_PLUS_PIPE] = ACTIONS(1213),
    [anon_sym_DASH_PIPE] = ACTIONS(1213),
    [anon_sym_PIPE_PIPE] = ACTIONS(1213),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_PERCENT] = ACTIONS(1213),
    [anon_sym_STAR_STAR] = ACTIONS(1213),
    [anon_sym_STAR_PERCENT] = ACTIONS(1213),
    [anon_sym_STAR_PIPE] = ACTIONS(1213),
    [anon_sym_QMARK] = ACTIONS(1213),
    [anon_sym_DOT_STAR] = ACTIONS(1213),
    [anon_sym_DOT_QMARK] = ACTIONS(1213),
    [anon_sym_struct] = ACTIONS(1215),
    [anon_sym_opaque] = ACTIONS(1215),
    [anon_sym_enum] = ACTIONS(1215),
    [anon_sym_union] = ACTIONS(1215),
    [sym_doc_comment] = ACTIONS(1213),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [aux_sym_FLOAT_token1] = ACTIONS(1213),
    [aux_sym_FLOAT_token2] = ACTIONS(1213),
    [aux_sym_FLOAT_token3] = ACTIONS(1213),
    [aux_sym_FLOAT_token4] = ACTIONS(1213),
    [aux_sym_INTEGER_token1] = ACTIONS(1213),
    [aux_sym_INTEGER_token2] = ACTIONS(1213),
    [aux_sym_INTEGER_token3] = ACTIONS(1215),
    [aux_sym_INTEGER_token4] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1213),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1213),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1215),
    [anon_sym_AT] = ACTIONS(1213),
  },
  [479] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1217),
    [anon_sym_COMMA] = ACTIONS(1217),
    [anon_sym_pub] = ACTIONS(1219),
    [anon_sym_test] = ACTIONS(1219),
    [anon_sym_comptime] = ACTIONS(1219),
    [anon_sym_export] = ACTIONS(1219),
    [anon_sym_extern] = ACTIONS(1219),
    [anon_sym_inline] = ACTIONS(1219),
    [anon_sym_noinline] = ACTIONS(1219),
    [anon_sym_threadlocal] = ACTIONS(1219),
    [anon_sym_usingnamespace] = ACTIONS(1219),
    [anon_sym_fn] = ACTIONS(1219),
    [anon_sym_const] = ACTIONS(1219),
    [anon_sym_var] = ACTIONS(1219),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1217),
    [anon_sym_async] = ACTIONS(1219),
    [anon_sym_DOT] = ACTIONS(1217),
    [anon_sym_error] = ACTIONS(1219),
    [anon_sym_false] = ACTIONS(1219),
    [anon_sym_null] = ACTIONS(1219),
    [anon_sym_anyframe] = ACTIONS(1219),
    [anon_sym_true] = ACTIONS(1219),
    [anon_sym_undefined] = ACTIONS(1219),
    [anon_sym_unreachable] = ACTIONS(1219),
    [sym_BuildinTypeExpr] = ACTIONS(1219),
    [anon_sym_packed] = ACTIONS(1219),
    [anon_sym_LPAREN] = ACTIONS(1217),
    [anon_sym_switch] = ACTIONS(1219),
    [anon_sym_LBRACK] = ACTIONS(1217),
    [anon_sym_if] = ACTIONS(1219),
    [anon_sym_while] = ACTIONS(1219),
    [anon_sym_for] = ACTIONS(1219),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1217),
    [anon_sym_struct] = ACTIONS(1219),
    [anon_sym_opaque] = ACTIONS(1219),
    [anon_sym_enum] = ACTIONS(1219),
    [anon_sym_union] = ACTIONS(1219),
    [sym_doc_comment] = ACTIONS(1217),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1217),
    [aux_sym_FLOAT_token1] = ACTIONS(1217),
    [aux_sym_FLOAT_token2] = ACTIONS(1217),
    [aux_sym_FLOAT_token3] = ACTIONS(1217),
    [aux_sym_FLOAT_token4] = ACTIONS(1217),
    [aux_sym_INTEGER_token1] = ACTIONS(1217),
    [aux_sym_INTEGER_token2] = ACTIONS(1217),
    [aux_sym_INTEGER_token3] = ACTIONS(1219),
    [aux_sym_INTEGER_token4] = ACTIONS(1219),
    [anon_sym_DQUOTE] = ACTIONS(1217),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1219),
    [anon_sym_AT] = ACTIONS(1217),
  },
  [480] = {
    [ts_builtin_sym_end] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(1221),
    [anon_sym_pub] = ACTIONS(1223),
    [anon_sym_test] = ACTIONS(1223),
    [anon_sym_comptime] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1223),
    [anon_sym_extern] = ACTIONS(1223),
    [anon_sym_inline] = ACTIONS(1223),
    [anon_sym_noinline] = ACTIONS(1223),
    [anon_sym_threadlocal] = ACTIONS(1223),
    [anon_sym_usingnamespace] = ACTIONS(1223),
    [anon_sym_fn] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1223),
    [anon_sym_const] = ACTIONS(1223),
    [anon_sym_var] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_RBRACE] = ACTIONS(1221),
    [anon_sym_async] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_error] = ACTIONS(1223),
    [anon_sym_false] = ACTIONS(1223),
    [anon_sym_null] = ACTIONS(1223),
    [anon_sym_anyframe] = ACTIONS(1223),
    [anon_sym_true] = ACTIONS(1223),
    [anon_sym_undefined] = ACTIONS(1223),
    [anon_sym_unreachable] = ACTIONS(1223),
    [sym_BuildinTypeExpr] = ACTIONS(1223),
    [anon_sym_packed] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1221),
    [anon_sym_switch] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [anon_sym_for] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1223),
    [anon_sym_STAR] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_orelse] = ACTIONS(1223),
    [anon_sym_catch] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_DASH] = ACTIONS(1223),
    [anon_sym_PLUS_PLUS] = ACTIONS(1221),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1221),
    [anon_sym_DASH_PERCENT] = ACTIONS(1221),
    [anon_sym_PLUS_PIPE] = ACTIONS(1221),
    [anon_sym_DASH_PIPE] = ACTIONS(1221),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_STAR_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_PIPE] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1221),
    [anon_sym_DOT_STAR] = ACTIONS(1221),
    [anon_sym_DOT_QMARK] = ACTIONS(1221),
    [anon_sym_struct] = ACTIONS(1223),
    [anon_sym_opaque] = ACTIONS(1223),
    [anon_sym_enum] = ACTIONS(1223),
    [anon_sym_union] = ACTIONS(1223),
    [sym_doc_comment] = ACTIONS(1221),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1221),
    [aux_sym_FLOAT_token1] = ACTIONS(1221),
    [aux_sym_FLOAT_token2] = ACTIONS(1221),
    [aux_sym_FLOAT_token3] = ACTIONS(1221),
    [aux_sym_FLOAT_token4] = ACTIONS(1221),
    [aux_sym_INTEGER_token1] = ACTIONS(1221),
    [aux_sym_INTEGER_token2] = ACTIONS(1221),
    [aux_sym_INTEGER_token3] = ACTIONS(1223),
    [aux_sym_INTEGER_token4] = ACTIONS(1223),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1221),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1223),
    [anon_sym_AT] = ACTIONS(1221),
  },
  [481] = {
    [ts_builtin_sym_end] = ACTIONS(1225),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_pub] = ACTIONS(1227),
    [anon_sym_test] = ACTIONS(1227),
    [anon_sym_comptime] = ACTIONS(1227),
    [anon_sym_export] = ACTIONS(1227),
    [anon_sym_extern] = ACTIONS(1227),
    [anon_sym_inline] = ACTIONS(1227),
    [anon_sym_noinline] = ACTIONS(1227),
    [anon_sym_threadlocal] = ACTIONS(1227),
    [anon_sym_usingnamespace] = ACTIONS(1227),
    [anon_sym_fn] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_const] = ACTIONS(1227),
    [anon_sym_var] = ACTIONS(1227),
    [anon_sym_else] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1225),
    [anon_sym_RBRACE] = ACTIONS(1225),
    [anon_sym_async] = ACTIONS(1227),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_error] = ACTIONS(1227),
    [anon_sym_false] = ACTIONS(1227),
    [anon_sym_null] = ACTIONS(1227),
    [anon_sym_anyframe] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1227),
    [anon_sym_undefined] = ACTIONS(1227),
    [anon_sym_unreachable] = ACTIONS(1227),
    [sym_BuildinTypeExpr] = ACTIONS(1227),
    [anon_sym_packed] = ACTIONS(1227),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1225),
    [anon_sym_if] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_STAR] = ACTIONS(1227),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1225),
    [anon_sym_orelse] = ACTIONS(1227),
    [anon_sym_catch] = ACTIONS(1227),
    [anon_sym_LT_LT] = ACTIONS(1227),
    [anon_sym_GT_GT] = ACTIONS(1225),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1225),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_DASH] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1225),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1225),
    [anon_sym_DASH_PERCENT] = ACTIONS(1225),
    [anon_sym_PLUS_PIPE] = ACTIONS(1225),
    [anon_sym_DASH_PIPE] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_STAR_STAR] = ACTIONS(1225),
    [anon_sym_STAR_PERCENT] = ACTIONS(1225),
    [anon_sym_STAR_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_DOT_STAR] = ACTIONS(1225),
    [anon_sym_DOT_QMARK] = ACTIONS(1225),
    [anon_sym_struct] = ACTIONS(1227),
    [anon_sym_opaque] = ACTIONS(1227),
    [anon_sym_enum] = ACTIONS(1227),
    [anon_sym_union] = ACTIONS(1227),
    [sym_doc_comment] = ACTIONS(1225),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1225),
    [aux_sym_FLOAT_token1] = ACTIONS(1225),
    [aux_sym_FLOAT_token2] = ACTIONS(1225),
    [aux_sym_FLOAT_token3] = ACTIONS(1225),
    [aux_sym_FLOAT_token4] = ACTIONS(1225),
    [aux_sym_INTEGER_token1] = ACTIONS(1225),
    [aux_sym_INTEGER_token2] = ACTIONS(1225),
    [aux_sym_INTEGER_token3] = ACTIONS(1227),
    [aux_sym_INTEGER_token4] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1225),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1225),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1227),
    [anon_sym_AT] = ACTIONS(1225),
  },
  [482] = {
    [ts_builtin_sym_end] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_pub] = ACTIONS(1231),
    [anon_sym_test] = ACTIONS(1231),
    [anon_sym_comptime] = ACTIONS(1231),
    [anon_sym_export] = ACTIONS(1231),
    [anon_sym_extern] = ACTIONS(1231),
    [anon_sym_inline] = ACTIONS(1231),
    [anon_sym_noinline] = ACTIONS(1231),
    [anon_sym_threadlocal] = ACTIONS(1231),
    [anon_sym_usingnamespace] = ACTIONS(1231),
    [anon_sym_fn] = ACTIONS(1231),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_const] = ACTIONS(1231),
    [anon_sym_var] = ACTIONS(1231),
    [anon_sym_else] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_error] = ACTIONS(1231),
    [anon_sym_false] = ACTIONS(1231),
    [anon_sym_null] = ACTIONS(1231),
    [anon_sym_anyframe] = ACTIONS(1231),
    [anon_sym_true] = ACTIONS(1231),
    [anon_sym_undefined] = ACTIONS(1231),
    [anon_sym_unreachable] = ACTIONS(1231),
    [sym_BuildinTypeExpr] = ACTIONS(1231),
    [anon_sym_packed] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1229),
    [anon_sym_if] = ACTIONS(1231),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_for] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1229),
    [anon_sym_orelse] = ACTIONS(1231),
    [anon_sym_catch] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1229),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_DASH] = ACTIONS(1231),
    [anon_sym_PLUS_PLUS] = ACTIONS(1229),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1229),
    [anon_sym_DASH_PERCENT] = ACTIONS(1229),
    [anon_sym_PLUS_PIPE] = ACTIONS(1229),
    [anon_sym_DASH_PIPE] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_STAR_STAR] = ACTIONS(1229),
    [anon_sym_STAR_PERCENT] = ACTIONS(1229),
    [anon_sym_STAR_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK] = ACTIONS(1229),
    [anon_sym_DOT_STAR] = ACTIONS(1229),
    [anon_sym_DOT_QMARK] = ACTIONS(1229),
    [anon_sym_struct] = ACTIONS(1231),
    [anon_sym_opaque] = ACTIONS(1231),
    [anon_sym_enum] = ACTIONS(1231),
    [anon_sym_union] = ACTIONS(1231),
    [sym_doc_comment] = ACTIONS(1229),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1229),
    [aux_sym_FLOAT_token1] = ACTIONS(1229),
    [aux_sym_FLOAT_token2] = ACTIONS(1229),
    [aux_sym_FLOAT_token3] = ACTIONS(1229),
    [aux_sym_FLOAT_token4] = ACTIONS(1229),
    [aux_sym_INTEGER_token1] = ACTIONS(1229),
    [aux_sym_INTEGER_token2] = ACTIONS(1229),
    [aux_sym_INTEGER_token3] = ACTIONS(1231),
    [aux_sym_INTEGER_token4] = ACTIONS(1231),
    [anon_sym_DQUOTE] = ACTIONS(1229),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1229),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1231),
    [anon_sym_AT] = ACTIONS(1229),
  },
  [483] = {
    [ts_builtin_sym_end] = ACTIONS(1233),
    [anon_sym_COMMA] = ACTIONS(1233),
    [anon_sym_pub] = ACTIONS(1235),
    [anon_sym_test] = ACTIONS(1235),
    [anon_sym_comptime] = ACTIONS(1235),
    [anon_sym_export] = ACTIONS(1235),
    [anon_sym_extern] = ACTIONS(1235),
    [anon_sym_inline] = ACTIONS(1235),
    [anon_sym_noinline] = ACTIONS(1235),
    [anon_sym_threadlocal] = ACTIONS(1235),
    [anon_sym_usingnamespace] = ACTIONS(1235),
    [anon_sym_fn] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_const] = ACTIONS(1235),
    [anon_sym_var] = ACTIONS(1235),
    [anon_sym_else] = ACTIONS(1235),
    [anon_sym_or] = ACTIONS(1235),
    [anon_sym_and] = ACTIONS(1235),
    [anon_sym_LBRACE] = ACTIONS(1233),
    [anon_sym_RBRACE] = ACTIONS(1233),
    [anon_sym_async] = ACTIONS(1235),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_error] = ACTIONS(1235),
    [anon_sym_false] = ACTIONS(1235),
    [anon_sym_null] = ACTIONS(1235),
    [anon_sym_anyframe] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(1235),
    [anon_sym_undefined] = ACTIONS(1235),
    [anon_sym_unreachable] = ACTIONS(1235),
    [sym_BuildinTypeExpr] = ACTIONS(1235),
    [anon_sym_packed] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_switch] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_if] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_PIPE] = ACTIONS(1235),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_EQ_EQ] = ACTIONS(1233),
    [anon_sym_BANG_EQ] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1235),
    [anon_sym_LT_EQ] = ACTIONS(1233),
    [anon_sym_GT_EQ] = ACTIONS(1233),
    [anon_sym_AMP] = ACTIONS(1233),
    [anon_sym_CARET] = ACTIONS(1233),
    [anon_sym_orelse] = ACTIONS(1235),
    [anon_sym_catch] = ACTIONS(1235),
    [anon_sym_LT_LT] = ACTIONS(1235),
    [anon_sym_GT_GT] = ACTIONS(1233),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1233),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1233),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_PERCENT] = ACTIONS(1233),
    [anon_sym_PLUS_PIPE] = ACTIONS(1233),
    [anon_sym_DASH_PIPE] = ACTIONS(1233),
    [anon_sym_PIPE_PIPE] = ACTIONS(1233),
    [anon_sym_SLASH] = ACTIONS(1235),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_STAR_STAR] = ACTIONS(1233),
    [anon_sym_STAR_PERCENT] = ACTIONS(1233),
    [anon_sym_STAR_PIPE] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(1233),
    [anon_sym_DOT_STAR] = ACTIONS(1233),
    [anon_sym_DOT_QMARK] = ACTIONS(1233),
    [anon_sym_struct] = ACTIONS(1235),
    [anon_sym_opaque] = ACTIONS(1235),
    [anon_sym_enum] = ACTIONS(1235),
    [anon_sym_union] = ACTIONS(1235),
    [sym_doc_comment] = ACTIONS(1233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1233),
    [aux_sym_FLOAT_token1] = ACTIONS(1233),
    [aux_sym_FLOAT_token2] = ACTIONS(1233),
    [aux_sym_FLOAT_token3] = ACTIONS(1233),
    [aux_sym_FLOAT_token4] = ACTIONS(1233),
    [aux_sym_INTEGER_token1] = ACTIONS(1233),
    [aux_sym_INTEGER_token2] = ACTIONS(1233),
    [aux_sym_INTEGER_token3] = ACTIONS(1235),
    [aux_sym_INTEGER_token4] = ACTIONS(1235),
    [anon_sym_DQUOTE] = ACTIONS(1233),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1233),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1235),
    [anon_sym_AT] = ACTIONS(1233),
  },
  [484] = {
    [ts_builtin_sym_end] = ACTIONS(1237),
    [anon_sym_COMMA] = ACTIONS(1237),
    [anon_sym_pub] = ACTIONS(1239),
    [anon_sym_test] = ACTIONS(1239),
    [anon_sym_comptime] = ACTIONS(1239),
    [anon_sym_export] = ACTIONS(1239),
    [anon_sym_extern] = ACTIONS(1239),
    [anon_sym_inline] = ACTIONS(1239),
    [anon_sym_noinline] = ACTIONS(1239),
    [anon_sym_threadlocal] = ACTIONS(1239),
    [anon_sym_usingnamespace] = ACTIONS(1239),
    [anon_sym_fn] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_const] = ACTIONS(1239),
    [anon_sym_var] = ACTIONS(1239),
    [anon_sym_else] = ACTIONS(1239),
    [anon_sym_or] = ACTIONS(1239),
    [anon_sym_and] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_RBRACE] = ACTIONS(1237),
    [anon_sym_async] = ACTIONS(1239),
    [anon_sym_DOT] = ACTIONS(1239),
    [anon_sym_error] = ACTIONS(1239),
    [anon_sym_false] = ACTIONS(1239),
    [anon_sym_null] = ACTIONS(1239),
    [anon_sym_anyframe] = ACTIONS(1239),
    [anon_sym_true] = ACTIONS(1239),
    [anon_sym_undefined] = ACTIONS(1239),
    [anon_sym_unreachable] = ACTIONS(1239),
    [sym_BuildinTypeExpr] = ACTIONS(1239),
    [anon_sym_packed] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1237),
    [anon_sym_switch] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_if] = ACTIONS(1239),
    [anon_sym_while] = ACTIONS(1239),
    [anon_sym_for] = ACTIONS(1239),
    [anon_sym_PIPE] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(1239),
    [anon_sym_EQ_EQ] = ACTIONS(1237),
    [anon_sym_BANG_EQ] = ACTIONS(1237),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_LT_EQ] = ACTIONS(1237),
    [anon_sym_GT_EQ] = ACTIONS(1237),
    [anon_sym_AMP] = ACTIONS(1237),
    [anon_sym_CARET] = ACTIONS(1237),
    [anon_sym_orelse] = ACTIONS(1239),
    [anon_sym_catch] = ACTIONS(1239),
    [anon_sym_LT_LT] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1237),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1237),
    [anon_sym_DASH_PERCENT] = ACTIONS(1237),
    [anon_sym_PLUS_PIPE] = ACTIONS(1237),
    [anon_sym_DASH_PIPE] = ACTIONS(1237),
    [anon_sym_PIPE_PIPE] = ACTIONS(1237),
    [anon_sym_SLASH] = ACTIONS(1239),
    [anon_sym_PERCENT] = ACTIONS(1237),
    [anon_sym_STAR_STAR] = ACTIONS(1237),
    [anon_sym_STAR_PERCENT] = ACTIONS(1237),
    [anon_sym_STAR_PIPE] = ACTIONS(1237),
    [anon_sym_QMARK] = ACTIONS(1237),
    [anon_sym_DOT_STAR] = ACTIONS(1237),
    [anon_sym_DOT_QMARK] = ACTIONS(1237),
    [anon_sym_struct] = ACTIONS(1239),
    [anon_sym_opaque] = ACTIONS(1239),
    [anon_sym_enum] = ACTIONS(1239),
    [anon_sym_union] = ACTIONS(1239),
    [sym_doc_comment] = ACTIONS(1237),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [aux_sym_FLOAT_token1] = ACTIONS(1237),
    [aux_sym_FLOAT_token2] = ACTIONS(1237),
    [aux_sym_FLOAT_token3] = ACTIONS(1237),
    [aux_sym_FLOAT_token4] = ACTIONS(1237),
    [aux_sym_INTEGER_token1] = ACTIONS(1237),
    [aux_sym_INTEGER_token2] = ACTIONS(1237),
    [aux_sym_INTEGER_token3] = ACTIONS(1239),
    [aux_sym_INTEGER_token4] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1237),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1237),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1239),
    [anon_sym_AT] = ACTIONS(1237),
  },
  [485] = {
    [ts_builtin_sym_end] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(1241),
    [anon_sym_pub] = ACTIONS(1243),
    [anon_sym_test] = ACTIONS(1243),
    [anon_sym_comptime] = ACTIONS(1243),
    [anon_sym_export] = ACTIONS(1243),
    [anon_sym_extern] = ACTIONS(1243),
    [anon_sym_inline] = ACTIONS(1243),
    [anon_sym_noinline] = ACTIONS(1243),
    [anon_sym_threadlocal] = ACTIONS(1243),
    [anon_sym_usingnamespace] = ACTIONS(1243),
    [anon_sym_fn] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_const] = ACTIONS(1243),
    [anon_sym_var] = ACTIONS(1243),
    [anon_sym_else] = ACTIONS(1243),
    [anon_sym_or] = ACTIONS(1243),
    [anon_sym_and] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_DOT] = ACTIONS(1243),
    [anon_sym_error] = ACTIONS(1243),
    [anon_sym_false] = ACTIONS(1243),
    [anon_sym_null] = ACTIONS(1243),
    [anon_sym_anyframe] = ACTIONS(1243),
    [anon_sym_true] = ACTIONS(1243),
    [anon_sym_undefined] = ACTIONS(1243),
    [anon_sym_unreachable] = ACTIONS(1243),
    [sym_BuildinTypeExpr] = ACTIONS(1243),
    [anon_sym_packed] = ACTIONS(1243),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_switch] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1243),
    [anon_sym_while] = ACTIONS(1243),
    [anon_sym_for] = ACTIONS(1243),
    [anon_sym_PIPE] = ACTIONS(1243),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_EQ_EQ] = ACTIONS(1241),
    [anon_sym_BANG_EQ] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1243),
    [anon_sym_GT] = ACTIONS(1243),
    [anon_sym_LT_EQ] = ACTIONS(1241),
    [anon_sym_GT_EQ] = ACTIONS(1241),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_CARET] = ACTIONS(1241),
    [anon_sym_orelse] = ACTIONS(1243),
    [anon_sym_catch] = ACTIONS(1243),
    [anon_sym_LT_LT] = ACTIONS(1243),
    [anon_sym_GT_GT] = ACTIONS(1241),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1241),
    [anon_sym_PLUS] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1241),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1241),
    [anon_sym_DASH_PERCENT] = ACTIONS(1241),
    [anon_sym_PLUS_PIPE] = ACTIONS(1241),
    [anon_sym_DASH_PIPE] = ACTIONS(1241),
    [anon_sym_PIPE_PIPE] = ACTIONS(1241),
    [anon_sym_SLASH] = ACTIONS(1243),
    [anon_sym_PERCENT] = ACTIONS(1241),
    [anon_sym_STAR_STAR] = ACTIONS(1241),
    [anon_sym_STAR_PERCENT] = ACTIONS(1241),
    [anon_sym_STAR_PIPE] = ACTIONS(1241),
    [anon_sym_QMARK] = ACTIONS(1241),
    [anon_sym_DOT_STAR] = ACTIONS(1241),
    [anon_sym_DOT_QMARK] = ACTIONS(1241),
    [anon_sym_struct] = ACTIONS(1243),
    [anon_sym_opaque] = ACTIONS(1243),
    [anon_sym_enum] = ACTIONS(1243),
    [anon_sym_union] = ACTIONS(1243),
    [sym_doc_comment] = ACTIONS(1241),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1241),
    [aux_sym_FLOAT_token1] = ACTIONS(1241),
    [aux_sym_FLOAT_token2] = ACTIONS(1241),
    [aux_sym_FLOAT_token3] = ACTIONS(1241),
    [aux_sym_FLOAT_token4] = ACTIONS(1241),
    [aux_sym_INTEGER_token1] = ACTIONS(1241),
    [aux_sym_INTEGER_token2] = ACTIONS(1241),
    [aux_sym_INTEGER_token3] = ACTIONS(1243),
    [aux_sym_INTEGER_token4] = ACTIONS(1243),
    [anon_sym_DQUOTE] = ACTIONS(1241),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1241),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1243),
    [anon_sym_AT] = ACTIONS(1241),
  },
  [486] = {
    [ts_builtin_sym_end] = ACTIONS(1245),
    [anon_sym_COMMA] = ACTIONS(1245),
    [anon_sym_pub] = ACTIONS(1247),
    [anon_sym_test] = ACTIONS(1247),
    [anon_sym_comptime] = ACTIONS(1247),
    [anon_sym_export] = ACTIONS(1247),
    [anon_sym_extern] = ACTIONS(1247),
    [anon_sym_inline] = ACTIONS(1247),
    [anon_sym_noinline] = ACTIONS(1247),
    [anon_sym_threadlocal] = ACTIONS(1247),
    [anon_sym_usingnamespace] = ACTIONS(1247),
    [anon_sym_fn] = ACTIONS(1247),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_const] = ACTIONS(1247),
    [anon_sym_var] = ACTIONS(1247),
    [anon_sym_else] = ACTIONS(1247),
    [anon_sym_or] = ACTIONS(1247),
    [anon_sym_and] = ACTIONS(1247),
    [anon_sym_LBRACE] = ACTIONS(1245),
    [anon_sym_RBRACE] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1247),
    [anon_sym_DOT] = ACTIONS(1247),
    [anon_sym_error] = ACTIONS(1247),
    [anon_sym_false] = ACTIONS(1247),
    [anon_sym_null] = ACTIONS(1247),
    [anon_sym_anyframe] = ACTIONS(1247),
    [anon_sym_true] = ACTIONS(1247),
    [anon_sym_undefined] = ACTIONS(1247),
    [anon_sym_unreachable] = ACTIONS(1247),
    [sym_BuildinTypeExpr] = ACTIONS(1247),
    [anon_sym_packed] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1245),
    [anon_sym_switch] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_if] = ACTIONS(1247),
    [anon_sym_while] = ACTIONS(1247),
    [anon_sym_for] = ACTIONS(1247),
    [anon_sym_PIPE] = ACTIONS(1247),
    [anon_sym_STAR] = ACTIONS(1247),
    [anon_sym_EQ_EQ] = ACTIONS(1245),
    [anon_sym_BANG_EQ] = ACTIONS(1245),
    [anon_sym_LT] = ACTIONS(1247),
    [anon_sym_GT] = ACTIONS(1247),
    [anon_sym_LT_EQ] = ACTIONS(1245),
    [anon_sym_GT_EQ] = ACTIONS(1245),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_CARET] = ACTIONS(1245),
    [anon_sym_orelse] = ACTIONS(1247),
    [anon_sym_catch] = ACTIONS(1247),
    [anon_sym_LT_LT] = ACTIONS(1247),
    [anon_sym_GT_GT] = ACTIONS(1245),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_DASH] = ACTIONS(1247),
    [anon_sym_PLUS_PLUS] = ACTIONS(1245),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1245),
    [anon_sym_DASH_PERCENT] = ACTIONS(1245),
    [anon_sym_PLUS_PIPE] = ACTIONS(1245),
    [anon_sym_DASH_PIPE] = ACTIONS(1245),
    [anon_sym_PIPE_PIPE] = ACTIONS(1245),
    [anon_sym_SLASH] = ACTIONS(1247),
    [anon_sym_PERCENT] = ACTIONS(1245),
    [anon_sym_STAR_STAR] = ACTIONS(1245),
    [anon_sym_STAR_PERCENT] = ACTIONS(1245),
    [anon_sym_STAR_PIPE] = ACTIONS(1245),
    [anon_sym_QMARK] = ACTIONS(1245),
    [anon_sym_DOT_STAR] = ACTIONS(1245),
    [anon_sym_DOT_QMARK] = ACTIONS(1245),
    [anon_sym_struct] = ACTIONS(1247),
    [anon_sym_opaque] = ACTIONS(1247),
    [anon_sym_enum] = ACTIONS(1247),
    [anon_sym_union] = ACTIONS(1247),
    [sym_doc_comment] = ACTIONS(1245),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1245),
    [aux_sym_FLOAT_token1] = ACTIONS(1245),
    [aux_sym_FLOAT_token2] = ACTIONS(1245),
    [aux_sym_FLOAT_token3] = ACTIONS(1245),
    [aux_sym_FLOAT_token4] = ACTIONS(1245),
    [aux_sym_INTEGER_token1] = ACTIONS(1245),
    [aux_sym_INTEGER_token2] = ACTIONS(1245),
    [aux_sym_INTEGER_token3] = ACTIONS(1247),
    [aux_sym_INTEGER_token4] = ACTIONS(1247),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1245),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1247),
    [anon_sym_AT] = ACTIONS(1245),
  },
  [487] = {
    [ts_builtin_sym_end] = ACTIONS(1249),
    [anon_sym_COMMA] = ACTIONS(1249),
    [anon_sym_pub] = ACTIONS(1251),
    [anon_sym_test] = ACTIONS(1251),
    [anon_sym_comptime] = ACTIONS(1251),
    [anon_sym_export] = ACTIONS(1251),
    [anon_sym_extern] = ACTIONS(1251),
    [anon_sym_inline] = ACTIONS(1251),
    [anon_sym_noinline] = ACTIONS(1251),
    [anon_sym_threadlocal] = ACTIONS(1251),
    [anon_sym_usingnamespace] = ACTIONS(1251),
    [anon_sym_fn] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_const] = ACTIONS(1251),
    [anon_sym_var] = ACTIONS(1251),
    [anon_sym_else] = ACTIONS(1251),
    [anon_sym_or] = ACTIONS(1251),
    [anon_sym_and] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(1249),
    [anon_sym_RBRACE] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1251),
    [anon_sym_error] = ACTIONS(1251),
    [anon_sym_false] = ACTIONS(1251),
    [anon_sym_null] = ACTIONS(1251),
    [anon_sym_anyframe] = ACTIONS(1251),
    [anon_sym_true] = ACTIONS(1251),
    [anon_sym_undefined] = ACTIONS(1251),
    [anon_sym_unreachable] = ACTIONS(1251),
    [sym_BuildinTypeExpr] = ACTIONS(1251),
    [anon_sym_packed] = ACTIONS(1251),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_switch] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1249),
    [anon_sym_if] = ACTIONS(1251),
    [anon_sym_while] = ACTIONS(1251),
    [anon_sym_for] = ACTIONS(1251),
    [anon_sym_PIPE] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1251),
    [anon_sym_EQ_EQ] = ACTIONS(1249),
    [anon_sym_BANG_EQ] = ACTIONS(1249),
    [anon_sym_LT] = ACTIONS(1251),
    [anon_sym_GT] = ACTIONS(1251),
    [anon_sym_LT_EQ] = ACTIONS(1249),
    [anon_sym_GT_EQ] = ACTIONS(1249),
    [anon_sym_AMP] = ACTIONS(1249),
    [anon_sym_CARET] = ACTIONS(1249),
    [anon_sym_orelse] = ACTIONS(1251),
    [anon_sym_catch] = ACTIONS(1251),
    [anon_sym_LT_LT] = ACTIONS(1251),
    [anon_sym_GT_GT] = ACTIONS(1249),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1249),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_PLUS_PLUS] = ACTIONS(1249),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1249),
    [anon_sym_DASH_PERCENT] = ACTIONS(1249),
    [anon_sym_PLUS_PIPE] = ACTIONS(1249),
    [anon_sym_DASH_PIPE] = ACTIONS(1249),
    [anon_sym_PIPE_PIPE] = ACTIONS(1249),
    [anon_sym_SLASH] = ACTIONS(1251),
    [anon_sym_PERCENT] = ACTIONS(1249),
    [anon_sym_STAR_STAR] = ACTIONS(1249),
    [anon_sym_STAR_PERCENT] = ACTIONS(1249),
    [anon_sym_STAR_PIPE] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(1249),
    [anon_sym_DOT_STAR] = ACTIONS(1249),
    [anon_sym_DOT_QMARK] = ACTIONS(1249),
    [anon_sym_struct] = ACTIONS(1251),
    [anon_sym_opaque] = ACTIONS(1251),
    [anon_sym_enum] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(1251),
    [sym_doc_comment] = ACTIONS(1249),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1249),
    [aux_sym_FLOAT_token1] = ACTIONS(1249),
    [aux_sym_FLOAT_token2] = ACTIONS(1249),
    [aux_sym_FLOAT_token3] = ACTIONS(1249),
    [aux_sym_FLOAT_token4] = ACTIONS(1249),
    [aux_sym_INTEGER_token1] = ACTIONS(1249),
    [aux_sym_INTEGER_token2] = ACTIONS(1249),
    [aux_sym_INTEGER_token3] = ACTIONS(1251),
    [aux_sym_INTEGER_token4] = ACTIONS(1251),
    [anon_sym_DQUOTE] = ACTIONS(1249),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1249),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1251),
    [anon_sym_AT] = ACTIONS(1249),
  },
  [488] = {
    [ts_builtin_sym_end] = ACTIONS(1253),
    [anon_sym_COMMA] = ACTIONS(1253),
    [anon_sym_pub] = ACTIONS(1255),
    [anon_sym_test] = ACTIONS(1255),
    [anon_sym_comptime] = ACTIONS(1255),
    [anon_sym_export] = ACTIONS(1255),
    [anon_sym_extern] = ACTIONS(1255),
    [anon_sym_inline] = ACTIONS(1255),
    [anon_sym_noinline] = ACTIONS(1255),
    [anon_sym_threadlocal] = ACTIONS(1255),
    [anon_sym_usingnamespace] = ACTIONS(1255),
    [anon_sym_fn] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_const] = ACTIONS(1255),
    [anon_sym_var] = ACTIONS(1255),
    [anon_sym_else] = ACTIONS(1255),
    [anon_sym_or] = ACTIONS(1255),
    [anon_sym_and] = ACTIONS(1255),
    [anon_sym_LBRACE] = ACTIONS(1253),
    [anon_sym_RBRACE] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1255),
    [anon_sym_DOT] = ACTIONS(1255),
    [anon_sym_error] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_null] = ACTIONS(1255),
    [anon_sym_anyframe] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_undefined] = ACTIONS(1255),
    [anon_sym_unreachable] = ACTIONS(1255),
    [sym_BuildinTypeExpr] = ACTIONS(1255),
    [anon_sym_packed] = ACTIONS(1255),
    [anon_sym_LPAREN] = ACTIONS(1253),
    [anon_sym_switch] = ACTIONS(1255),
    [anon_sym_LBRACK] = ACTIONS(1253),
    [anon_sym_if] = ACTIONS(1255),
    [anon_sym_while] = ACTIONS(1255),
    [anon_sym_for] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_EQ_EQ] = ACTIONS(1253),
    [anon_sym_BANG_EQ] = ACTIONS(1253),
    [anon_sym_LT] = ACTIONS(1255),
    [anon_sym_GT] = ACTIONS(1255),
    [anon_sym_LT_EQ] = ACTIONS(1253),
    [anon_sym_GT_EQ] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_orelse] = ACTIONS(1255),
    [anon_sym_catch] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1255),
    [anon_sym_GT_GT] = ACTIONS(1253),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1253),
    [anon_sym_PLUS] = ACTIONS(1255),
    [anon_sym_DASH] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1253),
    [anon_sym_DASH_PERCENT] = ACTIONS(1253),
    [anon_sym_PLUS_PIPE] = ACTIONS(1253),
    [anon_sym_DASH_PIPE] = ACTIONS(1253),
    [anon_sym_PIPE_PIPE] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(1255),
    [anon_sym_PERCENT] = ACTIONS(1253),
    [anon_sym_STAR_STAR] = ACTIONS(1253),
    [anon_sym_STAR_PERCENT] = ACTIONS(1253),
    [anon_sym_STAR_PIPE] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1253),
    [anon_sym_DOT_STAR] = ACTIONS(1253),
    [anon_sym_DOT_QMARK] = ACTIONS(1253),
    [anon_sym_struct] = ACTIONS(1255),
    [anon_sym_opaque] = ACTIONS(1255),
    [anon_sym_enum] = ACTIONS(1255),
    [anon_sym_union] = ACTIONS(1255),
    [sym_doc_comment] = ACTIONS(1253),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1253),
    [aux_sym_FLOAT_token1] = ACTIONS(1253),
    [aux_sym_FLOAT_token2] = ACTIONS(1253),
    [aux_sym_FLOAT_token3] = ACTIONS(1253),
    [aux_sym_FLOAT_token4] = ACTIONS(1253),
    [aux_sym_INTEGER_token1] = ACTIONS(1253),
    [aux_sym_INTEGER_token2] = ACTIONS(1253),
    [aux_sym_INTEGER_token3] = ACTIONS(1255),
    [aux_sym_INTEGER_token4] = ACTIONS(1255),
    [anon_sym_DQUOTE] = ACTIONS(1253),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1253),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1255),
    [anon_sym_AT] = ACTIONS(1253),
  },
  [489] = {
    [ts_builtin_sym_end] = ACTIONS(1257),
    [anon_sym_COMMA] = ACTIONS(1257),
    [anon_sym_pub] = ACTIONS(1259),
    [anon_sym_test] = ACTIONS(1259),
    [anon_sym_comptime] = ACTIONS(1259),
    [anon_sym_export] = ACTIONS(1259),
    [anon_sym_extern] = ACTIONS(1259),
    [anon_sym_inline] = ACTIONS(1259),
    [anon_sym_noinline] = ACTIONS(1259),
    [anon_sym_threadlocal] = ACTIONS(1259),
    [anon_sym_usingnamespace] = ACTIONS(1259),
    [anon_sym_fn] = ACTIONS(1259),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_const] = ACTIONS(1259),
    [anon_sym_var] = ACTIONS(1259),
    [anon_sym_else] = ACTIONS(1259),
    [anon_sym_or] = ACTIONS(1259),
    [anon_sym_and] = ACTIONS(1259),
    [anon_sym_LBRACE] = ACTIONS(1257),
    [anon_sym_RBRACE] = ACTIONS(1257),
    [anon_sym_async] = ACTIONS(1259),
    [anon_sym_DOT] = ACTIONS(1259),
    [anon_sym_error] = ACTIONS(1259),
    [anon_sym_false] = ACTIONS(1259),
    [anon_sym_null] = ACTIONS(1259),
    [anon_sym_anyframe] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(1259),
    [anon_sym_undefined] = ACTIONS(1259),
    [anon_sym_unreachable] = ACTIONS(1259),
    [sym_BuildinTypeExpr] = ACTIONS(1259),
    [anon_sym_packed] = ACTIONS(1259),
    [anon_sym_LPAREN] = ACTIONS(1257),
    [anon_sym_switch] = ACTIONS(1259),
    [anon_sym_LBRACK] = ACTIONS(1257),
    [anon_sym_if] = ACTIONS(1259),
    [anon_sym_while] = ACTIONS(1259),
    [anon_sym_for] = ACTIONS(1259),
    [anon_sym_PIPE] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1259),
    [anon_sym_EQ_EQ] = ACTIONS(1257),
    [anon_sym_BANG_EQ] = ACTIONS(1257),
    [anon_sym_LT] = ACTIONS(1259),
    [anon_sym_GT] = ACTIONS(1259),
    [anon_sym_LT_EQ] = ACTIONS(1257),
    [anon_sym_GT_EQ] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1257),
    [anon_sym_orelse] = ACTIONS(1259),
    [anon_sym_catch] = ACTIONS(1259),
    [anon_sym_LT_LT] = ACTIONS(1259),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS_PLUS] = ACTIONS(1257),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1257),
    [anon_sym_DASH_PERCENT] = ACTIONS(1257),
    [anon_sym_PLUS_PIPE] = ACTIONS(1257),
    [anon_sym_DASH_PIPE] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_SLASH] = ACTIONS(1259),
    [anon_sym_PERCENT] = ACTIONS(1257),
    [anon_sym_STAR_STAR] = ACTIONS(1257),
    [anon_sym_STAR_PERCENT] = ACTIONS(1257),
    [anon_sym_STAR_PIPE] = ACTIONS(1257),
    [anon_sym_QMARK] = ACTIONS(1257),
    [anon_sym_DOT_STAR] = ACTIONS(1257),
    [anon_sym_DOT_QMARK] = ACTIONS(1257),
    [anon_sym_struct] = ACTIONS(1259),
    [anon_sym_opaque] = ACTIONS(1259),
    [anon_sym_enum] = ACTIONS(1259),
    [anon_sym_union] = ACTIONS(1259),
    [sym_doc_comment] = ACTIONS(1257),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1257),
    [aux_sym_FLOAT_token1] = ACTIONS(1257),
    [aux_sym_FLOAT_token2] = ACTIONS(1257),
    [aux_sym_FLOAT_token3] = ACTIONS(1257),
    [aux_sym_FLOAT_token4] = ACTIONS(1257),
    [aux_sym_INTEGER_token1] = ACTIONS(1257),
    [aux_sym_INTEGER_token2] = ACTIONS(1257),
    [aux_sym_INTEGER_token3] = ACTIONS(1259),
    [aux_sym_INTEGER_token4] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1257),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1257),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1259),
    [anon_sym_AT] = ACTIONS(1257),
  },
  [490] = {
    [ts_builtin_sym_end] = ACTIONS(1261),
    [anon_sym_COMMA] = ACTIONS(1261),
    [anon_sym_pub] = ACTIONS(1263),
    [anon_sym_test] = ACTIONS(1263),
    [anon_sym_comptime] = ACTIONS(1263),
    [anon_sym_export] = ACTIONS(1263),
    [anon_sym_extern] = ACTIONS(1263),
    [anon_sym_inline] = ACTIONS(1263),
    [anon_sym_noinline] = ACTIONS(1263),
    [anon_sym_threadlocal] = ACTIONS(1263),
    [anon_sym_usingnamespace] = ACTIONS(1263),
    [anon_sym_fn] = ACTIONS(1263),
    [anon_sym_BANG] = ACTIONS(1263),
    [anon_sym_const] = ACTIONS(1263),
    [anon_sym_var] = ACTIONS(1263),
    [anon_sym_else] = ACTIONS(1263),
    [anon_sym_or] = ACTIONS(1263),
    [anon_sym_and] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_RBRACE] = ACTIONS(1261),
    [anon_sym_async] = ACTIONS(1263),
    [anon_sym_DOT] = ACTIONS(1263),
    [anon_sym_error] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_null] = ACTIONS(1263),
    [anon_sym_anyframe] = ACTIONS(1263),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_undefined] = ACTIONS(1263),
    [anon_sym_unreachable] = ACTIONS(1263),
    [sym_BuildinTypeExpr] = ACTIONS(1263),
    [anon_sym_packed] = ACTIONS(1263),
    [anon_sym_LPAREN] = ACTIONS(1261),
    [anon_sym_switch] = ACTIONS(1263),
    [anon_sym_LBRACK] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_while] = ACTIONS(1263),
    [anon_sym_for] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1263),
    [anon_sym_EQ_EQ] = ACTIONS(1261),
    [anon_sym_BANG_EQ] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_LT_EQ] = ACTIONS(1261),
    [anon_sym_GT_EQ] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_orelse] = ACTIONS(1263),
    [anon_sym_catch] = ACTIONS(1263),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1261),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1261),
    [anon_sym_DASH_PERCENT] = ACTIONS(1261),
    [anon_sym_PLUS_PIPE] = ACTIONS(1261),
    [anon_sym_DASH_PIPE] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [anon_sym_SLASH] = ACTIONS(1263),
    [anon_sym_PERCENT] = ACTIONS(1261),
    [anon_sym_STAR_STAR] = ACTIONS(1261),
    [anon_sym_STAR_PERCENT] = ACTIONS(1261),
    [anon_sym_STAR_PIPE] = ACTIONS(1261),
    [anon_sym_QMARK] = ACTIONS(1261),
    [anon_sym_DOT_STAR] = ACTIONS(1261),
    [anon_sym_DOT_QMARK] = ACTIONS(1261),
    [anon_sym_struct] = ACTIONS(1263),
    [anon_sym_opaque] = ACTIONS(1263),
    [anon_sym_enum] = ACTIONS(1263),
    [anon_sym_union] = ACTIONS(1263),
    [sym_doc_comment] = ACTIONS(1261),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [aux_sym_FLOAT_token1] = ACTIONS(1261),
    [aux_sym_FLOAT_token2] = ACTIONS(1261),
    [aux_sym_FLOAT_token3] = ACTIONS(1261),
    [aux_sym_FLOAT_token4] = ACTIONS(1261),
    [aux_sym_INTEGER_token1] = ACTIONS(1261),
    [aux_sym_INTEGER_token2] = ACTIONS(1261),
    [aux_sym_INTEGER_token3] = ACTIONS(1263),
    [aux_sym_INTEGER_token4] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1261),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1263),
    [anon_sym_AT] = ACTIONS(1261),
  },
  [491] = {
    [ts_builtin_sym_end] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_pub] = ACTIONS(1267),
    [anon_sym_test] = ACTIONS(1267),
    [anon_sym_comptime] = ACTIONS(1267),
    [anon_sym_export] = ACTIONS(1267),
    [anon_sym_extern] = ACTIONS(1267),
    [anon_sym_inline] = ACTIONS(1267),
    [anon_sym_noinline] = ACTIONS(1267),
    [anon_sym_threadlocal] = ACTIONS(1267),
    [anon_sym_usingnamespace] = ACTIONS(1267),
    [anon_sym_fn] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_const] = ACTIONS(1267),
    [anon_sym_var] = ACTIONS(1267),
    [anon_sym_else] = ACTIONS(1267),
    [anon_sym_or] = ACTIONS(1267),
    [anon_sym_and] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1265),
    [anon_sym_RBRACE] = ACTIONS(1265),
    [anon_sym_async] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1267),
    [anon_sym_error] = ACTIONS(1267),
    [anon_sym_false] = ACTIONS(1267),
    [anon_sym_null] = ACTIONS(1267),
    [anon_sym_anyframe] = ACTIONS(1267),
    [anon_sym_true] = ACTIONS(1267),
    [anon_sym_undefined] = ACTIONS(1267),
    [anon_sym_unreachable] = ACTIONS(1267),
    [sym_BuildinTypeExpr] = ACTIONS(1267),
    [anon_sym_packed] = ACTIONS(1267),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [anon_sym_switch] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1267),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1267),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_LT_EQ] = ACTIONS(1265),
    [anon_sym_GT_EQ] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1265),
    [anon_sym_orelse] = ACTIONS(1267),
    [anon_sym_catch] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1267),
    [anon_sym_PLUS_PLUS] = ACTIONS(1265),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1265),
    [anon_sym_DASH_PERCENT] = ACTIONS(1265),
    [anon_sym_PLUS_PIPE] = ACTIONS(1265),
    [anon_sym_DASH_PIPE] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1267),
    [anon_sym_PERCENT] = ACTIONS(1265),
    [anon_sym_STAR_STAR] = ACTIONS(1265),
    [anon_sym_STAR_PERCENT] = ACTIONS(1265),
    [anon_sym_STAR_PIPE] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_DOT_STAR] = ACTIONS(1265),
    [anon_sym_DOT_QMARK] = ACTIONS(1265),
    [anon_sym_struct] = ACTIONS(1267),
    [anon_sym_opaque] = ACTIONS(1267),
    [anon_sym_enum] = ACTIONS(1267),
    [anon_sym_union] = ACTIONS(1267),
    [sym_doc_comment] = ACTIONS(1265),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1265),
    [aux_sym_FLOAT_token1] = ACTIONS(1265),
    [aux_sym_FLOAT_token2] = ACTIONS(1265),
    [aux_sym_FLOAT_token3] = ACTIONS(1265),
    [aux_sym_FLOAT_token4] = ACTIONS(1265),
    [aux_sym_INTEGER_token1] = ACTIONS(1265),
    [aux_sym_INTEGER_token2] = ACTIONS(1265),
    [aux_sym_INTEGER_token3] = ACTIONS(1267),
    [aux_sym_INTEGER_token4] = ACTIONS(1267),
    [anon_sym_DQUOTE] = ACTIONS(1265),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1265),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1267),
    [anon_sym_AT] = ACTIONS(1265),
  },
  [492] = {
    [ts_builtin_sym_end] = ACTIONS(530),
    [anon_sym_COMMA] = ACTIONS(530),
    [anon_sym_pub] = ACTIONS(528),
    [anon_sym_test] = ACTIONS(528),
    [anon_sym_comptime] = ACTIONS(528),
    [anon_sym_export] = ACTIONS(528),
    [anon_sym_extern] = ACTIONS(528),
    [anon_sym_inline] = ACTIONS(528),
    [anon_sym_noinline] = ACTIONS(528),
    [anon_sym_threadlocal] = ACTIONS(528),
    [anon_sym_usingnamespace] = ACTIONS(528),
    [anon_sym_fn] = ACTIONS(528),
    [anon_sym_BANG] = ACTIONS(528),
    [anon_sym_const] = ACTIONS(528),
    [anon_sym_var] = ACTIONS(528),
    [anon_sym_else] = ACTIONS(528),
    [anon_sym_or] = ACTIONS(528),
    [anon_sym_and] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(528),
    [anon_sym_DOT] = ACTIONS(528),
    [anon_sym_error] = ACTIONS(528),
    [anon_sym_false] = ACTIONS(528),
    [anon_sym_null] = ACTIONS(528),
    [anon_sym_anyframe] = ACTIONS(528),
    [anon_sym_true] = ACTIONS(528),
    [anon_sym_undefined] = ACTIONS(528),
    [anon_sym_unreachable] = ACTIONS(528),
    [sym_BuildinTypeExpr] = ACTIONS(528),
    [anon_sym_packed] = ACTIONS(528),
    [anon_sym_LPAREN] = ACTIONS(530),
    [anon_sym_switch] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(530),
    [anon_sym_if] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(528),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_EQ_EQ] = ACTIONS(530),
    [anon_sym_BANG_EQ] = ACTIONS(530),
    [anon_sym_LT] = ACTIONS(528),
    [anon_sym_GT] = ACTIONS(528),
    [anon_sym_LT_EQ] = ACTIONS(530),
    [anon_sym_GT_EQ] = ACTIONS(530),
    [anon_sym_AMP] = ACTIONS(530),
    [anon_sym_CARET] = ACTIONS(530),
    [anon_sym_orelse] = ACTIONS(528),
    [anon_sym_catch] = ACTIONS(528),
    [anon_sym_LT_LT] = ACTIONS(528),
    [anon_sym_GT_GT] = ACTIONS(530),
    [anon_sym_LT_LT_PIPE] = ACTIONS(530),
    [anon_sym_PLUS] = ACTIONS(528),
    [anon_sym_DASH] = ACTIONS(528),
    [anon_sym_PLUS_PLUS] = ACTIONS(530),
    [anon_sym_PLUS_PERCENT] = ACTIONS(530),
    [anon_sym_DASH_PERCENT] = ACTIONS(530),
    [anon_sym_PLUS_PIPE] = ACTIONS(530),
    [anon_sym_DASH_PIPE] = ACTIONS(530),
    [anon_sym_PIPE_PIPE] = ACTIONS(530),
    [anon_sym_SLASH] = ACTIONS(528),
    [anon_sym_PERCENT] = ACTIONS(530),
    [anon_sym_STAR_STAR] = ACTIONS(530),
    [anon_sym_STAR_PERCENT] = ACTIONS(530),
    [anon_sym_STAR_PIPE] = ACTIONS(530),
    [anon_sym_QMARK] = ACTIONS(530),
    [anon_sym_DOT_STAR] = ACTIONS(530),
    [anon_sym_DOT_QMARK] = ACTIONS(530),
    [anon_sym_struct] = ACTIONS(528),
    [anon_sym_opaque] = ACTIONS(528),
    [anon_sym_enum] = ACTIONS(528),
    [anon_sym_union] = ACTIONS(528),
    [sym_doc_comment] = ACTIONS(530),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(530),
    [aux_sym_FLOAT_token1] = ACTIONS(530),
    [aux_sym_FLOAT_token2] = ACTIONS(530),
    [aux_sym_FLOAT_token3] = ACTIONS(530),
    [aux_sym_FLOAT_token4] = ACTIONS(530),
    [aux_sym_INTEGER_token1] = ACTIONS(530),
    [aux_sym_INTEGER_token2] = ACTIONS(530),
    [aux_sym_INTEGER_token3] = ACTIONS(528),
    [aux_sym_INTEGER_token4] = ACTIONS(528),
    [anon_sym_DQUOTE] = ACTIONS(530),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(530),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(528),
    [anon_sym_AT] = ACTIONS(530),
  },
  [493] = {
    [ts_builtin_sym_end] = ACTIONS(534),
    [anon_sym_COMMA] = ACTIONS(534),
    [anon_sym_pub] = ACTIONS(532),
    [anon_sym_test] = ACTIONS(532),
    [anon_sym_comptime] = ACTIONS(532),
    [anon_sym_export] = ACTIONS(532),
    [anon_sym_extern] = ACTIONS(532),
    [anon_sym_inline] = ACTIONS(532),
    [anon_sym_noinline] = ACTIONS(532),
    [anon_sym_threadlocal] = ACTIONS(532),
    [anon_sym_usingnamespace] = ACTIONS(532),
    [anon_sym_fn] = ACTIONS(532),
    [anon_sym_BANG] = ACTIONS(532),
    [anon_sym_const] = ACTIONS(532),
    [anon_sym_var] = ACTIONS(532),
    [anon_sym_else] = ACTIONS(532),
    [anon_sym_or] = ACTIONS(532),
    [anon_sym_and] = ACTIONS(532),
    [anon_sym_LBRACE] = ACTIONS(534),
    [anon_sym_RBRACE] = ACTIONS(534),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_DOT] = ACTIONS(532),
    [anon_sym_error] = ACTIONS(532),
    [anon_sym_false] = ACTIONS(532),
    [anon_sym_null] = ACTIONS(532),
    [anon_sym_anyframe] = ACTIONS(532),
    [anon_sym_true] = ACTIONS(532),
    [anon_sym_undefined] = ACTIONS(532),
    [anon_sym_unreachable] = ACTIONS(532),
    [sym_BuildinTypeExpr] = ACTIONS(532),
    [anon_sym_packed] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_switch] = ACTIONS(532),
    [anon_sym_LBRACK] = ACTIONS(534),
    [anon_sym_if] = ACTIONS(532),
    [anon_sym_while] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(532),
    [anon_sym_PIPE] = ACTIONS(532),
    [anon_sym_STAR] = ACTIONS(532),
    [anon_sym_EQ_EQ] = ACTIONS(534),
    [anon_sym_BANG_EQ] = ACTIONS(534),
    [anon_sym_LT] = ACTIONS(532),
    [anon_sym_GT] = ACTIONS(532),
    [anon_sym_LT_EQ] = ACTIONS(534),
    [anon_sym_GT_EQ] = ACTIONS(534),
    [anon_sym_AMP] = ACTIONS(534),
    [anon_sym_CARET] = ACTIONS(534),
    [anon_sym_orelse] = ACTIONS(532),
    [anon_sym_catch] = ACTIONS(532),
    [anon_sym_LT_LT] = ACTIONS(532),
    [anon_sym_GT_GT] = ACTIONS(534),
    [anon_sym_LT_LT_PIPE] = ACTIONS(534),
    [anon_sym_PLUS] = ACTIONS(532),
    [anon_sym_DASH] = ACTIONS(532),
    [anon_sym_PLUS_PLUS] = ACTIONS(534),
    [anon_sym_PLUS_PERCENT] = ACTIONS(534),
    [anon_sym_DASH_PERCENT] = ACTIONS(534),
    [anon_sym_PLUS_PIPE] = ACTIONS(534),
    [anon_sym_DASH_PIPE] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [anon_sym_SLASH] = ACTIONS(532),
    [anon_sym_PERCENT] = ACTIONS(534),
    [anon_sym_STAR_STAR] = ACTIONS(534),
    [anon_sym_STAR_PERCENT] = ACTIONS(534),
    [anon_sym_STAR_PIPE] = ACTIONS(534),
    [anon_sym_QMARK] = ACTIONS(534),
    [anon_sym_DOT_STAR] = ACTIONS(534),
    [anon_sym_DOT_QMARK] = ACTIONS(534),
    [anon_sym_struct] = ACTIONS(532),
    [anon_sym_opaque] = ACTIONS(532),
    [anon_sym_enum] = ACTIONS(532),
    [anon_sym_union] = ACTIONS(532),
    [sym_doc_comment] = ACTIONS(534),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(534),
    [aux_sym_FLOAT_token1] = ACTIONS(534),
    [aux_sym_FLOAT_token2] = ACTIONS(534),
    [aux_sym_FLOAT_token3] = ACTIONS(534),
    [aux_sym_FLOAT_token4] = ACTIONS(534),
    [aux_sym_INTEGER_token1] = ACTIONS(534),
    [aux_sym_INTEGER_token2] = ACTIONS(534),
    [aux_sym_INTEGER_token3] = ACTIONS(532),
    [aux_sym_INTEGER_token4] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(534),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(534),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(532),
    [anon_sym_AT] = ACTIONS(534),
  },
  [494] = {
    [ts_builtin_sym_end] = ACTIONS(1269),
    [anon_sym_COMMA] = ACTIONS(1269),
    [anon_sym_pub] = ACTIONS(1271),
    [anon_sym_test] = ACTIONS(1271),
    [anon_sym_comptime] = ACTIONS(1271),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_extern] = ACTIONS(1271),
    [anon_sym_inline] = ACTIONS(1271),
    [anon_sym_noinline] = ACTIONS(1271),
    [anon_sym_threadlocal] = ACTIONS(1271),
    [anon_sym_usingnamespace] = ACTIONS(1271),
    [anon_sym_fn] = ACTIONS(1271),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_const] = ACTIONS(1271),
    [anon_sym_var] = ACTIONS(1271),
    [anon_sym_else] = ACTIONS(1271),
    [anon_sym_or] = ACTIONS(1271),
    [anon_sym_and] = ACTIONS(1271),
    [anon_sym_LBRACE] = ACTIONS(1269),
    [anon_sym_RBRACE] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_DOT] = ACTIONS(1271),
    [anon_sym_error] = ACTIONS(1271),
    [anon_sym_false] = ACTIONS(1271),
    [anon_sym_null] = ACTIONS(1271),
    [anon_sym_anyframe] = ACTIONS(1271),
    [anon_sym_true] = ACTIONS(1271),
    [anon_sym_undefined] = ACTIONS(1271),
    [anon_sym_unreachable] = ACTIONS(1271),
    [sym_BuildinTypeExpr] = ACTIONS(1271),
    [anon_sym_packed] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_switch] = ACTIONS(1271),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_if] = ACTIONS(1271),
    [anon_sym_while] = ACTIONS(1271),
    [anon_sym_for] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(1271),
    [anon_sym_EQ_EQ] = ACTIONS(1269),
    [anon_sym_BANG_EQ] = ACTIONS(1269),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_LT_EQ] = ACTIONS(1269),
    [anon_sym_GT_EQ] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1269),
    [anon_sym_CARET] = ACTIONS(1269),
    [anon_sym_orelse] = ACTIONS(1271),
    [anon_sym_catch] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1269),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1269),
    [anon_sym_PLUS] = ACTIONS(1271),
    [anon_sym_DASH] = ACTIONS(1271),
    [anon_sym_PLUS_PLUS] = ACTIONS(1269),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1269),
    [anon_sym_DASH_PERCENT] = ACTIONS(1269),
    [anon_sym_PLUS_PIPE] = ACTIONS(1269),
    [anon_sym_DASH_PIPE] = ACTIONS(1269),
    [anon_sym_PIPE_PIPE] = ACTIONS(1269),
    [anon_sym_SLASH] = ACTIONS(1271),
    [anon_sym_PERCENT] = ACTIONS(1269),
    [anon_sym_STAR_STAR] = ACTIONS(1269),
    [anon_sym_STAR_PERCENT] = ACTIONS(1269),
    [anon_sym_STAR_PIPE] = ACTIONS(1269),
    [anon_sym_QMARK] = ACTIONS(1269),
    [anon_sym_DOT_STAR] = ACTIONS(1269),
    [anon_sym_DOT_QMARK] = ACTIONS(1269),
    [anon_sym_struct] = ACTIONS(1271),
    [anon_sym_opaque] = ACTIONS(1271),
    [anon_sym_enum] = ACTIONS(1271),
    [anon_sym_union] = ACTIONS(1271),
    [sym_doc_comment] = ACTIONS(1269),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1269),
    [aux_sym_FLOAT_token1] = ACTIONS(1269),
    [aux_sym_FLOAT_token2] = ACTIONS(1269),
    [aux_sym_FLOAT_token3] = ACTIONS(1269),
    [aux_sym_FLOAT_token4] = ACTIONS(1269),
    [aux_sym_INTEGER_token1] = ACTIONS(1269),
    [aux_sym_INTEGER_token2] = ACTIONS(1269),
    [aux_sym_INTEGER_token3] = ACTIONS(1271),
    [aux_sym_INTEGER_token4] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1269),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1271),
    [anon_sym_AT] = ACTIONS(1269),
  },
  [495] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1273),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_pub] = ACTIONS(1275),
    [anon_sym_test] = ACTIONS(1275),
    [anon_sym_comptime] = ACTIONS(1275),
    [anon_sym_export] = ACTIONS(1275),
    [anon_sym_extern] = ACTIONS(1275),
    [anon_sym_inline] = ACTIONS(1275),
    [anon_sym_noinline] = ACTIONS(1275),
    [anon_sym_threadlocal] = ACTIONS(1275),
    [anon_sym_usingnamespace] = ACTIONS(1275),
    [anon_sym_fn] = ACTIONS(1275),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_var] = ACTIONS(1275),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_async] = ACTIONS(1275),
    [anon_sym_DOT] = ACTIONS(1273),
    [anon_sym_error] = ACTIONS(1275),
    [anon_sym_false] = ACTIONS(1275),
    [anon_sym_null] = ACTIONS(1275),
    [anon_sym_anyframe] = ACTIONS(1275),
    [anon_sym_true] = ACTIONS(1275),
    [anon_sym_undefined] = ACTIONS(1275),
    [anon_sym_unreachable] = ACTIONS(1275),
    [sym_BuildinTypeExpr] = ACTIONS(1275),
    [anon_sym_packed] = ACTIONS(1275),
    [anon_sym_LPAREN] = ACTIONS(1273),
    [anon_sym_switch] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1275),
    [anon_sym_while] = ACTIONS(1275),
    [anon_sym_for] = ACTIONS(1275),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1273),
    [anon_sym_struct] = ACTIONS(1275),
    [anon_sym_opaque] = ACTIONS(1275),
    [anon_sym_enum] = ACTIONS(1275),
    [anon_sym_union] = ACTIONS(1275),
    [sym_doc_comment] = ACTIONS(1273),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1273),
    [aux_sym_FLOAT_token1] = ACTIONS(1273),
    [aux_sym_FLOAT_token2] = ACTIONS(1273),
    [aux_sym_FLOAT_token3] = ACTIONS(1273),
    [aux_sym_FLOAT_token4] = ACTIONS(1273),
    [aux_sym_INTEGER_token1] = ACTIONS(1273),
    [aux_sym_INTEGER_token2] = ACTIONS(1273),
    [aux_sym_INTEGER_token3] = ACTIONS(1275),
    [aux_sym_INTEGER_token4] = ACTIONS(1275),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1273),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1273),
  },
  [496] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1277),
    [anon_sym_COMMA] = ACTIONS(1277),
    [anon_sym_pub] = ACTIONS(1279),
    [anon_sym_test] = ACTIONS(1279),
    [anon_sym_comptime] = ACTIONS(1279),
    [anon_sym_export] = ACTIONS(1279),
    [anon_sym_extern] = ACTIONS(1279),
    [anon_sym_inline] = ACTIONS(1279),
    [anon_sym_noinline] = ACTIONS(1279),
    [anon_sym_threadlocal] = ACTIONS(1279),
    [anon_sym_usingnamespace] = ACTIONS(1279),
    [anon_sym_fn] = ACTIONS(1279),
    [anon_sym_const] = ACTIONS(1279),
    [anon_sym_var] = ACTIONS(1279),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1277),
    [anon_sym_async] = ACTIONS(1279),
    [anon_sym_DOT] = ACTIONS(1277),
    [anon_sym_error] = ACTIONS(1279),
    [anon_sym_false] = ACTIONS(1279),
    [anon_sym_null] = ACTIONS(1279),
    [anon_sym_anyframe] = ACTIONS(1279),
    [anon_sym_true] = ACTIONS(1279),
    [anon_sym_undefined] = ACTIONS(1279),
    [anon_sym_unreachable] = ACTIONS(1279),
    [sym_BuildinTypeExpr] = ACTIONS(1279),
    [anon_sym_packed] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1277),
    [anon_sym_switch] = ACTIONS(1279),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [anon_sym_if] = ACTIONS(1279),
    [anon_sym_while] = ACTIONS(1279),
    [anon_sym_for] = ACTIONS(1279),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1277),
    [anon_sym_struct] = ACTIONS(1279),
    [anon_sym_opaque] = ACTIONS(1279),
    [anon_sym_enum] = ACTIONS(1279),
    [anon_sym_union] = ACTIONS(1279),
    [sym_doc_comment] = ACTIONS(1277),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1277),
    [aux_sym_FLOAT_token1] = ACTIONS(1277),
    [aux_sym_FLOAT_token2] = ACTIONS(1277),
    [aux_sym_FLOAT_token3] = ACTIONS(1277),
    [aux_sym_FLOAT_token4] = ACTIONS(1277),
    [aux_sym_INTEGER_token1] = ACTIONS(1277),
    [aux_sym_INTEGER_token2] = ACTIONS(1277),
    [aux_sym_INTEGER_token3] = ACTIONS(1279),
    [aux_sym_INTEGER_token4] = ACTIONS(1279),
    [anon_sym_DQUOTE] = ACTIONS(1277),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1277),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1279),
    [anon_sym_AT] = ACTIONS(1277),
  },
  [497] = {
    [ts_builtin_sym_end] = ACTIONS(570),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_pub] = ACTIONS(568),
    [anon_sym_test] = ACTIONS(568),
    [anon_sym_comptime] = ACTIONS(568),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_extern] = ACTIONS(568),
    [anon_sym_inline] = ACTIONS(568),
    [anon_sym_noinline] = ACTIONS(568),
    [anon_sym_threadlocal] = ACTIONS(568),
    [anon_sym_usingnamespace] = ACTIONS(568),
    [anon_sym_fn] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(568),
    [anon_sym_const] = ACTIONS(568),
    [anon_sym_var] = ACTIONS(568),
    [anon_sym_else] = ACTIONS(568),
    [anon_sym_or] = ACTIONS(568),
    [anon_sym_and] = ACTIONS(568),
    [anon_sym_LBRACE] = ACTIONS(570),
    [anon_sym_RBRACE] = ACTIONS(570),
    [anon_sym_async] = ACTIONS(568),
    [anon_sym_DOT] = ACTIONS(568),
    [anon_sym_error] = ACTIONS(568),
    [anon_sym_false] = ACTIONS(568),
    [anon_sym_null] = ACTIONS(568),
    [anon_sym_anyframe] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(568),
    [anon_sym_undefined] = ACTIONS(568),
    [anon_sym_unreachable] = ACTIONS(568),
    [sym_BuildinTypeExpr] = ACTIONS(568),
    [anon_sym_packed] = ACTIONS(568),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_switch] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(568),
    [anon_sym_while] = ACTIONS(568),
    [anon_sym_for] = ACTIONS(568),
    [anon_sym_PIPE] = ACTIONS(568),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_EQ_EQ] = ACTIONS(570),
    [anon_sym_BANG_EQ] = ACTIONS(570),
    [anon_sym_LT] = ACTIONS(568),
    [anon_sym_GT] = ACTIONS(568),
    [anon_sym_LT_EQ] = ACTIONS(570),
    [anon_sym_GT_EQ] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(570),
    [anon_sym_CARET] = ACTIONS(570),
    [anon_sym_orelse] = ACTIONS(568),
    [anon_sym_catch] = ACTIONS(568),
    [anon_sym_LT_LT] = ACTIONS(568),
    [anon_sym_GT_GT] = ACTIONS(570),
    [anon_sym_LT_LT_PIPE] = ACTIONS(570),
    [anon_sym_PLUS] = ACTIONS(568),
    [anon_sym_DASH] = ACTIONS(568),
    [anon_sym_PLUS_PLUS] = ACTIONS(570),
    [anon_sym_PLUS_PERCENT] = ACTIONS(570),
    [anon_sym_DASH_PERCENT] = ACTIONS(570),
    [anon_sym_PLUS_PIPE] = ACTIONS(570),
    [anon_sym_DASH_PIPE] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(570),
    [anon_sym_SLASH] = ACTIONS(568),
    [anon_sym_PERCENT] = ACTIONS(570),
    [anon_sym_STAR_STAR] = ACTIONS(570),
    [anon_sym_STAR_PERCENT] = ACTIONS(570),
    [anon_sym_STAR_PIPE] = ACTIONS(570),
    [anon_sym_QMARK] = ACTIONS(570),
    [anon_sym_DOT_STAR] = ACTIONS(570),
    [anon_sym_DOT_QMARK] = ACTIONS(570),
    [anon_sym_struct] = ACTIONS(568),
    [anon_sym_opaque] = ACTIONS(568),
    [anon_sym_enum] = ACTIONS(568),
    [anon_sym_union] = ACTIONS(568),
    [sym_doc_comment] = ACTIONS(570),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(570),
    [aux_sym_FLOAT_token1] = ACTIONS(570),
    [aux_sym_FLOAT_token2] = ACTIONS(570),
    [aux_sym_FLOAT_token3] = ACTIONS(570),
    [aux_sym_FLOAT_token4] = ACTIONS(570),
    [aux_sym_INTEGER_token1] = ACTIONS(570),
    [aux_sym_INTEGER_token2] = ACTIONS(570),
    [aux_sym_INTEGER_token3] = ACTIONS(568),
    [aux_sym_INTEGER_token4] = ACTIONS(568),
    [anon_sym_DQUOTE] = ACTIONS(570),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(570),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(568),
    [anon_sym_AT] = ACTIONS(570),
  },
  [498] = {
    [ts_builtin_sym_end] = ACTIONS(566),
    [anon_sym_COMMA] = ACTIONS(566),
    [anon_sym_pub] = ACTIONS(564),
    [anon_sym_test] = ACTIONS(564),
    [anon_sym_comptime] = ACTIONS(564),
    [anon_sym_export] = ACTIONS(564),
    [anon_sym_extern] = ACTIONS(564),
    [anon_sym_inline] = ACTIONS(564),
    [anon_sym_noinline] = ACTIONS(564),
    [anon_sym_threadlocal] = ACTIONS(564),
    [anon_sym_usingnamespace] = ACTIONS(564),
    [anon_sym_fn] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_const] = ACTIONS(564),
    [anon_sym_var] = ACTIONS(564),
    [anon_sym_else] = ACTIONS(564),
    [anon_sym_or] = ACTIONS(564),
    [anon_sym_and] = ACTIONS(564),
    [anon_sym_LBRACE] = ACTIONS(566),
    [anon_sym_RBRACE] = ACTIONS(566),
    [anon_sym_async] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_error] = ACTIONS(564),
    [anon_sym_false] = ACTIONS(564),
    [anon_sym_null] = ACTIONS(564),
    [anon_sym_anyframe] = ACTIONS(564),
    [anon_sym_true] = ACTIONS(564),
    [anon_sym_undefined] = ACTIONS(564),
    [anon_sym_unreachable] = ACTIONS(564),
    [sym_BuildinTypeExpr] = ACTIONS(564),
    [anon_sym_packed] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_switch] = ACTIONS(564),
    [anon_sym_LBRACK] = ACTIONS(566),
    [anon_sym_if] = ACTIONS(564),
    [anon_sym_while] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(566),
    [anon_sym_BANG_EQ] = ACTIONS(566),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT_EQ] = ACTIONS(566),
    [anon_sym_GT_EQ] = ACTIONS(566),
    [anon_sym_AMP] = ACTIONS(566),
    [anon_sym_CARET] = ACTIONS(566),
    [anon_sym_orelse] = ACTIONS(564),
    [anon_sym_catch] = ACTIONS(564),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(566),
    [anon_sym_LT_LT_PIPE] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_PLUS_PLUS] = ACTIONS(566),
    [anon_sym_PLUS_PERCENT] = ACTIONS(566),
    [anon_sym_DASH_PERCENT] = ACTIONS(566),
    [anon_sym_PLUS_PIPE] = ACTIONS(566),
    [anon_sym_DASH_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_PIPE] = ACTIONS(566),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(566),
    [anon_sym_STAR_STAR] = ACTIONS(566),
    [anon_sym_STAR_PERCENT] = ACTIONS(566),
    [anon_sym_STAR_PIPE] = ACTIONS(566),
    [anon_sym_QMARK] = ACTIONS(566),
    [anon_sym_DOT_STAR] = ACTIONS(566),
    [anon_sym_DOT_QMARK] = ACTIONS(566),
    [anon_sym_struct] = ACTIONS(564),
    [anon_sym_opaque] = ACTIONS(564),
    [anon_sym_enum] = ACTIONS(564),
    [anon_sym_union] = ACTIONS(564),
    [sym_doc_comment] = ACTIONS(566),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(566),
    [aux_sym_FLOAT_token1] = ACTIONS(566),
    [aux_sym_FLOAT_token2] = ACTIONS(566),
    [aux_sym_FLOAT_token3] = ACTIONS(566),
    [aux_sym_FLOAT_token4] = ACTIONS(566),
    [aux_sym_INTEGER_token1] = ACTIONS(566),
    [aux_sym_INTEGER_token2] = ACTIONS(566),
    [aux_sym_INTEGER_token3] = ACTIONS(564),
    [aux_sym_INTEGER_token4] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(566),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(566),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(564),
    [anon_sym_AT] = ACTIONS(566),
  },
  [499] = {
    [ts_builtin_sym_end] = ACTIONS(1281),
    [anon_sym_COMMA] = ACTIONS(1281),
    [anon_sym_pub] = ACTIONS(1283),
    [anon_sym_test] = ACTIONS(1283),
    [anon_sym_comptime] = ACTIONS(1283),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_extern] = ACTIONS(1283),
    [anon_sym_inline] = ACTIONS(1283),
    [anon_sym_noinline] = ACTIONS(1283),
    [anon_sym_threadlocal] = ACTIONS(1283),
    [anon_sym_usingnamespace] = ACTIONS(1283),
    [anon_sym_fn] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_const] = ACTIONS(1283),
    [anon_sym_var] = ACTIONS(1283),
    [anon_sym_else] = ACTIONS(1283),
    [anon_sym_or] = ACTIONS(1283),
    [anon_sym_and] = ACTIONS(1283),
    [anon_sym_LBRACE] = ACTIONS(1281),
    [anon_sym_RBRACE] = ACTIONS(1281),
    [anon_sym_async] = ACTIONS(1283),
    [anon_sym_DOT] = ACTIONS(1283),
    [anon_sym_error] = ACTIONS(1283),
    [anon_sym_false] = ACTIONS(1283),
    [anon_sym_null] = ACTIONS(1283),
    [anon_sym_anyframe] = ACTIONS(1283),
    [anon_sym_true] = ACTIONS(1283),
    [anon_sym_undefined] = ACTIONS(1283),
    [anon_sym_unreachable] = ACTIONS(1283),
    [sym_BuildinTypeExpr] = ACTIONS(1283),
    [anon_sym_packed] = ACTIONS(1283),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_switch] = ACTIONS(1283),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_if] = ACTIONS(1283),
    [anon_sym_while] = ACTIONS(1283),
    [anon_sym_for] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_EQ_EQ] = ACTIONS(1281),
    [anon_sym_BANG_EQ] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(1283),
    [anon_sym_LT_EQ] = ACTIONS(1281),
    [anon_sym_GT_EQ] = ACTIONS(1281),
    [anon_sym_AMP] = ACTIONS(1281),
    [anon_sym_CARET] = ACTIONS(1281),
    [anon_sym_orelse] = ACTIONS(1283),
    [anon_sym_catch] = ACTIONS(1283),
    [anon_sym_LT_LT] = ACTIONS(1283),
    [anon_sym_GT_GT] = ACTIONS(1281),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_PLUS_PLUS] = ACTIONS(1281),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1281),
    [anon_sym_DASH_PERCENT] = ACTIONS(1281),
    [anon_sym_PLUS_PIPE] = ACTIONS(1281),
    [anon_sym_DASH_PIPE] = ACTIONS(1281),
    [anon_sym_PIPE_PIPE] = ACTIONS(1281),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_PERCENT] = ACTIONS(1281),
    [anon_sym_STAR_STAR] = ACTIONS(1281),
    [anon_sym_STAR_PERCENT] = ACTIONS(1281),
    [anon_sym_STAR_PIPE] = ACTIONS(1281),
    [anon_sym_QMARK] = ACTIONS(1281),
    [anon_sym_DOT_STAR] = ACTIONS(1281),
    [anon_sym_DOT_QMARK] = ACTIONS(1281),
    [anon_sym_struct] = ACTIONS(1283),
    [anon_sym_opaque] = ACTIONS(1283),
    [anon_sym_enum] = ACTIONS(1283),
    [anon_sym_union] = ACTIONS(1283),
    [sym_doc_comment] = ACTIONS(1281),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1281),
    [aux_sym_FLOAT_token1] = ACTIONS(1281),
    [aux_sym_FLOAT_token2] = ACTIONS(1281),
    [aux_sym_FLOAT_token3] = ACTIONS(1281),
    [aux_sym_FLOAT_token4] = ACTIONS(1281),
    [aux_sym_INTEGER_token1] = ACTIONS(1281),
    [aux_sym_INTEGER_token2] = ACTIONS(1281),
    [aux_sym_INTEGER_token3] = ACTIONS(1283),
    [aux_sym_INTEGER_token4] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(1281),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1281),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1283),
    [anon_sym_AT] = ACTIONS(1281),
  },
  [500] = {
    [ts_builtin_sym_end] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(574),
    [anon_sym_pub] = ACTIONS(572),
    [anon_sym_test] = ACTIONS(572),
    [anon_sym_comptime] = ACTIONS(572),
    [anon_sym_export] = ACTIONS(572),
    [anon_sym_extern] = ACTIONS(572),
    [anon_sym_inline] = ACTIONS(572),
    [anon_sym_noinline] = ACTIONS(572),
    [anon_sym_threadlocal] = ACTIONS(572),
    [anon_sym_usingnamespace] = ACTIONS(572),
    [anon_sym_fn] = ACTIONS(572),
    [anon_sym_BANG] = ACTIONS(572),
    [anon_sym_const] = ACTIONS(572),
    [anon_sym_var] = ACTIONS(572),
    [anon_sym_else] = ACTIONS(572),
    [anon_sym_or] = ACTIONS(572),
    [anon_sym_and] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(574),
    [anon_sym_RBRACE] = ACTIONS(574),
    [anon_sym_async] = ACTIONS(572),
    [anon_sym_DOT] = ACTIONS(572),
    [anon_sym_error] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_null] = ACTIONS(572),
    [anon_sym_anyframe] = ACTIONS(572),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_undefined] = ACTIONS(572),
    [anon_sym_unreachable] = ACTIONS(572),
    [sym_BuildinTypeExpr] = ACTIONS(572),
    [anon_sym_packed] = ACTIONS(572),
    [anon_sym_LPAREN] = ACTIONS(574),
    [anon_sym_switch] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_if] = ACTIONS(572),
    [anon_sym_while] = ACTIONS(572),
    [anon_sym_for] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_STAR] = ACTIONS(572),
    [anon_sym_EQ_EQ] = ACTIONS(574),
    [anon_sym_BANG_EQ] = ACTIONS(574),
    [anon_sym_LT] = ACTIONS(572),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_LT_EQ] = ACTIONS(574),
    [anon_sym_GT_EQ] = ACTIONS(574),
    [anon_sym_AMP] = ACTIONS(574),
    [anon_sym_CARET] = ACTIONS(574),
    [anon_sym_orelse] = ACTIONS(572),
    [anon_sym_catch] = ACTIONS(572),
    [anon_sym_LT_LT] = ACTIONS(572),
    [anon_sym_GT_GT] = ACTIONS(574),
    [anon_sym_LT_LT_PIPE] = ACTIONS(574),
    [anon_sym_PLUS] = ACTIONS(572),
    [anon_sym_DASH] = ACTIONS(572),
    [anon_sym_PLUS_PLUS] = ACTIONS(574),
    [anon_sym_PLUS_PERCENT] = ACTIONS(574),
    [anon_sym_DASH_PERCENT] = ACTIONS(574),
    [anon_sym_PLUS_PIPE] = ACTIONS(574),
    [anon_sym_DASH_PIPE] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(574),
    [anon_sym_SLASH] = ACTIONS(572),
    [anon_sym_PERCENT] = ACTIONS(574),
    [anon_sym_STAR_STAR] = ACTIONS(574),
    [anon_sym_STAR_PERCENT] = ACTIONS(574),
    [anon_sym_STAR_PIPE] = ACTIONS(574),
    [anon_sym_QMARK] = ACTIONS(574),
    [anon_sym_DOT_STAR] = ACTIONS(574),
    [anon_sym_DOT_QMARK] = ACTIONS(574),
    [anon_sym_struct] = ACTIONS(572),
    [anon_sym_opaque] = ACTIONS(572),
    [anon_sym_enum] = ACTIONS(572),
    [anon_sym_union] = ACTIONS(572),
    [sym_doc_comment] = ACTIONS(574),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(574),
    [aux_sym_FLOAT_token1] = ACTIONS(574),
    [aux_sym_FLOAT_token2] = ACTIONS(574),
    [aux_sym_FLOAT_token3] = ACTIONS(574),
    [aux_sym_FLOAT_token4] = ACTIONS(574),
    [aux_sym_INTEGER_token1] = ACTIONS(574),
    [aux_sym_INTEGER_token2] = ACTIONS(574),
    [aux_sym_INTEGER_token3] = ACTIONS(572),
    [aux_sym_INTEGER_token4] = ACTIONS(572),
    [anon_sym_DQUOTE] = ACTIONS(574),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(574),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(572),
    [anon_sym_AT] = ACTIONS(574),
  },
  [501] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1285),
    [anon_sym_COMMA] = ACTIONS(1285),
    [anon_sym_pub] = ACTIONS(1287),
    [anon_sym_test] = ACTIONS(1287),
    [anon_sym_comptime] = ACTIONS(1287),
    [anon_sym_export] = ACTIONS(1287),
    [anon_sym_extern] = ACTIONS(1287),
    [anon_sym_inline] = ACTIONS(1287),
    [anon_sym_noinline] = ACTIONS(1287),
    [anon_sym_threadlocal] = ACTIONS(1287),
    [anon_sym_usingnamespace] = ACTIONS(1287),
    [anon_sym_fn] = ACTIONS(1287),
    [anon_sym_const] = ACTIONS(1287),
    [anon_sym_var] = ACTIONS(1287),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1285),
    [anon_sym_async] = ACTIONS(1287),
    [anon_sym_DOT] = ACTIONS(1285),
    [anon_sym_error] = ACTIONS(1287),
    [anon_sym_false] = ACTIONS(1287),
    [anon_sym_null] = ACTIONS(1287),
    [anon_sym_anyframe] = ACTIONS(1287),
    [anon_sym_true] = ACTIONS(1287),
    [anon_sym_undefined] = ACTIONS(1287),
    [anon_sym_unreachable] = ACTIONS(1287),
    [sym_BuildinTypeExpr] = ACTIONS(1287),
    [anon_sym_packed] = ACTIONS(1287),
    [anon_sym_LPAREN] = ACTIONS(1285),
    [anon_sym_switch] = ACTIONS(1287),
    [anon_sym_LBRACK] = ACTIONS(1285),
    [anon_sym_if] = ACTIONS(1287),
    [anon_sym_while] = ACTIONS(1287),
    [anon_sym_for] = ACTIONS(1287),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1285),
    [anon_sym_struct] = ACTIONS(1287),
    [anon_sym_opaque] = ACTIONS(1287),
    [anon_sym_enum] = ACTIONS(1287),
    [anon_sym_union] = ACTIONS(1287),
    [sym_doc_comment] = ACTIONS(1285),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1285),
    [aux_sym_FLOAT_token1] = ACTIONS(1285),
    [aux_sym_FLOAT_token2] = ACTIONS(1285),
    [aux_sym_FLOAT_token3] = ACTIONS(1285),
    [aux_sym_FLOAT_token4] = ACTIONS(1285),
    [aux_sym_INTEGER_token1] = ACTIONS(1285),
    [aux_sym_INTEGER_token2] = ACTIONS(1285),
    [aux_sym_INTEGER_token3] = ACTIONS(1287),
    [aux_sym_INTEGER_token4] = ACTIONS(1287),
    [anon_sym_DQUOTE] = ACTIONS(1285),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1285),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1287),
    [anon_sym_AT] = ACTIONS(1285),
  },
  [502] = {
    [ts_builtin_sym_end] = ACTIONS(1289),
    [anon_sym_COMMA] = ACTIONS(1289),
    [anon_sym_pub] = ACTIONS(1291),
    [anon_sym_test] = ACTIONS(1291),
    [anon_sym_comptime] = ACTIONS(1291),
    [anon_sym_export] = ACTIONS(1291),
    [anon_sym_extern] = ACTIONS(1291),
    [anon_sym_inline] = ACTIONS(1291),
    [anon_sym_noinline] = ACTIONS(1291),
    [anon_sym_threadlocal] = ACTIONS(1291),
    [anon_sym_usingnamespace] = ACTIONS(1291),
    [anon_sym_fn] = ACTIONS(1291),
    [anon_sym_BANG] = ACTIONS(1291),
    [anon_sym_const] = ACTIONS(1291),
    [anon_sym_var] = ACTIONS(1291),
    [anon_sym_else] = ACTIONS(1291),
    [anon_sym_or] = ACTIONS(1291),
    [anon_sym_and] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1289),
    [anon_sym_RBRACE] = ACTIONS(1289),
    [anon_sym_async] = ACTIONS(1291),
    [anon_sym_DOT] = ACTIONS(1291),
    [anon_sym_error] = ACTIONS(1291),
    [anon_sym_false] = ACTIONS(1291),
    [anon_sym_null] = ACTIONS(1291),
    [anon_sym_anyframe] = ACTIONS(1291),
    [anon_sym_true] = ACTIONS(1291),
    [anon_sym_undefined] = ACTIONS(1291),
    [anon_sym_unreachable] = ACTIONS(1291),
    [sym_BuildinTypeExpr] = ACTIONS(1291),
    [anon_sym_packed] = ACTIONS(1291),
    [anon_sym_LPAREN] = ACTIONS(1289),
    [anon_sym_switch] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1291),
    [anon_sym_while] = ACTIONS(1291),
    [anon_sym_for] = ACTIONS(1291),
    [anon_sym_PIPE] = ACTIONS(1291),
    [anon_sym_STAR] = ACTIONS(1291),
    [anon_sym_EQ_EQ] = ACTIONS(1289),
    [anon_sym_BANG_EQ] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1291),
    [anon_sym_GT] = ACTIONS(1291),
    [anon_sym_LT_EQ] = ACTIONS(1289),
    [anon_sym_GT_EQ] = ACTIONS(1289),
    [anon_sym_AMP] = ACTIONS(1289),
    [anon_sym_CARET] = ACTIONS(1289),
    [anon_sym_orelse] = ACTIONS(1291),
    [anon_sym_catch] = ACTIONS(1291),
    [anon_sym_LT_LT] = ACTIONS(1291),
    [anon_sym_GT_GT] = ACTIONS(1289),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_DASH] = ACTIONS(1291),
    [anon_sym_PLUS_PLUS] = ACTIONS(1289),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1289),
    [anon_sym_DASH_PERCENT] = ACTIONS(1289),
    [anon_sym_PLUS_PIPE] = ACTIONS(1289),
    [anon_sym_DASH_PIPE] = ACTIONS(1289),
    [anon_sym_PIPE_PIPE] = ACTIONS(1289),
    [anon_sym_SLASH] = ACTIONS(1291),
    [anon_sym_PERCENT] = ACTIONS(1289),
    [anon_sym_STAR_STAR] = ACTIONS(1289),
    [anon_sym_STAR_PERCENT] = ACTIONS(1289),
    [anon_sym_STAR_PIPE] = ACTIONS(1289),
    [anon_sym_QMARK] = ACTIONS(1289),
    [anon_sym_DOT_STAR] = ACTIONS(1289),
    [anon_sym_DOT_QMARK] = ACTIONS(1289),
    [anon_sym_struct] = ACTIONS(1291),
    [anon_sym_opaque] = ACTIONS(1291),
    [anon_sym_enum] = ACTIONS(1291),
    [anon_sym_union] = ACTIONS(1291),
    [sym_doc_comment] = ACTIONS(1289),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [aux_sym_FLOAT_token1] = ACTIONS(1289),
    [aux_sym_FLOAT_token2] = ACTIONS(1289),
    [aux_sym_FLOAT_token3] = ACTIONS(1289),
    [aux_sym_FLOAT_token4] = ACTIONS(1289),
    [aux_sym_INTEGER_token1] = ACTIONS(1289),
    [aux_sym_INTEGER_token2] = ACTIONS(1289),
    [aux_sym_INTEGER_token3] = ACTIONS(1291),
    [aux_sym_INTEGER_token4] = ACTIONS(1291),
    [anon_sym_DQUOTE] = ACTIONS(1289),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1289),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1291),
    [anon_sym_AT] = ACTIONS(1289),
  },
  [503] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1293),
    [anon_sym_COMMA] = ACTIONS(1293),
    [anon_sym_pub] = ACTIONS(1295),
    [anon_sym_test] = ACTIONS(1295),
    [anon_sym_comptime] = ACTIONS(1295),
    [anon_sym_export] = ACTIONS(1295),
    [anon_sym_extern] = ACTIONS(1295),
    [anon_sym_inline] = ACTIONS(1295),
    [anon_sym_noinline] = ACTIONS(1295),
    [anon_sym_threadlocal] = ACTIONS(1295),
    [anon_sym_usingnamespace] = ACTIONS(1295),
    [anon_sym_fn] = ACTIONS(1295),
    [anon_sym_const] = ACTIONS(1295),
    [anon_sym_var] = ACTIONS(1295),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_DOT] = ACTIONS(1293),
    [anon_sym_error] = ACTIONS(1295),
    [anon_sym_false] = ACTIONS(1295),
    [anon_sym_null] = ACTIONS(1295),
    [anon_sym_anyframe] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1295),
    [anon_sym_undefined] = ACTIONS(1295),
    [anon_sym_unreachable] = ACTIONS(1295),
    [sym_BuildinTypeExpr] = ACTIONS(1295),
    [anon_sym_packed] = ACTIONS(1295),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_switch] = ACTIONS(1295),
    [anon_sym_LBRACK] = ACTIONS(1293),
    [anon_sym_if] = ACTIONS(1295),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_for] = ACTIONS(1295),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1293),
    [anon_sym_struct] = ACTIONS(1295),
    [anon_sym_opaque] = ACTIONS(1295),
    [anon_sym_enum] = ACTIONS(1295),
    [anon_sym_union] = ACTIONS(1295),
    [sym_doc_comment] = ACTIONS(1293),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [aux_sym_FLOAT_token1] = ACTIONS(1293),
    [aux_sym_FLOAT_token2] = ACTIONS(1293),
    [aux_sym_FLOAT_token3] = ACTIONS(1293),
    [aux_sym_FLOAT_token4] = ACTIONS(1293),
    [aux_sym_INTEGER_token1] = ACTIONS(1293),
    [aux_sym_INTEGER_token2] = ACTIONS(1293),
    [aux_sym_INTEGER_token3] = ACTIONS(1295),
    [aux_sym_INTEGER_token4] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(1293),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1293),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1295),
    [anon_sym_AT] = ACTIONS(1293),
  },
  [504] = {
    [ts_builtin_sym_end] = ACTIONS(1297),
    [anon_sym_COMMA] = ACTIONS(1297),
    [anon_sym_pub] = ACTIONS(1299),
    [anon_sym_test] = ACTIONS(1299),
    [anon_sym_comptime] = ACTIONS(1299),
    [anon_sym_export] = ACTIONS(1299),
    [anon_sym_extern] = ACTIONS(1299),
    [anon_sym_inline] = ACTIONS(1299),
    [anon_sym_noinline] = ACTIONS(1299),
    [anon_sym_threadlocal] = ACTIONS(1299),
    [anon_sym_usingnamespace] = ACTIONS(1299),
    [anon_sym_fn] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_const] = ACTIONS(1299),
    [anon_sym_var] = ACTIONS(1299),
    [anon_sym_else] = ACTIONS(1299),
    [anon_sym_or] = ACTIONS(1299),
    [anon_sym_and] = ACTIONS(1299),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_RBRACE] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1299),
    [anon_sym_error] = ACTIONS(1299),
    [anon_sym_false] = ACTIONS(1299),
    [anon_sym_null] = ACTIONS(1299),
    [anon_sym_anyframe] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(1299),
    [anon_sym_undefined] = ACTIONS(1299),
    [anon_sym_unreachable] = ACTIONS(1299),
    [sym_BuildinTypeExpr] = ACTIONS(1299),
    [anon_sym_packed] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1297),
    [anon_sym_switch] = ACTIONS(1299),
    [anon_sym_LBRACK] = ACTIONS(1297),
    [anon_sym_if] = ACTIONS(1299),
    [anon_sym_while] = ACTIONS(1299),
    [anon_sym_for] = ACTIONS(1299),
    [anon_sym_PIPE] = ACTIONS(1299),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_EQ_EQ] = ACTIONS(1297),
    [anon_sym_BANG_EQ] = ACTIONS(1297),
    [anon_sym_LT] = ACTIONS(1299),
    [anon_sym_GT] = ACTIONS(1299),
    [anon_sym_LT_EQ] = ACTIONS(1297),
    [anon_sym_GT_EQ] = ACTIONS(1297),
    [anon_sym_AMP] = ACTIONS(1297),
    [anon_sym_CARET] = ACTIONS(1297),
    [anon_sym_orelse] = ACTIONS(1299),
    [anon_sym_catch] = ACTIONS(1299),
    [anon_sym_LT_LT] = ACTIONS(1299),
    [anon_sym_GT_GT] = ACTIONS(1297),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1297),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1297),
    [anon_sym_DASH_PERCENT] = ACTIONS(1297),
    [anon_sym_PLUS_PIPE] = ACTIONS(1297),
    [anon_sym_DASH_PIPE] = ACTIONS(1297),
    [anon_sym_PIPE_PIPE] = ACTIONS(1297),
    [anon_sym_SLASH] = ACTIONS(1299),
    [anon_sym_PERCENT] = ACTIONS(1297),
    [anon_sym_STAR_STAR] = ACTIONS(1297),
    [anon_sym_STAR_PERCENT] = ACTIONS(1297),
    [anon_sym_STAR_PIPE] = ACTIONS(1297),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_DOT_STAR] = ACTIONS(1297),
    [anon_sym_DOT_QMARK] = ACTIONS(1297),
    [anon_sym_struct] = ACTIONS(1299),
    [anon_sym_opaque] = ACTIONS(1299),
    [anon_sym_enum] = ACTIONS(1299),
    [anon_sym_union] = ACTIONS(1299),
    [sym_doc_comment] = ACTIONS(1297),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1297),
    [aux_sym_FLOAT_token1] = ACTIONS(1297),
    [aux_sym_FLOAT_token2] = ACTIONS(1297),
    [aux_sym_FLOAT_token3] = ACTIONS(1297),
    [aux_sym_FLOAT_token4] = ACTIONS(1297),
    [aux_sym_INTEGER_token1] = ACTIONS(1297),
    [aux_sym_INTEGER_token2] = ACTIONS(1297),
    [aux_sym_INTEGER_token3] = ACTIONS(1299),
    [aux_sym_INTEGER_token4] = ACTIONS(1299),
    [anon_sym_DQUOTE] = ACTIONS(1297),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1297),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1297),
  },
  [505] = {
    [ts_builtin_sym_end] = ACTIONS(542),
    [anon_sym_COMMA] = ACTIONS(542),
    [anon_sym_pub] = ACTIONS(540),
    [anon_sym_test] = ACTIONS(540),
    [anon_sym_comptime] = ACTIONS(540),
    [anon_sym_export] = ACTIONS(540),
    [anon_sym_extern] = ACTIONS(540),
    [anon_sym_inline] = ACTIONS(540),
    [anon_sym_noinline] = ACTIONS(540),
    [anon_sym_threadlocal] = ACTIONS(540),
    [anon_sym_usingnamespace] = ACTIONS(540),
    [anon_sym_fn] = ACTIONS(540),
    [anon_sym_BANG] = ACTIONS(540),
    [anon_sym_const] = ACTIONS(540),
    [anon_sym_var] = ACTIONS(540),
    [anon_sym_else] = ACTIONS(540),
    [anon_sym_or] = ACTIONS(540),
    [anon_sym_and] = ACTIONS(540),
    [anon_sym_LBRACE] = ACTIONS(542),
    [anon_sym_RBRACE] = ACTIONS(542),
    [anon_sym_async] = ACTIONS(540),
    [anon_sym_DOT] = ACTIONS(540),
    [anon_sym_error] = ACTIONS(540),
    [anon_sym_false] = ACTIONS(540),
    [anon_sym_null] = ACTIONS(540),
    [anon_sym_anyframe] = ACTIONS(540),
    [anon_sym_true] = ACTIONS(540),
    [anon_sym_undefined] = ACTIONS(540),
    [anon_sym_unreachable] = ACTIONS(540),
    [sym_BuildinTypeExpr] = ACTIONS(540),
    [anon_sym_packed] = ACTIONS(540),
    [anon_sym_LPAREN] = ACTIONS(542),
    [anon_sym_switch] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(542),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_while] = ACTIONS(540),
    [anon_sym_for] = ACTIONS(540),
    [anon_sym_PIPE] = ACTIONS(540),
    [anon_sym_STAR] = ACTIONS(540),
    [anon_sym_EQ_EQ] = ACTIONS(542),
    [anon_sym_BANG_EQ] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(540),
    [anon_sym_GT] = ACTIONS(540),
    [anon_sym_LT_EQ] = ACTIONS(542),
    [anon_sym_GT_EQ] = ACTIONS(542),
    [anon_sym_AMP] = ACTIONS(542),
    [anon_sym_CARET] = ACTIONS(542),
    [anon_sym_orelse] = ACTIONS(540),
    [anon_sym_catch] = ACTIONS(540),
    [anon_sym_LT_LT] = ACTIONS(540),
    [anon_sym_GT_GT] = ACTIONS(542),
    [anon_sym_LT_LT_PIPE] = ACTIONS(542),
    [anon_sym_PLUS] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(540),
    [anon_sym_PLUS_PLUS] = ACTIONS(542),
    [anon_sym_PLUS_PERCENT] = ACTIONS(542),
    [anon_sym_DASH_PERCENT] = ACTIONS(542),
    [anon_sym_PLUS_PIPE] = ACTIONS(542),
    [anon_sym_DASH_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_PIPE] = ACTIONS(542),
    [anon_sym_SLASH] = ACTIONS(540),
    [anon_sym_PERCENT] = ACTIONS(542),
    [anon_sym_STAR_STAR] = ACTIONS(542),
    [anon_sym_STAR_PERCENT] = ACTIONS(542),
    [anon_sym_STAR_PIPE] = ACTIONS(542),
    [anon_sym_QMARK] = ACTIONS(542),
    [anon_sym_DOT_STAR] = ACTIONS(542),
    [anon_sym_DOT_QMARK] = ACTIONS(542),
    [anon_sym_struct] = ACTIONS(540),
    [anon_sym_opaque] = ACTIONS(540),
    [anon_sym_enum] = ACTIONS(540),
    [anon_sym_union] = ACTIONS(540),
    [sym_doc_comment] = ACTIONS(542),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(542),
    [aux_sym_FLOAT_token1] = ACTIONS(542),
    [aux_sym_FLOAT_token2] = ACTIONS(542),
    [aux_sym_FLOAT_token3] = ACTIONS(542),
    [aux_sym_FLOAT_token4] = ACTIONS(542),
    [aux_sym_INTEGER_token1] = ACTIONS(542),
    [aux_sym_INTEGER_token2] = ACTIONS(542),
    [aux_sym_INTEGER_token3] = ACTIONS(540),
    [aux_sym_INTEGER_token4] = ACTIONS(540),
    [anon_sym_DQUOTE] = ACTIONS(542),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(542),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(540),
    [anon_sym_AT] = ACTIONS(542),
  },
  [506] = {
    [ts_builtin_sym_end] = ACTIONS(1301),
    [anon_sym_COMMA] = ACTIONS(1301),
    [anon_sym_pub] = ACTIONS(1303),
    [anon_sym_test] = ACTIONS(1303),
    [anon_sym_comptime] = ACTIONS(1303),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_extern] = ACTIONS(1303),
    [anon_sym_inline] = ACTIONS(1303),
    [anon_sym_noinline] = ACTIONS(1303),
    [anon_sym_threadlocal] = ACTIONS(1303),
    [anon_sym_usingnamespace] = ACTIONS(1303),
    [anon_sym_fn] = ACTIONS(1303),
    [anon_sym_BANG] = ACTIONS(1303),
    [anon_sym_const] = ACTIONS(1303),
    [anon_sym_var] = ACTIONS(1303),
    [anon_sym_else] = ACTIONS(1303),
    [anon_sym_or] = ACTIONS(1303),
    [anon_sym_and] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(1301),
    [anon_sym_RBRACE] = ACTIONS(1301),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_DOT] = ACTIONS(1303),
    [anon_sym_error] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [anon_sym_null] = ACTIONS(1303),
    [anon_sym_anyframe] = ACTIONS(1303),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_undefined] = ACTIONS(1303),
    [anon_sym_unreachable] = ACTIONS(1303),
    [sym_BuildinTypeExpr] = ACTIONS(1303),
    [anon_sym_packed] = ACTIONS(1303),
    [anon_sym_LPAREN] = ACTIONS(1301),
    [anon_sym_switch] = ACTIONS(1303),
    [anon_sym_LBRACK] = ACTIONS(1301),
    [anon_sym_if] = ACTIONS(1303),
    [anon_sym_while] = ACTIONS(1303),
    [anon_sym_for] = ACTIONS(1303),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_EQ_EQ] = ACTIONS(1301),
    [anon_sym_BANG_EQ] = ACTIONS(1301),
    [anon_sym_LT] = ACTIONS(1303),
    [anon_sym_GT] = ACTIONS(1303),
    [anon_sym_LT_EQ] = ACTIONS(1301),
    [anon_sym_GT_EQ] = ACTIONS(1301),
    [anon_sym_AMP] = ACTIONS(1301),
    [anon_sym_CARET] = ACTIONS(1301),
    [anon_sym_orelse] = ACTIONS(1303),
    [anon_sym_catch] = ACTIONS(1303),
    [anon_sym_LT_LT] = ACTIONS(1303),
    [anon_sym_GT_GT] = ACTIONS(1301),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1301),
    [anon_sym_PLUS] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1303),
    [anon_sym_PLUS_PLUS] = ACTIONS(1301),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1301),
    [anon_sym_DASH_PERCENT] = ACTIONS(1301),
    [anon_sym_PLUS_PIPE] = ACTIONS(1301),
    [anon_sym_DASH_PIPE] = ACTIONS(1301),
    [anon_sym_PIPE_PIPE] = ACTIONS(1301),
    [anon_sym_SLASH] = ACTIONS(1303),
    [anon_sym_PERCENT] = ACTIONS(1301),
    [anon_sym_STAR_STAR] = ACTIONS(1301),
    [anon_sym_STAR_PERCENT] = ACTIONS(1301),
    [anon_sym_STAR_PIPE] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1301),
    [anon_sym_DOT_STAR] = ACTIONS(1301),
    [anon_sym_DOT_QMARK] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(1303),
    [anon_sym_opaque] = ACTIONS(1303),
    [anon_sym_enum] = ACTIONS(1303),
    [anon_sym_union] = ACTIONS(1303),
    [sym_doc_comment] = ACTIONS(1301),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1301),
    [aux_sym_FLOAT_token1] = ACTIONS(1301),
    [aux_sym_FLOAT_token2] = ACTIONS(1301),
    [aux_sym_FLOAT_token3] = ACTIONS(1301),
    [aux_sym_FLOAT_token4] = ACTIONS(1301),
    [aux_sym_INTEGER_token1] = ACTIONS(1301),
    [aux_sym_INTEGER_token2] = ACTIONS(1301),
    [aux_sym_INTEGER_token3] = ACTIONS(1303),
    [aux_sym_INTEGER_token4] = ACTIONS(1303),
    [anon_sym_DQUOTE] = ACTIONS(1301),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1301),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1303),
    [anon_sym_AT] = ACTIONS(1301),
  },
  [507] = {
    [ts_builtin_sym_end] = ACTIONS(1305),
    [anon_sym_COMMA] = ACTIONS(1305),
    [anon_sym_pub] = ACTIONS(1307),
    [anon_sym_test] = ACTIONS(1307),
    [anon_sym_comptime] = ACTIONS(1307),
    [anon_sym_export] = ACTIONS(1307),
    [anon_sym_extern] = ACTIONS(1307),
    [anon_sym_inline] = ACTIONS(1307),
    [anon_sym_noinline] = ACTIONS(1307),
    [anon_sym_threadlocal] = ACTIONS(1307),
    [anon_sym_usingnamespace] = ACTIONS(1307),
    [anon_sym_fn] = ACTIONS(1307),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_const] = ACTIONS(1307),
    [anon_sym_var] = ACTIONS(1307),
    [anon_sym_else] = ACTIONS(1307),
    [anon_sym_or] = ACTIONS(1307),
    [anon_sym_and] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1305),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_async] = ACTIONS(1307),
    [anon_sym_DOT] = ACTIONS(1307),
    [anon_sym_error] = ACTIONS(1307),
    [anon_sym_false] = ACTIONS(1307),
    [anon_sym_null] = ACTIONS(1307),
    [anon_sym_anyframe] = ACTIONS(1307),
    [anon_sym_true] = ACTIONS(1307),
    [anon_sym_undefined] = ACTIONS(1307),
    [anon_sym_unreachable] = ACTIONS(1307),
    [sym_BuildinTypeExpr] = ACTIONS(1307),
    [anon_sym_packed] = ACTIONS(1307),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [anon_sym_switch] = ACTIONS(1307),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [anon_sym_if] = ACTIONS(1307),
    [anon_sym_while] = ACTIONS(1307),
    [anon_sym_for] = ACTIONS(1307),
    [anon_sym_PIPE] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(1307),
    [anon_sym_EQ_EQ] = ACTIONS(1305),
    [anon_sym_BANG_EQ] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1307),
    [anon_sym_GT] = ACTIONS(1307),
    [anon_sym_LT_EQ] = ACTIONS(1305),
    [anon_sym_GT_EQ] = ACTIONS(1305),
    [anon_sym_AMP] = ACTIONS(1305),
    [anon_sym_CARET] = ACTIONS(1305),
    [anon_sym_orelse] = ACTIONS(1307),
    [anon_sym_catch] = ACTIONS(1307),
    [anon_sym_LT_LT] = ACTIONS(1307),
    [anon_sym_GT_GT] = ACTIONS(1305),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1305),
    [anon_sym_PLUS] = ACTIONS(1307),
    [anon_sym_DASH] = ACTIONS(1307),
    [anon_sym_PLUS_PLUS] = ACTIONS(1305),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1305),
    [anon_sym_DASH_PERCENT] = ACTIONS(1305),
    [anon_sym_PLUS_PIPE] = ACTIONS(1305),
    [anon_sym_DASH_PIPE] = ACTIONS(1305),
    [anon_sym_PIPE_PIPE] = ACTIONS(1305),
    [anon_sym_SLASH] = ACTIONS(1307),
    [anon_sym_PERCENT] = ACTIONS(1305),
    [anon_sym_STAR_STAR] = ACTIONS(1305),
    [anon_sym_STAR_PERCENT] = ACTIONS(1305),
    [anon_sym_STAR_PIPE] = ACTIONS(1305),
    [anon_sym_QMARK] = ACTIONS(1305),
    [anon_sym_DOT_STAR] = ACTIONS(1305),
    [anon_sym_DOT_QMARK] = ACTIONS(1305),
    [anon_sym_struct] = ACTIONS(1307),
    [anon_sym_opaque] = ACTIONS(1307),
    [anon_sym_enum] = ACTIONS(1307),
    [anon_sym_union] = ACTIONS(1307),
    [sym_doc_comment] = ACTIONS(1305),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [aux_sym_FLOAT_token1] = ACTIONS(1305),
    [aux_sym_FLOAT_token2] = ACTIONS(1305),
    [aux_sym_FLOAT_token3] = ACTIONS(1305),
    [aux_sym_FLOAT_token4] = ACTIONS(1305),
    [aux_sym_INTEGER_token1] = ACTIONS(1305),
    [aux_sym_INTEGER_token2] = ACTIONS(1305),
    [aux_sym_INTEGER_token3] = ACTIONS(1307),
    [aux_sym_INTEGER_token4] = ACTIONS(1307),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1305),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1307),
    [anon_sym_AT] = ACTIONS(1305),
  },
  [508] = {
    [ts_builtin_sym_end] = ACTIONS(1309),
    [anon_sym_COMMA] = ACTIONS(1309),
    [anon_sym_pub] = ACTIONS(1311),
    [anon_sym_test] = ACTIONS(1311),
    [anon_sym_comptime] = ACTIONS(1311),
    [anon_sym_export] = ACTIONS(1311),
    [anon_sym_extern] = ACTIONS(1311),
    [anon_sym_inline] = ACTIONS(1311),
    [anon_sym_noinline] = ACTIONS(1311),
    [anon_sym_threadlocal] = ACTIONS(1311),
    [anon_sym_usingnamespace] = ACTIONS(1311),
    [anon_sym_fn] = ACTIONS(1311),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_const] = ACTIONS(1311),
    [anon_sym_var] = ACTIONS(1311),
    [anon_sym_else] = ACTIONS(1311),
    [anon_sym_or] = ACTIONS(1311),
    [anon_sym_and] = ACTIONS(1311),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_RBRACE] = ACTIONS(1309),
    [anon_sym_async] = ACTIONS(1311),
    [anon_sym_DOT] = ACTIONS(1311),
    [anon_sym_error] = ACTIONS(1311),
    [anon_sym_false] = ACTIONS(1311),
    [anon_sym_null] = ACTIONS(1311),
    [anon_sym_anyframe] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1311),
    [anon_sym_undefined] = ACTIONS(1311),
    [anon_sym_unreachable] = ACTIONS(1311),
    [sym_BuildinTypeExpr] = ACTIONS(1311),
    [anon_sym_packed] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1309),
    [anon_sym_switch] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1309),
    [anon_sym_if] = ACTIONS(1311),
    [anon_sym_while] = ACTIONS(1311),
    [anon_sym_for] = ACTIONS(1311),
    [anon_sym_PIPE] = ACTIONS(1311),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_EQ_EQ] = ACTIONS(1309),
    [anon_sym_BANG_EQ] = ACTIONS(1309),
    [anon_sym_LT] = ACTIONS(1311),
    [anon_sym_GT] = ACTIONS(1311),
    [anon_sym_LT_EQ] = ACTIONS(1309),
    [anon_sym_GT_EQ] = ACTIONS(1309),
    [anon_sym_AMP] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1309),
    [anon_sym_orelse] = ACTIONS(1311),
    [anon_sym_catch] = ACTIONS(1311),
    [anon_sym_LT_LT] = ACTIONS(1311),
    [anon_sym_GT_GT] = ACTIONS(1309),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1309),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS_PLUS] = ACTIONS(1309),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1309),
    [anon_sym_DASH_PERCENT] = ACTIONS(1309),
    [anon_sym_PLUS_PIPE] = ACTIONS(1309),
    [anon_sym_DASH_PIPE] = ACTIONS(1309),
    [anon_sym_PIPE_PIPE] = ACTIONS(1309),
    [anon_sym_SLASH] = ACTIONS(1311),
    [anon_sym_PERCENT] = ACTIONS(1309),
    [anon_sym_STAR_STAR] = ACTIONS(1309),
    [anon_sym_STAR_PERCENT] = ACTIONS(1309),
    [anon_sym_STAR_PIPE] = ACTIONS(1309),
    [anon_sym_QMARK] = ACTIONS(1309),
    [anon_sym_DOT_STAR] = ACTIONS(1309),
    [anon_sym_DOT_QMARK] = ACTIONS(1309),
    [anon_sym_struct] = ACTIONS(1311),
    [anon_sym_opaque] = ACTIONS(1311),
    [anon_sym_enum] = ACTIONS(1311),
    [anon_sym_union] = ACTIONS(1311),
    [sym_doc_comment] = ACTIONS(1309),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1309),
    [aux_sym_FLOAT_token1] = ACTIONS(1309),
    [aux_sym_FLOAT_token2] = ACTIONS(1309),
    [aux_sym_FLOAT_token3] = ACTIONS(1309),
    [aux_sym_FLOAT_token4] = ACTIONS(1309),
    [aux_sym_INTEGER_token1] = ACTIONS(1309),
    [aux_sym_INTEGER_token2] = ACTIONS(1309),
    [aux_sym_INTEGER_token3] = ACTIONS(1311),
    [aux_sym_INTEGER_token4] = ACTIONS(1311),
    [anon_sym_DQUOTE] = ACTIONS(1309),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1309),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1311),
    [anon_sym_AT] = ACTIONS(1309),
  },
  [509] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1313),
    [anon_sym_COMMA] = ACTIONS(1313),
    [anon_sym_pub] = ACTIONS(1315),
    [anon_sym_test] = ACTIONS(1315),
    [anon_sym_comptime] = ACTIONS(1315),
    [anon_sym_export] = ACTIONS(1315),
    [anon_sym_extern] = ACTIONS(1315),
    [anon_sym_inline] = ACTIONS(1315),
    [anon_sym_noinline] = ACTIONS(1315),
    [anon_sym_threadlocal] = ACTIONS(1315),
    [anon_sym_usingnamespace] = ACTIONS(1315),
    [anon_sym_fn] = ACTIONS(1315),
    [anon_sym_const] = ACTIONS(1315),
    [anon_sym_var] = ACTIONS(1315),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_DOT] = ACTIONS(1313),
    [anon_sym_error] = ACTIONS(1315),
    [anon_sym_false] = ACTIONS(1315),
    [anon_sym_null] = ACTIONS(1315),
    [anon_sym_anyframe] = ACTIONS(1315),
    [anon_sym_true] = ACTIONS(1315),
    [anon_sym_undefined] = ACTIONS(1315),
    [anon_sym_unreachable] = ACTIONS(1315),
    [sym_BuildinTypeExpr] = ACTIONS(1315),
    [anon_sym_packed] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_switch] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_while] = ACTIONS(1315),
    [anon_sym_for] = ACTIONS(1315),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1313),
    [anon_sym_struct] = ACTIONS(1315),
    [anon_sym_opaque] = ACTIONS(1315),
    [anon_sym_enum] = ACTIONS(1315),
    [anon_sym_union] = ACTIONS(1315),
    [sym_doc_comment] = ACTIONS(1313),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1313),
    [aux_sym_FLOAT_token1] = ACTIONS(1313),
    [aux_sym_FLOAT_token2] = ACTIONS(1313),
    [aux_sym_FLOAT_token3] = ACTIONS(1313),
    [aux_sym_FLOAT_token4] = ACTIONS(1313),
    [aux_sym_INTEGER_token1] = ACTIONS(1313),
    [aux_sym_INTEGER_token2] = ACTIONS(1313),
    [aux_sym_INTEGER_token3] = ACTIONS(1315),
    [aux_sym_INTEGER_token4] = ACTIONS(1315),
    [anon_sym_DQUOTE] = ACTIONS(1313),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1313),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1315),
    [anon_sym_AT] = ACTIONS(1313),
  },
  [510] = {
    [ts_builtin_sym_end] = ACTIONS(1317),
    [anon_sym_COMMA] = ACTIONS(1317),
    [anon_sym_pub] = ACTIONS(1319),
    [anon_sym_test] = ACTIONS(1319),
    [anon_sym_comptime] = ACTIONS(1319),
    [anon_sym_export] = ACTIONS(1319),
    [anon_sym_extern] = ACTIONS(1319),
    [anon_sym_inline] = ACTIONS(1319),
    [anon_sym_noinline] = ACTIONS(1319),
    [anon_sym_threadlocal] = ACTIONS(1319),
    [anon_sym_usingnamespace] = ACTIONS(1319),
    [anon_sym_fn] = ACTIONS(1319),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_const] = ACTIONS(1319),
    [anon_sym_var] = ACTIONS(1319),
    [anon_sym_else] = ACTIONS(1319),
    [anon_sym_or] = ACTIONS(1319),
    [anon_sym_and] = ACTIONS(1319),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_RBRACE] = ACTIONS(1317),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_DOT] = ACTIONS(1319),
    [anon_sym_error] = ACTIONS(1319),
    [anon_sym_false] = ACTIONS(1319),
    [anon_sym_null] = ACTIONS(1319),
    [anon_sym_anyframe] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(1319),
    [anon_sym_undefined] = ACTIONS(1319),
    [anon_sym_unreachable] = ACTIONS(1319),
    [sym_BuildinTypeExpr] = ACTIONS(1319),
    [anon_sym_packed] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_switch] = ACTIONS(1319),
    [anon_sym_LBRACK] = ACTIONS(1317),
    [anon_sym_if] = ACTIONS(1319),
    [anon_sym_while] = ACTIONS(1319),
    [anon_sym_for] = ACTIONS(1319),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_EQ_EQ] = ACTIONS(1317),
    [anon_sym_BANG_EQ] = ACTIONS(1317),
    [anon_sym_LT] = ACTIONS(1319),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_LT_EQ] = ACTIONS(1317),
    [anon_sym_GT_EQ] = ACTIONS(1317),
    [anon_sym_AMP] = ACTIONS(1317),
    [anon_sym_CARET] = ACTIONS(1317),
    [anon_sym_orelse] = ACTIONS(1319),
    [anon_sym_catch] = ACTIONS(1319),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_GT_GT] = ACTIONS(1317),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1317),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1317),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1317),
    [anon_sym_DASH_PERCENT] = ACTIONS(1317),
    [anon_sym_PLUS_PIPE] = ACTIONS(1317),
    [anon_sym_DASH_PIPE] = ACTIONS(1317),
    [anon_sym_PIPE_PIPE] = ACTIONS(1317),
    [anon_sym_SLASH] = ACTIONS(1319),
    [anon_sym_PERCENT] = ACTIONS(1317),
    [anon_sym_STAR_STAR] = ACTIONS(1317),
    [anon_sym_STAR_PERCENT] = ACTIONS(1317),
    [anon_sym_STAR_PIPE] = ACTIONS(1317),
    [anon_sym_QMARK] = ACTIONS(1317),
    [anon_sym_DOT_STAR] = ACTIONS(1317),
    [anon_sym_DOT_QMARK] = ACTIONS(1317),
    [anon_sym_struct] = ACTIONS(1319),
    [anon_sym_opaque] = ACTIONS(1319),
    [anon_sym_enum] = ACTIONS(1319),
    [anon_sym_union] = ACTIONS(1319),
    [sym_doc_comment] = ACTIONS(1317),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1317),
    [aux_sym_FLOAT_token1] = ACTIONS(1317),
    [aux_sym_FLOAT_token2] = ACTIONS(1317),
    [aux_sym_FLOAT_token3] = ACTIONS(1317),
    [aux_sym_FLOAT_token4] = ACTIONS(1317),
    [aux_sym_INTEGER_token1] = ACTIONS(1317),
    [aux_sym_INTEGER_token2] = ACTIONS(1317),
    [aux_sym_INTEGER_token3] = ACTIONS(1319),
    [aux_sym_INTEGER_token4] = ACTIONS(1319),
    [anon_sym_DQUOTE] = ACTIONS(1317),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1317),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1319),
    [anon_sym_AT] = ACTIONS(1317),
  },
  [511] = {
    [ts_builtin_sym_end] = ACTIONS(1321),
    [anon_sym_COMMA] = ACTIONS(1321),
    [anon_sym_pub] = ACTIONS(1323),
    [anon_sym_test] = ACTIONS(1323),
    [anon_sym_comptime] = ACTIONS(1323),
    [anon_sym_export] = ACTIONS(1323),
    [anon_sym_extern] = ACTIONS(1323),
    [anon_sym_inline] = ACTIONS(1323),
    [anon_sym_noinline] = ACTIONS(1323),
    [anon_sym_threadlocal] = ACTIONS(1323),
    [anon_sym_usingnamespace] = ACTIONS(1323),
    [anon_sym_fn] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1323),
    [anon_sym_const] = ACTIONS(1323),
    [anon_sym_var] = ACTIONS(1323),
    [anon_sym_else] = ACTIONS(1323),
    [anon_sym_or] = ACTIONS(1323),
    [anon_sym_and] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1321),
    [anon_sym_RBRACE] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1323),
    [anon_sym_DOT] = ACTIONS(1323),
    [anon_sym_error] = ACTIONS(1323),
    [anon_sym_false] = ACTIONS(1323),
    [anon_sym_null] = ACTIONS(1323),
    [anon_sym_anyframe] = ACTIONS(1323),
    [anon_sym_true] = ACTIONS(1323),
    [anon_sym_undefined] = ACTIONS(1323),
    [anon_sym_unreachable] = ACTIONS(1323),
    [sym_BuildinTypeExpr] = ACTIONS(1323),
    [anon_sym_packed] = ACTIONS(1323),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_switch] = ACTIONS(1323),
    [anon_sym_LBRACK] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_while] = ACTIONS(1323),
    [anon_sym_for] = ACTIONS(1323),
    [anon_sym_PIPE] = ACTIONS(1323),
    [anon_sym_STAR] = ACTIONS(1323),
    [anon_sym_EQ_EQ] = ACTIONS(1321),
    [anon_sym_BANG_EQ] = ACTIONS(1321),
    [anon_sym_LT] = ACTIONS(1323),
    [anon_sym_GT] = ACTIONS(1323),
    [anon_sym_LT_EQ] = ACTIONS(1321),
    [anon_sym_GT_EQ] = ACTIONS(1321),
    [anon_sym_AMP] = ACTIONS(1321),
    [anon_sym_CARET] = ACTIONS(1321),
    [anon_sym_orelse] = ACTIONS(1323),
    [anon_sym_catch] = ACTIONS(1323),
    [anon_sym_LT_LT] = ACTIONS(1323),
    [anon_sym_GT_GT] = ACTIONS(1321),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1321),
    [anon_sym_PLUS] = ACTIONS(1323),
    [anon_sym_DASH] = ACTIONS(1323),
    [anon_sym_PLUS_PLUS] = ACTIONS(1321),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1321),
    [anon_sym_DASH_PERCENT] = ACTIONS(1321),
    [anon_sym_PLUS_PIPE] = ACTIONS(1321),
    [anon_sym_DASH_PIPE] = ACTIONS(1321),
    [anon_sym_PIPE_PIPE] = ACTIONS(1321),
    [anon_sym_SLASH] = ACTIONS(1323),
    [anon_sym_PERCENT] = ACTIONS(1321),
    [anon_sym_STAR_STAR] = ACTIONS(1321),
    [anon_sym_STAR_PERCENT] = ACTIONS(1321),
    [anon_sym_STAR_PIPE] = ACTIONS(1321),
    [anon_sym_QMARK] = ACTIONS(1321),
    [anon_sym_DOT_STAR] = ACTIONS(1321),
    [anon_sym_DOT_QMARK] = ACTIONS(1321),
    [anon_sym_struct] = ACTIONS(1323),
    [anon_sym_opaque] = ACTIONS(1323),
    [anon_sym_enum] = ACTIONS(1323),
    [anon_sym_union] = ACTIONS(1323),
    [sym_doc_comment] = ACTIONS(1321),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1321),
    [aux_sym_FLOAT_token1] = ACTIONS(1321),
    [aux_sym_FLOAT_token2] = ACTIONS(1321),
    [aux_sym_FLOAT_token3] = ACTIONS(1321),
    [aux_sym_FLOAT_token4] = ACTIONS(1321),
    [aux_sym_INTEGER_token1] = ACTIONS(1321),
    [aux_sym_INTEGER_token2] = ACTIONS(1321),
    [aux_sym_INTEGER_token3] = ACTIONS(1323),
    [aux_sym_INTEGER_token4] = ACTIONS(1323),
    [anon_sym_DQUOTE] = ACTIONS(1321),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1323),
    [anon_sym_AT] = ACTIONS(1321),
  },
  [512] = {
    [ts_builtin_sym_end] = ACTIONS(1325),
    [anon_sym_COMMA] = ACTIONS(1325),
    [anon_sym_pub] = ACTIONS(1327),
    [anon_sym_test] = ACTIONS(1327),
    [anon_sym_comptime] = ACTIONS(1327),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_extern] = ACTIONS(1327),
    [anon_sym_inline] = ACTIONS(1327),
    [anon_sym_noinline] = ACTIONS(1327),
    [anon_sym_threadlocal] = ACTIONS(1327),
    [anon_sym_usingnamespace] = ACTIONS(1327),
    [anon_sym_fn] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_const] = ACTIONS(1327),
    [anon_sym_var] = ACTIONS(1327),
    [anon_sym_else] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_RBRACE] = ACTIONS(1325),
    [anon_sym_async] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_error] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_null] = ACTIONS(1327),
    [anon_sym_anyframe] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_undefined] = ACTIONS(1327),
    [anon_sym_unreachable] = ACTIONS(1327),
    [sym_BuildinTypeExpr] = ACTIONS(1327),
    [anon_sym_packed] = ACTIONS(1327),
    [anon_sym_LPAREN] = ACTIONS(1325),
    [anon_sym_switch] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1325),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_EQ_EQ] = ACTIONS(1325),
    [anon_sym_BANG_EQ] = ACTIONS(1325),
    [anon_sym_LT] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1325),
    [anon_sym_GT_EQ] = ACTIONS(1325),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_CARET] = ACTIONS(1325),
    [anon_sym_orelse] = ACTIONS(1327),
    [anon_sym_catch] = ACTIONS(1327),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [anon_sym_GT_GT] = ACTIONS(1325),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1325),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1325),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1325),
    [anon_sym_DASH_PERCENT] = ACTIONS(1325),
    [anon_sym_PLUS_PIPE] = ACTIONS(1325),
    [anon_sym_DASH_PIPE] = ACTIONS(1325),
    [anon_sym_PIPE_PIPE] = ACTIONS(1325),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1325),
    [anon_sym_STAR_STAR] = ACTIONS(1325),
    [anon_sym_STAR_PERCENT] = ACTIONS(1325),
    [anon_sym_STAR_PIPE] = ACTIONS(1325),
    [anon_sym_QMARK] = ACTIONS(1325),
    [anon_sym_DOT_STAR] = ACTIONS(1325),
    [anon_sym_DOT_QMARK] = ACTIONS(1325),
    [anon_sym_struct] = ACTIONS(1327),
    [anon_sym_opaque] = ACTIONS(1327),
    [anon_sym_enum] = ACTIONS(1327),
    [anon_sym_union] = ACTIONS(1327),
    [sym_doc_comment] = ACTIONS(1325),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1325),
    [aux_sym_FLOAT_token1] = ACTIONS(1325),
    [aux_sym_FLOAT_token2] = ACTIONS(1325),
    [aux_sym_FLOAT_token3] = ACTIONS(1325),
    [aux_sym_FLOAT_token4] = ACTIONS(1325),
    [aux_sym_INTEGER_token1] = ACTIONS(1325),
    [aux_sym_INTEGER_token2] = ACTIONS(1325),
    [aux_sym_INTEGER_token3] = ACTIONS(1327),
    [aux_sym_INTEGER_token4] = ACTIONS(1327),
    [anon_sym_DQUOTE] = ACTIONS(1325),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1325),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(1325),
  },
  [513] = {
    [ts_builtin_sym_end] = ACTIONS(1329),
    [anon_sym_COMMA] = ACTIONS(1329),
    [anon_sym_pub] = ACTIONS(1331),
    [anon_sym_test] = ACTIONS(1331),
    [anon_sym_comptime] = ACTIONS(1331),
    [anon_sym_export] = ACTIONS(1331),
    [anon_sym_extern] = ACTIONS(1331),
    [anon_sym_inline] = ACTIONS(1331),
    [anon_sym_noinline] = ACTIONS(1331),
    [anon_sym_threadlocal] = ACTIONS(1331),
    [anon_sym_usingnamespace] = ACTIONS(1331),
    [anon_sym_fn] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_const] = ACTIONS(1331),
    [anon_sym_var] = ACTIONS(1331),
    [anon_sym_else] = ACTIONS(1331),
    [anon_sym_or] = ACTIONS(1331),
    [anon_sym_and] = ACTIONS(1331),
    [anon_sym_LBRACE] = ACTIONS(1329),
    [anon_sym_RBRACE] = ACTIONS(1329),
    [anon_sym_async] = ACTIONS(1331),
    [anon_sym_DOT] = ACTIONS(1331),
    [anon_sym_error] = ACTIONS(1331),
    [anon_sym_false] = ACTIONS(1331),
    [anon_sym_null] = ACTIONS(1331),
    [anon_sym_anyframe] = ACTIONS(1331),
    [anon_sym_true] = ACTIONS(1331),
    [anon_sym_undefined] = ACTIONS(1331),
    [anon_sym_unreachable] = ACTIONS(1331),
    [sym_BuildinTypeExpr] = ACTIONS(1331),
    [anon_sym_packed] = ACTIONS(1331),
    [anon_sym_LPAREN] = ACTIONS(1329),
    [anon_sym_switch] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(1329),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_while] = ACTIONS(1331),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_PIPE] = ACTIONS(1331),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_EQ_EQ] = ACTIONS(1329),
    [anon_sym_BANG_EQ] = ACTIONS(1329),
    [anon_sym_LT] = ACTIONS(1331),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1329),
    [anon_sym_GT_EQ] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_orelse] = ACTIONS(1331),
    [anon_sym_catch] = ACTIONS(1331),
    [anon_sym_LT_LT] = ACTIONS(1331),
    [anon_sym_GT_GT] = ACTIONS(1329),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1329),
    [anon_sym_DASH_PERCENT] = ACTIONS(1329),
    [anon_sym_PLUS_PIPE] = ACTIONS(1329),
    [anon_sym_DASH_PIPE] = ACTIONS(1329),
    [anon_sym_PIPE_PIPE] = ACTIONS(1329),
    [anon_sym_SLASH] = ACTIONS(1331),
    [anon_sym_PERCENT] = ACTIONS(1329),
    [anon_sym_STAR_STAR] = ACTIONS(1329),
    [anon_sym_STAR_PERCENT] = ACTIONS(1329),
    [anon_sym_STAR_PIPE] = ACTIONS(1329),
    [anon_sym_QMARK] = ACTIONS(1329),
    [anon_sym_DOT_STAR] = ACTIONS(1329),
    [anon_sym_DOT_QMARK] = ACTIONS(1329),
    [anon_sym_struct] = ACTIONS(1331),
    [anon_sym_opaque] = ACTIONS(1331),
    [anon_sym_enum] = ACTIONS(1331),
    [anon_sym_union] = ACTIONS(1331),
    [sym_doc_comment] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1329),
    [aux_sym_FLOAT_token1] = ACTIONS(1329),
    [aux_sym_FLOAT_token2] = ACTIONS(1329),
    [aux_sym_FLOAT_token3] = ACTIONS(1329),
    [aux_sym_FLOAT_token4] = ACTIONS(1329),
    [aux_sym_INTEGER_token1] = ACTIONS(1329),
    [aux_sym_INTEGER_token2] = ACTIONS(1329),
    [aux_sym_INTEGER_token3] = ACTIONS(1331),
    [aux_sym_INTEGER_token4] = ACTIONS(1331),
    [anon_sym_DQUOTE] = ACTIONS(1329),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1329),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1331),
    [anon_sym_AT] = ACTIONS(1329),
  },
  [514] = {
    [ts_builtin_sym_end] = ACTIONS(1333),
    [anon_sym_COMMA] = ACTIONS(1333),
    [anon_sym_pub] = ACTIONS(1335),
    [anon_sym_test] = ACTIONS(1335),
    [anon_sym_comptime] = ACTIONS(1335),
    [anon_sym_export] = ACTIONS(1335),
    [anon_sym_extern] = ACTIONS(1335),
    [anon_sym_inline] = ACTIONS(1335),
    [anon_sym_noinline] = ACTIONS(1335),
    [anon_sym_threadlocal] = ACTIONS(1335),
    [anon_sym_usingnamespace] = ACTIONS(1335),
    [anon_sym_fn] = ACTIONS(1335),
    [anon_sym_BANG] = ACTIONS(1335),
    [anon_sym_const] = ACTIONS(1335),
    [anon_sym_var] = ACTIONS(1335),
    [anon_sym_else] = ACTIONS(1335),
    [anon_sym_or] = ACTIONS(1335),
    [anon_sym_and] = ACTIONS(1335),
    [anon_sym_LBRACE] = ACTIONS(1333),
    [anon_sym_RBRACE] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1335),
    [anon_sym_error] = ACTIONS(1335),
    [anon_sym_false] = ACTIONS(1335),
    [anon_sym_null] = ACTIONS(1335),
    [anon_sym_anyframe] = ACTIONS(1335),
    [anon_sym_true] = ACTIONS(1335),
    [anon_sym_undefined] = ACTIONS(1335),
    [anon_sym_unreachable] = ACTIONS(1335),
    [sym_BuildinTypeExpr] = ACTIONS(1335),
    [anon_sym_packed] = ACTIONS(1335),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_switch] = ACTIONS(1335),
    [anon_sym_LBRACK] = ACTIONS(1333),
    [anon_sym_if] = ACTIONS(1335),
    [anon_sym_while] = ACTIONS(1335),
    [anon_sym_for] = ACTIONS(1335),
    [anon_sym_PIPE] = ACTIONS(1335),
    [anon_sym_STAR] = ACTIONS(1335),
    [anon_sym_EQ_EQ] = ACTIONS(1333),
    [anon_sym_BANG_EQ] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(1335),
    [anon_sym_GT] = ACTIONS(1335),
    [anon_sym_LT_EQ] = ACTIONS(1333),
    [anon_sym_GT_EQ] = ACTIONS(1333),
    [anon_sym_AMP] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1333),
    [anon_sym_orelse] = ACTIONS(1335),
    [anon_sym_catch] = ACTIONS(1335),
    [anon_sym_LT_LT] = ACTIONS(1335),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1333),
    [anon_sym_PLUS] = ACTIONS(1335),
    [anon_sym_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1333),
    [anon_sym_DASH_PERCENT] = ACTIONS(1333),
    [anon_sym_PLUS_PIPE] = ACTIONS(1333),
    [anon_sym_DASH_PIPE] = ACTIONS(1333),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_SLASH] = ACTIONS(1335),
    [anon_sym_PERCENT] = ACTIONS(1333),
    [anon_sym_STAR_STAR] = ACTIONS(1333),
    [anon_sym_STAR_PERCENT] = ACTIONS(1333),
    [anon_sym_STAR_PIPE] = ACTIONS(1333),
    [anon_sym_QMARK] = ACTIONS(1333),
    [anon_sym_DOT_STAR] = ACTIONS(1333),
    [anon_sym_DOT_QMARK] = ACTIONS(1333),
    [anon_sym_struct] = ACTIONS(1335),
    [anon_sym_opaque] = ACTIONS(1335),
    [anon_sym_enum] = ACTIONS(1335),
    [anon_sym_union] = ACTIONS(1335),
    [sym_doc_comment] = ACTIONS(1333),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1333),
    [aux_sym_FLOAT_token1] = ACTIONS(1333),
    [aux_sym_FLOAT_token2] = ACTIONS(1333),
    [aux_sym_FLOAT_token3] = ACTIONS(1333),
    [aux_sym_FLOAT_token4] = ACTIONS(1333),
    [aux_sym_INTEGER_token1] = ACTIONS(1333),
    [aux_sym_INTEGER_token2] = ACTIONS(1333),
    [aux_sym_INTEGER_token3] = ACTIONS(1335),
    [aux_sym_INTEGER_token4] = ACTIONS(1335),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1333),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1335),
    [anon_sym_AT] = ACTIONS(1333),
  },
  [515] = {
    [ts_builtin_sym_end] = ACTIONS(1337),
    [anon_sym_COMMA] = ACTIONS(1337),
    [anon_sym_pub] = ACTIONS(1339),
    [anon_sym_test] = ACTIONS(1339),
    [anon_sym_comptime] = ACTIONS(1339),
    [anon_sym_export] = ACTIONS(1339),
    [anon_sym_extern] = ACTIONS(1339),
    [anon_sym_inline] = ACTIONS(1339),
    [anon_sym_noinline] = ACTIONS(1339),
    [anon_sym_threadlocal] = ACTIONS(1339),
    [anon_sym_usingnamespace] = ACTIONS(1339),
    [anon_sym_fn] = ACTIONS(1339),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_const] = ACTIONS(1339),
    [anon_sym_var] = ACTIONS(1339),
    [anon_sym_else] = ACTIONS(1339),
    [anon_sym_or] = ACTIONS(1339),
    [anon_sym_and] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1337),
    [anon_sym_RBRACE] = ACTIONS(1337),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_DOT] = ACTIONS(1339),
    [anon_sym_error] = ACTIONS(1339),
    [anon_sym_false] = ACTIONS(1339),
    [anon_sym_null] = ACTIONS(1339),
    [anon_sym_anyframe] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(1339),
    [anon_sym_undefined] = ACTIONS(1339),
    [anon_sym_unreachable] = ACTIONS(1339),
    [sym_BuildinTypeExpr] = ACTIONS(1339),
    [anon_sym_packed] = ACTIONS(1339),
    [anon_sym_LPAREN] = ACTIONS(1337),
    [anon_sym_switch] = ACTIONS(1339),
    [anon_sym_LBRACK] = ACTIONS(1337),
    [anon_sym_if] = ACTIONS(1339),
    [anon_sym_while] = ACTIONS(1339),
    [anon_sym_for] = ACTIONS(1339),
    [anon_sym_PIPE] = ACTIONS(1339),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG_EQ] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1339),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_AMP] = ACTIONS(1337),
    [anon_sym_CARET] = ACTIONS(1337),
    [anon_sym_orelse] = ACTIONS(1339),
    [anon_sym_catch] = ACTIONS(1339),
    [anon_sym_LT_LT] = ACTIONS(1339),
    [anon_sym_GT_GT] = ACTIONS(1337),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1337),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1337),
    [anon_sym_DASH_PERCENT] = ACTIONS(1337),
    [anon_sym_PLUS_PIPE] = ACTIONS(1337),
    [anon_sym_DASH_PIPE] = ACTIONS(1337),
    [anon_sym_PIPE_PIPE] = ACTIONS(1337),
    [anon_sym_SLASH] = ACTIONS(1339),
    [anon_sym_PERCENT] = ACTIONS(1337),
    [anon_sym_STAR_STAR] = ACTIONS(1337),
    [anon_sym_STAR_PERCENT] = ACTIONS(1337),
    [anon_sym_STAR_PIPE] = ACTIONS(1337),
    [anon_sym_QMARK] = ACTIONS(1337),
    [anon_sym_DOT_STAR] = ACTIONS(1337),
    [anon_sym_DOT_QMARK] = ACTIONS(1337),
    [anon_sym_struct] = ACTIONS(1339),
    [anon_sym_opaque] = ACTIONS(1339),
    [anon_sym_enum] = ACTIONS(1339),
    [anon_sym_union] = ACTIONS(1339),
    [sym_doc_comment] = ACTIONS(1337),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1337),
    [aux_sym_FLOAT_token1] = ACTIONS(1337),
    [aux_sym_FLOAT_token2] = ACTIONS(1337),
    [aux_sym_FLOAT_token3] = ACTIONS(1337),
    [aux_sym_FLOAT_token4] = ACTIONS(1337),
    [aux_sym_INTEGER_token1] = ACTIONS(1337),
    [aux_sym_INTEGER_token2] = ACTIONS(1337),
    [aux_sym_INTEGER_token3] = ACTIONS(1339),
    [aux_sym_INTEGER_token4] = ACTIONS(1339),
    [anon_sym_DQUOTE] = ACTIONS(1337),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1337),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1339),
    [anon_sym_AT] = ACTIONS(1337),
  },
  [516] = {
    [ts_builtin_sym_end] = ACTIONS(1341),
    [anon_sym_COMMA] = ACTIONS(1341),
    [anon_sym_pub] = ACTIONS(1343),
    [anon_sym_test] = ACTIONS(1343),
    [anon_sym_comptime] = ACTIONS(1343),
    [anon_sym_export] = ACTIONS(1343),
    [anon_sym_extern] = ACTIONS(1343),
    [anon_sym_inline] = ACTIONS(1343),
    [anon_sym_noinline] = ACTIONS(1343),
    [anon_sym_threadlocal] = ACTIONS(1343),
    [anon_sym_usingnamespace] = ACTIONS(1343),
    [anon_sym_fn] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1343),
    [anon_sym_var] = ACTIONS(1343),
    [anon_sym_else] = ACTIONS(1343),
    [anon_sym_or] = ACTIONS(1343),
    [anon_sym_and] = ACTIONS(1343),
    [anon_sym_LBRACE] = ACTIONS(1341),
    [anon_sym_RBRACE] = ACTIONS(1341),
    [anon_sym_async] = ACTIONS(1343),
    [anon_sym_DOT] = ACTIONS(1343),
    [anon_sym_error] = ACTIONS(1343),
    [anon_sym_false] = ACTIONS(1343),
    [anon_sym_null] = ACTIONS(1343),
    [anon_sym_anyframe] = ACTIONS(1343),
    [anon_sym_true] = ACTIONS(1343),
    [anon_sym_undefined] = ACTIONS(1343),
    [anon_sym_unreachable] = ACTIONS(1343),
    [sym_BuildinTypeExpr] = ACTIONS(1343),
    [anon_sym_packed] = ACTIONS(1343),
    [anon_sym_LPAREN] = ACTIONS(1341),
    [anon_sym_switch] = ACTIONS(1343),
    [anon_sym_LBRACK] = ACTIONS(1341),
    [anon_sym_if] = ACTIONS(1343),
    [anon_sym_while] = ACTIONS(1343),
    [anon_sym_for] = ACTIONS(1343),
    [anon_sym_PIPE] = ACTIONS(1343),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_EQ_EQ] = ACTIONS(1341),
    [anon_sym_BANG_EQ] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(1343),
    [anon_sym_GT] = ACTIONS(1343),
    [anon_sym_LT_EQ] = ACTIONS(1341),
    [anon_sym_GT_EQ] = ACTIONS(1341),
    [anon_sym_AMP] = ACTIONS(1341),
    [anon_sym_CARET] = ACTIONS(1341),
    [anon_sym_orelse] = ACTIONS(1343),
    [anon_sym_catch] = ACTIONS(1343),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_GT_GT] = ACTIONS(1341),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1343),
    [anon_sym_PLUS_PLUS] = ACTIONS(1341),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1341),
    [anon_sym_DASH_PERCENT] = ACTIONS(1341),
    [anon_sym_PLUS_PIPE] = ACTIONS(1341),
    [anon_sym_DASH_PIPE] = ACTIONS(1341),
    [anon_sym_PIPE_PIPE] = ACTIONS(1341),
    [anon_sym_SLASH] = ACTIONS(1343),
    [anon_sym_PERCENT] = ACTIONS(1341),
    [anon_sym_STAR_STAR] = ACTIONS(1341),
    [anon_sym_STAR_PERCENT] = ACTIONS(1341),
    [anon_sym_STAR_PIPE] = ACTIONS(1341),
    [anon_sym_QMARK] = ACTIONS(1341),
    [anon_sym_DOT_STAR] = ACTIONS(1341),
    [anon_sym_DOT_QMARK] = ACTIONS(1341),
    [anon_sym_struct] = ACTIONS(1343),
    [anon_sym_opaque] = ACTIONS(1343),
    [anon_sym_enum] = ACTIONS(1343),
    [anon_sym_union] = ACTIONS(1343),
    [sym_doc_comment] = ACTIONS(1341),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1341),
    [aux_sym_FLOAT_token1] = ACTIONS(1341),
    [aux_sym_FLOAT_token2] = ACTIONS(1341),
    [aux_sym_FLOAT_token3] = ACTIONS(1341),
    [aux_sym_FLOAT_token4] = ACTIONS(1341),
    [aux_sym_INTEGER_token1] = ACTIONS(1341),
    [aux_sym_INTEGER_token2] = ACTIONS(1341),
    [aux_sym_INTEGER_token3] = ACTIONS(1343),
    [aux_sym_INTEGER_token4] = ACTIONS(1343),
    [anon_sym_DQUOTE] = ACTIONS(1341),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1341),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1343),
    [anon_sym_AT] = ACTIONS(1341),
  },
  [517] = {
    [ts_builtin_sym_end] = ACTIONS(1345),
    [anon_sym_COMMA] = ACTIONS(1345),
    [anon_sym_pub] = ACTIONS(1347),
    [anon_sym_test] = ACTIONS(1347),
    [anon_sym_comptime] = ACTIONS(1347),
    [anon_sym_export] = ACTIONS(1347),
    [anon_sym_extern] = ACTIONS(1347),
    [anon_sym_inline] = ACTIONS(1347),
    [anon_sym_noinline] = ACTIONS(1347),
    [anon_sym_threadlocal] = ACTIONS(1347),
    [anon_sym_usingnamespace] = ACTIONS(1347),
    [anon_sym_fn] = ACTIONS(1347),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_const] = ACTIONS(1347),
    [anon_sym_var] = ACTIONS(1347),
    [anon_sym_else] = ACTIONS(1347),
    [anon_sym_or] = ACTIONS(1347),
    [anon_sym_and] = ACTIONS(1347),
    [anon_sym_LBRACE] = ACTIONS(1345),
    [anon_sym_RBRACE] = ACTIONS(1345),
    [anon_sym_async] = ACTIONS(1347),
    [anon_sym_DOT] = ACTIONS(1347),
    [anon_sym_error] = ACTIONS(1347),
    [anon_sym_false] = ACTIONS(1347),
    [anon_sym_null] = ACTIONS(1347),
    [anon_sym_anyframe] = ACTIONS(1347),
    [anon_sym_true] = ACTIONS(1347),
    [anon_sym_undefined] = ACTIONS(1347),
    [anon_sym_unreachable] = ACTIONS(1347),
    [sym_BuildinTypeExpr] = ACTIONS(1347),
    [anon_sym_packed] = ACTIONS(1347),
    [anon_sym_LPAREN] = ACTIONS(1345),
    [anon_sym_switch] = ACTIONS(1347),
    [anon_sym_LBRACK] = ACTIONS(1345),
    [anon_sym_if] = ACTIONS(1347),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_for] = ACTIONS(1347),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_EQ_EQ] = ACTIONS(1345),
    [anon_sym_BANG_EQ] = ACTIONS(1345),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1345),
    [anon_sym_GT_EQ] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(1345),
    [anon_sym_CARET] = ACTIONS(1345),
    [anon_sym_orelse] = ACTIONS(1347),
    [anon_sym_catch] = ACTIONS(1347),
    [anon_sym_LT_LT] = ACTIONS(1347),
    [anon_sym_GT_GT] = ACTIONS(1345),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1345),
    [anon_sym_PLUS] = ACTIONS(1347),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(1345),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1345),
    [anon_sym_DASH_PERCENT] = ACTIONS(1345),
    [anon_sym_PLUS_PIPE] = ACTIONS(1345),
    [anon_sym_DASH_PIPE] = ACTIONS(1345),
    [anon_sym_PIPE_PIPE] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1347),
    [anon_sym_PERCENT] = ACTIONS(1345),
    [anon_sym_STAR_STAR] = ACTIONS(1345),
    [anon_sym_STAR_PERCENT] = ACTIONS(1345),
    [anon_sym_STAR_PIPE] = ACTIONS(1345),
    [anon_sym_QMARK] = ACTIONS(1345),
    [anon_sym_DOT_STAR] = ACTIONS(1345),
    [anon_sym_DOT_QMARK] = ACTIONS(1345),
    [anon_sym_struct] = ACTIONS(1347),
    [anon_sym_opaque] = ACTIONS(1347),
    [anon_sym_enum] = ACTIONS(1347),
    [anon_sym_union] = ACTIONS(1347),
    [sym_doc_comment] = ACTIONS(1345),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1345),
    [aux_sym_FLOAT_token1] = ACTIONS(1345),
    [aux_sym_FLOAT_token2] = ACTIONS(1345),
    [aux_sym_FLOAT_token3] = ACTIONS(1345),
    [aux_sym_FLOAT_token4] = ACTIONS(1345),
    [aux_sym_INTEGER_token1] = ACTIONS(1345),
    [aux_sym_INTEGER_token2] = ACTIONS(1345),
    [aux_sym_INTEGER_token3] = ACTIONS(1347),
    [aux_sym_INTEGER_token4] = ACTIONS(1347),
    [anon_sym_DQUOTE] = ACTIONS(1345),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1345),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1347),
    [anon_sym_AT] = ACTIONS(1345),
  },
  [518] = {
    [ts_builtin_sym_end] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1349),
    [anon_sym_pub] = ACTIONS(1351),
    [anon_sym_test] = ACTIONS(1351),
    [anon_sym_comptime] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_extern] = ACTIONS(1351),
    [anon_sym_inline] = ACTIONS(1351),
    [anon_sym_noinline] = ACTIONS(1351),
    [anon_sym_threadlocal] = ACTIONS(1351),
    [anon_sym_usingnamespace] = ACTIONS(1351),
    [anon_sym_fn] = ACTIONS(1351),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_var] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1351),
    [anon_sym_or] = ACTIONS(1351),
    [anon_sym_and] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1349),
    [anon_sym_RBRACE] = ACTIONS(1349),
    [anon_sym_async] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_error] = ACTIONS(1351),
    [anon_sym_false] = ACTIONS(1351),
    [anon_sym_null] = ACTIONS(1351),
    [anon_sym_anyframe] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1351),
    [anon_sym_undefined] = ACTIONS(1351),
    [anon_sym_unreachable] = ACTIONS(1351),
    [sym_BuildinTypeExpr] = ACTIONS(1351),
    [anon_sym_packed] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_switch] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_orelse] = ACTIONS(1351),
    [anon_sym_catch] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1351),
    [anon_sym_DASH] = ACTIONS(1351),
    [anon_sym_PLUS_PLUS] = ACTIONS(1349),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1349),
    [anon_sym_DASH_PERCENT] = ACTIONS(1349),
    [anon_sym_PLUS_PIPE] = ACTIONS(1349),
    [anon_sym_DASH_PIPE] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_STAR_PERCENT] = ACTIONS(1349),
    [anon_sym_STAR_PIPE] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_DOT_STAR] = ACTIONS(1349),
    [anon_sym_DOT_QMARK] = ACTIONS(1349),
    [anon_sym_struct] = ACTIONS(1351),
    [anon_sym_opaque] = ACTIONS(1351),
    [anon_sym_enum] = ACTIONS(1351),
    [anon_sym_union] = ACTIONS(1351),
    [sym_doc_comment] = ACTIONS(1349),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [aux_sym_FLOAT_token1] = ACTIONS(1349),
    [aux_sym_FLOAT_token2] = ACTIONS(1349),
    [aux_sym_FLOAT_token3] = ACTIONS(1349),
    [aux_sym_FLOAT_token4] = ACTIONS(1349),
    [aux_sym_INTEGER_token1] = ACTIONS(1349),
    [aux_sym_INTEGER_token2] = ACTIONS(1349),
    [aux_sym_INTEGER_token3] = ACTIONS(1351),
    [aux_sym_INTEGER_token4] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1349),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1349),
  },
  [519] = {
    [ts_builtin_sym_end] = ACTIONS(1353),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_pub] = ACTIONS(1355),
    [anon_sym_test] = ACTIONS(1355),
    [anon_sym_comptime] = ACTIONS(1355),
    [anon_sym_export] = ACTIONS(1355),
    [anon_sym_extern] = ACTIONS(1355),
    [anon_sym_inline] = ACTIONS(1355),
    [anon_sym_noinline] = ACTIONS(1355),
    [anon_sym_threadlocal] = ACTIONS(1355),
    [anon_sym_usingnamespace] = ACTIONS(1355),
    [anon_sym_fn] = ACTIONS(1355),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_const] = ACTIONS(1355),
    [anon_sym_var] = ACTIONS(1355),
    [anon_sym_else] = ACTIONS(1355),
    [anon_sym_or] = ACTIONS(1355),
    [anon_sym_and] = ACTIONS(1355),
    [anon_sym_LBRACE] = ACTIONS(1353),
    [anon_sym_RBRACE] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_DOT] = ACTIONS(1355),
    [anon_sym_error] = ACTIONS(1355),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_null] = ACTIONS(1355),
    [anon_sym_anyframe] = ACTIONS(1355),
    [anon_sym_true] = ACTIONS(1355),
    [anon_sym_undefined] = ACTIONS(1355),
    [anon_sym_unreachable] = ACTIONS(1355),
    [sym_BuildinTypeExpr] = ACTIONS(1355),
    [anon_sym_packed] = ACTIONS(1355),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_switch] = ACTIONS(1355),
    [anon_sym_LBRACK] = ACTIONS(1353),
    [anon_sym_if] = ACTIONS(1355),
    [anon_sym_while] = ACTIONS(1355),
    [anon_sym_for] = ACTIONS(1355),
    [anon_sym_PIPE] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1355),
    [anon_sym_EQ_EQ] = ACTIONS(1353),
    [anon_sym_BANG_EQ] = ACTIONS(1353),
    [anon_sym_LT] = ACTIONS(1355),
    [anon_sym_GT] = ACTIONS(1355),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT_EQ] = ACTIONS(1353),
    [anon_sym_AMP] = ACTIONS(1353),
    [anon_sym_CARET] = ACTIONS(1353),
    [anon_sym_orelse] = ACTIONS(1355),
    [anon_sym_catch] = ACTIONS(1355),
    [anon_sym_LT_LT] = ACTIONS(1355),
    [anon_sym_GT_GT] = ACTIONS(1353),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_PLUS_PLUS] = ACTIONS(1353),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1353),
    [anon_sym_DASH_PERCENT] = ACTIONS(1353),
    [anon_sym_PLUS_PIPE] = ACTIONS(1353),
    [anon_sym_DASH_PIPE] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1353),
    [anon_sym_SLASH] = ACTIONS(1355),
    [anon_sym_PERCENT] = ACTIONS(1353),
    [anon_sym_STAR_STAR] = ACTIONS(1353),
    [anon_sym_STAR_PERCENT] = ACTIONS(1353),
    [anon_sym_STAR_PIPE] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_DOT_STAR] = ACTIONS(1353),
    [anon_sym_DOT_QMARK] = ACTIONS(1353),
    [anon_sym_struct] = ACTIONS(1355),
    [anon_sym_opaque] = ACTIONS(1355),
    [anon_sym_enum] = ACTIONS(1355),
    [anon_sym_union] = ACTIONS(1355),
    [sym_doc_comment] = ACTIONS(1353),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1353),
    [aux_sym_FLOAT_token1] = ACTIONS(1353),
    [aux_sym_FLOAT_token2] = ACTIONS(1353),
    [aux_sym_FLOAT_token3] = ACTIONS(1353),
    [aux_sym_FLOAT_token4] = ACTIONS(1353),
    [aux_sym_INTEGER_token1] = ACTIONS(1353),
    [aux_sym_INTEGER_token2] = ACTIONS(1353),
    [aux_sym_INTEGER_token3] = ACTIONS(1355),
    [aux_sym_INTEGER_token4] = ACTIONS(1355),
    [anon_sym_DQUOTE] = ACTIONS(1353),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1353),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1355),
    [anon_sym_AT] = ACTIONS(1353),
  },
  [520] = {
    [ts_builtin_sym_end] = ACTIONS(1357),
    [anon_sym_COMMA] = ACTIONS(1357),
    [anon_sym_pub] = ACTIONS(1359),
    [anon_sym_test] = ACTIONS(1359),
    [anon_sym_comptime] = ACTIONS(1359),
    [anon_sym_export] = ACTIONS(1359),
    [anon_sym_extern] = ACTIONS(1359),
    [anon_sym_inline] = ACTIONS(1359),
    [anon_sym_noinline] = ACTIONS(1359),
    [anon_sym_threadlocal] = ACTIONS(1359),
    [anon_sym_usingnamespace] = ACTIONS(1359),
    [anon_sym_fn] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_const] = ACTIONS(1359),
    [anon_sym_var] = ACTIONS(1359),
    [anon_sym_else] = ACTIONS(1359),
    [anon_sym_or] = ACTIONS(1359),
    [anon_sym_and] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(1357),
    [anon_sym_RBRACE] = ACTIONS(1357),
    [anon_sym_async] = ACTIONS(1359),
    [anon_sym_DOT] = ACTIONS(1359),
    [anon_sym_error] = ACTIONS(1359),
    [anon_sym_false] = ACTIONS(1359),
    [anon_sym_null] = ACTIONS(1359),
    [anon_sym_anyframe] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(1359),
    [anon_sym_undefined] = ACTIONS(1359),
    [anon_sym_unreachable] = ACTIONS(1359),
    [sym_BuildinTypeExpr] = ACTIONS(1359),
    [anon_sym_packed] = ACTIONS(1359),
    [anon_sym_LPAREN] = ACTIONS(1357),
    [anon_sym_switch] = ACTIONS(1359),
    [anon_sym_LBRACK] = ACTIONS(1357),
    [anon_sym_if] = ACTIONS(1359),
    [anon_sym_while] = ACTIONS(1359),
    [anon_sym_for] = ACTIONS(1359),
    [anon_sym_PIPE] = ACTIONS(1359),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_EQ_EQ] = ACTIONS(1357),
    [anon_sym_BANG_EQ] = ACTIONS(1357),
    [anon_sym_LT] = ACTIONS(1359),
    [anon_sym_GT] = ACTIONS(1359),
    [anon_sym_LT_EQ] = ACTIONS(1357),
    [anon_sym_GT_EQ] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_orelse] = ACTIONS(1359),
    [anon_sym_catch] = ACTIONS(1359),
    [anon_sym_LT_LT] = ACTIONS(1359),
    [anon_sym_GT_GT] = ACTIONS(1357),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1357),
    [anon_sym_PLUS] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1357),
    [anon_sym_DASH_PERCENT] = ACTIONS(1357),
    [anon_sym_PLUS_PIPE] = ACTIONS(1357),
    [anon_sym_DASH_PIPE] = ACTIONS(1357),
    [anon_sym_PIPE_PIPE] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1359),
    [anon_sym_PERCENT] = ACTIONS(1357),
    [anon_sym_STAR_STAR] = ACTIONS(1357),
    [anon_sym_STAR_PERCENT] = ACTIONS(1357),
    [anon_sym_STAR_PIPE] = ACTIONS(1357),
    [anon_sym_QMARK] = ACTIONS(1357),
    [anon_sym_DOT_STAR] = ACTIONS(1357),
    [anon_sym_DOT_QMARK] = ACTIONS(1357),
    [anon_sym_struct] = ACTIONS(1359),
    [anon_sym_opaque] = ACTIONS(1359),
    [anon_sym_enum] = ACTIONS(1359),
    [anon_sym_union] = ACTIONS(1359),
    [sym_doc_comment] = ACTIONS(1357),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1357),
    [aux_sym_FLOAT_token1] = ACTIONS(1357),
    [aux_sym_FLOAT_token2] = ACTIONS(1357),
    [aux_sym_FLOAT_token3] = ACTIONS(1357),
    [aux_sym_FLOAT_token4] = ACTIONS(1357),
    [aux_sym_INTEGER_token1] = ACTIONS(1357),
    [aux_sym_INTEGER_token2] = ACTIONS(1357),
    [aux_sym_INTEGER_token3] = ACTIONS(1359),
    [aux_sym_INTEGER_token4] = ACTIONS(1359),
    [anon_sym_DQUOTE] = ACTIONS(1357),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1357),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1359),
    [anon_sym_AT] = ACTIONS(1357),
  },
  [521] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1361),
    [anon_sym_COMMA] = ACTIONS(1361),
    [anon_sym_pub] = ACTIONS(1363),
    [anon_sym_test] = ACTIONS(1363),
    [anon_sym_comptime] = ACTIONS(1363),
    [anon_sym_export] = ACTIONS(1363),
    [anon_sym_extern] = ACTIONS(1363),
    [anon_sym_inline] = ACTIONS(1363),
    [anon_sym_noinline] = ACTIONS(1363),
    [anon_sym_threadlocal] = ACTIONS(1363),
    [anon_sym_usingnamespace] = ACTIONS(1363),
    [anon_sym_fn] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1363),
    [anon_sym_var] = ACTIONS(1363),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1361),
    [anon_sym_async] = ACTIONS(1363),
    [anon_sym_DOT] = ACTIONS(1361),
    [anon_sym_error] = ACTIONS(1363),
    [anon_sym_false] = ACTIONS(1363),
    [anon_sym_null] = ACTIONS(1363),
    [anon_sym_anyframe] = ACTIONS(1363),
    [anon_sym_true] = ACTIONS(1363),
    [anon_sym_undefined] = ACTIONS(1363),
    [anon_sym_unreachable] = ACTIONS(1363),
    [sym_BuildinTypeExpr] = ACTIONS(1363),
    [anon_sym_packed] = ACTIONS(1363),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_switch] = ACTIONS(1363),
    [anon_sym_LBRACK] = ACTIONS(1361),
    [anon_sym_if] = ACTIONS(1363),
    [anon_sym_while] = ACTIONS(1363),
    [anon_sym_for] = ACTIONS(1363),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1361),
    [anon_sym_struct] = ACTIONS(1363),
    [anon_sym_opaque] = ACTIONS(1363),
    [anon_sym_enum] = ACTIONS(1363),
    [anon_sym_union] = ACTIONS(1363),
    [sym_doc_comment] = ACTIONS(1361),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1361),
    [aux_sym_FLOAT_token1] = ACTIONS(1361),
    [aux_sym_FLOAT_token2] = ACTIONS(1361),
    [aux_sym_FLOAT_token3] = ACTIONS(1361),
    [aux_sym_FLOAT_token4] = ACTIONS(1361),
    [aux_sym_INTEGER_token1] = ACTIONS(1361),
    [aux_sym_INTEGER_token2] = ACTIONS(1361),
    [aux_sym_INTEGER_token3] = ACTIONS(1363),
    [aux_sym_INTEGER_token4] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1361),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1361),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1363),
    [anon_sym_AT] = ACTIONS(1361),
  },
  [522] = {
    [ts_builtin_sym_end] = ACTIONS(1365),
    [anon_sym_COMMA] = ACTIONS(1365),
    [anon_sym_pub] = ACTIONS(1367),
    [anon_sym_test] = ACTIONS(1367),
    [anon_sym_comptime] = ACTIONS(1367),
    [anon_sym_export] = ACTIONS(1367),
    [anon_sym_extern] = ACTIONS(1367),
    [anon_sym_inline] = ACTIONS(1367),
    [anon_sym_noinline] = ACTIONS(1367),
    [anon_sym_threadlocal] = ACTIONS(1367),
    [anon_sym_usingnamespace] = ACTIONS(1367),
    [anon_sym_fn] = ACTIONS(1367),
    [anon_sym_BANG] = ACTIONS(1367),
    [anon_sym_const] = ACTIONS(1367),
    [anon_sym_var] = ACTIONS(1367),
    [anon_sym_else] = ACTIONS(1367),
    [anon_sym_or] = ACTIONS(1367),
    [anon_sym_and] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1365),
    [anon_sym_RBRACE] = ACTIONS(1365),
    [anon_sym_async] = ACTIONS(1367),
    [anon_sym_DOT] = ACTIONS(1367),
    [anon_sym_error] = ACTIONS(1367),
    [anon_sym_false] = ACTIONS(1367),
    [anon_sym_null] = ACTIONS(1367),
    [anon_sym_anyframe] = ACTIONS(1367),
    [anon_sym_true] = ACTIONS(1367),
    [anon_sym_undefined] = ACTIONS(1367),
    [anon_sym_unreachable] = ACTIONS(1367),
    [sym_BuildinTypeExpr] = ACTIONS(1367),
    [anon_sym_packed] = ACTIONS(1367),
    [anon_sym_LPAREN] = ACTIONS(1365),
    [anon_sym_switch] = ACTIONS(1367),
    [anon_sym_LBRACK] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(1367),
    [anon_sym_while] = ACTIONS(1367),
    [anon_sym_for] = ACTIONS(1367),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_EQ_EQ] = ACTIONS(1365),
    [anon_sym_BANG_EQ] = ACTIONS(1365),
    [anon_sym_LT] = ACTIONS(1367),
    [anon_sym_GT] = ACTIONS(1367),
    [anon_sym_LT_EQ] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_orelse] = ACTIONS(1367),
    [anon_sym_catch] = ACTIONS(1367),
    [anon_sym_LT_LT] = ACTIONS(1367),
    [anon_sym_GT_GT] = ACTIONS(1365),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(1367),
    [anon_sym_DASH] = ACTIONS(1367),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1365),
    [anon_sym_DASH_PERCENT] = ACTIONS(1365),
    [anon_sym_PLUS_PIPE] = ACTIONS(1365),
    [anon_sym_DASH_PIPE] = ACTIONS(1365),
    [anon_sym_PIPE_PIPE] = ACTIONS(1365),
    [anon_sym_SLASH] = ACTIONS(1367),
    [anon_sym_PERCENT] = ACTIONS(1365),
    [anon_sym_STAR_STAR] = ACTIONS(1365),
    [anon_sym_STAR_PERCENT] = ACTIONS(1365),
    [anon_sym_STAR_PIPE] = ACTIONS(1365),
    [anon_sym_QMARK] = ACTIONS(1365),
    [anon_sym_DOT_STAR] = ACTIONS(1365),
    [anon_sym_DOT_QMARK] = ACTIONS(1365),
    [anon_sym_struct] = ACTIONS(1367),
    [anon_sym_opaque] = ACTIONS(1367),
    [anon_sym_enum] = ACTIONS(1367),
    [anon_sym_union] = ACTIONS(1367),
    [sym_doc_comment] = ACTIONS(1365),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [aux_sym_FLOAT_token1] = ACTIONS(1365),
    [aux_sym_FLOAT_token2] = ACTIONS(1365),
    [aux_sym_FLOAT_token3] = ACTIONS(1365),
    [aux_sym_FLOAT_token4] = ACTIONS(1365),
    [aux_sym_INTEGER_token1] = ACTIONS(1365),
    [aux_sym_INTEGER_token2] = ACTIONS(1365),
    [aux_sym_INTEGER_token3] = ACTIONS(1367),
    [aux_sym_INTEGER_token4] = ACTIONS(1367),
    [anon_sym_DQUOTE] = ACTIONS(1365),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1365),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1367),
    [anon_sym_AT] = ACTIONS(1365),
  },
  [523] = {
    [ts_builtin_sym_end] = ACTIONS(1369),
    [anon_sym_COMMA] = ACTIONS(1369),
    [anon_sym_pub] = ACTIONS(1371),
    [anon_sym_test] = ACTIONS(1371),
    [anon_sym_comptime] = ACTIONS(1371),
    [anon_sym_export] = ACTIONS(1371),
    [anon_sym_extern] = ACTIONS(1371),
    [anon_sym_inline] = ACTIONS(1371),
    [anon_sym_noinline] = ACTIONS(1371),
    [anon_sym_threadlocal] = ACTIONS(1371),
    [anon_sym_usingnamespace] = ACTIONS(1371),
    [anon_sym_fn] = ACTIONS(1371),
    [anon_sym_BANG] = ACTIONS(1371),
    [anon_sym_const] = ACTIONS(1371),
    [anon_sym_var] = ACTIONS(1371),
    [anon_sym_else] = ACTIONS(1371),
    [anon_sym_or] = ACTIONS(1371),
    [anon_sym_and] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(1369),
    [anon_sym_RBRACE] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1371),
    [anon_sym_DOT] = ACTIONS(1371),
    [anon_sym_error] = ACTIONS(1371),
    [anon_sym_false] = ACTIONS(1371),
    [anon_sym_null] = ACTIONS(1371),
    [anon_sym_anyframe] = ACTIONS(1371),
    [anon_sym_true] = ACTIONS(1371),
    [anon_sym_undefined] = ACTIONS(1371),
    [anon_sym_unreachable] = ACTIONS(1371),
    [sym_BuildinTypeExpr] = ACTIONS(1371),
    [anon_sym_packed] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1369),
    [anon_sym_switch] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(1369),
    [anon_sym_if] = ACTIONS(1371),
    [anon_sym_while] = ACTIONS(1371),
    [anon_sym_for] = ACTIONS(1371),
    [anon_sym_PIPE] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_EQ_EQ] = ACTIONS(1369),
    [anon_sym_BANG_EQ] = ACTIONS(1369),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(1371),
    [anon_sym_LT_EQ] = ACTIONS(1369),
    [anon_sym_GT_EQ] = ACTIONS(1369),
    [anon_sym_AMP] = ACTIONS(1369),
    [anon_sym_CARET] = ACTIONS(1369),
    [anon_sym_orelse] = ACTIONS(1371),
    [anon_sym_catch] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1371),
    [anon_sym_GT_GT] = ACTIONS(1369),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1369),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_PLUS_PLUS] = ACTIONS(1369),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1369),
    [anon_sym_DASH_PERCENT] = ACTIONS(1369),
    [anon_sym_PLUS_PIPE] = ACTIONS(1369),
    [anon_sym_DASH_PIPE] = ACTIONS(1369),
    [anon_sym_PIPE_PIPE] = ACTIONS(1369),
    [anon_sym_SLASH] = ACTIONS(1371),
    [anon_sym_PERCENT] = ACTIONS(1369),
    [anon_sym_STAR_STAR] = ACTIONS(1369),
    [anon_sym_STAR_PERCENT] = ACTIONS(1369),
    [anon_sym_STAR_PIPE] = ACTIONS(1369),
    [anon_sym_QMARK] = ACTIONS(1369),
    [anon_sym_DOT_STAR] = ACTIONS(1369),
    [anon_sym_DOT_QMARK] = ACTIONS(1369),
    [anon_sym_struct] = ACTIONS(1371),
    [anon_sym_opaque] = ACTIONS(1371),
    [anon_sym_enum] = ACTIONS(1371),
    [anon_sym_union] = ACTIONS(1371),
    [sym_doc_comment] = ACTIONS(1369),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [aux_sym_FLOAT_token1] = ACTIONS(1369),
    [aux_sym_FLOAT_token2] = ACTIONS(1369),
    [aux_sym_FLOAT_token3] = ACTIONS(1369),
    [aux_sym_FLOAT_token4] = ACTIONS(1369),
    [aux_sym_INTEGER_token1] = ACTIONS(1369),
    [aux_sym_INTEGER_token2] = ACTIONS(1369),
    [aux_sym_INTEGER_token3] = ACTIONS(1371),
    [aux_sym_INTEGER_token4] = ACTIONS(1371),
    [anon_sym_DQUOTE] = ACTIONS(1369),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1369),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1371),
    [anon_sym_AT] = ACTIONS(1369),
  },
  [524] = {
    [ts_builtin_sym_end] = ACTIONS(1373),
    [anon_sym_COMMA] = ACTIONS(1373),
    [anon_sym_pub] = ACTIONS(1375),
    [anon_sym_test] = ACTIONS(1375),
    [anon_sym_comptime] = ACTIONS(1375),
    [anon_sym_export] = ACTIONS(1375),
    [anon_sym_extern] = ACTIONS(1375),
    [anon_sym_inline] = ACTIONS(1375),
    [anon_sym_noinline] = ACTIONS(1375),
    [anon_sym_threadlocal] = ACTIONS(1375),
    [anon_sym_usingnamespace] = ACTIONS(1375),
    [anon_sym_fn] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1375),
    [anon_sym_const] = ACTIONS(1375),
    [anon_sym_var] = ACTIONS(1375),
    [anon_sym_else] = ACTIONS(1375),
    [anon_sym_or] = ACTIONS(1375),
    [anon_sym_and] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1373),
    [anon_sym_RBRACE] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_DOT] = ACTIONS(1375),
    [anon_sym_error] = ACTIONS(1375),
    [anon_sym_false] = ACTIONS(1375),
    [anon_sym_null] = ACTIONS(1375),
    [anon_sym_anyframe] = ACTIONS(1375),
    [anon_sym_true] = ACTIONS(1375),
    [anon_sym_undefined] = ACTIONS(1375),
    [anon_sym_unreachable] = ACTIONS(1375),
    [sym_BuildinTypeExpr] = ACTIONS(1375),
    [anon_sym_packed] = ACTIONS(1375),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_switch] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(1373),
    [anon_sym_if] = ACTIONS(1375),
    [anon_sym_while] = ACTIONS(1375),
    [anon_sym_for] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_EQ_EQ] = ACTIONS(1373),
    [anon_sym_BANG_EQ] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_LT_EQ] = ACTIONS(1373),
    [anon_sym_GT_EQ] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_orelse] = ACTIONS(1375),
    [anon_sym_catch] = ACTIONS(1375),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1373),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_DASH] = ACTIONS(1375),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1373),
    [anon_sym_DASH_PERCENT] = ACTIONS(1373),
    [anon_sym_PLUS_PIPE] = ACTIONS(1373),
    [anon_sym_DASH_PIPE] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_SLASH] = ACTIONS(1375),
    [anon_sym_PERCENT] = ACTIONS(1373),
    [anon_sym_STAR_STAR] = ACTIONS(1373),
    [anon_sym_STAR_PERCENT] = ACTIONS(1373),
    [anon_sym_STAR_PIPE] = ACTIONS(1373),
    [anon_sym_QMARK] = ACTIONS(1373),
    [anon_sym_DOT_STAR] = ACTIONS(1373),
    [anon_sym_DOT_QMARK] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(1375),
    [anon_sym_opaque] = ACTIONS(1375),
    [anon_sym_enum] = ACTIONS(1375),
    [anon_sym_union] = ACTIONS(1375),
    [sym_doc_comment] = ACTIONS(1373),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1373),
    [aux_sym_FLOAT_token1] = ACTIONS(1373),
    [aux_sym_FLOAT_token2] = ACTIONS(1373),
    [aux_sym_FLOAT_token3] = ACTIONS(1373),
    [aux_sym_FLOAT_token4] = ACTIONS(1373),
    [aux_sym_INTEGER_token1] = ACTIONS(1373),
    [aux_sym_INTEGER_token2] = ACTIONS(1373),
    [aux_sym_INTEGER_token3] = ACTIONS(1375),
    [aux_sym_INTEGER_token4] = ACTIONS(1375),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1373),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(1373),
  },
  [525] = {
    [ts_builtin_sym_end] = ACTIONS(1377),
    [anon_sym_COMMA] = ACTIONS(1377),
    [anon_sym_pub] = ACTIONS(1379),
    [anon_sym_test] = ACTIONS(1379),
    [anon_sym_comptime] = ACTIONS(1379),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_extern] = ACTIONS(1379),
    [anon_sym_inline] = ACTIONS(1379),
    [anon_sym_noinline] = ACTIONS(1379),
    [anon_sym_threadlocal] = ACTIONS(1379),
    [anon_sym_usingnamespace] = ACTIONS(1379),
    [anon_sym_fn] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_const] = ACTIONS(1379),
    [anon_sym_var] = ACTIONS(1379),
    [anon_sym_else] = ACTIONS(1379),
    [anon_sym_or] = ACTIONS(1379),
    [anon_sym_and] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_RBRACE] = ACTIONS(1377),
    [anon_sym_async] = ACTIONS(1379),
    [anon_sym_DOT] = ACTIONS(1379),
    [anon_sym_error] = ACTIONS(1379),
    [anon_sym_false] = ACTIONS(1379),
    [anon_sym_null] = ACTIONS(1379),
    [anon_sym_anyframe] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(1379),
    [anon_sym_undefined] = ACTIONS(1379),
    [anon_sym_unreachable] = ACTIONS(1379),
    [sym_BuildinTypeExpr] = ACTIONS(1379),
    [anon_sym_packed] = ACTIONS(1379),
    [anon_sym_LPAREN] = ACTIONS(1377),
    [anon_sym_switch] = ACTIONS(1379),
    [anon_sym_LBRACK] = ACTIONS(1377),
    [anon_sym_if] = ACTIONS(1379),
    [anon_sym_while] = ACTIONS(1379),
    [anon_sym_for] = ACTIONS(1379),
    [anon_sym_PIPE] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_EQ_EQ] = ACTIONS(1377),
    [anon_sym_BANG_EQ] = ACTIONS(1377),
    [anon_sym_LT] = ACTIONS(1379),
    [anon_sym_GT] = ACTIONS(1379),
    [anon_sym_LT_EQ] = ACTIONS(1377),
    [anon_sym_GT_EQ] = ACTIONS(1377),
    [anon_sym_AMP] = ACTIONS(1377),
    [anon_sym_CARET] = ACTIONS(1377),
    [anon_sym_orelse] = ACTIONS(1379),
    [anon_sym_catch] = ACTIONS(1379),
    [anon_sym_LT_LT] = ACTIONS(1379),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1377),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1377),
    [anon_sym_DASH_PERCENT] = ACTIONS(1377),
    [anon_sym_PLUS_PIPE] = ACTIONS(1377),
    [anon_sym_DASH_PIPE] = ACTIONS(1377),
    [anon_sym_PIPE_PIPE] = ACTIONS(1377),
    [anon_sym_SLASH] = ACTIONS(1379),
    [anon_sym_PERCENT] = ACTIONS(1377),
    [anon_sym_STAR_STAR] = ACTIONS(1377),
    [anon_sym_STAR_PERCENT] = ACTIONS(1377),
    [anon_sym_STAR_PIPE] = ACTIONS(1377),
    [anon_sym_QMARK] = ACTIONS(1377),
    [anon_sym_DOT_STAR] = ACTIONS(1377),
    [anon_sym_DOT_QMARK] = ACTIONS(1377),
    [anon_sym_struct] = ACTIONS(1379),
    [anon_sym_opaque] = ACTIONS(1379),
    [anon_sym_enum] = ACTIONS(1379),
    [anon_sym_union] = ACTIONS(1379),
    [sym_doc_comment] = ACTIONS(1377),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1377),
    [aux_sym_FLOAT_token1] = ACTIONS(1377),
    [aux_sym_FLOAT_token2] = ACTIONS(1377),
    [aux_sym_FLOAT_token3] = ACTIONS(1377),
    [aux_sym_FLOAT_token4] = ACTIONS(1377),
    [aux_sym_INTEGER_token1] = ACTIONS(1377),
    [aux_sym_INTEGER_token2] = ACTIONS(1377),
    [aux_sym_INTEGER_token3] = ACTIONS(1379),
    [aux_sym_INTEGER_token4] = ACTIONS(1379),
    [anon_sym_DQUOTE] = ACTIONS(1377),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1377),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1379),
    [anon_sym_AT] = ACTIONS(1377),
  },
  [526] = {
    [ts_builtin_sym_end] = ACTIONS(1381),
    [anon_sym_COMMA] = ACTIONS(1381),
    [anon_sym_pub] = ACTIONS(1383),
    [anon_sym_test] = ACTIONS(1383),
    [anon_sym_comptime] = ACTIONS(1383),
    [anon_sym_export] = ACTIONS(1383),
    [anon_sym_extern] = ACTIONS(1383),
    [anon_sym_inline] = ACTIONS(1383),
    [anon_sym_noinline] = ACTIONS(1383),
    [anon_sym_threadlocal] = ACTIONS(1383),
    [anon_sym_usingnamespace] = ACTIONS(1383),
    [anon_sym_fn] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_const] = ACTIONS(1383),
    [anon_sym_var] = ACTIONS(1383),
    [anon_sym_else] = ACTIONS(1383),
    [anon_sym_or] = ACTIONS(1383),
    [anon_sym_and] = ACTIONS(1383),
    [anon_sym_LBRACE] = ACTIONS(1381),
    [anon_sym_RBRACE] = ACTIONS(1381),
    [anon_sym_async] = ACTIONS(1383),
    [anon_sym_DOT] = ACTIONS(1383),
    [anon_sym_error] = ACTIONS(1383),
    [anon_sym_false] = ACTIONS(1383),
    [anon_sym_null] = ACTIONS(1383),
    [anon_sym_anyframe] = ACTIONS(1383),
    [anon_sym_true] = ACTIONS(1383),
    [anon_sym_undefined] = ACTIONS(1383),
    [anon_sym_unreachable] = ACTIONS(1383),
    [sym_BuildinTypeExpr] = ACTIONS(1383),
    [anon_sym_packed] = ACTIONS(1383),
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_switch] = ACTIONS(1383),
    [anon_sym_LBRACK] = ACTIONS(1381),
    [anon_sym_if] = ACTIONS(1383),
    [anon_sym_while] = ACTIONS(1383),
    [anon_sym_for] = ACTIONS(1383),
    [anon_sym_PIPE] = ACTIONS(1383),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_EQ_EQ] = ACTIONS(1381),
    [anon_sym_BANG_EQ] = ACTIONS(1381),
    [anon_sym_LT] = ACTIONS(1383),
    [anon_sym_GT] = ACTIONS(1383),
    [anon_sym_LT_EQ] = ACTIONS(1381),
    [anon_sym_GT_EQ] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_orelse] = ACTIONS(1383),
    [anon_sym_catch] = ACTIONS(1383),
    [anon_sym_LT_LT] = ACTIONS(1383),
    [anon_sym_GT_GT] = ACTIONS(1381),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(1383),
    [anon_sym_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1381),
    [anon_sym_DASH_PERCENT] = ACTIONS(1381),
    [anon_sym_PLUS_PIPE] = ACTIONS(1381),
    [anon_sym_DASH_PIPE] = ACTIONS(1381),
    [anon_sym_PIPE_PIPE] = ACTIONS(1381),
    [anon_sym_SLASH] = ACTIONS(1383),
    [anon_sym_PERCENT] = ACTIONS(1381),
    [anon_sym_STAR_STAR] = ACTIONS(1381),
    [anon_sym_STAR_PERCENT] = ACTIONS(1381),
    [anon_sym_STAR_PIPE] = ACTIONS(1381),
    [anon_sym_QMARK] = ACTIONS(1381),
    [anon_sym_DOT_STAR] = ACTIONS(1381),
    [anon_sym_DOT_QMARK] = ACTIONS(1381),
    [anon_sym_struct] = ACTIONS(1383),
    [anon_sym_opaque] = ACTIONS(1383),
    [anon_sym_enum] = ACTIONS(1383),
    [anon_sym_union] = ACTIONS(1383),
    [sym_doc_comment] = ACTIONS(1381),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1381),
    [aux_sym_FLOAT_token1] = ACTIONS(1381),
    [aux_sym_FLOAT_token2] = ACTIONS(1381),
    [aux_sym_FLOAT_token3] = ACTIONS(1381),
    [aux_sym_FLOAT_token4] = ACTIONS(1381),
    [aux_sym_INTEGER_token1] = ACTIONS(1381),
    [aux_sym_INTEGER_token2] = ACTIONS(1381),
    [aux_sym_INTEGER_token3] = ACTIONS(1383),
    [aux_sym_INTEGER_token4] = ACTIONS(1383),
    [anon_sym_DQUOTE] = ACTIONS(1381),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1381),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1383),
    [anon_sym_AT] = ACTIONS(1381),
  },
  [527] = {
    [ts_builtin_sym_end] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(1385),
    [anon_sym_pub] = ACTIONS(1387),
    [anon_sym_test] = ACTIONS(1387),
    [anon_sym_comptime] = ACTIONS(1387),
    [anon_sym_export] = ACTIONS(1387),
    [anon_sym_extern] = ACTIONS(1387),
    [anon_sym_inline] = ACTIONS(1387),
    [anon_sym_noinline] = ACTIONS(1387),
    [anon_sym_threadlocal] = ACTIONS(1387),
    [anon_sym_usingnamespace] = ACTIONS(1387),
    [anon_sym_fn] = ACTIONS(1387),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_const] = ACTIONS(1387),
    [anon_sym_var] = ACTIONS(1387),
    [anon_sym_else] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(1387),
    [anon_sym_and] = ACTIONS(1387),
    [anon_sym_LBRACE] = ACTIONS(1385),
    [anon_sym_RBRACE] = ACTIONS(1385),
    [anon_sym_async] = ACTIONS(1387),
    [anon_sym_DOT] = ACTIONS(1387),
    [anon_sym_error] = ACTIONS(1387),
    [anon_sym_false] = ACTIONS(1387),
    [anon_sym_null] = ACTIONS(1387),
    [anon_sym_anyframe] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1387),
    [anon_sym_undefined] = ACTIONS(1387),
    [anon_sym_unreachable] = ACTIONS(1387),
    [sym_BuildinTypeExpr] = ACTIONS(1387),
    [anon_sym_packed] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1385),
    [anon_sym_switch] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1385),
    [anon_sym_if] = ACTIONS(1387),
    [anon_sym_while] = ACTIONS(1387),
    [anon_sym_for] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_EQ_EQ] = ACTIONS(1385),
    [anon_sym_BANG_EQ] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_LT_EQ] = ACTIONS(1385),
    [anon_sym_GT_EQ] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1385),
    [anon_sym_CARET] = ACTIONS(1385),
    [anon_sym_orelse] = ACTIONS(1387),
    [anon_sym_catch] = ACTIONS(1387),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1385),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1385),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1385),
    [anon_sym_DASH_PERCENT] = ACTIONS(1385),
    [anon_sym_PLUS_PIPE] = ACTIONS(1385),
    [anon_sym_DASH_PIPE] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1385),
    [anon_sym_STAR_STAR] = ACTIONS(1385),
    [anon_sym_STAR_PERCENT] = ACTIONS(1385),
    [anon_sym_STAR_PIPE] = ACTIONS(1385),
    [anon_sym_QMARK] = ACTIONS(1385),
    [anon_sym_DOT_STAR] = ACTIONS(1385),
    [anon_sym_DOT_QMARK] = ACTIONS(1385),
    [anon_sym_struct] = ACTIONS(1387),
    [anon_sym_opaque] = ACTIONS(1387),
    [anon_sym_enum] = ACTIONS(1387),
    [anon_sym_union] = ACTIONS(1387),
    [sym_doc_comment] = ACTIONS(1385),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1385),
    [aux_sym_FLOAT_token1] = ACTIONS(1385),
    [aux_sym_FLOAT_token2] = ACTIONS(1385),
    [aux_sym_FLOAT_token3] = ACTIONS(1385),
    [aux_sym_FLOAT_token4] = ACTIONS(1385),
    [aux_sym_INTEGER_token1] = ACTIONS(1385),
    [aux_sym_INTEGER_token2] = ACTIONS(1385),
    [aux_sym_INTEGER_token3] = ACTIONS(1387),
    [aux_sym_INTEGER_token4] = ACTIONS(1387),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1385),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1387),
    [anon_sym_AT] = ACTIONS(1385),
  },
  [528] = {
    [ts_builtin_sym_end] = ACTIONS(1389),
    [anon_sym_COMMA] = ACTIONS(1389),
    [anon_sym_pub] = ACTIONS(1391),
    [anon_sym_test] = ACTIONS(1391),
    [anon_sym_comptime] = ACTIONS(1391),
    [anon_sym_export] = ACTIONS(1391),
    [anon_sym_extern] = ACTIONS(1391),
    [anon_sym_inline] = ACTIONS(1391),
    [anon_sym_noinline] = ACTIONS(1391),
    [anon_sym_threadlocal] = ACTIONS(1391),
    [anon_sym_usingnamespace] = ACTIONS(1391),
    [anon_sym_fn] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1391),
    [anon_sym_const] = ACTIONS(1391),
    [anon_sym_var] = ACTIONS(1391),
    [anon_sym_else] = ACTIONS(1391),
    [anon_sym_or] = ACTIONS(1391),
    [anon_sym_and] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_RBRACE] = ACTIONS(1389),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_DOT] = ACTIONS(1391),
    [anon_sym_error] = ACTIONS(1391),
    [anon_sym_false] = ACTIONS(1391),
    [anon_sym_null] = ACTIONS(1391),
    [anon_sym_anyframe] = ACTIONS(1391),
    [anon_sym_true] = ACTIONS(1391),
    [anon_sym_undefined] = ACTIONS(1391),
    [anon_sym_unreachable] = ACTIONS(1391),
    [sym_BuildinTypeExpr] = ACTIONS(1391),
    [anon_sym_packed] = ACTIONS(1391),
    [anon_sym_LPAREN] = ACTIONS(1389),
    [anon_sym_switch] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1389),
    [anon_sym_if] = ACTIONS(1391),
    [anon_sym_while] = ACTIONS(1391),
    [anon_sym_for] = ACTIONS(1391),
    [anon_sym_PIPE] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_EQ_EQ] = ACTIONS(1389),
    [anon_sym_BANG_EQ] = ACTIONS(1389),
    [anon_sym_LT] = ACTIONS(1391),
    [anon_sym_GT] = ACTIONS(1391),
    [anon_sym_LT_EQ] = ACTIONS(1389),
    [anon_sym_GT_EQ] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_orelse] = ACTIONS(1391),
    [anon_sym_catch] = ACTIONS(1391),
    [anon_sym_LT_LT] = ACTIONS(1391),
    [anon_sym_GT_GT] = ACTIONS(1389),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1391),
    [anon_sym_DASH] = ACTIONS(1391),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1389),
    [anon_sym_DASH_PERCENT] = ACTIONS(1389),
    [anon_sym_PLUS_PIPE] = ACTIONS(1389),
    [anon_sym_DASH_PIPE] = ACTIONS(1389),
    [anon_sym_PIPE_PIPE] = ACTIONS(1389),
    [anon_sym_SLASH] = ACTIONS(1391),
    [anon_sym_PERCENT] = ACTIONS(1389),
    [anon_sym_STAR_STAR] = ACTIONS(1389),
    [anon_sym_STAR_PERCENT] = ACTIONS(1389),
    [anon_sym_STAR_PIPE] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1389),
    [anon_sym_DOT_STAR] = ACTIONS(1389),
    [anon_sym_DOT_QMARK] = ACTIONS(1389),
    [anon_sym_struct] = ACTIONS(1391),
    [anon_sym_opaque] = ACTIONS(1391),
    [anon_sym_enum] = ACTIONS(1391),
    [anon_sym_union] = ACTIONS(1391),
    [sym_doc_comment] = ACTIONS(1389),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1389),
    [aux_sym_FLOAT_token1] = ACTIONS(1389),
    [aux_sym_FLOAT_token2] = ACTIONS(1389),
    [aux_sym_FLOAT_token3] = ACTIONS(1389),
    [aux_sym_FLOAT_token4] = ACTIONS(1389),
    [aux_sym_INTEGER_token1] = ACTIONS(1389),
    [aux_sym_INTEGER_token2] = ACTIONS(1389),
    [aux_sym_INTEGER_token3] = ACTIONS(1391),
    [aux_sym_INTEGER_token4] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1389),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1389),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1391),
    [anon_sym_AT] = ACTIONS(1389),
  },
  [529] = {
    [ts_builtin_sym_end] = ACTIONS(1393),
    [anon_sym_COMMA] = ACTIONS(1393),
    [anon_sym_pub] = ACTIONS(1395),
    [anon_sym_test] = ACTIONS(1395),
    [anon_sym_comptime] = ACTIONS(1395),
    [anon_sym_export] = ACTIONS(1395),
    [anon_sym_extern] = ACTIONS(1395),
    [anon_sym_inline] = ACTIONS(1395),
    [anon_sym_noinline] = ACTIONS(1395),
    [anon_sym_threadlocal] = ACTIONS(1395),
    [anon_sym_usingnamespace] = ACTIONS(1395),
    [anon_sym_fn] = ACTIONS(1395),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_const] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1395),
    [anon_sym_else] = ACTIONS(1395),
    [anon_sym_or] = ACTIONS(1395),
    [anon_sym_and] = ACTIONS(1395),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_RBRACE] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_DOT] = ACTIONS(1395),
    [anon_sym_error] = ACTIONS(1395),
    [anon_sym_false] = ACTIONS(1395),
    [anon_sym_null] = ACTIONS(1395),
    [anon_sym_anyframe] = ACTIONS(1395),
    [anon_sym_true] = ACTIONS(1395),
    [anon_sym_undefined] = ACTIONS(1395),
    [anon_sym_unreachable] = ACTIONS(1395),
    [sym_BuildinTypeExpr] = ACTIONS(1395),
    [anon_sym_packed] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_switch] = ACTIONS(1395),
    [anon_sym_LBRACK] = ACTIONS(1393),
    [anon_sym_if] = ACTIONS(1395),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_for] = ACTIONS(1395),
    [anon_sym_PIPE] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(1395),
    [anon_sym_EQ_EQ] = ACTIONS(1393),
    [anon_sym_BANG_EQ] = ACTIONS(1393),
    [anon_sym_LT] = ACTIONS(1395),
    [anon_sym_GT] = ACTIONS(1395),
    [anon_sym_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1393),
    [anon_sym_CARET] = ACTIONS(1393),
    [anon_sym_orelse] = ACTIONS(1395),
    [anon_sym_catch] = ACTIONS(1395),
    [anon_sym_LT_LT] = ACTIONS(1395),
    [anon_sym_GT_GT] = ACTIONS(1393),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1393),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_DASH] = ACTIONS(1395),
    [anon_sym_PLUS_PLUS] = ACTIONS(1393),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1393),
    [anon_sym_DASH_PERCENT] = ACTIONS(1393),
    [anon_sym_PLUS_PIPE] = ACTIONS(1393),
    [anon_sym_DASH_PIPE] = ACTIONS(1393),
    [anon_sym_PIPE_PIPE] = ACTIONS(1393),
    [anon_sym_SLASH] = ACTIONS(1395),
    [anon_sym_PERCENT] = ACTIONS(1393),
    [anon_sym_STAR_STAR] = ACTIONS(1393),
    [anon_sym_STAR_PERCENT] = ACTIONS(1393),
    [anon_sym_STAR_PIPE] = ACTIONS(1393),
    [anon_sym_QMARK] = ACTIONS(1393),
    [anon_sym_DOT_STAR] = ACTIONS(1393),
    [anon_sym_DOT_QMARK] = ACTIONS(1393),
    [anon_sym_struct] = ACTIONS(1395),
    [anon_sym_opaque] = ACTIONS(1395),
    [anon_sym_enum] = ACTIONS(1395),
    [anon_sym_union] = ACTIONS(1395),
    [sym_doc_comment] = ACTIONS(1393),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1393),
    [aux_sym_FLOAT_token1] = ACTIONS(1393),
    [aux_sym_FLOAT_token2] = ACTIONS(1393),
    [aux_sym_FLOAT_token3] = ACTIONS(1393),
    [aux_sym_FLOAT_token4] = ACTIONS(1393),
    [aux_sym_INTEGER_token1] = ACTIONS(1393),
    [aux_sym_INTEGER_token2] = ACTIONS(1393),
    [aux_sym_INTEGER_token3] = ACTIONS(1395),
    [aux_sym_INTEGER_token4] = ACTIONS(1395),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1393),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1395),
    [anon_sym_AT] = ACTIONS(1393),
  },
  [530] = {
    [ts_builtin_sym_end] = ACTIONS(1397),
    [anon_sym_COMMA] = ACTIONS(1397),
    [anon_sym_pub] = ACTIONS(1399),
    [anon_sym_test] = ACTIONS(1399),
    [anon_sym_comptime] = ACTIONS(1399),
    [anon_sym_export] = ACTIONS(1399),
    [anon_sym_extern] = ACTIONS(1399),
    [anon_sym_inline] = ACTIONS(1399),
    [anon_sym_noinline] = ACTIONS(1399),
    [anon_sym_threadlocal] = ACTIONS(1399),
    [anon_sym_usingnamespace] = ACTIONS(1399),
    [anon_sym_fn] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_const] = ACTIONS(1399),
    [anon_sym_var] = ACTIONS(1399),
    [anon_sym_else] = ACTIONS(1399),
    [anon_sym_or] = ACTIONS(1399),
    [anon_sym_and] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_RBRACE] = ACTIONS(1397),
    [anon_sym_async] = ACTIONS(1399),
    [anon_sym_DOT] = ACTIONS(1399),
    [anon_sym_error] = ACTIONS(1399),
    [anon_sym_false] = ACTIONS(1399),
    [anon_sym_null] = ACTIONS(1399),
    [anon_sym_anyframe] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_undefined] = ACTIONS(1399),
    [anon_sym_unreachable] = ACTIONS(1399),
    [sym_BuildinTypeExpr] = ACTIONS(1399),
    [anon_sym_packed] = ACTIONS(1399),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_switch] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(1397),
    [anon_sym_if] = ACTIONS(1399),
    [anon_sym_while] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1399),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_EQ_EQ] = ACTIONS(1397),
    [anon_sym_BANG_EQ] = ACTIONS(1397),
    [anon_sym_LT] = ACTIONS(1399),
    [anon_sym_GT] = ACTIONS(1399),
    [anon_sym_LT_EQ] = ACTIONS(1397),
    [anon_sym_GT_EQ] = ACTIONS(1397),
    [anon_sym_AMP] = ACTIONS(1397),
    [anon_sym_CARET] = ACTIONS(1397),
    [anon_sym_orelse] = ACTIONS(1399),
    [anon_sym_catch] = ACTIONS(1399),
    [anon_sym_LT_LT] = ACTIONS(1399),
    [anon_sym_GT_GT] = ACTIONS(1397),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1399),
    [anon_sym_DASH] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1397),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1397),
    [anon_sym_DASH_PERCENT] = ACTIONS(1397),
    [anon_sym_PLUS_PIPE] = ACTIONS(1397),
    [anon_sym_DASH_PIPE] = ACTIONS(1397),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_SLASH] = ACTIONS(1399),
    [anon_sym_PERCENT] = ACTIONS(1397),
    [anon_sym_STAR_STAR] = ACTIONS(1397),
    [anon_sym_STAR_PERCENT] = ACTIONS(1397),
    [anon_sym_STAR_PIPE] = ACTIONS(1397),
    [anon_sym_QMARK] = ACTIONS(1397),
    [anon_sym_DOT_STAR] = ACTIONS(1397),
    [anon_sym_DOT_QMARK] = ACTIONS(1397),
    [anon_sym_struct] = ACTIONS(1399),
    [anon_sym_opaque] = ACTIONS(1399),
    [anon_sym_enum] = ACTIONS(1399),
    [anon_sym_union] = ACTIONS(1399),
    [sym_doc_comment] = ACTIONS(1397),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1397),
    [aux_sym_FLOAT_token1] = ACTIONS(1397),
    [aux_sym_FLOAT_token2] = ACTIONS(1397),
    [aux_sym_FLOAT_token3] = ACTIONS(1397),
    [aux_sym_FLOAT_token4] = ACTIONS(1397),
    [aux_sym_INTEGER_token1] = ACTIONS(1397),
    [aux_sym_INTEGER_token2] = ACTIONS(1397),
    [aux_sym_INTEGER_token3] = ACTIONS(1399),
    [aux_sym_INTEGER_token4] = ACTIONS(1399),
    [anon_sym_DQUOTE] = ACTIONS(1397),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1397),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1399),
    [anon_sym_AT] = ACTIONS(1397),
  },
  [531] = {
    [ts_builtin_sym_end] = ACTIONS(1401),
    [anon_sym_COMMA] = ACTIONS(1401),
    [anon_sym_pub] = ACTIONS(1403),
    [anon_sym_test] = ACTIONS(1403),
    [anon_sym_comptime] = ACTIONS(1403),
    [anon_sym_export] = ACTIONS(1403),
    [anon_sym_extern] = ACTIONS(1403),
    [anon_sym_inline] = ACTIONS(1403),
    [anon_sym_noinline] = ACTIONS(1403),
    [anon_sym_threadlocal] = ACTIONS(1403),
    [anon_sym_usingnamespace] = ACTIONS(1403),
    [anon_sym_fn] = ACTIONS(1403),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_const] = ACTIONS(1403),
    [anon_sym_var] = ACTIONS(1403),
    [anon_sym_else] = ACTIONS(1403),
    [anon_sym_or] = ACTIONS(1403),
    [anon_sym_and] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_RBRACE] = ACTIONS(1401),
    [anon_sym_async] = ACTIONS(1403),
    [anon_sym_DOT] = ACTIONS(1403),
    [anon_sym_error] = ACTIONS(1403),
    [anon_sym_false] = ACTIONS(1403),
    [anon_sym_null] = ACTIONS(1403),
    [anon_sym_anyframe] = ACTIONS(1403),
    [anon_sym_true] = ACTIONS(1403),
    [anon_sym_undefined] = ACTIONS(1403),
    [anon_sym_unreachable] = ACTIONS(1403),
    [sym_BuildinTypeExpr] = ACTIONS(1403),
    [anon_sym_packed] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1401),
    [anon_sym_switch] = ACTIONS(1403),
    [anon_sym_LBRACK] = ACTIONS(1401),
    [anon_sym_if] = ACTIONS(1403),
    [anon_sym_while] = ACTIONS(1403),
    [anon_sym_for] = ACTIONS(1403),
    [anon_sym_PIPE] = ACTIONS(1403),
    [anon_sym_STAR] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1401),
    [anon_sym_BANG_EQ] = ACTIONS(1401),
    [anon_sym_LT] = ACTIONS(1403),
    [anon_sym_GT] = ACTIONS(1403),
    [anon_sym_LT_EQ] = ACTIONS(1401),
    [anon_sym_GT_EQ] = ACTIONS(1401),
    [anon_sym_AMP] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1401),
    [anon_sym_orelse] = ACTIONS(1403),
    [anon_sym_catch] = ACTIONS(1403),
    [anon_sym_LT_LT] = ACTIONS(1403),
    [anon_sym_GT_GT] = ACTIONS(1401),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1401),
    [anon_sym_PLUS] = ACTIONS(1403),
    [anon_sym_DASH] = ACTIONS(1403),
    [anon_sym_PLUS_PLUS] = ACTIONS(1401),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1401),
    [anon_sym_DASH_PERCENT] = ACTIONS(1401),
    [anon_sym_PLUS_PIPE] = ACTIONS(1401),
    [anon_sym_DASH_PIPE] = ACTIONS(1401),
    [anon_sym_PIPE_PIPE] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1403),
    [anon_sym_PERCENT] = ACTIONS(1401),
    [anon_sym_STAR_STAR] = ACTIONS(1401),
    [anon_sym_STAR_PERCENT] = ACTIONS(1401),
    [anon_sym_STAR_PIPE] = ACTIONS(1401),
    [anon_sym_QMARK] = ACTIONS(1401),
    [anon_sym_DOT_STAR] = ACTIONS(1401),
    [anon_sym_DOT_QMARK] = ACTIONS(1401),
    [anon_sym_struct] = ACTIONS(1403),
    [anon_sym_opaque] = ACTIONS(1403),
    [anon_sym_enum] = ACTIONS(1403),
    [anon_sym_union] = ACTIONS(1403),
    [sym_doc_comment] = ACTIONS(1401),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1401),
    [aux_sym_FLOAT_token1] = ACTIONS(1401),
    [aux_sym_FLOAT_token2] = ACTIONS(1401),
    [aux_sym_FLOAT_token3] = ACTIONS(1401),
    [aux_sym_FLOAT_token4] = ACTIONS(1401),
    [aux_sym_INTEGER_token1] = ACTIONS(1401),
    [aux_sym_INTEGER_token2] = ACTIONS(1401),
    [aux_sym_INTEGER_token3] = ACTIONS(1403),
    [aux_sym_INTEGER_token4] = ACTIONS(1403),
    [anon_sym_DQUOTE] = ACTIONS(1401),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1401),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1403),
    [anon_sym_AT] = ACTIONS(1401),
  },
  [532] = {
    [ts_builtin_sym_end] = ACTIONS(1405),
    [anon_sym_COMMA] = ACTIONS(1405),
    [anon_sym_pub] = ACTIONS(1407),
    [anon_sym_test] = ACTIONS(1407),
    [anon_sym_comptime] = ACTIONS(1407),
    [anon_sym_export] = ACTIONS(1407),
    [anon_sym_extern] = ACTIONS(1407),
    [anon_sym_inline] = ACTIONS(1407),
    [anon_sym_noinline] = ACTIONS(1407),
    [anon_sym_threadlocal] = ACTIONS(1407),
    [anon_sym_usingnamespace] = ACTIONS(1407),
    [anon_sym_fn] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1407),
    [anon_sym_const] = ACTIONS(1407),
    [anon_sym_var] = ACTIONS(1407),
    [anon_sym_else] = ACTIONS(1407),
    [anon_sym_or] = ACTIONS(1407),
    [anon_sym_and] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_RBRACE] = ACTIONS(1405),
    [anon_sym_async] = ACTIONS(1407),
    [anon_sym_DOT] = ACTIONS(1407),
    [anon_sym_error] = ACTIONS(1407),
    [anon_sym_false] = ACTIONS(1407),
    [anon_sym_null] = ACTIONS(1407),
    [anon_sym_anyframe] = ACTIONS(1407),
    [anon_sym_true] = ACTIONS(1407),
    [anon_sym_undefined] = ACTIONS(1407),
    [anon_sym_unreachable] = ACTIONS(1407),
    [sym_BuildinTypeExpr] = ACTIONS(1407),
    [anon_sym_packed] = ACTIONS(1407),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_switch] = ACTIONS(1407),
    [anon_sym_LBRACK] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_while] = ACTIONS(1407),
    [anon_sym_for] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1405),
    [anon_sym_GT_EQ] = ACTIONS(1405),
    [anon_sym_AMP] = ACTIONS(1405),
    [anon_sym_CARET] = ACTIONS(1405),
    [anon_sym_orelse] = ACTIONS(1407),
    [anon_sym_catch] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1407),
    [anon_sym_GT_GT] = ACTIONS(1405),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1405),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1405),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1405),
    [anon_sym_DASH_PERCENT] = ACTIONS(1405),
    [anon_sym_PLUS_PIPE] = ACTIONS(1405),
    [anon_sym_DASH_PIPE] = ACTIONS(1405),
    [anon_sym_PIPE_PIPE] = ACTIONS(1405),
    [anon_sym_SLASH] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(1405),
    [anon_sym_STAR_STAR] = ACTIONS(1405),
    [anon_sym_STAR_PERCENT] = ACTIONS(1405),
    [anon_sym_STAR_PIPE] = ACTIONS(1405),
    [anon_sym_QMARK] = ACTIONS(1405),
    [anon_sym_DOT_STAR] = ACTIONS(1405),
    [anon_sym_DOT_QMARK] = ACTIONS(1405),
    [anon_sym_struct] = ACTIONS(1407),
    [anon_sym_opaque] = ACTIONS(1407),
    [anon_sym_enum] = ACTIONS(1407),
    [anon_sym_union] = ACTIONS(1407),
    [sym_doc_comment] = ACTIONS(1405),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1405),
    [aux_sym_FLOAT_token1] = ACTIONS(1405),
    [aux_sym_FLOAT_token2] = ACTIONS(1405),
    [aux_sym_FLOAT_token3] = ACTIONS(1405),
    [aux_sym_FLOAT_token4] = ACTIONS(1405),
    [aux_sym_INTEGER_token1] = ACTIONS(1405),
    [aux_sym_INTEGER_token2] = ACTIONS(1405),
    [aux_sym_INTEGER_token3] = ACTIONS(1407),
    [aux_sym_INTEGER_token4] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1405),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1405),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1407),
    [anon_sym_AT] = ACTIONS(1405),
  },
  [533] = {
    [ts_builtin_sym_end] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1409),
    [anon_sym_pub] = ACTIONS(1411),
    [anon_sym_test] = ACTIONS(1411),
    [anon_sym_comptime] = ACTIONS(1411),
    [anon_sym_export] = ACTIONS(1411),
    [anon_sym_extern] = ACTIONS(1411),
    [anon_sym_inline] = ACTIONS(1411),
    [anon_sym_noinline] = ACTIONS(1411),
    [anon_sym_threadlocal] = ACTIONS(1411),
    [anon_sym_usingnamespace] = ACTIONS(1411),
    [anon_sym_fn] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_const] = ACTIONS(1411),
    [anon_sym_var] = ACTIONS(1411),
    [anon_sym_else] = ACTIONS(1411),
    [anon_sym_or] = ACTIONS(1411),
    [anon_sym_and] = ACTIONS(1411),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_async] = ACTIONS(1411),
    [anon_sym_DOT] = ACTIONS(1411),
    [anon_sym_error] = ACTIONS(1411),
    [anon_sym_false] = ACTIONS(1411),
    [anon_sym_null] = ACTIONS(1411),
    [anon_sym_anyframe] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1411),
    [anon_sym_undefined] = ACTIONS(1411),
    [anon_sym_unreachable] = ACTIONS(1411),
    [sym_BuildinTypeExpr] = ACTIONS(1411),
    [anon_sym_packed] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1411),
    [anon_sym_LBRACK] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1411),
    [anon_sym_while] = ACTIONS(1411),
    [anon_sym_for] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(1411),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_CARET] = ACTIONS(1409),
    [anon_sym_orelse] = ACTIONS(1411),
    [anon_sym_catch] = ACTIONS(1411),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1409),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1411),
    [anon_sym_DASH] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1409),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1409),
    [anon_sym_DASH_PERCENT] = ACTIONS(1409),
    [anon_sym_PLUS_PIPE] = ACTIONS(1409),
    [anon_sym_DASH_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1411),
    [anon_sym_PERCENT] = ACTIONS(1409),
    [anon_sym_STAR_STAR] = ACTIONS(1409),
    [anon_sym_STAR_PERCENT] = ACTIONS(1409),
    [anon_sym_STAR_PIPE] = ACTIONS(1409),
    [anon_sym_QMARK] = ACTIONS(1409),
    [anon_sym_DOT_STAR] = ACTIONS(1409),
    [anon_sym_DOT_QMARK] = ACTIONS(1409),
    [anon_sym_struct] = ACTIONS(1411),
    [anon_sym_opaque] = ACTIONS(1411),
    [anon_sym_enum] = ACTIONS(1411),
    [anon_sym_union] = ACTIONS(1411),
    [sym_doc_comment] = ACTIONS(1409),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [aux_sym_FLOAT_token1] = ACTIONS(1409),
    [aux_sym_FLOAT_token2] = ACTIONS(1409),
    [aux_sym_FLOAT_token3] = ACTIONS(1409),
    [aux_sym_FLOAT_token4] = ACTIONS(1409),
    [aux_sym_INTEGER_token1] = ACTIONS(1409),
    [aux_sym_INTEGER_token2] = ACTIONS(1409),
    [aux_sym_INTEGER_token3] = ACTIONS(1411),
    [aux_sym_INTEGER_token4] = ACTIONS(1411),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1409),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1411),
    [anon_sym_AT] = ACTIONS(1409),
  },
  [534] = {
    [ts_builtin_sym_end] = ACTIONS(1413),
    [anon_sym_COMMA] = ACTIONS(1413),
    [anon_sym_pub] = ACTIONS(1415),
    [anon_sym_test] = ACTIONS(1415),
    [anon_sym_comptime] = ACTIONS(1415),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_extern] = ACTIONS(1415),
    [anon_sym_inline] = ACTIONS(1415),
    [anon_sym_noinline] = ACTIONS(1415),
    [anon_sym_threadlocal] = ACTIONS(1415),
    [anon_sym_usingnamespace] = ACTIONS(1415),
    [anon_sym_fn] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_const] = ACTIONS(1415),
    [anon_sym_var] = ACTIONS(1415),
    [anon_sym_else] = ACTIONS(1415),
    [anon_sym_or] = ACTIONS(1415),
    [anon_sym_and] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(1413),
    [anon_sym_RBRACE] = ACTIONS(1413),
    [anon_sym_async] = ACTIONS(1415),
    [anon_sym_DOT] = ACTIONS(1415),
    [anon_sym_error] = ACTIONS(1415),
    [anon_sym_false] = ACTIONS(1415),
    [anon_sym_null] = ACTIONS(1415),
    [anon_sym_anyframe] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(1415),
    [anon_sym_undefined] = ACTIONS(1415),
    [anon_sym_unreachable] = ACTIONS(1415),
    [sym_BuildinTypeExpr] = ACTIONS(1415),
    [anon_sym_packed] = ACTIONS(1415),
    [anon_sym_LPAREN] = ACTIONS(1413),
    [anon_sym_switch] = ACTIONS(1415),
    [anon_sym_LBRACK] = ACTIONS(1413),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_while] = ACTIONS(1415),
    [anon_sym_for] = ACTIONS(1415),
    [anon_sym_PIPE] = ACTIONS(1415),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_EQ_EQ] = ACTIONS(1413),
    [anon_sym_BANG_EQ] = ACTIONS(1413),
    [anon_sym_LT] = ACTIONS(1415),
    [anon_sym_GT] = ACTIONS(1415),
    [anon_sym_LT_EQ] = ACTIONS(1413),
    [anon_sym_GT_EQ] = ACTIONS(1413),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_CARET] = ACTIONS(1413),
    [anon_sym_orelse] = ACTIONS(1415),
    [anon_sym_catch] = ACTIONS(1415),
    [anon_sym_LT_LT] = ACTIONS(1415),
    [anon_sym_GT_GT] = ACTIONS(1413),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_DASH] = ACTIONS(1415),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1413),
    [anon_sym_DASH_PERCENT] = ACTIONS(1413),
    [anon_sym_PLUS_PIPE] = ACTIONS(1413),
    [anon_sym_DASH_PIPE] = ACTIONS(1413),
    [anon_sym_PIPE_PIPE] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1415),
    [anon_sym_PERCENT] = ACTIONS(1413),
    [anon_sym_STAR_STAR] = ACTIONS(1413),
    [anon_sym_STAR_PERCENT] = ACTIONS(1413),
    [anon_sym_STAR_PIPE] = ACTIONS(1413),
    [anon_sym_QMARK] = ACTIONS(1413),
    [anon_sym_DOT_STAR] = ACTIONS(1413),
    [anon_sym_DOT_QMARK] = ACTIONS(1413),
    [anon_sym_struct] = ACTIONS(1415),
    [anon_sym_opaque] = ACTIONS(1415),
    [anon_sym_enum] = ACTIONS(1415),
    [anon_sym_union] = ACTIONS(1415),
    [sym_doc_comment] = ACTIONS(1413),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [aux_sym_FLOAT_token1] = ACTIONS(1413),
    [aux_sym_FLOAT_token2] = ACTIONS(1413),
    [aux_sym_FLOAT_token3] = ACTIONS(1413),
    [aux_sym_FLOAT_token4] = ACTIONS(1413),
    [aux_sym_INTEGER_token1] = ACTIONS(1413),
    [aux_sym_INTEGER_token2] = ACTIONS(1413),
    [aux_sym_INTEGER_token3] = ACTIONS(1415),
    [aux_sym_INTEGER_token4] = ACTIONS(1415),
    [anon_sym_DQUOTE] = ACTIONS(1413),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1413),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1415),
    [anon_sym_AT] = ACTIONS(1413),
  },
  [535] = {
    [ts_builtin_sym_end] = ACTIONS(1417),
    [anon_sym_COMMA] = ACTIONS(1417),
    [anon_sym_pub] = ACTIONS(1419),
    [anon_sym_test] = ACTIONS(1419),
    [anon_sym_comptime] = ACTIONS(1419),
    [anon_sym_export] = ACTIONS(1419),
    [anon_sym_extern] = ACTIONS(1419),
    [anon_sym_inline] = ACTIONS(1419),
    [anon_sym_noinline] = ACTIONS(1419),
    [anon_sym_threadlocal] = ACTIONS(1419),
    [anon_sym_usingnamespace] = ACTIONS(1419),
    [anon_sym_fn] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_const] = ACTIONS(1419),
    [anon_sym_var] = ACTIONS(1419),
    [anon_sym_else] = ACTIONS(1419),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_and] = ACTIONS(1419),
    [anon_sym_LBRACE] = ACTIONS(1417),
    [anon_sym_RBRACE] = ACTIONS(1417),
    [anon_sym_async] = ACTIONS(1419),
    [anon_sym_DOT] = ACTIONS(1419),
    [anon_sym_error] = ACTIONS(1419),
    [anon_sym_false] = ACTIONS(1419),
    [anon_sym_null] = ACTIONS(1419),
    [anon_sym_anyframe] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1419),
    [anon_sym_undefined] = ACTIONS(1419),
    [anon_sym_unreachable] = ACTIONS(1419),
    [sym_BuildinTypeExpr] = ACTIONS(1419),
    [anon_sym_packed] = ACTIONS(1419),
    [anon_sym_LPAREN] = ACTIONS(1417),
    [anon_sym_switch] = ACTIONS(1419),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_if] = ACTIONS(1419),
    [anon_sym_while] = ACTIONS(1419),
    [anon_sym_for] = ACTIONS(1419),
    [anon_sym_PIPE] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_EQ_EQ] = ACTIONS(1417),
    [anon_sym_BANG_EQ] = ACTIONS(1417),
    [anon_sym_LT] = ACTIONS(1419),
    [anon_sym_GT] = ACTIONS(1419),
    [anon_sym_LT_EQ] = ACTIONS(1417),
    [anon_sym_GT_EQ] = ACTIONS(1417),
    [anon_sym_AMP] = ACTIONS(1417),
    [anon_sym_CARET] = ACTIONS(1417),
    [anon_sym_orelse] = ACTIONS(1419),
    [anon_sym_catch] = ACTIONS(1419),
    [anon_sym_LT_LT] = ACTIONS(1419),
    [anon_sym_GT_GT] = ACTIONS(1417),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1417),
    [anon_sym_PLUS] = ACTIONS(1419),
    [anon_sym_DASH] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1417),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1417),
    [anon_sym_DASH_PERCENT] = ACTIONS(1417),
    [anon_sym_PLUS_PIPE] = ACTIONS(1417),
    [anon_sym_DASH_PIPE] = ACTIONS(1417),
    [anon_sym_PIPE_PIPE] = ACTIONS(1417),
    [anon_sym_SLASH] = ACTIONS(1419),
    [anon_sym_PERCENT] = ACTIONS(1417),
    [anon_sym_STAR_STAR] = ACTIONS(1417),
    [anon_sym_STAR_PERCENT] = ACTIONS(1417),
    [anon_sym_STAR_PIPE] = ACTIONS(1417),
    [anon_sym_QMARK] = ACTIONS(1417),
    [anon_sym_DOT_STAR] = ACTIONS(1417),
    [anon_sym_DOT_QMARK] = ACTIONS(1417),
    [anon_sym_struct] = ACTIONS(1419),
    [anon_sym_opaque] = ACTIONS(1419),
    [anon_sym_enum] = ACTIONS(1419),
    [anon_sym_union] = ACTIONS(1419),
    [sym_doc_comment] = ACTIONS(1417),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [aux_sym_FLOAT_token1] = ACTIONS(1417),
    [aux_sym_FLOAT_token2] = ACTIONS(1417),
    [aux_sym_FLOAT_token3] = ACTIONS(1417),
    [aux_sym_FLOAT_token4] = ACTIONS(1417),
    [aux_sym_INTEGER_token1] = ACTIONS(1417),
    [aux_sym_INTEGER_token2] = ACTIONS(1417),
    [aux_sym_INTEGER_token3] = ACTIONS(1419),
    [aux_sym_INTEGER_token4] = ACTIONS(1419),
    [anon_sym_DQUOTE] = ACTIONS(1417),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1417),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1419),
    [anon_sym_AT] = ACTIONS(1417),
  },
  [536] = {
    [ts_builtin_sym_end] = ACTIONS(1421),
    [anon_sym_COMMA] = ACTIONS(1421),
    [anon_sym_pub] = ACTIONS(1423),
    [anon_sym_test] = ACTIONS(1423),
    [anon_sym_comptime] = ACTIONS(1423),
    [anon_sym_export] = ACTIONS(1423),
    [anon_sym_extern] = ACTIONS(1423),
    [anon_sym_inline] = ACTIONS(1423),
    [anon_sym_noinline] = ACTIONS(1423),
    [anon_sym_threadlocal] = ACTIONS(1423),
    [anon_sym_usingnamespace] = ACTIONS(1423),
    [anon_sym_fn] = ACTIONS(1423),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_const] = ACTIONS(1423),
    [anon_sym_var] = ACTIONS(1423),
    [anon_sym_else] = ACTIONS(1423),
    [anon_sym_or] = ACTIONS(1423),
    [anon_sym_and] = ACTIONS(1423),
    [anon_sym_LBRACE] = ACTIONS(1421),
    [anon_sym_RBRACE] = ACTIONS(1421),
    [anon_sym_async] = ACTIONS(1423),
    [anon_sym_DOT] = ACTIONS(1423),
    [anon_sym_error] = ACTIONS(1423),
    [anon_sym_false] = ACTIONS(1423),
    [anon_sym_null] = ACTIONS(1423),
    [anon_sym_anyframe] = ACTIONS(1423),
    [anon_sym_true] = ACTIONS(1423),
    [anon_sym_undefined] = ACTIONS(1423),
    [anon_sym_unreachable] = ACTIONS(1423),
    [sym_BuildinTypeExpr] = ACTIONS(1423),
    [anon_sym_packed] = ACTIONS(1423),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_switch] = ACTIONS(1423),
    [anon_sym_LBRACK] = ACTIONS(1421),
    [anon_sym_if] = ACTIONS(1423),
    [anon_sym_while] = ACTIONS(1423),
    [anon_sym_for] = ACTIONS(1423),
    [anon_sym_PIPE] = ACTIONS(1423),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_EQ_EQ] = ACTIONS(1421),
    [anon_sym_BANG_EQ] = ACTIONS(1421),
    [anon_sym_LT] = ACTIONS(1423),
    [anon_sym_GT] = ACTIONS(1423),
    [anon_sym_LT_EQ] = ACTIONS(1421),
    [anon_sym_GT_EQ] = ACTIONS(1421),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_CARET] = ACTIONS(1421),
    [anon_sym_orelse] = ACTIONS(1423),
    [anon_sym_catch] = ACTIONS(1423),
    [anon_sym_LT_LT] = ACTIONS(1423),
    [anon_sym_GT_GT] = ACTIONS(1421),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1423),
    [anon_sym_DASH] = ACTIONS(1423),
    [anon_sym_PLUS_PLUS] = ACTIONS(1421),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1421),
    [anon_sym_DASH_PERCENT] = ACTIONS(1421),
    [anon_sym_PLUS_PIPE] = ACTIONS(1421),
    [anon_sym_DASH_PIPE] = ACTIONS(1421),
    [anon_sym_PIPE_PIPE] = ACTIONS(1421),
    [anon_sym_SLASH] = ACTIONS(1423),
    [anon_sym_PERCENT] = ACTIONS(1421),
    [anon_sym_STAR_STAR] = ACTIONS(1421),
    [anon_sym_STAR_PERCENT] = ACTIONS(1421),
    [anon_sym_STAR_PIPE] = ACTIONS(1421),
    [anon_sym_QMARK] = ACTIONS(1421),
    [anon_sym_DOT_STAR] = ACTIONS(1421),
    [anon_sym_DOT_QMARK] = ACTIONS(1421),
    [anon_sym_struct] = ACTIONS(1423),
    [anon_sym_opaque] = ACTIONS(1423),
    [anon_sym_enum] = ACTIONS(1423),
    [anon_sym_union] = ACTIONS(1423),
    [sym_doc_comment] = ACTIONS(1421),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1421),
    [aux_sym_FLOAT_token1] = ACTIONS(1421),
    [aux_sym_FLOAT_token2] = ACTIONS(1421),
    [aux_sym_FLOAT_token3] = ACTIONS(1421),
    [aux_sym_FLOAT_token4] = ACTIONS(1421),
    [aux_sym_INTEGER_token1] = ACTIONS(1421),
    [aux_sym_INTEGER_token2] = ACTIONS(1421),
    [aux_sym_INTEGER_token3] = ACTIONS(1423),
    [aux_sym_INTEGER_token4] = ACTIONS(1423),
    [anon_sym_DQUOTE] = ACTIONS(1421),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1421),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1423),
    [anon_sym_AT] = ACTIONS(1421),
  },
  [537] = {
    [ts_builtin_sym_end] = ACTIONS(1425),
    [anon_sym_COMMA] = ACTIONS(1425),
    [anon_sym_pub] = ACTIONS(1427),
    [anon_sym_test] = ACTIONS(1427),
    [anon_sym_comptime] = ACTIONS(1427),
    [anon_sym_export] = ACTIONS(1427),
    [anon_sym_extern] = ACTIONS(1427),
    [anon_sym_inline] = ACTIONS(1427),
    [anon_sym_noinline] = ACTIONS(1427),
    [anon_sym_threadlocal] = ACTIONS(1427),
    [anon_sym_usingnamespace] = ACTIONS(1427),
    [anon_sym_fn] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_const] = ACTIONS(1427),
    [anon_sym_var] = ACTIONS(1427),
    [anon_sym_else] = ACTIONS(1427),
    [anon_sym_or] = ACTIONS(1427),
    [anon_sym_and] = ACTIONS(1427),
    [anon_sym_LBRACE] = ACTIONS(1425),
    [anon_sym_RBRACE] = ACTIONS(1425),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_DOT] = ACTIONS(1427),
    [anon_sym_error] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1427),
    [anon_sym_null] = ACTIONS(1427),
    [anon_sym_anyframe] = ACTIONS(1427),
    [anon_sym_true] = ACTIONS(1427),
    [anon_sym_undefined] = ACTIONS(1427),
    [anon_sym_unreachable] = ACTIONS(1427),
    [sym_BuildinTypeExpr] = ACTIONS(1427),
    [anon_sym_packed] = ACTIONS(1427),
    [anon_sym_LPAREN] = ACTIONS(1425),
    [anon_sym_switch] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1425),
    [anon_sym_if] = ACTIONS(1427),
    [anon_sym_while] = ACTIONS(1427),
    [anon_sym_for] = ACTIONS(1427),
    [anon_sym_PIPE] = ACTIONS(1427),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_EQ_EQ] = ACTIONS(1425),
    [anon_sym_BANG_EQ] = ACTIONS(1425),
    [anon_sym_LT] = ACTIONS(1427),
    [anon_sym_GT] = ACTIONS(1427),
    [anon_sym_LT_EQ] = ACTIONS(1425),
    [anon_sym_GT_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1425),
    [anon_sym_CARET] = ACTIONS(1425),
    [anon_sym_orelse] = ACTIONS(1427),
    [anon_sym_catch] = ACTIONS(1427),
    [anon_sym_LT_LT] = ACTIONS(1427),
    [anon_sym_GT_GT] = ACTIONS(1425),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1425),
    [anon_sym_PLUS] = ACTIONS(1427),
    [anon_sym_DASH] = ACTIONS(1427),
    [anon_sym_PLUS_PLUS] = ACTIONS(1425),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1425),
    [anon_sym_DASH_PERCENT] = ACTIONS(1425),
    [anon_sym_PLUS_PIPE] = ACTIONS(1425),
    [anon_sym_DASH_PIPE] = ACTIONS(1425),
    [anon_sym_PIPE_PIPE] = ACTIONS(1425),
    [anon_sym_SLASH] = ACTIONS(1427),
    [anon_sym_PERCENT] = ACTIONS(1425),
    [anon_sym_STAR_STAR] = ACTIONS(1425),
    [anon_sym_STAR_PERCENT] = ACTIONS(1425),
    [anon_sym_STAR_PIPE] = ACTIONS(1425),
    [anon_sym_QMARK] = ACTIONS(1425),
    [anon_sym_DOT_STAR] = ACTIONS(1425),
    [anon_sym_DOT_QMARK] = ACTIONS(1425),
    [anon_sym_struct] = ACTIONS(1427),
    [anon_sym_opaque] = ACTIONS(1427),
    [anon_sym_enum] = ACTIONS(1427),
    [anon_sym_union] = ACTIONS(1427),
    [sym_doc_comment] = ACTIONS(1425),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [aux_sym_FLOAT_token1] = ACTIONS(1425),
    [aux_sym_FLOAT_token2] = ACTIONS(1425),
    [aux_sym_FLOAT_token3] = ACTIONS(1425),
    [aux_sym_FLOAT_token4] = ACTIONS(1425),
    [aux_sym_INTEGER_token1] = ACTIONS(1425),
    [aux_sym_INTEGER_token2] = ACTIONS(1425),
    [aux_sym_INTEGER_token3] = ACTIONS(1427),
    [aux_sym_INTEGER_token4] = ACTIONS(1427),
    [anon_sym_DQUOTE] = ACTIONS(1425),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1425),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1427),
    [anon_sym_AT] = ACTIONS(1425),
  },
  [538] = {
    [ts_builtin_sym_end] = ACTIONS(1429),
    [anon_sym_COMMA] = ACTIONS(1429),
    [anon_sym_pub] = ACTIONS(1431),
    [anon_sym_test] = ACTIONS(1431),
    [anon_sym_comptime] = ACTIONS(1431),
    [anon_sym_export] = ACTIONS(1431),
    [anon_sym_extern] = ACTIONS(1431),
    [anon_sym_inline] = ACTIONS(1431),
    [anon_sym_noinline] = ACTIONS(1431),
    [anon_sym_threadlocal] = ACTIONS(1431),
    [anon_sym_usingnamespace] = ACTIONS(1431),
    [anon_sym_fn] = ACTIONS(1431),
    [anon_sym_BANG] = ACTIONS(1431),
    [anon_sym_const] = ACTIONS(1431),
    [anon_sym_var] = ACTIONS(1431),
    [anon_sym_else] = ACTIONS(1431),
    [anon_sym_or] = ACTIONS(1431),
    [anon_sym_and] = ACTIONS(1431),
    [anon_sym_LBRACE] = ACTIONS(1429),
    [anon_sym_RBRACE] = ACTIONS(1429),
    [anon_sym_async] = ACTIONS(1431),
    [anon_sym_DOT] = ACTIONS(1431),
    [anon_sym_error] = ACTIONS(1431),
    [anon_sym_false] = ACTIONS(1431),
    [anon_sym_null] = ACTIONS(1431),
    [anon_sym_anyframe] = ACTIONS(1431),
    [anon_sym_true] = ACTIONS(1431),
    [anon_sym_undefined] = ACTIONS(1431),
    [anon_sym_unreachable] = ACTIONS(1431),
    [sym_BuildinTypeExpr] = ACTIONS(1431),
    [anon_sym_packed] = ACTIONS(1431),
    [anon_sym_LPAREN] = ACTIONS(1429),
    [anon_sym_switch] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1429),
    [anon_sym_if] = ACTIONS(1431),
    [anon_sym_while] = ACTIONS(1431),
    [anon_sym_for] = ACTIONS(1431),
    [anon_sym_PIPE] = ACTIONS(1431),
    [anon_sym_STAR] = ACTIONS(1431),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ] = ACTIONS(1429),
    [anon_sym_LT] = ACTIONS(1431),
    [anon_sym_GT] = ACTIONS(1431),
    [anon_sym_LT_EQ] = ACTIONS(1429),
    [anon_sym_GT_EQ] = ACTIONS(1429),
    [anon_sym_AMP] = ACTIONS(1429),
    [anon_sym_CARET] = ACTIONS(1429),
    [anon_sym_orelse] = ACTIONS(1431),
    [anon_sym_catch] = ACTIONS(1431),
    [anon_sym_LT_LT] = ACTIONS(1431),
    [anon_sym_GT_GT] = ACTIONS(1429),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1429),
    [anon_sym_PLUS] = ACTIONS(1431),
    [anon_sym_DASH] = ACTIONS(1431),
    [anon_sym_PLUS_PLUS] = ACTIONS(1429),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1429),
    [anon_sym_DASH_PERCENT] = ACTIONS(1429),
    [anon_sym_PLUS_PIPE] = ACTIONS(1429),
    [anon_sym_DASH_PIPE] = ACTIONS(1429),
    [anon_sym_PIPE_PIPE] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1431),
    [anon_sym_PERCENT] = ACTIONS(1429),
    [anon_sym_STAR_STAR] = ACTIONS(1429),
    [anon_sym_STAR_PERCENT] = ACTIONS(1429),
    [anon_sym_STAR_PIPE] = ACTIONS(1429),
    [anon_sym_QMARK] = ACTIONS(1429),
    [anon_sym_DOT_STAR] = ACTIONS(1429),
    [anon_sym_DOT_QMARK] = ACTIONS(1429),
    [anon_sym_struct] = ACTIONS(1431),
    [anon_sym_opaque] = ACTIONS(1431),
    [anon_sym_enum] = ACTIONS(1431),
    [anon_sym_union] = ACTIONS(1431),
    [sym_doc_comment] = ACTIONS(1429),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1429),
    [aux_sym_FLOAT_token1] = ACTIONS(1429),
    [aux_sym_FLOAT_token2] = ACTIONS(1429),
    [aux_sym_FLOAT_token3] = ACTIONS(1429),
    [aux_sym_FLOAT_token4] = ACTIONS(1429),
    [aux_sym_INTEGER_token1] = ACTIONS(1429),
    [aux_sym_INTEGER_token2] = ACTIONS(1429),
    [aux_sym_INTEGER_token3] = ACTIONS(1431),
    [aux_sym_INTEGER_token4] = ACTIONS(1431),
    [anon_sym_DQUOTE] = ACTIONS(1429),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1429),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1431),
    [anon_sym_AT] = ACTIONS(1429),
  },
  [539] = {
    [ts_builtin_sym_end] = ACTIONS(1433),
    [anon_sym_COMMA] = ACTIONS(1433),
    [anon_sym_pub] = ACTIONS(1435),
    [anon_sym_test] = ACTIONS(1435),
    [anon_sym_comptime] = ACTIONS(1435),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_extern] = ACTIONS(1435),
    [anon_sym_inline] = ACTIONS(1435),
    [anon_sym_noinline] = ACTIONS(1435),
    [anon_sym_threadlocal] = ACTIONS(1435),
    [anon_sym_usingnamespace] = ACTIONS(1435),
    [anon_sym_fn] = ACTIONS(1435),
    [anon_sym_BANG] = ACTIONS(1435),
    [anon_sym_const] = ACTIONS(1435),
    [anon_sym_var] = ACTIONS(1435),
    [anon_sym_else] = ACTIONS(1435),
    [anon_sym_or] = ACTIONS(1435),
    [anon_sym_and] = ACTIONS(1435),
    [anon_sym_LBRACE] = ACTIONS(1433),
    [anon_sym_RBRACE] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_DOT] = ACTIONS(1435),
    [anon_sym_error] = ACTIONS(1435),
    [anon_sym_false] = ACTIONS(1435),
    [anon_sym_null] = ACTIONS(1435),
    [anon_sym_anyframe] = ACTIONS(1435),
    [anon_sym_true] = ACTIONS(1435),
    [anon_sym_undefined] = ACTIONS(1435),
    [anon_sym_unreachable] = ACTIONS(1435),
    [sym_BuildinTypeExpr] = ACTIONS(1435),
    [anon_sym_packed] = ACTIONS(1435),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_switch] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1435),
    [anon_sym_while] = ACTIONS(1435),
    [anon_sym_for] = ACTIONS(1435),
    [anon_sym_PIPE] = ACTIONS(1435),
    [anon_sym_STAR] = ACTIONS(1435),
    [anon_sym_EQ_EQ] = ACTIONS(1433),
    [anon_sym_BANG_EQ] = ACTIONS(1433),
    [anon_sym_LT] = ACTIONS(1435),
    [anon_sym_GT] = ACTIONS(1435),
    [anon_sym_LT_EQ] = ACTIONS(1433),
    [anon_sym_GT_EQ] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(1433),
    [anon_sym_CARET] = ACTIONS(1433),
    [anon_sym_orelse] = ACTIONS(1435),
    [anon_sym_catch] = ACTIONS(1435),
    [anon_sym_LT_LT] = ACTIONS(1435),
    [anon_sym_GT_GT] = ACTIONS(1433),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1433),
    [anon_sym_PLUS] = ACTIONS(1435),
    [anon_sym_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1433),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1433),
    [anon_sym_DASH_PERCENT] = ACTIONS(1433),
    [anon_sym_PLUS_PIPE] = ACTIONS(1433),
    [anon_sym_DASH_PIPE] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE] = ACTIONS(1433),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_PERCENT] = ACTIONS(1433),
    [anon_sym_STAR_STAR] = ACTIONS(1433),
    [anon_sym_STAR_PERCENT] = ACTIONS(1433),
    [anon_sym_STAR_PIPE] = ACTIONS(1433),
    [anon_sym_QMARK] = ACTIONS(1433),
    [anon_sym_DOT_STAR] = ACTIONS(1433),
    [anon_sym_DOT_QMARK] = ACTIONS(1433),
    [anon_sym_struct] = ACTIONS(1435),
    [anon_sym_opaque] = ACTIONS(1435),
    [anon_sym_enum] = ACTIONS(1435),
    [anon_sym_union] = ACTIONS(1435),
    [sym_doc_comment] = ACTIONS(1433),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1433),
    [aux_sym_FLOAT_token1] = ACTIONS(1433),
    [aux_sym_FLOAT_token2] = ACTIONS(1433),
    [aux_sym_FLOAT_token3] = ACTIONS(1433),
    [aux_sym_FLOAT_token4] = ACTIONS(1433),
    [aux_sym_INTEGER_token1] = ACTIONS(1433),
    [aux_sym_INTEGER_token2] = ACTIONS(1433),
    [aux_sym_INTEGER_token3] = ACTIONS(1435),
    [aux_sym_INTEGER_token4] = ACTIONS(1435),
    [anon_sym_DQUOTE] = ACTIONS(1433),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1433),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1435),
    [anon_sym_AT] = ACTIONS(1433),
  },
  [540] = {
    [ts_builtin_sym_end] = ACTIONS(1437),
    [anon_sym_COMMA] = ACTIONS(1437),
    [anon_sym_pub] = ACTIONS(1439),
    [anon_sym_test] = ACTIONS(1439),
    [anon_sym_comptime] = ACTIONS(1439),
    [anon_sym_export] = ACTIONS(1439),
    [anon_sym_extern] = ACTIONS(1439),
    [anon_sym_inline] = ACTIONS(1439),
    [anon_sym_noinline] = ACTIONS(1439),
    [anon_sym_threadlocal] = ACTIONS(1439),
    [anon_sym_usingnamespace] = ACTIONS(1439),
    [anon_sym_fn] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_const] = ACTIONS(1439),
    [anon_sym_var] = ACTIONS(1439),
    [anon_sym_else] = ACTIONS(1439),
    [anon_sym_or] = ACTIONS(1439),
    [anon_sym_and] = ACTIONS(1439),
    [anon_sym_LBRACE] = ACTIONS(1437),
    [anon_sym_RBRACE] = ACTIONS(1437),
    [anon_sym_async] = ACTIONS(1439),
    [anon_sym_DOT] = ACTIONS(1439),
    [anon_sym_error] = ACTIONS(1439),
    [anon_sym_false] = ACTIONS(1439),
    [anon_sym_null] = ACTIONS(1439),
    [anon_sym_anyframe] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1439),
    [anon_sym_undefined] = ACTIONS(1439),
    [anon_sym_unreachable] = ACTIONS(1439),
    [sym_BuildinTypeExpr] = ACTIONS(1439),
    [anon_sym_packed] = ACTIONS(1439),
    [anon_sym_LPAREN] = ACTIONS(1437),
    [anon_sym_switch] = ACTIONS(1439),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(1439),
    [anon_sym_while] = ACTIONS(1439),
    [anon_sym_for] = ACTIONS(1439),
    [anon_sym_PIPE] = ACTIONS(1439),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_EQ_EQ] = ACTIONS(1437),
    [anon_sym_BANG_EQ] = ACTIONS(1437),
    [anon_sym_LT] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1439),
    [anon_sym_LT_EQ] = ACTIONS(1437),
    [anon_sym_GT_EQ] = ACTIONS(1437),
    [anon_sym_AMP] = ACTIONS(1437),
    [anon_sym_CARET] = ACTIONS(1437),
    [anon_sym_orelse] = ACTIONS(1439),
    [anon_sym_catch] = ACTIONS(1439),
    [anon_sym_LT_LT] = ACTIONS(1439),
    [anon_sym_GT_GT] = ACTIONS(1437),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1437),
    [anon_sym_PLUS] = ACTIONS(1439),
    [anon_sym_DASH] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1437),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1437),
    [anon_sym_DASH_PERCENT] = ACTIONS(1437),
    [anon_sym_PLUS_PIPE] = ACTIONS(1437),
    [anon_sym_DASH_PIPE] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1439),
    [anon_sym_PERCENT] = ACTIONS(1437),
    [anon_sym_STAR_STAR] = ACTIONS(1437),
    [anon_sym_STAR_PERCENT] = ACTIONS(1437),
    [anon_sym_STAR_PIPE] = ACTIONS(1437),
    [anon_sym_QMARK] = ACTIONS(1437),
    [anon_sym_DOT_STAR] = ACTIONS(1437),
    [anon_sym_DOT_QMARK] = ACTIONS(1437),
    [anon_sym_struct] = ACTIONS(1439),
    [anon_sym_opaque] = ACTIONS(1439),
    [anon_sym_enum] = ACTIONS(1439),
    [anon_sym_union] = ACTIONS(1439),
    [sym_doc_comment] = ACTIONS(1437),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1437),
    [aux_sym_FLOAT_token1] = ACTIONS(1437),
    [aux_sym_FLOAT_token2] = ACTIONS(1437),
    [aux_sym_FLOAT_token3] = ACTIONS(1437),
    [aux_sym_FLOAT_token4] = ACTIONS(1437),
    [aux_sym_INTEGER_token1] = ACTIONS(1437),
    [aux_sym_INTEGER_token2] = ACTIONS(1437),
    [aux_sym_INTEGER_token3] = ACTIONS(1439),
    [aux_sym_INTEGER_token4] = ACTIONS(1439),
    [anon_sym_DQUOTE] = ACTIONS(1437),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1437),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1439),
    [anon_sym_AT] = ACTIONS(1437),
  },
  [541] = {
    [ts_builtin_sym_end] = ACTIONS(1441),
    [anon_sym_COMMA] = ACTIONS(1441),
    [anon_sym_pub] = ACTIONS(1443),
    [anon_sym_test] = ACTIONS(1443),
    [anon_sym_comptime] = ACTIONS(1443),
    [anon_sym_export] = ACTIONS(1443),
    [anon_sym_extern] = ACTIONS(1443),
    [anon_sym_inline] = ACTIONS(1443),
    [anon_sym_noinline] = ACTIONS(1443),
    [anon_sym_threadlocal] = ACTIONS(1443),
    [anon_sym_usingnamespace] = ACTIONS(1443),
    [anon_sym_fn] = ACTIONS(1443),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_const] = ACTIONS(1443),
    [anon_sym_var] = ACTIONS(1443),
    [anon_sym_else] = ACTIONS(1443),
    [anon_sym_or] = ACTIONS(1443),
    [anon_sym_and] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1441),
    [anon_sym_RBRACE] = ACTIONS(1441),
    [anon_sym_async] = ACTIONS(1443),
    [anon_sym_DOT] = ACTIONS(1443),
    [anon_sym_error] = ACTIONS(1443),
    [anon_sym_false] = ACTIONS(1443),
    [anon_sym_null] = ACTIONS(1443),
    [anon_sym_anyframe] = ACTIONS(1443),
    [anon_sym_true] = ACTIONS(1443),
    [anon_sym_undefined] = ACTIONS(1443),
    [anon_sym_unreachable] = ACTIONS(1443),
    [sym_BuildinTypeExpr] = ACTIONS(1443),
    [anon_sym_packed] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(1441),
    [anon_sym_switch] = ACTIONS(1443),
    [anon_sym_LBRACK] = ACTIONS(1441),
    [anon_sym_if] = ACTIONS(1443),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_for] = ACTIONS(1443),
    [anon_sym_PIPE] = ACTIONS(1443),
    [anon_sym_STAR] = ACTIONS(1443),
    [anon_sym_EQ_EQ] = ACTIONS(1441),
    [anon_sym_BANG_EQ] = ACTIONS(1441),
    [anon_sym_LT] = ACTIONS(1443),
    [anon_sym_GT] = ACTIONS(1443),
    [anon_sym_LT_EQ] = ACTIONS(1441),
    [anon_sym_GT_EQ] = ACTIONS(1441),
    [anon_sym_AMP] = ACTIONS(1441),
    [anon_sym_CARET] = ACTIONS(1441),
    [anon_sym_orelse] = ACTIONS(1443),
    [anon_sym_catch] = ACTIONS(1443),
    [anon_sym_LT_LT] = ACTIONS(1443),
    [anon_sym_GT_GT] = ACTIONS(1441),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1441),
    [anon_sym_PLUS] = ACTIONS(1443),
    [anon_sym_DASH] = ACTIONS(1443),
    [anon_sym_PLUS_PLUS] = ACTIONS(1441),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1441),
    [anon_sym_DASH_PERCENT] = ACTIONS(1441),
    [anon_sym_PLUS_PIPE] = ACTIONS(1441),
    [anon_sym_DASH_PIPE] = ACTIONS(1441),
    [anon_sym_PIPE_PIPE] = ACTIONS(1441),
    [anon_sym_SLASH] = ACTIONS(1443),
    [anon_sym_PERCENT] = ACTIONS(1441),
    [anon_sym_STAR_STAR] = ACTIONS(1441),
    [anon_sym_STAR_PERCENT] = ACTIONS(1441),
    [anon_sym_STAR_PIPE] = ACTIONS(1441),
    [anon_sym_QMARK] = ACTIONS(1441),
    [anon_sym_DOT_STAR] = ACTIONS(1441),
    [anon_sym_DOT_QMARK] = ACTIONS(1441),
    [anon_sym_struct] = ACTIONS(1443),
    [anon_sym_opaque] = ACTIONS(1443),
    [anon_sym_enum] = ACTIONS(1443),
    [anon_sym_union] = ACTIONS(1443),
    [sym_doc_comment] = ACTIONS(1441),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1441),
    [aux_sym_FLOAT_token1] = ACTIONS(1441),
    [aux_sym_FLOAT_token2] = ACTIONS(1441),
    [aux_sym_FLOAT_token3] = ACTIONS(1441),
    [aux_sym_FLOAT_token4] = ACTIONS(1441),
    [aux_sym_INTEGER_token1] = ACTIONS(1441),
    [aux_sym_INTEGER_token2] = ACTIONS(1441),
    [aux_sym_INTEGER_token3] = ACTIONS(1443),
    [aux_sym_INTEGER_token4] = ACTIONS(1443),
    [anon_sym_DQUOTE] = ACTIONS(1441),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1441),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1443),
    [anon_sym_AT] = ACTIONS(1441),
  },
  [542] = {
    [ts_builtin_sym_end] = ACTIONS(1445),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_pub] = ACTIONS(1447),
    [anon_sym_test] = ACTIONS(1447),
    [anon_sym_comptime] = ACTIONS(1447),
    [anon_sym_export] = ACTIONS(1447),
    [anon_sym_extern] = ACTIONS(1447),
    [anon_sym_inline] = ACTIONS(1447),
    [anon_sym_noinline] = ACTIONS(1447),
    [anon_sym_threadlocal] = ACTIONS(1447),
    [anon_sym_usingnamespace] = ACTIONS(1447),
    [anon_sym_fn] = ACTIONS(1447),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_const] = ACTIONS(1447),
    [anon_sym_var] = ACTIONS(1447),
    [anon_sym_else] = ACTIONS(1447),
    [anon_sym_or] = ACTIONS(1447),
    [anon_sym_and] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [anon_sym_RBRACE] = ACTIONS(1445),
    [anon_sym_async] = ACTIONS(1447),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_error] = ACTIONS(1447),
    [anon_sym_false] = ACTIONS(1447),
    [anon_sym_null] = ACTIONS(1447),
    [anon_sym_anyframe] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1447),
    [anon_sym_undefined] = ACTIONS(1447),
    [anon_sym_unreachable] = ACTIONS(1447),
    [sym_BuildinTypeExpr] = ACTIONS(1447),
    [anon_sym_packed] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1445),
    [anon_sym_switch] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(1445),
    [anon_sym_if] = ACTIONS(1447),
    [anon_sym_while] = ACTIONS(1447),
    [anon_sym_for] = ACTIONS(1447),
    [anon_sym_PIPE] = ACTIONS(1447),
    [anon_sym_STAR] = ACTIONS(1447),
    [anon_sym_EQ_EQ] = ACTIONS(1445),
    [anon_sym_BANG_EQ] = ACTIONS(1445),
    [anon_sym_LT] = ACTIONS(1447),
    [anon_sym_GT] = ACTIONS(1447),
    [anon_sym_LT_EQ] = ACTIONS(1445),
    [anon_sym_GT_EQ] = ACTIONS(1445),
    [anon_sym_AMP] = ACTIONS(1445),
    [anon_sym_CARET] = ACTIONS(1445),
    [anon_sym_orelse] = ACTIONS(1447),
    [anon_sym_catch] = ACTIONS(1447),
    [anon_sym_LT_LT] = ACTIONS(1447),
    [anon_sym_GT_GT] = ACTIONS(1445),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1445),
    [anon_sym_PLUS] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1445),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1445),
    [anon_sym_DASH_PERCENT] = ACTIONS(1445),
    [anon_sym_PLUS_PIPE] = ACTIONS(1445),
    [anon_sym_DASH_PIPE] = ACTIONS(1445),
    [anon_sym_PIPE_PIPE] = ACTIONS(1445),
    [anon_sym_SLASH] = ACTIONS(1447),
    [anon_sym_PERCENT] = ACTIONS(1445),
    [anon_sym_STAR_STAR] = ACTIONS(1445),
    [anon_sym_STAR_PERCENT] = ACTIONS(1445),
    [anon_sym_STAR_PIPE] = ACTIONS(1445),
    [anon_sym_QMARK] = ACTIONS(1445),
    [anon_sym_DOT_STAR] = ACTIONS(1445),
    [anon_sym_DOT_QMARK] = ACTIONS(1445),
    [anon_sym_struct] = ACTIONS(1447),
    [anon_sym_opaque] = ACTIONS(1447),
    [anon_sym_enum] = ACTIONS(1447),
    [anon_sym_union] = ACTIONS(1447),
    [sym_doc_comment] = ACTIONS(1445),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1445),
    [aux_sym_FLOAT_token1] = ACTIONS(1445),
    [aux_sym_FLOAT_token2] = ACTIONS(1445),
    [aux_sym_FLOAT_token3] = ACTIONS(1445),
    [aux_sym_FLOAT_token4] = ACTIONS(1445),
    [aux_sym_INTEGER_token1] = ACTIONS(1445),
    [aux_sym_INTEGER_token2] = ACTIONS(1445),
    [aux_sym_INTEGER_token3] = ACTIONS(1447),
    [aux_sym_INTEGER_token4] = ACTIONS(1447),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1445),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1447),
    [anon_sym_AT] = ACTIONS(1445),
  },
  [543] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1449),
    [anon_sym_COMMA] = ACTIONS(1449),
    [anon_sym_pub] = ACTIONS(1451),
    [anon_sym_test] = ACTIONS(1451),
    [anon_sym_comptime] = ACTIONS(1451),
    [anon_sym_export] = ACTIONS(1451),
    [anon_sym_extern] = ACTIONS(1451),
    [anon_sym_inline] = ACTIONS(1451),
    [anon_sym_noinline] = ACTIONS(1451),
    [anon_sym_threadlocal] = ACTIONS(1451),
    [anon_sym_usingnamespace] = ACTIONS(1451),
    [anon_sym_fn] = ACTIONS(1451),
    [anon_sym_const] = ACTIONS(1451),
    [anon_sym_var] = ACTIONS(1451),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1449),
    [anon_sym_async] = ACTIONS(1451),
    [anon_sym_DOT] = ACTIONS(1449),
    [anon_sym_error] = ACTIONS(1451),
    [anon_sym_false] = ACTIONS(1451),
    [anon_sym_null] = ACTIONS(1451),
    [anon_sym_anyframe] = ACTIONS(1451),
    [anon_sym_true] = ACTIONS(1451),
    [anon_sym_undefined] = ACTIONS(1451),
    [anon_sym_unreachable] = ACTIONS(1451),
    [sym_BuildinTypeExpr] = ACTIONS(1451),
    [anon_sym_packed] = ACTIONS(1451),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_switch] = ACTIONS(1451),
    [anon_sym_LBRACK] = ACTIONS(1449),
    [anon_sym_if] = ACTIONS(1451),
    [anon_sym_while] = ACTIONS(1451),
    [anon_sym_for] = ACTIONS(1451),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1449),
    [anon_sym_struct] = ACTIONS(1451),
    [anon_sym_opaque] = ACTIONS(1451),
    [anon_sym_enum] = ACTIONS(1451),
    [anon_sym_union] = ACTIONS(1451),
    [sym_doc_comment] = ACTIONS(1449),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1449),
    [aux_sym_FLOAT_token1] = ACTIONS(1449),
    [aux_sym_FLOAT_token2] = ACTIONS(1449),
    [aux_sym_FLOAT_token3] = ACTIONS(1449),
    [aux_sym_FLOAT_token4] = ACTIONS(1449),
    [aux_sym_INTEGER_token1] = ACTIONS(1449),
    [aux_sym_INTEGER_token2] = ACTIONS(1449),
    [aux_sym_INTEGER_token3] = ACTIONS(1451),
    [aux_sym_INTEGER_token4] = ACTIONS(1451),
    [anon_sym_DQUOTE] = ACTIONS(1449),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1449),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1451),
    [anon_sym_AT] = ACTIONS(1449),
  },
  [544] = {
    [ts_builtin_sym_end] = ACTIONS(1453),
    [anon_sym_COMMA] = ACTIONS(1453),
    [anon_sym_pub] = ACTIONS(1455),
    [anon_sym_test] = ACTIONS(1455),
    [anon_sym_comptime] = ACTIONS(1455),
    [anon_sym_export] = ACTIONS(1455),
    [anon_sym_extern] = ACTIONS(1455),
    [anon_sym_inline] = ACTIONS(1455),
    [anon_sym_noinline] = ACTIONS(1455),
    [anon_sym_threadlocal] = ACTIONS(1455),
    [anon_sym_usingnamespace] = ACTIONS(1455),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_BANG] = ACTIONS(1455),
    [anon_sym_const] = ACTIONS(1455),
    [anon_sym_var] = ACTIONS(1455),
    [anon_sym_else] = ACTIONS(1455),
    [anon_sym_or] = ACTIONS(1455),
    [anon_sym_and] = ACTIONS(1455),
    [anon_sym_LBRACE] = ACTIONS(1453),
    [anon_sym_RBRACE] = ACTIONS(1453),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_DOT] = ACTIONS(1455),
    [anon_sym_error] = ACTIONS(1455),
    [anon_sym_false] = ACTIONS(1455),
    [anon_sym_null] = ACTIONS(1455),
    [anon_sym_anyframe] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1455),
    [anon_sym_undefined] = ACTIONS(1455),
    [anon_sym_unreachable] = ACTIONS(1455),
    [sym_BuildinTypeExpr] = ACTIONS(1455),
    [anon_sym_packed] = ACTIONS(1455),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_switch] = ACTIONS(1455),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_if] = ACTIONS(1455),
    [anon_sym_while] = ACTIONS(1455),
    [anon_sym_for] = ACTIONS(1455),
    [anon_sym_PIPE] = ACTIONS(1455),
    [anon_sym_STAR] = ACTIONS(1455),
    [anon_sym_EQ_EQ] = ACTIONS(1453),
    [anon_sym_BANG_EQ] = ACTIONS(1453),
    [anon_sym_LT] = ACTIONS(1455),
    [anon_sym_GT] = ACTIONS(1455),
    [anon_sym_LT_EQ] = ACTIONS(1453),
    [anon_sym_GT_EQ] = ACTIONS(1453),
    [anon_sym_AMP] = ACTIONS(1453),
    [anon_sym_CARET] = ACTIONS(1453),
    [anon_sym_orelse] = ACTIONS(1455),
    [anon_sym_catch] = ACTIONS(1455),
    [anon_sym_LT_LT] = ACTIONS(1455),
    [anon_sym_GT_GT] = ACTIONS(1453),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1453),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_DASH] = ACTIONS(1455),
    [anon_sym_PLUS_PLUS] = ACTIONS(1453),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1453),
    [anon_sym_DASH_PERCENT] = ACTIONS(1453),
    [anon_sym_PLUS_PIPE] = ACTIONS(1453),
    [anon_sym_DASH_PIPE] = ACTIONS(1453),
    [anon_sym_PIPE_PIPE] = ACTIONS(1453),
    [anon_sym_SLASH] = ACTIONS(1455),
    [anon_sym_PERCENT] = ACTIONS(1453),
    [anon_sym_STAR_STAR] = ACTIONS(1453),
    [anon_sym_STAR_PERCENT] = ACTIONS(1453),
    [anon_sym_STAR_PIPE] = ACTIONS(1453),
    [anon_sym_QMARK] = ACTIONS(1453),
    [anon_sym_DOT_STAR] = ACTIONS(1453),
    [anon_sym_DOT_QMARK] = ACTIONS(1453),
    [anon_sym_struct] = ACTIONS(1455),
    [anon_sym_opaque] = ACTIONS(1455),
    [anon_sym_enum] = ACTIONS(1455),
    [anon_sym_union] = ACTIONS(1455),
    [sym_doc_comment] = ACTIONS(1453),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [aux_sym_FLOAT_token1] = ACTIONS(1453),
    [aux_sym_FLOAT_token2] = ACTIONS(1453),
    [aux_sym_FLOAT_token3] = ACTIONS(1453),
    [aux_sym_FLOAT_token4] = ACTIONS(1453),
    [aux_sym_INTEGER_token1] = ACTIONS(1453),
    [aux_sym_INTEGER_token2] = ACTIONS(1453),
    [aux_sym_INTEGER_token3] = ACTIONS(1455),
    [aux_sym_INTEGER_token4] = ACTIONS(1455),
    [anon_sym_DQUOTE] = ACTIONS(1453),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1453),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1455),
    [anon_sym_AT] = ACTIONS(1453),
  },
  [545] = {
    [ts_builtin_sym_end] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(1457),
    [anon_sym_pub] = ACTIONS(1459),
    [anon_sym_test] = ACTIONS(1459),
    [anon_sym_comptime] = ACTIONS(1459),
    [anon_sym_export] = ACTIONS(1459),
    [anon_sym_extern] = ACTIONS(1459),
    [anon_sym_inline] = ACTIONS(1459),
    [anon_sym_noinline] = ACTIONS(1459),
    [anon_sym_threadlocal] = ACTIONS(1459),
    [anon_sym_usingnamespace] = ACTIONS(1459),
    [anon_sym_fn] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_const] = ACTIONS(1459),
    [anon_sym_var] = ACTIONS(1459),
    [anon_sym_else] = ACTIONS(1459),
    [anon_sym_or] = ACTIONS(1459),
    [anon_sym_and] = ACTIONS(1459),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_RBRACE] = ACTIONS(1457),
    [anon_sym_async] = ACTIONS(1459),
    [anon_sym_DOT] = ACTIONS(1459),
    [anon_sym_error] = ACTIONS(1459),
    [anon_sym_false] = ACTIONS(1459),
    [anon_sym_null] = ACTIONS(1459),
    [anon_sym_anyframe] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(1459),
    [anon_sym_undefined] = ACTIONS(1459),
    [anon_sym_unreachable] = ACTIONS(1459),
    [sym_BuildinTypeExpr] = ACTIONS(1459),
    [anon_sym_packed] = ACTIONS(1459),
    [anon_sym_LPAREN] = ACTIONS(1457),
    [anon_sym_switch] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_if] = ACTIONS(1459),
    [anon_sym_while] = ACTIONS(1459),
    [anon_sym_for] = ACTIONS(1459),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_EQ_EQ] = ACTIONS(1457),
    [anon_sym_BANG_EQ] = ACTIONS(1457),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_LT_EQ] = ACTIONS(1457),
    [anon_sym_GT_EQ] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_orelse] = ACTIONS(1459),
    [anon_sym_catch] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1457),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_DASH] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1457),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1457),
    [anon_sym_DASH_PERCENT] = ACTIONS(1457),
    [anon_sym_PLUS_PIPE] = ACTIONS(1457),
    [anon_sym_DASH_PIPE] = ACTIONS(1457),
    [anon_sym_PIPE_PIPE] = ACTIONS(1457),
    [anon_sym_SLASH] = ACTIONS(1459),
    [anon_sym_PERCENT] = ACTIONS(1457),
    [anon_sym_STAR_STAR] = ACTIONS(1457),
    [anon_sym_STAR_PERCENT] = ACTIONS(1457),
    [anon_sym_STAR_PIPE] = ACTIONS(1457),
    [anon_sym_QMARK] = ACTIONS(1457),
    [anon_sym_DOT_STAR] = ACTIONS(1457),
    [anon_sym_DOT_QMARK] = ACTIONS(1457),
    [anon_sym_struct] = ACTIONS(1459),
    [anon_sym_opaque] = ACTIONS(1459),
    [anon_sym_enum] = ACTIONS(1459),
    [anon_sym_union] = ACTIONS(1459),
    [sym_doc_comment] = ACTIONS(1457),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1457),
    [aux_sym_FLOAT_token1] = ACTIONS(1457),
    [aux_sym_FLOAT_token2] = ACTIONS(1457),
    [aux_sym_FLOAT_token3] = ACTIONS(1457),
    [aux_sym_FLOAT_token4] = ACTIONS(1457),
    [aux_sym_INTEGER_token1] = ACTIONS(1457),
    [aux_sym_INTEGER_token2] = ACTIONS(1457),
    [aux_sym_INTEGER_token3] = ACTIONS(1459),
    [aux_sym_INTEGER_token4] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1457),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1457),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1459),
    [anon_sym_AT] = ACTIONS(1457),
  },
  [546] = {
    [sym_CompareOp] = STATE(329),
    [sym_BitwiseOp] = STATE(327),
    [sym_BitShiftOp] = STATE(326),
    [sym_AdditionOp] = STATE(325),
    [sym_MultiplyOp] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(1461),
    [anon_sym_COMMA] = ACTIONS(1461),
    [anon_sym_pub] = ACTIONS(1463),
    [anon_sym_test] = ACTIONS(1463),
    [anon_sym_comptime] = ACTIONS(1463),
    [anon_sym_export] = ACTIONS(1463),
    [anon_sym_extern] = ACTIONS(1463),
    [anon_sym_inline] = ACTIONS(1463),
    [anon_sym_noinline] = ACTIONS(1463),
    [anon_sym_threadlocal] = ACTIONS(1463),
    [anon_sym_usingnamespace] = ACTIONS(1463),
    [anon_sym_fn] = ACTIONS(1463),
    [anon_sym_const] = ACTIONS(1463),
    [anon_sym_var] = ACTIONS(1463),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1461),
    [anon_sym_async] = ACTIONS(1463),
    [anon_sym_DOT] = ACTIONS(1461),
    [anon_sym_error] = ACTIONS(1463),
    [anon_sym_false] = ACTIONS(1463),
    [anon_sym_null] = ACTIONS(1463),
    [anon_sym_anyframe] = ACTIONS(1463),
    [anon_sym_true] = ACTIONS(1463),
    [anon_sym_undefined] = ACTIONS(1463),
    [anon_sym_unreachable] = ACTIONS(1463),
    [sym_BuildinTypeExpr] = ACTIONS(1463),
    [anon_sym_packed] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(1461),
    [anon_sym_switch] = ACTIONS(1463),
    [anon_sym_LBRACK] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1463),
    [anon_sym_while] = ACTIONS(1463),
    [anon_sym_for] = ACTIONS(1463),
    [anon_sym_PIPE] = ACTIONS(1015),
    [anon_sym_STAR] = ACTIONS(1017),
    [anon_sym_EQ_EQ] = ACTIONS(1019),
    [anon_sym_BANG_EQ] = ACTIONS(1019),
    [anon_sym_LT] = ACTIONS(1021),
    [anon_sym_GT] = ACTIONS(1021),
    [anon_sym_LT_EQ] = ACTIONS(1019),
    [anon_sym_GT_EQ] = ACTIONS(1019),
    [anon_sym_AMP] = ACTIONS(1023),
    [anon_sym_CARET] = ACTIONS(1023),
    [anon_sym_orelse] = ACTIONS(1015),
    [anon_sym_catch] = ACTIONS(1025),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1033),
    [anon_sym_DASH_PERCENT] = ACTIONS(1033),
    [anon_sym_PLUS_PIPE] = ACTIONS(1033),
    [anon_sym_DASH_PIPE] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1035),
    [anon_sym_SLASH] = ACTIONS(1017),
    [anon_sym_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_STAR] = ACTIONS(1035),
    [anon_sym_STAR_PERCENT] = ACTIONS(1035),
    [anon_sym_STAR_PIPE] = ACTIONS(1035),
    [anon_sym_QMARK] = ACTIONS(1461),
    [anon_sym_struct] = ACTIONS(1463),
    [anon_sym_opaque] = ACTIONS(1463),
    [anon_sym_enum] = ACTIONS(1463),
    [anon_sym_union] = ACTIONS(1463),
    [sym_doc_comment] = ACTIONS(1461),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [aux_sym_FLOAT_token1] = ACTIONS(1461),
    [aux_sym_FLOAT_token2] = ACTIONS(1461),
    [aux_sym_FLOAT_token3] = ACTIONS(1461),
    [aux_sym_FLOAT_token4] = ACTIONS(1461),
    [aux_sym_INTEGER_token1] = ACTIONS(1461),
    [aux_sym_INTEGER_token2] = ACTIONS(1461),
    [aux_sym_INTEGER_token3] = ACTIONS(1463),
    [aux_sym_INTEGER_token4] = ACTIONS(1463),
    [anon_sym_DQUOTE] = ACTIONS(1461),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1461),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1463),
    [anon_sym_AT] = ACTIONS(1461),
  },
  [547] = {
    [ts_builtin_sym_end] = ACTIONS(530),
    [anon_sym_COMMA] = ACTIONS(530),
    [anon_sym_pub] = ACTIONS(528),
    [anon_sym_test] = ACTIONS(528),
    [anon_sym_comptime] = ACTIONS(528),
    [anon_sym_export] = ACTIONS(528),
    [anon_sym_extern] = ACTIONS(528),
    [anon_sym_inline] = ACTIONS(528),
    [anon_sym_noinline] = ACTIONS(528),
    [anon_sym_threadlocal] = ACTIONS(528),
    [anon_sym_usingnamespace] = ACTIONS(528),
    [anon_sym_fn] = ACTIONS(528),
    [anon_sym_BANG] = ACTIONS(528),
    [anon_sym_const] = ACTIONS(528),
    [anon_sym_var] = ACTIONS(528),
    [anon_sym_or] = ACTIONS(528),
    [anon_sym_and] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(530),
    [anon_sym_async] = ACTIONS(528),
    [anon_sym_DOT] = ACTIONS(528),
    [anon_sym_error] = ACTIONS(528),
    [anon_sym_false] = ACTIONS(528),
    [anon_sym_null] = ACTIONS(528),
    [anon_sym_anyframe] = ACTIONS(528),
    [anon_sym_true] = ACTIONS(528),
    [anon_sym_undefined] = ACTIONS(528),
    [anon_sym_unreachable] = ACTIONS(528),
    [sym_BuildinTypeExpr] = ACTIONS(528),
    [anon_sym_packed] = ACTIONS(528),
    [anon_sym_LPAREN] = ACTIONS(530),
    [anon_sym_switch] = ACTIONS(528),
    [anon_sym_LBRACK] = ACTIONS(530),
    [anon_sym_if] = ACTIONS(528),
    [anon_sym_while] = ACTIONS(528),
    [anon_sym_for] = ACTIONS(528),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_EQ_EQ] = ACTIONS(530),
    [anon_sym_BANG_EQ] = ACTIONS(530),
    [anon_sym_LT] = ACTIONS(528),
    [anon_sym_GT] = ACTIONS(528),
    [anon_sym_LT_EQ] = ACTIONS(530),
    [anon_sym_GT_EQ] = ACTIONS(530),
    [anon_sym_AMP] = ACTIONS(530),
    [anon_sym_CARET] = ACTIONS(530),
    [anon_sym_orelse] = ACTIONS(528),
    [anon_sym_catch] = ACTIONS(528),
    [anon_sym_LT_LT] = ACTIONS(528),
    [anon_sym_GT_GT] = ACTIONS(530),
    [anon_sym_LT_LT_PIPE] = ACTIONS(530),
    [anon_sym_PLUS] = ACTIONS(528),
    [anon_sym_DASH] = ACTIONS(528),
    [anon_sym_PLUS_PLUS] = ACTIONS(530),
    [anon_sym_PLUS_PERCENT] = ACTIONS(530),
    [anon_sym_DASH_PERCENT] = ACTIONS(530),
    [anon_sym_PLUS_PIPE] = ACTIONS(530),
    [anon_sym_DASH_PIPE] = ACTIONS(530),
    [anon_sym_PIPE_PIPE] = ACTIONS(530),
    [anon_sym_SLASH] = ACTIONS(528),
    [anon_sym_PERCENT] = ACTIONS(530),
    [anon_sym_STAR_STAR] = ACTIONS(530),
    [anon_sym_STAR_PERCENT] = ACTIONS(530),
    [anon_sym_STAR_PIPE] = ACTIONS(530),
    [anon_sym_QMARK] = ACTIONS(530),
    [anon_sym_DOT_STAR] = ACTIONS(530),
    [anon_sym_DOT_QMARK] = ACTIONS(530),
    [anon_sym_struct] = ACTIONS(528),
    [anon_sym_opaque] = ACTIONS(528),
    [anon_sym_enum] = ACTIONS(528),
    [anon_sym_union] = ACTIONS(528),
    [sym_doc_comment] = ACTIONS(530),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(530),
    [aux_sym_FLOAT_token1] = ACTIONS(530),
    [aux_sym_FLOAT_token2] = ACTIONS(530),
    [aux_sym_FLOAT_token3] = ACTIONS(530),
    [aux_sym_FLOAT_token4] = ACTIONS(530),
    [aux_sym_INTEGER_token1] = ACTIONS(530),
    [aux_sym_INTEGER_token2] = ACTIONS(530),
    [aux_sym_INTEGER_token3] = ACTIONS(528),
    [aux_sym_INTEGER_token4] = ACTIONS(528),
    [anon_sym_DQUOTE] = ACTIONS(530),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(530),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(528),
    [anon_sym_AT] = ACTIONS(530),
  },
  [548] = {
    [ts_builtin_sym_end] = ACTIONS(570),
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_pub] = ACTIONS(568),
    [anon_sym_test] = ACTIONS(568),
    [anon_sym_comptime] = ACTIONS(568),
    [anon_sym_export] = ACTIONS(568),
    [anon_sym_extern] = ACTIONS(568),
    [anon_sym_inline] = ACTIONS(568),
    [anon_sym_noinline] = ACTIONS(568),
    [anon_sym_threadlocal] = ACTIONS(568),
    [anon_sym_usingnamespace] = ACTIONS(568),
    [anon_sym_fn] = ACTIONS(568),
    [anon_sym_BANG] = ACTIONS(568),
    [anon_sym_const] = ACTIONS(568),
    [anon_sym_var] = ACTIONS(568),
    [anon_sym_or] = ACTIONS(568),
    [anon_sym_and] = ACTIONS(568),
    [anon_sym_LBRACE] = ACTIONS(570),
    [anon_sym_RBRACE] = ACTIONS(570),
    [anon_sym_async] = ACTIONS(568),
    [anon_sym_DOT] = ACTIONS(568),
    [anon_sym_error] = ACTIONS(568),
    [anon_sym_false] = ACTIONS(568),
    [anon_sym_null] = ACTIONS(568),
    [anon_sym_anyframe] = ACTIONS(568),
    [anon_sym_true] = ACTIONS(568),
    [anon_sym_undefined] = ACTIONS(568),
    [anon_sym_unreachable] = ACTIONS(568),
    [sym_BuildinTypeExpr] = ACTIONS(568),
    [anon_sym_packed] = ACTIONS(568),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_switch] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_if] = ACTIONS(568),
    [anon_sym_while] = ACTIONS(568),
    [anon_sym_for] = ACTIONS(568),
    [anon_sym_PIPE] = ACTIONS(568),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_EQ_EQ] = ACTIONS(570),
    [anon_sym_BANG_EQ] = ACTIONS(570),
    [anon_sym_LT] = ACTIONS(568),
    [anon_sym_GT] = ACTIONS(568),
    [anon_sym_LT_EQ] = ACTIONS(570),
    [anon_sym_GT_EQ] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(570),
    [anon_sym_CARET] = ACTIONS(570),
    [anon_sym_orelse] = ACTIONS(568),
    [anon_sym_catch] = ACTIONS(568),
    [anon_sym_LT_LT] = ACTIONS(568),
    [anon_sym_GT_GT] = ACTIONS(570),
    [anon_sym_LT_LT_PIPE] = ACTIONS(570),
    [anon_sym_PLUS] = ACTIONS(568),
    [anon_sym_DASH] = ACTIONS(568),
    [anon_sym_PLUS_PLUS] = ACTIONS(570),
    [anon_sym_PLUS_PERCENT] = ACTIONS(570),
    [anon_sym_DASH_PERCENT] = ACTIONS(570),
    [anon_sym_PLUS_PIPE] = ACTIONS(570),
    [anon_sym_DASH_PIPE] = ACTIONS(570),
    [anon_sym_PIPE_PIPE] = ACTIONS(570),
    [anon_sym_SLASH] = ACTIONS(568),
    [anon_sym_PERCENT] = ACTIONS(570),
    [anon_sym_STAR_STAR] = ACTIONS(570),
    [anon_sym_STAR_PERCENT] = ACTIONS(570),
    [anon_sym_STAR_PIPE] = ACTIONS(570),
    [anon_sym_QMARK] = ACTIONS(570),
    [anon_sym_DOT_STAR] = ACTIONS(570),
    [anon_sym_DOT_QMARK] = ACTIONS(570),
    [anon_sym_struct] = ACTIONS(568),
    [anon_sym_opaque] = ACTIONS(568),
    [anon_sym_enum] = ACTIONS(568),
    [anon_sym_union] = ACTIONS(568),
    [sym_doc_comment] = ACTIONS(570),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(570),
    [aux_sym_FLOAT_token1] = ACTIONS(570),
    [aux_sym_FLOAT_token2] = ACTIONS(570),
    [aux_sym_FLOAT_token3] = ACTIONS(570),
    [aux_sym_FLOAT_token4] = ACTIONS(570),
    [aux_sym_INTEGER_token1] = ACTIONS(570),
    [aux_sym_INTEGER_token2] = ACTIONS(570),
    [aux_sym_INTEGER_token3] = ACTIONS(568),
    [aux_sym_INTEGER_token4] = ACTIONS(568),
    [anon_sym_DQUOTE] = ACTIONS(570),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(570),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(568),
    [anon_sym_AT] = ACTIONS(570),
  },
  [549] = {
    [sym_Decl] = STATE(1373),
    [sym_FnProto] = STATE(1200),
    [sym_VarDecl] = STATE(1379),
    [sym__TypeExpr] = STATE(1304),
    [sym_ErrorUnionExpr] = STATE(1304),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1056),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_pub] = ACTIONS(1465),
    [anon_sym_test] = ACTIONS(1467),
    [anon_sym_comptime] = ACTIONS(1469),
    [anon_sym_export] = ACTIONS(13),
    [anon_sym_extern] = ACTIONS(15),
    [anon_sym_inline] = ACTIONS(17),
    [anon_sym_noinline] = ACTIONS(19),
    [anon_sym_threadlocal] = ACTIONS(21),
    [anon_sym_usingnamespace] = ACTIONS(23),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_const] = ACTIONS(27),
    [anon_sym_var] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(1471),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [550] = {
    [ts_builtin_sym_end] = ACTIONS(1163),
    [anon_sym_COMMA] = ACTIONS(1163),
    [anon_sym_pub] = ACTIONS(1165),
    [anon_sym_test] = ACTIONS(1165),
    [anon_sym_comptime] = ACTIONS(1165),
    [anon_sym_export] = ACTIONS(1165),
    [anon_sym_extern] = ACTIONS(1165),
    [anon_sym_inline] = ACTIONS(1165),
    [anon_sym_noinline] = ACTIONS(1165),
    [anon_sym_threadlocal] = ACTIONS(1165),
    [anon_sym_usingnamespace] = ACTIONS(1165),
    [anon_sym_fn] = ACTIONS(1165),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_const] = ACTIONS(1165),
    [anon_sym_var] = ACTIONS(1165),
    [anon_sym_or] = ACTIONS(1165),
    [anon_sym_and] = ACTIONS(1165),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(1163),
    [anon_sym_async] = ACTIONS(1165),
    [anon_sym_DOT] = ACTIONS(1165),
    [anon_sym_error] = ACTIONS(1165),
    [anon_sym_false] = ACTIONS(1165),
    [anon_sym_null] = ACTIONS(1165),
    [anon_sym_anyframe] = ACTIONS(1165),
    [anon_sym_true] = ACTIONS(1165),
    [anon_sym_undefined] = ACTIONS(1165),
    [anon_sym_unreachable] = ACTIONS(1165),
    [sym_BuildinTypeExpr] = ACTIONS(1165),
    [anon_sym_packed] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_switch] = ACTIONS(1165),
    [anon_sym_LBRACK] = ACTIONS(1163),
    [anon_sym_if] = ACTIONS(1165),
    [anon_sym_while] = ACTIONS(1165),
    [anon_sym_for] = ACTIONS(1165),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_EQ_EQ] = ACTIONS(1163),
    [anon_sym_BANG_EQ] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_GT] = ACTIONS(1165),
    [anon_sym_LT_EQ] = ACTIONS(1163),
    [anon_sym_GT_EQ] = ACTIONS(1163),
    [anon_sym_AMP] = ACTIONS(1163),
    [anon_sym_CARET] = ACTIONS(1163),
    [anon_sym_orelse] = ACTIONS(1165),
    [anon_sym_catch] = ACTIONS(1165),
    [anon_sym_LT_LT] = ACTIONS(1165),
    [anon_sym_GT_GT] = ACTIONS(1163),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1163),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_PLUS_PLUS] = ACTIONS(1163),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1163),
    [anon_sym_DASH_PERCENT] = ACTIONS(1163),
    [anon_sym_PLUS_PIPE] = ACTIONS(1163),
    [anon_sym_DASH_PIPE] = ACTIONS(1163),
    [anon_sym_PIPE_PIPE] = ACTIONS(1163),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1163),
    [anon_sym_STAR_STAR] = ACTIONS(1163),
    [anon_sym_STAR_PERCENT] = ACTIONS(1163),
    [anon_sym_STAR_PIPE] = ACTIONS(1163),
    [anon_sym_QMARK] = ACTIONS(1163),
    [anon_sym_DOT_STAR] = ACTIONS(1163),
    [anon_sym_DOT_QMARK] = ACTIONS(1163),
    [anon_sym_struct] = ACTIONS(1165),
    [anon_sym_opaque] = ACTIONS(1165),
    [anon_sym_enum] = ACTIONS(1165),
    [anon_sym_union] = ACTIONS(1165),
    [sym_doc_comment] = ACTIONS(1163),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1163),
    [aux_sym_FLOAT_token1] = ACTIONS(1163),
    [aux_sym_FLOAT_token2] = ACTIONS(1163),
    [aux_sym_FLOAT_token3] = ACTIONS(1163),
    [aux_sym_FLOAT_token4] = ACTIONS(1163),
    [aux_sym_INTEGER_token1] = ACTIONS(1163),
    [aux_sym_INTEGER_token2] = ACTIONS(1163),
    [aux_sym_INTEGER_token3] = ACTIONS(1165),
    [aux_sym_INTEGER_token4] = ACTIONS(1165),
    [anon_sym_DQUOTE] = ACTIONS(1163),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1163),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1165),
    [anon_sym_AT] = ACTIONS(1163),
  },
  [551] = {
    [ts_builtin_sym_end] = ACTIONS(566),
    [anon_sym_COMMA] = ACTIONS(566),
    [anon_sym_pub] = ACTIONS(564),
    [anon_sym_test] = ACTIONS(564),
    [anon_sym_comptime] = ACTIONS(564),
    [anon_sym_export] = ACTIONS(564),
    [anon_sym_extern] = ACTIONS(564),
    [anon_sym_inline] = ACTIONS(564),
    [anon_sym_noinline] = ACTIONS(564),
    [anon_sym_threadlocal] = ACTIONS(564),
    [anon_sym_usingnamespace] = ACTIONS(564),
    [anon_sym_fn] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_const] = ACTIONS(564),
    [anon_sym_var] = ACTIONS(564),
    [anon_sym_or] = ACTIONS(564),
    [anon_sym_and] = ACTIONS(564),
    [anon_sym_LBRACE] = ACTIONS(566),
    [anon_sym_RBRACE] = ACTIONS(566),
    [anon_sym_async] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_error] = ACTIONS(564),
    [anon_sym_false] = ACTIONS(564),
    [anon_sym_null] = ACTIONS(564),
    [anon_sym_anyframe] = ACTIONS(564),
    [anon_sym_true] = ACTIONS(564),
    [anon_sym_undefined] = ACTIONS(564),
    [anon_sym_unreachable] = ACTIONS(564),
    [sym_BuildinTypeExpr] = ACTIONS(564),
    [anon_sym_packed] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_switch] = ACTIONS(564),
    [anon_sym_LBRACK] = ACTIONS(566),
    [anon_sym_if] = ACTIONS(564),
    [anon_sym_while] = ACTIONS(564),
    [anon_sym_for] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(566),
    [anon_sym_BANG_EQ] = ACTIONS(566),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT_EQ] = ACTIONS(566),
    [anon_sym_GT_EQ] = ACTIONS(566),
    [anon_sym_AMP] = ACTIONS(566),
    [anon_sym_CARET] = ACTIONS(566),
    [anon_sym_orelse] = ACTIONS(564),
    [anon_sym_catch] = ACTIONS(564),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(566),
    [anon_sym_LT_LT_PIPE] = ACTIONS(566),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_PLUS_PLUS] = ACTIONS(566),
    [anon_sym_PLUS_PERCENT] = ACTIONS(566),
    [anon_sym_DASH_PERCENT] = ACTIONS(566),
    [anon_sym_PLUS_PIPE] = ACTIONS(566),
    [anon_sym_DASH_PIPE] = ACTIONS(566),
    [anon_sym_PIPE_PIPE] = ACTIONS(566),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(566),
    [anon_sym_STAR_STAR] = ACTIONS(566),
    [anon_sym_STAR_PERCENT] = ACTIONS(566),
    [anon_sym_STAR_PIPE] = ACTIONS(566),
    [anon_sym_QMARK] = ACTIONS(566),
    [anon_sym_DOT_STAR] = ACTIONS(566),
    [anon_sym_DOT_QMARK] = ACTIONS(566),
    [anon_sym_struct] = ACTIONS(564),
    [anon_sym_opaque] = ACTIONS(564),
    [anon_sym_enum] = ACTIONS(564),
    [anon_sym_union] = ACTIONS(564),
    [sym_doc_comment] = ACTIONS(566),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(566),
    [aux_sym_FLOAT_token1] = ACTIONS(566),
    [aux_sym_FLOAT_token2] = ACTIONS(566),
    [aux_sym_FLOAT_token3] = ACTIONS(566),
    [aux_sym_FLOAT_token4] = ACTIONS(566),
    [aux_sym_INTEGER_token1] = ACTIONS(566),
    [aux_sym_INTEGER_token2] = ACTIONS(566),
    [aux_sym_INTEGER_token3] = ACTIONS(564),
    [aux_sym_INTEGER_token4] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(566),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(566),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(564),
    [anon_sym_AT] = ACTIONS(566),
  },
  [552] = {
    [ts_builtin_sym_end] = ACTIONS(1167),
    [anon_sym_COMMA] = ACTIONS(1167),
    [anon_sym_pub] = ACTIONS(1169),
    [anon_sym_test] = ACTIONS(1169),
    [anon_sym_comptime] = ACTIONS(1169),
    [anon_sym_export] = ACTIONS(1169),
    [anon_sym_extern] = ACTIONS(1169),
    [anon_sym_inline] = ACTIONS(1169),
    [anon_sym_noinline] = ACTIONS(1169),
    [anon_sym_threadlocal] = ACTIONS(1169),
    [anon_sym_usingnamespace] = ACTIONS(1169),
    [anon_sym_fn] = ACTIONS(1169),
    [anon_sym_BANG] = ACTIONS(1169),
    [anon_sym_const] = ACTIONS(1169),
    [anon_sym_var] = ACTIONS(1169),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_and] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(1167),
    [anon_sym_async] = ACTIONS(1169),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_error] = ACTIONS(1169),
    [anon_sym_false] = ACTIONS(1169),
    [anon_sym_null] = ACTIONS(1169),
    [anon_sym_anyframe] = ACTIONS(1169),
    [anon_sym_true] = ACTIONS(1169),
    [anon_sym_undefined] = ACTIONS(1169),
    [anon_sym_unreachable] = ACTIONS(1169),
    [sym_BuildinTypeExpr] = ACTIONS(1169),
    [anon_sym_packed] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_switch] = ACTIONS(1169),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_if] = ACTIONS(1169),
    [anon_sym_while] = ACTIONS(1169),
    [anon_sym_for] = ACTIONS(1169),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_STAR] = ACTIONS(1169),
    [anon_sym_EQ_EQ] = ACTIONS(1167),
    [anon_sym_BANG_EQ] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_LT_EQ] = ACTIONS(1167),
    [anon_sym_GT_EQ] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1167),
    [anon_sym_CARET] = ACTIONS(1167),
    [anon_sym_orelse] = ACTIONS(1169),
    [anon_sym_catch] = ACTIONS(1169),
    [anon_sym_LT_LT] = ACTIONS(1169),
    [anon_sym_GT_GT] = ACTIONS(1167),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1167),
    [anon_sym_PLUS] = ACTIONS(1169),
    [anon_sym_DASH] = ACTIONS(1169),
    [anon_sym_PLUS_PLUS] = ACTIONS(1167),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1167),
    [anon_sym_DASH_PERCENT] = ACTIONS(1167),
    [anon_sym_PLUS_PIPE] = ACTIONS(1167),
    [anon_sym_DASH_PIPE] = ACTIONS(1167),
    [anon_sym_PIPE_PIPE] = ACTIONS(1167),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1167),
    [anon_sym_STAR_STAR] = ACTIONS(1167),
    [anon_sym_STAR_PERCENT] = ACTIONS(1167),
    [anon_sym_STAR_PIPE] = ACTIONS(1167),
    [anon_sym_QMARK] = ACTIONS(1167),
    [anon_sym_DOT_STAR] = ACTIONS(1167),
    [anon_sym_DOT_QMARK] = ACTIONS(1167),
    [anon_sym_struct] = ACTIONS(1169),
    [anon_sym_opaque] = ACTIONS(1169),
    [anon_sym_enum] = ACTIONS(1169),
    [anon_sym_union] = ACTIONS(1169),
    [sym_doc_comment] = ACTIONS(1167),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1167),
    [aux_sym_FLOAT_token1] = ACTIONS(1167),
    [aux_sym_FLOAT_token2] = ACTIONS(1167),
    [aux_sym_FLOAT_token3] = ACTIONS(1167),
    [aux_sym_FLOAT_token4] = ACTIONS(1167),
    [aux_sym_INTEGER_token1] = ACTIONS(1167),
    [aux_sym_INTEGER_token2] = ACTIONS(1167),
    [aux_sym_INTEGER_token3] = ACTIONS(1169),
    [aux_sym_INTEGER_token4] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1167),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1167),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1169),
    [anon_sym_AT] = ACTIONS(1167),
  },
  [553] = {
    [ts_builtin_sym_end] = ACTIONS(1175),
    [anon_sym_COMMA] = ACTIONS(1175),
    [anon_sym_pub] = ACTIONS(1177),
    [anon_sym_test] = ACTIONS(1177),
    [anon_sym_comptime] = ACTIONS(1177),
    [anon_sym_export] = ACTIONS(1177),
    [anon_sym_extern] = ACTIONS(1177),
    [anon_sym_inline] = ACTIONS(1177),
    [anon_sym_noinline] = ACTIONS(1177),
    [anon_sym_threadlocal] = ACTIONS(1177),
    [anon_sym_usingnamespace] = ACTIONS(1177),
    [anon_sym_fn] = ACTIONS(1177),
    [anon_sym_BANG] = ACTIONS(1473),
    [anon_sym_const] = ACTIONS(1177),
    [anon_sym_var] = ACTIONS(1177),
    [anon_sym_or] = ACTIONS(1177),
    [anon_sym_and] = ACTIONS(1177),
    [anon_sym_LBRACE] = ACTIONS(1175),
    [anon_sym_RBRACE] = ACTIONS(1175),
    [anon_sym_async] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(1177),
    [anon_sym_error] = ACTIONS(1177),
    [anon_sym_false] = ACTIONS(1177),
    [anon_sym_null] = ACTIONS(1177),
    [anon_sym_anyframe] = ACTIONS(1177),
    [anon_sym_true] = ACTIONS(1177),
    [anon_sym_undefined] = ACTIONS(1177),
    [anon_sym_unreachable] = ACTIONS(1177),
    [sym_BuildinTypeExpr] = ACTIONS(1177),
    [anon_sym_packed] = ACTIONS(1177),
    [anon_sym_LPAREN] = ACTIONS(1175),
    [anon_sym_switch] = ACTIONS(1177),
    [anon_sym_LBRACK] = ACTIONS(1175),
    [anon_sym_if] = ACTIONS(1177),
    [anon_sym_while] = ACTIONS(1177),
    [anon_sym_for] = ACTIONS(1177),
    [anon_sym_PIPE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1177),
    [anon_sym_EQ_EQ] = ACTIONS(1175),
    [anon_sym_BANG_EQ] = ACTIONS(1175),
    [anon_sym_LT] = ACTIONS(1177),
    [anon_sym_GT] = ACTIONS(1177),
    [anon_sym_LT_EQ] = ACTIONS(1175),
    [anon_sym_GT_EQ] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1175),
    [anon_sym_CARET] = ACTIONS(1175),
    [anon_sym_orelse] = ACTIONS(1177),
    [anon_sym_catch] = ACTIONS(1177),
    [anon_sym_LT_LT] = ACTIONS(1177),
    [anon_sym_GT_GT] = ACTIONS(1175),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1175),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1175),
    [anon_sym_DASH_PERCENT] = ACTIONS(1175),
    [anon_sym_PLUS_PIPE] = ACTIONS(1175),
    [anon_sym_DASH_PIPE] = ACTIONS(1175),
    [anon_sym_PIPE_PIPE] = ACTIONS(1175),
    [anon_sym_SLASH] = ACTIONS(1177),
    [anon_sym_PERCENT] = ACTIONS(1175),
    [anon_sym_STAR_STAR] = ACTIONS(1175),
    [anon_sym_STAR_PERCENT] = ACTIONS(1175),
    [anon_sym_STAR_PIPE] = ACTIONS(1175),
    [anon_sym_QMARK] = ACTIONS(1175),
    [anon_sym_DOT_STAR] = ACTIONS(1175),
    [anon_sym_DOT_QMARK] = ACTIONS(1175),
    [anon_sym_struct] = ACTIONS(1177),
    [anon_sym_opaque] = ACTIONS(1177),
    [anon_sym_enum] = ACTIONS(1177),
    [anon_sym_union] = ACTIONS(1177),
    [sym_doc_comment] = ACTIONS(1175),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1175),
    [aux_sym_FLOAT_token1] = ACTIONS(1175),
    [aux_sym_FLOAT_token2] = ACTIONS(1175),
    [aux_sym_FLOAT_token3] = ACTIONS(1175),
    [aux_sym_FLOAT_token4] = ACTIONS(1175),
    [aux_sym_INTEGER_token1] = ACTIONS(1175),
    [aux_sym_INTEGER_token2] = ACTIONS(1175),
    [aux_sym_INTEGER_token3] = ACTIONS(1177),
    [aux_sym_INTEGER_token4] = ACTIONS(1177),
    [anon_sym_DQUOTE] = ACTIONS(1175),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1175),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1177),
    [anon_sym_AT] = ACTIONS(1175),
  },
  [554] = {
    [ts_builtin_sym_end] = ACTIONS(1181),
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_pub] = ACTIONS(1183),
    [anon_sym_test] = ACTIONS(1183),
    [anon_sym_comptime] = ACTIONS(1183),
    [anon_sym_export] = ACTIONS(1183),
    [anon_sym_extern] = ACTIONS(1183),
    [anon_sym_inline] = ACTIONS(1183),
    [anon_sym_noinline] = ACTIONS(1183),
    [anon_sym_threadlocal] = ACTIONS(1183),
    [anon_sym_usingnamespace] = ACTIONS(1183),
    [anon_sym_fn] = ACTIONS(1183),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_const] = ACTIONS(1183),
    [anon_sym_var] = ACTIONS(1183),
    [anon_sym_or] = ACTIONS(1183),
    [anon_sym_and] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym_async] = ACTIONS(1183),
    [anon_sym_DOT] = ACTIONS(1183),
    [anon_sym_error] = ACTIONS(1183),
    [anon_sym_false] = ACTIONS(1183),
    [anon_sym_null] = ACTIONS(1183),
    [anon_sym_anyframe] = ACTIONS(1183),
    [anon_sym_true] = ACTIONS(1183),
    [anon_sym_undefined] = ACTIONS(1183),
    [anon_sym_unreachable] = ACTIONS(1183),
    [sym_BuildinTypeExpr] = ACTIONS(1183),
    [anon_sym_packed] = ACTIONS(1183),
    [anon_sym_LPAREN] = ACTIONS(1181),
    [anon_sym_switch] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_while] = ACTIONS(1183),
    [anon_sym_for] = ACTIONS(1183),
    [anon_sym_PIPE] = ACTIONS(1183),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_EQ_EQ] = ACTIONS(1181),
    [anon_sym_BANG_EQ] = ACTIONS(1181),
    [anon_sym_LT] = ACTIONS(1183),
    [anon_sym_GT] = ACTIONS(1183),
    [anon_sym_LT_EQ] = ACTIONS(1181),
    [anon_sym_GT_EQ] = ACTIONS(1181),
    [anon_sym_AMP] = ACTIONS(1181),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_orelse] = ACTIONS(1183),
    [anon_sym_catch] = ACTIONS(1183),
    [anon_sym_LT_LT] = ACTIONS(1183),
    [anon_sym_GT_GT] = ACTIONS(1181),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1181),
    [anon_sym_PLUS] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1183),
    [anon_sym_PLUS_PLUS] = ACTIONS(1181),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1181),
    [anon_sym_DASH_PERCENT] = ACTIONS(1181),
    [anon_sym_PLUS_PIPE] = ACTIONS(1181),
    [anon_sym_DASH_PIPE] = ACTIONS(1181),
    [anon_sym_PIPE_PIPE] = ACTIONS(1181),
    [anon_sym_SLASH] = ACTIONS(1183),
    [anon_sym_PERCENT] = ACTIONS(1181),
    [anon_sym_STAR_STAR] = ACTIONS(1181),
    [anon_sym_STAR_PERCENT] = ACTIONS(1181),
    [anon_sym_STAR_PIPE] = ACTIONS(1181),
    [anon_sym_QMARK] = ACTIONS(1181),
    [anon_sym_DOT_STAR] = ACTIONS(1181),
    [anon_sym_DOT_QMARK] = ACTIONS(1181),
    [anon_sym_struct] = ACTIONS(1183),
    [anon_sym_opaque] = ACTIONS(1183),
    [anon_sym_enum] = ACTIONS(1183),
    [anon_sym_union] = ACTIONS(1183),
    [sym_doc_comment] = ACTIONS(1181),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1181),
    [aux_sym_FLOAT_token1] = ACTIONS(1181),
    [aux_sym_FLOAT_token2] = ACTIONS(1181),
    [aux_sym_FLOAT_token3] = ACTIONS(1181),
    [aux_sym_FLOAT_token4] = ACTIONS(1181),
    [aux_sym_INTEGER_token1] = ACTIONS(1181),
    [aux_sym_INTEGER_token2] = ACTIONS(1181),
    [aux_sym_INTEGER_token3] = ACTIONS(1183),
    [aux_sym_INTEGER_token4] = ACTIONS(1183),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1181),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1183),
    [anon_sym_AT] = ACTIONS(1181),
  },
  [555] = {
    [ts_builtin_sym_end] = ACTIONS(1185),
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_pub] = ACTIONS(1187),
    [anon_sym_test] = ACTIONS(1187),
    [anon_sym_comptime] = ACTIONS(1187),
    [anon_sym_export] = ACTIONS(1187),
    [anon_sym_extern] = ACTIONS(1187),
    [anon_sym_inline] = ACTIONS(1187),
    [anon_sym_noinline] = ACTIONS(1187),
    [anon_sym_threadlocal] = ACTIONS(1187),
    [anon_sym_usingnamespace] = ACTIONS(1187),
    [anon_sym_fn] = ACTIONS(1187),
    [anon_sym_BANG] = ACTIONS(1187),
    [anon_sym_const] = ACTIONS(1187),
    [anon_sym_var] = ACTIONS(1187),
    [anon_sym_or] = ACTIONS(1187),
    [anon_sym_and] = ACTIONS(1187),
    [anon_sym_LBRACE] = ACTIONS(1185),
    [anon_sym_RBRACE] = ACTIONS(1185),
    [anon_sym_async] = ACTIONS(1187),
    [anon_sym_DOT] = ACTIONS(1187),
    [anon_sym_error] = ACTIONS(1187),
    [anon_sym_false] = ACTIONS(1187),
    [anon_sym_null] = ACTIONS(1187),
    [anon_sym_anyframe] = ACTIONS(1187),
    [anon_sym_true] = ACTIONS(1187),
    [anon_sym_undefined] = ACTIONS(1187),
    [anon_sym_unreachable] = ACTIONS(1187),
    [sym_BuildinTypeExpr] = ACTIONS(1187),
    [anon_sym_packed] = ACTIONS(1187),
    [anon_sym_LPAREN] = ACTIONS(1185),
    [anon_sym_switch] = ACTIONS(1187),
    [anon_sym_LBRACK] = ACTIONS(1185),
    [anon_sym_if] = ACTIONS(1187),
    [anon_sym_while] = ACTIONS(1187),
    [anon_sym_for] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_STAR] = ACTIONS(1187),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1185),
    [anon_sym_GT_EQ] = ACTIONS(1185),
    [anon_sym_AMP] = ACTIONS(1185),
    [anon_sym_CARET] = ACTIONS(1185),
    [anon_sym_orelse] = ACTIONS(1187),
    [anon_sym_catch] = ACTIONS(1187),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1185),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1185),
    [anon_sym_PLUS] = ACTIONS(1187),
    [anon_sym_DASH] = ACTIONS(1187),
    [anon_sym_PLUS_PLUS] = ACTIONS(1185),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1185),
    [anon_sym_DASH_PERCENT] = ACTIONS(1185),
    [anon_sym_PLUS_PIPE] = ACTIONS(1185),
    [anon_sym_DASH_PIPE] = ACTIONS(1185),
    [anon_sym_PIPE_PIPE] = ACTIONS(1185),
    [anon_sym_SLASH] = ACTIONS(1187),
    [anon_sym_PERCENT] = ACTIONS(1185),
    [anon_sym_STAR_STAR] = ACTIONS(1185),
    [anon_sym_STAR_PERCENT] = ACTIONS(1185),
    [anon_sym_STAR_PIPE] = ACTIONS(1185),
    [anon_sym_QMARK] = ACTIONS(1185),
    [anon_sym_DOT_STAR] = ACTIONS(1185),
    [anon_sym_DOT_QMARK] = ACTIONS(1185),
    [anon_sym_struct] = ACTIONS(1187),
    [anon_sym_opaque] = ACTIONS(1187),
    [anon_sym_enum] = ACTIONS(1187),
    [anon_sym_union] = ACTIONS(1187),
    [sym_doc_comment] = ACTIONS(1185),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1185),
    [aux_sym_FLOAT_token1] = ACTIONS(1185),
    [aux_sym_FLOAT_token2] = ACTIONS(1185),
    [aux_sym_FLOAT_token3] = ACTIONS(1185),
    [aux_sym_FLOAT_token4] = ACTIONS(1185),
    [aux_sym_INTEGER_token1] = ACTIONS(1185),
    [aux_sym_INTEGER_token2] = ACTIONS(1185),
    [aux_sym_INTEGER_token3] = ACTIONS(1187),
    [aux_sym_INTEGER_token4] = ACTIONS(1187),
    [anon_sym_DQUOTE] = ACTIONS(1185),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1185),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1187),
    [anon_sym_AT] = ACTIONS(1185),
  },
  [556] = {
    [ts_builtin_sym_end] = ACTIONS(1189),
    [anon_sym_COMMA] = ACTIONS(1189),
    [anon_sym_pub] = ACTIONS(1191),
    [anon_sym_test] = ACTIONS(1191),
    [anon_sym_comptime] = ACTIONS(1191),
    [anon_sym_export] = ACTIONS(1191),
    [anon_sym_extern] = ACTIONS(1191),
    [anon_sym_inline] = ACTIONS(1191),
    [anon_sym_noinline] = ACTIONS(1191),
    [anon_sym_threadlocal] = ACTIONS(1191),
    [anon_sym_usingnamespace] = ACTIONS(1191),
    [anon_sym_fn] = ACTIONS(1191),
    [anon_sym_BANG] = ACTIONS(1191),
    [anon_sym_const] = ACTIONS(1191),
    [anon_sym_var] = ACTIONS(1191),
    [anon_sym_or] = ACTIONS(1191),
    [anon_sym_and] = ACTIONS(1191),
    [anon_sym_LBRACE] = ACTIONS(1189),
    [anon_sym_RBRACE] = ACTIONS(1189),
    [anon_sym_async] = ACTIONS(1191),
    [anon_sym_DOT] = ACTIONS(1191),
    [anon_sym_error] = ACTIONS(1191),
    [anon_sym_false] = ACTIONS(1191),
    [anon_sym_null] = ACTIONS(1191),
    [anon_sym_anyframe] = ACTIONS(1191),
    [anon_sym_true] = ACTIONS(1191),
    [anon_sym_undefined] = ACTIONS(1191),
    [anon_sym_unreachable] = ACTIONS(1191),
    [sym_BuildinTypeExpr] = ACTIONS(1191),
    [anon_sym_packed] = ACTIONS(1191),
    [anon_sym_LPAREN] = ACTIONS(1189),
    [anon_sym_switch] = ACTIONS(1191),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_if] = ACTIONS(1191),
    [anon_sym_while] = ACTIONS(1191),
    [anon_sym_for] = ACTIONS(1191),
    [anon_sym_PIPE] = ACTIONS(1191),
    [anon_sym_STAR] = ACTIONS(1191),
    [anon_sym_EQ_EQ] = ACTIONS(1189),
    [anon_sym_BANG_EQ] = ACTIONS(1189),
    [anon_sym_LT] = ACTIONS(1191),
    [anon_sym_GT] = ACTIONS(1191),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_AMP] = ACTIONS(1189),
    [anon_sym_CARET] = ACTIONS(1189),
    [anon_sym_orelse] = ACTIONS(1191),
    [anon_sym_catch] = ACTIONS(1191),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1189),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1189),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_PLUS_PLUS] = ACTIONS(1189),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1189),
    [anon_sym_DASH_PERCENT] = ACTIONS(1189),
    [anon_sym_PLUS_PIPE] = ACTIONS(1189),
    [anon_sym_DASH_PIPE] = ACTIONS(1189),
    [anon_sym_PIPE_PIPE] = ACTIONS(1189),
    [anon_sym_SLASH] = ACTIONS(1191),
    [anon_sym_PERCENT] = ACTIONS(1189),
    [anon_sym_STAR_STAR] = ACTIONS(1189),
    [anon_sym_STAR_PERCENT] = ACTIONS(1189),
    [anon_sym_STAR_PIPE] = ACTIONS(1189),
    [anon_sym_QMARK] = ACTIONS(1189),
    [anon_sym_DOT_STAR] = ACTIONS(1189),
    [anon_sym_DOT_QMARK] = ACTIONS(1189),
    [anon_sym_struct] = ACTIONS(1191),
    [anon_sym_opaque] = ACTIONS(1191),
    [anon_sym_enum] = ACTIONS(1191),
    [anon_sym_union] = ACTIONS(1191),
    [sym_doc_comment] = ACTIONS(1189),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1189),
    [aux_sym_FLOAT_token1] = ACTIONS(1189),
    [aux_sym_FLOAT_token2] = ACTIONS(1189),
    [aux_sym_FLOAT_token3] = ACTIONS(1189),
    [aux_sym_FLOAT_token4] = ACTIONS(1189),
    [aux_sym_INTEGER_token1] = ACTIONS(1189),
    [aux_sym_INTEGER_token2] = ACTIONS(1189),
    [aux_sym_INTEGER_token3] = ACTIONS(1191),
    [aux_sym_INTEGER_token4] = ACTIONS(1191),
    [anon_sym_DQUOTE] = ACTIONS(1189),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1189),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1191),
    [anon_sym_AT] = ACTIONS(1189),
  },
  [557] = {
    [ts_builtin_sym_end] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(574),
    [anon_sym_pub] = ACTIONS(572),
    [anon_sym_test] = ACTIONS(572),
    [anon_sym_comptime] = ACTIONS(572),
    [anon_sym_export] = ACTIONS(572),
    [anon_sym_extern] = ACTIONS(572),
    [anon_sym_inline] = ACTIONS(572),
    [anon_sym_noinline] = ACTIONS(572),
    [anon_sym_threadlocal] = ACTIONS(572),
    [anon_sym_usingnamespace] = ACTIONS(572),
    [anon_sym_fn] = ACTIONS(572),
    [anon_sym_BANG] = ACTIONS(572),
    [anon_sym_const] = ACTIONS(572),
    [anon_sym_var] = ACTIONS(572),
    [anon_sym_or] = ACTIONS(572),
    [anon_sym_and] = ACTIONS(572),
    [anon_sym_LBRACE] = ACTIONS(574),
    [anon_sym_RBRACE] = ACTIONS(574),
    [anon_sym_async] = ACTIONS(572),
    [anon_sym_DOT] = ACTIONS(572),
    [anon_sym_error] = ACTIONS(572),
    [anon_sym_false] = ACTIONS(572),
    [anon_sym_null] = ACTIONS(572),
    [anon_sym_anyframe] = ACTIONS(572),
    [anon_sym_true] = ACTIONS(572),
    [anon_sym_undefined] = ACTIONS(572),
    [anon_sym_unreachable] = ACTIONS(572),
    [sym_BuildinTypeExpr] = ACTIONS(572),
    [anon_sym_packed] = ACTIONS(572),
    [anon_sym_LPAREN] = ACTIONS(574),
    [anon_sym_switch] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_if] = ACTIONS(572),
    [anon_sym_while] = ACTIONS(572),
    [anon_sym_for] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_STAR] = ACTIONS(572),
    [anon_sym_EQ_EQ] = ACTIONS(574),
    [anon_sym_BANG_EQ] = ACTIONS(574),
    [anon_sym_LT] = ACTIONS(572),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_LT_EQ] = ACTIONS(574),
    [anon_sym_GT_EQ] = ACTIONS(574),
    [anon_sym_AMP] = ACTIONS(574),
    [anon_sym_CARET] = ACTIONS(574),
    [anon_sym_orelse] = ACTIONS(572),
    [anon_sym_catch] = ACTIONS(572),
    [anon_sym_LT_LT] = ACTIONS(572),
    [anon_sym_GT_GT] = ACTIONS(574),
    [anon_sym_LT_LT_PIPE] = ACTIONS(574),
    [anon_sym_PLUS] = ACTIONS(572),
    [anon_sym_DASH] = ACTIONS(572),
    [anon_sym_PLUS_PLUS] = ACTIONS(574),
    [anon_sym_PLUS_PERCENT] = ACTIONS(574),
    [anon_sym_DASH_PERCENT] = ACTIONS(574),
    [anon_sym_PLUS_PIPE] = ACTIONS(574),
    [anon_sym_DASH_PIPE] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(574),
    [anon_sym_SLASH] = ACTIONS(572),
    [anon_sym_PERCENT] = ACTIONS(574),
    [anon_sym_STAR_STAR] = ACTIONS(574),
    [anon_sym_STAR_PERCENT] = ACTIONS(574),
    [anon_sym_STAR_PIPE] = ACTIONS(574),
    [anon_sym_QMARK] = ACTIONS(574),
    [anon_sym_DOT_STAR] = ACTIONS(574),
    [anon_sym_DOT_QMARK] = ACTIONS(574),
    [anon_sym_struct] = ACTIONS(572),
    [anon_sym_opaque] = ACTIONS(572),
    [anon_sym_enum] = ACTIONS(572),
    [anon_sym_union] = ACTIONS(572),
    [sym_doc_comment] = ACTIONS(574),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(574),
    [aux_sym_FLOAT_token1] = ACTIONS(574),
    [aux_sym_FLOAT_token2] = ACTIONS(574),
    [aux_sym_FLOAT_token3] = ACTIONS(574),
    [aux_sym_FLOAT_token4] = ACTIONS(574),
    [aux_sym_INTEGER_token1] = ACTIONS(574),
    [aux_sym_INTEGER_token2] = ACTIONS(574),
    [aux_sym_INTEGER_token3] = ACTIONS(572),
    [aux_sym_INTEGER_token4] = ACTIONS(572),
    [anon_sym_DQUOTE] = ACTIONS(574),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(574),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(572),
    [anon_sym_AT] = ACTIONS(574),
  },
  [558] = {
    [ts_builtin_sym_end] = ACTIONS(1193),
    [anon_sym_COMMA] = ACTIONS(1193),
    [anon_sym_pub] = ACTIONS(1195),
    [anon_sym_test] = ACTIONS(1195),
    [anon_sym_comptime] = ACTIONS(1195),
    [anon_sym_export] = ACTIONS(1195),
    [anon_sym_extern] = ACTIONS(1195),
    [anon_sym_inline] = ACTIONS(1195),
    [anon_sym_noinline] = ACTIONS(1195),
    [anon_sym_threadlocal] = ACTIONS(1195),
    [anon_sym_usingnamespace] = ACTIONS(1195),
    [anon_sym_fn] = ACTIONS(1195),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_const] = ACTIONS(1195),
    [anon_sym_var] = ACTIONS(1195),
    [anon_sym_or] = ACTIONS(1195),
    [anon_sym_and] = ACTIONS(1195),
    [anon_sym_LBRACE] = ACTIONS(1193),
    [anon_sym_RBRACE] = ACTIONS(1193),
    [anon_sym_async] = ACTIONS(1195),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_error] = ACTIONS(1195),
    [anon_sym_false] = ACTIONS(1195),
    [anon_sym_null] = ACTIONS(1195),
    [anon_sym_anyframe] = ACTIONS(1195),
    [anon_sym_true] = ACTIONS(1195),
    [anon_sym_undefined] = ACTIONS(1195),
    [anon_sym_unreachable] = ACTIONS(1195),
    [sym_BuildinTypeExpr] = ACTIONS(1195),
    [anon_sym_packed] = ACTIONS(1195),
    [anon_sym_LPAREN] = ACTIONS(1193),
    [anon_sym_switch] = ACTIONS(1195),
    [anon_sym_LBRACK] = ACTIONS(1193),
    [anon_sym_if] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1195),
    [anon_sym_for] = ACTIONS(1195),
    [anon_sym_PIPE] = ACTIONS(1195),
    [anon_sym_STAR] = ACTIONS(1195),
    [anon_sym_EQ_EQ] = ACTIONS(1193),
    [anon_sym_BANG_EQ] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_GT] = ACTIONS(1195),
    [anon_sym_LT_EQ] = ACTIONS(1193),
    [anon_sym_GT_EQ] = ACTIONS(1193),
    [anon_sym_AMP] = ACTIONS(1193),
    [anon_sym_CARET] = ACTIONS(1193),
    [anon_sym_orelse] = ACTIONS(1195),
    [anon_sym_catch] = ACTIONS(1195),
    [anon_sym_LT_LT] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1193),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1193),
    [anon_sym_PLUS] = ACTIONS(1195),
    [anon_sym_DASH] = ACTIONS(1195),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1193),
    [anon_sym_DASH_PERCENT] = ACTIONS(1193),
    [anon_sym_PLUS_PIPE] = ACTIONS(1193),
    [anon_sym_DASH_PIPE] = ACTIONS(1193),
    [anon_sym_PIPE_PIPE] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1195),
    [anon_sym_PERCENT] = ACTIONS(1193),
    [anon_sym_STAR_STAR] = ACTIONS(1193),
    [anon_sym_STAR_PERCENT] = ACTIONS(1193),
    [anon_sym_STAR_PIPE] = ACTIONS(1193),
    [anon_sym_QMARK] = ACTIONS(1193),
    [anon_sym_DOT_STAR] = ACTIONS(1193),
    [anon_sym_DOT_QMARK] = ACTIONS(1193),
    [anon_sym_struct] = ACTIONS(1195),
    [anon_sym_opaque] = ACTIONS(1195),
    [anon_sym_enum] = ACTIONS(1195),
    [anon_sym_union] = ACTIONS(1195),
    [sym_doc_comment] = ACTIONS(1193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1193),
    [aux_sym_FLOAT_token1] = ACTIONS(1193),
    [aux_sym_FLOAT_token2] = ACTIONS(1193),
    [aux_sym_FLOAT_token3] = ACTIONS(1193),
    [aux_sym_FLOAT_token4] = ACTIONS(1193),
    [aux_sym_INTEGER_token1] = ACTIONS(1193),
    [aux_sym_INTEGER_token2] = ACTIONS(1193),
    [aux_sym_INTEGER_token3] = ACTIONS(1195),
    [aux_sym_INTEGER_token4] = ACTIONS(1195),
    [anon_sym_DQUOTE] = ACTIONS(1193),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1193),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1195),
    [anon_sym_AT] = ACTIONS(1193),
  },
  [559] = {
    [ts_builtin_sym_end] = ACTIONS(1197),
    [anon_sym_COMMA] = ACTIONS(1197),
    [anon_sym_pub] = ACTIONS(1199),
    [anon_sym_test] = ACTIONS(1199),
    [anon_sym_comptime] = ACTIONS(1199),
    [anon_sym_export] = ACTIONS(1199),
    [anon_sym_extern] = ACTIONS(1199),
    [anon_sym_inline] = ACTIONS(1199),
    [anon_sym_noinline] = ACTIONS(1199),
    [anon_sym_threadlocal] = ACTIONS(1199),
    [anon_sym_usingnamespace] = ACTIONS(1199),
    [anon_sym_fn] = ACTIONS(1199),
    [anon_sym_BANG] = ACTIONS(1199),
    [anon_sym_const] = ACTIONS(1199),
    [anon_sym_var] = ACTIONS(1199),
    [anon_sym_or] = ACTIONS(1199),
    [anon_sym_and] = ACTIONS(1199),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_RBRACE] = ACTIONS(1197),
    [anon_sym_async] = ACTIONS(1199),
    [anon_sym_DOT] = ACTIONS(1199),
    [anon_sym_error] = ACTIONS(1199),
    [anon_sym_false] = ACTIONS(1199),
    [anon_sym_null] = ACTIONS(1199),
    [anon_sym_anyframe] = ACTIONS(1199),
    [anon_sym_true] = ACTIONS(1199),
    [anon_sym_undefined] = ACTIONS(1199),
    [anon_sym_unreachable] = ACTIONS(1199),
    [sym_BuildinTypeExpr] = ACTIONS(1199),
    [anon_sym_packed] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1197),
    [anon_sym_switch] = ACTIONS(1199),
    [anon_sym_LBRACK] = ACTIONS(1197),
    [anon_sym_if] = ACTIONS(1199),
    [anon_sym_while] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1199),
    [anon_sym_PIPE] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1199),
    [anon_sym_EQ_EQ] = ACTIONS(1197),
    [anon_sym_BANG_EQ] = ACTIONS(1197),
    [anon_sym_LT] = ACTIONS(1199),
    [anon_sym_GT] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1197),
    [anon_sym_GT_EQ] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_orelse] = ACTIONS(1199),
    [anon_sym_catch] = ACTIONS(1199),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1197),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1197),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1197),
    [anon_sym_DASH_PERCENT] = ACTIONS(1197),
    [anon_sym_PLUS_PIPE] = ACTIONS(1197),
    [anon_sym_DASH_PIPE] = ACTIONS(1197),
    [anon_sym_PIPE_PIPE] = ACTIONS(1197),
    [anon_sym_SLASH] = ACTIONS(1199),
    [anon_sym_PERCENT] = ACTIONS(1197),
    [anon_sym_STAR_STAR] = ACTIONS(1197),
    [anon_sym_STAR_PERCENT] = ACTIONS(1197),
    [anon_sym_STAR_PIPE] = ACTIONS(1197),
    [anon_sym_QMARK] = ACTIONS(1197),
    [anon_sym_DOT_STAR] = ACTIONS(1197),
    [anon_sym_DOT_QMARK] = ACTIONS(1197),
    [anon_sym_struct] = ACTIONS(1199),
    [anon_sym_opaque] = ACTIONS(1199),
    [anon_sym_enum] = ACTIONS(1199),
    [anon_sym_union] = ACTIONS(1199),
    [sym_doc_comment] = ACTIONS(1197),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1197),
    [aux_sym_FLOAT_token1] = ACTIONS(1197),
    [aux_sym_FLOAT_token2] = ACTIONS(1197),
    [aux_sym_FLOAT_token3] = ACTIONS(1197),
    [aux_sym_FLOAT_token4] = ACTIONS(1197),
    [aux_sym_INTEGER_token1] = ACTIONS(1197),
    [aux_sym_INTEGER_token2] = ACTIONS(1197),
    [aux_sym_INTEGER_token3] = ACTIONS(1199),
    [aux_sym_INTEGER_token4] = ACTIONS(1199),
    [anon_sym_DQUOTE] = ACTIONS(1197),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1197),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1199),
    [anon_sym_AT] = ACTIONS(1197),
  },
  [560] = {
    [ts_builtin_sym_end] = ACTIONS(1107),
    [anon_sym_COMMA] = ACTIONS(1107),
    [anon_sym_pub] = ACTIONS(1105),
    [anon_sym_test] = ACTIONS(1105),
    [anon_sym_comptime] = ACTIONS(1105),
    [anon_sym_export] = ACTIONS(1105),
    [anon_sym_extern] = ACTIONS(1105),
    [anon_sym_inline] = ACTIONS(1105),
    [anon_sym_noinline] = ACTIONS(1105),
    [anon_sym_threadlocal] = ACTIONS(1105),
    [anon_sym_usingnamespace] = ACTIONS(1105),
    [anon_sym_fn] = ACTIONS(1105),
    [anon_sym_BANG] = ACTIONS(1105),
    [anon_sym_const] = ACTIONS(1105),
    [anon_sym_var] = ACTIONS(1105),
    [anon_sym_or] = ACTIONS(1105),
    [anon_sym_and] = ACTIONS(1105),
    [anon_sym_LBRACE] = ACTIONS(1107),
    [anon_sym_RBRACE] = ACTIONS(1107),
    [anon_sym_async] = ACTIONS(1105),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_error] = ACTIONS(1105),
    [anon_sym_false] = ACTIONS(1105),
    [anon_sym_null] = ACTIONS(1105),
    [anon_sym_anyframe] = ACTIONS(1105),
    [anon_sym_true] = ACTIONS(1105),
    [anon_sym_undefined] = ACTIONS(1105),
    [anon_sym_unreachable] = ACTIONS(1105),
    [sym_BuildinTypeExpr] = ACTIONS(1105),
    [anon_sym_packed] = ACTIONS(1105),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_switch] = ACTIONS(1105),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_if] = ACTIONS(1105),
    [anon_sym_while] = ACTIONS(1105),
    [anon_sym_for] = ACTIONS(1105),
    [anon_sym_PIPE] = ACTIONS(1105),
    [anon_sym_STAR] = ACTIONS(1105),
    [anon_sym_EQ_EQ] = ACTIONS(1107),
    [anon_sym_BANG_EQ] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(1105),
    [anon_sym_LT_EQ] = ACTIONS(1107),
    [anon_sym_GT_EQ] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1107),
    [anon_sym_CARET] = ACTIONS(1107),
    [anon_sym_orelse] = ACTIONS(1105),
    [anon_sym_catch] = ACTIONS(1105),
    [anon_sym_LT_LT] = ACTIONS(1105),
    [anon_sym_GT_GT] = ACTIONS(1107),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1107),
    [anon_sym_DASH_PERCENT] = ACTIONS(1107),
    [anon_sym_PLUS_PIPE] = ACTIONS(1107),
    [anon_sym_DASH_PIPE] = ACTIONS(1107),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1107),
    [anon_sym_STAR_STAR] = ACTIONS(1107),
    [anon_sym_STAR_PERCENT] = ACTIONS(1107),
    [anon_sym_STAR_PIPE] = ACTIONS(1107),
    [anon_sym_QMARK] = ACTIONS(1107),
    [anon_sym_DOT_STAR] = ACTIONS(1107),
    [anon_sym_DOT_QMARK] = ACTIONS(1107),
    [anon_sym_struct] = ACTIONS(1105),
    [anon_sym_opaque] = ACTIONS(1105),
    [anon_sym_enum] = ACTIONS(1105),
    [anon_sym_union] = ACTIONS(1105),
    [sym_doc_comment] = ACTIONS(1107),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1107),
    [aux_sym_FLOAT_token1] = ACTIONS(1107),
    [aux_sym_FLOAT_token2] = ACTIONS(1107),
    [aux_sym_FLOAT_token3] = ACTIONS(1107),
    [aux_sym_FLOAT_token4] = ACTIONS(1107),
    [aux_sym_INTEGER_token1] = ACTIONS(1107),
    [aux_sym_INTEGER_token2] = ACTIONS(1107),
    [aux_sym_INTEGER_token3] = ACTIONS(1105),
    [aux_sym_INTEGER_token4] = ACTIONS(1105),
    [anon_sym_DQUOTE] = ACTIONS(1107),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1107),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1105),
    [anon_sym_AT] = ACTIONS(1107),
  },
  [561] = {
    [ts_builtin_sym_end] = ACTIONS(1201),
    [anon_sym_COMMA] = ACTIONS(1201),
    [anon_sym_pub] = ACTIONS(1203),
    [anon_sym_test] = ACTIONS(1203),
    [anon_sym_comptime] = ACTIONS(1203),
    [anon_sym_export] = ACTIONS(1203),
    [anon_sym_extern] = ACTIONS(1203),
    [anon_sym_inline] = ACTIONS(1203),
    [anon_sym_noinline] = ACTIONS(1203),
    [anon_sym_threadlocal] = ACTIONS(1203),
    [anon_sym_usingnamespace] = ACTIONS(1203),
    [anon_sym_fn] = ACTIONS(1203),
    [anon_sym_BANG] = ACTIONS(1203),
    [anon_sym_const] = ACTIONS(1203),
    [anon_sym_var] = ACTIONS(1203),
    [anon_sym_or] = ACTIONS(1203),
    [anon_sym_and] = ACTIONS(1203),
    [anon_sym_LBRACE] = ACTIONS(1201),
    [anon_sym_RBRACE] = ACTIONS(1201),
    [anon_sym_async] = ACTIONS(1203),
    [anon_sym_DOT] = ACTIONS(1203),
    [anon_sym_error] = ACTIONS(1203),
    [anon_sym_false] = ACTIONS(1203),
    [anon_sym_null] = ACTIONS(1203),
    [anon_sym_anyframe] = ACTIONS(1203),
    [anon_sym_true] = ACTIONS(1203),
    [anon_sym_undefined] = ACTIONS(1203),
    [anon_sym_unreachable] = ACTIONS(1203),
    [sym_BuildinTypeExpr] = ACTIONS(1203),
    [anon_sym_packed] = ACTIONS(1203),
    [anon_sym_LPAREN] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1203),
    [anon_sym_LBRACK] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1203),
    [anon_sym_while] = ACTIONS(1203),
    [anon_sym_for] = ACTIONS(1203),
    [anon_sym_PIPE] = ACTIONS(1203),
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_EQ_EQ] = ACTIONS(1201),
    [anon_sym_BANG_EQ] = ACTIONS(1201),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(1203),
    [anon_sym_LT_EQ] = ACTIONS(1201),
    [anon_sym_GT_EQ] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1201),
    [anon_sym_CARET] = ACTIONS(1201),
    [anon_sym_orelse] = ACTIONS(1203),
    [anon_sym_catch] = ACTIONS(1203),
    [anon_sym_LT_LT] = ACTIONS(1203),
    [anon_sym_GT_GT] = ACTIONS(1201),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1203),
    [anon_sym_DASH] = ACTIONS(1203),
    [anon_sym_PLUS_PLUS] = ACTIONS(1201),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1201),
    [anon_sym_DASH_PERCENT] = ACTIONS(1201),
    [anon_sym_PLUS_PIPE] = ACTIONS(1201),
    [anon_sym_DASH_PIPE] = ACTIONS(1201),
    [anon_sym_PIPE_PIPE] = ACTIONS(1201),
    [anon_sym_SLASH] = ACTIONS(1203),
    [anon_sym_PERCENT] = ACTIONS(1201),
    [anon_sym_STAR_STAR] = ACTIONS(1201),
    [anon_sym_STAR_PERCENT] = ACTIONS(1201),
    [anon_sym_STAR_PIPE] = ACTIONS(1201),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_DOT_STAR] = ACTIONS(1201),
    [anon_sym_DOT_QMARK] = ACTIONS(1201),
    [anon_sym_struct] = ACTIONS(1203),
    [anon_sym_opaque] = ACTIONS(1203),
    [anon_sym_enum] = ACTIONS(1203),
    [anon_sym_union] = ACTIONS(1203),
    [sym_doc_comment] = ACTIONS(1201),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1201),
    [aux_sym_FLOAT_token1] = ACTIONS(1201),
    [aux_sym_FLOAT_token2] = ACTIONS(1201),
    [aux_sym_FLOAT_token3] = ACTIONS(1201),
    [aux_sym_FLOAT_token4] = ACTIONS(1201),
    [aux_sym_INTEGER_token1] = ACTIONS(1201),
    [aux_sym_INTEGER_token2] = ACTIONS(1201),
    [aux_sym_INTEGER_token3] = ACTIONS(1203),
    [aux_sym_INTEGER_token4] = ACTIONS(1203),
    [anon_sym_DQUOTE] = ACTIONS(1201),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1201),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1203),
    [anon_sym_AT] = ACTIONS(1201),
  },
  [562] = {
    [ts_builtin_sym_end] = ACTIONS(1205),
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_pub] = ACTIONS(1207),
    [anon_sym_test] = ACTIONS(1207),
    [anon_sym_comptime] = ACTIONS(1207),
    [anon_sym_export] = ACTIONS(1207),
    [anon_sym_extern] = ACTIONS(1207),
    [anon_sym_inline] = ACTIONS(1207),
    [anon_sym_noinline] = ACTIONS(1207),
    [anon_sym_threadlocal] = ACTIONS(1207),
    [anon_sym_usingnamespace] = ACTIONS(1207),
    [anon_sym_fn] = ACTIONS(1207),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_const] = ACTIONS(1207),
    [anon_sym_var] = ACTIONS(1207),
    [anon_sym_or] = ACTIONS(1207),
    [anon_sym_and] = ACTIONS(1207),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_async] = ACTIONS(1207),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_error] = ACTIONS(1207),
    [anon_sym_false] = ACTIONS(1207),
    [anon_sym_null] = ACTIONS(1207),
    [anon_sym_anyframe] = ACTIONS(1207),
    [anon_sym_true] = ACTIONS(1207),
    [anon_sym_undefined] = ACTIONS(1207),
    [anon_sym_unreachable] = ACTIONS(1207),
    [sym_BuildinTypeExpr] = ACTIONS(1207),
    [anon_sym_packed] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1205),
    [anon_sym_switch] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1207),
    [anon_sym_while] = ACTIONS(1207),
    [anon_sym_for] = ACTIONS(1207),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ_EQ] = ACTIONS(1205),
    [anon_sym_BANG_EQ] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1205),
    [anon_sym_GT_EQ] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(1205),
    [anon_sym_CARET] = ACTIONS(1205),
    [anon_sym_orelse] = ACTIONS(1207),
    [anon_sym_catch] = ACTIONS(1207),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_GT_GT] = ACTIONS(1205),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1205),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1205),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1205),
    [anon_sym_DASH_PERCENT] = ACTIONS(1205),
    [anon_sym_PLUS_PIPE] = ACTIONS(1205),
    [anon_sym_DASH_PIPE] = ACTIONS(1205),
    [anon_sym_PIPE_PIPE] = ACTIONS(1205),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1205),
    [anon_sym_STAR_STAR] = ACTIONS(1205),
    [anon_sym_STAR_PERCENT] = ACTIONS(1205),
    [anon_sym_STAR_PIPE] = ACTIONS(1205),
    [anon_sym_QMARK] = ACTIONS(1205),
    [anon_sym_DOT_STAR] = ACTIONS(1205),
    [anon_sym_DOT_QMARK] = ACTIONS(1205),
    [anon_sym_struct] = ACTIONS(1207),
    [anon_sym_opaque] = ACTIONS(1207),
    [anon_sym_enum] = ACTIONS(1207),
    [anon_sym_union] = ACTIONS(1207),
    [sym_doc_comment] = ACTIONS(1205),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1205),
    [aux_sym_FLOAT_token1] = ACTIONS(1205),
    [aux_sym_FLOAT_token2] = ACTIONS(1205),
    [aux_sym_FLOAT_token3] = ACTIONS(1205),
    [aux_sym_FLOAT_token4] = ACTIONS(1205),
    [aux_sym_INTEGER_token1] = ACTIONS(1205),
    [aux_sym_INTEGER_token2] = ACTIONS(1205),
    [aux_sym_INTEGER_token3] = ACTIONS(1207),
    [aux_sym_INTEGER_token4] = ACTIONS(1207),
    [anon_sym_DQUOTE] = ACTIONS(1205),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1205),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1207),
    [anon_sym_AT] = ACTIONS(1205),
  },
  [563] = {
    [ts_builtin_sym_end] = ACTIONS(1209),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_pub] = ACTIONS(1211),
    [anon_sym_test] = ACTIONS(1211),
    [anon_sym_comptime] = ACTIONS(1211),
    [anon_sym_export] = ACTIONS(1211),
    [anon_sym_extern] = ACTIONS(1211),
    [anon_sym_inline] = ACTIONS(1211),
    [anon_sym_noinline] = ACTIONS(1211),
    [anon_sym_threadlocal] = ACTIONS(1211),
    [anon_sym_usingnamespace] = ACTIONS(1211),
    [anon_sym_fn] = ACTIONS(1211),
    [anon_sym_BANG] = ACTIONS(1211),
    [anon_sym_const] = ACTIONS(1211),
    [anon_sym_var] = ACTIONS(1211),
    [anon_sym_or] = ACTIONS(1211),
    [anon_sym_and] = ACTIONS(1211),
    [anon_sym_LBRACE] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_DOT] = ACTIONS(1211),
    [anon_sym_error] = ACTIONS(1211),
    [anon_sym_false] = ACTIONS(1211),
    [anon_sym_null] = ACTIONS(1211),
    [anon_sym_anyframe] = ACTIONS(1211),
    [anon_sym_true] = ACTIONS(1211),
    [anon_sym_undefined] = ACTIONS(1211),
    [anon_sym_unreachable] = ACTIONS(1211),
    [sym_BuildinTypeExpr] = ACTIONS(1211),
    [anon_sym_packed] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_switch] = ACTIONS(1211),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_if] = ACTIONS(1211),
    [anon_sym_while] = ACTIONS(1211),
    [anon_sym_for] = ACTIONS(1211),
    [anon_sym_PIPE] = ACTIONS(1211),
    [anon_sym_STAR] = ACTIONS(1211),
    [anon_sym_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_GT] = ACTIONS(1211),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1209),
    [anon_sym_CARET] = ACTIONS(1209),
    [anon_sym_orelse] = ACTIONS(1211),
    [anon_sym_catch] = ACTIONS(1211),
    [anon_sym_LT_LT] = ACTIONS(1211),
    [anon_sym_GT_GT] = ACTIONS(1209),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1209),
    [anon_sym_PLUS] = ACTIONS(1211),
    [anon_sym_DASH] = ACTIONS(1211),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1209),
    [anon_sym_DASH_PERCENT] = ACTIONS(1209),
    [anon_sym_PLUS_PIPE] = ACTIONS(1209),
    [anon_sym_DASH_PIPE] = ACTIONS(1209),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_SLASH] = ACTIONS(1211),
    [anon_sym_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_STAR_PERCENT] = ACTIONS(1209),
    [anon_sym_STAR_PIPE] = ACTIONS(1209),
    [anon_sym_QMARK] = ACTIONS(1209),
    [anon_sym_DOT_STAR] = ACTIONS(1209),
    [anon_sym_DOT_QMARK] = ACTIONS(1209),
    [anon_sym_struct] = ACTIONS(1211),
    [anon_sym_opaque] = ACTIONS(1211),
    [anon_sym_enum] = ACTIONS(1211),
    [anon_sym_union] = ACTIONS(1211),
    [sym_doc_comment] = ACTIONS(1209),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1209),
    [aux_sym_FLOAT_token1] = ACTIONS(1209),
    [aux_sym_FLOAT_token2] = ACTIONS(1209),
    [aux_sym_FLOAT_token3] = ACTIONS(1209),
    [aux_sym_FLOAT_token4] = ACTIONS(1209),
    [aux_sym_INTEGER_token1] = ACTIONS(1209),
    [aux_sym_INTEGER_token2] = ACTIONS(1209),
    [aux_sym_INTEGER_token3] = ACTIONS(1211),
    [aux_sym_INTEGER_token4] = ACTIONS(1211),
    [anon_sym_DQUOTE] = ACTIONS(1209),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1209),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1211),
    [anon_sym_AT] = ACTIONS(1209),
  },
  [564] = {
    [ts_builtin_sym_end] = ACTIONS(522),
    [anon_sym_COMMA] = ACTIONS(522),
    [anon_sym_pub] = ACTIONS(524),
    [anon_sym_test] = ACTIONS(524),
    [anon_sym_comptime] = ACTIONS(524),
    [anon_sym_export] = ACTIONS(524),
    [anon_sym_extern] = ACTIONS(524),
    [anon_sym_inline] = ACTIONS(524),
    [anon_sym_noinline] = ACTIONS(524),
    [anon_sym_threadlocal] = ACTIONS(524),
    [anon_sym_usingnamespace] = ACTIONS(524),
    [anon_sym_fn] = ACTIONS(524),
    [anon_sym_BANG] = ACTIONS(524),
    [anon_sym_const] = ACTIONS(524),
    [anon_sym_var] = ACTIONS(524),
    [anon_sym_or] = ACTIONS(524),
    [anon_sym_and] = ACTIONS(524),
    [anon_sym_LBRACE] = ACTIONS(522),
    [anon_sym_RBRACE] = ACTIONS(522),
    [anon_sym_async] = ACTIONS(524),
    [anon_sym_DOT] = ACTIONS(524),
    [anon_sym_error] = ACTIONS(524),
    [anon_sym_false] = ACTIONS(524),
    [anon_sym_null] = ACTIONS(524),
    [anon_sym_anyframe] = ACTIONS(524),
    [anon_sym_true] = ACTIONS(524),
    [anon_sym_undefined] = ACTIONS(524),
    [anon_sym_unreachable] = ACTIONS(524),
    [sym_BuildinTypeExpr] = ACTIONS(524),
    [anon_sym_packed] = ACTIONS(524),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_switch] = ACTIONS(524),
    [anon_sym_LBRACK] = ACTIONS(522),
    [anon_sym_if] = ACTIONS(524),
    [anon_sym_while] = ACTIONS(524),
    [anon_sym_for] = ACTIONS(524),
    [anon_sym_PIPE] = ACTIONS(524),
    [anon_sym_STAR] = ACTIONS(524),
    [anon_sym_EQ_EQ] = ACTIONS(522),
    [anon_sym_BANG_EQ] = ACTIONS(522),
    [anon_sym_LT] = ACTIONS(524),
    [anon_sym_GT] = ACTIONS(524),
    [anon_sym_LT_EQ] = ACTIONS(522),
    [anon_sym_GT_EQ] = ACTIONS(522),
    [anon_sym_AMP] = ACTIONS(522),
    [anon_sym_CARET] = ACTIONS(522),
    [anon_sym_orelse] = ACTIONS(524),
    [anon_sym_catch] = ACTIONS(524),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_GT_GT] = ACTIONS(522),
    [anon_sym_LT_LT_PIPE] = ACTIONS(522),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_PLUS_PLUS] = ACTIONS(522),
    [anon_sym_PLUS_PERCENT] = ACTIONS(522),
    [anon_sym_DASH_PERCENT] = ACTIONS(522),
    [anon_sym_PLUS_PIPE] = ACTIONS(522),
    [anon_sym_DASH_PIPE] = ACTIONS(522),
    [anon_sym_PIPE_PIPE] = ACTIONS(522),
    [anon_sym_SLASH] = ACTIONS(524),
    [anon_sym_PERCENT] = ACTIONS(522),
    [anon_sym_STAR_STAR] = ACTIONS(522),
    [anon_sym_STAR_PERCENT] = ACTIONS(522),
    [anon_sym_STAR_PIPE] = ACTIONS(522),
    [anon_sym_QMARK] = ACTIONS(522),
    [anon_sym_DOT_STAR] = ACTIONS(522),
    [anon_sym_DOT_QMARK] = ACTIONS(522),
    [anon_sym_struct] = ACTIONS(524),
    [anon_sym_opaque] = ACTIONS(524),
    [anon_sym_enum] = ACTIONS(524),
    [anon_sym_union] = ACTIONS(524),
    [sym_doc_comment] = ACTIONS(522),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(522),
    [aux_sym_FLOAT_token1] = ACTIONS(522),
    [aux_sym_FLOAT_token2] = ACTIONS(522),
    [aux_sym_FLOAT_token3] = ACTIONS(522),
    [aux_sym_FLOAT_token4] = ACTIONS(522),
    [aux_sym_INTEGER_token1] = ACTIONS(522),
    [aux_sym_INTEGER_token2] = ACTIONS(522),
    [aux_sym_INTEGER_token3] = ACTIONS(524),
    [aux_sym_INTEGER_token4] = ACTIONS(524),
    [anon_sym_DQUOTE] = ACTIONS(522),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(522),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(524),
    [anon_sym_AT] = ACTIONS(522),
  },
  [565] = {
    [ts_builtin_sym_end] = ACTIONS(1213),
    [anon_sym_COMMA] = ACTIONS(1213),
    [anon_sym_pub] = ACTIONS(1215),
    [anon_sym_test] = ACTIONS(1215),
    [anon_sym_comptime] = ACTIONS(1215),
    [anon_sym_export] = ACTIONS(1215),
    [anon_sym_extern] = ACTIONS(1215),
    [anon_sym_inline] = ACTIONS(1215),
    [anon_sym_noinline] = ACTIONS(1215),
    [anon_sym_threadlocal] = ACTIONS(1215),
    [anon_sym_usingnamespace] = ACTIONS(1215),
    [anon_sym_fn] = ACTIONS(1215),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_const] = ACTIONS(1215),
    [anon_sym_var] = ACTIONS(1215),
    [anon_sym_or] = ACTIONS(1215),
    [anon_sym_and] = ACTIONS(1215),
    [anon_sym_LBRACE] = ACTIONS(1213),
    [anon_sym_RBRACE] = ACTIONS(1213),
    [anon_sym_async] = ACTIONS(1215),
    [anon_sym_DOT] = ACTIONS(1215),
    [anon_sym_error] = ACTIONS(1215),
    [anon_sym_false] = ACTIONS(1215),
    [anon_sym_null] = ACTIONS(1215),
    [anon_sym_anyframe] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1215),
    [anon_sym_undefined] = ACTIONS(1215),
    [anon_sym_unreachable] = ACTIONS(1215),
    [sym_BuildinTypeExpr] = ACTIONS(1215),
    [anon_sym_packed] = ACTIONS(1215),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_switch] = ACTIONS(1215),
    [anon_sym_LBRACK] = ACTIONS(1213),
    [anon_sym_if] = ACTIONS(1215),
    [anon_sym_while] = ACTIONS(1215),
    [anon_sym_for] = ACTIONS(1215),
    [anon_sym_PIPE] = ACTIONS(1215),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_EQ_EQ] = ACTIONS(1213),
    [anon_sym_BANG_EQ] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(1215),
    [anon_sym_GT] = ACTIONS(1215),
    [anon_sym_LT_EQ] = ACTIONS(1213),
    [anon_sym_GT_EQ] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(1213),
    [anon_sym_CARET] = ACTIONS(1213),
    [anon_sym_orelse] = ACTIONS(1215),
    [anon_sym_catch] = ACTIONS(1215),
    [anon_sym_LT_LT] = ACTIONS(1215),
    [anon_sym_GT_GT] = ACTIONS(1213),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1213),
    [anon_sym_PLUS] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1213),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1213),
    [anon_sym_DASH_PERCENT] = ACTIONS(1213),
    [anon_sym_PLUS_PIPE] = ACTIONS(1213),
    [anon_sym_DASH_PIPE] = ACTIONS(1213),
    [anon_sym_PIPE_PIPE] = ACTIONS(1213),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_PERCENT] = ACTIONS(1213),
    [anon_sym_STAR_STAR] = ACTIONS(1213),
    [anon_sym_STAR_PERCENT] = ACTIONS(1213),
    [anon_sym_STAR_PIPE] = ACTIONS(1213),
    [anon_sym_QMARK] = ACTIONS(1213),
    [anon_sym_DOT_STAR] = ACTIONS(1213),
    [anon_sym_DOT_QMARK] = ACTIONS(1213),
    [anon_sym_struct] = ACTIONS(1215),
    [anon_sym_opaque] = ACTIONS(1215),
    [anon_sym_enum] = ACTIONS(1215),
    [anon_sym_union] = ACTIONS(1215),
    [sym_doc_comment] = ACTIONS(1213),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1213),
    [aux_sym_FLOAT_token1] = ACTIONS(1213),
    [aux_sym_FLOAT_token2] = ACTIONS(1213),
    [aux_sym_FLOAT_token3] = ACTIONS(1213),
    [aux_sym_FLOAT_token4] = ACTIONS(1213),
    [aux_sym_INTEGER_token1] = ACTIONS(1213),
    [aux_sym_INTEGER_token2] = ACTIONS(1213),
    [aux_sym_INTEGER_token3] = ACTIONS(1215),
    [aux_sym_INTEGER_token4] = ACTIONS(1215),
    [anon_sym_DQUOTE] = ACTIONS(1213),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1213),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1215),
    [anon_sym_AT] = ACTIONS(1213),
  },
  [566] = {
    [ts_builtin_sym_end] = ACTIONS(1221),
    [anon_sym_COMMA] = ACTIONS(1221),
    [anon_sym_pub] = ACTIONS(1223),
    [anon_sym_test] = ACTIONS(1223),
    [anon_sym_comptime] = ACTIONS(1223),
    [anon_sym_export] = ACTIONS(1223),
    [anon_sym_extern] = ACTIONS(1223),
    [anon_sym_inline] = ACTIONS(1223),
    [anon_sym_noinline] = ACTIONS(1223),
    [anon_sym_threadlocal] = ACTIONS(1223),
    [anon_sym_usingnamespace] = ACTIONS(1223),
    [anon_sym_fn] = ACTIONS(1223),
    [anon_sym_BANG] = ACTIONS(1223),
    [anon_sym_const] = ACTIONS(1223),
    [anon_sym_var] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_RBRACE] = ACTIONS(1221),
    [anon_sym_async] = ACTIONS(1223),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_error] = ACTIONS(1223),
    [anon_sym_false] = ACTIONS(1223),
    [anon_sym_null] = ACTIONS(1223),
    [anon_sym_anyframe] = ACTIONS(1223),
    [anon_sym_true] = ACTIONS(1223),
    [anon_sym_undefined] = ACTIONS(1223),
    [anon_sym_unreachable] = ACTIONS(1223),
    [sym_BuildinTypeExpr] = ACTIONS(1223),
    [anon_sym_packed] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1221),
    [anon_sym_switch] = ACTIONS(1223),
    [anon_sym_LBRACK] = ACTIONS(1221),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_while] = ACTIONS(1223),
    [anon_sym_for] = ACTIONS(1223),
    [anon_sym_PIPE] = ACTIONS(1223),
    [anon_sym_STAR] = ACTIONS(1223),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_CARET] = ACTIONS(1221),
    [anon_sym_orelse] = ACTIONS(1223),
    [anon_sym_catch] = ACTIONS(1223),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1221),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1221),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_DASH] = ACTIONS(1223),
    [anon_sym_PLUS_PLUS] = ACTIONS(1221),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1221),
    [anon_sym_DASH_PERCENT] = ACTIONS(1221),
    [anon_sym_PLUS_PIPE] = ACTIONS(1221),
    [anon_sym_DASH_PIPE] = ACTIONS(1221),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_STAR_PERCENT] = ACTIONS(1221),
    [anon_sym_STAR_PIPE] = ACTIONS(1221),
    [anon_sym_QMARK] = ACTIONS(1221),
    [anon_sym_DOT_STAR] = ACTIONS(1221),
    [anon_sym_DOT_QMARK] = ACTIONS(1221),
    [anon_sym_struct] = ACTIONS(1223),
    [anon_sym_opaque] = ACTIONS(1223),
    [anon_sym_enum] = ACTIONS(1223),
    [anon_sym_union] = ACTIONS(1223),
    [sym_doc_comment] = ACTIONS(1221),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1221),
    [aux_sym_FLOAT_token1] = ACTIONS(1221),
    [aux_sym_FLOAT_token2] = ACTIONS(1221),
    [aux_sym_FLOAT_token3] = ACTIONS(1221),
    [aux_sym_FLOAT_token4] = ACTIONS(1221),
    [aux_sym_INTEGER_token1] = ACTIONS(1221),
    [aux_sym_INTEGER_token2] = ACTIONS(1221),
    [aux_sym_INTEGER_token3] = ACTIONS(1223),
    [aux_sym_INTEGER_token4] = ACTIONS(1223),
    [anon_sym_DQUOTE] = ACTIONS(1221),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1221),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1223),
    [anon_sym_AT] = ACTIONS(1221),
  },
  [567] = {
    [ts_builtin_sym_end] = ACTIONS(1225),
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_pub] = ACTIONS(1227),
    [anon_sym_test] = ACTIONS(1227),
    [anon_sym_comptime] = ACTIONS(1227),
    [anon_sym_export] = ACTIONS(1227),
    [anon_sym_extern] = ACTIONS(1227),
    [anon_sym_inline] = ACTIONS(1227),
    [anon_sym_noinline] = ACTIONS(1227),
    [anon_sym_threadlocal] = ACTIONS(1227),
    [anon_sym_usingnamespace] = ACTIONS(1227),
    [anon_sym_fn] = ACTIONS(1227),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_const] = ACTIONS(1227),
    [anon_sym_var] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1225),
    [anon_sym_RBRACE] = ACTIONS(1225),
    [anon_sym_async] = ACTIONS(1227),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_error] = ACTIONS(1227),
    [anon_sym_false] = ACTIONS(1227),
    [anon_sym_null] = ACTIONS(1227),
    [anon_sym_anyframe] = ACTIONS(1227),
    [anon_sym_true] = ACTIONS(1227),
    [anon_sym_undefined] = ACTIONS(1227),
    [anon_sym_unreachable] = ACTIONS(1227),
    [sym_BuildinTypeExpr] = ACTIONS(1227),
    [anon_sym_packed] = ACTIONS(1227),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(1225),
    [anon_sym_if] = ACTIONS(1227),
    [anon_sym_while] = ACTIONS(1227),
    [anon_sym_for] = ACTIONS(1227),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_STAR] = ACTIONS(1227),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_CARET] = ACTIONS(1225),
    [anon_sym_orelse] = ACTIONS(1227),
    [anon_sym_catch] = ACTIONS(1227),
    [anon_sym_LT_LT] = ACTIONS(1227),
    [anon_sym_GT_GT] = ACTIONS(1225),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1225),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_DASH] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1225),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1225),
    [anon_sym_DASH_PERCENT] = ACTIONS(1225),
    [anon_sym_PLUS_PIPE] = ACTIONS(1225),
    [anon_sym_DASH_PIPE] = ACTIONS(1225),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1225),
    [anon_sym_STAR_STAR] = ACTIONS(1225),
    [anon_sym_STAR_PERCENT] = ACTIONS(1225),
    [anon_sym_STAR_PIPE] = ACTIONS(1225),
    [anon_sym_QMARK] = ACTIONS(1225),
    [anon_sym_DOT_STAR] = ACTIONS(1225),
    [anon_sym_DOT_QMARK] = ACTIONS(1225),
    [anon_sym_struct] = ACTIONS(1227),
    [anon_sym_opaque] = ACTIONS(1227),
    [anon_sym_enum] = ACTIONS(1227),
    [anon_sym_union] = ACTIONS(1227),
    [sym_doc_comment] = ACTIONS(1225),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1225),
    [aux_sym_FLOAT_token1] = ACTIONS(1225),
    [aux_sym_FLOAT_token2] = ACTIONS(1225),
    [aux_sym_FLOAT_token3] = ACTIONS(1225),
    [aux_sym_FLOAT_token4] = ACTIONS(1225),
    [aux_sym_INTEGER_token1] = ACTIONS(1225),
    [aux_sym_INTEGER_token2] = ACTIONS(1225),
    [aux_sym_INTEGER_token3] = ACTIONS(1227),
    [aux_sym_INTEGER_token4] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1225),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1225),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1227),
    [anon_sym_AT] = ACTIONS(1225),
  },
  [568] = {
    [ts_builtin_sym_end] = ACTIONS(1229),
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_pub] = ACTIONS(1231),
    [anon_sym_test] = ACTIONS(1231),
    [anon_sym_comptime] = ACTIONS(1231),
    [anon_sym_export] = ACTIONS(1231),
    [anon_sym_extern] = ACTIONS(1231),
    [anon_sym_inline] = ACTIONS(1231),
    [anon_sym_noinline] = ACTIONS(1231),
    [anon_sym_threadlocal] = ACTIONS(1231),
    [anon_sym_usingnamespace] = ACTIONS(1231),
    [anon_sym_fn] = ACTIONS(1231),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_const] = ACTIONS(1231),
    [anon_sym_var] = ACTIONS(1231),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_and] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_error] = ACTIONS(1231),
    [anon_sym_false] = ACTIONS(1231),
    [anon_sym_null] = ACTIONS(1231),
    [anon_sym_anyframe] = ACTIONS(1231),
    [anon_sym_true] = ACTIONS(1231),
    [anon_sym_undefined] = ACTIONS(1231),
    [anon_sym_unreachable] = ACTIONS(1231),
    [sym_BuildinTypeExpr] = ACTIONS(1231),
    [anon_sym_packed] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_switch] = ACTIONS(1231),
    [anon_sym_LBRACK] = ACTIONS(1229),
    [anon_sym_if] = ACTIONS(1231),
    [anon_sym_while] = ACTIONS(1231),
    [anon_sym_for] = ACTIONS(1231),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_AMP] = ACTIONS(1229),
    [anon_sym_CARET] = ACTIONS(1229),
    [anon_sym_orelse] = ACTIONS(1231),
    [anon_sym_catch] = ACTIONS(1231),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1229),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1229),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_DASH] = ACTIONS(1231),
    [anon_sym_PLUS_PLUS] = ACTIONS(1229),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1229),
    [anon_sym_DASH_PERCENT] = ACTIONS(1229),
    [anon_sym_PLUS_PIPE] = ACTIONS(1229),
    [anon_sym_DASH_PIPE] = ACTIONS(1229),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1229),
    [anon_sym_STAR_STAR] = ACTIONS(1229),
    [anon_sym_STAR_PERCENT] = ACTIONS(1229),
    [anon_sym_STAR_PIPE] = ACTIONS(1229),
    [anon_sym_QMARK] = ACTIONS(1229),
    [anon_sym_DOT_STAR] = ACTIONS(1229),
    [anon_sym_DOT_QMARK] = ACTIONS(1229),
    [anon_sym_struct] = ACTIONS(1231),
    [anon_sym_opaque] = ACTIONS(1231),
    [anon_sym_enum] = ACTIONS(1231),
    [anon_sym_union] = ACTIONS(1231),
    [sym_doc_comment] = ACTIONS(1229),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1229),
    [aux_sym_FLOAT_token1] = ACTIONS(1229),
    [aux_sym_FLOAT_token2] = ACTIONS(1229),
    [aux_sym_FLOAT_token3] = ACTIONS(1229),
    [aux_sym_FLOAT_token4] = ACTIONS(1229),
    [aux_sym_INTEGER_token1] = ACTIONS(1229),
    [aux_sym_INTEGER_token2] = ACTIONS(1229),
    [aux_sym_INTEGER_token3] = ACTIONS(1231),
    [aux_sym_INTEGER_token4] = ACTIONS(1231),
    [anon_sym_DQUOTE] = ACTIONS(1229),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1229),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1231),
    [anon_sym_AT] = ACTIONS(1229),
  },
  [569] = {
    [ts_builtin_sym_end] = ACTIONS(1233),
    [anon_sym_COMMA] = ACTIONS(1233),
    [anon_sym_pub] = ACTIONS(1235),
    [anon_sym_test] = ACTIONS(1235),
    [anon_sym_comptime] = ACTIONS(1235),
    [anon_sym_export] = ACTIONS(1235),
    [anon_sym_extern] = ACTIONS(1235),
    [anon_sym_inline] = ACTIONS(1235),
    [anon_sym_noinline] = ACTIONS(1235),
    [anon_sym_threadlocal] = ACTIONS(1235),
    [anon_sym_usingnamespace] = ACTIONS(1235),
    [anon_sym_fn] = ACTIONS(1235),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_const] = ACTIONS(1235),
    [anon_sym_var] = ACTIONS(1235),
    [anon_sym_or] = ACTIONS(1235),
    [anon_sym_and] = ACTIONS(1235),
    [anon_sym_LBRACE] = ACTIONS(1233),
    [anon_sym_RBRACE] = ACTIONS(1233),
    [anon_sym_async] = ACTIONS(1235),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_error] = ACTIONS(1235),
    [anon_sym_false] = ACTIONS(1235),
    [anon_sym_null] = ACTIONS(1235),
    [anon_sym_anyframe] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(1235),
    [anon_sym_undefined] = ACTIONS(1235),
    [anon_sym_unreachable] = ACTIONS(1235),
    [sym_BuildinTypeExpr] = ACTIONS(1235),
    [anon_sym_packed] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_switch] = ACTIONS(1235),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_if] = ACTIONS(1235),
    [anon_sym_while] = ACTIONS(1235),
    [anon_sym_for] = ACTIONS(1235),
    [anon_sym_PIPE] = ACTIONS(1235),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_EQ_EQ] = ACTIONS(1233),
    [anon_sym_BANG_EQ] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1235),
    [anon_sym_LT_EQ] = ACTIONS(1233),
    [anon_sym_GT_EQ] = ACTIONS(1233),
    [anon_sym_AMP] = ACTIONS(1233),
    [anon_sym_CARET] = ACTIONS(1233),
    [anon_sym_orelse] = ACTIONS(1235),
    [anon_sym_catch] = ACTIONS(1235),
    [anon_sym_LT_LT] = ACTIONS(1235),
    [anon_sym_GT_GT] = ACTIONS(1233),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1233),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1233),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1233),
    [anon_sym_DASH_PERCENT] = ACTIONS(1233),
    [anon_sym_PLUS_PIPE] = ACTIONS(1233),
    [anon_sym_DASH_PIPE] = ACTIONS(1233),
    [anon_sym_PIPE_PIPE] = ACTIONS(1233),
    [anon_sym_SLASH] = ACTIONS(1235),
    [anon_sym_PERCENT] = ACTIONS(1233),
    [anon_sym_STAR_STAR] = ACTIONS(1233),
    [anon_sym_STAR_PERCENT] = ACTIONS(1233),
    [anon_sym_STAR_PIPE] = ACTIONS(1233),
    [anon_sym_QMARK] = ACTIONS(1233),
    [anon_sym_DOT_STAR] = ACTIONS(1233),
    [anon_sym_DOT_QMARK] = ACTIONS(1233),
    [anon_sym_struct] = ACTIONS(1235),
    [anon_sym_opaque] = ACTIONS(1235),
    [anon_sym_enum] = ACTIONS(1235),
    [anon_sym_union] = ACTIONS(1235),
    [sym_doc_comment] = ACTIONS(1233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1233),
    [aux_sym_FLOAT_token1] = ACTIONS(1233),
    [aux_sym_FLOAT_token2] = ACTIONS(1233),
    [aux_sym_FLOAT_token3] = ACTIONS(1233),
    [aux_sym_FLOAT_token4] = ACTIONS(1233),
    [aux_sym_INTEGER_token1] = ACTIONS(1233),
    [aux_sym_INTEGER_token2] = ACTIONS(1233),
    [aux_sym_INTEGER_token3] = ACTIONS(1235),
    [aux_sym_INTEGER_token4] = ACTIONS(1235),
    [anon_sym_DQUOTE] = ACTIONS(1233),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1233),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1235),
    [anon_sym_AT] = ACTIONS(1233),
  },
  [570] = {
    [ts_builtin_sym_end] = ACTIONS(1237),
    [anon_sym_COMMA] = ACTIONS(1237),
    [anon_sym_pub] = ACTIONS(1239),
    [anon_sym_test] = ACTIONS(1239),
    [anon_sym_comptime] = ACTIONS(1239),
    [anon_sym_export] = ACTIONS(1239),
    [anon_sym_extern] = ACTIONS(1239),
    [anon_sym_inline] = ACTIONS(1239),
    [anon_sym_noinline] = ACTIONS(1239),
    [anon_sym_threadlocal] = ACTIONS(1239),
    [anon_sym_usingnamespace] = ACTIONS(1239),
    [anon_sym_fn] = ACTIONS(1239),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_const] = ACTIONS(1239),
    [anon_sym_var] = ACTIONS(1239),
    [anon_sym_or] = ACTIONS(1239),
    [anon_sym_and] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_RBRACE] = ACTIONS(1237),
    [anon_sym_async] = ACTIONS(1239),
    [anon_sym_DOT] = ACTIONS(1239),
    [anon_sym_error] = ACTIONS(1239),
    [anon_sym_false] = ACTIONS(1239),
    [anon_sym_null] = ACTIONS(1239),
    [anon_sym_anyframe] = ACTIONS(1239),
    [anon_sym_true] = ACTIONS(1239),
    [anon_sym_undefined] = ACTIONS(1239),
    [anon_sym_unreachable] = ACTIONS(1239),
    [sym_BuildinTypeExpr] = ACTIONS(1239),
    [anon_sym_packed] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1237),
    [anon_sym_switch] = ACTIONS(1239),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_if] = ACTIONS(1239),
    [anon_sym_while] = ACTIONS(1239),
    [anon_sym_for] = ACTIONS(1239),
    [anon_sym_PIPE] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(1239),
    [anon_sym_EQ_EQ] = ACTIONS(1237),
    [anon_sym_BANG_EQ] = ACTIONS(1237),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_LT_EQ] = ACTIONS(1237),
    [anon_sym_GT_EQ] = ACTIONS(1237),
    [anon_sym_AMP] = ACTIONS(1237),
    [anon_sym_CARET] = ACTIONS(1237),
    [anon_sym_orelse] = ACTIONS(1239),
    [anon_sym_catch] = ACTIONS(1239),
    [anon_sym_LT_LT] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1237),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1237),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1237),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1237),
    [anon_sym_DASH_PERCENT] = ACTIONS(1237),
    [anon_sym_PLUS_PIPE] = ACTIONS(1237),
    [anon_sym_DASH_PIPE] = ACTIONS(1237),
    [anon_sym_PIPE_PIPE] = ACTIONS(1237),
    [anon_sym_SLASH] = ACTIONS(1239),
    [anon_sym_PERCENT] = ACTIONS(1237),
    [anon_sym_STAR_STAR] = ACTIONS(1237),
    [anon_sym_STAR_PERCENT] = ACTIONS(1237),
    [anon_sym_STAR_PIPE] = ACTIONS(1237),
    [anon_sym_QMARK] = ACTIONS(1237),
    [anon_sym_DOT_STAR] = ACTIONS(1237),
    [anon_sym_DOT_QMARK] = ACTIONS(1237),
    [anon_sym_struct] = ACTIONS(1239),
    [anon_sym_opaque] = ACTIONS(1239),
    [anon_sym_enum] = ACTIONS(1239),
    [anon_sym_union] = ACTIONS(1239),
    [sym_doc_comment] = ACTIONS(1237),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1237),
    [aux_sym_FLOAT_token1] = ACTIONS(1237),
    [aux_sym_FLOAT_token2] = ACTIONS(1237),
    [aux_sym_FLOAT_token3] = ACTIONS(1237),
    [aux_sym_FLOAT_token4] = ACTIONS(1237),
    [aux_sym_INTEGER_token1] = ACTIONS(1237),
    [aux_sym_INTEGER_token2] = ACTIONS(1237),
    [aux_sym_INTEGER_token3] = ACTIONS(1239),
    [aux_sym_INTEGER_token4] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1237),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1237),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1239),
    [anon_sym_AT] = ACTIONS(1237),
  },
  [571] = {
    [ts_builtin_sym_end] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(1241),
    [anon_sym_pub] = ACTIONS(1243),
    [anon_sym_test] = ACTIONS(1243),
    [anon_sym_comptime] = ACTIONS(1243),
    [anon_sym_export] = ACTIONS(1243),
    [anon_sym_extern] = ACTIONS(1243),
    [anon_sym_inline] = ACTIONS(1243),
    [anon_sym_noinline] = ACTIONS(1243),
    [anon_sym_threadlocal] = ACTIONS(1243),
    [anon_sym_usingnamespace] = ACTIONS(1243),
    [anon_sym_fn] = ACTIONS(1243),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_const] = ACTIONS(1243),
    [anon_sym_var] = ACTIONS(1243),
    [anon_sym_or] = ACTIONS(1243),
    [anon_sym_and] = ACTIONS(1243),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_async] = ACTIONS(1243),
    [anon_sym_DOT] = ACTIONS(1243),
    [anon_sym_error] = ACTIONS(1243),
    [anon_sym_false] = ACTIONS(1243),
    [anon_sym_null] = ACTIONS(1243),
    [anon_sym_anyframe] = ACTIONS(1243),
    [anon_sym_true] = ACTIONS(1243),
    [anon_sym_undefined] = ACTIONS(1243),
    [anon_sym_unreachable] = ACTIONS(1243),
    [sym_BuildinTypeExpr] = ACTIONS(1243),
    [anon_sym_packed] = ACTIONS(1243),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_switch] = ACTIONS(1243),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_if] = ACTIONS(1243),
    [anon_sym_while] = ACTIONS(1243),
    [anon_sym_for] = ACTIONS(1243),
    [anon_sym_PIPE] = ACTIONS(1243),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_EQ_EQ] = ACTIONS(1241),
    [anon_sym_BANG_EQ] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1243),
    [anon_sym_GT] = ACTIONS(1243),
    [anon_sym_LT_EQ] = ACTIONS(1241),
    [anon_sym_GT_EQ] = ACTIONS(1241),
    [anon_sym_AMP] = ACTIONS(1241),
    [anon_sym_CARET] = ACTIONS(1241),
    [anon_sym_orelse] = ACTIONS(1243),
    [anon_sym_catch] = ACTIONS(1243),
    [anon_sym_LT_LT] = ACTIONS(1243),
    [anon_sym_GT_GT] = ACTIONS(1241),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1241),
    [anon_sym_PLUS] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1241),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1241),
    [anon_sym_DASH_PERCENT] = ACTIONS(1241),
    [anon_sym_PLUS_PIPE] = ACTIONS(1241),
    [anon_sym_DASH_PIPE] = ACTIONS(1241),
    [anon_sym_PIPE_PIPE] = ACTIONS(1241),
    [anon_sym_SLASH] = ACTIONS(1243),
    [anon_sym_PERCENT] = ACTIONS(1241),
    [anon_sym_STAR_STAR] = ACTIONS(1241),
    [anon_sym_STAR_PERCENT] = ACTIONS(1241),
    [anon_sym_STAR_PIPE] = ACTIONS(1241),
    [anon_sym_QMARK] = ACTIONS(1241),
    [anon_sym_DOT_STAR] = ACTIONS(1241),
    [anon_sym_DOT_QMARK] = ACTIONS(1241),
    [anon_sym_struct] = ACTIONS(1243),
    [anon_sym_opaque] = ACTIONS(1243),
    [anon_sym_enum] = ACTIONS(1243),
    [anon_sym_union] = ACTIONS(1243),
    [sym_doc_comment] = ACTIONS(1241),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1241),
    [aux_sym_FLOAT_token1] = ACTIONS(1241),
    [aux_sym_FLOAT_token2] = ACTIONS(1241),
    [aux_sym_FLOAT_token3] = ACTIONS(1241),
    [aux_sym_FLOAT_token4] = ACTIONS(1241),
    [aux_sym_INTEGER_token1] = ACTIONS(1241),
    [aux_sym_INTEGER_token2] = ACTIONS(1241),
    [aux_sym_INTEGER_token3] = ACTIONS(1243),
    [aux_sym_INTEGER_token4] = ACTIONS(1243),
    [anon_sym_DQUOTE] = ACTIONS(1241),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1241),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1243),
    [anon_sym_AT] = ACTIONS(1241),
  },
  [572] = {
    [ts_builtin_sym_end] = ACTIONS(542),
    [anon_sym_COMMA] = ACTIONS(542),
    [anon_sym_pub] = ACTIONS(540),
    [anon_sym_test] = ACTIONS(540),
    [anon_sym_comptime] = ACTIONS(540),
    [anon_sym_export] = ACTIONS(540),
    [anon_sym_extern] = ACTIONS(540),
    [anon_sym_inline] = ACTIONS(540),
    [anon_sym_noinline] = ACTIONS(540),
    [anon_sym_threadlocal] = ACTIONS(540),
    [anon_sym_usingnamespace] = ACTIONS(540),
    [anon_sym_fn] = ACTIONS(540),
    [anon_sym_BANG] = ACTIONS(540),
    [anon_sym_const] = ACTIONS(540),
    [anon_sym_var] = ACTIONS(540),
    [anon_sym_or] = ACTIONS(540),
    [anon_sym_and] = ACTIONS(540),
    [anon_sym_LBRACE] = ACTIONS(542),
    [anon_sym_RBRACE] = ACTIONS(542),
    [anon_sym_async] = ACTIONS(540),
    [anon_sym_DOT] = ACTIONS(540),
    [anon_sym_error] = ACTIONS(540),
    [anon_sym_false] = ACTIONS(540),
    [anon_sym_null] = ACTIONS(540),
    [anon_sym_anyframe] = ACTIONS(540),
    [anon_sym_true] = ACTIONS(540),
    [anon_sym_undefined] = ACTIONS(540),
    [anon_sym_unreachable] = ACTIONS(540),
    [sym_BuildinTypeExpr] = ACTIONS(540),
    [anon_sym_packed] = ACTIONS(540),
    [anon_sym_LPAREN] = ACTIONS(542),
    [anon_sym_switch] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(542),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_while] = ACTIONS(540),
    [anon_sym_for] = ACTIONS(540),
    [anon_sym_PIPE] = ACTIONS(540),
    [anon_sym_STAR] = ACTIONS(540),
    [anon_sym_EQ_EQ] = ACTIONS(542),
    [anon_sym_BANG_EQ] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(540),
    [anon_sym_GT] = ACTIONS(540),
    [anon_sym_LT_EQ] = ACTIONS(542),
    [anon_sym_GT_EQ] = ACTIONS(542),
    [anon_sym_AMP] = ACTIONS(542),
    [anon_sym_CARET] = ACTIONS(542),
    [anon_sym_orelse] = ACTIONS(540),
    [anon_sym_catch] = ACTIONS(540),
    [anon_sym_LT_LT] = ACTIONS(540),
    [anon_sym_GT_GT] = ACTIONS(542),
    [anon_sym_LT_LT_PIPE] = ACTIONS(542),
    [anon_sym_PLUS] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(540),
    [anon_sym_PLUS_PLUS] = ACTIONS(542),
    [anon_sym_PLUS_PERCENT] = ACTIONS(542),
    [anon_sym_DASH_PERCENT] = ACTIONS(542),
    [anon_sym_PLUS_PIPE] = ACTIONS(542),
    [anon_sym_DASH_PIPE] = ACTIONS(542),
    [anon_sym_PIPE_PIPE] = ACTIONS(542),
    [anon_sym_SLASH] = ACTIONS(540),
    [anon_sym_PERCENT] = ACTIONS(542),
    [anon_sym_STAR_STAR] = ACTIONS(542),
    [anon_sym_STAR_PERCENT] = ACTIONS(542),
    [anon_sym_STAR_PIPE] = ACTIONS(542),
    [anon_sym_QMARK] = ACTIONS(542),
    [anon_sym_DOT_STAR] = ACTIONS(542),
    [anon_sym_DOT_QMARK] = ACTIONS(542),
    [anon_sym_struct] = ACTIONS(540),
    [anon_sym_opaque] = ACTIONS(540),
    [anon_sym_enum] = ACTIONS(540),
    [anon_sym_union] = ACTIONS(540),
    [sym_doc_comment] = ACTIONS(542),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(542),
    [aux_sym_FLOAT_token1] = ACTIONS(542),
    [aux_sym_FLOAT_token2] = ACTIONS(542),
    [aux_sym_FLOAT_token3] = ACTIONS(542),
    [aux_sym_FLOAT_token4] = ACTIONS(542),
    [aux_sym_INTEGER_token1] = ACTIONS(542),
    [aux_sym_INTEGER_token2] = ACTIONS(542),
    [aux_sym_INTEGER_token3] = ACTIONS(540),
    [aux_sym_INTEGER_token4] = ACTIONS(540),
    [anon_sym_DQUOTE] = ACTIONS(542),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(542),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(540),
    [anon_sym_AT] = ACTIONS(542),
  },
  [573] = {
    [ts_builtin_sym_end] = ACTIONS(1245),
    [anon_sym_COMMA] = ACTIONS(1245),
    [anon_sym_pub] = ACTIONS(1247),
    [anon_sym_test] = ACTIONS(1247),
    [anon_sym_comptime] = ACTIONS(1247),
    [anon_sym_export] = ACTIONS(1247),
    [anon_sym_extern] = ACTIONS(1247),
    [anon_sym_inline] = ACTIONS(1247),
    [anon_sym_noinline] = ACTIONS(1247),
    [anon_sym_threadlocal] = ACTIONS(1247),
    [anon_sym_usingnamespace] = ACTIONS(1247),
    [anon_sym_fn] = ACTIONS(1247),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_const] = ACTIONS(1247),
    [anon_sym_var] = ACTIONS(1247),
    [anon_sym_or] = ACTIONS(1247),
    [anon_sym_and] = ACTIONS(1247),
    [anon_sym_LBRACE] = ACTIONS(1245),
    [anon_sym_RBRACE] = ACTIONS(1245),
    [anon_sym_async] = ACTIONS(1247),
    [anon_sym_DOT] = ACTIONS(1247),
    [anon_sym_error] = ACTIONS(1247),
    [anon_sym_false] = ACTIONS(1247),
    [anon_sym_null] = ACTIONS(1247),
    [anon_sym_anyframe] = ACTIONS(1247),
    [anon_sym_true] = ACTIONS(1247),
    [anon_sym_undefined] = ACTIONS(1247),
    [anon_sym_unreachable] = ACTIONS(1247),
    [sym_BuildinTypeExpr] = ACTIONS(1247),
    [anon_sym_packed] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1245),
    [anon_sym_switch] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_if] = ACTIONS(1247),
    [anon_sym_while] = ACTIONS(1247),
    [anon_sym_for] = ACTIONS(1247),
    [anon_sym_PIPE] = ACTIONS(1247),
    [anon_sym_STAR] = ACTIONS(1247),
    [anon_sym_EQ_EQ] = ACTIONS(1245),
    [anon_sym_BANG_EQ] = ACTIONS(1245),
    [anon_sym_LT] = ACTIONS(1247),
    [anon_sym_GT] = ACTIONS(1247),
    [anon_sym_LT_EQ] = ACTIONS(1245),
    [anon_sym_GT_EQ] = ACTIONS(1245),
    [anon_sym_AMP] = ACTIONS(1245),
    [anon_sym_CARET] = ACTIONS(1245),
    [anon_sym_orelse] = ACTIONS(1247),
    [anon_sym_catch] = ACTIONS(1247),
    [anon_sym_LT_LT] = ACTIONS(1247),
    [anon_sym_GT_GT] = ACTIONS(1245),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1245),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_DASH] = ACTIONS(1247),
    [anon_sym_PLUS_PLUS] = ACTIONS(1245),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1245),
    [anon_sym_DASH_PERCENT] = ACTIONS(1245),
    [anon_sym_PLUS_PIPE] = ACTIONS(1245),
    [anon_sym_DASH_PIPE] = ACTIONS(1245),
    [anon_sym_PIPE_PIPE] = ACTIONS(1245),
    [anon_sym_SLASH] = ACTIONS(1247),
    [anon_sym_PERCENT] = ACTIONS(1245),
    [anon_sym_STAR_STAR] = ACTIONS(1245),
    [anon_sym_STAR_PERCENT] = ACTIONS(1245),
    [anon_sym_STAR_PIPE] = ACTIONS(1245),
    [anon_sym_QMARK] = ACTIONS(1245),
    [anon_sym_DOT_STAR] = ACTIONS(1245),
    [anon_sym_DOT_QMARK] = ACTIONS(1245),
    [anon_sym_struct] = ACTIONS(1247),
    [anon_sym_opaque] = ACTIONS(1247),
    [anon_sym_enum] = ACTIONS(1247),
    [anon_sym_union] = ACTIONS(1247),
    [sym_doc_comment] = ACTIONS(1245),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1245),
    [aux_sym_FLOAT_token1] = ACTIONS(1245),
    [aux_sym_FLOAT_token2] = ACTIONS(1245),
    [aux_sym_FLOAT_token3] = ACTIONS(1245),
    [aux_sym_FLOAT_token4] = ACTIONS(1245),
    [aux_sym_INTEGER_token1] = ACTIONS(1245),
    [aux_sym_INTEGER_token2] = ACTIONS(1245),
    [aux_sym_INTEGER_token3] = ACTIONS(1247),
    [aux_sym_INTEGER_token4] = ACTIONS(1247),
    [anon_sym_DQUOTE] = ACTIONS(1245),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1245),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1247),
    [anon_sym_AT] = ACTIONS(1245),
  },
  [574] = {
    [ts_builtin_sym_end] = ACTIONS(1249),
    [anon_sym_COMMA] = ACTIONS(1249),
    [anon_sym_pub] = ACTIONS(1251),
    [anon_sym_test] = ACTIONS(1251),
    [anon_sym_comptime] = ACTIONS(1251),
    [anon_sym_export] = ACTIONS(1251),
    [anon_sym_extern] = ACTIONS(1251),
    [anon_sym_inline] = ACTIONS(1251),
    [anon_sym_noinline] = ACTIONS(1251),
    [anon_sym_threadlocal] = ACTIONS(1251),
    [anon_sym_usingnamespace] = ACTIONS(1251),
    [anon_sym_fn] = ACTIONS(1251),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_const] = ACTIONS(1251),
    [anon_sym_var] = ACTIONS(1251),
    [anon_sym_or] = ACTIONS(1251),
    [anon_sym_and] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(1249),
    [anon_sym_RBRACE] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_DOT] = ACTIONS(1251),
    [anon_sym_error] = ACTIONS(1251),
    [anon_sym_false] = ACTIONS(1251),
    [anon_sym_null] = ACTIONS(1251),
    [anon_sym_anyframe] = ACTIONS(1251),
    [anon_sym_true] = ACTIONS(1251),
    [anon_sym_undefined] = ACTIONS(1251),
    [anon_sym_unreachable] = ACTIONS(1251),
    [sym_BuildinTypeExpr] = ACTIONS(1251),
    [anon_sym_packed] = ACTIONS(1251),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_switch] = ACTIONS(1251),
    [anon_sym_LBRACK] = ACTIONS(1249),
    [anon_sym_if] = ACTIONS(1251),
    [anon_sym_while] = ACTIONS(1251),
    [anon_sym_for] = ACTIONS(1251),
    [anon_sym_PIPE] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1251),
    [anon_sym_EQ_EQ] = ACTIONS(1249),
    [anon_sym_BANG_EQ] = ACTIONS(1249),
    [anon_sym_LT] = ACTIONS(1251),
    [anon_sym_GT] = ACTIONS(1251),
    [anon_sym_LT_EQ] = ACTIONS(1249),
    [anon_sym_GT_EQ] = ACTIONS(1249),
    [anon_sym_AMP] = ACTIONS(1249),
    [anon_sym_CARET] = ACTIONS(1249),
    [anon_sym_orelse] = ACTIONS(1251),
    [anon_sym_catch] = ACTIONS(1251),
    [anon_sym_LT_LT] = ACTIONS(1251),
    [anon_sym_GT_GT] = ACTIONS(1249),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1249),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_PLUS_PLUS] = ACTIONS(1249),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1249),
    [anon_sym_DASH_PERCENT] = ACTIONS(1249),
    [anon_sym_PLUS_PIPE] = ACTIONS(1249),
    [anon_sym_DASH_PIPE] = ACTIONS(1249),
    [anon_sym_PIPE_PIPE] = ACTIONS(1249),
    [anon_sym_SLASH] = ACTIONS(1251),
    [anon_sym_PERCENT] = ACTIONS(1249),
    [anon_sym_STAR_STAR] = ACTIONS(1249),
    [anon_sym_STAR_PERCENT] = ACTIONS(1249),
    [anon_sym_STAR_PIPE] = ACTIONS(1249),
    [anon_sym_QMARK] = ACTIONS(1249),
    [anon_sym_DOT_STAR] = ACTIONS(1249),
    [anon_sym_DOT_QMARK] = ACTIONS(1249),
    [anon_sym_struct] = ACTIONS(1251),
    [anon_sym_opaque] = ACTIONS(1251),
    [anon_sym_enum] = ACTIONS(1251),
    [anon_sym_union] = ACTIONS(1251),
    [sym_doc_comment] = ACTIONS(1249),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1249),
    [aux_sym_FLOAT_token1] = ACTIONS(1249),
    [aux_sym_FLOAT_token2] = ACTIONS(1249),
    [aux_sym_FLOAT_token3] = ACTIONS(1249),
    [aux_sym_FLOAT_token4] = ACTIONS(1249),
    [aux_sym_INTEGER_token1] = ACTIONS(1249),
    [aux_sym_INTEGER_token2] = ACTIONS(1249),
    [aux_sym_INTEGER_token3] = ACTIONS(1251),
    [aux_sym_INTEGER_token4] = ACTIONS(1251),
    [anon_sym_DQUOTE] = ACTIONS(1249),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1249),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1251),
    [anon_sym_AT] = ACTIONS(1249),
  },
  [575] = {
    [ts_builtin_sym_end] = ACTIONS(1253),
    [anon_sym_COMMA] = ACTIONS(1253),
    [anon_sym_pub] = ACTIONS(1255),
    [anon_sym_test] = ACTIONS(1255),
    [anon_sym_comptime] = ACTIONS(1255),
    [anon_sym_export] = ACTIONS(1255),
    [anon_sym_extern] = ACTIONS(1255),
    [anon_sym_inline] = ACTIONS(1255),
    [anon_sym_noinline] = ACTIONS(1255),
    [anon_sym_threadlocal] = ACTIONS(1255),
    [anon_sym_usingnamespace] = ACTIONS(1255),
    [anon_sym_fn] = ACTIONS(1255),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_const] = ACTIONS(1255),
    [anon_sym_var] = ACTIONS(1255),
    [anon_sym_or] = ACTIONS(1255),
    [anon_sym_and] = ACTIONS(1255),
    [anon_sym_LBRACE] = ACTIONS(1253),
    [anon_sym_RBRACE] = ACTIONS(1253),
    [anon_sym_async] = ACTIONS(1255),
    [anon_sym_DOT] = ACTIONS(1255),
    [anon_sym_error] = ACTIONS(1255),
    [anon_sym_false] = ACTIONS(1255),
    [anon_sym_null] = ACTIONS(1255),
    [anon_sym_anyframe] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(1255),
    [anon_sym_undefined] = ACTIONS(1255),
    [anon_sym_unreachable] = ACTIONS(1255),
    [sym_BuildinTypeExpr] = ACTIONS(1255),
    [anon_sym_packed] = ACTIONS(1255),
    [anon_sym_LPAREN] = ACTIONS(1253),
    [anon_sym_switch] = ACTIONS(1255),
    [anon_sym_LBRACK] = ACTIONS(1253),
    [anon_sym_if] = ACTIONS(1255),
    [anon_sym_while] = ACTIONS(1255),
    [anon_sym_for] = ACTIONS(1255),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_EQ_EQ] = ACTIONS(1253),
    [anon_sym_BANG_EQ] = ACTIONS(1253),
    [anon_sym_LT] = ACTIONS(1255),
    [anon_sym_GT] = ACTIONS(1255),
    [anon_sym_LT_EQ] = ACTIONS(1253),
    [anon_sym_GT_EQ] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_orelse] = ACTIONS(1255),
    [anon_sym_catch] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1255),
    [anon_sym_GT_GT] = ACTIONS(1253),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1253),
    [anon_sym_PLUS] = ACTIONS(1255),
    [anon_sym_DASH] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1253),
    [anon_sym_DASH_PERCENT] = ACTIONS(1253),
    [anon_sym_PLUS_PIPE] = ACTIONS(1253),
    [anon_sym_DASH_PIPE] = ACTIONS(1253),
    [anon_sym_PIPE_PIPE] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(1255),
    [anon_sym_PERCENT] = ACTIONS(1253),
    [anon_sym_STAR_STAR] = ACTIONS(1253),
    [anon_sym_STAR_PERCENT] = ACTIONS(1253),
    [anon_sym_STAR_PIPE] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1253),
    [anon_sym_DOT_STAR] = ACTIONS(1253),
    [anon_sym_DOT_QMARK] = ACTIONS(1253),
    [anon_sym_struct] = ACTIONS(1255),
    [anon_sym_opaque] = ACTIONS(1255),
    [anon_sym_enum] = ACTIONS(1255),
    [anon_sym_union] = ACTIONS(1255),
    [sym_doc_comment] = ACTIONS(1253),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1253),
    [aux_sym_FLOAT_token1] = ACTIONS(1253),
    [aux_sym_FLOAT_token2] = ACTIONS(1253),
    [aux_sym_FLOAT_token3] = ACTIONS(1253),
    [aux_sym_FLOAT_token4] = ACTIONS(1253),
    [aux_sym_INTEGER_token1] = ACTIONS(1253),
    [aux_sym_INTEGER_token2] = ACTIONS(1253),
    [aux_sym_INTEGER_token3] = ACTIONS(1255),
    [aux_sym_INTEGER_token4] = ACTIONS(1255),
    [anon_sym_DQUOTE] = ACTIONS(1253),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1253),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1255),
    [anon_sym_AT] = ACTIONS(1253),
  },
  [576] = {
    [ts_builtin_sym_end] = ACTIONS(1257),
    [anon_sym_COMMA] = ACTIONS(1257),
    [anon_sym_pub] = ACTIONS(1259),
    [anon_sym_test] = ACTIONS(1259),
    [anon_sym_comptime] = ACTIONS(1259),
    [anon_sym_export] = ACTIONS(1259),
    [anon_sym_extern] = ACTIONS(1259),
    [anon_sym_inline] = ACTIONS(1259),
    [anon_sym_noinline] = ACTIONS(1259),
    [anon_sym_threadlocal] = ACTIONS(1259),
    [anon_sym_usingnamespace] = ACTIONS(1259),
    [anon_sym_fn] = ACTIONS(1259),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_const] = ACTIONS(1259),
    [anon_sym_var] = ACTIONS(1259),
    [anon_sym_or] = ACTIONS(1259),
    [anon_sym_and] = ACTIONS(1259),
    [anon_sym_LBRACE] = ACTIONS(1257),
    [anon_sym_RBRACE] = ACTIONS(1257),
    [anon_sym_async] = ACTIONS(1259),
    [anon_sym_DOT] = ACTIONS(1259),
    [anon_sym_error] = ACTIONS(1259),
    [anon_sym_false] = ACTIONS(1259),
    [anon_sym_null] = ACTIONS(1259),
    [anon_sym_anyframe] = ACTIONS(1259),
    [anon_sym_true] = ACTIONS(1259),
    [anon_sym_undefined] = ACTIONS(1259),
    [anon_sym_unreachable] = ACTIONS(1259),
    [sym_BuildinTypeExpr] = ACTIONS(1259),
    [anon_sym_packed] = ACTIONS(1259),
    [anon_sym_LPAREN] = ACTIONS(1257),
    [anon_sym_switch] = ACTIONS(1259),
    [anon_sym_LBRACK] = ACTIONS(1257),
    [anon_sym_if] = ACTIONS(1259),
    [anon_sym_while] = ACTIONS(1259),
    [anon_sym_for] = ACTIONS(1259),
    [anon_sym_PIPE] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1259),
    [anon_sym_EQ_EQ] = ACTIONS(1257),
    [anon_sym_BANG_EQ] = ACTIONS(1257),
    [anon_sym_LT] = ACTIONS(1259),
    [anon_sym_GT] = ACTIONS(1259),
    [anon_sym_LT_EQ] = ACTIONS(1257),
    [anon_sym_GT_EQ] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1257),
    [anon_sym_CARET] = ACTIONS(1257),
    [anon_sym_orelse] = ACTIONS(1259),
    [anon_sym_catch] = ACTIONS(1259),
    [anon_sym_LT_LT] = ACTIONS(1259),
    [anon_sym_GT_GT] = ACTIONS(1257),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1257),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS_PLUS] = ACTIONS(1257),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1257),
    [anon_sym_DASH_PERCENT] = ACTIONS(1257),
    [anon_sym_PLUS_PIPE] = ACTIONS(1257),
    [anon_sym_DASH_PIPE] = ACTIONS(1257),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_SLASH] = ACTIONS(1259),
    [anon_sym_PERCENT] = ACTIONS(1257),
    [anon_sym_STAR_STAR] = ACTIONS(1257),
    [anon_sym_STAR_PERCENT] = ACTIONS(1257),
    [anon_sym_STAR_PIPE] = ACTIONS(1257),
    [anon_sym_QMARK] = ACTIONS(1257),
    [anon_sym_DOT_STAR] = ACTIONS(1257),
    [anon_sym_DOT_QMARK] = ACTIONS(1257),
    [anon_sym_struct] = ACTIONS(1259),
    [anon_sym_opaque] = ACTIONS(1259),
    [anon_sym_enum] = ACTIONS(1259),
    [anon_sym_union] = ACTIONS(1259),
    [sym_doc_comment] = ACTIONS(1257),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1257),
    [aux_sym_FLOAT_token1] = ACTIONS(1257),
    [aux_sym_FLOAT_token2] = ACTIONS(1257),
    [aux_sym_FLOAT_token3] = ACTIONS(1257),
    [aux_sym_FLOAT_token4] = ACTIONS(1257),
    [aux_sym_INTEGER_token1] = ACTIONS(1257),
    [aux_sym_INTEGER_token2] = ACTIONS(1257),
    [aux_sym_INTEGER_token3] = ACTIONS(1259),
    [aux_sym_INTEGER_token4] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1257),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1257),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1259),
    [anon_sym_AT] = ACTIONS(1257),
  },
  [577] = {
    [ts_builtin_sym_end] = ACTIONS(1261),
    [anon_sym_COMMA] = ACTIONS(1261),
    [anon_sym_pub] = ACTIONS(1263),
    [anon_sym_test] = ACTIONS(1263),
    [anon_sym_comptime] = ACTIONS(1263),
    [anon_sym_export] = ACTIONS(1263),
    [anon_sym_extern] = ACTIONS(1263),
    [anon_sym_inline] = ACTIONS(1263),
    [anon_sym_noinline] = ACTIONS(1263),
    [anon_sym_threadlocal] = ACTIONS(1263),
    [anon_sym_usingnamespace] = ACTIONS(1263),
    [anon_sym_fn] = ACTIONS(1263),
    [anon_sym_BANG] = ACTIONS(1263),
    [anon_sym_const] = ACTIONS(1263),
    [anon_sym_var] = ACTIONS(1263),
    [anon_sym_or] = ACTIONS(1263),
    [anon_sym_and] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_RBRACE] = ACTIONS(1261),
    [anon_sym_async] = ACTIONS(1263),
    [anon_sym_DOT] = ACTIONS(1263),
    [anon_sym_error] = ACTIONS(1263),
    [anon_sym_false] = ACTIONS(1263),
    [anon_sym_null] = ACTIONS(1263),
    [anon_sym_anyframe] = ACTIONS(1263),
    [anon_sym_true] = ACTIONS(1263),
    [anon_sym_undefined] = ACTIONS(1263),
    [anon_sym_unreachable] = ACTIONS(1263),
    [sym_BuildinTypeExpr] = ACTIONS(1263),
    [anon_sym_packed] = ACTIONS(1263),
    [anon_sym_LPAREN] = ACTIONS(1261),
    [anon_sym_switch] = ACTIONS(1263),
    [anon_sym_LBRACK] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_while] = ACTIONS(1263),
    [anon_sym_for] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1263),
    [anon_sym_EQ_EQ] = ACTIONS(1261),
    [anon_sym_BANG_EQ] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_LT_EQ] = ACTIONS(1261),
    [anon_sym_GT_EQ] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_CARET] = ACTIONS(1261),
    [anon_sym_orelse] = ACTIONS(1263),
    [anon_sym_catch] = ACTIONS(1263),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1261),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1261),
    [anon_sym_DASH_PERCENT] = ACTIONS(1261),
    [anon_sym_PLUS_PIPE] = ACTIONS(1261),
    [anon_sym_DASH_PIPE] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [anon_sym_SLASH] = ACTIONS(1263),
    [anon_sym_PERCENT] = ACTIONS(1261),
    [anon_sym_STAR_STAR] = ACTIONS(1261),
    [anon_sym_STAR_PERCENT] = ACTIONS(1261),
    [anon_sym_STAR_PIPE] = ACTIONS(1261),
    [anon_sym_QMARK] = ACTIONS(1261),
    [anon_sym_DOT_STAR] = ACTIONS(1261),
    [anon_sym_DOT_QMARK] = ACTIONS(1261),
    [anon_sym_struct] = ACTIONS(1263),
    [anon_sym_opaque] = ACTIONS(1263),
    [anon_sym_enum] = ACTIONS(1263),
    [anon_sym_union] = ACTIONS(1263),
    [sym_doc_comment] = ACTIONS(1261),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1261),
    [aux_sym_FLOAT_token1] = ACTIONS(1261),
    [aux_sym_FLOAT_token2] = ACTIONS(1261),
    [aux_sym_FLOAT_token3] = ACTIONS(1261),
    [aux_sym_FLOAT_token4] = ACTIONS(1261),
    [aux_sym_INTEGER_token1] = ACTIONS(1261),
    [aux_sym_INTEGER_token2] = ACTIONS(1261),
    [aux_sym_INTEGER_token3] = ACTIONS(1263),
    [aux_sym_INTEGER_token4] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1261),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1263),
    [anon_sym_AT] = ACTIONS(1261),
  },
  [578] = {
    [ts_builtin_sym_end] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_pub] = ACTIONS(1267),
    [anon_sym_test] = ACTIONS(1267),
    [anon_sym_comptime] = ACTIONS(1267),
    [anon_sym_export] = ACTIONS(1267),
    [anon_sym_extern] = ACTIONS(1267),
    [anon_sym_inline] = ACTIONS(1267),
    [anon_sym_noinline] = ACTIONS(1267),
    [anon_sym_threadlocal] = ACTIONS(1267),
    [anon_sym_usingnamespace] = ACTIONS(1267),
    [anon_sym_fn] = ACTIONS(1267),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_const] = ACTIONS(1267),
    [anon_sym_var] = ACTIONS(1267),
    [anon_sym_or] = ACTIONS(1267),
    [anon_sym_and] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1265),
    [anon_sym_RBRACE] = ACTIONS(1265),
    [anon_sym_async] = ACTIONS(1267),
    [anon_sym_DOT] = ACTIONS(1267),
    [anon_sym_error] = ACTIONS(1267),
    [anon_sym_false] = ACTIONS(1267),
    [anon_sym_null] = ACTIONS(1267),
    [anon_sym_anyframe] = ACTIONS(1267),
    [anon_sym_true] = ACTIONS(1267),
    [anon_sym_undefined] = ACTIONS(1267),
    [anon_sym_unreachable] = ACTIONS(1267),
    [sym_BuildinTypeExpr] = ACTIONS(1267),
    [anon_sym_packed] = ACTIONS(1267),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [anon_sym_switch] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(1265),
    [anon_sym_if] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1267),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1267),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_LT_EQ] = ACTIONS(1265),
    [anon_sym_GT_EQ] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1265),
    [anon_sym_CARET] = ACTIONS(1265),
    [anon_sym_orelse] = ACTIONS(1267),
    [anon_sym_catch] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1265),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1265),
    [anon_sym_PLUS] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1267),
    [anon_sym_PLUS_PLUS] = ACTIONS(1265),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1265),
    [anon_sym_DASH_PERCENT] = ACTIONS(1265),
    [anon_sym_PLUS_PIPE] = ACTIONS(1265),
    [anon_sym_DASH_PIPE] = ACTIONS(1265),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1267),
    [anon_sym_PERCENT] = ACTIONS(1265),
    [anon_sym_STAR_STAR] = ACTIONS(1265),
    [anon_sym_STAR_PERCENT] = ACTIONS(1265),
    [anon_sym_STAR_PIPE] = ACTIONS(1265),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_DOT_STAR] = ACTIONS(1265),
    [anon_sym_DOT_QMARK] = ACTIONS(1265),
    [anon_sym_struct] = ACTIONS(1267),
    [anon_sym_opaque] = ACTIONS(1267),
    [anon_sym_enum] = ACTIONS(1267),
    [anon_sym_union] = ACTIONS(1267),
    [sym_doc_comment] = ACTIONS(1265),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1265),
    [aux_sym_FLOAT_token1] = ACTIONS(1265),
    [aux_sym_FLOAT_token2] = ACTIONS(1265),
    [aux_sym_FLOAT_token3] = ACTIONS(1265),
    [aux_sym_FLOAT_token4] = ACTIONS(1265),
    [aux_sym_INTEGER_token1] = ACTIONS(1265),
    [aux_sym_INTEGER_token2] = ACTIONS(1265),
    [aux_sym_INTEGER_token3] = ACTIONS(1267),
    [aux_sym_INTEGER_token4] = ACTIONS(1267),
    [anon_sym_DQUOTE] = ACTIONS(1265),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1265),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1267),
    [anon_sym_AT] = ACTIONS(1265),
  },
  [579] = {
    [ts_builtin_sym_end] = ACTIONS(1269),
    [anon_sym_COMMA] = ACTIONS(1269),
    [anon_sym_pub] = ACTIONS(1271),
    [anon_sym_test] = ACTIONS(1271),
    [anon_sym_comptime] = ACTIONS(1271),
    [anon_sym_export] = ACTIONS(1271),
    [anon_sym_extern] = ACTIONS(1271),
    [anon_sym_inline] = ACTIONS(1271),
    [anon_sym_noinline] = ACTIONS(1271),
    [anon_sym_threadlocal] = ACTIONS(1271),
    [anon_sym_usingnamespace] = ACTIONS(1271),
    [anon_sym_fn] = ACTIONS(1271),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_const] = ACTIONS(1271),
    [anon_sym_var] = ACTIONS(1271),
    [anon_sym_or] = ACTIONS(1271),
    [anon_sym_and] = ACTIONS(1271),
    [anon_sym_LBRACE] = ACTIONS(1269),
    [anon_sym_RBRACE] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_DOT] = ACTIONS(1271),
    [anon_sym_error] = ACTIONS(1271),
    [anon_sym_false] = ACTIONS(1271),
    [anon_sym_null] = ACTIONS(1271),
    [anon_sym_anyframe] = ACTIONS(1271),
    [anon_sym_true] = ACTIONS(1271),
    [anon_sym_undefined] = ACTIONS(1271),
    [anon_sym_unreachable] = ACTIONS(1271),
    [sym_BuildinTypeExpr] = ACTIONS(1271),
    [anon_sym_packed] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_switch] = ACTIONS(1271),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_if] = ACTIONS(1271),
    [anon_sym_while] = ACTIONS(1271),
    [anon_sym_for] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(1271),
    [anon_sym_EQ_EQ] = ACTIONS(1269),
    [anon_sym_BANG_EQ] = ACTIONS(1269),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_LT_EQ] = ACTIONS(1269),
    [anon_sym_GT_EQ] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1269),
    [anon_sym_CARET] = ACTIONS(1269),
    [anon_sym_orelse] = ACTIONS(1271),
    [anon_sym_catch] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1269),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1269),
    [anon_sym_PLUS] = ACTIONS(1271),
    [anon_sym_DASH] = ACTIONS(1271),
    [anon_sym_PLUS_PLUS] = ACTIONS(1269),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1269),
    [anon_sym_DASH_PERCENT] = ACTIONS(1269),
    [anon_sym_PLUS_PIPE] = ACTIONS(1269),
    [anon_sym_DASH_PIPE] = ACTIONS(1269),
    [anon_sym_PIPE_PIPE] = ACTIONS(1269),
    [anon_sym_SLASH] = ACTIONS(1271),
    [anon_sym_PERCENT] = ACTIONS(1269),
    [anon_sym_STAR_STAR] = ACTIONS(1269),
    [anon_sym_STAR_PERCENT] = ACTIONS(1269),
    [anon_sym_STAR_PIPE] = ACTIONS(1269),
    [anon_sym_QMARK] = ACTIONS(1269),
    [anon_sym_DOT_STAR] = ACTIONS(1269),
    [anon_sym_DOT_QMARK] = ACTIONS(1269),
    [anon_sym_struct] = ACTIONS(1271),
    [anon_sym_opaque] = ACTIONS(1271),
    [anon_sym_enum] = ACTIONS(1271),
    [anon_sym_union] = ACTIONS(1271),
    [sym_doc_comment] = ACTIONS(1269),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1269),
    [aux_sym_FLOAT_token1] = ACTIONS(1269),
    [aux_sym_FLOAT_token2] = ACTIONS(1269),
    [aux_sym_FLOAT_token3] = ACTIONS(1269),
    [aux_sym_FLOAT_token4] = ACTIONS(1269),
    [aux_sym_INTEGER_token1] = ACTIONS(1269),
    [aux_sym_INTEGER_token2] = ACTIONS(1269),
    [aux_sym_INTEGER_token3] = ACTIONS(1271),
    [aux_sym_INTEGER_token4] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1269),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1271),
    [anon_sym_AT] = ACTIONS(1269),
  },
  [580] = {
    [ts_builtin_sym_end] = ACTIONS(1281),
    [anon_sym_COMMA] = ACTIONS(1281),
    [anon_sym_pub] = ACTIONS(1283),
    [anon_sym_test] = ACTIONS(1283),
    [anon_sym_comptime] = ACTIONS(1283),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_extern] = ACTIONS(1283),
    [anon_sym_inline] = ACTIONS(1283),
    [anon_sym_noinline] = ACTIONS(1283),
    [anon_sym_threadlocal] = ACTIONS(1283),
    [anon_sym_usingnamespace] = ACTIONS(1283),
    [anon_sym_fn] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_const] = ACTIONS(1283),
    [anon_sym_var] = ACTIONS(1283),
    [anon_sym_or] = ACTIONS(1283),
    [anon_sym_and] = ACTIONS(1283),
    [anon_sym_LBRACE] = ACTIONS(1281),
    [anon_sym_RBRACE] = ACTIONS(1281),
    [anon_sym_async] = ACTIONS(1283),
    [anon_sym_DOT] = ACTIONS(1283),
    [anon_sym_error] = ACTIONS(1283),
    [anon_sym_false] = ACTIONS(1283),
    [anon_sym_null] = ACTIONS(1283),
    [anon_sym_anyframe] = ACTIONS(1283),
    [anon_sym_true] = ACTIONS(1283),
    [anon_sym_undefined] = ACTIONS(1283),
    [anon_sym_unreachable] = ACTIONS(1283),
    [sym_BuildinTypeExpr] = ACTIONS(1283),
    [anon_sym_packed] = ACTIONS(1283),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_switch] = ACTIONS(1283),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_if] = ACTIONS(1283),
    [anon_sym_while] = ACTIONS(1283),
    [anon_sym_for] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_EQ_EQ] = ACTIONS(1281),
    [anon_sym_BANG_EQ] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(1283),
    [anon_sym_LT_EQ] = ACTIONS(1281),
    [anon_sym_GT_EQ] = ACTIONS(1281),
    [anon_sym_AMP] = ACTIONS(1281),
    [anon_sym_CARET] = ACTIONS(1281),
    [anon_sym_orelse] = ACTIONS(1283),
    [anon_sym_catch] = ACTIONS(1283),
    [anon_sym_LT_LT] = ACTIONS(1283),
    [anon_sym_GT_GT] = ACTIONS(1281),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1281),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_PLUS_PLUS] = ACTIONS(1281),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1281),
    [anon_sym_DASH_PERCENT] = ACTIONS(1281),
    [anon_sym_PLUS_PIPE] = ACTIONS(1281),
    [anon_sym_DASH_PIPE] = ACTIONS(1281),
    [anon_sym_PIPE_PIPE] = ACTIONS(1281),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_PERCENT] = ACTIONS(1281),
    [anon_sym_STAR_STAR] = ACTIONS(1281),
    [anon_sym_STAR_PERCENT] = ACTIONS(1281),
    [anon_sym_STAR_PIPE] = ACTIONS(1281),
    [anon_sym_QMARK] = ACTIONS(1281),
    [anon_sym_DOT_STAR] = ACTIONS(1281),
    [anon_sym_DOT_QMARK] = ACTIONS(1281),
    [anon_sym_struct] = ACTIONS(1283),
    [anon_sym_opaque] = ACTIONS(1283),
    [anon_sym_enum] = ACTIONS(1283),
    [anon_sym_union] = ACTIONS(1283),
    [sym_doc_comment] = ACTIONS(1281),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1281),
    [aux_sym_FLOAT_token1] = ACTIONS(1281),
    [aux_sym_FLOAT_token2] = ACTIONS(1281),
    [aux_sym_FLOAT_token3] = ACTIONS(1281),
    [aux_sym_FLOAT_token4] = ACTIONS(1281),
    [aux_sym_INTEGER_token1] = ACTIONS(1281),
    [aux_sym_INTEGER_token2] = ACTIONS(1281),
    [aux_sym_INTEGER_token3] = ACTIONS(1283),
    [aux_sym_INTEGER_token4] = ACTIONS(1283),
    [anon_sym_DQUOTE] = ACTIONS(1281),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1281),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1283),
    [anon_sym_AT] = ACTIONS(1281),
  },
  [581] = {
    [ts_builtin_sym_end] = ACTIONS(1289),
    [anon_sym_COMMA] = ACTIONS(1289),
    [anon_sym_pub] = ACTIONS(1291),
    [anon_sym_test] = ACTIONS(1291),
    [anon_sym_comptime] = ACTIONS(1291),
    [anon_sym_export] = ACTIONS(1291),
    [anon_sym_extern] = ACTIONS(1291),
    [anon_sym_inline] = ACTIONS(1291),
    [anon_sym_noinline] = ACTIONS(1291),
    [anon_sym_threadlocal] = ACTIONS(1291),
    [anon_sym_usingnamespace] = ACTIONS(1291),
    [anon_sym_fn] = ACTIONS(1291),
    [anon_sym_BANG] = ACTIONS(1291),
    [anon_sym_const] = ACTIONS(1291),
    [anon_sym_var] = ACTIONS(1291),
    [anon_sym_or] = ACTIONS(1291),
    [anon_sym_and] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1289),
    [anon_sym_RBRACE] = ACTIONS(1289),
    [anon_sym_async] = ACTIONS(1291),
    [anon_sym_DOT] = ACTIONS(1291),
    [anon_sym_error] = ACTIONS(1291),
    [anon_sym_false] = ACTIONS(1291),
    [anon_sym_null] = ACTIONS(1291),
    [anon_sym_anyframe] = ACTIONS(1291),
    [anon_sym_true] = ACTIONS(1291),
    [anon_sym_undefined] = ACTIONS(1291),
    [anon_sym_unreachable] = ACTIONS(1291),
    [sym_BuildinTypeExpr] = ACTIONS(1291),
    [anon_sym_packed] = ACTIONS(1291),
    [anon_sym_LPAREN] = ACTIONS(1289),
    [anon_sym_switch] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_if] = ACTIONS(1291),
    [anon_sym_while] = ACTIONS(1291),
    [anon_sym_for] = ACTIONS(1291),
    [anon_sym_PIPE] = ACTIONS(1291),
    [anon_sym_STAR] = ACTIONS(1291),
    [anon_sym_EQ_EQ] = ACTIONS(1289),
    [anon_sym_BANG_EQ] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1291),
    [anon_sym_GT] = ACTIONS(1291),
    [anon_sym_LT_EQ] = ACTIONS(1289),
    [anon_sym_GT_EQ] = ACTIONS(1289),
    [anon_sym_AMP] = ACTIONS(1289),
    [anon_sym_CARET] = ACTIONS(1289),
    [anon_sym_orelse] = ACTIONS(1291),
    [anon_sym_catch] = ACTIONS(1291),
    [anon_sym_LT_LT] = ACTIONS(1291),
    [anon_sym_GT_GT] = ACTIONS(1289),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_DASH] = ACTIONS(1291),
    [anon_sym_PLUS_PLUS] = ACTIONS(1289),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1289),
    [anon_sym_DASH_PERCENT] = ACTIONS(1289),
    [anon_sym_PLUS_PIPE] = ACTIONS(1289),
    [anon_sym_DASH_PIPE] = ACTIONS(1289),
    [anon_sym_PIPE_PIPE] = ACTIONS(1289),
    [anon_sym_SLASH] = ACTIONS(1291),
    [anon_sym_PERCENT] = ACTIONS(1289),
    [anon_sym_STAR_STAR] = ACTIONS(1289),
    [anon_sym_STAR_PERCENT] = ACTIONS(1289),
    [anon_sym_STAR_PIPE] = ACTIONS(1289),
    [anon_sym_QMARK] = ACTIONS(1289),
    [anon_sym_DOT_STAR] = ACTIONS(1289),
    [anon_sym_DOT_QMARK] = ACTIONS(1289),
    [anon_sym_struct] = ACTIONS(1291),
    [anon_sym_opaque] = ACTIONS(1291),
    [anon_sym_enum] = ACTIONS(1291),
    [anon_sym_union] = ACTIONS(1291),
    [sym_doc_comment] = ACTIONS(1289),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1289),
    [aux_sym_FLOAT_token1] = ACTIONS(1289),
    [aux_sym_FLOAT_token2] = ACTIONS(1289),
    [aux_sym_FLOAT_token3] = ACTIONS(1289),
    [aux_sym_FLOAT_token4] = ACTIONS(1289),
    [aux_sym_INTEGER_token1] = ACTIONS(1289),
    [aux_sym_INTEGER_token2] = ACTIONS(1289),
    [aux_sym_INTEGER_token3] = ACTIONS(1291),
    [aux_sym_INTEGER_token4] = ACTIONS(1291),
    [anon_sym_DQUOTE] = ACTIONS(1289),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1289),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1291),
    [anon_sym_AT] = ACTIONS(1289),
  },
  [582] = {
    [ts_builtin_sym_end] = ACTIONS(1297),
    [anon_sym_COMMA] = ACTIONS(1297),
    [anon_sym_pub] = ACTIONS(1299),
    [anon_sym_test] = ACTIONS(1299),
    [anon_sym_comptime] = ACTIONS(1299),
    [anon_sym_export] = ACTIONS(1299),
    [anon_sym_extern] = ACTIONS(1299),
    [anon_sym_inline] = ACTIONS(1299),
    [anon_sym_noinline] = ACTIONS(1299),
    [anon_sym_threadlocal] = ACTIONS(1299),
    [anon_sym_usingnamespace] = ACTIONS(1299),
    [anon_sym_fn] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_const] = ACTIONS(1299),
    [anon_sym_var] = ACTIONS(1299),
    [anon_sym_or] = ACTIONS(1299),
    [anon_sym_and] = ACTIONS(1299),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_RBRACE] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1299),
    [anon_sym_DOT] = ACTIONS(1299),
    [anon_sym_error] = ACTIONS(1299),
    [anon_sym_false] = ACTIONS(1299),
    [anon_sym_null] = ACTIONS(1299),
    [anon_sym_anyframe] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(1299),
    [anon_sym_undefined] = ACTIONS(1299),
    [anon_sym_unreachable] = ACTIONS(1299),
    [sym_BuildinTypeExpr] = ACTIONS(1299),
    [anon_sym_packed] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1297),
    [anon_sym_switch] = ACTIONS(1299),
    [anon_sym_LBRACK] = ACTIONS(1297),
    [anon_sym_if] = ACTIONS(1299),
    [anon_sym_while] = ACTIONS(1299),
    [anon_sym_for] = ACTIONS(1299),
    [anon_sym_PIPE] = ACTIONS(1299),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_EQ_EQ] = ACTIONS(1297),
    [anon_sym_BANG_EQ] = ACTIONS(1297),
    [anon_sym_LT] = ACTIONS(1299),
    [anon_sym_GT] = ACTIONS(1299),
    [anon_sym_LT_EQ] = ACTIONS(1297),
    [anon_sym_GT_EQ] = ACTIONS(1297),
    [anon_sym_AMP] = ACTIONS(1297),
    [anon_sym_CARET] = ACTIONS(1297),
    [anon_sym_orelse] = ACTIONS(1299),
    [anon_sym_catch] = ACTIONS(1299),
    [anon_sym_LT_LT] = ACTIONS(1299),
    [anon_sym_GT_GT] = ACTIONS(1297),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1297),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1297),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1297),
    [anon_sym_DASH_PERCENT] = ACTIONS(1297),
    [anon_sym_PLUS_PIPE] = ACTIONS(1297),
    [anon_sym_DASH_PIPE] = ACTIONS(1297),
    [anon_sym_PIPE_PIPE] = ACTIONS(1297),
    [anon_sym_SLASH] = ACTIONS(1299),
    [anon_sym_PERCENT] = ACTIONS(1297),
    [anon_sym_STAR_STAR] = ACTIONS(1297),
    [anon_sym_STAR_PERCENT] = ACTIONS(1297),
    [anon_sym_STAR_PIPE] = ACTIONS(1297),
    [anon_sym_QMARK] = ACTIONS(1297),
    [anon_sym_DOT_STAR] = ACTIONS(1297),
    [anon_sym_DOT_QMARK] = ACTIONS(1297),
    [anon_sym_struct] = ACTIONS(1299),
    [anon_sym_opaque] = ACTIONS(1299),
    [anon_sym_enum] = ACTIONS(1299),
    [anon_sym_union] = ACTIONS(1299),
    [sym_doc_comment] = ACTIONS(1297),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1297),
    [aux_sym_FLOAT_token1] = ACTIONS(1297),
    [aux_sym_FLOAT_token2] = ACTIONS(1297),
    [aux_sym_FLOAT_token3] = ACTIONS(1297),
    [aux_sym_FLOAT_token4] = ACTIONS(1297),
    [aux_sym_INTEGER_token1] = ACTIONS(1297),
    [aux_sym_INTEGER_token2] = ACTIONS(1297),
    [aux_sym_INTEGER_token3] = ACTIONS(1299),
    [aux_sym_INTEGER_token4] = ACTIONS(1299),
    [anon_sym_DQUOTE] = ACTIONS(1297),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1297),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1297),
  },
  [583] = {
    [ts_builtin_sym_end] = ACTIONS(1301),
    [anon_sym_COMMA] = ACTIONS(1301),
    [anon_sym_pub] = ACTIONS(1303),
    [anon_sym_test] = ACTIONS(1303),
    [anon_sym_comptime] = ACTIONS(1303),
    [anon_sym_export] = ACTIONS(1303),
    [anon_sym_extern] = ACTIONS(1303),
    [anon_sym_inline] = ACTIONS(1303),
    [anon_sym_noinline] = ACTIONS(1303),
    [anon_sym_threadlocal] = ACTIONS(1303),
    [anon_sym_usingnamespace] = ACTIONS(1303),
    [anon_sym_fn] = ACTIONS(1303),
    [anon_sym_BANG] = ACTIONS(1303),
    [anon_sym_const] = ACTIONS(1303),
    [anon_sym_var] = ACTIONS(1303),
    [anon_sym_or] = ACTIONS(1303),
    [anon_sym_and] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(1301),
    [anon_sym_RBRACE] = ACTIONS(1301),
    [anon_sym_async] = ACTIONS(1303),
    [anon_sym_DOT] = ACTIONS(1303),
    [anon_sym_error] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [anon_sym_null] = ACTIONS(1303),
    [anon_sym_anyframe] = ACTIONS(1303),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_undefined] = ACTIONS(1303),
    [anon_sym_unreachable] = ACTIONS(1303),
    [sym_BuildinTypeExpr] = ACTIONS(1303),
    [anon_sym_packed] = ACTIONS(1303),
    [anon_sym_LPAREN] = ACTIONS(1301),
    [anon_sym_switch] = ACTIONS(1303),
    [anon_sym_LBRACK] = ACTIONS(1301),
    [anon_sym_if] = ACTIONS(1303),
    [anon_sym_while] = ACTIONS(1303),
    [anon_sym_for] = ACTIONS(1303),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_EQ_EQ] = ACTIONS(1301),
    [anon_sym_BANG_EQ] = ACTIONS(1301),
    [anon_sym_LT] = ACTIONS(1303),
    [anon_sym_GT] = ACTIONS(1303),
    [anon_sym_LT_EQ] = ACTIONS(1301),
    [anon_sym_GT_EQ] = ACTIONS(1301),
    [anon_sym_AMP] = ACTIONS(1301),
    [anon_sym_CARET] = ACTIONS(1301),
    [anon_sym_orelse] = ACTIONS(1303),
    [anon_sym_catch] = ACTIONS(1303),
    [anon_sym_LT_LT] = ACTIONS(1303),
    [anon_sym_GT_GT] = ACTIONS(1301),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1301),
    [anon_sym_PLUS] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1303),
    [anon_sym_PLUS_PLUS] = ACTIONS(1301),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1301),
    [anon_sym_DASH_PERCENT] = ACTIONS(1301),
    [anon_sym_PLUS_PIPE] = ACTIONS(1301),
    [anon_sym_DASH_PIPE] = ACTIONS(1301),
    [anon_sym_PIPE_PIPE] = ACTIONS(1301),
    [anon_sym_SLASH] = ACTIONS(1303),
    [anon_sym_PERCENT] = ACTIONS(1301),
    [anon_sym_STAR_STAR] = ACTIONS(1301),
    [anon_sym_STAR_PERCENT] = ACTIONS(1301),
    [anon_sym_STAR_PIPE] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1301),
    [anon_sym_DOT_STAR] = ACTIONS(1301),
    [anon_sym_DOT_QMARK] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(1303),
    [anon_sym_opaque] = ACTIONS(1303),
    [anon_sym_enum] = ACTIONS(1303),
    [anon_sym_union] = ACTIONS(1303),
    [sym_doc_comment] = ACTIONS(1301),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1301),
    [aux_sym_FLOAT_token1] = ACTIONS(1301),
    [aux_sym_FLOAT_token2] = ACTIONS(1301),
    [aux_sym_FLOAT_token3] = ACTIONS(1301),
    [aux_sym_FLOAT_token4] = ACTIONS(1301),
    [aux_sym_INTEGER_token1] = ACTIONS(1301),
    [aux_sym_INTEGER_token2] = ACTIONS(1301),
    [aux_sym_INTEGER_token3] = ACTIONS(1303),
    [aux_sym_INTEGER_token4] = ACTIONS(1303),
    [anon_sym_DQUOTE] = ACTIONS(1301),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1301),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1303),
    [anon_sym_AT] = ACTIONS(1301),
  },
  [584] = {
    [ts_builtin_sym_end] = ACTIONS(1305),
    [anon_sym_COMMA] = ACTIONS(1305),
    [anon_sym_pub] = ACTIONS(1307),
    [anon_sym_test] = ACTIONS(1307),
    [anon_sym_comptime] = ACTIONS(1307),
    [anon_sym_export] = ACTIONS(1307),
    [anon_sym_extern] = ACTIONS(1307),
    [anon_sym_inline] = ACTIONS(1307),
    [anon_sym_noinline] = ACTIONS(1307),
    [anon_sym_threadlocal] = ACTIONS(1307),
    [anon_sym_usingnamespace] = ACTIONS(1307),
    [anon_sym_fn] = ACTIONS(1307),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_const] = ACTIONS(1307),
    [anon_sym_var] = ACTIONS(1307),
    [anon_sym_or] = ACTIONS(1307),
    [anon_sym_and] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1305),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_async] = ACTIONS(1307),
    [anon_sym_DOT] = ACTIONS(1307),
    [anon_sym_error] = ACTIONS(1307),
    [anon_sym_false] = ACTIONS(1307),
    [anon_sym_null] = ACTIONS(1307),
    [anon_sym_anyframe] = ACTIONS(1307),
    [anon_sym_true] = ACTIONS(1307),
    [anon_sym_undefined] = ACTIONS(1307),
    [anon_sym_unreachable] = ACTIONS(1307),
    [sym_BuildinTypeExpr] = ACTIONS(1307),
    [anon_sym_packed] = ACTIONS(1307),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [anon_sym_switch] = ACTIONS(1307),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [anon_sym_if] = ACTIONS(1307),
    [anon_sym_while] = ACTIONS(1307),
    [anon_sym_for] = ACTIONS(1307),
    [anon_sym_PIPE] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(1307),
    [anon_sym_EQ_EQ] = ACTIONS(1305),
    [anon_sym_BANG_EQ] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1307),
    [anon_sym_GT] = ACTIONS(1307),
    [anon_sym_LT_EQ] = ACTIONS(1305),
    [anon_sym_GT_EQ] = ACTIONS(1305),
    [anon_sym_AMP] = ACTIONS(1305),
    [anon_sym_CARET] = ACTIONS(1305),
    [anon_sym_orelse] = ACTIONS(1307),
    [anon_sym_catch] = ACTIONS(1307),
    [anon_sym_LT_LT] = ACTIONS(1307),
    [anon_sym_GT_GT] = ACTIONS(1305),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1305),
    [anon_sym_PLUS] = ACTIONS(1307),
    [anon_sym_DASH] = ACTIONS(1307),
    [anon_sym_PLUS_PLUS] = ACTIONS(1305),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1305),
    [anon_sym_DASH_PERCENT] = ACTIONS(1305),
    [anon_sym_PLUS_PIPE] = ACTIONS(1305),
    [anon_sym_DASH_PIPE] = ACTIONS(1305),
    [anon_sym_PIPE_PIPE] = ACTIONS(1305),
    [anon_sym_SLASH] = ACTIONS(1307),
    [anon_sym_PERCENT] = ACTIONS(1305),
    [anon_sym_STAR_STAR] = ACTIONS(1305),
    [anon_sym_STAR_PERCENT] = ACTIONS(1305),
    [anon_sym_STAR_PIPE] = ACTIONS(1305),
    [anon_sym_QMARK] = ACTIONS(1305),
    [anon_sym_DOT_STAR] = ACTIONS(1305),
    [anon_sym_DOT_QMARK] = ACTIONS(1305),
    [anon_sym_struct] = ACTIONS(1307),
    [anon_sym_opaque] = ACTIONS(1307),
    [anon_sym_enum] = ACTIONS(1307),
    [anon_sym_union] = ACTIONS(1307),
    [sym_doc_comment] = ACTIONS(1305),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [aux_sym_FLOAT_token1] = ACTIONS(1305),
    [aux_sym_FLOAT_token2] = ACTIONS(1305),
    [aux_sym_FLOAT_token3] = ACTIONS(1305),
    [aux_sym_FLOAT_token4] = ACTIONS(1305),
    [aux_sym_INTEGER_token1] = ACTIONS(1305),
    [aux_sym_INTEGER_token2] = ACTIONS(1305),
    [aux_sym_INTEGER_token3] = ACTIONS(1307),
    [aux_sym_INTEGER_token4] = ACTIONS(1307),
    [anon_sym_DQUOTE] = ACTIONS(1305),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1305),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1307),
    [anon_sym_AT] = ACTIONS(1305),
  },
  [585] = {
    [ts_builtin_sym_end] = ACTIONS(1309),
    [anon_sym_COMMA] = ACTIONS(1309),
    [anon_sym_pub] = ACTIONS(1311),
    [anon_sym_test] = ACTIONS(1311),
    [anon_sym_comptime] = ACTIONS(1311),
    [anon_sym_export] = ACTIONS(1311),
    [anon_sym_extern] = ACTIONS(1311),
    [anon_sym_inline] = ACTIONS(1311),
    [anon_sym_noinline] = ACTIONS(1311),
    [anon_sym_threadlocal] = ACTIONS(1311),
    [anon_sym_usingnamespace] = ACTIONS(1311),
    [anon_sym_fn] = ACTIONS(1311),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_const] = ACTIONS(1311),
    [anon_sym_var] = ACTIONS(1311),
    [anon_sym_or] = ACTIONS(1311),
    [anon_sym_and] = ACTIONS(1311),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_RBRACE] = ACTIONS(1309),
    [anon_sym_async] = ACTIONS(1311),
    [anon_sym_DOT] = ACTIONS(1311),
    [anon_sym_error] = ACTIONS(1311),
    [anon_sym_false] = ACTIONS(1311),
    [anon_sym_null] = ACTIONS(1311),
    [anon_sym_anyframe] = ACTIONS(1311),
    [anon_sym_true] = ACTIONS(1311),
    [anon_sym_undefined] = ACTIONS(1311),
    [anon_sym_unreachable] = ACTIONS(1311),
    [sym_BuildinTypeExpr] = ACTIONS(1311),
    [anon_sym_packed] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1309),
    [anon_sym_switch] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1309),
    [anon_sym_if] = ACTIONS(1311),
    [anon_sym_while] = ACTIONS(1311),
    [anon_sym_for] = ACTIONS(1311),
    [anon_sym_PIPE] = ACTIONS(1311),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_EQ_EQ] = ACTIONS(1309),
    [anon_sym_BANG_EQ] = ACTIONS(1309),
    [anon_sym_LT] = ACTIONS(1311),
    [anon_sym_GT] = ACTIONS(1311),
    [anon_sym_LT_EQ] = ACTIONS(1309),
    [anon_sym_GT_EQ] = ACTIONS(1309),
    [anon_sym_AMP] = ACTIONS(1309),
    [anon_sym_CARET] = ACTIONS(1309),
    [anon_sym_orelse] = ACTIONS(1311),
    [anon_sym_catch] = ACTIONS(1311),
    [anon_sym_LT_LT] = ACTIONS(1311),
    [anon_sym_GT_GT] = ACTIONS(1309),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1309),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS_PLUS] = ACTIONS(1309),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1309),
    [anon_sym_DASH_PERCENT] = ACTIONS(1309),
    [anon_sym_PLUS_PIPE] = ACTIONS(1309),
    [anon_sym_DASH_PIPE] = ACTIONS(1309),
    [anon_sym_PIPE_PIPE] = ACTIONS(1309),
    [anon_sym_SLASH] = ACTIONS(1311),
    [anon_sym_PERCENT] = ACTIONS(1309),
    [anon_sym_STAR_STAR] = ACTIONS(1309),
    [anon_sym_STAR_PERCENT] = ACTIONS(1309),
    [anon_sym_STAR_PIPE] = ACTIONS(1309),
    [anon_sym_QMARK] = ACTIONS(1309),
    [anon_sym_DOT_STAR] = ACTIONS(1309),
    [anon_sym_DOT_QMARK] = ACTIONS(1309),
    [anon_sym_struct] = ACTIONS(1311),
    [anon_sym_opaque] = ACTIONS(1311),
    [anon_sym_enum] = ACTIONS(1311),
    [anon_sym_union] = ACTIONS(1311),
    [sym_doc_comment] = ACTIONS(1309),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1309),
    [aux_sym_FLOAT_token1] = ACTIONS(1309),
    [aux_sym_FLOAT_token2] = ACTIONS(1309),
    [aux_sym_FLOAT_token3] = ACTIONS(1309),
    [aux_sym_FLOAT_token4] = ACTIONS(1309),
    [aux_sym_INTEGER_token1] = ACTIONS(1309),
    [aux_sym_INTEGER_token2] = ACTIONS(1309),
    [aux_sym_INTEGER_token3] = ACTIONS(1311),
    [aux_sym_INTEGER_token4] = ACTIONS(1311),
    [anon_sym_DQUOTE] = ACTIONS(1309),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1309),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1311),
    [anon_sym_AT] = ACTIONS(1309),
  },
  [586] = {
    [ts_builtin_sym_end] = ACTIONS(1317),
    [anon_sym_COMMA] = ACTIONS(1317),
    [anon_sym_pub] = ACTIONS(1319),
    [anon_sym_test] = ACTIONS(1319),
    [anon_sym_comptime] = ACTIONS(1319),
    [anon_sym_export] = ACTIONS(1319),
    [anon_sym_extern] = ACTIONS(1319),
    [anon_sym_inline] = ACTIONS(1319),
    [anon_sym_noinline] = ACTIONS(1319),
    [anon_sym_threadlocal] = ACTIONS(1319),
    [anon_sym_usingnamespace] = ACTIONS(1319),
    [anon_sym_fn] = ACTIONS(1319),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_const] = ACTIONS(1319),
    [anon_sym_var] = ACTIONS(1319),
    [anon_sym_or] = ACTIONS(1319),
    [anon_sym_and] = ACTIONS(1319),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_RBRACE] = ACTIONS(1317),
    [anon_sym_async] = ACTIONS(1319),
    [anon_sym_DOT] = ACTIONS(1319),
    [anon_sym_error] = ACTIONS(1319),
    [anon_sym_false] = ACTIONS(1319),
    [anon_sym_null] = ACTIONS(1319),
    [anon_sym_anyframe] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(1319),
    [anon_sym_undefined] = ACTIONS(1319),
    [anon_sym_unreachable] = ACTIONS(1319),
    [sym_BuildinTypeExpr] = ACTIONS(1319),
    [anon_sym_packed] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_switch] = ACTIONS(1319),
    [anon_sym_LBRACK] = ACTIONS(1317),
    [anon_sym_if] = ACTIONS(1319),
    [anon_sym_while] = ACTIONS(1319),
    [anon_sym_for] = ACTIONS(1319),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_EQ_EQ] = ACTIONS(1317),
    [anon_sym_BANG_EQ] = ACTIONS(1317),
    [anon_sym_LT] = ACTIONS(1319),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_LT_EQ] = ACTIONS(1317),
    [anon_sym_GT_EQ] = ACTIONS(1317),
    [anon_sym_AMP] = ACTIONS(1317),
    [anon_sym_CARET] = ACTIONS(1317),
    [anon_sym_orelse] = ACTIONS(1319),
    [anon_sym_catch] = ACTIONS(1319),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_GT_GT] = ACTIONS(1317),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1317),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1317),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1317),
    [anon_sym_DASH_PERCENT] = ACTIONS(1317),
    [anon_sym_PLUS_PIPE] = ACTIONS(1317),
    [anon_sym_DASH_PIPE] = ACTIONS(1317),
    [anon_sym_PIPE_PIPE] = ACTIONS(1317),
    [anon_sym_SLASH] = ACTIONS(1319),
    [anon_sym_PERCENT] = ACTIONS(1317),
    [anon_sym_STAR_STAR] = ACTIONS(1317),
    [anon_sym_STAR_PERCENT] = ACTIONS(1317),
    [anon_sym_STAR_PIPE] = ACTIONS(1317),
    [anon_sym_QMARK] = ACTIONS(1317),
    [anon_sym_DOT_STAR] = ACTIONS(1317),
    [anon_sym_DOT_QMARK] = ACTIONS(1317),
    [anon_sym_struct] = ACTIONS(1319),
    [anon_sym_opaque] = ACTIONS(1319),
    [anon_sym_enum] = ACTIONS(1319),
    [anon_sym_union] = ACTIONS(1319),
    [sym_doc_comment] = ACTIONS(1317),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1317),
    [aux_sym_FLOAT_token1] = ACTIONS(1317),
    [aux_sym_FLOAT_token2] = ACTIONS(1317),
    [aux_sym_FLOAT_token3] = ACTIONS(1317),
    [aux_sym_FLOAT_token4] = ACTIONS(1317),
    [aux_sym_INTEGER_token1] = ACTIONS(1317),
    [aux_sym_INTEGER_token2] = ACTIONS(1317),
    [aux_sym_INTEGER_token3] = ACTIONS(1319),
    [aux_sym_INTEGER_token4] = ACTIONS(1319),
    [anon_sym_DQUOTE] = ACTIONS(1317),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1317),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1319),
    [anon_sym_AT] = ACTIONS(1317),
  },
  [587] = {
    [ts_builtin_sym_end] = ACTIONS(1321),
    [anon_sym_COMMA] = ACTIONS(1321),
    [anon_sym_pub] = ACTIONS(1323),
    [anon_sym_test] = ACTIONS(1323),
    [anon_sym_comptime] = ACTIONS(1323),
    [anon_sym_export] = ACTIONS(1323),
    [anon_sym_extern] = ACTIONS(1323),
    [anon_sym_inline] = ACTIONS(1323),
    [anon_sym_noinline] = ACTIONS(1323),
    [anon_sym_threadlocal] = ACTIONS(1323),
    [anon_sym_usingnamespace] = ACTIONS(1323),
    [anon_sym_fn] = ACTIONS(1323),
    [anon_sym_BANG] = ACTIONS(1323),
    [anon_sym_const] = ACTIONS(1323),
    [anon_sym_var] = ACTIONS(1323),
    [anon_sym_or] = ACTIONS(1323),
    [anon_sym_and] = ACTIONS(1323),
    [anon_sym_LBRACE] = ACTIONS(1321),
    [anon_sym_RBRACE] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1323),
    [anon_sym_DOT] = ACTIONS(1323),
    [anon_sym_error] = ACTIONS(1323),
    [anon_sym_false] = ACTIONS(1323),
    [anon_sym_null] = ACTIONS(1323),
    [anon_sym_anyframe] = ACTIONS(1323),
    [anon_sym_true] = ACTIONS(1323),
    [anon_sym_undefined] = ACTIONS(1323),
    [anon_sym_unreachable] = ACTIONS(1323),
    [sym_BuildinTypeExpr] = ACTIONS(1323),
    [anon_sym_packed] = ACTIONS(1323),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_switch] = ACTIONS(1323),
    [anon_sym_LBRACK] = ACTIONS(1321),
    [anon_sym_if] = ACTIONS(1323),
    [anon_sym_while] = ACTIONS(1323),
    [anon_sym_for] = ACTIONS(1323),
    [anon_sym_PIPE] = ACTIONS(1323),
    [anon_sym_STAR] = ACTIONS(1323),
    [anon_sym_EQ_EQ] = ACTIONS(1321),
    [anon_sym_BANG_EQ] = ACTIONS(1321),
    [anon_sym_LT] = ACTIONS(1323),
    [anon_sym_GT] = ACTIONS(1323),
    [anon_sym_LT_EQ] = ACTIONS(1321),
    [anon_sym_GT_EQ] = ACTIONS(1321),
    [anon_sym_AMP] = ACTIONS(1321),
    [anon_sym_CARET] = ACTIONS(1321),
    [anon_sym_orelse] = ACTIONS(1323),
    [anon_sym_catch] = ACTIONS(1323),
    [anon_sym_LT_LT] = ACTIONS(1323),
    [anon_sym_GT_GT] = ACTIONS(1321),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1321),
    [anon_sym_PLUS] = ACTIONS(1323),
    [anon_sym_DASH] = ACTIONS(1323),
    [anon_sym_PLUS_PLUS] = ACTIONS(1321),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1321),
    [anon_sym_DASH_PERCENT] = ACTIONS(1321),
    [anon_sym_PLUS_PIPE] = ACTIONS(1321),
    [anon_sym_DASH_PIPE] = ACTIONS(1321),
    [anon_sym_PIPE_PIPE] = ACTIONS(1321),
    [anon_sym_SLASH] = ACTIONS(1323),
    [anon_sym_PERCENT] = ACTIONS(1321),
    [anon_sym_STAR_STAR] = ACTIONS(1321),
    [anon_sym_STAR_PERCENT] = ACTIONS(1321),
    [anon_sym_STAR_PIPE] = ACTIONS(1321),
    [anon_sym_QMARK] = ACTIONS(1321),
    [anon_sym_DOT_STAR] = ACTIONS(1321),
    [anon_sym_DOT_QMARK] = ACTIONS(1321),
    [anon_sym_struct] = ACTIONS(1323),
    [anon_sym_opaque] = ACTIONS(1323),
    [anon_sym_enum] = ACTIONS(1323),
    [anon_sym_union] = ACTIONS(1323),
    [sym_doc_comment] = ACTIONS(1321),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1321),
    [aux_sym_FLOAT_token1] = ACTIONS(1321),
    [aux_sym_FLOAT_token2] = ACTIONS(1321),
    [aux_sym_FLOAT_token3] = ACTIONS(1321),
    [aux_sym_FLOAT_token4] = ACTIONS(1321),
    [aux_sym_INTEGER_token1] = ACTIONS(1321),
    [aux_sym_INTEGER_token2] = ACTIONS(1321),
    [aux_sym_INTEGER_token3] = ACTIONS(1323),
    [aux_sym_INTEGER_token4] = ACTIONS(1323),
    [anon_sym_DQUOTE] = ACTIONS(1321),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1323),
    [anon_sym_AT] = ACTIONS(1321),
  },
  [588] = {
    [ts_builtin_sym_end] = ACTIONS(1325),
    [anon_sym_COMMA] = ACTIONS(1325),
    [anon_sym_pub] = ACTIONS(1327),
    [anon_sym_test] = ACTIONS(1327),
    [anon_sym_comptime] = ACTIONS(1327),
    [anon_sym_export] = ACTIONS(1327),
    [anon_sym_extern] = ACTIONS(1327),
    [anon_sym_inline] = ACTIONS(1327),
    [anon_sym_noinline] = ACTIONS(1327),
    [anon_sym_threadlocal] = ACTIONS(1327),
    [anon_sym_usingnamespace] = ACTIONS(1327),
    [anon_sym_fn] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_const] = ACTIONS(1327),
    [anon_sym_var] = ACTIONS(1327),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1327),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_RBRACE] = ACTIONS(1325),
    [anon_sym_async] = ACTIONS(1327),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_error] = ACTIONS(1327),
    [anon_sym_false] = ACTIONS(1327),
    [anon_sym_null] = ACTIONS(1327),
    [anon_sym_anyframe] = ACTIONS(1327),
    [anon_sym_true] = ACTIONS(1327),
    [anon_sym_undefined] = ACTIONS(1327),
    [anon_sym_unreachable] = ACTIONS(1327),
    [sym_BuildinTypeExpr] = ACTIONS(1327),
    [anon_sym_packed] = ACTIONS(1327),
    [anon_sym_LPAREN] = ACTIONS(1325),
    [anon_sym_switch] = ACTIONS(1327),
    [anon_sym_LBRACK] = ACTIONS(1325),
    [anon_sym_if] = ACTIONS(1327),
    [anon_sym_while] = ACTIONS(1327),
    [anon_sym_for] = ACTIONS(1327),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_EQ_EQ] = ACTIONS(1325),
    [anon_sym_BANG_EQ] = ACTIONS(1325),
    [anon_sym_LT] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1325),
    [anon_sym_GT_EQ] = ACTIONS(1325),
    [anon_sym_AMP] = ACTIONS(1325),
    [anon_sym_CARET] = ACTIONS(1325),
    [anon_sym_orelse] = ACTIONS(1327),
    [anon_sym_catch] = ACTIONS(1327),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [anon_sym_GT_GT] = ACTIONS(1325),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1325),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1325),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1325),
    [anon_sym_DASH_PERCENT] = ACTIONS(1325),
    [anon_sym_PLUS_PIPE] = ACTIONS(1325),
    [anon_sym_DASH_PIPE] = ACTIONS(1325),
    [anon_sym_PIPE_PIPE] = ACTIONS(1325),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1325),
    [anon_sym_STAR_STAR] = ACTIONS(1325),
    [anon_sym_STAR_PERCENT] = ACTIONS(1325),
    [anon_sym_STAR_PIPE] = ACTIONS(1325),
    [anon_sym_QMARK] = ACTIONS(1325),
    [anon_sym_DOT_STAR] = ACTIONS(1325),
    [anon_sym_DOT_QMARK] = ACTIONS(1325),
    [anon_sym_struct] = ACTIONS(1327),
    [anon_sym_opaque] = ACTIONS(1327),
    [anon_sym_enum] = ACTIONS(1327),
    [anon_sym_union] = ACTIONS(1327),
    [sym_doc_comment] = ACTIONS(1325),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1325),
    [aux_sym_FLOAT_token1] = ACTIONS(1325),
    [aux_sym_FLOAT_token2] = ACTIONS(1325),
    [aux_sym_FLOAT_token3] = ACTIONS(1325),
    [aux_sym_FLOAT_token4] = ACTIONS(1325),
    [aux_sym_INTEGER_token1] = ACTIONS(1325),
    [aux_sym_INTEGER_token2] = ACTIONS(1325),
    [aux_sym_INTEGER_token3] = ACTIONS(1327),
    [aux_sym_INTEGER_token4] = ACTIONS(1327),
    [anon_sym_DQUOTE] = ACTIONS(1325),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1325),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1327),
    [anon_sym_AT] = ACTIONS(1325),
  },
  [589] = {
    [ts_builtin_sym_end] = ACTIONS(1329),
    [anon_sym_COMMA] = ACTIONS(1329),
    [anon_sym_pub] = ACTIONS(1331),
    [anon_sym_test] = ACTIONS(1331),
    [anon_sym_comptime] = ACTIONS(1331),
    [anon_sym_export] = ACTIONS(1331),
    [anon_sym_extern] = ACTIONS(1331),
    [anon_sym_inline] = ACTIONS(1331),
    [anon_sym_noinline] = ACTIONS(1331),
    [anon_sym_threadlocal] = ACTIONS(1331),
    [anon_sym_usingnamespace] = ACTIONS(1331),
    [anon_sym_fn] = ACTIONS(1331),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_const] = ACTIONS(1331),
    [anon_sym_var] = ACTIONS(1331),
    [anon_sym_or] = ACTIONS(1331),
    [anon_sym_and] = ACTIONS(1331),
    [anon_sym_LBRACE] = ACTIONS(1329),
    [anon_sym_RBRACE] = ACTIONS(1329),
    [anon_sym_async] = ACTIONS(1331),
    [anon_sym_DOT] = ACTIONS(1331),
    [anon_sym_error] = ACTIONS(1331),
    [anon_sym_false] = ACTIONS(1331),
    [anon_sym_null] = ACTIONS(1331),
    [anon_sym_anyframe] = ACTIONS(1331),
    [anon_sym_true] = ACTIONS(1331),
    [anon_sym_undefined] = ACTIONS(1331),
    [anon_sym_unreachable] = ACTIONS(1331),
    [sym_BuildinTypeExpr] = ACTIONS(1331),
    [anon_sym_packed] = ACTIONS(1331),
    [anon_sym_LPAREN] = ACTIONS(1329),
    [anon_sym_switch] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(1329),
    [anon_sym_if] = ACTIONS(1331),
    [anon_sym_while] = ACTIONS(1331),
    [anon_sym_for] = ACTIONS(1331),
    [anon_sym_PIPE] = ACTIONS(1331),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_EQ_EQ] = ACTIONS(1329),
    [anon_sym_BANG_EQ] = ACTIONS(1329),
    [anon_sym_LT] = ACTIONS(1331),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1329),
    [anon_sym_GT_EQ] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1329),
    [anon_sym_CARET] = ACTIONS(1329),
    [anon_sym_orelse] = ACTIONS(1331),
    [anon_sym_catch] = ACTIONS(1331),
    [anon_sym_LT_LT] = ACTIONS(1331),
    [anon_sym_GT_GT] = ACTIONS(1329),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1329),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1329),
    [anon_sym_DASH_PERCENT] = ACTIONS(1329),
    [anon_sym_PLUS_PIPE] = ACTIONS(1329),
    [anon_sym_DASH_PIPE] = ACTIONS(1329),
    [anon_sym_PIPE_PIPE] = ACTIONS(1329),
    [anon_sym_SLASH] = ACTIONS(1331),
    [anon_sym_PERCENT] = ACTIONS(1329),
    [anon_sym_STAR_STAR] = ACTIONS(1329),
    [anon_sym_STAR_PERCENT] = ACTIONS(1329),
    [anon_sym_STAR_PIPE] = ACTIONS(1329),
    [anon_sym_QMARK] = ACTIONS(1329),
    [anon_sym_DOT_STAR] = ACTIONS(1329),
    [anon_sym_DOT_QMARK] = ACTIONS(1329),
    [anon_sym_struct] = ACTIONS(1331),
    [anon_sym_opaque] = ACTIONS(1331),
    [anon_sym_enum] = ACTIONS(1331),
    [anon_sym_union] = ACTIONS(1331),
    [sym_doc_comment] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1329),
    [aux_sym_FLOAT_token1] = ACTIONS(1329),
    [aux_sym_FLOAT_token2] = ACTIONS(1329),
    [aux_sym_FLOAT_token3] = ACTIONS(1329),
    [aux_sym_FLOAT_token4] = ACTIONS(1329),
    [aux_sym_INTEGER_token1] = ACTIONS(1329),
    [aux_sym_INTEGER_token2] = ACTIONS(1329),
    [aux_sym_INTEGER_token3] = ACTIONS(1331),
    [aux_sym_INTEGER_token4] = ACTIONS(1331),
    [anon_sym_DQUOTE] = ACTIONS(1329),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1329),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1331),
    [anon_sym_AT] = ACTIONS(1329),
  },
  [590] = {
    [ts_builtin_sym_end] = ACTIONS(1333),
    [anon_sym_COMMA] = ACTIONS(1333),
    [anon_sym_pub] = ACTIONS(1335),
    [anon_sym_test] = ACTIONS(1335),
    [anon_sym_comptime] = ACTIONS(1335),
    [anon_sym_export] = ACTIONS(1335),
    [anon_sym_extern] = ACTIONS(1335),
    [anon_sym_inline] = ACTIONS(1335),
    [anon_sym_noinline] = ACTIONS(1335),
    [anon_sym_threadlocal] = ACTIONS(1335),
    [anon_sym_usingnamespace] = ACTIONS(1335),
    [anon_sym_fn] = ACTIONS(1335),
    [anon_sym_BANG] = ACTIONS(1335),
    [anon_sym_const] = ACTIONS(1335),
    [anon_sym_var] = ACTIONS(1335),
    [anon_sym_or] = ACTIONS(1335),
    [anon_sym_and] = ACTIONS(1335),
    [anon_sym_LBRACE] = ACTIONS(1333),
    [anon_sym_RBRACE] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_DOT] = ACTIONS(1335),
    [anon_sym_error] = ACTIONS(1335),
    [anon_sym_false] = ACTIONS(1335),
    [anon_sym_null] = ACTIONS(1335),
    [anon_sym_anyframe] = ACTIONS(1335),
    [anon_sym_true] = ACTIONS(1335),
    [anon_sym_undefined] = ACTIONS(1335),
    [anon_sym_unreachable] = ACTIONS(1335),
    [sym_BuildinTypeExpr] = ACTIONS(1335),
    [anon_sym_packed] = ACTIONS(1335),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_switch] = ACTIONS(1335),
    [anon_sym_LBRACK] = ACTIONS(1333),
    [anon_sym_if] = ACTIONS(1335),
    [anon_sym_while] = ACTIONS(1335),
    [anon_sym_for] = ACTIONS(1335),
    [anon_sym_PIPE] = ACTIONS(1335),
    [anon_sym_STAR] = ACTIONS(1335),
    [anon_sym_EQ_EQ] = ACTIONS(1333),
    [anon_sym_BANG_EQ] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(1335),
    [anon_sym_GT] = ACTIONS(1335),
    [anon_sym_LT_EQ] = ACTIONS(1333),
    [anon_sym_GT_EQ] = ACTIONS(1333),
    [anon_sym_AMP] = ACTIONS(1333),
    [anon_sym_CARET] = ACTIONS(1333),
    [anon_sym_orelse] = ACTIONS(1335),
    [anon_sym_catch] = ACTIONS(1335),
    [anon_sym_LT_LT] = ACTIONS(1335),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1333),
    [anon_sym_PLUS] = ACTIONS(1335),
    [anon_sym_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1333),
    [anon_sym_DASH_PERCENT] = ACTIONS(1333),
    [anon_sym_PLUS_PIPE] = ACTIONS(1333),
    [anon_sym_DASH_PIPE] = ACTIONS(1333),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_SLASH] = ACTIONS(1335),
    [anon_sym_PERCENT] = ACTIONS(1333),
    [anon_sym_STAR_STAR] = ACTIONS(1333),
    [anon_sym_STAR_PERCENT] = ACTIONS(1333),
    [anon_sym_STAR_PIPE] = ACTIONS(1333),
    [anon_sym_QMARK] = ACTIONS(1333),
    [anon_sym_DOT_STAR] = ACTIONS(1333),
    [anon_sym_DOT_QMARK] = ACTIONS(1333),
    [anon_sym_struct] = ACTIONS(1335),
    [anon_sym_opaque] = ACTIONS(1335),
    [anon_sym_enum] = ACTIONS(1335),
    [anon_sym_union] = ACTIONS(1335),
    [sym_doc_comment] = ACTIONS(1333),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1333),
    [aux_sym_FLOAT_token1] = ACTIONS(1333),
    [aux_sym_FLOAT_token2] = ACTIONS(1333),
    [aux_sym_FLOAT_token3] = ACTIONS(1333),
    [aux_sym_FLOAT_token4] = ACTIONS(1333),
    [aux_sym_INTEGER_token1] = ACTIONS(1333),
    [aux_sym_INTEGER_token2] = ACTIONS(1333),
    [aux_sym_INTEGER_token3] = ACTIONS(1335),
    [aux_sym_INTEGER_token4] = ACTIONS(1335),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1333),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1335),
    [anon_sym_AT] = ACTIONS(1333),
  },
  [591] = {
    [ts_builtin_sym_end] = ACTIONS(1337),
    [anon_sym_COMMA] = ACTIONS(1337),
    [anon_sym_pub] = ACTIONS(1339),
    [anon_sym_test] = ACTIONS(1339),
    [anon_sym_comptime] = ACTIONS(1339),
    [anon_sym_export] = ACTIONS(1339),
    [anon_sym_extern] = ACTIONS(1339),
    [anon_sym_inline] = ACTIONS(1339),
    [anon_sym_noinline] = ACTIONS(1339),
    [anon_sym_threadlocal] = ACTIONS(1339),
    [anon_sym_usingnamespace] = ACTIONS(1339),
    [anon_sym_fn] = ACTIONS(1339),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_const] = ACTIONS(1339),
    [anon_sym_var] = ACTIONS(1339),
    [anon_sym_or] = ACTIONS(1339),
    [anon_sym_and] = ACTIONS(1339),
    [anon_sym_LBRACE] = ACTIONS(1337),
    [anon_sym_RBRACE] = ACTIONS(1337),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_DOT] = ACTIONS(1339),
    [anon_sym_error] = ACTIONS(1339),
    [anon_sym_false] = ACTIONS(1339),
    [anon_sym_null] = ACTIONS(1339),
    [anon_sym_anyframe] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(1339),
    [anon_sym_undefined] = ACTIONS(1339),
    [anon_sym_unreachable] = ACTIONS(1339),
    [sym_BuildinTypeExpr] = ACTIONS(1339),
    [anon_sym_packed] = ACTIONS(1339),
    [anon_sym_LPAREN] = ACTIONS(1337),
    [anon_sym_switch] = ACTIONS(1339),
    [anon_sym_LBRACK] = ACTIONS(1337),
    [anon_sym_if] = ACTIONS(1339),
    [anon_sym_while] = ACTIONS(1339),
    [anon_sym_for] = ACTIONS(1339),
    [anon_sym_PIPE] = ACTIONS(1339),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG_EQ] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1339),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_AMP] = ACTIONS(1337),
    [anon_sym_CARET] = ACTIONS(1337),
    [anon_sym_orelse] = ACTIONS(1339),
    [anon_sym_catch] = ACTIONS(1339),
    [anon_sym_LT_LT] = ACTIONS(1339),
    [anon_sym_GT_GT] = ACTIONS(1337),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1337),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1337),
    [anon_sym_DASH_PERCENT] = ACTIONS(1337),
    [anon_sym_PLUS_PIPE] = ACTIONS(1337),
    [anon_sym_DASH_PIPE] = ACTIONS(1337),
    [anon_sym_PIPE_PIPE] = ACTIONS(1337),
    [anon_sym_SLASH] = ACTIONS(1339),
    [anon_sym_PERCENT] = ACTIONS(1337),
    [anon_sym_STAR_STAR] = ACTIONS(1337),
    [anon_sym_STAR_PERCENT] = ACTIONS(1337),
    [anon_sym_STAR_PIPE] = ACTIONS(1337),
    [anon_sym_QMARK] = ACTIONS(1337),
    [anon_sym_DOT_STAR] = ACTIONS(1337),
    [anon_sym_DOT_QMARK] = ACTIONS(1337),
    [anon_sym_struct] = ACTIONS(1339),
    [anon_sym_opaque] = ACTIONS(1339),
    [anon_sym_enum] = ACTIONS(1339),
    [anon_sym_union] = ACTIONS(1339),
    [sym_doc_comment] = ACTIONS(1337),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1337),
    [aux_sym_FLOAT_token1] = ACTIONS(1337),
    [aux_sym_FLOAT_token2] = ACTIONS(1337),
    [aux_sym_FLOAT_token3] = ACTIONS(1337),
    [aux_sym_FLOAT_token4] = ACTIONS(1337),
    [aux_sym_INTEGER_token1] = ACTIONS(1337),
    [aux_sym_INTEGER_token2] = ACTIONS(1337),
    [aux_sym_INTEGER_token3] = ACTIONS(1339),
    [aux_sym_INTEGER_token4] = ACTIONS(1339),
    [anon_sym_DQUOTE] = ACTIONS(1337),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1337),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1339),
    [anon_sym_AT] = ACTIONS(1337),
  },
  [592] = {
    [ts_builtin_sym_end] = ACTIONS(1341),
    [anon_sym_COMMA] = ACTIONS(1341),
    [anon_sym_pub] = ACTIONS(1343),
    [anon_sym_test] = ACTIONS(1343),
    [anon_sym_comptime] = ACTIONS(1343),
    [anon_sym_export] = ACTIONS(1343),
    [anon_sym_extern] = ACTIONS(1343),
    [anon_sym_inline] = ACTIONS(1343),
    [anon_sym_noinline] = ACTIONS(1343),
    [anon_sym_threadlocal] = ACTIONS(1343),
    [anon_sym_usingnamespace] = ACTIONS(1343),
    [anon_sym_fn] = ACTIONS(1343),
    [anon_sym_BANG] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1343),
    [anon_sym_var] = ACTIONS(1343),
    [anon_sym_or] = ACTIONS(1343),
    [anon_sym_and] = ACTIONS(1343),
    [anon_sym_LBRACE] = ACTIONS(1341),
    [anon_sym_RBRACE] = ACTIONS(1341),
    [anon_sym_async] = ACTIONS(1343),
    [anon_sym_DOT] = ACTIONS(1343),
    [anon_sym_error] = ACTIONS(1343),
    [anon_sym_false] = ACTIONS(1343),
    [anon_sym_null] = ACTIONS(1343),
    [anon_sym_anyframe] = ACTIONS(1343),
    [anon_sym_true] = ACTIONS(1343),
    [anon_sym_undefined] = ACTIONS(1343),
    [anon_sym_unreachable] = ACTIONS(1343),
    [sym_BuildinTypeExpr] = ACTIONS(1343),
    [anon_sym_packed] = ACTIONS(1343),
    [anon_sym_LPAREN] = ACTIONS(1341),
    [anon_sym_switch] = ACTIONS(1343),
    [anon_sym_LBRACK] = ACTIONS(1341),
    [anon_sym_if] = ACTIONS(1343),
    [anon_sym_while] = ACTIONS(1343),
    [anon_sym_for] = ACTIONS(1343),
    [anon_sym_PIPE] = ACTIONS(1343),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_EQ_EQ] = ACTIONS(1341),
    [anon_sym_BANG_EQ] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(1343),
    [anon_sym_GT] = ACTIONS(1343),
    [anon_sym_LT_EQ] = ACTIONS(1341),
    [anon_sym_GT_EQ] = ACTIONS(1341),
    [anon_sym_AMP] = ACTIONS(1341),
    [anon_sym_CARET] = ACTIONS(1341),
    [anon_sym_orelse] = ACTIONS(1343),
    [anon_sym_catch] = ACTIONS(1343),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_GT_GT] = ACTIONS(1341),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1341),
    [anon_sym_PLUS] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1343),
    [anon_sym_PLUS_PLUS] = ACTIONS(1341),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1341),
    [anon_sym_DASH_PERCENT] = ACTIONS(1341),
    [anon_sym_PLUS_PIPE] = ACTIONS(1341),
    [anon_sym_DASH_PIPE] = ACTIONS(1341),
    [anon_sym_PIPE_PIPE] = ACTIONS(1341),
    [anon_sym_SLASH] = ACTIONS(1343),
    [anon_sym_PERCENT] = ACTIONS(1341),
    [anon_sym_STAR_STAR] = ACTIONS(1341),
    [anon_sym_STAR_PERCENT] = ACTIONS(1341),
    [anon_sym_STAR_PIPE] = ACTIONS(1341),
    [anon_sym_QMARK] = ACTIONS(1341),
    [anon_sym_DOT_STAR] = ACTIONS(1341),
    [anon_sym_DOT_QMARK] = ACTIONS(1341),
    [anon_sym_struct] = ACTIONS(1343),
    [anon_sym_opaque] = ACTIONS(1343),
    [anon_sym_enum] = ACTIONS(1343),
    [anon_sym_union] = ACTIONS(1343),
    [sym_doc_comment] = ACTIONS(1341),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1341),
    [aux_sym_FLOAT_token1] = ACTIONS(1341),
    [aux_sym_FLOAT_token2] = ACTIONS(1341),
    [aux_sym_FLOAT_token3] = ACTIONS(1341),
    [aux_sym_FLOAT_token4] = ACTIONS(1341),
    [aux_sym_INTEGER_token1] = ACTIONS(1341),
    [aux_sym_INTEGER_token2] = ACTIONS(1341),
    [aux_sym_INTEGER_token3] = ACTIONS(1343),
    [aux_sym_INTEGER_token4] = ACTIONS(1343),
    [anon_sym_DQUOTE] = ACTIONS(1341),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1341),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1343),
    [anon_sym_AT] = ACTIONS(1341),
  },
  [593] = {
    [ts_builtin_sym_end] = ACTIONS(1345),
    [anon_sym_COMMA] = ACTIONS(1345),
    [anon_sym_pub] = ACTIONS(1347),
    [anon_sym_test] = ACTIONS(1347),
    [anon_sym_comptime] = ACTIONS(1347),
    [anon_sym_export] = ACTIONS(1347),
    [anon_sym_extern] = ACTIONS(1347),
    [anon_sym_inline] = ACTIONS(1347),
    [anon_sym_noinline] = ACTIONS(1347),
    [anon_sym_threadlocal] = ACTIONS(1347),
    [anon_sym_usingnamespace] = ACTIONS(1347),
    [anon_sym_fn] = ACTIONS(1347),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_const] = ACTIONS(1347),
    [anon_sym_var] = ACTIONS(1347),
    [anon_sym_or] = ACTIONS(1347),
    [anon_sym_and] = ACTIONS(1347),
    [anon_sym_LBRACE] = ACTIONS(1345),
    [anon_sym_RBRACE] = ACTIONS(1345),
    [anon_sym_async] = ACTIONS(1347),
    [anon_sym_DOT] = ACTIONS(1347),
    [anon_sym_error] = ACTIONS(1347),
    [anon_sym_false] = ACTIONS(1347),
    [anon_sym_null] = ACTIONS(1347),
    [anon_sym_anyframe] = ACTIONS(1347),
    [anon_sym_true] = ACTIONS(1347),
    [anon_sym_undefined] = ACTIONS(1347),
    [anon_sym_unreachable] = ACTIONS(1347),
    [sym_BuildinTypeExpr] = ACTIONS(1347),
    [anon_sym_packed] = ACTIONS(1347),
    [anon_sym_LPAREN] = ACTIONS(1345),
    [anon_sym_switch] = ACTIONS(1347),
    [anon_sym_LBRACK] = ACTIONS(1345),
    [anon_sym_if] = ACTIONS(1347),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_for] = ACTIONS(1347),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_EQ_EQ] = ACTIONS(1345),
    [anon_sym_BANG_EQ] = ACTIONS(1345),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1345),
    [anon_sym_GT_EQ] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(1345),
    [anon_sym_CARET] = ACTIONS(1345),
    [anon_sym_orelse] = ACTIONS(1347),
    [anon_sym_catch] = ACTIONS(1347),
    [anon_sym_LT_LT] = ACTIONS(1347),
    [anon_sym_GT_GT] = ACTIONS(1345),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1345),
    [anon_sym_PLUS] = ACTIONS(1347),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(1345),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1345),
    [anon_sym_DASH_PERCENT] = ACTIONS(1345),
    [anon_sym_PLUS_PIPE] = ACTIONS(1345),
    [anon_sym_DASH_PIPE] = ACTIONS(1345),
    [anon_sym_PIPE_PIPE] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1347),
    [anon_sym_PERCENT] = ACTIONS(1345),
    [anon_sym_STAR_STAR] = ACTIONS(1345),
    [anon_sym_STAR_PERCENT] = ACTIONS(1345),
    [anon_sym_STAR_PIPE] = ACTIONS(1345),
    [anon_sym_QMARK] = ACTIONS(1345),
    [anon_sym_DOT_STAR] = ACTIONS(1345),
    [anon_sym_DOT_QMARK] = ACTIONS(1345),
    [anon_sym_struct] = ACTIONS(1347),
    [anon_sym_opaque] = ACTIONS(1347),
    [anon_sym_enum] = ACTIONS(1347),
    [anon_sym_union] = ACTIONS(1347),
    [sym_doc_comment] = ACTIONS(1345),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1345),
    [aux_sym_FLOAT_token1] = ACTIONS(1345),
    [aux_sym_FLOAT_token2] = ACTIONS(1345),
    [aux_sym_FLOAT_token3] = ACTIONS(1345),
    [aux_sym_FLOAT_token4] = ACTIONS(1345),
    [aux_sym_INTEGER_token1] = ACTIONS(1345),
    [aux_sym_INTEGER_token2] = ACTIONS(1345),
    [aux_sym_INTEGER_token3] = ACTIONS(1347),
    [aux_sym_INTEGER_token4] = ACTIONS(1347),
    [anon_sym_DQUOTE] = ACTIONS(1345),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1345),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1347),
    [anon_sym_AT] = ACTIONS(1345),
  },
  [594] = {
    [ts_builtin_sym_end] = ACTIONS(1349),
    [anon_sym_COMMA] = ACTIONS(1349),
    [anon_sym_pub] = ACTIONS(1351),
    [anon_sym_test] = ACTIONS(1351),
    [anon_sym_comptime] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_extern] = ACTIONS(1351),
    [anon_sym_inline] = ACTIONS(1351),
    [anon_sym_noinline] = ACTIONS(1351),
    [anon_sym_threadlocal] = ACTIONS(1351),
    [anon_sym_usingnamespace] = ACTIONS(1351),
    [anon_sym_fn] = ACTIONS(1351),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_var] = ACTIONS(1351),
    [anon_sym_or] = ACTIONS(1351),
    [anon_sym_and] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1349),
    [anon_sym_RBRACE] = ACTIONS(1349),
    [anon_sym_async] = ACTIONS(1351),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_error] = ACTIONS(1351),
    [anon_sym_false] = ACTIONS(1351),
    [anon_sym_null] = ACTIONS(1351),
    [anon_sym_anyframe] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1351),
    [anon_sym_undefined] = ACTIONS(1351),
    [anon_sym_unreachable] = ACTIONS(1351),
    [sym_BuildinTypeExpr] = ACTIONS(1351),
    [anon_sym_packed] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_switch] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_PIPE] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_CARET] = ACTIONS(1349),
    [anon_sym_orelse] = ACTIONS(1351),
    [anon_sym_catch] = ACTIONS(1351),
    [anon_sym_LT_LT] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1349),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1349),
    [anon_sym_PLUS] = ACTIONS(1351),
    [anon_sym_DASH] = ACTIONS(1351),
    [anon_sym_PLUS_PLUS] = ACTIONS(1349),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1349),
    [anon_sym_DASH_PERCENT] = ACTIONS(1349),
    [anon_sym_PLUS_PIPE] = ACTIONS(1349),
    [anon_sym_DASH_PIPE] = ACTIONS(1349),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1349),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_STAR_PERCENT] = ACTIONS(1349),
    [anon_sym_STAR_PIPE] = ACTIONS(1349),
    [anon_sym_QMARK] = ACTIONS(1349),
    [anon_sym_DOT_STAR] = ACTIONS(1349),
    [anon_sym_DOT_QMARK] = ACTIONS(1349),
    [anon_sym_struct] = ACTIONS(1351),
    [anon_sym_opaque] = ACTIONS(1351),
    [anon_sym_enum] = ACTIONS(1351),
    [anon_sym_union] = ACTIONS(1351),
    [sym_doc_comment] = ACTIONS(1349),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1349),
    [aux_sym_FLOAT_token1] = ACTIONS(1349),
    [aux_sym_FLOAT_token2] = ACTIONS(1349),
    [aux_sym_FLOAT_token3] = ACTIONS(1349),
    [aux_sym_FLOAT_token4] = ACTIONS(1349),
    [aux_sym_INTEGER_token1] = ACTIONS(1349),
    [aux_sym_INTEGER_token2] = ACTIONS(1349),
    [aux_sym_INTEGER_token3] = ACTIONS(1351),
    [aux_sym_INTEGER_token4] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1349),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1349),
  },
  [595] = {
    [ts_builtin_sym_end] = ACTIONS(1353),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_pub] = ACTIONS(1355),
    [anon_sym_test] = ACTIONS(1355),
    [anon_sym_comptime] = ACTIONS(1355),
    [anon_sym_export] = ACTIONS(1355),
    [anon_sym_extern] = ACTIONS(1355),
    [anon_sym_inline] = ACTIONS(1355),
    [anon_sym_noinline] = ACTIONS(1355),
    [anon_sym_threadlocal] = ACTIONS(1355),
    [anon_sym_usingnamespace] = ACTIONS(1355),
    [anon_sym_fn] = ACTIONS(1355),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_const] = ACTIONS(1355),
    [anon_sym_var] = ACTIONS(1355),
    [anon_sym_or] = ACTIONS(1355),
    [anon_sym_and] = ACTIONS(1355),
    [anon_sym_LBRACE] = ACTIONS(1353),
    [anon_sym_RBRACE] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_DOT] = ACTIONS(1355),
    [anon_sym_error] = ACTIONS(1355),
    [anon_sym_false] = ACTIONS(1355),
    [anon_sym_null] = ACTIONS(1355),
    [anon_sym_anyframe] = ACTIONS(1355),
    [anon_sym_true] = ACTIONS(1355),
    [anon_sym_undefined] = ACTIONS(1355),
    [anon_sym_unreachable] = ACTIONS(1355),
    [sym_BuildinTypeExpr] = ACTIONS(1355),
    [anon_sym_packed] = ACTIONS(1355),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_switch] = ACTIONS(1355),
    [anon_sym_LBRACK] = ACTIONS(1353),
    [anon_sym_if] = ACTIONS(1355),
    [anon_sym_while] = ACTIONS(1355),
    [anon_sym_for] = ACTIONS(1355),
    [anon_sym_PIPE] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1355),
    [anon_sym_EQ_EQ] = ACTIONS(1353),
    [anon_sym_BANG_EQ] = ACTIONS(1353),
    [anon_sym_LT] = ACTIONS(1355),
    [anon_sym_GT] = ACTIONS(1355),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT_EQ] = ACTIONS(1353),
    [anon_sym_AMP] = ACTIONS(1353),
    [anon_sym_CARET] = ACTIONS(1353),
    [anon_sym_orelse] = ACTIONS(1355),
    [anon_sym_catch] = ACTIONS(1355),
    [anon_sym_LT_LT] = ACTIONS(1355),
    [anon_sym_GT_GT] = ACTIONS(1353),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1353),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_PLUS_PLUS] = ACTIONS(1353),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1353),
    [anon_sym_DASH_PERCENT] = ACTIONS(1353),
    [anon_sym_PLUS_PIPE] = ACTIONS(1353),
    [anon_sym_DASH_PIPE] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1353),
    [anon_sym_SLASH] = ACTIONS(1355),
    [anon_sym_PERCENT] = ACTIONS(1353),
    [anon_sym_STAR_STAR] = ACTIONS(1353),
    [anon_sym_STAR_PERCENT] = ACTIONS(1353),
    [anon_sym_STAR_PIPE] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_DOT_STAR] = ACTIONS(1353),
    [anon_sym_DOT_QMARK] = ACTIONS(1353),
    [anon_sym_struct] = ACTIONS(1355),
    [anon_sym_opaque] = ACTIONS(1355),
    [anon_sym_enum] = ACTIONS(1355),
    [anon_sym_union] = ACTIONS(1355),
    [sym_doc_comment] = ACTIONS(1353),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1353),
    [aux_sym_FLOAT_token1] = ACTIONS(1353),
    [aux_sym_FLOAT_token2] = ACTIONS(1353),
    [aux_sym_FLOAT_token3] = ACTIONS(1353),
    [aux_sym_FLOAT_token4] = ACTIONS(1353),
    [aux_sym_INTEGER_token1] = ACTIONS(1353),
    [aux_sym_INTEGER_token2] = ACTIONS(1353),
    [aux_sym_INTEGER_token3] = ACTIONS(1355),
    [aux_sym_INTEGER_token4] = ACTIONS(1355),
    [anon_sym_DQUOTE] = ACTIONS(1353),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1353),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1355),
    [anon_sym_AT] = ACTIONS(1353),
  },
  [596] = {
    [ts_builtin_sym_end] = ACTIONS(1357),
    [anon_sym_COMMA] = ACTIONS(1357),
    [anon_sym_pub] = ACTIONS(1359),
    [anon_sym_test] = ACTIONS(1359),
    [anon_sym_comptime] = ACTIONS(1359),
    [anon_sym_export] = ACTIONS(1359),
    [anon_sym_extern] = ACTIONS(1359),
    [anon_sym_inline] = ACTIONS(1359),
    [anon_sym_noinline] = ACTIONS(1359),
    [anon_sym_threadlocal] = ACTIONS(1359),
    [anon_sym_usingnamespace] = ACTIONS(1359),
    [anon_sym_fn] = ACTIONS(1359),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_const] = ACTIONS(1359),
    [anon_sym_var] = ACTIONS(1359),
    [anon_sym_or] = ACTIONS(1359),
    [anon_sym_and] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(1357),
    [anon_sym_RBRACE] = ACTIONS(1357),
    [anon_sym_async] = ACTIONS(1359),
    [anon_sym_DOT] = ACTIONS(1359),
    [anon_sym_error] = ACTIONS(1359),
    [anon_sym_false] = ACTIONS(1359),
    [anon_sym_null] = ACTIONS(1359),
    [anon_sym_anyframe] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(1359),
    [anon_sym_undefined] = ACTIONS(1359),
    [anon_sym_unreachable] = ACTIONS(1359),
    [sym_BuildinTypeExpr] = ACTIONS(1359),
    [anon_sym_packed] = ACTIONS(1359),
    [anon_sym_LPAREN] = ACTIONS(1357),
    [anon_sym_switch] = ACTIONS(1359),
    [anon_sym_LBRACK] = ACTIONS(1357),
    [anon_sym_if] = ACTIONS(1359),
    [anon_sym_while] = ACTIONS(1359),
    [anon_sym_for] = ACTIONS(1359),
    [anon_sym_PIPE] = ACTIONS(1359),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_EQ_EQ] = ACTIONS(1357),
    [anon_sym_BANG_EQ] = ACTIONS(1357),
    [anon_sym_LT] = ACTIONS(1359),
    [anon_sym_GT] = ACTIONS(1359),
    [anon_sym_LT_EQ] = ACTIONS(1357),
    [anon_sym_GT_EQ] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_CARET] = ACTIONS(1357),
    [anon_sym_orelse] = ACTIONS(1359),
    [anon_sym_catch] = ACTIONS(1359),
    [anon_sym_LT_LT] = ACTIONS(1359),
    [anon_sym_GT_GT] = ACTIONS(1357),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1357),
    [anon_sym_PLUS] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1357),
    [anon_sym_DASH_PERCENT] = ACTIONS(1357),
    [anon_sym_PLUS_PIPE] = ACTIONS(1357),
    [anon_sym_DASH_PIPE] = ACTIONS(1357),
    [anon_sym_PIPE_PIPE] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1359),
    [anon_sym_PERCENT] = ACTIONS(1357),
    [anon_sym_STAR_STAR] = ACTIONS(1357),
    [anon_sym_STAR_PERCENT] = ACTIONS(1357),
    [anon_sym_STAR_PIPE] = ACTIONS(1357),
    [anon_sym_QMARK] = ACTIONS(1357),
    [anon_sym_DOT_STAR] = ACTIONS(1357),
    [anon_sym_DOT_QMARK] = ACTIONS(1357),
    [anon_sym_struct] = ACTIONS(1359),
    [anon_sym_opaque] = ACTIONS(1359),
    [anon_sym_enum] = ACTIONS(1359),
    [anon_sym_union] = ACTIONS(1359),
    [sym_doc_comment] = ACTIONS(1357),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1357),
    [aux_sym_FLOAT_token1] = ACTIONS(1357),
    [aux_sym_FLOAT_token2] = ACTIONS(1357),
    [aux_sym_FLOAT_token3] = ACTIONS(1357),
    [aux_sym_FLOAT_token4] = ACTIONS(1357),
    [aux_sym_INTEGER_token1] = ACTIONS(1357),
    [aux_sym_INTEGER_token2] = ACTIONS(1357),
    [aux_sym_INTEGER_token3] = ACTIONS(1359),
    [aux_sym_INTEGER_token4] = ACTIONS(1359),
    [anon_sym_DQUOTE] = ACTIONS(1357),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1357),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1359),
    [anon_sym_AT] = ACTIONS(1357),
  },
  [597] = {
    [ts_builtin_sym_end] = ACTIONS(1365),
    [anon_sym_COMMA] = ACTIONS(1365),
    [anon_sym_pub] = ACTIONS(1367),
    [anon_sym_test] = ACTIONS(1367),
    [anon_sym_comptime] = ACTIONS(1367),
    [anon_sym_export] = ACTIONS(1367),
    [anon_sym_extern] = ACTIONS(1367),
    [anon_sym_inline] = ACTIONS(1367),
    [anon_sym_noinline] = ACTIONS(1367),
    [anon_sym_threadlocal] = ACTIONS(1367),
    [anon_sym_usingnamespace] = ACTIONS(1367),
    [anon_sym_fn] = ACTIONS(1367),
    [anon_sym_BANG] = ACTIONS(1367),
    [anon_sym_const] = ACTIONS(1367),
    [anon_sym_var] = ACTIONS(1367),
    [anon_sym_or] = ACTIONS(1367),
    [anon_sym_and] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(1365),
    [anon_sym_RBRACE] = ACTIONS(1365),
    [anon_sym_async] = ACTIONS(1367),
    [anon_sym_DOT] = ACTIONS(1367),
    [anon_sym_error] = ACTIONS(1367),
    [anon_sym_false] = ACTIONS(1367),
    [anon_sym_null] = ACTIONS(1367),
    [anon_sym_anyframe] = ACTIONS(1367),
    [anon_sym_true] = ACTIONS(1367),
    [anon_sym_undefined] = ACTIONS(1367),
    [anon_sym_unreachable] = ACTIONS(1367),
    [sym_BuildinTypeExpr] = ACTIONS(1367),
    [anon_sym_packed] = ACTIONS(1367),
    [anon_sym_LPAREN] = ACTIONS(1365),
    [anon_sym_switch] = ACTIONS(1367),
    [anon_sym_LBRACK] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(1367),
    [anon_sym_while] = ACTIONS(1367),
    [anon_sym_for] = ACTIONS(1367),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_EQ_EQ] = ACTIONS(1365),
    [anon_sym_BANG_EQ] = ACTIONS(1365),
    [anon_sym_LT] = ACTIONS(1367),
    [anon_sym_GT] = ACTIONS(1367),
    [anon_sym_LT_EQ] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_CARET] = ACTIONS(1365),
    [anon_sym_orelse] = ACTIONS(1367),
    [anon_sym_catch] = ACTIONS(1367),
    [anon_sym_LT_LT] = ACTIONS(1367),
    [anon_sym_GT_GT] = ACTIONS(1365),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1365),
    [anon_sym_PLUS] = ACTIONS(1367),
    [anon_sym_DASH] = ACTIONS(1367),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1365),
    [anon_sym_DASH_PERCENT] = ACTIONS(1365),
    [anon_sym_PLUS_PIPE] = ACTIONS(1365),
    [anon_sym_DASH_PIPE] = ACTIONS(1365),
    [anon_sym_PIPE_PIPE] = ACTIONS(1365),
    [anon_sym_SLASH] = ACTIONS(1367),
    [anon_sym_PERCENT] = ACTIONS(1365),
    [anon_sym_STAR_STAR] = ACTIONS(1365),
    [anon_sym_STAR_PERCENT] = ACTIONS(1365),
    [anon_sym_STAR_PIPE] = ACTIONS(1365),
    [anon_sym_QMARK] = ACTIONS(1365),
    [anon_sym_DOT_STAR] = ACTIONS(1365),
    [anon_sym_DOT_QMARK] = ACTIONS(1365),
    [anon_sym_struct] = ACTIONS(1367),
    [anon_sym_opaque] = ACTIONS(1367),
    [anon_sym_enum] = ACTIONS(1367),
    [anon_sym_union] = ACTIONS(1367),
    [sym_doc_comment] = ACTIONS(1365),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1365),
    [aux_sym_FLOAT_token1] = ACTIONS(1365),
    [aux_sym_FLOAT_token2] = ACTIONS(1365),
    [aux_sym_FLOAT_token3] = ACTIONS(1365),
    [aux_sym_FLOAT_token4] = ACTIONS(1365),
    [aux_sym_INTEGER_token1] = ACTIONS(1365),
    [aux_sym_INTEGER_token2] = ACTIONS(1365),
    [aux_sym_INTEGER_token3] = ACTIONS(1367),
    [aux_sym_INTEGER_token4] = ACTIONS(1367),
    [anon_sym_DQUOTE] = ACTIONS(1365),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1365),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1367),
    [anon_sym_AT] = ACTIONS(1365),
  },
  [598] = {
    [ts_builtin_sym_end] = ACTIONS(1369),
    [anon_sym_COMMA] = ACTIONS(1369),
    [anon_sym_pub] = ACTIONS(1371),
    [anon_sym_test] = ACTIONS(1371),
    [anon_sym_comptime] = ACTIONS(1371),
    [anon_sym_export] = ACTIONS(1371),
    [anon_sym_extern] = ACTIONS(1371),
    [anon_sym_inline] = ACTIONS(1371),
    [anon_sym_noinline] = ACTIONS(1371),
    [anon_sym_threadlocal] = ACTIONS(1371),
    [anon_sym_usingnamespace] = ACTIONS(1371),
    [anon_sym_fn] = ACTIONS(1371),
    [anon_sym_BANG] = ACTIONS(1371),
    [anon_sym_const] = ACTIONS(1371),
    [anon_sym_var] = ACTIONS(1371),
    [anon_sym_or] = ACTIONS(1371),
    [anon_sym_and] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(1369),
    [anon_sym_RBRACE] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1371),
    [anon_sym_DOT] = ACTIONS(1371),
    [anon_sym_error] = ACTIONS(1371),
    [anon_sym_false] = ACTIONS(1371),
    [anon_sym_null] = ACTIONS(1371),
    [anon_sym_anyframe] = ACTIONS(1371),
    [anon_sym_true] = ACTIONS(1371),
    [anon_sym_undefined] = ACTIONS(1371),
    [anon_sym_unreachable] = ACTIONS(1371),
    [sym_BuildinTypeExpr] = ACTIONS(1371),
    [anon_sym_packed] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1369),
    [anon_sym_switch] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(1369),
    [anon_sym_if] = ACTIONS(1371),
    [anon_sym_while] = ACTIONS(1371),
    [anon_sym_for] = ACTIONS(1371),
    [anon_sym_PIPE] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_EQ_EQ] = ACTIONS(1369),
    [anon_sym_BANG_EQ] = ACTIONS(1369),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(1371),
    [anon_sym_LT_EQ] = ACTIONS(1369),
    [anon_sym_GT_EQ] = ACTIONS(1369),
    [anon_sym_AMP] = ACTIONS(1369),
    [anon_sym_CARET] = ACTIONS(1369),
    [anon_sym_orelse] = ACTIONS(1371),
    [anon_sym_catch] = ACTIONS(1371),
    [anon_sym_LT_LT] = ACTIONS(1371),
    [anon_sym_GT_GT] = ACTIONS(1369),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1369),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_PLUS_PLUS] = ACTIONS(1369),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1369),
    [anon_sym_DASH_PERCENT] = ACTIONS(1369),
    [anon_sym_PLUS_PIPE] = ACTIONS(1369),
    [anon_sym_DASH_PIPE] = ACTIONS(1369),
    [anon_sym_PIPE_PIPE] = ACTIONS(1369),
    [anon_sym_SLASH] = ACTIONS(1371),
    [anon_sym_PERCENT] = ACTIONS(1369),
    [anon_sym_STAR_STAR] = ACTIONS(1369),
    [anon_sym_STAR_PERCENT] = ACTIONS(1369),
    [anon_sym_STAR_PIPE] = ACTIONS(1369),
    [anon_sym_QMARK] = ACTIONS(1369),
    [anon_sym_DOT_STAR] = ACTIONS(1369),
    [anon_sym_DOT_QMARK] = ACTIONS(1369),
    [anon_sym_struct] = ACTIONS(1371),
    [anon_sym_opaque] = ACTIONS(1371),
    [anon_sym_enum] = ACTIONS(1371),
    [anon_sym_union] = ACTIONS(1371),
    [sym_doc_comment] = ACTIONS(1369),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1369),
    [aux_sym_FLOAT_token1] = ACTIONS(1369),
    [aux_sym_FLOAT_token2] = ACTIONS(1369),
    [aux_sym_FLOAT_token3] = ACTIONS(1369),
    [aux_sym_FLOAT_token4] = ACTIONS(1369),
    [aux_sym_INTEGER_token1] = ACTIONS(1369),
    [aux_sym_INTEGER_token2] = ACTIONS(1369),
    [aux_sym_INTEGER_token3] = ACTIONS(1371),
    [aux_sym_INTEGER_token4] = ACTIONS(1371),
    [anon_sym_DQUOTE] = ACTIONS(1369),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1369),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1371),
    [anon_sym_AT] = ACTIONS(1369),
  },
  [599] = {
    [ts_builtin_sym_end] = ACTIONS(1373),
    [anon_sym_COMMA] = ACTIONS(1373),
    [anon_sym_pub] = ACTIONS(1375),
    [anon_sym_test] = ACTIONS(1375),
    [anon_sym_comptime] = ACTIONS(1375),
    [anon_sym_export] = ACTIONS(1375),
    [anon_sym_extern] = ACTIONS(1375),
    [anon_sym_inline] = ACTIONS(1375),
    [anon_sym_noinline] = ACTIONS(1375),
    [anon_sym_threadlocal] = ACTIONS(1375),
    [anon_sym_usingnamespace] = ACTIONS(1375),
    [anon_sym_fn] = ACTIONS(1375),
    [anon_sym_BANG] = ACTIONS(1375),
    [anon_sym_const] = ACTIONS(1375),
    [anon_sym_var] = ACTIONS(1375),
    [anon_sym_or] = ACTIONS(1375),
    [anon_sym_and] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(1373),
    [anon_sym_RBRACE] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_DOT] = ACTIONS(1375),
    [anon_sym_error] = ACTIONS(1375),
    [anon_sym_false] = ACTIONS(1375),
    [anon_sym_null] = ACTIONS(1375),
    [anon_sym_anyframe] = ACTIONS(1375),
    [anon_sym_true] = ACTIONS(1375),
    [anon_sym_undefined] = ACTIONS(1375),
    [anon_sym_unreachable] = ACTIONS(1375),
    [sym_BuildinTypeExpr] = ACTIONS(1375),
    [anon_sym_packed] = ACTIONS(1375),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_switch] = ACTIONS(1375),
    [anon_sym_LBRACK] = ACTIONS(1373),
    [anon_sym_if] = ACTIONS(1375),
    [anon_sym_while] = ACTIONS(1375),
    [anon_sym_for] = ACTIONS(1375),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_EQ_EQ] = ACTIONS(1373),
    [anon_sym_BANG_EQ] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_LT_EQ] = ACTIONS(1373),
    [anon_sym_GT_EQ] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_CARET] = ACTIONS(1373),
    [anon_sym_orelse] = ACTIONS(1375),
    [anon_sym_catch] = ACTIONS(1375),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1373),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1373),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_DASH] = ACTIONS(1375),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1373),
    [anon_sym_DASH_PERCENT] = ACTIONS(1373),
    [anon_sym_PLUS_PIPE] = ACTIONS(1373),
    [anon_sym_DASH_PIPE] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_SLASH] = ACTIONS(1375),
    [anon_sym_PERCENT] = ACTIONS(1373),
    [anon_sym_STAR_STAR] = ACTIONS(1373),
    [anon_sym_STAR_PERCENT] = ACTIONS(1373),
    [anon_sym_STAR_PIPE] = ACTIONS(1373),
    [anon_sym_QMARK] = ACTIONS(1373),
    [anon_sym_DOT_STAR] = ACTIONS(1373),
    [anon_sym_DOT_QMARK] = ACTIONS(1373),
    [anon_sym_struct] = ACTIONS(1375),
    [anon_sym_opaque] = ACTIONS(1375),
    [anon_sym_enum] = ACTIONS(1375),
    [anon_sym_union] = ACTIONS(1375),
    [sym_doc_comment] = ACTIONS(1373),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1373),
    [aux_sym_FLOAT_token1] = ACTIONS(1373),
    [aux_sym_FLOAT_token2] = ACTIONS(1373),
    [aux_sym_FLOAT_token3] = ACTIONS(1373),
    [aux_sym_FLOAT_token4] = ACTIONS(1373),
    [aux_sym_INTEGER_token1] = ACTIONS(1373),
    [aux_sym_INTEGER_token2] = ACTIONS(1373),
    [aux_sym_INTEGER_token3] = ACTIONS(1375),
    [aux_sym_INTEGER_token4] = ACTIONS(1375),
    [anon_sym_DQUOTE] = ACTIONS(1373),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1373),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(1373),
  },
  [600] = {
    [ts_builtin_sym_end] = ACTIONS(1377),
    [anon_sym_COMMA] = ACTIONS(1377),
    [anon_sym_pub] = ACTIONS(1379),
    [anon_sym_test] = ACTIONS(1379),
    [anon_sym_comptime] = ACTIONS(1379),
    [anon_sym_export] = ACTIONS(1379),
    [anon_sym_extern] = ACTIONS(1379),
    [anon_sym_inline] = ACTIONS(1379),
    [anon_sym_noinline] = ACTIONS(1379),
    [anon_sym_threadlocal] = ACTIONS(1379),
    [anon_sym_usingnamespace] = ACTIONS(1379),
    [anon_sym_fn] = ACTIONS(1379),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_const] = ACTIONS(1379),
    [anon_sym_var] = ACTIONS(1379),
    [anon_sym_or] = ACTIONS(1379),
    [anon_sym_and] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_RBRACE] = ACTIONS(1377),
    [anon_sym_async] = ACTIONS(1379),
    [anon_sym_DOT] = ACTIONS(1379),
    [anon_sym_error] = ACTIONS(1379),
    [anon_sym_false] = ACTIONS(1379),
    [anon_sym_null] = ACTIONS(1379),
    [anon_sym_anyframe] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(1379),
    [anon_sym_undefined] = ACTIONS(1379),
    [anon_sym_unreachable] = ACTIONS(1379),
    [sym_BuildinTypeExpr] = ACTIONS(1379),
    [anon_sym_packed] = ACTIONS(1379),
    [anon_sym_LPAREN] = ACTIONS(1377),
    [anon_sym_switch] = ACTIONS(1379),
    [anon_sym_LBRACK] = ACTIONS(1377),
    [anon_sym_if] = ACTIONS(1379),
    [anon_sym_while] = ACTIONS(1379),
    [anon_sym_for] = ACTIONS(1379),
    [anon_sym_PIPE] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_EQ_EQ] = ACTIONS(1377),
    [anon_sym_BANG_EQ] = ACTIONS(1377),
    [anon_sym_LT] = ACTIONS(1379),
    [anon_sym_GT] = ACTIONS(1379),
    [anon_sym_LT_EQ] = ACTIONS(1377),
    [anon_sym_GT_EQ] = ACTIONS(1377),
    [anon_sym_AMP] = ACTIONS(1377),
    [anon_sym_CARET] = ACTIONS(1377),
    [anon_sym_orelse] = ACTIONS(1379),
    [anon_sym_catch] = ACTIONS(1379),
    [anon_sym_LT_LT] = ACTIONS(1379),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1377),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1377),
    [anon_sym_DASH_PERCENT] = ACTIONS(1377),
    [anon_sym_PLUS_PIPE] = ACTIONS(1377),
    [anon_sym_DASH_PIPE] = ACTIONS(1377),
    [anon_sym_PIPE_PIPE] = ACTIONS(1377),
    [anon_sym_SLASH] = ACTIONS(1379),
    [anon_sym_PERCENT] = ACTIONS(1377),
    [anon_sym_STAR_STAR] = ACTIONS(1377),
    [anon_sym_STAR_PERCENT] = ACTIONS(1377),
    [anon_sym_STAR_PIPE] = ACTIONS(1377),
    [anon_sym_QMARK] = ACTIONS(1377),
    [anon_sym_DOT_STAR] = ACTIONS(1377),
    [anon_sym_DOT_QMARK] = ACTIONS(1377),
    [anon_sym_struct] = ACTIONS(1379),
    [anon_sym_opaque] = ACTIONS(1379),
    [anon_sym_enum] = ACTIONS(1379),
    [anon_sym_union] = ACTIONS(1379),
    [sym_doc_comment] = ACTIONS(1377),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1377),
    [aux_sym_FLOAT_token1] = ACTIONS(1377),
    [aux_sym_FLOAT_token2] = ACTIONS(1377),
    [aux_sym_FLOAT_token3] = ACTIONS(1377),
    [aux_sym_FLOAT_token4] = ACTIONS(1377),
    [aux_sym_INTEGER_token1] = ACTIONS(1377),
    [aux_sym_INTEGER_token2] = ACTIONS(1377),
    [aux_sym_INTEGER_token3] = ACTIONS(1379),
    [aux_sym_INTEGER_token4] = ACTIONS(1379),
    [anon_sym_DQUOTE] = ACTIONS(1377),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1377),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1379),
    [anon_sym_AT] = ACTIONS(1377),
  },
  [601] = {
    [ts_builtin_sym_end] = ACTIONS(1381),
    [anon_sym_COMMA] = ACTIONS(1381),
    [anon_sym_pub] = ACTIONS(1383),
    [anon_sym_test] = ACTIONS(1383),
    [anon_sym_comptime] = ACTIONS(1383),
    [anon_sym_export] = ACTIONS(1383),
    [anon_sym_extern] = ACTIONS(1383),
    [anon_sym_inline] = ACTIONS(1383),
    [anon_sym_noinline] = ACTIONS(1383),
    [anon_sym_threadlocal] = ACTIONS(1383),
    [anon_sym_usingnamespace] = ACTIONS(1383),
    [anon_sym_fn] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_const] = ACTIONS(1383),
    [anon_sym_var] = ACTIONS(1383),
    [anon_sym_or] = ACTIONS(1383),
    [anon_sym_and] = ACTIONS(1383),
    [anon_sym_LBRACE] = ACTIONS(1381),
    [anon_sym_RBRACE] = ACTIONS(1381),
    [anon_sym_async] = ACTIONS(1383),
    [anon_sym_DOT] = ACTIONS(1383),
    [anon_sym_error] = ACTIONS(1383),
    [anon_sym_false] = ACTIONS(1383),
    [anon_sym_null] = ACTIONS(1383),
    [anon_sym_anyframe] = ACTIONS(1383),
    [anon_sym_true] = ACTIONS(1383),
    [anon_sym_undefined] = ACTIONS(1383),
    [anon_sym_unreachable] = ACTIONS(1383),
    [sym_BuildinTypeExpr] = ACTIONS(1383),
    [anon_sym_packed] = ACTIONS(1383),
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_switch] = ACTIONS(1383),
    [anon_sym_LBRACK] = ACTIONS(1381),
    [anon_sym_if] = ACTIONS(1383),
    [anon_sym_while] = ACTIONS(1383),
    [anon_sym_for] = ACTIONS(1383),
    [anon_sym_PIPE] = ACTIONS(1383),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_EQ_EQ] = ACTIONS(1381),
    [anon_sym_BANG_EQ] = ACTIONS(1381),
    [anon_sym_LT] = ACTIONS(1383),
    [anon_sym_GT] = ACTIONS(1383),
    [anon_sym_LT_EQ] = ACTIONS(1381),
    [anon_sym_GT_EQ] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_orelse] = ACTIONS(1383),
    [anon_sym_catch] = ACTIONS(1383),
    [anon_sym_LT_LT] = ACTIONS(1383),
    [anon_sym_GT_GT] = ACTIONS(1381),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1381),
    [anon_sym_PLUS] = ACTIONS(1383),
    [anon_sym_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1381),
    [anon_sym_DASH_PERCENT] = ACTIONS(1381),
    [anon_sym_PLUS_PIPE] = ACTIONS(1381),
    [anon_sym_DASH_PIPE] = ACTIONS(1381),
    [anon_sym_PIPE_PIPE] = ACTIONS(1381),
    [anon_sym_SLASH] = ACTIONS(1383),
    [anon_sym_PERCENT] = ACTIONS(1381),
    [anon_sym_STAR_STAR] = ACTIONS(1381),
    [anon_sym_STAR_PERCENT] = ACTIONS(1381),
    [anon_sym_STAR_PIPE] = ACTIONS(1381),
    [anon_sym_QMARK] = ACTIONS(1381),
    [anon_sym_DOT_STAR] = ACTIONS(1381),
    [anon_sym_DOT_QMARK] = ACTIONS(1381),
    [anon_sym_struct] = ACTIONS(1383),
    [anon_sym_opaque] = ACTIONS(1383),
    [anon_sym_enum] = ACTIONS(1383),
    [anon_sym_union] = ACTIONS(1383),
    [sym_doc_comment] = ACTIONS(1381),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1381),
    [aux_sym_FLOAT_token1] = ACTIONS(1381),
    [aux_sym_FLOAT_token2] = ACTIONS(1381),
    [aux_sym_FLOAT_token3] = ACTIONS(1381),
    [aux_sym_FLOAT_token4] = ACTIONS(1381),
    [aux_sym_INTEGER_token1] = ACTIONS(1381),
    [aux_sym_INTEGER_token2] = ACTIONS(1381),
    [aux_sym_INTEGER_token3] = ACTIONS(1383),
    [aux_sym_INTEGER_token4] = ACTIONS(1383),
    [anon_sym_DQUOTE] = ACTIONS(1381),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1381),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1383),
    [anon_sym_AT] = ACTIONS(1381),
  },
  [602] = {
    [ts_builtin_sym_end] = ACTIONS(1385),
    [anon_sym_COMMA] = ACTIONS(1385),
    [anon_sym_pub] = ACTIONS(1387),
    [anon_sym_test] = ACTIONS(1387),
    [anon_sym_comptime] = ACTIONS(1387),
    [anon_sym_export] = ACTIONS(1387),
    [anon_sym_extern] = ACTIONS(1387),
    [anon_sym_inline] = ACTIONS(1387),
    [anon_sym_noinline] = ACTIONS(1387),
    [anon_sym_threadlocal] = ACTIONS(1387),
    [anon_sym_usingnamespace] = ACTIONS(1387),
    [anon_sym_fn] = ACTIONS(1387),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_const] = ACTIONS(1387),
    [anon_sym_var] = ACTIONS(1387),
    [anon_sym_or] = ACTIONS(1387),
    [anon_sym_and] = ACTIONS(1387),
    [anon_sym_LBRACE] = ACTIONS(1385),
    [anon_sym_RBRACE] = ACTIONS(1385),
    [anon_sym_async] = ACTIONS(1387),
    [anon_sym_DOT] = ACTIONS(1387),
    [anon_sym_error] = ACTIONS(1387),
    [anon_sym_false] = ACTIONS(1387),
    [anon_sym_null] = ACTIONS(1387),
    [anon_sym_anyframe] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1387),
    [anon_sym_undefined] = ACTIONS(1387),
    [anon_sym_unreachable] = ACTIONS(1387),
    [sym_BuildinTypeExpr] = ACTIONS(1387),
    [anon_sym_packed] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1385),
    [anon_sym_switch] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1385),
    [anon_sym_if] = ACTIONS(1387),
    [anon_sym_while] = ACTIONS(1387),
    [anon_sym_for] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_EQ_EQ] = ACTIONS(1385),
    [anon_sym_BANG_EQ] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_LT_EQ] = ACTIONS(1385),
    [anon_sym_GT_EQ] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1385),
    [anon_sym_CARET] = ACTIONS(1385),
    [anon_sym_orelse] = ACTIONS(1387),
    [anon_sym_catch] = ACTIONS(1387),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1385),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1385),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1385),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1385),
    [anon_sym_DASH_PERCENT] = ACTIONS(1385),
    [anon_sym_PLUS_PIPE] = ACTIONS(1385),
    [anon_sym_DASH_PIPE] = ACTIONS(1385),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1385),
    [anon_sym_STAR_STAR] = ACTIONS(1385),
    [anon_sym_STAR_PERCENT] = ACTIONS(1385),
    [anon_sym_STAR_PIPE] = ACTIONS(1385),
    [anon_sym_QMARK] = ACTIONS(1385),
    [anon_sym_DOT_STAR] = ACTIONS(1385),
    [anon_sym_DOT_QMARK] = ACTIONS(1385),
    [anon_sym_struct] = ACTIONS(1387),
    [anon_sym_opaque] = ACTIONS(1387),
    [anon_sym_enum] = ACTIONS(1387),
    [anon_sym_union] = ACTIONS(1387),
    [sym_doc_comment] = ACTIONS(1385),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1385),
    [aux_sym_FLOAT_token1] = ACTIONS(1385),
    [aux_sym_FLOAT_token2] = ACTIONS(1385),
    [aux_sym_FLOAT_token3] = ACTIONS(1385),
    [aux_sym_FLOAT_token4] = ACTIONS(1385),
    [aux_sym_INTEGER_token1] = ACTIONS(1385),
    [aux_sym_INTEGER_token2] = ACTIONS(1385),
    [aux_sym_INTEGER_token3] = ACTIONS(1387),
    [aux_sym_INTEGER_token4] = ACTIONS(1387),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1385),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1387),
    [anon_sym_AT] = ACTIONS(1385),
  },
  [603] = {
    [ts_builtin_sym_end] = ACTIONS(1389),
    [anon_sym_COMMA] = ACTIONS(1389),
    [anon_sym_pub] = ACTIONS(1391),
    [anon_sym_test] = ACTIONS(1391),
    [anon_sym_comptime] = ACTIONS(1391),
    [anon_sym_export] = ACTIONS(1391),
    [anon_sym_extern] = ACTIONS(1391),
    [anon_sym_inline] = ACTIONS(1391),
    [anon_sym_noinline] = ACTIONS(1391),
    [anon_sym_threadlocal] = ACTIONS(1391),
    [anon_sym_usingnamespace] = ACTIONS(1391),
    [anon_sym_fn] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1391),
    [anon_sym_const] = ACTIONS(1391),
    [anon_sym_var] = ACTIONS(1391),
    [anon_sym_or] = ACTIONS(1391),
    [anon_sym_and] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_RBRACE] = ACTIONS(1389),
    [anon_sym_async] = ACTIONS(1391),
    [anon_sym_DOT] = ACTIONS(1391),
    [anon_sym_error] = ACTIONS(1391),
    [anon_sym_false] = ACTIONS(1391),
    [anon_sym_null] = ACTIONS(1391),
    [anon_sym_anyframe] = ACTIONS(1391),
    [anon_sym_true] = ACTIONS(1391),
    [anon_sym_undefined] = ACTIONS(1391),
    [anon_sym_unreachable] = ACTIONS(1391),
    [sym_BuildinTypeExpr] = ACTIONS(1391),
    [anon_sym_packed] = ACTIONS(1391),
    [anon_sym_LPAREN] = ACTIONS(1389),
    [anon_sym_switch] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1389),
    [anon_sym_if] = ACTIONS(1391),
    [anon_sym_while] = ACTIONS(1391),
    [anon_sym_for] = ACTIONS(1391),
    [anon_sym_PIPE] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_EQ_EQ] = ACTIONS(1389),
    [anon_sym_BANG_EQ] = ACTIONS(1389),
    [anon_sym_LT] = ACTIONS(1391),
    [anon_sym_GT] = ACTIONS(1391),
    [anon_sym_LT_EQ] = ACTIONS(1389),
    [anon_sym_GT_EQ] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1389),
    [anon_sym_CARET] = ACTIONS(1389),
    [anon_sym_orelse] = ACTIONS(1391),
    [anon_sym_catch] = ACTIONS(1391),
    [anon_sym_LT_LT] = ACTIONS(1391),
    [anon_sym_GT_GT] = ACTIONS(1389),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1389),
    [anon_sym_PLUS] = ACTIONS(1391),
    [anon_sym_DASH] = ACTIONS(1391),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1389),
    [anon_sym_DASH_PERCENT] = ACTIONS(1389),
    [anon_sym_PLUS_PIPE] = ACTIONS(1389),
    [anon_sym_DASH_PIPE] = ACTIONS(1389),
    [anon_sym_PIPE_PIPE] = ACTIONS(1389),
    [anon_sym_SLASH] = ACTIONS(1391),
    [anon_sym_PERCENT] = ACTIONS(1389),
    [anon_sym_STAR_STAR] = ACTIONS(1389),
    [anon_sym_STAR_PERCENT] = ACTIONS(1389),
    [anon_sym_STAR_PIPE] = ACTIONS(1389),
    [anon_sym_QMARK] = ACTIONS(1389),
    [anon_sym_DOT_STAR] = ACTIONS(1389),
    [anon_sym_DOT_QMARK] = ACTIONS(1389),
    [anon_sym_struct] = ACTIONS(1391),
    [anon_sym_opaque] = ACTIONS(1391),
    [anon_sym_enum] = ACTIONS(1391),
    [anon_sym_union] = ACTIONS(1391),
    [sym_doc_comment] = ACTIONS(1389),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1389),
    [aux_sym_FLOAT_token1] = ACTIONS(1389),
    [aux_sym_FLOAT_token2] = ACTIONS(1389),
    [aux_sym_FLOAT_token3] = ACTIONS(1389),
    [aux_sym_FLOAT_token4] = ACTIONS(1389),
    [aux_sym_INTEGER_token1] = ACTIONS(1389),
    [aux_sym_INTEGER_token2] = ACTIONS(1389),
    [aux_sym_INTEGER_token3] = ACTIONS(1391),
    [aux_sym_INTEGER_token4] = ACTIONS(1391),
    [anon_sym_DQUOTE] = ACTIONS(1389),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1389),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1391),
    [anon_sym_AT] = ACTIONS(1389),
  },
  [604] = {
    [ts_builtin_sym_end] = ACTIONS(1393),
    [anon_sym_COMMA] = ACTIONS(1393),
    [anon_sym_pub] = ACTIONS(1395),
    [anon_sym_test] = ACTIONS(1395),
    [anon_sym_comptime] = ACTIONS(1395),
    [anon_sym_export] = ACTIONS(1395),
    [anon_sym_extern] = ACTIONS(1395),
    [anon_sym_inline] = ACTIONS(1395),
    [anon_sym_noinline] = ACTIONS(1395),
    [anon_sym_threadlocal] = ACTIONS(1395),
    [anon_sym_usingnamespace] = ACTIONS(1395),
    [anon_sym_fn] = ACTIONS(1395),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_const] = ACTIONS(1395),
    [anon_sym_var] = ACTIONS(1395),
    [anon_sym_or] = ACTIONS(1395),
    [anon_sym_and] = ACTIONS(1395),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_RBRACE] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_DOT] = ACTIONS(1395),
    [anon_sym_error] = ACTIONS(1395),
    [anon_sym_false] = ACTIONS(1395),
    [anon_sym_null] = ACTIONS(1395),
    [anon_sym_anyframe] = ACTIONS(1395),
    [anon_sym_true] = ACTIONS(1395),
    [anon_sym_undefined] = ACTIONS(1395),
    [anon_sym_unreachable] = ACTIONS(1395),
    [sym_BuildinTypeExpr] = ACTIONS(1395),
    [anon_sym_packed] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_switch] = ACTIONS(1395),
    [anon_sym_LBRACK] = ACTIONS(1393),
    [anon_sym_if] = ACTIONS(1395),
    [anon_sym_while] = ACTIONS(1395),
    [anon_sym_for] = ACTIONS(1395),
    [anon_sym_PIPE] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(1395),
    [anon_sym_EQ_EQ] = ACTIONS(1393),
    [anon_sym_BANG_EQ] = ACTIONS(1393),
    [anon_sym_LT] = ACTIONS(1395),
    [anon_sym_GT] = ACTIONS(1395),
    [anon_sym_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1393),
    [anon_sym_CARET] = ACTIONS(1393),
    [anon_sym_orelse] = ACTIONS(1395),
    [anon_sym_catch] = ACTIONS(1395),
    [anon_sym_LT_LT] = ACTIONS(1395),
    [anon_sym_GT_GT] = ACTIONS(1393),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1393),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_DASH] = ACTIONS(1395),
    [anon_sym_PLUS_PLUS] = ACTIONS(1393),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1393),
    [anon_sym_DASH_PERCENT] = ACTIONS(1393),
    [anon_sym_PLUS_PIPE] = ACTIONS(1393),
    [anon_sym_DASH_PIPE] = ACTIONS(1393),
    [anon_sym_PIPE_PIPE] = ACTIONS(1393),
    [anon_sym_SLASH] = ACTIONS(1395),
    [anon_sym_PERCENT] = ACTIONS(1393),
    [anon_sym_STAR_STAR] = ACTIONS(1393),
    [anon_sym_STAR_PERCENT] = ACTIONS(1393),
    [anon_sym_STAR_PIPE] = ACTIONS(1393),
    [anon_sym_QMARK] = ACTIONS(1393),
    [anon_sym_DOT_STAR] = ACTIONS(1393),
    [anon_sym_DOT_QMARK] = ACTIONS(1393),
    [anon_sym_struct] = ACTIONS(1395),
    [anon_sym_opaque] = ACTIONS(1395),
    [anon_sym_enum] = ACTIONS(1395),
    [anon_sym_union] = ACTIONS(1395),
    [sym_doc_comment] = ACTIONS(1393),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1393),
    [aux_sym_FLOAT_token1] = ACTIONS(1393),
    [aux_sym_FLOAT_token2] = ACTIONS(1393),
    [aux_sym_FLOAT_token3] = ACTIONS(1393),
    [aux_sym_FLOAT_token4] = ACTIONS(1393),
    [aux_sym_INTEGER_token1] = ACTIONS(1393),
    [aux_sym_INTEGER_token2] = ACTIONS(1393),
    [aux_sym_INTEGER_token3] = ACTIONS(1395),
    [aux_sym_INTEGER_token4] = ACTIONS(1395),
    [anon_sym_DQUOTE] = ACTIONS(1393),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1393),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1395),
    [anon_sym_AT] = ACTIONS(1393),
  },
  [605] = {
    [ts_builtin_sym_end] = ACTIONS(1397),
    [anon_sym_COMMA] = ACTIONS(1397),
    [anon_sym_pub] = ACTIONS(1399),
    [anon_sym_test] = ACTIONS(1399),
    [anon_sym_comptime] = ACTIONS(1399),
    [anon_sym_export] = ACTIONS(1399),
    [anon_sym_extern] = ACTIONS(1399),
    [anon_sym_inline] = ACTIONS(1399),
    [anon_sym_noinline] = ACTIONS(1399),
    [anon_sym_threadlocal] = ACTIONS(1399),
    [anon_sym_usingnamespace] = ACTIONS(1399),
    [anon_sym_fn] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_const] = ACTIONS(1399),
    [anon_sym_var] = ACTIONS(1399),
    [anon_sym_or] = ACTIONS(1399),
    [anon_sym_and] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_RBRACE] = ACTIONS(1397),
    [anon_sym_async] = ACTIONS(1399),
    [anon_sym_DOT] = ACTIONS(1399),
    [anon_sym_error] = ACTIONS(1399),
    [anon_sym_false] = ACTIONS(1399),
    [anon_sym_null] = ACTIONS(1399),
    [anon_sym_anyframe] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1399),
    [anon_sym_undefined] = ACTIONS(1399),
    [anon_sym_unreachable] = ACTIONS(1399),
    [sym_BuildinTypeExpr] = ACTIONS(1399),
    [anon_sym_packed] = ACTIONS(1399),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_switch] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(1397),
    [anon_sym_if] = ACTIONS(1399),
    [anon_sym_while] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1399),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_EQ_EQ] = ACTIONS(1397),
    [anon_sym_BANG_EQ] = ACTIONS(1397),
    [anon_sym_LT] = ACTIONS(1399),
    [anon_sym_GT] = ACTIONS(1399),
    [anon_sym_LT_EQ] = ACTIONS(1397),
    [anon_sym_GT_EQ] = ACTIONS(1397),
    [anon_sym_AMP] = ACTIONS(1397),
    [anon_sym_CARET] = ACTIONS(1397),
    [anon_sym_orelse] = ACTIONS(1399),
    [anon_sym_catch] = ACTIONS(1399),
    [anon_sym_LT_LT] = ACTIONS(1399),
    [anon_sym_GT_GT] = ACTIONS(1397),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1399),
    [anon_sym_DASH] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1397),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1397),
    [anon_sym_DASH_PERCENT] = ACTIONS(1397),
    [anon_sym_PLUS_PIPE] = ACTIONS(1397),
    [anon_sym_DASH_PIPE] = ACTIONS(1397),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_SLASH] = ACTIONS(1399),
    [anon_sym_PERCENT] = ACTIONS(1397),
    [anon_sym_STAR_STAR] = ACTIONS(1397),
    [anon_sym_STAR_PERCENT] = ACTIONS(1397),
    [anon_sym_STAR_PIPE] = ACTIONS(1397),
    [anon_sym_QMARK] = ACTIONS(1397),
    [anon_sym_DOT_STAR] = ACTIONS(1397),
    [anon_sym_DOT_QMARK] = ACTIONS(1397),
    [anon_sym_struct] = ACTIONS(1399),
    [anon_sym_opaque] = ACTIONS(1399),
    [anon_sym_enum] = ACTIONS(1399),
    [anon_sym_union] = ACTIONS(1399),
    [sym_doc_comment] = ACTIONS(1397),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1397),
    [aux_sym_FLOAT_token1] = ACTIONS(1397),
    [aux_sym_FLOAT_token2] = ACTIONS(1397),
    [aux_sym_FLOAT_token3] = ACTIONS(1397),
    [aux_sym_FLOAT_token4] = ACTIONS(1397),
    [aux_sym_INTEGER_token1] = ACTIONS(1397),
    [aux_sym_INTEGER_token2] = ACTIONS(1397),
    [aux_sym_INTEGER_token3] = ACTIONS(1399),
    [aux_sym_INTEGER_token4] = ACTIONS(1399),
    [anon_sym_DQUOTE] = ACTIONS(1397),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1397),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1399),
    [anon_sym_AT] = ACTIONS(1397),
  },
  [606] = {
    [ts_builtin_sym_end] = ACTIONS(1401),
    [anon_sym_COMMA] = ACTIONS(1401),
    [anon_sym_pub] = ACTIONS(1403),
    [anon_sym_test] = ACTIONS(1403),
    [anon_sym_comptime] = ACTIONS(1403),
    [anon_sym_export] = ACTIONS(1403),
    [anon_sym_extern] = ACTIONS(1403),
    [anon_sym_inline] = ACTIONS(1403),
    [anon_sym_noinline] = ACTIONS(1403),
    [anon_sym_threadlocal] = ACTIONS(1403),
    [anon_sym_usingnamespace] = ACTIONS(1403),
    [anon_sym_fn] = ACTIONS(1403),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_const] = ACTIONS(1403),
    [anon_sym_var] = ACTIONS(1403),
    [anon_sym_or] = ACTIONS(1403),
    [anon_sym_and] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_RBRACE] = ACTIONS(1401),
    [anon_sym_async] = ACTIONS(1403),
    [anon_sym_DOT] = ACTIONS(1403),
    [anon_sym_error] = ACTIONS(1403),
    [anon_sym_false] = ACTIONS(1403),
    [anon_sym_null] = ACTIONS(1403),
    [anon_sym_anyframe] = ACTIONS(1403),
    [anon_sym_true] = ACTIONS(1403),
    [anon_sym_undefined] = ACTIONS(1403),
    [anon_sym_unreachable] = ACTIONS(1403),
    [sym_BuildinTypeExpr] = ACTIONS(1403),
    [anon_sym_packed] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1401),
    [anon_sym_switch] = ACTIONS(1403),
    [anon_sym_LBRACK] = ACTIONS(1401),
    [anon_sym_if] = ACTIONS(1403),
    [anon_sym_while] = ACTIONS(1403),
    [anon_sym_for] = ACTIONS(1403),
    [anon_sym_PIPE] = ACTIONS(1403),
    [anon_sym_STAR] = ACTIONS(1403),
    [anon_sym_EQ_EQ] = ACTIONS(1401),
    [anon_sym_BANG_EQ] = ACTIONS(1401),
    [anon_sym_LT] = ACTIONS(1403),
    [anon_sym_GT] = ACTIONS(1403),
    [anon_sym_LT_EQ] = ACTIONS(1401),
    [anon_sym_GT_EQ] = ACTIONS(1401),
    [anon_sym_AMP] = ACTIONS(1401),
    [anon_sym_CARET] = ACTIONS(1401),
    [anon_sym_orelse] = ACTIONS(1403),
    [anon_sym_catch] = ACTIONS(1403),
    [anon_sym_LT_LT] = ACTIONS(1403),
    [anon_sym_GT_GT] = ACTIONS(1401),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1401),
    [anon_sym_PLUS] = ACTIONS(1403),
    [anon_sym_DASH] = ACTIONS(1403),
    [anon_sym_PLUS_PLUS] = ACTIONS(1401),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1401),
    [anon_sym_DASH_PERCENT] = ACTIONS(1401),
    [anon_sym_PLUS_PIPE] = ACTIONS(1401),
    [anon_sym_DASH_PIPE] = ACTIONS(1401),
    [anon_sym_PIPE_PIPE] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1403),
    [anon_sym_PERCENT] = ACTIONS(1401),
    [anon_sym_STAR_STAR] = ACTIONS(1401),
    [anon_sym_STAR_PERCENT] = ACTIONS(1401),
    [anon_sym_STAR_PIPE] = ACTIONS(1401),
    [anon_sym_QMARK] = ACTIONS(1401),
    [anon_sym_DOT_STAR] = ACTIONS(1401),
    [anon_sym_DOT_QMARK] = ACTIONS(1401),
    [anon_sym_struct] = ACTIONS(1403),
    [anon_sym_opaque] = ACTIONS(1403),
    [anon_sym_enum] = ACTIONS(1403),
    [anon_sym_union] = ACTIONS(1403),
    [sym_doc_comment] = ACTIONS(1401),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1401),
    [aux_sym_FLOAT_token1] = ACTIONS(1401),
    [aux_sym_FLOAT_token2] = ACTIONS(1401),
    [aux_sym_FLOAT_token3] = ACTIONS(1401),
    [aux_sym_FLOAT_token4] = ACTIONS(1401),
    [aux_sym_INTEGER_token1] = ACTIONS(1401),
    [aux_sym_INTEGER_token2] = ACTIONS(1401),
    [aux_sym_INTEGER_token3] = ACTIONS(1403),
    [aux_sym_INTEGER_token4] = ACTIONS(1403),
    [anon_sym_DQUOTE] = ACTIONS(1401),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1401),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1403),
    [anon_sym_AT] = ACTIONS(1401),
  },
  [607] = {
    [ts_builtin_sym_end] = ACTIONS(1405),
    [anon_sym_COMMA] = ACTIONS(1405),
    [anon_sym_pub] = ACTIONS(1407),
    [anon_sym_test] = ACTIONS(1407),
    [anon_sym_comptime] = ACTIONS(1407),
    [anon_sym_export] = ACTIONS(1407),
    [anon_sym_extern] = ACTIONS(1407),
    [anon_sym_inline] = ACTIONS(1407),
    [anon_sym_noinline] = ACTIONS(1407),
    [anon_sym_threadlocal] = ACTIONS(1407),
    [anon_sym_usingnamespace] = ACTIONS(1407),
    [anon_sym_fn] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1407),
    [anon_sym_const] = ACTIONS(1407),
    [anon_sym_var] = ACTIONS(1407),
    [anon_sym_or] = ACTIONS(1407),
    [anon_sym_and] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_RBRACE] = ACTIONS(1405),
    [anon_sym_async] = ACTIONS(1407),
    [anon_sym_DOT] = ACTIONS(1407),
    [anon_sym_error] = ACTIONS(1407),
    [anon_sym_false] = ACTIONS(1407),
    [anon_sym_null] = ACTIONS(1407),
    [anon_sym_anyframe] = ACTIONS(1407),
    [anon_sym_true] = ACTIONS(1407),
    [anon_sym_undefined] = ACTIONS(1407),
    [anon_sym_unreachable] = ACTIONS(1407),
    [sym_BuildinTypeExpr] = ACTIONS(1407),
    [anon_sym_packed] = ACTIONS(1407),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_switch] = ACTIONS(1407),
    [anon_sym_LBRACK] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1407),
    [anon_sym_while] = ACTIONS(1407),
    [anon_sym_for] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(1407),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1405),
    [anon_sym_GT_EQ] = ACTIONS(1405),
    [anon_sym_AMP] = ACTIONS(1405),
    [anon_sym_CARET] = ACTIONS(1405),
    [anon_sym_orelse] = ACTIONS(1407),
    [anon_sym_catch] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1407),
    [anon_sym_GT_GT] = ACTIONS(1405),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1405),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1405),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1405),
    [anon_sym_DASH_PERCENT] = ACTIONS(1405),
    [anon_sym_PLUS_PIPE] = ACTIONS(1405),
    [anon_sym_DASH_PIPE] = ACTIONS(1405),
    [anon_sym_PIPE_PIPE] = ACTIONS(1405),
    [anon_sym_SLASH] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(1405),
    [anon_sym_STAR_STAR] = ACTIONS(1405),
    [anon_sym_STAR_PERCENT] = ACTIONS(1405),
    [anon_sym_STAR_PIPE] = ACTIONS(1405),
    [anon_sym_QMARK] = ACTIONS(1405),
    [anon_sym_DOT_STAR] = ACTIONS(1405),
    [anon_sym_DOT_QMARK] = ACTIONS(1405),
    [anon_sym_struct] = ACTIONS(1407),
    [anon_sym_opaque] = ACTIONS(1407),
    [anon_sym_enum] = ACTIONS(1407),
    [anon_sym_union] = ACTIONS(1407),
    [sym_doc_comment] = ACTIONS(1405),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1405),
    [aux_sym_FLOAT_token1] = ACTIONS(1405),
    [aux_sym_FLOAT_token2] = ACTIONS(1405),
    [aux_sym_FLOAT_token3] = ACTIONS(1405),
    [aux_sym_FLOAT_token4] = ACTIONS(1405),
    [aux_sym_INTEGER_token1] = ACTIONS(1405),
    [aux_sym_INTEGER_token2] = ACTIONS(1405),
    [aux_sym_INTEGER_token3] = ACTIONS(1407),
    [aux_sym_INTEGER_token4] = ACTIONS(1407),
    [anon_sym_DQUOTE] = ACTIONS(1405),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1405),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1407),
    [anon_sym_AT] = ACTIONS(1405),
  },
  [608] = {
    [ts_builtin_sym_end] = ACTIONS(1409),
    [anon_sym_COMMA] = ACTIONS(1409),
    [anon_sym_pub] = ACTIONS(1411),
    [anon_sym_test] = ACTIONS(1411),
    [anon_sym_comptime] = ACTIONS(1411),
    [anon_sym_export] = ACTIONS(1411),
    [anon_sym_extern] = ACTIONS(1411),
    [anon_sym_inline] = ACTIONS(1411),
    [anon_sym_noinline] = ACTIONS(1411),
    [anon_sym_threadlocal] = ACTIONS(1411),
    [anon_sym_usingnamespace] = ACTIONS(1411),
    [anon_sym_fn] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_const] = ACTIONS(1411),
    [anon_sym_var] = ACTIONS(1411),
    [anon_sym_or] = ACTIONS(1411),
    [anon_sym_and] = ACTIONS(1411),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_async] = ACTIONS(1411),
    [anon_sym_DOT] = ACTIONS(1411),
    [anon_sym_error] = ACTIONS(1411),
    [anon_sym_false] = ACTIONS(1411),
    [anon_sym_null] = ACTIONS(1411),
    [anon_sym_anyframe] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1411),
    [anon_sym_undefined] = ACTIONS(1411),
    [anon_sym_unreachable] = ACTIONS(1411),
    [sym_BuildinTypeExpr] = ACTIONS(1411),
    [anon_sym_packed] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1409),
    [anon_sym_switch] = ACTIONS(1411),
    [anon_sym_LBRACK] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1411),
    [anon_sym_while] = ACTIONS(1411),
    [anon_sym_for] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(1411),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1409),
    [anon_sym_CARET] = ACTIONS(1409),
    [anon_sym_orelse] = ACTIONS(1411),
    [anon_sym_catch] = ACTIONS(1411),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1409),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1409),
    [anon_sym_PLUS] = ACTIONS(1411),
    [anon_sym_DASH] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1409),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1409),
    [anon_sym_DASH_PERCENT] = ACTIONS(1409),
    [anon_sym_PLUS_PIPE] = ACTIONS(1409),
    [anon_sym_DASH_PIPE] = ACTIONS(1409),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1411),
    [anon_sym_PERCENT] = ACTIONS(1409),
    [anon_sym_STAR_STAR] = ACTIONS(1409),
    [anon_sym_STAR_PERCENT] = ACTIONS(1409),
    [anon_sym_STAR_PIPE] = ACTIONS(1409),
    [anon_sym_QMARK] = ACTIONS(1409),
    [anon_sym_DOT_STAR] = ACTIONS(1409),
    [anon_sym_DOT_QMARK] = ACTIONS(1409),
    [anon_sym_struct] = ACTIONS(1411),
    [anon_sym_opaque] = ACTIONS(1411),
    [anon_sym_enum] = ACTIONS(1411),
    [anon_sym_union] = ACTIONS(1411),
    [sym_doc_comment] = ACTIONS(1409),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [aux_sym_FLOAT_token1] = ACTIONS(1409),
    [aux_sym_FLOAT_token2] = ACTIONS(1409),
    [aux_sym_FLOAT_token3] = ACTIONS(1409),
    [aux_sym_FLOAT_token4] = ACTIONS(1409),
    [aux_sym_INTEGER_token1] = ACTIONS(1409),
    [aux_sym_INTEGER_token2] = ACTIONS(1409),
    [aux_sym_INTEGER_token3] = ACTIONS(1411),
    [aux_sym_INTEGER_token4] = ACTIONS(1411),
    [anon_sym_DQUOTE] = ACTIONS(1409),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1409),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1411),
    [anon_sym_AT] = ACTIONS(1409),
  },
  [609] = {
    [ts_builtin_sym_end] = ACTIONS(1413),
    [anon_sym_COMMA] = ACTIONS(1413),
    [anon_sym_pub] = ACTIONS(1415),
    [anon_sym_test] = ACTIONS(1415),
    [anon_sym_comptime] = ACTIONS(1415),
    [anon_sym_export] = ACTIONS(1415),
    [anon_sym_extern] = ACTIONS(1415),
    [anon_sym_inline] = ACTIONS(1415),
    [anon_sym_noinline] = ACTIONS(1415),
    [anon_sym_threadlocal] = ACTIONS(1415),
    [anon_sym_usingnamespace] = ACTIONS(1415),
    [anon_sym_fn] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_const] = ACTIONS(1415),
    [anon_sym_var] = ACTIONS(1415),
    [anon_sym_or] = ACTIONS(1415),
    [anon_sym_and] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(1413),
    [anon_sym_RBRACE] = ACTIONS(1413),
    [anon_sym_async] = ACTIONS(1415),
    [anon_sym_DOT] = ACTIONS(1415),
    [anon_sym_error] = ACTIONS(1415),
    [anon_sym_false] = ACTIONS(1415),
    [anon_sym_null] = ACTIONS(1415),
    [anon_sym_anyframe] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(1415),
    [anon_sym_undefined] = ACTIONS(1415),
    [anon_sym_unreachable] = ACTIONS(1415),
    [sym_BuildinTypeExpr] = ACTIONS(1415),
    [anon_sym_packed] = ACTIONS(1415),
    [anon_sym_LPAREN] = ACTIONS(1413),
    [anon_sym_switch] = ACTIONS(1415),
    [anon_sym_LBRACK] = ACTIONS(1413),
    [anon_sym_if] = ACTIONS(1415),
    [anon_sym_while] = ACTIONS(1415),
    [anon_sym_for] = ACTIONS(1415),
    [anon_sym_PIPE] = ACTIONS(1415),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_EQ_EQ] = ACTIONS(1413),
    [anon_sym_BANG_EQ] = ACTIONS(1413),
    [anon_sym_LT] = ACTIONS(1415),
    [anon_sym_GT] = ACTIONS(1415),
    [anon_sym_LT_EQ] = ACTIONS(1413),
    [anon_sym_GT_EQ] = ACTIONS(1413),
    [anon_sym_AMP] = ACTIONS(1413),
    [anon_sym_CARET] = ACTIONS(1413),
    [anon_sym_orelse] = ACTIONS(1415),
    [anon_sym_catch] = ACTIONS(1415),
    [anon_sym_LT_LT] = ACTIONS(1415),
    [anon_sym_GT_GT] = ACTIONS(1413),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1413),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_DASH] = ACTIONS(1415),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1413),
    [anon_sym_DASH_PERCENT] = ACTIONS(1413),
    [anon_sym_PLUS_PIPE] = ACTIONS(1413),
    [anon_sym_DASH_PIPE] = ACTIONS(1413),
    [anon_sym_PIPE_PIPE] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1415),
    [anon_sym_PERCENT] = ACTIONS(1413),
    [anon_sym_STAR_STAR] = ACTIONS(1413),
    [anon_sym_STAR_PERCENT] = ACTIONS(1413),
    [anon_sym_STAR_PIPE] = ACTIONS(1413),
    [anon_sym_QMARK] = ACTIONS(1413),
    [anon_sym_DOT_STAR] = ACTIONS(1413),
    [anon_sym_DOT_QMARK] = ACTIONS(1413),
    [anon_sym_struct] = ACTIONS(1415),
    [anon_sym_opaque] = ACTIONS(1415),
    [anon_sym_enum] = ACTIONS(1415),
    [anon_sym_union] = ACTIONS(1415),
    [sym_doc_comment] = ACTIONS(1413),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [aux_sym_FLOAT_token1] = ACTIONS(1413),
    [aux_sym_FLOAT_token2] = ACTIONS(1413),
    [aux_sym_FLOAT_token3] = ACTIONS(1413),
    [aux_sym_FLOAT_token4] = ACTIONS(1413),
    [aux_sym_INTEGER_token1] = ACTIONS(1413),
    [aux_sym_INTEGER_token2] = ACTIONS(1413),
    [aux_sym_INTEGER_token3] = ACTIONS(1415),
    [aux_sym_INTEGER_token4] = ACTIONS(1415),
    [anon_sym_DQUOTE] = ACTIONS(1413),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1413),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1415),
    [anon_sym_AT] = ACTIONS(1413),
  },
  [610] = {
    [ts_builtin_sym_end] = ACTIONS(1417),
    [anon_sym_COMMA] = ACTIONS(1417),
    [anon_sym_pub] = ACTIONS(1419),
    [anon_sym_test] = ACTIONS(1419),
    [anon_sym_comptime] = ACTIONS(1419),
    [anon_sym_export] = ACTIONS(1419),
    [anon_sym_extern] = ACTIONS(1419),
    [anon_sym_inline] = ACTIONS(1419),
    [anon_sym_noinline] = ACTIONS(1419),
    [anon_sym_threadlocal] = ACTIONS(1419),
    [anon_sym_usingnamespace] = ACTIONS(1419),
    [anon_sym_fn] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_const] = ACTIONS(1419),
    [anon_sym_var] = ACTIONS(1419),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_and] = ACTIONS(1419),
    [anon_sym_LBRACE] = ACTIONS(1417),
    [anon_sym_RBRACE] = ACTIONS(1417),
    [anon_sym_async] = ACTIONS(1419),
    [anon_sym_DOT] = ACTIONS(1419),
    [anon_sym_error] = ACTIONS(1419),
    [anon_sym_false] = ACTIONS(1419),
    [anon_sym_null] = ACTIONS(1419),
    [anon_sym_anyframe] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1419),
    [anon_sym_undefined] = ACTIONS(1419),
    [anon_sym_unreachable] = ACTIONS(1419),
    [sym_BuildinTypeExpr] = ACTIONS(1419),
    [anon_sym_packed] = ACTIONS(1419),
    [anon_sym_LPAREN] = ACTIONS(1417),
    [anon_sym_switch] = ACTIONS(1419),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_if] = ACTIONS(1419),
    [anon_sym_while] = ACTIONS(1419),
    [anon_sym_for] = ACTIONS(1419),
    [anon_sym_PIPE] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_EQ_EQ] = ACTIONS(1417),
    [anon_sym_BANG_EQ] = ACTIONS(1417),
    [anon_sym_LT] = ACTIONS(1419),
    [anon_sym_GT] = ACTIONS(1419),
    [anon_sym_LT_EQ] = ACTIONS(1417),
    [anon_sym_GT_EQ] = ACTIONS(1417),
    [anon_sym_AMP] = ACTIONS(1417),
    [anon_sym_CARET] = ACTIONS(1417),
    [anon_sym_orelse] = ACTIONS(1419),
    [anon_sym_catch] = ACTIONS(1419),
    [anon_sym_LT_LT] = ACTIONS(1419),
    [anon_sym_GT_GT] = ACTIONS(1417),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1417),
    [anon_sym_PLUS] = ACTIONS(1419),
    [anon_sym_DASH] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1417),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1417),
    [anon_sym_DASH_PERCENT] = ACTIONS(1417),
    [anon_sym_PLUS_PIPE] = ACTIONS(1417),
    [anon_sym_DASH_PIPE] = ACTIONS(1417),
    [anon_sym_PIPE_PIPE] = ACTIONS(1417),
    [anon_sym_SLASH] = ACTIONS(1419),
    [anon_sym_PERCENT] = ACTIONS(1417),
    [anon_sym_STAR_STAR] = ACTIONS(1417),
    [anon_sym_STAR_PERCENT] = ACTIONS(1417),
    [anon_sym_STAR_PIPE] = ACTIONS(1417),
    [anon_sym_QMARK] = ACTIONS(1417),
    [anon_sym_DOT_STAR] = ACTIONS(1417),
    [anon_sym_DOT_QMARK] = ACTIONS(1417),
    [anon_sym_struct] = ACTIONS(1419),
    [anon_sym_opaque] = ACTIONS(1419),
    [anon_sym_enum] = ACTIONS(1419),
    [anon_sym_union] = ACTIONS(1419),
    [sym_doc_comment] = ACTIONS(1417),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [aux_sym_FLOAT_token1] = ACTIONS(1417),
    [aux_sym_FLOAT_token2] = ACTIONS(1417),
    [aux_sym_FLOAT_token3] = ACTIONS(1417),
    [aux_sym_FLOAT_token4] = ACTIONS(1417),
    [aux_sym_INTEGER_token1] = ACTIONS(1417),
    [aux_sym_INTEGER_token2] = ACTIONS(1417),
    [aux_sym_INTEGER_token3] = ACTIONS(1419),
    [aux_sym_INTEGER_token4] = ACTIONS(1419),
    [anon_sym_DQUOTE] = ACTIONS(1417),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1417),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1419),
    [anon_sym_AT] = ACTIONS(1417),
  },
  [611] = {
    [ts_builtin_sym_end] = ACTIONS(1421),
    [anon_sym_COMMA] = ACTIONS(1421),
    [anon_sym_pub] = ACTIONS(1423),
    [anon_sym_test] = ACTIONS(1423),
    [anon_sym_comptime] = ACTIONS(1423),
    [anon_sym_export] = ACTIONS(1423),
    [anon_sym_extern] = ACTIONS(1423),
    [anon_sym_inline] = ACTIONS(1423),
    [anon_sym_noinline] = ACTIONS(1423),
    [anon_sym_threadlocal] = ACTIONS(1423),
    [anon_sym_usingnamespace] = ACTIONS(1423),
    [anon_sym_fn] = ACTIONS(1423),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_const] = ACTIONS(1423),
    [anon_sym_var] = ACTIONS(1423),
    [anon_sym_or] = ACTIONS(1423),
    [anon_sym_and] = ACTIONS(1423),
    [anon_sym_LBRACE] = ACTIONS(1421),
    [anon_sym_RBRACE] = ACTIONS(1421),
    [anon_sym_async] = ACTIONS(1423),
    [anon_sym_DOT] = ACTIONS(1423),
    [anon_sym_error] = ACTIONS(1423),
    [anon_sym_false] = ACTIONS(1423),
    [anon_sym_null] = ACTIONS(1423),
    [anon_sym_anyframe] = ACTIONS(1423),
    [anon_sym_true] = ACTIONS(1423),
    [anon_sym_undefined] = ACTIONS(1423),
    [anon_sym_unreachable] = ACTIONS(1423),
    [sym_BuildinTypeExpr] = ACTIONS(1423),
    [anon_sym_packed] = ACTIONS(1423),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_switch] = ACTIONS(1423),
    [anon_sym_LBRACK] = ACTIONS(1421),
    [anon_sym_if] = ACTIONS(1423),
    [anon_sym_while] = ACTIONS(1423),
    [anon_sym_for] = ACTIONS(1423),
    [anon_sym_PIPE] = ACTIONS(1423),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_EQ_EQ] = ACTIONS(1421),
    [anon_sym_BANG_EQ] = ACTIONS(1421),
    [anon_sym_LT] = ACTIONS(1423),
    [anon_sym_GT] = ACTIONS(1423),
    [anon_sym_LT_EQ] = ACTIONS(1421),
    [anon_sym_GT_EQ] = ACTIONS(1421),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_CARET] = ACTIONS(1421),
    [anon_sym_orelse] = ACTIONS(1423),
    [anon_sym_catch] = ACTIONS(1423),
    [anon_sym_LT_LT] = ACTIONS(1423),
    [anon_sym_GT_GT] = ACTIONS(1421),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1421),
    [anon_sym_PLUS] = ACTIONS(1423),
    [anon_sym_DASH] = ACTIONS(1423),
    [anon_sym_PLUS_PLUS] = ACTIONS(1421),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1421),
    [anon_sym_DASH_PERCENT] = ACTIONS(1421),
    [anon_sym_PLUS_PIPE] = ACTIONS(1421),
    [anon_sym_DASH_PIPE] = ACTIONS(1421),
    [anon_sym_PIPE_PIPE] = ACTIONS(1421),
    [anon_sym_SLASH] = ACTIONS(1423),
    [anon_sym_PERCENT] = ACTIONS(1421),
    [anon_sym_STAR_STAR] = ACTIONS(1421),
    [anon_sym_STAR_PERCENT] = ACTIONS(1421),
    [anon_sym_STAR_PIPE] = ACTIONS(1421),
    [anon_sym_QMARK] = ACTIONS(1421),
    [anon_sym_DOT_STAR] = ACTIONS(1421),
    [anon_sym_DOT_QMARK] = ACTIONS(1421),
    [anon_sym_struct] = ACTIONS(1423),
    [anon_sym_opaque] = ACTIONS(1423),
    [anon_sym_enum] = ACTIONS(1423),
    [anon_sym_union] = ACTIONS(1423),
    [sym_doc_comment] = ACTIONS(1421),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1421),
    [aux_sym_FLOAT_token1] = ACTIONS(1421),
    [aux_sym_FLOAT_token2] = ACTIONS(1421),
    [aux_sym_FLOAT_token3] = ACTIONS(1421),
    [aux_sym_FLOAT_token4] = ACTIONS(1421),
    [aux_sym_INTEGER_token1] = ACTIONS(1421),
    [aux_sym_INTEGER_token2] = ACTIONS(1421),
    [aux_sym_INTEGER_token3] = ACTIONS(1423),
    [aux_sym_INTEGER_token4] = ACTIONS(1423),
    [anon_sym_DQUOTE] = ACTIONS(1421),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1421),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1423),
    [anon_sym_AT] = ACTIONS(1421),
  },
  [612] = {
    [ts_builtin_sym_end] = ACTIONS(1425),
    [anon_sym_COMMA] = ACTIONS(1425),
    [anon_sym_pub] = ACTIONS(1427),
    [anon_sym_test] = ACTIONS(1427),
    [anon_sym_comptime] = ACTIONS(1427),
    [anon_sym_export] = ACTIONS(1427),
    [anon_sym_extern] = ACTIONS(1427),
    [anon_sym_inline] = ACTIONS(1427),
    [anon_sym_noinline] = ACTIONS(1427),
    [anon_sym_threadlocal] = ACTIONS(1427),
    [anon_sym_usingnamespace] = ACTIONS(1427),
    [anon_sym_fn] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_const] = ACTIONS(1427),
    [anon_sym_var] = ACTIONS(1427),
    [anon_sym_or] = ACTIONS(1427),
    [anon_sym_and] = ACTIONS(1427),
    [anon_sym_LBRACE] = ACTIONS(1425),
    [anon_sym_RBRACE] = ACTIONS(1425),
    [anon_sym_async] = ACTIONS(1427),
    [anon_sym_DOT] = ACTIONS(1427),
    [anon_sym_error] = ACTIONS(1427),
    [anon_sym_false] = ACTIONS(1427),
    [anon_sym_null] = ACTIONS(1427),
    [anon_sym_anyframe] = ACTIONS(1427),
    [anon_sym_true] = ACTIONS(1427),
    [anon_sym_undefined] = ACTIONS(1427),
    [anon_sym_unreachable] = ACTIONS(1427),
    [sym_BuildinTypeExpr] = ACTIONS(1427),
    [anon_sym_packed] = ACTIONS(1427),
    [anon_sym_LPAREN] = ACTIONS(1425),
    [anon_sym_switch] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1425),
    [anon_sym_if] = ACTIONS(1427),
    [anon_sym_while] = ACTIONS(1427),
    [anon_sym_for] = ACTIONS(1427),
    [anon_sym_PIPE] = ACTIONS(1427),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_EQ_EQ] = ACTIONS(1425),
    [anon_sym_BANG_EQ] = ACTIONS(1425),
    [anon_sym_LT] = ACTIONS(1427),
    [anon_sym_GT] = ACTIONS(1427),
    [anon_sym_LT_EQ] = ACTIONS(1425),
    [anon_sym_GT_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1425),
    [anon_sym_CARET] = ACTIONS(1425),
    [anon_sym_orelse] = ACTIONS(1427),
    [anon_sym_catch] = ACTIONS(1427),
    [anon_sym_LT_LT] = ACTIONS(1427),
    [anon_sym_GT_GT] = ACTIONS(1425),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1425),
    [anon_sym_PLUS] = ACTIONS(1427),
    [anon_sym_DASH] = ACTIONS(1427),
    [anon_sym_PLUS_PLUS] = ACTIONS(1425),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1425),
    [anon_sym_DASH_PERCENT] = ACTIONS(1425),
    [anon_sym_PLUS_PIPE] = ACTIONS(1425),
    [anon_sym_DASH_PIPE] = ACTIONS(1425),
    [anon_sym_PIPE_PIPE] = ACTIONS(1425),
    [anon_sym_SLASH] = ACTIONS(1427),
    [anon_sym_PERCENT] = ACTIONS(1425),
    [anon_sym_STAR_STAR] = ACTIONS(1425),
    [anon_sym_STAR_PERCENT] = ACTIONS(1425),
    [anon_sym_STAR_PIPE] = ACTIONS(1425),
    [anon_sym_QMARK] = ACTIONS(1425),
    [anon_sym_DOT_STAR] = ACTIONS(1425),
    [anon_sym_DOT_QMARK] = ACTIONS(1425),
    [anon_sym_struct] = ACTIONS(1427),
    [anon_sym_opaque] = ACTIONS(1427),
    [anon_sym_enum] = ACTIONS(1427),
    [anon_sym_union] = ACTIONS(1427),
    [sym_doc_comment] = ACTIONS(1425),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [aux_sym_FLOAT_token1] = ACTIONS(1425),
    [aux_sym_FLOAT_token2] = ACTIONS(1425),
    [aux_sym_FLOAT_token3] = ACTIONS(1425),
    [aux_sym_FLOAT_token4] = ACTIONS(1425),
    [aux_sym_INTEGER_token1] = ACTIONS(1425),
    [aux_sym_INTEGER_token2] = ACTIONS(1425),
    [aux_sym_INTEGER_token3] = ACTIONS(1427),
    [aux_sym_INTEGER_token4] = ACTIONS(1427),
    [anon_sym_DQUOTE] = ACTIONS(1425),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1425),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1427),
    [anon_sym_AT] = ACTIONS(1425),
  },
  [613] = {
    [ts_builtin_sym_end] = ACTIONS(1429),
    [anon_sym_COMMA] = ACTIONS(1429),
    [anon_sym_pub] = ACTIONS(1431),
    [anon_sym_test] = ACTIONS(1431),
    [anon_sym_comptime] = ACTIONS(1431),
    [anon_sym_export] = ACTIONS(1431),
    [anon_sym_extern] = ACTIONS(1431),
    [anon_sym_inline] = ACTIONS(1431),
    [anon_sym_noinline] = ACTIONS(1431),
    [anon_sym_threadlocal] = ACTIONS(1431),
    [anon_sym_usingnamespace] = ACTIONS(1431),
    [anon_sym_fn] = ACTIONS(1431),
    [anon_sym_BANG] = ACTIONS(1431),
    [anon_sym_const] = ACTIONS(1431),
    [anon_sym_var] = ACTIONS(1431),
    [anon_sym_or] = ACTIONS(1431),
    [anon_sym_and] = ACTIONS(1431),
    [anon_sym_LBRACE] = ACTIONS(1429),
    [anon_sym_RBRACE] = ACTIONS(1429),
    [anon_sym_async] = ACTIONS(1431),
    [anon_sym_DOT] = ACTIONS(1431),
    [anon_sym_error] = ACTIONS(1431),
    [anon_sym_false] = ACTIONS(1431),
    [anon_sym_null] = ACTIONS(1431),
    [anon_sym_anyframe] = ACTIONS(1431),
    [anon_sym_true] = ACTIONS(1431),
    [anon_sym_undefined] = ACTIONS(1431),
    [anon_sym_unreachable] = ACTIONS(1431),
    [sym_BuildinTypeExpr] = ACTIONS(1431),
    [anon_sym_packed] = ACTIONS(1431),
    [anon_sym_LPAREN] = ACTIONS(1429),
    [anon_sym_switch] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1429),
    [anon_sym_if] = ACTIONS(1431),
    [anon_sym_while] = ACTIONS(1431),
    [anon_sym_for] = ACTIONS(1431),
    [anon_sym_PIPE] = ACTIONS(1431),
    [anon_sym_STAR] = ACTIONS(1431),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ] = ACTIONS(1429),
    [anon_sym_LT] = ACTIONS(1431),
    [anon_sym_GT] = ACTIONS(1431),
    [anon_sym_LT_EQ] = ACTIONS(1429),
    [anon_sym_GT_EQ] = ACTIONS(1429),
    [anon_sym_AMP] = ACTIONS(1429),
    [anon_sym_CARET] = ACTIONS(1429),
    [anon_sym_orelse] = ACTIONS(1431),
    [anon_sym_catch] = ACTIONS(1431),
    [anon_sym_LT_LT] = ACTIONS(1431),
    [anon_sym_GT_GT] = ACTIONS(1429),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1429),
    [anon_sym_PLUS] = ACTIONS(1431),
    [anon_sym_DASH] = ACTIONS(1431),
    [anon_sym_PLUS_PLUS] = ACTIONS(1429),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1429),
    [anon_sym_DASH_PERCENT] = ACTIONS(1429),
    [anon_sym_PLUS_PIPE] = ACTIONS(1429),
    [anon_sym_DASH_PIPE] = ACTIONS(1429),
    [anon_sym_PIPE_PIPE] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1431),
    [anon_sym_PERCENT] = ACTIONS(1429),
    [anon_sym_STAR_STAR] = ACTIONS(1429),
    [anon_sym_STAR_PERCENT] = ACTIONS(1429),
    [anon_sym_STAR_PIPE] = ACTIONS(1429),
    [anon_sym_QMARK] = ACTIONS(1429),
    [anon_sym_DOT_STAR] = ACTIONS(1429),
    [anon_sym_DOT_QMARK] = ACTIONS(1429),
    [anon_sym_struct] = ACTIONS(1431),
    [anon_sym_opaque] = ACTIONS(1431),
    [anon_sym_enum] = ACTIONS(1431),
    [anon_sym_union] = ACTIONS(1431),
    [sym_doc_comment] = ACTIONS(1429),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1429),
    [aux_sym_FLOAT_token1] = ACTIONS(1429),
    [aux_sym_FLOAT_token2] = ACTIONS(1429),
    [aux_sym_FLOAT_token3] = ACTIONS(1429),
    [aux_sym_FLOAT_token4] = ACTIONS(1429),
    [aux_sym_INTEGER_token1] = ACTIONS(1429),
    [aux_sym_INTEGER_token2] = ACTIONS(1429),
    [aux_sym_INTEGER_token3] = ACTIONS(1431),
    [aux_sym_INTEGER_token4] = ACTIONS(1431),
    [anon_sym_DQUOTE] = ACTIONS(1429),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1429),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1431),
    [anon_sym_AT] = ACTIONS(1429),
  },
  [614] = {
    [ts_builtin_sym_end] = ACTIONS(1433),
    [anon_sym_COMMA] = ACTIONS(1433),
    [anon_sym_pub] = ACTIONS(1435),
    [anon_sym_test] = ACTIONS(1435),
    [anon_sym_comptime] = ACTIONS(1435),
    [anon_sym_export] = ACTIONS(1435),
    [anon_sym_extern] = ACTIONS(1435),
    [anon_sym_inline] = ACTIONS(1435),
    [anon_sym_noinline] = ACTIONS(1435),
    [anon_sym_threadlocal] = ACTIONS(1435),
    [anon_sym_usingnamespace] = ACTIONS(1435),
    [anon_sym_fn] = ACTIONS(1435),
    [anon_sym_BANG] = ACTIONS(1435),
    [anon_sym_const] = ACTIONS(1435),
    [anon_sym_var] = ACTIONS(1435),
    [anon_sym_or] = ACTIONS(1435),
    [anon_sym_and] = ACTIONS(1435),
    [anon_sym_LBRACE] = ACTIONS(1433),
    [anon_sym_RBRACE] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_DOT] = ACTIONS(1435),
    [anon_sym_error] = ACTIONS(1435),
    [anon_sym_false] = ACTIONS(1435),
    [anon_sym_null] = ACTIONS(1435),
    [anon_sym_anyframe] = ACTIONS(1435),
    [anon_sym_true] = ACTIONS(1435),
    [anon_sym_undefined] = ACTIONS(1435),
    [anon_sym_unreachable] = ACTIONS(1435),
    [sym_BuildinTypeExpr] = ACTIONS(1435),
    [anon_sym_packed] = ACTIONS(1435),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_switch] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1433),
    [anon_sym_if] = ACTIONS(1435),
    [anon_sym_while] = ACTIONS(1435),
    [anon_sym_for] = ACTIONS(1435),
    [anon_sym_PIPE] = ACTIONS(1435),
    [anon_sym_STAR] = ACTIONS(1435),
    [anon_sym_EQ_EQ] = ACTIONS(1433),
    [anon_sym_BANG_EQ] = ACTIONS(1433),
    [anon_sym_LT] = ACTIONS(1435),
    [anon_sym_GT] = ACTIONS(1435),
    [anon_sym_LT_EQ] = ACTIONS(1433),
    [anon_sym_GT_EQ] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(1433),
    [anon_sym_CARET] = ACTIONS(1433),
    [anon_sym_orelse] = ACTIONS(1435),
    [anon_sym_catch] = ACTIONS(1435),
    [anon_sym_LT_LT] = ACTIONS(1435),
    [anon_sym_GT_GT] = ACTIONS(1433),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1433),
    [anon_sym_PLUS] = ACTIONS(1435),
    [anon_sym_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1433),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1433),
    [anon_sym_DASH_PERCENT] = ACTIONS(1433),
    [anon_sym_PLUS_PIPE] = ACTIONS(1433),
    [anon_sym_DASH_PIPE] = ACTIONS(1433),
    [anon_sym_PIPE_PIPE] = ACTIONS(1433),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_PERCENT] = ACTIONS(1433),
    [anon_sym_STAR_STAR] = ACTIONS(1433),
    [anon_sym_STAR_PERCENT] = ACTIONS(1433),
    [anon_sym_STAR_PIPE] = ACTIONS(1433),
    [anon_sym_QMARK] = ACTIONS(1433),
    [anon_sym_DOT_STAR] = ACTIONS(1433),
    [anon_sym_DOT_QMARK] = ACTIONS(1433),
    [anon_sym_struct] = ACTIONS(1435),
    [anon_sym_opaque] = ACTIONS(1435),
    [anon_sym_enum] = ACTIONS(1435),
    [anon_sym_union] = ACTIONS(1435),
    [sym_doc_comment] = ACTIONS(1433),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1433),
    [aux_sym_FLOAT_token1] = ACTIONS(1433),
    [aux_sym_FLOAT_token2] = ACTIONS(1433),
    [aux_sym_FLOAT_token3] = ACTIONS(1433),
    [aux_sym_FLOAT_token4] = ACTIONS(1433),
    [aux_sym_INTEGER_token1] = ACTIONS(1433),
    [aux_sym_INTEGER_token2] = ACTIONS(1433),
    [aux_sym_INTEGER_token3] = ACTIONS(1435),
    [aux_sym_INTEGER_token4] = ACTIONS(1435),
    [anon_sym_DQUOTE] = ACTIONS(1433),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1433),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1435),
    [anon_sym_AT] = ACTIONS(1433),
  },
  [615] = {
    [ts_builtin_sym_end] = ACTIONS(1437),
    [anon_sym_COMMA] = ACTIONS(1437),
    [anon_sym_pub] = ACTIONS(1439),
    [anon_sym_test] = ACTIONS(1439),
    [anon_sym_comptime] = ACTIONS(1439),
    [anon_sym_export] = ACTIONS(1439),
    [anon_sym_extern] = ACTIONS(1439),
    [anon_sym_inline] = ACTIONS(1439),
    [anon_sym_noinline] = ACTIONS(1439),
    [anon_sym_threadlocal] = ACTIONS(1439),
    [anon_sym_usingnamespace] = ACTIONS(1439),
    [anon_sym_fn] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_const] = ACTIONS(1439),
    [anon_sym_var] = ACTIONS(1439),
    [anon_sym_or] = ACTIONS(1439),
    [anon_sym_and] = ACTIONS(1439),
    [anon_sym_LBRACE] = ACTIONS(1437),
    [anon_sym_RBRACE] = ACTIONS(1437),
    [anon_sym_async] = ACTIONS(1439),
    [anon_sym_DOT] = ACTIONS(1439),
    [anon_sym_error] = ACTIONS(1439),
    [anon_sym_false] = ACTIONS(1439),
    [anon_sym_null] = ACTIONS(1439),
    [anon_sym_anyframe] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1439),
    [anon_sym_undefined] = ACTIONS(1439),
    [anon_sym_unreachable] = ACTIONS(1439),
    [sym_BuildinTypeExpr] = ACTIONS(1439),
    [anon_sym_packed] = ACTIONS(1439),
    [anon_sym_LPAREN] = ACTIONS(1437),
    [anon_sym_switch] = ACTIONS(1439),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(1439),
    [anon_sym_while] = ACTIONS(1439),
    [anon_sym_for] = ACTIONS(1439),
    [anon_sym_PIPE] = ACTIONS(1439),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_EQ_EQ] = ACTIONS(1437),
    [anon_sym_BANG_EQ] = ACTIONS(1437),
    [anon_sym_LT] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1439),
    [anon_sym_LT_EQ] = ACTIONS(1437),
    [anon_sym_GT_EQ] = ACTIONS(1437),
    [anon_sym_AMP] = ACTIONS(1437),
    [anon_sym_CARET] = ACTIONS(1437),
    [anon_sym_orelse] = ACTIONS(1439),
    [anon_sym_catch] = ACTIONS(1439),
    [anon_sym_LT_LT] = ACTIONS(1439),
    [anon_sym_GT_GT] = ACTIONS(1437),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1437),
    [anon_sym_PLUS] = ACTIONS(1439),
    [anon_sym_DASH] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1437),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1437),
    [anon_sym_DASH_PERCENT] = ACTIONS(1437),
    [anon_sym_PLUS_PIPE] = ACTIONS(1437),
    [anon_sym_DASH_PIPE] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1439),
    [anon_sym_PERCENT] = ACTIONS(1437),
    [anon_sym_STAR_STAR] = ACTIONS(1437),
    [anon_sym_STAR_PERCENT] = ACTIONS(1437),
    [anon_sym_STAR_PIPE] = ACTIONS(1437),
    [anon_sym_QMARK] = ACTIONS(1437),
    [anon_sym_DOT_STAR] = ACTIONS(1437),
    [anon_sym_DOT_QMARK] = ACTIONS(1437),
    [anon_sym_struct] = ACTIONS(1439),
    [anon_sym_opaque] = ACTIONS(1439),
    [anon_sym_enum] = ACTIONS(1439),
    [anon_sym_union] = ACTIONS(1439),
    [sym_doc_comment] = ACTIONS(1437),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1437),
    [aux_sym_FLOAT_token1] = ACTIONS(1437),
    [aux_sym_FLOAT_token2] = ACTIONS(1437),
    [aux_sym_FLOAT_token3] = ACTIONS(1437),
    [aux_sym_FLOAT_token4] = ACTIONS(1437),
    [aux_sym_INTEGER_token1] = ACTIONS(1437),
    [aux_sym_INTEGER_token2] = ACTIONS(1437),
    [aux_sym_INTEGER_token3] = ACTIONS(1439),
    [aux_sym_INTEGER_token4] = ACTIONS(1439),
    [anon_sym_DQUOTE] = ACTIONS(1437),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1437),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1439),
    [anon_sym_AT] = ACTIONS(1437),
  },
  [616] = {
    [ts_builtin_sym_end] = ACTIONS(1441),
    [anon_sym_COMMA] = ACTIONS(1441),
    [anon_sym_pub] = ACTIONS(1443),
    [anon_sym_test] = ACTIONS(1443),
    [anon_sym_comptime] = ACTIONS(1443),
    [anon_sym_export] = ACTIONS(1443),
    [anon_sym_extern] = ACTIONS(1443),
    [anon_sym_inline] = ACTIONS(1443),
    [anon_sym_noinline] = ACTIONS(1443),
    [anon_sym_threadlocal] = ACTIONS(1443),
    [anon_sym_usingnamespace] = ACTIONS(1443),
    [anon_sym_fn] = ACTIONS(1443),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_const] = ACTIONS(1443),
    [anon_sym_var] = ACTIONS(1443),
    [anon_sym_or] = ACTIONS(1443),
    [anon_sym_and] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1441),
    [anon_sym_RBRACE] = ACTIONS(1441),
    [anon_sym_async] = ACTIONS(1443),
    [anon_sym_DOT] = ACTIONS(1443),
    [anon_sym_error] = ACTIONS(1443),
    [anon_sym_false] = ACTIONS(1443),
    [anon_sym_null] = ACTIONS(1443),
    [anon_sym_anyframe] = ACTIONS(1443),
    [anon_sym_true] = ACTIONS(1443),
    [anon_sym_undefined] = ACTIONS(1443),
    [anon_sym_unreachable] = ACTIONS(1443),
    [sym_BuildinTypeExpr] = ACTIONS(1443),
    [anon_sym_packed] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(1441),
    [anon_sym_switch] = ACTIONS(1443),
    [anon_sym_LBRACK] = ACTIONS(1441),
    [anon_sym_if] = ACTIONS(1443),
    [anon_sym_while] = ACTIONS(1443),
    [anon_sym_for] = ACTIONS(1443),
    [anon_sym_PIPE] = ACTIONS(1443),
    [anon_sym_STAR] = ACTIONS(1443),
    [anon_sym_EQ_EQ] = ACTIONS(1441),
    [anon_sym_BANG_EQ] = ACTIONS(1441),
    [anon_sym_LT] = ACTIONS(1443),
    [anon_sym_GT] = ACTIONS(1443),
    [anon_sym_LT_EQ] = ACTIONS(1441),
    [anon_sym_GT_EQ] = ACTIONS(1441),
    [anon_sym_AMP] = ACTIONS(1441),
    [anon_sym_CARET] = ACTIONS(1441),
    [anon_sym_orelse] = ACTIONS(1443),
    [anon_sym_catch] = ACTIONS(1443),
    [anon_sym_LT_LT] = ACTIONS(1443),
    [anon_sym_GT_GT] = ACTIONS(1441),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1441),
    [anon_sym_PLUS] = ACTIONS(1443),
    [anon_sym_DASH] = ACTIONS(1443),
    [anon_sym_PLUS_PLUS] = ACTIONS(1441),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1441),
    [anon_sym_DASH_PERCENT] = ACTIONS(1441),
    [anon_sym_PLUS_PIPE] = ACTIONS(1441),
    [anon_sym_DASH_PIPE] = ACTIONS(1441),
    [anon_sym_PIPE_PIPE] = ACTIONS(1441),
    [anon_sym_SLASH] = ACTIONS(1443),
    [anon_sym_PERCENT] = ACTIONS(1441),
    [anon_sym_STAR_STAR] = ACTIONS(1441),
    [anon_sym_STAR_PERCENT] = ACTIONS(1441),
    [anon_sym_STAR_PIPE] = ACTIONS(1441),
    [anon_sym_QMARK] = ACTIONS(1441),
    [anon_sym_DOT_STAR] = ACTIONS(1441),
    [anon_sym_DOT_QMARK] = ACTIONS(1441),
    [anon_sym_struct] = ACTIONS(1443),
    [anon_sym_opaque] = ACTIONS(1443),
    [anon_sym_enum] = ACTIONS(1443),
    [anon_sym_union] = ACTIONS(1443),
    [sym_doc_comment] = ACTIONS(1441),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1441),
    [aux_sym_FLOAT_token1] = ACTIONS(1441),
    [aux_sym_FLOAT_token2] = ACTIONS(1441),
    [aux_sym_FLOAT_token3] = ACTIONS(1441),
    [aux_sym_FLOAT_token4] = ACTIONS(1441),
    [aux_sym_INTEGER_token1] = ACTIONS(1441),
    [aux_sym_INTEGER_token2] = ACTIONS(1441),
    [aux_sym_INTEGER_token3] = ACTIONS(1443),
    [aux_sym_INTEGER_token4] = ACTIONS(1443),
    [anon_sym_DQUOTE] = ACTIONS(1441),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1441),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1443),
    [anon_sym_AT] = ACTIONS(1441),
  },
  [617] = {
    [ts_builtin_sym_end] = ACTIONS(1445),
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_pub] = ACTIONS(1447),
    [anon_sym_test] = ACTIONS(1447),
    [anon_sym_comptime] = ACTIONS(1447),
    [anon_sym_export] = ACTIONS(1447),
    [anon_sym_extern] = ACTIONS(1447),
    [anon_sym_inline] = ACTIONS(1447),
    [anon_sym_noinline] = ACTIONS(1447),
    [anon_sym_threadlocal] = ACTIONS(1447),
    [anon_sym_usingnamespace] = ACTIONS(1447),
    [anon_sym_fn] = ACTIONS(1447),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_const] = ACTIONS(1447),
    [anon_sym_var] = ACTIONS(1447),
    [anon_sym_or] = ACTIONS(1447),
    [anon_sym_and] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [anon_sym_RBRACE] = ACTIONS(1445),
    [anon_sym_async] = ACTIONS(1447),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_error] = ACTIONS(1447),
    [anon_sym_false] = ACTIONS(1447),
    [anon_sym_null] = ACTIONS(1447),
    [anon_sym_anyframe] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1447),
    [anon_sym_undefined] = ACTIONS(1447),
    [anon_sym_unreachable] = ACTIONS(1447),
    [sym_BuildinTypeExpr] = ACTIONS(1447),
    [anon_sym_packed] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1445),
    [anon_sym_switch] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(1445),
    [anon_sym_if] = ACTIONS(1447),
    [anon_sym_while] = ACTIONS(1447),
    [anon_sym_for] = ACTIONS(1447),
    [anon_sym_PIPE] = ACTIONS(1447),
    [anon_sym_STAR] = ACTIONS(1447),
    [anon_sym_EQ_EQ] = ACTIONS(1445),
    [anon_sym_BANG_EQ] = ACTIONS(1445),
    [anon_sym_LT] = ACTIONS(1447),
    [anon_sym_GT] = ACTIONS(1447),
    [anon_sym_LT_EQ] = ACTIONS(1445),
    [anon_sym_GT_EQ] = ACTIONS(1445),
    [anon_sym_AMP] = ACTIONS(1445),
    [anon_sym_CARET] = ACTIONS(1445),
    [anon_sym_orelse] = ACTIONS(1447),
    [anon_sym_catch] = ACTIONS(1447),
    [anon_sym_LT_LT] = ACTIONS(1447),
    [anon_sym_GT_GT] = ACTIONS(1445),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1445),
    [anon_sym_PLUS] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1445),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1445),
    [anon_sym_DASH_PERCENT] = ACTIONS(1445),
    [anon_sym_PLUS_PIPE] = ACTIONS(1445),
    [anon_sym_DASH_PIPE] = ACTIONS(1445),
    [anon_sym_PIPE_PIPE] = ACTIONS(1445),
    [anon_sym_SLASH] = ACTIONS(1447),
    [anon_sym_PERCENT] = ACTIONS(1445),
    [anon_sym_STAR_STAR] = ACTIONS(1445),
    [anon_sym_STAR_PERCENT] = ACTIONS(1445),
    [anon_sym_STAR_PIPE] = ACTIONS(1445),
    [anon_sym_QMARK] = ACTIONS(1445),
    [anon_sym_DOT_STAR] = ACTIONS(1445),
    [anon_sym_DOT_QMARK] = ACTIONS(1445),
    [anon_sym_struct] = ACTIONS(1447),
    [anon_sym_opaque] = ACTIONS(1447),
    [anon_sym_enum] = ACTIONS(1447),
    [anon_sym_union] = ACTIONS(1447),
    [sym_doc_comment] = ACTIONS(1445),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1445),
    [aux_sym_FLOAT_token1] = ACTIONS(1445),
    [aux_sym_FLOAT_token2] = ACTIONS(1445),
    [aux_sym_FLOAT_token3] = ACTIONS(1445),
    [aux_sym_FLOAT_token4] = ACTIONS(1445),
    [aux_sym_INTEGER_token1] = ACTIONS(1445),
    [aux_sym_INTEGER_token2] = ACTIONS(1445),
    [aux_sym_INTEGER_token3] = ACTIONS(1447),
    [aux_sym_INTEGER_token4] = ACTIONS(1447),
    [anon_sym_DQUOTE] = ACTIONS(1445),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1445),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1447),
    [anon_sym_AT] = ACTIONS(1445),
  },
  [618] = {
    [ts_builtin_sym_end] = ACTIONS(1453),
    [anon_sym_COMMA] = ACTIONS(1453),
    [anon_sym_pub] = ACTIONS(1455),
    [anon_sym_test] = ACTIONS(1455),
    [anon_sym_comptime] = ACTIONS(1455),
    [anon_sym_export] = ACTIONS(1455),
    [anon_sym_extern] = ACTIONS(1455),
    [anon_sym_inline] = ACTIONS(1455),
    [anon_sym_noinline] = ACTIONS(1455),
    [anon_sym_threadlocal] = ACTIONS(1455),
    [anon_sym_usingnamespace] = ACTIONS(1455),
    [anon_sym_fn] = ACTIONS(1455),
    [anon_sym_BANG] = ACTIONS(1455),
    [anon_sym_const] = ACTIONS(1455),
    [anon_sym_var] = ACTIONS(1455),
    [anon_sym_or] = ACTIONS(1455),
    [anon_sym_and] = ACTIONS(1455),
    [anon_sym_LBRACE] = ACTIONS(1453),
    [anon_sym_RBRACE] = ACTIONS(1453),
    [anon_sym_async] = ACTIONS(1455),
    [anon_sym_DOT] = ACTIONS(1455),
    [anon_sym_error] = ACTIONS(1455),
    [anon_sym_false] = ACTIONS(1455),
    [anon_sym_null] = ACTIONS(1455),
    [anon_sym_anyframe] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1455),
    [anon_sym_undefined] = ACTIONS(1455),
    [anon_sym_unreachable] = ACTIONS(1455),
    [sym_BuildinTypeExpr] = ACTIONS(1455),
    [anon_sym_packed] = ACTIONS(1455),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_switch] = ACTIONS(1455),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_if] = ACTIONS(1455),
    [anon_sym_while] = ACTIONS(1455),
    [anon_sym_for] = ACTIONS(1455),
    [anon_sym_PIPE] = ACTIONS(1455),
    [anon_sym_STAR] = ACTIONS(1455),
    [anon_sym_EQ_EQ] = ACTIONS(1453),
    [anon_sym_BANG_EQ] = ACTIONS(1453),
    [anon_sym_LT] = ACTIONS(1455),
    [anon_sym_GT] = ACTIONS(1455),
    [anon_sym_LT_EQ] = ACTIONS(1453),
    [anon_sym_GT_EQ] = ACTIONS(1453),
    [anon_sym_AMP] = ACTIONS(1453),
    [anon_sym_CARET] = ACTIONS(1453),
    [anon_sym_orelse] = ACTIONS(1455),
    [anon_sym_catch] = ACTIONS(1455),
    [anon_sym_LT_LT] = ACTIONS(1455),
    [anon_sym_GT_GT] = ACTIONS(1453),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1453),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_DASH] = ACTIONS(1455),
    [anon_sym_PLUS_PLUS] = ACTIONS(1453),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1453),
    [anon_sym_DASH_PERCENT] = ACTIONS(1453),
    [anon_sym_PLUS_PIPE] = ACTIONS(1453),
    [anon_sym_DASH_PIPE] = ACTIONS(1453),
    [anon_sym_PIPE_PIPE] = ACTIONS(1453),
    [anon_sym_SLASH] = ACTIONS(1455),
    [anon_sym_PERCENT] = ACTIONS(1453),
    [anon_sym_STAR_STAR] = ACTIONS(1453),
    [anon_sym_STAR_PERCENT] = ACTIONS(1453),
    [anon_sym_STAR_PIPE] = ACTIONS(1453),
    [anon_sym_QMARK] = ACTIONS(1453),
    [anon_sym_DOT_STAR] = ACTIONS(1453),
    [anon_sym_DOT_QMARK] = ACTIONS(1453),
    [anon_sym_struct] = ACTIONS(1455),
    [anon_sym_opaque] = ACTIONS(1455),
    [anon_sym_enum] = ACTIONS(1455),
    [anon_sym_union] = ACTIONS(1455),
    [sym_doc_comment] = ACTIONS(1453),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [aux_sym_FLOAT_token1] = ACTIONS(1453),
    [aux_sym_FLOAT_token2] = ACTIONS(1453),
    [aux_sym_FLOAT_token3] = ACTIONS(1453),
    [aux_sym_FLOAT_token4] = ACTIONS(1453),
    [aux_sym_INTEGER_token1] = ACTIONS(1453),
    [aux_sym_INTEGER_token2] = ACTIONS(1453),
    [aux_sym_INTEGER_token3] = ACTIONS(1455),
    [aux_sym_INTEGER_token4] = ACTIONS(1455),
    [anon_sym_DQUOTE] = ACTIONS(1453),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1453),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1455),
    [anon_sym_AT] = ACTIONS(1453),
  },
  [619] = {
    [ts_builtin_sym_end] = ACTIONS(1457),
    [anon_sym_COMMA] = ACTIONS(1457),
    [anon_sym_pub] = ACTIONS(1459),
    [anon_sym_test] = ACTIONS(1459),
    [anon_sym_comptime] = ACTIONS(1459),
    [anon_sym_export] = ACTIONS(1459),
    [anon_sym_extern] = ACTIONS(1459),
    [anon_sym_inline] = ACTIONS(1459),
    [anon_sym_noinline] = ACTIONS(1459),
    [anon_sym_threadlocal] = ACTIONS(1459),
    [anon_sym_usingnamespace] = ACTIONS(1459),
    [anon_sym_fn] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_const] = ACTIONS(1459),
    [anon_sym_var] = ACTIONS(1459),
    [anon_sym_or] = ACTIONS(1459),
    [anon_sym_and] = ACTIONS(1459),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_RBRACE] = ACTIONS(1457),
    [anon_sym_async] = ACTIONS(1459),
    [anon_sym_DOT] = ACTIONS(1459),
    [anon_sym_error] = ACTIONS(1459),
    [anon_sym_false] = ACTIONS(1459),
    [anon_sym_null] = ACTIONS(1459),
    [anon_sym_anyframe] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(1459),
    [anon_sym_undefined] = ACTIONS(1459),
    [anon_sym_unreachable] = ACTIONS(1459),
    [sym_BuildinTypeExpr] = ACTIONS(1459),
    [anon_sym_packed] = ACTIONS(1459),
    [anon_sym_LPAREN] = ACTIONS(1457),
    [anon_sym_switch] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_if] = ACTIONS(1459),
    [anon_sym_while] = ACTIONS(1459),
    [anon_sym_for] = ACTIONS(1459),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_EQ_EQ] = ACTIONS(1457),
    [anon_sym_BANG_EQ] = ACTIONS(1457),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_LT_EQ] = ACTIONS(1457),
    [anon_sym_GT_EQ] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(1457),
    [anon_sym_CARET] = ACTIONS(1457),
    [anon_sym_orelse] = ACTIONS(1459),
    [anon_sym_catch] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1457),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1457),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_DASH] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1457),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1457),
    [anon_sym_DASH_PERCENT] = ACTIONS(1457),
    [anon_sym_PLUS_PIPE] = ACTIONS(1457),
    [anon_sym_DASH_PIPE] = ACTIONS(1457),
    [anon_sym_PIPE_PIPE] = ACTIONS(1457),
    [anon_sym_SLASH] = ACTIONS(1459),
    [anon_sym_PERCENT] = ACTIONS(1457),
    [anon_sym_STAR_STAR] = ACTIONS(1457),
    [anon_sym_STAR_PERCENT] = ACTIONS(1457),
    [anon_sym_STAR_PIPE] = ACTIONS(1457),
    [anon_sym_QMARK] = ACTIONS(1457),
    [anon_sym_DOT_STAR] = ACTIONS(1457),
    [anon_sym_DOT_QMARK] = ACTIONS(1457),
    [anon_sym_struct] = ACTIONS(1459),
    [anon_sym_opaque] = ACTIONS(1459),
    [anon_sym_enum] = ACTIONS(1459),
    [anon_sym_union] = ACTIONS(1459),
    [sym_doc_comment] = ACTIONS(1457),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1457),
    [aux_sym_FLOAT_token1] = ACTIONS(1457),
    [aux_sym_FLOAT_token2] = ACTIONS(1457),
    [aux_sym_FLOAT_token3] = ACTIONS(1457),
    [aux_sym_FLOAT_token4] = ACTIONS(1457),
    [aux_sym_INTEGER_token1] = ACTIONS(1457),
    [aux_sym_INTEGER_token2] = ACTIONS(1457),
    [aux_sym_INTEGER_token3] = ACTIONS(1459),
    [aux_sym_INTEGER_token4] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1457),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1457),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1459),
    [anon_sym_AT] = ACTIONS(1457),
  },
  [620] = {
    [ts_builtin_sym_end] = ACTIONS(534),
    [anon_sym_COMMA] = ACTIONS(534),
    [anon_sym_pub] = ACTIONS(532),
    [anon_sym_test] = ACTIONS(532),
    [anon_sym_comptime] = ACTIONS(532),
    [anon_sym_export] = ACTIONS(532),
    [anon_sym_extern] = ACTIONS(532),
    [anon_sym_inline] = ACTIONS(532),
    [anon_sym_noinline] = ACTIONS(532),
    [anon_sym_threadlocal] = ACTIONS(532),
    [anon_sym_usingnamespace] = ACTIONS(532),
    [anon_sym_fn] = ACTIONS(532),
    [anon_sym_BANG] = ACTIONS(532),
    [anon_sym_const] = ACTIONS(532),
    [anon_sym_var] = ACTIONS(532),
    [anon_sym_or] = ACTIONS(532),
    [anon_sym_and] = ACTIONS(532),
    [anon_sym_LBRACE] = ACTIONS(534),
    [anon_sym_RBRACE] = ACTIONS(534),
    [anon_sym_async] = ACTIONS(532),
    [anon_sym_DOT] = ACTIONS(532),
    [anon_sym_error] = ACTIONS(532),
    [anon_sym_false] = ACTIONS(532),
    [anon_sym_null] = ACTIONS(532),
    [anon_sym_anyframe] = ACTIONS(532),
    [anon_sym_true] = ACTIONS(532),
    [anon_sym_undefined] = ACTIONS(532),
    [anon_sym_unreachable] = ACTIONS(532),
    [sym_BuildinTypeExpr] = ACTIONS(532),
    [anon_sym_packed] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_switch] = ACTIONS(532),
    [anon_sym_LBRACK] = ACTIONS(534),
    [anon_sym_if] = ACTIONS(532),
    [anon_sym_while] = ACTIONS(532),
    [anon_sym_for] = ACTIONS(532),
    [anon_sym_PIPE] = ACTIONS(532),
    [anon_sym_STAR] = ACTIONS(532),
    [anon_sym_EQ_EQ] = ACTIONS(534),
    [anon_sym_BANG_EQ] = ACTIONS(534),
    [anon_sym_LT] = ACTIONS(532),
    [anon_sym_GT] = ACTIONS(532),
    [anon_sym_LT_EQ] = ACTIONS(534),
    [anon_sym_GT_EQ] = ACTIONS(534),
    [anon_sym_AMP] = ACTIONS(534),
    [anon_sym_CARET] = ACTIONS(534),
    [anon_sym_orelse] = ACTIONS(532),
    [anon_sym_catch] = ACTIONS(532),
    [anon_sym_LT_LT] = ACTIONS(532),
    [anon_sym_GT_GT] = ACTIONS(534),
    [anon_sym_LT_LT_PIPE] = ACTIONS(534),
    [anon_sym_PLUS] = ACTIONS(532),
    [anon_sym_DASH] = ACTIONS(532),
    [anon_sym_PLUS_PLUS] = ACTIONS(534),
    [anon_sym_PLUS_PERCENT] = ACTIONS(534),
    [anon_sym_DASH_PERCENT] = ACTIONS(534),
    [anon_sym_PLUS_PIPE] = ACTIONS(534),
    [anon_sym_DASH_PIPE] = ACTIONS(534),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [anon_sym_SLASH] = ACTIONS(532),
    [anon_sym_PERCENT] = ACTIONS(534),
    [anon_sym_STAR_STAR] = ACTIONS(534),
    [anon_sym_STAR_PERCENT] = ACTIONS(534),
    [anon_sym_STAR_PIPE] = ACTIONS(534),
    [anon_sym_QMARK] = ACTIONS(534),
    [anon_sym_DOT_STAR] = ACTIONS(534),
    [anon_sym_DOT_QMARK] = ACTIONS(534),
    [anon_sym_struct] = ACTIONS(532),
    [anon_sym_opaque] = ACTIONS(532),
    [anon_sym_enum] = ACTIONS(532),
    [anon_sym_union] = ACTIONS(532),
    [sym_doc_comment] = ACTIONS(534),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(534),
    [aux_sym_FLOAT_token1] = ACTIONS(534),
    [aux_sym_FLOAT_token2] = ACTIONS(534),
    [aux_sym_FLOAT_token3] = ACTIONS(534),
    [aux_sym_FLOAT_token4] = ACTIONS(534),
    [aux_sym_INTEGER_token1] = ACTIONS(534),
    [aux_sym_INTEGER_token2] = ACTIONS(534),
    [aux_sym_INTEGER_token3] = ACTIONS(532),
    [aux_sym_INTEGER_token4] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(534),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(534),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(532),
    [anon_sym_AT] = ACTIONS(534),
  },
  [621] = {
    [anon_sym_COMMA] = ACTIONS(556),
    [anon_sym_comptime] = ACTIONS(558),
    [anon_sym_extern] = ACTIONS(558),
    [anon_sym_inline] = ACTIONS(558),
    [anon_sym_fn] = ACTIONS(558),
    [anon_sym_BANG] = ACTIONS(558),
    [anon_sym_nosuspend] = ACTIONS(558),
    [anon_sym_else] = ACTIONS(558),
    [anon_sym_or] = ACTIONS(558),
    [anon_sym_and] = ACTIONS(558),
    [anon_sym_break] = ACTIONS(558),
    [anon_sym_continue] = ACTIONS(558),
    [anon_sym_resume] = ACTIONS(558),
    [anon_sym_return] = ACTIONS(558),
    [anon_sym_LBRACE] = ACTIONS(556),
    [anon_sym_async] = ACTIONS(558),
    [anon_sym_DOT] = ACTIONS(558),
    [anon_sym_error] = ACTIONS(558),
    [anon_sym_false] = ACTIONS(558),
    [anon_sym_null] = ACTIONS(558),
    [anon_sym_anyframe] = ACTIONS(558),
    [anon_sym_true] = ACTIONS(558),
    [anon_sym_undefined] = ACTIONS(558),
    [anon_sym_unreachable] = ACTIONS(558),
    [sym_BuildinTypeExpr] = ACTIONS(558),
    [anon_sym_packed] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_switch] = ACTIONS(558),
    [anon_sym_asm] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(556),
    [anon_sym_if] = ACTIONS(558),
    [anon_sym_while] = ACTIONS(558),
    [anon_sym_for] = ACTIONS(558),
    [anon_sym_PIPE] = ACTIONS(558),
    [anon_sym_STAR] = ACTIONS(558),
    [anon_sym_EQ_GT] = ACTIONS(556),
    [anon_sym_EQ_EQ] = ACTIONS(556),
    [anon_sym_BANG_EQ] = ACTIONS(556),
    [anon_sym_LT] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(558),
    [anon_sym_LT_EQ] = ACTIONS(556),
    [anon_sym_GT_EQ] = ACTIONS(556),
    [anon_sym_AMP] = ACTIONS(556),
    [anon_sym_CARET] = ACTIONS(556),
    [anon_sym_orelse] = ACTIONS(558),
    [anon_sym_catch] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(558),
    [anon_sym_GT_GT] = ACTIONS(556),
    [anon_sym_LT_LT_PIPE] = ACTIONS(556),
    [anon_sym_PLUS] = ACTIONS(558),
    [anon_sym_DASH] = ACTIONS(558),
    [anon_sym_PLUS_PLUS] = ACTIONS(556),
    [anon_sym_PLUS_PERCENT] = ACTIONS(556),
    [anon_sym_DASH_PERCENT] = ACTIONS(556),
    [anon_sym_PLUS_PIPE] = ACTIONS(556),
    [anon_sym_DASH_PIPE] = ACTIONS(556),
    [anon_sym_PIPE_PIPE] = ACTIONS(556),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_PERCENT] = ACTIONS(556),
    [anon_sym_STAR_STAR] = ACTIONS(556),
    [anon_sym_STAR_PERCENT] = ACTIONS(556),
    [anon_sym_STAR_PIPE] = ACTIONS(556),
    [anon_sym_TILDE] = ACTIONS(556),
    [anon_sym_try] = ACTIONS(558),
    [anon_sym_await] = ACTIONS(558),
    [anon_sym_QMARK] = ACTIONS(556),
    [anon_sym_struct] = ACTIONS(558),
    [anon_sym_opaque] = ACTIONS(558),
    [anon_sym_enum] = ACTIONS(558),
    [anon_sym_union] = ACTIONS(558),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(556),
    [aux_sym_FLOAT_token1] = ACTIONS(556),
    [aux_sym_FLOAT_token2] = ACTIONS(556),
    [aux_sym_FLOAT_token3] = ACTIONS(556),
    [aux_sym_FLOAT_token4] = ACTIONS(556),
    [aux_sym_INTEGER_token1] = ACTIONS(556),
    [aux_sym_INTEGER_token2] = ACTIONS(556),
    [aux_sym_INTEGER_token3] = ACTIONS(558),
    [aux_sym_INTEGER_token4] = ACTIONS(558),
    [anon_sym_DQUOTE] = ACTIONS(556),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(556),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(558),
    [anon_sym_AT] = ACTIONS(556),
  },
  [622] = {
    [anon_sym_COMMA] = ACTIONS(552),
    [anon_sym_comptime] = ACTIONS(554),
    [anon_sym_extern] = ACTIONS(554),
    [anon_sym_inline] = ACTIONS(554),
    [anon_sym_fn] = ACTIONS(554),
    [anon_sym_BANG] = ACTIONS(554),
    [anon_sym_nosuspend] = ACTIONS(554),
    [anon_sym_else] = ACTIONS(554),
    [anon_sym_or] = ACTIONS(554),
    [anon_sym_and] = ACTIONS(554),
    [anon_sym_break] = ACTIONS(554),
    [anon_sym_continue] = ACTIONS(554),
    [anon_sym_resume] = ACTIONS(554),
    [anon_sym_return] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(554),
    [anon_sym_DOT] = ACTIONS(554),
    [anon_sym_error] = ACTIONS(554),
    [anon_sym_false] = ACTIONS(554),
    [anon_sym_null] = ACTIONS(554),
    [anon_sym_anyframe] = ACTIONS(554),
    [anon_sym_true] = ACTIONS(554),
    [anon_sym_undefined] = ACTIONS(554),
    [anon_sym_unreachable] = ACTIONS(554),
    [sym_BuildinTypeExpr] = ACTIONS(554),
    [anon_sym_packed] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_switch] = ACTIONS(554),
    [anon_sym_asm] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(552),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(554),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_PIPE] = ACTIONS(554),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_EQ_GT] = ACTIONS(552),
    [anon_sym_EQ_EQ] = ACTIONS(552),
    [anon_sym_BANG_EQ] = ACTIONS(552),
    [anon_sym_LT] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(552),
    [anon_sym_GT_EQ] = ACTIONS(552),
    [anon_sym_AMP] = ACTIONS(552),
    [anon_sym_CARET] = ACTIONS(552),
    [anon_sym_orelse] = ACTIONS(554),
    [anon_sym_catch] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(554),
    [anon_sym_GT_GT] = ACTIONS(552),
    [anon_sym_LT_LT_PIPE] = ACTIONS(552),
    [anon_sym_PLUS] = ACTIONS(554),
    [anon_sym_DASH] = ACTIONS(554),
    [anon_sym_PLUS_PLUS] = ACTIONS(552),
    [anon_sym_PLUS_PERCENT] = ACTIONS(552),
    [anon_sym_DASH_PERCENT] = ACTIONS(552),
    [anon_sym_PLUS_PIPE] = ACTIONS(552),
    [anon_sym_DASH_PIPE] = ACTIONS(552),
    [anon_sym_PIPE_PIPE] = ACTIONS(552),
    [anon_sym_SLASH] = ACTIONS(554),
    [anon_sym_PERCENT] = ACTIONS(552),
    [anon_sym_STAR_STAR] = ACTIONS(552),
    [anon_sym_STAR_PERCENT] = ACTIONS(552),
    [anon_sym_STAR_PIPE] = ACTIONS(552),
    [anon_sym_TILDE] = ACTIONS(552),
    [anon_sym_try] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(554),
    [anon_sym_QMARK] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_opaque] = ACTIONS(554),
    [anon_sym_enum] = ACTIONS(554),
    [anon_sym_union] = ACTIONS(554),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [aux_sym_FLOAT_token1] = ACTIONS(552),
    [aux_sym_FLOAT_token2] = ACTIONS(552),
    [aux_sym_FLOAT_token3] = ACTIONS(552),
    [aux_sym_FLOAT_token4] = ACTIONS(552),
    [aux_sym_INTEGER_token1] = ACTIONS(552),
    [aux_sym_INTEGER_token2] = ACTIONS(552),
    [aux_sym_INTEGER_token3] = ACTIONS(554),
    [aux_sym_INTEGER_token4] = ACTIONS(554),
    [anon_sym_DQUOTE] = ACTIONS(552),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(552),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(552),
  },
  [623] = {
    [anon_sym_COMMA] = ACTIONS(560),
    [anon_sym_comptime] = ACTIONS(562),
    [anon_sym_extern] = ACTIONS(562),
    [anon_sym_inline] = ACTIONS(562),
    [anon_sym_fn] = ACTIONS(562),
    [anon_sym_BANG] = ACTIONS(562),
    [anon_sym_nosuspend] = ACTIONS(562),
    [anon_sym_else] = ACTIONS(562),
    [anon_sym_or] = ACTIONS(562),
    [anon_sym_and] = ACTIONS(562),
    [anon_sym_break] = ACTIONS(562),
    [anon_sym_continue] = ACTIONS(562),
    [anon_sym_resume] = ACTIONS(562),
    [anon_sym_return] = ACTIONS(562),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_async] = ACTIONS(562),
    [anon_sym_DOT] = ACTIONS(562),
    [anon_sym_error] = ACTIONS(562),
    [anon_sym_false] = ACTIONS(562),
    [anon_sym_null] = ACTIONS(562),
    [anon_sym_anyframe] = ACTIONS(562),
    [anon_sym_true] = ACTIONS(562),
    [anon_sym_undefined] = ACTIONS(562),
    [anon_sym_unreachable] = ACTIONS(562),
    [sym_BuildinTypeExpr] = ACTIONS(562),
    [anon_sym_packed] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(560),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_asm] = ACTIONS(562),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(560),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_while] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(562),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_STAR] = ACTIONS(562),
    [anon_sym_EQ_GT] = ACTIONS(560),
    [anon_sym_EQ_EQ] = ACTIONS(560),
    [anon_sym_BANG_EQ] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_LT_EQ] = ACTIONS(560),
    [anon_sym_GT_EQ] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(560),
    [anon_sym_CARET] = ACTIONS(560),
    [anon_sym_orelse] = ACTIONS(562),
    [anon_sym_catch] = ACTIONS(562),
    [anon_sym_LT_LT] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(560),
    [anon_sym_LT_LT_PIPE] = ACTIONS(560),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(560),
    [anon_sym_PLUS_PERCENT] = ACTIONS(560),
    [anon_sym_DASH_PERCENT] = ACTIONS(560),
    [anon_sym_PLUS_PIPE] = ACTIONS(560),
    [anon_sym_DASH_PIPE] = ACTIONS(560),
    [anon_sym_PIPE_PIPE] = ACTIONS(560),
    [anon_sym_SLASH] = ACTIONS(562),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_STAR_STAR] = ACTIONS(560),
    [anon_sym_STAR_PERCENT] = ACTIONS(560),
    [anon_sym_STAR_PIPE] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(560),
    [anon_sym_try] = ACTIONS(562),
    [anon_sym_await] = ACTIONS(562),
    [anon_sym_QMARK] = ACTIONS(560),
    [anon_sym_struct] = ACTIONS(562),
    [anon_sym_opaque] = ACTIONS(562),
    [anon_sym_enum] = ACTIONS(562),
    [anon_sym_union] = ACTIONS(562),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(560),
    [aux_sym_FLOAT_token1] = ACTIONS(560),
    [aux_sym_FLOAT_token2] = ACTIONS(560),
    [aux_sym_FLOAT_token3] = ACTIONS(560),
    [aux_sym_FLOAT_token4] = ACTIONS(560),
    [aux_sym_INTEGER_token1] = ACTIONS(560),
    [aux_sym_INTEGER_token2] = ACTIONS(560),
    [aux_sym_INTEGER_token3] = ACTIONS(562),
    [aux_sym_INTEGER_token4] = ACTIONS(562),
    [anon_sym_DQUOTE] = ACTIONS(560),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(560),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(562),
    [anon_sym_AT] = ACTIONS(560),
  },
  [624] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1528),
    [sym_ErrorUnionExpr] = STATE(1528),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_LinkSection] = STATE(741),
    [sym_AddrSpace] = STATE(691),
    [sym_CallConv] = STATE(767),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_ByteAlign] = STATE(664),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_addrspace] = ACTIONS(1483),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_align] = ACTIONS(1487),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [625] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1229),
    [sym_ErrorUnionExpr] = STATE(1229),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_LinkSection] = STATE(722),
    [sym_AddrSpace] = STATE(706),
    [sym_CallConv] = STATE(797),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_ByteAlign] = STATE(656),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_addrspace] = ACTIONS(1483),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_align] = ACTIONS(1487),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [626] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1225),
    [sym_ErrorUnionExpr] = STATE(1225),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_LinkSection] = STATE(711),
    [sym_AddrSpace] = STATE(695),
    [sym_CallConv] = STATE(765),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_ByteAlign] = STATE(667),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1495),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_addrspace] = ACTIONS(1483),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_align] = ACTIONS(1487),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [627] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(989),
    [sym_ErrorUnionExpr] = STATE(989),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_LinkSection] = STATE(710),
    [sym_AddrSpace] = STATE(693),
    [sym_CallConv] = STATE(772),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_ByteAlign] = STATE(660),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1501),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_addrspace] = ACTIONS(1483),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_align] = ACTIONS(1487),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [628] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(566),
    [sym_ErrorUnionExpr] = STATE(566),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_LinkSection] = STATE(736),
    [sym_AddrSpace] = STATE(701),
    [sym_CallConv] = STATE(775),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_ByteAlign] = STATE(648),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(1507),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_addrspace] = ACTIONS(1483),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_align] = ACTIONS(1487),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [629] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(581),
    [sym_ErrorUnionExpr] = STATE(581),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_LinkSection] = STATE(747),
    [sym_AddrSpace] = STATE(687),
    [sym_CallConv] = STATE(811),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_ByteAlign] = STATE(662),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_addrspace] = ACTIONS(1483),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_align] = ACTIONS(1487),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [630] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1498),
    [sym_ErrorUnionExpr] = STATE(1498),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_LinkSection] = STATE(726),
    [sym_AddrSpace] = STATE(708),
    [sym_CallConv] = STATE(791),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_ByteAlign] = STATE(647),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_addrspace] = ACTIONS(1483),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_align] = ACTIONS(1487),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [631] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(998),
    [sym_ErrorUnionExpr] = STATE(998),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_LinkSection] = STATE(742),
    [sym_AddrSpace] = STATE(690),
    [sym_CallConv] = STATE(770),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_ByteAlign] = STATE(669),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1513),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_addrspace] = ACTIONS(1483),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_align] = ACTIONS(1487),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [632] = {
    [anon_sym_COMMA] = ACTIONS(536),
    [anon_sym_comptime] = ACTIONS(538),
    [anon_sym_extern] = ACTIONS(538),
    [anon_sym_inline] = ACTIONS(538),
    [anon_sym_fn] = ACTIONS(538),
    [anon_sym_BANG] = ACTIONS(538),
    [anon_sym_nosuspend] = ACTIONS(538),
    [anon_sym_else] = ACTIONS(538),
    [anon_sym_or] = ACTIONS(538),
    [anon_sym_and] = ACTIONS(538),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(538),
    [anon_sym_resume] = ACTIONS(538),
    [anon_sym_return] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(536),
    [anon_sym_async] = ACTIONS(538),
    [anon_sym_DOT] = ACTIONS(538),
    [anon_sym_error] = ACTIONS(538),
    [anon_sym_false] = ACTIONS(538),
    [anon_sym_null] = ACTIONS(538),
    [anon_sym_anyframe] = ACTIONS(538),
    [anon_sym_true] = ACTIONS(538),
    [anon_sym_undefined] = ACTIONS(538),
    [anon_sym_unreachable] = ACTIONS(538),
    [sym_BuildinTypeExpr] = ACTIONS(538),
    [anon_sym_packed] = ACTIONS(538),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_switch] = ACTIONS(538),
    [anon_sym_asm] = ACTIONS(538),
    [anon_sym_LBRACK] = ACTIONS(536),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(536),
    [anon_sym_if] = ACTIONS(538),
    [anon_sym_while] = ACTIONS(538),
    [anon_sym_for] = ACTIONS(538),
    [anon_sym_PIPE] = ACTIONS(538),
    [anon_sym_STAR] = ACTIONS(538),
    [anon_sym_EQ_GT] = ACTIONS(536),
    [anon_sym_EQ_EQ] = ACTIONS(536),
    [anon_sym_BANG_EQ] = ACTIONS(536),
    [anon_sym_LT] = ACTIONS(538),
    [anon_sym_GT] = ACTIONS(538),
    [anon_sym_LT_EQ] = ACTIONS(536),
    [anon_sym_GT_EQ] = ACTIONS(536),
    [anon_sym_AMP] = ACTIONS(536),
    [anon_sym_CARET] = ACTIONS(536),
    [anon_sym_orelse] = ACTIONS(538),
    [anon_sym_catch] = ACTIONS(538),
    [anon_sym_LT_LT] = ACTIONS(538),
    [anon_sym_GT_GT] = ACTIONS(536),
    [anon_sym_LT_LT_PIPE] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(538),
    [anon_sym_DASH] = ACTIONS(538),
    [anon_sym_PLUS_PLUS] = ACTIONS(536),
    [anon_sym_PLUS_PERCENT] = ACTIONS(536),
    [anon_sym_DASH_PERCENT] = ACTIONS(536),
    [anon_sym_PLUS_PIPE] = ACTIONS(536),
    [anon_sym_DASH_PIPE] = ACTIONS(536),
    [anon_sym_PIPE_PIPE] = ACTIONS(536),
    [anon_sym_SLASH] = ACTIONS(538),
    [anon_sym_PERCENT] = ACTIONS(536),
    [anon_sym_STAR_STAR] = ACTIONS(536),
    [anon_sym_STAR_PERCENT] = ACTIONS(536),
    [anon_sym_STAR_PIPE] = ACTIONS(536),
    [anon_sym_TILDE] = ACTIONS(536),
    [anon_sym_try] = ACTIONS(538),
    [anon_sym_await] = ACTIONS(538),
    [anon_sym_QMARK] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_opaque] = ACTIONS(538),
    [anon_sym_enum] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(538),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(536),
    [aux_sym_FLOAT_token1] = ACTIONS(536),
    [aux_sym_FLOAT_token2] = ACTIONS(536),
    [aux_sym_FLOAT_token3] = ACTIONS(536),
    [aux_sym_FLOAT_token4] = ACTIONS(536),
    [aux_sym_INTEGER_token1] = ACTIONS(536),
    [aux_sym_INTEGER_token2] = ACTIONS(536),
    [aux_sym_INTEGER_token3] = ACTIONS(538),
    [aux_sym_INTEGER_token4] = ACTIONS(538),
    [anon_sym_DQUOTE] = ACTIONS(536),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(536),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(538),
    [anon_sym_AT] = ACTIONS(536),
  },
  [633] = {
    [sym_InitList] = STATE(658),
    [ts_builtin_sym_end] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(1039),
    [anon_sym_pub] = ACTIONS(1041),
    [anon_sym_test] = ACTIONS(1041),
    [anon_sym_comptime] = ACTIONS(1041),
    [anon_sym_export] = ACTIONS(1041),
    [anon_sym_extern] = ACTIONS(1041),
    [anon_sym_inline] = ACTIONS(1041),
    [anon_sym_noinline] = ACTIONS(1041),
    [anon_sym_threadlocal] = ACTIONS(1041),
    [anon_sym_usingnamespace] = ACTIONS(1041),
    [anon_sym_fn] = ACTIONS(1041),
    [anon_sym_const] = ACTIONS(1041),
    [anon_sym_var] = ACTIONS(1041),
    [anon_sym_else] = ACTIONS(1041),
    [anon_sym_or] = ACTIONS(1041),
    [anon_sym_and] = ACTIONS(1041),
    [anon_sym_LBRACE] = ACTIONS(1045),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_async] = ACTIONS(1041),
    [anon_sym_DOT] = ACTIONS(1039),
    [anon_sym_error] = ACTIONS(1041),
    [anon_sym_false] = ACTIONS(1041),
    [anon_sym_null] = ACTIONS(1041),
    [anon_sym_anyframe] = ACTIONS(1041),
    [anon_sym_true] = ACTIONS(1041),
    [anon_sym_undefined] = ACTIONS(1041),
    [anon_sym_unreachable] = ACTIONS(1041),
    [sym_BuildinTypeExpr] = ACTIONS(1041),
    [anon_sym_packed] = ACTIONS(1041),
    [anon_sym_LPAREN] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_while] = ACTIONS(1041),
    [anon_sym_for] = ACTIONS(1041),
    [anon_sym_PIPE] = ACTIONS(1041),
    [anon_sym_STAR] = ACTIONS(1041),
    [anon_sym_EQ_EQ] = ACTIONS(1039),
    [anon_sym_BANG_EQ] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_GT] = ACTIONS(1041),
    [anon_sym_LT_EQ] = ACTIONS(1039),
    [anon_sym_GT_EQ] = ACTIONS(1039),
    [anon_sym_AMP] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(1039),
    [anon_sym_orelse] = ACTIONS(1041),
    [anon_sym_catch] = ACTIONS(1041),
    [anon_sym_LT_LT] = ACTIONS(1041),
    [anon_sym_GT_GT] = ACTIONS(1039),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1039),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1039),
    [anon_sym_DASH_PERCENT] = ACTIONS(1039),
    [anon_sym_PLUS_PIPE] = ACTIONS(1039),
    [anon_sym_DASH_PIPE] = ACTIONS(1039),
    [anon_sym_PIPE_PIPE] = ACTIONS(1039),
    [anon_sym_SLASH] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1039),
    [anon_sym_STAR_STAR] = ACTIONS(1039),
    [anon_sym_STAR_PERCENT] = ACTIONS(1039),
    [anon_sym_STAR_PIPE] = ACTIONS(1039),
    [anon_sym_QMARK] = ACTIONS(1039),
    [anon_sym_struct] = ACTIONS(1041),
    [anon_sym_opaque] = ACTIONS(1041),
    [anon_sym_enum] = ACTIONS(1041),
    [anon_sym_union] = ACTIONS(1041),
    [sym_doc_comment] = ACTIONS(1039),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1039),
    [aux_sym_FLOAT_token1] = ACTIONS(1039),
    [aux_sym_FLOAT_token2] = ACTIONS(1039),
    [aux_sym_FLOAT_token3] = ACTIONS(1039),
    [aux_sym_FLOAT_token4] = ACTIONS(1039),
    [aux_sym_INTEGER_token1] = ACTIONS(1039),
    [aux_sym_INTEGER_token2] = ACTIONS(1039),
    [aux_sym_INTEGER_token3] = ACTIONS(1041),
    [aux_sym_INTEGER_token4] = ACTIONS(1041),
    [anon_sym_DQUOTE] = ACTIONS(1039),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1039),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(1039),
  },
  [634] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1115),
    [sym_ErrorUnionExpr] = STATE(1115),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_LinkSection] = STATE(732),
    [sym_AddrSpace] = STATE(699),
    [sym_CallConv] = STATE(778),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_ByteAlign] = STATE(663),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_addrspace] = ACTIONS(1483),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_align] = ACTIONS(1487),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [635] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(480),
    [sym_ErrorUnionExpr] = STATE(480),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_LinkSection] = STATE(719),
    [sym_AddrSpace] = STATE(688),
    [sym_CallConv] = STATE(794),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_ByteAlign] = STATE(661),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(1559),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_addrspace] = ACTIONS(1483),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_align] = ACTIONS(1487),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [636] = {
    [sym_BreakLabel] = STATE(670),
    [ts_builtin_sym_end] = ACTIONS(87),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_pub] = ACTIONS(101),
    [anon_sym_test] = ACTIONS(101),
    [anon_sym_comptime] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_extern] = ACTIONS(101),
    [anon_sym_inline] = ACTIONS(101),
    [anon_sym_noinline] = ACTIONS(101),
    [anon_sym_threadlocal] = ACTIONS(101),
    [anon_sym_usingnamespace] = ACTIONS(101),
    [anon_sym_fn] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_var] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(1561),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(87),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_error] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_null] = ACTIONS(101),
    [anon_sym_anyframe] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_undefined] = ACTIONS(101),
    [anon_sym_unreachable] = ACTIONS(101),
    [sym_BuildinTypeExpr] = ACTIONS(101),
    [anon_sym_packed] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(87),
    [anon_sym_switch] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_EQ_EQ] = ACTIONS(87),
    [anon_sym_BANG_EQ] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(101),
    [anon_sym_GT] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(87),
    [anon_sym_GT_EQ] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(87),
    [anon_sym_CARET] = ACTIONS(87),
    [anon_sym_orelse] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(87),
    [anon_sym_LT_LT_PIPE] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_PLUS_PERCENT] = ACTIONS(87),
    [anon_sym_DASH_PERCENT] = ACTIONS(87),
    [anon_sym_PLUS_PIPE] = ACTIONS(87),
    [anon_sym_DASH_PIPE] = ACTIONS(87),
    [anon_sym_PIPE_PIPE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(87),
    [anon_sym_STAR_STAR] = ACTIONS(87),
    [anon_sym_STAR_PERCENT] = ACTIONS(87),
    [anon_sym_STAR_PIPE] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(87),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_opaque] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(101),
    [sym_doc_comment] = ACTIONS(87),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [aux_sym_FLOAT_token1] = ACTIONS(87),
    [aux_sym_FLOAT_token2] = ACTIONS(87),
    [aux_sym_FLOAT_token3] = ACTIONS(87),
    [aux_sym_FLOAT_token4] = ACTIONS(87),
    [aux_sym_INTEGER_token1] = ACTIONS(87),
    [aux_sym_INTEGER_token2] = ACTIONS(87),
    [aux_sym_INTEGER_token3] = ACTIONS(101),
    [aux_sym_INTEGER_token4] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(87),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(87),
  },
  [637] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(502),
    [sym_ErrorUnionExpr] = STATE(502),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_LinkSection] = STATE(712),
    [sym_AddrSpace] = STATE(704),
    [sym_CallConv] = STATE(812),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_ByteAlign] = STATE(654),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_addrspace] = ACTIONS(1483),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_align] = ACTIONS(1487),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [638] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1116),
    [sym_ErrorUnionExpr] = STATE(1116),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_LinkSection] = STATE(737),
    [sym_AddrSpace] = STATE(697),
    [sym_CallConv] = STATE(768),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_ByteAlign] = STATE(650),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_addrspace] = ACTIONS(1483),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_align] = ACTIONS(1487),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [639] = {
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_comptime] = ACTIONS(578),
    [anon_sym_extern] = ACTIONS(578),
    [anon_sym_inline] = ACTIONS(578),
    [anon_sym_fn] = ACTIONS(578),
    [anon_sym_BANG] = ACTIONS(578),
    [anon_sym_nosuspend] = ACTIONS(578),
    [anon_sym_else] = ACTIONS(578),
    [anon_sym_or] = ACTIONS(578),
    [anon_sym_and] = ACTIONS(578),
    [anon_sym_break] = ACTIONS(578),
    [anon_sym_continue] = ACTIONS(578),
    [anon_sym_resume] = ACTIONS(578),
    [anon_sym_return] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(576),
    [anon_sym_async] = ACTIONS(578),
    [anon_sym_DOT] = ACTIONS(578),
    [anon_sym_error] = ACTIONS(578),
    [anon_sym_false] = ACTIONS(578),
    [anon_sym_null] = ACTIONS(578),
    [anon_sym_anyframe] = ACTIONS(578),
    [anon_sym_true] = ACTIONS(578),
    [anon_sym_undefined] = ACTIONS(578),
    [anon_sym_unreachable] = ACTIONS(578),
    [sym_BuildinTypeExpr] = ACTIONS(578),
    [anon_sym_packed] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(576),
    [anon_sym_switch] = ACTIONS(578),
    [anon_sym_asm] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(576),
    [anon_sym_if] = ACTIONS(578),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_for] = ACTIONS(578),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(578),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(576),
    [anon_sym_BANG_EQ] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_GT] = ACTIONS(578),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_AMP] = ACTIONS(576),
    [anon_sym_CARET] = ACTIONS(576),
    [anon_sym_orelse] = ACTIONS(578),
    [anon_sym_catch] = ACTIONS(578),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_GT_GT] = ACTIONS(576),
    [anon_sym_LT_LT_PIPE] = ACTIONS(576),
    [anon_sym_PLUS] = ACTIONS(578),
    [anon_sym_DASH] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_PLUS_PERCENT] = ACTIONS(576),
    [anon_sym_DASH_PERCENT] = ACTIONS(576),
    [anon_sym_PLUS_PIPE] = ACTIONS(576),
    [anon_sym_DASH_PIPE] = ACTIONS(576),
    [anon_sym_PIPE_PIPE] = ACTIONS(576),
    [anon_sym_SLASH] = ACTIONS(578),
    [anon_sym_PERCENT] = ACTIONS(576),
    [anon_sym_STAR_STAR] = ACTIONS(576),
    [anon_sym_STAR_PERCENT] = ACTIONS(576),
    [anon_sym_STAR_PIPE] = ACTIONS(576),
    [anon_sym_TILDE] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(578),
    [anon_sym_await] = ACTIONS(578),
    [anon_sym_QMARK] = ACTIONS(576),
    [anon_sym_struct] = ACTIONS(578),
    [anon_sym_opaque] = ACTIONS(578),
    [anon_sym_enum] = ACTIONS(578),
    [anon_sym_union] = ACTIONS(578),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(576),
    [aux_sym_FLOAT_token1] = ACTIONS(576),
    [aux_sym_FLOAT_token2] = ACTIONS(576),
    [aux_sym_FLOAT_token3] = ACTIONS(576),
    [aux_sym_FLOAT_token4] = ACTIONS(576),
    [aux_sym_INTEGER_token1] = ACTIONS(576),
    [aux_sym_INTEGER_token2] = ACTIONS(576),
    [aux_sym_INTEGER_token3] = ACTIONS(578),
    [aux_sym_INTEGER_token4] = ACTIONS(578),
    [anon_sym_DQUOTE] = ACTIONS(576),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(576),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(578),
    [anon_sym_AT] = ACTIONS(576),
  },
  [640] = {
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_comptime] = ACTIONS(578),
    [anon_sym_extern] = ACTIONS(578),
    [anon_sym_inline] = ACTIONS(578),
    [anon_sym_fn] = ACTIONS(578),
    [anon_sym_BANG] = ACTIONS(578),
    [anon_sym_nosuspend] = ACTIONS(578),
    [anon_sym_or] = ACTIONS(578),
    [anon_sym_and] = ACTIONS(578),
    [anon_sym_break] = ACTIONS(578),
    [anon_sym_continue] = ACTIONS(578),
    [anon_sym_resume] = ACTIONS(578),
    [anon_sym_return] = ACTIONS(578),
    [anon_sym_LBRACE] = ACTIONS(576),
    [anon_sym_async] = ACTIONS(578),
    [anon_sym_DOT] = ACTIONS(578),
    [anon_sym_error] = ACTIONS(578),
    [anon_sym_false] = ACTIONS(578),
    [anon_sym_null] = ACTIONS(578),
    [anon_sym_anyframe] = ACTIONS(578),
    [anon_sym_true] = ACTIONS(578),
    [anon_sym_undefined] = ACTIONS(578),
    [anon_sym_unreachable] = ACTIONS(578),
    [sym_BuildinTypeExpr] = ACTIONS(578),
    [anon_sym_packed] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(576),
    [anon_sym_switch] = ACTIONS(578),
    [anon_sym_asm] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(576),
    [anon_sym_if] = ACTIONS(578),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_for] = ACTIONS(578),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(578),
    [anon_sym_EQ_GT] = ACTIONS(576),
    [anon_sym_EQ_EQ] = ACTIONS(576),
    [anon_sym_BANG_EQ] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_GT] = ACTIONS(578),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_AMP] = ACTIONS(576),
    [anon_sym_CARET] = ACTIONS(576),
    [anon_sym_orelse] = ACTIONS(578),
    [anon_sym_catch] = ACTIONS(578),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_GT_GT] = ACTIONS(576),
    [anon_sym_LT_LT_PIPE] = ACTIONS(576),
    [anon_sym_PLUS] = ACTIONS(578),
    [anon_sym_DASH] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_PLUS_PERCENT] = ACTIONS(576),
    [anon_sym_DASH_PERCENT] = ACTIONS(576),
    [anon_sym_PLUS_PIPE] = ACTIONS(576),
    [anon_sym_DASH_PIPE] = ACTIONS(576),
    [anon_sym_PIPE_PIPE] = ACTIONS(576),
    [anon_sym_SLASH] = ACTIONS(578),
    [anon_sym_PERCENT] = ACTIONS(576),
    [anon_sym_STAR_STAR] = ACTIONS(576),
    [anon_sym_STAR_PERCENT] = ACTIONS(576),
    [anon_sym_STAR_PIPE] = ACTIONS(576),
    [anon_sym_TILDE] = ACTIONS(576),
    [anon_sym_try] = ACTIONS(578),
    [anon_sym_await] = ACTIONS(578),
    [anon_sym_QMARK] = ACTIONS(576),
    [anon_sym_struct] = ACTIONS(578),
    [anon_sym_opaque] = ACTIONS(578),
    [anon_sym_enum] = ACTIONS(578),
    [anon_sym_union] = ACTIONS(578),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(576),
    [aux_sym_FLOAT_token1] = ACTIONS(576),
    [aux_sym_FLOAT_token2] = ACTIONS(576),
    [aux_sym_FLOAT_token3] = ACTIONS(576),
    [aux_sym_FLOAT_token4] = ACTIONS(576),
    [aux_sym_INTEGER_token1] = ACTIONS(576),
    [aux_sym_INTEGER_token2] = ACTIONS(576),
    [aux_sym_INTEGER_token3] = ACTIONS(578),
    [aux_sym_INTEGER_token4] = ACTIONS(578),
    [anon_sym_DQUOTE] = ACTIONS(576),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(576),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(578),
    [anon_sym_AT] = ACTIONS(576),
  },
  [641] = {
    [anon_sym_COMMA] = ACTIONS(560),
    [anon_sym_comptime] = ACTIONS(562),
    [anon_sym_extern] = ACTIONS(562),
    [anon_sym_inline] = ACTIONS(562),
    [anon_sym_fn] = ACTIONS(562),
    [anon_sym_BANG] = ACTIONS(562),
    [anon_sym_nosuspend] = ACTIONS(562),
    [anon_sym_or] = ACTIONS(562),
    [anon_sym_and] = ACTIONS(562),
    [anon_sym_break] = ACTIONS(562),
    [anon_sym_continue] = ACTIONS(562),
    [anon_sym_resume] = ACTIONS(562),
    [anon_sym_return] = ACTIONS(562),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_async] = ACTIONS(562),
    [anon_sym_DOT] = ACTIONS(562),
    [anon_sym_error] = ACTIONS(562),
    [anon_sym_false] = ACTIONS(562),
    [anon_sym_null] = ACTIONS(562),
    [anon_sym_anyframe] = ACTIONS(562),
    [anon_sym_true] = ACTIONS(562),
    [anon_sym_undefined] = ACTIONS(562),
    [anon_sym_unreachable] = ACTIONS(562),
    [sym_BuildinTypeExpr] = ACTIONS(562),
    [anon_sym_packed] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(560),
    [anon_sym_switch] = ACTIONS(562),
    [anon_sym_asm] = ACTIONS(562),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(560),
    [anon_sym_if] = ACTIONS(562),
    [anon_sym_while] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(562),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_STAR] = ACTIONS(562),
    [anon_sym_EQ_GT] = ACTIONS(560),
    [anon_sym_EQ_EQ] = ACTIONS(560),
    [anon_sym_BANG_EQ] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_LT_EQ] = ACTIONS(560),
    [anon_sym_GT_EQ] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(560),
    [anon_sym_CARET] = ACTIONS(560),
    [anon_sym_orelse] = ACTIONS(562),
    [anon_sym_catch] = ACTIONS(562),
    [anon_sym_LT_LT] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(560),
    [anon_sym_LT_LT_PIPE] = ACTIONS(560),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(560),
    [anon_sym_PLUS_PERCENT] = ACTIONS(560),
    [anon_sym_DASH_PERCENT] = ACTIONS(560),
    [anon_sym_PLUS_PIPE] = ACTIONS(560),
    [anon_sym_DASH_PIPE] = ACTIONS(560),
    [anon_sym_PIPE_PIPE] = ACTIONS(560),
    [anon_sym_SLASH] = ACTIONS(562),
    [anon_sym_PERCENT] = ACTIONS(560),
    [anon_sym_STAR_STAR] = ACTIONS(560),
    [anon_sym_STAR_PERCENT] = ACTIONS(560),
    [anon_sym_STAR_PIPE] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(560),
    [anon_sym_try] = ACTIONS(562),
    [anon_sym_await] = ACTIONS(562),
    [anon_sym_QMARK] = ACTIONS(560),
    [anon_sym_struct] = ACTIONS(562),
    [anon_sym_opaque] = ACTIONS(562),
    [anon_sym_enum] = ACTIONS(562),
    [anon_sym_union] = ACTIONS(562),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(560),
    [aux_sym_FLOAT_token1] = ACTIONS(560),
    [aux_sym_FLOAT_token2] = ACTIONS(560),
    [aux_sym_FLOAT_token3] = ACTIONS(560),
    [aux_sym_FLOAT_token4] = ACTIONS(560),
    [aux_sym_INTEGER_token1] = ACTIONS(560),
    [aux_sym_INTEGER_token2] = ACTIONS(560),
    [aux_sym_INTEGER_token3] = ACTIONS(562),
    [aux_sym_INTEGER_token4] = ACTIONS(562),
    [anon_sym_DQUOTE] = ACTIONS(560),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(560),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(562),
    [anon_sym_AT] = ACTIONS(560),
  },
  [642] = {
    [anon_sym_COMMA] = ACTIONS(556),
    [anon_sym_comptime] = ACTIONS(558),
    [anon_sym_extern] = ACTIONS(558),
    [anon_sym_inline] = ACTIONS(558),
    [anon_sym_fn] = ACTIONS(558),
    [anon_sym_BANG] = ACTIONS(558),
    [anon_sym_nosuspend] = ACTIONS(558),
    [anon_sym_or] = ACTIONS(558),
    [anon_sym_and] = ACTIONS(558),
    [anon_sym_break] = ACTIONS(558),
    [anon_sym_continue] = ACTIONS(558),
    [anon_sym_resume] = ACTIONS(558),
    [anon_sym_return] = ACTIONS(558),
    [anon_sym_LBRACE] = ACTIONS(556),
    [anon_sym_async] = ACTIONS(558),
    [anon_sym_DOT] = ACTIONS(558),
    [anon_sym_error] = ACTIONS(558),
    [anon_sym_false] = ACTIONS(558),
    [anon_sym_null] = ACTIONS(558),
    [anon_sym_anyframe] = ACTIONS(558),
    [anon_sym_true] = ACTIONS(558),
    [anon_sym_undefined] = ACTIONS(558),
    [anon_sym_unreachable] = ACTIONS(558),
    [sym_BuildinTypeExpr] = ACTIONS(558),
    [anon_sym_packed] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_switch] = ACTIONS(558),
    [anon_sym_asm] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(556),
    [anon_sym_if] = ACTIONS(558),
    [anon_sym_while] = ACTIONS(558),
    [anon_sym_for] = ACTIONS(558),
    [anon_sym_PIPE] = ACTIONS(558),
    [anon_sym_STAR] = ACTIONS(558),
    [anon_sym_EQ_GT] = ACTIONS(556),
    [anon_sym_EQ_EQ] = ACTIONS(556),
    [anon_sym_BANG_EQ] = ACTIONS(556),
    [anon_sym_LT] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(558),
    [anon_sym_LT_EQ] = ACTIONS(556),
    [anon_sym_GT_EQ] = ACTIONS(556),
    [anon_sym_AMP] = ACTIONS(556),
    [anon_sym_CARET] = ACTIONS(556),
    [anon_sym_orelse] = ACTIONS(558),
    [anon_sym_catch] = ACTIONS(558),
    [anon_sym_LT_LT] = ACTIONS(558),
    [anon_sym_GT_GT] = ACTIONS(556),
    [anon_sym_LT_LT_PIPE] = ACTIONS(556),
    [anon_sym_PLUS] = ACTIONS(558),
    [anon_sym_DASH] = ACTIONS(558),
    [anon_sym_PLUS_PLUS] = ACTIONS(556),
    [anon_sym_PLUS_PERCENT] = ACTIONS(556),
    [anon_sym_DASH_PERCENT] = ACTIONS(556),
    [anon_sym_PLUS_PIPE] = ACTIONS(556),
    [anon_sym_DASH_PIPE] = ACTIONS(556),
    [anon_sym_PIPE_PIPE] = ACTIONS(556),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_PERCENT] = ACTIONS(556),
    [anon_sym_STAR_STAR] = ACTIONS(556),
    [anon_sym_STAR_PERCENT] = ACTIONS(556),
    [anon_sym_STAR_PIPE] = ACTIONS(556),
    [anon_sym_TILDE] = ACTIONS(556),
    [anon_sym_try] = ACTIONS(558),
    [anon_sym_await] = ACTIONS(558),
    [anon_sym_QMARK] = ACTIONS(556),
    [anon_sym_struct] = ACTIONS(558),
    [anon_sym_opaque] = ACTIONS(558),
    [anon_sym_enum] = ACTIONS(558),
    [anon_sym_union] = ACTIONS(558),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(556),
    [aux_sym_FLOAT_token1] = ACTIONS(556),
    [aux_sym_FLOAT_token2] = ACTIONS(556),
    [aux_sym_FLOAT_token3] = ACTIONS(556),
    [aux_sym_FLOAT_token4] = ACTIONS(556),
    [aux_sym_INTEGER_token1] = ACTIONS(556),
    [aux_sym_INTEGER_token2] = ACTIONS(556),
    [aux_sym_INTEGER_token3] = ACTIONS(558),
    [aux_sym_INTEGER_token4] = ACTIONS(558),
    [anon_sym_DQUOTE] = ACTIONS(556),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(556),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(558),
    [anon_sym_AT] = ACTIONS(556),
  },
  [643] = {
    [sym_BreakLabel] = STATE(682),
    [ts_builtin_sym_end] = ACTIONS(87),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_pub] = ACTIONS(101),
    [anon_sym_test] = ACTIONS(101),
    [anon_sym_comptime] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_extern] = ACTIONS(101),
    [anon_sym_inline] = ACTIONS(101),
    [anon_sym_noinline] = ACTIONS(101),
    [anon_sym_threadlocal] = ACTIONS(101),
    [anon_sym_usingnamespace] = ACTIONS(101),
    [anon_sym_fn] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_var] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(1567),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(87),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_error] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [anon_sym_null] = ACTIONS(101),
    [anon_sym_anyframe] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_undefined] = ACTIONS(101),
    [anon_sym_unreachable] = ACTIONS(101),
    [sym_BuildinTypeExpr] = ACTIONS(101),
    [anon_sym_packed] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(87),
    [anon_sym_switch] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(87),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(101),
    [anon_sym_EQ_EQ] = ACTIONS(87),
    [anon_sym_BANG_EQ] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(101),
    [anon_sym_GT] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(87),
    [anon_sym_GT_EQ] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(87),
    [anon_sym_CARET] = ACTIONS(87),
    [anon_sym_orelse] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(87),
    [anon_sym_LT_LT_PIPE] = ACTIONS(87),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(87),
    [anon_sym_PLUS_PERCENT] = ACTIONS(87),
    [anon_sym_DASH_PERCENT] = ACTIONS(87),
    [anon_sym_PLUS_PIPE] = ACTIONS(87),
    [anon_sym_DASH_PIPE] = ACTIONS(87),
    [anon_sym_PIPE_PIPE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(87),
    [anon_sym_STAR_STAR] = ACTIONS(87),
    [anon_sym_STAR_PERCENT] = ACTIONS(87),
    [anon_sym_STAR_PIPE] = ACTIONS(87),
    [anon_sym_QMARK] = ACTIONS(87),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_opaque] = ACTIONS(101),
    [anon_sym_enum] = ACTIONS(101),
    [anon_sym_union] = ACTIONS(101),
    [sym_doc_comment] = ACTIONS(87),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [aux_sym_FLOAT_token1] = ACTIONS(87),
    [aux_sym_FLOAT_token2] = ACTIONS(87),
    [aux_sym_FLOAT_token3] = ACTIONS(87),
    [aux_sym_FLOAT_token4] = ACTIONS(87),
    [aux_sym_INTEGER_token1] = ACTIONS(87),
    [aux_sym_INTEGER_token2] = ACTIONS(87),
    [aux_sym_INTEGER_token3] = ACTIONS(101),
    [aux_sym_INTEGER_token4] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(87),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(87),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(87),
  },
  [644] = {
    [anon_sym_COMMA] = ACTIONS(536),
    [anon_sym_comptime] = ACTIONS(538),
    [anon_sym_extern] = ACTIONS(538),
    [anon_sym_inline] = ACTIONS(538),
    [anon_sym_fn] = ACTIONS(538),
    [anon_sym_BANG] = ACTIONS(538),
    [anon_sym_nosuspend] = ACTIONS(538),
    [anon_sym_or] = ACTIONS(538),
    [anon_sym_and] = ACTIONS(538),
    [anon_sym_break] = ACTIONS(538),
    [anon_sym_continue] = ACTIONS(538),
    [anon_sym_resume] = ACTIONS(538),
    [anon_sym_return] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(536),
    [anon_sym_async] = ACTIONS(538),
    [anon_sym_DOT] = ACTIONS(538),
    [anon_sym_error] = ACTIONS(538),
    [anon_sym_false] = ACTIONS(538),
    [anon_sym_null] = ACTIONS(538),
    [anon_sym_anyframe] = ACTIONS(538),
    [anon_sym_true] = ACTIONS(538),
    [anon_sym_undefined] = ACTIONS(538),
    [anon_sym_unreachable] = ACTIONS(538),
    [sym_BuildinTypeExpr] = ACTIONS(538),
    [anon_sym_packed] = ACTIONS(538),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_switch] = ACTIONS(538),
    [anon_sym_asm] = ACTIONS(538),
    [anon_sym_LBRACK] = ACTIONS(536),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(536),
    [anon_sym_if] = ACTIONS(538),
    [anon_sym_while] = ACTIONS(538),
    [anon_sym_for] = ACTIONS(538),
    [anon_sym_PIPE] = ACTIONS(538),
    [anon_sym_STAR] = ACTIONS(538),
    [anon_sym_EQ_GT] = ACTIONS(536),
    [anon_sym_EQ_EQ] = ACTIONS(536),
    [anon_sym_BANG_EQ] = ACTIONS(536),
    [anon_sym_LT] = ACTIONS(538),
    [anon_sym_GT] = ACTIONS(538),
    [anon_sym_LT_EQ] = ACTIONS(536),
    [anon_sym_GT_EQ] = ACTIONS(536),
    [anon_sym_AMP] = ACTIONS(536),
    [anon_sym_CARET] = ACTIONS(536),
    [anon_sym_orelse] = ACTIONS(538),
    [anon_sym_catch] = ACTIONS(538),
    [anon_sym_LT_LT] = ACTIONS(538),
    [anon_sym_GT_GT] = ACTIONS(536),
    [anon_sym_LT_LT_PIPE] = ACTIONS(536),
    [anon_sym_PLUS] = ACTIONS(538),
    [anon_sym_DASH] = ACTIONS(538),
    [anon_sym_PLUS_PLUS] = ACTIONS(536),
    [anon_sym_PLUS_PERCENT] = ACTIONS(536),
    [anon_sym_DASH_PERCENT] = ACTIONS(536),
    [anon_sym_PLUS_PIPE] = ACTIONS(536),
    [anon_sym_DASH_PIPE] = ACTIONS(536),
    [anon_sym_PIPE_PIPE] = ACTIONS(536),
    [anon_sym_SLASH] = ACTIONS(538),
    [anon_sym_PERCENT] = ACTIONS(536),
    [anon_sym_STAR_STAR] = ACTIONS(536),
    [anon_sym_STAR_PERCENT] = ACTIONS(536),
    [anon_sym_STAR_PIPE] = ACTIONS(536),
    [anon_sym_TILDE] = ACTIONS(536),
    [anon_sym_try] = ACTIONS(538),
    [anon_sym_await] = ACTIONS(538),
    [anon_sym_QMARK] = ACTIONS(536),
    [anon_sym_struct] = ACTIONS(538),
    [anon_sym_opaque] = ACTIONS(538),
    [anon_sym_enum] = ACTIONS(538),
    [anon_sym_union] = ACTIONS(538),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(536),
    [aux_sym_FLOAT_token1] = ACTIONS(536),
    [aux_sym_FLOAT_token2] = ACTIONS(536),
    [aux_sym_FLOAT_token3] = ACTIONS(536),
    [aux_sym_FLOAT_token4] = ACTIONS(536),
    [aux_sym_INTEGER_token1] = ACTIONS(536),
    [aux_sym_INTEGER_token2] = ACTIONS(536),
    [aux_sym_INTEGER_token3] = ACTIONS(538),
    [aux_sym_INTEGER_token4] = ACTIONS(538),
    [anon_sym_DQUOTE] = ACTIONS(536),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(536),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(538),
    [anon_sym_AT] = ACTIONS(536),
  },
  [645] = {
    [anon_sym_COMMA] = ACTIONS(552),
    [anon_sym_comptime] = ACTIONS(554),
    [anon_sym_extern] = ACTIONS(554),
    [anon_sym_inline] = ACTIONS(554),
    [anon_sym_fn] = ACTIONS(554),
    [anon_sym_BANG] = ACTIONS(554),
    [anon_sym_nosuspend] = ACTIONS(554),
    [anon_sym_or] = ACTIONS(554),
    [anon_sym_and] = ACTIONS(554),
    [anon_sym_break] = ACTIONS(554),
    [anon_sym_continue] = ACTIONS(554),
    [anon_sym_resume] = ACTIONS(554),
    [anon_sym_return] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(552),
    [anon_sym_async] = ACTIONS(554),
    [anon_sym_DOT] = ACTIONS(554),
    [anon_sym_error] = ACTIONS(554),
    [anon_sym_false] = ACTIONS(554),
    [anon_sym_null] = ACTIONS(554),
    [anon_sym_anyframe] = ACTIONS(554),
    [anon_sym_true] = ACTIONS(554),
    [anon_sym_undefined] = ACTIONS(554),
    [anon_sym_unreachable] = ACTIONS(554),
    [sym_BuildinTypeExpr] = ACTIONS(554),
    [anon_sym_packed] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_switch] = ACTIONS(554),
    [anon_sym_asm] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(552),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(554),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_for] = ACTIONS(554),
    [anon_sym_PIPE] = ACTIONS(554),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_EQ_GT] = ACTIONS(552),
    [anon_sym_EQ_EQ] = ACTIONS(552),
    [anon_sym_BANG_EQ] = ACTIONS(552),
    [anon_sym_LT] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(552),
    [anon_sym_GT_EQ] = ACTIONS(552),
    [anon_sym_AMP] = ACTIONS(552),
    [anon_sym_CARET] = ACTIONS(552),
    [anon_sym_orelse] = ACTIONS(554),
    [anon_sym_catch] = ACTIONS(554),
    [anon_sym_LT_LT] = ACTIONS(554),
    [anon_sym_GT_GT] = ACTIONS(552),
    [anon_sym_LT_LT_PIPE] = ACTIONS(552),
    [anon_sym_PLUS] = ACTIONS(554),
    [anon_sym_DASH] = ACTIONS(554),
    [anon_sym_PLUS_PLUS] = ACTIONS(552),
    [anon_sym_PLUS_PERCENT] = ACTIONS(552),
    [anon_sym_DASH_PERCENT] = ACTIONS(552),
    [anon_sym_PLUS_PIPE] = ACTIONS(552),
    [anon_sym_DASH_PIPE] = ACTIONS(552),
    [anon_sym_PIPE_PIPE] = ACTIONS(552),
    [anon_sym_SLASH] = ACTIONS(554),
    [anon_sym_PERCENT] = ACTIONS(552),
    [anon_sym_STAR_STAR] = ACTIONS(552),
    [anon_sym_STAR_PERCENT] = ACTIONS(552),
    [anon_sym_STAR_PIPE] = ACTIONS(552),
    [anon_sym_TILDE] = ACTIONS(552),
    [anon_sym_try] = ACTIONS(554),
    [anon_sym_await] = ACTIONS(554),
    [anon_sym_QMARK] = ACTIONS(552),
    [anon_sym_struct] = ACTIONS(554),
    [anon_sym_opaque] = ACTIONS(554),
    [anon_sym_enum] = ACTIONS(554),
    [anon_sym_union] = ACTIONS(554),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(552),
    [aux_sym_FLOAT_token1] = ACTIONS(552),
    [aux_sym_FLOAT_token2] = ACTIONS(552),
    [aux_sym_FLOAT_token3] = ACTIONS(552),
    [aux_sym_FLOAT_token4] = ACTIONS(552),
    [aux_sym_INTEGER_token1] = ACTIONS(552),
    [aux_sym_INTEGER_token2] = ACTIONS(552),
    [aux_sym_INTEGER_token3] = ACTIONS(554),
    [aux_sym_INTEGER_token4] = ACTIONS(554),
    [anon_sym_DQUOTE] = ACTIONS(552),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(552),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(552),
  },
  [646] = {
    [sym_InitList] = STATE(677),
    [ts_builtin_sym_end] = ACTIONS(1039),
    [anon_sym_COMMA] = ACTIONS(1039),
    [anon_sym_pub] = ACTIONS(1041),
    [anon_sym_test] = ACTIONS(1041),
    [anon_sym_comptime] = ACTIONS(1041),
    [anon_sym_export] = ACTIONS(1041),
    [anon_sym_extern] = ACTIONS(1041),
    [anon_sym_inline] = ACTIONS(1041),
    [anon_sym_noinline] = ACTIONS(1041),
    [anon_sym_threadlocal] = ACTIONS(1041),
    [anon_sym_usingnamespace] = ACTIONS(1041),
    [anon_sym_fn] = ACTIONS(1041),
    [anon_sym_const] = ACTIONS(1041),
    [anon_sym_var] = ACTIONS(1041),
    [anon_sym_or] = ACTIONS(1041),
    [anon_sym_and] = ACTIONS(1041),
    [anon_sym_LBRACE] = ACTIONS(1125),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_async] = ACTIONS(1041),
    [anon_sym_DOT] = ACTIONS(1039),
    [anon_sym_error] = ACTIONS(1041),
    [anon_sym_false] = ACTIONS(1041),
    [anon_sym_null] = ACTIONS(1041),
    [anon_sym_anyframe] = ACTIONS(1041),
    [anon_sym_true] = ACTIONS(1041),
    [anon_sym_undefined] = ACTIONS(1041),
    [anon_sym_unreachable] = ACTIONS(1041),
    [sym_BuildinTypeExpr] = ACTIONS(1041),
    [anon_sym_packed] = ACTIONS(1041),
    [anon_sym_LPAREN] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(1041),
    [anon_sym_LBRACK] = ACTIONS(1039),
    [anon_sym_if] = ACTIONS(1041),
    [anon_sym_while] = ACTIONS(1041),
    [anon_sym_for] = ACTIONS(1041),
    [anon_sym_PIPE] = ACTIONS(1041),
    [anon_sym_STAR] = ACTIONS(1041),
    [anon_sym_EQ_EQ] = ACTIONS(1039),
    [anon_sym_BANG_EQ] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_GT] = ACTIONS(1041),
    [anon_sym_LT_EQ] = ACTIONS(1039),
    [anon_sym_GT_EQ] = ACTIONS(1039),
    [anon_sym_AMP] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(1039),
    [anon_sym_orelse] = ACTIONS(1041),
    [anon_sym_catch] = ACTIONS(1041),
    [anon_sym_LT_LT] = ACTIONS(1041),
    [anon_sym_GT_GT] = ACTIONS(1039),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1039),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1039),
    [anon_sym_DASH_PERCENT] = ACTIONS(1039),
    [anon_sym_PLUS_PIPE] = ACTIONS(1039),
    [anon_sym_DASH_PIPE] = ACTIONS(1039),
    [anon_sym_PIPE_PIPE] = ACTIONS(1039),
    [anon_sym_SLASH] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1039),
    [anon_sym_STAR_STAR] = ACTIONS(1039),
    [anon_sym_STAR_PERCENT] = ACTIONS(1039),
    [anon_sym_STAR_PIPE] = ACTIONS(1039),
    [anon_sym_QMARK] = ACTIONS(1039),
    [anon_sym_struct] = ACTIONS(1041),
    [anon_sym_opaque] = ACTIONS(1041),
    [anon_sym_enum] = ACTIONS(1041),
    [anon_sym_union] = ACTIONS(1041),
    [sym_doc_comment] = ACTIONS(1039),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1039),
    [aux_sym_FLOAT_token1] = ACTIONS(1039),
    [aux_sym_FLOAT_token2] = ACTIONS(1039),
    [aux_sym_FLOAT_token3] = ACTIONS(1039),
    [aux_sym_FLOAT_token4] = ACTIONS(1039),
    [aux_sym_INTEGER_token1] = ACTIONS(1039),
    [aux_sym_INTEGER_token2] = ACTIONS(1039),
    [aux_sym_INTEGER_token3] = ACTIONS(1041),
    [aux_sym_INTEGER_token4] = ACTIONS(1041),
    [anon_sym_DQUOTE] = ACTIONS(1039),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1039),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(1039),
  },
  [647] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1487),
    [sym_ErrorUnionExpr] = STATE(1487),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_LinkSection] = STATE(735),
    [sym_AddrSpace] = STATE(685),
    [sym_CallConv] = STATE(766),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_addrspace] = ACTIONS(1483),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [648] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(580),
    [sym_ErrorUnionExpr] = STATE(580),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_LinkSection] = STATE(744),
    [sym_AddrSpace] = STATE(696),
    [sym_CallConv] = STATE(792),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_addrspace] = ACTIONS(1483),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [649] = {
    [ts_builtin_sym_end] = ACTIONS(1573),
    [anon_sym_COMMA] = ACTIONS(1573),
    [anon_sym_pub] = ACTIONS(1575),
    [anon_sym_test] = ACTIONS(1575),
    [anon_sym_comptime] = ACTIONS(1575),
    [anon_sym_export] = ACTIONS(1575),
    [anon_sym_extern] = ACTIONS(1575),
    [anon_sym_inline] = ACTIONS(1575),
    [anon_sym_noinline] = ACTIONS(1575),
    [anon_sym_threadlocal] = ACTIONS(1575),
    [anon_sym_usingnamespace] = ACTIONS(1575),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_const] = ACTIONS(1575),
    [anon_sym_var] = ACTIONS(1575),
    [anon_sym_else] = ACTIONS(1575),
    [anon_sym_or] = ACTIONS(1575),
    [anon_sym_and] = ACTIONS(1575),
    [anon_sym_RBRACE] = ACTIONS(1573),
    [anon_sym_async] = ACTIONS(1575),
    [anon_sym_DOT] = ACTIONS(1573),
    [anon_sym_error] = ACTIONS(1575),
    [anon_sym_false] = ACTIONS(1575),
    [anon_sym_null] = ACTIONS(1575),
    [anon_sym_anyframe] = ACTIONS(1575),
    [anon_sym_true] = ACTIONS(1575),
    [anon_sym_undefined] = ACTIONS(1575),
    [anon_sym_unreachable] = ACTIONS(1575),
    [sym_BuildinTypeExpr] = ACTIONS(1575),
    [anon_sym_packed] = ACTIONS(1575),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_switch] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(1573),
    [anon_sym_if] = ACTIONS(1575),
    [anon_sym_while] = ACTIONS(1575),
    [anon_sym_for] = ACTIONS(1575),
    [anon_sym_PIPE] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ_EQ] = ACTIONS(1573),
    [anon_sym_BANG_EQ] = ACTIONS(1573),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_LT_EQ] = ACTIONS(1573),
    [anon_sym_GT_EQ] = ACTIONS(1573),
    [anon_sym_AMP] = ACTIONS(1573),
    [anon_sym_CARET] = ACTIONS(1573),
    [anon_sym_orelse] = ACTIONS(1575),
    [anon_sym_catch] = ACTIONS(1575),
    [anon_sym_LT_LT] = ACTIONS(1575),
    [anon_sym_GT_GT] = ACTIONS(1573),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1573),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_DASH] = ACTIONS(1575),
    [anon_sym_PLUS_PLUS] = ACTIONS(1573),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1573),
    [anon_sym_DASH_PERCENT] = ACTIONS(1573),
    [anon_sym_PLUS_PIPE] = ACTIONS(1573),
    [anon_sym_DASH_PIPE] = ACTIONS(1573),
    [anon_sym_PIPE_PIPE] = ACTIONS(1573),
    [anon_sym_SLASH] = ACTIONS(1575),
    [anon_sym_PERCENT] = ACTIONS(1573),
    [anon_sym_STAR_STAR] = ACTIONS(1573),
    [anon_sym_STAR_PERCENT] = ACTIONS(1573),
    [anon_sym_STAR_PIPE] = ACTIONS(1573),
    [anon_sym_QMARK] = ACTIONS(1573),
    [anon_sym_struct] = ACTIONS(1575),
    [anon_sym_opaque] = ACTIONS(1575),
    [anon_sym_enum] = ACTIONS(1575),
    [anon_sym_union] = ACTIONS(1575),
    [sym_doc_comment] = ACTIONS(1573),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1573),
    [aux_sym_FLOAT_token1] = ACTIONS(1573),
    [aux_sym_FLOAT_token2] = ACTIONS(1573),
    [aux_sym_FLOAT_token3] = ACTIONS(1573),
    [aux_sym_FLOAT_token4] = ACTIONS(1573),
    [aux_sym_INTEGER_token1] = ACTIONS(1573),
    [aux_sym_INTEGER_token2] = ACTIONS(1573),
    [aux_sym_INTEGER_token3] = ACTIONS(1575),
    [aux_sym_INTEGER_token4] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(1573),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1573),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1575),
    [anon_sym_AT] = ACTIONS(1573),
  },
  [650] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1110),
    [sym_ErrorUnionExpr] = STATE(1110),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_LinkSection] = STATE(728),
    [sym_AddrSpace] = STATE(700),
    [sym_CallConv] = STATE(787),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1577),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_addrspace] = ACTIONS(1483),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [651] = {
    [ts_builtin_sym_end] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(1579),
    [anon_sym_pub] = ACTIONS(1581),
    [anon_sym_test] = ACTIONS(1581),
    [anon_sym_comptime] = ACTIONS(1581),
    [anon_sym_export] = ACTIONS(1581),
    [anon_sym_extern] = ACTIONS(1581),
    [anon_sym_inline] = ACTIONS(1581),
    [anon_sym_noinline] = ACTIONS(1581),
    [anon_sym_threadlocal] = ACTIONS(1581),
    [anon_sym_usingnamespace] = ACTIONS(1581),
    [anon_sym_fn] = ACTIONS(1581),
    [anon_sym_const] = ACTIONS(1581),
    [anon_sym_var] = ACTIONS(1581),
    [anon_sym_else] = ACTIONS(1581),
    [anon_sym_or] = ACTIONS(1581),
    [anon_sym_and] = ACTIONS(1581),
    [anon_sym_RBRACE] = ACTIONS(1579),
    [anon_sym_async] = ACTIONS(1581),
    [anon_sym_DOT] = ACTIONS(1579),
    [anon_sym_error] = ACTIONS(1581),
    [anon_sym_false] = ACTIONS(1581),
    [anon_sym_null] = ACTIONS(1581),
    [anon_sym_anyframe] = ACTIONS(1581),
    [anon_sym_true] = ACTIONS(1581),
    [anon_sym_undefined] = ACTIONS(1581),
    [anon_sym_unreachable] = ACTIONS(1581),
    [sym_BuildinTypeExpr] = ACTIONS(1581),
    [anon_sym_packed] = ACTIONS(1581),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_switch] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(1579),
    [anon_sym_if] = ACTIONS(1581),
    [anon_sym_while] = ACTIONS(1581),
    [anon_sym_for] = ACTIONS(1581),
    [anon_sym_PIPE] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1581),
    [anon_sym_EQ_EQ] = ACTIONS(1579),
    [anon_sym_BANG_EQ] = ACTIONS(1579),
    [anon_sym_LT] = ACTIONS(1581),
    [anon_sym_GT] = ACTIONS(1581),
    [anon_sym_LT_EQ] = ACTIONS(1579),
    [anon_sym_GT_EQ] = ACTIONS(1579),
    [anon_sym_AMP] = ACTIONS(1579),
    [anon_sym_CARET] = ACTIONS(1579),
    [anon_sym_orelse] = ACTIONS(1581),
    [anon_sym_catch] = ACTIONS(1581),
    [anon_sym_LT_LT] = ACTIONS(1581),
    [anon_sym_GT_GT] = ACTIONS(1579),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1579),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_PLUS_PLUS] = ACTIONS(1579),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1579),
    [anon_sym_DASH_PERCENT] = ACTIONS(1579),
    [anon_sym_PLUS_PIPE] = ACTIONS(1579),
    [anon_sym_DASH_PIPE] = ACTIONS(1579),
    [anon_sym_PIPE_PIPE] = ACTIONS(1579),
    [anon_sym_SLASH] = ACTIONS(1581),
    [anon_sym_PERCENT] = ACTIONS(1579),
    [anon_sym_STAR_STAR] = ACTIONS(1579),
    [anon_sym_STAR_PERCENT] = ACTIONS(1579),
    [anon_sym_STAR_PIPE] = ACTIONS(1579),
    [anon_sym_QMARK] = ACTIONS(1579),
    [anon_sym_struct] = ACTIONS(1581),
    [anon_sym_opaque] = ACTIONS(1581),
    [anon_sym_enum] = ACTIONS(1581),
    [anon_sym_union] = ACTIONS(1581),
    [sym_doc_comment] = ACTIONS(1579),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1579),
    [aux_sym_FLOAT_token1] = ACTIONS(1579),
    [aux_sym_FLOAT_token2] = ACTIONS(1579),
    [aux_sym_FLOAT_token3] = ACTIONS(1579),
    [aux_sym_FLOAT_token4] = ACTIONS(1579),
    [aux_sym_INTEGER_token1] = ACTIONS(1579),
    [aux_sym_INTEGER_token2] = ACTIONS(1579),
    [aux_sym_INTEGER_token3] = ACTIONS(1581),
    [aux_sym_INTEGER_token4] = ACTIONS(1581),
    [anon_sym_DQUOTE] = ACTIONS(1579),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1579),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1581),
    [anon_sym_AT] = ACTIONS(1579),
  },
  [652] = {
    [ts_builtin_sym_end] = ACTIONS(1583),
    [anon_sym_COMMA] = ACTIONS(1583),
    [anon_sym_pub] = ACTIONS(1585),
    [anon_sym_test] = ACTIONS(1585),
    [anon_sym_comptime] = ACTIONS(1585),
    [anon_sym_export] = ACTIONS(1585),
    [anon_sym_extern] = ACTIONS(1585),
    [anon_sym_inline] = ACTIONS(1585),
    [anon_sym_noinline] = ACTIONS(1585),
    [anon_sym_threadlocal] = ACTIONS(1585),
    [anon_sym_usingnamespace] = ACTIONS(1585),
    [anon_sym_fn] = ACTIONS(1585),
    [anon_sym_const] = ACTIONS(1585),
    [anon_sym_var] = ACTIONS(1585),
    [anon_sym_else] = ACTIONS(1585),
    [anon_sym_or] = ACTIONS(1585),
    [anon_sym_and] = ACTIONS(1585),
    [anon_sym_RBRACE] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_DOT] = ACTIONS(1583),
    [anon_sym_error] = ACTIONS(1585),
    [anon_sym_false] = ACTIONS(1585),
    [anon_sym_null] = ACTIONS(1585),
    [anon_sym_anyframe] = ACTIONS(1585),
    [anon_sym_true] = ACTIONS(1585),
    [anon_sym_undefined] = ACTIONS(1585),
    [anon_sym_unreachable] = ACTIONS(1585),
    [sym_BuildinTypeExpr] = ACTIONS(1585),
    [anon_sym_packed] = ACTIONS(1585),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_switch] = ACTIONS(1585),
    [anon_sym_LBRACK] = ACTIONS(1583),
    [anon_sym_if] = ACTIONS(1585),
    [anon_sym_while] = ACTIONS(1585),
    [anon_sym_for] = ACTIONS(1585),
    [anon_sym_PIPE] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1585),
    [anon_sym_EQ_EQ] = ACTIONS(1583),
    [anon_sym_BANG_EQ] = ACTIONS(1583),
    [anon_sym_LT] = ACTIONS(1585),
    [anon_sym_GT] = ACTIONS(1585),
    [anon_sym_LT_EQ] = ACTIONS(1583),
    [anon_sym_GT_EQ] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_orelse] = ACTIONS(1585),
    [anon_sym_catch] = ACTIONS(1585),
    [anon_sym_LT_LT] = ACTIONS(1585),
    [anon_sym_GT_GT] = ACTIONS(1583),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1583),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1583),
    [anon_sym_DASH_PERCENT] = ACTIONS(1583),
    [anon_sym_PLUS_PIPE] = ACTIONS(1583),
    [anon_sym_DASH_PIPE] = ACTIONS(1583),
    [anon_sym_PIPE_PIPE] = ACTIONS(1583),
    [anon_sym_SLASH] = ACTIONS(1585),
    [anon_sym_PERCENT] = ACTIONS(1583),
    [anon_sym_STAR_STAR] = ACTIONS(1583),
    [anon_sym_STAR_PERCENT] = ACTIONS(1583),
    [anon_sym_STAR_PIPE] = ACTIONS(1583),
    [anon_sym_QMARK] = ACTIONS(1583),
    [anon_sym_struct] = ACTIONS(1585),
    [anon_sym_opaque] = ACTIONS(1585),
    [anon_sym_enum] = ACTIONS(1585),
    [anon_sym_union] = ACTIONS(1585),
    [sym_doc_comment] = ACTIONS(1583),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1583),
    [aux_sym_FLOAT_token1] = ACTIONS(1583),
    [aux_sym_FLOAT_token2] = ACTIONS(1583),
    [aux_sym_FLOAT_token3] = ACTIONS(1583),
    [aux_sym_FLOAT_token4] = ACTIONS(1583),
    [aux_sym_INTEGER_token1] = ACTIONS(1583),
    [aux_sym_INTEGER_token2] = ACTIONS(1583),
    [aux_sym_INTEGER_token3] = ACTIONS(1585),
    [aux_sym_INTEGER_token4] = ACTIONS(1585),
    [anon_sym_DQUOTE] = ACTIONS(1583),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1583),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1585),
    [anon_sym_AT] = ACTIONS(1583),
  },
  [653] = {
    [ts_builtin_sym_end] = ACTIONS(576),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_pub] = ACTIONS(578),
    [anon_sym_test] = ACTIONS(578),
    [anon_sym_comptime] = ACTIONS(578),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_extern] = ACTIONS(578),
    [anon_sym_inline] = ACTIONS(578),
    [anon_sym_noinline] = ACTIONS(578),
    [anon_sym_threadlocal] = ACTIONS(578),
    [anon_sym_usingnamespace] = ACTIONS(578),
    [anon_sym_fn] = ACTIONS(578),
    [anon_sym_const] = ACTIONS(578),
    [anon_sym_var] = ACTIONS(578),
    [anon_sym_else] = ACTIONS(578),
    [anon_sym_or] = ACTIONS(578),
    [anon_sym_and] = ACTIONS(578),
    [anon_sym_RBRACE] = ACTIONS(576),
    [anon_sym_async] = ACTIONS(578),
    [anon_sym_DOT] = ACTIONS(576),
    [anon_sym_error] = ACTIONS(578),
    [anon_sym_false] = ACTIONS(578),
    [anon_sym_null] = ACTIONS(578),
    [anon_sym_anyframe] = ACTIONS(578),
    [anon_sym_true] = ACTIONS(578),
    [anon_sym_undefined] = ACTIONS(578),
    [anon_sym_unreachable] = ACTIONS(578),
    [sym_BuildinTypeExpr] = ACTIONS(578),
    [anon_sym_packed] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(576),
    [anon_sym_switch] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_if] = ACTIONS(578),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_for] = ACTIONS(578),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(578),
    [anon_sym_EQ_EQ] = ACTIONS(576),
    [anon_sym_BANG_EQ] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_GT] = ACTIONS(578),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_AMP] = ACTIONS(576),
    [anon_sym_CARET] = ACTIONS(576),
    [anon_sym_orelse] = ACTIONS(578),
    [anon_sym_catch] = ACTIONS(578),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_GT_GT] = ACTIONS(576),
    [anon_sym_LT_LT_PIPE] = ACTIONS(576),
    [anon_sym_PLUS] = ACTIONS(578),
    [anon_sym_DASH] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_PLUS_PERCENT] = ACTIONS(576),
    [anon_sym_DASH_PERCENT] = ACTIONS(576),
    [anon_sym_PLUS_PIPE] = ACTIONS(576),
    [anon_sym_DASH_PIPE] = ACTIONS(576),
    [anon_sym_PIPE_PIPE] = ACTIONS(576),
    [anon_sym_SLASH] = ACTIONS(578),
    [anon_sym_PERCENT] = ACTIONS(576),
    [anon_sym_STAR_STAR] = ACTIONS(576),
    [anon_sym_STAR_PERCENT] = ACTIONS(576),
    [anon_sym_STAR_PIPE] = ACTIONS(576),
    [anon_sym_QMARK] = ACTIONS(576),
    [anon_sym_struct] = ACTIONS(578),
    [anon_sym_opaque] = ACTIONS(578),
    [anon_sym_enum] = ACTIONS(578),
    [anon_sym_union] = ACTIONS(578),
    [sym_doc_comment] = ACTIONS(576),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(576),
    [aux_sym_FLOAT_token1] = ACTIONS(576),
    [aux_sym_FLOAT_token2] = ACTIONS(576),
    [aux_sym_FLOAT_token3] = ACTIONS(576),
    [aux_sym_FLOAT_token4] = ACTIONS(576),
    [aux_sym_INTEGER_token1] = ACTIONS(576),
    [aux_sym_INTEGER_token2] = ACTIONS(576),
    [aux_sym_INTEGER_token3] = ACTIONS(578),
    [aux_sym_INTEGER_token4] = ACTIONS(578),
    [anon_sym_DQUOTE] = ACTIONS(576),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(576),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(578),
    [anon_sym_AT] = ACTIONS(576),
  },
  [654] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(516),
    [sym_ErrorUnionExpr] = STATE(516),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_LinkSection] = STATE(721),
    [sym_AddrSpace] = STATE(692),
    [sym_CallConv] = STATE(793),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_addrspace] = ACTIONS(1483),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [655] = {
    [ts_builtin_sym_end] = ACTIONS(1589),
    [anon_sym_COMMA] = ACTIONS(1589),
    [anon_sym_pub] = ACTIONS(1591),
    [anon_sym_test] = ACTIONS(1591),
    [anon_sym_comptime] = ACTIONS(1591),
    [anon_sym_export] = ACTIONS(1591),
    [anon_sym_extern] = ACTIONS(1591),
    [anon_sym_inline] = ACTIONS(1591),
    [anon_sym_noinline] = ACTIONS(1591),
    [anon_sym_threadlocal] = ACTIONS(1591),
    [anon_sym_usingnamespace] = ACTIONS(1591),
    [anon_sym_fn] = ACTIONS(1591),
    [anon_sym_const] = ACTIONS(1591),
    [anon_sym_var] = ACTIONS(1591),
    [anon_sym_else] = ACTIONS(1591),
    [anon_sym_or] = ACTIONS(1591),
    [anon_sym_and] = ACTIONS(1591),
    [anon_sym_RBRACE] = ACTIONS(1589),
    [anon_sym_async] = ACTIONS(1591),
    [anon_sym_DOT] = ACTIONS(1589),
    [anon_sym_error] = ACTIONS(1591),
    [anon_sym_false] = ACTIONS(1591),
    [anon_sym_null] = ACTIONS(1591),
    [anon_sym_anyframe] = ACTIONS(1591),
    [anon_sym_true] = ACTIONS(1591),
    [anon_sym_undefined] = ACTIONS(1591),
    [anon_sym_unreachable] = ACTIONS(1591),
    [sym_BuildinTypeExpr] = ACTIONS(1591),
    [anon_sym_packed] = ACTIONS(1591),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_switch] = ACTIONS(1591),
    [anon_sym_LBRACK] = ACTIONS(1589),
    [anon_sym_if] = ACTIONS(1591),
    [anon_sym_while] = ACTIONS(1591),
    [anon_sym_for] = ACTIONS(1591),
    [anon_sym_PIPE] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1591),
    [anon_sym_EQ_EQ] = ACTIONS(1589),
    [anon_sym_BANG_EQ] = ACTIONS(1589),
    [anon_sym_LT] = ACTIONS(1591),
    [anon_sym_GT] = ACTIONS(1591),
    [anon_sym_LT_EQ] = ACTIONS(1589),
    [anon_sym_GT_EQ] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_orelse] = ACTIONS(1591),
    [anon_sym_catch] = ACTIONS(1591),
    [anon_sym_LT_LT] = ACTIONS(1591),
    [anon_sym_GT_GT] = ACTIONS(1589),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1589),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1589),
    [anon_sym_DASH_PERCENT] = ACTIONS(1589),
    [anon_sym_PLUS_PIPE] = ACTIONS(1589),
    [anon_sym_DASH_PIPE] = ACTIONS(1589),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [anon_sym_SLASH] = ACTIONS(1591),
    [anon_sym_PERCENT] = ACTIONS(1589),
    [anon_sym_STAR_STAR] = ACTIONS(1589),
    [anon_sym_STAR_PERCENT] = ACTIONS(1589),
    [anon_sym_STAR_PIPE] = ACTIONS(1589),
    [anon_sym_QMARK] = ACTIONS(1589),
    [anon_sym_struct] = ACTIONS(1591),
    [anon_sym_opaque] = ACTIONS(1591),
    [anon_sym_enum] = ACTIONS(1591),
    [anon_sym_union] = ACTIONS(1591),
    [sym_doc_comment] = ACTIONS(1589),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1589),
    [aux_sym_FLOAT_token1] = ACTIONS(1589),
    [aux_sym_FLOAT_token2] = ACTIONS(1589),
    [aux_sym_FLOAT_token3] = ACTIONS(1589),
    [aux_sym_FLOAT_token4] = ACTIONS(1589),
    [aux_sym_INTEGER_token1] = ACTIONS(1589),
    [aux_sym_INTEGER_token2] = ACTIONS(1589),
    [aux_sym_INTEGER_token3] = ACTIONS(1591),
    [aux_sym_INTEGER_token4] = ACTIONS(1591),
    [anon_sym_DQUOTE] = ACTIONS(1589),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1589),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1591),
    [anon_sym_AT] = ACTIONS(1589),
  },
  [656] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1254),
    [sym_ErrorUnionExpr] = STATE(1254),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_LinkSection] = STATE(725),
    [sym_AddrSpace] = STATE(705),
    [sym_CallConv] = STATE(783),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1593),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_addrspace] = ACTIONS(1483),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [657] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(2091),
    [sym_ErrorUnionExpr] = STATE(2091),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_ParamDecl] = STATE(1919),
    [sym_ParamType] = STATE(2075),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(1673),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1595),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(1597),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(1599),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_noalias] = ACTIONS(1601),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1603),
    [anon_sym_anytype] = ACTIONS(1605),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(1607),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [658] = {
    [ts_builtin_sym_end] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_pub] = ACTIONS(1611),
    [anon_sym_test] = ACTIONS(1611),
    [anon_sym_comptime] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(1611),
    [anon_sym_extern] = ACTIONS(1611),
    [anon_sym_inline] = ACTIONS(1611),
    [anon_sym_noinline] = ACTIONS(1611),
    [anon_sym_threadlocal] = ACTIONS(1611),
    [anon_sym_usingnamespace] = ACTIONS(1611),
    [anon_sym_fn] = ACTIONS(1611),
    [anon_sym_const] = ACTIONS(1611),
    [anon_sym_var] = ACTIONS(1611),
    [anon_sym_else] = ACTIONS(1611),
    [anon_sym_or] = ACTIONS(1611),
    [anon_sym_and] = ACTIONS(1611),
    [anon_sym_RBRACE] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1611),
    [anon_sym_DOT] = ACTIONS(1609),
    [anon_sym_error] = ACTIONS(1611),
    [anon_sym_false] = ACTIONS(1611),
    [anon_sym_null] = ACTIONS(1611),
    [anon_sym_anyframe] = ACTIONS(1611),
    [anon_sym_true] = ACTIONS(1611),
    [anon_sym_undefined] = ACTIONS(1611),
    [anon_sym_unreachable] = ACTIONS(1611),
    [sym_BuildinTypeExpr] = ACTIONS(1611),
    [anon_sym_packed] = ACTIONS(1611),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [anon_sym_switch] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_if] = ACTIONS(1611),
    [anon_sym_while] = ACTIONS(1611),
    [anon_sym_for] = ACTIONS(1611),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_EQ_EQ] = ACTIONS(1609),
    [anon_sym_BANG_EQ] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_AMP] = ACTIONS(1609),
    [anon_sym_CARET] = ACTIONS(1609),
    [anon_sym_orelse] = ACTIONS(1611),
    [anon_sym_catch] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_GT_GT] = ACTIONS(1609),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1609),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1609),
    [anon_sym_DASH_PERCENT] = ACTIONS(1609),
    [anon_sym_PLUS_PIPE] = ACTIONS(1609),
    [anon_sym_DASH_PIPE] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SLASH] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1609),
    [anon_sym_STAR_STAR] = ACTIONS(1609),
    [anon_sym_STAR_PERCENT] = ACTIONS(1609),
    [anon_sym_STAR_PIPE] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_struct] = ACTIONS(1611),
    [anon_sym_opaque] = ACTIONS(1611),
    [anon_sym_enum] = ACTIONS(1611),
    [anon_sym_union] = ACTIONS(1611),
    [sym_doc_comment] = ACTIONS(1609),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1609),
    [aux_sym_FLOAT_token1] = ACTIONS(1609),
    [aux_sym_FLOAT_token2] = ACTIONS(1609),
    [aux_sym_FLOAT_token3] = ACTIONS(1609),
    [aux_sym_FLOAT_token4] = ACTIONS(1609),
    [aux_sym_INTEGER_token1] = ACTIONS(1609),
    [aux_sym_INTEGER_token2] = ACTIONS(1609),
    [aux_sym_INTEGER_token3] = ACTIONS(1611),
    [aux_sym_INTEGER_token4] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1609),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1609),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(1609),
  },
  [659] = {
    [ts_builtin_sym_end] = ACTIONS(1613),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_pub] = ACTIONS(1615),
    [anon_sym_test] = ACTIONS(1615),
    [anon_sym_comptime] = ACTIONS(1615),
    [anon_sym_export] = ACTIONS(1615),
    [anon_sym_extern] = ACTIONS(1615),
    [anon_sym_inline] = ACTIONS(1615),
    [anon_sym_noinline] = ACTIONS(1615),
    [anon_sym_threadlocal] = ACTIONS(1615),
    [anon_sym_usingnamespace] = ACTIONS(1615),
    [anon_sym_fn] = ACTIONS(1615),
    [anon_sym_const] = ACTIONS(1615),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_else] = ACTIONS(1615),
    [anon_sym_or] = ACTIONS(1615),
    [anon_sym_and] = ACTIONS(1615),
    [anon_sym_RBRACE] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1615),
    [anon_sym_DOT] = ACTIONS(1613),
    [anon_sym_error] = ACTIONS(1615),
    [anon_sym_false] = ACTIONS(1615),
    [anon_sym_null] = ACTIONS(1615),
    [anon_sym_anyframe] = ACTIONS(1615),
    [anon_sym_true] = ACTIONS(1615),
    [anon_sym_undefined] = ACTIONS(1615),
    [anon_sym_unreachable] = ACTIONS(1615),
    [sym_BuildinTypeExpr] = ACTIONS(1615),
    [anon_sym_packed] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_switch] = ACTIONS(1615),
    [anon_sym_LBRACK] = ACTIONS(1613),
    [anon_sym_if] = ACTIONS(1615),
    [anon_sym_while] = ACTIONS(1615),
    [anon_sym_for] = ACTIONS(1615),
    [anon_sym_PIPE] = ACTIONS(1615),
    [anon_sym_STAR] = ACTIONS(1615),
    [anon_sym_EQ_EQ] = ACTIONS(1613),
    [anon_sym_BANG_EQ] = ACTIONS(1613),
    [anon_sym_LT] = ACTIONS(1615),
    [anon_sym_GT] = ACTIONS(1615),
    [anon_sym_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1613),
    [anon_sym_CARET] = ACTIONS(1613),
    [anon_sym_orelse] = ACTIONS(1615),
    [anon_sym_catch] = ACTIONS(1615),
    [anon_sym_LT_LT] = ACTIONS(1615),
    [anon_sym_GT_GT] = ACTIONS(1613),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1613),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_DASH] = ACTIONS(1615),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1613),
    [anon_sym_DASH_PERCENT] = ACTIONS(1613),
    [anon_sym_PLUS_PIPE] = ACTIONS(1613),
    [anon_sym_DASH_PIPE] = ACTIONS(1613),
    [anon_sym_PIPE_PIPE] = ACTIONS(1613),
    [anon_sym_SLASH] = ACTIONS(1615),
    [anon_sym_PERCENT] = ACTIONS(1613),
    [anon_sym_STAR_STAR] = ACTIONS(1613),
    [anon_sym_STAR_PERCENT] = ACTIONS(1613),
    [anon_sym_STAR_PIPE] = ACTIONS(1613),
    [anon_sym_QMARK] = ACTIONS(1613),
    [anon_sym_struct] = ACTIONS(1615),
    [anon_sym_opaque] = ACTIONS(1615),
    [anon_sym_enum] = ACTIONS(1615),
    [anon_sym_union] = ACTIONS(1615),
    [sym_doc_comment] = ACTIONS(1613),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1613),
    [aux_sym_FLOAT_token1] = ACTIONS(1613),
    [aux_sym_FLOAT_token2] = ACTIONS(1613),
    [aux_sym_FLOAT_token3] = ACTIONS(1613),
    [aux_sym_FLOAT_token4] = ACTIONS(1613),
    [aux_sym_INTEGER_token1] = ACTIONS(1613),
    [aux_sym_INTEGER_token2] = ACTIONS(1613),
    [aux_sym_INTEGER_token3] = ACTIONS(1615),
    [aux_sym_INTEGER_token4] = ACTIONS(1615),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1613),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1615),
    [anon_sym_AT] = ACTIONS(1613),
  },
  [660] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(997),
    [sym_ErrorUnionExpr] = STATE(997),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_LinkSection] = STATE(743),
    [sym_AddrSpace] = STATE(689),
    [sym_CallConv] = STATE(804),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_addrspace] = ACTIONS(1483),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [661] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(499),
    [sym_ErrorUnionExpr] = STATE(499),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_LinkSection] = STATE(739),
    [sym_AddrSpace] = STATE(686),
    [sym_CallConv] = STATE(785),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_addrspace] = ACTIONS(1483),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [662] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(592),
    [sym_ErrorUnionExpr] = STATE(592),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_LinkSection] = STATE(724),
    [sym_AddrSpace] = STATE(707),
    [sym_CallConv] = STATE(790),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_addrspace] = ACTIONS(1483),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [663] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1138),
    [sym_ErrorUnionExpr] = STATE(1138),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_LinkSection] = STATE(723),
    [sym_AddrSpace] = STATE(702),
    [sym_CallConv] = STATE(789),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_addrspace] = ACTIONS(1483),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [664] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1500),
    [sym_ErrorUnionExpr] = STATE(1500),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_LinkSection] = STATE(738),
    [sym_AddrSpace] = STATE(698),
    [sym_CallConv] = STATE(773),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_addrspace] = ACTIONS(1483),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [665] = {
    [ts_builtin_sym_end] = ACTIONS(1627),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_pub] = ACTIONS(1629),
    [anon_sym_test] = ACTIONS(1629),
    [anon_sym_comptime] = ACTIONS(1629),
    [anon_sym_export] = ACTIONS(1629),
    [anon_sym_extern] = ACTIONS(1629),
    [anon_sym_inline] = ACTIONS(1629),
    [anon_sym_noinline] = ACTIONS(1629),
    [anon_sym_threadlocal] = ACTIONS(1629),
    [anon_sym_usingnamespace] = ACTIONS(1629),
    [anon_sym_fn] = ACTIONS(1629),
    [anon_sym_const] = ACTIONS(1629),
    [anon_sym_var] = ACTIONS(1629),
    [anon_sym_else] = ACTIONS(1629),
    [anon_sym_or] = ACTIONS(1629),
    [anon_sym_and] = ACTIONS(1629),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_async] = ACTIONS(1629),
    [anon_sym_DOT] = ACTIONS(1627),
    [anon_sym_error] = ACTIONS(1629),
    [anon_sym_false] = ACTIONS(1629),
    [anon_sym_null] = ACTIONS(1629),
    [anon_sym_anyframe] = ACTIONS(1629),
    [anon_sym_true] = ACTIONS(1629),
    [anon_sym_undefined] = ACTIONS(1629),
    [anon_sym_unreachable] = ACTIONS(1629),
    [sym_BuildinTypeExpr] = ACTIONS(1629),
    [anon_sym_packed] = ACTIONS(1629),
    [anon_sym_LPAREN] = ACTIONS(1627),
    [anon_sym_switch] = ACTIONS(1629),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1629),
    [anon_sym_while] = ACTIONS(1629),
    [anon_sym_for] = ACTIONS(1629),
    [anon_sym_PIPE] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1629),
    [anon_sym_EQ_EQ] = ACTIONS(1627),
    [anon_sym_BANG_EQ] = ACTIONS(1627),
    [anon_sym_LT] = ACTIONS(1629),
    [anon_sym_GT] = ACTIONS(1629),
    [anon_sym_LT_EQ] = ACTIONS(1627),
    [anon_sym_GT_EQ] = ACTIONS(1627),
    [anon_sym_AMP] = ACTIONS(1627),
    [anon_sym_CARET] = ACTIONS(1627),
    [anon_sym_orelse] = ACTIONS(1629),
    [anon_sym_catch] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1629),
    [anon_sym_GT_GT] = ACTIONS(1627),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_PLUS_PLUS] = ACTIONS(1627),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1627),
    [anon_sym_DASH_PERCENT] = ACTIONS(1627),
    [anon_sym_PLUS_PIPE] = ACTIONS(1627),
    [anon_sym_DASH_PIPE] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(1629),
    [anon_sym_PERCENT] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(1627),
    [anon_sym_STAR_PERCENT] = ACTIONS(1627),
    [anon_sym_STAR_PIPE] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(1627),
    [anon_sym_struct] = ACTIONS(1629),
    [anon_sym_opaque] = ACTIONS(1629),
    [anon_sym_enum] = ACTIONS(1629),
    [anon_sym_union] = ACTIONS(1629),
    [sym_doc_comment] = ACTIONS(1627),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1627),
    [aux_sym_FLOAT_token1] = ACTIONS(1627),
    [aux_sym_FLOAT_token2] = ACTIONS(1627),
    [aux_sym_FLOAT_token3] = ACTIONS(1627),
    [aux_sym_FLOAT_token4] = ACTIONS(1627),
    [aux_sym_INTEGER_token1] = ACTIONS(1627),
    [aux_sym_INTEGER_token2] = ACTIONS(1627),
    [aux_sym_INTEGER_token3] = ACTIONS(1629),
    [aux_sym_INTEGER_token4] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(1627),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1627),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1629),
    [anon_sym_AT] = ACTIONS(1627),
  },
  [666] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(2091),
    [sym_ErrorUnionExpr] = STATE(2091),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_ParamDecl] = STATE(2046),
    [sym_ParamType] = STATE(2075),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(1673),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1595),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(1597),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(1631),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_noalias] = ACTIONS(1601),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1603),
    [anon_sym_anytype] = ACTIONS(1605),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(1607),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [667] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1228),
    [sym_ErrorUnionExpr] = STATE(1228),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_LinkSection] = STATE(720),
    [sym_AddrSpace] = STATE(694),
    [sym_CallConv] = STATE(764),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1633),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_addrspace] = ACTIONS(1483),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [668] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(2091),
    [sym_ErrorUnionExpr] = STATE(2091),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_ParamDecl] = STATE(2046),
    [sym_ParamType] = STATE(2075),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(1673),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1595),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(1597),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(1635),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_noalias] = ACTIONS(1601),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1603),
    [anon_sym_anytype] = ACTIONS(1605),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(1607),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [669] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(964),
    [sym_ErrorUnionExpr] = STATE(964),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_LinkSection] = STATE(715),
    [sym_AddrSpace] = STATE(703),
    [sym_CallConv] = STATE(763),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1637),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_addrspace] = ACTIONS(1483),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [670] = {
    [ts_builtin_sym_end] = ACTIONS(155),
    [anon_sym_COMMA] = ACTIONS(155),
    [anon_sym_pub] = ACTIONS(157),
    [anon_sym_test] = ACTIONS(157),
    [anon_sym_comptime] = ACTIONS(157),
    [anon_sym_export] = ACTIONS(157),
    [anon_sym_extern] = ACTIONS(157),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_noinline] = ACTIONS(157),
    [anon_sym_threadlocal] = ACTIONS(157),
    [anon_sym_usingnamespace] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(157),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_var] = ACTIONS(157),
    [anon_sym_else] = ACTIONS(157),
    [anon_sym_or] = ACTIONS(157),
    [anon_sym_and] = ACTIONS(157),
    [anon_sym_RBRACE] = ACTIONS(155),
    [anon_sym_async] = ACTIONS(157),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_error] = ACTIONS(157),
    [anon_sym_false] = ACTIONS(157),
    [anon_sym_null] = ACTIONS(157),
    [anon_sym_anyframe] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(157),
    [anon_sym_undefined] = ACTIONS(157),
    [anon_sym_unreachable] = ACTIONS(157),
    [sym_BuildinTypeExpr] = ACTIONS(157),
    [anon_sym_packed] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(157),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(157),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_AMP] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [anon_sym_orelse] = ACTIONS(157),
    [anon_sym_catch] = ACTIONS(157),
    [anon_sym_LT_LT] = ACTIONS(157),
    [anon_sym_GT_GT] = ACTIONS(155),
    [anon_sym_LT_LT_PIPE] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(155),
    [anon_sym_PLUS_PERCENT] = ACTIONS(155),
    [anon_sym_DASH_PERCENT] = ACTIONS(155),
    [anon_sym_PLUS_PIPE] = ACTIONS(155),
    [anon_sym_DASH_PIPE] = ACTIONS(155),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_PERCENT] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_STAR_PERCENT] = ACTIONS(155),
    [anon_sym_STAR_PIPE] = ACTIONS(155),
    [anon_sym_QMARK] = ACTIONS(155),
    [anon_sym_struct] = ACTIONS(157),
    [anon_sym_opaque] = ACTIONS(157),
    [anon_sym_enum] = ACTIONS(157),
    [anon_sym_union] = ACTIONS(157),
    [sym_doc_comment] = ACTIONS(155),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [aux_sym_FLOAT_token1] = ACTIONS(155),
    [aux_sym_FLOAT_token2] = ACTIONS(155),
    [aux_sym_FLOAT_token3] = ACTIONS(155),
    [aux_sym_FLOAT_token4] = ACTIONS(155),
    [aux_sym_INTEGER_token1] = ACTIONS(155),
    [aux_sym_INTEGER_token2] = ACTIONS(155),
    [aux_sym_INTEGER_token3] = ACTIONS(157),
    [aux_sym_INTEGER_token4] = ACTIONS(157),
    [anon_sym_DQUOTE] = ACTIONS(155),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(155),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(157),
    [anon_sym_AT] = ACTIONS(155),
  },
  [671] = {
    [ts_builtin_sym_end] = ACTIONS(1639),
    [anon_sym_COMMA] = ACTIONS(1639),
    [anon_sym_pub] = ACTIONS(1641),
    [anon_sym_test] = ACTIONS(1641),
    [anon_sym_comptime] = ACTIONS(1641),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_extern] = ACTIONS(1641),
    [anon_sym_inline] = ACTIONS(1641),
    [anon_sym_noinline] = ACTIONS(1641),
    [anon_sym_threadlocal] = ACTIONS(1641),
    [anon_sym_usingnamespace] = ACTIONS(1641),
    [anon_sym_fn] = ACTIONS(1641),
    [anon_sym_const] = ACTIONS(1641),
    [anon_sym_var] = ACTIONS(1641),
    [anon_sym_else] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_RBRACE] = ACTIONS(1639),
    [anon_sym_async] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1639),
    [anon_sym_error] = ACTIONS(1641),
    [anon_sym_false] = ACTIONS(1641),
    [anon_sym_null] = ACTIONS(1641),
    [anon_sym_anyframe] = ACTIONS(1641),
    [anon_sym_true] = ACTIONS(1641),
    [anon_sym_undefined] = ACTIONS(1641),
    [anon_sym_unreachable] = ACTIONS(1641),
    [sym_BuildinTypeExpr] = ACTIONS(1641),
    [anon_sym_packed] = ACTIONS(1641),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_switch] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_for] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(1641),
    [anon_sym_STAR] = ACTIONS(1641),
    [anon_sym_EQ_EQ] = ACTIONS(1639),
    [anon_sym_BANG_EQ] = ACTIONS(1639),
    [anon_sym_LT] = ACTIONS(1641),
    [anon_sym_GT] = ACTIONS(1641),
    [anon_sym_LT_EQ] = ACTIONS(1639),
    [anon_sym_GT_EQ] = ACTIONS(1639),
    [anon_sym_AMP] = ACTIONS(1639),
    [anon_sym_CARET] = ACTIONS(1639),
    [anon_sym_orelse] = ACTIONS(1641),
    [anon_sym_catch] = ACTIONS(1641),
    [anon_sym_LT_LT] = ACTIONS(1641),
    [anon_sym_GT_GT] = ACTIONS(1639),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1639),
    [anon_sym_PLUS] = ACTIONS(1641),
    [anon_sym_DASH] = ACTIONS(1641),
    [anon_sym_PLUS_PLUS] = ACTIONS(1639),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1639),
    [anon_sym_DASH_PERCENT] = ACTIONS(1639),
    [anon_sym_PLUS_PIPE] = ACTIONS(1639),
    [anon_sym_DASH_PIPE] = ACTIONS(1639),
    [anon_sym_PIPE_PIPE] = ACTIONS(1639),
    [anon_sym_SLASH] = ACTIONS(1641),
    [anon_sym_PERCENT] = ACTIONS(1639),
    [anon_sym_STAR_STAR] = ACTIONS(1639),
    [anon_sym_STAR_PERCENT] = ACTIONS(1639),
    [anon_sym_STAR_PIPE] = ACTIONS(1639),
    [anon_sym_QMARK] = ACTIONS(1639),
    [anon_sym_struct] = ACTIONS(1641),
    [anon_sym_opaque] = ACTIONS(1641),
    [anon_sym_enum] = ACTIONS(1641),
    [anon_sym_union] = ACTIONS(1641),
    [sym_doc_comment] = ACTIONS(1639),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1639),
    [aux_sym_FLOAT_token1] = ACTIONS(1639),
    [aux_sym_FLOAT_token2] = ACTIONS(1639),
    [aux_sym_FLOAT_token3] = ACTIONS(1639),
    [aux_sym_FLOAT_token4] = ACTIONS(1639),
    [aux_sym_INTEGER_token1] = ACTIONS(1639),
    [aux_sym_INTEGER_token2] = ACTIONS(1639),
    [aux_sym_INTEGER_token3] = ACTIONS(1641),
    [aux_sym_INTEGER_token4] = ACTIONS(1641),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1639),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1641),
    [anon_sym_AT] = ACTIONS(1639),
  },
  [672] = {
    [ts_builtin_sym_end] = ACTIONS(1643),
    [anon_sym_COMMA] = ACTIONS(1643),
    [anon_sym_pub] = ACTIONS(1645),
    [anon_sym_test] = ACTIONS(1645),
    [anon_sym_comptime] = ACTIONS(1645),
    [anon_sym_export] = ACTIONS(1645),
    [anon_sym_extern] = ACTIONS(1645),
    [anon_sym_inline] = ACTIONS(1645),
    [anon_sym_noinline] = ACTIONS(1645),
    [anon_sym_threadlocal] = ACTIONS(1645),
    [anon_sym_usingnamespace] = ACTIONS(1645),
    [anon_sym_fn] = ACTIONS(1645),
    [anon_sym_const] = ACTIONS(1645),
    [anon_sym_var] = ACTIONS(1645),
    [anon_sym_else] = ACTIONS(1645),
    [anon_sym_or] = ACTIONS(1645),
    [anon_sym_and] = ACTIONS(1645),
    [anon_sym_RBRACE] = ACTIONS(1643),
    [anon_sym_async] = ACTIONS(1645),
    [anon_sym_DOT] = ACTIONS(1643),
    [anon_sym_error] = ACTIONS(1645),
    [anon_sym_false] = ACTIONS(1645),
    [anon_sym_null] = ACTIONS(1645),
    [anon_sym_anyframe] = ACTIONS(1645),
    [anon_sym_true] = ACTIONS(1645),
    [anon_sym_undefined] = ACTIONS(1645),
    [anon_sym_unreachable] = ACTIONS(1645),
    [sym_BuildinTypeExpr] = ACTIONS(1645),
    [anon_sym_packed] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_switch] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(1643),
    [anon_sym_if] = ACTIONS(1645),
    [anon_sym_while] = ACTIONS(1645),
    [anon_sym_for] = ACTIONS(1645),
    [anon_sym_PIPE] = ACTIONS(1645),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_EQ_EQ] = ACTIONS(1643),
    [anon_sym_BANG_EQ] = ACTIONS(1643),
    [anon_sym_LT] = ACTIONS(1645),
    [anon_sym_GT] = ACTIONS(1645),
    [anon_sym_LT_EQ] = ACTIONS(1643),
    [anon_sym_GT_EQ] = ACTIONS(1643),
    [anon_sym_AMP] = ACTIONS(1643),
    [anon_sym_CARET] = ACTIONS(1643),
    [anon_sym_orelse] = ACTIONS(1645),
    [anon_sym_catch] = ACTIONS(1645),
    [anon_sym_LT_LT] = ACTIONS(1645),
    [anon_sym_GT_GT] = ACTIONS(1643),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1643),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_PLUS_PLUS] = ACTIONS(1643),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1643),
    [anon_sym_DASH_PERCENT] = ACTIONS(1643),
    [anon_sym_PLUS_PIPE] = ACTIONS(1643),
    [anon_sym_DASH_PIPE] = ACTIONS(1643),
    [anon_sym_PIPE_PIPE] = ACTIONS(1643),
    [anon_sym_SLASH] = ACTIONS(1645),
    [anon_sym_PERCENT] = ACTIONS(1643),
    [anon_sym_STAR_STAR] = ACTIONS(1643),
    [anon_sym_STAR_PERCENT] = ACTIONS(1643),
    [anon_sym_STAR_PIPE] = ACTIONS(1643),
    [anon_sym_QMARK] = ACTIONS(1643),
    [anon_sym_struct] = ACTIONS(1645),
    [anon_sym_opaque] = ACTIONS(1645),
    [anon_sym_enum] = ACTIONS(1645),
    [anon_sym_union] = ACTIONS(1645),
    [sym_doc_comment] = ACTIONS(1643),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1643),
    [aux_sym_FLOAT_token1] = ACTIONS(1643),
    [aux_sym_FLOAT_token2] = ACTIONS(1643),
    [aux_sym_FLOAT_token3] = ACTIONS(1643),
    [aux_sym_FLOAT_token4] = ACTIONS(1643),
    [aux_sym_INTEGER_token1] = ACTIONS(1643),
    [aux_sym_INTEGER_token2] = ACTIONS(1643),
    [aux_sym_INTEGER_token3] = ACTIONS(1645),
    [aux_sym_INTEGER_token4] = ACTIONS(1645),
    [anon_sym_DQUOTE] = ACTIONS(1643),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1643),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1645),
    [anon_sym_AT] = ACTIONS(1643),
  },
  [673] = {
    [ts_builtin_sym_end] = ACTIONS(1573),
    [anon_sym_COMMA] = ACTIONS(1573),
    [anon_sym_pub] = ACTIONS(1575),
    [anon_sym_test] = ACTIONS(1575),
    [anon_sym_comptime] = ACTIONS(1575),
    [anon_sym_export] = ACTIONS(1575),
    [anon_sym_extern] = ACTIONS(1575),
    [anon_sym_inline] = ACTIONS(1575),
    [anon_sym_noinline] = ACTIONS(1575),
    [anon_sym_threadlocal] = ACTIONS(1575),
    [anon_sym_usingnamespace] = ACTIONS(1575),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_const] = ACTIONS(1575),
    [anon_sym_var] = ACTIONS(1575),
    [anon_sym_or] = ACTIONS(1575),
    [anon_sym_and] = ACTIONS(1575),
    [anon_sym_RBRACE] = ACTIONS(1573),
    [anon_sym_async] = ACTIONS(1575),
    [anon_sym_DOT] = ACTIONS(1573),
    [anon_sym_error] = ACTIONS(1575),
    [anon_sym_false] = ACTIONS(1575),
    [anon_sym_null] = ACTIONS(1575),
    [anon_sym_anyframe] = ACTIONS(1575),
    [anon_sym_true] = ACTIONS(1575),
    [anon_sym_undefined] = ACTIONS(1575),
    [anon_sym_unreachable] = ACTIONS(1575),
    [sym_BuildinTypeExpr] = ACTIONS(1575),
    [anon_sym_packed] = ACTIONS(1575),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_switch] = ACTIONS(1575),
    [anon_sym_LBRACK] = ACTIONS(1573),
    [anon_sym_if] = ACTIONS(1575),
    [anon_sym_while] = ACTIONS(1575),
    [anon_sym_for] = ACTIONS(1575),
    [anon_sym_PIPE] = ACTIONS(1575),
    [anon_sym_STAR] = ACTIONS(1575),
    [anon_sym_EQ_EQ] = ACTIONS(1573),
    [anon_sym_BANG_EQ] = ACTIONS(1573),
    [anon_sym_LT] = ACTIONS(1575),
    [anon_sym_GT] = ACTIONS(1575),
    [anon_sym_LT_EQ] = ACTIONS(1573),
    [anon_sym_GT_EQ] = ACTIONS(1573),
    [anon_sym_AMP] = ACTIONS(1573),
    [anon_sym_CARET] = ACTIONS(1573),
    [anon_sym_orelse] = ACTIONS(1575),
    [anon_sym_catch] = ACTIONS(1575),
    [anon_sym_LT_LT] = ACTIONS(1575),
    [anon_sym_GT_GT] = ACTIONS(1573),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1573),
    [anon_sym_PLUS] = ACTIONS(1575),
    [anon_sym_DASH] = ACTIONS(1575),
    [anon_sym_PLUS_PLUS] = ACTIONS(1573),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1573),
    [anon_sym_DASH_PERCENT] = ACTIONS(1573),
    [anon_sym_PLUS_PIPE] = ACTIONS(1573),
    [anon_sym_DASH_PIPE] = ACTIONS(1573),
    [anon_sym_PIPE_PIPE] = ACTIONS(1573),
    [anon_sym_SLASH] = ACTIONS(1575),
    [anon_sym_PERCENT] = ACTIONS(1573),
    [anon_sym_STAR_STAR] = ACTIONS(1573),
    [anon_sym_STAR_PERCENT] = ACTIONS(1573),
    [anon_sym_STAR_PIPE] = ACTIONS(1573),
    [anon_sym_QMARK] = ACTIONS(1573),
    [anon_sym_struct] = ACTIONS(1575),
    [anon_sym_opaque] = ACTIONS(1575),
    [anon_sym_enum] = ACTIONS(1575),
    [anon_sym_union] = ACTIONS(1575),
    [sym_doc_comment] = ACTIONS(1573),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1573),
    [aux_sym_FLOAT_token1] = ACTIONS(1573),
    [aux_sym_FLOAT_token2] = ACTIONS(1573),
    [aux_sym_FLOAT_token3] = ACTIONS(1573),
    [aux_sym_FLOAT_token4] = ACTIONS(1573),
    [aux_sym_INTEGER_token1] = ACTIONS(1573),
    [aux_sym_INTEGER_token2] = ACTIONS(1573),
    [aux_sym_INTEGER_token3] = ACTIONS(1575),
    [aux_sym_INTEGER_token4] = ACTIONS(1575),
    [anon_sym_DQUOTE] = ACTIONS(1573),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1573),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1575),
    [anon_sym_AT] = ACTIONS(1573),
  },
  [674] = {
    [ts_builtin_sym_end] = ACTIONS(1579),
    [anon_sym_COMMA] = ACTIONS(1579),
    [anon_sym_pub] = ACTIONS(1581),
    [anon_sym_test] = ACTIONS(1581),
    [anon_sym_comptime] = ACTIONS(1581),
    [anon_sym_export] = ACTIONS(1581),
    [anon_sym_extern] = ACTIONS(1581),
    [anon_sym_inline] = ACTIONS(1581),
    [anon_sym_noinline] = ACTIONS(1581),
    [anon_sym_threadlocal] = ACTIONS(1581),
    [anon_sym_usingnamespace] = ACTIONS(1581),
    [anon_sym_fn] = ACTIONS(1581),
    [anon_sym_const] = ACTIONS(1581),
    [anon_sym_var] = ACTIONS(1581),
    [anon_sym_or] = ACTIONS(1581),
    [anon_sym_and] = ACTIONS(1581),
    [anon_sym_RBRACE] = ACTIONS(1579),
    [anon_sym_async] = ACTIONS(1581),
    [anon_sym_DOT] = ACTIONS(1579),
    [anon_sym_error] = ACTIONS(1581),
    [anon_sym_false] = ACTIONS(1581),
    [anon_sym_null] = ACTIONS(1581),
    [anon_sym_anyframe] = ACTIONS(1581),
    [anon_sym_true] = ACTIONS(1581),
    [anon_sym_undefined] = ACTIONS(1581),
    [anon_sym_unreachable] = ACTIONS(1581),
    [sym_BuildinTypeExpr] = ACTIONS(1581),
    [anon_sym_packed] = ACTIONS(1581),
    [anon_sym_LPAREN] = ACTIONS(1579),
    [anon_sym_switch] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(1579),
    [anon_sym_if] = ACTIONS(1581),
    [anon_sym_while] = ACTIONS(1581),
    [anon_sym_for] = ACTIONS(1581),
    [anon_sym_PIPE] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1581),
    [anon_sym_EQ_EQ] = ACTIONS(1579),
    [anon_sym_BANG_EQ] = ACTIONS(1579),
    [anon_sym_LT] = ACTIONS(1581),
    [anon_sym_GT] = ACTIONS(1581),
    [anon_sym_LT_EQ] = ACTIONS(1579),
    [anon_sym_GT_EQ] = ACTIONS(1579),
    [anon_sym_AMP] = ACTIONS(1579),
    [anon_sym_CARET] = ACTIONS(1579),
    [anon_sym_orelse] = ACTIONS(1581),
    [anon_sym_catch] = ACTIONS(1581),
    [anon_sym_LT_LT] = ACTIONS(1581),
    [anon_sym_GT_GT] = ACTIONS(1579),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1579),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_PLUS_PLUS] = ACTIONS(1579),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1579),
    [anon_sym_DASH_PERCENT] = ACTIONS(1579),
    [anon_sym_PLUS_PIPE] = ACTIONS(1579),
    [anon_sym_DASH_PIPE] = ACTIONS(1579),
    [anon_sym_PIPE_PIPE] = ACTIONS(1579),
    [anon_sym_SLASH] = ACTIONS(1581),
    [anon_sym_PERCENT] = ACTIONS(1579),
    [anon_sym_STAR_STAR] = ACTIONS(1579),
    [anon_sym_STAR_PERCENT] = ACTIONS(1579),
    [anon_sym_STAR_PIPE] = ACTIONS(1579),
    [anon_sym_QMARK] = ACTIONS(1579),
    [anon_sym_struct] = ACTIONS(1581),
    [anon_sym_opaque] = ACTIONS(1581),
    [anon_sym_enum] = ACTIONS(1581),
    [anon_sym_union] = ACTIONS(1581),
    [sym_doc_comment] = ACTIONS(1579),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1579),
    [aux_sym_FLOAT_token1] = ACTIONS(1579),
    [aux_sym_FLOAT_token2] = ACTIONS(1579),
    [aux_sym_FLOAT_token3] = ACTIONS(1579),
    [aux_sym_FLOAT_token4] = ACTIONS(1579),
    [aux_sym_INTEGER_token1] = ACTIONS(1579),
    [aux_sym_INTEGER_token2] = ACTIONS(1579),
    [aux_sym_INTEGER_token3] = ACTIONS(1581),
    [aux_sym_INTEGER_token4] = ACTIONS(1581),
    [anon_sym_DQUOTE] = ACTIONS(1579),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1579),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1581),
    [anon_sym_AT] = ACTIONS(1579),
  },
  [675] = {
    [ts_builtin_sym_end] = ACTIONS(576),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_pub] = ACTIONS(578),
    [anon_sym_test] = ACTIONS(578),
    [anon_sym_comptime] = ACTIONS(578),
    [anon_sym_export] = ACTIONS(578),
    [anon_sym_extern] = ACTIONS(578),
    [anon_sym_inline] = ACTIONS(578),
    [anon_sym_noinline] = ACTIONS(578),
    [anon_sym_threadlocal] = ACTIONS(578),
    [anon_sym_usingnamespace] = ACTIONS(578),
    [anon_sym_fn] = ACTIONS(578),
    [anon_sym_const] = ACTIONS(578),
    [anon_sym_var] = ACTIONS(578),
    [anon_sym_or] = ACTIONS(578),
    [anon_sym_and] = ACTIONS(578),
    [anon_sym_RBRACE] = ACTIONS(576),
    [anon_sym_async] = ACTIONS(578),
    [anon_sym_DOT] = ACTIONS(576),
    [anon_sym_error] = ACTIONS(578),
    [anon_sym_false] = ACTIONS(578),
    [anon_sym_null] = ACTIONS(578),
    [anon_sym_anyframe] = ACTIONS(578),
    [anon_sym_true] = ACTIONS(578),
    [anon_sym_undefined] = ACTIONS(578),
    [anon_sym_unreachable] = ACTIONS(578),
    [sym_BuildinTypeExpr] = ACTIONS(578),
    [anon_sym_packed] = ACTIONS(578),
    [anon_sym_LPAREN] = ACTIONS(576),
    [anon_sym_switch] = ACTIONS(578),
    [anon_sym_LBRACK] = ACTIONS(576),
    [anon_sym_if] = ACTIONS(578),
    [anon_sym_while] = ACTIONS(578),
    [anon_sym_for] = ACTIONS(578),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_STAR] = ACTIONS(578),
    [anon_sym_EQ_EQ] = ACTIONS(576),
    [anon_sym_BANG_EQ] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_GT] = ACTIONS(578),
    [anon_sym_LT_EQ] = ACTIONS(576),
    [anon_sym_GT_EQ] = ACTIONS(576),
    [anon_sym_AMP] = ACTIONS(576),
    [anon_sym_CARET] = ACTIONS(576),
    [anon_sym_orelse] = ACTIONS(578),
    [anon_sym_catch] = ACTIONS(578),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_GT_GT] = ACTIONS(576),
    [anon_sym_LT_LT_PIPE] = ACTIONS(576),
    [anon_sym_PLUS] = ACTIONS(578),
    [anon_sym_DASH] = ACTIONS(578),
    [anon_sym_PLUS_PLUS] = ACTIONS(576),
    [anon_sym_PLUS_PERCENT] = ACTIONS(576),
    [anon_sym_DASH_PERCENT] = ACTIONS(576),
    [anon_sym_PLUS_PIPE] = ACTIONS(576),
    [anon_sym_DASH_PIPE] = ACTIONS(576),
    [anon_sym_PIPE_PIPE] = ACTIONS(576),
    [anon_sym_SLASH] = ACTIONS(578),
    [anon_sym_PERCENT] = ACTIONS(576),
    [anon_sym_STAR_STAR] = ACTIONS(576),
    [anon_sym_STAR_PERCENT] = ACTIONS(576),
    [anon_sym_STAR_PIPE] = ACTIONS(576),
    [anon_sym_QMARK] = ACTIONS(576),
    [anon_sym_struct] = ACTIONS(578),
    [anon_sym_opaque] = ACTIONS(578),
    [anon_sym_enum] = ACTIONS(578),
    [anon_sym_union] = ACTIONS(578),
    [sym_doc_comment] = ACTIONS(576),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(576),
    [aux_sym_FLOAT_token1] = ACTIONS(576),
    [aux_sym_FLOAT_token2] = ACTIONS(576),
    [aux_sym_FLOAT_token3] = ACTIONS(576),
    [aux_sym_FLOAT_token4] = ACTIONS(576),
    [aux_sym_INTEGER_token1] = ACTIONS(576),
    [aux_sym_INTEGER_token2] = ACTIONS(576),
    [aux_sym_INTEGER_token3] = ACTIONS(578),
    [aux_sym_INTEGER_token4] = ACTIONS(578),
    [anon_sym_DQUOTE] = ACTIONS(576),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(576),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(578),
    [anon_sym_AT] = ACTIONS(576),
  },
  [676] = {
    [ts_builtin_sym_end] = ACTIONS(1613),
    [anon_sym_COMMA] = ACTIONS(1613),
    [anon_sym_pub] = ACTIONS(1615),
    [anon_sym_test] = ACTIONS(1615),
    [anon_sym_comptime] = ACTIONS(1615),
    [anon_sym_export] = ACTIONS(1615),
    [anon_sym_extern] = ACTIONS(1615),
    [anon_sym_inline] = ACTIONS(1615),
    [anon_sym_noinline] = ACTIONS(1615),
    [anon_sym_threadlocal] = ACTIONS(1615),
    [anon_sym_usingnamespace] = ACTIONS(1615),
    [anon_sym_fn] = ACTIONS(1615),
    [anon_sym_const] = ACTIONS(1615),
    [anon_sym_var] = ACTIONS(1615),
    [anon_sym_or] = ACTIONS(1615),
    [anon_sym_and] = ACTIONS(1615),
    [anon_sym_RBRACE] = ACTIONS(1613),
    [anon_sym_async] = ACTIONS(1615),
    [anon_sym_DOT] = ACTIONS(1613),
    [anon_sym_error] = ACTIONS(1615),
    [anon_sym_false] = ACTIONS(1615),
    [anon_sym_null] = ACTIONS(1615),
    [anon_sym_anyframe] = ACTIONS(1615),
    [anon_sym_true] = ACTIONS(1615),
    [anon_sym_undefined] = ACTIONS(1615),
    [anon_sym_unreachable] = ACTIONS(1615),
    [sym_BuildinTypeExpr] = ACTIONS(1615),
    [anon_sym_packed] = ACTIONS(1615),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_switch] = ACTIONS(1615),
    [anon_sym_LBRACK] = ACTIONS(1613),
    [anon_sym_if] = ACTIONS(1615),
    [anon_sym_while] = ACTIONS(1615),
    [anon_sym_for] = ACTIONS(1615),
    [anon_sym_PIPE] = ACTIONS(1615),
    [anon_sym_STAR] = ACTIONS(1615),
    [anon_sym_EQ_EQ] = ACTIONS(1613),
    [anon_sym_BANG_EQ] = ACTIONS(1613),
    [anon_sym_LT] = ACTIONS(1615),
    [anon_sym_GT] = ACTIONS(1615),
    [anon_sym_LT_EQ] = ACTIONS(1613),
    [anon_sym_GT_EQ] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1613),
    [anon_sym_CARET] = ACTIONS(1613),
    [anon_sym_orelse] = ACTIONS(1615),
    [anon_sym_catch] = ACTIONS(1615),
    [anon_sym_LT_LT] = ACTIONS(1615),
    [anon_sym_GT_GT] = ACTIONS(1613),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1613),
    [anon_sym_PLUS] = ACTIONS(1615),
    [anon_sym_DASH] = ACTIONS(1615),
    [anon_sym_PLUS_PLUS] = ACTIONS(1613),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1613),
    [anon_sym_DASH_PERCENT] = ACTIONS(1613),
    [anon_sym_PLUS_PIPE] = ACTIONS(1613),
    [anon_sym_DASH_PIPE] = ACTIONS(1613),
    [anon_sym_PIPE_PIPE] = ACTIONS(1613),
    [anon_sym_SLASH] = ACTIONS(1615),
    [anon_sym_PERCENT] = ACTIONS(1613),
    [anon_sym_STAR_STAR] = ACTIONS(1613),
    [anon_sym_STAR_PERCENT] = ACTIONS(1613),
    [anon_sym_STAR_PIPE] = ACTIONS(1613),
    [anon_sym_QMARK] = ACTIONS(1613),
    [anon_sym_struct] = ACTIONS(1615),
    [anon_sym_opaque] = ACTIONS(1615),
    [anon_sym_enum] = ACTIONS(1615),
    [anon_sym_union] = ACTIONS(1615),
    [sym_doc_comment] = ACTIONS(1613),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1613),
    [aux_sym_FLOAT_token1] = ACTIONS(1613),
    [aux_sym_FLOAT_token2] = ACTIONS(1613),
    [aux_sym_FLOAT_token3] = ACTIONS(1613),
    [aux_sym_FLOAT_token4] = ACTIONS(1613),
    [aux_sym_INTEGER_token1] = ACTIONS(1613),
    [aux_sym_INTEGER_token2] = ACTIONS(1613),
    [aux_sym_INTEGER_token3] = ACTIONS(1615),
    [aux_sym_INTEGER_token4] = ACTIONS(1615),
    [anon_sym_DQUOTE] = ACTIONS(1613),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1613),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1615),
    [anon_sym_AT] = ACTIONS(1613),
  },
  [677] = {
    [ts_builtin_sym_end] = ACTIONS(1609),
    [anon_sym_COMMA] = ACTIONS(1609),
    [anon_sym_pub] = ACTIONS(1611),
    [anon_sym_test] = ACTIONS(1611),
    [anon_sym_comptime] = ACTIONS(1611),
    [anon_sym_export] = ACTIONS(1611),
    [anon_sym_extern] = ACTIONS(1611),
    [anon_sym_inline] = ACTIONS(1611),
    [anon_sym_noinline] = ACTIONS(1611),
    [anon_sym_threadlocal] = ACTIONS(1611),
    [anon_sym_usingnamespace] = ACTIONS(1611),
    [anon_sym_fn] = ACTIONS(1611),
    [anon_sym_const] = ACTIONS(1611),
    [anon_sym_var] = ACTIONS(1611),
    [anon_sym_or] = ACTIONS(1611),
    [anon_sym_and] = ACTIONS(1611),
    [anon_sym_RBRACE] = ACTIONS(1609),
    [anon_sym_async] = ACTIONS(1611),
    [anon_sym_DOT] = ACTIONS(1609),
    [anon_sym_error] = ACTIONS(1611),
    [anon_sym_false] = ACTIONS(1611),
    [anon_sym_null] = ACTIONS(1611),
    [anon_sym_anyframe] = ACTIONS(1611),
    [anon_sym_true] = ACTIONS(1611),
    [anon_sym_undefined] = ACTIONS(1611),
    [anon_sym_unreachable] = ACTIONS(1611),
    [sym_BuildinTypeExpr] = ACTIONS(1611),
    [anon_sym_packed] = ACTIONS(1611),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [anon_sym_switch] = ACTIONS(1611),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_if] = ACTIONS(1611),
    [anon_sym_while] = ACTIONS(1611),
    [anon_sym_for] = ACTIONS(1611),
    [anon_sym_PIPE] = ACTIONS(1611),
    [anon_sym_STAR] = ACTIONS(1611),
    [anon_sym_EQ_EQ] = ACTIONS(1609),
    [anon_sym_BANG_EQ] = ACTIONS(1609),
    [anon_sym_LT] = ACTIONS(1611),
    [anon_sym_GT] = ACTIONS(1611),
    [anon_sym_LT_EQ] = ACTIONS(1609),
    [anon_sym_GT_EQ] = ACTIONS(1609),
    [anon_sym_AMP] = ACTIONS(1609),
    [anon_sym_CARET] = ACTIONS(1609),
    [anon_sym_orelse] = ACTIONS(1611),
    [anon_sym_catch] = ACTIONS(1611),
    [anon_sym_LT_LT] = ACTIONS(1611),
    [anon_sym_GT_GT] = ACTIONS(1609),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1609),
    [anon_sym_PLUS] = ACTIONS(1611),
    [anon_sym_DASH] = ACTIONS(1611),
    [anon_sym_PLUS_PLUS] = ACTIONS(1609),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1609),
    [anon_sym_DASH_PERCENT] = ACTIONS(1609),
    [anon_sym_PLUS_PIPE] = ACTIONS(1609),
    [anon_sym_DASH_PIPE] = ACTIONS(1609),
    [anon_sym_PIPE_PIPE] = ACTIONS(1609),
    [anon_sym_SLASH] = ACTIONS(1611),
    [anon_sym_PERCENT] = ACTIONS(1609),
    [anon_sym_STAR_STAR] = ACTIONS(1609),
    [anon_sym_STAR_PERCENT] = ACTIONS(1609),
    [anon_sym_STAR_PIPE] = ACTIONS(1609),
    [anon_sym_QMARK] = ACTIONS(1609),
    [anon_sym_struct] = ACTIONS(1611),
    [anon_sym_opaque] = ACTIONS(1611),
    [anon_sym_enum] = ACTIONS(1611),
    [anon_sym_union] = ACTIONS(1611),
    [sym_doc_comment] = ACTIONS(1609),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1609),
    [aux_sym_FLOAT_token1] = ACTIONS(1609),
    [aux_sym_FLOAT_token2] = ACTIONS(1609),
    [aux_sym_FLOAT_token3] = ACTIONS(1609),
    [aux_sym_FLOAT_token4] = ACTIONS(1609),
    [aux_sym_INTEGER_token1] = ACTIONS(1609),
    [aux_sym_INTEGER_token2] = ACTIONS(1609),
    [aux_sym_INTEGER_token3] = ACTIONS(1611),
    [aux_sym_INTEGER_token4] = ACTIONS(1611),
    [anon_sym_DQUOTE] = ACTIONS(1609),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1609),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1611),
    [anon_sym_AT] = ACTIONS(1609),
  },
  [678] = {
    [ts_builtin_sym_end] = ACTIONS(1639),
    [anon_sym_COMMA] = ACTIONS(1639),
    [anon_sym_pub] = ACTIONS(1641),
    [anon_sym_test] = ACTIONS(1641),
    [anon_sym_comptime] = ACTIONS(1641),
    [anon_sym_export] = ACTIONS(1641),
    [anon_sym_extern] = ACTIONS(1641),
    [anon_sym_inline] = ACTIONS(1641),
    [anon_sym_noinline] = ACTIONS(1641),
    [anon_sym_threadlocal] = ACTIONS(1641),
    [anon_sym_usingnamespace] = ACTIONS(1641),
    [anon_sym_fn] = ACTIONS(1641),
    [anon_sym_const] = ACTIONS(1641),
    [anon_sym_var] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_RBRACE] = ACTIONS(1639),
    [anon_sym_async] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1639),
    [anon_sym_error] = ACTIONS(1641),
    [anon_sym_false] = ACTIONS(1641),
    [anon_sym_null] = ACTIONS(1641),
    [anon_sym_anyframe] = ACTIONS(1641),
    [anon_sym_true] = ACTIONS(1641),
    [anon_sym_undefined] = ACTIONS(1641),
    [anon_sym_unreachable] = ACTIONS(1641),
    [sym_BuildinTypeExpr] = ACTIONS(1641),
    [anon_sym_packed] = ACTIONS(1641),
    [anon_sym_LPAREN] = ACTIONS(1639),
    [anon_sym_switch] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1639),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_for] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(1641),
    [anon_sym_STAR] = ACTIONS(1641),
    [anon_sym_EQ_EQ] = ACTIONS(1639),
    [anon_sym_BANG_EQ] = ACTIONS(1639),
    [anon_sym_LT] = ACTIONS(1641),
    [anon_sym_GT] = ACTIONS(1641),
    [anon_sym_LT_EQ] = ACTIONS(1639),
    [anon_sym_GT_EQ] = ACTIONS(1639),
    [anon_sym_AMP] = ACTIONS(1639),
    [anon_sym_CARET] = ACTIONS(1639),
    [anon_sym_orelse] = ACTIONS(1641),
    [anon_sym_catch] = ACTIONS(1641),
    [anon_sym_LT_LT] = ACTIONS(1641),
    [anon_sym_GT_GT] = ACTIONS(1639),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1639),
    [anon_sym_PLUS] = ACTIONS(1641),
    [anon_sym_DASH] = ACTIONS(1641),
    [anon_sym_PLUS_PLUS] = ACTIONS(1639),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1639),
    [anon_sym_DASH_PERCENT] = ACTIONS(1639),
    [anon_sym_PLUS_PIPE] = ACTIONS(1639),
    [anon_sym_DASH_PIPE] = ACTIONS(1639),
    [anon_sym_PIPE_PIPE] = ACTIONS(1639),
    [anon_sym_SLASH] = ACTIONS(1641),
    [anon_sym_PERCENT] = ACTIONS(1639),
    [anon_sym_STAR_STAR] = ACTIONS(1639),
    [anon_sym_STAR_PERCENT] = ACTIONS(1639),
    [anon_sym_STAR_PIPE] = ACTIONS(1639),
    [anon_sym_QMARK] = ACTIONS(1639),
    [anon_sym_struct] = ACTIONS(1641),
    [anon_sym_opaque] = ACTIONS(1641),
    [anon_sym_enum] = ACTIONS(1641),
    [anon_sym_union] = ACTIONS(1641),
    [sym_doc_comment] = ACTIONS(1639),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1639),
    [aux_sym_FLOAT_token1] = ACTIONS(1639),
    [aux_sym_FLOAT_token2] = ACTIONS(1639),
    [aux_sym_FLOAT_token3] = ACTIONS(1639),
    [aux_sym_FLOAT_token4] = ACTIONS(1639),
    [aux_sym_INTEGER_token1] = ACTIONS(1639),
    [aux_sym_INTEGER_token2] = ACTIONS(1639),
    [aux_sym_INTEGER_token3] = ACTIONS(1641),
    [aux_sym_INTEGER_token4] = ACTIONS(1641),
    [anon_sym_DQUOTE] = ACTIONS(1639),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1639),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1641),
    [anon_sym_AT] = ACTIONS(1639),
  },
  [679] = {
    [ts_builtin_sym_end] = ACTIONS(1627),
    [anon_sym_COMMA] = ACTIONS(1627),
    [anon_sym_pub] = ACTIONS(1629),
    [anon_sym_test] = ACTIONS(1629),
    [anon_sym_comptime] = ACTIONS(1629),
    [anon_sym_export] = ACTIONS(1629),
    [anon_sym_extern] = ACTIONS(1629),
    [anon_sym_inline] = ACTIONS(1629),
    [anon_sym_noinline] = ACTIONS(1629),
    [anon_sym_threadlocal] = ACTIONS(1629),
    [anon_sym_usingnamespace] = ACTIONS(1629),
    [anon_sym_fn] = ACTIONS(1629),
    [anon_sym_const] = ACTIONS(1629),
    [anon_sym_var] = ACTIONS(1629),
    [anon_sym_or] = ACTIONS(1629),
    [anon_sym_and] = ACTIONS(1629),
    [anon_sym_RBRACE] = ACTIONS(1627),
    [anon_sym_async] = ACTIONS(1629),
    [anon_sym_DOT] = ACTIONS(1627),
    [anon_sym_error] = ACTIONS(1629),
    [anon_sym_false] = ACTIONS(1629),
    [anon_sym_null] = ACTIONS(1629),
    [anon_sym_anyframe] = ACTIONS(1629),
    [anon_sym_true] = ACTIONS(1629),
    [anon_sym_undefined] = ACTIONS(1629),
    [anon_sym_unreachable] = ACTIONS(1629),
    [sym_BuildinTypeExpr] = ACTIONS(1629),
    [anon_sym_packed] = ACTIONS(1629),
    [anon_sym_LPAREN] = ACTIONS(1627),
    [anon_sym_switch] = ACTIONS(1629),
    [anon_sym_LBRACK] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1629),
    [anon_sym_while] = ACTIONS(1629),
    [anon_sym_for] = ACTIONS(1629),
    [anon_sym_PIPE] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1629),
    [anon_sym_EQ_EQ] = ACTIONS(1627),
    [anon_sym_BANG_EQ] = ACTIONS(1627),
    [anon_sym_LT] = ACTIONS(1629),
    [anon_sym_GT] = ACTIONS(1629),
    [anon_sym_LT_EQ] = ACTIONS(1627),
    [anon_sym_GT_EQ] = ACTIONS(1627),
    [anon_sym_AMP] = ACTIONS(1627),
    [anon_sym_CARET] = ACTIONS(1627),
    [anon_sym_orelse] = ACTIONS(1629),
    [anon_sym_catch] = ACTIONS(1629),
    [anon_sym_LT_LT] = ACTIONS(1629),
    [anon_sym_GT_GT] = ACTIONS(1627),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1627),
    [anon_sym_PLUS] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_PLUS_PLUS] = ACTIONS(1627),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1627),
    [anon_sym_DASH_PERCENT] = ACTIONS(1627),
    [anon_sym_PLUS_PIPE] = ACTIONS(1627),
    [anon_sym_DASH_PIPE] = ACTIONS(1627),
    [anon_sym_PIPE_PIPE] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(1629),
    [anon_sym_PERCENT] = ACTIONS(1627),
    [anon_sym_STAR_STAR] = ACTIONS(1627),
    [anon_sym_STAR_PERCENT] = ACTIONS(1627),
    [anon_sym_STAR_PIPE] = ACTIONS(1627),
    [anon_sym_QMARK] = ACTIONS(1627),
    [anon_sym_struct] = ACTIONS(1629),
    [anon_sym_opaque] = ACTIONS(1629),
    [anon_sym_enum] = ACTIONS(1629),
    [anon_sym_union] = ACTIONS(1629),
    [sym_doc_comment] = ACTIONS(1627),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1627),
    [aux_sym_FLOAT_token1] = ACTIONS(1627),
    [aux_sym_FLOAT_token2] = ACTIONS(1627),
    [aux_sym_FLOAT_token3] = ACTIONS(1627),
    [aux_sym_FLOAT_token4] = ACTIONS(1627),
    [aux_sym_INTEGER_token1] = ACTIONS(1627),
    [aux_sym_INTEGER_token2] = ACTIONS(1627),
    [aux_sym_INTEGER_token3] = ACTIONS(1629),
    [aux_sym_INTEGER_token4] = ACTIONS(1629),
    [anon_sym_DQUOTE] = ACTIONS(1627),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1627),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1629),
    [anon_sym_AT] = ACTIONS(1627),
  },
  [680] = {
    [ts_builtin_sym_end] = ACTIONS(1589),
    [anon_sym_COMMA] = ACTIONS(1589),
    [anon_sym_pub] = ACTIONS(1591),
    [anon_sym_test] = ACTIONS(1591),
    [anon_sym_comptime] = ACTIONS(1591),
    [anon_sym_export] = ACTIONS(1591),
    [anon_sym_extern] = ACTIONS(1591),
    [anon_sym_inline] = ACTIONS(1591),
    [anon_sym_noinline] = ACTIONS(1591),
    [anon_sym_threadlocal] = ACTIONS(1591),
    [anon_sym_usingnamespace] = ACTIONS(1591),
    [anon_sym_fn] = ACTIONS(1591),
    [anon_sym_const] = ACTIONS(1591),
    [anon_sym_var] = ACTIONS(1591),
    [anon_sym_or] = ACTIONS(1591),
    [anon_sym_and] = ACTIONS(1591),
    [anon_sym_RBRACE] = ACTIONS(1589),
    [anon_sym_async] = ACTIONS(1591),
    [anon_sym_DOT] = ACTIONS(1589),
    [anon_sym_error] = ACTIONS(1591),
    [anon_sym_false] = ACTIONS(1591),
    [anon_sym_null] = ACTIONS(1591),
    [anon_sym_anyframe] = ACTIONS(1591),
    [anon_sym_true] = ACTIONS(1591),
    [anon_sym_undefined] = ACTIONS(1591),
    [anon_sym_unreachable] = ACTIONS(1591),
    [sym_BuildinTypeExpr] = ACTIONS(1591),
    [anon_sym_packed] = ACTIONS(1591),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_switch] = ACTIONS(1591),
    [anon_sym_LBRACK] = ACTIONS(1589),
    [anon_sym_if] = ACTIONS(1591),
    [anon_sym_while] = ACTIONS(1591),
    [anon_sym_for] = ACTIONS(1591),
    [anon_sym_PIPE] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1591),
    [anon_sym_EQ_EQ] = ACTIONS(1589),
    [anon_sym_BANG_EQ] = ACTIONS(1589),
    [anon_sym_LT] = ACTIONS(1591),
    [anon_sym_GT] = ACTIONS(1591),
    [anon_sym_LT_EQ] = ACTIONS(1589),
    [anon_sym_GT_EQ] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_orelse] = ACTIONS(1591),
    [anon_sym_catch] = ACTIONS(1591),
    [anon_sym_LT_LT] = ACTIONS(1591),
    [anon_sym_GT_GT] = ACTIONS(1589),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1589),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1589),
    [anon_sym_DASH_PERCENT] = ACTIONS(1589),
    [anon_sym_PLUS_PIPE] = ACTIONS(1589),
    [anon_sym_DASH_PIPE] = ACTIONS(1589),
    [anon_sym_PIPE_PIPE] = ACTIONS(1589),
    [anon_sym_SLASH] = ACTIONS(1591),
    [anon_sym_PERCENT] = ACTIONS(1589),
    [anon_sym_STAR_STAR] = ACTIONS(1589),
    [anon_sym_STAR_PERCENT] = ACTIONS(1589),
    [anon_sym_STAR_PIPE] = ACTIONS(1589),
    [anon_sym_QMARK] = ACTIONS(1589),
    [anon_sym_struct] = ACTIONS(1591),
    [anon_sym_opaque] = ACTIONS(1591),
    [anon_sym_enum] = ACTIONS(1591),
    [anon_sym_union] = ACTIONS(1591),
    [sym_doc_comment] = ACTIONS(1589),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1589),
    [aux_sym_FLOAT_token1] = ACTIONS(1589),
    [aux_sym_FLOAT_token2] = ACTIONS(1589),
    [aux_sym_FLOAT_token3] = ACTIONS(1589),
    [aux_sym_FLOAT_token4] = ACTIONS(1589),
    [aux_sym_INTEGER_token1] = ACTIONS(1589),
    [aux_sym_INTEGER_token2] = ACTIONS(1589),
    [aux_sym_INTEGER_token3] = ACTIONS(1591),
    [aux_sym_INTEGER_token4] = ACTIONS(1591),
    [anon_sym_DQUOTE] = ACTIONS(1589),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1589),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1591),
    [anon_sym_AT] = ACTIONS(1589),
  },
  [681] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(2091),
    [sym_ErrorUnionExpr] = STATE(2091),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_ParamDecl] = STATE(2046),
    [sym_ParamType] = STATE(2075),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(1673),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1595),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(1597),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_noalias] = ACTIONS(1601),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1603),
    [anon_sym_anytype] = ACTIONS(1605),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_doc_comment] = ACTIONS(1607),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [682] = {
    [ts_builtin_sym_end] = ACTIONS(155),
    [anon_sym_COMMA] = ACTIONS(155),
    [anon_sym_pub] = ACTIONS(157),
    [anon_sym_test] = ACTIONS(157),
    [anon_sym_comptime] = ACTIONS(157),
    [anon_sym_export] = ACTIONS(157),
    [anon_sym_extern] = ACTIONS(157),
    [anon_sym_inline] = ACTIONS(157),
    [anon_sym_noinline] = ACTIONS(157),
    [anon_sym_threadlocal] = ACTIONS(157),
    [anon_sym_usingnamespace] = ACTIONS(157),
    [anon_sym_fn] = ACTIONS(157),
    [anon_sym_const] = ACTIONS(157),
    [anon_sym_var] = ACTIONS(157),
    [anon_sym_or] = ACTIONS(157),
    [anon_sym_and] = ACTIONS(157),
    [anon_sym_RBRACE] = ACTIONS(155),
    [anon_sym_async] = ACTIONS(157),
    [anon_sym_DOT] = ACTIONS(155),
    [anon_sym_error] = ACTIONS(157),
    [anon_sym_false] = ACTIONS(157),
    [anon_sym_null] = ACTIONS(157),
    [anon_sym_anyframe] = ACTIONS(157),
    [anon_sym_true] = ACTIONS(157),
    [anon_sym_undefined] = ACTIONS(157),
    [anon_sym_unreachable] = ACTIONS(157),
    [sym_BuildinTypeExpr] = ACTIONS(157),
    [anon_sym_packed] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(157),
    [anon_sym_while] = ACTIONS(157),
    [anon_sym_for] = ACTIONS(157),
    [anon_sym_PIPE] = ACTIONS(157),
    [anon_sym_STAR] = ACTIONS(157),
    [anon_sym_EQ_EQ] = ACTIONS(155),
    [anon_sym_BANG_EQ] = ACTIONS(155),
    [anon_sym_LT] = ACTIONS(157),
    [anon_sym_GT] = ACTIONS(157),
    [anon_sym_LT_EQ] = ACTIONS(155),
    [anon_sym_GT_EQ] = ACTIONS(155),
    [anon_sym_AMP] = ACTIONS(155),
    [anon_sym_CARET] = ACTIONS(155),
    [anon_sym_orelse] = ACTIONS(157),
    [anon_sym_catch] = ACTIONS(157),
    [anon_sym_LT_LT] = ACTIONS(157),
    [anon_sym_GT_GT] = ACTIONS(155),
    [anon_sym_LT_LT_PIPE] = ACTIONS(155),
    [anon_sym_PLUS] = ACTIONS(157),
    [anon_sym_DASH] = ACTIONS(157),
    [anon_sym_PLUS_PLUS] = ACTIONS(155),
    [anon_sym_PLUS_PERCENT] = ACTIONS(155),
    [anon_sym_DASH_PERCENT] = ACTIONS(155),
    [anon_sym_PLUS_PIPE] = ACTIONS(155),
    [anon_sym_DASH_PIPE] = ACTIONS(155),
    [anon_sym_PIPE_PIPE] = ACTIONS(155),
    [anon_sym_SLASH] = ACTIONS(157),
    [anon_sym_PERCENT] = ACTIONS(155),
    [anon_sym_STAR_STAR] = ACTIONS(155),
    [anon_sym_STAR_PERCENT] = ACTIONS(155),
    [anon_sym_STAR_PIPE] = ACTIONS(155),
    [anon_sym_QMARK] = ACTIONS(155),
    [anon_sym_struct] = ACTIONS(157),
    [anon_sym_opaque] = ACTIONS(157),
    [anon_sym_enum] = ACTIONS(157),
    [anon_sym_union] = ACTIONS(157),
    [sym_doc_comment] = ACTIONS(155),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(155),
    [aux_sym_FLOAT_token1] = ACTIONS(155),
    [aux_sym_FLOAT_token2] = ACTIONS(155),
    [aux_sym_FLOAT_token3] = ACTIONS(155),
    [aux_sym_FLOAT_token4] = ACTIONS(155),
    [aux_sym_INTEGER_token1] = ACTIONS(155),
    [aux_sym_INTEGER_token2] = ACTIONS(155),
    [aux_sym_INTEGER_token3] = ACTIONS(157),
    [aux_sym_INTEGER_token4] = ACTIONS(157),
    [anon_sym_DQUOTE] = ACTIONS(155),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(155),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(157),
    [anon_sym_AT] = ACTIONS(155),
  },
  [683] = {
    [ts_builtin_sym_end] = ACTIONS(1583),
    [anon_sym_COMMA] = ACTIONS(1583),
    [anon_sym_pub] = ACTIONS(1585),
    [anon_sym_test] = ACTIONS(1585),
    [anon_sym_comptime] = ACTIONS(1585),
    [anon_sym_export] = ACTIONS(1585),
    [anon_sym_extern] = ACTIONS(1585),
    [anon_sym_inline] = ACTIONS(1585),
    [anon_sym_noinline] = ACTIONS(1585),
    [anon_sym_threadlocal] = ACTIONS(1585),
    [anon_sym_usingnamespace] = ACTIONS(1585),
    [anon_sym_fn] = ACTIONS(1585),
    [anon_sym_const] = ACTIONS(1585),
    [anon_sym_var] = ACTIONS(1585),
    [anon_sym_or] = ACTIONS(1585),
    [anon_sym_and] = ACTIONS(1585),
    [anon_sym_RBRACE] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_DOT] = ACTIONS(1583),
    [anon_sym_error] = ACTIONS(1585),
    [anon_sym_false] = ACTIONS(1585),
    [anon_sym_null] = ACTIONS(1585),
    [anon_sym_anyframe] = ACTIONS(1585),
    [anon_sym_true] = ACTIONS(1585),
    [anon_sym_undefined] = ACTIONS(1585),
    [anon_sym_unreachable] = ACTIONS(1585),
    [sym_BuildinTypeExpr] = ACTIONS(1585),
    [anon_sym_packed] = ACTIONS(1585),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_switch] = ACTIONS(1585),
    [anon_sym_LBRACK] = ACTIONS(1583),
    [anon_sym_if] = ACTIONS(1585),
    [anon_sym_while] = ACTIONS(1585),
    [anon_sym_for] = ACTIONS(1585),
    [anon_sym_PIPE] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1585),
    [anon_sym_EQ_EQ] = ACTIONS(1583),
    [anon_sym_BANG_EQ] = ACTIONS(1583),
    [anon_sym_LT] = ACTIONS(1585),
    [anon_sym_GT] = ACTIONS(1585),
    [anon_sym_LT_EQ] = ACTIONS(1583),
    [anon_sym_GT_EQ] = ACTIONS(1583),
    [anon_sym_AMP] = ACTIONS(1583),
    [anon_sym_CARET] = ACTIONS(1583),
    [anon_sym_orelse] = ACTIONS(1585),
    [anon_sym_catch] = ACTIONS(1585),
    [anon_sym_LT_LT] = ACTIONS(1585),
    [anon_sym_GT_GT] = ACTIONS(1583),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1583),
    [anon_sym_PLUS] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_PLUS_PLUS] = ACTIONS(1583),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1583),
    [anon_sym_DASH_PERCENT] = ACTIONS(1583),
    [anon_sym_PLUS_PIPE] = ACTIONS(1583),
    [anon_sym_DASH_PIPE] = ACTIONS(1583),
    [anon_sym_PIPE_PIPE] = ACTIONS(1583),
    [anon_sym_SLASH] = ACTIONS(1585),
    [anon_sym_PERCENT] = ACTIONS(1583),
    [anon_sym_STAR_STAR] = ACTIONS(1583),
    [anon_sym_STAR_PERCENT] = ACTIONS(1583),
    [anon_sym_STAR_PIPE] = ACTIONS(1583),
    [anon_sym_QMARK] = ACTIONS(1583),
    [anon_sym_struct] = ACTIONS(1585),
    [anon_sym_opaque] = ACTIONS(1585),
    [anon_sym_enum] = ACTIONS(1585),
    [anon_sym_union] = ACTIONS(1585),
    [sym_doc_comment] = ACTIONS(1583),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1583),
    [aux_sym_FLOAT_token1] = ACTIONS(1583),
    [aux_sym_FLOAT_token2] = ACTIONS(1583),
    [aux_sym_FLOAT_token3] = ACTIONS(1583),
    [aux_sym_FLOAT_token4] = ACTIONS(1583),
    [aux_sym_INTEGER_token1] = ACTIONS(1583),
    [aux_sym_INTEGER_token2] = ACTIONS(1583),
    [aux_sym_INTEGER_token3] = ACTIONS(1585),
    [aux_sym_INTEGER_token4] = ACTIONS(1585),
    [anon_sym_DQUOTE] = ACTIONS(1583),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1583),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1585),
    [anon_sym_AT] = ACTIONS(1583),
  },
  [684] = {
    [ts_builtin_sym_end] = ACTIONS(1643),
    [anon_sym_COMMA] = ACTIONS(1643),
    [anon_sym_pub] = ACTIONS(1645),
    [anon_sym_test] = ACTIONS(1645),
    [anon_sym_comptime] = ACTIONS(1645),
    [anon_sym_export] = ACTIONS(1645),
    [anon_sym_extern] = ACTIONS(1645),
    [anon_sym_inline] = ACTIONS(1645),
    [anon_sym_noinline] = ACTIONS(1645),
    [anon_sym_threadlocal] = ACTIONS(1645),
    [anon_sym_usingnamespace] = ACTIONS(1645),
    [anon_sym_fn] = ACTIONS(1645),
    [anon_sym_const] = ACTIONS(1645),
    [anon_sym_var] = ACTIONS(1645),
    [anon_sym_or] = ACTIONS(1645),
    [anon_sym_and] = ACTIONS(1645),
    [anon_sym_RBRACE] = ACTIONS(1643),
    [anon_sym_async] = ACTIONS(1645),
    [anon_sym_DOT] = ACTIONS(1643),
    [anon_sym_error] = ACTIONS(1645),
    [anon_sym_false] = ACTIONS(1645),
    [anon_sym_null] = ACTIONS(1645),
    [anon_sym_anyframe] = ACTIONS(1645),
    [anon_sym_true] = ACTIONS(1645),
    [anon_sym_undefined] = ACTIONS(1645),
    [anon_sym_unreachable] = ACTIONS(1645),
    [sym_BuildinTypeExpr] = ACTIONS(1645),
    [anon_sym_packed] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(1643),
    [anon_sym_switch] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(1643),
    [anon_sym_if] = ACTIONS(1645),
    [anon_sym_while] = ACTIONS(1645),
    [anon_sym_for] = ACTIONS(1645),
    [anon_sym_PIPE] = ACTIONS(1645),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_EQ_EQ] = ACTIONS(1643),
    [anon_sym_BANG_EQ] = ACTIONS(1643),
    [anon_sym_LT] = ACTIONS(1645),
    [anon_sym_GT] = ACTIONS(1645),
    [anon_sym_LT_EQ] = ACTIONS(1643),
    [anon_sym_GT_EQ] = ACTIONS(1643),
    [anon_sym_AMP] = ACTIONS(1643),
    [anon_sym_CARET] = ACTIONS(1643),
    [anon_sym_orelse] = ACTIONS(1645),
    [anon_sym_catch] = ACTIONS(1645),
    [anon_sym_LT_LT] = ACTIONS(1645),
    [anon_sym_GT_GT] = ACTIONS(1643),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1643),
    [anon_sym_PLUS] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_PLUS_PLUS] = ACTIONS(1643),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1643),
    [anon_sym_DASH_PERCENT] = ACTIONS(1643),
    [anon_sym_PLUS_PIPE] = ACTIONS(1643),
    [anon_sym_DASH_PIPE] = ACTIONS(1643),
    [anon_sym_PIPE_PIPE] = ACTIONS(1643),
    [anon_sym_SLASH] = ACTIONS(1645),
    [anon_sym_PERCENT] = ACTIONS(1643),
    [anon_sym_STAR_STAR] = ACTIONS(1643),
    [anon_sym_STAR_PERCENT] = ACTIONS(1643),
    [anon_sym_STAR_PIPE] = ACTIONS(1643),
    [anon_sym_QMARK] = ACTIONS(1643),
    [anon_sym_struct] = ACTIONS(1645),
    [anon_sym_opaque] = ACTIONS(1645),
    [anon_sym_enum] = ACTIONS(1645),
    [anon_sym_union] = ACTIONS(1645),
    [sym_doc_comment] = ACTIONS(1643),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(1643),
    [aux_sym_FLOAT_token1] = ACTIONS(1643),
    [aux_sym_FLOAT_token2] = ACTIONS(1643),
    [aux_sym_FLOAT_token3] = ACTIONS(1643),
    [aux_sym_FLOAT_token4] = ACTIONS(1643),
    [aux_sym_INTEGER_token1] = ACTIONS(1643),
    [aux_sym_INTEGER_token2] = ACTIONS(1643),
    [aux_sym_INTEGER_token3] = ACTIONS(1645),
    [aux_sym_INTEGER_token4] = ACTIONS(1645),
    [anon_sym_DQUOTE] = ACTIONS(1643),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1643),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1645),
    [anon_sym_AT] = ACTIONS(1643),
  },
  [685] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1471),
    [sym_ErrorUnionExpr] = STATE(1471),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_LinkSection] = STATE(748),
    [sym_CallConv] = STATE(809),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [686] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(514),
    [sym_ErrorUnionExpr] = STATE(514),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_LinkSection] = STATE(713),
    [sym_CallConv] = STATE(813),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [687] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(592),
    [sym_ErrorUnionExpr] = STATE(592),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_LinkSection] = STATE(724),
    [sym_CallConv] = STATE(790),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [688] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(499),
    [sym_ErrorUnionExpr] = STATE(499),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_LinkSection] = STATE(739),
    [sym_CallConv] = STATE(785),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [689] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(967),
    [sym_ErrorUnionExpr] = STATE(967),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_LinkSection] = STATE(717),
    [sym_CallConv] = STATE(800),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1651),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [690] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(964),
    [sym_ErrorUnionExpr] = STATE(964),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_LinkSection] = STATE(715),
    [sym_CallConv] = STATE(763),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1637),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [691] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1500),
    [sym_ErrorUnionExpr] = STATE(1500),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_LinkSection] = STATE(738),
    [sym_CallConv] = STATE(773),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [692] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(529),
    [sym_ErrorUnionExpr] = STATE(529),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_LinkSection] = STATE(746),
    [sym_CallConv] = STATE(807),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [693] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(997),
    [sym_ErrorUnionExpr] = STATE(997),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_LinkSection] = STATE(743),
    [sym_CallConv] = STATE(804),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [694] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1262),
    [sym_ErrorUnionExpr] = STATE(1262),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_LinkSection] = STATE(745),
    [sym_CallConv] = STATE(788),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1655),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [695] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1228),
    [sym_ErrorUnionExpr] = STATE(1228),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_LinkSection] = STATE(720),
    [sym_CallConv] = STATE(764),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1633),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [696] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(590),
    [sym_ErrorUnionExpr] = STATE(590),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_LinkSection] = STATE(709),
    [sym_CallConv] = STATE(784),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(1657),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [697] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1110),
    [sym_ErrorUnionExpr] = STATE(1110),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_LinkSection] = STATE(728),
    [sym_CallConv] = STATE(787),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1577),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [698] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1490),
    [sym_ErrorUnionExpr] = STATE(1490),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_LinkSection] = STATE(716),
    [sym_CallConv] = STATE(802),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1659),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [699] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1138),
    [sym_ErrorUnionExpr] = STATE(1138),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_LinkSection] = STATE(723),
    [sym_CallConv] = STATE(789),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [700] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1133),
    [sym_ErrorUnionExpr] = STATE(1133),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_LinkSection] = STATE(730),
    [sym_CallConv] = STATE(779),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1661),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [701] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(580),
    [sym_ErrorUnionExpr] = STATE(580),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_LinkSection] = STATE(744),
    [sym_CallConv] = STATE(792),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [702] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1160),
    [sym_ErrorUnionExpr] = STATE(1160),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_LinkSection] = STATE(718),
    [sym_CallConv] = STATE(801),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1663),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [703] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(965),
    [sym_ErrorUnionExpr] = STATE(965),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_LinkSection] = STATE(729),
    [sym_CallConv] = STATE(798),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [704] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(516),
    [sym_ErrorUnionExpr] = STATE(516),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_LinkSection] = STATE(721),
    [sym_CallConv] = STATE(793),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [705] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1249),
    [sym_ErrorUnionExpr] = STATE(1249),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_LinkSection] = STATE(731),
    [sym_CallConv] = STATE(776),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1667),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [706] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1254),
    [sym_ErrorUnionExpr] = STATE(1254),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_LinkSection] = STATE(725),
    [sym_CallConv] = STATE(783),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1593),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [707] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(604),
    [sym_ErrorUnionExpr] = STATE(604),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_LinkSection] = STATE(714),
    [sym_CallConv] = STATE(808),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [708] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1487),
    [sym_ErrorUnionExpr] = STATE(1487),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_LinkSection] = STATE(735),
    [sym_CallConv] = STATE(766),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_linksection] = ACTIONS(1481),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [709] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(602),
    [sym_ErrorUnionExpr] = STATE(602),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_CallConv] = STATE(803),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(1671),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [710] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(997),
    [sym_ErrorUnionExpr] = STATE(997),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_CallConv] = STATE(804),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [711] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1228),
    [sym_ErrorUnionExpr] = STATE(1228),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_CallConv] = STATE(764),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1633),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [712] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(516),
    [sym_ErrorUnionExpr] = STATE(516),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_CallConv] = STATE(793),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [713] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(527),
    [sym_ErrorUnionExpr] = STATE(527),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_CallConv] = STATE(777),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(1673),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [714] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(614),
    [sym_ErrorUnionExpr] = STATE(614),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_CallConv] = STATE(781),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [715] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(965),
    [sym_ErrorUnionExpr] = STATE(965),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_CallConv] = STATE(798),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [716] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1475),
    [sym_ErrorUnionExpr] = STATE(1475),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_CallConv] = STATE(782),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1677),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [717] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(961),
    [sym_ErrorUnionExpr] = STATE(961),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_CallConv] = STATE(810),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [718] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1176),
    [sym_ErrorUnionExpr] = STATE(1176),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_CallConv] = STATE(805),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [719] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(499),
    [sym_ErrorUnionExpr] = STATE(499),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_CallConv] = STATE(785),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [720] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1262),
    [sym_ErrorUnionExpr] = STATE(1262),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_CallConv] = STATE(788),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1655),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [721] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(529),
    [sym_ErrorUnionExpr] = STATE(529),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_CallConv] = STATE(807),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [722] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1254),
    [sym_ErrorUnionExpr] = STATE(1254),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_CallConv] = STATE(783),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1593),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [723] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1160),
    [sym_ErrorUnionExpr] = STATE(1160),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_CallConv] = STATE(801),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1663),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [724] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(604),
    [sym_ErrorUnionExpr] = STATE(604),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_CallConv] = STATE(808),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [725] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1249),
    [sym_ErrorUnionExpr] = STATE(1249),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_CallConv] = STATE(776),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1667),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [726] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1487),
    [sym_ErrorUnionExpr] = STATE(1487),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_CallConv] = STATE(766),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [727] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(2091),
    [sym_ErrorUnionExpr] = STATE(2091),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_ParamType] = STATE(2019),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(752),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_LBRACE] = ACTIONS(754),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_anytype] = ACTIONS(1605),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(752),
    [anon_sym_for] = ACTIONS(752),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [728] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1133),
    [sym_ErrorUnionExpr] = STATE(1133),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_CallConv] = STATE(779),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1661),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [729] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(983),
    [sym_ErrorUnionExpr] = STATE(983),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_CallConv] = STATE(780),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [730] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1156),
    [sym_ErrorUnionExpr] = STATE(1156),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_CallConv] = STATE(799),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1685),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [731] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1260),
    [sym_ErrorUnionExpr] = STATE(1260),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_CallConv] = STATE(769),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1687),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [732] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1138),
    [sym_ErrorUnionExpr] = STATE(1138),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_CallConv] = STATE(789),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [733] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(2091),
    [sym_ErrorUnionExpr] = STATE(2091),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_ParamType] = STATE(2055),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(752),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_LBRACE] = ACTIONS(754),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_anytype] = ACTIONS(1605),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(752),
    [anon_sym_for] = ACTIONS(752),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [734] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(2091),
    [sym_ErrorUnionExpr] = STATE(2091),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_ParamType] = STATE(2040),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(1675),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1689),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(1691),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_noalias] = ACTIONS(1693),
    [anon_sym_anytype] = ACTIONS(1605),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [735] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1471),
    [sym_ErrorUnionExpr] = STATE(1471),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_CallConv] = STATE(809),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [736] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(580),
    [sym_ErrorUnionExpr] = STATE(580),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_CallConv] = STATE(792),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [737] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1110),
    [sym_ErrorUnionExpr] = STATE(1110),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_CallConv] = STATE(787),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1577),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [738] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1490),
    [sym_ErrorUnionExpr] = STATE(1490),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_CallConv] = STATE(802),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1659),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [739] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(514),
    [sym_ErrorUnionExpr] = STATE(514),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_CallConv] = STATE(813),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [740] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(2091),
    [sym_ErrorUnionExpr] = STATE(2091),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_ParamType] = STATE(2061),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(752),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_LBRACE] = ACTIONS(754),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_anytype] = ACTIONS(1605),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(752),
    [anon_sym_for] = ACTIONS(752),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [741] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1500),
    [sym_ErrorUnionExpr] = STATE(1500),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_CallConv] = STATE(773),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [742] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(964),
    [sym_ErrorUnionExpr] = STATE(964),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_CallConv] = STATE(763),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1637),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [743] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(967),
    [sym_ErrorUnionExpr] = STATE(967),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_CallConv] = STATE(800),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1651),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [744] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(590),
    [sym_ErrorUnionExpr] = STATE(590),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_CallConv] = STATE(784),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(1657),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [745] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1244),
    [sym_ErrorUnionExpr] = STATE(1244),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_CallConv] = STATE(796),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1695),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [746] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(539),
    [sym_ErrorUnionExpr] = STATE(539),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_CallConv] = STATE(795),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [747] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(592),
    [sym_ErrorUnionExpr] = STATE(592),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_CallConv] = STATE(790),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [748] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1460),
    [sym_ErrorUnionExpr] = STATE(1460),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_CallConv] = STATE(786),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_callconv] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [749] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(2091),
    [sym_ErrorUnionExpr] = STATE(2091),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_ParamType] = STATE(2084),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_anytype] = ACTIONS(1605),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [750] = {
    [sym_FnProto] = STATE(1037),
    [sym_Block] = STATE(1364),
    [sym__TypeExpr] = STATE(1278),
    [sym_ErrorUnionExpr] = STATE(1278),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1056),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(1701),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(1471),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [751] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(2091),
    [sym_ErrorUnionExpr] = STATE(2091),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_ParamType] = STATE(2040),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(1675),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(1691),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_anytype] = ACTIONS(1605),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [752] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(1734),
    [sym_ErrorUnionExpr] = STATE(1734),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_ParamType] = STATE(2040),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(1675),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(1691),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_anytype] = ACTIONS(1605),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [753] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(511),
    [sym_ErrorUnionExpr] = STATE(511),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_Payload] = STATE(897),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [754] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1125),
    [sym_ErrorUnionExpr] = STATE(1125),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_Payload] = STATE(858),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [755] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(1019),
    [sym_ErrorUnionExpr] = STATE(1019),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_Payload] = STATE(922),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [756] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(2091),
    [sym_ErrorUnionExpr] = STATE(2091),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_ParamType] = STATE(2018),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_anytype] = ACTIONS(1605),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [757] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1493),
    [sym_ErrorUnionExpr] = STATE(1493),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_Payload] = STATE(881),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [758] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(2091),
    [sym_ErrorUnionExpr] = STATE(2091),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_ParamType] = STATE(2056),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_anytype] = ACTIONS(1605),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [759] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1230),
    [sym_ErrorUnionExpr] = STATE(1230),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_Payload] = STATE(904),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [760] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(1734),
    [sym_ErrorUnionExpr] = STATE(1734),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_ParamType] = STATE(2080),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(1668),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(1705),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_anytype] = ACTIONS(1605),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [761] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(587),
    [sym_ErrorUnionExpr] = STATE(587),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_Payload] = STATE(867),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [762] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(2091),
    [sym_ErrorUnionExpr] = STATE(2091),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_ParamType] = STATE(2080),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(1668),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(1705),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_anytype] = ACTIONS(1605),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [763] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(965),
    [sym_ErrorUnionExpr] = STATE(965),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [764] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1262),
    [sym_ErrorUnionExpr] = STATE(1262),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1655),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [765] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1228),
    [sym_ErrorUnionExpr] = STATE(1228),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1633),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [766] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1471),
    [sym_ErrorUnionExpr] = STATE(1471),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1647),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [767] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1500),
    [sym_ErrorUnionExpr] = STATE(1500),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [768] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1110),
    [sym_ErrorUnionExpr] = STATE(1110),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1577),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [769] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1246),
    [sym_ErrorUnionExpr] = STATE(1246),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [770] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(964),
    [sym_ErrorUnionExpr] = STATE(964),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1637),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [771] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1313),
    [sym_ErrorUnionExpr] = STATE(1313),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(909),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(754),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [772] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(997),
    [sym_ErrorUnionExpr] = STATE(997),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [773] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1490),
    [sym_ErrorUnionExpr] = STATE(1490),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1659),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [774] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1314),
    [sym_ErrorUnionExpr] = STATE(1314),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(846),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(754),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [775] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(580),
    [sym_ErrorUnionExpr] = STATE(580),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [776] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1260),
    [sym_ErrorUnionExpr] = STATE(1260),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1687),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [777] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(537),
    [sym_ErrorUnionExpr] = STATE(537),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(1709),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [778] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1138),
    [sym_ErrorUnionExpr] = STATE(1138),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1623),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [779] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1156),
    [sym_ErrorUnionExpr] = STATE(1156),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1685),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [780] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(993),
    [sym_ErrorUnionExpr] = STATE(993),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [781] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(618),
    [sym_ErrorUnionExpr] = STATE(618),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(1713),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [782] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1462),
    [sym_ErrorUnionExpr] = STATE(1462),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1715),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [783] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1249),
    [sym_ErrorUnionExpr] = STATE(1249),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1667),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [784] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(602),
    [sym_ErrorUnionExpr] = STATE(602),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(1671),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [785] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(514),
    [sym_ErrorUnionExpr] = STATE(514),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [786] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1454),
    [sym_ErrorUnionExpr] = STATE(1454),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1717),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [787] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1133),
    [sym_ErrorUnionExpr] = STATE(1133),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1661),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [788] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1244),
    [sym_ErrorUnionExpr] = STATE(1244),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1695),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [789] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1160),
    [sym_ErrorUnionExpr] = STATE(1160),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1663),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [790] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(604),
    [sym_ErrorUnionExpr] = STATE(604),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [791] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1487),
    [sym_ErrorUnionExpr] = STATE(1487),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [792] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(590),
    [sym_ErrorUnionExpr] = STATE(590),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(1657),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [793] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(529),
    [sym_ErrorUnionExpr] = STATE(529),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [794] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(499),
    [sym_ErrorUnionExpr] = STATE(499),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [795] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(544),
    [sym_ErrorUnionExpr] = STATE(544),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(1719),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [796] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1210),
    [sym_ErrorUnionExpr] = STATE(1210),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1721),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [797] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1254),
    [sym_ErrorUnionExpr] = STATE(1254),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_BANG] = ACTIONS(1593),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [798] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(983),
    [sym_ErrorUnionExpr] = STATE(983),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [799] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1173),
    [sym_ErrorUnionExpr] = STATE(1173),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1723),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [800] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(961),
    [sym_ErrorUnionExpr] = STATE(961),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1679),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [801] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1176),
    [sym_ErrorUnionExpr] = STATE(1176),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [802] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1475),
    [sym_ErrorUnionExpr] = STATE(1475),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1677),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [803] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(612),
    [sym_ErrorUnionExpr] = STATE(612),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(1725),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [804] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(967),
    [sym_ErrorUnionExpr] = STATE(967),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1651),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [805] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1183),
    [sym_ErrorUnionExpr] = STATE(1183),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [806] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1307),
    [sym_ErrorUnionExpr] = STATE(1307),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(873),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(754),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [807] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(539),
    [sym_ErrorUnionExpr] = STATE(539),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [808] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(614),
    [sym_ErrorUnionExpr] = STATE(614),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(1675),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [809] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1460),
    [sym_ErrorUnionExpr] = STATE(1460),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [810] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(980),
    [sym_ErrorUnionExpr] = STATE(980),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_BANG] = ACTIONS(1729),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [811] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(592),
    [sym_ErrorUnionExpr] = STATE(592),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [812] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(516),
    [sym_ErrorUnionExpr] = STATE(516),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [813] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(527),
    [sym_ErrorUnionExpr] = STATE(527),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(1673),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [814] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1472),
    [sym_ErrorUnionExpr] = STATE(1472),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [815] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(603),
    [sym_ErrorUnionExpr] = STATE(603),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [816] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1185),
    [sym_ErrorUnionExpr] = STATE(1185),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [817] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1245),
    [sym_ErrorUnionExpr] = STATE(1245),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [818] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1196),
    [sym_ErrorUnionExpr] = STATE(1196),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [819] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(978),
    [sym_ErrorUnionExpr] = STATE(978),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [820] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(515),
    [sym_ErrorUnionExpr] = STATE(515),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [821] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1181),
    [sym_ErrorUnionExpr] = STATE(1181),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [822] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1180),
    [sym_ErrorUnionExpr] = STATE(1180),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [823] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1453),
    [sym_ErrorUnionExpr] = STATE(1453),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [824] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(513),
    [sym_ErrorUnionExpr] = STATE(513),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [825] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(963),
    [sym_ErrorUnionExpr] = STATE(963),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [826] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1432),
    [sym_ErrorUnionExpr] = STATE(1432),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [827] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1174),
    [sym_ErrorUnionExpr] = STATE(1174),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [828] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(968),
    [sym_ErrorUnionExpr] = STATE(968),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [829] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(545),
    [sym_ErrorUnionExpr] = STATE(545),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [830] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1171),
    [sym_ErrorUnionExpr] = STATE(1171),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [831] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(981),
    [sym_ErrorUnionExpr] = STATE(981),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [832] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1205),
    [sym_ErrorUnionExpr] = STATE(1205),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [833] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1517),
    [sym_ErrorUnionExpr] = STATE(1517),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [834] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1207),
    [sym_ErrorUnionExpr] = STATE(1207),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [835] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(542),
    [sym_ErrorUnionExpr] = STATE(542),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [836] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(494),
    [sym_ErrorUnionExpr] = STATE(494),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [837] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1439),
    [sym_ErrorUnionExpr] = STATE(1439),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [838] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(959),
    [sym_ErrorUnionExpr] = STATE(959),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [839] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1158),
    [sym_ErrorUnionExpr] = STATE(1158),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [840] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1308),
    [sym_ErrorUnionExpr] = STATE(1308),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [841] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1242),
    [sym_ErrorUnionExpr] = STATE(1242),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [842] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1255),
    [sym_ErrorUnionExpr] = STATE(1255),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [843] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1438),
    [sym_ErrorUnionExpr] = STATE(1438),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [844] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(573),
    [sym_ErrorUnionExpr] = STATE(573),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [845] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(541),
    [sym_ErrorUnionExpr] = STATE(541),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [846] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1316),
    [sym_ErrorUnionExpr] = STATE(1316),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [847] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1272),
    [sym_ErrorUnionExpr] = STATE(1272),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [848] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(2121),
    [sym_ErrorUnionExpr] = STATE(2121),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [849] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(579),
    [sym_ErrorUnionExpr] = STATE(579),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [850] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1154),
    [sym_ErrorUnionExpr] = STATE(1154),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [851] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(946),
    [sym_ErrorUnionExpr] = STATE(946),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [852] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1504),
    [sym_ErrorUnionExpr] = STATE(1504),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [853] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(1730),
    [sym_ErrorUnionExpr] = STATE(1730),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [854] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1521),
    [sym_ErrorUnionExpr] = STATE(1521),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [855] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1317),
    [sym_ErrorUnionExpr] = STATE(1317),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(840),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [856] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1279),
    [sym_ErrorUnionExpr] = STATE(1279),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1055),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(1731),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [857] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(431),
    [sym_ErrorUnionExpr] = STATE(431),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [858] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1149),
    [sym_ErrorUnionExpr] = STATE(1149),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [859] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1080),
    [sym_ErrorUnionExpr] = STATE(1080),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [860] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(994),
    [sym_ErrorUnionExpr] = STATE(994),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [861] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1455),
    [sym_ErrorUnionExpr] = STATE(1455),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [862] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(589),
    [sym_ErrorUnionExpr] = STATE(589),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [863] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(591),
    [sym_ErrorUnionExpr] = STATE(591),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [864] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1491),
    [sym_ErrorUnionExpr] = STATE(1491),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [865] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(538),
    [sym_ErrorUnionExpr] = STATE(538),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [866] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1306),
    [sym_ErrorUnionExpr] = STATE(1306),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(879),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [867] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(599),
    [sym_ErrorUnionExpr] = STATE(599),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [868] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(990),
    [sym_ErrorUnionExpr] = STATE(990),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [869] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1261),
    [sym_ErrorUnionExpr] = STATE(1261),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [870] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(536),
    [sym_ErrorUnionExpr] = STATE(536),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [871] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(601),
    [sym_ErrorUnionExpr] = STATE(601),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [872] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1136),
    [sym_ErrorUnionExpr] = STATE(1136),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [873] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1311),
    [sym_ErrorUnionExpr] = STATE(1311),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [874] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(430),
    [sym_ErrorUnionExpr] = STATE(430),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [875] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1488),
    [sym_ErrorUnionExpr] = STATE(1488),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [876] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(991),
    [sym_ErrorUnionExpr] = STATE(991),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [877] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1131),
    [sym_ErrorUnionExpr] = STATE(1131),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [878] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1257),
    [sym_ErrorUnionExpr] = STATE(1257),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [879] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1310),
    [sym_ErrorUnionExpr] = STATE(1310),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [880] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(945),
    [sym_ErrorUnionExpr] = STATE(945),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [881] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1444),
    [sym_ErrorUnionExpr] = STATE(1444),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [882] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1476),
    [sym_ErrorUnionExpr] = STATE(1476),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [883] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1082),
    [sym_ErrorUnionExpr] = STATE(1082),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [884] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1087),
    [sym_ErrorUnionExpr] = STATE(1087),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [885] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(611),
    [sym_ErrorUnionExpr] = STATE(611),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [886] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(528),
    [sym_ErrorUnionExpr] = STATE(528),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [887] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(613),
    [sym_ErrorUnionExpr] = STATE(613),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [888] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1253),
    [sym_ErrorUnionExpr] = STATE(1253),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [889] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1457),
    [sym_ErrorUnionExpr] = STATE(1457),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [890] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(526),
    [sym_ErrorUnionExpr] = STATE(526),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [891] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1108),
    [sym_ErrorUnionExpr] = STATE(1108),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [892] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1066),
    [sym_ErrorUnionExpr] = STATE(1066),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [893] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1085),
    [sym_ErrorUnionExpr] = STATE(1085),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [894] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1059),
    [sym_ErrorUnionExpr] = STATE(1059),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [895] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(1719),
    [sym_ErrorUnionExpr] = STATE(1719),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [896] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(616),
    [sym_ErrorUnionExpr] = STATE(616),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [897] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(524),
    [sym_ErrorUnionExpr] = STATE(524),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [898] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(617),
    [sym_ErrorUnionExpr] = STATE(617),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [899] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1463),
    [sym_ErrorUnionExpr] = STATE(1463),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [900] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(429),
    [sym_ErrorUnionExpr] = STATE(429),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [901] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(473),
    [sym_ErrorUnionExpr] = STATE(473),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [902] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1305),
    [sym_ErrorUnionExpr] = STATE(1305),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [903] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(977),
    [sym_ErrorUnionExpr] = STATE(977),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [904] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1222),
    [sym_ErrorUnionExpr] = STATE(1222),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [905] = {
    [sym_FnProto] = STATE(1410),
    [sym__TypeExpr] = STATE(1461),
    [sym_ErrorUnionExpr] = STATE(1461),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(927),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(927),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [906] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(619),
    [sym_ErrorUnionExpr] = STATE(619),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [907] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1247),
    [sym_ErrorUnionExpr] = STATE(1247),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [908] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(966),
    [sym_ErrorUnionExpr] = STATE(966),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [909] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1302),
    [sym_ErrorUnionExpr] = STATE(1302),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [910] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1267),
    [sym_ErrorUnionExpr] = STATE(1267),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [911] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(421),
    [sym_ErrorUnionExpr] = STATE(421),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [912] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(413),
    [sym_ErrorUnionExpr] = STATE(413),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [913] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(425),
    [sym_ErrorUnionExpr] = STATE(425),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [914] = {
    [sym_FnProto] = STATE(389),
    [sym__TypeExpr] = STATE(560),
    [sym_ErrorUnionExpr] = STATE(560),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(926),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(926),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [915] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1315),
    [sym_ErrorUnionExpr] = STATE(1315),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(902),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [916] = {
    [sym_FnProto] = STATE(1033),
    [sym__TypeExpr] = STATE(1099),
    [sym_ErrorUnionExpr] = STATE(1099),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(923),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(923),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [917] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(1001),
    [sym_ErrorUnionExpr] = STATE(1001),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [918] = {
    [sym_FnProto] = STATE(1037),
    [sym__TypeExpr] = STATE(1259),
    [sym_ErrorUnionExpr] = STATE(1259),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(925),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(925),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [919] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(944),
    [sym_ErrorUnionExpr] = STATE(944),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [920] = {
    [sym_FnProto] = STATE(384),
    [sym__TypeExpr] = STATE(486),
    [sym_ErrorUnionExpr] = STATE(486),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(924),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(924),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [921] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(1000),
    [sym_ErrorUnionExpr] = STATE(1000),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [922] = {
    [sym_FnProto] = STATE(935),
    [sym__TypeExpr] = STATE(953),
    [sym_ErrorUnionExpr] = STATE(953),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(928),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(928),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [923] = {
    [sym_FnProto] = STATE(1033),
    [sym_ErrorUnionExpr] = STATE(1175),
    [sym_SuffixExpr] = STATE(1152),
    [sym__PrimaryTypeExpr] = STATE(1033),
    [sym_ContainerDecl] = STATE(1033),
    [sym_ErrorSetDecl] = STATE(1033),
    [sym_GroupedExpr] = STATE(1033),
    [sym_IfTypeExpr] = STATE(1033),
    [sym_LabeledTypeExpr] = STATE(1033),
    [sym_LoopTypeExpr] = STATE(1162),
    [sym_ForTypeExpr] = STATE(1170),
    [sym_WhileTypeExpr] = STATE(1170),
    [sym_SwitchExpr] = STATE(1033),
    [sym_BlockLabel] = STATE(1708),
    [sym_IfPrefix] = STATE(892),
    [sym_WhilePrefix] = STATE(893),
    [sym_ForPrefix] = STATE(894),
    [sym_PrefixTypeOp] = STATE(1397),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1182),
    [sym_ContainerDeclType] = STATE(2151),
    [sym_CHAR_LITERAL] = STATE(1033),
    [sym_FLOAT] = STATE(1033),
    [sym_INTEGER] = STATE(1033),
    [sym_STRINGLITERALSINGLE] = STATE(1033),
    [sym_LINESTRING] = STATE(1033),
    [sym__STRINGLITERAL] = STATE(1033),
    [sym_IDENTIFIER] = STATE(1023),
    [sym_BUILTINIDENTIFIER] = STATE(2051),
    [aux_sym__TypeExpr_repeat1] = STATE(1397),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1033),
    [anon_sym_comptime] = ACTIONS(1515),
    [anon_sym_extern] = ACTIONS(1517),
    [anon_sym_inline] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1521),
    [anon_sym_async] = ACTIONS(1525),
    [anon_sym_DOT] = ACTIONS(1527),
    [anon_sym_error] = ACTIONS(1529),
    [anon_sym_false] = ACTIONS(1531),
    [anon_sym_null] = ACTIONS(1531),
    [anon_sym_anyframe] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_undefined] = ACTIONS(1531),
    [anon_sym_unreachable] = ACTIONS(1531),
    [sym_BuildinTypeExpr] = ACTIONS(1531),
    [anon_sym_packed] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1535),
    [anon_sym_switch] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [aux_sym_FLOAT_token1] = ACTIONS(1541),
    [aux_sym_FLOAT_token2] = ACTIONS(1541),
    [aux_sym_FLOAT_token3] = ACTIONS(1541),
    [aux_sym_FLOAT_token4] = ACTIONS(1541),
    [aux_sym_INTEGER_token1] = ACTIONS(1543),
    [aux_sym_INTEGER_token2] = ACTIONS(1543),
    [aux_sym_INTEGER_token3] = ACTIONS(1545),
    [aux_sym_INTEGER_token4] = ACTIONS(1545),
    [anon_sym_DQUOTE] = ACTIONS(1547),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1549),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(1551),
    [anon_sym_AT] = ACTIONS(1553),
  },
  [924] = {
    [sym_FnProto] = STATE(384),
    [sym_ErrorUnionExpr] = STATE(478),
    [sym_SuffixExpr] = STATE(467),
    [sym__PrimaryTypeExpr] = STATE(384),
    [sym_ContainerDecl] = STATE(384),
    [sym_ErrorSetDecl] = STATE(384),
    [sym_GroupedExpr] = STATE(384),
    [sym_IfTypeExpr] = STATE(384),
    [sym_LabeledTypeExpr] = STATE(384),
    [sym_LoopTypeExpr] = STATE(468),
    [sym_ForTypeExpr] = STATE(469),
    [sym_WhileTypeExpr] = STATE(469),
    [sym_SwitchExpr] = STATE(384),
    [sym_BlockLabel] = STATE(1709),
    [sym_IfPrefix] = STATE(900),
    [sym_WhilePrefix] = STATE(874),
    [sym_ForPrefix] = STATE(857),
    [sym_PrefixTypeOp] = STATE(1397),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(470),
    [sym_ContainerDeclType] = STATE(2169),
    [sym_CHAR_LITERAL] = STATE(384),
    [sym_FLOAT] = STATE(384),
    [sym_INTEGER] = STATE(384),
    [sym_STRINGLITERALSINGLE] = STATE(384),
    [sym_LINESTRING] = STATE(384),
    [sym__STRINGLITERAL] = STATE(384),
    [sym_IDENTIFIER] = STATE(377),
    [sym_BUILTINIDENTIFIER] = STATE(2060),
    [aux_sym__TypeExpr_repeat1] = STATE(1397),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(384),
    [anon_sym_comptime] = ACTIONS(1555),
    [anon_sym_extern] = ACTIONS(173),
    [anon_sym_inline] = ACTIONS(1557),
    [anon_sym_fn] = ACTIONS(177),
    [anon_sym_async] = ACTIONS(191),
    [anon_sym_DOT] = ACTIONS(193),
    [anon_sym_error] = ACTIONS(195),
    [anon_sym_false] = ACTIONS(197),
    [anon_sym_null] = ACTIONS(197),
    [anon_sym_anyframe] = ACTIONS(199),
    [anon_sym_true] = ACTIONS(197),
    [anon_sym_undefined] = ACTIONS(197),
    [anon_sym_unreachable] = ACTIONS(197),
    [sym_BuildinTypeExpr] = ACTIONS(197),
    [anon_sym_packed] = ACTIONS(173),
    [anon_sym_LPAREN] = ACTIONS(201),
    [anon_sym_switch] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(207),
    [aux_sym_FLOAT_token1] = ACTIONS(209),
    [aux_sym_FLOAT_token2] = ACTIONS(209),
    [aux_sym_FLOAT_token3] = ACTIONS(209),
    [aux_sym_FLOAT_token4] = ACTIONS(209),
    [aux_sym_INTEGER_token1] = ACTIONS(211),
    [aux_sym_INTEGER_token2] = ACTIONS(211),
    [aux_sym_INTEGER_token3] = ACTIONS(213),
    [aux_sym_INTEGER_token4] = ACTIONS(213),
    [anon_sym_DQUOTE] = ACTIONS(215),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(217),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(219),
    [anon_sym_AT] = ACTIONS(221),
  },
  [925] = {
    [sym_FnProto] = STATE(1037),
    [sym_ErrorUnionExpr] = STATE(1250),
    [sym_SuffixExpr] = STATE(1216),
    [sym__PrimaryTypeExpr] = STATE(1037),
    [sym_ContainerDecl] = STATE(1037),
    [sym_ErrorSetDecl] = STATE(1037),
    [sym_GroupedExpr] = STATE(1037),
    [sym_IfTypeExpr] = STATE(1037),
    [sym_LabeledTypeExpr] = STATE(1037),
    [sym_LoopTypeExpr] = STATE(1202),
    [sym_ForTypeExpr] = STATE(1238),
    [sym_WhileTypeExpr] = STATE(1238),
    [sym_SwitchExpr] = STATE(1037),
    [sym_BlockLabel] = STATE(1711),
    [sym_IfPrefix] = STATE(884),
    [sym_WhilePrefix] = STATE(883),
    [sym_ForPrefix] = STATE(859),
    [sym_PrefixTypeOp] = STATE(1397),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1251),
    [sym_ContainerDeclType] = STATE(2115),
    [sym_CHAR_LITERAL] = STATE(1037),
    [sym_FLOAT] = STATE(1037),
    [sym_INTEGER] = STATE(1037),
    [sym_STRINGLITERALSINGLE] = STATE(1037),
    [sym_LINESTRING] = STATE(1037),
    [sym__STRINGLITERAL] = STATE(1037),
    [sym_IDENTIFIER] = STATE(1036),
    [sym_BUILTINIDENTIFIER] = STATE(2079),
    [aux_sym__TypeExpr_repeat1] = STATE(1397),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1037),
    [anon_sym_comptime] = ACTIONS(1489),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym_inline] = ACTIONS(1491),
    [anon_sym_fn] = ACTIONS(25),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_DOT] = ACTIONS(31),
    [anon_sym_error] = ACTIONS(33),
    [anon_sym_false] = ACTIONS(35),
    [anon_sym_null] = ACTIONS(35),
    [anon_sym_anyframe] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_undefined] = ACTIONS(35),
    [anon_sym_unreachable] = ACTIONS(35),
    [sym_BuildinTypeExpr] = ACTIONS(35),
    [anon_sym_packed] = ACTIONS(41),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_switch] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(71),
    [aux_sym_FLOAT_token1] = ACTIONS(73),
    [aux_sym_FLOAT_token2] = ACTIONS(73),
    [aux_sym_FLOAT_token3] = ACTIONS(73),
    [aux_sym_FLOAT_token4] = ACTIONS(73),
    [aux_sym_INTEGER_token1] = ACTIONS(75),
    [aux_sym_INTEGER_token2] = ACTIONS(75),
    [aux_sym_INTEGER_token3] = ACTIONS(77),
    [aux_sym_INTEGER_token4] = ACTIONS(77),
    [anon_sym_DQUOTE] = ACTIONS(79),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(81),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(85),
  },
  [926] = {
    [sym_FnProto] = STATE(389),
    [sym_ErrorUnionExpr] = STATE(565),
    [sym_SuffixExpr] = STATE(553),
    [sym__PrimaryTypeExpr] = STATE(389),
    [sym_ContainerDecl] = STATE(389),
    [sym_ErrorSetDecl] = STATE(389),
    [sym_GroupedExpr] = STATE(389),
    [sym_IfTypeExpr] = STATE(389),
    [sym_LabeledTypeExpr] = STATE(389),
    [sym_LoopTypeExpr] = STATE(554),
    [sym_ForTypeExpr] = STATE(555),
    [sym_WhileTypeExpr] = STATE(555),
    [sym_SwitchExpr] = STATE(389),
    [sym_BlockLabel] = STATE(1707),
    [sym_IfPrefix] = STATE(913),
    [sym_WhilePrefix] = STATE(912),
    [sym_ForPrefix] = STATE(911),
    [sym_PrefixTypeOp] = STATE(1397),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(556),
    [sym_ContainerDeclType] = STATE(2161),
    [sym_CHAR_LITERAL] = STATE(389),
    [sym_FLOAT] = STATE(389),
    [sym_INTEGER] = STATE(389),
    [sym_STRINGLITERALSINGLE] = STATE(389),
    [sym_LINESTRING] = STATE(389),
    [sym__STRINGLITERAL] = STATE(389),
    [sym_IDENTIFIER] = STATE(380),
    [sym_BUILTINIDENTIFIER] = STATE(2085),
    [aux_sym__TypeExpr_repeat1] = STATE(1397),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(389),
    [anon_sym_comptime] = ACTIONS(1503),
    [anon_sym_extern] = ACTIONS(225),
    [anon_sym_inline] = ACTIONS(1505),
    [anon_sym_fn] = ACTIONS(229),
    [anon_sym_async] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(245),
    [anon_sym_error] = ACTIONS(247),
    [anon_sym_false] = ACTIONS(249),
    [anon_sym_null] = ACTIONS(249),
    [anon_sym_anyframe] = ACTIONS(251),
    [anon_sym_true] = ACTIONS(249),
    [anon_sym_undefined] = ACTIONS(249),
    [anon_sym_unreachable] = ACTIONS(249),
    [sym_BuildinTypeExpr] = ACTIONS(249),
    [anon_sym_packed] = ACTIONS(225),
    [anon_sym_LPAREN] = ACTIONS(253),
    [anon_sym_switch] = ACTIONS(255),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(259),
    [aux_sym_FLOAT_token1] = ACTIONS(261),
    [aux_sym_FLOAT_token2] = ACTIONS(261),
    [aux_sym_FLOAT_token3] = ACTIONS(261),
    [aux_sym_FLOAT_token4] = ACTIONS(261),
    [aux_sym_INTEGER_token1] = ACTIONS(263),
    [aux_sym_INTEGER_token2] = ACTIONS(263),
    [aux_sym_INTEGER_token3] = ACTIONS(265),
    [aux_sym_INTEGER_token4] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(267),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(269),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(271),
    [anon_sym_AT] = ACTIONS(273),
  },
  [927] = {
    [sym_FnProto] = STATE(1410),
    [sym_ErrorUnionExpr] = STATE(1533),
    [sym_SuffixExpr] = STATE(1505),
    [sym__PrimaryTypeExpr] = STATE(1410),
    [sym_ContainerDecl] = STATE(1410),
    [sym_ErrorSetDecl] = STATE(1410),
    [sym_GroupedExpr] = STATE(1410),
    [sym_IfTypeExpr] = STATE(1410),
    [sym_LabeledTypeExpr] = STATE(1410),
    [sym_LoopTypeExpr] = STATE(1507),
    [sym_ForTypeExpr] = STATE(1508),
    [sym_WhileTypeExpr] = STATE(1508),
    [sym_SwitchExpr] = STATE(1410),
    [sym_BlockLabel] = STATE(1712),
    [sym_IfPrefix] = STATE(843),
    [sym_WhilePrefix] = STATE(837),
    [sym_ForPrefix] = STATE(826),
    [sym_PrefixTypeOp] = STATE(1397),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1509),
    [sym_ContainerDeclType] = STATE(2175),
    [sym_CHAR_LITERAL] = STATE(1410),
    [sym_FLOAT] = STATE(1410),
    [sym_INTEGER] = STATE(1410),
    [sym_STRINGLITERALSINGLE] = STATE(1410),
    [sym_LINESTRING] = STATE(1418),
    [sym__STRINGLITERAL] = STATE(1410),
    [sym_IDENTIFIER] = STATE(1408),
    [sym_BUILTINIDENTIFIER] = STATE(2033),
    [aux_sym__TypeExpr_repeat1] = STATE(1397),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(1418),
    [anon_sym_comptime] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(277),
    [anon_sym_inline] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(281),
    [anon_sym_async] = ACTIONS(295),
    [anon_sym_DOT] = ACTIONS(590),
    [anon_sym_error] = ACTIONS(299),
    [anon_sym_false] = ACTIONS(301),
    [anon_sym_null] = ACTIONS(301),
    [anon_sym_anyframe] = ACTIONS(303),
    [anon_sym_true] = ACTIONS(301),
    [anon_sym_undefined] = ACTIONS(301),
    [anon_sym_unreachable] = ACTIONS(301),
    [sym_BuildinTypeExpr] = ACTIONS(301),
    [anon_sym_packed] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_switch] = ACTIONS(307),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(311),
    [aux_sym_FLOAT_token1] = ACTIONS(313),
    [aux_sym_FLOAT_token2] = ACTIONS(313),
    [aux_sym_FLOAT_token3] = ACTIONS(313),
    [aux_sym_FLOAT_token4] = ACTIONS(313),
    [aux_sym_INTEGER_token1] = ACTIONS(315),
    [aux_sym_INTEGER_token2] = ACTIONS(315),
    [aux_sym_INTEGER_token3] = ACTIONS(317),
    [aux_sym_INTEGER_token4] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(319),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(321),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(323),
    [anon_sym_AT] = ACTIONS(325),
  },
  [928] = {
    [sym_FnProto] = STATE(935),
    [sym_ErrorUnionExpr] = STATE(996),
    [sym_SuffixExpr] = STATE(1018),
    [sym__PrimaryTypeExpr] = STATE(935),
    [sym_ContainerDecl] = STATE(935),
    [sym_ErrorSetDecl] = STATE(935),
    [sym_GroupedExpr] = STATE(935),
    [sym_IfTypeExpr] = STATE(935),
    [sym_LabeledTypeExpr] = STATE(935),
    [sym_LoopTypeExpr] = STATE(1016),
    [sym_ForTypeExpr] = STATE(1015),
    [sym_WhileTypeExpr] = STATE(1015),
    [sym_SwitchExpr] = STATE(935),
    [sym_BlockLabel] = STATE(1710),
    [sym_IfPrefix] = STATE(851),
    [sym_WhilePrefix] = STATE(880),
    [sym_ForPrefix] = STATE(919),
    [sym_PrefixTypeOp] = STATE(1397),
    [sym_SliceTypeStart] = STATE(1386),
    [sym_PtrTypeStart] = STATE(1389),
    [sym_ArrayTypeStart] = STATE(1499),
    [sym__ContainerDeclAuto] = STATE(1014),
    [sym_ContainerDeclType] = STATE(2119),
    [sym_CHAR_LITERAL] = STATE(935),
    [sym_FLOAT] = STATE(935),
    [sym_INTEGER] = STATE(935),
    [sym_STRINGLITERALSINGLE] = STATE(935),
    [sym_LINESTRING] = STATE(941),
    [sym__STRINGLITERAL] = STATE(935),
    [sym_IDENTIFIER] = STATE(933),
    [sym_BUILTINIDENTIFIER] = STATE(2064),
    [aux_sym__TypeExpr_repeat1] = STATE(1397),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(941),
    [anon_sym_comptime] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(91),
    [anon_sym_inline] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(95),
    [anon_sym_async] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(355),
    [anon_sym_error] = ACTIONS(117),
    [anon_sym_false] = ACTIONS(119),
    [anon_sym_null] = ACTIONS(119),
    [anon_sym_anyframe] = ACTIONS(121),
    [anon_sym_true] = ACTIONS(119),
    [anon_sym_undefined] = ACTIONS(119),
    [anon_sym_unreachable] = ACTIONS(119),
    [sym_BuildinTypeExpr] = ACTIONS(119),
    [anon_sym_packed] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(125),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(49),
    [anon_sym_while] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_STAR_STAR] = ACTIONS(57),
    [anon_sym_QMARK] = ACTIONS(59),
    [anon_sym_struct] = ACTIONS(61),
    [anon_sym_opaque] = ACTIONS(63),
    [anon_sym_enum] = ACTIONS(61),
    [anon_sym_union] = ACTIONS(65),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_SQUOTE] = ACTIONS(139),
    [aux_sym_FLOAT_token1] = ACTIONS(141),
    [aux_sym_FLOAT_token2] = ACTIONS(141),
    [aux_sym_FLOAT_token3] = ACTIONS(141),
    [aux_sym_FLOAT_token4] = ACTIONS(141),
    [aux_sym_INTEGER_token1] = ACTIONS(143),
    [aux_sym_INTEGER_token2] = ACTIONS(143),
    [aux_sym_INTEGER_token3] = ACTIONS(145),
    [aux_sym_INTEGER_token4] = ACTIONS(145),
    [anon_sym_DQUOTE] = ACTIONS(147),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(151),
    [anon_sym_AT] = ACTIONS(153),
  },
  [929] = {
    [sym_FieldOrFnCall] = STATE(929),
    [sym_SuffixOp] = STATE(929),
    [sym_FnCallArguments] = STATE(929),
    [aux_sym_SuffixExpr_repeat1] = STATE(929),
    [anon_sym_COMMA] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_COLON] = ACTIONS(957),
    [anon_sym_EQ] = ACTIONS(959),
    [anon_sym_else] = ACTIONS(957),
    [anon_sym_or] = ACTIONS(959),
    [anon_sym_and] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(957),
    [anon_sym_RBRACE] = ACTIONS(957),
    [anon_sym_DOT] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1736),
    [anon_sym_RPAREN] = ACTIONS(957),
    [anon_sym_LBRACK] = ACTIONS(1739),
    [anon_sym_RBRACK] = ACTIONS(957),
    [anon_sym_linksection] = ACTIONS(957),
    [anon_sym_addrspace] = ACTIONS(957),
    [anon_sym_PIPE] = ACTIONS(959),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_EQ_GT] = ACTIONS(957),
    [anon_sym_DOT_DOT] = ACTIONS(957),
    [anon_sym_STAR_EQ] = ACTIONS(957),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(957),
    [anon_sym_SLASH_EQ] = ACTIONS(957),
    [anon_sym_PERCENT_EQ] = ACTIONS(957),
    [anon_sym_PLUS_EQ] = ACTIONS(957),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(957),
    [anon_sym_DASH_EQ] = ACTIONS(957),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(957),
    [anon_sym_LT_LT_EQ] = ACTIONS(957),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(957),
    [anon_sym_GT_GT_EQ] = ACTIONS(957),
    [anon_sym_AMP_EQ] = ACTIONS(957),
    [anon_sym_CARET_EQ] = ACTIONS(957),
    [anon_sym_PIPE_EQ] = ACTIONS(957),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(957),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(957),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(957),
    [anon_sym_EQ_EQ] = ACTIONS(957),
    [anon_sym_BANG_EQ] = ACTIONS(957),
    [anon_sym_LT] = ACTIONS(959),
    [anon_sym_GT] = ACTIONS(959),
    [anon_sym_LT_EQ] = ACTIONS(957),
    [anon_sym_GT_EQ] = ACTIONS(957),
    [anon_sym_AMP] = ACTIONS(959),
    [anon_sym_CARET] = ACTIONS(959),
    [anon_sym_orelse] = ACTIONS(957),
    [anon_sym_catch] = ACTIONS(957),
    [anon_sym_LT_LT] = ACTIONS(959),
    [anon_sym_GT_GT] = ACTIONS(959),
    [anon_sym_LT_LT_PIPE] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(959),
    [anon_sym_DASH] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(957),
    [anon_sym_PLUS_PERCENT] = ACTIONS(959),
    [anon_sym_DASH_PERCENT] = ACTIONS(959),
    [anon_sym_PLUS_PIPE] = ACTIONS(959),
    [anon_sym_DASH_PIPE] = ACTIONS(959),
    [anon_sym_PIPE_PIPE] = ACTIONS(957),
    [anon_sym_SLASH] = ACTIONS(959),
    [anon_sym_PERCENT] = ACTIONS(959),
    [anon_sym_STAR_STAR] = ACTIONS(957),
    [anon_sym_STAR_PERCENT] = ACTIONS(959),
    [anon_sym_STAR_PIPE] = ACTIONS(959),
    [anon_sym_align] = ACTIONS(957),
    [anon_sym_DOT_STAR] = ACTIONS(1742),
    [anon_sym_DOT_QMARK] = ACTIONS(1742),
    [sym_line_comment] = ACTIONS(137),
  },
  [930] = {
    [anon_sym_COMMA] = ACTIONS(552),
    [anon_sym_SEMI] = ACTIONS(552),
    [anon_sym_threadlocal] = ACTIONS(552),
    [anon_sym_fn] = ACTIONS(552),
    [anon_sym_BANG] = ACTIONS(554),
    [anon_sym_const] = ACTIONS(552),
    [anon_sym_var] = ACTIONS(552),
    [anon_sym_COLON] = ACTIONS(552),
    [anon_sym_EQ] = ACTIONS(554),
    [anon_sym_else] = ACTIONS(552),
    [anon_sym_or] = ACTIONS(554),
    [anon_sym_and] = ACTIONS(552),
    [anon_sym_LBRACE] = ACTIONS(552),
    [anon_sym_RBRACE] = ACTIONS(552),
    [anon_sym_DOT] = ACTIONS(554),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_RPAREN] = ACTIONS(552),
    [anon_sym_LBRACK] = ACTIONS(552),
    [anon_sym_RBRACK] = ACTIONS(552),
    [anon_sym_linksection] = ACTIONS(552),
    [anon_sym_addrspace] = ACTIONS(552),
    [anon_sym_PIPE] = ACTIONS(554),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_EQ_GT] = ACTIONS(552),
    [anon_sym_DOT_DOT] = ACTIONS(552),
    [anon_sym_STAR_EQ] = ACTIONS(552),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(552),
    [anon_sym_SLASH_EQ] = ACTIONS(552),
    [anon_sym_PERCENT_EQ] = ACTIONS(552),
    [anon_sym_PLUS_EQ] = ACTIONS(552),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(552),
    [anon_sym_DASH_EQ] = ACTIONS(552),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(552),
    [anon_sym_LT_LT_EQ] = ACTIONS(552),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(552),
    [anon_sym_GT_GT_EQ] = ACTIONS(552),
    [anon_sym_AMP_EQ] = ACTIONS(552),
    [anon_sym_CARET_EQ] = ACTIONS(552),
    [anon_sym_PIPE_EQ] = ACTIONS(552),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(552),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(552),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(552),
    [anon_sym_EQ_EQ] = ACTIONS(552),
    [anon_sym_BANG_EQ] = ACTIONS(552),
    [anon_sym_LT] = ACTIONS(554),
    [anon_sym_GT] = ACTIONS(554),
    [anon_sym_LT_EQ] = ACTIONS(552),
    [anon_sym_GT_EQ] = ACTIONS(552),
    [anon_sym_AMP] = ACTIONS(554),
    [anon_sym_CARET] = ACTIONS(554),
    [anon_sym_orelse] = ACTIONS(552),
    [anon_sym_catch] = ACTIONS(552),
    [anon_sym_LT_LT] = ACTIONS(554),
    [anon_sym_GT_GT] = ACTIONS(554),
    [anon_sym_LT_LT_PIPE] = ACTIONS(554),
    [anon_sym_PLUS] = ACTIONS(554),
    [anon_sym_DASH] = ACTIONS(554),
    [anon_sym_PLUS_PLUS] = ACTIONS(552),
    [anon_sym_PLUS_PERCENT] = ACTIONS(554),
    [anon_sym_DASH_PERCENT] = ACTIONS(554),
    [anon_sym_PLUS_PIPE] = ACTIONS(554),
    [anon_sym_DASH_PIPE] = ACTIONS(554),
    [anon_sym_PIPE_PIPE] = ACTIONS(552),
    [anon_sym_SLASH] = ACTIONS(554),
    [anon_sym_PERCENT] = ACTIONS(554),
    [anon_sym_STAR_STAR] = ACTIONS(552),
    [anon_sym_STAR_PERCENT] = ACTIONS(554),
    [anon_sym_STAR_PIPE] = ACTIONS(554),
    [anon_sym_align] = ACTIONS(552),
    [anon_sym_DOT_STAR] = ACTIONS(552),
    [anon_sym_DOT_QMARK] = ACTIONS(552),
    [sym_line_comment] = ACTIONS(137),
  },
  [931] = {
    [sym_FieldOrFnCall] = STATE(929),
    [sym_SuffixOp] = STATE(929),
    [sym_FnCallArguments] = STATE(929),
    [aux_sym_SuffixExpr_repeat1] = STATE(929),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_BANG] = ACTIONS(975),
    [anon_sym_COLON] = ACTIONS(973),
    [anon_sym_EQ] = ACTIONS(975),
    [anon_sym_else] = ACTIONS(973),
    [anon_sym_or] = ACTIONS(975),
    [anon_sym_and] = ACTIONS(973),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_DOT] = ACTIONS(1745),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_RPAREN] = ACTIONS(973),
    [anon_sym_LBRACK] = ACTIONS(1749),
    [anon_sym_RBRACK] = ACTIONS(973),
    [anon_sym_linksection] = ACTIONS(973),
    [anon_sym_addrspace] = ACTIONS(973),
    [anon_sym_PIPE] = ACTIONS(975),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_EQ_GT] = ACTIONS(973),
    [anon_sym_DOT_DOT] = ACTIONS(973),
    [anon_sym_STAR_EQ] = ACTIONS(973),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(973),
    [anon_sym_SLASH_EQ] = ACTIONS(973),
    [anon_sym_PERCENT_EQ] = ACTIONS(973),
    [anon_sym_PLUS_EQ] = ACTIONS(973),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(973),
    [anon_sym_DASH_EQ] = ACTIONS(973),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(973),
    [anon_sym_LT_LT_EQ] = ACTIONS(973),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(973),
    [anon_sym_GT_GT_EQ] = ACTIONS(973),
    [anon_sym_AMP_EQ] = ACTIONS(973),
    [anon_sym_CARET_EQ] = ACTIONS(973),
    [anon_sym_PIPE_EQ] = ACTIONS(973),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(973),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(973),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(973),
    [anon_sym_EQ_EQ] = ACTIONS(973),
    [anon_sym_BANG_EQ] = ACTIONS(973),
    [anon_sym_LT] = ACTIONS(975),
    [anon_sym_GT] = ACTIONS(975),
    [anon_sym_LT_EQ] = ACTIONS(973),
    [anon_sym_GT_EQ] = ACTIONS(973),
    [anon_sym_AMP] = ACTIONS(975),
    [anon_sym_CARET] = ACTIONS(975),
    [anon_sym_orelse] = ACTIONS(973),
    [anon_sym_catch] = ACTIONS(973),
    [anon_sym_LT_LT] = ACTIONS(975),
    [anon_sym_GT_GT] = ACTIONS(975),
    [anon_sym_LT_LT_PIPE] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(975),
    [anon_sym_DASH] = ACTIONS(975),
    [anon_sym_PLUS_PLUS] = ACTIONS(973),
    [anon_sym_PLUS_PERCENT] = ACTIONS(975),
    [anon_sym_DASH_PERCENT] = ACTIONS(975),
    [anon_sym_PLUS_PIPE] = ACTIONS(975),
    [anon_sym_DASH_PIPE] = ACTIONS(975),
    [anon_sym_PIPE_PIPE] = ACTIONS(973),
    [anon_sym_SLASH] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(975),
    [anon_sym_STAR_STAR] = ACTIONS(973),
    [anon_sym_STAR_PERCENT] = ACTIONS(975),
    [anon_sym_STAR_PIPE] = ACTIONS(975),
    [anon_sym_align] = ACTIONS(973),
    [anon_sym_DOT_STAR] = ACTIONS(1751),
    [anon_sym_DOT_QMARK] = ACTIONS(1751),
    [sym_line_comment] = ACTIONS(137),
  },
  [932] = {
    [sym_FieldOrFnCall] = STATE(929),
    [sym_SuffixOp] = STATE(929),
    [sym_FnCallArguments] = STATE(929),
    [aux_sym_SuffixExpr_repeat1] = STATE(929),
    [anon_sym_COMMA] = ACTIONS(977),
    [anon_sym_SEMI] = ACTIONS(977),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_COLON] = ACTIONS(977),
    [anon_sym_EQ] = ACTIONS(979),
    [anon_sym_else] = ACTIONS(977),
    [anon_sym_or] = ACTIONS(979),
    [anon_sym_and] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(977),
    [anon_sym_RBRACE] = ACTIONS(977),
    [anon_sym_DOT] = ACTIONS(1745),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_RPAREN] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(1749),
    [anon_sym_RBRACK] = ACTIONS(977),
    [anon_sym_linksection] = ACTIONS(977),
    [anon_sym_addrspace] = ACTIONS(977),
    [anon_sym_PIPE] = ACTIONS(979),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_EQ_GT] = ACTIONS(977),
    [anon_sym_DOT_DOT] = ACTIONS(977),
    [anon_sym_STAR_EQ] = ACTIONS(977),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(977),
    [anon_sym_SLASH_EQ] = ACTIONS(977),
    [anon_sym_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_PLUS_EQ] = ACTIONS(977),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(977),
    [anon_sym_DASH_EQ] = ACTIONS(977),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(977),
    [anon_sym_LT_LT_EQ] = ACTIONS(977),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(977),
    [anon_sym_GT_GT_EQ] = ACTIONS(977),
    [anon_sym_AMP_EQ] = ACTIONS(977),
    [anon_sym_CARET_EQ] = ACTIONS(977),
    [anon_sym_PIPE_EQ] = ACTIONS(977),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(977),
    [anon_sym_EQ_EQ] = ACTIONS(977),
    [anon_sym_BANG_EQ] = ACTIONS(977),
    [anon_sym_LT] = ACTIONS(979),
    [anon_sym_GT] = ACTIONS(979),
    [anon_sym_LT_EQ] = ACTIONS(977),
    [anon_sym_GT_EQ] = ACTIONS(977),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_orelse] = ACTIONS(977),
    [anon_sym_catch] = ACTIONS(977),
    [anon_sym_LT_LT] = ACTIONS(979),
    [anon_sym_GT_GT] = ACTIONS(979),
    [anon_sym_LT_LT_PIPE] = ACTIONS(979),
    [anon_sym_PLUS] = ACTIONS(979),
    [anon_sym_DASH] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(977),
    [anon_sym_PLUS_PERCENT] = ACTIONS(979),
    [anon_sym_DASH_PERCENT] = ACTIONS(979),
    [anon_sym_PLUS_PIPE] = ACTIONS(979),
    [anon_sym_DASH_PIPE] = ACTIONS(979),
    [anon_sym_PIPE_PIPE] = ACTIONS(977),
    [anon_sym_SLASH] = ACTIONS(979),
    [anon_sym_PERCENT] = ACTIONS(979),
    [anon_sym_STAR_STAR] = ACTIONS(977),
    [anon_sym_STAR_PERCENT] = ACTIONS(979),
    [anon_sym_STAR_PIPE] = ACTIONS(979),
    [anon_sym_align] = ACTIONS(977),
    [anon_sym_DOT_STAR] = ACTIONS(1751),
    [anon_sym_DOT_QMARK] = ACTIONS(1751),
    [sym_line_comment] = ACTIONS(137),
  },
  [933] = {
    [sym_FieldOrFnCall] = STATE(934),
    [sym_SuffixOp] = STATE(934),
    [sym_FnCallArguments] = STATE(934),
    [aux_sym_SuffixExpr_repeat1] = STATE(934),
    [anon_sym_COMMA] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(941),
    [anon_sym_BANG] = ACTIONS(943),
    [anon_sym_COLON] = ACTIONS(931),
    [anon_sym_EQ] = ACTIONS(943),
    [anon_sym_else] = ACTIONS(941),
    [anon_sym_or] = ACTIONS(943),
    [anon_sym_and] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(941),
    [anon_sym_RBRACE] = ACTIONS(941),
    [anon_sym_DOT] = ACTIONS(1745),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_RPAREN] = ACTIONS(941),
    [anon_sym_LBRACK] = ACTIONS(1749),
    [anon_sym_RBRACK] = ACTIONS(941),
    [anon_sym_linksection] = ACTIONS(941),
    [anon_sym_addrspace] = ACTIONS(941),
    [anon_sym_PIPE] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(943),
    [anon_sym_EQ_GT] = ACTIONS(941),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_STAR_EQ] = ACTIONS(941),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(941),
    [anon_sym_SLASH_EQ] = ACTIONS(941),
    [anon_sym_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_PLUS_EQ] = ACTIONS(941),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(941),
    [anon_sym_DASH_EQ] = ACTIONS(941),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(941),
    [anon_sym_LT_LT_EQ] = ACTIONS(941),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(941),
    [anon_sym_GT_GT_EQ] = ACTIONS(941),
    [anon_sym_AMP_EQ] = ACTIONS(941),
    [anon_sym_CARET_EQ] = ACTIONS(941),
    [anon_sym_PIPE_EQ] = ACTIONS(941),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(943),
    [anon_sym_GT] = ACTIONS(943),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(943),
    [anon_sym_CARET] = ACTIONS(943),
    [anon_sym_orelse] = ACTIONS(941),
    [anon_sym_catch] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(943),
    [anon_sym_GT_GT] = ACTIONS(943),
    [anon_sym_LT_LT_PIPE] = ACTIONS(943),
    [anon_sym_PLUS] = ACTIONS(943),
    [anon_sym_DASH] = ACTIONS(943),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_PLUS_PERCENT] = ACTIONS(943),
    [anon_sym_DASH_PERCENT] = ACTIONS(943),
    [anon_sym_PLUS_PIPE] = ACTIONS(943),
    [anon_sym_DASH_PIPE] = ACTIONS(943),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(943),
    [anon_sym_PERCENT] = ACTIONS(943),
    [anon_sym_STAR_STAR] = ACTIONS(941),
    [anon_sym_STAR_PERCENT] = ACTIONS(943),
    [anon_sym_STAR_PIPE] = ACTIONS(943),
    [anon_sym_align] = ACTIONS(941),
    [anon_sym_DOT_STAR] = ACTIONS(1751),
    [anon_sym_DOT_QMARK] = ACTIONS(1751),
    [sym_line_comment] = ACTIONS(137),
  },
  [934] = {
    [sym_FieldOrFnCall] = STATE(929),
    [sym_SuffixOp] = STATE(929),
    [sym_FnCallArguments] = STATE(929),
    [aux_sym_SuffixExpr_repeat1] = STATE(929),
    [anon_sym_COMMA] = ACTIONS(953),
    [anon_sym_SEMI] = ACTIONS(953),
    [anon_sym_BANG] = ACTIONS(955),
    [anon_sym_COLON] = ACTIONS(953),
    [anon_sym_EQ] = ACTIONS(955),
    [anon_sym_else] = ACTIONS(953),
    [anon_sym_or] = ACTIONS(955),
    [anon_sym_and] = ACTIONS(953),
    [anon_sym_LBRACE] = ACTIONS(953),
    [anon_sym_RBRACE] = ACTIONS(953),
    [anon_sym_DOT] = ACTIONS(1745),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_RPAREN] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(1749),
    [anon_sym_RBRACK] = ACTIONS(953),
    [anon_sym_linksection] = ACTIONS(953),
    [anon_sym_addrspace] = ACTIONS(953),
    [anon_sym_PIPE] = ACTIONS(955),
    [anon_sym_STAR] = ACTIONS(955),
    [anon_sym_EQ_GT] = ACTIONS(953),
    [anon_sym_DOT_DOT] = ACTIONS(953),
    [anon_sym_STAR_EQ] = ACTIONS(953),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(953),
    [anon_sym_SLASH_EQ] = ACTIONS(953),
    [anon_sym_PERCENT_EQ] = ACTIONS(953),
    [anon_sym_PLUS_EQ] = ACTIONS(953),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(953),
    [anon_sym_DASH_EQ] = ACTIONS(953),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(953),
    [anon_sym_LT_LT_EQ] = ACTIONS(953),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(953),
    [anon_sym_GT_GT_EQ] = ACTIONS(953),
    [anon_sym_AMP_EQ] = ACTIONS(953),
    [anon_sym_CARET_EQ] = ACTIONS(953),
    [anon_sym_PIPE_EQ] = ACTIONS(953),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(953),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(953),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(953),
    [anon_sym_EQ_EQ] = ACTIONS(953),
    [anon_sym_BANG_EQ] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(955),
    [anon_sym_GT] = ACTIONS(955),
    [anon_sym_LT_EQ] = ACTIONS(953),
    [anon_sym_GT_EQ] = ACTIONS(953),
    [anon_sym_AMP] = ACTIONS(955),
    [anon_sym_CARET] = ACTIONS(955),
    [anon_sym_orelse] = ACTIONS(953),
    [anon_sym_catch] = ACTIONS(953),
    [anon_sym_LT_LT] = ACTIONS(955),
    [anon_sym_GT_GT] = ACTIONS(955),
    [anon_sym_LT_LT_PIPE] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(955),
    [anon_sym_PLUS_PLUS] = ACTIONS(953),
    [anon_sym_PLUS_PERCENT] = ACTIONS(955),
    [anon_sym_DASH_PERCENT] = ACTIONS(955),
    [anon_sym_PLUS_PIPE] = ACTIONS(955),
    [anon_sym_DASH_PIPE] = ACTIONS(955),
    [anon_sym_PIPE_PIPE] = ACTIONS(953),
    [anon_sym_SLASH] = ACTIONS(955),
    [anon_sym_PERCENT] = ACTIONS(955),
    [anon_sym_STAR_STAR] = ACTIONS(953),
    [anon_sym_STAR_PERCENT] = ACTIONS(955),
    [anon_sym_STAR_PIPE] = ACTIONS(955),
    [anon_sym_align] = ACTIONS(953),
    [anon_sym_DOT_STAR] = ACTIONS(1751),
    [anon_sym_DOT_QMARK] = ACTIONS(1751),
    [sym_line_comment] = ACTIONS(137),
  },
  [935] = {
    [sym_FieldOrFnCall] = STATE(936),
    [sym_SuffixOp] = STATE(936),
    [sym_FnCallArguments] = STATE(936),
    [aux_sym_SuffixExpr_repeat1] = STATE(936),
    [anon_sym_COMMA] = ACTIONS(981),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_BANG] = ACTIONS(983),
    [anon_sym_COLON] = ACTIONS(981),
    [anon_sym_EQ] = ACTIONS(983),
    [anon_sym_else] = ACTIONS(981),
    [anon_sym_or] = ACTIONS(983),
    [anon_sym_and] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(981),
    [anon_sym_RBRACE] = ACTIONS(981),
    [anon_sym_DOT] = ACTIONS(1745),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_RPAREN] = ACTIONS(981),
    [anon_sym_LBRACK] = ACTIONS(1749),
    [anon_sym_RBRACK] = ACTIONS(981),
    [anon_sym_linksection] = ACTIONS(981),
    [anon_sym_addrspace] = ACTIONS(981),
    [anon_sym_PIPE] = ACTIONS(983),
    [anon_sym_STAR] = ACTIONS(983),
    [anon_sym_EQ_GT] = ACTIONS(981),
    [anon_sym_DOT_DOT] = ACTIONS(981),
    [anon_sym_STAR_EQ] = ACTIONS(981),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(981),
    [anon_sym_SLASH_EQ] = ACTIONS(981),
    [anon_sym_PERCENT_EQ] = ACTIONS(981),
    [anon_sym_PLUS_EQ] = ACTIONS(981),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(981),
    [anon_sym_DASH_EQ] = ACTIONS(981),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(981),
    [anon_sym_LT_LT_EQ] = ACTIONS(981),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(981),
    [anon_sym_GT_GT_EQ] = ACTIONS(981),
    [anon_sym_AMP_EQ] = ACTIONS(981),
    [anon_sym_CARET_EQ] = ACTIONS(981),
    [anon_sym_PIPE_EQ] = ACTIONS(981),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(981),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(981),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(981),
    [anon_sym_EQ_EQ] = ACTIONS(981),
    [anon_sym_BANG_EQ] = ACTIONS(981),
    [anon_sym_LT] = ACTIONS(983),
    [anon_sym_GT] = ACTIONS(983),
    [anon_sym_LT_EQ] = ACTIONS(981),
    [anon_sym_GT_EQ] = ACTIONS(981),
    [anon_sym_AMP] = ACTIONS(983),
    [anon_sym_CARET] = ACTIONS(983),
    [anon_sym_orelse] = ACTIONS(981),
    [anon_sym_catch] = ACTIONS(981),
    [anon_sym_LT_LT] = ACTIONS(983),
    [anon_sym_GT_GT] = ACTIONS(983),
    [anon_sym_LT_LT_PIPE] = ACTIONS(983),
    [anon_sym_PLUS] = ACTIONS(983),
    [anon_sym_DASH] = ACTIONS(983),
    [anon_sym_PLUS_PLUS] = ACTIONS(981),
    [anon_sym_PLUS_PERCENT] = ACTIONS(983),
    [anon_sym_DASH_PERCENT] = ACTIONS(983),
    [anon_sym_PLUS_PIPE] = ACTIONS(983),
    [anon_sym_DASH_PIPE] = ACTIONS(983),
    [anon_sym_PIPE_PIPE] = ACTIONS(981),
    [anon_sym_SLASH] = ACTIONS(983),
    [anon_sym_PERCENT] = ACTIONS(983),
    [anon_sym_STAR_STAR] = ACTIONS(981),
    [anon_sym_STAR_PERCENT] = ACTIONS(983),
    [anon_sym_STAR_PIPE] = ACTIONS(983),
    [anon_sym_align] = ACTIONS(981),
    [anon_sym_DOT_STAR] = ACTIONS(1751),
    [anon_sym_DOT_QMARK] = ACTIONS(1751),
    [sym_line_comment] = ACTIONS(137),
  },
  [936] = {
    [sym_FieldOrFnCall] = STATE(929),
    [sym_SuffixOp] = STATE(929),
    [sym_FnCallArguments] = STATE(929),
    [aux_sym_SuffixExpr_repeat1] = STATE(929),
    [anon_sym_COMMA] = ACTIONS(989),
    [anon_sym_SEMI] = ACTIONS(989),
    [anon_sym_BANG] = ACTIONS(991),
    [anon_sym_COLON] = ACTIONS(989),
    [anon_sym_EQ] = ACTIONS(991),
    [anon_sym_else] = ACTIONS(989),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_and] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_RBRACE] = ACTIONS(989),
    [anon_sym_DOT] = ACTIONS(1745),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_RPAREN] = ACTIONS(989),
    [anon_sym_LBRACK] = ACTIONS(1749),
    [anon_sym_RBRACK] = ACTIONS(989),
    [anon_sym_linksection] = ACTIONS(989),
    [anon_sym_addrspace] = ACTIONS(989),
    [anon_sym_PIPE] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(991),
    [anon_sym_EQ_GT] = ACTIONS(989),
    [anon_sym_DOT_DOT] = ACTIONS(989),
    [anon_sym_STAR_EQ] = ACTIONS(989),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(989),
    [anon_sym_SLASH_EQ] = ACTIONS(989),
    [anon_sym_PERCENT_EQ] = ACTIONS(989),
    [anon_sym_PLUS_EQ] = ACTIONS(989),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(989),
    [anon_sym_DASH_EQ] = ACTIONS(989),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(989),
    [anon_sym_LT_LT_EQ] = ACTIONS(989),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(989),
    [anon_sym_GT_GT_EQ] = ACTIONS(989),
    [anon_sym_AMP_EQ] = ACTIONS(989),
    [anon_sym_CARET_EQ] = ACTIONS(989),
    [anon_sym_PIPE_EQ] = ACTIONS(989),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(989),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(989),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(989),
    [anon_sym_EQ_EQ] = ACTIONS(989),
    [anon_sym_BANG_EQ] = ACTIONS(989),
    [anon_sym_LT] = ACTIONS(991),
    [anon_sym_GT] = ACTIONS(991),
    [anon_sym_LT_EQ] = ACTIONS(989),
    [anon_sym_GT_EQ] = ACTIONS(989),
    [anon_sym_AMP] = ACTIONS(991),
    [anon_sym_CARET] = ACTIONS(991),
    [anon_sym_orelse] = ACTIONS(989),
    [anon_sym_catch] = ACTIONS(989),
    [anon_sym_LT_LT] = ACTIONS(991),
    [anon_sym_GT_GT] = ACTIONS(991),
    [anon_sym_LT_LT_PIPE] = ACTIONS(991),
    [anon_sym_PLUS] = ACTIONS(991),
    [anon_sym_DASH] = ACTIONS(991),
    [anon_sym_PLUS_PLUS] = ACTIONS(989),
    [anon_sym_PLUS_PERCENT] = ACTIONS(991),
    [anon_sym_DASH_PERCENT] = ACTIONS(991),
    [anon_sym_PLUS_PIPE] = ACTIONS(991),
    [anon_sym_DASH_PIPE] = ACTIONS(991),
    [anon_sym_PIPE_PIPE] = ACTIONS(989),
    [anon_sym_SLASH] = ACTIONS(991),
    [anon_sym_PERCENT] = ACTIONS(991),
    [anon_sym_STAR_STAR] = ACTIONS(989),
    [anon_sym_STAR_PERCENT] = ACTIONS(991),
    [anon_sym_STAR_PIPE] = ACTIONS(991),
    [anon_sym_align] = ACTIONS(989),
    [anon_sym_DOT_STAR] = ACTIONS(1751),
    [anon_sym_DOT_QMARK] = ACTIONS(1751),
    [sym_line_comment] = ACTIONS(137),
  },
  [937] = {
    [anon_sym_COMMA] = ACTIONS(556),
    [anon_sym_SEMI] = ACTIONS(556),
    [anon_sym_threadlocal] = ACTIONS(556),
    [anon_sym_fn] = ACTIONS(556),
    [anon_sym_BANG] = ACTIONS(558),
    [anon_sym_const] = ACTIONS(556),
    [anon_sym_var] = ACTIONS(556),
    [anon_sym_COLON] = ACTIONS(556),
    [anon_sym_EQ] = ACTIONS(558),
    [anon_sym_else] = ACTIONS(556),
    [anon_sym_or] = ACTIONS(558),
    [anon_sym_and] = ACTIONS(556),
    [anon_sym_LBRACE] = ACTIONS(556),
    [anon_sym_RBRACE] = ACTIONS(556),
    [anon_sym_DOT] = ACTIONS(558),
    [anon_sym_LPAREN] = ACTIONS(556),
    [anon_sym_RPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(556),
    [anon_sym_RBRACK] = ACTIONS(556),
    [anon_sym_linksection] = ACTIONS(556),
    [anon_sym_addrspace] = ACTIONS(556),
    [anon_sym_PIPE] = ACTIONS(558),
    [anon_sym_STAR] = ACTIONS(558),
    [anon_sym_EQ_GT] = ACTIONS(556),
    [anon_sym_DOT_DOT] = ACTIONS(556),
    [anon_sym_STAR_EQ] = ACTIONS(556),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(556),
    [anon_sym_SLASH_EQ] = ACTIONS(556),
    [anon_sym_PERCENT_EQ] = ACTIONS(556),
    [anon_sym_PLUS_EQ] = ACTIONS(556),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(556),
    [anon_sym_DASH_EQ] = ACTIONS(556),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(556),
    [anon_sym_LT_LT_EQ] = ACTIONS(556),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(556),
    [anon_sym_GT_GT_EQ] = ACTIONS(556),
    [anon_sym_AMP_EQ] = ACTIONS(556),
    [anon_sym_CARET_EQ] = ACTIONS(556),
    [anon_sym_PIPE_EQ] = ACTIONS(556),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(556),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(556),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(556),
    [anon_sym_EQ_EQ] = ACTIONS(556),
    [anon_sym_BANG_EQ] = ACTIONS(556),
    [anon_sym_LT] = ACTIONS(558),
    [anon_sym_GT] = ACTIONS(558),
    [anon_sym_LT_EQ] = ACTIONS(556),
    [anon_sym_GT_EQ] = ACTIONS(556),
    [anon_sym_AMP] = ACTIONS(558),
    [anon_sym_CARET] = ACTIONS(558),
    [anon_sym_orelse] = ACTIONS(556),
    [anon_sym_catch] = ACTIONS(556),
    [anon_sym_LT_LT] = ACTIONS(558),
    [anon_sym_GT_GT] = ACTIONS(558),
    [anon_sym_LT_LT_PIPE] = ACTIONS(558),
    [anon_sym_PLUS] = ACTIONS(558),
    [anon_sym_DASH] = ACTIONS(558),
    [anon_sym_PLUS_PLUS] = ACTIONS(556),
    [anon_sym_PLUS_PERCENT] = ACTIONS(558),
    [anon_sym_DASH_PERCENT] = ACTIONS(558),
    [anon_sym_PLUS_PIPE] = ACTIONS(558),
    [anon_sym_DASH_PIPE] = ACTIONS(558),
    [anon_sym_PIPE_PIPE] = ACTIONS(556),
    [anon_sym_SLASH] = ACTIONS(558),
    [anon_sym_PERCENT] = ACTIONS(558),
    [anon_sym_STAR_STAR] = ACTIONS(556),
    [anon_sym_STAR_PERCENT] = ACTIONS(558),
    [anon_sym_STAR_PIPE] = ACTIONS(558),
    [anon_sym_align] = ACTIONS(556),
    [anon_sym_DOT_STAR] = ACTIONS(556),
    [anon_sym_DOT_QMARK] = ACTIONS(556),
    [sym_line_comment] = ACTIONS(137),
  },
  [938] = {
    [sym_FieldOrFnCall] = STATE(931),
    [sym_SuffixOp] = STATE(931),
    [sym_FnCallArguments] = STATE(931),
    [aux_sym_SuffixExpr_repeat1] = STATE(931),
    [anon_sym_COMMA] = ACTIONS(927),
    [anon_sym_SEMI] = ACTIONS(927),
    [anon_sym_BANG] = ACTIONS(929),
    [anon_sym_COLON] = ACTIONS(931),
    [anon_sym_EQ] = ACTIONS(929),
    [anon_sym_else] = ACTIONS(927),
    [anon_sym_or] = ACTIONS(929),
    [anon_sym_and] = ACTIONS(927),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_RBRACE] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(1745),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_RPAREN] = ACTIONS(927),
    [anon_sym_LBRACK] = ACTIONS(1749),
    [anon_sym_RBRACK] = ACTIONS(927),
    [anon_sym_linksection] = ACTIONS(927),
    [anon_sym_addrspace] = ACTIONS(927),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_EQ_GT] = ACTIONS(927),
    [anon_sym_DOT_DOT] = ACTIONS(927),
    [anon_sym_STAR_EQ] = ACTIONS(927),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(927),
    [anon_sym_SLASH_EQ] = ACTIONS(927),
    [anon_sym_PERCENT_EQ] = ACTIONS(927),
    [anon_sym_PLUS_EQ] = ACTIONS(927),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(927),
    [anon_sym_DASH_EQ] = ACTIONS(927),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(927),
    [anon_sym_LT_LT_EQ] = ACTIONS(927),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(927),
    [anon_sym_GT_GT_EQ] = ACTIONS(927),
    [anon_sym_AMP_EQ] = ACTIONS(927),
    [anon_sym_CARET_EQ] = ACTIONS(927),
    [anon_sym_PIPE_EQ] = ACTIONS(927),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(927),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(927),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(927),
    [anon_sym_EQ_EQ] = ACTIONS(927),
    [anon_sym_BANG_EQ] = ACTIONS(927),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_LT_EQ] = ACTIONS(927),
    [anon_sym_GT_EQ] = ACTIONS(927),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_orelse] = ACTIONS(927),
    [anon_sym_catch] = ACTIONS(927),
    [anon_sym_LT_LT] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(929),
    [anon_sym_LT_LT_PIPE] = ACTIONS(929),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_PLUS_PLUS] = ACTIONS(927),
    [anon_sym_PLUS_PERCENT] = ACTIONS(929),
    [anon_sym_DASH_PERCENT] = ACTIONS(929),
    [anon_sym_PLUS_PIPE] = ACTIONS(929),
    [anon_sym_DASH_PIPE] = ACTIONS(929),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_PERCENT] = ACTIONS(929),
    [anon_sym_STAR_STAR] = ACTIONS(927),
    [anon_sym_STAR_PERCENT] = ACTIONS(929),
    [anon_sym_STAR_PIPE] = ACTIONS(929),
    [anon_sym_align] = ACTIONS(927),
    [anon_sym_DOT_STAR] = ACTIONS(1751),
    [anon_sym_DOT_QMARK] = ACTIONS(1751),
    [sym_line_comment] = ACTIONS(137),
  },
  [939] = {
    [sym_FieldOrFnCall] = STATE(932),
    [sym_SuffixOp] = STATE(932),
    [sym_FnCallArguments] = STATE(932),
    [aux_sym_SuffixExpr_repeat1] = STATE(932),
    [anon_sym_COMMA] = ACTIONS(985),
    [anon_sym_SEMI] = ACTIONS(985),
    [anon_sym_BANG] = ACTIONS(987),
    [anon_sym_COLON] = ACTIONS(985),
    [anon_sym_EQ] = ACTIONS(987),
    [anon_sym_else] = ACTIONS(985),
    [anon_sym_or] = ACTIONS(987),
    [anon_sym_and] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(985),
    [anon_sym_RBRACE] = ACTIONS(985),
    [anon_sym_DOT] = ACTIONS(1745),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_RPAREN] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(1749),
    [anon_sym_RBRACK] = ACTIONS(985),
    [anon_sym_linksection] = ACTIONS(985),
    [anon_sym_addrspace] = ACTIONS(985),
    [anon_sym_PIPE] = ACTIONS(987),
    [anon_sym_STAR] = ACTIONS(987),
    [anon_sym_EQ_GT] = ACTIONS(985),
    [anon_sym_DOT_DOT] = ACTIONS(985),
    [anon_sym_STAR_EQ] = ACTIONS(985),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(985),
    [anon_sym_SLASH_EQ] = ACTIONS(985),
    [anon_sym_PERCENT_EQ] = ACTIONS(985),
    [anon_sym_PLUS_EQ] = ACTIONS(985),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(985),
    [anon_sym_DASH_EQ] = ACTIONS(985),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(985),
    [anon_sym_LT_LT_EQ] = ACTIONS(985),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(985),
    [anon_sym_GT_GT_EQ] = ACTIONS(985),
    [anon_sym_AMP_EQ] = ACTIONS(985),
    [anon_sym_CARET_EQ] = ACTIONS(985),
    [anon_sym_PIPE_EQ] = ACTIONS(985),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(985),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(985),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(985),
    [anon_sym_EQ_EQ] = ACTIONS(985),
    [anon_sym_BANG_EQ] = ACTIONS(985),
    [anon_sym_LT] = ACTIONS(987),
    [anon_sym_GT] = ACTIONS(987),
    [anon_sym_LT_EQ] = ACTIONS(985),
    [anon_sym_GT_EQ] = ACTIONS(985),
    [anon_sym_AMP] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(987),
    [anon_sym_orelse] = ACTIONS(985),
    [anon_sym_catch] = ACTIONS(985),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_LT_LT_PIPE] = ACTIONS(987),
    [anon_sym_PLUS] = ACTIONS(987),
    [anon_sym_DASH] = ACTIONS(987),
    [anon_sym_PLUS_PLUS] = ACTIONS(985),
    [anon_sym_PLUS_PERCENT] = ACTIONS(987),
    [anon_sym_DASH_PERCENT] = ACTIONS(987),
    [anon_sym_PLUS_PIPE] = ACTIONS(987),
    [anon_sym_DASH_PIPE] = ACTIONS(987),
    [anon_sym_PIPE_PIPE] = ACTIONS(985),
    [anon_sym_SLASH] = ACTIONS(987),
    [anon_sym_PERCENT] = ACTIONS(987),
    [anon_sym_STAR_STAR] = ACTIONS(985),
    [anon_sym_STAR_PERCENT] = ACTIONS(987),
    [anon_sym_STAR_PIPE] = ACTIONS(987),
    [anon_sym_align] = ACTIONS(985),
    [anon_sym_DOT_STAR] = ACTIONS(1751),
    [anon_sym_DOT_QMARK] = ACTIONS(1751),
    [sym_line_comment] = ACTIONS(137),
  },
  [940] = {
    [sym_LINESTRING] = STATE(940),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(940),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1067),
    [anon_sym_else] = ACTIONS(1065),
    [anon_sym_or] = ACTIONS(1067),
    [anon_sym_and] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1067),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [anon_sym_LBRACK] = ACTIONS(1065),
    [anon_sym_RBRACK] = ACTIONS(1065),
    [anon_sym_linksection] = ACTIONS(1065),
    [anon_sym_addrspace] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1067),
    [anon_sym_STAR] = ACTIONS(1067),
    [anon_sym_EQ_GT] = ACTIONS(1065),
    [anon_sym_DOT_DOT] = ACTIONS(1065),
    [anon_sym_STAR_EQ] = ACTIONS(1065),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1065),
    [anon_sym_SLASH_EQ] = ACTIONS(1065),
    [anon_sym_PERCENT_EQ] = ACTIONS(1065),
    [anon_sym_PLUS_EQ] = ACTIONS(1065),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1065),
    [anon_sym_DASH_EQ] = ACTIONS(1065),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1065),
    [anon_sym_LT_LT_EQ] = ACTIONS(1065),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1065),
    [anon_sym_GT_GT_EQ] = ACTIONS(1065),
    [anon_sym_AMP_EQ] = ACTIONS(1065),
    [anon_sym_CARET_EQ] = ACTIONS(1065),
    [anon_sym_PIPE_EQ] = ACTIONS(1065),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1065),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1065),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1065),
    [anon_sym_EQ_EQ] = ACTIONS(1065),
    [anon_sym_BANG_EQ] = ACTIONS(1065),
    [anon_sym_LT] = ACTIONS(1067),
    [anon_sym_GT] = ACTIONS(1067),
    [anon_sym_LT_EQ] = ACTIONS(1065),
    [anon_sym_GT_EQ] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1067),
    [anon_sym_CARET] = ACTIONS(1067),
    [anon_sym_orelse] = ACTIONS(1065),
    [anon_sym_catch] = ACTIONS(1065),
    [anon_sym_LT_LT] = ACTIONS(1067),
    [anon_sym_GT_GT] = ACTIONS(1067),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1067),
    [anon_sym_PLUS] = ACTIONS(1067),
    [anon_sym_DASH] = ACTIONS(1067),
    [anon_sym_PLUS_PLUS] = ACTIONS(1065),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1067),
    [anon_sym_DASH_PERCENT] = ACTIONS(1067),
    [anon_sym_PLUS_PIPE] = ACTIONS(1067),
    [anon_sym_DASH_PIPE] = ACTIONS(1067),
    [anon_sym_PIPE_PIPE] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1067),
    [anon_sym_PERCENT] = ACTIONS(1067),
    [anon_sym_STAR_STAR] = ACTIONS(1065),
    [anon_sym_STAR_PERCENT] = ACTIONS(1067),
    [anon_sym_STAR_PIPE] = ACTIONS(1067),
    [anon_sym_align] = ACTIONS(1065),
    [anon_sym_DOT_STAR] = ACTIONS(1065),
    [anon_sym_DOT_QMARK] = ACTIONS(1065),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1753),
  },
  [941] = {
    [sym_LINESTRING] = STATE(940),
    [aux_sym__STRINGLITERAL_repeat1] = STATE(940),
    [anon_sym_COMMA] = ACTIONS(1756),
    [anon_sym_SEMI] = ACTIONS(1756),
    [anon_sym_BANG] = ACTIONS(1758),
    [anon_sym_COLON] = ACTIONS(1756),
    [anon_sym_EQ] = ACTIONS(1758),
    [anon_sym_else] = ACTIONS(1756),
    [anon_sym_or] = ACTIONS(1758),
    [anon_sym_and] = ACTIONS(1756),
    [anon_sym_LBRACE] = ACTIONS(1756),
    [anon_sym_RBRACE] = ACTIONS(1756),
    [anon_sym_DOT] = ACTIONS(1758),
    [anon_sym_LPAREN] = ACTIONS(1756),
    [anon_sym_RPAREN] = ACTIONS(1756),
    [anon_sym_LBRACK] = ACTIONS(1756),
    [anon_sym_RBRACK] = ACTIONS(1756),
    [anon_sym_linksection] = ACTIONS(1756),
    [anon_sym_addrspace] = ACTIONS(1756),
    [anon_sym_PIPE] = ACTIONS(1758),
    [anon_sym_STAR] = ACTIONS(1758),
    [anon_sym_EQ_GT] = ACTIONS(1756),
    [anon_sym_DOT_DOT] = ACTIONS(1756),
    [anon_sym_STAR_EQ] = ACTIONS(1756),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1756),
    [anon_sym_SLASH_EQ] = ACTIONS(1756),
    [anon_sym_PERCENT_EQ] = ACTIONS(1756),
    [anon_sym_PLUS_EQ] = ACTIONS(1756),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1756),
    [anon_sym_DASH_EQ] = ACTIONS(1756),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1756),
    [anon_sym_LT_LT_EQ] = ACTIONS(1756),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1756),
    [anon_sym_GT_GT_EQ] = ACTIONS(1756),
    [anon_sym_AMP_EQ] = ACTIONS(1756),
    [anon_sym_CARET_EQ] = ACTIONS(1756),
    [anon_sym_PIPE_EQ] = ACTIONS(1756),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1756),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1756),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1756),
    [anon_sym_EQ_EQ] = ACTIONS(1756),
    [anon_sym_BANG_EQ] = ACTIONS(1756),
    [anon_sym_LT] = ACTIONS(1758),
    [anon_sym_GT] = ACTIONS(1758),
    [anon_sym_LT_EQ] = ACTIONS(1756),
    [anon_sym_GT_EQ] = ACTIONS(1756),
    [anon_sym_AMP] = ACTIONS(1758),
    [anon_sym_CARET] = ACTIONS(1758),
    [anon_sym_orelse] = ACTIONS(1756),
    [anon_sym_catch] = ACTIONS(1756),
    [anon_sym_LT_LT] = ACTIONS(1758),
    [anon_sym_GT_GT] = ACTIONS(1758),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1758),
    [anon_sym_PLUS] = ACTIONS(1758),
    [anon_sym_DASH] = ACTIONS(1758),
    [anon_sym_PLUS_PLUS] = ACTIONS(1756),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1758),
    [anon_sym_DASH_PERCENT] = ACTIONS(1758),
    [anon_sym_PLUS_PIPE] = ACTIONS(1758),
    [anon_sym_DASH_PIPE] = ACTIONS(1758),
    [anon_sym_PIPE_PIPE] = ACTIONS(1756),
    [anon_sym_SLASH] = ACTIONS(1758),
    [anon_sym_PERCENT] = ACTIONS(1758),
    [anon_sym_STAR_STAR] = ACTIONS(1756),
    [anon_sym_STAR_PERCENT] = ACTIONS(1758),
    [anon_sym_STAR_PIPE] = ACTIONS(1758),
    [anon_sym_align] = ACTIONS(1756),
    [anon_sym_DOT_STAR] = ACTIONS(1756),
    [anon_sym_DOT_QMARK] = ACTIONS(1756),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(149),
  },
  [942] = {
    [sym_FnCallArguments] = STATE(987),
    [anon_sym_COMMA] = ACTIONS(1089),
    [anon_sym_SEMI] = ACTIONS(1089),
    [anon_sym_BANG] = ACTIONS(1091),
    [anon_sym_COLON] = ACTIONS(1089),
    [anon_sym_EQ] = ACTIONS(1091),
    [anon_sym_else] = ACTIONS(1089),
    [anon_sym_or] = ACTIONS(1091),
    [anon_sym_and] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1089),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym_DOT] = ACTIONS(1091),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_RPAREN] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_RBRACK] = ACTIONS(1089),
    [anon_sym_linksection] = ACTIONS(1089),
    [anon_sym_addrspace] = ACTIONS(1089),
    [anon_sym_PIPE] = ACTIONS(1091),
    [anon_sym_STAR] = ACTIONS(1091),
    [anon_sym_EQ_GT] = ACTIONS(1089),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym_STAR_EQ] = ACTIONS(1089),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_SLASH_EQ] = ACTIONS(1089),
    [anon_sym_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1089),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_DASH_EQ] = ACTIONS(1089),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_EQ] = ACTIONS(1089),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_GT_GT_EQ] = ACTIONS(1089),
    [anon_sym_AMP_EQ] = ACTIONS(1089),
    [anon_sym_CARET_EQ] = ACTIONS(1089),
    [anon_sym_PIPE_EQ] = ACTIONS(1089),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1089),
    [anon_sym_EQ_EQ] = ACTIONS(1089),
    [anon_sym_BANG_EQ] = ACTIONS(1089),
    [anon_sym_LT] = ACTIONS(1091),
    [anon_sym_GT] = ACTIONS(1091),
    [anon_sym_LT_EQ] = ACTIONS(1089),
    [anon_sym_GT_EQ] = ACTIONS(1089),
    [anon_sym_AMP] = ACTIONS(1091),
    [anon_sym_CARET] = ACTIONS(1091),
    [anon_sym_orelse] = ACTIONS(1089),
    [anon_sym_catch] = ACTIONS(1089),
    [anon_sym_LT_LT] = ACTIONS(1091),
    [anon_sym_GT_GT] = ACTIONS(1091),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1091),
    [anon_sym_PLUS] = ACTIONS(1091),
    [anon_sym_DASH] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1089),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1091),
    [anon_sym_DASH_PERCENT] = ACTIONS(1091),
    [anon_sym_PLUS_PIPE] = ACTIONS(1091),
    [anon_sym_DASH_PIPE] = ACTIONS(1091),
    [anon_sym_PIPE_PIPE] = ACTIONS(1089),
    [anon_sym_SLASH] = ACTIONS(1091),
    [anon_sym_PERCENT] = ACTIONS(1091),
    [anon_sym_STAR_STAR] = ACTIONS(1089),
    [anon_sym_STAR_PERCENT] = ACTIONS(1091),
    [anon_sym_STAR_PIPE] = ACTIONS(1091),
    [anon_sym_align] = ACTIONS(1089),
    [anon_sym_DOT_STAR] = ACTIONS(1089),
    [anon_sym_DOT_QMARK] = ACTIONS(1089),
    [sym_line_comment] = ACTIONS(137),
  },
  [943] = {
    [anon_sym_COMMA] = ACTIONS(546),
    [anon_sym_SEMI] = ACTIONS(546),
    [anon_sym_BANG] = ACTIONS(548),
    [anon_sym_COLON] = ACTIONS(546),
    [anon_sym_EQ] = ACTIONS(548),
    [anon_sym_else] = ACTIONS(546),
    [anon_sym_or] = ACTIONS(548),
    [anon_sym_and] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_RBRACE] = ACTIONS(546),
    [anon_sym_DOT] = ACTIONS(548),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_RPAREN] = ACTIONS(546),
    [anon_sym_LBRACK] = ACTIONS(546),
    [anon_sym_RBRACK] = ACTIONS(546),
    [anon_sym_DASH_GT] = ACTIONS(1101),
    [anon_sym_linksection] = ACTIONS(546),
    [anon_sym_addrspace] = ACTIONS(546),
    [anon_sym_PIPE] = ACTIONS(548),
    [anon_sym_STAR] = ACTIONS(548),
    [anon_sym_EQ_GT] = ACTIONS(546),
    [anon_sym_DOT_DOT] = ACTIONS(546),
    [anon_sym_STAR_EQ] = ACTIONS(546),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(546),
    [anon_sym_SLASH_EQ] = ACTIONS(546),
    [anon_sym_PERCENT_EQ] = ACTIONS(546),
    [anon_sym_PLUS_EQ] = ACTIONS(546),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(546),
    [anon_sym_DASH_EQ] = ACTIONS(546),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(546),
    [anon_sym_LT_LT_EQ] = ACTIONS(546),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(546),
    [anon_sym_GT_GT_EQ] = ACTIONS(546),
    [anon_sym_AMP_EQ] = ACTIONS(546),
    [anon_sym_CARET_EQ] = ACTIONS(546),
    [anon_sym_PIPE_EQ] = ACTIONS(546),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(546),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(546),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(546),
    [anon_sym_EQ_EQ] = ACTIONS(546),
    [anon_sym_BANG_EQ] = ACTIONS(546),
    [anon_sym_LT] = ACTIONS(548),
    [anon_sym_GT] = ACTIONS(548),
    [anon_sym_LT_EQ] = ACTIONS(546),
    [anon_sym_GT_EQ] = ACTIONS(546),
    [anon_sym_AMP] = ACTIONS(548),
    [anon_sym_CARET] = ACTIONS(548),
    [anon_sym_orelse] = ACTIONS(546),
    [anon_sym_catch] = ACTIONS(546),
    [anon_sym_LT_LT] = ACTIONS(548),
    [anon_sym_GT_GT] = ACTIONS(548),
    [anon_sym_LT_LT_PIPE] = ACTIONS(548),
    [anon_sym_PLUS] = ACTIONS(548),
    [anon_sym_DASH] = ACTIONS(548),
    [anon_sym_PLUS_PLUS] = ACTIONS(546),
    [anon_sym_PLUS_PERCENT] = ACTIONS(548),
    [anon_sym_DASH_PERCENT] = ACTIONS(548),
    [anon_sym_PLUS_PIPE] = ACTIONS(548),
    [anon_sym_DASH_PIPE] = ACTIONS(548),
    [anon_sym_PIPE_PIPE] = ACTIONS(546),
    [anon_sym_SLASH] = ACTIONS(548),
    [anon_sym_PERCENT] = ACTIONS(548),
    [anon_sym_STAR_STAR] = ACTIONS(546),
    [anon_sym_STAR_PERCENT] = ACTIONS(548),
    [anon_sym_STAR_PIPE] = ACTIONS(548),
    [anon_sym_align] = ACTIONS(546),
    [anon_sym_DOT_STAR] = ACTIONS(546),
    [anon_sym_DOT_QMARK] = ACTIONS(546),
    [sym_line_comment] = ACTIONS(137),
  },
  [944] = {
    [sym__ElseTypeExprTail] = STATE(954),
    [anon_sym_COMMA] = ACTIONS(1047),
    [anon_sym_SEMI] = ACTIONS(1047),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_COLON] = ACTIONS(1047),
    [anon_sym_EQ] = ACTIONS(1043),
    [anon_sym_else] = ACTIONS(1760),
    [anon_sym_or] = ACTIONS(1043),
    [anon_sym_and] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(1047),
    [anon_sym_DOT] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1047),
    [anon_sym_RPAREN] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(1047),
    [anon_sym_linksection] = ACTIONS(1047),
    [anon_sym_addrspace] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(1043),
    [anon_sym_STAR] = ACTIONS(1043),
    [anon_sym_EQ_GT] = ACTIONS(1047),
    [anon_sym_DOT_DOT] = ACTIONS(1047),
    [anon_sym_STAR_EQ] = ACTIONS(1047),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1047),
    [anon_sym_SLASH_EQ] = ACTIONS(1047),
    [anon_sym_PERCENT_EQ] = ACTIONS(1047),
    [anon_sym_PLUS_EQ] = ACTIONS(1047),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1047),
    [anon_sym_DASH_EQ] = ACTIONS(1047),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1047),
    [anon_sym_LT_LT_EQ] = ACTIONS(1047),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1047),
    [anon_sym_GT_GT_EQ] = ACTIONS(1047),
    [anon_sym_AMP_EQ] = ACTIONS(1047),
    [anon_sym_CARET_EQ] = ACTIONS(1047),
    [anon_sym_PIPE_EQ] = ACTIONS(1047),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1047),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1047),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1047),
    [anon_sym_EQ_EQ] = ACTIONS(1047),
    [anon_sym_BANG_EQ] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1043),
    [anon_sym_GT] = ACTIONS(1043),
    [anon_sym_LT_EQ] = ACTIONS(1047),
    [anon_sym_GT_EQ] = ACTIONS(1047),
    [anon_sym_AMP] = ACTIONS(1043),
    [anon_sym_CARET] = ACTIONS(1043),
    [anon_sym_orelse] = ACTIONS(1047),
    [anon_sym_catch] = ACTIONS(1047),
    [anon_sym_LT_LT] = ACTIONS(1043),
    [anon_sym_GT_GT] = ACTIONS(1043),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1043),
    [anon_sym_PLUS] = ACTIONS(1043),
    [anon_sym_DASH] = ACTIONS(1043),
    [anon_sym_PLUS_PLUS] = ACTIONS(1047),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1043),
    [anon_sym_DASH_PERCENT] = ACTIONS(1043),
    [anon_sym_PLUS_PIPE] = ACTIONS(1043),
    [anon_sym_DASH_PIPE] = ACTIONS(1043),
    [anon_sym_PIPE_PIPE] = ACTIONS(1047),
    [anon_sym_SLASH] = ACTIONS(1043),
    [anon_sym_PERCENT] = ACTIONS(1043),
    [anon_sym_STAR_STAR] = ACTIONS(1047),
    [anon_sym_STAR_PERCENT] = ACTIONS(1043),
    [anon_sym_STAR_PIPE] = ACTIONS(1043),
    [anon_sym_align] = ACTIONS(1047),
    [anon_sym_DOT_STAR] = ACTIONS(1047),
    [anon_sym_DOT_QMARK] = ACTIONS(1047),
    [sym_line_comment] = ACTIONS(137),
  },
  [945] = {
    [sym__ElseTypeExprTail] = STATE(957),
    [anon_sym_COMMA] = ACTIONS(1055),
    [anon_sym_SEMI] = ACTIONS(1055),
    [anon_sym_BANG] = ACTIONS(1053),
    [anon_sym_COLON] = ACTIONS(1055),
    [anon_sym_EQ] = ACTIONS(1053),
    [anon_sym_else] = ACTIONS(1760),
    [anon_sym_or] = ACTIONS(1053),
    [anon_sym_and] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(1055),
    [anon_sym_RBRACE] = ACTIONS(1055),
    [anon_sym_DOT] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1055),
    [anon_sym_RPAREN] = ACTIONS(1055),
    [anon_sym_LBRACK] = ACTIONS(1055),
    [anon_sym_RBRACK] = ACTIONS(1055),
    [anon_sym_linksection] = ACTIONS(1055),
    [anon_sym_addrspace] = ACTIONS(1055),
    [anon_sym_PIPE] = ACTIONS(1053),
    [anon_sym_STAR] = ACTIONS(1053),
    [anon_sym_EQ_GT] = ACTIONS(1055),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym_STAR_EQ] = ACTIONS(1055),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1055),
    [anon_sym_SLASH_EQ] = ACTIONS(1055),
    [anon_sym_PERCENT_EQ] = ACTIONS(1055),
    [anon_sym_PLUS_EQ] = ACTIONS(1055),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1055),
    [anon_sym_DASH_EQ] = ACTIONS(1055),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1055),
    [anon_sym_LT_LT_EQ] = ACTIONS(1055),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1055),
    [anon_sym_GT_GT_EQ] = ACTIONS(1055),
    [anon_sym_AMP_EQ] = ACTIONS(1055),
    [anon_sym_CARET_EQ] = ACTIONS(1055),
    [anon_sym_PIPE_EQ] = ACTIONS(1055),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1055),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1055),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1055),
    [anon_sym_EQ_EQ] = ACTIONS(1055),
    [anon_sym_BANG_EQ] = ACTIONS(1055),
    [anon_sym_LT] = ACTIONS(1053),
    [anon_sym_GT] = ACTIONS(1053),
    [anon_sym_LT_EQ] = ACTIONS(1055),
    [anon_sym_GT_EQ] = ACTIONS(1055),
    [anon_sym_AMP] = ACTIONS(1053),
    [anon_sym_CARET] = ACTIONS(1053),
    [anon_sym_orelse] = ACTIONS(1055),
    [anon_sym_catch] = ACTIONS(1055),
    [anon_sym_LT_LT] = ACTIONS(1053),
    [anon_sym_GT_GT] = ACTIONS(1053),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1053),
    [anon_sym_PLUS] = ACTIONS(1053),
    [anon_sym_DASH] = ACTIONS(1053),
    [anon_sym_PLUS_PLUS] = ACTIONS(1055),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1053),
    [anon_sym_DASH_PERCENT] = ACTIONS(1053),
    [anon_sym_PLUS_PIPE] = ACTIONS(1053),
    [anon_sym_DASH_PIPE] = ACTIONS(1053),
    [anon_sym_PIPE_PIPE] = ACTIONS(1055),
    [anon_sym_SLASH] = ACTIONS(1053),
    [anon_sym_PERCENT] = ACTIONS(1053),
    [anon_sym_STAR_STAR] = ACTIONS(1055),
    [anon_sym_STAR_PERCENT] = ACTIONS(1053),
    [anon_sym_STAR_PIPE] = ACTIONS(1053),
    [anon_sym_align] = ACTIONS(1055),
    [anon_sym_DOT_STAR] = ACTIONS(1055),
    [anon_sym_DOT_QMARK] = ACTIONS(1055),
    [sym_line_comment] = ACTIONS(137),
  },
  [946] = {
    [sym__ElseTypeExprTail] = STATE(958),
    [anon_sym_COMMA] = ACTIONS(1063),
    [anon_sym_SEMI] = ACTIONS(1063),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_COLON] = ACTIONS(1063),
    [anon_sym_EQ] = ACTIONS(1061),
    [anon_sym_else] = ACTIONS(1760),
    [anon_sym_or] = ACTIONS(1061),
    [anon_sym_and] = ACTIONS(1063),
    [anon_sym_LBRACE] = ACTIONS(1063),
    [anon_sym_RBRACE] = ACTIONS(1063),
    [anon_sym_DOT] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_RPAREN] = ACTIONS(1063),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [anon_sym_RBRACK] = ACTIONS(1063),
    [anon_sym_linksection] = ACTIONS(1063),
    [anon_sym_addrspace] = ACTIONS(1063),
    [anon_sym_PIPE] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(1061),
    [anon_sym_EQ_GT] = ACTIONS(1063),
    [anon_sym_DOT_DOT] = ACTIONS(1063),
    [anon_sym_STAR_EQ] = ACTIONS(1063),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1063),
    [anon_sym_SLASH_EQ] = ACTIONS(1063),
    [anon_sym_PERCENT_EQ] = ACTIONS(1063),
    [anon_sym_PLUS_EQ] = ACTIONS(1063),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1063),
    [anon_sym_DASH_EQ] = ACTIONS(1063),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1063),
    [anon_sym_LT_LT_EQ] = ACTIONS(1063),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1063),
    [anon_sym_GT_GT_EQ] = ACTIONS(1063),
    [anon_sym_AMP_EQ] = ACTIONS(1063),
    [anon_sym_CARET_EQ] = ACTIONS(1063),
    [anon_sym_PIPE_EQ] = ACTIONS(1063),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1063),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1063),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1063),
    [anon_sym_EQ_EQ] = ACTIONS(1063),
    [anon_sym_BANG_EQ] = ACTIONS(1063),
    [anon_sym_LT] = ACTIONS(1061),
    [anon_sym_GT] = ACTIONS(1061),
    [anon_sym_LT_EQ] = ACTIONS(1063),
    [anon_sym_GT_EQ] = ACTIONS(1063),
    [anon_sym_AMP] = ACTIONS(1061),
    [anon_sym_CARET] = ACTIONS(1061),
    [anon_sym_orelse] = ACTIONS(1063),
    [anon_sym_catch] = ACTIONS(1063),
    [anon_sym_LT_LT] = ACTIONS(1061),
    [anon_sym_GT_GT] = ACTIONS(1061),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1061),
    [anon_sym_PLUS] = ACTIONS(1061),
    [anon_sym_DASH] = ACTIONS(1061),
    [anon_sym_PLUS_PLUS] = ACTIONS(1063),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1061),
    [anon_sym_DASH_PERCENT] = ACTIONS(1061),
    [anon_sym_PLUS_PIPE] = ACTIONS(1061),
    [anon_sym_DASH_PIPE] = ACTIONS(1061),
    [anon_sym_PIPE_PIPE] = ACTIONS(1063),
    [anon_sym_SLASH] = ACTIONS(1061),
    [anon_sym_PERCENT] = ACTIONS(1061),
    [anon_sym_STAR_STAR] = ACTIONS(1063),
    [anon_sym_STAR_PERCENT] = ACTIONS(1061),
    [anon_sym_STAR_PIPE] = ACTIONS(1061),
    [anon_sym_align] = ACTIONS(1063),
    [anon_sym_DOT_STAR] = ACTIONS(1063),
    [anon_sym_DOT_QMARK] = ACTIONS(1063),
    [sym_line_comment] = ACTIONS(137),
  },
  [947] = {
    [anon_sym_COMMA] = ACTIONS(1205),
    [anon_sym_SEMI] = ACTIONS(1205),
    [anon_sym_BANG] = ACTIONS(1207),
    [anon_sym_COLON] = ACTIONS(1205),
    [anon_sym_EQ] = ACTIONS(1207),
    [anon_sym_else] = ACTIONS(1205),
    [anon_sym_or] = ACTIONS(1207),
    [anon_sym_and] = ACTIONS(1205),
    [anon_sym_LBRACE] = ACTIONS(1205),
    [anon_sym_RBRACE] = ACTIONS(1205),
    [anon_sym_DOT] = ACTIONS(1207),
    [anon_sym_LPAREN] = ACTIONS(1205),
    [anon_sym_RPAREN] = ACTIONS(1205),
    [anon_sym_LBRACK] = ACTIONS(1205),
    [anon_sym_RBRACK] = ACTIONS(1205),
    [anon_sym_linksection] = ACTIONS(1205),
    [anon_sym_addrspace] = ACTIONS(1205),
    [anon_sym_PIPE] = ACTIONS(1207),
    [anon_sym_STAR] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(1205),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym_STAR_EQ] = ACTIONS(1205),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1205),
    [anon_sym_SLASH_EQ] = ACTIONS(1205),
    [anon_sym_PERCENT_EQ] = ACTIONS(1205),
    [anon_sym_PLUS_EQ] = ACTIONS(1205),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1205),
    [anon_sym_DASH_EQ] = ACTIONS(1205),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1205),
    [anon_sym_LT_LT_EQ] = ACTIONS(1205),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1205),
    [anon_sym_GT_GT_EQ] = ACTIONS(1205),
    [anon_sym_AMP_EQ] = ACTIONS(1205),
    [anon_sym_CARET_EQ] = ACTIONS(1205),
    [anon_sym_PIPE_EQ] = ACTIONS(1205),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1205),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1205),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1205),
    [anon_sym_EQ_EQ] = ACTIONS(1205),
    [anon_sym_BANG_EQ] = ACTIONS(1205),
    [anon_sym_LT] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1207),
    [anon_sym_LT_EQ] = ACTIONS(1205),
    [anon_sym_GT_EQ] = ACTIONS(1205),
    [anon_sym_AMP] = ACTIONS(1207),
    [anon_sym_CARET] = ACTIONS(1207),
    [anon_sym_orelse] = ACTIONS(1205),
    [anon_sym_catch] = ACTIONS(1205),
    [anon_sym_LT_LT] = ACTIONS(1207),
    [anon_sym_GT_GT] = ACTIONS(1207),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(1207),
    [anon_sym_DASH] = ACTIONS(1207),
    [anon_sym_PLUS_PLUS] = ACTIONS(1205),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1207),
    [anon_sym_DASH_PERCENT] = ACTIONS(1207),
    [anon_sym_PLUS_PIPE] = ACTIONS(1207),
    [anon_sym_DASH_PIPE] = ACTIONS(1207),
    [anon_sym_PIPE_PIPE] = ACTIONS(1205),
    [anon_sym_SLASH] = ACTIONS(1207),
    [anon_sym_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_STAR] = ACTIONS(1205),
    [anon_sym_STAR_PERCENT] = ACTIONS(1207),
    [anon_sym_STAR_PIPE] = ACTIONS(1207),
    [anon_sym_align] = ACTIONS(1205),
    [anon_sym_DOT_STAR] = ACTIONS(1205),
    [anon_sym_DOT_QMARK] = ACTIONS(1205),
    [sym_line_comment] = ACTIONS(137),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1205),
  },
  [948] = {
    [anon_sym_COMMA] = ACTIONS(1301),
    [anon_sym_SEMI] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1303),
    [anon_sym_COLON] = ACTIONS(1301),
    [anon_sym_EQ] = ACTIONS(1303),
    [anon_sym_else] = ACTIONS(1301),
    [anon_sym_or] = ACTIONS(1303),
    [anon_sym_and] = ACTIONS(1301),
    [anon_sym_LBRACE] = ACTIONS(1301),
    [anon_sym_RBRACE] = ACTIONS(1301),
    [anon_sym_DOT] = ACTIONS(1303),
    [anon_sym_LPAREN] = ACTIONS(1301),
    [anon_sym_RPAREN] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1301),
    [anon_sym_RBRACK] = ACTIONS(1301),
    [anon_sym_linksection] = ACTIONS(1301),
    [anon_sym_addrspace] = ACTIONS(1301),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_EQ_GT] = ACTIONS(1301),
    [anon_sym_DOT_DOT] = ACTIONS(1301),
    [anon_sym_STAR_EQ] = ACTIONS(1301),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1301),
    [anon_sym_SLASH_EQ] = ACTIONS(1301),
    [anon_sym_PERCENT_EQ] = ACTIONS(1301),
    [anon_sym_PLUS_EQ] = ACTIONS(1301),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1301),
    [anon_sym_DASH_EQ] = ACTIONS(1301),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1301),
    [anon_sym_LT_LT_EQ] = ACTIONS(1301),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1301),
    [anon_sym_GT_GT_EQ] = ACTIONS(1301),
    [anon_sym_AMP_EQ] = ACTIONS(1301),
    [anon_sym_CARET_EQ] = ACTIONS(1301),
    [anon_sym_PIPE_EQ] = ACTIONS(1301),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1301),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1301),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1301),
    [anon_sym_EQ_EQ] = ACTIONS(1301),
    [anon_sym_BANG_EQ] = ACTIONS(1301),
    [anon_sym_LT] = ACTIONS(1303),
    [anon_sym_GT] = ACTIONS(1303),
    [anon_sym_LT_EQ] = ACTIONS(1301),
    [anon_sym_GT_EQ] = ACTIONS(1301),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_CARET] = ACTIONS(1303),
    [anon_sym_orelse] = ACTIONS(1301),
    [anon_sym_catch] = ACTIONS(1301),
    [anon_sym_LT_LT] = ACTIONS(1303),
    [anon_sym_GT_GT] = ACTIONS(1303),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1303),
    [anon_sym_PLUS] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1303),
    [anon_sym_PLUS_PLUS] = ACTIONS(1301),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1303),
    [anon_sym_DASH_PERCENT] = ACTIONS(1303),
    [anon_sym_PLUS_PIPE] = ACTIONS(1303),
    [anon_sym_DASH_PIPE] = ACTIONS(1303),
    [anon_sym_PIPE_PIPE] = ACTIONS(1301),
    [anon_sym_SLASH] = ACTIONS(1303),
    [anon_sym_PERCENT] = ACTIONS(1303),
    [anon_sym_STAR_STAR] = ACTIONS(1301),
    [anon_sym_STAR_PERCENT] = ACTIONS(1303),
    [anon_sym_STAR_PIPE] = ACTIONS(1303),
    [anon_sym_align] = ACTIONS(1301),
    [anon_sym_DOT_STAR] = ACTIONS(1301),
    [anon_sym_DOT_QMARK] = ACTIONS(1301),
    [sym_line_comment] = ACTIONS(137),
  },
  [949] = {
    [anon_sym_COMMA] = ACTIONS(574),
    [anon_sym_SEMI] = ACTIONS(574),
    [anon_sym_BANG] = ACTIONS(572),
    [anon_sym_COLON] = ACTIONS(574),
    [anon_sym_EQ] = ACTIONS(572),
    [anon_sym_else] = ACTIONS(574),
    [anon_sym_or] = ACTIONS(572),
    [anon_sym_and] = ACTIONS(574),
    [anon_sym_LBRACE] = ACTIONS(574),
    [anon_sym_RBRACE] = ACTIONS(574),
    [anon_sym_DOT] = ACTIONS(572),
    [anon_sym_LPAREN] = ACTIONS(574),
    [anon_sym_RPAREN] = ACTIONS(574),
    [anon_sym_LBRACK] = ACTIONS(574),
    [anon_sym_RBRACK] = ACTIONS(574),
    [anon_sym_linksection] = ACTIONS(574),
    [anon_sym_addrspace] = ACTIONS(574),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_STAR] = ACTIONS(572),
    [anon_sym_EQ_GT] = ACTIONS(574),
    [anon_sym_DOT_DOT] = ACTIONS(574),
    [anon_sym_STAR_EQ] = ACTIONS(574),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(574),
    [anon_sym_SLASH_EQ] = ACTIONS(574),
    [anon_sym_PERCENT_EQ] = ACTIONS(574),
    [anon_sym_PLUS_EQ] = ACTIONS(574),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(574),
    [anon_sym_DASH_EQ] = ACTIONS(574),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(574),
    [anon_sym_LT_LT_EQ] = ACTIONS(574),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(574),
    [anon_sym_GT_GT_EQ] = ACTIONS(574),
    [anon_sym_AMP_EQ] = ACTIONS(574),
    [anon_sym_CARET_EQ] = ACTIONS(574),
    [anon_sym_PIPE_EQ] = ACTIONS(574),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(574),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(574),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(574),
    [anon_sym_EQ_EQ] = ACTIONS(574),
    [anon_sym_BANG_EQ] = ACTIONS(574),
    [anon_sym_LT] = ACTIONS(572),
    [anon_sym_GT] = ACTIONS(572),
    [anon_sym_LT_EQ] = ACTIONS(574),
    [anon_sym_GT_EQ] = ACTIONS(574),
    [anon_sym_AMP] = ACTIONS(572),
    [anon_sym_CARET] = ACTIONS(572),
    [anon_sym_orelse] = ACTIONS(574),
    [anon_sym_catch] = ACTIONS(574),
    [anon_sym_LT_LT] = ACTIONS(572),
    [anon_sym_GT_GT] = ACTIONS(572),
    [anon_sym_LT_LT_PIPE] = ACTIONS(572),
    [anon_sym_PLUS] = ACTIONS(572),
    [anon_sym_DASH] = ACTIONS(572),
    [anon_sym_PLUS_PLUS] = ACTIONS(574),
    [anon_sym_PLUS_PERCENT] = ACTIONS(572),
    [anon_sym_DASH_PERCENT] = ACTIONS(572),
    [anon_sym_PLUS_PIPE] = ACTIONS(572),
    [anon_sym_DASH_PIPE] = ACTIONS(572),
    [anon_sym_PIPE_PIPE] = ACTIONS(574),
    [anon_sym_SLASH] = ACTIONS(572),
    [anon_sym_PERCENT] = ACTIONS(572),
    [anon_sym_STAR_STAR] = ACTIONS(574),
    [anon_sym_STAR_PERCENT] = ACTIONS(572),
    [anon_sym_STAR_PIPE] = ACTIONS(572),
    [anon_sym_align] = ACTIONS(574),
    [anon_sym_DOT_STAR] = ACTIONS(574),
    [anon_sym_DOT_QMARK] = ACTIONS(574),
    [sym_line_comment] = ACTIONS(137),
  },
  [950] = {
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_SEMI] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_COLON] = ACTIONS(1265),
    [anon_sym_EQ] = ACTIONS(1267),
    [anon_sym_else] = ACTIONS(1265),
    [anon_sym_or] = ACTIONS(1267),
    [anon_sym_and] = ACTIONS(1265),
    [anon_sym_LBRACE] = ACTIONS(1265),
    [anon_sym_RBRACE] = ACTIONS(1265),
    [anon_sym_DOT] = ACTIONS(1267),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [anon_sym_RPAREN] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1265),
    [anon_sym_RBRACK] = ACTIONS(1265),
    [anon_sym_linksection] = ACTIONS(1265),
    [anon_sym_addrspace] = ACTIONS(1265),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1267),
    [anon_sym_EQ_GT] = ACTIONS(1265),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym_STAR_EQ] = ACTIONS(1265),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1265),
    [anon_sym_SLASH_EQ] = ACTIONS(1265),
    [anon_sym_PERCENT_EQ] = ACTIONS(1265),
    [anon_sym_PLUS_EQ] = ACTIONS(1265),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1265),
    [anon_sym_DASH_EQ] = ACTIONS(1265),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1265),
    [anon_sym_LT_LT_EQ] = ACTIONS(1265),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1265),
    [anon_sym_GT_GT_EQ] = ACTIONS(1265),
    [anon_sym_AMP_EQ] = ACTIONS(1265),
    [anon_sym_CARET_EQ] = ACTIONS(1265),
    [anon_sym_PIPE_EQ] = ACTIONS(1265),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1265),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1265),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_LT_EQ] = ACTIONS(1265),
    [anon_sym_GT_EQ] = ACTIONS(1265),
    [anon_sym_AMP] = ACTIONS(1267),
    [anon_sym_CARET] = ACTIONS(1267),
    [anon_sym_orelse] = ACTIONS(1265),
    [anon_sym_catch] = ACTIONS(1265),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1267),
    [anon_sym_PLUS] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1267),
    [anon_sym_PLUS_PLUS] = ACTIONS(1265),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1267),
    [anon_sym_DASH_PERCENT] = ACTIONS(1267),
    [anon_sym_PLUS_PIPE] = ACTIONS(1267),
    [anon_sym_DASH_PIPE] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_SLASH] = ACTIONS(1267),
    [anon_sym_PERCENT] = ACTIONS(1267),
    [anon_sym_STAR_STAR] = ACTIONS(1265),
    [anon_sym_STAR_PERCENT] = ACTIONS(1267),
    [anon_sym_STAR_PIPE] = ACTIONS(1267),
    [anon_sym_align] = ACTIONS(1265),
    [anon_sym_DOT_STAR] = ACTIONS(1265),
    [anon_sym_DOT_QMARK] = ACTIONS(1265),
    [sym_line_comment] = ACTIONS(137),
  },
  [951] = {
    [anon_sym_COMMA] = ACTIONS(1365),
    [anon_sym_SEMI] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1367),
    [anon_sym_COLON] = ACTIONS(1365),
    [anon_sym_EQ] = ACTIONS(1367),
    [anon_sym_else] = ACTIONS(1365),
    [anon_sym_or] = ACTIONS(1367),
    [anon_sym_and] = ACTIONS(1365),
    [anon_sym_LBRACE] = ACTIONS(1365),
    [anon_sym_RBRACE] = ACTIONS(1365),
    [anon_sym_DOT] = ACTIONS(1367),
    [anon_sym_LPAREN] = ACTIONS(1365),
    [anon_sym_RPAREN] = ACTIONS(1365),
    [anon_sym_LBRACK] = ACTIONS(1365),
    [anon_sym_RBRACK] = ACTIONS(1365),
    [anon_sym_linksection] = ACTIONS(1365),
    [anon_sym_addrspace] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1367),
    [anon_sym_STAR] = ACTIONS(1367),
    [anon_sym_EQ_GT] = ACTIONS(1365),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_STAR_EQ] = ACTIONS(1365),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1365),
    [anon_sym_SLASH_EQ] = ACTIONS(1365),
    [anon_sym_PERCENT_EQ] = ACTIONS(1365),
    [anon_sym_PLUS_EQ] = ACTIONS(1365),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1365),
    [anon_sym_DASH_EQ] = ACTIONS(1365),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1365),
    [anon_sym_LT_LT_EQ] = ACTIONS(1365),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1365),
    [anon_sym_GT_GT_EQ] = ACTIONS(1365),
    [anon_sym_AMP_EQ] = ACTIONS(1365),
    [anon_sym_CARET_EQ] = ACTIONS(1365),
    [anon_sym_PIPE_EQ] = ACTIONS(1365),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1365),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1365),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1365),
    [anon_sym_EQ_EQ] = ACTIONS(1365),
    [anon_sym_BANG_EQ] = ACTIONS(1365),
    [anon_sym_LT] = ACTIONS(1367),
    [anon_sym_GT] = ACTIONS(1367),
    [anon_sym_LT_EQ] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1367),
    [anon_sym_CARET] = ACTIONS(1367),
    [anon_sym_orelse] = ACTIONS(1365),
    [anon_sym_catch] = ACTIONS(1365),
    [anon_sym_LT_LT] = ACTIONS(1367),
    [anon_sym_GT_GT] = ACTIONS(1367),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1367),
    [anon_sym_PLUS] = ACTIONS(1367),
    [anon_sym_DASH] = ACTIONS(1367),
    [anon_sym_PLUS_PLUS] = ACTIONS(1365),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1367),
    [anon_sym_DASH_PERCENT] = ACTIONS(1367),
    [anon_sym_PLUS_PIPE] = ACTIONS(1367),
    [anon_sym_DASH_PIPE] = ACTIONS(1367),
    [anon_sym_PIPE_PIPE] = ACTIONS(1365),
    [anon_sym_SLASH] = ACTIONS(1367),
    [anon_sym_PERCENT] = ACTIONS(1367),
    [anon_sym_STAR_STAR] = ACTIONS(1365),
    [anon_sym_STAR_PERCENT] = ACTIONS(1367),
    [anon_sym_STAR_PIPE] = ACTIONS(1367),
    [anon_sym_align] = ACTIONS(1365),
    [anon_sym_DOT_STAR] = ACTIONS(1365),
    [anon_sym_DOT_QMARK] = ACTIONS(1365),
    [sym_line_comment] = ACTIONS(137),
  },
  [952] = {
    [anon_sym_COMMA] = ACTIONS(1369),
    [anon_sym_SEMI] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1371),
    [anon_sym_COLON] = ACTIONS(1369),
    [anon_sym_EQ] = ACTIONS(1371),
    [anon_sym_else] = ACTIONS(1369),
    [anon_sym_or] = ACTIONS(1371),
    [anon_sym_and] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1369),
    [anon_sym_RBRACE] = ACTIONS(1369),
    [anon_sym_DOT] = ACTIONS(1371),
    [anon_sym_LPAREN] = ACTIONS(1369),
    [anon_sym_RPAREN] = ACTIONS(1369),
    [anon_sym_LBRACK] = ACTIONS(1369),
    [anon_sym_RBRACK] = ACTIONS(1369),
    [anon_sym_linksection] = ACTIONS(1369),
    [anon_sym_addrspace] = ACTIONS(1369),
    [anon_sym_PIPE] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(1371),
    [anon_sym_EQ_GT] = ACTIONS(1369),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym_STAR_EQ] = ACTIONS(1369),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1369),
    [anon_sym_SLASH_EQ] = ACTIONS(1369),
    [anon_sym_PERCENT_EQ] = ACTIONS(1369),
    [anon_sym_PLUS_EQ] = ACTIONS(1369),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1369),
    [anon_sym_DASH_EQ] = ACTIONS(1369),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1369),
    [anon_sym_LT_LT_EQ] = ACTIONS(1369),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1369),
    [anon_sym_GT_GT_EQ] = ACTIONS(1369),
    [anon_sym_AMP_EQ] = ACTIONS(1369),
    [anon_sym_CARET_EQ] = ACTIONS(1369),
    [anon_sym_PIPE_EQ] = ACTIONS(1369),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1369),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1369),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1369),
    [anon_sym_EQ_EQ] = ACTIONS(1369),
    [anon_sym_BANG_EQ] = ACTIONS(1369),
    [anon_sym_LT] = ACTIONS(1371),
    [anon_sym_GT] = ACTIONS(1371),
    [anon_sym_LT_EQ] = ACTIONS(1369),
    [anon_sym_GT_EQ] = ACTIONS(1369),
    [anon_sym_AMP] = ACTIONS(1371),
    [anon_sym_CARET] = ACTIONS(1371),
    [anon_sym_orelse] = ACTIONS(1369),
    [anon_sym_catch] = ACTIONS(1369),
    [anon_sym_LT_LT] = ACTIONS(1371),
    [anon_sym_GT_GT] = ACTIONS(1371),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1371),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_PLUS_PLUS] = ACTIONS(1369),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1371),
    [anon_sym_DASH_PERCENT] = ACTIONS(1371),
    [anon_sym_PLUS_PIPE] = ACTIONS(1371),
    [anon_sym_DASH_PIPE] = ACTIONS(1371),
    [anon_sym_PIPE_PIPE] = ACTIONS(1369),
    [anon_sym_SLASH] = ACTIONS(1371),
    [anon_sym_PERCENT] = ACTIONS(1371),
    [anon_sym_STAR_STAR] = ACTIONS(1369),
    [anon_sym_STAR_PERCENT] = ACTIONS(1371),
    [anon_sym_STAR_PIPE] = ACTIONS(1371),
    [anon_sym_align] = ACTIONS(1369),
    [anon_sym_DOT_STAR] = ACTIONS(1369),
    [anon_sym_DOT_QMARK] = ACTIONS(1369),
    [sym_line_comment] = ACTIONS(137),
  },
  [953] = {
    [anon_sym_COMMA] = ACTIONS(1373),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_BANG] = ACTIONS(1375),
    [anon_sym_COLON] = ACTIONS(1373),
    [anon_sym_EQ] = ACTIONS(1375),
    [anon_sym_else] = ACTIONS(1373),
    [anon_sym_or] = ACTIONS(1375),
    [anon_sym_and] = ACTIONS(1373),
    [anon_sym_LBRACE] = ACTIONS(1373),
    [anon_sym_RBRACE] = ACTIONS(1373),
    [anon_sym_DOT] = ACTIONS(1375),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_RPAREN] = ACTIONS(1373),
    [anon_sym_LBRACK] = ACTIONS(1373),
    [anon_sym_RBRACK] = ACTIONS(1373),
    [anon_sym_linksection] = ACTIONS(1373),
    [anon_sym_addrspace] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1375),
    [anon_sym_STAR] = ACTIONS(1375),
    [anon_sym_EQ_GT] = ACTIONS(1373),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_STAR_EQ] = ACTIONS(1373),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1373),
    [anon_sym_SLASH_EQ] = ACTIONS(1373),
    [anon_sym_PERCENT_EQ] = ACTIONS(1373),
    [anon_sym_PLUS_EQ] = ACTIONS(1373),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1373),
    [anon_sym_DASH_EQ] = ACTIONS(1373),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1373),
    [anon_sym_LT_LT_EQ] = ACTIONS(1373),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1373),
    [anon_sym_GT_GT_EQ] = ACTIONS(1373),
    [anon_sym_AMP_EQ] = ACTIONS(1373),
    [anon_sym_CARET_EQ] = ACTIONS(1373),
    [anon_sym_PIPE_EQ] = ACTIONS(1373),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1373),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1373),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1373),
    [anon_sym_EQ_EQ] = ACTIONS(1373),
    [anon_sym_BANG_EQ] = ACTIONS(1373),
    [anon_sym_LT] = ACTIONS(1375),
    [anon_sym_GT] = ACTIONS(1375),
    [anon_sym_LT_EQ] = ACTIONS(1373),
    [anon_sym_GT_EQ] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1375),
    [anon_sym_CARET] = ACTIONS(1375),
    [anon_sym_orelse] = ACTIONS(1373),
    [anon_sym_catch] = ACTIONS(1373),
    [anon_sym_LT_LT] = ACTIONS(1375),
    [anon_sym_GT_GT] = ACTIONS(1375),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1375),
    [anon_sym_PLUS] = ACTIONS(1375),
    [anon_sym_DASH] = ACTIONS(1375),
    [anon_sym_PLUS_PLUS] = ACTIONS(1373),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1375),
    [anon_sym_DASH_PERCENT] = ACTIONS(1375),
    [anon_sym_PLUS_PIPE] = ACTIONS(1375),
    [anon_sym_DASH_PIPE] = ACTIONS(1375),
    [anon_sym_PIPE_PIPE] = ACTIONS(1373),
    [anon_sym_SLASH] = ACTIONS(1375),
    [anon_sym_PERCENT] = ACTIONS(1375),
    [anon_sym_STAR_STAR] = ACTIONS(1373),
    [anon_sym_STAR_PERCENT] = ACTIONS(1375),
    [anon_sym_STAR_PIPE] = ACTIONS(1375),
    [anon_sym_align] = ACTIONS(1373),
    [anon_sym_DOT_STAR] = ACTIONS(1373),
    [anon_sym_DOT_QMARK] = ACTIONS(1373),
    [sym_line_comment] = ACTIONS(137),
  },
  [954] = {
    [anon_sym_COMMA] = ACTIONS(1261),
    [anon_sym_SEMI] = ACTIONS(1261),
    [anon_sym_BANG] = ACTIONS(1263),
    [anon_sym_COLON] = ACTIONS(1261),
    [anon_sym_EQ] = ACTIONS(1263),
    [anon_sym_else] = ACTIONS(1261),
    [anon_sym_or] = ACTIONS(1263),
    [anon_sym_and] = ACTIONS(1261),
    [anon_sym_LBRACE] = ACTIONS(1261),
    [anon_sym_RBRACE] = ACTIONS(1261),
    [anon_sym_DOT] = ACTIONS(1263),
    [anon_sym_LPAREN] = ACTIONS(1261),
    [anon_sym_RPAREN] = ACTIONS(1261),
    [anon_sym_LBRACK] = ACTIONS(1261),
    [anon_sym_RBRACK] = ACTIONS(1261),
    [anon_sym_linksection] = ACTIONS(1261),
    [anon_sym_addrspace] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1263),
    [anon_sym_EQ_GT] = ACTIONS(1261),
    [anon_sym_DOT_DOT] = ACTIONS(1261),
    [anon_sym_STAR_EQ] = ACTIONS(1261),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1261),
    [anon_sym_SLASH_EQ] = ACTIONS(1261),
    [anon_sym_PERCENT_EQ] = ACTIONS(1261),
    [anon_sym_PLUS_EQ] = ACTIONS(1261),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1261),
    [anon_sym_DASH_EQ] = ACTIONS(1261),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1261),
    [anon_sym_LT_LT_EQ] = ACTIONS(1261),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1261),
    [anon_sym_GT_GT_EQ] = ACTIONS(1261),
    [anon_sym_AMP_EQ] = ACTIONS(1261),
    [anon_sym_CARET_EQ] = ACTIONS(1261),
    [anon_sym_PIPE_EQ] = ACTIONS(1261),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1261),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1261),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1261),
    [anon_sym_EQ_EQ] = ACTIONS(1261),
    [anon_sym_BANG_EQ] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_LT_EQ] = ACTIONS(1261),
    [anon_sym_GT_EQ] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1263),
    [anon_sym_CARET] = ACTIONS(1263),
    [anon_sym_orelse] = ACTIONS(1261),
    [anon_sym_catch] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1263),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1263),
    [anon_sym_DASH_PERCENT] = ACTIONS(1263),
    [anon_sym_PLUS_PIPE] = ACTIONS(1263),
    [anon_sym_DASH_PIPE] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [anon_sym_SLASH] = ACTIONS(1263),
    [anon_sym_PERCENT] = ACTIONS(1263),
    [anon_sym_STAR_STAR] = ACTIONS(1261),
    [anon_sym_STAR_PERCENT] = ACTIONS(1263),
    [anon_sym_STAR_PIPE] = ACTIONS(1263),
    [anon_sym_align] = ACTIONS(1261),
    [anon_sym_DOT_STAR] = ACTIONS(1261),
    [anon_sym_DOT_QMARK] = ACTIONS(1261),
    [sym_line_comment] = ACTIONS(137),
  },
  [955] = {
    [anon_sym_COMMA] = ACTIONS(1377),
    [anon_sym_SEMI] = ACTIONS(1377),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_COLON] = ACTIONS(1377),
    [anon_sym_EQ] = ACTIONS(1379),
    [anon_sym_else] = ACTIONS(1377),
    [anon_sym_or] = ACTIONS(1379),
    [anon_sym_and] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(1377),
    [anon_sym_RBRACE] = ACTIONS(1377),
    [anon_sym_DOT] = ACTIONS(1379),
    [anon_sym_LPAREN] = ACTIONS(1377),
    [anon_sym_RPAREN] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(1377),
    [anon_sym_RBRACK] = ACTIONS(1377),
    [anon_sym_linksection] = ACTIONS(1377),
    [anon_sym_addrspace] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(1379),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_EQ_GT] = ACTIONS(1377),
    [anon_sym_DOT_DOT] = ACTIONS(1377),
    [anon_sym_STAR_EQ] = ACTIONS(1377),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1377),
    [anon_sym_SLASH_EQ] = ACTIONS(1377),
    [anon_sym_PERCENT_EQ] = ACTIONS(1377),
    [anon_sym_PLUS_EQ] = ACTIONS(1377),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1377),
    [anon_sym_DASH_EQ] = ACTIONS(1377),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1377),
    [anon_sym_LT_LT_EQ] = ACTIONS(1377),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1377),
    [anon_sym_GT_GT_EQ] = ACTIONS(1377),
    [anon_sym_AMP_EQ] = ACTIONS(1377),
    [anon_sym_CARET_EQ] = ACTIONS(1377),
    [anon_sym_PIPE_EQ] = ACTIONS(1377),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1377),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1377),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1377),
    [anon_sym_EQ_EQ] = ACTIONS(1377),
    [anon_sym_BANG_EQ] = ACTIONS(1377),
    [anon_sym_LT] = ACTIONS(1379),
    [anon_sym_GT] = ACTIONS(1379),
    [anon_sym_LT_EQ] = ACTIONS(1377),
    [anon_sym_GT_EQ] = ACTIONS(1377),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_orelse] = ACTIONS(1377),
    [anon_sym_catch] = ACTIONS(1377),
    [anon_sym_LT_LT] = ACTIONS(1379),
    [anon_sym_GT_GT] = ACTIONS(1379),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1379),
    [anon_sym_DASH_PERCENT] = ACTIONS(1379),
    [anon_sym_PLUS_PIPE] = ACTIONS(1379),
    [anon_sym_DASH_PIPE] = ACTIONS(1379),
    [anon_sym_PIPE_PIPE] = ACTIONS(1377),
    [anon_sym_SLASH] = ACTIONS(1379),
    [anon_sym_PERCENT] = ACTIONS(1379),
    [anon_sym_STAR_STAR] = ACTIONS(1377),
    [anon_sym_STAR_PERCENT] = ACTIONS(1379),
    [anon_sym_STAR_PIPE] = ACTIONS(1379),
    [anon_sym_align] = ACTIONS(1377),
    [anon_sym_DOT_STAR] = ACTIONS(1377),
    [anon_sym_DOT_QMARK] = ACTIONS(1377),
    [sym_line_comment] = ACTIONS(137),
  },
  [956] = {
    [anon_sym_COMMA] = ACTIONS(560),
    [anon_sym_SEMI] = ACTIONS(560),
    [anon_sym_BANG] = ACTIONS(562),
    [anon_sym_COLON] = ACTIONS(560),
    [anon_sym_EQ] = ACTIONS(562),
    [anon_sym_else] = ACTIONS(560),
    [anon_sym_or] = ACTIONS(562),
    [anon_sym_and] = ACTIONS(560),
    [anon_sym_LBRACE] = ACTIONS(560),
    [anon_sym_RBRACE] = ACTIONS(560),
    [anon_sym_DOT] = ACTIONS(562),
    [anon_sym_LPAREN] = ACTIONS(560),
    [anon_sym_RPAREN] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_RBRACK] = ACTIONS(560),
    [anon_sym_linksection] = ACTIONS(560),
    [anon_sym_addrspace] = ACTIONS(560),
    [anon_sym_PIPE] = ACTIONS(562),
    [anon_sym_STAR] = ACTIONS(562),
    [anon_sym_EQ_GT] = ACTIONS(560),
    [anon_sym_DOT_DOT] = ACTIONS(560),
    [anon_sym_STAR_EQ] = ACTIONS(560),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(560),
    [anon_sym_SLASH_EQ] = ACTIONS(560),
    [anon_sym_PERCENT_EQ] = ACTIONS(560),
    [anon_sym_PLUS_EQ] = ACTIONS(560),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(560),
    [anon_sym_DASH_EQ] = ACTIONS(560),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(560),
    [anon_sym_LT_LT_EQ] = ACTIONS(560),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(560),
    [anon_sym_GT_GT_EQ] = ACTIONS(560),
    [anon_sym_AMP_EQ] = ACTIONS(560),
    [anon_sym_CARET_EQ] = ACTIONS(560),
    [anon_sym_PIPE_EQ] = ACTIONS(560),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(560),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(560),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(560),
    [anon_sym_EQ_EQ] = ACTIONS(560),
    [anon_sym_BANG_EQ] = ACTIONS(560),
    [anon_sym_LT] = ACTIONS(562),
    [anon_sym_GT] = ACTIONS(562),
    [anon_sym_LT_EQ] = ACTIONS(560),
    [anon_sym_GT_EQ] = ACTIONS(560),
    [anon_sym_AMP] = ACTIONS(562),
    [anon_sym_CARET] = ACTIONS(562),
    [anon_sym_orelse] = ACTIONS(560),
    [anon_sym_catch] = ACTIONS(560),
    [anon_sym_LT_LT] = ACTIONS(562),
    [anon_sym_GT_GT] = ACTIONS(562),
    [anon_sym_LT_LT_PIPE] = ACTIONS(562),
    [anon_sym_PLUS] = ACTIONS(562),
    [anon_sym_DASH] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(560),
    [anon_sym_PLUS_PERCENT] = ACTIONS(562),
    [anon_sym_DASH_PERCENT] = ACTIONS(562),
    [anon_sym_PLUS_PIPE] = ACTIONS(562),
    [anon_sym_DASH_PIPE] = ACTIONS(562),
    [anon_sym_PIPE_PIPE] = ACTIONS(560),
    [anon_sym_SLASH] = ACTIONS(562),
    [anon_sym_PERCENT] = ACTIONS(562),
    [anon_sym_STAR_STAR] = ACTIONS(560),
    [anon_sym_STAR_PERCENT] = ACTIONS(562),
    [anon_sym_STAR_PIPE] = ACTIONS(562),
    [anon_sym_align] = ACTIONS(560),
    [anon_sym_DOT_STAR] = ACTIONS(560),
    [anon_sym_DOT_QMARK] = ACTIONS(560),
    [sym_line_comment] = ACTIONS(137),
  },
  [957] = {
    [anon_sym_COMMA] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(1257),
    [anon_sym_BANG] = ACTIONS(1259),
    [anon_sym_COLON] = ACTIONS(1257),
    [anon_sym_EQ] = ACTIONS(1259),
    [anon_sym_else] = ACTIONS(1257),
    [anon_sym_or] = ACTIONS(1259),
    [anon_sym_and] = ACTIONS(1257),
    [anon_sym_LBRACE] = ACTIONS(1257),
    [anon_sym_RBRACE] = ACTIONS(1257),
    [anon_sym_DOT] = ACTIONS(1259),
    [anon_sym_LPAREN] = ACTIONS(1257),
    [anon_sym_RPAREN] = ACTIONS(1257),
    [anon_sym_LBRACK] = ACTIONS(1257),
    [anon_sym_RBRACK] = ACTIONS(1257),
    [anon_sym_linksection] = ACTIONS(1257),
    [anon_sym_addrspace] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1259),
    [anon_sym_STAR] = ACTIONS(1259),
    [anon_sym_EQ_GT] = ACTIONS(1257),
    [anon_sym_DOT_DOT] = ACTIONS(1257),
    [anon_sym_STAR_EQ] = ACTIONS(1257),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1257),
    [anon_sym_SLASH_EQ] = ACTIONS(1257),
    [anon_sym_PERCENT_EQ] = ACTIONS(1257),
    [anon_sym_PLUS_EQ] = ACTIONS(1257),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1257),
    [anon_sym_DASH_EQ] = ACTIONS(1257),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1257),
    [anon_sym_LT_LT_EQ] = ACTIONS(1257),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1257),
    [anon_sym_GT_GT_EQ] = ACTIONS(1257),
    [anon_sym_AMP_EQ] = ACTIONS(1257),
    [anon_sym_CARET_EQ] = ACTIONS(1257),
    [anon_sym_PIPE_EQ] = ACTIONS(1257),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1257),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1257),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1257),
    [anon_sym_EQ_EQ] = ACTIONS(1257),
    [anon_sym_BANG_EQ] = ACTIONS(1257),
    [anon_sym_LT] = ACTIONS(1259),
    [anon_sym_GT] = ACTIONS(1259),
    [anon_sym_LT_EQ] = ACTIONS(1257),
    [anon_sym_GT_EQ] = ACTIONS(1257),
    [anon_sym_AMP] = ACTIONS(1259),
    [anon_sym_CARET] = ACTIONS(1259),
    [anon_sym_orelse] = ACTIONS(1257),
    [anon_sym_catch] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(1259),
    [anon_sym_GT_GT] = ACTIONS(1259),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS_PLUS] = ACTIONS(1257),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1259),
    [anon_sym_DASH_PERCENT] = ACTIONS(1259),
    [anon_sym_PLUS_PIPE] = ACTIONS(1259),
    [anon_sym_DASH_PIPE] = ACTIONS(1259),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_SLASH] = ACTIONS(1259),
    [anon_sym_PERCENT] = ACTIONS(1259),
    [anon_sym_STAR_STAR] = ACTIONS(1257),
    [anon_sym_STAR_PERCENT] = ACTIONS(1259),
    [anon_sym_STAR_PIPE] = ACTIONS(1259),
    [anon_sym_align] = ACTIONS(1257),
    [anon_sym_DOT_STAR] = ACTIONS(1257),
    [anon_sym_DOT_QMARK] = ACTIONS(1257),
    [sym_line_comment] = ACTIONS(137),
  },
  [958] = {
    [anon_sym_COMMA] = ACTIONS(1253),
    [anon_sym_SEMI] = ACTIONS(1253),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_COLON] = ACTIONS(1253),
    [anon_sym_EQ] = ACTIONS(1255),
    [anon_sym_else] = ACTIONS(1253),
    [anon_sym_or] = ACTIONS(1255),
    [anon_sym_and] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(1253),
    [anon_sym_RBRACE] = ACTIONS(1253),
    [anon_sym_DOT] = ACTIONS(1255),
    [anon_sym_LPAREN] = ACTIONS(1253),
    [anon_sym_RPAREN] = ACTIONS(1253),
    [anon_sym_LBRACK] = ACTIONS(1253),
    [anon_sym_RBRACK] = ACTIONS(1253),
    [anon_sym_linksection] = ACTIONS(1253),
    [anon_sym_addrspace] = ACTIONS(1253),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_EQ_GT] = ACTIONS(1253),
    [anon_sym_DOT_DOT] = ACTIONS(1253),
    [anon_sym_STAR_EQ] = ACTIONS(1253),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1253),
    [anon_sym_SLASH_EQ] = ACTIONS(1253),
    [anon_sym_PERCENT_EQ] = ACTIONS(1253),
    [anon_sym_PLUS_EQ] = ACTIONS(1253),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1253),
    [anon_sym_DASH_EQ] = ACTIONS(1253),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1253),
    [anon_sym_LT_LT_EQ] = ACTIONS(1253),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1253),
    [anon_sym_GT_GT_EQ] = ACTIONS(1253),
    [anon_sym_AMP_EQ] = ACTIONS(1253),
    [anon_sym_CARET_EQ] = ACTIONS(1253),
    [anon_sym_PIPE_EQ] = ACTIONS(1253),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1253),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1253),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1253),
    [anon_sym_EQ_EQ] = ACTIONS(1253),
    [anon_sym_BANG_EQ] = ACTIONS(1253),
    [anon_sym_LT] = ACTIONS(1255),
    [anon_sym_GT] = ACTIONS(1255),
    [anon_sym_LT_EQ] = ACTIONS(1253),
    [anon_sym_GT_EQ] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_orelse] = ACTIONS(1253),
    [anon_sym_catch] = ACTIONS(1253),
    [anon_sym_LT_LT] = ACTIONS(1255),
    [anon_sym_GT_GT] = ACTIONS(1255),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1255),
    [anon_sym_DASH] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1253),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1255),
    [anon_sym_DASH_PERCENT] = ACTIONS(1255),
    [anon_sym_PLUS_PIPE] = ACTIONS(1255),
    [anon_sym_DASH_PIPE] = ACTIONS(1255),
    [anon_sym_PIPE_PIPE] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(1255),
    [anon_sym_PERCENT] = ACTIONS(1255),
    [anon_sym_STAR_STAR] = ACTIONS(1253),
    [anon_sym_STAR_PERCENT] = ACTIONS(1255),
    [anon_sym_STAR_PIPE] = ACTIONS(1255),
    [anon_sym_align] = ACTIONS(1253),
    [anon_sym_DOT_STAR] = ACTIONS(1253),
    [anon_sym_DOT_QMARK] = ACTIONS(1253),
    [sym_line_comment] = ACTIONS(137),
  },
  [959] = {
    [anon_sym_COMMA] = ACTIONS(1381),
    [anon_sym_SEMI] = ACTIONS(1381),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_COLON] = ACTIONS(1381),
    [anon_sym_EQ] = ACTIONS(1383),
    [anon_sym_else] = ACTIONS(1381),
    [anon_sym_or] = ACTIONS(1383),
    [anon_sym_and] = ACTIONS(1381),
    [anon_sym_LBRACE] = ACTIONS(1381),
    [anon_sym_RBRACE] = ACTIONS(1381),
    [anon_sym_DOT] = ACTIONS(1383),
    [anon_sym_LPAREN] = ACTIONS(1381),
    [anon_sym_RPAREN] = ACTIONS(1381),
    [anon_sym_LBRACK] = ACTIONS(1381),
    [anon_sym_RBRACK] = ACTIONS(1381),
    [anon_sym_linksection] = ACTIONS(1381),
    [anon_sym_addrspace] = ACTIONS(1381),
    [anon_sym_PIPE] = ACTIONS(1383),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_EQ_GT] = ACTIONS(1381),
    [anon_sym_DOT_DOT] = ACTIONS(1381),
    [anon_sym_STAR_EQ] = ACTIONS(1381),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1381),
    [anon_sym_SLASH_EQ] = ACTIONS(1381),
    [anon_sym_PERCENT_EQ] = ACTIONS(1381),
    [anon_sym_PLUS_EQ] = ACTIONS(1381),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1381),
    [anon_sym_DASH_EQ] = ACTIONS(1381),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1381),
    [anon_sym_LT_LT_EQ] = ACTIONS(1381),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1381),
    [anon_sym_GT_GT_EQ] = ACTIONS(1381),
    [anon_sym_AMP_EQ] = ACTIONS(1381),
    [anon_sym_CARET_EQ] = ACTIONS(1381),
    [anon_sym_PIPE_EQ] = ACTIONS(1381),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1381),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1381),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1381),
    [anon_sym_EQ_EQ] = ACTIONS(1381),
    [anon_sym_BANG_EQ] = ACTIONS(1381),
    [anon_sym_LT] = ACTIONS(1383),
    [anon_sym_GT] = ACTIONS(1383),
    [anon_sym_LT_EQ] = ACTIONS(1381),
    [anon_sym_GT_EQ] = ACTIONS(1381),
    [anon_sym_AMP] = ACTIONS(1383),
    [anon_sym_CARET] = ACTIONS(1383),
    [anon_sym_orelse] = ACTIONS(1381),
    [anon_sym_catch] = ACTIONS(1381),
    [anon_sym_LT_LT] = ACTIONS(1383),
    [anon_sym_GT_GT] = ACTIONS(1383),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1383),
    [anon_sym_DASH] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1381),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1383),
    [anon_sym_DASH_PERCENT] = ACTIONS(1383),
    [anon_sym_PLUS_PIPE] = ACTIONS(1383),
    [anon_sym_DASH_PIPE] = ACTIONS(1383),
    [anon_sym_PIPE_PIPE] = ACTIONS(1381),
    [anon_sym_SLASH] = ACTIONS(1383),
    [anon_sym_PERCENT] = ACTIONS(1383),
    [anon_sym_STAR_STAR] = ACTIONS(1381),
    [anon_sym_STAR_PERCENT] = ACTIONS(1383),
    [anon_sym_STAR_PIPE] = ACTIONS(1383),
    [anon_sym_align] = ACTIONS(1381),
    [anon_sym_DOT_STAR] = ACTIONS(1381),
    [anon_sym_DOT_QMARK] = ACTIONS(1381),
    [sym_line_comment] = ACTIONS(137),
  },
  [960] = {
    [anon_sym_COMMA] = ACTIONS(1345),
    [anon_sym_SEMI] = ACTIONS(1345),
    [anon_sym_BANG] = ACTIONS(1347),
    [anon_sym_COLON] = ACTIONS(1345),
    [anon_sym_EQ] = ACTIONS(1347),
    [anon_sym_else] = ACTIONS(1345),
    [anon_sym_or] = ACTIONS(1347),
    [anon_sym_and] = ACTIONS(1345),
    [anon_sym_LBRACE] = ACTIONS(1345),
    [anon_sym_RBRACE] = ACTIONS(1345),
    [anon_sym_DOT] = ACTIONS(1347),
    [anon_sym_LPAREN] = ACTIONS(1345),
    [anon_sym_RPAREN] = ACTIONS(1345),
    [anon_sym_LBRACK] = ACTIONS(1345),
    [anon_sym_RBRACK] = ACTIONS(1345),
    [anon_sym_linksection] = ACTIONS(1345),
    [anon_sym_addrspace] = ACTIONS(1345),
    [anon_sym_PIPE] = ACTIONS(1347),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_EQ_GT] = ACTIONS(1345),
    [anon_sym_DOT_DOT] = ACTIONS(1345),
    [anon_sym_STAR_EQ] = ACTIONS(1345),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1345),
    [anon_sym_SLASH_EQ] = ACTIONS(1345),
    [anon_sym_PERCENT_EQ] = ACTIONS(1345),
    [anon_sym_PLUS_EQ] = ACTIONS(1345),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1345),
    [anon_sym_DASH_EQ] = ACTIONS(1345),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1345),
    [anon_sym_LT_LT_EQ] = ACTIONS(1345),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1345),
    [anon_sym_GT_GT_EQ] = ACTIONS(1345),
    [anon_sym_AMP_EQ] = ACTIONS(1345),
    [anon_sym_CARET_EQ] = ACTIONS(1345),
    [anon_sym_PIPE_EQ] = ACTIONS(1345),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1345),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1345),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1345),
    [anon_sym_EQ_EQ] = ACTIONS(1345),
    [anon_sym_BANG_EQ] = ACTIONS(1345),
    [anon_sym_LT] = ACTIONS(1347),
    [anon_sym_GT] = ACTIONS(1347),
    [anon_sym_LT_EQ] = ACTIONS(1345),
    [anon_sym_GT_EQ] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(1347),
    [anon_sym_CARET] = ACTIONS(1347),
    [anon_sym_orelse] = ACTIONS(1345),
    [anon_sym_catch] = ACTIONS(1345),
    [anon_sym_LT_LT] = ACTIONS(1347),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1347),
    [anon_sym_PLUS] = ACTIONS(1347),
    [anon_sym_DASH] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(1345),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1347),
    [anon_sym_DASH_PERCENT] = ACTIONS(1347),
    [anon_sym_PLUS_PIPE] = ACTIONS(1347),
    [anon_sym_DASH_PIPE] = ACTIONS(1347),
    [anon_sym_PIPE_PIPE] = ACTIONS(1345),
    [anon_sym_SLASH] = ACTIONS(1347),
    [anon_sym_PERCENT] = ACTIONS(1347),
    [anon_sym_STAR_STAR] = ACTIONS(1345),
    [anon_sym_STAR_PERCENT] = ACTIONS(1347),
    [anon_sym_STAR_PIPE] = ACTIONS(1347),
    [anon_sym_align] = ACTIONS(1345),
    [anon_sym_DOT_STAR] = ACTIONS(1345),
    [anon_sym_DOT_QMARK] = ACTIONS(1345),
    [sym_line_comment] = ACTIONS(137),
  },
  [961] = {
    [anon_sym_COMMA] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1385),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_COLON] = ACTIONS(1385),
    [anon_sym_EQ] = ACTIONS(1387),
    [anon_sym_else] = ACTIONS(1385),
    [anon_sym_or] = ACTIONS(1387),
    [anon_sym_and] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(1385),
    [anon_sym_RBRACE] = ACTIONS(1385),
    [anon_sym_DOT] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1385),
    [anon_sym_RPAREN] = ACTIONS(1385),
    [anon_sym_LBRACK] = ACTIONS(1385),
    [anon_sym_RBRACK] = ACTIONS(1385),
    [anon_sym_linksection] = ACTIONS(1385),
    [anon_sym_addrspace] = ACTIONS(1385),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_EQ_GT] = ACTIONS(1385),
    [anon_sym_DOT_DOT] = ACTIONS(1385),
    [anon_sym_STAR_EQ] = ACTIONS(1385),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1385),
    [anon_sym_SLASH_EQ] = ACTIONS(1385),
    [anon_sym_PERCENT_EQ] = ACTIONS(1385),
    [anon_sym_PLUS_EQ] = ACTIONS(1385),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1385),
    [anon_sym_DASH_EQ] = ACTIONS(1385),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1385),
    [anon_sym_LT_LT_EQ] = ACTIONS(1385),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1385),
    [anon_sym_GT_GT_EQ] = ACTIONS(1385),
    [anon_sym_AMP_EQ] = ACTIONS(1385),
    [anon_sym_CARET_EQ] = ACTIONS(1385),
    [anon_sym_PIPE_EQ] = ACTIONS(1385),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1385),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1385),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1385),
    [anon_sym_EQ_EQ] = ACTIONS(1385),
    [anon_sym_BANG_EQ] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_GT] = ACTIONS(1387),
    [anon_sym_LT_EQ] = ACTIONS(1385),
    [anon_sym_GT_EQ] = ACTIONS(1385),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_CARET] = ACTIONS(1387),
    [anon_sym_orelse] = ACTIONS(1385),
    [anon_sym_catch] = ACTIONS(1385),
    [anon_sym_LT_LT] = ACTIONS(1387),
    [anon_sym_GT_GT] = ACTIONS(1387),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1387),
    [anon_sym_PLUS] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1385),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1387),
    [anon_sym_DASH_PERCENT] = ACTIONS(1387),
    [anon_sym_PLUS_PIPE] = ACTIONS(1387),
    [anon_sym_DASH_PIPE] = ACTIONS(1387),
    [anon_sym_PIPE_PIPE] = ACTIONS(1385),
    [anon_sym_SLASH] = ACTIONS(1387),
    [anon_sym_PERCENT] = ACTIONS(1387),
    [anon_sym_STAR_STAR] = ACTIONS(1385),
    [anon_sym_STAR_PERCENT] = ACTIONS(1387),
    [anon_sym_STAR_PIPE] = ACTIONS(1387),
    [anon_sym_align] = ACTIONS(1385),
    [anon_sym_DOT_STAR] = ACTIONS(1385),
    [anon_sym_DOT_QMARK] = ACTIONS(1385),
    [sym_line_comment] = ACTIONS(137),
  },
  [962] = {
    [anon_sym_COMMA] = ACTIONS(1249),
    [anon_sym_SEMI] = ACTIONS(1249),
    [anon_sym_BANG] = ACTIONS(1251),
    [anon_sym_COLON] = ACTIONS(1249),
    [anon_sym_EQ] = ACTIONS(1251),
    [anon_sym_else] = ACTIONS(1249),
    [anon_sym_or] = ACTIONS(1251),
    [anon_sym_and] = ACTIONS(1249),
    [anon_sym_LBRACE] = ACTIONS(1249),
    [anon_sym_RBRACE] = ACTIONS(1249),
    [anon_sym_DOT] = ACTIONS(1251),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_RPAREN] = ACTIONS(1249),
    [anon_sym_LBRACK] = ACTIONS(1249),
    [anon_sym_RBRACK] = ACTIONS(1249),
    [anon_sym_linksection] = ACTIONS(1249),
    [anon_sym_addrspace] = ACTIONS(1249),
    [anon_sym_PIPE] = ACTIONS(1251),
    [anon_sym_STAR] = ACTIONS(1251),
    [anon_sym_EQ_GT] = ACTIONS(1249),
    [anon_sym_DOT_DOT] = ACTIONS(1249),
    [anon_sym_STAR_EQ] = ACTIONS(1249),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1249),
    [anon_sym_SLASH_EQ] = ACTIONS(1249),
    [anon_sym_PERCENT_EQ] = ACTIONS(1249),
    [anon_sym_PLUS_EQ] = ACTIONS(1249),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1249),
    [anon_sym_DASH_EQ] = ACTIONS(1249),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1249),
    [anon_sym_LT_LT_EQ] = ACTIONS(1249),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1249),
    [anon_sym_GT_GT_EQ] = ACTIONS(1249),
    [anon_sym_AMP_EQ] = ACTIONS(1249),
    [anon_sym_CARET_EQ] = ACTIONS(1249),
    [anon_sym_PIPE_EQ] = ACTIONS(1249),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1249),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1249),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1249),
    [anon_sym_EQ_EQ] = ACTIONS(1249),
    [anon_sym_BANG_EQ] = ACTIONS(1249),
    [anon_sym_LT] = ACTIONS(1251),
    [anon_sym_GT] = ACTIONS(1251),
    [anon_sym_LT_EQ] = ACTIONS(1249),
    [anon_sym_GT_EQ] = ACTIONS(1249),
    [anon_sym_AMP] = ACTIONS(1251),
    [anon_sym_CARET] = ACTIONS(1251),
    [anon_sym_orelse] = ACTIONS(1249),
    [anon_sym_catch] = ACTIONS(1249),
    [anon_sym_LT_LT] = ACTIONS(1251),
    [anon_sym_GT_GT] = ACTIONS(1251),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1251),
    [anon_sym_PLUS] = ACTIONS(1251),
    [anon_sym_DASH] = ACTIONS(1251),
    [anon_sym_PLUS_PLUS] = ACTIONS(1249),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1251),
    [anon_sym_DASH_PERCENT] = ACTIONS(1251),
    [anon_sym_PLUS_PIPE] = ACTIONS(1251),
    [anon_sym_DASH_PIPE] = ACTIONS(1251),
    [anon_sym_PIPE_PIPE] = ACTIONS(1249),
    [anon_sym_SLASH] = ACTIONS(1251),
    [anon_sym_PERCENT] = ACTIONS(1251),
    [anon_sym_STAR_STAR] = ACTIONS(1249),
    [anon_sym_STAR_PERCENT] = ACTIONS(1251),
    [anon_sym_STAR_PIPE] = ACTIONS(1251),
    [anon_sym_align] = ACTIONS(1249),
    [anon_sym_DOT_STAR] = ACTIONS(1249),
    [anon_sym_DOT_QMARK] = ACTIONS(1249),
    [sym_line_comment] = ACTIONS(137),
  },
  [963] = {
    [anon_sym_COMMA] = ACTIONS(1389),
    [anon_sym_SEMI] = ACTIONS(1389),
    [anon_sym_BANG] = ACTIONS(1391),
    [anon_sym_COLON] = ACTIONS(1389),
    [anon_sym_EQ] = ACTIONS(1391),
    [anon_sym_else] = ACTIONS(1389),
    [anon_sym_or] = ACTIONS(1391),
    [anon_sym_and] = ACTIONS(1389),
    [anon_sym_LBRACE] = ACTIONS(1389),
    [anon_sym_RBRACE] = ACTIONS(1389),
    [anon_sym_DOT] = ACTIONS(1391),
    [anon_sym_LPAREN] = ACTIONS(1389),
    [anon_sym_RPAREN] = ACTIONS(1389),
    [anon_sym_LBRACK] = ACTIONS(1389),
    [anon_sym_RBRACK] = ACTIONS(1389),
    [anon_sym_linksection] = ACTIONS(1389),
    [anon_sym_addrspace] = ACTIONS(1389),
    [anon_sym_PIPE] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_EQ_GT] = ACTIONS(1389),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym_STAR_EQ] = ACTIONS(1389),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1389),
    [anon_sym_SLASH_EQ] = ACTIONS(1389),
    [anon_sym_PERCENT_EQ] = ACTIONS(1389),
    [anon_sym_PLUS_EQ] = ACTIONS(1389),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1389),
    [anon_sym_DASH_EQ] = ACTIONS(1389),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1389),
    [anon_sym_LT_LT_EQ] = ACTIONS(1389),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1389),
    [anon_sym_GT_GT_EQ] = ACTIONS(1389),
    [anon_sym_AMP_EQ] = ACTIONS(1389),
    [anon_sym_CARET_EQ] = ACTIONS(1389),
    [anon_sym_PIPE_EQ] = ACTIONS(1389),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1389),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1389),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1389),
    [anon_sym_EQ_EQ] = ACTIONS(1389),
    [anon_sym_BANG_EQ] = ACTIONS(1389),
    [anon_sym_LT] = ACTIONS(1391),
    [anon_sym_GT] = ACTIONS(1391),
    [anon_sym_LT_EQ] = ACTIONS(1389),
    [anon_sym_GT_EQ] = ACTIONS(1389),
    [anon_sym_AMP] = ACTIONS(1391),
    [anon_sym_CARET] = ACTIONS(1391),
    [anon_sym_orelse] = ACTIONS(1389),
    [anon_sym_catch] = ACTIONS(1389),
    [anon_sym_LT_LT] = ACTIONS(1391),
    [anon_sym_GT_GT] = ACTIONS(1391),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1391),
    [anon_sym_PLUS] = ACTIONS(1391),
    [anon_sym_DASH] = ACTIONS(1391),
    [anon_sym_PLUS_PLUS] = ACTIONS(1389),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1391),
    [anon_sym_DASH_PERCENT] = ACTIONS(1391),
    [anon_sym_PLUS_PIPE] = ACTIONS(1391),
    [anon_sym_DASH_PIPE] = ACTIONS(1391),
    [anon_sym_PIPE_PIPE] = ACTIONS(1389),
    [anon_sym_SLASH] = ACTIONS(1391),
    [anon_sym_PERCENT] = ACTIONS(1391),
    [anon_sym_STAR_STAR] = ACTIONS(1389),
    [anon_sym_STAR_PERCENT] = ACTIONS(1391),
    [anon_sym_STAR_PIPE] = ACTIONS(1391),
    [anon_sym_align] = ACTIONS(1389),
    [anon_sym_DOT_STAR] = ACTIONS(1389),
    [anon_sym_DOT_QMARK] = ACTIONS(1389),
    [sym_line_comment] = ACTIONS(137),
  },
  [964] = {
    [anon_sym_COMMA] = ACTIONS(1341),
    [anon_sym_SEMI] = ACTIONS(1341),
    [anon_sym_BANG] = ACTIONS(1343),
    [anon_sym_COLON] = ACTIONS(1341),
    [anon_sym_EQ] = ACTIONS(1343),
    [anon_sym_else] = ACTIONS(1341),
    [anon_sym_or] = ACTIONS(1343),
    [anon_sym_and] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1341),
    [anon_sym_RBRACE] = ACTIONS(1341),
    [anon_sym_DOT] = ACTIONS(1343),
    [anon_sym_LPAREN] = ACTIONS(1341),
    [anon_sym_RPAREN] = ACTIONS(1341),
    [anon_sym_LBRACK] = ACTIONS(1341),
    [anon_sym_RBRACK] = ACTIONS(1341),
    [anon_sym_linksection] = ACTIONS(1341),
    [anon_sym_addrspace] = ACTIONS(1341),
    [anon_sym_PIPE] = ACTIONS(1343),
    [anon_sym_STAR] = ACTIONS(1343),
    [anon_sym_EQ_GT] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1341),
    [anon_sym_STAR_EQ] = ACTIONS(1341),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1341),
    [anon_sym_SLASH_EQ] = ACTIONS(1341),
    [anon_sym_PERCENT_EQ] = ACTIONS(1341),
    [anon_sym_PLUS_EQ] = ACTIONS(1341),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1341),
    [anon_sym_DASH_EQ] = ACTIONS(1341),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1341),
    [anon_sym_LT_LT_EQ] = ACTIONS(1341),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1341),
    [anon_sym_GT_GT_EQ] = ACTIONS(1341),
    [anon_sym_AMP_EQ] = ACTIONS(1341),
    [anon_sym_CARET_EQ] = ACTIONS(1341),
    [anon_sym_PIPE_EQ] = ACTIONS(1341),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1341),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1341),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1341),
    [anon_sym_EQ_EQ] = ACTIONS(1341),
    [anon_sym_BANG_EQ] = ACTIONS(1341),
    [anon_sym_LT] = ACTIONS(1343),
    [anon_sym_GT] = ACTIONS(1343),
    [anon_sym_LT_EQ] = ACTIONS(1341),
    [anon_sym_GT_EQ] = ACTIONS(1341),
    [anon_sym_AMP] = ACTIONS(1343),
    [anon_sym_CARET] = ACTIONS(1343),
    [anon_sym_orelse] = ACTIONS(1341),
    [anon_sym_catch] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_GT_GT] = ACTIONS(1343),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1343),
    [anon_sym_PLUS] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1343),
    [anon_sym_PLUS_PLUS] = ACTIONS(1341),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1343),
    [anon_sym_DASH_PERCENT] = ACTIONS(1343),
    [anon_sym_PLUS_PIPE] = ACTIONS(1343),
    [anon_sym_DASH_PIPE] = ACTIONS(1343),
    [anon_sym_PIPE_PIPE] = ACTIONS(1341),
    [anon_sym_SLASH] = ACTIONS(1343),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_STAR_STAR] = ACTIONS(1341),
    [anon_sym_STAR_PERCENT] = ACTIONS(1343),
    [anon_sym_STAR_PIPE] = ACTIONS(1343),
    [anon_sym_align] = ACTIONS(1341),
    [anon_sym_DOT_STAR] = ACTIONS(1341),
    [anon_sym_DOT_QMARK] = ACTIONS(1341),
    [sym_line_comment] = ACTIONS(137),
  },
  [965] = {
    [anon_sym_COMMA] = ACTIONS(1393),
    [anon_sym_SEMI] = ACTIONS(1393),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_COLON] = ACTIONS(1393),
    [anon_sym_EQ] = ACTIONS(1395),
    [anon_sym_else] = ACTIONS(1393),
    [anon_sym_or] = ACTIONS(1395),
    [anon_sym_and] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(1393),
    [anon_sym_RBRACE] = ACTIONS(1393),
    [anon_sym_DOT] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_RPAREN] = ACTIONS(1393),
    [anon_sym_LBRACK] = ACTIONS(1393),
    [anon_sym_RBRACK] = ACTIONS(1393),
    [anon_sym_linksection] = ACTIONS(1393),
    [anon_sym_addrspace] = ACTIONS(1393),
    [anon_sym_PIPE] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(1395),
    [anon_sym_EQ_GT] = ACTIONS(1393),
    [anon_sym_DOT_DOT] = ACTIONS(1393),
    [anon_sym_STAR_EQ] = ACTIONS(1393),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_SLASH_EQ] = ACTIONS(1393),
    [anon_sym_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_DASH_EQ] = ACTIONS(1393),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_EQ] = ACTIONS(1393),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_GT_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP_EQ] = ACTIONS(1393),
    [anon_sym_CARET_EQ] = ACTIONS(1393),
    [anon_sym_PIPE_EQ] = ACTIONS(1393),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1393),
    [anon_sym_EQ_EQ] = ACTIONS(1393),
    [anon_sym_BANG_EQ] = ACTIONS(1393),
    [anon_sym_LT] = ACTIONS(1395),
    [anon_sym_GT] = ACTIONS(1395),
    [anon_sym_LT_EQ] = ACTIONS(1393),
    [anon_sym_GT_EQ] = ACTIONS(1393),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_CARET] = ACTIONS(1395),
    [anon_sym_orelse] = ACTIONS(1393),
    [anon_sym_catch] = ACTIONS(1393),
    [anon_sym_LT_LT] = ACTIONS(1395),
    [anon_sym_GT_GT] = ACTIONS(1395),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1395),
    [anon_sym_PLUS] = ACTIONS(1395),
    [anon_sym_DASH] = ACTIONS(1395),
    [anon_sym_PLUS_PLUS] = ACTIONS(1393),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1395),
    [anon_sym_DASH_PERCENT] = ACTIONS(1395),
    [anon_sym_PLUS_PIPE] = ACTIONS(1395),
    [anon_sym_DASH_PIPE] = ACTIONS(1395),
    [anon_sym_PIPE_PIPE] = ACTIONS(1393),
    [anon_sym_SLASH] = ACTIONS(1395),
    [anon_sym_PERCENT] = ACTIONS(1395),
    [anon_sym_STAR_STAR] = ACTIONS(1393),
    [anon_sym_STAR_PERCENT] = ACTIONS(1395),
    [anon_sym_STAR_PIPE] = ACTIONS(1395),
    [anon_sym_align] = ACTIONS(1393),
    [anon_sym_DOT_STAR] = ACTIONS(1393),
    [anon_sym_DOT_QMARK] = ACTIONS(1393),
    [sym_line_comment] = ACTIONS(137),
  },
  [966] = {
    [anon_sym_COMMA] = ACTIONS(1337),
    [anon_sym_SEMI] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_COLON] = ACTIONS(1337),
    [anon_sym_EQ] = ACTIONS(1339),
    [anon_sym_else] = ACTIONS(1337),
    [anon_sym_or] = ACTIONS(1339),
    [anon_sym_and] = ACTIONS(1337),
    [anon_sym_LBRACE] = ACTIONS(1337),
    [anon_sym_RBRACE] = ACTIONS(1337),
    [anon_sym_DOT] = ACTIONS(1339),
    [anon_sym_LPAREN] = ACTIONS(1337),
    [anon_sym_RPAREN] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(1337),
    [anon_sym_RBRACK] = ACTIONS(1337),
    [anon_sym_linksection] = ACTIONS(1337),
    [anon_sym_addrspace] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(1339),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_EQ_GT] = ACTIONS(1337),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_STAR_EQ] = ACTIONS(1337),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1337),
    [anon_sym_SLASH_EQ] = ACTIONS(1337),
    [anon_sym_PERCENT_EQ] = ACTIONS(1337),
    [anon_sym_PLUS_EQ] = ACTIONS(1337),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1337),
    [anon_sym_DASH_EQ] = ACTIONS(1337),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1337),
    [anon_sym_LT_LT_EQ] = ACTIONS(1337),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1337),
    [anon_sym_GT_GT_EQ] = ACTIONS(1337),
    [anon_sym_AMP_EQ] = ACTIONS(1337),
    [anon_sym_CARET_EQ] = ACTIONS(1337),
    [anon_sym_PIPE_EQ] = ACTIONS(1337),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1337),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1337),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1337),
    [anon_sym_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG_EQ] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1339),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_orelse] = ACTIONS(1337),
    [anon_sym_catch] = ACTIONS(1337),
    [anon_sym_LT_LT] = ACTIONS(1339),
    [anon_sym_GT_GT] = ACTIONS(1339),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1337),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1339),
    [anon_sym_DASH_PERCENT] = ACTIONS(1339),
    [anon_sym_PLUS_PIPE] = ACTIONS(1339),
    [anon_sym_DASH_PIPE] = ACTIONS(1339),
    [anon_sym_PIPE_PIPE] = ACTIONS(1337),
    [anon_sym_SLASH] = ACTIONS(1339),
    [anon_sym_PERCENT] = ACTIONS(1339),
    [anon_sym_STAR_STAR] = ACTIONS(1337),
    [anon_sym_STAR_PERCENT] = ACTIONS(1339),
    [anon_sym_STAR_PIPE] = ACTIONS(1339),
    [anon_sym_align] = ACTIONS(1337),
    [anon_sym_DOT_STAR] = ACTIONS(1337),
    [anon_sym_DOT_QMARK] = ACTIONS(1337),
    [sym_line_comment] = ACTIONS(137),
  },
  [967] = {
    [anon_sym_COMMA] = ACTIONS(1333),
    [anon_sym_SEMI] = ACTIONS(1333),
    [anon_sym_BANG] = ACTIONS(1335),
    [anon_sym_COLON] = ACTIONS(1333),
    [anon_sym_EQ] = ACTIONS(1335),
    [anon_sym_else] = ACTIONS(1333),
    [anon_sym_or] = ACTIONS(1335),
    [anon_sym_and] = ACTIONS(1333),
    [anon_sym_LBRACE] = ACTIONS(1333),
    [anon_sym_RBRACE] = ACTIONS(1333),
    [anon_sym_DOT] = ACTIONS(1335),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_RPAREN] = ACTIONS(1333),
    [anon_sym_LBRACK] = ACTIONS(1333),
    [anon_sym_RBRACK] = ACTIONS(1333),
    [anon_sym_linksection] = ACTIONS(1333),
    [anon_sym_addrspace] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1335),
    [anon_sym_STAR] = ACTIONS(1335),
    [anon_sym_EQ_GT] = ACTIONS(1333),
    [anon_sym_DOT_DOT] = ACTIONS(1333),
    [anon_sym_STAR_EQ] = ACTIONS(1333),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1333),
    [anon_sym_SLASH_EQ] = ACTIONS(1333),
    [anon_sym_PERCENT_EQ] = ACTIONS(1333),
    [anon_sym_PLUS_EQ] = ACTIONS(1333),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1333),
    [anon_sym_DASH_EQ] = ACTIONS(1333),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1333),
    [anon_sym_LT_LT_EQ] = ACTIONS(1333),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1333),
    [anon_sym_GT_GT_EQ] = ACTIONS(1333),
    [anon_sym_AMP_EQ] = ACTIONS(1333),
    [anon_sym_CARET_EQ] = ACTIONS(1333),
    [anon_sym_PIPE_EQ] = ACTIONS(1333),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1333),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1333),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1333),
    [anon_sym_EQ_EQ] = ACTIONS(1333),
    [anon_sym_BANG_EQ] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(1335),
    [anon_sym_GT] = ACTIONS(1335),
    [anon_sym_LT_EQ] = ACTIONS(1333),
    [anon_sym_GT_EQ] = ACTIONS(1333),
    [anon_sym_AMP] = ACTIONS(1335),
    [anon_sym_CARET] = ACTIONS(1335),
    [anon_sym_orelse] = ACTIONS(1333),
    [anon_sym_catch] = ACTIONS(1333),
    [anon_sym_LT_LT] = ACTIONS(1335),
    [anon_sym_GT_GT] = ACTIONS(1335),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1335),
    [anon_sym_PLUS] = ACTIONS(1335),
    [anon_sym_DASH] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1335),
    [anon_sym_DASH_PERCENT] = ACTIONS(1335),
    [anon_sym_PLUS_PIPE] = ACTIONS(1335),
    [anon_sym_DASH_PIPE] = ACTIONS(1335),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_SLASH] = ACTIONS(1335),
    [anon_sym_PERCENT] = ACTIONS(1335),
    [anon_sym_STAR_STAR] = ACTIONS(1333),
    [anon_sym_STAR_PERCENT] = ACTIONS(1335),
    [anon_sym_STAR_PIPE] = ACTIONS(1335),
    [anon_sym_align] = ACTIONS(1333),
    [anon_sym_DOT_STAR] = ACTIONS(1333),
    [anon_sym_DOT_QMARK] = ACTIONS(1333),
    [sym_line_comment] = ACTIONS(137),
  },
  [968] = {
    [anon_sym_COMMA] = ACTIONS(1245),
    [anon_sym_SEMI] = ACTIONS(1245),
    [anon_sym_BANG] = ACTIONS(1247),
    [anon_sym_COLON] = ACTIONS(1245),
    [anon_sym_EQ] = ACTIONS(1247),
    [anon_sym_else] = ACTIONS(1245),
    [anon_sym_or] = ACTIONS(1247),
    [anon_sym_and] = ACTIONS(1245),
    [anon_sym_LBRACE] = ACTIONS(1245),
    [anon_sym_RBRACE] = ACTIONS(1245),
    [anon_sym_DOT] = ACTIONS(1247),
    [anon_sym_LPAREN] = ACTIONS(1245),
    [anon_sym_RPAREN] = ACTIONS(1245),
    [anon_sym_LBRACK] = ACTIONS(1245),
    [anon_sym_RBRACK] = ACTIONS(1245),
    [anon_sym_linksection] = ACTIONS(1245),
    [anon_sym_addrspace] = ACTIONS(1245),
    [anon_sym_PIPE] = ACTIONS(1247),
    [anon_sym_STAR] = ACTIONS(1247),
    [anon_sym_EQ_GT] = ACTIONS(1245),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym_STAR_EQ] = ACTIONS(1245),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1245),
    [anon_sym_SLASH_EQ] = ACTIONS(1245),
    [anon_sym_PERCENT_EQ] = ACTIONS(1245),
    [anon_sym_PLUS_EQ] = ACTIONS(1245),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1245),
    [anon_sym_DASH_EQ] = ACTIONS(1245),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1245),
    [anon_sym_LT_LT_EQ] = ACTIONS(1245),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1245),
    [anon_sym_GT_GT_EQ] = ACTIONS(1245),
    [anon_sym_AMP_EQ] = ACTIONS(1245),
    [anon_sym_CARET_EQ] = ACTIONS(1245),
    [anon_sym_PIPE_EQ] = ACTIONS(1245),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1245),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1245),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1245),
    [anon_sym_EQ_EQ] = ACTIONS(1245),
    [anon_sym_BANG_EQ] = ACTIONS(1245),
    [anon_sym_LT] = ACTIONS(1247),
    [anon_sym_GT] = ACTIONS(1247),
    [anon_sym_LT_EQ] = ACTIONS(1245),
    [anon_sym_GT_EQ] = ACTIONS(1245),
    [anon_sym_AMP] = ACTIONS(1247),
    [anon_sym_CARET] = ACTIONS(1247),
    [anon_sym_orelse] = ACTIONS(1245),
    [anon_sym_catch] = ACTIONS(1245),
    [anon_sym_LT_LT] = ACTIONS(1247),
    [anon_sym_GT_GT] = ACTIONS(1247),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1247),
    [anon_sym_PLUS] = ACTIONS(1247),
    [anon_sym_DASH] = ACTIONS(1247),
    [anon_sym_PLUS_PLUS] = ACTIONS(1245),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1247),
    [anon_sym_DASH_PERCENT] = ACTIONS(1247),
    [anon_sym_PLUS_PIPE] = ACTIONS(1247),
    [anon_sym_DASH_PIPE] = ACTIONS(1247),
    [anon_sym_PIPE_PIPE] = ACTIONS(1245),
    [anon_sym_SLASH] = ACTIONS(1247),
    [anon_sym_PERCENT] = ACTIONS(1247),
    [anon_sym_STAR_STAR] = ACTIONS(1245),
    [anon_sym_STAR_PERCENT] = ACTIONS(1247),
    [anon_sym_STAR_PIPE] = ACTIONS(1247),
    [anon_sym_align] = ACTIONS(1245),
    [anon_sym_DOT_STAR] = ACTIONS(1245),
    [anon_sym_DOT_QMARK] = ACTIONS(1245),
    [sym_line_comment] = ACTIONS(137),
  },
  [969] = {
    [anon_sym_COMMA] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(1397),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_COLON] = ACTIONS(1397),
    [anon_sym_EQ] = ACTIONS(1399),
    [anon_sym_else] = ACTIONS(1397),
    [anon_sym_or] = ACTIONS(1399),
    [anon_sym_and] = ACTIONS(1397),
    [anon_sym_LBRACE] = ACTIONS(1397),
    [anon_sym_RBRACE] = ACTIONS(1397),
    [anon_sym_DOT] = ACTIONS(1399),
    [anon_sym_LPAREN] = ACTIONS(1397),
    [anon_sym_RPAREN] = ACTIONS(1397),
    [anon_sym_LBRACK] = ACTIONS(1397),
    [anon_sym_RBRACK] = ACTIONS(1397),
    [anon_sym_linksection] = ACTIONS(1397),
    [anon_sym_addrspace] = ACTIONS(1397),
    [anon_sym_PIPE] = ACTIONS(1399),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_EQ_GT] = ACTIONS(1397),
    [anon_sym_DOT_DOT] = ACTIONS(1397),
    [anon_sym_STAR_EQ] = ACTIONS(1397),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1397),
    [anon_sym_SLASH_EQ] = ACTIONS(1397),
    [anon_sym_PERCENT_EQ] = ACTIONS(1397),
    [anon_sym_PLUS_EQ] = ACTIONS(1397),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1397),
    [anon_sym_DASH_EQ] = ACTIONS(1397),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1397),
    [anon_sym_LT_LT_EQ] = ACTIONS(1397),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1397),
    [anon_sym_GT_GT_EQ] = ACTIONS(1397),
    [anon_sym_AMP_EQ] = ACTIONS(1397),
    [anon_sym_CARET_EQ] = ACTIONS(1397),
    [anon_sym_PIPE_EQ] = ACTIONS(1397),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1397),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1397),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1397),
    [anon_sym_EQ_EQ] = ACTIONS(1397),
    [anon_sym_BANG_EQ] = ACTIONS(1397),
    [anon_sym_LT] = ACTIONS(1399),
    [anon_sym_GT] = ACTIONS(1399),
    [anon_sym_LT_EQ] = ACTIONS(1397),
    [anon_sym_GT_EQ] = ACTIONS(1397),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_orelse] = ACTIONS(1397),
    [anon_sym_catch] = ACTIONS(1397),
    [anon_sym_LT_LT] = ACTIONS(1399),
    [anon_sym_GT_GT] = ACTIONS(1399),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1399),
    [anon_sym_PLUS] = ACTIONS(1399),
    [anon_sym_DASH] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1397),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1399),
    [anon_sym_DASH_PERCENT] = ACTIONS(1399),
    [anon_sym_PLUS_PIPE] = ACTIONS(1399),
    [anon_sym_DASH_PIPE] = ACTIONS(1399),
    [anon_sym_PIPE_PIPE] = ACTIONS(1397),
    [anon_sym_SLASH] = ACTIONS(1399),
    [anon_sym_PERCENT] = ACTIONS(1399),
    [anon_sym_STAR_STAR] = ACTIONS(1397),
    [anon_sym_STAR_PERCENT] = ACTIONS(1399),
    [anon_sym_STAR_PIPE] = ACTIONS(1399),
    [anon_sym_align] = ACTIONS(1397),
    [anon_sym_DOT_STAR] = ACTIONS(1397),
    [anon_sym_DOT_QMARK] = ACTIONS(1397),
    [sym_line_comment] = ACTIONS(137),
  },
  [970] = {
    [anon_sym_COMMA] = ACTIONS(1401),
    [anon_sym_SEMI] = ACTIONS(1401),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_COLON] = ACTIONS(1401),
    [anon_sym_EQ] = ACTIONS(1403),
    [anon_sym_else] = ACTIONS(1401),
    [anon_sym_or] = ACTIONS(1403),
    [anon_sym_and] = ACTIONS(1401),
    [anon_sym_LBRACE] = ACTIONS(1401),
    [anon_sym_RBRACE] = ACTIONS(1401),
    [anon_sym_DOT] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1401),
    [anon_sym_RPAREN] = ACTIONS(1401),
    [anon_sym_LBRACK] = ACTIONS(1401),
    [anon_sym_RBRACK] = ACTIONS(1401),
    [anon_sym_linksection] = ACTIONS(1401),
    [anon_sym_addrspace] = ACTIONS(1401),
    [anon_sym_PIPE] = ACTIONS(1403),
    [anon_sym_STAR] = ACTIONS(1403),
    [anon_sym_EQ_GT] = ACTIONS(1401),
    [anon_sym_DOT_DOT] = ACTIONS(1401),
    [anon_sym_STAR_EQ] = ACTIONS(1401),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1401),
    [anon_sym_SLASH_EQ] = ACTIONS(1401),
    [anon_sym_PERCENT_EQ] = ACTIONS(1401),
    [anon_sym_PLUS_EQ] = ACTIONS(1401),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1401),
    [anon_sym_DASH_EQ] = ACTIONS(1401),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1401),
    [anon_sym_LT_LT_EQ] = ACTIONS(1401),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1401),
    [anon_sym_GT_GT_EQ] = ACTIONS(1401),
    [anon_sym_AMP_EQ] = ACTIONS(1401),
    [anon_sym_CARET_EQ] = ACTIONS(1401),
    [anon_sym_PIPE_EQ] = ACTIONS(1401),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1401),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1401),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1401),
    [anon_sym_EQ_EQ] = ACTIONS(1401),
    [anon_sym_BANG_EQ] = ACTIONS(1401),
    [anon_sym_LT] = ACTIONS(1403),
    [anon_sym_GT] = ACTIONS(1403),
    [anon_sym_LT_EQ] = ACTIONS(1401),
    [anon_sym_GT_EQ] = ACTIONS(1401),
    [anon_sym_AMP] = ACTIONS(1403),
    [anon_sym_CARET] = ACTIONS(1403),
    [anon_sym_orelse] = ACTIONS(1401),
    [anon_sym_catch] = ACTIONS(1401),
    [anon_sym_LT_LT] = ACTIONS(1403),
    [anon_sym_GT_GT] = ACTIONS(1403),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1403),
    [anon_sym_PLUS] = ACTIONS(1403),
    [anon_sym_DASH] = ACTIONS(1403),
    [anon_sym_PLUS_PLUS] = ACTIONS(1401),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1403),
    [anon_sym_DASH_PERCENT] = ACTIONS(1403),
    [anon_sym_PLUS_PIPE] = ACTIONS(1403),
    [anon_sym_DASH_PIPE] = ACTIONS(1403),
    [anon_sym_PIPE_PIPE] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(1403),
    [anon_sym_PERCENT] = ACTIONS(1403),
    [anon_sym_STAR_STAR] = ACTIONS(1401),
    [anon_sym_STAR_PERCENT] = ACTIONS(1403),
    [anon_sym_STAR_PIPE] = ACTIONS(1403),
    [anon_sym_align] = ACTIONS(1401),
    [anon_sym_DOT_STAR] = ACTIONS(1401),
    [anon_sym_DOT_QMARK] = ACTIONS(1401),
    [sym_line_comment] = ACTIONS(137),
  },
  [971] = {
    [anon_sym_COMMA] = ACTIONS(530),
    [anon_sym_SEMI] = ACTIONS(530),
    [anon_sym_BANG] = ACTIONS(528),
    [anon_sym_COLON] = ACTIONS(530),
    [anon_sym_EQ] = ACTIONS(528),
    [anon_sym_else] = ACTIONS(530),
    [anon_sym_or] = ACTIONS(528),
    [anon_sym_and] = ACTIONS(530),
    [anon_sym_LBRACE] = ACTIONS(530),
    [anon_sym_RBRACE] = ACTIONS(530),
    [anon_sym_DOT] = ACTIONS(528),
    [anon_sym_LPAREN] = ACTIONS(530),
    [anon_sym_RPAREN] = ACTIONS(530),
    [anon_sym_LBRACK] = ACTIONS(530),
    [anon_sym_RBRACK] = ACTIONS(530),
    [anon_sym_linksection] = ACTIONS(530),
    [anon_sym_addrspace] = ACTIONS(530),
    [anon_sym_PIPE] = ACTIONS(528),
    [anon_sym_STAR] = ACTIONS(528),
    [anon_sym_EQ_GT] = ACTIONS(530),
    [anon_sym_DOT_DOT] = ACTIONS(530),
    [anon_sym_STAR_EQ] = ACTIONS(530),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(530),
    [anon_sym_SLASH_EQ] = ACTIONS(530),
    [anon_sym_PERCENT_EQ] = ACTIONS(530),
    [anon_sym_PLUS_EQ] = ACTIONS(530),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(530),
    [anon_sym_DASH_EQ] = ACTIONS(530),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(530),
    [anon_sym_LT_LT_EQ] = ACTIONS(530),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(530),
    [anon_sym_GT_GT_EQ] = ACTIONS(530),
    [anon_sym_AMP_EQ] = ACTIONS(530),
    [anon_sym_CARET_EQ] = ACTIONS(530),
    [anon_sym_PIPE_EQ] = ACTIONS(530),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(530),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(530),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(530),
    [anon_sym_EQ_EQ] = ACTIONS(530),
    [anon_sym_BANG_EQ] = ACTIONS(530),
    [anon_sym_LT] = ACTIONS(528),
    [anon_sym_GT] = ACTIONS(528),
    [anon_sym_LT_EQ] = ACTIONS(530),
    [anon_sym_GT_EQ] = ACTIONS(530),
    [anon_sym_AMP] = ACTIONS(528),
    [anon_sym_CARET] = ACTIONS(528),
    [anon_sym_orelse] = ACTIONS(530),
    [anon_sym_catch] = ACTIONS(530),
    [anon_sym_LT_LT] = ACTIONS(528),
    [anon_sym_GT_GT] = ACTIONS(528),
    [anon_sym_LT_LT_PIPE] = ACTIONS(528),
    [anon_sym_PLUS] = ACTIONS(528),
    [anon_sym_DASH] = ACTIONS(528),
    [anon_sym_PLUS_PLUS] = ACTIONS(530),
    [anon_sym_PLUS_PERCENT] = ACTIONS(528),
    [anon_sym_DASH_PERCENT] = ACTIONS(528),
    [anon_sym_PLUS_PIPE] = ACTIONS(528),
    [anon_sym_DASH_PIPE] = ACTIONS(528),
    [anon_sym_PIPE_PIPE] = ACTIONS(530),
    [anon_sym_SLASH] = ACTIONS(528),
    [anon_sym_PERCENT] = ACTIONS(528),
    [anon_sym_STAR_STAR] = ACTIONS(530),
    [anon_sym_STAR_PERCENT] = ACTIONS(528),
    [anon_sym_STAR_PIPE] = ACTIONS(528),
    [anon_sym_align] = ACTIONS(530),
    [anon_sym_DOT_STAR] = ACTIONS(530),
    [anon_sym_DOT_QMARK] = ACTIONS(530),
    [sym_line_comment] = ACTIONS(137),
  },
  [972] = {
    [anon_sym_COMMA] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1409),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_COLON] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(1411),
    [anon_sym_else] = ACTIONS(1409),
    [anon_sym_or] = ACTIONS(1411),
    [anon_sym_and] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(1409),
    [anon_sym_RBRACE] = ACTIONS(1409),
    [anon_sym_DOT] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1409),
    [anon_sym_RPAREN] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(1409),
    [anon_sym_RBRACK] = ACTIONS(1409),
    [anon_sym_linksection] = ACTIONS(1409),
    [anon_sym_addrspace] = ACTIONS(1409),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(1411),
    [anon_sym_EQ_GT] = ACTIONS(1409),
    [anon_sym_DOT_DOT] = ACTIONS(1409),
    [anon_sym_STAR_EQ] = ACTIONS(1409),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1409),
    [anon_sym_SLASH_EQ] = ACTIONS(1409),
    [anon_sym_PERCENT_EQ] = ACTIONS(1409),
    [anon_sym_PLUS_EQ] = ACTIONS(1409),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1409),
    [anon_sym_DASH_EQ] = ACTIONS(1409),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_EQ] = ACTIONS(1409),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1409),
    [anon_sym_GT_GT_EQ] = ACTIONS(1409),
    [anon_sym_AMP_EQ] = ACTIONS(1409),
    [anon_sym_CARET_EQ] = ACTIONS(1409),
    [anon_sym_PIPE_EQ] = ACTIONS(1409),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1409),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1409),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1409),
    [anon_sym_EQ_EQ] = ACTIONS(1409),
    [anon_sym_BANG_EQ] = ACTIONS(1409),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_GT] = ACTIONS(1411),
    [anon_sym_LT_EQ] = ACTIONS(1409),
    [anon_sym_GT_EQ] = ACTIONS(1409),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_CARET] = ACTIONS(1411),
    [anon_sym_orelse] = ACTIONS(1409),
    [anon_sym_catch] = ACTIONS(1409),
    [anon_sym_LT_LT] = ACTIONS(1411),
    [anon_sym_GT_GT] = ACTIONS(1411),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1411),
    [anon_sym_PLUS] = ACTIONS(1411),
    [anon_sym_DASH] = ACTIONS(1411),
    [anon_sym_PLUS_PLUS] = ACTIONS(1409),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1411),
    [anon_sym_DASH_PERCENT] = ACTIONS(1411),
    [anon_sym_PLUS_PIPE] = ACTIONS(1411),
    [anon_sym_DASH_PIPE] = ACTIONS(1411),
    [anon_sym_PIPE_PIPE] = ACTIONS(1409),
    [anon_sym_SLASH] = ACTIONS(1411),
    [anon_sym_PERCENT] = ACTIONS(1411),
    [anon_sym_STAR_STAR] = ACTIONS(1409),
    [anon_sym_STAR_PERCENT] = ACTIONS(1411),
    [anon_sym_STAR_PIPE] = ACTIONS(1411),
    [anon_sym_align] = ACTIONS(1409),
    [anon_sym_DOT_STAR] = ACTIONS(1409),
    [anon_sym_DOT_QMARK] = ACTIONS(1409),
    [sym_line_comment] = ACTIONS(137),
  },
  [973] = {
    [anon_sym_COMMA] = ACTIONS(542),
    [anon_sym_SEMI] = ACTIONS(542),
    [anon_sym_BANG] = ACTIONS(540),
    [anon_sym_COLON] = ACTIONS(542),
    [anon_sym_EQ] = ACTIONS(540),
    [anon_sym_else] = ACTIONS(542),
    [anon_sym_or] = ACTIONS(540),
    [anon_sym_and] = ACTIONS(542),
    [anon_sym_LBRACE] = ACTIONS(542),
    [anon_sym_RBRACE] = ACTIONS(542),
    [anon_sym_DOT] = ACTIONS(540),
    [anon_sym_LPAREN] = ACTIONS(542),
    [anon_sym_RPAREN] = ACTIONS(542),
    [anon_sym_LBRACK] = ACTIONS(542),
    [anon_sym_RBRACK] = ACTIONS(542),
    [anon_sym_linksection] = ACTIONS(542),
    [anon_sym_addrspace] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(540),
    [anon_sym_STAR] = ACTIONS(540),
    [anon_sym_EQ_GT] = ACTIONS(542),
    [anon_sym_DOT_DOT] = ACTIONS(542),
    [anon_sym_STAR_EQ] = ACTIONS(542),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(542),
    [anon_sym_SLASH_EQ] = ACTIONS(542),
    [anon_sym_PERCENT_EQ] = ACTIONS(542),
    [anon_sym_PLUS_EQ] = ACTIONS(542),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(542),
    [anon_sym_DASH_EQ] = ACTIONS(542),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(542),
    [anon_sym_LT_LT_EQ] = ACTIONS(542),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(542),
    [anon_sym_GT_GT_EQ] = ACTIONS(542),
    [anon_sym_AMP_EQ] = ACTIONS(542),
    [anon_sym_CARET_EQ] = ACTIONS(542),
    [anon_sym_PIPE_EQ] = ACTIONS(542),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(542),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(542),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(542),
    [anon_sym_EQ_EQ] = ACTIONS(542),
    [anon_sym_BANG_EQ] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(540),
    [anon_sym_GT] = ACTIONS(540),
    [anon_sym_LT_EQ] = ACTIONS(542),
    [anon_sym_GT_EQ] = ACTIONS(542),
    [anon_sym_AMP] = ACTIONS(540),
    [anon_sym_CARET] = ACTIONS(540),
    [anon_sym_orelse] = ACTIONS(542),
    [anon_sym_catch] = ACTIONS(542),
    [anon_sym_LT_LT] = ACTIONS(540),
    [anon_sym_GT_GT] = ACTIONS(540),
    [anon_sym_LT_LT_PIPE] = ACTIONS(540),
    [anon_sym_PLUS] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(540),
    [anon_sym_PLUS_PLUS] = ACTIONS(542),
    [anon_sym_PLUS_PERCENT] = ACTIONS(540),
    [anon_sym_DASH_PERCENT] = ACTIONS(540),
    [anon_sym_PLUS_PIPE] = ACTIONS(540),
    [anon_sym_DASH_PIPE] = ACTIONS(540),
    [anon_sym_PIPE_PIPE] = ACTIONS(542),
    [anon_sym_SLASH] = ACTIONS(540),
    [anon_sym_PERCENT] = ACTIONS(540),
    [anon_sym_STAR_STAR] = ACTIONS(542),
    [anon_sym_STAR_PERCENT] = ACTIONS(540),
    [anon_sym_STAR_PIPE] = ACTIONS(540),
    [anon_sym_align] = ACTIONS(542),
    [anon_sym_DOT_STAR] = ACTIONS(542),
    [anon_sym_DOT_QMARK] = ACTIONS(542),
    [sym_line_comment] = ACTIONS(137),
  },
  [974] = {
    [anon_sym_COMMA] = ACTIONS(1241),
    [anon_sym_SEMI] = ACTIONS(1241),
    [anon_sym_BANG] = ACTIONS(1243),
    [anon_sym_COLON] = ACTIONS(1241),
    [anon_sym_EQ] = ACTIONS(1243),
    [anon_sym_else] = ACTIONS(1241),
    [anon_sym_or] = ACTIONS(1243),
    [anon_sym_and] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(1241),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [anon_sym_DOT] = ACTIONS(1243),
    [anon_sym_LPAREN] = ACTIONS(1241),
    [anon_sym_RPAREN] = ACTIONS(1241),
    [anon_sym_LBRACK] = ACTIONS(1241),
    [anon_sym_RBRACK] = ACTIONS(1241),
    [anon_sym_linksection] = ACTIONS(1241),
    [anon_sym_addrspace] = ACTIONS(1241),
    [anon_sym_PIPE] = ACTIONS(1243),
    [anon_sym_STAR] = ACTIONS(1243),
    [anon_sym_EQ_GT] = ACTIONS(1241),
    [anon_sym_DOT_DOT] = ACTIONS(1241),
    [anon_sym_STAR_EQ] = ACTIONS(1241),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1241),
    [anon_sym_SLASH_EQ] = ACTIONS(1241),
    [anon_sym_PERCENT_EQ] = ACTIONS(1241),
    [anon_sym_PLUS_EQ] = ACTIONS(1241),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1241),
    [anon_sym_DASH_EQ] = ACTIONS(1241),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1241),
    [anon_sym_LT_LT_EQ] = ACTIONS(1241),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1241),
    [anon_sym_GT_GT_EQ] = ACTIONS(1241),
    [anon_sym_AMP_EQ] = ACTIONS(1241),
    [anon_sym_CARET_EQ] = ACTIONS(1241),
    [anon_sym_PIPE_EQ] = ACTIONS(1241),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1241),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1241),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1241),
    [anon_sym_EQ_EQ] = ACTIONS(1241),
    [anon_sym_BANG_EQ] = ACTIONS(1241),
    [anon_sym_LT] = ACTIONS(1243),
    [anon_sym_GT] = ACTIONS(1243),
    [anon_sym_LT_EQ] = ACTIONS(1241),
    [anon_sym_GT_EQ] = ACTIONS(1241),
    [anon_sym_AMP] = ACTIONS(1243),
    [anon_sym_CARET] = ACTIONS(1243),
    [anon_sym_orelse] = ACTIONS(1241),
    [anon_sym_catch] = ACTIONS(1241),
    [anon_sym_LT_LT] = ACTIONS(1243),
    [anon_sym_GT_GT] = ACTIONS(1243),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1243),
    [anon_sym_PLUS] = ACTIONS(1243),
    [anon_sym_DASH] = ACTIONS(1243),
    [anon_sym_PLUS_PLUS] = ACTIONS(1241),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1243),
    [anon_sym_DASH_PERCENT] = ACTIONS(1243),
    [anon_sym_PLUS_PIPE] = ACTIONS(1243),
    [anon_sym_DASH_PIPE] = ACTIONS(1243),
    [anon_sym_PIPE_PIPE] = ACTIONS(1241),
    [anon_sym_SLASH] = ACTIONS(1243),
    [anon_sym_PERCENT] = ACTIONS(1243),
    [anon_sym_STAR_STAR] = ACTIONS(1241),
    [anon_sym_STAR_PERCENT] = ACTIONS(1243),
    [anon_sym_STAR_PIPE] = ACTIONS(1243),
    [anon_sym_align] = ACTIONS(1241),
    [anon_sym_DOT_STAR] = ACTIONS(1241),
    [anon_sym_DOT_QMARK] = ACTIONS(1241),
    [sym_line_comment] = ACTIONS(137),
  },
  [975] = {
    [anon_sym_COMMA] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(1413),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_COLON] = ACTIONS(1413),
    [anon_sym_EQ] = ACTIONS(1415),
    [anon_sym_else] = ACTIONS(1413),
    [anon_sym_or] = ACTIONS(1415),
    [anon_sym_and] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(1413),
    [anon_sym_RBRACE] = ACTIONS(1413),
    [anon_sym_DOT] = ACTIONS(1415),
    [anon_sym_LPAREN] = ACTIONS(1413),
    [anon_sym_RPAREN] = ACTIONS(1413),
    [anon_sym_LBRACK] = ACTIONS(1413),
    [anon_sym_RBRACK] = ACTIONS(1413),
    [anon_sym_linksection] = ACTIONS(1413),
    [anon_sym_addrspace] = ACTIONS(1413),
    [anon_sym_PIPE] = ACTIONS(1415),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_EQ_GT] = ACTIONS(1413),
    [anon_sym_DOT_DOT] = ACTIONS(1413),
    [anon_sym_STAR_EQ] = ACTIONS(1413),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1413),
    [anon_sym_SLASH_EQ] = ACTIONS(1413),
    [anon_sym_PERCENT_EQ] = ACTIONS(1413),
    [anon_sym_PLUS_EQ] = ACTIONS(1413),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1413),
    [anon_sym_DASH_EQ] = ACTIONS(1413),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1413),
    [anon_sym_LT_LT_EQ] = ACTIONS(1413),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1413),
    [anon_sym_GT_GT_EQ] = ACTIONS(1413),
    [anon_sym_AMP_EQ] = ACTIONS(1413),
    [anon_sym_CARET_EQ] = ACTIONS(1413),
    [anon_sym_PIPE_EQ] = ACTIONS(1413),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1413),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1413),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1413),
    [anon_sym_EQ_EQ] = ACTIONS(1413),
    [anon_sym_BANG_EQ] = ACTIONS(1413),
    [anon_sym_LT] = ACTIONS(1415),
    [anon_sym_GT] = ACTIONS(1415),
    [anon_sym_LT_EQ] = ACTIONS(1413),
    [anon_sym_GT_EQ] = ACTIONS(1413),
    [anon_sym_AMP] = ACTIONS(1415),
    [anon_sym_CARET] = ACTIONS(1415),
    [anon_sym_orelse] = ACTIONS(1413),
    [anon_sym_catch] = ACTIONS(1413),
    [anon_sym_LT_LT] = ACTIONS(1415),
    [anon_sym_GT_GT] = ACTIONS(1415),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1415),
    [anon_sym_PLUS] = ACTIONS(1415),
    [anon_sym_DASH] = ACTIONS(1415),
    [anon_sym_PLUS_PLUS] = ACTIONS(1413),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1415),
    [anon_sym_DASH_PERCENT] = ACTIONS(1415),
    [anon_sym_PLUS_PIPE] = ACTIONS(1415),
    [anon_sym_DASH_PIPE] = ACTIONS(1415),
    [anon_sym_PIPE_PIPE] = ACTIONS(1413),
    [anon_sym_SLASH] = ACTIONS(1415),
    [anon_sym_PERCENT] = ACTIONS(1415),
    [anon_sym_STAR_STAR] = ACTIONS(1413),
    [anon_sym_STAR_PERCENT] = ACTIONS(1415),
    [anon_sym_STAR_PIPE] = ACTIONS(1415),
    [anon_sym_align] = ACTIONS(1413),
    [anon_sym_DOT_STAR] = ACTIONS(1413),
    [anon_sym_DOT_QMARK] = ACTIONS(1413),
    [sym_line_comment] = ACTIONS(137),
  },
  [976] = {
    [anon_sym_COMMA] = ACTIONS(1417),
    [anon_sym_SEMI] = ACTIONS(1417),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_COLON] = ACTIONS(1417),
    [anon_sym_EQ] = ACTIONS(1419),
    [anon_sym_else] = ACTIONS(1417),
    [anon_sym_or] = ACTIONS(1419),
    [anon_sym_and] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(1417),
    [anon_sym_RBRACE] = ACTIONS(1417),
    [anon_sym_DOT] = ACTIONS(1419),
    [anon_sym_LPAREN] = ACTIONS(1417),
    [anon_sym_RPAREN] = ACTIONS(1417),
    [anon_sym_LBRACK] = ACTIONS(1417),
    [anon_sym_RBRACK] = ACTIONS(1417),
    [anon_sym_linksection] = ACTIONS(1417),
    [anon_sym_addrspace] = ACTIONS(1417),
    [anon_sym_PIPE] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_EQ_GT] = ACTIONS(1417),
    [anon_sym_DOT_DOT] = ACTIONS(1417),
    [anon_sym_STAR_EQ] = ACTIONS(1417),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1417),
    [anon_sym_SLASH_EQ] = ACTIONS(1417),
    [anon_sym_PERCENT_EQ] = ACTIONS(1417),
    [anon_sym_PLUS_EQ] = ACTIONS(1417),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1417),
    [anon_sym_DASH_EQ] = ACTIONS(1417),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1417),
    [anon_sym_LT_LT_EQ] = ACTIONS(1417),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1417),
    [anon_sym_GT_GT_EQ] = ACTIONS(1417),
    [anon_sym_AMP_EQ] = ACTIONS(1417),
    [anon_sym_CARET_EQ] = ACTIONS(1417),
    [anon_sym_PIPE_EQ] = ACTIONS(1417),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1417),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1417),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1417),
    [anon_sym_EQ_EQ] = ACTIONS(1417),
    [anon_sym_BANG_EQ] = ACTIONS(1417),
    [anon_sym_LT] = ACTIONS(1419),
    [anon_sym_GT] = ACTIONS(1419),
    [anon_sym_LT_EQ] = ACTIONS(1417),
    [anon_sym_GT_EQ] = ACTIONS(1417),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_orelse] = ACTIONS(1417),
    [anon_sym_catch] = ACTIONS(1417),
    [anon_sym_LT_LT] = ACTIONS(1419),
    [anon_sym_GT_GT] = ACTIONS(1419),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1419),
    [anon_sym_PLUS] = ACTIONS(1419),
    [anon_sym_DASH] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1417),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1419),
    [anon_sym_DASH_PERCENT] = ACTIONS(1419),
    [anon_sym_PLUS_PIPE] = ACTIONS(1419),
    [anon_sym_DASH_PIPE] = ACTIONS(1419),
    [anon_sym_PIPE_PIPE] = ACTIONS(1417),
    [anon_sym_SLASH] = ACTIONS(1419),
    [anon_sym_PERCENT] = ACTIONS(1419),
    [anon_sym_STAR_STAR] = ACTIONS(1417),
    [anon_sym_STAR_PERCENT] = ACTIONS(1419),
    [anon_sym_STAR_PIPE] = ACTIONS(1419),
    [anon_sym_align] = ACTIONS(1417),
    [anon_sym_DOT_STAR] = ACTIONS(1417),
    [anon_sym_DOT_QMARK] = ACTIONS(1417),
    [sym_line_comment] = ACTIONS(137),
  },
  [977] = {
    [anon_sym_COMMA] = ACTIONS(1329),
    [anon_sym_SEMI] = ACTIONS(1329),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_COLON] = ACTIONS(1329),
    [anon_sym_EQ] = ACTIONS(1331),
    [anon_sym_else] = ACTIONS(1329),
    [anon_sym_or] = ACTIONS(1331),
    [anon_sym_and] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(1329),
    [anon_sym_RBRACE] = ACTIONS(1329),
    [anon_sym_DOT] = ACTIONS(1331),
    [anon_sym_LPAREN] = ACTIONS(1329),
    [anon_sym_RPAREN] = ACTIONS(1329),
    [anon_sym_LBRACK] = ACTIONS(1329),
    [anon_sym_RBRACK] = ACTIONS(1329),
    [anon_sym_linksection] = ACTIONS(1329),
    [anon_sym_addrspace] = ACTIONS(1329),
    [anon_sym_PIPE] = ACTIONS(1331),
    [anon_sym_STAR] = ACTIONS(1331),
    [anon_sym_EQ_GT] = ACTIONS(1329),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym_STAR_EQ] = ACTIONS(1329),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1329),
    [anon_sym_SLASH_EQ] = ACTIONS(1329),
    [anon_sym_PERCENT_EQ] = ACTIONS(1329),
    [anon_sym_PLUS_EQ] = ACTIONS(1329),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1329),
    [anon_sym_DASH_EQ] = ACTIONS(1329),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1329),
    [anon_sym_LT_LT_EQ] = ACTIONS(1329),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1329),
    [anon_sym_GT_GT_EQ] = ACTIONS(1329),
    [anon_sym_AMP_EQ] = ACTIONS(1329),
    [anon_sym_CARET_EQ] = ACTIONS(1329),
    [anon_sym_PIPE_EQ] = ACTIONS(1329),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1329),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1329),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1329),
    [anon_sym_EQ_EQ] = ACTIONS(1329),
    [anon_sym_BANG_EQ] = ACTIONS(1329),
    [anon_sym_LT] = ACTIONS(1331),
    [anon_sym_GT] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1329),
    [anon_sym_GT_EQ] = ACTIONS(1329),
    [anon_sym_AMP] = ACTIONS(1331),
    [anon_sym_CARET] = ACTIONS(1331),
    [anon_sym_orelse] = ACTIONS(1329),
    [anon_sym_catch] = ACTIONS(1329),
    [anon_sym_LT_LT] = ACTIONS(1331),
    [anon_sym_GT_GT] = ACTIONS(1331),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1331),
    [anon_sym_PLUS_PLUS] = ACTIONS(1329),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1331),
    [anon_sym_DASH_PERCENT] = ACTIONS(1331),
    [anon_sym_PLUS_PIPE] = ACTIONS(1331),
    [anon_sym_DASH_PIPE] = ACTIONS(1331),
    [anon_sym_PIPE_PIPE] = ACTIONS(1329),
    [anon_sym_SLASH] = ACTIONS(1331),
    [anon_sym_PERCENT] = ACTIONS(1331),
    [anon_sym_STAR_STAR] = ACTIONS(1329),
    [anon_sym_STAR_PERCENT] = ACTIONS(1331),
    [anon_sym_STAR_PIPE] = ACTIONS(1331),
    [anon_sym_align] = ACTIONS(1329),
    [anon_sym_DOT_STAR] = ACTIONS(1329),
    [anon_sym_DOT_QMARK] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(137),
  },
  [978] = {
    [anon_sym_COMMA] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1421),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_COLON] = ACTIONS(1421),
    [anon_sym_EQ] = ACTIONS(1423),
    [anon_sym_else] = ACTIONS(1421),
    [anon_sym_or] = ACTIONS(1423),
    [anon_sym_and] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(1421),
    [anon_sym_RBRACE] = ACTIONS(1421),
    [anon_sym_DOT] = ACTIONS(1423),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_RPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1421),
    [anon_sym_RBRACK] = ACTIONS(1421),
    [anon_sym_linksection] = ACTIONS(1421),
    [anon_sym_addrspace] = ACTIONS(1421),
    [anon_sym_PIPE] = ACTIONS(1423),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_EQ_GT] = ACTIONS(1421),
    [anon_sym_DOT_DOT] = ACTIONS(1421),
    [anon_sym_STAR_EQ] = ACTIONS(1421),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1421),
    [anon_sym_SLASH_EQ] = ACTIONS(1421),
    [anon_sym_PERCENT_EQ] = ACTIONS(1421),
    [anon_sym_PLUS_EQ] = ACTIONS(1421),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1421),
    [anon_sym_DASH_EQ] = ACTIONS(1421),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1421),
    [anon_sym_LT_LT_EQ] = ACTIONS(1421),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1421),
    [anon_sym_GT_GT_EQ] = ACTIONS(1421),
    [anon_sym_AMP_EQ] = ACTIONS(1421),
    [anon_sym_CARET_EQ] = ACTIONS(1421),
    [anon_sym_PIPE_EQ] = ACTIONS(1421),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1421),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1421),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1421),
    [anon_sym_EQ_EQ] = ACTIONS(1421),
    [anon_sym_BANG_EQ] = ACTIONS(1421),
    [anon_sym_LT] = ACTIONS(1423),
    [anon_sym_GT] = ACTIONS(1423),
    [anon_sym_LT_EQ] = ACTIONS(1421),
    [anon_sym_GT_EQ] = ACTIONS(1421),
    [anon_sym_AMP] = ACTIONS(1423),
    [anon_sym_CARET] = ACTIONS(1423),
    [anon_sym_orelse] = ACTIONS(1421),
    [anon_sym_catch] = ACTIONS(1421),
    [anon_sym_LT_LT] = ACTIONS(1423),
    [anon_sym_GT_GT] = ACTIONS(1423),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1423),
    [anon_sym_PLUS] = ACTIONS(1423),
    [anon_sym_DASH] = ACTIONS(1423),
    [anon_sym_PLUS_PLUS] = ACTIONS(1421),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1423),
    [anon_sym_DASH_PERCENT] = ACTIONS(1423),
    [anon_sym_PLUS_PIPE] = ACTIONS(1423),
    [anon_sym_DASH_PIPE] = ACTIONS(1423),
    [anon_sym_PIPE_PIPE] = ACTIONS(1421),
    [anon_sym_SLASH] = ACTIONS(1423),
    [anon_sym_PERCENT] = ACTIONS(1423),
    [anon_sym_STAR_STAR] = ACTIONS(1421),
    [anon_sym_STAR_PERCENT] = ACTIONS(1423),
    [anon_sym_STAR_PIPE] = ACTIONS(1423),
    [anon_sym_align] = ACTIONS(1421),
    [anon_sym_DOT_STAR] = ACTIONS(1421),
    [anon_sym_DOT_QMARK] = ACTIONS(1421),
    [sym_line_comment] = ACTIONS(137),
  },
  [979] = {
    [anon_sym_COMMA] = ACTIONS(1237),
    [anon_sym_SEMI] = ACTIONS(1237),
    [anon_sym_BANG] = ACTIONS(1239),
    [anon_sym_COLON] = ACTIONS(1237),
    [anon_sym_EQ] = ACTIONS(1239),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_or] = ACTIONS(1239),
    [anon_sym_and] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(1237),
    [anon_sym_RBRACE] = ACTIONS(1237),
    [anon_sym_DOT] = ACTIONS(1239),
    [anon_sym_LPAREN] = ACTIONS(1237),
    [anon_sym_RPAREN] = ACTIONS(1237),
    [anon_sym_LBRACK] = ACTIONS(1237),
    [anon_sym_RBRACK] = ACTIONS(1237),
    [anon_sym_linksection] = ACTIONS(1237),
    [anon_sym_addrspace] = ACTIONS(1237),
    [anon_sym_PIPE] = ACTIONS(1239),
    [anon_sym_STAR] = ACTIONS(1239),
    [anon_sym_EQ_GT] = ACTIONS(1237),
    [anon_sym_DOT_DOT] = ACTIONS(1237),
    [anon_sym_STAR_EQ] = ACTIONS(1237),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1237),
    [anon_sym_SLASH_EQ] = ACTIONS(1237),
    [anon_sym_PERCENT_EQ] = ACTIONS(1237),
    [anon_sym_PLUS_EQ] = ACTIONS(1237),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1237),
    [anon_sym_DASH_EQ] = ACTIONS(1237),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1237),
    [anon_sym_LT_LT_EQ] = ACTIONS(1237),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1237),
    [anon_sym_GT_GT_EQ] = ACTIONS(1237),
    [anon_sym_AMP_EQ] = ACTIONS(1237),
    [anon_sym_CARET_EQ] = ACTIONS(1237),
    [anon_sym_PIPE_EQ] = ACTIONS(1237),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1237),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1237),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1237),
    [anon_sym_EQ_EQ] = ACTIONS(1237),
    [anon_sym_BANG_EQ] = ACTIONS(1237),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1239),
    [anon_sym_LT_EQ] = ACTIONS(1237),
    [anon_sym_GT_EQ] = ACTIONS(1237),
    [anon_sym_AMP] = ACTIONS(1239),
    [anon_sym_CARET] = ACTIONS(1239),
    [anon_sym_orelse] = ACTIONS(1237),
    [anon_sym_catch] = ACTIONS(1237),
    [anon_sym_LT_LT] = ACTIONS(1239),
    [anon_sym_GT_GT] = ACTIONS(1239),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1239),
    [anon_sym_PLUS] = ACTIONS(1239),
    [anon_sym_DASH] = ACTIONS(1239),
    [anon_sym_PLUS_PLUS] = ACTIONS(1237),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1239),
    [anon_sym_DASH_PERCENT] = ACTIONS(1239),
    [anon_sym_PLUS_PIPE] = ACTIONS(1239),
    [anon_sym_DASH_PIPE] = ACTIONS(1239),
    [anon_sym_PIPE_PIPE] = ACTIONS(1237),
    [anon_sym_SLASH] = ACTIONS(1239),
    [anon_sym_PERCENT] = ACTIONS(1239),
    [anon_sym_STAR_STAR] = ACTIONS(1237),
    [anon_sym_STAR_PERCENT] = ACTIONS(1239),
    [anon_sym_STAR_PIPE] = ACTIONS(1239),
    [anon_sym_align] = ACTIONS(1237),
    [anon_sym_DOT_STAR] = ACTIONS(1237),
    [anon_sym_DOT_QMARK] = ACTIONS(1237),
    [sym_line_comment] = ACTIONS(137),
  },
  [980] = {
    [anon_sym_COMMA] = ACTIONS(1425),
    [anon_sym_SEMI] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_COLON] = ACTIONS(1425),
    [anon_sym_EQ] = ACTIONS(1427),
    [anon_sym_else] = ACTIONS(1425),
    [anon_sym_or] = ACTIONS(1427),
    [anon_sym_and] = ACTIONS(1425),
    [anon_sym_LBRACE] = ACTIONS(1425),
    [anon_sym_RBRACE] = ACTIONS(1425),
    [anon_sym_DOT] = ACTIONS(1427),
    [anon_sym_LPAREN] = ACTIONS(1425),
    [anon_sym_RPAREN] = ACTIONS(1425),
    [anon_sym_LBRACK] = ACTIONS(1425),
    [anon_sym_RBRACK] = ACTIONS(1425),
    [anon_sym_linksection] = ACTIONS(1425),
    [anon_sym_addrspace] = ACTIONS(1425),
    [anon_sym_PIPE] = ACTIONS(1427),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_EQ_GT] = ACTIONS(1425),
    [anon_sym_DOT_DOT] = ACTIONS(1425),
    [anon_sym_STAR_EQ] = ACTIONS(1425),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1425),
    [anon_sym_SLASH_EQ] = ACTIONS(1425),
    [anon_sym_PERCENT_EQ] = ACTIONS(1425),
    [anon_sym_PLUS_EQ] = ACTIONS(1425),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1425),
    [anon_sym_DASH_EQ] = ACTIONS(1425),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1425),
    [anon_sym_LT_LT_EQ] = ACTIONS(1425),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1425),
    [anon_sym_GT_GT_EQ] = ACTIONS(1425),
    [anon_sym_AMP_EQ] = ACTIONS(1425),
    [anon_sym_CARET_EQ] = ACTIONS(1425),
    [anon_sym_PIPE_EQ] = ACTIONS(1425),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1425),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1425),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1425),
    [anon_sym_EQ_EQ] = ACTIONS(1425),
    [anon_sym_BANG_EQ] = ACTIONS(1425),
    [anon_sym_LT] = ACTIONS(1427),
    [anon_sym_GT] = ACTIONS(1427),
    [anon_sym_LT_EQ] = ACTIONS(1425),
    [anon_sym_GT_EQ] = ACTIONS(1425),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_CARET] = ACTIONS(1427),
    [anon_sym_orelse] = ACTIONS(1425),
    [anon_sym_catch] = ACTIONS(1425),
    [anon_sym_LT_LT] = ACTIONS(1427),
    [anon_sym_GT_GT] = ACTIONS(1427),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1427),
    [anon_sym_PLUS] = ACTIONS(1427),
    [anon_sym_DASH] = ACTIONS(1427),
    [anon_sym_PLUS_PLUS] = ACTIONS(1425),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1427),
    [anon_sym_DASH_PERCENT] = ACTIONS(1427),
    [anon_sym_PLUS_PIPE] = ACTIONS(1427),
    [anon_sym_DASH_PIPE] = ACTIONS(1427),
    [anon_sym_PIPE_PIPE] = ACTIONS(1425),
    [anon_sym_SLASH] = ACTIONS(1427),
    [anon_sym_PERCENT] = ACTIONS(1427),
    [anon_sym_STAR_STAR] = ACTIONS(1425),
    [anon_sym_STAR_PERCENT] = ACTIONS(1427),
    [anon_sym_STAR_PIPE] = ACTIONS(1427),
    [anon_sym_align] = ACTIONS(1425),
    [anon_sym_DOT_STAR] = ACTIONS(1425),
    [anon_sym_DOT_QMARK] = ACTIONS(1425),
    [sym_line_comment] = ACTIONS(137),
  },
  [981] = {
    [anon_sym_COMMA] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1429),
    [anon_sym_BANG] = ACTIONS(1431),
    [anon_sym_COLON] = ACTIONS(1429),
    [anon_sym_EQ] = ACTIONS(1431),
    [anon_sym_else] = ACTIONS(1429),
    [anon_sym_or] = ACTIONS(1431),
    [anon_sym_and] = ACTIONS(1429),
    [anon_sym_LBRACE] = ACTIONS(1429),
    [anon_sym_RBRACE] = ACTIONS(1429),
    [anon_sym_DOT] = ACTIONS(1431),
    [anon_sym_LPAREN] = ACTIONS(1429),
    [anon_sym_RPAREN] = ACTIONS(1429),
    [anon_sym_LBRACK] = ACTIONS(1429),
    [anon_sym_RBRACK] = ACTIONS(1429),
    [anon_sym_linksection] = ACTIONS(1429),
    [anon_sym_addrspace] = ACTIONS(1429),
    [anon_sym_PIPE] = ACTIONS(1431),
    [anon_sym_STAR] = ACTIONS(1431),
    [anon_sym_EQ_GT] = ACTIONS(1429),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym_STAR_EQ] = ACTIONS(1429),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1429),
    [anon_sym_SLASH_EQ] = ACTIONS(1429),
    [anon_sym_PERCENT_EQ] = ACTIONS(1429),
    [anon_sym_PLUS_EQ] = ACTIONS(1429),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1429),
    [anon_sym_DASH_EQ] = ACTIONS(1429),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1429),
    [anon_sym_LT_LT_EQ] = ACTIONS(1429),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1429),
    [anon_sym_GT_GT_EQ] = ACTIONS(1429),
    [anon_sym_AMP_EQ] = ACTIONS(1429),
    [anon_sym_CARET_EQ] = ACTIONS(1429),
    [anon_sym_PIPE_EQ] = ACTIONS(1429),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1429),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1429),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1429),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ] = ACTIONS(1429),
    [anon_sym_LT] = ACTIONS(1431),
    [anon_sym_GT] = ACTIONS(1431),
    [anon_sym_LT_EQ] = ACTIONS(1429),
    [anon_sym_GT_EQ] = ACTIONS(1429),
    [anon_sym_AMP] = ACTIONS(1431),
    [anon_sym_CARET] = ACTIONS(1431),
    [anon_sym_orelse] = ACTIONS(1429),
    [anon_sym_catch] = ACTIONS(1429),
    [anon_sym_LT_LT] = ACTIONS(1431),
    [anon_sym_GT_GT] = ACTIONS(1431),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1431),
    [anon_sym_PLUS] = ACTIONS(1431),
    [anon_sym_DASH] = ACTIONS(1431),
    [anon_sym_PLUS_PLUS] = ACTIONS(1429),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1431),
    [anon_sym_DASH_PERCENT] = ACTIONS(1431),
    [anon_sym_PLUS_PIPE] = ACTIONS(1431),
    [anon_sym_DASH_PIPE] = ACTIONS(1431),
    [anon_sym_PIPE_PIPE] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1431),
    [anon_sym_PERCENT] = ACTIONS(1431),
    [anon_sym_STAR_STAR] = ACTIONS(1429),
    [anon_sym_STAR_PERCENT] = ACTIONS(1431),
    [anon_sym_STAR_PIPE] = ACTIONS(1431),
    [anon_sym_align] = ACTIONS(1429),
    [anon_sym_DOT_STAR] = ACTIONS(1429),
    [anon_sym_DOT_QMARK] = ACTIONS(1429),
    [sym_line_comment] = ACTIONS(137),
  },
  [982] = {
    [anon_sym_COMMA] = ACTIONS(1233),
    [anon_sym_SEMI] = ACTIONS(1233),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_COLON] = ACTIONS(1233),
    [anon_sym_EQ] = ACTIONS(1235),
    [anon_sym_else] = ACTIONS(1233),
    [anon_sym_or] = ACTIONS(1235),
    [anon_sym_and] = ACTIONS(1233),
    [anon_sym_LBRACE] = ACTIONS(1233),
    [anon_sym_RBRACE] = ACTIONS(1233),
    [anon_sym_DOT] = ACTIONS(1235),
    [anon_sym_LPAREN] = ACTIONS(1233),
    [anon_sym_RPAREN] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_RBRACK] = ACTIONS(1233),
    [anon_sym_linksection] = ACTIONS(1233),
    [anon_sym_addrspace] = ACTIONS(1233),
    [anon_sym_PIPE] = ACTIONS(1235),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_EQ_GT] = ACTIONS(1233),
    [anon_sym_DOT_DOT] = ACTIONS(1233),
    [anon_sym_STAR_EQ] = ACTIONS(1233),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1233),
    [anon_sym_SLASH_EQ] = ACTIONS(1233),
    [anon_sym_PERCENT_EQ] = ACTIONS(1233),
    [anon_sym_PLUS_EQ] = ACTIONS(1233),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1233),
    [anon_sym_DASH_EQ] = ACTIONS(1233),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1233),
    [anon_sym_LT_LT_EQ] = ACTIONS(1233),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1233),
    [anon_sym_GT_GT_EQ] = ACTIONS(1233),
    [anon_sym_AMP_EQ] = ACTIONS(1233),
    [anon_sym_CARET_EQ] = ACTIONS(1233),
    [anon_sym_PIPE_EQ] = ACTIONS(1233),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1233),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1233),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1233),
    [anon_sym_EQ_EQ] = ACTIONS(1233),
    [anon_sym_BANG_EQ] = ACTIONS(1233),
    [anon_sym_LT] = ACTIONS(1235),
    [anon_sym_GT] = ACTIONS(1235),
    [anon_sym_LT_EQ] = ACTIONS(1233),
    [anon_sym_GT_EQ] = ACTIONS(1233),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_orelse] = ACTIONS(1233),
    [anon_sym_catch] = ACTIONS(1233),
    [anon_sym_LT_LT] = ACTIONS(1235),
    [anon_sym_GT_GT] = ACTIONS(1235),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1235),
    [anon_sym_PLUS] = ACTIONS(1235),
    [anon_sym_DASH] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1233),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1235),
    [anon_sym_DASH_PERCENT] = ACTIONS(1235),
    [anon_sym_PLUS_PIPE] = ACTIONS(1235),
    [anon_sym_DASH_PIPE] = ACTIONS(1235),
    [anon_sym_PIPE_PIPE] = ACTIONS(1233),
    [anon_sym_SLASH] = ACTIONS(1235),
    [anon_sym_PERCENT] = ACTIONS(1235),
    [anon_sym_STAR_STAR] = ACTIONS(1233),
    [anon_sym_STAR_PERCENT] = ACTIONS(1235),
    [anon_sym_STAR_PIPE] = ACTIONS(1235),
    [anon_sym_align] = ACTIONS(1233),
    [anon_sym_DOT_STAR] = ACTIONS(1233),
    [anon_sym_DOT_QMARK] = ACTIONS(1233),
    [sym_line_comment] = ACTIONS(137),
  },
  [983] = {
    [anon_sym_COMMA] = ACTIONS(1433),
    [anon_sym_SEMI] = ACTIONS(1433),
    [anon_sym_BANG] = ACTIONS(1435),
    [anon_sym_COLON] = ACTIONS(1433),
    [anon_sym_EQ] = ACTIONS(1435),
    [anon_sym_else] = ACTIONS(1433),
    [anon_sym_or] = ACTIONS(1435),
    [anon_sym_and] = ACTIONS(1433),
    [anon_sym_LBRACE] = ACTIONS(1433),
    [anon_sym_RBRACE] = ACTIONS(1433),
    [anon_sym_DOT] = ACTIONS(1435),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_RPAREN] = ACTIONS(1433),
    [anon_sym_LBRACK] = ACTIONS(1433),
    [anon_sym_RBRACK] = ACTIONS(1433),
    [anon_sym_linksection] = ACTIONS(1433),
    [anon_sym_addrspace] = ACTIONS(1433),
    [anon_sym_PIPE] = ACTIONS(1435),
    [anon_sym_STAR] = ACTIONS(1435),
    [anon_sym_EQ_GT] = ACTIONS(1433),
    [anon_sym_DOT_DOT] = ACTIONS(1433),
    [anon_sym_STAR_EQ] = ACTIONS(1433),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_SLASH_EQ] = ACTIONS(1433),
    [anon_sym_PERCENT_EQ] = ACTIONS(1433),
    [anon_sym_PLUS_EQ] = ACTIONS(1433),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_DASH_EQ] = ACTIONS(1433),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_LT_LT_EQ] = ACTIONS(1433),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_GT_GT_EQ] = ACTIONS(1433),
    [anon_sym_AMP_EQ] = ACTIONS(1433),
    [anon_sym_CARET_EQ] = ACTIONS(1433),
    [anon_sym_PIPE_EQ] = ACTIONS(1433),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1433),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1433),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1433),
    [anon_sym_EQ_EQ] = ACTIONS(1433),
    [anon_sym_BANG_EQ] = ACTIONS(1433),
    [anon_sym_LT] = ACTIONS(1435),
    [anon_sym_GT] = ACTIONS(1435),
    [anon_sym_LT_EQ] = ACTIONS(1433),
    [anon_sym_GT_EQ] = ACTIONS(1433),
    [anon_sym_AMP] = ACTIONS(1435),
    [anon_sym_CARET] = ACTIONS(1435),
    [anon_sym_orelse] = ACTIONS(1433),
    [anon_sym_catch] = ACTIONS(1433),
    [anon_sym_LT_LT] = ACTIONS(1435),
    [anon_sym_GT_GT] = ACTIONS(1435),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1435),
    [anon_sym_PLUS] = ACTIONS(1435),
    [anon_sym_DASH] = ACTIONS(1435),
    [anon_sym_PLUS_PLUS] = ACTIONS(1433),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1435),
    [anon_sym_DASH_PERCENT] = ACTIONS(1435),
    [anon_sym_PLUS_PIPE] = ACTIONS(1435),
    [anon_sym_DASH_PIPE] = ACTIONS(1435),
    [anon_sym_PIPE_PIPE] = ACTIONS(1433),
    [anon_sym_SLASH] = ACTIONS(1435),
    [anon_sym_PERCENT] = ACTIONS(1435),
    [anon_sym_STAR_STAR] = ACTIONS(1433),
    [anon_sym_STAR_PERCENT] = ACTIONS(1435),
    [anon_sym_STAR_PIPE] = ACTIONS(1435),
    [anon_sym_align] = ACTIONS(1433),
    [anon_sym_DOT_STAR] = ACTIONS(1433),
    [anon_sym_DOT_QMARK] = ACTIONS(1433),
    [sym_line_comment] = ACTIONS(137),
  },
  [984] = {
    [anon_sym_COMMA] = ACTIONS(1167),
    [anon_sym_SEMI] = ACTIONS(1167),
    [anon_sym_BANG] = ACTIONS(1169),
    [anon_sym_COLON] = ACTIONS(1167),
    [anon_sym_EQ] = ACTIONS(1169),
    [anon_sym_else] = ACTIONS(1167),
    [anon_sym_or] = ACTIONS(1169),
    [anon_sym_and] = ACTIONS(1167),
    [anon_sym_LBRACE] = ACTIONS(1167),
    [anon_sym_RBRACE] = ACTIONS(1167),
    [anon_sym_DOT] = ACTIONS(1169),
    [anon_sym_LPAREN] = ACTIONS(1167),
    [anon_sym_RPAREN] = ACTIONS(1167),
    [anon_sym_LBRACK] = ACTIONS(1167),
    [anon_sym_RBRACK] = ACTIONS(1167),
    [anon_sym_linksection] = ACTIONS(1167),
    [anon_sym_addrspace] = ACTIONS(1167),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_STAR] = ACTIONS(1169),
    [anon_sym_EQ_GT] = ACTIONS(1167),
    [anon_sym_DOT_DOT] = ACTIONS(1167),
    [anon_sym_STAR_EQ] = ACTIONS(1167),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1167),
    [anon_sym_SLASH_EQ] = ACTIONS(1167),
    [anon_sym_PERCENT_EQ] = ACTIONS(1167),
    [anon_sym_PLUS_EQ] = ACTIONS(1167),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1167),
    [anon_sym_DASH_EQ] = ACTIONS(1167),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1167),
    [anon_sym_LT_LT_EQ] = ACTIONS(1167),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1167),
    [anon_sym_GT_GT_EQ] = ACTIONS(1167),
    [anon_sym_AMP_EQ] = ACTIONS(1167),
    [anon_sym_CARET_EQ] = ACTIONS(1167),
    [anon_sym_PIPE_EQ] = ACTIONS(1167),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1167),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1167),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1167),
    [anon_sym_EQ_EQ] = ACTIONS(1167),
    [anon_sym_BANG_EQ] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_LT_EQ] = ACTIONS(1167),
    [anon_sym_GT_EQ] = ACTIONS(1167),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_CARET] = ACTIONS(1169),
    [anon_sym_orelse] = ACTIONS(1167),
    [anon_sym_catch] = ACTIONS(1167),
    [anon_sym_LT_LT] = ACTIONS(1169),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1169),
    [anon_sym_PLUS] = ACTIONS(1169),
    [anon_sym_DASH] = ACTIONS(1169),
    [anon_sym_PLUS_PLUS] = ACTIONS(1167),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1169),
    [anon_sym_DASH_PERCENT] = ACTIONS(1169),
    [anon_sym_PLUS_PIPE] = ACTIONS(1169),
    [anon_sym_DASH_PIPE] = ACTIONS(1169),
    [anon_sym_PIPE_PIPE] = ACTIONS(1167),
    [anon_sym_SLASH] = ACTIONS(1169),
    [anon_sym_PERCENT] = ACTIONS(1169),
    [anon_sym_STAR_STAR] = ACTIONS(1167),
    [anon_sym_STAR_PERCENT] = ACTIONS(1169),
    [anon_sym_STAR_PIPE] = ACTIONS(1169),
    [anon_sym_align] = ACTIONS(1167),
    [anon_sym_DOT_STAR] = ACTIONS(1167),
    [anon_sym_DOT_QMARK] = ACTIONS(1167),
    [sym_line_comment] = ACTIONS(137),
  },
  [985] = {
    [anon_sym_COMMA] = ACTIONS(1229),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_BANG] = ACTIONS(1231),
    [anon_sym_COLON] = ACTIONS(1229),
    [anon_sym_EQ] = ACTIONS(1231),
    [anon_sym_else] = ACTIONS(1229),
    [anon_sym_or] = ACTIONS(1231),
    [anon_sym_and] = ACTIONS(1229),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_DOT] = ACTIONS(1231),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_RPAREN] = ACTIONS(1229),
    [anon_sym_LBRACK] = ACTIONS(1229),
    [anon_sym_RBRACK] = ACTIONS(1229),
    [anon_sym_linksection] = ACTIONS(1229),
    [anon_sym_addrspace] = ACTIONS(1229),
    [anon_sym_PIPE] = ACTIONS(1231),
    [anon_sym_STAR] = ACTIONS(1231),
    [anon_sym_EQ_GT] = ACTIONS(1229),
    [anon_sym_DOT_DOT] = ACTIONS(1229),
    [anon_sym_STAR_EQ] = ACTIONS(1229),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1229),
    [anon_sym_SLASH_EQ] = ACTIONS(1229),
    [anon_sym_PERCENT_EQ] = ACTIONS(1229),
    [anon_sym_PLUS_EQ] = ACTIONS(1229),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1229),
    [anon_sym_DASH_EQ] = ACTIONS(1229),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1229),
    [anon_sym_LT_LT_EQ] = ACTIONS(1229),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1229),
    [anon_sym_GT_GT_EQ] = ACTIONS(1229),
    [anon_sym_AMP_EQ] = ACTIONS(1229),
    [anon_sym_CARET_EQ] = ACTIONS(1229),
    [anon_sym_PIPE_EQ] = ACTIONS(1229),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1229),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1229),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1229),
    [anon_sym_EQ_EQ] = ACTIONS(1229),
    [anon_sym_BANG_EQ] = ACTIONS(1229),
    [anon_sym_LT] = ACTIONS(1231),
    [anon_sym_GT] = ACTIONS(1231),
    [anon_sym_LT_EQ] = ACTIONS(1229),
    [anon_sym_GT_EQ] = ACTIONS(1229),
    [anon_sym_AMP] = ACTIONS(1231),
    [anon_sym_CARET] = ACTIONS(1231),
    [anon_sym_orelse] = ACTIONS(1229),
    [anon_sym_catch] = ACTIONS(1229),
    [anon_sym_LT_LT] = ACTIONS(1231),
    [anon_sym_GT_GT] = ACTIONS(1231),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1231),
    [anon_sym_PLUS] = ACTIONS(1231),
    [anon_sym_DASH] = ACTIONS(1231),
    [anon_sym_PLUS_PLUS] = ACTIONS(1229),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1231),
    [anon_sym_DASH_PERCENT] = ACTIONS(1231),
    [anon_sym_PLUS_PIPE] = ACTIONS(1231),
    [anon_sym_DASH_PIPE] = ACTIONS(1231),
    [anon_sym_PIPE_PIPE] = ACTIONS(1229),
    [anon_sym_SLASH] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_STAR] = ACTIONS(1229),
    [anon_sym_STAR_PERCENT] = ACTIONS(1231),
    [anon_sym_STAR_PIPE] = ACTIONS(1231),
    [anon_sym_align] = ACTIONS(1229),
    [anon_sym_DOT_STAR] = ACTIONS(1229),
    [anon_sym_DOT_QMARK] = ACTIONS(1229),
    [sym_line_comment] = ACTIONS(137),
  },
  [986] = {
    [anon_sym_COMMA] = ACTIONS(1437),
    [anon_sym_SEMI] = ACTIONS(1437),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_COLON] = ACTIONS(1437),
    [anon_sym_EQ] = ACTIONS(1439),
    [anon_sym_else] = ACTIONS(1437),
    [anon_sym_or] = ACTIONS(1439),
    [anon_sym_and] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(1437),
    [anon_sym_RBRACE] = ACTIONS(1437),
    [anon_sym_DOT] = ACTIONS(1439),
    [anon_sym_LPAREN] = ACTIONS(1437),
    [anon_sym_RPAREN] = ACTIONS(1437),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_RBRACK] = ACTIONS(1437),
    [anon_sym_linksection] = ACTIONS(1437),
    [anon_sym_addrspace] = ACTIONS(1437),
    [anon_sym_PIPE] = ACTIONS(1439),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_EQ_GT] = ACTIONS(1437),
    [anon_sym_DOT_DOT] = ACTIONS(1437),
    [anon_sym_STAR_EQ] = ACTIONS(1437),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1437),
    [anon_sym_SLASH_EQ] = ACTIONS(1437),
    [anon_sym_PERCENT_EQ] = ACTIONS(1437),
    [anon_sym_PLUS_EQ] = ACTIONS(1437),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1437),
    [anon_sym_DASH_EQ] = ACTIONS(1437),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1437),
    [anon_sym_LT_LT_EQ] = ACTIONS(1437),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1437),
    [anon_sym_GT_GT_EQ] = ACTIONS(1437),
    [anon_sym_AMP_EQ] = ACTIONS(1437),
    [anon_sym_CARET_EQ] = ACTIONS(1437),
    [anon_sym_PIPE_EQ] = ACTIONS(1437),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1437),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1437),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1437),
    [anon_sym_EQ_EQ] = ACTIONS(1437),
    [anon_sym_BANG_EQ] = ACTIONS(1437),
    [anon_sym_LT] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1439),
    [anon_sym_LT_EQ] = ACTIONS(1437),
    [anon_sym_GT_EQ] = ACTIONS(1437),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_orelse] = ACTIONS(1437),
    [anon_sym_catch] = ACTIONS(1437),
    [anon_sym_LT_LT] = ACTIONS(1439),
    [anon_sym_GT_GT] = ACTIONS(1439),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1439),
    [anon_sym_PLUS] = ACTIONS(1439),
    [anon_sym_DASH] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1437),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1439),
    [anon_sym_DASH_PERCENT] = ACTIONS(1439),
    [anon_sym_PLUS_PIPE] = ACTIONS(1439),
    [anon_sym_DASH_PIPE] = ACTIONS(1439),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [anon_sym_SLASH] = ACTIONS(1439),
    [anon_sym_PERCENT] = ACTIONS(1439),
    [anon_sym_STAR_STAR] = ACTIONS(1437),
    [anon_sym_STAR_PERCENT] = ACTIONS(1439),
    [anon_sym_STAR_PIPE] = ACTIONS(1439),
    [anon_sym_align] = ACTIONS(1437),
    [anon_sym_DOT_STAR] = ACTIONS(1437),
    [anon_sym_DOT_QMARK] = ACTIONS(1437),
    [sym_line_comment] = ACTIONS(137),
  },
  [987] = {
    [anon_sym_COMMA] = ACTIONS(1305),
    [anon_sym_SEMI] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_COLON] = ACTIONS(1305),
    [anon_sym_EQ] = ACTIONS(1307),
    [anon_sym_else] = ACTIONS(1305),
    [anon_sym_or] = ACTIONS(1307),
    [anon_sym_and] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1305),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1307),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [anon_sym_RPAREN] = ACTIONS(1305),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [anon_sym_RBRACK] = ACTIONS(1305),
    [anon_sym_linksection] = ACTIONS(1305),
    [anon_sym_addrspace] = ACTIONS(1305),
    [anon_sym_PIPE] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(1307),
    [anon_sym_EQ_GT] = ACTIONS(1305),
    [anon_sym_DOT_DOT] = ACTIONS(1305),
    [anon_sym_STAR_EQ] = ACTIONS(1305),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1305),
    [anon_sym_SLASH_EQ] = ACTIONS(1305),
    [anon_sym_PERCENT_EQ] = ACTIONS(1305),
    [anon_sym_PLUS_EQ] = ACTIONS(1305),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1305),
    [anon_sym_DASH_EQ] = ACTIONS(1305),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1305),
    [anon_sym_LT_LT_EQ] = ACTIONS(1305),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1305),
    [anon_sym_GT_GT_EQ] = ACTIONS(1305),
    [anon_sym_AMP_EQ] = ACTIONS(1305),
    [anon_sym_CARET_EQ] = ACTIONS(1305),
    [anon_sym_PIPE_EQ] = ACTIONS(1305),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1305),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1305),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1305),
    [anon_sym_EQ_EQ] = ACTIONS(1305),
    [anon_sym_BANG_EQ] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1307),
    [anon_sym_GT] = ACTIONS(1307),
    [anon_sym_LT_EQ] = ACTIONS(1305),
    [anon_sym_GT_EQ] = ACTIONS(1305),
    [anon_sym_AMP] = ACTIONS(1307),
    [anon_sym_CARET] = ACTIONS(1307),
    [anon_sym_orelse] = ACTIONS(1305),
    [anon_sym_catch] = ACTIONS(1305),
    [anon_sym_LT_LT] = ACTIONS(1307),
    [anon_sym_GT_GT] = ACTIONS(1307),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1307),
    [anon_sym_PLUS] = ACTIONS(1307),
    [anon_sym_DASH] = ACTIONS(1307),
    [anon_sym_PLUS_PLUS] = ACTIONS(1305),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1307),
    [anon_sym_DASH_PERCENT] = ACTIONS(1307),
    [anon_sym_PLUS_PIPE] = ACTIONS(1307),
    [anon_sym_DASH_PIPE] = ACTIONS(1307),
    [anon_sym_PIPE_PIPE] = ACTIONS(1305),
    [anon_sym_SLASH] = ACTIONS(1307),
    [anon_sym_PERCENT] = ACTIONS(1307),
    [anon_sym_STAR_STAR] = ACTIONS(1305),
    [anon_sym_STAR_PERCENT] = ACTIONS(1307),
    [anon_sym_STAR_PIPE] = ACTIONS(1307),
    [anon_sym_align] = ACTIONS(1305),
    [anon_sym_DOT_STAR] = ACTIONS(1305),
    [anon_sym_DOT_QMARK] = ACTIONS(1305),
    [sym_line_comment] = ACTIONS(137),
  },
  [988] = {
    [anon_sym_COMMA] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(1225),
    [anon_sym_BANG] = ACTIONS(1227),
    [anon_sym_COLON] = ACTIONS(1225),
    [anon_sym_EQ] = ACTIONS(1227),
    [anon_sym_else] = ACTIONS(1225),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_and] = ACTIONS(1225),
    [anon_sym_LBRACE] = ACTIONS(1225),
    [anon_sym_RBRACE] = ACTIONS(1225),
    [anon_sym_DOT] = ACTIONS(1227),
    [anon_sym_LPAREN] = ACTIONS(1225),
    [anon_sym_RPAREN] = ACTIONS(1225),
    [anon_sym_LBRACK] = ACTIONS(1225),
    [anon_sym_RBRACK] = ACTIONS(1225),
    [anon_sym_linksection] = ACTIONS(1225),
    [anon_sym_addrspace] = ACTIONS(1225),
    [anon_sym_PIPE] = ACTIONS(1227),
    [anon_sym_STAR] = ACTIONS(1227),
    [anon_sym_EQ_GT] = ACTIONS(1225),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym_STAR_EQ] = ACTIONS(1225),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1225),
    [anon_sym_SLASH_EQ] = ACTIONS(1225),
    [anon_sym_PERCENT_EQ] = ACTIONS(1225),
    [anon_sym_PLUS_EQ] = ACTIONS(1225),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1225),
    [anon_sym_DASH_EQ] = ACTIONS(1225),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1225),
    [anon_sym_LT_LT_EQ] = ACTIONS(1225),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1225),
    [anon_sym_GT_GT_EQ] = ACTIONS(1225),
    [anon_sym_AMP_EQ] = ACTIONS(1225),
    [anon_sym_CARET_EQ] = ACTIONS(1225),
    [anon_sym_PIPE_EQ] = ACTIONS(1225),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1225),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1225),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(1225),
    [anon_sym_BANG_EQ] = ACTIONS(1225),
    [anon_sym_LT] = ACTIONS(1227),
    [anon_sym_GT] = ACTIONS(1227),
    [anon_sym_LT_EQ] = ACTIONS(1225),
    [anon_sym_GT_EQ] = ACTIONS(1225),
    [anon_sym_AMP] = ACTIONS(1227),
    [anon_sym_CARET] = ACTIONS(1227),
    [anon_sym_orelse] = ACTIONS(1225),
    [anon_sym_catch] = ACTIONS(1225),
    [anon_sym_LT_LT] = ACTIONS(1227),
    [anon_sym_GT_GT] = ACTIONS(1227),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1227),
    [anon_sym_PLUS] = ACTIONS(1227),
    [anon_sym_DASH] = ACTIONS(1227),
    [anon_sym_PLUS_PLUS] = ACTIONS(1225),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1227),
    [anon_sym_DASH_PERCENT] = ACTIONS(1227),
    [anon_sym_PLUS_PIPE] = ACTIONS(1227),
    [anon_sym_DASH_PIPE] = ACTIONS(1227),
    [anon_sym_PIPE_PIPE] = ACTIONS(1225),
    [anon_sym_SLASH] = ACTIONS(1227),
    [anon_sym_PERCENT] = ACTIONS(1227),
    [anon_sym_STAR_STAR] = ACTIONS(1225),
    [anon_sym_STAR_PERCENT] = ACTIONS(1227),
    [anon_sym_STAR_PIPE] = ACTIONS(1227),
    [anon_sym_align] = ACTIONS(1225),
    [anon_sym_DOT_STAR] = ACTIONS(1225),
    [anon_sym_DOT_QMARK] = ACTIONS(1225),
    [sym_line_comment] = ACTIONS(137),
  },
  [989] = {
    [anon_sym_COMMA] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1221),
    [anon_sym_BANG] = ACTIONS(1223),
    [anon_sym_COLON] = ACTIONS(1221),
    [anon_sym_EQ] = ACTIONS(1223),
    [anon_sym_else] = ACTIONS(1221),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1221),
    [anon_sym_LBRACE] = ACTIONS(1221),
    [anon_sym_RBRACE] = ACTIONS(1221),
    [anon_sym_DOT] = ACTIONS(1223),
    [anon_sym_LPAREN] = ACTIONS(1221),
    [anon_sym_RPAREN] = ACTIONS(1221),
    [anon_sym_LBRACK] = ACTIONS(1221),
    [anon_sym_RBRACK] = ACTIONS(1221),
    [anon_sym_linksection] = ACTIONS(1221),
    [anon_sym_addrspace] = ACTIONS(1221),
    [anon_sym_PIPE] = ACTIONS(1223),
    [anon_sym_STAR] = ACTIONS(1223),
    [anon_sym_EQ_GT] = ACTIONS(1221),
    [anon_sym_DOT_DOT] = ACTIONS(1221),
    [anon_sym_STAR_EQ] = ACTIONS(1221),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1221),
    [anon_sym_SLASH_EQ] = ACTIONS(1221),
    [anon_sym_PERCENT_EQ] = ACTIONS(1221),
    [anon_sym_PLUS_EQ] = ACTIONS(1221),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1221),
    [anon_sym_DASH_EQ] = ACTIONS(1221),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1221),
    [anon_sym_LT_LT_EQ] = ACTIONS(1221),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1221),
    [anon_sym_GT_GT_EQ] = ACTIONS(1221),
    [anon_sym_AMP_EQ] = ACTIONS(1221),
    [anon_sym_CARET_EQ] = ACTIONS(1221),
    [anon_sym_PIPE_EQ] = ACTIONS(1221),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1221),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1221),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1221),
    [anon_sym_EQ_EQ] = ACTIONS(1221),
    [anon_sym_BANG_EQ] = ACTIONS(1221),
    [anon_sym_LT] = ACTIONS(1223),
    [anon_sym_GT] = ACTIONS(1223),
    [anon_sym_LT_EQ] = ACTIONS(1221),
    [anon_sym_GT_EQ] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1223),
    [anon_sym_CARET] = ACTIONS(1223),
    [anon_sym_orelse] = ACTIONS(1221),
    [anon_sym_catch] = ACTIONS(1221),
    [anon_sym_LT_LT] = ACTIONS(1223),
    [anon_sym_GT_GT] = ACTIONS(1223),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1223),
    [anon_sym_PLUS] = ACTIONS(1223),
    [anon_sym_DASH] = ACTIONS(1223),
    [anon_sym_PLUS_PLUS] = ACTIONS(1221),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1223),
    [anon_sym_DASH_PERCENT] = ACTIONS(1223),
    [anon_sym_PLUS_PIPE] = ACTIONS(1223),
    [anon_sym_DASH_PIPE] = ACTIONS(1223),
    [anon_sym_PIPE_PIPE] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(1223),
    [anon_sym_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_STAR] = ACTIONS(1221),
    [anon_sym_STAR_PERCENT] = ACTIONS(1223),
    [anon_sym_STAR_PIPE] = ACTIONS(1223),
    [anon_sym_align] = ACTIONS(1221),
    [anon_sym_DOT_STAR] = ACTIONS(1221),
    [anon_sym_DOT_QMARK] = ACTIONS(1221),
    [sym_line_comment] = ACTIONS(137),
  },
  [990] = {
    [anon_sym_COMMA] = ACTIONS(1441),
    [anon_sym_SEMI] = ACTIONS(1441),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_COLON] = ACTIONS(1441),
    [anon_sym_EQ] = ACTIONS(1443),
    [anon_sym_else] = ACTIONS(1441),
    [anon_sym_or] = ACTIONS(1443),
    [anon_sym_and] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(1441),
    [anon_sym_RBRACE] = ACTIONS(1441),
    [anon_sym_DOT] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(1441),
    [anon_sym_RPAREN] = ACTIONS(1441),
    [anon_sym_LBRACK] = ACTIONS(1441),
    [anon_sym_RBRACK] = ACTIONS(1441),
    [anon_sym_linksection] = ACTIONS(1441),
    [anon_sym_addrspace] = ACTIONS(1441),
    [anon_sym_PIPE] = ACTIONS(1443),
    [anon_sym_STAR] = ACTIONS(1443),
    [anon_sym_EQ_GT] = ACTIONS(1441),
    [anon_sym_DOT_DOT] = ACTIONS(1441),
    [anon_sym_STAR_EQ] = ACTIONS(1441),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1441),
    [anon_sym_SLASH_EQ] = ACTIONS(1441),
    [anon_sym_PERCENT_EQ] = ACTIONS(1441),
    [anon_sym_PLUS_EQ] = ACTIONS(1441),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1441),
    [anon_sym_DASH_EQ] = ACTIONS(1441),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1441),
    [anon_sym_LT_LT_EQ] = ACTIONS(1441),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1441),
    [anon_sym_GT_GT_EQ] = ACTIONS(1441),
    [anon_sym_AMP_EQ] = ACTIONS(1441),
    [anon_sym_CARET_EQ] = ACTIONS(1441),
    [anon_sym_PIPE_EQ] = ACTIONS(1441),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1441),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1441),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1441),
    [anon_sym_EQ_EQ] = ACTIONS(1441),
    [anon_sym_BANG_EQ] = ACTIONS(1441),
    [anon_sym_LT] = ACTIONS(1443),
    [anon_sym_GT] = ACTIONS(1443),
    [anon_sym_LT_EQ] = ACTIONS(1441),
    [anon_sym_GT_EQ] = ACTIONS(1441),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_CARET] = ACTIONS(1443),
    [anon_sym_orelse] = ACTIONS(1441),
    [anon_sym_catch] = ACTIONS(1441),
    [anon_sym_LT_LT] = ACTIONS(1443),
    [anon_sym_GT_GT] = ACTIONS(1443),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1443),
    [anon_sym_PLUS] = ACTIONS(1443),
    [anon_sym_DASH] = ACTIONS(1443),
    [anon_sym_PLUS_PLUS] = ACTIONS(1441),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1443),
    [anon_sym_DASH_PERCENT] = ACTIONS(1443),
    [anon_sym_PLUS_PIPE] = ACTIONS(1443),
    [anon_sym_DASH_PIPE] = ACTIONS(1443),
    [anon_sym_PIPE_PIPE] = ACTIONS(1441),
    [anon_sym_SLASH] = ACTIONS(1443),
    [anon_sym_PERCENT] = ACTIONS(1443),
    [anon_sym_STAR_STAR] = ACTIONS(1441),
    [anon_sym_STAR_PERCENT] = ACTIONS(1443),
    [anon_sym_STAR_PIPE] = ACTIONS(1443),
    [anon_sym_align] = ACTIONS(1441),
    [anon_sym_DOT_STAR] = ACTIONS(1441),
    [anon_sym_DOT_QMARK] = ACTIONS(1441),
    [sym_line_comment] = ACTIONS(137),
  },
  [991] = {
    [anon_sym_COMMA] = ACTIONS(1445),
    [anon_sym_SEMI] = ACTIONS(1445),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_COLON] = ACTIONS(1445),
    [anon_sym_EQ] = ACTIONS(1447),
    [anon_sym_else] = ACTIONS(1445),
    [anon_sym_or] = ACTIONS(1447),
    [anon_sym_and] = ACTIONS(1445),
    [anon_sym_LBRACE] = ACTIONS(1445),
    [anon_sym_RBRACE] = ACTIONS(1445),
    [anon_sym_DOT] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1445),
    [anon_sym_RPAREN] = ACTIONS(1445),
    [anon_sym_LBRACK] = ACTIONS(1445),
    [anon_sym_RBRACK] = ACTIONS(1445),
    [anon_sym_linksection] = ACTIONS(1445),
    [anon_sym_addrspace] = ACTIONS(1445),
    [anon_sym_PIPE] = ACTIONS(1447),
    [anon_sym_STAR] = ACTIONS(1447),
    [anon_sym_EQ_GT] = ACTIONS(1445),
    [anon_sym_DOT_DOT] = ACTIONS(1445),
    [anon_sym_STAR_EQ] = ACTIONS(1445),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1445),
    [anon_sym_SLASH_EQ] = ACTIONS(1445),
    [anon_sym_PERCENT_EQ] = ACTIONS(1445),
    [anon_sym_PLUS_EQ] = ACTIONS(1445),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1445),
    [anon_sym_DASH_EQ] = ACTIONS(1445),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1445),
    [anon_sym_LT_LT_EQ] = ACTIONS(1445),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1445),
    [anon_sym_GT_GT_EQ] = ACTIONS(1445),
    [anon_sym_AMP_EQ] = ACTIONS(1445),
    [anon_sym_CARET_EQ] = ACTIONS(1445),
    [anon_sym_PIPE_EQ] = ACTIONS(1445),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1445),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1445),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1445),
    [anon_sym_EQ_EQ] = ACTIONS(1445),
    [anon_sym_BANG_EQ] = ACTIONS(1445),
    [anon_sym_LT] = ACTIONS(1447),
    [anon_sym_GT] = ACTIONS(1447),
    [anon_sym_LT_EQ] = ACTIONS(1445),
    [anon_sym_GT_EQ] = ACTIONS(1445),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_CARET] = ACTIONS(1447),
    [anon_sym_orelse] = ACTIONS(1445),
    [anon_sym_catch] = ACTIONS(1445),
    [anon_sym_LT_LT] = ACTIONS(1447),
    [anon_sym_GT_GT] = ACTIONS(1447),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1447),
    [anon_sym_PLUS] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [anon_sym_PLUS_PLUS] = ACTIONS(1445),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1447),
    [anon_sym_DASH_PERCENT] = ACTIONS(1447),
    [anon_sym_PLUS_PIPE] = ACTIONS(1447),
    [anon_sym_DASH_PIPE] = ACTIONS(1447),
    [anon_sym_PIPE_PIPE] = ACTIONS(1445),
    [anon_sym_SLASH] = ACTIONS(1447),
    [anon_sym_PERCENT] = ACTIONS(1447),
    [anon_sym_STAR_STAR] = ACTIONS(1445),
    [anon_sym_STAR_PERCENT] = ACTIONS(1447),
    [anon_sym_STAR_PIPE] = ACTIONS(1447),
    [anon_sym_align] = ACTIONS(1445),
    [anon_sym_DOT_STAR] = ACTIONS(1445),
    [anon_sym_DOT_QMARK] = ACTIONS(1445),
    [sym_line_comment] = ACTIONS(137),
  },
  [992] = {
    [anon_sym_COMMA] = ACTIONS(534),
    [anon_sym_SEMI] = ACTIONS(534),
    [anon_sym_BANG] = ACTIONS(532),
    [anon_sym_COLON] = ACTIONS(534),
    [anon_sym_EQ] = ACTIONS(532),
    [anon_sym_else] = ACTIONS(534),
    [anon_sym_or] = ACTIONS(532),
    [anon_sym_and] = ACTIONS(534),
    [anon_sym_LBRACE] = ACTIONS(534),
    [anon_sym_RBRACE] = ACTIONS(534),
    [anon_sym_DOT] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_RPAREN] = ACTIONS(534),
    [anon_sym_LBRACK] = ACTIONS(534),
    [anon_sym_RBRACK] = ACTIONS(534),
    [anon_sym_linksection] = ACTIONS(534),
    [anon_sym_addrspace] = ACTIONS(534),
    [anon_sym_PIPE] = ACTIONS(532),
    [anon_sym_STAR] = ACTIONS(532),
    [anon_sym_EQ_GT] = ACTIONS(534),
    [anon_sym_DOT_DOT] = ACTIONS(534),
    [anon_sym_STAR_EQ] = ACTIONS(534),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(534),
    [anon_sym_SLASH_EQ] = ACTIONS(534),
    [anon_sym_PERCENT_EQ] = ACTIONS(534),
    [anon_sym_PLUS_EQ] = ACTIONS(534),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(534),
    [anon_sym_DASH_EQ] = ACTIONS(534),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(534),
    [anon_sym_LT_LT_EQ] = ACTIONS(534),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(534),
    [anon_sym_GT_GT_EQ] = ACTIONS(534),
    [anon_sym_AMP_EQ] = ACTIONS(534),
    [anon_sym_CARET_EQ] = ACTIONS(534),
    [anon_sym_PIPE_EQ] = ACTIONS(534),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(534),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(534),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(534),
    [anon_sym_EQ_EQ] = ACTIONS(534),
    [anon_sym_BANG_EQ] = ACTIONS(534),
    [anon_sym_LT] = ACTIONS(532),
    [anon_sym_GT] = ACTIONS(532),
    [anon_sym_LT_EQ] = ACTIONS(534),
    [anon_sym_GT_EQ] = ACTIONS(534),
    [anon_sym_AMP] = ACTIONS(532),
    [anon_sym_CARET] = ACTIONS(532),
    [anon_sym_orelse] = ACTIONS(534),
    [anon_sym_catch] = ACTIONS(534),
    [anon_sym_LT_LT] = ACTIONS(532),
    [anon_sym_GT_GT] = ACTIONS(532),
    [anon_sym_LT_LT_PIPE] = ACTIONS(532),
    [anon_sym_PLUS] = ACTIONS(532),
    [anon_sym_DASH] = ACTIONS(532),
    [anon_sym_PLUS_PLUS] = ACTIONS(534),
    [anon_sym_PLUS_PERCENT] = ACTIONS(532),
    [anon_sym_DASH_PERCENT] = ACTIONS(532),
    [anon_sym_PLUS_PIPE] = ACTIONS(532),
    [anon_sym_DASH_PIPE] = ACTIONS(532),
    [anon_sym_PIPE_PIPE] = ACTIONS(534),
    [anon_sym_SLASH] = ACTIONS(532),
    [anon_sym_PERCENT] = ACTIONS(532),
    [anon_sym_STAR_STAR] = ACTIONS(534),
    [anon_sym_STAR_PERCENT] = ACTIONS(532),
    [anon_sym_STAR_PIPE] = ACTIONS(532),
    [anon_sym_align] = ACTIONS(534),
    [anon_sym_DOT_STAR] = ACTIONS(534),
    [anon_sym_DOT_QMARK] = ACTIONS(534),
    [sym_line_comment] = ACTIONS(137),
  },
  [993] = {
    [anon_sym_COMMA] = ACTIONS(1453),
    [anon_sym_SEMI] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(1455),
    [anon_sym_COLON] = ACTIONS(1453),
    [anon_sym_EQ] = ACTIONS(1455),
    [anon_sym_else] = ACTIONS(1453),
    [anon_sym_or] = ACTIONS(1455),
    [anon_sym_and] = ACTIONS(1453),
    [anon_sym_LBRACE] = ACTIONS(1453),
    [anon_sym_RBRACE] = ACTIONS(1453),
    [anon_sym_DOT] = ACTIONS(1455),
    [anon_sym_LPAREN] = ACTIONS(1453),
    [anon_sym_RPAREN] = ACTIONS(1453),
    [anon_sym_LBRACK] = ACTIONS(1453),
    [anon_sym_RBRACK] = ACTIONS(1453),
    [anon_sym_linksection] = ACTIONS(1453),
    [anon_sym_addrspace] = ACTIONS(1453),
    [anon_sym_PIPE] = ACTIONS(1455),
    [anon_sym_STAR] = ACTIONS(1455),
    [anon_sym_EQ_GT] = ACTIONS(1453),
    [anon_sym_DOT_DOT] = ACTIONS(1453),
    [anon_sym_STAR_EQ] = ACTIONS(1453),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1453),
    [anon_sym_SLASH_EQ] = ACTIONS(1453),
    [anon_sym_PERCENT_EQ] = ACTIONS(1453),
    [anon_sym_PLUS_EQ] = ACTIONS(1453),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1453),
    [anon_sym_DASH_EQ] = ACTIONS(1453),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1453),
    [anon_sym_LT_LT_EQ] = ACTIONS(1453),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1453),
    [anon_sym_GT_GT_EQ] = ACTIONS(1453),
    [anon_sym_AMP_EQ] = ACTIONS(1453),
    [anon_sym_CARET_EQ] = ACTIONS(1453),
    [anon_sym_PIPE_EQ] = ACTIONS(1453),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1453),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1453),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1453),
    [anon_sym_EQ_EQ] = ACTIONS(1453),
    [anon_sym_BANG_EQ] = ACTIONS(1453),
    [anon_sym_LT] = ACTIONS(1455),
    [anon_sym_GT] = ACTIONS(1455),
    [anon_sym_LT_EQ] = ACTIONS(1453),
    [anon_sym_GT_EQ] = ACTIONS(1453),
    [anon_sym_AMP] = ACTIONS(1455),
    [anon_sym_CARET] = ACTIONS(1455),
    [anon_sym_orelse] = ACTIONS(1453),
    [anon_sym_catch] = ACTIONS(1453),
    [anon_sym_LT_LT] = ACTIONS(1455),
    [anon_sym_GT_GT] = ACTIONS(1455),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1455),
    [anon_sym_PLUS] = ACTIONS(1455),
    [anon_sym_DASH] = ACTIONS(1455),
    [anon_sym_PLUS_PLUS] = ACTIONS(1453),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1455),
    [anon_sym_DASH_PERCENT] = ACTIONS(1455),
    [anon_sym_PLUS_PIPE] = ACTIONS(1455),
    [anon_sym_DASH_PIPE] = ACTIONS(1455),
    [anon_sym_PIPE_PIPE] = ACTIONS(1453),
    [anon_sym_SLASH] = ACTIONS(1455),
    [anon_sym_PERCENT] = ACTIONS(1455),
    [anon_sym_STAR_STAR] = ACTIONS(1453),
    [anon_sym_STAR_PERCENT] = ACTIONS(1455),
    [anon_sym_STAR_PIPE] = ACTIONS(1455),
    [anon_sym_align] = ACTIONS(1453),
    [anon_sym_DOT_STAR] = ACTIONS(1453),
    [anon_sym_DOT_QMARK] = ACTIONS(1453),
    [sym_line_comment] = ACTIONS(137),
  },
  [994] = {
    [anon_sym_COMMA] = ACTIONS(1269),
    [anon_sym_SEMI] = ACTIONS(1269),
    [anon_sym_BANG] = ACTIONS(1271),
    [anon_sym_COLON] = ACTIONS(1269),
    [anon_sym_EQ] = ACTIONS(1271),
    [anon_sym_else] = ACTIONS(1269),
    [anon_sym_or] = ACTIONS(1271),
    [anon_sym_and] = ACTIONS(1269),
    [anon_sym_LBRACE] = ACTIONS(1269),
    [anon_sym_RBRACE] = ACTIONS(1269),
    [anon_sym_DOT] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_RPAREN] = ACTIONS(1269),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_RBRACK] = ACTIONS(1269),
    [anon_sym_linksection] = ACTIONS(1269),
    [anon_sym_addrspace] = ACTIONS(1269),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(1271),
    [anon_sym_EQ_GT] = ACTIONS(1269),
    [anon_sym_DOT_DOT] = ACTIONS(1269),
    [anon_sym_STAR_EQ] = ACTIONS(1269),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1269),
    [anon_sym_SLASH_EQ] = ACTIONS(1269),
    [anon_sym_PERCENT_EQ] = ACTIONS(1269),
    [anon_sym_PLUS_EQ] = ACTIONS(1269),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1269),
    [anon_sym_DASH_EQ] = ACTIONS(1269),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1269),
    [anon_sym_LT_LT_EQ] = ACTIONS(1269),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1269),
    [anon_sym_GT_GT_EQ] = ACTIONS(1269),
    [anon_sym_AMP_EQ] = ACTIONS(1269),
    [anon_sym_CARET_EQ] = ACTIONS(1269),
    [anon_sym_PIPE_EQ] = ACTIONS(1269),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1269),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1269),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1269),
    [anon_sym_EQ_EQ] = ACTIONS(1269),
    [anon_sym_BANG_EQ] = ACTIONS(1269),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_LT_EQ] = ACTIONS(1269),
    [anon_sym_GT_EQ] = ACTIONS(1269),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_CARET] = ACTIONS(1271),
    [anon_sym_orelse] = ACTIONS(1269),
    [anon_sym_catch] = ACTIONS(1269),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1271),
    [anon_sym_PLUS] = ACTIONS(1271),
    [anon_sym_DASH] = ACTIONS(1271),
    [anon_sym_PLUS_PLUS] = ACTIONS(1269),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1271),
    [anon_sym_DASH_PERCENT] = ACTIONS(1271),
    [anon_sym_PLUS_PIPE] = ACTIONS(1271),
    [anon_sym_DASH_PIPE] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1269),
    [anon_sym_SLASH] = ACTIONS(1271),
    [anon_sym_PERCENT] = ACTIONS(1271),
    [anon_sym_STAR_STAR] = ACTIONS(1269),
    [anon_sym_STAR_PERCENT] = ACTIONS(1271),
    [anon_sym_STAR_PIPE] = ACTIONS(1271),
    [anon_sym_align] = ACTIONS(1269),
    [anon_sym_DOT_STAR] = ACTIONS(1269),
    [anon_sym_DOT_QMARK] = ACTIONS(1269),
    [sym_line_comment] = ACTIONS(137),
  },
  [995] = {
    [anon_sym_COMMA] = ACTIONS(566),
    [anon_sym_SEMI] = ACTIONS(566),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_COLON] = ACTIONS(566),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_else] = ACTIONS(566),
    [anon_sym_or] = ACTIONS(564),
    [anon_sym_and] = ACTIONS(566),
    [anon_sym_LBRACE] = ACTIONS(566),
    [anon_sym_RBRACE] = ACTIONS(566),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_RPAREN] = ACTIONS(566),
    [anon_sym_LBRACK] = ACTIONS(566),
    [anon_sym_RBRACK] = ACTIONS(566),
    [anon_sym_linksection] = ACTIONS(566),
    [anon_sym_addrspace] = ACTIONS(566),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_EQ_GT] = ACTIONS(566),
    [anon_sym_DOT_DOT] = ACTIONS(566),
    [anon_sym_STAR_EQ] = ACTIONS(566),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(566),
    [anon_sym_SLASH_EQ] = ACTIONS(566),
    [anon_sym_PERCENT_EQ] = ACTIONS(566),
    [anon_sym_PLUS_EQ] = ACTIONS(566),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(566),
    [anon_sym_DASH_EQ] = ACTIONS(566),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(566),
    [anon_sym_LT_LT_EQ] = ACTIONS(566),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(566),
    [anon_sym_GT_GT_EQ] = ACTIONS(566),
    [anon_sym_AMP_EQ] = ACTIONS(566),
    [anon_sym_CARET_EQ] = ACTIONS(566),
    [anon_sym_PIPE_EQ] = ACTIONS(566),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(566),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(566),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(566),
    [anon_sym_EQ_EQ] = ACTIONS(566),
    [anon_sym_BANG_EQ] = ACTIONS(566),
    [anon_sym_LT] = ACTIONS(564),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_LT_EQ] = ACTIONS(566),
    [anon_sym_GT_EQ] = ACTIONS(566),
    [anon_sym_AMP] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym_orelse] = ACTIONS(566),
    [anon_sym_catch] = ACTIONS(566),
    [anon_sym_LT_LT] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(564),
    [anon_sym_LT_LT_PIPE] = ACTIONS(564),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_PLUS_PLUS] = ACTIONS(566),
    [anon_sym_PLUS_PERCENT] = ACTIONS(564),
    [anon_sym_DASH_PERCENT] = ACTIONS(564),
    [anon_sym_PLUS_PIPE] = ACTIONS(564),
    [anon_sym_DASH_PIPE] = ACTIONS(564),
    [anon_sym_PIPE_PIPE] = ACTIONS(566),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_STAR_STAR] = ACTIONS(566),
    [anon_sym_STAR_PERCENT] = ACTIONS(564),
    [anon_sym_STAR_PIPE] = ACTIONS(564),
    [anon_sym_align] = ACTIONS(566),
    [anon_sym_DOT_STAR] = ACTIONS(566),
    [anon_sym_DOT_QMARK] = ACTIONS(566),
    [sym_line_comment] = ACTIONS(137),
  },
  [996] = {
    [anon_sym_COMMA] = ACTIONS(1213),
    [anon_sym_SEMI] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_COLON] = ACTIONS(1213),
    [anon_sym_EQ] = ACTIONS(1215),
    [anon_sym_else] = ACTIONS(1213),
    [anon_sym_or] = ACTIONS(1215),
    [anon_sym_and] = ACTIONS(1213),
    [anon_sym_LBRACE] = ACTIONS(1213),
    [anon_sym_RBRACE] = ACTIONS(1213),
    [anon_sym_DOT] = ACTIONS(1215),
    [anon_sym_LPAREN] = ACTIONS(1213),
    [anon_sym_RPAREN] = ACTIONS(1213),
    [anon_sym_LBRACK] = ACTIONS(1213),
    [anon_sym_RBRACK] = ACTIONS(1213),
    [anon_sym_linksection] = ACTIONS(1213),
    [anon_sym_addrspace] = ACTIONS(1213),
    [anon_sym_PIPE] = ACTIONS(1215),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_EQ_GT] = ACTIONS(1213),
    [anon_sym_DOT_DOT] = ACTIONS(1213),
    [anon_sym_STAR_EQ] = ACTIONS(1213),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1213),
    [anon_sym_SLASH_EQ] = ACTIONS(1213),
    [anon_sym_PERCENT_EQ] = ACTIONS(1213),
    [anon_sym_PLUS_EQ] = ACTIONS(1213),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1213),
    [anon_sym_DASH_EQ] = ACTIONS(1213),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1213),
    [anon_sym_LT_LT_EQ] = ACTIONS(1213),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1213),
    [anon_sym_GT_GT_EQ] = ACTIONS(1213),
    [anon_sym_AMP_EQ] = ACTIONS(1213),
    [anon_sym_CARET_EQ] = ACTIONS(1213),
    [anon_sym_PIPE_EQ] = ACTIONS(1213),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1213),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1213),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1213),
    [anon_sym_EQ_EQ] = ACTIONS(1213),
    [anon_sym_BANG_EQ] = ACTIONS(1213),
    [anon_sym_LT] = ACTIONS(1215),
    [anon_sym_GT] = ACTIONS(1215),
    [anon_sym_LT_EQ] = ACTIONS(1213),
    [anon_sym_GT_EQ] = ACTIONS(1213),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_orelse] = ACTIONS(1213),
    [anon_sym_catch] = ACTIONS(1213),
    [anon_sym_LT_LT] = ACTIONS(1215),
    [anon_sym_GT_GT] = ACTIONS(1215),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1215),
    [anon_sym_PLUS] = ACTIONS(1215),
    [anon_sym_DASH] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1213),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1215),
    [anon_sym_DASH_PERCENT] = ACTIONS(1215),
    [anon_sym_PLUS_PIPE] = ACTIONS(1215),
    [anon_sym_DASH_PIPE] = ACTIONS(1215),
    [anon_sym_PIPE_PIPE] = ACTIONS(1213),
    [anon_sym_SLASH] = ACTIONS(1215),
    [anon_sym_PERCENT] = ACTIONS(1215),
    [anon_sym_STAR_STAR] = ACTIONS(1213),
    [anon_sym_STAR_PERCENT] = ACTIONS(1215),
    [anon_sym_STAR_PIPE] = ACTIONS(1215),
    [anon_sym_align] = ACTIONS(1213),
    [anon_sym_DOT_STAR] = ACTIONS(1213),
    [anon_sym_DOT_QMARK] = ACTIONS(1213),
    [sym_line_comment] = ACTIONS(137),
  },
  [997] = {
    [anon_sym_COMMA] = ACTIONS(1281),
    [anon_sym_SEMI] = ACTIONS(1281),
    [anon_sym_BANG] = ACTIONS(1283),
    [anon_sym_COLON] = ACTIONS(1281),
    [anon_sym_EQ] = ACTIONS(1283),
    [anon_sym_else] = ACTIONS(1281),
    [anon_sym_or] = ACTIONS(1283),
    [anon_sym_and] = ACTIONS(1281),
    [anon_sym_LBRACE] = ACTIONS(1281),
    [anon_sym_RBRACE] = ACTIONS(1281),
    [anon_sym_DOT] = ACTIONS(1283),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_RPAREN] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_RBRACK] = ACTIONS(1281),
    [anon_sym_linksection] = ACTIONS(1281),
    [anon_sym_addrspace] = ACTIONS(1281),
    [anon_sym_PIPE] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_EQ_GT] = ACTIONS(1281),
    [anon_sym_DOT_DOT] = ACTIONS(1281),
    [anon_sym_STAR_EQ] = ACTIONS(1281),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1281),
    [anon_sym_SLASH_EQ] = ACTIONS(1281),
    [anon_sym_PERCENT_EQ] = ACTIONS(1281),
    [anon_sym_PLUS_EQ] = ACTIONS(1281),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1281),
    [anon_sym_DASH_EQ] = ACTIONS(1281),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1281),
    [anon_sym_LT_LT_EQ] = ACTIONS(1281),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1281),
    [anon_sym_GT_GT_EQ] = ACTIONS(1281),
    [anon_sym_AMP_EQ] = ACTIONS(1281),
    [anon_sym_CARET_EQ] = ACTIONS(1281),
    [anon_sym_PIPE_EQ] = ACTIONS(1281),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1281),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1281),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1281),
    [anon_sym_EQ_EQ] = ACTIONS(1281),
    [anon_sym_BANG_EQ] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(1283),
    [anon_sym_LT_EQ] = ACTIONS(1281),
    [anon_sym_GT_EQ] = ACTIONS(1281),
    [anon_sym_AMP] = ACTIONS(1283),
    [anon_sym_CARET] = ACTIONS(1283),
    [anon_sym_orelse] = ACTIONS(1281),
    [anon_sym_catch] = ACTIONS(1281),
    [anon_sym_LT_LT] = ACTIONS(1283),
    [anon_sym_GT_GT] = ACTIONS(1283),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1283),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_PLUS_PLUS] = ACTIONS(1281),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1283),
    [anon_sym_DASH_PERCENT] = ACTIONS(1283),
    [anon_sym_PLUS_PIPE] = ACTIONS(1283),
    [anon_sym_DASH_PIPE] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE] = ACTIONS(1281),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_PERCENT] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1281),
    [anon_sym_STAR_PERCENT] = ACTIONS(1283),
    [anon_sym_STAR_PIPE] = ACTIONS(1283),
    [anon_sym_align] = ACTIONS(1281),
    [anon_sym_DOT_STAR] = ACTIONS(1281),
    [anon_sym_DOT_QMARK] = ACTIONS(1281),
    [sym_line_comment] = ACTIONS(137),
  },
  [998] = {
    [anon_sym_COMMA] = ACTIONS(1289),
    [anon_sym_SEMI] = ACTIONS(1289),
    [anon_sym_BANG] = ACTIONS(1291),
    [anon_sym_COLON] = ACTIONS(1289),
    [anon_sym_EQ] = ACTIONS(1291),
    [anon_sym_else] = ACTIONS(1289),
    [anon_sym_or] = ACTIONS(1291),
    [anon_sym_and] = ACTIONS(1289),
    [anon_sym_LBRACE] = ACTIONS(1289),
    [anon_sym_RBRACE] = ACTIONS(1289),
    [anon_sym_DOT] = ACTIONS(1291),
    [anon_sym_LPAREN] = ACTIONS(1289),
    [anon_sym_RPAREN] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_RBRACK] = ACTIONS(1289),
    [anon_sym_linksection] = ACTIONS(1289),
    [anon_sym_addrspace] = ACTIONS(1289),
    [anon_sym_PIPE] = ACTIONS(1291),
    [anon_sym_STAR] = ACTIONS(1291),
    [anon_sym_EQ_GT] = ACTIONS(1289),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym_STAR_EQ] = ACTIONS(1289),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1289),
    [anon_sym_SLASH_EQ] = ACTIONS(1289),
    [anon_sym_PERCENT_EQ] = ACTIONS(1289),
    [anon_sym_PLUS_EQ] = ACTIONS(1289),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1289),
    [anon_sym_DASH_EQ] = ACTIONS(1289),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1289),
    [anon_sym_LT_LT_EQ] = ACTIONS(1289),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1289),
    [anon_sym_GT_GT_EQ] = ACTIONS(1289),
    [anon_sym_AMP_EQ] = ACTIONS(1289),
    [anon_sym_CARET_EQ] = ACTIONS(1289),
    [anon_sym_PIPE_EQ] = ACTIONS(1289),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1289),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1289),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1289),
    [anon_sym_EQ_EQ] = ACTIONS(1289),
    [anon_sym_BANG_EQ] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1291),
    [anon_sym_GT] = ACTIONS(1291),
    [anon_sym_LT_EQ] = ACTIONS(1289),
    [anon_sym_GT_EQ] = ACTIONS(1289),
    [anon_sym_AMP] = ACTIONS(1291),
    [anon_sym_CARET] = ACTIONS(1291),
    [anon_sym_orelse] = ACTIONS(1289),
    [anon_sym_catch] = ACTIONS(1289),
    [anon_sym_LT_LT] = ACTIONS(1291),
    [anon_sym_GT_GT] = ACTIONS(1291),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1291),
    [anon_sym_PLUS] = ACTIONS(1291),
    [anon_sym_DASH] = ACTIONS(1291),
    [anon_sym_PLUS_PLUS] = ACTIONS(1289),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1291),
    [anon_sym_DASH_PERCENT] = ACTIONS(1291),
    [anon_sym_PLUS_PIPE] = ACTIONS(1291),
    [anon_sym_DASH_PIPE] = ACTIONS(1291),
    [anon_sym_PIPE_PIPE] = ACTIONS(1289),
    [anon_sym_SLASH] = ACTIONS(1291),
    [anon_sym_PERCENT] = ACTIONS(1291),
    [anon_sym_STAR_STAR] = ACTIONS(1289),
    [anon_sym_STAR_PERCENT] = ACTIONS(1291),
    [anon_sym_STAR_PIPE] = ACTIONS(1291),
    [anon_sym_align] = ACTIONS(1289),
    [anon_sym_DOT_STAR] = ACTIONS(1289),
    [anon_sym_DOT_QMARK] = ACTIONS(1289),
    [sym_line_comment] = ACTIONS(137),
  },
  [999] = {
    [anon_sym_COMMA] = ACTIONS(1357),
    [anon_sym_SEMI] = ACTIONS(1357),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_COLON] = ACTIONS(1357),
    [anon_sym_EQ] = ACTIONS(1359),
    [anon_sym_else] = ACTIONS(1357),
    [anon_sym_or] = ACTIONS(1359),
    [anon_sym_and] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1357),
    [anon_sym_RBRACE] = ACTIONS(1357),
    [anon_sym_DOT] = ACTIONS(1359),
    [anon_sym_LPAREN] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(1357),
    [anon_sym_LBRACK] = ACTIONS(1357),
    [anon_sym_RBRACK] = ACTIONS(1357),
    [anon_sym_linksection] = ACTIONS(1357),
    [anon_sym_addrspace] = ACTIONS(1357),
    [anon_sym_PIPE] = ACTIONS(1359),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_EQ_GT] = ACTIONS(1357),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_STAR_EQ] = ACTIONS(1357),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1357),
    [anon_sym_SLASH_EQ] = ACTIONS(1357),
    [anon_sym_PERCENT_EQ] = ACTIONS(1357),
    [anon_sym_PLUS_EQ] = ACTIONS(1357),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1357),
    [anon_sym_DASH_EQ] = ACTIONS(1357),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1357),
    [anon_sym_LT_LT_EQ] = ACTIONS(1357),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1357),
    [anon_sym_GT_GT_EQ] = ACTIONS(1357),
    [anon_sym_AMP_EQ] = ACTIONS(1357),
    [anon_sym_CARET_EQ] = ACTIONS(1357),
    [anon_sym_PIPE_EQ] = ACTIONS(1357),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1357),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1357),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1357),
    [anon_sym_EQ_EQ] = ACTIONS(1357),
    [anon_sym_BANG_EQ] = ACTIONS(1357),
    [anon_sym_LT] = ACTIONS(1359),
    [anon_sym_GT] = ACTIONS(1359),
    [anon_sym_LT_EQ] = ACTIONS(1357),
    [anon_sym_GT_EQ] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_orelse] = ACTIONS(1357),
    [anon_sym_catch] = ACTIONS(1357),
    [anon_sym_LT_LT] = ACTIONS(1359),
    [anon_sym_GT_GT] = ACTIONS(1359),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1359),
    [anon_sym_DASH] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1357),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1359),
    [anon_sym_DASH_PERCENT] = ACTIONS(1359),
    [anon_sym_PLUS_PIPE] = ACTIONS(1359),
    [anon_sym_DASH_PIPE] = ACTIONS(1359),
    [anon_sym_PIPE_PIPE] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1359),
    [anon_sym_PERCENT] = ACTIONS(1359),
    [anon_sym_STAR_STAR] = ACTIONS(1357),
    [anon_sym_STAR_PERCENT] = ACTIONS(1359),
    [anon_sym_STAR_PIPE] = ACTIONS(1359),
    [anon_sym_align] = ACTIONS(1357),
    [anon_sym_DOT_STAR] = ACTIONS(1357),
    [anon_sym_DOT_QMARK] = ACTIONS(1357),
    [sym_line_comment] = ACTIONS(137),
  },
  [1000] = {
    [anon_sym_COMMA] = ACTIONS(1107),
    [anon_sym_SEMI] = ACTIONS(1107),
    [anon_sym_BANG] = ACTIONS(1105),
    [anon_sym_COLON] = ACTIONS(1107),
    [anon_sym_EQ] = ACTIONS(1105),
    [anon_sym_else] = ACTIONS(1107),
    [anon_sym_or] = ACTIONS(1105),
    [anon_sym_and] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1107),
    [anon_sym_RBRACE] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1107),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_RBRACK] = ACTIONS(1107),
    [anon_sym_linksection] = ACTIONS(1107),
    [anon_sym_addrspace] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(1105),
    [anon_sym_STAR] = ACTIONS(1105),
    [anon_sym_EQ_GT] = ACTIONS(1107),
    [anon_sym_DOT_DOT] = ACTIONS(1107),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_EQ_EQ] = ACTIONS(1107),
    [anon_sym_BANG_EQ] = ACTIONS(1107),
    [anon_sym_LT] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(1105),
    [anon_sym_LT_EQ] = ACTIONS(1107),
    [anon_sym_GT_EQ] = ACTIONS(1107),
    [anon_sym_AMP] = ACTIONS(1105),
    [anon_sym_CARET] = ACTIONS(1105),
    [anon_sym_orelse] = ACTIONS(1107),
    [anon_sym_catch] = ACTIONS(1107),
    [anon_sym_LT_LT] = ACTIONS(1105),
    [anon_sym_GT_GT] = ACTIONS(1105),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1105),
    [anon_sym_PLUS] = ACTIONS(1105),
    [anon_sym_DASH] = ACTIONS(1105),
    [anon_sym_PLUS_PLUS] = ACTIONS(1107),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1105),
    [anon_sym_DASH_PERCENT] = ACTIONS(1105),
    [anon_sym_PLUS_PIPE] = ACTIONS(1105),
    [anon_sym_DASH_PIPE] = ACTIONS(1105),
    [anon_sym_PIPE_PIPE] = ACTIONS(1107),
    [anon_sym_SLASH] = ACTIONS(1105),
    [anon_sym_PERCENT] = ACTIONS(1105),
    [anon_sym_STAR_STAR] = ACTIONS(1107),
    [anon_sym_STAR_PERCENT] = ACTIONS(1105),
    [anon_sym_STAR_PIPE] = ACTIONS(1105),
    [anon_sym_align] = ACTIONS(1107),
    [anon_sym_DOT_STAR] = ACTIONS(1107),
    [anon_sym_DOT_QMARK] = ACTIONS(1107),
    [sym_line_comment] = ACTIONS(137),
  },
  [1001] = {
    [anon_sym_COMMA] = ACTIONS(1457),
    [anon_sym_SEMI] = ACTIONS(1457),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_COLON] = ACTIONS(1457),
    [anon_sym_EQ] = ACTIONS(1459),
    [anon_sym_else] = ACTIONS(1457),
    [anon_sym_or] = ACTIONS(1459),
    [anon_sym_and] = ACTIONS(1457),
    [anon_sym_LBRACE] = ACTIONS(1457),
    [anon_sym_RBRACE] = ACTIONS(1457),
    [anon_sym_DOT] = ACTIONS(1459),
    [anon_sym_LPAREN] = ACTIONS(1457),
    [anon_sym_RPAREN] = ACTIONS(1457),
    [anon_sym_LBRACK] = ACTIONS(1457),
    [anon_sym_RBRACK] = ACTIONS(1457),
    [anon_sym_linksection] = ACTIONS(1457),
    [anon_sym_addrspace] = ACTIONS(1457),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_EQ_GT] = ACTIONS(1457),
    [anon_sym_DOT_DOT] = ACTIONS(1457),
    [anon_sym_STAR_EQ] = ACTIONS(1457),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1457),
    [anon_sym_SLASH_EQ] = ACTIONS(1457),
    [anon_sym_PERCENT_EQ] = ACTIONS(1457),
    [anon_sym_PLUS_EQ] = ACTIONS(1457),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1457),
    [anon_sym_DASH_EQ] = ACTIONS(1457),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1457),
    [anon_sym_LT_LT_EQ] = ACTIONS(1457),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1457),
    [anon_sym_GT_GT_EQ] = ACTIONS(1457),
    [anon_sym_AMP_EQ] = ACTIONS(1457),
    [anon_sym_CARET_EQ] = ACTIONS(1457),
    [anon_sym_PIPE_EQ] = ACTIONS(1457),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1457),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1457),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1457),
    [anon_sym_EQ_EQ] = ACTIONS(1457),
    [anon_sym_BANG_EQ] = ACTIONS(1457),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_LT_EQ] = ACTIONS(1457),
    [anon_sym_GT_EQ] = ACTIONS(1457),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_orelse] = ACTIONS(1457),
    [anon_sym_catch] = ACTIONS(1457),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1459),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1459),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_DASH] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1457),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1459),
    [anon_sym_DASH_PERCENT] = ACTIONS(1459),
    [anon_sym_PLUS_PIPE] = ACTIONS(1459),
    [anon_sym_DASH_PIPE] = ACTIONS(1459),
    [anon_sym_PIPE_PIPE] = ACTIONS(1457),
    [anon_sym_SLASH] = ACTIONS(1459),
    [anon_sym_PERCENT] = ACTIONS(1459),
    [anon_sym_STAR_STAR] = ACTIONS(1457),
    [anon_sym_STAR_PERCENT] = ACTIONS(1459),
    [anon_sym_STAR_PIPE] = ACTIONS(1459),
    [anon_sym_align] = ACTIONS(1457),
    [anon_sym_DOT_STAR] = ACTIONS(1457),
    [anon_sym_DOT_QMARK] = ACTIONS(1457),
    [sym_line_comment] = ACTIONS(137),
  },
  [1002] = {
    [anon_sym_COMMA] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(1349),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1349),
    [anon_sym_or] = ACTIONS(1351),
    [anon_sym_and] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1349),
    [anon_sym_RBRACE] = ACTIONS(1349),
    [anon_sym_DOT] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_RPAREN] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1349),
    [anon_sym_RBRACK] = ACTIONS(1349),
    [anon_sym_linksection] = ACTIONS(1349),
    [anon_sym_addrspace] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1351),
    [anon_sym_STAR] = ACTIONS(1351),
    [anon_sym_EQ_GT] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_STAR_EQ] = ACTIONS(1349),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1349),
    [anon_sym_SLASH_EQ] = ACTIONS(1349),
    [anon_sym_PERCENT_EQ] = ACTIONS(1349),
    [anon_sym_PLUS_EQ] = ACTIONS(1349),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1349),
    [anon_sym_DASH_EQ] = ACTIONS(1349),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1349),
    [anon_sym_LT_LT_EQ] = ACTIONS(1349),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1349),
    [anon_sym_GT_GT_EQ] = ACTIONS(1349),
    [anon_sym_AMP_EQ] = ACTIONS(1349),
    [anon_sym_CARET_EQ] = ACTIONS(1349),
    [anon_sym_PIPE_EQ] = ACTIONS(1349),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1349),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1349),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1349),
    [anon_sym_EQ_EQ] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1349),
    [anon_sym_LT] = ACTIONS(1351),
    [anon_sym_GT] = ACTIONS(1351),
    [anon_sym_LT_EQ] = ACTIONS(1349),
    [anon_sym_GT_EQ] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_CARET] = ACTIONS(1351),
    [anon_sym_orelse] = ACTIONS(1349),
    [anon_sym_catch] = ACTIONS(1349),
    [anon_sym_LT_LT] = ACTIONS(1351),
    [anon_sym_GT_GT] = ACTIONS(1351),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1351),
    [anon_sym_PLUS] = ACTIONS(1351),
    [anon_sym_DASH] = ACTIONS(1351),
    [anon_sym_PLUS_PLUS] = ACTIONS(1349),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1351),
    [anon_sym_DASH_PERCENT] = ACTIONS(1351),
    [anon_sym_PLUS_PIPE] = ACTIONS(1351),
    [anon_sym_DASH_PIPE] = ACTIONS(1351),
    [anon_sym_PIPE_PIPE] = ACTIONS(1349),
    [anon_sym_SLASH] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1351),
    [anon_sym_STAR_STAR] = ACTIONS(1349),
    [anon_sym_STAR_PERCENT] = ACTIONS(1351),
    [anon_sym_STAR_PIPE] = ACTIONS(1351),
    [anon_sym_align] = ACTIONS(1349),
    [anon_sym_DOT_STAR] = ACTIONS(1349),
    [anon_sym_DOT_QMARK] = ACTIONS(1349),
    [sym_line_comment] = ACTIONS(137),
  },
  [1003] = {
    [anon_sym_COMMA] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(570),
    [anon_sym_BANG] = ACTIONS(568),
    [anon_sym_COLON] = ACTIONS(570),
    [anon_sym_EQ] = ACTIONS(568),
    [anon_sym_else] = ACTIONS(570),
    [anon_sym_or] = ACTIONS(568),
    [anon_sym_and] = ACTIONS(570),
    [anon_sym_LBRACE] = ACTIONS(570),
    [anon_sym_RBRACE] = ACTIONS(570),
    [anon_sym_DOT] = ACTIONS(568),
    [anon_sym_LPAREN] = ACTIONS(570),
    [anon_sym_RPAREN] = ACTIONS(570),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(570),
    [anon_sym_linksection] = ACTIONS(570),
    [anon_sym_addrspace] = ACTIONS(570),
    [anon_sym_PIPE] = ACTIONS(568),
    [anon_sym_STAR] = ACTIONS(568),
    [anon_sym_EQ_GT] = ACTIONS(570),
    [anon_sym_DOT_DOT] = ACTIONS(570),
    [anon_sym_STAR_EQ] = ACTIONS(570),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(570),
    [anon_sym_SLASH_EQ] = ACTIONS(570),
    [anon_sym_PERCENT_EQ] = ACTIONS(570),
    [anon_sym_PLUS_EQ] = ACTIONS(570),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(570),
    [anon_sym_DASH_EQ] = ACTIONS(570),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(570),
    [anon_sym_LT_LT_EQ] = ACTIONS(570),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(570),
    [anon_sym_GT_GT_EQ] = ACTIONS(570),
    [anon_sym_AMP_EQ] = ACTIONS(570),
    [anon_sym_CARET_EQ] = ACTIONS(570),
    [anon_sym_PIPE_EQ] = ACTIONS(570),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(570),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(570),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(570),
    [anon_sym_EQ_EQ] = ACTIONS(570),
    [anon_sym_BANG_EQ] = ACTIONS(570),
    [anon_sym_LT] = ACTIONS(568),
    [anon_sym_GT] = ACTIONS(568),
    [anon_sym_LT_EQ] = ACTIONS(570),
    [anon_sym_GT_EQ] = ACTIONS(570),
    [anon_sym_AMP] = ACTIONS(568),
    [anon_sym_CARET] = ACTIONS(568),
    [anon_sym_orelse] = ACTIONS(570),
    [anon_sym_catch] = ACTIONS(570),
    [anon_sym_LT_LT] = ACTIONS(568),
    [anon_sym_GT_GT] = ACTIONS(568),
    [anon_sym_LT_LT_PIPE] = ACTIONS(568),
    [anon_sym_PLUS] = ACTIONS(568),
    [anon_sym_DASH] = ACTIONS(568),
    [anon_sym_PLUS_PLUS] = ACTIONS(570),
    [anon_sym_PLUS_PERCENT] = ACTIONS(568),
    [anon_sym_DASH_PERCENT] = ACTIONS(568),
    [anon_sym_PLUS_PIPE] = ACTIONS(568),
    [anon_sym_DASH_PIPE] = ACTIONS(568),
    [anon_sym_PIPE_PIPE] = ACTIONS(570),
    [anon_sym_SLASH] = ACTIONS(568),
    [anon_sym_PERCENT] = ACTIONS(568),
    [anon_sym_STAR_STAR] = ACTIONS(570),
    [anon_sym_STAR_PERCENT] = ACTIONS(568),
    [anon_sym_STAR_PIPE] = ACTIONS(568),
    [anon_sym_align] = ACTIONS(570),
    [anon_sym_DOT_STAR] = ACTIONS(570),
    [anon_sym_DOT_QMARK] = ACTIONS(570),
    [sym_line_comment] = ACTIONS(137),
  },
  [1004] = {
    [anon_sym_COMMA] = ACTIONS(1297),
    [anon_sym_SEMI] = ACTIONS(1297),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_COLON] = ACTIONS(1297),
    [anon_sym_EQ] = ACTIONS(1299),
    [anon_sym_else] = ACTIONS(1297),
    [anon_sym_or] = ACTIONS(1299),
    [anon_sym_and] = ACTIONS(1297),
    [anon_sym_LBRACE] = ACTIONS(1297),
    [anon_sym_RBRACE] = ACTIONS(1297),
    [anon_sym_DOT] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1297),
    [anon_sym_RPAREN] = ACTIONS(1297),
    [anon_sym_LBRACK] = ACTIONS(1297),
    [anon_sym_RBRACK] = ACTIONS(1297),
    [anon_sym_linksection] = ACTIONS(1297),
    [anon_sym_addrspace] = ACTIONS(1297),
    [anon_sym_PIPE] = ACTIONS(1299),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_EQ_GT] = ACTIONS(1297),
    [anon_sym_DOT_DOT] = ACTIONS(1297),
    [anon_sym_STAR_EQ] = ACTIONS(1297),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1297),
    [anon_sym_SLASH_EQ] = ACTIONS(1297),
    [anon_sym_PERCENT_EQ] = ACTIONS(1297),
    [anon_sym_PLUS_EQ] = ACTIONS(1297),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1297),
    [anon_sym_DASH_EQ] = ACTIONS(1297),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1297),
    [anon_sym_LT_LT_EQ] = ACTIONS(1297),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1297),
    [anon_sym_GT_GT_EQ] = ACTIONS(1297),
    [anon_sym_AMP_EQ] = ACTIONS(1297),
    [anon_sym_CARET_EQ] = ACTIONS(1297),
    [anon_sym_PIPE_EQ] = ACTIONS(1297),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1297),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1297),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1297),
    [anon_sym_EQ_EQ] = ACTIONS(1297),
    [anon_sym_BANG_EQ] = ACTIONS(1297),
    [anon_sym_LT] = ACTIONS(1299),
    [anon_sym_GT] = ACTIONS(1299),
    [anon_sym_LT_EQ] = ACTIONS(1297),
    [anon_sym_GT_EQ] = ACTIONS(1297),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_orelse] = ACTIONS(1297),
    [anon_sym_catch] = ACTIONS(1297),
    [anon_sym_LT_LT] = ACTIONS(1299),
    [anon_sym_GT_GT] = ACTIONS(1299),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1299),
    [anon_sym_PLUS] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1297),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1299),
    [anon_sym_DASH_PERCENT] = ACTIONS(1299),
    [anon_sym_PLUS_PIPE] = ACTIONS(1299),
    [anon_sym_DASH_PIPE] = ACTIONS(1299),
    [anon_sym_PIPE_PIPE] = ACTIONS(1297),
    [anon_sym_SLASH] = ACTIONS(1299),
    [anon_sym_PERCENT] = ACTIONS(1299),
    [anon_sym_STAR_STAR] = ACTIONS(1297),
    [anon_sym_STAR_PERCENT] = ACTIONS(1299),
    [anon_sym_STAR_PIPE] = ACTIONS(1299),
    [anon_sym_align] = ACTIONS(1297),
    [anon_sym_DOT_STAR] = ACTIONS(1297),
    [anon_sym_DOT_QMARK] = ACTIONS(1297),
    [sym_line_comment] = ACTIONS(137),
  },
  [1005] = {
    [anon_sym_COMMA] = ACTIONS(522),
    [anon_sym_SEMI] = ACTIONS(522),
    [anon_sym_BANG] = ACTIONS(524),
    [anon_sym_COLON] = ACTIONS(522),
    [anon_sym_EQ] = ACTIONS(524),
    [anon_sym_else] = ACTIONS(522),
    [anon_sym_or] = ACTIONS(524),
    [anon_sym_and] = ACTIONS(522),
    [anon_sym_LBRACE] = ACTIONS(522),
    [anon_sym_RBRACE] = ACTIONS(522),
    [anon_sym_DOT] = ACTIONS(524),
    [anon_sym_LPAREN] = ACTIONS(522),
    [anon_sym_RPAREN] = ACTIONS(522),
    [anon_sym_LBRACK] = ACTIONS(522),
    [anon_sym_RBRACK] = ACTIONS(522),
    [anon_sym_linksection] = ACTIONS(522),
    [anon_sym_addrspace] = ACTIONS(522),
    [anon_sym_PIPE] = ACTIONS(524),
    [anon_sym_STAR] = ACTIONS(524),
    [anon_sym_EQ_GT] = ACTIONS(522),
    [anon_sym_DOT_DOT] = ACTIONS(522),
    [anon_sym_STAR_EQ] = ACTIONS(522),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(522),
    [anon_sym_SLASH_EQ] = ACTIONS(522),
    [anon_sym_PERCENT_EQ] = ACTIONS(522),
    [anon_sym_PLUS_EQ] = ACTIONS(522),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(522),
    [anon_sym_DASH_EQ] = ACTIONS(522),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(522),
    [anon_sym_LT_LT_EQ] = ACTIONS(522),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(522),
    [anon_sym_GT_GT_EQ] = ACTIONS(522),
    [anon_sym_AMP_EQ] = ACTIONS(522),
    [anon_sym_CARET_EQ] = ACTIONS(522),
    [anon_sym_PIPE_EQ] = ACTIONS(522),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(522),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(522),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(522),
    [anon_sym_EQ_EQ] = ACTIONS(522),
    [anon_sym_BANG_EQ] = ACTIONS(522),
    [anon_sym_LT] = ACTIONS(524),
    [anon_sym_GT] = ACTIONS(524),
    [anon_sym_LT_EQ] = ACTIONS(522),
    [anon_sym_GT_EQ] = ACTIONS(522),
    [anon_sym_AMP] = ACTIONS(524),
    [anon_sym_CARET] = ACTIONS(524),
    [anon_sym_orelse] = ACTIONS(522),
    [anon_sym_catch] = ACTIONS(522),
    [anon_sym_LT_LT] = ACTIONS(524),
    [anon_sym_GT_GT] = ACTIONS(524),
    [anon_sym_LT_LT_PIPE] = ACTIONS(524),
    [anon_sym_PLUS] = ACTIONS(524),
    [anon_sym_DASH] = ACTIONS(524),
    [anon_sym_PLUS_PLUS] = ACTIONS(522),
    [anon_sym_PLUS_PERCENT] = ACTIONS(524),
    [anon_sym_DASH_PERCENT] = ACTIONS(524),
    [anon_sym_PLUS_PIPE] = ACTIONS(524),
    [anon_sym_DASH_PIPE] = ACTIONS(524),
    [anon_sym_PIPE_PIPE] = ACTIONS(522),
    [anon_sym_SLASH] = ACTIONS(524),
    [anon_sym_PERCENT] = ACTIONS(524),
    [anon_sym_STAR_STAR] = ACTIONS(522),
    [anon_sym_STAR_PERCENT] = ACTIONS(524),
    [anon_sym_STAR_PIPE] = ACTIONS(524),
    [anon_sym_align] = ACTIONS(522),
    [anon_sym_DOT_STAR] = ACTIONS(522),
    [anon_sym_DOT_QMARK] = ACTIONS(522),
    [sym_line_comment] = ACTIONS(137),
  },
  [1006] = {
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_SEMI] = ACTIONS(1209),
    [anon_sym_BANG] = ACTIONS(1211),
    [anon_sym_COLON] = ACTIONS(1209),
    [anon_sym_EQ] = ACTIONS(1211),
    [anon_sym_else] = ACTIONS(1209),
    [anon_sym_or] = ACTIONS(1211),
    [anon_sym_and] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1209),
    [anon_sym_RBRACE] = ACTIONS(1209),
    [anon_sym_DOT] = ACTIONS(1211),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_RPAREN] = ACTIONS(1209),
    [anon_sym_LBRACK] = ACTIONS(1209),
    [anon_sym_RBRACK] = ACTIONS(1209),
    [anon_sym_linksection] = ACTIONS(1209),
    [anon_sym_addrspace] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1211),
    [anon_sym_STAR] = ACTIONS(1211),
    [anon_sym_EQ_GT] = ACTIONS(1209),
    [anon_sym_DOT_DOT] = ACTIONS(1209),
    [anon_sym_STAR_EQ] = ACTIONS(1209),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1209),
    [anon_sym_SLASH_EQ] = ACTIONS(1209),
    [anon_sym_PERCENT_EQ] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(1209),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1209),
    [anon_sym_DASH_EQ] = ACTIONS(1209),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1209),
    [anon_sym_LT_LT_EQ] = ACTIONS(1209),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1209),
    [anon_sym_GT_GT_EQ] = ACTIONS(1209),
    [anon_sym_AMP_EQ] = ACTIONS(1209),
    [anon_sym_CARET_EQ] = ACTIONS(1209),
    [anon_sym_PIPE_EQ] = ACTIONS(1209),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1209),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1209),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1209),
    [anon_sym_EQ_EQ] = ACTIONS(1209),
    [anon_sym_BANG_EQ] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1211),
    [anon_sym_GT] = ACTIONS(1211),
    [anon_sym_LT_EQ] = ACTIONS(1209),
    [anon_sym_GT_EQ] = ACTIONS(1209),
    [anon_sym_AMP] = ACTIONS(1211),
    [anon_sym_CARET] = ACTIONS(1211),
    [anon_sym_orelse] = ACTIONS(1209),
    [anon_sym_catch] = ACTIONS(1209),
    [anon_sym_LT_LT] = ACTIONS(1211),
    [anon_sym_GT_GT] = ACTIONS(1211),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1211),
    [anon_sym_PLUS] = ACTIONS(1211),
    [anon_sym_DASH] = ACTIONS(1211),
    [anon_sym_PLUS_PLUS] = ACTIONS(1209),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1211),
    [anon_sym_DASH_PERCENT] = ACTIONS(1211),
    [anon_sym_PLUS_PIPE] = ACTIONS(1211),
    [anon_sym_DASH_PIPE] = ACTIONS(1211),
    [anon_sym_PIPE_PIPE] = ACTIONS(1209),
    [anon_sym_SLASH] = ACTIONS(1211),
    [anon_sym_PERCENT] = ACTIONS(1211),
    [anon_sym_STAR_STAR] = ACTIONS(1209),
    [anon_sym_STAR_PERCENT] = ACTIONS(1211),
    [anon_sym_STAR_PIPE] = ACTIONS(1211),
    [anon_sym_align] = ACTIONS(1209),
    [anon_sym_DOT_STAR] = ACTIONS(1209),
    [anon_sym_DOT_QMARK] = ACTIONS(1209),
    [sym_line_comment] = ACTIONS(137),
  },
  [1007] = {
    [anon_sym_COMMA] = ACTIONS(536),
    [anon_sym_SEMI] = ACTIONS(536),
    [anon_sym_BANG] = ACTIONS(538),
    [anon_sym_COLON] = ACTIONS(536),
    [anon_sym_EQ] = ACTIONS(538),
    [anon_sym_else] = ACTIONS(536),
    [anon_sym_or] = ACTIONS(538),
    [anon_sym_and] = ACTIONS(536),
    [anon_sym_LBRACE] = ACTIONS(536),
    [anon_sym_RBRACE] = ACTIONS(536),
    [anon_sym_DOT] = ACTIONS(538),
    [anon_sym_LPAREN] = ACTIONS(536),
    [anon_sym_RPAREN] = ACTIONS(536),
    [anon_sym_LBRACK] = ACTIONS(536),
    [anon_sym_RBRACK] = ACTIONS(536),
    [anon_sym_linksection] = ACTIONS(536),
    [anon_sym_addrspace] = ACTIONS(536),
    [anon_sym_PIPE] = ACTIONS(538),
    [anon_sym_STAR] = ACTIONS(538),
    [anon_sym_EQ_GT] = ACTIONS(536),
    [anon_sym_DOT_DOT] = ACTIONS(536),
    [anon_sym_STAR_EQ] = ACTIONS(536),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(536),
    [anon_sym_SLASH_EQ] = ACTIONS(536),
    [anon_sym_PERCENT_EQ] = ACTIONS(536),
    [anon_sym_PLUS_EQ] = ACTIONS(536),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(536),
    [anon_sym_DASH_EQ] = ACTIONS(536),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(536),
    [anon_sym_LT_LT_EQ] = ACTIONS(536),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(536),
    [anon_sym_GT_GT_EQ] = ACTIONS(536),
    [anon_sym_AMP_EQ] = ACTIONS(536),
    [anon_sym_CARET_EQ] = ACTIONS(536),
    [anon_sym_PIPE_EQ] = ACTIONS(536),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(536),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(536),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(536),
    [anon_sym_EQ_EQ] = ACTIONS(536),
    [anon_sym_BANG_EQ] = ACTIONS(536),
    [anon_sym_LT] = ACTIONS(538),
    [anon_sym_GT] = ACTIONS(538),
    [anon_sym_LT_EQ] = ACTIONS(536),
    [anon_sym_GT_EQ] = ACTIONS(536),
    [anon_sym_AMP] = ACTIONS(538),
    [anon_sym_CARET] = ACTIONS(538),
    [anon_sym_orelse] = ACTIONS(536),
    [anon_sym_catch] = ACTIONS(536),
    [anon_sym_LT_LT] = ACTIONS(538),
    [anon_sym_GT_GT] = ACTIONS(538),
    [anon_sym_LT_LT_PIPE] = ACTIONS(538),
    [anon_sym_PLUS] = ACTIONS(538),
    [anon_sym_DASH] = ACTIONS(538),
    [anon_sym_PLUS_PLUS] = ACTIONS(536),
    [anon_sym_PLUS_PERCENT] = ACTIONS(538),
    [anon_sym_DASH_PERCENT] = ACTIONS(538),
    [anon_sym_PLUS_PIPE] = ACTIONS(538),
    [anon_sym_DASH_PIPE] = ACTIONS(538),
    [anon_sym_PIPE_PIPE] = ACTIONS(536),
    [anon_sym_SLASH] = ACTIONS(538),
    [anon_sym_PERCENT] = ACTIONS(538),
    [anon_sym_STAR_STAR] = ACTIONS(536),
    [anon_sym_STAR_PERCENT] = ACTIONS(538),
    [anon_sym_STAR_PIPE] = ACTIONS(538),
    [anon_sym_align] = ACTIONS(536),
    [anon_sym_DOT_STAR] = ACTIONS(536),
    [anon_sym_DOT_QMARK] = ACTIONS(536),
    [sym_line_comment] = ACTIONS(137),
  },
  [1008] = {
    [anon_sym_COMMA] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(1201),
    [anon_sym_BANG] = ACTIONS(1203),
    [anon_sym_COLON] = ACTIONS(1201),
    [anon_sym_EQ] = ACTIONS(1203),
    [anon_sym_else] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1203),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1201),
    [anon_sym_RBRACE] = ACTIONS(1201),
    [anon_sym_DOT] = ACTIONS(1203),
    [anon_sym_LPAREN] = ACTIONS(1201),
    [anon_sym_RPAREN] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(1201),
    [anon_sym_RBRACK] = ACTIONS(1201),
    [anon_sym_linksection] = ACTIONS(1201),
    [anon_sym_addrspace] = ACTIONS(1201),
    [anon_sym_PIPE] = ACTIONS(1203),
    [anon_sym_STAR] = ACTIONS(1203),
    [anon_sym_EQ_GT] = ACTIONS(1201),
    [anon_sym_DOT_DOT] = ACTIONS(1201),
    [anon_sym_STAR_EQ] = ACTIONS(1201),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1201),
    [anon_sym_SLASH_EQ] = ACTIONS(1201),
    [anon_sym_PERCENT_EQ] = ACTIONS(1201),
    [anon_sym_PLUS_EQ] = ACTIONS(1201),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1201),
    [anon_sym_DASH_EQ] = ACTIONS(1201),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1201),
    [anon_sym_LT_LT_EQ] = ACTIONS(1201),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1201),
    [anon_sym_GT_GT_EQ] = ACTIONS(1201),
    [anon_sym_AMP_EQ] = ACTIONS(1201),
    [anon_sym_CARET_EQ] = ACTIONS(1201),
    [anon_sym_PIPE_EQ] = ACTIONS(1201),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1201),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1201),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1201),
    [anon_sym_EQ_EQ] = ACTIONS(1201),
    [anon_sym_BANG_EQ] = ACTIONS(1201),
    [anon_sym_LT] = ACTIONS(1203),
    [anon_sym_GT] = ACTIONS(1203),
    [anon_sym_LT_EQ] = ACTIONS(1201),
    [anon_sym_GT_EQ] = ACTIONS(1201),
    [anon_sym_AMP] = ACTIONS(1203),
    [anon_sym_CARET] = ACTIONS(1203),
    [anon_sym_orelse] = ACTIONS(1201),
    [anon_sym_catch] = ACTIONS(1201),
    [anon_sym_LT_LT] = ACTIONS(1203),
    [anon_sym_GT_GT] = ACTIONS(1203),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1203),
    [anon_sym_PLUS] = ACTIONS(1203),
    [anon_sym_DASH] = ACTIONS(1203),
    [anon_sym_PLUS_PLUS] = ACTIONS(1201),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1203),
    [anon_sym_DASH_PERCENT] = ACTIONS(1203),
    [anon_sym_PLUS_PIPE] = ACTIONS(1203),
    [anon_sym_DASH_PIPE] = ACTIONS(1203),
    [anon_sym_PIPE_PIPE] = ACTIONS(1201),
    [anon_sym_SLASH] = ACTIONS(1203),
    [anon_sym_PERCENT] = ACTIONS(1203),
    [anon_sym_STAR_STAR] = ACTIONS(1201),
    [anon_sym_STAR_PERCENT] = ACTIONS(1203),
    [anon_sym_STAR_PIPE] = ACTIONS(1203),
    [anon_sym_align] = ACTIONS(1201),
    [anon_sym_DOT_STAR] = ACTIONS(1201),
    [anon_sym_DOT_QMARK] = ACTIONS(1201),
    [sym_line_comment] = ACTIONS(137),
  },
  [1009] = {
    [anon_sym_COMMA] = ACTIONS(1309),
    [anon_sym_SEMI] = ACTIONS(1309),
    [anon_sym_BANG] = ACTIONS(1311),
    [anon_sym_COLON] = ACTIONS(1309),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_else] = ACTIONS(1309),
    [anon_sym_or] = ACTIONS(1311),
    [anon_sym_and] = ACTIONS(1309),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_RBRACE] = ACTIONS(1309),
    [anon_sym_DOT] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1309),
    [anon_sym_RPAREN] = ACTIONS(1309),
    [anon_sym_LBRACK] = ACTIONS(1309),
    [anon_sym_RBRACK] = ACTIONS(1309),
    [anon_sym_linksection] = ACTIONS(1309),
    [anon_sym_addrspace] = ACTIONS(1309),
    [anon_sym_PIPE] = ACTIONS(1311),
    [anon_sym_STAR] = ACTIONS(1311),
    [anon_sym_EQ_GT] = ACTIONS(1309),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym_STAR_EQ] = ACTIONS(1309),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1309),
    [anon_sym_SLASH_EQ] = ACTIONS(1309),
    [anon_sym_PERCENT_EQ] = ACTIONS(1309),
    [anon_sym_PLUS_EQ] = ACTIONS(1309),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1309),
    [anon_sym_DASH_EQ] = ACTIONS(1309),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1309),
    [anon_sym_LT_LT_EQ] = ACTIONS(1309),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1309),
    [anon_sym_GT_GT_EQ] = ACTIONS(1309),
    [anon_sym_AMP_EQ] = ACTIONS(1309),
    [anon_sym_CARET_EQ] = ACTIONS(1309),
    [anon_sym_PIPE_EQ] = ACTIONS(1309),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1309),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1309),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1309),
    [anon_sym_EQ_EQ] = ACTIONS(1309),
    [anon_sym_BANG_EQ] = ACTIONS(1309),
    [anon_sym_LT] = ACTIONS(1311),
    [anon_sym_GT] = ACTIONS(1311),
    [anon_sym_LT_EQ] = ACTIONS(1309),
    [anon_sym_GT_EQ] = ACTIONS(1309),
    [anon_sym_AMP] = ACTIONS(1311),
    [anon_sym_CARET] = ACTIONS(1311),
    [anon_sym_orelse] = ACTIONS(1309),
    [anon_sym_catch] = ACTIONS(1309),
    [anon_sym_LT_LT] = ACTIONS(1311),
    [anon_sym_GT_GT] = ACTIONS(1311),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS_PLUS] = ACTIONS(1309),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1311),
    [anon_sym_DASH_PERCENT] = ACTIONS(1311),
    [anon_sym_PLUS_PIPE] = ACTIONS(1311),
    [anon_sym_DASH_PIPE] = ACTIONS(1311),
    [anon_sym_PIPE_PIPE] = ACTIONS(1309),
    [anon_sym_SLASH] = ACTIONS(1311),
    [anon_sym_PERCENT] = ACTIONS(1311),
    [anon_sym_STAR_STAR] = ACTIONS(1309),
    [anon_sym_STAR_PERCENT] = ACTIONS(1311),
    [anon_sym_STAR_PIPE] = ACTIONS(1311),
    [anon_sym_align] = ACTIONS(1309),
    [anon_sym_DOT_STAR] = ACTIONS(1309),
    [anon_sym_DOT_QMARK] = ACTIONS(1309),
    [sym_line_comment] = ACTIONS(137),
  },
  [1010] = {
    [anon_sym_COMMA] = ACTIONS(1325),
    [anon_sym_SEMI] = ACTIONS(1325),
    [anon_sym_BANG] = ACTIONS(1327),
    [anon_sym_COLON] = ACTIONS(1325),
    [anon_sym_EQ] = ACTIONS(1327),
    [anon_sym_else] = ACTIONS(1325),
    [anon_sym_or] = ACTIONS(1327),
    [anon_sym_and] = ACTIONS(1325),
    [anon_sym_LBRACE] = ACTIONS(1325),
    [anon_sym_RBRACE] = ACTIONS(1325),
    [anon_sym_DOT] = ACTIONS(1327),
    [anon_sym_LPAREN] = ACTIONS(1325),
    [anon_sym_RPAREN] = ACTIONS(1325),
    [anon_sym_LBRACK] = ACTIONS(1325),
    [anon_sym_RBRACK] = ACTIONS(1325),
    [anon_sym_linksection] = ACTIONS(1325),
    [anon_sym_addrspace] = ACTIONS(1325),
    [anon_sym_PIPE] = ACTIONS(1327),
    [anon_sym_STAR] = ACTIONS(1327),
    [anon_sym_EQ_GT] = ACTIONS(1325),
    [anon_sym_DOT_DOT] = ACTIONS(1325),
    [anon_sym_STAR_EQ] = ACTIONS(1325),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1325),
    [anon_sym_SLASH_EQ] = ACTIONS(1325),
    [anon_sym_PERCENT_EQ] = ACTIONS(1325),
    [anon_sym_PLUS_EQ] = ACTIONS(1325),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1325),
    [anon_sym_DASH_EQ] = ACTIONS(1325),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1325),
    [anon_sym_LT_LT_EQ] = ACTIONS(1325),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1325),
    [anon_sym_GT_GT_EQ] = ACTIONS(1325),
    [anon_sym_AMP_EQ] = ACTIONS(1325),
    [anon_sym_CARET_EQ] = ACTIONS(1325),
    [anon_sym_PIPE_EQ] = ACTIONS(1325),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1325),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1325),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1325),
    [anon_sym_EQ_EQ] = ACTIONS(1325),
    [anon_sym_BANG_EQ] = ACTIONS(1325),
    [anon_sym_LT] = ACTIONS(1327),
    [anon_sym_GT] = ACTIONS(1327),
    [anon_sym_LT_EQ] = ACTIONS(1325),
    [anon_sym_GT_EQ] = ACTIONS(1325),
    [anon_sym_AMP] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1327),
    [anon_sym_orelse] = ACTIONS(1325),
    [anon_sym_catch] = ACTIONS(1325),
    [anon_sym_LT_LT] = ACTIONS(1327),
    [anon_sym_GT_GT] = ACTIONS(1327),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(1327),
    [anon_sym_DASH] = ACTIONS(1327),
    [anon_sym_PLUS_PLUS] = ACTIONS(1325),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1327),
    [anon_sym_DASH_PERCENT] = ACTIONS(1327),
    [anon_sym_PLUS_PIPE] = ACTIONS(1327),
    [anon_sym_DASH_PIPE] = ACTIONS(1327),
    [anon_sym_PIPE_PIPE] = ACTIONS(1325),
    [anon_sym_SLASH] = ACTIONS(1327),
    [anon_sym_PERCENT] = ACTIONS(1327),
    [anon_sym_STAR_STAR] = ACTIONS(1325),
    [anon_sym_STAR_PERCENT] = ACTIONS(1327),
    [anon_sym_STAR_PIPE] = ACTIONS(1327),
    [anon_sym_align] = ACTIONS(1325),
    [anon_sym_DOT_STAR] = ACTIONS(1325),
    [anon_sym_DOT_QMARK] = ACTIONS(1325),
    [sym_line_comment] = ACTIONS(137),
  },
  [1011] = {
    [anon_sym_COMMA] = ACTIONS(1197),
    [anon_sym_SEMI] = ACTIONS(1197),
    [anon_sym_BANG] = ACTIONS(1199),
    [anon_sym_COLON] = ACTIONS(1197),
    [anon_sym_EQ] = ACTIONS(1199),
    [anon_sym_else] = ACTIONS(1197),
    [anon_sym_or] = ACTIONS(1199),
    [anon_sym_and] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1197),
    [anon_sym_RBRACE] = ACTIONS(1197),
    [anon_sym_DOT] = ACTIONS(1199),
    [anon_sym_LPAREN] = ACTIONS(1197),
    [anon_sym_RPAREN] = ACTIONS(1197),
    [anon_sym_LBRACK] = ACTIONS(1197),
    [anon_sym_RBRACK] = ACTIONS(1197),
    [anon_sym_linksection] = ACTIONS(1197),
    [anon_sym_addrspace] = ACTIONS(1197),
    [anon_sym_PIPE] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1199),
    [anon_sym_EQ_GT] = ACTIONS(1197),
    [anon_sym_DOT_DOT] = ACTIONS(1197),
    [anon_sym_STAR_EQ] = ACTIONS(1197),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1197),
    [anon_sym_SLASH_EQ] = ACTIONS(1197),
    [anon_sym_PERCENT_EQ] = ACTIONS(1197),
    [anon_sym_PLUS_EQ] = ACTIONS(1197),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1197),
    [anon_sym_DASH_EQ] = ACTIONS(1197),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1197),
    [anon_sym_LT_LT_EQ] = ACTIONS(1197),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1197),
    [anon_sym_GT_GT_EQ] = ACTIONS(1197),
    [anon_sym_AMP_EQ] = ACTIONS(1197),
    [anon_sym_CARET_EQ] = ACTIONS(1197),
    [anon_sym_PIPE_EQ] = ACTIONS(1197),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1197),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1197),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1197),
    [anon_sym_EQ_EQ] = ACTIONS(1197),
    [anon_sym_BANG_EQ] = ACTIONS(1197),
    [anon_sym_LT] = ACTIONS(1199),
    [anon_sym_GT] = ACTIONS(1199),
    [anon_sym_LT_EQ] = ACTIONS(1197),
    [anon_sym_GT_EQ] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1199),
    [anon_sym_CARET] = ACTIONS(1199),
    [anon_sym_orelse] = ACTIONS(1197),
    [anon_sym_catch] = ACTIONS(1197),
    [anon_sym_LT_LT] = ACTIONS(1199),
    [anon_sym_GT_GT] = ACTIONS(1199),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1199),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1199),
    [anon_sym_DASH_PERCENT] = ACTIONS(1199),
    [anon_sym_PLUS_PIPE] = ACTIONS(1199),
    [anon_sym_DASH_PIPE] = ACTIONS(1199),
    [anon_sym_PIPE_PIPE] = ACTIONS(1197),
    [anon_sym_SLASH] = ACTIONS(1199),
    [anon_sym_PERCENT] = ACTIONS(1199),
    [anon_sym_STAR_STAR] = ACTIONS(1197),
    [anon_sym_STAR_PERCENT] = ACTIONS(1199),
    [anon_sym_STAR_PIPE] = ACTIONS(1199),
    [anon_sym_align] = ACTIONS(1197),
    [anon_sym_DOT_STAR] = ACTIONS(1197),
    [anon_sym_DOT_QMARK] = ACTIONS(1197),
    [sym_line_comment] = ACTIONS(137),
  },
  [1012] = {
    [anon_sym_COMMA] = ACTIONS(1193),
    [anon_sym_SEMI] = ACTIONS(1193),
    [anon_sym_BANG] = ACTIONS(1195),
    [anon_sym_COLON] = ACTIONS(1193),
    [anon_sym_EQ] = ACTIONS(1195),
    [anon_sym_else] = ACTIONS(1193),
    [anon_sym_or] = ACTIONS(1195),
    [anon_sym_and] = ACTIONS(1193),
    [anon_sym_LBRACE] = ACTIONS(1193),
    [anon_sym_RBRACE] = ACTIONS(1193),
    [anon_sym_DOT] = ACTIONS(1195),
    [anon_sym_LPAREN] = ACTIONS(1193),
    [anon_sym_RPAREN] = ACTIONS(1193),
    [anon_sym_LBRACK] = ACTIONS(1193),
    [anon_sym_RBRACK] = ACTIONS(1193),
    [anon_sym_linksection] = ACTIONS(1193),
    [anon_sym_addrspace] = ACTIONS(1193),
    [anon_sym_PIPE] = ACTIONS(1195),
    [anon_sym_STAR] = ACTIONS(1195),
    [anon_sym_EQ_GT] = ACTIONS(1193),
    [anon_sym_DOT_DOT] = ACTIONS(1193),
    [anon_sym_STAR_EQ] = ACTIONS(1193),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1193),
    [anon_sym_SLASH_EQ] = ACTIONS(1193),
    [anon_sym_PERCENT_EQ] = ACTIONS(1193),
    [anon_sym_PLUS_EQ] = ACTIONS(1193),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1193),
    [anon_sym_DASH_EQ] = ACTIONS(1193),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1193),
    [anon_sym_LT_LT_EQ] = ACTIONS(1193),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1193),
    [anon_sym_GT_GT_EQ] = ACTIONS(1193),
    [anon_sym_AMP_EQ] = ACTIONS(1193),
    [anon_sym_CARET_EQ] = ACTIONS(1193),
    [anon_sym_PIPE_EQ] = ACTIONS(1193),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1193),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1193),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1193),
    [anon_sym_EQ_EQ] = ACTIONS(1193),
    [anon_sym_BANG_EQ] = ACTIONS(1193),
    [anon_sym_LT] = ACTIONS(1195),
    [anon_sym_GT] = ACTIONS(1195),
    [anon_sym_LT_EQ] = ACTIONS(1193),
    [anon_sym_GT_EQ] = ACTIONS(1193),
    [anon_sym_AMP] = ACTIONS(1195),
    [anon_sym_CARET] = ACTIONS(1195),
    [anon_sym_orelse] = ACTIONS(1193),
    [anon_sym_catch] = ACTIONS(1193),
    [anon_sym_LT_LT] = ACTIONS(1195),
    [anon_sym_GT_GT] = ACTIONS(1195),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1195),
    [anon_sym_PLUS] = ACTIONS(1195),
    [anon_sym_DASH] = ACTIONS(1195),
    [anon_sym_PLUS_PLUS] = ACTIONS(1193),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1195),
    [anon_sym_DASH_PERCENT] = ACTIONS(1195),
    [anon_sym_PLUS_PIPE] = ACTIONS(1195),
    [anon_sym_DASH_PIPE] = ACTIONS(1195),
    [anon_sym_PIPE_PIPE] = ACTIONS(1193),
    [anon_sym_SLASH] = ACTIONS(1195),
    [anon_sym_PERCENT] = ACTIONS(1195),
    [anon_sym_STAR_STAR] = ACTIONS(1193),
    [anon_sym_STAR_PERCENT] = ACTIONS(1195),
    [anon_sym_STAR_PIPE] = ACTIONS(1195),
    [anon_sym_align] = ACTIONS(1193),
    [anon_sym_DOT_STAR] = ACTIONS(1193),
    [anon_sym_DOT_QMARK] = ACTIONS(1193),
    [sym_line_comment] = ACTIONS(137),
  },
  [1013] = {
    [anon_sym_COMMA] = ACTIONS(1163),
    [anon_sym_SEMI] = ACTIONS(1163),
    [anon_sym_BANG] = ACTIONS(1165),
    [anon_sym_COLON] = ACTIONS(1163),
    [anon_sym_EQ] = ACTIONS(1165),
    [anon_sym_else] = ACTIONS(1163),
    [anon_sym_or] = ACTIONS(1165),
    [anon_sym_and] = ACTIONS(1163),
    [anon_sym_LBRACE] = ACTIONS(1163),
    [anon_sym_RBRACE] = ACTIONS(1163),
    [anon_sym_DOT] = ACTIONS(1165),
    [anon_sym_LPAREN] = ACTIONS(1163),
    [anon_sym_RPAREN] = ACTIONS(1163),
    [anon_sym_LBRACK] = ACTIONS(1163),
    [anon_sym_RBRACK] = ACTIONS(1163),
    [anon_sym_linksection] = ACTIONS(1163),
    [anon_sym_addrspace] = ACTIONS(1163),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_STAR] = ACTIONS(1165),
    [anon_sym_EQ_GT] = ACTIONS(1163),
    [anon_sym_DOT_DOT] = ACTIONS(1163),
    [anon_sym_STAR_EQ] = ACTIONS(1163),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1163),
    [anon_sym_SLASH_EQ] = ACTIONS(1163),
    [anon_sym_PERCENT_EQ] = ACTIONS(1163),
    [anon_sym_PLUS_EQ] = ACTIONS(1163),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1163),
    [anon_sym_DASH_EQ] = ACTIONS(1163),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1163),
    [anon_sym_LT_LT_EQ] = ACTIONS(1163),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1163),
    [anon_sym_GT_GT_EQ] = ACTIONS(1163),
    [anon_sym_AMP_EQ] = ACTIONS(1163),
    [anon_sym_CARET_EQ] = ACTIONS(1163),
    [anon_sym_PIPE_EQ] = ACTIONS(1163),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1163),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1163),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1163),
    [anon_sym_EQ_EQ] = ACTIONS(1163),
    [anon_sym_BANG_EQ] = ACTIONS(1163),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_GT] = ACTIONS(1165),
    [anon_sym_LT_EQ] = ACTIONS(1163),
    [anon_sym_GT_EQ] = ACTIONS(1163),
    [anon_sym_AMP] = ACTIONS(1165),
    [anon_sym_CARET] = ACTIONS(1165),
    [anon_sym_orelse] = ACTIONS(1163),
    [anon_sym_catch] = ACTIONS(1163),
    [anon_sym_LT_LT] = ACTIONS(1165),
    [anon_sym_GT_GT] = ACTIONS(1165),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1165),
    [anon_sym_PLUS] = ACTIONS(1165),
    [anon_sym_DASH] = ACTIONS(1165),
    [anon_sym_PLUS_PLUS] = ACTIONS(1163),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1165),
    [anon_sym_DASH_PERCENT] = ACTIONS(1165),
    [anon_sym_PLUS_PIPE] = ACTIONS(1165),
    [anon_sym_DASH_PIPE] = ACTIONS(1165),
    [anon_sym_PIPE_PIPE] = ACTIONS(1163),
    [anon_sym_SLASH] = ACTIONS(1165),
    [anon_sym_PERCENT] = ACTIONS(1165),
    [anon_sym_STAR_STAR] = ACTIONS(1163),
    [anon_sym_STAR_PERCENT] = ACTIONS(1165),
    [anon_sym_STAR_PIPE] = ACTIONS(1165),
    [anon_sym_align] = ACTIONS(1163),
    [anon_sym_DOT_STAR] = ACTIONS(1163),
    [anon_sym_DOT_QMARK] = ACTIONS(1163),
    [sym_line_comment] = ACTIONS(137),
  },
  [1014] = {
    [anon_sym_COMMA] = ACTIONS(1189),
    [anon_sym_SEMI] = ACTIONS(1189),
    [anon_sym_BANG] = ACTIONS(1191),
    [anon_sym_COLON] = ACTIONS(1189),
    [anon_sym_EQ] = ACTIONS(1191),
    [anon_sym_else] = ACTIONS(1189),
    [anon_sym_or] = ACTIONS(1191),
    [anon_sym_and] = ACTIONS(1189),
    [anon_sym_LBRACE] = ACTIONS(1189),
    [anon_sym_RBRACE] = ACTIONS(1189),
    [anon_sym_DOT] = ACTIONS(1191),
    [anon_sym_LPAREN] = ACTIONS(1189),
    [anon_sym_RPAREN] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(1189),
    [anon_sym_RBRACK] = ACTIONS(1189),
    [anon_sym_linksection] = ACTIONS(1189),
    [anon_sym_addrspace] = ACTIONS(1189),
    [anon_sym_PIPE] = ACTIONS(1191),
    [anon_sym_STAR] = ACTIONS(1191),
    [anon_sym_EQ_GT] = ACTIONS(1189),
    [anon_sym_DOT_DOT] = ACTIONS(1189),
    [anon_sym_STAR_EQ] = ACTIONS(1189),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1189),
    [anon_sym_SLASH_EQ] = ACTIONS(1189),
    [anon_sym_PERCENT_EQ] = ACTIONS(1189),
    [anon_sym_PLUS_EQ] = ACTIONS(1189),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1189),
    [anon_sym_DASH_EQ] = ACTIONS(1189),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT_EQ] = ACTIONS(1189),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1189),
    [anon_sym_GT_GT_EQ] = ACTIONS(1189),
    [anon_sym_AMP_EQ] = ACTIONS(1189),
    [anon_sym_CARET_EQ] = ACTIONS(1189),
    [anon_sym_PIPE_EQ] = ACTIONS(1189),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1189),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1189),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1189),
    [anon_sym_EQ_EQ] = ACTIONS(1189),
    [anon_sym_BANG_EQ] = ACTIONS(1189),
    [anon_sym_LT] = ACTIONS(1191),
    [anon_sym_GT] = ACTIONS(1191),
    [anon_sym_LT_EQ] = ACTIONS(1189),
    [anon_sym_GT_EQ] = ACTIONS(1189),
    [anon_sym_AMP] = ACTIONS(1191),
    [anon_sym_CARET] = ACTIONS(1191),
    [anon_sym_orelse] = ACTIONS(1189),
    [anon_sym_catch] = ACTIONS(1189),
    [anon_sym_LT_LT] = ACTIONS(1191),
    [anon_sym_GT_GT] = ACTIONS(1191),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1191),
    [anon_sym_PLUS] = ACTIONS(1191),
    [anon_sym_DASH] = ACTIONS(1191),
    [anon_sym_PLUS_PLUS] = ACTIONS(1189),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1191),
    [anon_sym_DASH_PERCENT] = ACTIONS(1191),
    [anon_sym_PLUS_PIPE] = ACTIONS(1191),
    [anon_sym_DASH_PIPE] = ACTIONS(1191),
    [anon_sym_PIPE_PIPE] = ACTIONS(1189),
    [anon_sym_SLASH] = ACTIONS(1191),
    [anon_sym_PERCENT] = ACTIONS(1191),
    [anon_sym_STAR_STAR] = ACTIONS(1189),
    [anon_sym_STAR_PERCENT] = ACTIONS(1191),
    [anon_sym_STAR_PIPE] = ACTIONS(1191),
    [anon_sym_align] = ACTIONS(1189),
    [anon_sym_DOT_STAR] = ACTIONS(1189),
    [anon_sym_DOT_QMARK] = ACTIONS(1189),
    [sym_line_comment] = ACTIONS(137),
  },
  [1015] = {
    [anon_sym_COMMA] = ACTIONS(1185),
    [anon_sym_SEMI] = ACTIONS(1185),
    [anon_sym_BANG] = ACTIONS(1187),
    [anon_sym_COLON] = ACTIONS(1185),
    [anon_sym_EQ] = ACTIONS(1187),
    [anon_sym_else] = ACTIONS(1185),
    [anon_sym_or] = ACTIONS(1187),
    [anon_sym_and] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(1185),
    [anon_sym_RBRACE] = ACTIONS(1185),
    [anon_sym_DOT] = ACTIONS(1187),
    [anon_sym_LPAREN] = ACTIONS(1185),
    [anon_sym_RPAREN] = ACTIONS(1185),
    [anon_sym_LBRACK] = ACTIONS(1185),
    [anon_sym_RBRACK] = ACTIONS(1185),
    [anon_sym_linksection] = ACTIONS(1185),
    [anon_sym_addrspace] = ACTIONS(1185),
    [anon_sym_PIPE] = ACTIONS(1187),
    [anon_sym_STAR] = ACTIONS(1187),
    [anon_sym_EQ_GT] = ACTIONS(1185),
    [anon_sym_DOT_DOT] = ACTIONS(1185),
    [anon_sym_STAR_EQ] = ACTIONS(1185),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1185),
    [anon_sym_SLASH_EQ] = ACTIONS(1185),
    [anon_sym_PERCENT_EQ] = ACTIONS(1185),
    [anon_sym_PLUS_EQ] = ACTIONS(1185),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1185),
    [anon_sym_DASH_EQ] = ACTIONS(1185),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1185),
    [anon_sym_LT_LT_EQ] = ACTIONS(1185),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1185),
    [anon_sym_GT_GT_EQ] = ACTIONS(1185),
    [anon_sym_AMP_EQ] = ACTIONS(1185),
    [anon_sym_CARET_EQ] = ACTIONS(1185),
    [anon_sym_PIPE_EQ] = ACTIONS(1185),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1185),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1185),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1185),
    [anon_sym_EQ_EQ] = ACTIONS(1185),
    [anon_sym_BANG_EQ] = ACTIONS(1185),
    [anon_sym_LT] = ACTIONS(1187),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_LT_EQ] = ACTIONS(1185),
    [anon_sym_GT_EQ] = ACTIONS(1185),
    [anon_sym_AMP] = ACTIONS(1187),
    [anon_sym_CARET] = ACTIONS(1187),
    [anon_sym_orelse] = ACTIONS(1185),
    [anon_sym_catch] = ACTIONS(1185),
    [anon_sym_LT_LT] = ACTIONS(1187),
    [anon_sym_GT_GT] = ACTIONS(1187),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1187),
    [anon_sym_PLUS] = ACTIONS(1187),
    [anon_sym_DASH] = ACTIONS(1187),
    [anon_sym_PLUS_PLUS] = ACTIONS(1185),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1187),
    [anon_sym_DASH_PERCENT] = ACTIONS(1187),
    [anon_sym_PLUS_PIPE] = ACTIONS(1187),
    [anon_sym_DASH_PIPE] = ACTIONS(1187),
    [anon_sym_PIPE_PIPE] = ACTIONS(1185),
    [anon_sym_SLASH] = ACTIONS(1187),
    [anon_sym_PERCENT] = ACTIONS(1187),
    [anon_sym_STAR_STAR] = ACTIONS(1185),
    [anon_sym_STAR_PERCENT] = ACTIONS(1187),
    [anon_sym_STAR_PIPE] = ACTIONS(1187),
    [anon_sym_align] = ACTIONS(1185),
    [anon_sym_DOT_STAR] = ACTIONS(1185),
    [anon_sym_DOT_QMARK] = ACTIONS(1185),
    [sym_line_comment] = ACTIONS(137),
  },
  [1016] = {
    [anon_sym_COMMA] = ACTIONS(1181),
    [anon_sym_SEMI] = ACTIONS(1181),
    [anon_sym_BANG] = ACTIONS(1183),
    [anon_sym_COLON] = ACTIONS(1181),
    [anon_sym_EQ] = ACTIONS(1183),
    [anon_sym_else] = ACTIONS(1181),
    [anon_sym_or] = ACTIONS(1183),
    [anon_sym_and] = ACTIONS(1181),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym_DOT] = ACTIONS(1183),
    [anon_sym_LPAREN] = ACTIONS(1181),
    [anon_sym_RPAREN] = ACTIONS(1181),
    [anon_sym_LBRACK] = ACTIONS(1181),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [anon_sym_linksection] = ACTIONS(1181),
    [anon_sym_addrspace] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(1183),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_EQ_GT] = ACTIONS(1181),
    [anon_sym_DOT_DOT] = ACTIONS(1181),
    [anon_sym_STAR_EQ] = ACTIONS(1181),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1181),
    [anon_sym_SLASH_EQ] = ACTIONS(1181),
    [anon_sym_PERCENT_EQ] = ACTIONS(1181),
    [anon_sym_PLUS_EQ] = ACTIONS(1181),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1181),
    [anon_sym_DASH_EQ] = ACTIONS(1181),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1181),
    [anon_sym_LT_LT_EQ] = ACTIONS(1181),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1181),
    [anon_sym_GT_GT_EQ] = ACTIONS(1181),
    [anon_sym_AMP_EQ] = ACTIONS(1181),
    [anon_sym_CARET_EQ] = ACTIONS(1181),
    [anon_sym_PIPE_EQ] = ACTIONS(1181),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1181),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1181),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1181),
    [anon_sym_EQ_EQ] = ACTIONS(1181),
    [anon_sym_BANG_EQ] = ACTIONS(1181),
    [anon_sym_LT] = ACTIONS(1183),
    [anon_sym_GT] = ACTIONS(1183),
    [anon_sym_LT_EQ] = ACTIONS(1181),
    [anon_sym_GT_EQ] = ACTIONS(1181),
    [anon_sym_AMP] = ACTIONS(1183),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym_orelse] = ACTIONS(1181),
    [anon_sym_catch] = ACTIONS(1181),
    [anon_sym_LT_LT] = ACTIONS(1183),
    [anon_sym_GT_GT] = ACTIONS(1183),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1183),
    [anon_sym_PLUS] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1183),
    [anon_sym_PLUS_PLUS] = ACTIONS(1181),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1183),
    [anon_sym_DASH_PERCENT] = ACTIONS(1183),
    [anon_sym_PLUS_PIPE] = ACTIONS(1183),
    [anon_sym_DASH_PIPE] = ACTIONS(1183),
    [anon_sym_PIPE_PIPE] = ACTIONS(1181),
    [anon_sym_SLASH] = ACTIONS(1183),
    [anon_sym_PERCENT] = ACTIONS(1183),
    [anon_sym_STAR_STAR] = ACTIONS(1181),
    [anon_sym_STAR_PERCENT] = ACTIONS(1183),
    [anon_sym_STAR_PIPE] = ACTIONS(1183),
    [anon_sym_align] = ACTIONS(1181),
    [anon_sym_DOT_STAR] = ACTIONS(1181),
    [anon_sym_DOT_QMARK] = ACTIONS(1181),
    [sym_line_comment] = ACTIONS(137),
  },
  [1017] = {
    [anon_sym_COMMA] = ACTIONS(1405),
    [anon_sym_SEMI] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1407),
    [anon_sym_COLON] = ACTIONS(1405),
    [anon_sym_EQ] = ACTIONS(1407),
    [anon_sym_else] = ACTIONS(1405),
    [anon_sym_or] = ACTIONS(1407),
    [anon_sym_and] = ACTIONS(1405),
    [anon_sym_LBRACE] = ACTIONS(1405),
    [anon_sym_RBRACE] = ACTIONS(1405),
    [anon_sym_DOT] = ACTIONS(1407),
    [anon_sym_LPAREN] = ACTIONS(1405),
    [anon_sym_RPAREN] = ACTIONS(1405),
    [anon_sym_LBRACK] = ACTIONS(1405),
    [anon_sym_RBRACK] = ACTIONS(1405),
    [anon_sym_linksection] = ACTIONS(1405),
    [anon_sym_addrspace] = ACTIONS(1405),
    [anon_sym_PIPE] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(1407),
    [anon_sym_EQ_GT] = ACTIONS(1405),
    [anon_sym_DOT_DOT] = ACTIONS(1405),
    [anon_sym_STAR_EQ] = ACTIONS(1405),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1405),
    [anon_sym_SLASH_EQ] = ACTIONS(1405),
    [anon_sym_PERCENT_EQ] = ACTIONS(1405),
    [anon_sym_PLUS_EQ] = ACTIONS(1405),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1405),
    [anon_sym_DASH_EQ] = ACTIONS(1405),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1405),
    [anon_sym_LT_LT_EQ] = ACTIONS(1405),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1405),
    [anon_sym_GT_GT_EQ] = ACTIONS(1405),
    [anon_sym_AMP_EQ] = ACTIONS(1405),
    [anon_sym_CARET_EQ] = ACTIONS(1405),
    [anon_sym_PIPE_EQ] = ACTIONS(1405),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1405),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1405),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1405),
    [anon_sym_EQ_EQ] = ACTIONS(1405),
    [anon_sym_BANG_EQ] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_LT_EQ] = ACTIONS(1405),
    [anon_sym_GT_EQ] = ACTIONS(1405),
    [anon_sym_AMP] = ACTIONS(1407),
    [anon_sym_CARET] = ACTIONS(1407),
    [anon_sym_orelse] = ACTIONS(1405),
    [anon_sym_catch] = ACTIONS(1405),
    [anon_sym_LT_LT] = ACTIONS(1407),
    [anon_sym_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1407),
    [anon_sym_PLUS] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_PLUS_PLUS] = ACTIONS(1405),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1407),
    [anon_sym_DASH_PERCENT] = ACTIONS(1407),
    [anon_sym_PLUS_PIPE] = ACTIONS(1407),
    [anon_sym_DASH_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1405),
    [anon_sym_SLASH] = ACTIONS(1407),
    [anon_sym_PERCENT] = ACTIONS(1407),
    [anon_sym_STAR_STAR] = ACTIONS(1405),
    [anon_sym_STAR_PERCENT] = ACTIONS(1407),
    [anon_sym_STAR_PIPE] = ACTIONS(1407),
    [anon_sym_align] = ACTIONS(1405),
    [anon_sym_DOT_STAR] = ACTIONS(1405),
    [anon_sym_DOT_QMARK] = ACTIONS(1405),
    [sym_line_comment] = ACTIONS(137),
  },
  [1018] = {
    [anon_sym_COMMA] = ACTIONS(1175),
    [anon_sym_SEMI] = ACTIONS(1175),
    [anon_sym_BANG] = ACTIONS(1762),
    [anon_sym_COLON] = ACTIONS(1175),
    [anon_sym_EQ] = ACTIONS(1177),
    [anon_sym_else] = ACTIONS(1175),
    [anon_sym_or] = ACTIONS(1177),
    [anon_sym_and] = ACTIONS(1175),
    [anon_sym_LBRACE] = ACTIONS(1175),
    [anon_sym_RBRACE] = ACTIONS(1175),
    [anon_sym_DOT] = ACTIONS(1177),
    [anon_sym_LPAREN] = ACTIONS(1175),
    [anon_sym_RPAREN] = ACTIONS(1175),
    [anon_sym_LBRACK] = ACTIONS(1175),
    [anon_sym_RBRACK] = ACTIONS(1175),
    [anon_sym_linksection] = ACTIONS(1175),
    [anon_sym_addrspace] = ACTIONS(1175),
    [anon_sym_PIPE] = ACTIONS(1177),
    [anon_sym_STAR] = ACTIONS(1177),
    [anon_sym_EQ_GT] = ACTIONS(1175),
    [anon_sym_DOT_DOT] = ACTIONS(1175),
    [anon_sym_STAR_EQ] = ACTIONS(1175),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1175),
    [anon_sym_SLASH_EQ] = ACTIONS(1175),
    [anon_sym_PERCENT_EQ] = ACTIONS(1175),
    [anon_sym_PLUS_EQ] = ACTIONS(1175),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1175),
    [anon_sym_DASH_EQ] = ACTIONS(1175),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1175),
    [anon_sym_LT_LT_EQ] = ACTIONS(1175),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1175),
    [anon_sym_GT_GT_EQ] = ACTIONS(1175),
    [anon_sym_AMP_EQ] = ACTIONS(1175),
    [anon_sym_CARET_EQ] = ACTIONS(1175),
    [anon_sym_PIPE_EQ] = ACTIONS(1175),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1175),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1175),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1175),
    [anon_sym_EQ_EQ] = ACTIONS(1175),
    [anon_sym_BANG_EQ] = ACTIONS(1175),
    [anon_sym_LT] = ACTIONS(1177),
    [anon_sym_GT] = ACTIONS(1177),
    [anon_sym_LT_EQ] = ACTIONS(1175),
    [anon_sym_GT_EQ] = ACTIONS(1175),
    [anon_sym_AMP] = ACTIONS(1177),
    [anon_sym_CARET] = ACTIONS(1177),
    [anon_sym_orelse] = ACTIONS(1175),
    [anon_sym_catch] = ACTIONS(1175),
    [anon_sym_LT_LT] = ACTIONS(1177),
    [anon_sym_GT_GT] = ACTIONS(1177),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1177),
    [anon_sym_PLUS] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1177),
    [anon_sym_PLUS_PLUS] = ACTIONS(1175),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1177),
    [anon_sym_DASH_PERCENT] = ACTIONS(1177),
    [anon_sym_PLUS_PIPE] = ACTIONS(1177),
    [anon_sym_DASH_PIPE] = ACTIONS(1177),
    [anon_sym_PIPE_PIPE] = ACTIONS(1175),
    [anon_sym_SLASH] = ACTIONS(1177),
    [anon_sym_PERCENT] = ACTIONS(1177),
    [anon_sym_STAR_STAR] = ACTIONS(1175),
    [anon_sym_STAR_PERCENT] = ACTIONS(1177),
    [anon_sym_STAR_PIPE] = ACTIONS(1177),
    [anon_sym_align] = ACTIONS(1175),
    [anon_sym_DOT_STAR] = ACTIONS(1175),
    [anon_sym_DOT_QMARK] = ACTIONS(1175),
    [sym_line_comment] = ACTIONS(137),
  },
  [1019] = {
    [anon_sym_COMMA] = ACTIONS(1321),
    [anon_sym_SEMI] = ACTIONS(1321),
    [anon_sym_BANG] = ACTIONS(1323),
    [anon_sym_COLON] = ACTIONS(1321),
    [anon_sym_EQ] = ACTIONS(1323),
    [anon_sym_else] = ACTIONS(1321),
    [anon_sym_or] = ACTIONS(1323),
    [anon_sym_and] = ACTIONS(1321),
    [anon_sym_LBRACE] = ACTIONS(1321),
    [anon_sym_RBRACE] = ACTIONS(1321),
    [anon_sym_DOT] = ACTIONS(1323),
    [anon_sym_LPAREN] = ACTIONS(1321),
    [anon_sym_RPAREN] = ACTIONS(1321),
    [anon_sym_LBRACK] = ACTIONS(1321),
    [anon_sym_RBRACK] = ACTIONS(1321),
    [anon_sym_linksection] = ACTIONS(1321),
    [anon_sym_addrspace] = ACTIONS(1321),
    [anon_sym_PIPE] = ACTIONS(1323),
    [anon_sym_STAR] = ACTIONS(1323),
    [anon_sym_EQ_GT] = ACTIONS(1321),
    [anon_sym_DOT_DOT] = ACTIONS(1321),
    [anon_sym_STAR_EQ] = ACTIONS(1321),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1321),
    [anon_sym_SLASH_EQ] = ACTIONS(1321),
    [anon_sym_PERCENT_EQ] = ACTIONS(1321),
    [anon_sym_PLUS_EQ] = ACTIONS(1321),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1321),
    [anon_sym_DASH_EQ] = ACTIONS(1321),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1321),
    [anon_sym_LT_LT_EQ] = ACTIONS(1321),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1321),
    [anon_sym_GT_GT_EQ] = ACTIONS(1321),
    [anon_sym_AMP_EQ] = ACTIONS(1321),
    [anon_sym_CARET_EQ] = ACTIONS(1321),
    [anon_sym_PIPE_EQ] = ACTIONS(1321),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1321),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1321),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1321),
    [anon_sym_EQ_EQ] = ACTIONS(1321),
    [anon_sym_BANG_EQ] = ACTIONS(1321),
    [anon_sym_LT] = ACTIONS(1323),
    [anon_sym_GT] = ACTIONS(1323),
    [anon_sym_LT_EQ] = ACTIONS(1321),
    [anon_sym_GT_EQ] = ACTIONS(1321),
    [anon_sym_AMP] = ACTIONS(1323),
    [anon_sym_CARET] = ACTIONS(1323),
    [anon_sym_orelse] = ACTIONS(1321),
    [anon_sym_catch] = ACTIONS(1321),
    [anon_sym_LT_LT] = ACTIONS(1323),
    [anon_sym_GT_GT] = ACTIONS(1323),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1323),
    [anon_sym_PLUS] = ACTIONS(1323),
    [anon_sym_DASH] = ACTIONS(1323),
    [anon_sym_PLUS_PLUS] = ACTIONS(1321),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1323),
    [anon_sym_DASH_PERCENT] = ACTIONS(1323),
    [anon_sym_PLUS_PIPE] = ACTIONS(1323),
    [anon_sym_DASH_PIPE] = ACTIONS(1323),
    [anon_sym_PIPE_PIPE] = ACTIONS(1321),
    [anon_sym_SLASH] = ACTIONS(1323),
    [anon_sym_PERCENT] = ACTIONS(1323),
    [anon_sym_STAR_STAR] = ACTIONS(1321),
    [anon_sym_STAR_PERCENT] = ACTIONS(1323),
    [anon_sym_STAR_PIPE] = ACTIONS(1323),
    [anon_sym_align] = ACTIONS(1321),
    [anon_sym_DOT_STAR] = ACTIONS(1321),
    [anon_sym_DOT_QMARK] = ACTIONS(1321),
    [sym_line_comment] = ACTIONS(137),
  },
  [1020] = {
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_SEMI] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1355),
    [anon_sym_COLON] = ACTIONS(1353),
    [anon_sym_EQ] = ACTIONS(1355),
    [anon_sym_else] = ACTIONS(1353),
    [anon_sym_or] = ACTIONS(1355),
    [anon_sym_and] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1353),
    [anon_sym_RBRACE] = ACTIONS(1353),
    [anon_sym_DOT] = ACTIONS(1355),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_RPAREN] = ACTIONS(1353),
    [anon_sym_LBRACK] = ACTIONS(1353),
    [anon_sym_RBRACK] = ACTIONS(1353),
    [anon_sym_linksection] = ACTIONS(1353),
    [anon_sym_addrspace] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(1355),
    [anon_sym_STAR] = ACTIONS(1355),
    [anon_sym_EQ_GT] = ACTIONS(1353),
    [anon_sym_DOT_DOT] = ACTIONS(1353),
    [anon_sym_STAR_EQ] = ACTIONS(1353),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1353),
    [anon_sym_SLASH_EQ] = ACTIONS(1353),
    [anon_sym_PERCENT_EQ] = ACTIONS(1353),
    [anon_sym_PLUS_EQ] = ACTIONS(1353),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1353),
    [anon_sym_DASH_EQ] = ACTIONS(1353),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1353),
    [anon_sym_LT_LT_EQ] = ACTIONS(1353),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1353),
    [anon_sym_GT_GT_EQ] = ACTIONS(1353),
    [anon_sym_AMP_EQ] = ACTIONS(1353),
    [anon_sym_CARET_EQ] = ACTIONS(1353),
    [anon_sym_PIPE_EQ] = ACTIONS(1353),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1353),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1353),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1353),
    [anon_sym_EQ_EQ] = ACTIONS(1353),
    [anon_sym_BANG_EQ] = ACTIONS(1353),
    [anon_sym_LT] = ACTIONS(1355),
    [anon_sym_GT] = ACTIONS(1355),
    [anon_sym_LT_EQ] = ACTIONS(1353),
    [anon_sym_GT_EQ] = ACTIONS(1353),
    [anon_sym_AMP] = ACTIONS(1355),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_orelse] = ACTIONS(1353),
    [anon_sym_catch] = ACTIONS(1353),
    [anon_sym_LT_LT] = ACTIONS(1355),
    [anon_sym_GT_GT] = ACTIONS(1355),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1355),
    [anon_sym_PLUS] = ACTIONS(1355),
    [anon_sym_DASH] = ACTIONS(1355),
    [anon_sym_PLUS_PLUS] = ACTIONS(1353),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1355),
    [anon_sym_DASH_PERCENT] = ACTIONS(1355),
    [anon_sym_PLUS_PIPE] = ACTIONS(1355),
    [anon_sym_DASH_PIPE] = ACTIONS(1355),
    [anon_sym_PIPE_PIPE] = ACTIONS(1353),
    [anon_sym_SLASH] = ACTIONS(1355),
    [anon_sym_PERCENT] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1353),
    [anon_sym_STAR_PERCENT] = ACTIONS(1355),
    [anon_sym_STAR_PIPE] = ACTIONS(1355),
    [anon_sym_align] = ACTIONS(1353),
    [anon_sym_DOT_STAR] = ACTIONS(1353),
    [anon_sym_DOT_QMARK] = ACTIONS(1353),
    [sym_line_comment] = ACTIONS(137),
  },
  [1021] = {
    [anon_sym_COMMA] = ACTIONS(1317),
    [anon_sym_SEMI] = ACTIONS(1317),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_COLON] = ACTIONS(1317),
    [anon_sym_EQ] = ACTIONS(1319),
    [anon_sym_else] = ACTIONS(1317),
    [anon_sym_or] = ACTIONS(1319),
    [anon_sym_and] = ACTIONS(1317),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_RBRACE] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1319),
    [anon_sym_LPAREN] = ACTIONS(1317),
    [anon_sym_RPAREN] = ACTIONS(1317),
    [anon_sym_LBRACK] = ACTIONS(1317),
    [anon_sym_RBRACK] = ACTIONS(1317),
    [anon_sym_linksection] = ACTIONS(1317),
    [anon_sym_addrspace] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_EQ_GT] = ACTIONS(1317),
    [anon_sym_DOT_DOT] = ACTIONS(1317),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_EQ_EQ] = ACTIONS(1317),
    [anon_sym_BANG_EQ] = ACTIONS(1317),
    [anon_sym_LT] = ACTIONS(1319),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_LT_EQ] = ACTIONS(1317),
    [anon_sym_GT_EQ] = ACTIONS(1317),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_orelse] = ACTIONS(1317),
    [anon_sym_catch] = ACTIONS(1317),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1317),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1319),
    [anon_sym_DASH_PERCENT] = ACTIONS(1319),
    [anon_sym_PLUS_PIPE] = ACTIONS(1319),
    [anon_sym_DASH_PIPE] = ACTIONS(1319),
    [anon_sym_PIPE_PIPE] = ACTIONS(1317),
    [anon_sym_SLASH] = ACTIONS(1319),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_STAR_STAR] = ACTIONS(1317),
    [anon_sym_STAR_PERCENT] = ACTIONS(1319),
    [anon_sym_STAR_PIPE] = ACTIONS(1319),
    [anon_sym_align] = ACTIONS(1317),
    [anon_sym_DOT_STAR] = ACTIONS(1317),
    [anon_sym_DOT_QMARK] = ACTIONS(1317),
    [sym_line_comment] = ACTIONS(137),
  },
  [1022] = {
    [sym_InitList] = STATE(1285),
    [sym__ElseTypeExprTail] = STATE(954),
    [anon_sym_COMMA] = ACTIONS(1039),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_BANG] = ACTIONS(1043),
    [anon_sym_COLON] = ACTIONS(1039),
    [anon_sym_EQ] = ACTIONS(1041),
    [anon_sym_else] = ACTIONS(1039),
    [anon_sym_or] = ACTIONS(1041),
    [anon_sym_and] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1764),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_DOT] = ACTIONS(1043),
    [anon_sym_LPAREN] = ACTIONS(1047),
    [anon_sym_RPAREN] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(1039),
    [anon_sym_PIPE] = ACTIONS(1041),
    [anon_sym_STAR] = ACTIONS(1041),
    [anon_sym_EQ_GT] = ACTIONS(1039),
    [anon_sym_DOT_DOT] = ACTIONS(1039),
    [anon_sym_STAR_EQ] = ACTIONS(1039),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1039),
    [anon_sym_SLASH_EQ] = ACTIONS(1039),
    [anon_sym_PERCENT_EQ] = ACTIONS(1039),
    [anon_sym_PLUS_EQ] = ACTIONS(1039),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1039),
    [anon_sym_DASH_EQ] = ACTIONS(1039),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1039),
    [anon_sym_LT_LT_EQ] = ACTIONS(1039),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1039),
    [anon_sym_GT_GT_EQ] = ACTIONS(1039),
    [anon_sym_AMP_EQ] = ACTIONS(1039),
    [anon_sym_CARET_EQ] = ACTIONS(1039),
    [anon_sym_PIPE_EQ] = ACTIONS(1039),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1039),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1039),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1039),
    [anon_sym_EQ_EQ] = ACTIONS(1039),
    [anon_sym_BANG_EQ] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_GT] = ACTIONS(1041),
    [anon_sym_LT_EQ] = ACTIONS(1039),
    [anon_sym_GT_EQ] = ACTIONS(1039),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_CARET] = ACTIONS(1041),
    [anon_sym_orelse] = ACTIONS(1039),
    [anon_sym_catch] = ACTIONS(1039),
    [anon_sym_LT_LT] = ACTIONS(1041),
    [anon_sym_GT_GT] = ACTIONS(1041),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1041),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1041),
    [anon_sym_DASH_PERCENT] = ACTIONS(1041),
    [anon_sym_PLUS_PIPE] = ACTIONS(1041),
    [anon_sym_DASH_PIPE] = ACTIONS(1041),
    [anon_sym_PIPE_PIPE] = ACTIONS(1039),
    [anon_sym_SLASH] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1041),
    [anon_sym_STAR_STAR] = ACTIONS(1039),
    [anon_sym_STAR_PERCENT] = ACTIONS(1041),
    [anon_sym_STAR_PIPE] = ACTIONS(1041),
    [anon_sym_DOT_STAR] = ACTIONS(1047),
    [anon_sym_DOT_QMARK] = ACTIONS(1047),
    [sym_line_comment] = ACTIONS(137),
  },
  [1023] = {
    [sym_FieldOrFnCall] = STATE(1035),
    [sym_SuffixOp] = STATE(1035),
    [sym_FnCallArguments] = STATE(1035),
    [aux_sym_SuffixExpr_repeat1] = STATE(1035),
    [ts_builtin_sym_end] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(941),
    [anon_sym_pub] = ACTIONS(943),
    [anon_sym_test] = ACTIONS(943),
    [anon_sym_comptime] = ACTIONS(943),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_extern] = ACTIONS(943),
    [anon_sym_inline] = ACTIONS(943),
    [anon_sym_noinline] = ACTIONS(943),
    [anon_sym_SEMI] = ACTIONS(941),
    [anon_sym_threadlocal] = ACTIONS(943),
    [anon_sym_usingnamespace] = ACTIONS(943),
    [anon_sym_fn] = ACTIONS(943),
    [anon_sym_BANG] = ACTIONS(941),
    [anon_sym_const] = ACTIONS(943),
    [anon_sym_var] = ACTIONS(943),
    [anon_sym_COLON] = ACTIONS(931),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_else] = ACTIONS(943),
    [anon_sym_LBRACE] = ACTIONS(941),
    [anon_sym_RBRACE] = ACTIONS(941),
    [anon_sym_async] = ACTIONS(943),
    [anon_sym_DOT] = ACTIONS(1766),
    [anon_sym_error] = ACTIONS(943),
    [anon_sym_false] = ACTIONS(943),
    [anon_sym_null] = ACTIONS(943),
    [anon_sym_anyframe] = ACTIONS(943),
    [anon_sym_true] = ACTIONS(943),
    [anon_sym_undefined] = ACTIONS(943),
    [anon_sym_unreachable] = ACTIONS(943),
    [sym_BuildinTypeExpr] = ACTIONS(943),
    [anon_sym_packed] = ACTIONS(943),
    [anon_sym_LPAREN] = ACTIONS(1768),
    [anon_sym_switch] = ACTIONS(943),
    [anon_sym_LBRACK] = ACTIONS(1770),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_while] = ACTIONS(943),
    [anon_sym_for] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(943),
    [anon_sym_STAR_STAR] = ACTIONS(941),
    [anon_sym_QMARK] = ACTIONS(941),
    [anon_sym_align] = ACTIONS(943),
    [anon_sym_DOT_STAR] = ACTIONS(1772),
    [anon_sym_DOT_QMARK] = ACTIONS(1772),
    [anon_sym_struct] = ACTIONS(943),
    [anon_sym_opaque] = ACTIONS(943),
    [anon_sym_enum] = ACTIONS(943),
    [anon_sym_union] = ACTIONS(943),
    [sym_doc_comment] = ACTIONS(941),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(941),
    [aux_sym_FLOAT_token1] = ACTIONS(941),
    [aux_sym_FLOAT_token2] = ACTIONS(941),
    [aux_sym_FLOAT_token3] = ACTIONS(941),
    [aux_sym_FLOAT_token4] = ACTIONS(941),
    [aux_sym_INTEGER_token1] = ACTIONS(941),
    [aux_sym_INTEGER_token2] = ACTIONS(941),
    [aux_sym_INTEGER_token3] = ACTIONS(943),
    [aux_sym_INTEGER_token4] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(941),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(941),
  },
  [1024] = {
    [sym_FieldOrFnCall] = STATE(1031),
    [sym_SuffixOp] = STATE(1031),
    [sym_FnCallArguments] = STATE(1031),
    [aux_sym_SuffixExpr_repeat1] = STATE(1031),
    [ts_builtin_sym_end] = ACTIONS(927),
    [anon_sym_COMMA] = ACTIONS(927),
    [anon_sym_pub] = ACTIONS(929),
    [anon_sym_test] = ACTIONS(929),
    [anon_sym_comptime] = ACTIONS(929),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_extern] = ACTIONS(929),
    [anon_sym_inline] = ACTIONS(929),
    [anon_sym_noinline] = ACTIONS(929),
    [anon_sym_SEMI] = ACTIONS(927),
    [anon_sym_threadlocal] = ACTIONS(929),
    [anon_sym_usingnamespace] = ACTIONS(929),
    [anon_sym_fn] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(927),
    [anon_sym_const] = ACTIONS(929),
    [anon_sym_var] = ACTIONS(929),
    [anon_sym_COLON] = ACTIONS(931),
    [anon_sym_EQ] = ACTIONS(927),
    [anon_sym_else] = ACTIONS(929),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_RBRACE] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(1766),
    [anon_sym_error] = ACTIONS(929),
    [anon_sym_false] = ACTIONS(929),
    [anon_sym_null] = ACTIONS(929),
    [anon_sym_anyframe] = ACTIONS(929),
    [anon_sym_true] = ACTIONS(929),
    [anon_sym_undefined] = ACTIONS(929),
    [anon_sym_unreachable] = ACTIONS(929),
    [sym_BuildinTypeExpr] = ACTIONS(929),
    [anon_sym_packed] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(1768),
    [anon_sym_switch] = ACTIONS(929),
    [anon_sym_LBRACK] = ACTIONS(1770),
    [anon_sym_if] = ACTIONS(929),
    [anon_sym_while] = ACTIONS(929),
    [anon_sym_for] = ACTIONS(929),
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_STAR_STAR] = ACTIONS(927),
    [anon_sym_QMARK] = ACTIONS(927),
    [anon_sym_align] = ACTIONS(929),
    [anon_sym_DOT_STAR] = ACTIONS(1772),
    [anon_sym_DOT_QMARK] = ACTIONS(1772),
    [anon_sym_struct] = ACTIONS(929),
    [anon_sym_opaque] = ACTIONS(929),
    [anon_sym_enum] = ACTIONS(929),
    [anon_sym_union] = ACTIONS(929),
    [sym_doc_comment] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(927),
    [aux_sym_FLOAT_token1] = ACTIONS(927),
    [aux_sym_FLOAT_token2] = ACTIONS(927),
    [aux_sym_FLOAT_token3] = ACTIONS(927),
    [aux_sym_FLOAT_token4] = ACTIONS(927),
    [aux_sym_INTEGER_token1] = ACTIONS(927),
    [aux_sym_INTEGER_token2] = ACTIONS(927),
    [aux_sym_INTEGER_token3] = ACTIONS(929),
    [aux_sym_INTEGER_token4] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(927),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(927),
  },
  [1025] = {
    [sym_InitList] = STATE(1285),
    [sym__ElseTypeExprTail] = STATE(957),
    [anon_sym_COMMA] = ACTIONS(1039),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_BANG] = ACTIONS(1053),
    [anon_sym_COLON] = ACTIONS(1039),
    [anon_sym_EQ] = ACTIONS(1041),
    [anon_sym_else] = ACTIONS(1039),
    [anon_sym_or] = ACTIONS(1041),
    [anon_sym_and] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1764),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_DOT] = ACTIONS(1053),
    [anon_sym_LPAREN] = ACTIONS(1055),
    [anon_sym_RPAREN] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(1055),
    [anon_sym_RBRACK] = ACTIONS(1039),
    [anon_sym_PIPE] = ACTIONS(1041),
    [anon_sym_STAR] = ACTIONS(1041),
    [anon_sym_EQ_GT] = ACTIONS(1039),
    [anon_sym_DOT_DOT] = ACTIONS(1039),
    [anon_sym_STAR_EQ] = ACTIONS(1039),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1039),
    [anon_sym_SLASH_EQ] = ACTIONS(1039),
    [anon_sym_PERCENT_EQ] = ACTIONS(1039),
    [anon_sym_PLUS_EQ] = ACTIONS(1039),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1039),
    [anon_sym_DASH_EQ] = ACTIONS(1039),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1039),
    [anon_sym_LT_LT_EQ] = ACTIONS(1039),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1039),
    [anon_sym_GT_GT_EQ] = ACTIONS(1039),
    [anon_sym_AMP_EQ] = ACTIONS(1039),
    [anon_sym_CARET_EQ] = ACTIONS(1039),
    [anon_sym_PIPE_EQ] = ACTIONS(1039),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1039),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1039),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1039),
    [anon_sym_EQ_EQ] = ACTIONS(1039),
    [anon_sym_BANG_EQ] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_GT] = ACTIONS(1041),
    [anon_sym_LT_EQ] = ACTIONS(1039),
    [anon_sym_GT_EQ] = ACTIONS(1039),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_CARET] = ACTIONS(1041),
    [anon_sym_orelse] = ACTIONS(1039),
    [anon_sym_catch] = ACTIONS(1039),
    [anon_sym_LT_LT] = ACTIONS(1041),
    [anon_sym_GT_GT] = ACTIONS(1041),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1041),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1041),
    [anon_sym_DASH_PERCENT] = ACTIONS(1041),
    [anon_sym_PLUS_PIPE] = ACTIONS(1041),
    [anon_sym_DASH_PIPE] = ACTIONS(1041),
    [anon_sym_PIPE_PIPE] = ACTIONS(1039),
    [anon_sym_SLASH] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1041),
    [anon_sym_STAR_STAR] = ACTIONS(1039),
    [anon_sym_STAR_PERCENT] = ACTIONS(1041),
    [anon_sym_STAR_PIPE] = ACTIONS(1041),
    [anon_sym_DOT_STAR] = ACTIONS(1055),
    [anon_sym_DOT_QMARK] = ACTIONS(1055),
    [sym_line_comment] = ACTIONS(137),
  },
  [1026] = {
    [sym_InitList] = STATE(1285),
    [sym__ElseTypeExprTail] = STATE(958),
    [anon_sym_COMMA] = ACTIONS(1039),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_BANG] = ACTIONS(1061),
    [anon_sym_COLON] = ACTIONS(1039),
    [anon_sym_EQ] = ACTIONS(1041),
    [anon_sym_else] = ACTIONS(1039),
    [anon_sym_or] = ACTIONS(1041),
    [anon_sym_and] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1764),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_DOT] = ACTIONS(1061),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_RPAREN] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(1063),
    [anon_sym_RBRACK] = ACTIONS(1039),
    [anon_sym_PIPE] = ACTIONS(1041),
    [anon_sym_STAR] = ACTIONS(1041),
    [anon_sym_EQ_GT] = ACTIONS(1039),
    [anon_sym_DOT_DOT] = ACTIONS(1039),
    [anon_sym_STAR_EQ] = ACTIONS(1039),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1039),
    [anon_sym_SLASH_EQ] = ACTIONS(1039),
    [anon_sym_PERCENT_EQ] = ACTIONS(1039),
    [anon_sym_PLUS_EQ] = ACTIONS(1039),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1039),
    [anon_sym_DASH_EQ] = ACTIONS(1039),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1039),
    [anon_sym_LT_LT_EQ] = ACTIONS(1039),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1039),
    [anon_sym_GT_GT_EQ] = ACTIONS(1039),
    [anon_sym_AMP_EQ] = ACTIONS(1039),
    [anon_sym_CARET_EQ] = ACTIONS(1039),
    [anon_sym_PIPE_EQ] = ACTIONS(1039),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1039),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1039),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1039),
    [anon_sym_EQ_EQ] = ACTIONS(1039),
    [anon_sym_BANG_EQ] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_GT] = ACTIONS(1041),
    [anon_sym_LT_EQ] = ACTIONS(1039),
    [anon_sym_GT_EQ] = ACTIONS(1039),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_CARET] = ACTIONS(1041),
    [anon_sym_orelse] = ACTIONS(1039),
    [anon_sym_catch] = ACTIONS(1039),
    [anon_sym_LT_LT] = ACTIONS(1041),
    [anon_sym_GT_GT] = ACTIONS(1041),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1041),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1041),
    [anon_sym_DASH_PERCENT] = ACTIONS(1041),
    [anon_sym_PLUS_PIPE] = ACTIONS(1041),
    [anon_sym_DASH_PIPE] = ACTIONS(1041),
    [anon_sym_PIPE_PIPE] = ACTIONS(1039),
    [anon_sym_SLASH] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1041),
    [anon_sym_STAR_STAR] = ACTIONS(1039),
    [anon_sym_STAR_PERCENT] = ACTIONS(1041),
    [anon_sym_STAR_PIPE] = ACTIONS(1041),
    [anon_sym_DOT_STAR] = ACTIONS(1063),
    [anon_sym_DOT_QMARK] = ACTIONS(1063),
    [sym_line_comment] = ACTIONS(137),
  },
  [1027] = {
    [sym_FieldOrFnCall] = STATE(1027),
    [sym_SuffixOp] = STATE(1027),
    [sym_FnCallArguments] = STATE(1027),
    [aux_sym_SuffixExpr_repeat1] = STATE(1027),
    [ts_builtin_sym_end] = ACTIONS(957),
    [anon_sym_COMMA] = ACTIONS(957),
    [anon_sym_pub] = ACTIONS(959),
    [anon_sym_test] = ACTIONS(959),
    [anon_sym_comptime] = ACTIONS(959),
    [anon_sym_export] = ACTIONS(959),
    [anon_sym_extern] = ACTIONS(959),
    [anon_sym_inline] = ACTIONS(959),
    [anon_sym_noinline] = ACTIONS(959),
    [anon_sym_SEMI] = ACTIONS(957),
    [anon_sym_threadlocal] = ACTIONS(959),
    [anon_sym_usingnamespace] = ACTIONS(959),
    [anon_sym_fn] = ACTIONS(959),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_var] = ACTIONS(959),
    [anon_sym_EQ] = ACTIONS(957),
    [anon_sym_else] = ACTIONS(959),
    [anon_sym_LBRACE] = ACTIONS(957),
    [anon_sym_RBRACE] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_DOT] = ACTIONS(1774),
    [anon_sym_error] = ACTIONS(959),
    [anon_sym_false] = ACTIONS(959),
    [anon_sym_null] = ACTIONS(959),
    [anon_sym_anyframe] = ACTIONS(959),
    [anon_sym_true] = ACTIONS(959),
    [anon_sym_undefined] = ACTIONS(959),
    [anon_sym_unreachable] = ACTIONS(959),
    [sym_BuildinTypeExpr] = ACTIONS(959),
    [anon_sym_packed] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [anon_sym_switch] = ACTIONS(959),
    [anon_sym_LBRACK] = ACTIONS(1780),
    [anon_sym_if] = ACTIONS(959),
    [anon_sym_while] = ACTIONS(959),
    [anon_sym_for] = ACTIONS(959),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_STAR_STAR] = ACTIONS(957),
    [anon_sym_QMARK] = ACTIONS(957),
    [anon_sym_align] = ACTIONS(959),
    [anon_sym_DOT_STAR] = ACTIONS(1783),
    [anon_sym_DOT_QMARK] = ACTIONS(1783),
    [anon_sym_struct] = ACTIONS(959),
    [anon_sym_opaque] = ACTIONS(959),
    [anon_sym_enum] = ACTIONS(959),
    [anon_sym_union] = ACTIONS(959),
    [sym_doc_comment] = ACTIONS(957),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(957),
    [aux_sym_FLOAT_token1] = ACTIONS(957),
    [aux_sym_FLOAT_token2] = ACTIONS(957),
    [aux_sym_FLOAT_token3] = ACTIONS(957),
    [aux_sym_FLOAT_token4] = ACTIONS(957),
    [aux_sym_INTEGER_token1] = ACTIONS(957),
    [aux_sym_INTEGER_token2] = ACTIONS(957),
    [aux_sym_INTEGER_token3] = ACTIONS(959),
    [aux_sym_INTEGER_token4] = ACTIONS(959),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(957),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(959),
    [anon_sym_AT] = ACTIONS(957),
  },
  [1028] = {
    [sym_FieldOrFnCall] = STATE(1042),
    [sym_SuffixOp] = STATE(1042),
    [sym_FnCallArguments] = STATE(1042),
    [aux_sym_SuffixExpr_repeat1] = STATE(1042),
    [ts_builtin_sym_end] = ACTIONS(927),
    [anon_sym_COMMA] = ACTIONS(927),
    [anon_sym_pub] = ACTIONS(929),
    [anon_sym_test] = ACTIONS(929),
    [anon_sym_comptime] = ACTIONS(929),
    [anon_sym_export] = ACTIONS(929),
    [anon_sym_extern] = ACTIONS(929),
    [anon_sym_inline] = ACTIONS(929),
    [anon_sym_noinline] = ACTIONS(929),
    [anon_sym_SEMI] = ACTIONS(927),
    [anon_sym_threadlocal] = ACTIONS(929),
    [anon_sym_usingnamespace] = ACTIONS(929),
    [anon_sym_fn] = ACTIONS(929),
    [anon_sym_BANG] = ACTIONS(927),
    [anon_sym_const] = ACTIONS(929),
    [anon_sym_var] = ACTIONS(929),
    [anon_sym_COLON] = ACTIONS(931),
    [anon_sym_EQ] = ACTIONS(927),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_RBRACE] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(929),
    [anon_sym_DOT] = ACTIONS(1786),
    [anon_sym_error] = ACTIONS(929),
    [anon_sym_false] = ACTIONS(929),
    [anon_sym_null] = ACTIONS(929),
    [anon_sym_anyframe] = ACTIONS(929),
    [anon_sym_true] = ACTIONS(929),
    [anon_sym_undefined] = ACTIONS(929),
    [anon_sym_unreachable] = ACTIONS(929),
    [sym_BuildinTypeExpr] = ACTIONS(929),
    [anon_sym_packed] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(1788),
    [anon_sym_switch] = ACTIONS(929),
    [anon_sym_LBRACK] = ACTIONS(1790),
    [anon_sym_if] = ACTIONS(929),
    [anon_sym_while] = ACTIONS(929),
    [anon_sym_for] = ACTIONS(929),
    [anon_sym_STAR] = ACTIONS(929),
    [anon_sym_STAR_STAR] = ACTIONS(927),
    [anon_sym_QMARK] = ACTIONS(927),
    [anon_sym_align] = ACTIONS(929),
    [anon_sym_DOT_STAR] = ACTIONS(1792),
    [anon_sym_DOT_QMARK] = ACTIONS(1792),
    [anon_sym_struct] = ACTIONS(929),
    [anon_sym_opaque] = ACTIONS(929),
    [anon_sym_enum] = ACTIONS(929),
    [anon_sym_union] = ACTIONS(929),
    [sym_doc_comment] = ACTIONS(927),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(927),
    [aux_sym_FLOAT_token1] = ACTIONS(927),
    [aux_sym_FLOAT_token2] = ACTIONS(927),
    [aux_sym_FLOAT_token3] = ACTIONS(927),
    [aux_sym_FLOAT_token4] = ACTIONS(927),
    [aux_sym_INTEGER_token1] = ACTIONS(927),
    [aux_sym_INTEGER_token2] = ACTIONS(927),
    [aux_sym_INTEGER_token3] = ACTIONS(929),
    [aux_sym_INTEGER_token4] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(927),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(927),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(927),
  },
  [1029] = {
    [sym_FieldOrFnCall] = STATE(1032),
    [sym_SuffixOp] = STATE(1032),
    [sym_FnCallArguments] = STATE(1032),
    [aux_sym_SuffixExpr_repeat1] = STATE(1032),
    [ts_builtin_sym_end] = ACTIONS(985),
    [anon_sym_COMMA] = ACTIONS(985),
    [anon_sym_pub] = ACTIONS(987),
    [anon_sym_test] = ACTIONS(987),
    [anon_sym_comptime] = ACTIONS(987),
    [anon_sym_export] = ACTIONS(987),
    [anon_sym_extern] = ACTIONS(987),
    [anon_sym_inline] = ACTIONS(987),
    [anon_sym_noinline] = ACTIONS(987),
    [anon_sym_SEMI] = ACTIONS(985),
    [anon_sym_threadlocal] = ACTIONS(987),
    [anon_sym_usingnamespace] = ACTIONS(987),
    [anon_sym_fn] = ACTIONS(987),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_const] = ACTIONS(987),
    [anon_sym_var] = ACTIONS(987),
    [anon_sym_EQ] = ACTIONS(985),
    [anon_sym_else] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(985),
    [anon_sym_RBRACE] = ACTIONS(985),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_DOT] = ACTIONS(1766),
    [anon_sym_error] = ACTIONS(987),
    [anon_sym_false] = ACTIONS(987),
    [anon_sym_null] = ACTIONS(987),
    [anon_sym_anyframe] = ACTIONS(987),
    [anon_sym_true] = ACTIONS(987),
    [anon_sym_undefined] = ACTIONS(987),
    [anon_sym_unreachable] = ACTIONS(987),
    [sym_BuildinTypeExpr] = ACTIONS(987),
    [anon_sym_packed] = ACTIONS(987),
    [anon_sym_LPAREN] = ACTIONS(1768),
    [anon_sym_switch] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(1770),
    [anon_sym_if] = ACTIONS(987),
    [anon_sym_while] = ACTIONS(987),
    [anon_sym_for] = ACTIONS(987),
    [anon_sym_STAR] = ACTIONS(987),
    [anon_sym_STAR_STAR] = ACTIONS(985),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_align] = ACTIONS(987),
    [anon_sym_DOT_STAR] = ACTIONS(1772),
    [anon_sym_DOT_QMARK] = ACTIONS(1772),
    [anon_sym_struct] = ACTIONS(987),
    [anon_sym_opaque] = ACTIONS(987),
    [anon_sym_enum] = ACTIONS(987),
    [anon_sym_union] = ACTIONS(987),
    [sym_doc_comment] = ACTIONS(985),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(985),
    [aux_sym_FLOAT_token1] = ACTIONS(985),
    [aux_sym_FLOAT_token2] = ACTIONS(985),
    [aux_sym_FLOAT_token3] = ACTIONS(985),
    [aux_sym_FLOAT_token4] = ACTIONS(985),
    [aux_sym_INTEGER_token1] = ACTIONS(985),
    [aux_sym_INTEGER_token2] = ACTIONS(985),
    [aux_sym_INTEGER_token3] = ACTIONS(987),
    [aux_sym_INTEGER_token4] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(985),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(985),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(987),
    [anon_sym_AT] = ACTIONS(985),
  },
  [1030] = {
    [sym_InitList] = STATE(1285),
    [anon_sym_COMMA] = ACTIONS(1039),
    [anon_sym_SEMI] = ACTIONS(1039),
    [anon_sym_BANG] = ACTIONS(1105),
    [anon_sym_COLON] = ACTIONS(1039),
    [anon_sym_EQ] = ACTIONS(1041),
    [anon_sym_else] = ACTIONS(1039),
    [anon_sym_or] = ACTIONS(1041),
    [anon_sym_and] = ACTIONS(1039),
    [anon_sym_LBRACE] = ACTIONS(1764),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym_DOT] = ACTIONS(1105),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_RPAREN] = ACTIONS(1039),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_RBRACK] = ACTIONS(1039),
    [anon_sym_PIPE] = ACTIONS(1041),
    [anon_sym_STAR] = ACTIONS(1041),
    [anon_sym_EQ_GT] = ACTIONS(1039),
    [anon_sym_DOT_DOT] = ACTIONS(1039),
    [anon_sym_STAR_EQ] = ACTIONS(1039),
    [anon_sym_STAR_PIPE_EQ] = ACTIONS(1039),
    [anon_sym_SLASH_EQ] = ACTIONS(1039),
    [anon_sym_PERCENT_EQ] = ACTIONS(1039),
    [anon_sym_PLUS_EQ] = ACTIONS(1039),
    [anon_sym_PLUS_PIPE_EQ] = ACTIONS(1039),
    [anon_sym_DASH_EQ] = ACTIONS(1039),
    [anon_sym_DASH_PIPE_EQ] = ACTIONS(1039),
    [anon_sym_LT_LT_EQ] = ACTIONS(1039),
    [anon_sym_LT_LT_PIPE_EQ] = ACTIONS(1039),
    [anon_sym_GT_GT_EQ] = ACTIONS(1039),
    [anon_sym_AMP_EQ] = ACTIONS(1039),
    [anon_sym_CARET_EQ] = ACTIONS(1039),
    [anon_sym_PIPE_EQ] = ACTIONS(1039),
    [anon_sym_STAR_PERCENT_EQ] = ACTIONS(1039),
    [anon_sym_PLUS_PERCENT_EQ] = ACTIONS(1039),
    [anon_sym_DASH_PERCENT_EQ] = ACTIONS(1039),
    [anon_sym_EQ_EQ] = ACTIONS(1039),
    [anon_sym_BANG_EQ] = ACTIONS(1039),
    [anon_sym_LT] = ACTIONS(1041),
    [anon_sym_GT] = ACTIONS(1041),
    [anon_sym_LT_EQ] = ACTIONS(1039),
    [anon_sym_GT_EQ] = ACTIONS(1039),
    [anon_sym_AMP] = ACTIONS(1041),
    [anon_sym_CARET] = ACTIONS(1041),
    [anon_sym_orelse] = ACTIONS(1039),
    [anon_sym_catch] = ACTIONS(1039),
    [anon_sym_LT_LT] = ACTIONS(1041),
    [anon_sym_GT_GT] = ACTIONS(1041),
    [anon_sym_LT_LT_PIPE] = ACTIONS(1041),
    [anon_sym_PLUS] = ACTIONS(1041),
    [anon_sym_DASH] = ACTIONS(1041),
    [anon_sym_PLUS_PLUS] = ACTIONS(1039),
    [anon_sym_PLUS_PERCENT] = ACTIONS(1041),
    [anon_sym_DASH_PERCENT] = ACTIONS(1041),
    [anon_sym_PLUS_PIPE] = ACTIONS(1041),
    [anon_sym_DASH_PIPE] = ACTIONS(1041),
    [anon_sym_PIPE_PIPE] = ACTIONS(1039),
    [anon_sym_SLASH] = ACTIONS(1041),
    [anon_sym_PERCENT] = ACTIONS(1041),
    [anon_sym_STAR_STAR] = ACTIONS(1039),
    [anon_sym_STAR_PERCENT] = ACTIONS(1041),
    [anon_sym_STAR_PIPE] = ACTIONS(1041),
    [anon_sym_DOT_STAR] = ACTIONS(1107),
    [anon_sym_DOT_QMARK] = ACTIONS(1107),
    [sym_line_comment] = ACTIONS(137),
  },
  [1031] = {
    [sym_FieldOrFnCall] = STATE(1027),
    [sym_SuffixOp] = STATE(1027),
    [sym_FnCallArguments] = STATE(1027),
    [aux_sym_SuffixExpr_repeat1] = STATE(1027),
    [ts_builtin_sym_end] = ACTIONS(973),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_pub] = ACTIONS(975),
    [anon_sym_test] = ACTIONS(975),
    [anon_sym_comptime] = ACTIONS(975),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_extern] = ACTIONS(975),
    [anon_sym_inline] = ACTIONS(975),
    [anon_sym_noinline] = ACTIONS(975),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_threadlocal] = ACTIONS(975),
    [anon_sym_usingnamespace] = ACTIONS(975),
    [anon_sym_fn] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_const] = ACTIONS(975),
    [anon_sym_var] = ACTIONS(975),
    [anon_sym_EQ] = ACTIONS(973),
    [anon_sym_else] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(975),
    [anon_sym_DOT] = ACTIONS(1766),
    [anon_sym_error] = ACTIONS(975),
    [anon_sym_false] = ACTIONS(975),
    [anon_sym_null] = ACTIONS(975),
    [anon_sym_anyframe] = ACTIONS(975),
    [anon_sym_true] = ACTIONS(975),
    [anon_sym_undefined] = ACTIONS(975),
    [anon_sym_unreachable] = ACTIONS(975),
    [sym_BuildinTypeExpr] = ACTIONS(975),
    [anon_sym_packed] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1768),
    [anon_sym_switch] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(1770),
    [anon_sym_if] = ACTIONS(975),
    [anon_sym_while] = ACTIONS(975),
    [anon_sym_for] = ACTIONS(975),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_STAR_STAR] = ACTIONS(973),
    [anon_sym_QMARK] = ACTIONS(973),
    [anon_sym_align] = ACTIONS(975),
    [anon_sym_DOT_STAR] = ACTIONS(1772),
    [anon_sym_DOT_QMARK] = ACTIONS(1772),
    [anon_sym_struct] = ACTIONS(975),
    [anon_sym_opaque] = ACTIONS(975),
    [anon_sym_enum] = ACTIONS(975),
    [anon_sym_union] = ACTIONS(975),
    [sym_doc_comment] = ACTIONS(973),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [aux_sym_FLOAT_token1] = ACTIONS(973),
    [aux_sym_FLOAT_token2] = ACTIONS(973),
    [aux_sym_FLOAT_token3] = ACTIONS(973),
    [aux_sym_FLOAT_token4] = ACTIONS(973),
    [aux_sym_INTEGER_token1] = ACTIONS(973),
    [aux_sym_INTEGER_token2] = ACTIONS(973),
    [aux_sym_INTEGER_token3] = ACTIONS(975),
    [aux_sym_INTEGER_token4] = ACTIONS(975),
    [anon_sym_DQUOTE] = ACTIONS(973),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(973),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(975),
    [anon_sym_AT] = ACTIONS(973),
  },
  [1032] = {
    [sym_FieldOrFnCall] = STATE(1027),
    [sym_SuffixOp] = STATE(1027),
    [sym_FnCallArguments] = STATE(1027),
    [aux_sym_SuffixExpr_repeat1] = STATE(1027),
    [ts_builtin_sym_end] = ACTIONS(977),
    [anon_sym_COMMA] = ACTIONS(977),
    [anon_sym_pub] = ACTIONS(979),
    [anon_sym_test] = ACTIONS(979),
    [anon_sym_comptime] = ACTIONS(979),
    [anon_sym_export] = ACTIONS(979),
    [anon_sym_extern] = ACTIONS(979),
    [anon_sym_inline] = ACTIONS(979),
    [anon_sym_noinline] = ACTIONS(979),
    [anon_sym_SEMI] = ACTIONS(977),
    [anon_sym_threadlocal] = ACTIONS(979),
    [anon_sym_usingnamespace] = ACTIONS(979),
    [anon_sym_fn] = ACTIONS(979),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_const] = ACTIONS(979),
    [anon_sym_var] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(977),
    [anon_sym_else] = ACTIONS(979),
    [anon_sym_LBRACE] = ACTIONS(977),
    [anon_sym_RBRACE] = ACTIONS(977),
    [anon_sym_async] = ACTIONS(979),
    [anon_sym_DOT] = ACTIONS(1766),
    [anon_sym_error] = ACTIONS(979),
    [anon_sym_false] = ACTIONS(979),
    [anon_sym_null] = ACTIONS(979),
    [anon_sym_anyframe] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(979),
    [anon_sym_undefined] = ACTIONS(979),
    [anon_sym_unreachable] = ACTIONS(979),
    [sym_BuildinTypeExpr] = ACTIONS(979),
    [anon_sym_packed] = ACTIONS(979),
    [anon_sym_LPAREN] = ACTIONS(1768),
    [anon_sym_switch] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1770),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(979),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_STAR_STAR] = ACTIONS(977),
    [anon_sym_QMARK] = ACTIONS(977),
    [anon_sym_align] = ACTIONS(979),
    [anon_sym_DOT_STAR] = ACTIONS(1772),
    [anon_sym_DOT_QMARK] = ACTIONS(1772),
    [anon_sym_struct] = ACTIONS(979),
    [anon_sym_opaque] = ACTIONS(979),
    [anon_sym_enum] = ACTIONS(979),
    [anon_sym_union] = ACTIONS(979),
    [sym_doc_comment] = ACTIONS(977),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(977),
    [aux_sym_FLOAT_token1] = ACTIONS(977),
    [aux_sym_FLOAT_token2] = ACTIONS(977),
    [aux_sym_FLOAT_token3] = ACTIONS(977),
    [aux_sym_FLOAT_token4] = ACTIONS(977),
    [aux_sym_INTEGER_token1] = ACTIONS(977),
    [aux_sym_INTEGER_token2] = ACTIONS(977),
    [aux_sym_INTEGER_token3] = ACTIONS(979),
    [aux_sym_INTEGER_token4] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(977),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(979),
    [anon_sym_AT] = ACTIONS(977),
  },
  [1033] = {
    [sym_FieldOrFnCall] = STATE(1034),
    [sym_SuffixOp] = STATE(1034),
    [sym_FnCallArguments] = STATE(1034),
    [aux_sym_SuffixExpr_repeat1] = STATE(1034),
    [ts_builtin_sym_end] = ACTIONS(981),
    [anon_sym_COMMA] = ACTIONS(981),
    [anon_sym_pub] = ACTIONS(983),
    [anon_sym_test] = ACTIONS(983),
    [anon_sym_comptime] = ACTIONS(983),
    [anon_sym_export] = ACTIONS(983),
    [anon_sym_extern] = ACTIONS(983),
    [anon_sym_inline] = ACTIONS(983),
    [anon_sym_noinline] = ACTIONS(983),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_threadlocal] = ACTIONS(983),
    [anon_sym_usingnamespace] = ACTIONS(983),
    [anon_sym_fn] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(981),
    [anon_sym_const] = ACTIONS(983),
    [anon_sym_var] = ACTIONS(983),
    [anon_sym_EQ] = ACTIONS(981),
    [anon_sym_else] = ACTIONS(983),
    [anon_sym_LBRACE] = ACTIONS(981),
    [anon_sym_RBRACE] = ACTIONS(981),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_DOT] = ACTIONS(1766),
    [anon_sym_error] = ACTIONS(983),
    [anon_sym_false] = ACTIONS(983),
    [anon_sym_null] = ACTIONS(983),
    [anon_sym_anyframe] = ACTIONS(983),
    [anon_sym_true] = ACTIONS(983),
    [anon_sym_undefined] = ACTIONS(983),
    [anon_sym_unreachable] = ACTIONS(983),
    [sym_BuildinTypeExpr] = ACTIONS(983),
    [anon_sym_packed] = ACTIONS(983),
    [anon_sym_LPAREN] = ACTIONS(1768),
    [anon_sym_switch] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(1770),
    [anon_sym_if] = ACTIONS(983),
    [anon_sym_while] = ACTIONS(983),
    [anon_sym_for] = ACTIONS(983),
    [anon_sym_STAR] = ACTIONS(983),
    [anon_sym_STAR_STAR] = ACTIONS(981),
    [anon_sym_QMARK] = ACTIONS(981),
    [anon_sym_align] = ACTIONS(983),
    [anon_sym_DOT_STAR] = ACTIONS(1772),
    [anon_sym_DOT_QMARK] = ACTIONS(1772),
    [anon_sym_struct] = ACTIONS(983),
    [anon_sym_opaque] = ACTIONS(983),
    [anon_sym_enum] = ACTIONS(983),
    [anon_sym_union] = ACTIONS(983),
    [sym_doc_comment] = ACTIONS(981),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(981),
    [aux_sym_FLOAT_token1] = ACTIONS(981),
    [aux_sym_FLOAT_token2] = ACTIONS(981),
    [aux_sym_FLOAT_token3] = ACTIONS(981),
    [aux_sym_FLOAT_token4] = ACTIONS(981),
    [aux_sym_INTEGER_token1] = ACTIONS(981),
    [aux_sym_INTEGER_token2] = ACTIONS(981),
    [aux_sym_INTEGER_token3] = ACTIONS(983),
    [aux_sym_INTEGER_token4] = ACTIONS(983),
    [anon_sym_DQUOTE] = ACTIONS(981),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(981),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(981),
  },
  [1034] = {
    [sym_FieldOrFnCall] = STATE(1027),
    [sym_SuffixOp] = STATE(1027),
    [sym_FnCallArguments] = STATE(1027),
    [aux_sym_SuffixExpr_repeat1] = STATE(1027),
    [ts_builtin_sym_end] = ACTIONS(989),
    [anon_sym_COMMA] = ACTIONS(989),
    [anon_sym_pub] = ACTIONS(991),
    [anon_sym_test] = ACTIONS(991),
    [anon_sym_comptime] = ACTIONS(991),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_extern] = ACTIONS(991),
    [anon_sym_inline] = ACTIONS(991),
    [anon_sym_noinline] = ACTIONS(991),
    [anon_sym_SEMI] = ACTIONS(989),
    [anon_sym_threadlocal] = ACTIONS(991),
    [anon_sym_usingnamespace] = ACTIONS(991),
    [anon_sym_fn] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(989),
    [anon_sym_const] = ACTIONS(991),
    [anon_sym_var] = ACTIONS(991),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_else] = ACTIONS(991),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_RBRACE] = ACTIONS(989),
    [anon_sym_async] = ACTIONS(991),
    [anon_sym_DOT] = ACTIONS(1766),
    [anon_sym_error] = ACTIONS(991),
    [anon_sym_false] = ACTIONS(991),
    [anon_sym_null] = ACTIONS(991),
    [anon_sym_anyframe] = ACTIONS(991),
    [anon_sym_true] = ACTIONS(991),
    [anon_sym_undefined] = ACTIONS(991),
    [anon_sym_unreachable] = ACTIONS(991),
    [sym_BuildinTypeExpr] = ACTIONS(991),
    [anon_sym_packed] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(1768),
    [anon_sym_switch] = ACTIONS(991),
    [anon_sym_LBRACK] = ACTIONS(1770),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_while] = ACTIONS(991),
    [anon_sym_for] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(991),
    [anon_sym_STAR_STAR] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(989),
    [anon_sym_align] = ACTIONS(991),
    [anon_sym_DOT_STAR] = ACTIONS(1772),
    [anon_sym_DOT_QMARK] = ACTIONS(1772),
    [anon_sym_struct] = ACTIONS(991),
    [anon_sym_opaque] = ACTIONS(991),
    [anon_sym_enum] = ACTIONS(991),
    [anon_sym_union] = ACTIONS(991),
    [sym_doc_comment] = ACTIONS(989),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(989),
    [aux_sym_FLOAT_token1] = ACTIONS(989),
    [aux_sym_FLOAT_token2] = ACTIONS(989),
    [aux_sym_FLOAT_token3] = ACTIONS(989),
    [aux_sym_FLOAT_token4] = ACTIONS(989),
    [aux_sym_INTEGER_token1] = ACTIONS(989),
    [aux_sym_INTEGER_token2] = ACTIONS(989),
    [aux_sym_INTEGER_token3] = ACTIONS(991),
    [aux_sym_INTEGER_token4] = ACTIONS(991),
    [anon_sym_DQUOTE] = ACTIONS(989),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(989),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(991),
    [anon_sym_AT] = ACTIONS(989),
  },
  [1035] = {
    [sym_FieldOrFnCall] = STATE(1027),
    [sym_SuffixOp] = STATE(1027),
    [sym_FnCallArguments] = STATE(1027),
    [aux_sym_SuffixExpr_repeat1] = STATE(1027),
    [ts_builtin_sym_end] = ACTIONS(953),
    [anon_sym_COMMA] = ACTIONS(953),
    [anon_sym_pub] = ACTIONS(955),
    [anon_sym_test] = ACTIONS(955),
    [anon_sym_comptime] = ACTIONS(955),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_extern] = ACTIONS(955),
    [anon_sym_inline] = ACTIONS(955),
    [anon_sym_noinline] = ACTIONS(955),
    [anon_sym_SEMI] = ACTIONS(953),
    [anon_sym_threadlocal] = ACTIONS(955),
    [anon_sym_usingnamespace] = ACTIONS(955),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_var] = ACTIONS(955),
    [anon_sym_EQ] = ACTIONS(953),
    [anon_sym_else] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(953),
    [anon_sym_RBRACE] = ACTIONS(953),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_DOT] = ACTIONS(1766),
    [anon_sym_error] = ACTIONS(955),
    [anon_sym_false] = ACTIONS(955),
    [anon_sym_null] = ACTIONS(955),
    [anon_sym_anyframe] = ACTIONS(955),
    [anon_sym_true] = ACTIONS(955),
    [anon_sym_undefined] = ACTIONS(955),
    [anon_sym_unreachable] = ACTIONS(955),
    [sym_BuildinTypeExpr] = ACTIONS(955),
    [anon_sym_packed] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1768),
    [anon_sym_switch] = ACTIONS(955),
    [anon_sym_LBRACK] = ACTIONS(1770),
    [anon_sym_if] = ACTIONS(955),
    [anon_sym_while] = ACTIONS(955),
    [anon_sym_for] = ACTIONS(955),
    [anon_sym_STAR] = ACTIONS(955),
    [anon_sym_STAR_STAR] = ACTIONS(953),
    [anon_sym_QMARK] = ACTIONS(953),
    [anon_sym_align] = ACTIONS(955),
    [anon_sym_DOT_STAR] = ACTIONS(1772),
    [anon_sym_DOT_QMARK] = ACTIONS(1772),
    [anon_sym_struct] = ACTIONS(955),
    [anon_sym_opaque] = ACTIONS(955),
    [anon_sym_enum] = ACTIONS(955),
    [anon_sym_union] = ACTIONS(955),
    [sym_doc_comment] = ACTIONS(953),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(953),
    [aux_sym_FLOAT_token1] = ACTIONS(953),
    [aux_sym_FLOAT_token2] = ACTIONS(953),
    [aux_sym_FLOAT_token3] = ACTIONS(953),
    [aux_sym_FLOAT_token4] = ACTIONS(953),
    [aux_sym_INTEGER_token1] = ACTIONS(953),
    [aux_sym_INTEGER_token2] = ACTIONS(953),
    [aux_sym_INTEGER_token3] = ACTIONS(955),
    [aux_sym_INTEGER_token4] = ACTIONS(955),
    [anon_sym_DQUOTE] = ACTIONS(953),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(953),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(955),
    [anon_sym_AT] = ACTIONS(953),
  },
  [1036] = {
    [sym_FieldOrFnCall] = STATE(1039),
    [sym_SuffixOp] = STATE(1039),
    [sym_FnCallArguments] = STATE(1039),
    [aux_sym_SuffixExpr_repeat1] = STATE(1039),
    [ts_builtin_sym_end] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(941),
    [anon_sym_pub] = ACTIONS(943),
    [anon_sym_test] = ACTIONS(943),
    [anon_sym_comptime] = ACTIONS(943),
    [anon_sym_export] = ACTIONS(943),
    [anon_sym_extern] = ACTIONS(943),
    [anon_sym_inline] = ACTIONS(943),
    [anon_sym_noinline] = ACTIONS(943),
    [anon_sym_SEMI] = ACTIONS(941),
    [anon_sym_threadlocal] = ACTIONS(943),
    [anon_sym_usingnamespace] = ACTIONS(943),
    [anon_sym_fn] = ACTIONS(943),
    [anon_sym_BANG] = ACTIONS(941),
    [anon_sym_const] = ACTIONS(943),
    [anon_sym_var] = ACTIONS(943),
    [anon_sym_COLON] = ACTIONS(931),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(941),
    [anon_sym_RBRACE] = ACTIONS(941),
    [anon_sym_async] = ACTIONS(943),
    [anon_sym_DOT] = ACTIONS(1786),
    [anon_sym_error] = ACTIONS(943),
    [anon_sym_false] = ACTIONS(943),
    [anon_sym_null] = ACTIONS(943),
    [anon_sym_anyframe] = ACTIONS(943),
    [anon_sym_true] = ACTIONS(943),
    [anon_sym_undefined] = ACTIONS(943),
    [anon_sym_unreachable] = ACTIONS(943),
    [sym_BuildinTypeExpr] = ACTIONS(943),
    [anon_sym_packed] = ACTIONS(943),
    [anon_sym_LPAREN] = ACTIONS(1788),
    [anon_sym_switch] = ACTIONS(943),
    [anon_sym_LBRACK] = ACTIONS(1790),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_while] = ACTIONS(943),
    [anon_sym_for] = ACTIONS(943),
    [anon_sym_STAR] = ACTIONS(943),
    [anon_sym_STAR_STAR] = ACTIONS(941),
    [anon_sym_QMARK] = ACTIONS(941),
    [anon_sym_align] = ACTIONS(943),
    [anon_sym_DOT_STAR] = ACTIONS(1792),
    [anon_sym_DOT_QMARK] = ACTIONS(1792),
    [anon_sym_struct] = ACTIONS(943),
    [anon_sym_opaque] = ACTIONS(943),
    [anon_sym_enum] = ACTIONS(943),
    [anon_sym_union] = ACTIONS(943),
    [sym_doc_comment] = ACTIONS(941),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(941),
    [aux_sym_FLOAT_token1] = ACTIONS(941),
    [aux_sym_FLOAT_token2] = ACTIONS(941),
    [aux_sym_FLOAT_token3] = ACTIONS(941),
    [aux_sym_FLOAT_token4] = ACTIONS(941),
    [aux_sym_INTEGER_token1] = ACTIONS(941),
    [aux_sym_INTEGER_token2] = ACTIONS(941),
    [aux_sym_INTEGER_token3] = ACTIONS(943),
    [aux_sym_INTEGER_token4] = ACTIONS(943),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(941),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(941),
  },
  [1037] = {
    [sym_FieldOrFnCall] = STATE(1040),
    [sym_SuffixOp] = STATE(1040),
    [sym_FnCallArguments] = STATE(1040),
    [aux_sym_SuffixExpr_repeat1] = STATE(1040),
    [ts_builtin_sym_end] = ACTIONS(981),
    [anon_sym_COMMA] = ACTIONS(981),
    [anon_sym_pub] = ACTIONS(983),
    [anon_sym_test] = ACTIONS(983),
    [anon_sym_comptime] = ACTIONS(983),
    [anon_sym_export] = ACTIONS(983),
    [anon_sym_extern] = ACTIONS(983),
    [anon_sym_inline] = ACTIONS(983),
    [anon_sym_noinline] = ACTIONS(983),
    [anon_sym_SEMI] = ACTIONS(981),
    [anon_sym_threadlocal] = ACTIONS(983),
    [anon_sym_usingnamespace] = ACTIONS(983),
    [anon_sym_fn] = ACTIONS(983),
    [anon_sym_BANG] = ACTIONS(981),
    [anon_sym_const] = ACTIONS(983),
    [anon_sym_var] = ACTIONS(983),
    [anon_sym_EQ] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(981),
    [anon_sym_RBRACE] = ACTIONS(981),
    [anon_sym_async] = ACTIONS(983),
    [anon_sym_DOT] = ACTIONS(1786),
    [anon_sym_error] = ACTIONS(983),
    [anon_sym_false] = ACTIONS(983),
    [anon_sym_null] = ACTIONS(983),
    [anon_sym_anyframe] = ACTIONS(983),
    [anon_sym_true] = ACTIONS(983),
    [anon_sym_undefined] = ACTIONS(983),
    [anon_sym_unreachable] = ACTIONS(983),
    [sym_BuildinTypeExpr] = ACTIONS(983),
    [anon_sym_packed] = ACTIONS(983),
    [anon_sym_LPAREN] = ACTIONS(1788),
    [anon_sym_switch] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(1790),
    [anon_sym_if] = ACTIONS(983),
    [anon_sym_while] = ACTIONS(983),
    [anon_sym_for] = ACTIONS(983),
    [anon_sym_STAR] = ACTIONS(983),
    [anon_sym_STAR_STAR] = ACTIONS(981),
    [anon_sym_QMARK] = ACTIONS(981),
    [anon_sym_align] = ACTIONS(983),
    [anon_sym_DOT_STAR] = ACTIONS(1792),
    [anon_sym_DOT_QMARK] = ACTIONS(1792),
    [anon_sym_struct] = ACTIONS(983),
    [anon_sym_opaque] = ACTIONS(983),
    [anon_sym_enum] = ACTIONS(983),
    [anon_sym_union] = ACTIONS(983),
    [sym_doc_comment] = ACTIONS(981),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(981),
    [aux_sym_FLOAT_token1] = ACTIONS(981),
    [aux_sym_FLOAT_token2] = ACTIONS(981),
    [aux_sym_FLOAT_token3] = ACTIONS(981),
    [aux_sym_FLOAT_token4] = ACTIONS(981),
    [aux_sym_INTEGER_token1] = ACTIONS(981),
    [aux_sym_INTEGER_token2] = ACTIONS(981),
    [aux_sym_INTEGER_token3] = ACTIONS(983),
    [aux_sym_INTEGER_token4] = ACTIONS(983),
    [anon_sym_DQUOTE] = ACTIONS(981),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(981),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(981),
  },
  [1038] = {
    [sym_FieldOrFnCall] = STATE(1041),
    [sym_SuffixOp] = STATE(1041),
    [sym_FnCallArguments] = STATE(1041),
    [aux_sym_SuffixExpr_repeat1] = STATE(1041),
    [ts_builtin_sym_end] = ACTIONS(977),
    [anon_sym_COMMA] = ACTIONS(977),
    [anon_sym_pub] = ACTIONS(979),
    [anon_sym_test] = ACTIONS(979),
    [anon_sym_comptime] = ACTIONS(979),
    [anon_sym_export] = ACTIONS(979),
    [anon_sym_extern] = ACTIONS(979),
    [anon_sym_inline] = ACTIONS(979),
    [anon_sym_noinline] = ACTIONS(979),
    [anon_sym_SEMI] = ACTIONS(977),
    [anon_sym_threadlocal] = ACTIONS(979),
    [anon_sym_usingnamespace] = ACTIONS(979),
    [anon_sym_fn] = ACTIONS(979),
    [anon_sym_BANG] = ACTIONS(977),
    [anon_sym_const] = ACTIONS(979),
    [anon_sym_var] = ACTIONS(979),
    [anon_sym_EQ] = ACTIONS(977),
    [anon_sym_LBRACE] = ACTIONS(977),
    [anon_sym_RBRACE] = ACTIONS(977),
    [anon_sym_async] = ACTIONS(979),
    [anon_sym_DOT] = ACTIONS(1786),
    [anon_sym_error] = ACTIONS(979),
    [anon_sym_false] = ACTIONS(979),
    [anon_sym_null] = ACTIONS(979),
    [anon_sym_anyframe] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(979),
    [anon_sym_undefined] = ACTIONS(979),
    [anon_sym_unreachable] = ACTIONS(979),
    [sym_BuildinTypeExpr] = ACTIONS(979),
    [anon_sym_packed] = ACTIONS(979),
    [anon_sym_LPAREN] = ACTIONS(1788),
    [anon_sym_switch] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(1790),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_while] = ACTIONS(979),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_STAR_STAR] = ACTIONS(977),
    [anon_sym_QMARK] = ACTIONS(977),
    [anon_sym_align] = ACTIONS(979),
    [anon_sym_DOT_STAR] = ACTIONS(1792),
    [anon_sym_DOT_QMARK] = ACTIONS(1792),
    [anon_sym_struct] = ACTIONS(979),
    [anon_sym_opaque] = ACTIONS(979),
    [anon_sym_enum] = ACTIONS(979),
    [anon_sym_union] = ACTIONS(979),
    [sym_doc_comment] = ACTIONS(977),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(977),
    [aux_sym_FLOAT_token1] = ACTIONS(977),
    [aux_sym_FLOAT_token2] = ACTIONS(977),
    [aux_sym_FLOAT_token3] = ACTIONS(977),
    [aux_sym_FLOAT_token4] = ACTIONS(977),
    [aux_sym_INTEGER_token1] = ACTIONS(977),
    [aux_sym_INTEGER_token2] = ACTIONS(977),
    [aux_sym_INTEGER_token3] = ACTIONS(979),
    [aux_sym_INTEGER_token4] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(977),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(979),
    [anon_sym_AT] = ACTIONS(977),
  },
  [1039] = {
    [sym_FieldOrFnCall] = STATE(1041),
    [sym_SuffixOp] = STATE(1041),
    [sym_FnCallArguments] = STATE(1041),
    [aux_sym_SuffixExpr_repeat1] = STATE(1041),
    [ts_builtin_sym_end] = ACTIONS(953),
    [anon_sym_COMMA] = ACTIONS(953),
    [anon_sym_pub] = ACTIONS(955),
    [anon_sym_test] = ACTIONS(955),
    [anon_sym_comptime] = ACTIONS(955),
    [anon_sym_export] = ACTIONS(955),
    [anon_sym_extern] = ACTIONS(955),
    [anon_sym_inline] = ACTIONS(955),
    [anon_sym_noinline] = ACTIONS(955),
    [anon_sym_SEMI] = ACTIONS(953),
    [anon_sym_threadlocal] = ACTIONS(955),
    [anon_sym_usingnamespace] = ACTIONS(955),
    [anon_sym_fn] = ACTIONS(955),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_var] = ACTIONS(955),
    [anon_sym_EQ] = ACTIONS(953),
    [anon_sym_LBRACE] = ACTIONS(953),
    [anon_sym_RBRACE] = ACTIONS(953),
    [anon_sym_async] = ACTIONS(955),
    [anon_sym_DOT] = ACTIONS(1786),
    [anon_sym_error] = ACTIONS(955),
    [anon_sym_false] = ACTIONS(955),
    [anon_sym_null] = ACTIONS(955),
    [anon_sym_anyframe] = ACTIONS(955),
    [anon_sym_true] = ACTIONS(955),
    [anon_sym_undefined] = ACTIONS(955),
    [anon_sym_unreachable] = ACTIONS(955),
    [sym_BuildinTypeExpr] = ACTIONS(955),
    [anon_sym_packed] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1788),
    [anon_sym_switch] = ACTIONS(955),
    [anon_sym_LBRACK] = ACTIONS(1790),
    [anon_sym_if] = ACTIONS(955),
    [anon_sym_while] = ACTIONS(955),
    [anon_sym_for] = ACTIONS(955),
    [anon_sym_STAR] = ACTIONS(955),
    [anon_sym_STAR_STAR] = ACTIONS(953),
    [anon_sym_QMARK] = ACTIONS(953),
    [anon_sym_align] = ACTIONS(955),
    [anon_sym_DOT_STAR] = ACTIONS(1792),
    [anon_sym_DOT_QMARK] = ACTIONS(1792),
    [anon_sym_struct] = ACTIONS(955),
    [anon_sym_opaque] = ACTIONS(955),
    [anon_sym_enum] = ACTIONS(955),
    [anon_sym_union] = ACTIONS(955),
    [sym_doc_comment] = ACTIONS(953),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(953),
    [aux_sym_FLOAT_token1] = ACTIONS(953),
    [aux_sym_FLOAT_token2] = ACTIONS(953),
    [aux_sym_FLOAT_token3] = ACTIONS(953),
    [aux_sym_FLOAT_token4] = ACTIONS(953),
    [aux_sym_INTEGER_token1] = ACTIONS(953),
    [aux_sym_INTEGER_token2] = ACTIONS(953),
    [aux_sym_INTEGER_token3] = ACTIONS(955),
    [aux_sym_INTEGER_token4] = ACTIONS(955),
    [anon_sym_DQUOTE] = ACTIONS(953),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(953),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(955),
    [anon_sym_AT] = ACTIONS(953),
  },
  [1040] = {
    [sym_FieldOrFnCall] = STATE(1041),
    [sym_SuffixOp] = STATE(1041),
    [sym_FnCallArguments] = STATE(1041),
    [aux_sym_SuffixExpr_repeat1] = STATE(1041),
    [ts_builtin_sym_end] = ACTIONS(989),
    [anon_sym_COMMA] = ACTIONS(989),
    [anon_sym_pub] = ACTIONS(991),
    [anon_sym_test] = ACTIONS(991),
    [anon_sym_comptime] = ACTIONS(991),
    [anon_sym_export] = ACTIONS(991),
    [anon_sym_extern] = ACTIONS(991),
    [anon_sym_inline] = ACTIONS(991),
    [anon_sym_noinline] = ACTIONS(991),
    [anon_sym_SEMI] = ACTIONS(989),
    [anon_sym_threadlocal] = ACTIONS(991),
    [anon_sym_usingnamespace] = ACTIONS(991),
    [anon_sym_fn] = ACTIONS(991),
    [anon_sym_BANG] = ACTIONS(989),
    [anon_sym_const] = ACTIONS(991),
    [anon_sym_var] = ACTIONS(991),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_RBRACE] = ACTIONS(989),
    [anon_sym_async] = ACTIONS(991),
    [anon_sym_DOT] = ACTIONS(1786),
    [anon_sym_error] = ACTIONS(991),
    [anon_sym_false] = ACTIONS(991),
    [anon_sym_null] = ACTIONS(991),
    [anon_sym_anyframe] = ACTIONS(991),
    [anon_sym_true] = ACTIONS(991),
    [anon_sym_undefined] = ACTIONS(991),
    [anon_sym_unreachable] = ACTIONS(991),
    [sym_BuildinTypeExpr] = ACTIONS(991),
    [anon_sym_packed] = ACTIONS(991),
    [anon_sym_LPAREN] = ACTIONS(1788),
    [anon_sym_switch] = ACTIONS(991),
    [anon_sym_LBRACK] = ACTIONS(1790),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_while] = ACTIONS(991),
    [anon_sym_for] = ACTIONS(991),
    [anon_sym_STAR] = ACTIONS(991),
    [anon_sym_STAR_STAR] = ACTIONS(989),
    [anon_sym_QMARK] = ACTIONS(989),
    [anon_sym_align] = ACTIONS(991),
    [anon_sym_DOT_STAR] = ACTIONS(1792),
    [anon_sym_DOT_QMARK] = ACTIONS(1792),
    [anon_sym_struct] = ACTIONS(991),
    [anon_sym_opaque] = ACTIONS(991),
    [anon_sym_enum] = ACTIONS(991),
    [anon_sym_union] = ACTIONS(991),
    [sym_doc_comment] = ACTIONS(989),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(989),
    [aux_sym_FLOAT_token1] = ACTIONS(989),
    [aux_sym_FLOAT_token2] = ACTIONS(989),
    [aux_sym_FLOAT_token3] = ACTIONS(989),
    [aux_sym_FLOAT_token4] = ACTIONS(989),
    [aux_sym_INTEGER_token1] = ACTIONS(989),
    [aux_sym_INTEGER_token2] = ACTIONS(989),
    [aux_sym_INTEGER_token3] = ACTIONS(991),
    [aux_sym_INTEGER_token4] = ACTIONS(991),
    [anon_sym_DQUOTE] = ACTIONS(989),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(989),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(991),
    [anon_sym_AT] = ACTIONS(989),
  },
  [1041] = {
    [sym_FieldOrFnCall] = STATE(1041),
    [sym_SuffixOp] = STATE(1041),
    [sym_FnCallArguments] = STATE(1041),
    [aux_sym_SuffixExpr_repeat1] = STATE(1041),
    [ts_builtin_sym_end] = ACTIONS(957),
    [anon_sym_COMMA] = ACTIONS(957),
    [anon_sym_pub] = ACTIONS(959),
    [anon_sym_test] = ACTIONS(959),
    [anon_sym_comptime] = ACTIONS(959),
    [anon_sym_export] = ACTIONS(959),
    [anon_sym_extern] = ACTIONS(959),
    [anon_sym_inline] = ACTIONS(959),
    [anon_sym_noinline] = ACTIONS(959),
    [anon_sym_SEMI] = ACTIONS(957),
    [anon_sym_threadlocal] = ACTIONS(959),
    [anon_sym_usingnamespace] = ACTIONS(959),
    [anon_sym_fn] = ACTIONS(959),
    [anon_sym_BANG] = ACTIONS(957),
    [anon_sym_const] = ACTIONS(959),
    [anon_sym_var] = ACTIONS(959),
    [anon_sym_EQ] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(957),
    [anon_sym_RBRACE] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_DOT] = ACTIONS(1794),
    [anon_sym_error] = ACTIONS(959),
    [anon_sym_false] = ACTIONS(959),
    [anon_sym_null] = ACTIONS(959),
    [anon_sym_anyframe] = ACTIONS(959),
    [anon_sym_true] = ACTIONS(959),
    [anon_sym_undefined] = ACTIONS(959),
    [anon_sym_unreachable] = ACTIONS(959),
    [sym_BuildinTypeExpr] = ACTIONS(959),
    [anon_sym_packed] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(1797),
    [anon_sym_switch] = ACTIONS(959),
    [anon_sym_LBRACK] = ACTIONS(1800),
    [anon_sym_if] = ACTIONS(959),
    [anon_sym_while] = ACTIONS(959),
    [anon_sym_for] = ACTIONS(959),
    [anon_sym_STAR] = ACTIONS(959),
    [anon_sym_STAR_STAR] = ACTIONS(957),
    [anon_sym_QMARK] = ACTIONS(957),
    [anon_sym_align] = ACTIONS(959),
    [anon_sym_DOT_STAR] = ACTIONS(1803),
    [anon_sym_DOT_QMARK] = ACTIONS(1803),
    [anon_sym_struct] = ACTIONS(959),
    [anon_sym_opaque] = ACTIONS(959),
    [anon_sym_enum] = ACTIONS(959),
    [anon_sym_union] = ACTIONS(959),
    [sym_doc_comment] = ACTIONS(957),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(957),
    [aux_sym_FLOAT_token1] = ACTIONS(957),
    [aux_sym_FLOAT_token2] = ACTIONS(957),
    [aux_sym_FLOAT_token3] = ACTIONS(957),
    [aux_sym_FLOAT_token4] = ACTIONS(957),
    [aux_sym_INTEGER_token1] = ACTIONS(957),
    [aux_sym_INTEGER_token2] = ACTIONS(957),
    [aux_sym_INTEGER_token3] = ACTIONS(959),
    [aux_sym_INTEGER_token4] = ACTIONS(959),
    [anon_sym_DQUOTE] = ACTIONS(957),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(957),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(959),
    [anon_sym_AT] = ACTIONS(957),
  },
  [1042] = {
    [sym_FieldOrFnCall] = STATE(1041),
    [sym_SuffixOp] = STATE(1041),
    [sym_FnCallArguments] = STATE(1041),
    [aux_sym_SuffixExpr_repeat1] = STATE(1041),
    [ts_builtin_sym_end] = ACTIONS(973),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_pub] = ACTIONS(975),
    [anon_sym_test] = ACTIONS(975),
    [anon_sym_comptime] = ACTIONS(975),
    [anon_sym_export] = ACTIONS(975),
    [anon_sym_extern] = ACTIONS(975),
    [anon_sym_inline] = ACTIONS(975),
    [anon_sym_noinline] = ACTIONS(975),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_threadlocal] = ACTIONS(975),
    [anon_sym_usingnamespace] = ACTIONS(975),
    [anon_sym_fn] = ACTIONS(975),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_const] = ACTIONS(975),
    [anon_sym_var] = ACTIONS(975),
    [anon_sym_EQ] = ACTIONS(973),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_async] = ACTIONS(975),
    [anon_sym_DOT] = ACTIONS(1786),
    [anon_sym_error] = ACTIONS(975),
    [anon_sym_false] = ACTIONS(975),
    [anon_sym_null] = ACTIONS(975),
    [anon_sym_anyframe] = ACTIONS(975),
    [anon_sym_true] = ACTIONS(975),
    [anon_sym_undefined] = ACTIONS(975),
    [anon_sym_unreachable] = ACTIONS(975),
    [sym_BuildinTypeExpr] = ACTIONS(975),
    [anon_sym_packed] = ACTIONS(975),
    [anon_sym_LPAREN] = ACTIONS(1788),
    [anon_sym_switch] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(1790),
    [anon_sym_if] = ACTIONS(975),
    [anon_sym_while] = ACTIONS(975),
    [anon_sym_for] = ACTIONS(975),
    [anon_sym_STAR] = ACTIONS(975),
    [anon_sym_STAR_STAR] = ACTIONS(973),
    [anon_sym_QMARK] = ACTIONS(973),
    [anon_sym_align] = ACTIONS(975),
    [anon_sym_DOT_STAR] = ACTIONS(1792),
    [anon_sym_DOT_QMARK] = ACTIONS(1792),
    [anon_sym_struct] = ACTIONS(975),
    [anon_sym_opaque] = ACTIONS(975),
    [anon_sym_enum] = ACTIONS(975),
    [anon_sym_union] = ACTIONS(975),
    [sym_doc_comment] = ACTIONS(973),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [aux_sym_FLOAT_token1] = ACTIONS(973),
    [aux_sym_FLOAT_token2] = ACTIONS(973),
    [aux_sym_FLOAT_token3] = ACTIONS(973),
    [aux_sym_FLOAT_token4] = ACTIONS(973),
    [aux_sym_INTEGER_token1] = ACTIONS(973),
    [aux_sym_INTEGER_token2] = ACTIONS(973),
    [aux_sym_INTEGER_token3] = ACTIONS(975),
    [aux_sym_INTEGER_token4] = ACTIONS(975),
    [anon_sym_DQUOTE] = ACTIONS(973),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(973),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(975),
    [anon_sym_AT] = ACTIONS(973),
  },
  [1043] = {
    [sym_FieldOrFnCall] = STATE(1038),
    [sym_SuffixOp] = STATE(1038),
    [sym_FnCallArguments] = STATE(1038),
    [aux_sym_SuffixExpr_repeat1] = STATE(1038),
    [ts_builtin_sym_end] = ACTIONS(985),
    [anon_sym_COMMA] = ACTIONS(985),
    [anon_sym_pub] = ACTIONS(987),
    [anon_sym_test] = ACTIONS(987),
    [anon_sym_comptime] = ACTIONS(987),
    [anon_sym_export] = ACTIONS(987),
    [anon_sym_extern] = ACTIONS(987),
    [anon_sym_inline] = ACTIONS(987),
    [anon_sym_noinline] = ACTIONS(987),
    [anon_sym_SEMI] = ACTIONS(985),
    [anon_sym_threadlocal] = ACTIONS(987),
    [anon_sym_usingnamespace] = ACTIONS(987),
    [anon_sym_fn] = ACTIONS(987),
    [anon_sym_BANG] = ACTIONS(985),
    [anon_sym_const] = ACTIONS(987),
    [anon_sym_var] = ACTIONS(987),
    [anon_sym_EQ] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(985),
    [anon_sym_RBRACE] = ACTIONS(985),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_DOT] = ACTIONS(1786),
    [anon_sym_error] = ACTIONS(987),
    [anon_sym_false] = ACTIONS(987),
    [anon_sym_null] = ACTIONS(987),
    [anon_sym_anyframe] = ACTIONS(987),
    [anon_sym_true] = ACTIONS(987),
    [anon_sym_undefined] = ACTIONS(987),
    [anon_sym_unreachable] = ACTIONS(987),
    [sym_BuildinTypeExpr] = ACTIONS(987),
    [anon_sym_packed] = ACTIONS(987),
    [anon_sym_LPAREN] = ACTIONS(1788),
    [anon_sym_switch] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(1790),
    [anon_sym_if] = ACTIONS(987),
    [anon_sym_while] = ACTIONS(987),
    [anon_sym_for] = ACTIONS(987),
    [anon_sym_STAR] = ACTIONS(987),
    [anon_sym_STAR_STAR] = ACTIONS(985),
    [anon_sym_QMARK] = ACTIONS(985),
    [anon_sym_align] = ACTIONS(987),
    [anon_sym_DOT_STAR] = ACTIONS(1792),
    [anon_sym_DOT_QMARK] = ACTIONS(1792),
    [anon_sym_struct] = ACTIONS(987),
    [anon_sym_opaque] = ACTIONS(987),
    [anon_sym_enum] = ACTIONS(987),
    [anon_sym_union] = ACTIONS(987),
    [sym_doc_comment] = ACTIONS(985),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(985),
    [aux_sym_FLOAT_token1] = ACTIONS(985),
    [aux_sym_FLOAT_token2] = ACTIONS(985),
    [aux_sym_FLOAT_token3] = ACTIONS(985),
    [aux_sym_FLOAT_token4] = ACTIONS(985),
    [aux_sym_INTEGER_token1] = ACTIONS(985),
    [aux_sym_INTEGER_token2] = ACTIONS(985),
    [aux_sym_INTEGER_token3] = ACTIONS(987),
    [aux_sym_INTEGER_token4] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(985),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(985),
    [aux_sym_IDENTIFIER_token1] = ACTIONS(987),
    [anon_sym_AT] = ACTIONS(985),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1810), 1,
      anon_sym_else,
    STATE(1137), 1,
      sym__ElseStatementTail,
    ACTIONS(1808), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1806), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [75] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1059), 1,
      anon_sym_EQ,
    ACTIONS(1812), 1,
      anon_sym_else,
    ACTIONS(1814), 1,
      anon_sym_or,
    ACTIONS(1816), 1,
      anon_sym_and,
    ACTIONS(1818), 1,
      anon_sym_catch,
    STATE(307), 1,
      sym_CompareOp,
    STATE(308), 1,
      sym_BitwiseOp,
    STATE(310), 1,
      sym_BitShiftOp,
    STATE(315), 1,
      sym_AdditionOp,
    STATE(316), 1,
      sym_MultiplyOp,
    STATE(1301), 1,
      sym__ElseExprTail,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1057), 25,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
  [184] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1007), 1,
      anon_sym_EQ,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1812), 1,
      anon_sym_else,
    ACTIONS(1814), 1,
      anon_sym_or,
    ACTIONS(1816), 1,
      anon_sym_and,
    ACTIONS(1818), 1,
      anon_sym_catch,
    STATE(307), 1,
      sym_CompareOp,
    STATE(308), 1,
      sym_BitwiseOp,
    STATE(310), 1,
      sym_BitShiftOp,
    STATE(315), 1,
      sym_AdditionOp,
    STATE(316), 1,
      sym_MultiplyOp,
    STATE(1297), 1,
      sym__ElseExprTail,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1005), 25,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
  [293] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1786), 1,
      anon_sym_DOT,
    ACTIONS(1788), 1,
      anon_sym_LPAREN,
    ACTIONS(1790), 1,
      anon_sym_LBRACK,
    ACTIONS(1820), 1,
      anon_sym_COLON,
    ACTIONS(1792), 2,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    STATE(1039), 4,
      sym_FieldOrFnCall,
      sym_SuffixOp,
      sym_FnCallArguments,
      aux_sym_SuffixExpr_repeat1,
    ACTIONS(941), 18,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(943), 35,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [376] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1822), 1,
      anon_sym_BSLASH_BSLASH,
    STATE(1048), 2,
      sym_LINESTRING,
      aux_sym__STRINGLITERAL_repeat1,
    ACTIONS(1065), 23,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_AT,
    ACTIONS(1067), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [451] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1051), 1,
      anon_sym_EQ,
    ACTIONS(1814), 1,
      anon_sym_or,
    ACTIONS(1816), 1,
      anon_sym_and,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1825), 1,
      anon_sym_else,
    STATE(307), 1,
      sym_CompareOp,
    STATE(308), 1,
      sym_BitwiseOp,
    STATE(310), 1,
      sym_BitShiftOp,
    STATE(315), 1,
      sym_AdditionOp,
    STATE(316), 1,
      sym_MultiplyOp,
    STATE(1286), 1,
      sym__ElseExprTail,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1049), 25,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
  [560] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1810), 1,
      anon_sym_else,
    STATE(1104), 1,
      sym__ElseStatementTail,
    ACTIONS(1829), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1827), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [635] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1059), 1,
      anon_sym_EQ,
    ACTIONS(1814), 1,
      anon_sym_or,
    ACTIONS(1816), 1,
      anon_sym_and,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1825), 1,
      anon_sym_else,
    STATE(307), 1,
      sym_CompareOp,
    STATE(308), 1,
      sym_BitwiseOp,
    STATE(310), 1,
      sym_BitShiftOp,
    STATE(315), 1,
      sym_AdditionOp,
    STATE(316), 1,
      sym_MultiplyOp,
    STATE(1301), 1,
      sym__ElseExprTail,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1057), 25,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
  [744] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1051), 1,
      anon_sym_EQ,
    ACTIONS(1812), 1,
      anon_sym_else,
    ACTIONS(1814), 1,
      anon_sym_or,
    ACTIONS(1816), 1,
      anon_sym_and,
    ACTIONS(1818), 1,
      anon_sym_catch,
    STATE(307), 1,
      sym_CompareOp,
    STATE(308), 1,
      sym_BitwiseOp,
    STATE(310), 1,
      sym_BitShiftOp,
    STATE(315), 1,
      sym_AdditionOp,
    STATE(316), 1,
      sym_MultiplyOp,
    STATE(1286), 1,
      sym__ElseExprTail,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1049), 25,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
  [853] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1810), 1,
      anon_sym_else,
    STATE(1134), 1,
      sym__ElseStatementTail,
    ACTIONS(1833), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1831), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [928] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1007), 1,
      anon_sym_EQ,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1814), 1,
      anon_sym_or,
    ACTIONS(1816), 1,
      anon_sym_and,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1825), 1,
      anon_sym_else,
    STATE(307), 1,
      sym_CompareOp,
    STATE(308), 1,
      sym_BitwiseOp,
    STATE(310), 1,
      sym_BitShiftOp,
    STATE(315), 1,
      sym_AdditionOp,
    STATE(316), 1,
      sym_MultiplyOp,
    STATE(1297), 1,
      sym__ElseExprTail,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1005), 25,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
  [1037] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1786), 1,
      anon_sym_DOT,
    ACTIONS(1788), 1,
      anon_sym_LPAREN,
    ACTIONS(1790), 1,
      anon_sym_LBRACK,
    ACTIONS(1835), 1,
      anon_sym_COLON,
    ACTIONS(1792), 2,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    STATE(1039), 4,
      sym_FieldOrFnCall,
      sym_SuffixOp,
      sym_FnCallArguments,
      aux_sym_SuffixExpr_repeat1,
    ACTIONS(941), 18,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(943), 35,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [1120] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1786), 1,
      anon_sym_DOT,
    ACTIONS(1788), 1,
      anon_sym_LPAREN,
    ACTIONS(1790), 1,
      anon_sym_LBRACK,
    ACTIONS(1837), 1,
      anon_sym_COLON,
    ACTIONS(1792), 2,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    STATE(1039), 4,
      sym_FieldOrFnCall,
      sym_SuffixOp,
      sym_FnCallArguments,
      aux_sym_SuffixExpr_repeat1,
    ACTIONS(941), 18,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(943), 35,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [1203] = 8,
    ACTIONS(137), 1,
      sym_line_comment,
    STATE(307), 1,
      sym_CompareOp,
    STATE(308), 1,
      sym_BitwiseOp,
    STATE(310), 1,
      sym_BitShiftOp,
    STATE(315), 1,
      sym_AdditionOp,
    STATE(316), 1,
      sym_MultiplyOp,
    ACTIONS(1095), 21,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1093), 36,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_PLUS_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
  [1283] = 19,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1816), 1,
      anon_sym_and,
    ACTIONS(1818), 1,
      anon_sym_catch,
    STATE(307), 1,
      sym_CompareOp,
    STATE(308), 1,
      sym_BitwiseOp,
    STATE(310), 1,
      sym_BitShiftOp,
    STATE(315), 1,
      sym_AdditionOp,
    STATE(316), 1,
      sym_MultiplyOp,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1074), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1072), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
  [1385] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1839), 1,
      anon_sym_else,
    STATE(1092), 1,
      sym__ElseTypeExprTail,
    ACTIONS(1047), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1043), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [1459] = 10,
    ACTIONS(137), 1,
      sym_line_comment,
    STATE(307), 1,
      sym_CompareOp,
    STATE(308), 1,
      sym_BitwiseOp,
    STATE(310), 1,
      sym_BitShiftOp,
    STATE(315), 1,
      sym_AdditionOp,
    STATE(316), 1,
      sym_MultiplyOp,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1074), 16,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1072), 34,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_PLUS_PLUS,
  [1543] = 36,
    ACTIONS(49), 1,
      anon_sym_if,
    ACTIONS(51), 1,
      anon_sym_while,
    ACTIONS(53), 1,
      anon_sym_for,
    ACTIONS(63), 1,
      anon_sym_opaque,
    ACTIONS(65), 1,
      anon_sym_union,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(281), 1,
      anon_sym_fn,
    ACTIONS(299), 1,
      anon_sym_error,
    ACTIONS(305), 1,
      anon_sym_LPAREN,
    ACTIONS(307), 1,
      anon_sym_switch,
    ACTIONS(311), 1,
      anon_sym_SQUOTE,
    ACTIONS(319), 1,
      anon_sym_DQUOTE,
    ACTIONS(321), 1,
      anon_sym_BSLASH_BSLASH,
    ACTIONS(323), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(325), 1,
      anon_sym_AT,
    ACTIONS(590), 1,
      anon_sym_DOT,
    ACTIONS(1475), 1,
      anon_sym_comptime,
    ACTIONS(1477), 1,
      anon_sym_inline,
    STATE(826), 1,
      sym_ForPrefix,
    STATE(837), 1,
      sym_WhilePrefix,
    STATE(843), 1,
      sym_IfPrefix,
    STATE(1406), 1,
      sym_IDENTIFIER,
    STATE(1507), 1,
      sym_LoopTypeExpr,
    STATE(1509), 1,
      sym__ContainerDeclAuto,
    STATE(1712), 1,
      sym_BlockLabel,
    STATE(2033), 1,
      sym_BUILTINIDENTIFIER,
    STATE(2175), 1,
      sym_ContainerDeclType,
    ACTIONS(61), 2,
      anon_sym_struct,
      anon_sym_enum,
    ACTIONS(277), 2,
      anon_sym_extern,
      anon_sym_packed,
    ACTIONS(315), 2,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
    ACTIONS(317), 2,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
    STATE(1418), 2,
      sym_LINESTRING,
      aux_sym__STRINGLITERAL_repeat1,
    STATE(1508), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    ACTIONS(313), 4,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
    ACTIONS(1841), 7,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
    STATE(1414), 13,
      sym_FnProto,
      sym__PrimaryTypeExpr,
      sym_ContainerDecl,
      sym_ErrorSetDecl,
      sym_GroupedExpr,
      sym_IfTypeExpr,
      sym_LabeledTypeExpr,
      sym_SwitchExpr,
      sym_CHAR_LITERAL,
      sym_FLOAT,
      sym_INTEGER,
      sym_STRINGLITERALSINGLE,
      sym__STRINGLITERAL,
  [1679] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1843), 1,
      anon_sym_BSLASH_BSLASH,
    STATE(1062), 2,
      sym_LINESTRING,
      aux_sym__STRINGLITERAL_repeat1,
    ACTIONS(1065), 23,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_AT,
    ACTIONS(1067), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [1753] = 12,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    STATE(307), 1,
      sym_CompareOp,
    STATE(308), 1,
      sym_BitwiseOp,
    STATE(310), 1,
      sym_BitShiftOp,
    STATE(315), 1,
      sym_AdditionOp,
    STATE(316), 1,
      sym_MultiplyOp,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1074), 10,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1072), 33,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
  [1841] = 13,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    STATE(307), 1,
      sym_CompareOp,
    STATE(308), 1,
      sym_BitwiseOp,
    STATE(310), 1,
      sym_BitShiftOp,
    STATE(315), 1,
      sym_AdditionOp,
    STATE(316), 1,
      sym_MultiplyOp,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1074), 7,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1072), 33,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
  [1931] = 35,
    ACTIONS(25), 1,
      anon_sym_fn,
    ACTIONS(31), 1,
      anon_sym_DOT,
    ACTIONS(33), 1,
      anon_sym_error,
    ACTIONS(43), 1,
      anon_sym_LPAREN,
    ACTIONS(45), 1,
      anon_sym_switch,
    ACTIONS(49), 1,
      anon_sym_if,
    ACTIONS(51), 1,
      anon_sym_while,
    ACTIONS(53), 1,
      anon_sym_for,
    ACTIONS(63), 1,
      anon_sym_opaque,
    ACTIONS(65), 1,
      anon_sym_union,
    ACTIONS(71), 1,
      anon_sym_SQUOTE,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(81), 1,
      anon_sym_BSLASH_BSLASH,
    ACTIONS(83), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(85), 1,
      anon_sym_AT,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1489), 1,
      anon_sym_comptime,
    ACTIONS(1491), 1,
      anon_sym_inline,
    STATE(859), 1,
      sym_ForPrefix,
    STATE(883), 1,
      sym_WhilePrefix,
    STATE(884), 1,
      sym_IfPrefix,
    STATE(1028), 1,
      sym_IDENTIFIER,
    STATE(1202), 1,
      sym_LoopTypeExpr,
    STATE(1251), 1,
      sym__ContainerDeclAuto,
    STATE(1711), 1,
      sym_BlockLabel,
    STATE(2079), 1,
      sym_BUILTINIDENTIFIER,
    STATE(2115), 1,
      sym_ContainerDeclType,
    ACTIONS(41), 2,
      anon_sym_extern,
      anon_sym_packed,
    ACTIONS(61), 2,
      anon_sym_struct,
      anon_sym_enum,
    ACTIONS(75), 2,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
    ACTIONS(77), 2,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
    STATE(1238), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    ACTIONS(73), 4,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
    ACTIONS(1846), 7,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
    STATE(1043), 15,
      sym_FnProto,
      sym__PrimaryTypeExpr,
      sym_ContainerDecl,
      sym_ErrorSetDecl,
      sym_GroupedExpr,
      sym_IfTypeExpr,
      sym_LabeledTypeExpr,
      sym_SwitchExpr,
      sym_CHAR_LITERAL,
      sym_FLOAT,
      sym_INTEGER,
      sym_STRINGLITERALSINGLE,
      sym_LINESTRING,
      sym__STRINGLITERAL,
      aux_sym__STRINGLITERAL_repeat1,
  [2065] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1839), 1,
      anon_sym_else,
    STATE(1090), 1,
      sym__ElseTypeExprTail,
    ACTIONS(1063), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1061), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [2139] = 16,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1818), 1,
      anon_sym_catch,
    STATE(307), 1,
      sym_CompareOp,
    STATE(308), 1,
      sym_BitwiseOp,
    STATE(310), 1,
      sym_BitShiftOp,
    STATE(315), 1,
      sym_AdditionOp,
    STATE(316), 1,
      sym_MultiplyOp,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1074), 4,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1072), 31,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [2235] = 36,
    ACTIONS(49), 1,
      anon_sym_if,
    ACTIONS(51), 1,
      anon_sym_while,
    ACTIONS(53), 1,
      anon_sym_for,
    ACTIONS(63), 1,
      anon_sym_opaque,
    ACTIONS(65), 1,
      anon_sym_union,
    ACTIONS(95), 1,
      anon_sym_fn,
    ACTIONS(117), 1,
      anon_sym_error,
    ACTIONS(123), 1,
      anon_sym_LPAREN,
    ACTIONS(125), 1,
      anon_sym_switch,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(139), 1,
      anon_sym_SQUOTE,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_BSLASH_BSLASH,
    ACTIONS(151), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(153), 1,
      anon_sym_AT,
    ACTIONS(355), 1,
      anon_sym_DOT,
    ACTIONS(1497), 1,
      anon_sym_comptime,
    ACTIONS(1499), 1,
      anon_sym_inline,
    STATE(851), 1,
      sym_IfPrefix,
    STATE(880), 1,
      sym_WhilePrefix,
    STATE(919), 1,
      sym_ForPrefix,
    STATE(938), 1,
      sym_IDENTIFIER,
    STATE(1014), 1,
      sym__ContainerDeclAuto,
    STATE(1016), 1,
      sym_LoopTypeExpr,
    STATE(1710), 1,
      sym_BlockLabel,
    STATE(2064), 1,
      sym_BUILTINIDENTIFIER,
    STATE(2119), 1,
      sym_ContainerDeclType,
    ACTIONS(61), 2,
      anon_sym_struct,
      anon_sym_enum,
    ACTIONS(91), 2,
      anon_sym_extern,
      anon_sym_packed,
    ACTIONS(143), 2,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
    ACTIONS(145), 2,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
    STATE(941), 2,
      sym_LINESTRING,
      aux_sym__STRINGLITERAL_repeat1,
    STATE(1015), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    ACTIONS(141), 4,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
    ACTIONS(1848), 7,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
    STATE(939), 13,
      sym_FnProto,
      sym__PrimaryTypeExpr,
      sym_ContainerDecl,
      sym_ErrorSetDecl,
      sym_GroupedExpr,
      sym_IfTypeExpr,
      sym_LabeledTypeExpr,
      sym_SwitchExpr,
      sym_CHAR_LITERAL,
      sym_FLOAT,
      sym_INTEGER,
      sym_STRINGLITERALSINGLE,
      sym__STRINGLITERAL,
  [2371] = 35,
    ACTIONS(49), 1,
      anon_sym_if,
    ACTIONS(51), 1,
      anon_sym_while,
    ACTIONS(53), 1,
      anon_sym_for,
    ACTIONS(63), 1,
      anon_sym_opaque,
    ACTIONS(65), 1,
      anon_sym_union,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(229), 1,
      anon_sym_fn,
    ACTIONS(245), 1,
      anon_sym_DOT,
    ACTIONS(247), 1,
      anon_sym_error,
    ACTIONS(253), 1,
      anon_sym_LPAREN,
    ACTIONS(255), 1,
      anon_sym_switch,
    ACTIONS(259), 1,
      anon_sym_SQUOTE,
    ACTIONS(267), 1,
      anon_sym_DQUOTE,
    ACTIONS(269), 1,
      anon_sym_BSLASH_BSLASH,
    ACTIONS(271), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(273), 1,
      anon_sym_AT,
    ACTIONS(1503), 1,
      anon_sym_comptime,
    ACTIONS(1505), 1,
      anon_sym_inline,
    STATE(378), 1,
      sym_IDENTIFIER,
    STATE(554), 1,
      sym_LoopTypeExpr,
    STATE(556), 1,
      sym__ContainerDeclAuto,
    STATE(911), 1,
      sym_ForPrefix,
    STATE(912), 1,
      sym_WhilePrefix,
    STATE(913), 1,
      sym_IfPrefix,
    STATE(1707), 1,
      sym_BlockLabel,
    STATE(2085), 1,
      sym_BUILTINIDENTIFIER,
    STATE(2161), 1,
      sym_ContainerDeclType,
    ACTIONS(61), 2,
      anon_sym_struct,
      anon_sym_enum,
    ACTIONS(225), 2,
      anon_sym_extern,
      anon_sym_packed,
    ACTIONS(263), 2,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
    ACTIONS(265), 2,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
    STATE(555), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    ACTIONS(261), 4,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
    ACTIONS(1850), 7,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
    STATE(387), 15,
      sym_FnProto,
      sym__PrimaryTypeExpr,
      sym_ContainerDecl,
      sym_ErrorSetDecl,
      sym_GroupedExpr,
      sym_IfTypeExpr,
      sym_LabeledTypeExpr,
      sym_SwitchExpr,
      sym_CHAR_LITERAL,
      sym_FLOAT,
      sym_INTEGER,
      sym_STRINGLITERALSINGLE,
      sym_LINESTRING,
      sym__STRINGLITERAL,
      aux_sym__STRINGLITERAL_repeat1,
  [2505] = 35,
    ACTIONS(49), 1,
      anon_sym_if,
    ACTIONS(51), 1,
      anon_sym_while,
    ACTIONS(53), 1,
      anon_sym_for,
    ACTIONS(63), 1,
      anon_sym_opaque,
    ACTIONS(65), 1,
      anon_sym_union,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(177), 1,
      anon_sym_fn,
    ACTIONS(193), 1,
      anon_sym_DOT,
    ACTIONS(195), 1,
      anon_sym_error,
    ACTIONS(201), 1,
      anon_sym_LPAREN,
    ACTIONS(203), 1,
      anon_sym_switch,
    ACTIONS(207), 1,
      anon_sym_SQUOTE,
    ACTIONS(215), 1,
      anon_sym_DQUOTE,
    ACTIONS(217), 1,
      anon_sym_BSLASH_BSLASH,
    ACTIONS(219), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(221), 1,
      anon_sym_AT,
    ACTIONS(1555), 1,
      anon_sym_comptime,
    ACTIONS(1557), 1,
      anon_sym_inline,
    STATE(376), 1,
      sym_IDENTIFIER,
    STATE(468), 1,
      sym_LoopTypeExpr,
    STATE(470), 1,
      sym__ContainerDeclAuto,
    STATE(857), 1,
      sym_ForPrefix,
    STATE(874), 1,
      sym_WhilePrefix,
    STATE(900), 1,
      sym_IfPrefix,
    STATE(1709), 1,
      sym_BlockLabel,
    STATE(2060), 1,
      sym_BUILTINIDENTIFIER,
    STATE(2169), 1,
      sym_ContainerDeclType,
    ACTIONS(61), 2,
      anon_sym_struct,
      anon_sym_enum,
    ACTIONS(173), 2,
      anon_sym_extern,
      anon_sym_packed,
    ACTIONS(211), 2,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
    ACTIONS(213), 2,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
    STATE(469), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    ACTIONS(209), 4,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
    ACTIONS(1852), 7,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
    STATE(385), 15,
      sym_FnProto,
      sym__PrimaryTypeExpr,
      sym_ContainerDecl,
      sym_ErrorSetDecl,
      sym_GroupedExpr,
      sym_IfTypeExpr,
      sym_LabeledTypeExpr,
      sym_SwitchExpr,
      sym_CHAR_LITERAL,
      sym_FLOAT,
      sym_INTEGER,
      sym_STRINGLITERALSINGLE,
      sym_LINESTRING,
      sym__STRINGLITERAL,
      aux_sym__STRINGLITERAL_repeat1,
  [2639] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1078), 1,
      anon_sym_EQ,
    ACTIONS(1814), 1,
      anon_sym_or,
    ACTIONS(1816), 1,
      anon_sym_and,
    ACTIONS(1818), 1,
      anon_sym_catch,
    STATE(307), 1,
      sym_CompareOp,
    STATE(308), 1,
      sym_BitwiseOp,
    STATE(310), 1,
      sym_BitShiftOp,
    STATE(315), 1,
      sym_AdditionOp,
    STATE(316), 1,
      sym_MultiplyOp,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1076), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
  [2743] = 8,
    ACTIONS(137), 1,
      sym_line_comment,
    STATE(307), 1,
      sym_CompareOp,
    STATE(308), 1,
      sym_BitwiseOp,
    STATE(310), 1,
      sym_BitShiftOp,
    STATE(315), 1,
      sym_AdditionOp,
    STATE(316), 1,
      sym_MultiplyOp,
    ACTIONS(1074), 21,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1072), 36,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_PLUS_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
  [2823] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(1814), 1,
      anon_sym_or,
    ACTIONS(1816), 1,
      anon_sym_and,
    ACTIONS(1818), 1,
      anon_sym_catch,
    STATE(307), 1,
      sym_CompareOp,
    STATE(308), 1,
      sym_BitwiseOp,
    STATE(310), 1,
      sym_BitShiftOp,
    STATE(315), 1,
      sym_AdditionOp,
    STATE(316), 1,
      sym_MultiplyOp,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1097), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
  [2927] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1101), 1,
      anon_sym_DASH_GT,
    ACTIONS(546), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(548), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [2999] = 18,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1818), 1,
      anon_sym_catch,
    STATE(307), 1,
      sym_CompareOp,
    STATE(308), 1,
      sym_BitwiseOp,
    STATE(310), 1,
      sym_BitShiftOp,
    STATE(315), 1,
      sym_AdditionOp,
    STATE(316), 1,
      sym_MultiplyOp,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1074), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1072), 27,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
  [3099] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(157), 1,
      anon_sym_EQ,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1814), 1,
      anon_sym_or,
    ACTIONS(1816), 1,
      anon_sym_and,
    ACTIONS(1818), 1,
      anon_sym_catch,
    STATE(307), 1,
      sym_CompareOp,
    STATE(308), 1,
      sym_BitwiseOp,
    STATE(310), 1,
      sym_BitShiftOp,
    STATE(315), 1,
      sym_AdditionOp,
    STATE(316), 1,
      sym_MultiplyOp,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(155), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
  [3203] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(560), 25,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(562), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [3273] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(536), 25,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(538), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [3343] = 35,
    ACTIONS(49), 1,
      anon_sym_if,
    ACTIONS(51), 1,
      anon_sym_while,
    ACTIONS(53), 1,
      anon_sym_for,
    ACTIONS(63), 1,
      anon_sym_opaque,
    ACTIONS(65), 1,
      anon_sym_union,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1515), 1,
      anon_sym_comptime,
    ACTIONS(1519), 1,
      anon_sym_inline,
    ACTIONS(1521), 1,
      anon_sym_fn,
    ACTIONS(1527), 1,
      anon_sym_DOT,
    ACTIONS(1529), 1,
      anon_sym_error,
    ACTIONS(1535), 1,
      anon_sym_LPAREN,
    ACTIONS(1537), 1,
      anon_sym_switch,
    ACTIONS(1539), 1,
      anon_sym_SQUOTE,
    ACTIONS(1547), 1,
      anon_sym_DQUOTE,
    ACTIONS(1549), 1,
      anon_sym_BSLASH_BSLASH,
    ACTIONS(1551), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(1553), 1,
      anon_sym_AT,
    STATE(892), 1,
      sym_IfPrefix,
    STATE(893), 1,
      sym_WhilePrefix,
    STATE(894), 1,
      sym_ForPrefix,
    STATE(1024), 1,
      sym_IDENTIFIER,
    STATE(1162), 1,
      sym_LoopTypeExpr,
    STATE(1182), 1,
      sym__ContainerDeclAuto,
    STATE(1708), 1,
      sym_BlockLabel,
    STATE(2051), 1,
      sym_BUILTINIDENTIFIER,
    STATE(2151), 1,
      sym_ContainerDeclType,
    ACTIONS(61), 2,
      anon_sym_struct,
      anon_sym_enum,
    ACTIONS(1517), 2,
      anon_sym_extern,
      anon_sym_packed,
    ACTIONS(1543), 2,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
    ACTIONS(1545), 2,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
    STATE(1170), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    ACTIONS(1541), 4,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
    ACTIONS(1854), 7,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
    STATE(1029), 15,
      sym_FnProto,
      sym__PrimaryTypeExpr,
      sym_ContainerDecl,
      sym_ErrorSetDecl,
      sym_GroupedExpr,
      sym_IfTypeExpr,
      sym_LabeledTypeExpr,
      sym_SwitchExpr,
      sym_CHAR_LITERAL,
      sym_FLOAT,
      sym_INTEGER,
      sym_STRINGLITERALSINGLE,
      sym_LINESTRING,
      sym__STRINGLITERAL,
      aux_sym__STRINGLITERAL_repeat1,
  [3477] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1856), 1,
      anon_sym_else,
    STATE(1235), 1,
      sym__ElseTypeExprTail,
    ACTIONS(1047), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1043), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [3551] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1082), 1,
      anon_sym_EQ,
    ACTIONS(1814), 1,
      anon_sym_or,
    ACTIONS(1816), 1,
      anon_sym_and,
    ACTIONS(1818), 1,
      anon_sym_catch,
    STATE(307), 1,
      sym_CompareOp,
    STATE(308), 1,
      sym_BitwiseOp,
    STATE(310), 1,
      sym_BitShiftOp,
    STATE(315), 1,
      sym_AdditionOp,
    STATE(316), 1,
      sym_MultiplyOp,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1080), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
  [3655] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1856), 1,
      anon_sym_else,
    STATE(1236), 1,
      sym__ElseTypeExprTail,
    ACTIONS(1055), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1053), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [3729] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(556), 25,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(558), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [3799] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(552), 25,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(554), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [3869] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1839), 1,
      anon_sym_else,
    STATE(1091), 1,
      sym__ElseTypeExprTail,
    ACTIONS(1055), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1053), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [3943] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1768), 1,
      anon_sym_LPAREN,
    STATE(1122), 1,
      sym_FnCallArguments,
    ACTIONS(1089), 23,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1091), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [4017] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1856), 1,
      anon_sym_else,
    STATE(1237), 1,
      sym__ElseTypeExprTail,
    ACTIONS(1063), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1061), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [4091] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1349), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1351), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [4160] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(530), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(528), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [4229] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1253), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1255), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [4298] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1257), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1259), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [4367] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1261), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1263), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [4436] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1265), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1267), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [4505] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(536), 25,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(538), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [4574] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1078), 1,
      anon_sym_EQ,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1076), 25,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
  [4677] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1864), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1862), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [4746] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1249), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1251), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [4815] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1868), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1866), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [4884] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1245), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1247), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [4953] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1872), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1870), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [5022] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(556), 25,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(558), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [5091] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1241), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1243), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [5160] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1876), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1874), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [5229] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1880), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1878), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [5298] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1237), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1239), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [5367] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1233), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1235), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [5436] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1229), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1231), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [5505] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1269), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1271), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [5574] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(552), 25,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(554), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [5643] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1281), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1283), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [5712] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1225), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1227), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [5781] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1884), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1882), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [5850] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(550), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(544), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [5919] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1197), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1199), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [5988] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1289), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1291), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [6057] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1221), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1223), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [6126] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1888), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1886), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [6195] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(640), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(638), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [6264] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1892), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1890), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [6333] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1297), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1299), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [6402] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1301), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1303), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [6471] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1305), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1307), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [6540] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1309), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1311), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [6609] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1317), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1319), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [6678] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1321), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1323), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [6747] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1896), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1894), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [6816] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1325), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1327), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [6885] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(157), 1,
      anon_sym_EQ,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(155), 25,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
  [6988] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1101), 1,
      anon_sym_DASH_GT,
    ACTIONS(546), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(548), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [7059] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1788), 1,
      anon_sym_LPAREN,
    STATE(1231), 1,
      sym_FnCallArguments,
    ACTIONS(1089), 23,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1091), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [7132] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1329), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1331), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [7201] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1900), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1898), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [7270] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1333), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1335), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [7339] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1904), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1902), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [7408] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1082), 1,
      anon_sym_EQ,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1080), 25,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
  [7511] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1337), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1339), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [7580] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1908), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1906), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [7649] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1341), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1343), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [7718] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1912), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1910), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [7787] = 8,
    ACTIONS(137), 1,
      sym_line_comment,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1095), 21,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1093), 35,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_PLUS_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
  [7866] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1163), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1165), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [7935] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1345), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1347), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [8004] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1167), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1169), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [8073] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1353), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1355), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [8142] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1357), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1359), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [8211] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1916), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1914), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [8280] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1365), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1367), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [8349] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1369), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1371), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [8418] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1373), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1375), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [8487] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1377), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1379), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [8556] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1920), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1918), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [8625] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1922), 1,
      anon_sym_BANG,
    ACTIONS(1175), 23,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1177), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [8696] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(582), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(580), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [8765] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1381), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1383), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [8834] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1099), 1,
      anon_sym_EQ,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1097), 25,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
  [8937] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1385), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1387), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [9006] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(534), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(532), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [9075] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1389), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1391), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [9144] = 19,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1860), 1,
      anon_sym_and,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1074), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1072), 25,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
  [9245] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1393), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1395), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [9314] = 18,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1818), 1,
      anon_sym_catch,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1074), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1072), 26,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
  [9413] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1181), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1183), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [9482] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1397), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1399), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [9551] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1401), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1403), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [9620] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1405), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1407), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [9689] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1409), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1411), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [9758] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(542), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(540), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [9827] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1413), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1415), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [9896] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1417), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1419), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [9965] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1185), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1187), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [10034] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1421), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1423), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [10103] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1926), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1924), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [10172] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1425), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1427), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [10241] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1429), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1431), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [10310] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1213), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1215), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [10379] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1433), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1435), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [10448] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1930), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1928), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [10517] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1437), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1439), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [10586] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(574), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(572), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [10655] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1441), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1443), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [10724] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1445), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1447), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [10793] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1189), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1191), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [10862] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1453), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1455), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [10931] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(566), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(564), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [11000] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1457), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1459), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [11069] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(570), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(568), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [11138] = 16,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1818), 1,
      anon_sym_catch,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1074), 4,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1072), 30,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [11233] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1193), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1195), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [11302] = 13,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1074), 7,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1072), 32,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
  [11391] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(522), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(524), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [11460] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1209), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1211), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [11529] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1934), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1932), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [11598] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1938), 21,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1936), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [11667] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1205), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1207), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [11736] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1201), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1203), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [11805] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1107), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1105), 37,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_else,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [11874] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(560), 25,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(562), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [11943] = 12,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1074), 10,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1072), 32,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
  [12030] = 10,
    ACTIONS(137), 1,
      sym_line_comment,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1074), 16,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1072), 33,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_PLUS_PLUS,
  [12113] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1701), 1,
      anon_sym_LBRACE,
    ACTIONS(1940), 1,
      anon_sym_SEMI,
    STATE(1380), 1,
      sym_Block,
    ACTIONS(546), 22,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(548), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [12188] = 8,
    ACTIONS(137), 1,
      sym_line_comment,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1074), 21,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1072), 35,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_PLUS_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
  [12267] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1181), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1183), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [12335] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(542), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(540), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [12403] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1205), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1207), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [12471] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1441), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1443), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [12539] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1241), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1243), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [12607] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1445), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1447), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [12675] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1167), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1169), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [12743] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1365), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1367), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [12811] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1453), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1455), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [12879] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1209), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1211), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [12947] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(522), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(524), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [13015] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1309), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1311), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [13083] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(566), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(564), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [13151] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(574), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(572), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [13219] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1942), 1,
      anon_sym_BANG,
    ACTIONS(1175), 23,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1177), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [13289] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1237), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1239), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [13357] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1297), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1299), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [13425] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1369), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1371), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [13493] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(530), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(528), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [13561] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1317), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1319), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [13629] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1373), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1375), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [13697] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1201), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1203), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [13765] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1233), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1235), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [13833] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1289), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1291), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [13901] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1229), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1231), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [13969] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1325), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1327), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [14037] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1341), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1343), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [14105] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1221), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1223), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [14173] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1321), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1323), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [14241] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1305), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1307), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [14309] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1265), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1267), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [14377] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(534), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(532), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [14445] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1349), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1351), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [14513] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1261), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1263), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [14581] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1257), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1259), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [14649] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1253), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1255), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [14717] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1185), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1187), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [14785] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1377), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1379), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [14853] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1301), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1303), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [14921] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1437), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1439), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [14989] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1107), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1105), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [15057] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1946), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1944), 40,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_nosuspend,
      anon_sym_defer,
      anon_sym_suspend,
      anon_sym_errdefer,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [15125] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1433), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1435), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [15193] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1429), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1431), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [15261] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1425), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1427), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [15329] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1421), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1423), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [15397] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1225), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1227), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [15465] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1333), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1335), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [15533] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1213), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1215), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [15601] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1189), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1191), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [15669] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1197), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1199), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [15737] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1457), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1459), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [15805] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1281), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1283), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [15873] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1269), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1271), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [15941] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1193), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1195), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [16009] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1337), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1339), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [16077] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(570), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(568), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [16145] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1381), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1383), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [16213] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1385), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1387), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [16281] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1389), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1391), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [16349] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1393), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1395), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [16417] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1417), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1419), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [16485] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1397), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1399), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [16553] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1249), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1251), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [16621] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1413), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1415), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [16689] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1245), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1247), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [16757] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1353), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1355), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [16825] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1401), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1403), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [16893] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1405), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1407), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [16961] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1409), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1411), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [17029] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1329), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1331), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [17097] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1163), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1165), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [17165] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1357), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1359), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [17233] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1345), 24,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1347), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [17301] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1948), 1,
      anon_sym_COLON,
    ACTIONS(546), 22,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(548), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [17370] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1764), 1,
      anon_sym_LBRACE,
    STATE(1285), 1,
      sym_InitList,
    ACTIONS(1041), 21,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1039), 36,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_PLUS_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
  [17441] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1954), 1,
      anon_sym_EQ,
    ACTIONS(1956), 1,
      anon_sym_align,
    STATE(1350), 1,
      sym_ByteAlign,
    ACTIONS(1107), 3,
      anon_sym_BANG,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    ACTIONS(1950), 18,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1952), 35,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [17516] = 7,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1956), 1,
      anon_sym_align,
    ACTIONS(1958), 1,
      anon_sym_EQ,
    STATE(1360), 1,
      sym_ByteAlign,
    ACTIONS(1107), 3,
      anon_sym_BANG,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    ACTIONS(1139), 18,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1141), 35,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [17591] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1960), 1,
      anon_sym_COLON,
    ACTIONS(546), 22,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(548), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [17660] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1962), 1,
      anon_sym_COLON,
    ACTIONS(546), 22,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(548), 36,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_DOT,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [17729] = 7,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1968), 1,
      anon_sym_COLON,
    ACTIONS(1970), 1,
      anon_sym_PIPE,
    STATE(1292), 1,
      sym_PtrPayload,
    STATE(1343), 1,
      sym_WhileContinueExpr,
    ACTIONS(1966), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1964), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [17804] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1972), 1,
      anon_sym_COLON,
    STATE(1289), 1,
      sym_BreakLabel,
    ACTIONS(101), 21,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(87), 35,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_else,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_PLUS_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
  [17874] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(1976), 1,
      anon_sym_EQ,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    STATE(311), 1,
      sym_AssignOp,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1974), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1978), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
  [17978] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1611), 21,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1609), 36,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_PLUS_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
  [18043] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1585), 21,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1583), 36,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_PLUS_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
  [18108] = 23,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1814), 1,
      anon_sym_or,
    ACTIONS(1816), 1,
      anon_sym_and,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1976), 1,
      anon_sym_EQ,
    STATE(307), 1,
      sym_CompareOp,
    STATE(308), 1,
      sym_BitwiseOp,
    STATE(310), 1,
      sym_BitShiftOp,
    STATE(315), 1,
      sym_AdditionOp,
    STATE(316), 1,
      sym_MultiplyOp,
    STATE(318), 1,
      sym_AssignOp,
    STATE(1286), 1,
      sym__ElseExprTail,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1974), 2,
      anon_sym_SEMI,
      anon_sym_else,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1978), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
  [18213] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(578), 21,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(576), 36,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_PLUS_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
  [18278] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(157), 21,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(155), 36,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_PLUS_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
  [18343] = 23,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1814), 1,
      anon_sym_or,
    ACTIONS(1816), 1,
      anon_sym_and,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1976), 1,
      anon_sym_EQ,
    STATE(307), 1,
      sym_CompareOp,
    STATE(308), 1,
      sym_BitwiseOp,
    STATE(310), 1,
      sym_BitShiftOp,
    STATE(315), 1,
      sym_AdditionOp,
    STATE(316), 1,
      sym_MultiplyOp,
    STATE(318), 1,
      sym_AssignOp,
    STATE(1301), 1,
      sym__ElseExprTail,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1974), 2,
      anon_sym_SEMI,
      anon_sym_else,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1978), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
  [18448] = 23,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1814), 1,
      anon_sym_or,
    ACTIONS(1816), 1,
      anon_sym_and,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1976), 1,
      anon_sym_EQ,
    STATE(307), 1,
      sym_CompareOp,
    STATE(308), 1,
      sym_BitwiseOp,
    STATE(310), 1,
      sym_BitShiftOp,
    STATE(315), 1,
      sym_AdditionOp,
    STATE(316), 1,
      sym_MultiplyOp,
    STATE(318), 1,
      sym_AssignOp,
    STATE(1297), 1,
      sym__ElseExprTail,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1974), 2,
      anon_sym_SEMI,
      anon_sym_else,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1978), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
  [18553] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1968), 1,
      anon_sym_COLON,
    STATE(1324), 1,
      sym_WhileContinueExpr,
    ACTIONS(1982), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1980), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [18622] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(630), 1,
      anon_sym_PIPE,
    STATE(1344), 1,
      sym_Payload,
    ACTIONS(1986), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1984), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [18691] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1641), 21,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1639), 36,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_PLUS_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
  [18756] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1970), 1,
      anon_sym_PIPE,
    STATE(1321), 1,
      sym_PtrPayload,
    ACTIONS(1990), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1988), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [18825] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1615), 21,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1613), 36,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_PLUS_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
  [18890] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1575), 21,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1573), 36,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_PLUS_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
  [18955] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1629), 21,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1627), 36,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_PLUS_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
  [19020] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1591), 21,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1589), 36,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_PLUS_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
  [19085] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1645), 21,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1643), 36,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_PLUS_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
  [19150] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1581), 21,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1579), 36,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ_GT,
      anon_sym_DOT_DOT,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_PLUS_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
  [19215] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1956), 1,
      anon_sym_align,
    ACTIONS(1996), 1,
      anon_sym_EQ,
    STATE(1354), 1,
      sym_ByteAlign,
    ACTIONS(1992), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1994), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [19285] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1956), 1,
      anon_sym_align,
    ACTIONS(2002), 1,
      anon_sym_EQ,
    STATE(1356), 1,
      sym_ByteAlign,
    ACTIONS(1998), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2000), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [19355] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1954), 1,
      anon_sym_EQ,
    ACTIONS(1956), 1,
      anon_sym_align,
    STATE(1350), 1,
      sym_ByteAlign,
    ACTIONS(1950), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1952), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [19425] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1956), 1,
      anon_sym_align,
    ACTIONS(2008), 1,
      anon_sym_EQ,
    STATE(1352), 1,
      sym_ByteAlign,
    ACTIONS(2004), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2006), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [19495] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1956), 1,
      anon_sym_align,
    ACTIONS(2014), 1,
      anon_sym_EQ,
    STATE(1353), 1,
      sym_ByteAlign,
    ACTIONS(2010), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2012), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [19565] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1956), 1,
      anon_sym_align,
    ACTIONS(2020), 1,
      anon_sym_EQ,
    STATE(1347), 1,
      sym_ByteAlign,
    ACTIONS(2016), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2018), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [19635] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1956), 1,
      anon_sym_align,
    ACTIONS(2026), 1,
      anon_sym_EQ,
    STATE(1346), 1,
      sym_ByteAlign,
    ACTIONS(2022), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2024), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [19705] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2030), 21,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2028), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [19769] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1956), 1,
      anon_sym_align,
    ACTIONS(2036), 1,
      anon_sym_EQ,
    STATE(1358), 1,
      sym_ByteAlign,
    ACTIONS(2032), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2034), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [19839] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1956), 1,
      anon_sym_align,
    ACTIONS(2042), 1,
      anon_sym_EQ,
    STATE(1357), 1,
      sym_ByteAlign,
    ACTIONS(2038), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2040), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [19909] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2046), 21,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2044), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [19973] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1956), 1,
      anon_sym_align,
    ACTIONS(2052), 1,
      anon_sym_EQ,
    STATE(1345), 1,
      sym_ByteAlign,
    ACTIONS(2048), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2050), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [20043] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1956), 1,
      anon_sym_align,
    ACTIONS(2058), 1,
      anon_sym_EQ,
    STATE(1348), 1,
      sym_ByteAlign,
    ACTIONS(2054), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2056), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [20113] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1956), 1,
      anon_sym_align,
    ACTIONS(2064), 1,
      anon_sym_EQ,
    STATE(1355), 1,
      sym_ByteAlign,
    ACTIONS(2060), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2062), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [20183] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1956), 1,
      anon_sym_align,
    ACTIONS(2070), 1,
      anon_sym_EQ,
    STATE(1349), 1,
      sym_ByteAlign,
    ACTIONS(2066), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2068), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [20253] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1956), 1,
      anon_sym_align,
    ACTIONS(2076), 1,
      anon_sym_EQ,
    STATE(1351), 1,
      sym_ByteAlign,
    ACTIONS(2072), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2074), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [20323] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2080), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2078), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [20386] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2084), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2082), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [20449] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1946), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1944), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [20512] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2088), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2086), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [20575] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2092), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2090), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [20638] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2096), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2094), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [20701] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2100), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2098), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [20764] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2104), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2102), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [20827] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1986), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1984), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [20890] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2108), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2106), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [20953] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2112), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2110), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [21016] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2116), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2114), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [21079] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2120), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2118), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [21142] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2124), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2122), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [21205] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2128), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2126), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [21268] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2132), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2130), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [21331] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1023), 1,
      anon_sym_orelse,
    ACTIONS(1033), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(1974), 1,
      anon_sym_SEMI,
    ACTIONS(1976), 1,
      anon_sym_EQ,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    STATE(311), 1,
      sym_AssignOp,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1035), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR_STAR,
    ACTIONS(1015), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
    ACTIONS(1027), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1017), 5,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1031), 6,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1978), 17,
      anon_sym_STAR_EQ,
      anon_sym_STAR_PIPE_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_LT_LT_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_PERCENT_EQ,
      anon_sym_PLUS_PERCENT_EQ,
      anon_sym_DASH_PERCENT_EQ,
  [21432] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2136), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2134), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [21495] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2140), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2138), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [21558] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2144), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2142), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [21621] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2148), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2146), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [21684] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2152), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2150), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [21747] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2156), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2154), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [21810] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2160), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2158), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [21873] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2164), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2162), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [21936] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1982), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1980), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [21999] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2168), 20,
      anon_sym_BANG,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP,
      anon_sym_DASH_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_TILDE,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2166), 35,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_nosuspend,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_resume,
      anon_sym_return,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_asm,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_try,
      anon_sym_await,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [22062] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1996), 1,
      anon_sym_EQ,
    ACTIONS(1992), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1994), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [22126] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2170), 1,
      anon_sym_EQ,
    ACTIONS(1293), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1295), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [22190] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2042), 1,
      anon_sym_EQ,
    ACTIONS(2038), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2040), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [22254] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2070), 1,
      anon_sym_EQ,
    ACTIONS(2066), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2068), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [22318] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2172), 1,
      anon_sym_EQ,
    ACTIONS(1449), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1451), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [22382] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1958), 1,
      anon_sym_EQ,
    ACTIONS(1139), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1141), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [22446] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2026), 1,
      anon_sym_EQ,
    ACTIONS(2022), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2024), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [22510] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2174), 1,
      anon_sym_EQ,
    ACTIONS(1461), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1463), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [22574] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2036), 1,
      anon_sym_EQ,
    ACTIONS(2032), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2034), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [22638] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2176), 1,
      anon_sym_EQ,
    ACTIONS(1109), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1111), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [22702] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2008), 1,
      anon_sym_EQ,
    ACTIONS(2004), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2006), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [22766] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1954), 1,
      anon_sym_EQ,
    ACTIONS(1950), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1952), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [22830] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2178), 1,
      anon_sym_EQ,
    ACTIONS(1159), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1161), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [22894] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2180), 1,
      anon_sym_EQ,
    ACTIONS(1171), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1173), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [22958] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2182), 20,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2184), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [23020] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2186), 1,
      anon_sym_EQ,
    ACTIONS(1121), 19,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1123), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [23084] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2190), 1,
      anon_sym_COMMA,
    ACTIONS(2188), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2192), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [23147] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1900), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1898), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [23207] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1864), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1862), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [23267] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2194), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2196), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [23327] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1884), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1882), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [23387] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1872), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1870), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [23447] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2198), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2200), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [23507] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(530), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(528), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [23567] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1868), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1866), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [23627] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(534), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(532), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [23687] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2202), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2204), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [23747] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2206), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2208), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [23807] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2210), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2212), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [23867] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1912), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1910), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [23927] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2214), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2216), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [23987] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2218), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2220), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [24047] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(776), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2222), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [24107] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1876), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1874), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [24167] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2224), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2226), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [24227] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2228), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2230), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [24287] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2232), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2234), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [24347] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1892), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      sym_doc_comment,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1890), 34,
      anon_sym_pub,
      anon_sym_test,
      anon_sym_comptime,
      anon_sym_export,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_noinline,
      anon_sym_threadlocal,
      anon_sym_usingnamespace,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_var,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [24407] = 7,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2242), 1,
      anon_sym_addrspace,
    ACTIONS(2244), 1,
      anon_sym_align,
    ACTIONS(2238), 3,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_allowzero,
    STATE(1385), 3,
      sym_AddrSpace,
      sym_ByteAlign,
      aux_sym_PrefixTypeOp_repeat1,
    ACTIONS(2240), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2236), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [24472] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2248), 1,
      anon_sym_COLON,
    ACTIONS(2252), 1,
      anon_sym_RBRACK,
    ACTIONS(2254), 1,
      anon_sym_c,
    ACTIONS(2250), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2246), 31,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_volatile,
      anon_sym_addrspace,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_allowzero,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [24535] = 7,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2263), 1,
      anon_sym_addrspace,
    ACTIONS(2266), 1,
      anon_sym_align,
    ACTIONS(2258), 3,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_allowzero,
    STATE(1385), 3,
      sym_AddrSpace,
      sym_ByteAlign,
      aux_sym_PrefixTypeOp_repeat1,
    ACTIONS(2261), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2256), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [24600] = 7,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2242), 1,
      anon_sym_addrspace,
    ACTIONS(2244), 1,
      anon_sym_align,
    ACTIONS(2271), 3,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_allowzero,
    STATE(1383), 3,
      sym_AddrSpace,
      sym_ByteAlign,
      aux_sym_PrefixTypeOp_repeat1,
    ACTIONS(2273), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2269), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [24665] = 7,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2282), 1,
      anon_sym_addrspace,
    ACTIONS(2285), 1,
      anon_sym_align,
    STATE(1387), 2,
      sym_AddrSpace,
      aux_sym_PrefixTypeOp_repeat2,
    ACTIONS(2277), 3,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_allowzero,
    ACTIONS(2280), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2275), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [24729] = 7,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2242), 1,
      anon_sym_addrspace,
    ACTIONS(2290), 1,
      anon_sym_align,
    STATE(1387), 2,
      sym_AddrSpace,
      aux_sym_PrefixTypeOp_repeat2,
    ACTIONS(2288), 3,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_allowzero,
    ACTIONS(2240), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2236), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [24793] = 7,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2242), 1,
      anon_sym_addrspace,
    ACTIONS(2290), 1,
      anon_sym_align,
    STATE(1388), 2,
      sym_AddrSpace,
      aux_sym_PrefixTypeOp_repeat2,
    ACTIONS(2292), 3,
      anon_sym_const,
      anon_sym_volatile,
      anon_sym_allowzero,
    ACTIONS(2273), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2269), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [24857] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2182), 18,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2184), 29,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_linksection,
      anon_sym_addrspace,
      anon_sym_callconv,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [24912] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2296), 18,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2294), 28,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_linksection,
      anon_sym_callconv,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [24966] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2300), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2298), 31,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_volatile,
      anon_sym_addrspace,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_allowzero,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [25020] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2304), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2302), 31,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_volatile,
      anon_sym_addrspace,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_allowzero,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [25074] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2296), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2294), 31,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_volatile,
      anon_sym_addrspace,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_allowzero,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [25128] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2182), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2184), 31,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_volatile,
      anon_sym_addrspace,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_allowzero,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [25182] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2308), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2306), 31,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_volatile,
      anon_sym_addrspace,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_allowzero,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [25236] = 12,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2314), 1,
      anon_sym_anyframe,
    ACTIONS(2317), 1,
      anon_sym_LBRACK,
    ACTIONS(2320), 1,
      anon_sym_STAR,
    ACTIONS(2323), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2326), 1,
      anon_sym_QMARK,
    STATE(1386), 1,
      sym_SliceTypeStart,
    STATE(1389), 1,
      sym_PtrTypeStart,
    STATE(1499), 1,
      sym_ArrayTypeStart,
    STATE(1397), 2,
      sym_PrefixTypeOp,
      aux_sym__TypeExpr_repeat1,
    ACTIONS(2312), 12,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2310), 24,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [25308] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2331), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2329), 31,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_volatile,
      anon_sym_addrspace,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_allowzero,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [25362] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2335), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2333), 31,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_volatile,
      anon_sym_addrspace,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_allowzero,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [25416] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2339), 16,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2337), 30,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_linksection,
      anon_sym_addrspace,
      anon_sym_callconv,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [25470] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2343), 16,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2341), 30,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_linksection,
      anon_sym_addrspace,
      anon_sym_callconv,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [25524] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2347), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2345), 31,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_volatile,
      anon_sym_addrspace,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_allowzero,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [25578] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2250), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2246), 31,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_volatile,
      anon_sym_addrspace,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_allowzero,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [25632] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2351), 16,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2349), 30,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_linksection,
      anon_sym_addrspace,
      anon_sym_callconv,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [25686] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2355), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2353), 31,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_const,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_volatile,
      anon_sym_addrspace,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_allowzero,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [25740] = 9,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(931), 1,
      anon_sym_COLON,
    ACTIONS(2357), 1,
      anon_sym_DOT,
    ACTIONS(2359), 1,
      anon_sym_LPAREN,
    ACTIONS(2361), 1,
      anon_sym_LBRACK,
    ACTIONS(2363), 2,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    STATE(1412), 4,
      sym_FieldOrFnCall,
      sym_SuffixOp,
      sym_FnCallArguments,
      aux_sym_SuffixExpr_repeat1,
    ACTIONS(929), 10,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(927), 26,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [25806] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2367), 16,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2365), 30,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_linksection,
      anon_sym_addrspace,
      anon_sym_callconv,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_align,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [25860] = 9,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(931), 1,
      anon_sym_COLON,
    ACTIONS(2357), 1,
      anon_sym_DOT,
    ACTIONS(2359), 1,
      anon_sym_LPAREN,
    ACTIONS(2361), 1,
      anon_sym_LBRACK,
    ACTIONS(2363), 2,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    STATE(1416), 4,
      sym_FieldOrFnCall,
      sym_SuffixOp,
      sym_FnCallArguments,
      aux_sym_SuffixExpr_repeat1,
    ACTIONS(943), 10,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(941), 26,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [25926] = 8,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2369), 1,
      anon_sym_DOT,
    ACTIONS(2372), 1,
      anon_sym_LPAREN,
    ACTIONS(2375), 1,
      anon_sym_LBRACK,
    ACTIONS(2378), 2,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    STATE(1409), 4,
      sym_FieldOrFnCall,
      sym_SuffixOp,
      sym_FnCallArguments,
      aux_sym_SuffixExpr_repeat1,
    ACTIONS(959), 10,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(957), 26,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [25989] = 8,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2357), 1,
      anon_sym_DOT,
    ACTIONS(2359), 1,
      anon_sym_LPAREN,
    ACTIONS(2361), 1,
      anon_sym_LBRACK,
    ACTIONS(2363), 2,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    STATE(1415), 4,
      sym_FieldOrFnCall,
      sym_SuffixOp,
      sym_FnCallArguments,
      aux_sym_SuffixExpr_repeat1,
    ACTIONS(983), 10,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(981), 26,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [26052] = 7,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2381), 1,
      anon_sym_COLON,
    ACTIONS(2383), 1,
      anon_sym_PIPE,
    STATE(1425), 1,
      sym_PtrPayload,
    STATE(1486), 1,
      sym_WhileContinueExpr,
    ACTIONS(1966), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1964), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [26113] = 8,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2357), 1,
      anon_sym_DOT,
    ACTIONS(2359), 1,
      anon_sym_LPAREN,
    ACTIONS(2361), 1,
      anon_sym_LBRACK,
    ACTIONS(2363), 2,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    STATE(1409), 4,
      sym_FieldOrFnCall,
      sym_SuffixOp,
      sym_FnCallArguments,
      aux_sym_SuffixExpr_repeat1,
    ACTIONS(975), 10,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(973), 26,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [26176] = 8,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2357), 1,
      anon_sym_DOT,
    ACTIONS(2359), 1,
      anon_sym_LPAREN,
    ACTIONS(2361), 1,
      anon_sym_LBRACK,
    ACTIONS(2363), 2,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    STATE(1409), 4,
      sym_FieldOrFnCall,
      sym_SuffixOp,
      sym_FnCallArguments,
      aux_sym_SuffixExpr_repeat1,
    ACTIONS(979), 10,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(977), 26,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [26239] = 8,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2357), 1,
      anon_sym_DOT,
    ACTIONS(2359), 1,
      anon_sym_LPAREN,
    ACTIONS(2361), 1,
      anon_sym_LBRACK,
    ACTIONS(2363), 2,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    STATE(1413), 4,
      sym_FieldOrFnCall,
      sym_SuffixOp,
      sym_FnCallArguments,
      aux_sym_SuffixExpr_repeat1,
    ACTIONS(987), 10,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(985), 26,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [26302] = 8,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2357), 1,
      anon_sym_DOT,
    ACTIONS(2359), 1,
      anon_sym_LPAREN,
    ACTIONS(2361), 1,
      anon_sym_LBRACK,
    ACTIONS(2363), 2,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    STATE(1409), 4,
      sym_FieldOrFnCall,
      sym_SuffixOp,
      sym_FnCallArguments,
      aux_sym_SuffixExpr_repeat1,
    ACTIONS(991), 10,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(989), 26,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [26365] = 8,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2357), 1,
      anon_sym_DOT,
    ACTIONS(2359), 1,
      anon_sym_LPAREN,
    ACTIONS(2361), 1,
      anon_sym_LBRACK,
    ACTIONS(2363), 2,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    STATE(1409), 4,
      sym_FieldOrFnCall,
      sym_SuffixOp,
      sym_FnCallArguments,
      aux_sym_SuffixExpr_repeat1,
    ACTIONS(955), 10,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(953), 26,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [26428] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2387), 18,
      anon_sym_SEMI,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2385), 27,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_callconv,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [26481] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(321), 1,
      anon_sym_BSLASH_BSLASH,
    STATE(1420), 2,
      sym_LINESTRING,
      aux_sym__STRINGLITERAL_repeat1,
    ACTIONS(1758), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1756), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [26537] = 11,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1745), 1,
      anon_sym_DOT,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1749), 1,
      anon_sym_LBRACK,
    ACTIONS(2389), 1,
      anon_sym_COLON,
    ACTIONS(2391), 1,
      anon_sym_RBRACK,
    ACTIONS(2393), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1751), 2,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    STATE(934), 4,
      sym_FieldOrFnCall,
      sym_SuffixOp,
      sym_FnCallArguments,
      aux_sym_SuffixExpr_repeat1,
    ACTIONS(943), 10,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(941), 22,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [26605] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2395), 1,
      anon_sym_BSLASH_BSLASH,
    STATE(1420), 2,
      sym_LINESTRING,
      aux_sym__STRINGLITERAL_repeat1,
    ACTIONS(1067), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1065), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [26661] = 8,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2398), 1,
      anon_sym_LBRACE,
    STATE(1510), 1,
      sym__ElseTypeExprTail,
    STATE(1663), 1,
      sym_InitList,
    ACTIONS(1043), 2,
      anon_sym_BANG,
      anon_sym_DOT,
    ACTIONS(1047), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    ACTIONS(1041), 9,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1039), 25,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [26722] = 8,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2398), 1,
      anon_sym_LBRACE,
    STATE(1514), 1,
      sym__ElseTypeExprTail,
    STATE(1663), 1,
      sym_InitList,
    ACTIONS(1061), 2,
      anon_sym_BANG,
      anon_sym_DOT,
    ACTIONS(1063), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    ACTIONS(1041), 9,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1039), 25,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [26783] = 9,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1745), 1,
      anon_sym_DOT,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1749), 1,
      anon_sym_LBRACK,
    ACTIONS(2400), 1,
      anon_sym_COLON,
    ACTIONS(1751), 2,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    STATE(934), 4,
      sym_FieldOrFnCall,
      sym_SuffixOp,
      sym_FnCallArguments,
      aux_sym_SuffixExpr_repeat1,
    ACTIONS(943), 10,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(941), 23,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [26846] = 8,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2398), 1,
      anon_sym_LBRACE,
    STATE(1511), 1,
      sym__ElseTypeExprTail,
    STATE(1663), 1,
      sym_InitList,
    ACTIONS(1053), 2,
      anon_sym_BANG,
      anon_sym_DOT,
    ACTIONS(1055), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    ACTIONS(1041), 9,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1039), 25,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [26907] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2381), 1,
      anon_sym_COLON,
    STATE(1456), 1,
      sym_WhileContinueExpr,
    ACTIONS(1982), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1980), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [26962] = 10,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(931), 1,
      anon_sym_COLON,
    ACTIONS(1745), 1,
      anon_sym_DOT,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1749), 1,
      anon_sym_LBRACK,
    ACTIONS(2402), 1,
      anon_sym_RBRACK,
    ACTIONS(1751), 2,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    STATE(934), 4,
      sym_FieldOrFnCall,
      sym_SuffixOp,
      sym_FnCallArguments,
      aux_sym_SuffixExpr_repeat1,
    ACTIONS(943), 10,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(941), 22,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [27027] = 10,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(931), 1,
      anon_sym_COLON,
    ACTIONS(1745), 1,
      anon_sym_DOT,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1749), 1,
      anon_sym_LBRACK,
    ACTIONS(2404), 1,
      anon_sym_RBRACK,
    ACTIONS(1751), 2,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    STATE(934), 4,
      sym_FieldOrFnCall,
      sym_SuffixOp,
      sym_FnCallArguments,
      aux_sym_SuffixExpr_repeat1,
    ACTIONS(943), 10,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(941), 22,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [27092] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2383), 1,
      anon_sym_PIPE,
    STATE(1473), 1,
      sym_PtrPayload,
    ACTIONS(1990), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1988), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [27147] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1207), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1205), 31,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
      anon_sym_BSLASH_BSLASH,
  [27197] = 7,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2398), 1,
      anon_sym_LBRACE,
    STATE(1663), 1,
      sym_InitList,
    ACTIONS(1105), 2,
      anon_sym_BANG,
      anon_sym_DOT,
    ACTIONS(1107), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    ACTIONS(1041), 9,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1039), 25,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [27255] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(554), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(552), 31,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [27305] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2406), 1,
      anon_sym_else,
    STATE(1510), 1,
      sym__ElseTypeExprTail,
    ACTIONS(1043), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1047), 29,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [27359] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1101), 1,
      anon_sym_DASH_GT,
    ACTIONS(548), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(546), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [27411] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2410), 16,
      anon_sym_BANG,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2408), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [27461] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2030), 16,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2028), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [27511] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2046), 16,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2044), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [27561] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(538), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(536), 31,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [27611] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2406), 1,
      anon_sym_else,
    STATE(1514), 1,
      sym__ElseTypeExprTail,
    ACTIONS(1061), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1063), 29,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [27665] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2406), 1,
      anon_sym_else,
    STATE(1511), 1,
      sym__ElseTypeExprTail,
    ACTIONS(1053), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1055), 29,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [27719] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(562), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(560), 31,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [27769] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2359), 1,
      anon_sym_LPAREN,
    STATE(1496), 1,
      sym_FnCallArguments,
    ACTIONS(1091), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1089), 29,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [27823] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(558), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(556), 31,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [27873] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1303), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1301), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [27922] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1375), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1373), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [27971] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2414), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2412), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [28020] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1946), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1944), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [28069] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(568), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(570), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [28118] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(564), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(566), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [28167] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(572), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(574), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [28216] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(540), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(542), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [28265] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(528), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(530), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [28314] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2092), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2090), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [28363] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1459), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1457), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [28412] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1455), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1453), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [28461] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1447), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1445), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [28510] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2100), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2098), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [28559] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1443), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1441), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [28608] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1439), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1437), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [28657] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2418), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2416), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [28706] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1435), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1433), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [28755] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1431), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1429), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [28804] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1427), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1425), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [28853] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1423), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1421), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [28902] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1419), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1417), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [28951] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1415), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1413), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [29000] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2422), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2420), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [29049] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1411), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1409), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [29098] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1407), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1405), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [29147] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1403), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1401), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [29196] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1399), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1397), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [29245] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1395), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1393), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [29294] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1391), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1389), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [29343] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2088), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2086), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [29392] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2160), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2158), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [29441] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1387), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1385), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [29490] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1383), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1381), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [29539] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1379), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1377), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [29588] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1371), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1369), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [29637] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1367), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1365), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [29686] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1359), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1357), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [29735] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2148), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2146), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [29784] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1355), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1353), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [29833] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2132), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2130), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [29882] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1351), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1349), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [29931] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1347), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1345), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [29980] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1982), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(1980), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [30029] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1343), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1341), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [30078] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1339), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1337), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [30127] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2156), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2154), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [30176] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1335), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1333), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [30225] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1331), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1329), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [30274] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1327), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1325), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [30323] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1323), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1321), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [30372] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1319), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1317), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [30421] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1311), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1309), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [30470] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1307), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1305), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [30519] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1299), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1297), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [30568] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1291), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1289), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [30617] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2273), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2269), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [30666] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1283), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1281), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [30715] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2144), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2142), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [30764] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1165), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1163), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [30813] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1169), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1167), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [30862] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1271), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1269), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [30911] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2424), 1,
      anon_sym_BANG,
    ACTIONS(1177), 10,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1175), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [30962] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1267), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1265), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [31011] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1183), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1181), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [31060] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1187), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1185), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [31109] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1191), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1189), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [31158] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1263), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1261), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [31207] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1259), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1257), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [31256] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1195), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1193), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [31305] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1199), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1197), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [31354] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1255), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1253), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [31403] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1251), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1249), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [31452] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(532), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(534), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [31501] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1247), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1245), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [31550] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2152), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2150), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [31599] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2128), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2126), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [31648] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2104), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2102), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [31697] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1105), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1107), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [31746] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1203), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1201), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [31795] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1243), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1241), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [31844] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1239), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1237), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [31893] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1235), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1233), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [31942] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1231), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1229), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [31991] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1227), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1225), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [32040] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1223), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1221), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [32089] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1211), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1209), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [32138] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2428), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2426), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [32187] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(524), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(522), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [32236] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2240), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2236), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [32285] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1215), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1213), 30,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [32334] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2084), 15,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_QMARK,
      anon_sym_SQUOTE,
      aux_sym_FLOAT_token1,
      aux_sym_FLOAT_token2,
      aux_sym_FLOAT_token3,
      aux_sym_FLOAT_token4,
      aux_sym_INTEGER_token1,
      aux_sym_INTEGER_token2,
      anon_sym_DQUOTE,
      anon_sym_BSLASH_BSLASH,
      anon_sym_AT,
    ACTIONS(2082), 26,
      anon_sym_comptime,
      anon_sym_extern,
      anon_sym_inline,
      anon_sym_fn,
      anon_sym_async,
      anon_sym_error,
      anon_sym_false,
      anon_sym_null,
      anon_sym_anyframe,
      anon_sym_true,
      anon_sym_undefined,
      anon_sym_unreachable,
      sym_BuildinTypeExpr,
      anon_sym_packed,
      anon_sym_switch,
      anon_sym_if,
      anon_sym_while,
      anon_sym_for,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_opaque,
      anon_sym_enum,
      anon_sym_union,
      aux_sym_INTEGER_token3,
      aux_sym_INTEGER_token4,
      aux_sym_IDENTIFIER_token1,
  [32383] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2430), 1,
      anon_sym_EQ,
    ACTIONS(1203), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1201), 28,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [32433] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2435), 11,
      anon_sym_BANG,
      anon_sym_or,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(2432), 29,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [32481] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(2438), 1,
      anon_sym_else,
    ACTIONS(2440), 1,
      anon_sym_or,
    ACTIONS(2442), 1,
      anon_sym_and,
    STATE(223), 1,
      sym_MultiplyOp,
    STATE(224), 1,
      sym_AdditionOp,
    STATE(225), 1,
      sym_BitShiftOp,
    STATE(226), 1,
      sym_BitwiseOp,
    STATE(227), 1,
      sym_CompareOp,
    STATE(1657), 1,
      sym__ElseExprTail,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1005), 3,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [32567] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(2438), 1,
      anon_sym_else,
    ACTIONS(2440), 1,
      anon_sym_or,
    ACTIONS(2442), 1,
      anon_sym_and,
    STATE(223), 1,
      sym_MultiplyOp,
    STATE(224), 1,
      sym_AdditionOp,
    STATE(225), 1,
      sym_BitShiftOp,
    STATE(226), 1,
      sym_BitwiseOp,
    STATE(227), 1,
      sym_CompareOp,
    STATE(1655), 1,
      sym__ElseExprTail,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1049), 3,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [32653] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(2440), 1,
      anon_sym_or,
    ACTIONS(2442), 1,
      anon_sym_and,
    ACTIONS(2444), 1,
      anon_sym_else,
    STATE(223), 1,
      sym_MultiplyOp,
    STATE(224), 1,
      sym_AdditionOp,
    STATE(225), 1,
      sym_BitShiftOp,
    STATE(226), 1,
      sym_BitwiseOp,
    STATE(227), 1,
      sym_CompareOp,
    STATE(1657), 1,
      sym__ElseExprTail,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1005), 3,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [32739] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(2438), 1,
      anon_sym_else,
    ACTIONS(2440), 1,
      anon_sym_or,
    ACTIONS(2442), 1,
      anon_sym_and,
    STATE(223), 1,
      sym_MultiplyOp,
    STATE(224), 1,
      sym_AdditionOp,
    STATE(225), 1,
      sym_BitShiftOp,
    STATE(226), 1,
      sym_BitwiseOp,
    STATE(227), 1,
      sym_CompareOp,
    STATE(1654), 1,
      sym__ElseExprTail,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1057), 3,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [32825] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(2440), 1,
      anon_sym_or,
    ACTIONS(2442), 1,
      anon_sym_and,
    ACTIONS(2444), 1,
      anon_sym_else,
    STATE(223), 1,
      sym_MultiplyOp,
    STATE(224), 1,
      sym_AdditionOp,
    STATE(225), 1,
      sym_BitShiftOp,
    STATE(226), 1,
      sym_BitwiseOp,
    STATE(227), 1,
      sym_CompareOp,
    STATE(1654), 1,
      sym__ElseExprTail,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1057), 3,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [32911] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(2440), 1,
      anon_sym_or,
    ACTIONS(2442), 1,
      anon_sym_and,
    ACTIONS(2444), 1,
      anon_sym_else,
    STATE(223), 1,
      sym_MultiplyOp,
    STATE(224), 1,
      sym_AdditionOp,
    STATE(225), 1,
      sym_BitShiftOp,
    STATE(226), 1,
      sym_BitwiseOp,
    STATE(227), 1,
      sym_CompareOp,
    STATE(1655), 1,
      sym__ElseExprTail,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1049), 3,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [32997] = 17,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    STATE(223), 1,
      sym_MultiplyOp,
    STATE(224), 1,
      sym_AdditionOp,
    STATE(225), 1,
      sym_BitShiftOp,
    STATE(226), 1,
      sym_BitwiseOp,
    STATE(227), 1,
      sym_CompareOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1074), 3,
      anon_sym_or,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1072), 9,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [33072] = 14,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    STATE(223), 1,
      sym_MultiplyOp,
    STATE(224), 1,
      sym_AdditionOp,
    STATE(225), 1,
      sym_BitShiftOp,
    STATE(226), 1,
      sym_BitwiseOp,
    STATE(227), 1,
      sym_CompareOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1074), 4,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1072), 13,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
  [33141] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(2440), 1,
      anon_sym_or,
    ACTIONS(2442), 1,
      anon_sym_and,
    STATE(223), 1,
      sym_MultiplyOp,
    STATE(224), 1,
      sym_AdditionOp,
    STATE(225), 1,
      sym_BitShiftOp,
    STATE(226), 1,
      sym_BitwiseOp,
    STATE(227), 1,
      sym_CompareOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1080), 4,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [33222] = 8,
    ACTIONS(137), 1,
      sym_line_comment,
    STATE(223), 1,
      sym_MultiplyOp,
    STATE(224), 1,
      sym_AdditionOp,
    STATE(225), 1,
      sym_BitShiftOp,
    STATE(226), 1,
      sym_BitwiseOp,
    STATE(227), 1,
      sym_CompareOp,
    ACTIONS(1095), 9,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1093), 25,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [33279] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(2440), 1,
      anon_sym_or,
    ACTIONS(2442), 1,
      anon_sym_and,
    STATE(223), 1,
      sym_MultiplyOp,
    STATE(224), 1,
      sym_AdditionOp,
    STATE(225), 1,
      sym_BitShiftOp,
    STATE(226), 1,
      sym_BitwiseOp,
    STATE(227), 1,
      sym_CompareOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1076), 4,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [33360] = 8,
    ACTIONS(137), 1,
      sym_line_comment,
    STATE(223), 1,
      sym_MultiplyOp,
    STATE(224), 1,
      sym_AdditionOp,
    STATE(225), 1,
      sym_BitShiftOp,
    STATE(226), 1,
      sym_BitwiseOp,
    STATE(227), 1,
      sym_CompareOp,
    ACTIONS(1074), 9,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1072), 25,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [33417] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(2440), 1,
      anon_sym_or,
    ACTIONS(2442), 1,
      anon_sym_and,
    STATE(223), 1,
      sym_MultiplyOp,
    STATE(224), 1,
      sym_AdditionOp,
    STATE(225), 1,
      sym_BitShiftOp,
    STATE(226), 1,
      sym_BitwiseOp,
    STATE(227), 1,
      sym_CompareOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(155), 4,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [33498] = 10,
    ACTIONS(137), 1,
      sym_line_comment,
    STATE(223), 1,
      sym_MultiplyOp,
    STATE(224), 1,
      sym_AdditionOp,
    STATE(225), 1,
      sym_BitShiftOp,
    STATE(226), 1,
      sym_BitwiseOp,
    STATE(227), 1,
      sym_CompareOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1074), 7,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1072), 20,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
  [33559] = 12,
    ACTIONS(137), 1,
      sym_line_comment,
    STATE(223), 1,
      sym_MultiplyOp,
    STATE(224), 1,
      sym_AdditionOp,
    STATE(225), 1,
      sym_BitShiftOp,
    STATE(226), 1,
      sym_BitwiseOp,
    STATE(227), 1,
      sym_CompareOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1074), 5,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
    ACTIONS(1072), 15,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
  [33624] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(2440), 1,
      anon_sym_or,
    ACTIONS(2442), 1,
      anon_sym_and,
    STATE(223), 1,
      sym_MultiplyOp,
    STATE(224), 1,
      sym_AdditionOp,
    STATE(225), 1,
      sym_BitShiftOp,
    STATE(226), 1,
      sym_BitwiseOp,
    STATE(227), 1,
      sym_CompareOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 4,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [33705] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1074), 1,
      anon_sym_or,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(2442), 1,
      anon_sym_and,
    STATE(223), 1,
      sym_MultiplyOp,
    STATE(224), 1,
      sym_AdditionOp,
    STATE(225), 1,
      sym_BitShiftOp,
    STATE(226), 1,
      sym_BitwiseOp,
    STATE(227), 1,
      sym_CompareOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1072), 4,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [33786] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2446), 4,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [33867] = 19,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1074), 1,
      anon_sym_or,
    ACTIONS(1818), 1,
      anon_sym_catch,
    STATE(223), 1,
      sym_MultiplyOp,
    STATE(224), 1,
      sym_AdditionOp,
    STATE(225), 1,
      sym_BitShiftOp,
    STATE(226), 1,
      sym_BitwiseOp,
    STATE(227), 1,
      sym_CompareOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1072), 5,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
  [33946] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2448), 1,
      anon_sym_COLON,
    ACTIONS(2450), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    STATE(2138), 1,
      sym_AsmOutput,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [34030] = 10,
    ACTIONS(137), 1,
      sym_line_comment,
    STATE(245), 1,
      sym_MultiplyOp,
    STATE(246), 1,
      sym_AdditionOp,
    STATE(247), 1,
      sym_BitShiftOp,
    STATE(248), 1,
      sym_BitwiseOp,
    STATE(249), 1,
      sym_CompareOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1074), 7,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1072), 19,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
  [34090] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1074), 1,
      anon_sym_or,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(2452), 1,
      anon_sym_and,
    STATE(245), 1,
      sym_MultiplyOp,
    STATE(246), 1,
      sym_AdditionOp,
    STATE(247), 1,
      sym_BitShiftOp,
    STATE(248), 1,
      sym_BitwiseOp,
    STATE(249), 1,
      sym_CompareOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1072), 3,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [34170] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2454), 1,
      anon_sym_COMMA,
    ACTIONS(2456), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    STATE(1943), 1,
      aux_sym_InitList_repeat2,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [34254] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2458), 1,
      anon_sym_COMMA,
    ACTIONS(2460), 1,
      anon_sym_RBRACE,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    STATE(1936), 1,
      aux_sym_InitList_repeat2,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [34338] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2448), 1,
      anon_sym_COLON,
    ACTIONS(2462), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    STATE(2168), 1,
      sym_AsmOutput,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [34422] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2448), 1,
      anon_sym_COLON,
    ACTIONS(2464), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    STATE(2142), 1,
      sym_AsmOutput,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [34506] = 8,
    ACTIONS(137), 1,
      sym_line_comment,
    STATE(245), 1,
      sym_MultiplyOp,
    STATE(246), 1,
      sym_AdditionOp,
    STATE(247), 1,
      sym_BitShiftOp,
    STATE(248), 1,
      sym_BitwiseOp,
    STATE(249), 1,
      sym_CompareOp,
    ACTIONS(1095), 9,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1093), 24,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [34562] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2466), 1,
      anon_sym_COMMA,
    ACTIONS(2468), 1,
      anon_sym_RBRACE,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    STATE(1945), 1,
      aux_sym_InitList_repeat2,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [34646] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2470), 1,
      anon_sym_COMMA,
    ACTIONS(2472), 1,
      anon_sym_RBRACE,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    STATE(2014), 1,
      aux_sym_InitList_repeat2,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [34730] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2474), 1,
      anon_sym_COMMA,
    ACTIONS(2476), 1,
      anon_sym_RBRACE,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    STATE(1978), 1,
      aux_sym_InitList_repeat2,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [34814] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2478), 1,
      anon_sym_COMMA,
    ACTIONS(2480), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    STATE(1920), 1,
      aux_sym_InitList_repeat2,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [34898] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2448), 1,
      anon_sym_COLON,
    ACTIONS(2482), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    STATE(2182), 1,
      sym_AsmOutput,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [34982] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(2452), 1,
      anon_sym_and,
    ACTIONS(2484), 1,
      anon_sym_or,
    STATE(245), 1,
      sym_MultiplyOp,
    STATE(246), 1,
      sym_AdditionOp,
    STATE(247), 1,
      sym_BitShiftOp,
    STATE(248), 1,
      sym_BitwiseOp,
    STATE(249), 1,
      sym_CompareOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1076), 3,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [35062] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(2452), 1,
      anon_sym_and,
    ACTIONS(2484), 1,
      anon_sym_or,
    STATE(245), 1,
      sym_MultiplyOp,
    STATE(246), 1,
      sym_AdditionOp,
    STATE(247), 1,
      sym_BitShiftOp,
    STATE(248), 1,
      sym_BitwiseOp,
    STATE(249), 1,
      sym_CompareOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1097), 3,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [35142] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(2452), 1,
      anon_sym_and,
    ACTIONS(2484), 1,
      anon_sym_or,
    STATE(245), 1,
      sym_MultiplyOp,
    STATE(246), 1,
      sym_AdditionOp,
    STATE(247), 1,
      sym_BitShiftOp,
    STATE(248), 1,
      sym_BitwiseOp,
    STATE(249), 1,
      sym_CompareOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(155), 3,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [35222] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2448), 1,
      anon_sym_COLON,
    ACTIONS(2486), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    STATE(2127), 1,
      sym_AsmOutput,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [35306] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(2488), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [35386] = 21,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(2452), 1,
      anon_sym_and,
    ACTIONS(2484), 1,
      anon_sym_or,
    ACTIONS(2492), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(245), 1,
      sym_MultiplyOp,
    STATE(246), 1,
      sym_AdditionOp,
    STATE(247), 1,
      sym_BitShiftOp,
    STATE(248), 1,
      sym_BitwiseOp,
    STATE(249), 1,
      sym_CompareOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2490), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [35468] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2448), 1,
      anon_sym_COLON,
    ACTIONS(2494), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    STATE(2113), 1,
      sym_AsmOutput,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [35552] = 8,
    ACTIONS(137), 1,
      sym_line_comment,
    STATE(245), 1,
      sym_MultiplyOp,
    STATE(246), 1,
      sym_AdditionOp,
    STATE(247), 1,
      sym_BitShiftOp,
    STATE(248), 1,
      sym_BitwiseOp,
    STATE(249), 1,
      sym_CompareOp,
    ACTIONS(1074), 9,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1072), 24,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [35608] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2496), 1,
      anon_sym_COMMA,
    ACTIONS(2498), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    STATE(2005), 1,
      aux_sym_InitList_repeat2,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [35692] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2500), 1,
      anon_sym_COMMA,
    ACTIONS(2502), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    STATE(1969), 1,
      aux_sym_InitList_repeat2,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [35776] = 21,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2506), 1,
      anon_sym_DOT_DOT,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2504), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [35858] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2508), 1,
      anon_sym_COMMA,
    ACTIONS(2510), 1,
      anon_sym_RBRACE,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    STATE(1889), 1,
      aux_sym_InitList_repeat2,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [35942] = 12,
    ACTIONS(137), 1,
      sym_line_comment,
    STATE(245), 1,
      sym_MultiplyOp,
    STATE(246), 1,
      sym_AdditionOp,
    STATE(247), 1,
      sym_BitShiftOp,
    STATE(248), 1,
      sym_BitwiseOp,
    STATE(249), 1,
      sym_CompareOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1074), 5,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
    ACTIONS(1072), 14,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
  [36006] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2512), 1,
      anon_sym_COMMA,
    ACTIONS(2514), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    STATE(1895), 1,
      aux_sym_InitList_repeat2,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [36090] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2516), 1,
      anon_sym_COMMA,
    ACTIONS(2518), 1,
      anon_sym_RBRACE,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    STATE(1990), 1,
      aux_sym_InitList_repeat2,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [36174] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2448), 1,
      anon_sym_COLON,
    ACTIONS(2520), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    STATE(2184), 1,
      sym_AsmOutput,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [36258] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(2452), 1,
      anon_sym_and,
    ACTIONS(2484), 1,
      anon_sym_or,
    STATE(245), 1,
      sym_MultiplyOp,
    STATE(246), 1,
      sym_AdditionOp,
    STATE(247), 1,
      sym_BitShiftOp,
    STATE(248), 1,
      sym_BitwiseOp,
    STATE(249), 1,
      sym_CompareOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1080), 3,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [36338] = 14,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    STATE(245), 1,
      sym_MultiplyOp,
    STATE(246), 1,
      sym_AdditionOp,
    STATE(247), 1,
      sym_BitShiftOp,
    STATE(248), 1,
      sym_BitwiseOp,
    STATE(249), 1,
      sym_CompareOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1074), 4,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1072), 12,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
  [36406] = 17,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    STATE(245), 1,
      sym_MultiplyOp,
    STATE(246), 1,
      sym_AdditionOp,
    STATE(247), 1,
      sym_BitShiftOp,
    STATE(248), 1,
      sym_BitwiseOp,
    STATE(249), 1,
      sym_CompareOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1074), 3,
      anon_sym_or,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
    ACTIONS(1072), 8,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [36480] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2391), 1,
      anon_sym_RBRACK,
    ACTIONS(2393), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2522), 1,
      anon_sym_COLON,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [36564] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2524), 1,
      anon_sym_COMMA,
    ACTIONS(2526), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    STATE(1996), 1,
      aux_sym_InitList_repeat2,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [36648] = 22,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2448), 1,
      anon_sym_COLON,
    ACTIONS(2528), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    STATE(2165), 1,
      sym_AsmOutput,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [36732] = 19,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1074), 1,
      anon_sym_or,
    ACTIONS(1818), 1,
      anon_sym_catch,
    STATE(245), 1,
      sym_MultiplyOp,
    STATE(246), 1,
      sym_AdditionOp,
    STATE(247), 1,
      sym_BitShiftOp,
    STATE(248), 1,
      sym_BitwiseOp,
    STATE(249), 1,
      sym_CompareOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1072), 4,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [36810] = 21,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2530), 1,
      anon_sym_RBRACK,
    ACTIONS(2532), 1,
      anon_sym_DOT_DOT,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [36891] = 21,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2534), 1,
      anon_sym_RBRACK,
    ACTIONS(2536), 1,
      anon_sym_DOT_DOT,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [36972] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2538), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [37051] = 21,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2540), 1,
      anon_sym_RBRACK,
    ACTIONS(2542), 1,
      anon_sym_DOT_DOT,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [37132] = 21,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2544), 1,
      anon_sym_RBRACK,
    ACTIONS(2546), 1,
      anon_sym_DOT_DOT,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [37213] = 21,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2548), 1,
      anon_sym_RBRACK,
    ACTIONS(2550), 1,
      anon_sym_DOT_DOT,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [37294] = 21,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2552), 1,
      anon_sym_RBRACK,
    ACTIONS(2554), 1,
      anon_sym_DOT_DOT,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [37375] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2556), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [37454] = 21,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2558), 1,
      anon_sym_COLON,
    ACTIONS(2560), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [37535] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1814), 1,
      anon_sym_or,
    ACTIONS(1816), 1,
      anon_sym_and,
    ACTIONS(1818), 1,
      anon_sym_catch,
    STATE(307), 1,
      sym_CompareOp,
    STATE(308), 1,
      sym_BitwiseOp,
    STATE(310), 1,
      sym_BitShiftOp,
    STATE(315), 1,
      sym_AdditionOp,
    STATE(316), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2446), 2,
      anon_sym_SEMI,
      anon_sym_else,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [37614] = 21,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2562), 1,
      anon_sym_COLON,
    ACTIONS(2564), 1,
      anon_sym_RBRACK,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [37695] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2566), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [37774] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_RBRACK,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [37852] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2568), 1,
      anon_sym_SEMI,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [37930] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2570), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [38008] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2572), 1,
      anon_sym_SEMI,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [38086] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2574), 1,
      anon_sym_RBRACK,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [38164] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2576), 1,
      anon_sym_SEMI,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [38242] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2578), 1,
      anon_sym_SEMI,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [38320] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2580), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [38398] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2582), 1,
      anon_sym_COLON,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [38476] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2584), 1,
      anon_sym_SEMI,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [38554] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2586), 1,
      anon_sym_RBRACK,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [38632] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2588), 1,
      anon_sym_RBRACK,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [38710] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2590), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [38788] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2592), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [38866] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2594), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [38944] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2596), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [39022] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2598), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [39100] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2600), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [39178] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2602), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [39256] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2404), 1,
      anon_sym_RBRACK,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [39334] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2604), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [39412] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2606), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [39490] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2608), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [39568] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2610), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [39646] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2612), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [39724] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2614), 1,
      anon_sym_SEMI,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [39802] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2616), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [39880] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2618), 1,
      anon_sym_RBRACK,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [39958] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2620), 1,
      anon_sym_COLON,
    STATE(1664), 1,
      sym_BreakLabel,
    ACTIONS(101), 9,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(87), 25,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [40006] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2622), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [40084] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2624), 1,
      anon_sym_SEMI,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [40162] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2626), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [40240] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2628), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [40318] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2630), 1,
      anon_sym_SEMI,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [40396] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2632), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [40474] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2634), 1,
      anon_sym_SEMI,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [40552] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2636), 1,
      anon_sym_SEMI,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [40630] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2638), 1,
      anon_sym_SEMI,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [40708] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2640), 1,
      anon_sym_SEMI,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [40786] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2642), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [40864] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2398), 1,
      anon_sym_LBRACE,
    STATE(1663), 1,
      sym_InitList,
    ACTIONS(1041), 9,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1039), 25,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [40912] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2644), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [40990] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2646), 1,
      anon_sym_SEMI,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [41068] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2648), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [41146] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2650), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [41224] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2652), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [41302] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2654), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [41380] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2656), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [41458] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2658), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [41536] = 20,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1015), 1,
      anon_sym_PIPE,
    ACTIONS(1027), 1,
      anon_sym_LT_LT,
    ACTIONS(1818), 1,
      anon_sym_catch,
    ACTIONS(1858), 1,
      anon_sym_or,
    ACTIONS(1860), 1,
      anon_sym_and,
    ACTIONS(2660), 1,
      anon_sym_RPAREN,
    STATE(202), 1,
      sym_CompareOp,
    STATE(203), 1,
      sym_BitwiseOp,
    STATE(204), 1,
      sym_BitShiftOp,
    STATE(205), 1,
      sym_AdditionOp,
    STATE(206), 1,
      sym_MultiplyOp,
    ACTIONS(1017), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1021), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1029), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
    ACTIONS(1031), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1023), 3,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
    ACTIONS(1019), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1033), 5,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
    ACTIONS(1035), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [41614] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1581), 9,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1579), 25,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [41656] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1585), 9,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1583), 25,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [41698] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1615), 9,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1613), 25,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [41740] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1575), 9,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1573), 25,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [41782] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(578), 9,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(576), 25,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [41824] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1641), 9,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1639), 25,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [41866] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1591), 9,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1589), 25,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [41908] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1645), 9,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1643), 25,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [41950] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1629), 9,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1627), 25,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [41992] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1611), 9,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(1609), 25,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [42034] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(157), 9,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(155), 25,
      anon_sym_COMMA,
      anon_sym_else,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [42076] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2665), 9,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_LT_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(2662), 24,
      anon_sym_COMMA,
      anon_sym_and,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_orelse,
      anon_sym_catch,
      anon_sym_GT_GT,
      anon_sym_LT_LT_PIPE,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_PERCENT,
      anon_sym_DASH_PERCENT,
      anon_sym_PLUS_PIPE,
      anon_sym_DASH_PIPE,
      anon_sym_PIPE_PIPE,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_STAR_PERCENT,
      anon_sym_STAR_PIPE,
  [42117] = 14,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(351), 1,
      anon_sym_LBRACE,
    ACTIONS(2668), 1,
      anon_sym_inline,
    ACTIONS(2670), 1,
      anon_sym_while,
    ACTIONS(2672), 1,
      anon_sym_for,
    STATE(57), 1,
      sym_Block,
    STATE(115), 1,
      sym_WhilePrefix,
    STATE(119), 1,
      sym_ForPrefix,
    STATE(1005), 1,
      sym_LoopTypeExpr,
    STATE(1153), 1,
      sym_LoopStatement,
    STATE(1289), 1,
      sym_LoopExpr,
    STATE(1015), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    STATE(1126), 2,
      sym_ForStatement,
      sym_WhileStatement,
    STATE(1294), 2,
      sym_ForExpr,
      sym_WhileExpr,
  [42163] = 13,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(2674), 1,
      anon_sym_threadlocal,
    ACTIONS(2676), 1,
      anon_sym_fn,
    ACTIONS(2682), 1,
      anon_sym_opaque,
    ACTIONS(2684), 1,
      anon_sym_union,
    STATE(1256), 1,
      sym__ContainerDeclAuto,
    STATE(1380), 1,
      sym_VarDecl,
    STATE(1761), 1,
      sym_STRINGLITERALSINGLE,
    STATE(2008), 1,
      sym_FnProto,
    STATE(2115), 1,
      sym_ContainerDeclType,
    ACTIONS(2678), 2,
      anon_sym_const,
      anon_sym_var,
    ACTIONS(2680), 2,
      anon_sym_struct,
      anon_sym_enum,
  [42205] = 8,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1745), 1,
      anon_sym_DOT,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1749), 1,
      anon_sym_LBRACK,
    ACTIONS(2686), 1,
      anon_sym_COLON,
    ACTIONS(1751), 2,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    ACTIONS(941), 3,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_RPAREN,
    STATE(934), 4,
      sym_FieldOrFnCall,
      sym_SuffixOp,
      sym_FnCallArguments,
      aux_sym_SuffixExpr_repeat1,
  [42236] = 12,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(351), 1,
      anon_sym_LBRACE,
    ACTIONS(2670), 1,
      anon_sym_while,
    ACTIONS(2672), 1,
      anon_sym_for,
    ACTIONS(2688), 1,
      anon_sym_inline,
    STATE(58), 1,
      sym_Block,
    STATE(252), 1,
      sym_ForPrefix,
    STATE(265), 1,
      sym_WhilePrefix,
    STATE(1005), 1,
      sym_LoopTypeExpr,
    STATE(1289), 1,
      sym_LoopExpr,
    STATE(1015), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    STATE(1294), 2,
      sym_ForExpr,
      sym_WhileExpr,
  [42275] = 11,
    ACTIONS(111), 1,
      anon_sym_LBRACE,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2670), 1,
      anon_sym_while,
    ACTIONS(2672), 1,
      anon_sym_for,
    ACTIONS(2688), 1,
      anon_sym_inline,
    STATE(252), 1,
      sym_ForPrefix,
    STATE(265), 1,
      sym_WhilePrefix,
    STATE(1289), 1,
      sym_LoopExpr,
    STATE(1005), 2,
      sym_Block,
      sym_LoopTypeExpr,
    STATE(1015), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    STATE(1294), 2,
      sym_ForExpr,
      sym_WhileExpr,
  [42312] = 11,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(2670), 1,
      anon_sym_while,
    ACTIONS(2672), 1,
      anon_sym_for,
    ACTIONS(2690), 1,
      anon_sym_inline,
    STATE(177), 1,
      sym_WhilePrefix,
    STATE(193), 1,
      sym_ForPrefix,
    STATE(1664), 1,
      sym_LoopExpr,
    STATE(1508), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    STATE(1531), 2,
      sym_Block,
      sym_LoopTypeExpr,
    STATE(1659), 2,
      sym_ForExpr,
      sym_WhileExpr,
  [42349] = 12,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(678), 1,
      anon_sym_LBRACE,
    ACTIONS(2670), 1,
      anon_sym_while,
    ACTIONS(2672), 1,
      anon_sym_for,
    ACTIONS(2692), 1,
      anon_sym_inline,
    STATE(41), 1,
      sym_Block,
    STATE(314), 1,
      sym_WhilePrefix,
    STATE(321), 1,
      sym_ForPrefix,
    STATE(1005), 1,
      sym_LoopTypeExpr,
    STATE(1289), 1,
      sym_LoopExpr,
    STATE(1015), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    STATE(1294), 2,
      sym_ForExpr,
      sym_WhileExpr,
  [42388] = 8,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1745), 1,
      anon_sym_DOT,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1749), 1,
      anon_sym_LBRACK,
    ACTIONS(2694), 1,
      anon_sym_COLON,
    ACTIONS(1751), 2,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    ACTIONS(941), 3,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_RPAREN,
    STATE(934), 4,
      sym_FieldOrFnCall,
      sym_SuffixOp,
      sym_FnCallArguments,
      aux_sym_SuffixExpr_repeat1,
  [42419] = 11,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(241), 1,
      anon_sym_LBRACE,
    ACTIONS(2670), 1,
      anon_sym_while,
    ACTIONS(2672), 1,
      anon_sym_for,
    ACTIONS(2696), 1,
      anon_sym_inline,
    STATE(297), 1,
      sym_WhilePrefix,
    STATE(298), 1,
      sym_ForPrefix,
    STATE(682), 1,
      sym_LoopExpr,
    STATE(555), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    STATE(564), 2,
      sym_Block,
      sym_LoopTypeExpr,
    STATE(678), 2,
      sym_ForExpr,
      sym_WhileExpr,
  [42456] = 8,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1745), 1,
      anon_sym_DOT,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    ACTIONS(1749), 1,
      anon_sym_LBRACK,
    ACTIONS(2698), 1,
      anon_sym_COLON,
    ACTIONS(1751), 2,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
    ACTIONS(941), 3,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_RPAREN,
    STATE(934), 4,
      sym_FieldOrFnCall,
      sym_SuffixOp,
      sym_FnCallArguments,
      aux_sym_SuffixExpr_repeat1,
  [42487] = 11,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(189), 1,
      anon_sym_LBRACE,
    ACTIONS(2670), 1,
      anon_sym_while,
    ACTIONS(2672), 1,
      anon_sym_for,
    ACTIONS(2700), 1,
      anon_sym_inline,
    STATE(271), 1,
      sym_ForPrefix,
    STATE(272), 1,
      sym_WhilePrefix,
    STATE(670), 1,
      sym_LoopExpr,
    STATE(469), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    STATE(477), 2,
      sym_Block,
      sym_LoopTypeExpr,
    STATE(671), 2,
      sym_ForExpr,
      sym_WhileExpr,
  [42524] = 11,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(2670), 1,
      anon_sym_while,
    ACTIONS(2672), 1,
      anon_sym_for,
    ACTIONS(2702), 1,
      anon_sym_inline,
    STATE(174), 1,
      sym_ForPrefix,
    STATE(175), 1,
      sym_WhilePrefix,
    STATE(1664), 1,
      sym_LoopExpr,
    STATE(1508), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    STATE(1531), 2,
      sym_Block,
      sym_LoopTypeExpr,
    STATE(1659), 2,
      sym_ForExpr,
      sym_WhileExpr,
  [42561] = 11,
    ACTIONS(111), 1,
      anon_sym_LBRACE,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2670), 1,
      anon_sym_while,
    ACTIONS(2672), 1,
      anon_sym_for,
    ACTIONS(2692), 1,
      anon_sym_inline,
    STATE(314), 1,
      sym_WhilePrefix,
    STATE(321), 1,
      sym_ForPrefix,
    STATE(1289), 1,
      sym_LoopExpr,
    STATE(1005), 2,
      sym_Block,
      sym_LoopTypeExpr,
    STATE(1015), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    STATE(1294), 2,
      sym_ForExpr,
      sym_WhileExpr,
  [42598] = 11,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2676), 1,
      anon_sym_fn,
    ACTIONS(2704), 1,
      anon_sym_export,
    ACTIONS(2706), 1,
      anon_sym_extern,
    ACTIONS(2710), 1,
      anon_sym_threadlocal,
    ACTIONS(2712), 1,
      anon_sym_usingnamespace,
    STATE(1373), 1,
      sym_Decl,
    STATE(1379), 1,
      sym_VarDecl,
    STATE(1965), 1,
      sym_FnProto,
    ACTIONS(2678), 2,
      anon_sym_const,
      anon_sym_var,
    ACTIONS(2708), 2,
      anon_sym_inline,
      anon_sym_noinline,
  [42634] = 11,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2676), 1,
      anon_sym_fn,
    ACTIONS(2704), 1,
      anon_sym_export,
    ACTIONS(2706), 1,
      anon_sym_extern,
    ACTIONS(2710), 1,
      anon_sym_threadlocal,
    ACTIONS(2712), 1,
      anon_sym_usingnamespace,
    STATE(1371), 1,
      sym_Decl,
    STATE(1379), 1,
      sym_VarDecl,
    STATE(1965), 1,
      sym_FnProto,
    ACTIONS(2678), 2,
      anon_sym_const,
      anon_sym_var,
    ACTIONS(2708), 2,
      anon_sym_inline,
      anon_sym_noinline,
  [42670] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_BSLASH,
    ACTIONS(2720), 1,
      anon_sym_DQUOTE,
    ACTIONS(2722), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2718), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2724), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1690), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [42699] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_BSLASH,
    ACTIONS(2726), 1,
      anon_sym_DQUOTE,
    ACTIONS(2728), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2718), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2730), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1683), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [42728] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_BSLASH,
    ACTIONS(2732), 1,
      anon_sym_DQUOTE,
    ACTIONS(2734), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2718), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2736), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1688), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [42757] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2738), 1,
      anon_sym_DQUOTE,
    ACTIONS(2718), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2736), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1688), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [42786] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_BSLASH,
    ACTIONS(2740), 1,
      anon_sym_DQUOTE,
    ACTIONS(2742), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2718), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2744), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1687), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [42815] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2746), 1,
      anon_sym_DQUOTE,
    ACTIONS(2718), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2736), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1688), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [42844] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2748), 1,
      anon_sym_DQUOTE,
    ACTIONS(2718), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2736), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1688), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [42873] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2750), 1,
      anon_sym_LBRACE,
    ACTIONS(2753), 1,
      anon_sym_BSLASH,
    ACTIONS(2759), 1,
      anon_sym_DQUOTE,
    ACTIONS(2761), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2756), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2764), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1688), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [42902] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2767), 1,
      anon_sym_DQUOTE,
    ACTIONS(2718), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2736), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1688), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [42931] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2769), 1,
      anon_sym_DQUOTE,
    ACTIONS(2718), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2736), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1688), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [42960] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_BSLASH,
    ACTIONS(2771), 1,
      anon_sym_DQUOTE,
    ACTIONS(2773), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2718), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2775), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1693), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [42989] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2777), 1,
      anon_sym_DQUOTE,
    ACTIONS(2718), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2736), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1688), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [43018] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2779), 1,
      anon_sym_DQUOTE,
    ACTIONS(2718), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2736), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1688), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [43047] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_BSLASH,
    ACTIONS(2781), 1,
      anon_sym_DQUOTE,
    ACTIONS(2783), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2718), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2785), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1692), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [43076] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2787), 1,
      anon_sym_DQUOTE,
    ACTIONS(2718), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2736), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1688), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [43105] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_BSLASH,
    ACTIONS(2789), 1,
      anon_sym_DQUOTE,
    ACTIONS(2791), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2718), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2793), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1695), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [43134] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_BSLASH,
    ACTIONS(2795), 1,
      anon_sym_DQUOTE,
    ACTIONS(2797), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2718), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2799), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1689), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [43163] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_BSLASH,
    ACTIONS(2801), 1,
      anon_sym_DQUOTE,
    ACTIONS(2803), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2718), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2805), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1684), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [43192] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_BSLASH,
    ACTIONS(2807), 1,
      anon_sym_DQUOTE,
    ACTIONS(2809), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2718), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2811), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1701), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [43221] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2813), 1,
      anon_sym_DQUOTE,
    ACTIONS(2718), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2736), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1688), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [43250] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2815), 1,
      anon_sym_DQUOTE,
    ACTIONS(2718), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2736), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1688), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [43279] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_BSLASH,
    ACTIONS(2817), 1,
      anon_sym_DQUOTE,
    ACTIONS(2819), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2718), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2821), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1686), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [43308] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_BSLASH,
    ACTIONS(2823), 1,
      anon_sym_DQUOTE,
    ACTIONS(2825), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2718), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2827), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1700), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [43337] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_BSLASH,
    ACTIONS(2829), 1,
      anon_sym_DQUOTE,
    ACTIONS(2831), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2718), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2833), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1705), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [43366] = 8,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_BSLASH,
    ACTIONS(2734), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2835), 1,
      anon_sym_DQUOTE,
    ACTIONS(2718), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
    ACTIONS(2736), 2,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
    STATE(1688), 3,
      sym_EscapeSequence,
      sym_FormatSequence,
      aux_sym_STRINGLITERALSINGLE_repeat1,
  [43395] = 8,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2670), 1,
      anon_sym_while,
    ACTIONS(2672), 1,
      anon_sym_for,
    STATE(115), 1,
      sym_WhilePrefix,
    STATE(119), 1,
      sym_ForPrefix,
    STATE(1011), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    STATE(1193), 2,
      sym_ForStatement,
      sym_WhileStatement,
    STATE(1300), 2,
      sym_ForExpr,
      sym_WhileExpr,
  [43423] = 9,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(241), 1,
      anon_sym_LBRACE,
    ACTIONS(2837), 1,
      anon_sym_inline,
    ACTIONS(2839), 1,
      anon_sym_while,
    ACTIONS(2841), 1,
      anon_sym_for,
    STATE(911), 1,
      sym_ForPrefix,
    STATE(912), 1,
      sym_WhilePrefix,
    STATE(555), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    STATE(564), 2,
      sym_Block,
      sym_LoopTypeExpr,
  [43453] = 9,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2839), 1,
      anon_sym_while,
    ACTIONS(2841), 1,
      anon_sym_for,
    ACTIONS(2843), 1,
      anon_sym_inline,
    ACTIONS(2845), 1,
      anon_sym_LBRACE,
    STATE(893), 1,
      sym_WhilePrefix,
    STATE(894), 1,
      sym_ForPrefix,
    STATE(1170), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    STATE(1190), 2,
      sym_Block,
      sym_LoopTypeExpr,
  [43483] = 9,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(189), 1,
      anon_sym_LBRACE,
    ACTIONS(2839), 1,
      anon_sym_while,
    ACTIONS(2841), 1,
      anon_sym_for,
    ACTIONS(2847), 1,
      anon_sym_inline,
    STATE(857), 1,
      sym_ForPrefix,
    STATE(874), 1,
      sym_WhilePrefix,
    STATE(469), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    STATE(477), 2,
      sym_Block,
      sym_LoopTypeExpr,
  [43513] = 9,
    ACTIONS(111), 1,
      anon_sym_LBRACE,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2839), 1,
      anon_sym_while,
    ACTIONS(2841), 1,
      anon_sym_for,
    ACTIONS(2849), 1,
      anon_sym_inline,
    STATE(880), 1,
      sym_WhilePrefix,
    STATE(919), 1,
      sym_ForPrefix,
    STATE(1005), 2,
      sym_Block,
      sym_LoopTypeExpr,
    STATE(1015), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
  [43543] = 9,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2839), 1,
      anon_sym_while,
    ACTIONS(2841), 1,
      anon_sym_for,
    ACTIONS(2851), 1,
      anon_sym_inline,
    ACTIONS(2853), 1,
      anon_sym_LBRACE,
    STATE(859), 1,
      sym_ForPrefix,
    STATE(883), 1,
      sym_WhilePrefix,
    STATE(1212), 2,
      sym_Block,
      sym_LoopTypeExpr,
    STATE(1238), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
  [43573] = 9,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(293), 1,
      anon_sym_LBRACE,
    ACTIONS(2839), 1,
      anon_sym_while,
    ACTIONS(2841), 1,
      anon_sym_for,
    ACTIONS(2855), 1,
      anon_sym_inline,
    STATE(826), 1,
      sym_ForPrefix,
    STATE(837), 1,
      sym_WhilePrefix,
    STATE(1508), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    STATE(1531), 2,
      sym_Block,
      sym_LoopTypeExpr,
  [43603] = 10,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2857), 1,
      anon_sym_SEMI,
    ACTIONS(2859), 1,
      anon_sym_COLON,
    ACTIONS(2861), 1,
      anon_sym_EQ,
    ACTIONS(2863), 1,
      anon_sym_linksection,
    ACTIONS(2865), 1,
      anon_sym_addrspace,
    ACTIONS(2867), 1,
      anon_sym_align,
    STATE(1752), 1,
      sym_ByteAlign,
    STATE(1833), 1,
      sym_AddrSpace,
    STATE(2094), 1,
      sym_LinkSection,
  [43634] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(548), 1,
      anon_sym_DOT,
    ACTIONS(2869), 1,
      anon_sym_COLON,
    ACTIONS(546), 7,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [43653] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(548), 1,
      anon_sym_DOT,
    ACTIONS(2871), 1,
      anon_sym_COLON,
    ACTIONS(546), 7,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [43672] = 10,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2863), 1,
      anon_sym_linksection,
    ACTIONS(2865), 1,
      anon_sym_addrspace,
    ACTIONS(2867), 1,
      anon_sym_align,
    ACTIONS(2873), 1,
      anon_sym_SEMI,
    ACTIONS(2875), 1,
      anon_sym_COLON,
    ACTIONS(2877), 1,
      anon_sym_EQ,
    STATE(1754), 1,
      sym_ByteAlign,
    STATE(1835), 1,
      sym_AddrSpace,
    STATE(2081), 1,
      sym_LinkSection,
  [43703] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(548), 1,
      anon_sym_DOT,
    ACTIONS(2879), 1,
      anon_sym_COLON,
    ACTIONS(546), 7,
      anon_sym_COMMA,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [43722] = 7,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2670), 1,
      anon_sym_while,
    ACTIONS(2672), 1,
      anon_sym_for,
    STATE(174), 1,
      sym_ForPrefix,
    STATE(175), 1,
      sym_WhilePrefix,
    STATE(1513), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    STATE(1661), 2,
      sym_ForExpr,
      sym_WhileExpr,
  [43746] = 9,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2584), 1,
      anon_sym_SEMI,
    ACTIONS(2863), 1,
      anon_sym_linksection,
    ACTIONS(2865), 1,
      anon_sym_addrspace,
    ACTIONS(2867), 1,
      anon_sym_align,
    ACTIONS(2881), 1,
      anon_sym_EQ,
    STATE(1760), 1,
      sym_ByteAlign,
    STATE(1848), 1,
      sym_AddrSpace,
    STATE(2050), 1,
      sym_LinkSection,
  [43774] = 7,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2670), 1,
      anon_sym_while,
    ACTIONS(2672), 1,
      anon_sym_for,
    STATE(252), 1,
      sym_ForPrefix,
    STATE(265), 1,
      sym_WhilePrefix,
    STATE(1011), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    STATE(1300), 2,
      sym_ForExpr,
      sym_WhileExpr,
  [43798] = 7,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2670), 1,
      anon_sym_while,
    ACTIONS(2672), 1,
      anon_sym_for,
    STATE(271), 1,
      sym_ForPrefix,
    STATE(272), 1,
      sym_WhilePrefix,
    STATE(472), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    STATE(672), 2,
      sym_ForExpr,
      sym_WhileExpr,
  [43822] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2885), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2883), 7,
      anon_sym_LBRACE,
      anon_sym_BSLASH,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DQUOTE,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
  [43838] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2889), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2887), 7,
      anon_sym_LBRACE,
      anon_sym_BSLASH,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DQUOTE,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
  [43854] = 7,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2670), 1,
      anon_sym_while,
    ACTIONS(2672), 1,
      anon_sym_for,
    STATE(177), 1,
      sym_WhilePrefix,
    STATE(193), 1,
      sym_ForPrefix,
    STATE(1513), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    STATE(1661), 2,
      sym_ForExpr,
      sym_WhileExpr,
  [43878] = 8,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2676), 1,
      anon_sym_fn,
    ACTIONS(2839), 1,
      anon_sym_while,
    ACTIONS(2841), 1,
      anon_sym_for,
    STATE(859), 1,
      sym_ForPrefix,
    STATE(883), 1,
      sym_WhilePrefix,
    STATE(2008), 1,
      sym_FnProto,
    STATE(1252), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
  [43904] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2893), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2891), 7,
      anon_sym_LBRACE,
      anon_sym_BSLASH,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DQUOTE,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
  [43920] = 7,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2670), 1,
      anon_sym_while,
    ACTIONS(2672), 1,
      anon_sym_for,
    STATE(314), 1,
      sym_WhilePrefix,
    STATE(321), 1,
      sym_ForPrefix,
    STATE(1011), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    STATE(1300), 2,
      sym_ForExpr,
      sym_WhileExpr,
  [43944] = 7,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2670), 1,
      anon_sym_while,
    ACTIONS(2672), 1,
      anon_sym_for,
    STATE(297), 1,
      sym_WhilePrefix,
    STATE(298), 1,
      sym_ForPrefix,
    STATE(559), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
    STATE(684), 2,
      sym_ForExpr,
      sym_WhileExpr,
  [43968] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2897), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2895), 7,
      anon_sym_LBRACE,
      anon_sym_BSLASH,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DQUOTE,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
  [43984] = 9,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2646), 1,
      anon_sym_SEMI,
    ACTIONS(2863), 1,
      anon_sym_linksection,
    ACTIONS(2865), 1,
      anon_sym_addrspace,
    ACTIONS(2867), 1,
      anon_sym_align,
    ACTIONS(2899), 1,
      anon_sym_EQ,
    STATE(1756), 1,
      sym_ByteAlign,
    STATE(1843), 1,
      sym_AddrSpace,
    STATE(2042), 1,
      sym_LinkSection,
  [44012] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2903), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2901), 7,
      anon_sym_LBRACE,
      anon_sym_BSLASH,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DQUOTE,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
  [44028] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2907), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2905), 7,
      anon_sym_LBRACE,
      anon_sym_BSLASH,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DQUOTE,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
  [44044] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2911), 1,
      aux_sym_STRINGLITERALSINGLE_token1,
    ACTIONS(2909), 7,
      anon_sym_LBRACE,
      anon_sym_BSLASH,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
      anon_sym_DQUOTE,
      anon_sym_LBRACE2,
      anon_sym_RBRACE2,
  [44060] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1105), 1,
      anon_sym_DOT,
    ACTIONS(2913), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1107), 5,
      anon_sym_BANG,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT_STAR,
      anon_sym_DOT_QMARK,
  [44078] = 8,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(2674), 1,
      anon_sym_threadlocal,
    ACTIONS(2676), 1,
      anon_sym_fn,
    STATE(1380), 1,
      sym_VarDecl,
    STATE(1761), 1,
      sym_STRINGLITERALSINGLE,
    STATE(2008), 1,
      sym_FnProto,
    ACTIONS(2678), 2,
      anon_sym_const,
      anon_sym_var,
  [44104] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_BSLASH_BSLASH,
    ACTIONS(2915), 1,
      anon_sym_RPAREN,
    STATE(941), 2,
      sym_LINESTRING,
      aux_sym__STRINGLITERAL_repeat1,
    STATE(1912), 2,
      sym_STRINGLITERALSINGLE,
      sym__STRINGLITERAL,
  [44125] = 7,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      anon_sym_LBRACE,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(1372), 1,
      sym_Block,
    STATE(2063), 2,
      sym_STRINGLITERALSINGLE,
      sym_IDENTIFIER,
  [44148] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_BSLASH_BSLASH,
    ACTIONS(2921), 1,
      anon_sym_RPAREN,
    STATE(941), 2,
      sym_LINESTRING,
      aux_sym__STRINGLITERAL_repeat1,
    STATE(2054), 2,
      sym_STRINGLITERALSINGLE,
      sym__STRINGLITERAL,
  [44169] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_BSLASH_BSLASH,
    ACTIONS(2923), 1,
      anon_sym_RPAREN,
    STATE(941), 2,
      sym_LINESTRING,
      aux_sym__STRINGLITERAL_repeat1,
    STATE(2054), 2,
      sym_STRINGLITERALSINGLE,
      sym__STRINGLITERAL,
  [44190] = 7,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(1701), 1,
      anon_sym_LBRACE,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(1376), 1,
      sym_Block,
    STATE(2077), 2,
      sym_STRINGLITERALSINGLE,
      sym_IDENTIFIER,
  [44213] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2682), 1,
      anon_sym_opaque,
    ACTIONS(2684), 1,
      anon_sym_union,
    STATE(1188), 1,
      sym__ContainerDeclAuto,
    STATE(2151), 1,
      sym_ContainerDeclType,
    ACTIONS(2680), 2,
      anon_sym_struct,
      anon_sym_enum,
  [44233] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2839), 1,
      anon_sym_while,
    ACTIONS(2841), 1,
      anon_sym_for,
    STATE(857), 1,
      sym_ForPrefix,
    STATE(874), 1,
      sym_WhilePrefix,
    STATE(472), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
  [44253] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_BSLASH_BSLASH,
    STATE(941), 2,
      sym_LINESTRING,
      aux_sym__STRINGLITERAL_repeat1,
    STATE(2054), 2,
      sym_STRINGLITERALSINGLE,
      sym__STRINGLITERAL,
  [44271] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2839), 1,
      anon_sym_while,
    ACTIONS(2841), 1,
      anon_sym_for,
    STATE(859), 1,
      sym_ForPrefix,
    STATE(883), 1,
      sym_WhilePrefix,
    STATE(1252), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
  [44291] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2682), 1,
      anon_sym_opaque,
    ACTIONS(2684), 1,
      anon_sym_union,
    STATE(1256), 1,
      sym__ContainerDeclAuto,
    STATE(2115), 1,
      sym_ContainerDeclType,
    ACTIONS(2680), 2,
      anon_sym_struct,
      anon_sym_enum,
  [44311] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2682), 1,
      anon_sym_opaque,
    ACTIONS(2684), 1,
      anon_sym_union,
    STATE(1012), 1,
      sym__ContainerDeclAuto,
    STATE(2119), 1,
      sym_ContainerDeclType,
    ACTIONS(2680), 2,
      anon_sym_struct,
      anon_sym_enum,
  [44331] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2682), 1,
      anon_sym_opaque,
    ACTIONS(2684), 1,
      anon_sym_union,
    STATE(471), 1,
      sym__ContainerDeclAuto,
    STATE(2169), 1,
      sym_ContainerDeclType,
    ACTIONS(2680), 2,
      anon_sym_struct,
      anon_sym_enum,
  [44351] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2839), 1,
      anon_sym_while,
    ACTIONS(2841), 1,
      anon_sym_for,
    STATE(911), 1,
      sym_ForPrefix,
    STATE(912), 1,
      sym_WhilePrefix,
    STATE(559), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
  [44371] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_BSLASH_BSLASH,
    STATE(941), 2,
      sym_LINESTRING,
      aux_sym__STRINGLITERAL_repeat1,
    STATE(2203), 2,
      sym_STRINGLITERALSINGLE,
      sym__STRINGLITERAL,
  [44389] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2674), 1,
      anon_sym_threadlocal,
    ACTIONS(2676), 1,
      anon_sym_fn,
    STATE(1380), 1,
      sym_VarDecl,
    STATE(2008), 1,
      sym_FnProto,
    ACTIONS(2678), 2,
      anon_sym_const,
      anon_sym_var,
  [44409] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2839), 1,
      anon_sym_while,
    ACTIONS(2841), 1,
      anon_sym_for,
    STATE(893), 1,
      sym_WhilePrefix,
    STATE(894), 1,
      sym_ForPrefix,
    STATE(1114), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
  [44429] = 7,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2863), 1,
      anon_sym_linksection,
    ACTIONS(2865), 1,
      anon_sym_addrspace,
    ACTIONS(2925), 1,
      anon_sym_SEMI,
    ACTIONS(2927), 1,
      anon_sym_EQ,
    STATE(1839), 1,
      sym_AddrSpace,
    STATE(2053), 1,
      sym_LinkSection,
  [44451] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2839), 1,
      anon_sym_while,
    ACTIONS(2841), 1,
      anon_sym_for,
    STATE(826), 1,
      sym_ForPrefix,
    STATE(837), 1,
      sym_WhilePrefix,
    STATE(1513), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
  [44471] = 7,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2863), 1,
      anon_sym_linksection,
    ACTIONS(2865), 1,
      anon_sym_addrspace,
    ACTIONS(2929), 1,
      anon_sym_SEMI,
    ACTIONS(2931), 1,
      anon_sym_EQ,
    STATE(1841), 1,
      sym_AddrSpace,
    STATE(2022), 1,
      sym_LinkSection,
  [44493] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2839), 1,
      anon_sym_while,
    ACTIONS(2841), 1,
      anon_sym_for,
    STATE(880), 1,
      sym_WhilePrefix,
    STATE(919), 1,
      sym_ForPrefix,
    STATE(1011), 2,
      sym_ForTypeExpr,
      sym_WhileTypeExpr,
  [44513] = 7,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2630), 1,
      anon_sym_SEMI,
    ACTIONS(2863), 1,
      anon_sym_linksection,
    ACTIONS(2865), 1,
      anon_sym_addrspace,
    ACTIONS(2933), 1,
      anon_sym_EQ,
    STATE(1844), 1,
      sym_AddrSpace,
    STATE(2049), 1,
      sym_LinkSection,
  [44535] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_BSLASH_BSLASH,
    STATE(941), 2,
      sym_LINESTRING,
      aux_sym__STRINGLITERAL_repeat1,
    STATE(2147), 2,
      sym_STRINGLITERALSINGLE,
      sym__STRINGLITERAL,
  [44553] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2682), 1,
      anon_sym_opaque,
    ACTIONS(2684), 1,
      anon_sym_union,
    STATE(1512), 1,
      sym__ContainerDeclAuto,
    STATE(2175), 1,
      sym_ContainerDeclType,
    ACTIONS(2680), 2,
      anon_sym_struct,
      anon_sym_enum,
  [44573] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2682), 1,
      anon_sym_opaque,
    ACTIONS(2684), 1,
      anon_sym_union,
    STATE(558), 1,
      sym__ContainerDeclAuto,
    STATE(2161), 1,
      sym_ContainerDeclType,
    ACTIONS(2680), 2,
      anon_sym_struct,
      anon_sym_enum,
  [44593] = 7,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2614), 1,
      anon_sym_SEMI,
    ACTIONS(2863), 1,
      anon_sym_linksection,
    ACTIONS(2865), 1,
      anon_sym_addrspace,
    ACTIONS(2935), 1,
      anon_sym_EQ,
    STATE(1840), 1,
      sym_AddrSpace,
    STATE(2026), 1,
      sym_LinkSection,
  [44615] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2676), 1,
      anon_sym_fn,
    ACTIONS(2937), 1,
      anon_sym_threadlocal,
    STATE(1381), 1,
      sym_VarDecl,
    STATE(2004), 1,
      sym_FnProto,
    ACTIONS(2678), 2,
      anon_sym_const,
      anon_sym_var,
  [44635] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2398), 1,
      anon_sym_LBRACE,
    ACTIONS(2939), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2941), 1,
      anon_sym_AT,
    STATE(1521), 1,
      sym_InitList,
    STATE(1522), 1,
      sym_IDENTIFIER,
  [44654] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2943), 1,
      anon_sym_RBRACE,
    ACTIONS(2945), 1,
      sym_doc_comment,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [44673] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      sym_doc_comment,
    ACTIONS(2947), 1,
      anon_sym_RBRACE,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [44692] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      sym_doc_comment,
    ACTIONS(2949), 1,
      anon_sym_RBRACE,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [44711] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      sym_doc_comment,
    ACTIONS(2951), 1,
      anon_sym_RBRACE,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [44730] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2953), 1,
      anon_sym_RBRACE,
    ACTIONS(2955), 1,
      sym_doc_comment,
    STATE(1882), 1,
      sym_IDENTIFIER,
  [44749] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2957), 1,
      anon_sym_LPAREN,
    STATE(628), 1,
      sym_ParamDeclList,
    STATE(2098), 1,
      sym_IDENTIFIER,
  [44768] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      sym_doc_comment,
    ACTIONS(2959), 1,
      anon_sym_RBRACE,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [44787] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      sym_doc_comment,
    ACTIONS(2961), 1,
      anon_sym_RBRACE,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [44806] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2963), 1,
      anon_sym_COLON,
    ACTIONS(2965), 1,
      anon_sym_RPAREN,
    ACTIONS(2967), 1,
      anon_sym_LBRACK,
    STATE(1995), 1,
      sym_AsmInputItem,
    STATE(2131), 1,
      sym_AsmClobbers,
  [44825] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      sym_doc_comment,
    ACTIONS(2969), 1,
      anon_sym_RBRACE,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [44844] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      sym_doc_comment,
    ACTIONS(2971), 1,
      anon_sym_RBRACE,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [44863] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      sym_doc_comment,
    ACTIONS(2973), 1,
      anon_sym_RBRACE,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [44882] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2957), 1,
      anon_sym_LPAREN,
    STATE(624), 1,
      sym_ParamDeclList,
    STATE(2039), 1,
      sym_IDENTIFIER,
  [44901] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2963), 1,
      anon_sym_COLON,
    ACTIONS(2967), 1,
      anon_sym_LBRACK,
    ACTIONS(2975), 1,
      anon_sym_RPAREN,
    STATE(1995), 1,
      sym_AsmInputItem,
    STATE(2189), 1,
      sym_AsmClobbers,
  [44920] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      sym_doc_comment,
    ACTIONS(2977), 1,
      anon_sym_RBRACE,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [44939] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2979), 1,
      anon_sym_PIPE,
    ACTIONS(2981), 1,
      anon_sym_STAR,
    STATE(2057), 1,
      sym_IDENTIFIER,
  [44958] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2983), 1,
      anon_sym_RBRACE,
    ACTIONS(2985), 1,
      sym_doc_comment,
    STATE(1979), 1,
      sym_IDENTIFIER,
  [44977] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2957), 1,
      anon_sym_LPAREN,
    STATE(627), 1,
      sym_ParamDeclList,
    STATE(2076), 1,
      sym_IDENTIFIER,
  [44996] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2987), 1,
      anon_sym_RBRACE,
    ACTIONS(2989), 1,
      sym_doc_comment,
    STATE(1929), 1,
      sym_IDENTIFIER,
  [45015] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      sym_doc_comment,
    ACTIONS(2991), 1,
      anon_sym_RBRACE,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [45034] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      sym_doc_comment,
    ACTIONS(2993), 1,
      anon_sym_RBRACE,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [45053] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2995), 1,
      anon_sym_RBRACE,
    ACTIONS(2997), 1,
      sym_doc_comment,
    STATE(1987), 1,
      sym_IDENTIFIER,
  [45072] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2981), 1,
      anon_sym_STAR,
    ACTIONS(2999), 1,
      anon_sym_PIPE,
    STATE(2057), 1,
      sym_IDENTIFIER,
  [45091] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2963), 1,
      anon_sym_COLON,
    ACTIONS(2975), 1,
      anon_sym_RPAREN,
    ACTIONS(3001), 1,
      anon_sym_COMMA,
    STATE(1849), 1,
      aux_sym_AsmInput_repeat1,
    STATE(2189), 1,
      sym_AsmClobbers,
  [45110] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2981), 1,
      anon_sym_STAR,
    ACTIONS(3003), 1,
      anon_sym_PIPE,
    STATE(2057), 1,
      sym_IDENTIFIER,
  [45129] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      sym_doc_comment,
    ACTIONS(3005), 1,
      anon_sym_RBRACE,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [45148] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3007), 1,
      anon_sym_COMMA,
    ACTIONS(3009), 1,
      anon_sym_COLON,
    ACTIONS(3011), 1,
      anon_sym_RPAREN,
    STATE(1817), 1,
      aux_sym_AsmOutput_repeat1,
    STATE(2197), 1,
      sym_AsmInput,
  [45167] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3009), 1,
      anon_sym_COLON,
    ACTIONS(3013), 1,
      anon_sym_RPAREN,
    ACTIONS(3015), 1,
      anon_sym_LBRACK,
    STATE(1789), 1,
      sym_AsmOutputItem,
    STATE(2150), 1,
      sym_AsmInput,
  [45186] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      sym_doc_comment,
    ACTIONS(3017), 1,
      anon_sym_RBRACE,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [45205] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2963), 1,
      anon_sym_COLON,
    ACTIONS(2967), 1,
      anon_sym_LBRACK,
    ACTIONS(3019), 1,
      anon_sym_RPAREN,
    STATE(1812), 1,
      sym_AsmInputItem,
    STATE(2195), 1,
      sym_AsmClobbers,
  [45224] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2981), 1,
      anon_sym_STAR,
    ACTIONS(3021), 1,
      anon_sym_PIPE,
    STATE(2057), 1,
      sym_IDENTIFIER,
  [45243] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      sym_doc_comment,
    ACTIONS(3023), 1,
      anon_sym_RBRACE,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [45262] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1045), 1,
      anon_sym_LBRACE,
    ACTIONS(3025), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(3027), 1,
      anon_sym_AT,
    STATE(473), 1,
      sym_InitList,
    STATE(474), 1,
      sym_IDENTIFIER,
  [45281] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2981), 1,
      anon_sym_STAR,
    ACTIONS(3029), 1,
      anon_sym_PIPE,
    STATE(2057), 1,
      sym_IDENTIFIER,
  [45300] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2981), 1,
      anon_sym_STAR,
    ACTIONS(3031), 1,
      anon_sym_PIPE,
    STATE(2057), 1,
      sym_IDENTIFIER,
  [45319] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2957), 1,
      anon_sym_LPAREN,
    STATE(635), 1,
      sym_ParamDeclList,
    STATE(2031), 1,
      sym_IDENTIFIER,
  [45338] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2981), 1,
      anon_sym_STAR,
    ACTIONS(3033), 1,
      anon_sym_PIPE,
    STATE(2057), 1,
      sym_IDENTIFIER,
  [45357] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(3035), 1,
      anon_sym_RBRACE,
    ACTIONS(3037), 1,
      sym_doc_comment,
    STATE(1859), 1,
      sym_IDENTIFIER,
  [45376] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2981), 1,
      anon_sym_STAR,
    ACTIONS(3039), 1,
      anon_sym_PIPE,
    STATE(2057), 1,
      sym_IDENTIFIER,
  [45395] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      sym_doc_comment,
    ACTIONS(3041), 1,
      anon_sym_RBRACE,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [45414] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      sym_doc_comment,
    ACTIONS(3043), 1,
      anon_sym_RBRACE,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [45433] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      sym_doc_comment,
    ACTIONS(3045), 1,
      anon_sym_RBRACE,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [45452] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2957), 1,
      anon_sym_LPAREN,
    STATE(625), 1,
      sym_ParamDeclList,
    STATE(2044), 1,
      sym_IDENTIFIER,
  [45471] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      sym_doc_comment,
    ACTIONS(3047), 1,
      anon_sym_RBRACE,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [45490] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1764), 1,
      anon_sym_LBRACE,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(1000), 1,
      sym_InitList,
    STATE(1008), 1,
      sym_IDENTIFIER,
  [45509] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3009), 1,
      anon_sym_COLON,
    ACTIONS(3015), 1,
      anon_sym_LBRACK,
    ACTIONS(3049), 1,
      anon_sym_RPAREN,
    STATE(1930), 1,
      sym_AsmOutputItem,
    STATE(2123), 1,
      sym_AsmInput,
  [45528] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(3051), 1,
      aux_sym_CHAR_LITERAL_token1,
    ACTIONS(3053), 1,
      anon_sym_BSLASH,
    STATE(2183), 1,
      sym_EscapeSequence,
    ACTIONS(3055), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
  [45545] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      sym_doc_comment,
    ACTIONS(3057), 1,
      anon_sym_RBRACE,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [45564] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(3053), 1,
      anon_sym_BSLASH,
    ACTIONS(3059), 1,
      aux_sym_CHAR_LITERAL_token1,
    STATE(2194), 1,
      sym_EscapeSequence,
    ACTIONS(3055), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
  [45581] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2963), 1,
      anon_sym_COLON,
    ACTIONS(3061), 1,
      anon_sym_COMMA,
    ACTIONS(3063), 1,
      anon_sym_RPAREN,
    STATE(1786), 1,
      aux_sym_AsmInput_repeat1,
    STATE(2108), 1,
      sym_AsmClobbers,
  [45600] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      sym_doc_comment,
    ACTIONS(3065), 1,
      anon_sym_RBRACE,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [45619] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(3053), 1,
      anon_sym_BSLASH,
    ACTIONS(3067), 1,
      aux_sym_CHAR_LITERAL_token1,
    STATE(2135), 1,
      sym_EscapeSequence,
    ACTIONS(3055), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
  [45636] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3009), 1,
      anon_sym_COLON,
    ACTIONS(3015), 1,
      anon_sym_LBRACK,
    ACTIONS(3069), 1,
      anon_sym_RPAREN,
    STATE(1930), 1,
      sym_AsmOutputItem,
    STATE(2109), 1,
      sym_AsmInput,
  [45655] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1125), 1,
      anon_sym_LBRACE,
    ACTIONS(3071), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(3073), 1,
      anon_sym_AT,
    STATE(560), 1,
      sym_InitList,
    STATE(561), 1,
      sym_IDENTIFIER,
  [45674] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3009), 1,
      anon_sym_COLON,
    ACTIONS(3069), 1,
      anon_sym_RPAREN,
    ACTIONS(3075), 1,
      anon_sym_COMMA,
    STATE(1836), 1,
      aux_sym_AsmOutput_repeat1,
    STATE(2109), 1,
      sym_AsmInput,
  [45693] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(3077), 1,
      anon_sym_RBRACE,
    ACTIONS(3079), 1,
      sym_doc_comment,
    STATE(1940), 1,
      sym_IDENTIFIER,
  [45712] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1764), 1,
      anon_sym_LBRACE,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(1000), 1,
      sym_InitList,
    STATE(1535), 1,
      sym_IDENTIFIER,
  [45731] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      sym_doc_comment,
    ACTIONS(3081), 1,
      anon_sym_RBRACE,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [45750] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3083), 1,
      anon_sym_LBRACE,
    ACTIONS(3085), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(3087), 1,
      anon_sym_AT,
    STATE(1223), 1,
      sym_IDENTIFIER,
    STATE(1242), 1,
      sym_InitList,
  [45769] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      sym_doc_comment,
    ACTIONS(3089), 1,
      anon_sym_RBRACE,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [45788] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(3053), 1,
      anon_sym_BSLASH,
    ACTIONS(3091), 1,
      aux_sym_CHAR_LITERAL_token1,
    STATE(2105), 1,
      sym_EscapeSequence,
    ACTIONS(3055), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
  [45805] = 6,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      sym_doc_comment,
    ACTIONS(3093), 1,
      anon_sym_RBRACE,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [45824] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(3053), 1,
      anon_sym_BSLASH,
    ACTIONS(3095), 1,
      aux_sym_CHAR_LITERAL_token1,
    STATE(2157), 1,
      sym_EscapeSequence,
    ACTIONS(3055), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
  [45841] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2957), 1,
      anon_sym_LPAREN,
    STATE(638), 1,
      sym_ParamDeclList,
    STATE(2062), 1,
      sym_IDENTIFIER,
  [45860] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(3053), 1,
      anon_sym_BSLASH,
    ACTIONS(3097), 1,
      aux_sym_CHAR_LITERAL_token1,
    STATE(2162), 1,
      sym_EscapeSequence,
    ACTIONS(3055), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_RBRACE_RBRACE,
  [45877] = 6,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3099), 1,
      anon_sym_LBRACE,
    ACTIONS(3101), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(3103), 1,
      anon_sym_AT,
    STATE(1195), 1,
      sym_IDENTIFIER,
    STATE(1196), 1,
      sym_InitList,
  [45896] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(3105), 1,
      anon_sym_STAR,
    STATE(1957), 1,
      sym_IDENTIFIER,
  [45912] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(3107), 1,
      anon_sym_STAR,
    STATE(1982), 1,
      sym_IDENTIFIER,
  [45928] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(3109), 1,
      anon_sym_STAR,
    STATE(2191), 1,
      sym_IDENTIFIER,
  [45944] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(3111), 1,
      anon_sym_STAR,
    STATE(2154), 1,
      sym_IDENTIFIER,
  [45960] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2863), 1,
      anon_sym_linksection,
    ACTIONS(2925), 1,
      anon_sym_SEMI,
    ACTIONS(2927), 1,
      anon_sym_EQ,
    STATE(2053), 1,
      sym_LinkSection,
  [45976] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(3113), 1,
      anon_sym_DASH_GT,
    STATE(2114), 1,
      sym_IDENTIFIER,
  [45992] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2863), 1,
      anon_sym_linksection,
    ACTIONS(2929), 1,
      anon_sym_SEMI,
    ACTIONS(2931), 1,
      anon_sym_EQ,
    STATE(2022), 1,
      sym_LinkSection,
  [46008] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3115), 1,
      anon_sym_COMMA,
    STATE(1836), 1,
      aux_sym_AsmOutput_repeat1,
    ACTIONS(3118), 2,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [46022] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(3120), 1,
      anon_sym_STAR,
    STATE(2045), 1,
      sym_IDENTIFIER,
  [46038] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2981), 1,
      anon_sym_STAR,
    STATE(2057), 1,
      sym_IDENTIFIER,
  [46054] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2584), 1,
      anon_sym_SEMI,
    ACTIONS(2863), 1,
      anon_sym_linksection,
    ACTIONS(2881), 1,
      anon_sym_EQ,
    STATE(2050), 1,
      sym_LinkSection,
  [46070] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2624), 1,
      anon_sym_SEMI,
    ACTIONS(2863), 1,
      anon_sym_linksection,
    ACTIONS(3122), 1,
      anon_sym_EQ,
    STATE(2023), 1,
      sym_LinkSection,
  [46086] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2646), 1,
      anon_sym_SEMI,
    ACTIONS(2863), 1,
      anon_sym_linksection,
    ACTIONS(2899), 1,
      anon_sym_EQ,
    STATE(2042), 1,
      sym_LinkSection,
  [46102] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3124), 1,
      anon_sym_COLON,
    ACTIONS(3126), 1,
      anon_sym_RBRACE,
    ACTIONS(3128), 2,
      aux_sym_FormatSequence_token2,
      anon_sym_any,
  [46116] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2630), 1,
      anon_sym_SEMI,
    ACTIONS(2863), 1,
      anon_sym_linksection,
    ACTIONS(2933), 1,
      anon_sym_EQ,
    STATE(2049), 1,
      sym_LinkSection,
  [46132] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2576), 1,
      anon_sym_SEMI,
    ACTIONS(2863), 1,
      anon_sym_linksection,
    ACTIONS(3130), 1,
      anon_sym_EQ,
    STATE(2021), 1,
      sym_LinkSection,
  [46148] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    ACTIONS(2945), 1,
      sym_doc_comment,
    STATE(2036), 1,
      sym_IDENTIFIER,
  [46164] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3132), 1,
      anon_sym_COMMA,
    STATE(1846), 1,
      aux_sym_InitList_repeat2,
    ACTIONS(2488), 2,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
  [46178] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(754), 4,
      anon_sym_inline,
      anon_sym_LBRACE,
      anon_sym_while,
      anon_sym_for,
  [46188] = 5,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2614), 1,
      anon_sym_SEMI,
    ACTIONS(2863), 1,
      anon_sym_linksection,
    ACTIONS(2935), 1,
      anon_sym_EQ,
    STATE(2026), 1,
      sym_LinkSection,
  [46204] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3135), 1,
      anon_sym_COMMA,
    STATE(1849), 1,
      aux_sym_AsmInput_repeat1,
    ACTIONS(3138), 2,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [46218] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(608), 1,
      anon_sym_RBRACE,
    ACTIONS(3140), 1,
      anon_sym_COMMA,
    STATE(1947), 1,
      aux_sym_SwitchExpr_repeat1,
  [46231] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2476), 1,
      anon_sym_RBRACE,
    ACTIONS(3142), 1,
      anon_sym_COMMA,
    STATE(1975), 1,
      aux_sym_InitList_repeat1,
  [46244] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(738), 1,
      anon_sym_RBRACE,
    ACTIONS(3144), 1,
      anon_sym_DOT,
    STATE(2020), 1,
      sym_FieldInit,
  [46257] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(1911), 1,
      sym_IDENTIFIER,
  [46270] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3101), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(3103), 1,
      anon_sym_AT,
    STATE(1086), 1,
      sym_IDENTIFIER,
  [46283] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(2200), 1,
      sym_IDENTIFIER,
  [46296] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2468), 1,
      anon_sym_RBRACE,
    ACTIONS(3146), 1,
      anon_sym_COMMA,
    STATE(1935), 1,
      aux_sym_InitList_repeat1,
  [46309] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(2048), 1,
      sym_IDENTIFIER,
  [46322] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3148), 1,
      anon_sym_SEMI,
    ACTIONS(3150), 1,
      anon_sym_else,
    STATE(1134), 1,
      sym__ElseStatementTail,
  [46335] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3152), 1,
      anon_sym_COMMA,
    ACTIONS(3154), 1,
      anon_sym_RBRACE,
    STATE(1877), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [46348] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3150), 1,
      anon_sym_else,
    ACTIONS(3156), 1,
      anon_sym_SEMI,
    STATE(1137), 1,
      sym__ElseStatementTail,
  [46361] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3150), 1,
      anon_sym_else,
    ACTIONS(3158), 1,
      anon_sym_SEMI,
    STATE(1104), 1,
      sym__ElseStatementTail,
  [46374] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    STATE(1380), 1,
      sym_VarDecl,
    ACTIONS(2678), 2,
      anon_sym_const,
      anon_sym_var,
  [46385] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3160), 1,
      anon_sym_COMMA,
    ACTIONS(3163), 1,
      anon_sym_RBRACE,
    STATE(1863), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [46398] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1547), 1,
      anon_sym_DQUOTE,
    ACTIONS(3165), 1,
      aux_sym_IDENTIFIER_token1,
    STATE(1078), 1,
      sym_STRINGLITERALSINGLE,
  [46411] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(1974), 1,
      sym_IDENTIFIER,
  [46424] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3167), 1,
      anon_sym_COMMA,
    ACTIONS(3170), 1,
      anon_sym_RPAREN,
    STATE(1866), 1,
      aux_sym_ParamDeclList_repeat1,
  [46437] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(1716), 1,
      sym_IDENTIFIER,
  [46450] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(1993), 1,
      sym_IDENTIFIER,
  [46463] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(3165), 1,
      aux_sym_IDENTIFIER_token1,
    STATE(1007), 1,
      sym_STRINGLITERALSINGLE,
  [46476] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(1939), 1,
      sym_IDENTIFIER,
  [46489] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(610), 1,
      anon_sym_RBRACE,
    ACTIONS(3172), 1,
      anon_sym_COMMA,
    STATE(1947), 1,
      aux_sym_SwitchExpr_repeat1,
  [46502] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1635), 1,
      anon_sym_RPAREN,
    ACTIONS(3174), 1,
      anon_sym_COMMA,
    STATE(1866), 1,
      aux_sym_ParamDeclList_repeat1,
  [46515] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(942), 1,
      sym_IDENTIFIER,
  [46528] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3025), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(3027), 1,
      anon_sym_AT,
    STATE(422), 1,
      sym_IDENTIFIER,
  [46541] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(2140), 1,
      sym_IDENTIFIER,
  [46554] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(1892), 1,
      sym_IDENTIFIER,
  [46567] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3176), 1,
      anon_sym_COMMA,
    ACTIONS(3178), 1,
      anon_sym_RBRACE,
    STATE(1863), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [46580] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3101), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(3103), 1,
      anon_sym_AT,
    STATE(1106), 1,
      sym_IDENTIFIER,
  [46593] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3180), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(3182), 1,
      anon_sym_AT,
    STATE(55), 1,
      sym_IDENTIFIER,
  [46606] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3025), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(3027), 1,
      anon_sym_AT,
    STATE(483), 1,
      sym_IDENTIFIER,
  [46619] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2510), 1,
      anon_sym_RBRACE,
    ACTIONS(3184), 1,
      anon_sym_COMMA,
    STATE(1891), 1,
      aux_sym_InitList_repeat1,
  [46632] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3186), 1,
      anon_sym_COMMA,
    ACTIONS(3188), 1,
      anon_sym_RBRACE,
    STATE(1893), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [46645] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(682), 1,
      anon_sym_EQ_GT,
    ACTIONS(3190), 1,
      anon_sym_COMMA,
    STATE(1962), 1,
      aux_sym_SwitchCase_repeat1,
  [46658] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(982), 1,
      sym_IDENTIFIER,
  [46671] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(1971), 1,
      sym_IDENTIFIER,
  [46684] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3192), 1,
      anon_sym_COMMA,
    ACTIONS(3194), 1,
      anon_sym_RPAREN,
    STATE(1952), 1,
      aux_sym_ForArgumentsList_repeat1,
  [46697] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(2170), 1,
      sym_IDENTIFIER,
  [46710] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3196), 1,
      anon_sym_COMMA,
    ACTIONS(3198), 1,
      anon_sym_PIPE,
    STATE(1972), 1,
      aux_sym_PtrListPayload_repeat1,
  [46723] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(722), 1,
      anon_sym_RBRACE,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    STATE(1846), 1,
      aux_sym_InitList_repeat2,
  [46736] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(722), 1,
      anon_sym_RBRACE,
    ACTIONS(3144), 1,
      anon_sym_DOT,
    STATE(2020), 1,
      sym_FieldInit,
  [46749] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(722), 1,
      anon_sym_RBRACE,
    ACTIONS(3202), 1,
      anon_sym_COMMA,
    STATE(1948), 1,
      aux_sym_InitList_repeat1,
  [46762] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3204), 1,
      anon_sym_COMMA,
    ACTIONS(3206), 1,
      anon_sym_RBRACE,
    STATE(1902), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [46775] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3208), 1,
      anon_sym_COMMA,
    ACTIONS(3210), 1,
      anon_sym_RBRACE,
    STATE(1863), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [46788] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3212), 1,
      anon_sym_COMMA,
    ACTIONS(3214), 1,
      anon_sym_PIPE,
    STATE(1983), 1,
      aux_sym_PtrListPayload_repeat1,
  [46801] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(716), 1,
      anon_sym_RPAREN,
    ACTIONS(3216), 1,
      anon_sym_COMMA,
    STATE(1846), 1,
      aux_sym_InitList_repeat2,
  [46814] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3085), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(3087), 1,
      anon_sym_AT,
    STATE(1130), 1,
      sym_IDENTIFIER,
  [46827] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(2116), 1,
      sym_IDENTIFIER,
  [46840] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3218), 1,
      anon_sym_COMMA,
    ACTIONS(3221), 1,
      anon_sym_RPAREN,
    STATE(1898), 1,
      aux_sym_ForArgumentsList_repeat1,
  [46853] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(2206), 1,
      sym_IDENTIFIER,
  [46866] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2602), 1,
      anon_sym_RPAREN,
    ACTIONS(3223), 1,
      anon_sym_LBRACE,
    ACTIONS(3225), 1,
      anon_sym_LPAREN,
  [46879] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(712), 1,
      anon_sym_RBRACE,
    ACTIONS(3144), 1,
      anon_sym_DOT,
    STATE(2020), 1,
      sym_FieldInit,
  [46892] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3227), 1,
      anon_sym_COMMA,
    ACTIONS(3229), 1,
      anon_sym_RBRACE,
    STATE(1863), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [46905] = 4,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3165), 1,
      aux_sym_IDENTIFIER_token1,
    STATE(1094), 1,
      sym_STRINGLITERALSINGLE,
  [46918] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(2010), 1,
      sym_IDENTIFIER,
  [46931] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3231), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [46940] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3071), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(3073), 1,
      anon_sym_AT,
    STATE(569), 1,
      sym_IDENTIFIER,
  [46953] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3233), 1,
      anon_sym_COMMA,
    ACTIONS(3235), 1,
      anon_sym_RBRACE,
    STATE(1908), 1,
      aux_sym_SwitchExpr_repeat1,
  [46966] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(588), 1,
      anon_sym_RBRACE,
    ACTIONS(3237), 1,
      anon_sym_COMMA,
    STATE(1947), 1,
      aux_sym_SwitchExpr_repeat1,
  [46979] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3239), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [46988] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3241), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [46997] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3243), 1,
      anon_sym_COMMA,
    ACTIONS(3245), 1,
      anon_sym_RBRACE,
    STATE(1950), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [47010] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3247), 1,
      anon_sym_COMMA,
    ACTIONS(3249), 1,
      anon_sym_RPAREN,
    STATE(1989), 1,
      aux_sym_AsmClobbers_repeat1,
  [47023] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3071), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(3073), 1,
      anon_sym_AT,
    STATE(455), 1,
      sym_IDENTIFIER,
  [47036] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(2124), 1,
      sym_IDENTIFIER,
  [47049] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(267), 1,
      anon_sym_DQUOTE,
    ACTIONS(3165), 1,
      aux_sym_IDENTIFIER_token1,
    STATE(453), 1,
      sym_STRINGLITERALSINGLE,
  [47062] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3251), 3,
      aux_sym_EscapeSequence_token1,
      aux_sym_EscapeSequence_token2,
      aux_sym_EscapeSequence_token3,
  [47071] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(1713), 1,
      sym_IDENTIFIER,
  [47084] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3253), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(3255), 1,
      anon_sym_AT,
    STATE(639), 1,
      sym_IDENTIFIER,
  [47097] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3257), 1,
      anon_sym_COMMA,
    ACTIONS(3259), 1,
      anon_sym_RPAREN,
    STATE(1872), 1,
      aux_sym_ParamDeclList_repeat1,
  [47110] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(694), 1,
      anon_sym_RPAREN,
    ACTIONS(3261), 1,
      anon_sym_COMMA,
    STATE(1846), 1,
      aux_sym_InitList_repeat2,
  [47123] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2939), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2941), 1,
      anon_sym_AT,
    STATE(1658), 1,
      sym_IDENTIFIER,
  [47136] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3263), 3,
      aux_sym_EscapeSequence_token1,
      aux_sym_EscapeSequence_token2,
      aux_sym_EscapeSequence_token3,
  [47145] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(1288), 1,
      sym_IDENTIFIER,
  [47158] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3265), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(3267), 1,
      anon_sym_AT,
    STATE(640), 1,
      sym_IDENTIFIER,
  [47171] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(2120), 1,
      sym_IDENTIFIER,
  [47184] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2939), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2941), 1,
      anon_sym_AT,
    STATE(1441), 1,
      sym_IDENTIFIER,
  [47197] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3269), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(3271), 1,
      anon_sym_AT,
    STATE(373), 1,
      sym_IDENTIFIER,
  [47210] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2460), 1,
      anon_sym_RBRACE,
    ACTIONS(3273), 1,
      anon_sym_COMMA,
    STATE(1938), 1,
      aux_sym_InitList_repeat1,
  [47223] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3275), 1,
      anon_sym_COMMA,
    ACTIONS(3277), 1,
      anon_sym_RBRACE,
    STATE(1941), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [47236] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3118), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [47245] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(602), 1,
      anon_sym_RBRACE,
    ACTIONS(3279), 1,
      anon_sym_COMMA,
    STATE(1947), 1,
      aux_sym_SwitchExpr_repeat1,
  [47258] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2472), 1,
      anon_sym_RBRACE,
    ACTIONS(3281), 1,
      anon_sym_COMMA,
    STATE(2012), 1,
      aux_sym_InitList_repeat1,
  [47271] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(2163), 1,
      sym_IDENTIFIER,
  [47284] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3283), 1,
      anon_sym_COMMA,
    ACTIONS(3285), 1,
      anon_sym_RBRACE,
    STATE(1931), 1,
      aux_sym_SwitchExpr_repeat1,
  [47297] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(732), 1,
      anon_sym_RBRACE,
    ACTIONS(3287), 1,
      anon_sym_COMMA,
    STATE(1948), 1,
      aux_sym_InitList_repeat1,
  [47310] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(708), 1,
      anon_sym_RBRACE,
    ACTIONS(3289), 1,
      anon_sym_COMMA,
    STATE(1846), 1,
      aux_sym_InitList_repeat2,
  [47323] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(708), 1,
      anon_sym_RBRACE,
    ACTIONS(3144), 1,
      anon_sym_DOT,
    STATE(2020), 1,
      sym_FieldInit,
  [47336] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(708), 1,
      anon_sym_RBRACE,
    ACTIONS(3291), 1,
      anon_sym_COMMA,
    STATE(1948), 1,
      aux_sym_InitList_repeat1,
  [47349] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3293), 1,
      anon_sym_COMMA,
    ACTIONS(3295), 1,
      anon_sym_RBRACE,
    STATE(1951), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [47362] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3297), 1,
      anon_sym_COMMA,
    ACTIONS(3299), 1,
      anon_sym_RBRACE,
    STATE(2007), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [47375] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3301), 1,
      anon_sym_COMMA,
    ACTIONS(3303), 1,
      anon_sym_RBRACE,
    STATE(1863), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [47388] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(732), 1,
      anon_sym_RBRACE,
    ACTIONS(3144), 1,
      anon_sym_DOT,
    STATE(2020), 1,
      sym_FieldInit,
  [47401] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(710), 1,
      anon_sym_RPAREN,
    ACTIONS(3305), 1,
      anon_sym_COMMA,
    STATE(1846), 1,
      aux_sym_InitList_repeat2,
  [47414] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3025), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(3027), 1,
      anon_sym_AT,
    STATE(653), 1,
      sym_IDENTIFIER,
  [47427] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(732), 1,
      anon_sym_RBRACE,
    ACTIONS(3307), 1,
      anon_sym_COMMA,
    STATE(1846), 1,
      aux_sym_InitList_repeat2,
  [47440] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2939), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2941), 1,
      anon_sym_AT,
    STATE(1525), 1,
      sym_IDENTIFIER,
  [47453] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3309), 1,
      anon_sym_COMMA,
    ACTIONS(3312), 1,
      anon_sym_RBRACE,
    STATE(1947), 1,
      aux_sym_SwitchExpr_repeat1,
  [47466] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3314), 1,
      anon_sym_COMMA,
    ACTIONS(3317), 1,
      anon_sym_RBRACE,
    STATE(1948), 1,
      aux_sym_InitList_repeat1,
  [47479] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(720), 1,
      anon_sym_RBRACE,
    ACTIONS(3144), 1,
      anon_sym_DOT,
    STATE(2020), 1,
      sym_FieldInit,
  [47492] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3319), 1,
      anon_sym_COMMA,
    ACTIONS(3321), 1,
      anon_sym_RBRACE,
    STATE(1863), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [47505] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3323), 1,
      anon_sym_COMMA,
    ACTIONS(3325), 1,
      anon_sym_RBRACE,
    STATE(1863), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [47518] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(684), 1,
      anon_sym_RPAREN,
    ACTIONS(3327), 1,
      anon_sym_COMMA,
    STATE(1898), 1,
      aux_sym_ForArgumentsList_repeat1,
  [47531] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3329), 1,
      anon_sym_COMMA,
    ACTIONS(3331), 1,
      anon_sym_RBRACE,
    STATE(1850), 1,
      aux_sym_SwitchExpr_repeat1,
  [47544] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3085), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(3087), 1,
      anon_sym_AT,
    STATE(1224), 1,
      sym_IDENTIFIER,
  [47557] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3333), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(3335), 1,
      anon_sym_AT,
    STATE(62), 1,
      sym_IDENTIFIER,
  [47570] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(2117), 1,
      sym_IDENTIFIER,
  [47583] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3337), 1,
      anon_sym_COMMA,
    ACTIONS(3339), 1,
      anon_sym_PIPE,
    STATE(1894), 1,
      aux_sym_PtrListPayload_repeat1,
  [47596] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3341), 1,
      anon_sym_COMMA,
    ACTIONS(3343), 1,
      anon_sym_RBRACE,
    STATE(1960), 1,
      aux_sym_SwitchExpr_repeat1,
  [47609] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(1888), 1,
      sym_IDENTIFIER,
  [47622] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(636), 1,
      anon_sym_RBRACE,
    ACTIONS(3345), 1,
      anon_sym_COMMA,
    STATE(1947), 1,
      aux_sym_SwitchExpr_repeat1,
  [47635] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3347), 1,
      anon_sym_COMMA,
    ACTIONS(3349), 1,
      anon_sym_RBRACE,
    STATE(1863), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [47648] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3351), 1,
      anon_sym_COMMA,
    ACTIONS(3354), 1,
      anon_sym_EQ_GT,
    STATE(1962), 1,
      aux_sym_SwitchCase_repeat1,
  [47661] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(748), 1,
      anon_sym_RBRACE,
    ACTIONS(3144), 1,
      anon_sym_DOT,
    STATE(2020), 1,
      sym_FieldInit,
  [47674] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3356), 1,
      anon_sym_COMMA,
    ACTIONS(3358), 1,
      anon_sym_PIPE,
    STATE(1983), 1,
      aux_sym_PtrListPayload_repeat1,
  [47687] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1701), 1,
      anon_sym_LBRACE,
    ACTIONS(1940), 1,
      anon_sym_SEMI,
    STATE(1380), 1,
      sym_Block,
  [47700] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3360), 1,
      anon_sym_COMMA,
    ACTIONS(3363), 1,
      anon_sym_RPAREN,
    STATE(1966), 1,
      aux_sym_AsmClobbers_repeat1,
  [47713] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(2149), 1,
      sym_IDENTIFIER,
  [47726] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3365), 1,
      anon_sym_COMMA,
    ACTIONS(3367), 1,
      anon_sym_PIPE,
    STATE(1983), 1,
      aux_sym_PtrListPayload_repeat1,
  [47739] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(746), 1,
      anon_sym_RPAREN,
    ACTIONS(3369), 1,
      anon_sym_COMMA,
    STATE(1846), 1,
      aux_sym_InitList_repeat2,
  [47752] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(215), 1,
      anon_sym_DQUOTE,
    ACTIONS(3165), 1,
      aux_sym_IDENTIFIER_token1,
    STATE(414), 1,
      sym_STRINGLITERALSINGLE,
  [47765] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3371), 1,
      anon_sym_COMMA,
    ACTIONS(3373), 1,
      anon_sym_PIPE,
    STATE(1964), 1,
      aux_sym_PtrListPayload_repeat1,
  [47778] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3375), 1,
      anon_sym_COMMA,
    ACTIONS(3377), 1,
      anon_sym_PIPE,
    STATE(1983), 1,
      aux_sym_PtrListPayload_repeat1,
  [47791] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3379), 1,
      anon_sym_COMMA,
    ACTIONS(3381), 1,
      anon_sym_RBRACE,
    STATE(1863), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [47804] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3383), 1,
      anon_sym_COMMA,
    ACTIONS(3385), 1,
      anon_sym_RBRACE,
    STATE(1961), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [47817] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(744), 1,
      anon_sym_RBRACE,
    ACTIONS(3387), 1,
      anon_sym_COMMA,
    STATE(1948), 1,
      aux_sym_InitList_repeat1,
  [47830] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(2052), 1,
      sym_IDENTIFIER,
  [47843] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(744), 1,
      anon_sym_RBRACE,
    ACTIONS(3144), 1,
      anon_sym_DOT,
    STATE(2020), 1,
      sym_FieldInit,
  [47856] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(744), 1,
      anon_sym_RBRACE,
    ACTIONS(3389), 1,
      anon_sym_COMMA,
    STATE(1846), 1,
      aux_sym_InitList_repeat2,
  [47869] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3391), 1,
      anon_sym_COMMA,
    ACTIONS(3393), 1,
      anon_sym_RBRACE,
    STATE(1973), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [47882] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(618), 1,
      anon_sym_RBRACE,
    ACTIONS(3395), 1,
      anon_sym_COMMA,
    STATE(1947), 1,
      aux_sym_SwitchExpr_repeat1,
  [47895] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3397), 1,
      anon_sym_COMMA,
    ACTIONS(3399), 1,
      anon_sym_EQ_GT,
    STATE(1883), 1,
      aux_sym_SwitchCase_repeat1,
  [47908] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3401), 1,
      anon_sym_COMMA,
    ACTIONS(3403), 1,
      anon_sym_PIPE,
    STATE(1968), 1,
      aux_sym_PtrListPayload_repeat1,
  [47921] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3405), 1,
      anon_sym_COMMA,
    ACTIONS(3408), 1,
      anon_sym_PIPE,
    STATE(1983), 1,
      aux_sym_PtrListPayload_repeat1,
  [47934] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3410), 1,
      anon_sym_COMMA,
    ACTIONS(3412), 1,
      anon_sym_RBRACE,
    STATE(1980), 1,
      aux_sym_SwitchExpr_repeat1,
  [47947] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3071), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(3073), 1,
      anon_sym_AT,
    STATE(675), 1,
      sym_IDENTIFIER,
  [47960] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2518), 1,
      anon_sym_RBRACE,
    ACTIONS(3414), 1,
      anon_sym_COMMA,
    STATE(1992), 1,
      aux_sym_InitList_repeat1,
  [47973] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3416), 1,
      anon_sym_COMMA,
    ACTIONS(3418), 1,
      anon_sym_RBRACE,
    STATE(1994), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [47986] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3420), 1,
      anon_sym_COMMA,
    ACTIONS(3422), 1,
      anon_sym_RBRACE,
    STATE(1871), 1,
      aux_sym_SwitchExpr_repeat1,
  [47999] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2923), 1,
      anon_sym_RPAREN,
    ACTIONS(3424), 1,
      anon_sym_COMMA,
    STATE(1966), 1,
      aux_sym_AsmClobbers_repeat1,
  [48012] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(734), 1,
      anon_sym_RBRACE,
    ACTIONS(3426), 1,
      anon_sym_COMMA,
    STATE(1846), 1,
      aux_sym_InitList_repeat2,
  [48025] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(734), 1,
      anon_sym_RBRACE,
    ACTIONS(3144), 1,
      anon_sym_DOT,
    STATE(2020), 1,
      sym_FieldInit,
  [48038] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(734), 1,
      anon_sym_RBRACE,
    ACTIONS(3428), 1,
      anon_sym_COMMA,
    STATE(1948), 1,
      aux_sym_InitList_repeat1,
  [48051] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3430), 1,
      anon_sym_COMMA,
    ACTIONS(3432), 1,
      anon_sym_RBRACE,
    STATE(2000), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [48064] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3434), 1,
      anon_sym_COMMA,
    ACTIONS(3436), 1,
      anon_sym_RBRACE,
    STATE(1863), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [48077] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3138), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
  [48086] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(736), 1,
      anon_sym_RPAREN,
    ACTIONS(3438), 1,
      anon_sym_COMMA,
    STATE(1846), 1,
      aux_sym_InitList_repeat2,
  [48099] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3440), 1,
      anon_sym_COMMA,
    ACTIONS(3442), 1,
      anon_sym_RBRACE,
    STATE(1863), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [48112] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(690), 1,
      anon_sym_RBRACE,
    ACTIONS(3144), 1,
      anon_sym_DOT,
    STATE(2020), 1,
      sym_FieldInit,
  [48125] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(714), 1,
      anon_sym_RBRACE,
    ACTIONS(3144), 1,
      anon_sym_DOT,
    STATE(2020), 1,
      sym_FieldInit,
  [48138] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3444), 1,
      anon_sym_COMMA,
    ACTIONS(3446), 1,
      anon_sym_RBRACE,
    STATE(1863), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [48151] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3448), 1,
      anon_sym_COMMA,
    ACTIONS(3450), 1,
      anon_sym_RBRACE,
    STATE(2002), 1,
      aux_sym_SwitchExpr_repeat1,
  [48164] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(628), 1,
      anon_sym_RBRACE,
    ACTIONS(3452), 1,
      anon_sym_COMMA,
    STATE(1947), 1,
      aux_sym_SwitchExpr_repeat1,
  [48177] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    STATE(1367), 1,
      sym_VarDecl,
    ACTIONS(2678), 2,
      anon_sym_const,
      anon_sym_var,
  [48188] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1701), 1,
      anon_sym_LBRACE,
    ACTIONS(3454), 1,
      anon_sym_SEMI,
    STATE(1367), 1,
      sym_Block,
  [48201] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(706), 1,
      anon_sym_RPAREN,
    ACTIONS(3456), 1,
      anon_sym_COMMA,
    STATE(1846), 1,
      aux_sym_InitList_repeat2,
  [48214] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(319), 1,
      anon_sym_DQUOTE,
    ACTIONS(3165), 1,
      aux_sym_IDENTIFIER_token1,
    STATE(1437), 1,
      sym_STRINGLITERALSINGLE,
  [48227] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3458), 1,
      anon_sym_COMMA,
    ACTIONS(3460), 1,
      anon_sym_RBRACE,
    STATE(1863), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [48240] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1701), 1,
      anon_sym_LBRACE,
    ACTIONS(2572), 1,
      anon_sym_SEMI,
    STATE(1381), 1,
      sym_Block,
  [48253] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    STATE(1381), 1,
      sym_VarDecl,
    ACTIONS(2678), 2,
      anon_sym_const,
      anon_sym_var,
  [48264] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3462), 1,
      anon_sym_COMMA,
    ACTIONS(3464), 1,
      anon_sym_RBRACE,
    STATE(1997), 1,
      aux_sym_ErrorSetDecl_repeat1,
  [48277] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2917), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(2919), 1,
      anon_sym_AT,
    STATE(2092), 1,
      sym_IDENTIFIER,
  [48290] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(700), 1,
      anon_sym_RBRACE,
    ACTIONS(3466), 1,
      anon_sym_COMMA,
    STATE(1948), 1,
      aux_sym_InitList_repeat1,
  [48303] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(700), 1,
      anon_sym_RBRACE,
    ACTIONS(3144), 1,
      anon_sym_DOT,
    STATE(2020), 1,
      sym_FieldInit,
  [48316] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(700), 1,
      anon_sym_RBRACE,
    ACTIONS(3468), 1,
      anon_sym_COMMA,
    STATE(1846), 1,
      aux_sym_InitList_repeat2,
  [48329] = 4,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3470), 1,
      aux_sym_IDENTIFIER_token1,
    ACTIONS(3472), 1,
      anon_sym_AT,
    STATE(343), 1,
      sym_IDENTIFIER,
  [48342] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3474), 1,
      anon_sym_PIPE,
    STATE(1340), 1,
      sym_PtrListPayload,
  [48352] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3476), 1,
      anon_sym_LBRACE,
    ACTIONS(3478), 1,
      anon_sym_DOT,
  [48362] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3480), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [48370] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [48378] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3317), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [48386] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2640), 1,
      anon_sym_SEMI,
    ACTIONS(3484), 1,
      anon_sym_EQ,
  [48396] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2646), 1,
      anon_sym_SEMI,
    ACTIONS(2899), 1,
      anon_sym_EQ,
  [48406] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2568), 1,
      anon_sym_SEMI,
    ACTIONS(3486), 1,
      anon_sym_EQ,
  [48416] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3144), 1,
      anon_sym_DOT,
    STATE(2020), 1,
      sym_FieldInit,
  [48426] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2967), 1,
      anon_sym_LBRACK,
    STATE(1995), 1,
      sym_AsmInputItem,
  [48436] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2624), 1,
      anon_sym_SEMI,
    ACTIONS(3122), 1,
      anon_sym_EQ,
  [48446] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3488), 1,
      anon_sym_LBRACE,
    ACTIONS(3490), 1,
      anon_sym_DOT,
  [48456] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2676), 1,
      anon_sym_fn,
    STATE(2008), 1,
      sym_FnProto,
  [48466] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3492), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [48474] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3494), 1,
      anon_sym_LBRACE,
    ACTIONS(3496), 1,
      anon_sym_DOT,
  [48484] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2957), 1,
      anon_sym_LPAREN,
    STATE(637), 1,
      sym_ParamDeclList,
  [48494] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3498), 1,
      anon_sym_LPAREN,
    ACTIONS(3500), 1,
      anon_sym_volatile,
  [48504] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2359), 1,
      anon_sym_LPAREN,
    STATE(1521), 1,
      sym_FnCallArguments,
  [48514] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3015), 1,
      anon_sym_LBRACK,
    STATE(1930), 1,
      sym_AsmOutputItem,
  [48524] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3502), 1,
      anon_sym_DQUOTE,
    STATE(44), 1,
      sym_STRINGLITERALSINGLE,
  [48534] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3504), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [48542] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3506), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [48550] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3508), 1,
      anon_sym_LPAREN,
    ACTIONS(3510), 1,
      anon_sym_volatile,
  [48560] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2957), 1,
      anon_sym_LPAREN,
    STATE(630), 1,
      sym_ParamDeclList,
  [48570] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3512), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [48578] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3514), 1,
      anon_sym_LPAREN,
    ACTIONS(3516), 1,
      anon_sym_volatile,
  [48588] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2630), 1,
      anon_sym_SEMI,
    ACTIONS(2933), 1,
      anon_sym_EQ,
  [48598] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3518), 1,
      anon_sym_LPAREN,
    ACTIONS(3520), 1,
      anon_sym_volatile,
  [48608] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2957), 1,
      anon_sym_LPAREN,
    STATE(626), 1,
      sym_ParamDeclList,
  [48618] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3522), 1,
      anon_sym_COMMA,
    ACTIONS(3524), 1,
      anon_sym_PIPE,
  [48628] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3170), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [48636] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3526), 1,
      anon_sym_LBRACE,
    ACTIONS(3528), 1,
      anon_sym_DOT,
  [48646] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3530), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [48654] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2576), 1,
      anon_sym_SEMI,
    ACTIONS(3130), 1,
      anon_sym_EQ,
  [48664] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2614), 1,
      anon_sym_SEMI,
    ACTIONS(2935), 1,
      anon_sym_EQ,
  [48674] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1768), 1,
      anon_sym_LPAREN,
    STATE(1196), 1,
      sym_FnCallArguments,
  [48684] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3532), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [48692] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2584), 1,
      anon_sym_SEMI,
    ACTIONS(2881), 1,
      anon_sym_EQ,
  [48702] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3363), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [48710] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3534), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [48718] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3536), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [48726] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3538), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [48734] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1547), 1,
      anon_sym_DQUOTE,
    STATE(1078), 1,
      sym_STRINGLITERALSINGLE,
  [48744] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(267), 1,
      anon_sym_DQUOTE,
    STATE(453), 1,
      sym_STRINGLITERALSINGLE,
  [48754] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(935), 1,
      anon_sym_LPAREN,
    STATE(473), 1,
      sym_FnCallArguments,
  [48764] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3540), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [48772] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2957), 1,
      anon_sym_LPAREN,
    STATE(634), 1,
      sym_ParamDeclList,
  [48782] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1701), 1,
      anon_sym_LBRACE,
    STATE(1376), 1,
      sym_Block,
  [48792] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1747), 1,
      anon_sym_LPAREN,
    STATE(1000), 1,
      sym_FnCallArguments,
  [48802] = 3,
    ACTIONS(79), 1,
      anon_sym_DQUOTE,
    ACTIONS(137), 1,
      sym_line_comment,
    STATE(1094), 1,
      sym_STRINGLITERALSINGLE,
  [48812] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    STATE(1007), 1,
      sym_STRINGLITERALSINGLE,
  [48822] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3542), 1,
      anon_sym_LBRACE,
    ACTIONS(3544), 1,
      anon_sym_DOT,
  [48832] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3546), 1,
      anon_sym_COLON,
    ACTIONS(3548), 1,
      anon_sym_RBRACK,
  [48842] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3221), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [48850] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3550), 1,
      anon_sym_COLON,
    ACTIONS(3552), 1,
      anon_sym_RBRACE,
  [48860] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3354), 2,
      anon_sym_COMMA,
      anon_sym_EQ_GT,
  [48868] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3223), 1,
      anon_sym_LBRACE,
    ACTIONS(3554), 1,
      anon_sym_LPAREN,
  [48878] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(3556), 1,
      aux_sym_FormatSequence_token3,
    ACTIONS(3558), 1,
      aux_sym_FormatSequence_token4,
  [48888] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3223), 1,
      anon_sym_LBRACE,
    ACTIONS(3560), 1,
      anon_sym_LPAREN,
  [48898] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3562), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [48906] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2957), 1,
      anon_sym_LPAREN,
    STATE(631), 1,
      sym_ParamDeclList,
  [48916] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1701), 1,
      anon_sym_LBRACE,
    STATE(1375), 1,
      sym_Block,
  [48926] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3564), 1,
      anon_sym_LBRACE,
    ACTIONS(3566), 1,
      anon_sym_DOT,
  [48936] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1788), 1,
      anon_sym_LPAREN,
    STATE(1242), 1,
      sym_FnCallArguments,
  [48946] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3568), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [48954] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2929), 1,
      anon_sym_SEMI,
    ACTIONS(2931), 1,
      anon_sym_EQ,
  [48964] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3570), 1,
      anon_sym_DQUOTE,
    STATE(365), 1,
      sym_STRINGLITERALSINGLE,
  [48974] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3572), 1,
      anon_sym_LBRACE,
    ACTIONS(3574), 1,
      anon_sym_RPAREN,
  [48984] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3576), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [48992] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(947), 1,
      anon_sym_LPAREN,
    STATE(560), 1,
      sym_FnCallArguments,
  [49002] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3312), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [49010] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3578), 1,
      anon_sym_DQUOTE,
    STATE(632), 1,
      sym_STRINGLITERALSINGLE,
  [49020] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(3580), 1,
      aux_sym_FormatSequence_token3,
    ACTIONS(3582), 1,
      aux_sym_FormatSequence_token4,
  [49030] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3584), 1,
      anon_sym_PIPE,
    STATE(1489), 1,
      sym_PtrListPayload,
  [49040] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3586), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [49048] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2913), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [49056] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3588), 1,
      anon_sym_COMMA,
    ACTIONS(3590), 1,
      anon_sym_PIPE,
  [49066] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(215), 1,
      anon_sym_DQUOTE,
    STATE(414), 1,
      sym_STRINGLITERALSINGLE,
  [49076] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2925), 1,
      anon_sym_SEMI,
    ACTIONS(2927), 1,
      anon_sym_EQ,
  [49086] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3592), 1,
      anon_sym_DQUOTE,
    STATE(644), 1,
      sym_STRINGLITERALSINGLE,
  [49096] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3594), 1,
      anon_sym_DQUOTE,
    STATE(65), 1,
      sym_STRINGLITERALSINGLE,
  [49106] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(319), 1,
      anon_sym_DQUOTE,
    STATE(1437), 1,
      sym_STRINGLITERALSINGLE,
  [49116] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2957), 1,
      anon_sym_LPAREN,
    STATE(629), 1,
      sym_ParamDeclList,
  [49126] = 3,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3596), 1,
      anon_sym_DQUOTE,
    STATE(346), 1,
      sym_STRINGLITERALSINGLE,
  [49136] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3598), 1,
      anon_sym_LPAREN,
  [49143] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(3600), 1,
      aux_sym_LINESTRING_token1,
  [49150] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3602), 1,
      anon_sym_LPAREN,
  [49157] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2897), 1,
      anon_sym_SQUOTE,
  [49164] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3604), 1,
      anon_sym_LPAREN,
  [49171] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3606), 1,
      anon_sym_SQUOTE,
  [49178] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(3608), 1,
      aux_sym_FormatSequence_token1,
  [49185] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3610), 1,
      anon_sym_LPAREN,
  [49192] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2975), 1,
      anon_sym_RPAREN,
  [49199] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3049), 1,
      anon_sym_RPAREN,
  [49206] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3612), 1,
      anon_sym_LBRACE,
  [49213] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3614), 1,
      anon_sym_RBRACE,
  [49220] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3616), 1,
      anon_sym_RBRACE,
  [49227] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2464), 1,
      anon_sym_RPAREN,
  [49234] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3618), 1,
      anon_sym_RPAREN,
  [49241] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3620), 1,
      anon_sym_LBRACE,
  [49248] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3622), 1,
      anon_sym_PIPE,
  [49255] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3624), 1,
      anon_sym_RBRACK,
  [49262] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(1101), 1,
      anon_sym_DASH_GT,
  [49269] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3626), 1,
      anon_sym_LBRACE,
  [49276] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3628), 1,
      anon_sym_PIPE,
  [49283] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3630), 1,
      anon_sym_RPAREN,
  [49290] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(3632), 1,
      aux_sym_LINESTRING_token1,
  [49297] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3634), 1,
      anon_sym_RPAREN,
  [49304] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3636), 1,
      anon_sym_PIPE,
  [49311] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3638), 1,
      anon_sym_RBRACE,
  [49318] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3640), 1,
      anon_sym_LPAREN,
  [49325] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3642), 1,
      anon_sym_RPAREN,
  [49332] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3644), 1,
      ts_builtin_sym_end,
  [49339] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3646), 1,
      anon_sym_RBRACK,
  [49346] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3648), 1,
      anon_sym_RPAREN,
  [49353] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3650), 1,
      anon_sym_RPAREN,
  [49360] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3652), 1,
      anon_sym_SEMI,
  [49367] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3654), 1,
      anon_sym_LPAREN,
  [49374] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(3656), 1,
      aux_sym_LINESTRING_token1,
  [49381] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3658), 1,
      anon_sym_SQUOTE,
  [49388] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3660), 1,
      anon_sym_LBRACE,
  [49395] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(3582), 1,
      aux_sym_FormatSequence_token4,
  [49402] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2486), 1,
      anon_sym_RPAREN,
  [49409] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3662), 1,
      anon_sym_RBRACK,
  [49416] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3664), 1,
      anon_sym_PIPE,
  [49423] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3666), 1,
      anon_sym_LBRACE,
  [49430] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3668), 1,
      anon_sym_RPAREN,
  [49437] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3670), 1,
      anon_sym_RPAREN,
  [49444] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2885), 1,
      anon_sym_SQUOTE,
  [49451] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3672), 1,
      anon_sym_RBRACK,
  [49458] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3223), 1,
      anon_sym_LBRACE,
  [49465] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3674), 1,
      anon_sym_LPAREN,
  [49472] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3676), 1,
      anon_sym_RPAREN,
  [49479] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3678), 1,
      anon_sym_PIPE,
  [49486] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3011), 1,
      anon_sym_RPAREN,
  [49493] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3680), 1,
      anon_sym_LBRACE,
  [49500] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3682), 1,
      anon_sym_LPAREN,
  [49507] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3684), 1,
      anon_sym_LPAREN,
  [49514] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3686), 1,
      anon_sym_PIPE,
  [49521] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3688), 1,
      anon_sym_LPAREN,
  [49528] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3690), 1,
      anon_sym_LPAREN,
  [49535] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3692), 1,
      anon_sym_SQUOTE,
  [49542] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(3694), 1,
      aux_sym_FormatSequence_token4,
  [49549] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(3696), 1,
      aux_sym_LINESTRING_token1,
  [49556] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3698), 1,
      anon_sym_RPAREN,
  [49563] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3700), 1,
      anon_sym_LBRACE,
  [49570] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3702), 1,
      anon_sym_SQUOTE,
  [49577] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3704), 1,
      anon_sym_RBRACK,
  [49584] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3706), 1,
      anon_sym_LPAREN,
  [49591] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2520), 1,
      anon_sym_RPAREN,
  [49598] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
  [49605] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3710), 1,
      anon_sym_RBRACK,
  [49612] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3712), 1,
      anon_sym_RPAREN,
  [49619] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3714), 1,
      anon_sym_LBRACE,
  [49626] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3716), 1,
      anon_sym_PIPE,
  [49633] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3718), 1,
      anon_sym_RBRACK,
  [49640] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3720), 1,
      anon_sym_LBRACE,
  [49647] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3722), 1,
      anon_sym_SEMI,
  [49654] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(3724), 1,
      aux_sym_LINESTRING_token1,
  [49661] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3726), 1,
      anon_sym_LBRACE,
  [49668] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3399), 1,
      anon_sym_EQ_GT,
  [49675] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3728), 1,
      anon_sym_RBRACK,
  [49682] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3730), 1,
      anon_sym_LBRACE,
  [49689] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3732), 1,
      anon_sym_LBRACE,
  [49696] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3734), 1,
      anon_sym_LPAREN,
  [49703] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3736), 1,
      anon_sym_LPAREN,
  [49710] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2462), 1,
      anon_sym_RPAREN,
  [49717] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3738), 1,
      anon_sym_SQUOTE,
  [49724] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3740), 1,
      anon_sym_RPAREN,
  [49731] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(3742), 1,
      aux_sym_LINESTRING_token1,
  [49738] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3744), 1,
      anon_sym_LPAREN,
  [49745] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3746), 1,
      anon_sym_LPAREN,
  [49752] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3748), 1,
      anon_sym_LPAREN,
  [49759] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(2965), 1,
      anon_sym_RPAREN,
  [49766] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3750), 1,
      anon_sym_LPAREN,
  [49773] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3752), 1,
      anon_sym_PIPE,
  [49780] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3754), 1,
      anon_sym_LPAREN,
  [49787] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3756), 1,
      anon_sym_LPAREN,
  [49794] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3758), 1,
      anon_sym_SQUOTE,
  [49801] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3063), 1,
      anon_sym_RPAREN,
  [49808] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3760), 1,
      anon_sym_LPAREN,
  [49815] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3069), 1,
      anon_sym_RPAREN,
  [49822] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3762), 1,
      anon_sym_LBRACE,
  [49829] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3764), 1,
      anon_sym_EQ_GT,
  [49836] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3766), 1,
      anon_sym_EQ,
  [49843] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3768), 1,
      anon_sym_LPAREN,
  [49850] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3572), 1,
      anon_sym_LBRACE,
  [49857] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3770), 1,
      anon_sym_LPAREN,
  [49864] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3772), 1,
      anon_sym_EQ_GT,
  [49871] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3774), 1,
      anon_sym_LPAREN,
  [49878] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3776), 1,
      anon_sym_PIPE,
  [49885] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3778), 1,
      anon_sym_RBRACK,
  [49892] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3780), 1,
      anon_sym_LPAREN,
  [49899] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3782), 1,
      anon_sym_LPAREN,
  [49906] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3784), 1,
      anon_sym_LPAREN,
  [49913] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3786), 1,
      anon_sym_LPAREN,
  [49920] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3788), 1,
      anon_sym_LPAREN,
  [49927] = 2,
    ACTIONS(137), 1,
      sym_line_comment,
    ACTIONS(3790), 1,
      anon_sym_LPAREN,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(1044)] = 0,
  [SMALL_STATE(1045)] = 75,
  [SMALL_STATE(1046)] = 184,
  [SMALL_STATE(1047)] = 293,
  [SMALL_STATE(1048)] = 376,
  [SMALL_STATE(1049)] = 451,
  [SMALL_STATE(1050)] = 560,
  [SMALL_STATE(1051)] = 635,
  [SMALL_STATE(1052)] = 744,
  [SMALL_STATE(1053)] = 853,
  [SMALL_STATE(1054)] = 928,
  [SMALL_STATE(1055)] = 1037,
  [SMALL_STATE(1056)] = 1120,
  [SMALL_STATE(1057)] = 1203,
  [SMALL_STATE(1058)] = 1283,
  [SMALL_STATE(1059)] = 1385,
  [SMALL_STATE(1060)] = 1459,
  [SMALL_STATE(1061)] = 1543,
  [SMALL_STATE(1062)] = 1679,
  [SMALL_STATE(1063)] = 1753,
  [SMALL_STATE(1064)] = 1841,
  [SMALL_STATE(1065)] = 1931,
  [SMALL_STATE(1066)] = 2065,
  [SMALL_STATE(1067)] = 2139,
  [SMALL_STATE(1068)] = 2235,
  [SMALL_STATE(1069)] = 2371,
  [SMALL_STATE(1070)] = 2505,
  [SMALL_STATE(1071)] = 2639,
  [SMALL_STATE(1072)] = 2743,
  [SMALL_STATE(1073)] = 2823,
  [SMALL_STATE(1074)] = 2927,
  [SMALL_STATE(1075)] = 2999,
  [SMALL_STATE(1076)] = 3099,
  [SMALL_STATE(1077)] = 3203,
  [SMALL_STATE(1078)] = 3273,
  [SMALL_STATE(1079)] = 3343,
  [SMALL_STATE(1080)] = 3477,
  [SMALL_STATE(1081)] = 3551,
  [SMALL_STATE(1082)] = 3655,
  [SMALL_STATE(1083)] = 3729,
  [SMALL_STATE(1084)] = 3799,
  [SMALL_STATE(1085)] = 3869,
  [SMALL_STATE(1086)] = 3943,
  [SMALL_STATE(1087)] = 4017,
  [SMALL_STATE(1088)] = 4091,
  [SMALL_STATE(1089)] = 4160,
  [SMALL_STATE(1090)] = 4229,
  [SMALL_STATE(1091)] = 4298,
  [SMALL_STATE(1092)] = 4367,
  [SMALL_STATE(1093)] = 4436,
  [SMALL_STATE(1094)] = 4505,
  [SMALL_STATE(1095)] = 4574,
  [SMALL_STATE(1096)] = 4677,
  [SMALL_STATE(1097)] = 4746,
  [SMALL_STATE(1098)] = 4815,
  [SMALL_STATE(1099)] = 4884,
  [SMALL_STATE(1100)] = 4953,
  [SMALL_STATE(1101)] = 5022,
  [SMALL_STATE(1102)] = 5091,
  [SMALL_STATE(1103)] = 5160,
  [SMALL_STATE(1104)] = 5229,
  [SMALL_STATE(1105)] = 5298,
  [SMALL_STATE(1106)] = 5367,
  [SMALL_STATE(1107)] = 5436,
  [SMALL_STATE(1108)] = 5505,
  [SMALL_STATE(1109)] = 5574,
  [SMALL_STATE(1110)] = 5643,
  [SMALL_STATE(1111)] = 5712,
  [SMALL_STATE(1112)] = 5781,
  [SMALL_STATE(1113)] = 5850,
  [SMALL_STATE(1114)] = 5919,
  [SMALL_STATE(1115)] = 5988,
  [SMALL_STATE(1116)] = 6057,
  [SMALL_STATE(1117)] = 6126,
  [SMALL_STATE(1118)] = 6195,
  [SMALL_STATE(1119)] = 6264,
  [SMALL_STATE(1120)] = 6333,
  [SMALL_STATE(1121)] = 6402,
  [SMALL_STATE(1122)] = 6471,
  [SMALL_STATE(1123)] = 6540,
  [SMALL_STATE(1124)] = 6609,
  [SMALL_STATE(1125)] = 6678,
  [SMALL_STATE(1126)] = 6747,
  [SMALL_STATE(1127)] = 6816,
  [SMALL_STATE(1128)] = 6885,
  [SMALL_STATE(1129)] = 6988,
  [SMALL_STATE(1130)] = 7059,
  [SMALL_STATE(1131)] = 7132,
  [SMALL_STATE(1132)] = 7201,
  [SMALL_STATE(1133)] = 7270,
  [SMALL_STATE(1134)] = 7339,
  [SMALL_STATE(1135)] = 7408,
  [SMALL_STATE(1136)] = 7511,
  [SMALL_STATE(1137)] = 7580,
  [SMALL_STATE(1138)] = 7649,
  [SMALL_STATE(1139)] = 7718,
  [SMALL_STATE(1140)] = 7787,
  [SMALL_STATE(1141)] = 7866,
  [SMALL_STATE(1142)] = 7935,
  [SMALL_STATE(1143)] = 8004,
  [SMALL_STATE(1144)] = 8073,
  [SMALL_STATE(1145)] = 8142,
  [SMALL_STATE(1146)] = 8211,
  [SMALL_STATE(1147)] = 8280,
  [SMALL_STATE(1148)] = 8349,
  [SMALL_STATE(1149)] = 8418,
  [SMALL_STATE(1150)] = 8487,
  [SMALL_STATE(1151)] = 8556,
  [SMALL_STATE(1152)] = 8625,
  [SMALL_STATE(1153)] = 8696,
  [SMALL_STATE(1154)] = 8765,
  [SMALL_STATE(1155)] = 8834,
  [SMALL_STATE(1156)] = 8937,
  [SMALL_STATE(1157)] = 9006,
  [SMALL_STATE(1158)] = 9075,
  [SMALL_STATE(1159)] = 9144,
  [SMALL_STATE(1160)] = 9245,
  [SMALL_STATE(1161)] = 9314,
  [SMALL_STATE(1162)] = 9413,
  [SMALL_STATE(1163)] = 9482,
  [SMALL_STATE(1164)] = 9551,
  [SMALL_STATE(1165)] = 9620,
  [SMALL_STATE(1166)] = 9689,
  [SMALL_STATE(1167)] = 9758,
  [SMALL_STATE(1168)] = 9827,
  [SMALL_STATE(1169)] = 9896,
  [SMALL_STATE(1170)] = 9965,
  [SMALL_STATE(1171)] = 10034,
  [SMALL_STATE(1172)] = 10103,
  [SMALL_STATE(1173)] = 10172,
  [SMALL_STATE(1174)] = 10241,
  [SMALL_STATE(1175)] = 10310,
  [SMALL_STATE(1176)] = 10379,
  [SMALL_STATE(1177)] = 10448,
  [SMALL_STATE(1178)] = 10517,
  [SMALL_STATE(1179)] = 10586,
  [SMALL_STATE(1180)] = 10655,
  [SMALL_STATE(1181)] = 10724,
  [SMALL_STATE(1182)] = 10793,
  [SMALL_STATE(1183)] = 10862,
  [SMALL_STATE(1184)] = 10931,
  [SMALL_STATE(1185)] = 11000,
  [SMALL_STATE(1186)] = 11069,
  [SMALL_STATE(1187)] = 11138,
  [SMALL_STATE(1188)] = 11233,
  [SMALL_STATE(1189)] = 11302,
  [SMALL_STATE(1190)] = 11391,
  [SMALL_STATE(1191)] = 11460,
  [SMALL_STATE(1192)] = 11529,
  [SMALL_STATE(1193)] = 11598,
  [SMALL_STATE(1194)] = 11667,
  [SMALL_STATE(1195)] = 11736,
  [SMALL_STATE(1196)] = 11805,
  [SMALL_STATE(1197)] = 11874,
  [SMALL_STATE(1198)] = 11943,
  [SMALL_STATE(1199)] = 12030,
  [SMALL_STATE(1200)] = 12113,
  [SMALL_STATE(1201)] = 12188,
  [SMALL_STATE(1202)] = 12267,
  [SMALL_STATE(1203)] = 12335,
  [SMALL_STATE(1204)] = 12403,
  [SMALL_STATE(1205)] = 12471,
  [SMALL_STATE(1206)] = 12539,
  [SMALL_STATE(1207)] = 12607,
  [SMALL_STATE(1208)] = 12675,
  [SMALL_STATE(1209)] = 12743,
  [SMALL_STATE(1210)] = 12811,
  [SMALL_STATE(1211)] = 12879,
  [SMALL_STATE(1212)] = 12947,
  [SMALL_STATE(1213)] = 13015,
  [SMALL_STATE(1214)] = 13083,
  [SMALL_STATE(1215)] = 13151,
  [SMALL_STATE(1216)] = 13219,
  [SMALL_STATE(1217)] = 13289,
  [SMALL_STATE(1218)] = 13357,
  [SMALL_STATE(1219)] = 13425,
  [SMALL_STATE(1220)] = 13493,
  [SMALL_STATE(1221)] = 13561,
  [SMALL_STATE(1222)] = 13629,
  [SMALL_STATE(1223)] = 13697,
  [SMALL_STATE(1224)] = 13765,
  [SMALL_STATE(1225)] = 13833,
  [SMALL_STATE(1226)] = 13901,
  [SMALL_STATE(1227)] = 13969,
  [SMALL_STATE(1228)] = 14037,
  [SMALL_STATE(1229)] = 14105,
  [SMALL_STATE(1230)] = 14173,
  [SMALL_STATE(1231)] = 14241,
  [SMALL_STATE(1232)] = 14309,
  [SMALL_STATE(1233)] = 14377,
  [SMALL_STATE(1234)] = 14445,
  [SMALL_STATE(1235)] = 14513,
  [SMALL_STATE(1236)] = 14581,
  [SMALL_STATE(1237)] = 14649,
  [SMALL_STATE(1238)] = 14717,
  [SMALL_STATE(1239)] = 14785,
  [SMALL_STATE(1240)] = 14853,
  [SMALL_STATE(1241)] = 14921,
  [SMALL_STATE(1242)] = 14989,
  [SMALL_STATE(1243)] = 15057,
  [SMALL_STATE(1244)] = 15125,
  [SMALL_STATE(1245)] = 15193,
  [SMALL_STATE(1246)] = 15261,
  [SMALL_STATE(1247)] = 15329,
  [SMALL_STATE(1248)] = 15397,
  [SMALL_STATE(1249)] = 15465,
  [SMALL_STATE(1250)] = 15533,
  [SMALL_STATE(1251)] = 15601,
  [SMALL_STATE(1252)] = 15669,
  [SMALL_STATE(1253)] = 15737,
  [SMALL_STATE(1254)] = 15805,
  [SMALL_STATE(1255)] = 15873,
  [SMALL_STATE(1256)] = 15941,
  [SMALL_STATE(1257)] = 16009,
  [SMALL_STATE(1258)] = 16077,
  [SMALL_STATE(1259)] = 16145,
  [SMALL_STATE(1260)] = 16213,
  [SMALL_STATE(1261)] = 16281,
  [SMALL_STATE(1262)] = 16349,
  [SMALL_STATE(1263)] = 16417,
  [SMALL_STATE(1264)] = 16485,
  [SMALL_STATE(1265)] = 16553,
  [SMALL_STATE(1266)] = 16621,
  [SMALL_STATE(1267)] = 16689,
  [SMALL_STATE(1268)] = 16757,
  [SMALL_STATE(1269)] = 16825,
  [SMALL_STATE(1270)] = 16893,
  [SMALL_STATE(1271)] = 16961,
  [SMALL_STATE(1272)] = 17029,
  [SMALL_STATE(1273)] = 17097,
  [SMALL_STATE(1274)] = 17165,
  [SMALL_STATE(1275)] = 17233,
  [SMALL_STATE(1276)] = 17301,
  [SMALL_STATE(1277)] = 17370,
  [SMALL_STATE(1278)] = 17441,
  [SMALL_STATE(1279)] = 17516,
  [SMALL_STATE(1280)] = 17591,
  [SMALL_STATE(1281)] = 17660,
  [SMALL_STATE(1282)] = 17729,
  [SMALL_STATE(1283)] = 17804,
  [SMALL_STATE(1284)] = 17874,
  [SMALL_STATE(1285)] = 17978,
  [SMALL_STATE(1286)] = 18043,
  [SMALL_STATE(1287)] = 18108,
  [SMALL_STATE(1288)] = 18213,
  [SMALL_STATE(1289)] = 18278,
  [SMALL_STATE(1290)] = 18343,
  [SMALL_STATE(1291)] = 18448,
  [SMALL_STATE(1292)] = 18553,
  [SMALL_STATE(1293)] = 18622,
  [SMALL_STATE(1294)] = 18691,
  [SMALL_STATE(1295)] = 18756,
  [SMALL_STATE(1296)] = 18825,
  [SMALL_STATE(1297)] = 18890,
  [SMALL_STATE(1298)] = 18955,
  [SMALL_STATE(1299)] = 19020,
  [SMALL_STATE(1300)] = 19085,
  [SMALL_STATE(1301)] = 19150,
  [SMALL_STATE(1302)] = 19215,
  [SMALL_STATE(1303)] = 19285,
  [SMALL_STATE(1304)] = 19355,
  [SMALL_STATE(1305)] = 19425,
  [SMALL_STATE(1306)] = 19495,
  [SMALL_STATE(1307)] = 19565,
  [SMALL_STATE(1308)] = 19635,
  [SMALL_STATE(1309)] = 19705,
  [SMALL_STATE(1310)] = 19769,
  [SMALL_STATE(1311)] = 19839,
  [SMALL_STATE(1312)] = 19909,
  [SMALL_STATE(1313)] = 19973,
  [SMALL_STATE(1314)] = 20043,
  [SMALL_STATE(1315)] = 20113,
  [SMALL_STATE(1316)] = 20183,
  [SMALL_STATE(1317)] = 20253,
  [SMALL_STATE(1318)] = 20323,
  [SMALL_STATE(1319)] = 20386,
  [SMALL_STATE(1320)] = 20449,
  [SMALL_STATE(1321)] = 20512,
  [SMALL_STATE(1322)] = 20575,
  [SMALL_STATE(1323)] = 20638,
  [SMALL_STATE(1324)] = 20701,
  [SMALL_STATE(1325)] = 20764,
  [SMALL_STATE(1326)] = 20827,
  [SMALL_STATE(1327)] = 20890,
  [SMALL_STATE(1328)] = 20953,
  [SMALL_STATE(1329)] = 21016,
  [SMALL_STATE(1330)] = 21079,
  [SMALL_STATE(1331)] = 21142,
  [SMALL_STATE(1332)] = 21205,
  [SMALL_STATE(1333)] = 21268,
  [SMALL_STATE(1334)] = 21331,
  [SMALL_STATE(1335)] = 21432,
  [SMALL_STATE(1336)] = 21495,
  [SMALL_STATE(1337)] = 21558,
  [SMALL_STATE(1338)] = 21621,
  [SMALL_STATE(1339)] = 21684,
  [SMALL_STATE(1340)] = 21747,
  [SMALL_STATE(1341)] = 21810,
  [SMALL_STATE(1342)] = 21873,
  [SMALL_STATE(1343)] = 21936,
  [SMALL_STATE(1344)] = 21999,
  [SMALL_STATE(1345)] = 22062,
  [SMALL_STATE(1346)] = 22126,
  [SMALL_STATE(1347)] = 22190,
  [SMALL_STATE(1348)] = 22254,
  [SMALL_STATE(1349)] = 22318,
  [SMALL_STATE(1350)] = 22382,
  [SMALL_STATE(1351)] = 22446,
  [SMALL_STATE(1352)] = 22510,
  [SMALL_STATE(1353)] = 22574,
  [SMALL_STATE(1354)] = 22638,
  [SMALL_STATE(1355)] = 22702,
  [SMALL_STATE(1356)] = 22766,
  [SMALL_STATE(1357)] = 22830,
  [SMALL_STATE(1358)] = 22894,
  [SMALL_STATE(1359)] = 22958,
  [SMALL_STATE(1360)] = 23020,
  [SMALL_STATE(1361)] = 23084,
  [SMALL_STATE(1362)] = 23147,
  [SMALL_STATE(1363)] = 23207,
  [SMALL_STATE(1364)] = 23267,
  [SMALL_STATE(1365)] = 23327,
  [SMALL_STATE(1366)] = 23387,
  [SMALL_STATE(1367)] = 23447,
  [SMALL_STATE(1368)] = 23507,
  [SMALL_STATE(1369)] = 23567,
  [SMALL_STATE(1370)] = 23627,
  [SMALL_STATE(1371)] = 23687,
  [SMALL_STATE(1372)] = 23747,
  [SMALL_STATE(1373)] = 23807,
  [SMALL_STATE(1374)] = 23867,
  [SMALL_STATE(1375)] = 23927,
  [SMALL_STATE(1376)] = 23987,
  [SMALL_STATE(1377)] = 24047,
  [SMALL_STATE(1378)] = 24107,
  [SMALL_STATE(1379)] = 24167,
  [SMALL_STATE(1380)] = 24227,
  [SMALL_STATE(1381)] = 24287,
  [SMALL_STATE(1382)] = 24347,
  [SMALL_STATE(1383)] = 24407,
  [SMALL_STATE(1384)] = 24472,
  [SMALL_STATE(1385)] = 24535,
  [SMALL_STATE(1386)] = 24600,
  [SMALL_STATE(1387)] = 24665,
  [SMALL_STATE(1388)] = 24729,
  [SMALL_STATE(1389)] = 24793,
  [SMALL_STATE(1390)] = 24857,
  [SMALL_STATE(1391)] = 24912,
  [SMALL_STATE(1392)] = 24966,
  [SMALL_STATE(1393)] = 25020,
  [SMALL_STATE(1394)] = 25074,
  [SMALL_STATE(1395)] = 25128,
  [SMALL_STATE(1396)] = 25182,
  [SMALL_STATE(1397)] = 25236,
  [SMALL_STATE(1398)] = 25308,
  [SMALL_STATE(1399)] = 25362,
  [SMALL_STATE(1400)] = 25416,
  [SMALL_STATE(1401)] = 25470,
  [SMALL_STATE(1402)] = 25524,
  [SMALL_STATE(1403)] = 25578,
  [SMALL_STATE(1404)] = 25632,
  [SMALL_STATE(1405)] = 25686,
  [SMALL_STATE(1406)] = 25740,
  [SMALL_STATE(1407)] = 25806,
  [SMALL_STATE(1408)] = 25860,
  [SMALL_STATE(1409)] = 25926,
  [SMALL_STATE(1410)] = 25989,
  [SMALL_STATE(1411)] = 26052,
  [SMALL_STATE(1412)] = 26113,
  [SMALL_STATE(1413)] = 26176,
  [SMALL_STATE(1414)] = 26239,
  [SMALL_STATE(1415)] = 26302,
  [SMALL_STATE(1416)] = 26365,
  [SMALL_STATE(1417)] = 26428,
  [SMALL_STATE(1418)] = 26481,
  [SMALL_STATE(1419)] = 26537,
  [SMALL_STATE(1420)] = 26605,
  [SMALL_STATE(1421)] = 26661,
  [SMALL_STATE(1422)] = 26722,
  [SMALL_STATE(1423)] = 26783,
  [SMALL_STATE(1424)] = 26846,
  [SMALL_STATE(1425)] = 26907,
  [SMALL_STATE(1426)] = 26962,
  [SMALL_STATE(1427)] = 27027,
  [SMALL_STATE(1428)] = 27092,
  [SMALL_STATE(1429)] = 27147,
  [SMALL_STATE(1430)] = 27197,
  [SMALL_STATE(1431)] = 27255,
  [SMALL_STATE(1432)] = 27305,
  [SMALL_STATE(1433)] = 27359,
  [SMALL_STATE(1434)] = 27411,
  [SMALL_STATE(1435)] = 27461,
  [SMALL_STATE(1436)] = 27511,
  [SMALL_STATE(1437)] = 27561,
  [SMALL_STATE(1438)] = 27611,
  [SMALL_STATE(1439)] = 27665,
  [SMALL_STATE(1440)] = 27719,
  [SMALL_STATE(1441)] = 27769,
  [SMALL_STATE(1442)] = 27823,
  [SMALL_STATE(1443)] = 27873,
  [SMALL_STATE(1444)] = 27922,
  [SMALL_STATE(1445)] = 27971,
  [SMALL_STATE(1446)] = 28020,
  [SMALL_STATE(1447)] = 28069,
  [SMALL_STATE(1448)] = 28118,
  [SMALL_STATE(1449)] = 28167,
  [SMALL_STATE(1450)] = 28216,
  [SMALL_STATE(1451)] = 28265,
  [SMALL_STATE(1452)] = 28314,
  [SMALL_STATE(1453)] = 28363,
  [SMALL_STATE(1454)] = 28412,
  [SMALL_STATE(1455)] = 28461,
  [SMALL_STATE(1456)] = 28510,
  [SMALL_STATE(1457)] = 28559,
  [SMALL_STATE(1458)] = 28608,
  [SMALL_STATE(1459)] = 28657,
  [SMALL_STATE(1460)] = 28706,
  [SMALL_STATE(1461)] = 28755,
  [SMALL_STATE(1462)] = 28804,
  [SMALL_STATE(1463)] = 28853,
  [SMALL_STATE(1464)] = 28902,
  [SMALL_STATE(1465)] = 28951,
  [SMALL_STATE(1466)] = 29000,
  [SMALL_STATE(1467)] = 29049,
  [SMALL_STATE(1468)] = 29098,
  [SMALL_STATE(1469)] = 29147,
  [SMALL_STATE(1470)] = 29196,
  [SMALL_STATE(1471)] = 29245,
  [SMALL_STATE(1472)] = 29294,
  [SMALL_STATE(1473)] = 29343,
  [SMALL_STATE(1474)] = 29392,
  [SMALL_STATE(1475)] = 29441,
  [SMALL_STATE(1476)] = 29490,
  [SMALL_STATE(1477)] = 29539,
  [SMALL_STATE(1478)] = 29588,
  [SMALL_STATE(1479)] = 29637,
  [SMALL_STATE(1480)] = 29686,
  [SMALL_STATE(1481)] = 29735,
  [SMALL_STATE(1482)] = 29784,
  [SMALL_STATE(1483)] = 29833,
  [SMALL_STATE(1484)] = 29882,
  [SMALL_STATE(1485)] = 29931,
  [SMALL_STATE(1486)] = 29980,
  [SMALL_STATE(1487)] = 30029,
  [SMALL_STATE(1488)] = 30078,
  [SMALL_STATE(1489)] = 30127,
  [SMALL_STATE(1490)] = 30176,
  [SMALL_STATE(1491)] = 30225,
  [SMALL_STATE(1492)] = 30274,
  [SMALL_STATE(1493)] = 30323,
  [SMALL_STATE(1494)] = 30372,
  [SMALL_STATE(1495)] = 30421,
  [SMALL_STATE(1496)] = 30470,
  [SMALL_STATE(1497)] = 30519,
  [SMALL_STATE(1498)] = 30568,
  [SMALL_STATE(1499)] = 30617,
  [SMALL_STATE(1500)] = 30666,
  [SMALL_STATE(1501)] = 30715,
  [SMALL_STATE(1502)] = 30764,
  [SMALL_STATE(1503)] = 30813,
  [SMALL_STATE(1504)] = 30862,
  [SMALL_STATE(1505)] = 30911,
  [SMALL_STATE(1506)] = 30962,
  [SMALL_STATE(1507)] = 31011,
  [SMALL_STATE(1508)] = 31060,
  [SMALL_STATE(1509)] = 31109,
  [SMALL_STATE(1510)] = 31158,
  [SMALL_STATE(1511)] = 31207,
  [SMALL_STATE(1512)] = 31256,
  [SMALL_STATE(1513)] = 31305,
  [SMALL_STATE(1514)] = 31354,
  [SMALL_STATE(1515)] = 31403,
  [SMALL_STATE(1516)] = 31452,
  [SMALL_STATE(1517)] = 31501,
  [SMALL_STATE(1518)] = 31550,
  [SMALL_STATE(1519)] = 31599,
  [SMALL_STATE(1520)] = 31648,
  [SMALL_STATE(1521)] = 31697,
  [SMALL_STATE(1522)] = 31746,
  [SMALL_STATE(1523)] = 31795,
  [SMALL_STATE(1524)] = 31844,
  [SMALL_STATE(1525)] = 31893,
  [SMALL_STATE(1526)] = 31942,
  [SMALL_STATE(1527)] = 31991,
  [SMALL_STATE(1528)] = 32040,
  [SMALL_STATE(1529)] = 32089,
  [SMALL_STATE(1530)] = 32138,
  [SMALL_STATE(1531)] = 32187,
  [SMALL_STATE(1532)] = 32236,
  [SMALL_STATE(1533)] = 32285,
  [SMALL_STATE(1534)] = 32334,
  [SMALL_STATE(1535)] = 32383,
  [SMALL_STATE(1536)] = 32433,
  [SMALL_STATE(1537)] = 32481,
  [SMALL_STATE(1538)] = 32567,
  [SMALL_STATE(1539)] = 32653,
  [SMALL_STATE(1540)] = 32739,
  [SMALL_STATE(1541)] = 32825,
  [SMALL_STATE(1542)] = 32911,
  [SMALL_STATE(1543)] = 32997,
  [SMALL_STATE(1544)] = 33072,
  [SMALL_STATE(1545)] = 33141,
  [SMALL_STATE(1546)] = 33222,
  [SMALL_STATE(1547)] = 33279,
  [SMALL_STATE(1548)] = 33360,
  [SMALL_STATE(1549)] = 33417,
  [SMALL_STATE(1550)] = 33498,
  [SMALL_STATE(1551)] = 33559,
  [SMALL_STATE(1552)] = 33624,
  [SMALL_STATE(1553)] = 33705,
  [SMALL_STATE(1554)] = 33786,
  [SMALL_STATE(1555)] = 33867,
  [SMALL_STATE(1556)] = 33946,
  [SMALL_STATE(1557)] = 34030,
  [SMALL_STATE(1558)] = 34090,
  [SMALL_STATE(1559)] = 34170,
  [SMALL_STATE(1560)] = 34254,
  [SMALL_STATE(1561)] = 34338,
  [SMALL_STATE(1562)] = 34422,
  [SMALL_STATE(1563)] = 34506,
  [SMALL_STATE(1564)] = 34562,
  [SMALL_STATE(1565)] = 34646,
  [SMALL_STATE(1566)] = 34730,
  [SMALL_STATE(1567)] = 34814,
  [SMALL_STATE(1568)] = 34898,
  [SMALL_STATE(1569)] = 34982,
  [SMALL_STATE(1570)] = 35062,
  [SMALL_STATE(1571)] = 35142,
  [SMALL_STATE(1572)] = 35222,
  [SMALL_STATE(1573)] = 35306,
  [SMALL_STATE(1574)] = 35386,
  [SMALL_STATE(1575)] = 35468,
  [SMALL_STATE(1576)] = 35552,
  [SMALL_STATE(1577)] = 35608,
  [SMALL_STATE(1578)] = 35692,
  [SMALL_STATE(1579)] = 35776,
  [SMALL_STATE(1580)] = 35858,
  [SMALL_STATE(1581)] = 35942,
  [SMALL_STATE(1582)] = 36006,
  [SMALL_STATE(1583)] = 36090,
  [SMALL_STATE(1584)] = 36174,
  [SMALL_STATE(1585)] = 36258,
  [SMALL_STATE(1586)] = 36338,
  [SMALL_STATE(1587)] = 36406,
  [SMALL_STATE(1588)] = 36480,
  [SMALL_STATE(1589)] = 36564,
  [SMALL_STATE(1590)] = 36648,
  [SMALL_STATE(1591)] = 36732,
  [SMALL_STATE(1592)] = 36810,
  [SMALL_STATE(1593)] = 36891,
  [SMALL_STATE(1594)] = 36972,
  [SMALL_STATE(1595)] = 37051,
  [SMALL_STATE(1596)] = 37132,
  [SMALL_STATE(1597)] = 37213,
  [SMALL_STATE(1598)] = 37294,
  [SMALL_STATE(1599)] = 37375,
  [SMALL_STATE(1600)] = 37454,
  [SMALL_STATE(1601)] = 37535,
  [SMALL_STATE(1602)] = 37614,
  [SMALL_STATE(1603)] = 37695,
  [SMALL_STATE(1604)] = 37774,
  [SMALL_STATE(1605)] = 37852,
  [SMALL_STATE(1606)] = 37930,
  [SMALL_STATE(1607)] = 38008,
  [SMALL_STATE(1608)] = 38086,
  [SMALL_STATE(1609)] = 38164,
  [SMALL_STATE(1610)] = 38242,
  [SMALL_STATE(1611)] = 38320,
  [SMALL_STATE(1612)] = 38398,
  [SMALL_STATE(1613)] = 38476,
  [SMALL_STATE(1614)] = 38554,
  [SMALL_STATE(1615)] = 38632,
  [SMALL_STATE(1616)] = 38710,
  [SMALL_STATE(1617)] = 38788,
  [SMALL_STATE(1618)] = 38866,
  [SMALL_STATE(1619)] = 38944,
  [SMALL_STATE(1620)] = 39022,
  [SMALL_STATE(1621)] = 39100,
  [SMALL_STATE(1622)] = 39178,
  [SMALL_STATE(1623)] = 39256,
  [SMALL_STATE(1624)] = 39334,
  [SMALL_STATE(1625)] = 39412,
  [SMALL_STATE(1626)] = 39490,
  [SMALL_STATE(1627)] = 39568,
  [SMALL_STATE(1628)] = 39646,
  [SMALL_STATE(1629)] = 39724,
  [SMALL_STATE(1630)] = 39802,
  [SMALL_STATE(1631)] = 39880,
  [SMALL_STATE(1632)] = 39958,
  [SMALL_STATE(1633)] = 40006,
  [SMALL_STATE(1634)] = 40084,
  [SMALL_STATE(1635)] = 40162,
  [SMALL_STATE(1636)] = 40240,
  [SMALL_STATE(1637)] = 40318,
  [SMALL_STATE(1638)] = 40396,
  [SMALL_STATE(1639)] = 40474,
  [SMALL_STATE(1640)] = 40552,
  [SMALL_STATE(1641)] = 40630,
  [SMALL_STATE(1642)] = 40708,
  [SMALL_STATE(1643)] = 40786,
  [SMALL_STATE(1644)] = 40864,
  [SMALL_STATE(1645)] = 40912,
  [SMALL_STATE(1646)] = 40990,
  [SMALL_STATE(1647)] = 41068,
  [SMALL_STATE(1648)] = 41146,
  [SMALL_STATE(1649)] = 41224,
  [SMALL_STATE(1650)] = 41302,
  [SMALL_STATE(1651)] = 41380,
  [SMALL_STATE(1652)] = 41458,
  [SMALL_STATE(1653)] = 41536,
  [SMALL_STATE(1654)] = 41614,
  [SMALL_STATE(1655)] = 41656,
  [SMALL_STATE(1656)] = 41698,
  [SMALL_STATE(1657)] = 41740,
  [SMALL_STATE(1658)] = 41782,
  [SMALL_STATE(1659)] = 41824,
  [SMALL_STATE(1660)] = 41866,
  [SMALL_STATE(1661)] = 41908,
  [SMALL_STATE(1662)] = 41950,
  [SMALL_STATE(1663)] = 41992,
  [SMALL_STATE(1664)] = 42034,
  [SMALL_STATE(1665)] = 42076,
  [SMALL_STATE(1666)] = 42117,
  [SMALL_STATE(1667)] = 42163,
  [SMALL_STATE(1668)] = 42205,
  [SMALL_STATE(1669)] = 42236,
  [SMALL_STATE(1670)] = 42275,
  [SMALL_STATE(1671)] = 42312,
  [SMALL_STATE(1672)] = 42349,
  [SMALL_STATE(1673)] = 42388,
  [SMALL_STATE(1674)] = 42419,
  [SMALL_STATE(1675)] = 42456,
  [SMALL_STATE(1676)] = 42487,
  [SMALL_STATE(1677)] = 42524,
  [SMALL_STATE(1678)] = 42561,
  [SMALL_STATE(1679)] = 42598,
  [SMALL_STATE(1680)] = 42634,
  [SMALL_STATE(1681)] = 42670,
  [SMALL_STATE(1682)] = 42699,
  [SMALL_STATE(1683)] = 42728,
  [SMALL_STATE(1684)] = 42757,
  [SMALL_STATE(1685)] = 42786,
  [SMALL_STATE(1686)] = 42815,
  [SMALL_STATE(1687)] = 42844,
  [SMALL_STATE(1688)] = 42873,
  [SMALL_STATE(1689)] = 42902,
  [SMALL_STATE(1690)] = 42931,
  [SMALL_STATE(1691)] = 42960,
  [SMALL_STATE(1692)] = 42989,
  [SMALL_STATE(1693)] = 43018,
  [SMALL_STATE(1694)] = 43047,
  [SMALL_STATE(1695)] = 43076,
  [SMALL_STATE(1696)] = 43105,
  [SMALL_STATE(1697)] = 43134,
  [SMALL_STATE(1698)] = 43163,
  [SMALL_STATE(1699)] = 43192,
  [SMALL_STATE(1700)] = 43221,
  [SMALL_STATE(1701)] = 43250,
  [SMALL_STATE(1702)] = 43279,
  [SMALL_STATE(1703)] = 43308,
  [SMALL_STATE(1704)] = 43337,
  [SMALL_STATE(1705)] = 43366,
  [SMALL_STATE(1706)] = 43395,
  [SMALL_STATE(1707)] = 43423,
  [SMALL_STATE(1708)] = 43453,
  [SMALL_STATE(1709)] = 43483,
  [SMALL_STATE(1710)] = 43513,
  [SMALL_STATE(1711)] = 43543,
  [SMALL_STATE(1712)] = 43573,
  [SMALL_STATE(1713)] = 43603,
  [SMALL_STATE(1714)] = 43634,
  [SMALL_STATE(1715)] = 43653,
  [SMALL_STATE(1716)] = 43672,
  [SMALL_STATE(1717)] = 43703,
  [SMALL_STATE(1718)] = 43722,
  [SMALL_STATE(1719)] = 43746,
  [SMALL_STATE(1720)] = 43774,
  [SMALL_STATE(1721)] = 43798,
  [SMALL_STATE(1722)] = 43822,
  [SMALL_STATE(1723)] = 43838,
  [SMALL_STATE(1724)] = 43854,
  [SMALL_STATE(1725)] = 43878,
  [SMALL_STATE(1726)] = 43904,
  [SMALL_STATE(1727)] = 43920,
  [SMALL_STATE(1728)] = 43944,
  [SMALL_STATE(1729)] = 43968,
  [SMALL_STATE(1730)] = 43984,
  [SMALL_STATE(1731)] = 44012,
  [SMALL_STATE(1732)] = 44028,
  [SMALL_STATE(1733)] = 44044,
  [SMALL_STATE(1734)] = 44060,
  [SMALL_STATE(1735)] = 44078,
  [SMALL_STATE(1736)] = 44104,
  [SMALL_STATE(1737)] = 44125,
  [SMALL_STATE(1738)] = 44148,
  [SMALL_STATE(1739)] = 44169,
  [SMALL_STATE(1740)] = 44190,
  [SMALL_STATE(1741)] = 44213,
  [SMALL_STATE(1742)] = 44233,
  [SMALL_STATE(1743)] = 44253,
  [SMALL_STATE(1744)] = 44271,
  [SMALL_STATE(1745)] = 44291,
  [SMALL_STATE(1746)] = 44311,
  [SMALL_STATE(1747)] = 44331,
  [SMALL_STATE(1748)] = 44351,
  [SMALL_STATE(1749)] = 44371,
  [SMALL_STATE(1750)] = 44389,
  [SMALL_STATE(1751)] = 44409,
  [SMALL_STATE(1752)] = 44429,
  [SMALL_STATE(1753)] = 44451,
  [SMALL_STATE(1754)] = 44471,
  [SMALL_STATE(1755)] = 44493,
  [SMALL_STATE(1756)] = 44513,
  [SMALL_STATE(1757)] = 44535,
  [SMALL_STATE(1758)] = 44553,
  [SMALL_STATE(1759)] = 44573,
  [SMALL_STATE(1760)] = 44593,
  [SMALL_STATE(1761)] = 44615,
  [SMALL_STATE(1762)] = 44635,
  [SMALL_STATE(1763)] = 44654,
  [SMALL_STATE(1764)] = 44673,
  [SMALL_STATE(1765)] = 44692,
  [SMALL_STATE(1766)] = 44711,
  [SMALL_STATE(1767)] = 44730,
  [SMALL_STATE(1768)] = 44749,
  [SMALL_STATE(1769)] = 44768,
  [SMALL_STATE(1770)] = 44787,
  [SMALL_STATE(1771)] = 44806,
  [SMALL_STATE(1772)] = 44825,
  [SMALL_STATE(1773)] = 44844,
  [SMALL_STATE(1774)] = 44863,
  [SMALL_STATE(1775)] = 44882,
  [SMALL_STATE(1776)] = 44901,
  [SMALL_STATE(1777)] = 44920,
  [SMALL_STATE(1778)] = 44939,
  [SMALL_STATE(1779)] = 44958,
  [SMALL_STATE(1780)] = 44977,
  [SMALL_STATE(1781)] = 44996,
  [SMALL_STATE(1782)] = 45015,
  [SMALL_STATE(1783)] = 45034,
  [SMALL_STATE(1784)] = 45053,
  [SMALL_STATE(1785)] = 45072,
  [SMALL_STATE(1786)] = 45091,
  [SMALL_STATE(1787)] = 45110,
  [SMALL_STATE(1788)] = 45129,
  [SMALL_STATE(1789)] = 45148,
  [SMALL_STATE(1790)] = 45167,
  [SMALL_STATE(1791)] = 45186,
  [SMALL_STATE(1792)] = 45205,
  [SMALL_STATE(1793)] = 45224,
  [SMALL_STATE(1794)] = 45243,
  [SMALL_STATE(1795)] = 45262,
  [SMALL_STATE(1796)] = 45281,
  [SMALL_STATE(1797)] = 45300,
  [SMALL_STATE(1798)] = 45319,
  [SMALL_STATE(1799)] = 45338,
  [SMALL_STATE(1800)] = 45357,
  [SMALL_STATE(1801)] = 45376,
  [SMALL_STATE(1802)] = 45395,
  [SMALL_STATE(1803)] = 45414,
  [SMALL_STATE(1804)] = 45433,
  [SMALL_STATE(1805)] = 45452,
  [SMALL_STATE(1806)] = 45471,
  [SMALL_STATE(1807)] = 45490,
  [SMALL_STATE(1808)] = 45509,
  [SMALL_STATE(1809)] = 45528,
  [SMALL_STATE(1810)] = 45545,
  [SMALL_STATE(1811)] = 45564,
  [SMALL_STATE(1812)] = 45581,
  [SMALL_STATE(1813)] = 45600,
  [SMALL_STATE(1814)] = 45619,
  [SMALL_STATE(1815)] = 45636,
  [SMALL_STATE(1816)] = 45655,
  [SMALL_STATE(1817)] = 45674,
  [SMALL_STATE(1818)] = 45693,
  [SMALL_STATE(1819)] = 45712,
  [SMALL_STATE(1820)] = 45731,
  [SMALL_STATE(1821)] = 45750,
  [SMALL_STATE(1822)] = 45769,
  [SMALL_STATE(1823)] = 45788,
  [SMALL_STATE(1824)] = 45805,
  [SMALL_STATE(1825)] = 45824,
  [SMALL_STATE(1826)] = 45841,
  [SMALL_STATE(1827)] = 45860,
  [SMALL_STATE(1828)] = 45877,
  [SMALL_STATE(1829)] = 45896,
  [SMALL_STATE(1830)] = 45912,
  [SMALL_STATE(1831)] = 45928,
  [SMALL_STATE(1832)] = 45944,
  [SMALL_STATE(1833)] = 45960,
  [SMALL_STATE(1834)] = 45976,
  [SMALL_STATE(1835)] = 45992,
  [SMALL_STATE(1836)] = 46008,
  [SMALL_STATE(1837)] = 46022,
  [SMALL_STATE(1838)] = 46038,
  [SMALL_STATE(1839)] = 46054,
  [SMALL_STATE(1840)] = 46070,
  [SMALL_STATE(1841)] = 46086,
  [SMALL_STATE(1842)] = 46102,
  [SMALL_STATE(1843)] = 46116,
  [SMALL_STATE(1844)] = 46132,
  [SMALL_STATE(1845)] = 46148,
  [SMALL_STATE(1846)] = 46164,
  [SMALL_STATE(1847)] = 46178,
  [SMALL_STATE(1848)] = 46188,
  [SMALL_STATE(1849)] = 46204,
  [SMALL_STATE(1850)] = 46218,
  [SMALL_STATE(1851)] = 46231,
  [SMALL_STATE(1852)] = 46244,
  [SMALL_STATE(1853)] = 46257,
  [SMALL_STATE(1854)] = 46270,
  [SMALL_STATE(1855)] = 46283,
  [SMALL_STATE(1856)] = 46296,
  [SMALL_STATE(1857)] = 46309,
  [SMALL_STATE(1858)] = 46322,
  [SMALL_STATE(1859)] = 46335,
  [SMALL_STATE(1860)] = 46348,
  [SMALL_STATE(1861)] = 46361,
  [SMALL_STATE(1862)] = 46374,
  [SMALL_STATE(1863)] = 46385,
  [SMALL_STATE(1864)] = 46398,
  [SMALL_STATE(1865)] = 46411,
  [SMALL_STATE(1866)] = 46424,
  [SMALL_STATE(1867)] = 46437,
  [SMALL_STATE(1868)] = 46450,
  [SMALL_STATE(1869)] = 46463,
  [SMALL_STATE(1870)] = 46476,
  [SMALL_STATE(1871)] = 46489,
  [SMALL_STATE(1872)] = 46502,
  [SMALL_STATE(1873)] = 46515,
  [SMALL_STATE(1874)] = 46528,
  [SMALL_STATE(1875)] = 46541,
  [SMALL_STATE(1876)] = 46554,
  [SMALL_STATE(1877)] = 46567,
  [SMALL_STATE(1878)] = 46580,
  [SMALL_STATE(1879)] = 46593,
  [SMALL_STATE(1880)] = 46606,
  [SMALL_STATE(1881)] = 46619,
  [SMALL_STATE(1882)] = 46632,
  [SMALL_STATE(1883)] = 46645,
  [SMALL_STATE(1884)] = 46658,
  [SMALL_STATE(1885)] = 46671,
  [SMALL_STATE(1886)] = 46684,
  [SMALL_STATE(1887)] = 46697,
  [SMALL_STATE(1888)] = 46710,
  [SMALL_STATE(1889)] = 46723,
  [SMALL_STATE(1890)] = 46736,
  [SMALL_STATE(1891)] = 46749,
  [SMALL_STATE(1892)] = 46762,
  [SMALL_STATE(1893)] = 46775,
  [SMALL_STATE(1894)] = 46788,
  [SMALL_STATE(1895)] = 46801,
  [SMALL_STATE(1896)] = 46814,
  [SMALL_STATE(1897)] = 46827,
  [SMALL_STATE(1898)] = 46840,
  [SMALL_STATE(1899)] = 46853,
  [SMALL_STATE(1900)] = 46866,
  [SMALL_STATE(1901)] = 46879,
  [SMALL_STATE(1902)] = 46892,
  [SMALL_STATE(1903)] = 46905,
  [SMALL_STATE(1904)] = 46918,
  [SMALL_STATE(1905)] = 46931,
  [SMALL_STATE(1906)] = 46940,
  [SMALL_STATE(1907)] = 46953,
  [SMALL_STATE(1908)] = 46966,
  [SMALL_STATE(1909)] = 46979,
  [SMALL_STATE(1910)] = 46988,
  [SMALL_STATE(1911)] = 46997,
  [SMALL_STATE(1912)] = 47010,
  [SMALL_STATE(1913)] = 47023,
  [SMALL_STATE(1914)] = 47036,
  [SMALL_STATE(1915)] = 47049,
  [SMALL_STATE(1916)] = 47062,
  [SMALL_STATE(1917)] = 47071,
  [SMALL_STATE(1918)] = 47084,
  [SMALL_STATE(1919)] = 47097,
  [SMALL_STATE(1920)] = 47110,
  [SMALL_STATE(1921)] = 47123,
  [SMALL_STATE(1922)] = 47136,
  [SMALL_STATE(1923)] = 47145,
  [SMALL_STATE(1924)] = 47158,
  [SMALL_STATE(1925)] = 47171,
  [SMALL_STATE(1926)] = 47184,
  [SMALL_STATE(1927)] = 47197,
  [SMALL_STATE(1928)] = 47210,
  [SMALL_STATE(1929)] = 47223,
  [SMALL_STATE(1930)] = 47236,
  [SMALL_STATE(1931)] = 47245,
  [SMALL_STATE(1932)] = 47258,
  [SMALL_STATE(1933)] = 47271,
  [SMALL_STATE(1934)] = 47284,
  [SMALL_STATE(1935)] = 47297,
  [SMALL_STATE(1936)] = 47310,
  [SMALL_STATE(1937)] = 47323,
  [SMALL_STATE(1938)] = 47336,
  [SMALL_STATE(1939)] = 47349,
  [SMALL_STATE(1940)] = 47362,
  [SMALL_STATE(1941)] = 47375,
  [SMALL_STATE(1942)] = 47388,
  [SMALL_STATE(1943)] = 47401,
  [SMALL_STATE(1944)] = 47414,
  [SMALL_STATE(1945)] = 47427,
  [SMALL_STATE(1946)] = 47440,
  [SMALL_STATE(1947)] = 47453,
  [SMALL_STATE(1948)] = 47466,
  [SMALL_STATE(1949)] = 47479,
  [SMALL_STATE(1950)] = 47492,
  [SMALL_STATE(1951)] = 47505,
  [SMALL_STATE(1952)] = 47518,
  [SMALL_STATE(1953)] = 47531,
  [SMALL_STATE(1954)] = 47544,
  [SMALL_STATE(1955)] = 47557,
  [SMALL_STATE(1956)] = 47570,
  [SMALL_STATE(1957)] = 47583,
  [SMALL_STATE(1958)] = 47596,
  [SMALL_STATE(1959)] = 47609,
  [SMALL_STATE(1960)] = 47622,
  [SMALL_STATE(1961)] = 47635,
  [SMALL_STATE(1962)] = 47648,
  [SMALL_STATE(1963)] = 47661,
  [SMALL_STATE(1964)] = 47674,
  [SMALL_STATE(1965)] = 47687,
  [SMALL_STATE(1966)] = 47700,
  [SMALL_STATE(1967)] = 47713,
  [SMALL_STATE(1968)] = 47726,
  [SMALL_STATE(1969)] = 47739,
  [SMALL_STATE(1970)] = 47752,
  [SMALL_STATE(1971)] = 47765,
  [SMALL_STATE(1972)] = 47778,
  [SMALL_STATE(1973)] = 47791,
  [SMALL_STATE(1974)] = 47804,
  [SMALL_STATE(1975)] = 47817,
  [SMALL_STATE(1976)] = 47830,
  [SMALL_STATE(1977)] = 47843,
  [SMALL_STATE(1978)] = 47856,
  [SMALL_STATE(1979)] = 47869,
  [SMALL_STATE(1980)] = 47882,
  [SMALL_STATE(1981)] = 47895,
  [SMALL_STATE(1982)] = 47908,
  [SMALL_STATE(1983)] = 47921,
  [SMALL_STATE(1984)] = 47934,
  [SMALL_STATE(1985)] = 47947,
  [SMALL_STATE(1986)] = 47960,
  [SMALL_STATE(1987)] = 47973,
  [SMALL_STATE(1988)] = 47986,
  [SMALL_STATE(1989)] = 47999,
  [SMALL_STATE(1990)] = 48012,
  [SMALL_STATE(1991)] = 48025,
  [SMALL_STATE(1992)] = 48038,
  [SMALL_STATE(1993)] = 48051,
  [SMALL_STATE(1994)] = 48064,
  [SMALL_STATE(1995)] = 48077,
  [SMALL_STATE(1996)] = 48086,
  [SMALL_STATE(1997)] = 48099,
  [SMALL_STATE(1998)] = 48112,
  [SMALL_STATE(1999)] = 48125,
  [SMALL_STATE(2000)] = 48138,
  [SMALL_STATE(2001)] = 48151,
  [SMALL_STATE(2002)] = 48164,
  [SMALL_STATE(2003)] = 48177,
  [SMALL_STATE(2004)] = 48188,
  [SMALL_STATE(2005)] = 48201,
  [SMALL_STATE(2006)] = 48214,
  [SMALL_STATE(2007)] = 48227,
  [SMALL_STATE(2008)] = 48240,
  [SMALL_STATE(2009)] = 48253,
  [SMALL_STATE(2010)] = 48264,
  [SMALL_STATE(2011)] = 48277,
  [SMALL_STATE(2012)] = 48290,
  [SMALL_STATE(2013)] = 48303,
  [SMALL_STATE(2014)] = 48316,
  [SMALL_STATE(2015)] = 48329,
  [SMALL_STATE(2016)] = 48342,
  [SMALL_STATE(2017)] = 48352,
  [SMALL_STATE(2018)] = 48362,
  [SMALL_STATE(2019)] = 48370,
  [SMALL_STATE(2020)] = 48378,
  [SMALL_STATE(2021)] = 48386,
  [SMALL_STATE(2022)] = 48396,
  [SMALL_STATE(2023)] = 48406,
  [SMALL_STATE(2024)] = 48416,
  [SMALL_STATE(2025)] = 48426,
  [SMALL_STATE(2026)] = 48436,
  [SMALL_STATE(2027)] = 48446,
  [SMALL_STATE(2028)] = 48456,
  [SMALL_STATE(2029)] = 48466,
  [SMALL_STATE(2030)] = 48474,
  [SMALL_STATE(2031)] = 48484,
  [SMALL_STATE(2032)] = 48494,
  [SMALL_STATE(2033)] = 48504,
  [SMALL_STATE(2034)] = 48514,
  [SMALL_STATE(2035)] = 48524,
  [SMALL_STATE(2036)] = 48534,
  [SMALL_STATE(2037)] = 48542,
  [SMALL_STATE(2038)] = 48550,
  [SMALL_STATE(2039)] = 48560,
  [SMALL_STATE(2040)] = 48570,
  [SMALL_STATE(2041)] = 48578,
  [SMALL_STATE(2042)] = 48588,
  [SMALL_STATE(2043)] = 48598,
  [SMALL_STATE(2044)] = 48608,
  [SMALL_STATE(2045)] = 48618,
  [SMALL_STATE(2046)] = 48628,
  [SMALL_STATE(2047)] = 48636,
  [SMALL_STATE(2048)] = 48646,
  [SMALL_STATE(2049)] = 48654,
  [SMALL_STATE(2050)] = 48664,
  [SMALL_STATE(2051)] = 48674,
  [SMALL_STATE(2052)] = 48684,
  [SMALL_STATE(2053)] = 48692,
  [SMALL_STATE(2054)] = 48702,
  [SMALL_STATE(2055)] = 48710,
  [SMALL_STATE(2056)] = 48718,
  [SMALL_STATE(2057)] = 48726,
  [SMALL_STATE(2058)] = 48734,
  [SMALL_STATE(2059)] = 48744,
  [SMALL_STATE(2060)] = 48754,
  [SMALL_STATE(2061)] = 48764,
  [SMALL_STATE(2062)] = 48772,
  [SMALL_STATE(2063)] = 48782,
  [SMALL_STATE(2064)] = 48792,
  [SMALL_STATE(2065)] = 48802,
  [SMALL_STATE(2066)] = 48812,
  [SMALL_STATE(2067)] = 48822,
  [SMALL_STATE(2068)] = 48832,
  [SMALL_STATE(2069)] = 48842,
  [SMALL_STATE(2070)] = 48850,
  [SMALL_STATE(2071)] = 48860,
  [SMALL_STATE(2072)] = 48868,
  [SMALL_STATE(2073)] = 48878,
  [SMALL_STATE(2074)] = 48888,
  [SMALL_STATE(2075)] = 48898,
  [SMALL_STATE(2076)] = 48906,
  [SMALL_STATE(2077)] = 48916,
  [SMALL_STATE(2078)] = 48926,
  [SMALL_STATE(2079)] = 48936,
  [SMALL_STATE(2080)] = 48946,
  [SMALL_STATE(2081)] = 48954,
  [SMALL_STATE(2082)] = 48964,
  [SMALL_STATE(2083)] = 48974,
  [SMALL_STATE(2084)] = 48984,
  [SMALL_STATE(2085)] = 48992,
  [SMALL_STATE(2086)] = 49002,
  [SMALL_STATE(2087)] = 49010,
  [SMALL_STATE(2088)] = 49020,
  [SMALL_STATE(2089)] = 49030,
  [SMALL_STATE(2090)] = 49040,
  [SMALL_STATE(2091)] = 49048,
  [SMALL_STATE(2092)] = 49056,
  [SMALL_STATE(2093)] = 49066,
  [SMALL_STATE(2094)] = 49076,
  [SMALL_STATE(2095)] = 49086,
  [SMALL_STATE(2096)] = 49096,
  [SMALL_STATE(2097)] = 49106,
  [SMALL_STATE(2098)] = 49116,
  [SMALL_STATE(2099)] = 49126,
  [SMALL_STATE(2100)] = 49136,
  [SMALL_STATE(2101)] = 49143,
  [SMALL_STATE(2102)] = 49150,
  [SMALL_STATE(2103)] = 49157,
  [SMALL_STATE(2104)] = 49164,
  [SMALL_STATE(2105)] = 49171,
  [SMALL_STATE(2106)] = 49178,
  [SMALL_STATE(2107)] = 49185,
  [SMALL_STATE(2108)] = 49192,
  [SMALL_STATE(2109)] = 49199,
  [SMALL_STATE(2110)] = 49206,
  [SMALL_STATE(2111)] = 49213,
  [SMALL_STATE(2112)] = 49220,
  [SMALL_STATE(2113)] = 49227,
  [SMALL_STATE(2114)] = 49234,
  [SMALL_STATE(2115)] = 49241,
  [SMALL_STATE(2116)] = 49248,
  [SMALL_STATE(2117)] = 49255,
  [SMALL_STATE(2118)] = 49262,
  [SMALL_STATE(2119)] = 49269,
  [SMALL_STATE(2120)] = 49276,
  [SMALL_STATE(2121)] = 49283,
  [SMALL_STATE(2122)] = 49290,
  [SMALL_STATE(2123)] = 49297,
  [SMALL_STATE(2124)] = 49304,
  [SMALL_STATE(2125)] = 49311,
  [SMALL_STATE(2126)] = 49318,
  [SMALL_STATE(2127)] = 49325,
  [SMALL_STATE(2128)] = 49332,
  [SMALL_STATE(2129)] = 49339,
  [SMALL_STATE(2130)] = 49346,
  [SMALL_STATE(2131)] = 49353,
  [SMALL_STATE(2132)] = 49360,
  [SMALL_STATE(2133)] = 49367,
  [SMALL_STATE(2134)] = 49374,
  [SMALL_STATE(2135)] = 49381,
  [SMALL_STATE(2136)] = 49388,
  [SMALL_STATE(2137)] = 49395,
  [SMALL_STATE(2138)] = 49402,
  [SMALL_STATE(2139)] = 49409,
  [SMALL_STATE(2140)] = 49416,
  [SMALL_STATE(2141)] = 49423,
  [SMALL_STATE(2142)] = 49430,
  [SMALL_STATE(2143)] = 49437,
  [SMALL_STATE(2144)] = 49444,
  [SMALL_STATE(2145)] = 49451,
  [SMALL_STATE(2146)] = 49458,
  [SMALL_STATE(2147)] = 49465,
  [SMALL_STATE(2148)] = 49472,
  [SMALL_STATE(2149)] = 49479,
  [SMALL_STATE(2150)] = 49486,
  [SMALL_STATE(2151)] = 49493,
  [SMALL_STATE(2152)] = 49500,
  [SMALL_STATE(2153)] = 49507,
  [SMALL_STATE(2154)] = 49514,
  [SMALL_STATE(2155)] = 49521,
  [SMALL_STATE(2156)] = 49528,
  [SMALL_STATE(2157)] = 49535,
  [SMALL_STATE(2158)] = 49542,
  [SMALL_STATE(2159)] = 49549,
  [SMALL_STATE(2160)] = 49556,
  [SMALL_STATE(2161)] = 49563,
  [SMALL_STATE(2162)] = 49570,
  [SMALL_STATE(2163)] = 49577,
  [SMALL_STATE(2164)] = 49584,
  [SMALL_STATE(2165)] = 49591,
  [SMALL_STATE(2166)] = 49598,
  [SMALL_STATE(2167)] = 49605,
  [SMALL_STATE(2168)] = 49612,
  [SMALL_STATE(2169)] = 49619,
  [SMALL_STATE(2170)] = 49626,
  [SMALL_STATE(2171)] = 49633,
  [SMALL_STATE(2172)] = 49640,
  [SMALL_STATE(2173)] = 49647,
  [SMALL_STATE(2174)] = 49654,
  [SMALL_STATE(2175)] = 49661,
  [SMALL_STATE(2176)] = 49668,
  [SMALL_STATE(2177)] = 49675,
  [SMALL_STATE(2178)] = 49682,
  [SMALL_STATE(2179)] = 49689,
  [SMALL_STATE(2180)] = 49696,
  [SMALL_STATE(2181)] = 49703,
  [SMALL_STATE(2182)] = 49710,
  [SMALL_STATE(2183)] = 49717,
  [SMALL_STATE(2184)] = 49724,
  [SMALL_STATE(2185)] = 49731,
  [SMALL_STATE(2186)] = 49738,
  [SMALL_STATE(2187)] = 49745,
  [SMALL_STATE(2188)] = 49752,
  [SMALL_STATE(2189)] = 49759,
  [SMALL_STATE(2190)] = 49766,
  [SMALL_STATE(2191)] = 49773,
  [SMALL_STATE(2192)] = 49780,
  [SMALL_STATE(2193)] = 49787,
  [SMALL_STATE(2194)] = 49794,
  [SMALL_STATE(2195)] = 49801,
  [SMALL_STATE(2196)] = 49808,
  [SMALL_STATE(2197)] = 49815,
  [SMALL_STATE(2198)] = 49822,
  [SMALL_STATE(2199)] = 49829,
  [SMALL_STATE(2200)] = 49836,
  [SMALL_STATE(2201)] = 49843,
  [SMALL_STATE(2202)] = 49850,
  [SMALL_STATE(2203)] = 49857,
  [SMALL_STATE(2204)] = 49864,
  [SMALL_STATE(2205)] = 49871,
  [SMALL_STATE(2206)] = 49878,
  [SMALL_STATE(2207)] = 49885,
  [SMALL_STATE(2208)] = 49892,
  [SMALL_STATE(2209)] = 49899,
  [SMALL_STATE(2210)] = 49906,
  [SMALL_STATE(2211)] = 49913,
  [SMALL_STATE(2212)] = 49920,
  [SMALL_STATE(2213)] = 49927,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1737),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1750),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1667),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1725),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2028),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1862),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1805),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1867),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1065),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2017),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1037),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1745),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2156),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2155),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2153),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2152),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1403),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2072),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2146),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2074),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1208),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [87] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__PrimaryExpr, 1),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1746),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1727),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1780),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1327),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__PrimaryExpr, 1),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1283),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1807),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2047),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(943),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2208),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2041),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2180),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2181),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2201),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__PrimaryExpr, 2),
  [157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__PrimaryExpr, 2),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1720),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1747),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1721),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1798),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2212),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2038),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1759),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1728),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1768),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2078),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2211),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2043),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(552),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1724),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1775),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1632),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1061),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1762),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2027),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1410),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2213),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2032),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1503),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1440),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1718),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(234),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1706),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(100),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2210),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(46),
  [378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(1746),
  [381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(1706),
  [384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(1780),
  [387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(1327),
  [390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(1917),
  [393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(100),
  [396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(91),
  [399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(83),
  [402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(5),
  [405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(1283),
  [408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(273),
  [411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(6),
  [414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(32),
  [417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_Block_repeat1, 2),
  [419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(1068),
  [422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(1807),
  [425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(2047),
  [428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(935),
  [431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(943),
  [434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(309),
  [437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(2210),
  [440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(2041),
  [443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(107),
  [446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(2180),
  [449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(2181),
  [452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(2201),
  [455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(1403),
  [458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(1327),
  [461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(1403),
  [464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(1499),
  [467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(2072),
  [470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(2146),
  [473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(2074),
  [476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(1814),
  [479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(1013),
  [482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(984),
  [485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(984),
  [488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(1694),
  [491] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(2174),
  [494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(956),
  [497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_Block_repeat1, 2), SHIFT_REPEAT(1869),
  [500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_BlockExpr, 2),
  [522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_LabeledTypeExpr, 2),
  [524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_LabeledTypeExpr, 2),
  [526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_BlockExpr, 2),
  [528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_Block, 3),
  [530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_Block, 3),
  [532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_Block, 2),
  [534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_Block, 2),
  [536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_IDENTIFIER, 2),
  [538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_IDENTIFIER, 2),
  [540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_SwitchExpr, 6),
  [542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SwitchExpr, 6),
  [544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_Statement, 1),
  [546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__PrimaryTypeExpr, 1),
  [548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__PrimaryTypeExpr, 1),
  [550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_Statement, 1),
  [552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_STRINGLITERALSINGLE, 3),
  [554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_STRINGLITERALSINGLE, 3),
  [556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_STRINGLITERALSINGLE, 2),
  [558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_STRINGLITERALSINGLE, 2),
  [560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_IDENTIFIER, 1),
  [562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_IDENTIFIER, 1),
  [564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_SwitchExpr, 8),
  [566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SwitchExpr, 8),
  [568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_SwitchExpr, 9),
  [570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SwitchExpr, 9),
  [572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_SwitchExpr, 7),
  [574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SwitchExpr, 7),
  [576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_BreakLabel, 2),
  [578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_BreakLabel, 2),
  [580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_LabeledStatement, 2),
  [582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_LabeledStatement, 2),
  [584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2176),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_BlockExpr, 1),
  [596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_BlockExpr, 1),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_LabeledStatement, 1),
  [640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_LabeledStatement, 1),
  [642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SwitchCase, 3),
  [660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ForItem, 2),
  [674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ForArgumentsList, 3),
  [682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SwitchCase, 2),
  [684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ForArgumentsList, 2),
  [686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1900),
  [752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_BlockLabel, 2),
  [754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_BlockLabel, 2),
  [756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__ContainerMembers, 2),
  [778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(1679),
  [781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(1737),
  [784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(750),
  [787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(1750),
  [790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(1667),
  [793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(1725),
  [796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(2028),
  [799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(1862),
  [802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(184),
  [805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(1805),
  [808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(1867),
  [811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(1065),
  [814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(1821),
  [817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(2017),
  [820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(1037),
  [823] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(1129),
  [826] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(1280),
  [829] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(1745),
  [832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(257),
  [835] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(2156),
  [838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(107),
  [841] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(2155),
  [844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(2153),
  [847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(2152),
  [850] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(1403),
  [853] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(1403),
  [856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(1499),
  [859] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(2072),
  [862] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(2146),
  [865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(2074),
  [868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(549),
  [871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(1825),
  [874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(1273),
  [877] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(1208),
  [880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(1208),
  [883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(1682),
  [886] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(2134),
  [889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(1197),
  [892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__ContainerMembers, 2), SHIFT_REPEAT(1903),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 2),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SuffixExpr, 2, .production_id = 4),
  [929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_SuffixExpr, 2, .production_id = 4),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1874),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SuffixExpr, 1, .production_id = 2),
  [943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_SuffixExpr, 1, .production_id = 2),
  [945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SuffixExpr, 2, .production_id = 2),
  [955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_SuffixExpr, 2, .production_id = 2),
  [957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2),
  [959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2),
  [961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2), SHIFT_REPEAT(1874),
  [964] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2), SHIFT_REPEAT(148),
  [967] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2), SHIFT_REPEAT(200),
  [970] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2), SHIFT_REPEAT(476),
  [973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SuffixExpr, 3, .production_id = 4),
  [975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_SuffixExpr, 3, .production_id = 4),
  [977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SuffixExpr, 3, .production_id = 3),
  [979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_SuffixExpr, 3, .production_id = 3),
  [981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SuffixExpr, 1, .production_id = 1),
  [983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_SuffixExpr, 1, .production_id = 1),
  [985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SuffixExpr, 2, .production_id = 3),
  [987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_SuffixExpr, 2, .production_id = 3),
  [989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SuffixExpr, 2, .production_id = 1),
  [991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_SuffixExpr, 2, .production_id = 1),
  [993] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2), SHIFT_REPEAT(1913),
  [996] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2), SHIFT_REPEAT(129),
  [999] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2), SHIFT_REPEAT(221),
  [1002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2), SHIFT_REPEAT(563),
  [1005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_IfExpr, 2),
  [1007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_IfExpr, 2),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1326),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1329),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [1039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__CurlySuffixExpr, 1),
  [1041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__CurlySuffixExpr, 1),
  [1043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ForTypeExpr, 2),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [1047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ForTypeExpr, 2),
  [1049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ForExpr, 2),
  [1051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ForExpr, 2),
  [1053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_WhileTypeExpr, 2),
  [1055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_WhileTypeExpr, 2),
  [1057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_WhileExpr, 2),
  [1059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_WhileExpr, 2),
  [1061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_IfTypeExpr, 2),
  [1063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_IfTypeExpr, 2),
  [1065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__STRINGLITERAL_repeat1, 2),
  [1067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__STRINGLITERAL_repeat1, 2),
  [1069] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__STRINGLITERAL_repeat1, 2), SHIFT_REPEAT(2159),
  [1072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_BinaryExpr, 3, .production_id = 14),
  [1074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_BinaryExpr, 3, .production_id = 14),
  [1076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ElseExprTail, 2),
  [1078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ElseExprTail, 2),
  [1080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ElseExprTail, 3),
  [1082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ElseExprTail, 3),
  [1084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(761),
  [1086] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__STRINGLITERAL_repeat1, 2), SHIFT_REPEAT(2122),
  [1089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FieldOrFnCall, 2, .production_id = 10),
  [1091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FieldOrFnCall, 2, .production_id = 10),
  [1093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_UnaryExpr, 2, .production_id = 6),
  [1095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_UnaryExpr, 2, .production_id = 6),
  [1097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__PrimaryExpr, 3),
  [1099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__PrimaryExpr, 3),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [1105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__PrimaryTypeExpr, 2),
  [1107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__PrimaryTypeExpr, 2),
  [1109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 6, .production_id = 13),
  [1111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 6, .production_id = 13),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [1117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 8, .production_id = 12),
  [1119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 8, .production_id = 12),
  [1121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 4),
  [1123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 4),
  [1125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [1127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 5),
  [1129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 5),
  [1131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 9, .production_id = 26),
  [1133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 9, .production_id = 26),
  [1135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 9, .production_id = 25),
  [1137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 9, .production_id = 25),
  [1139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 3),
  [1141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 3),
  [1143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 8, .production_id = 26),
  [1145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 8, .production_id = 26),
  [1147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 8, .production_id = 25),
  [1149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 8, .production_id = 25),
  [1151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 8, .production_id = 13),
  [1153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 8, .production_id = 13),
  [1155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 7, .production_id = 11),
  [1157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 7, .production_id = 11),
  [1159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 7, .production_id = 26),
  [1161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 7, .production_id = 26),
  [1163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FLOAT, 1),
  [1165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FLOAT, 1),
  [1167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_INTEGER, 1),
  [1169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_INTEGER, 1),
  [1171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 7, .production_id = 25),
  [1173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 7, .production_id = 25),
  [1175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ErrorUnionExpr, 1),
  [1177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ErrorUnionExpr, 1),
  [1179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [1181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_LabeledTypeExpr, 1),
  [1183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_LabeledTypeExpr, 1),
  [1185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_LoopTypeExpr, 1),
  [1187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_LoopTypeExpr, 1),
  [1189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerDecl, 1),
  [1191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerDecl, 1),
  [1193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerDecl, 2),
  [1195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerDecl, 2),
  [1197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_LoopTypeExpr, 2),
  [1199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_LoopTypeExpr, 2),
  [1201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__PrimaryTypeExpr, 2, .production_id = 5),
  [1203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__PrimaryTypeExpr, 2, .production_id = 5),
  [1205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_LINESTRING, 2),
  [1207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_LINESTRING, 2),
  [1209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SuffixOp, 1),
  [1211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_SuffixOp, 1),
  [1213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__TypeExpr, 2),
  [1215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__TypeExpr, 2),
  [1217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 7, .production_id = 8),
  [1219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 7, .production_id = 8),
  [1221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FnProto, 3),
  [1223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FnProto, 3),
  [1225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_InitList, 2),
  [1227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_InitList, 2),
  [1229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ErrorSetDecl, 3),
  [1231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ErrorSetDecl, 3),
  [1233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__PrimaryTypeExpr, 3, .production_id = 7),
  [1235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__PrimaryTypeExpr, 3, .production_id = 7),
  [1237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_GroupedExpr, 3),
  [1239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_GroupedExpr, 3),
  [1241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_CHAR_LITERAL, 3),
  [1243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_CHAR_LITERAL, 3),
  [1245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ErrorUnionExpr, 3, .production_id = 9),
  [1247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ErrorUnionExpr, 3, .production_id = 9),
  [1249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FnCallArguments, 2),
  [1251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FnCallArguments, 2),
  [1253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_IfTypeExpr, 3),
  [1255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_IfTypeExpr, 3),
  [1257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_WhileTypeExpr, 3),
  [1259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_WhileTypeExpr, 3),
  [1261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ForTypeExpr, 3),
  [1263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ForTypeExpr, 3),
  [1265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ContainerDeclAuto, 3),
  [1267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ContainerDeclAuto, 3),
  [1269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FnProto, 4, .production_id = 15),
  [1271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FnProto, 4, .production_id = 15),
  [1273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 7, .production_id = 13),
  [1275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 7, .production_id = 13),
  [1277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 7, .production_id = 12),
  [1279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 7, .production_id = 12),
  [1281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FnProto, 4),
  [1283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FnProto, 4),
  [1285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 6, .production_id = 11),
  [1287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 6, .production_id = 11),
  [1289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FnProto, 4, .production_id = 16),
  [1291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FnProto, 4, .production_id = 16),
  [1293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 5, .production_id = 8),
  [1295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 5, .production_id = 8),
  [1297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_InitList, 3),
  [1299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_InitList, 3),
  [1301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ErrorSetDecl, 4, .production_id = 7),
  [1303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ErrorSetDecl, 4, .production_id = 7),
  [1305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FieldOrFnCall, 3, .production_id = 17),
  [1307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FieldOrFnCall, 3, .production_id = 17),
  [1309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FnCallArguments, 3),
  [1311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FnCallArguments, 3),
  [1313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 6),
  [1315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 6),
  [1317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SuffixOp, 3),
  [1319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_SuffixOp, 3),
  [1321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ElseTypeExprTail, 2),
  [1323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ElseTypeExprTail, 2),
  [1325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ContainerDeclAuto, 4),
  [1327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ContainerDeclAuto, 4),
  [1329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FnProto, 5, .production_id = 20),
  [1331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FnProto, 5, .production_id = 20),
  [1333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FnProto, 5),
  [1335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FnProto, 5),
  [1337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FnProto, 5, .production_id = 21),
  [1339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FnProto, 5, .production_id = 21),
  [1341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FnProto, 5, .production_id = 16),
  [1343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FnProto, 5, .production_id = 16),
  [1345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_InitList, 4),
  [1347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_InitList, 4),
  [1349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ErrorSetDecl, 5, .production_id = 22),
  [1351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ErrorSetDecl, 5, .production_id = 22),
  [1353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ErrorSetDecl, 5, .production_id = 7),
  [1355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ErrorSetDecl, 5, .production_id = 7),
  [1357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ErrorSetDecl, 5, .production_id = 23),
  [1359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ErrorSetDecl, 5, .production_id = 23),
  [1361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 6, .production_id = 8),
  [1363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 6, .production_id = 8),
  [1365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FnCallArguments, 4),
  [1367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FnCallArguments, 4),
  [1369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SuffixOp, 4),
  [1371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_SuffixOp, 4),
  [1373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ElseTypeExprTail, 3),
  [1375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ElseTypeExprTail, 3),
  [1377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ContainerDeclAuto, 5),
  [1379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ContainerDeclAuto, 5),
  [1381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FnProto, 6, .production_id = 30),
  [1383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FnProto, 6, .production_id = 30),
  [1385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FnProto, 6),
  [1387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FnProto, 6),
  [1389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FnProto, 6, .production_id = 31),
  [1391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FnProto, 6, .production_id = 31),
  [1393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FnProto, 6, .production_id = 16),
  [1395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FnProto, 6, .production_id = 16),
  [1397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_InitList, 5),
  [1399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_InitList, 5),
  [1401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ErrorSetDecl, 6, .production_id = 22),
  [1403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ErrorSetDecl, 6, .production_id = 22),
  [1405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ErrorSetDecl, 6, .production_id = 32),
  [1407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ErrorSetDecl, 6, .production_id = 32),
  [1409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ErrorSetDecl, 6, .production_id = 23),
  [1411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ErrorSetDecl, 6, .production_id = 23),
  [1413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FnCallArguments, 5),
  [1415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FnCallArguments, 5),
  [1417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SuffixOp, 5),
  [1419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_SuffixOp, 5),
  [1421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FnProto, 7, .production_id = 35),
  [1423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FnProto, 7, .production_id = 35),
  [1425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FnProto, 7),
  [1427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FnProto, 7),
  [1429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FnProto, 7, .production_id = 36),
  [1431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FnProto, 7, .production_id = 36),
  [1433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FnProto, 7, .production_id = 16),
  [1435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FnProto, 7, .production_id = 16),
  [1437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ErrorSetDecl, 7, .production_id = 32),
  [1439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ErrorSetDecl, 7, .production_id = 32),
  [1441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FnProto, 8, .production_id = 37),
  [1443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FnProto, 8, .production_id = 37),
  [1445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FnProto, 8, .production_id = 38),
  [1447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FnProto, 8, .production_id = 38),
  [1449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 5, .production_id = 11),
  [1451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 5, .production_id = 11),
  [1453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FnProto, 8, .production_id = 16),
  [1455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FnProto, 8, .production_id = 16),
  [1457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FnProto, 9, .production_id = 42),
  [1459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FnProto, 9, .production_id = 42),
  [1461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 6, .production_id = 12),
  [1463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 6, .production_id = 12),
  [1465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1680),
  [1467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1740),
  [1469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [1471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [1473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [1475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [1477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1753),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [1481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2102),
  [1483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2187),
  [1485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [1487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2192),
  [1489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [1491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1744),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [1497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [1499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [1503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(914),
  [1505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1748),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [1515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [1517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1741),
  [1519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1751),
  [1521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1826),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [1525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [1529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2030),
  [1531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [1533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1074),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [1537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2209),
  [1539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [1541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [1543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [1545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [1547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [1549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [1551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [1555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [1557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [1559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [1561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [1563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [1565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [1567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [1569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [1571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [1573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_IfExpr, 3),
  [1575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_IfExpr, 3),
  [1577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [1579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_WhileExpr, 3),
  [1581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_WhileExpr, 3),
  [1583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ForExpr, 3),
  [1585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ForExpr, 3),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [1589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AsmExpr, 6),
  [1591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_AsmExpr, 6),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [1595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [1597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1714),
  [1599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [1601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [1603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [1605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2091),
  [1607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [1609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__CurlySuffixExpr, 2),
  [1611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__CurlySuffixExpr, 2),
  [1613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AsmExpr, 5),
  [1615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_AsmExpr, 5),
  [1617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [1619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [1621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [1623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [1625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [1627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AsmExpr, 4),
  [1629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_AsmExpr, 4),
  [1631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [1633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [1635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [1637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [1639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_LoopExpr, 1),
  [1641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_LoopExpr, 1),
  [1643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_LoopExpr, 2),
  [1645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_LoopExpr, 2),
  [1647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [1649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [1651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [1653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [1655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [1657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [1659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [1661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [1663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [1665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [1667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [1669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [1671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [1673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [1675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [1677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [1679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [1681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [1683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [1687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [1689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [1691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1717),
  [1693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [1695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [1701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [1703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [1705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1715),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [1711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [1713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [1715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [1717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [1719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [1721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [1725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [1727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [1729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [1731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1281),
  [1733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2), SHIFT_REPEAT(1873),
  [1736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2), SHIFT_REPEAT(127),
  [1739] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2), SHIFT_REPEAT(332),
  [1742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2), SHIFT_REPEAT(1006),
  [1745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1873),
  [1747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [1749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [1751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [1753] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__STRINGLITERAL_repeat1, 2), SHIFT_REPEAT(2174),
  [1756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__STRINGLITERAL, 1),
  [1758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__STRINGLITERAL, 1),
  [1760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [1762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [1764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [1766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1854),
  [1768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [1770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [1774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2), SHIFT_REPEAT(1854),
  [1777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2), SHIFT_REPEAT(149),
  [1780] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2), SHIFT_REPEAT(269),
  [1783] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2), SHIFT_REPEAT(1191),
  [1786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [1788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [1790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [1792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [1794] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2), SHIFT_REPEAT(1896),
  [1797] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2), SHIFT_REPEAT(142),
  [1800] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2), SHIFT_REPEAT(182),
  [1803] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2), SHIFT_REPEAT(1211),
  [1806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_WhileStatement, 2),
  [1808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_WhileStatement, 2),
  [1810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [1812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [1814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [1816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [1818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [1820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [1822] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__STRINGLITERAL_repeat1, 2), SHIFT_REPEAT(2185),
  [1825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [1827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_IfStatement, 2),
  [1829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_IfStatement, 2),
  [1831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ForStatement, 2),
  [1833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ForStatement, 2),
  [1835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [1837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [1839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [1841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1414),
  [1843] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__STRINGLITERAL_repeat1, 2), SHIFT_REPEAT(2134),
  [1846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1043),
  [1848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [1850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [1852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [1854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [1856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [1858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [1860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [1862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_VarDecl, 4, .production_id = 4),
  [1864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_VarDecl, 4, .production_id = 4),
  [1866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_VarDecl, 5, .production_id = 4),
  [1868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_VarDecl, 5, .production_id = 4),
  [1870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_VarDecl, 6, .production_id = 4),
  [1872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_VarDecl, 6, .production_id = 4),
  [1874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_VarDecl, 7, .production_id = 4),
  [1876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_VarDecl, 7, .production_id = 4),
  [1878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_IfStatement, 3),
  [1880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_IfStatement, 3),
  [1882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_VarDecl, 8, .production_id = 4),
  [1884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_VarDecl, 8, .production_id = 4),
  [1886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ElseStatementTail, 3),
  [1888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ElseStatementTail, 3),
  [1890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_VarDecl, 3, .production_id = 4),
  [1892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_VarDecl, 3, .production_id = 4),
  [1894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_LoopStatement, 1),
  [1896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_LoopStatement, 1),
  [1898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_VarDecl, 9, .production_id = 4),
  [1900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_VarDecl, 9, .production_id = 4),
  [1902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ForStatement, 3),
  [1904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ForStatement, 3),
  [1906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_WhileStatement, 3),
  [1908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_WhileStatement, 3),
  [1910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_VarDecl, 10, .production_id = 4),
  [1912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_VarDecl, 10, .production_id = 4),
  [1914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ElseStatementTail, 2),
  [1916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ElseStatementTail, 2),
  [1918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_Statement, 3),
  [1920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_Statement, 3),
  [1922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [1924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_BlockExprStatement, 2),
  [1926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_BlockExprStatement, 2),
  [1928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_Statement, 2),
  [1930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_Statement, 2),
  [1932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_BlockExprStatement, 1),
  [1934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_BlockExprStatement, 1),
  [1936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_LoopStatement, 2),
  [1938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_LoopStatement, 2),
  [1940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [1942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [1944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_Payload, 3, .production_id = 27),
  [1946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_Payload, 3, .production_id = 27),
  [1948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [1950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 2),
  [1952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 2),
  [1954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [1956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2133),
  [1958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [1960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [1962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [1964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_WhilePrefix, 4),
  [1966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_WhilePrefix, 4),
  [1968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [1970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [1972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [1974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AssignExpr, 1),
  [1976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [1978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [1980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_WhilePrefix, 5),
  [1982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_WhilePrefix, 5),
  [1984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_BitwiseOp, 1),
  [1986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_BitwiseOp, 1),
  [1988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_IfPrefix, 4),
  [1990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_IfPrefix, 4),
  [1992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 5, .production_id = 13),
  [1994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 5, .production_id = 13),
  [1996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [1998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 1),
  [2000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 1),
  [2002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [2004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 5, .production_id = 12),
  [2006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 5, .production_id = 12),
  [2008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [2010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 5, .production_id = 25),
  [2012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 5, .production_id = 25),
  [2014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [2016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 5, .production_id = 26),
  [2018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 5, .production_id = 26),
  [2020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [2022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 4, .production_id = 8),
  [2024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 4, .production_id = 8),
  [2026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [2028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_PtrPayload, 4, .production_id = 39),
  [2030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_PtrPayload, 4, .production_id = 39),
  [2032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 6, .production_id = 25),
  [2034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 6, .production_id = 25),
  [2036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [2038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 6, .production_id = 26),
  [2040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 6, .production_id = 26),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [2044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_PtrPayload, 3, .production_id = 27),
  [2046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_PtrPayload, 3, .production_id = 27),
  [2048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 4, .production_id = 13),
  [2050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 4, .production_id = 13),
  [2052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [2054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 3, .production_id = 11),
  [2056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 3, .production_id = 11),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [2060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 4, .production_id = 12),
  [2062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 4, .production_id = 12),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [2066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 4, .production_id = 11),
  [2068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 4, .production_id = 11),
  [2070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [2072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerField, 3, .production_id = 8),
  [2074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ContainerField, 3, .production_id = 8),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [2078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_AdditionOp, 1),
  [2080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AdditionOp, 1),
  [2082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_WhileContinueExpr, 4),
  [2084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_WhileContinueExpr, 4),
  [2086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_IfPrefix, 5),
  [2088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_IfPrefix, 5),
  [2090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_PtrListPayload, 3, .production_id = 27),
  [2092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_PtrListPayload, 3, .production_id = 27),
  [2094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_PtrIndexPayload, 3, .production_id = 27),
  [2096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_PtrIndexPayload, 3, .production_id = 27),
  [2098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_WhilePrefix, 6),
  [2100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_WhilePrefix, 6),
  [2102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_PtrListPayload, 4, .production_id = 39),
  [2104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_PtrListPayload, 4, .production_id = 39),
  [2106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_PrefixOp, 1),
  [2108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_PrefixOp, 1),
  [2110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_PtrIndexPayload, 5, .production_id = 45),
  [2112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_PtrIndexPayload, 5, .production_id = 45),
  [2114] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_CompareOp, 1),
  [2116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_CompareOp, 1),
  [2118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_PtrIndexPayload, 6, .production_id = 46),
  [2120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_PtrIndexPayload, 6, .production_id = 46),
  [2122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_PtrIndexPayload, 4, .production_id = 39),
  [2124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_PtrIndexPayload, 4, .production_id = 39),
  [2126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_PtrListPayload, 4, .production_id = 40),
  [2128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_PtrListPayload, 4, .production_id = 40),
  [2130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_PtrListPayload, 5, .production_id = 40),
  [2132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_PtrListPayload, 5, .production_id = 40),
  [2134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_BitShiftOp, 1),
  [2136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_BitShiftOp, 1),
  [2138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_AssignOp, 1),
  [2140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AssignOp, 1),
  [2142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_PtrListPayload, 4, .production_id = 27),
  [2144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_PtrListPayload, 4, .production_id = 27),
  [2146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_PtrListPayload, 5, .production_id = 43),
  [2148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_PtrListPayload, 5, .production_id = 43),
  [2150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_PtrListPayload, 6, .production_id = 43),
  [2152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_PtrListPayload, 6, .production_id = 43),
  [2154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ForPrefix, 5),
  [2156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ForPrefix, 5),
  [2158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_PtrListPayload, 5, .production_id = 39),
  [2160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_PtrListPayload, 5, .production_id = 39),
  [2162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_MultiplyOp, 1),
  [2164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_MultiplyOp, 1),
  [2166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_BitwiseOp, 2),
  [2168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_BitwiseOp, 2),
  [2170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [2172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [2174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [2178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [2182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ByteAlign, 4),
  [2184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ByteAlign, 4),
  [2186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [2188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__ContainerMembers, 1),
  [2190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [2192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 1),
  [2194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ComptimeDecl, 2),
  [2196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ComptimeDecl, 2),
  [2198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_Decl, 4),
  [2200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_Decl, 4),
  [2202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ContainerDeclarations, 3),
  [2204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ContainerDeclarations, 3),
  [2206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_TestDecl, 2),
  [2208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_TestDecl, 2),
  [2210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ContainerDeclarations, 2),
  [2212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ContainerDeclarations, 2),
  [2214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_TestDecl, 4),
  [2216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_TestDecl, 4),
  [2218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_TestDecl, 3),
  [2220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_TestDecl, 3),
  [2222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__ContainerMembers, 2),
  [2224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_Decl, 1),
  [2226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_Decl, 1),
  [2228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_Decl, 2),
  [2230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_Decl, 2),
  [2232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_Decl, 3),
  [2234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_Decl, 3),
  [2236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_PrefixTypeOp, 2),
  [2238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1385),
  [2240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_PrefixTypeOp, 2),
  [2242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2100),
  [2244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2186),
  [2246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_PtrTypeStart, 1),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [2250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_PtrTypeStart, 1),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [2254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [2256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_PrefixTypeOp_repeat1, 2),
  [2258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_PrefixTypeOp_repeat1, 2), SHIFT_REPEAT(1385),
  [2261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_PrefixTypeOp_repeat1, 2),
  [2263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_PrefixTypeOp_repeat1, 2), SHIFT_REPEAT(2100),
  [2266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_PrefixTypeOp_repeat1, 2), SHIFT_REPEAT(2186),
  [2269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_PrefixTypeOp, 1),
  [2271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1383),
  [2273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_PrefixTypeOp, 1),
  [2275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_PrefixTypeOp_repeat2, 2),
  [2277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_PrefixTypeOp_repeat2, 2), SHIFT_REPEAT(1387),
  [2280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_PrefixTypeOp_repeat2, 2),
  [2282] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_PrefixTypeOp_repeat2, 2), SHIFT_REPEAT(2100),
  [2285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_PrefixTypeOp_repeat2, 2), SHIFT_REPEAT(2164),
  [2288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1387),
  [2290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2164),
  [2292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [2294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_AddrSpace, 4),
  [2296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AddrSpace, 4),
  [2298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_PtrTypeStart, 4),
  [2300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_PtrTypeStart, 4),
  [2302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_PtrTypeStart, 5),
  [2304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_PtrTypeStart, 5),
  [2306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_PrefixTypeOp_repeat2, 4),
  [2308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_PrefixTypeOp_repeat2, 4),
  [2310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__TypeExpr_repeat1, 2),
  [2312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__TypeExpr_repeat1, 2),
  [2314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__TypeExpr_repeat1, 2), SHIFT_REPEAT(2118),
  [2317] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__TypeExpr_repeat1, 2), SHIFT_REPEAT(107),
  [2320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__TypeExpr_repeat1, 2), SHIFT_REPEAT(1403),
  [2323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__TypeExpr_repeat1, 2), SHIFT_REPEAT(1403),
  [2326] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__TypeExpr_repeat1, 2), SHIFT_REPEAT(1499),
  [2329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_SliceTypeStart, 2),
  [2331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SliceTypeStart, 2),
  [2333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_PrefixTypeOp_repeat2, 8),
  [2335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_PrefixTypeOp_repeat2, 8),
  [2337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ParamDeclList, 3),
  [2339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ParamDeclList, 3),
  [2341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ParamDeclList, 5),
  [2343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ParamDeclList, 5),
  [2345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_SliceTypeStart, 4),
  [2347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SliceTypeStart, 4),
  [2349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ParamDeclList, 4),
  [2351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ParamDeclList, 4),
  [2353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_PtrTypeStart, 3),
  [2355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_PtrTypeStart, 3),
  [2357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1926),
  [2359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [2361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [2363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [2365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ParamDeclList, 2),
  [2367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ParamDeclList, 2),
  [2369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2), SHIFT_REPEAT(1926),
  [2372] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2), SHIFT_REPEAT(157),
  [2375] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2), SHIFT_REPEAT(183),
  [2378] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_SuffixExpr_repeat1, 2), SHIFT_REPEAT(1529),
  [2381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [2383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [2385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_LinkSection, 4),
  [2387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_LinkSection, 4),
  [2389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [2391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [2393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [2395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__STRINGLITERAL_repeat1, 2), SHIFT_REPEAT(2101),
  [2398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [2408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_CallConv, 4),
  [2410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_CallConv, 4),
  [2412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ArrayTypeStart, 4),
  [2414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ArrayTypeStart, 4),
  [2416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ArrayTypeStart, 6),
  [2418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ArrayTypeStart, 6),
  [2420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ArrayTypeStart, 5),
  [2422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ArrayTypeStart, 5),
  [2424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [2426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ArrayTypeStart, 3),
  [2428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ArrayTypeStart, 3),
  [2430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [2432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_LoopTypeExpr, 1), REDUCE(sym_LoopTypeExpr, 2),
  [2435] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_LoopTypeExpr, 1), REDUCE(sym_LoopTypeExpr, 2),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [2440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [2446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AssignExpr, 3),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [2484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [2488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_InitList_repeat2, 2),
  [2490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SwitchItem, 1),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [2504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ForItem, 1),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [2508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [2510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [2514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [2520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [2522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [2524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [2526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [2532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [2536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [2538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FieldInit, 4, .production_id = 13),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [2544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [2548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [2552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [2554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [2556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SwitchItem, 3),
  [2558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [2560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [2564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__SentinelTerminatedExpr, 1),
  [2566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ForItem, 3),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [2576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [2580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [2582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [2584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [2586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [2588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__SentinelTerminatedExpr, 2),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [2592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [2594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [2596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [2598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [2600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [2602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [2604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [2606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [2608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [2610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [2612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [2614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [2616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [2618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__SentinelTerminatedExpr, 3),
  [2620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [2622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [2624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [2628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [2632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [2634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [2636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [2638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [2640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [2642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [2644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [2648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [2650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [2652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [2654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [2658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [2660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [2662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_LoopExpr, 1), REDUCE(sym_LoopExpr, 2),
  [2665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_LoopExpr, 1), REDUCE(sym_LoopExpr, 2),
  [2668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [2670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [2672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [2674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [2676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [2678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [2680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [2682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [2684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [2686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [2688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [2690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [2692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [2698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [2702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [2704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [2706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [2708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [2710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [2712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [2714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [2716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1916),
  [2718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1729),
  [2720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [2722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [2724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1690),
  [2726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [2728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [2730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1683),
  [2732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [2736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1688),
  [2738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [2740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [2744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1687),
  [2746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [2748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [2750] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_STRINGLITERALSINGLE_repeat1, 2), SHIFT_REPEAT(2106),
  [2753] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_STRINGLITERALSINGLE_repeat1, 2), SHIFT_REPEAT(1916),
  [2756] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_STRINGLITERALSINGLE_repeat1, 2), SHIFT_REPEAT(1729),
  [2759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_STRINGLITERALSINGLE_repeat1, 2),
  [2761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_STRINGLITERALSINGLE_repeat1, 2), SHIFT_REPEAT(1688),
  [2764] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_STRINGLITERALSINGLE_repeat1, 2), SHIFT_REPEAT(1688),
  [2767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(424),
  [2769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [2771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(621),
  [2773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [2775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1693),
  [2777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [2779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(622),
  [2781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(937),
  [2783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [2785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1692),
  [2787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [2789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [2791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [2793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1695),
  [2795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [2799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1689),
  [2801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [2805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1684),
  [2807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [2809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [2811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1701),
  [2813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [2815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [2817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [2821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1686),
  [2823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(452),
  [2825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [2827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1700),
  [2829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1442),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [2833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1705),
  [2835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [2839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [2841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [2843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [2845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [2847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [2849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [2851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [2853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [2855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [2857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [2859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [2861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [2863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [2865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [2867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [2871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [2875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [2877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [2879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [2881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [2883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_EscapeSequence, 2),
  [2885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_EscapeSequence, 2),
  [2887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FormatSequence, 5),
  [2889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FormatSequence, 5),
  [2891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FormatSequence, 4),
  [2893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FormatSequence, 4),
  [2895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_EscapeSequence, 1),
  [2897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_EscapeSequence, 1),
  [2899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [2901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FormatSequence, 7),
  [2903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FormatSequence, 7),
  [2905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FormatSequence, 6),
  [2907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FormatSequence, 6),
  [2909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_FormatSequence, 3),
  [2911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_FormatSequence, 3),
  [2913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ParamType, 1),
  [2915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AsmClobbers, 1),
  [2917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [2919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [2921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AsmClobbers, 4),
  [2923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AsmClobbers, 3),
  [2925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [2927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [2929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [2935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [2949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [2953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [2965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AsmInput, 4),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [2969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [2971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [2973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [2975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AsmInput, 3),
  [2977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [2983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [2989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [2991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [2997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [2999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [3001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [3003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [3009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [3011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AsmOutput, 2),
  [3013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AsmOutput, 1),
  [3015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [3019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AsmInput, 1),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [3027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [3037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [3047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [3049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AsmOutput, 4),
  [3051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [3053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1922),
  [3055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2103),
  [3057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [3059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [3063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AsmInput, 2),
  [3065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [3067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [3069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AsmOutput, 3),
  [3071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [3073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [3075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [3077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [3079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [3081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [3083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [3085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [3089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [3091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [3093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [3095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [3097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [3099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [3101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [3103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [3105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [3107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [3109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [3111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [3113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [3115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_AsmOutput_repeat1, 2), SHIFT_REPEAT(2034),
  [3118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_AsmOutput_repeat1, 2),
  [3120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [3122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [3124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [3126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [3128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [3130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [3132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_InitList_repeat2, 2), SHIFT_REPEAT(212),
  [3135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_AsmInput_repeat1, 2), SHIFT_REPEAT(2025),
  [3138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_AsmInput_repeat1, 2),
  [3140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [3142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [3144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [3146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [3148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [3150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [3152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [3154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [3156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [3158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [3160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_ErrorSetDecl_repeat1, 2, .production_id = 24), SHIFT_REPEAT(1845),
  [3163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ErrorSetDecl_repeat1, 2, .production_id = 24),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [3167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_ParamDeclList_repeat1, 2), SHIFT_REPEAT(681),
  [3170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ParamDeclList_repeat1, 2),
  [3172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [3174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [3176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [3178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [3180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [3182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [3184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [3186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [3188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [3190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [3194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ForArgumentsList, 1),
  [3196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [3200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [3202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [3204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [3206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [3212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [3218] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_ForArgumentsList_repeat1, 2), SHIFT_REPEAT(147),
  [3221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ForArgumentsList_repeat1, 2),
  [3223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerDeclType, 1),
  [3225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [3227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [3229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [3231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AsmOutputItem, 8, .production_id = 27),
  [3233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [3235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [3237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [3239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AsmInputItem, 7, .production_id = 27),
  [3241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AsmOutputItem, 7, .production_id = 44),
  [3243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [3245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [3247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [3249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AsmClobbers, 2),
  [3251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [3253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [3255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [3257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [3259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [3261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [3263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [3265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [3267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [3269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [3271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [3273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [3275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [3277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [3279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [3281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [3283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [3285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [3287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [3289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [3291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [3293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [3295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [3297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [3299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [3301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [3303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [3305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [3307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [3309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_SwitchExpr_repeat1, 2), SHIFT_REPEAT(89),
  [3312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_SwitchExpr_repeat1, 2),
  [3314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_InitList_repeat1, 2), SHIFT_REPEAT(2024),
  [3317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_InitList_repeat1, 2),
  [3319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [3321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [3323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [3325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [3327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [3329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [3331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [3333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [3335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [3337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [3339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [3341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [3343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [3345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [3347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [3349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [3351] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_SwitchCase_repeat1, 2), SHIFT_REPEAT(156),
  [3354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_SwitchCase_repeat1, 2),
  [3356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [3360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_AsmClobbers_repeat1, 2), SHIFT_REPEAT(1743),
  [3363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_AsmClobbers_repeat1, 2),
  [3365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [3367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [3369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [3371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [3373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [3375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [3377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [3379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [3381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [3383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [3385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [3387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [3389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [3391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [3393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [3395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [3397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [3399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SwitchCase, 1),
  [3401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [3403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [3405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_PtrListPayload_repeat1, 2, .production_id = 41), SHIFT_REPEAT(1838),
  [3408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_PtrListPayload_repeat1, 2, .production_id = 41),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [3414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [3418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [3420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [3422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [3424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [3426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [3428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [3430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [3432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [3434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [3436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [3438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [3440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [3442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [3444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [3446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [3448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [3450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [3452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [3454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [3456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [3460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [3464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [3466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [3468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [3470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [3472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [3474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [3476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [3478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [3480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ParamDecl, 5, .production_id = 33),
  [3482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ParamDecl, 5, .production_id = 34),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [3488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [3492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SwitchProng, 3),
  [3494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [3496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [3498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [3500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [3504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ErrorSetDecl_repeat1, 2, .production_id = 5),
  [3506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SwitchProng, 4),
  [3508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [3510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [3512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ParamDecl, 2),
  [3514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [3518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [3520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [3524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [3526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [3528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [3530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ErrorSetDecl_repeat1, 3, .production_id = 7),
  [3532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_PtrListPayload_repeat1, 3, .production_id = 39),
  [3534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ParamDecl, 4, .production_id = 29),
  [3536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ParamDecl, 4, .production_id = 28),
  [3538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_PtrListPayload_repeat1, 2, .production_id = 27),
  [3540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ParamDecl, 3, .production_id = 19),
  [3542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [3544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [3546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [3548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [3550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [3552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [3554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [3556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2137),
  [3558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2112),
  [3560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [3562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ParamDecl, 1),
  [3564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [3566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [3568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ParamDecl, 3),
  [3570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [3572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerDeclType, 4),
  [3574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [3576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ParamDecl, 3, .production_id = 18),
  [3578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [3580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2158),
  [3582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2111),
  [3584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [3586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_SwitchProng, 5),
  [3588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [3590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [3592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [3594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [3596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [3598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [3600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1429),
  [3602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [3604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [3606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [3608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [3610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [3612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [3614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [3616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [3618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [3620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [3622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [3624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [3626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [3628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [3630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [3632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [3634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AsmOutput, 5),
  [3636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [3638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [3640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_BUILTINIDENTIFIER, 2),
  [3642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [3644] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [3646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [3648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [3650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_AsmInput, 5),
  [3652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [3654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [3656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [3658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [3660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [3662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [3664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [3666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ContainerDeclType, 7),
  [3668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [3670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [3672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [3674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [3676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [3678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [3680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [3682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [3686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [3688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [3690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [3692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [3694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2125),
  [3696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [3700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [3702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [3704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [3706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [3708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [3710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [3712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [3714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [3716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [3718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [3720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [3722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [3724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(947),
  [3726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [3728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [3730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [3732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [3734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [3736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [3738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [3740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [3742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [3744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [3746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [3748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [3750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [3752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [3754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [3756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [3758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [3760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [3762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [3764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [3766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [3768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [3770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [3772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [3774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [3776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [3778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [3780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [3782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [3784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [3786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [3788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [3790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_zig(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
